/* agent-matcher.c generated by valac 0.56.18, the Vala compiler
 * generated from agent-matcher.vala, do not modify */

/* SPDX-License-Identifier: LGPL-2.1-or-later*/
/* SPDX-FileCopyrightText: 2023 Jens Georg <mail@jensge.org>*/

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "rygel-core.h"

#define RYGEL_AGENT_MATCHER_MATCHING_PATTERN ".*%s.*"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_AGENT_MATCHER (rygel_agent_matcher_get_type ())
#define RYGEL_AGENT_MATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcher))
#define RYGEL_AGENT_MATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcherClass))
#define RYGEL_IS_AGENT_MATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_AGENT_MATCHER))
#define RYGEL_IS_AGENT_MATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_AGENT_MATCHER))
#define RYGEL_AGENT_MATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcherClass))

typedef struct _RygelAgentMatcher RygelAgentMatcher;
typedef struct _RygelAgentMatcherClass RygelAgentMatcherClass;
typedef struct _RygelAgentMatcherPrivate RygelAgentMatcherPrivate;
enum  {
	RYGEL_AGENT_MATCHER_0_PROPERTY,
	RYGEL_AGENT_MATCHER_AGENTS_PROPERTY,
	RYGEL_AGENT_MATCHER_NAME_PROPERTY,
	RYGEL_AGENT_MATCHER_AGENT_REGEX_PROPERTY,
	RYGEL_AGENT_MATCHER_NUM_PROPERTIES
};
static GParamSpec* rygel_agent_matcher_properties[RYGEL_AGENT_MATCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _RygelAgentMatcher {
	GObject parent_instance;
	RygelAgentMatcherPrivate * priv;
};

struct _RygelAgentMatcherClass {
	GObjectClass parent_class;
};

struct _RygelAgentMatcherPrivate {
	GeeArrayList* _agents;
	gchar* _name;
	GRegex* _agent_regex;
	gchar* agent_pattern;
};

static gint RygelAgentMatcher_private_offset;
static gpointer rygel_agent_matcher_parent_class = NULL;

VALA_EXTERN GType rygel_agent_matcher_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelAgentMatcher* rygel_agent_matcher_new (const gchar* name,
                                            GeeArrayList* agents);
VALA_EXTERN RygelAgentMatcher* rygel_agent_matcher_construct (GType object_type,
                                                  const gchar* name,
                                                  GeeArrayList* agents);
static void rygel_agent_matcher_real_constructed (GObject* base);
VALA_EXTERN GeeArrayList* rygel_agent_matcher_get_agents (RygelAgentMatcher* self);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void rygel_agent_matcher_set_agent_regex (RygelAgentMatcher* self,
                                          GRegex* value);
VALA_EXTERN gboolean rygel_agent_matcher_empty (RygelAgentMatcher* self);
VALA_EXTERN gboolean rygel_agent_matcher_matches (RygelAgentMatcher* self,
                                      const gchar* header);
VALA_EXTERN GRegex* rygel_agent_matcher_get_agent_regex (RygelAgentMatcher* self);
static void rygel_agent_matcher_set_agents (RygelAgentMatcher* self,
                                     GeeArrayList* value);
VALA_EXTERN const gchar* rygel_agent_matcher_get_name (RygelAgentMatcher* self);
static void rygel_agent_matcher_set_name (RygelAgentMatcher* self,
                                   const gchar* value);
static void rygel_agent_matcher_finalize (GObject * obj);
static GType rygel_agent_matcher_get_type_once (void);
static void _vala_rygel_agent_matcher_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_rygel_agent_matcher_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
rygel_agent_matcher_get_instance_private (RygelAgentMatcher* self)
{
	return G_STRUCT_MEMBER_P (self, RygelAgentMatcher_private_offset);
}

RygelAgentMatcher*
rygel_agent_matcher_construct (GType object_type,
                               const gchar* name,
                               GeeArrayList* agents)
{
	RygelAgentMatcher * self = NULL;
#line 13 "../src/librygel-core/agent-matcher.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 13 "../src/librygel-core/agent-matcher.vala"
	g_return_val_if_fail (agents != NULL, NULL);
#line 14 "../src/librygel-core/agent-matcher.vala"
	self = (RygelAgentMatcher*) g_object_new (object_type, "agents", agents, "name", name, NULL);
#line 13 "../src/librygel-core/agent-matcher.vala"
	return self;
#line 127 "agent-matcher.c"
}

RygelAgentMatcher*
rygel_agent_matcher_new (const gchar* name,
                         GeeArrayList* agents)
{
#line 13 "../src/librygel-core/agent-matcher.vala"
	return rygel_agent_matcher_construct (RYGEL_TYPE_AGENT_MATCHER, name, agents);
#line 136 "agent-matcher.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 24 "../src/librygel-core/agent-matcher.vala"
	if ((*length) == (*size)) {
#line 24 "../src/librygel-core/agent-matcher.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 24 "../src/librygel-core/agent-matcher.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 151 "agent-matcher.c"
	}
#line 24 "../src/librygel-core/agent-matcher.vala"
	(*array)[(*length)++] = value;
#line 24 "../src/librygel-core/agent-matcher.vala"
	(*array)[*length] = NULL;
#line 157 "agent-matcher.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 171 "agent-matcher.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 175 "agent-matcher.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 181 "agent-matcher.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 186 "agent-matcher.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 192 "agent-matcher.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 196 "agent-matcher.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 200 "agent-matcher.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 204 "agent-matcher.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 208 "agent-matcher.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 212 "agent-matcher.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 227 "agent-matcher.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 236 "agent-matcher.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 243 "agent-matcher.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 249 "agent-matcher.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 257 "agent-matcher.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 261 "agent-matcher.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 267 "agent-matcher.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 272 "agent-matcher.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 278 "agent-matcher.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 282 "agent-matcher.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 286 "agent-matcher.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 292 "agent-matcher.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 298 "agent-matcher.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 310 "agent-matcher.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 314 "agent-matcher.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 318 "agent-matcher.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 323 "agent-matcher.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 331 "agent-matcher.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 349 "agent-matcher.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 355 "agent-matcher.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 359 "agent-matcher.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 367 "agent-matcher.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 376 "agent-matcher.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 385 "agent-matcher.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 391 "agent-matcher.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 399 "agent-matcher.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 411 "agent-matcher.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 417 "agent-matcher.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 421 "agent-matcher.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 429 "agent-matcher.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 440 "agent-matcher.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 449 "agent-matcher.c"
	}
}

static void
rygel_agent_matcher_real_constructed (GObject* base)
{
	RygelAgentMatcher * self;
	gchar** agents_with_pattern = NULL;
	gchar** _tmp0_;
	gint agents_with_pattern_length1;
	gint _agents_with_pattern_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 17 "../src/librygel-core/agent-matcher.vala"
	self = (RygelAgentMatcher*) base;
#line 18 "../src/librygel-core/agent-matcher.vala"
	if (G_OBJECT_CLASS (rygel_agent_matcher_parent_class)->constructed != NULL) {
#line 19 "../src/librygel-core/agent-matcher.vala"
		G_OBJECT_CLASS (rygel_agent_matcher_parent_class)->constructed (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 471 "agent-matcher.c"
	}
#line 22 "../src/librygel-core/agent-matcher.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 22 "../src/librygel-core/agent-matcher.vala"
	agents_with_pattern = _tmp0_;
#line 22 "../src/librygel-core/agent-matcher.vala"
	agents_with_pattern_length1 = 0;
#line 22 "../src/librygel-core/agent-matcher.vala"
	_agents_with_pattern_size_ = agents_with_pattern_length1;
#line 481 "agent-matcher.c"
	{
		GeeArrayList* _agent_list = NULL;
		GeeArrayList* _tmp1_;
		gint _agent_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _agent_index = 0;
#line 23 "../src/librygel-core/agent-matcher.vala"
		_tmp1_ = self->priv->_agents;
#line 23 "../src/librygel-core/agent-matcher.vala"
		_agent_list = _tmp1_;
#line 23 "../src/librygel-core/agent-matcher.vala"
		_tmp2_ = _agent_list;
#line 23 "../src/librygel-core/agent-matcher.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 23 "../src/librygel-core/agent-matcher.vala"
		_tmp4_ = _tmp3_;
#line 23 "../src/librygel-core/agent-matcher.vala"
		_agent_size = _tmp4_;
#line 23 "../src/librygel-core/agent-matcher.vala"
		_agent_index = -1;
#line 23 "../src/librygel-core/agent-matcher.vala"
		while (TRUE) {
#line 506 "agent-matcher.c"
			gint _tmp5_;
			gint _tmp6_;
			gchar* agent = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 23 "../src/librygel-core/agent-matcher.vala"
			_agent_index = _agent_index + 1;
#line 23 "../src/librygel-core/agent-matcher.vala"
			_tmp5_ = _agent_index;
#line 23 "../src/librygel-core/agent-matcher.vala"
			_tmp6_ = _agent_size;
#line 23 "../src/librygel-core/agent-matcher.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 23 "../src/librygel-core/agent-matcher.vala"
				break;
#line 526 "agent-matcher.c"
			}
#line 23 "../src/librygel-core/agent-matcher.vala"
			_tmp7_ = _agent_list;
#line 23 "../src/librygel-core/agent-matcher.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _agent_index);
#line 23 "../src/librygel-core/agent-matcher.vala"
			agent = (gchar*) _tmp8_;
#line 24 "../src/librygel-core/agent-matcher.vala"
			_tmp9_ = agent;
#line 24 "../src/librygel-core/agent-matcher.vala"
			_tmp10_ = g_regex_escape_string (_tmp9_, -1);
#line 24 "../src/librygel-core/agent-matcher.vala"
			_tmp11_ = _tmp10_;
#line 24 "../src/librygel-core/agent-matcher.vala"
			_tmp12_ = g_strdup_printf (RYGEL_AGENT_MATCHER_MATCHING_PATTERN, _tmp11_);
#line 24 "../src/librygel-core/agent-matcher.vala"
			_vala_array_add14 (&agents_with_pattern, &agents_with_pattern_length1, &_agents_with_pattern_size_, _tmp12_);
#line 24 "../src/librygel-core/agent-matcher.vala"
			_g_free0 (_tmp11_);
#line 23 "../src/librygel-core/agent-matcher.vala"
			_g_free0 (agent);
#line 548 "agent-matcher.c"
		}
	}
#line 28 "../src/librygel-core/agent-matcher.vala"
	_tmp13_ = agents_with_pattern;
#line 28 "../src/librygel-core/agent-matcher.vala"
	_tmp13__length1 = agents_with_pattern_length1;
#line 28 "../src/librygel-core/agent-matcher.vala"
	if (_tmp13__length1 > 0) {
#line 557 "agent-matcher.c"
		gchar** _tmp14_;
		gint _tmp14__length1;
		gchar* _tmp15_;
#line 29 "../src/librygel-core/agent-matcher.vala"
		_tmp14_ = agents_with_pattern;
#line 29 "../src/librygel-core/agent-matcher.vala"
		_tmp14__length1 = agents_with_pattern_length1;
#line 29 "../src/librygel-core/agent-matcher.vala"
		_tmp15_ = _vala_g_strjoinv ("|", _tmp14_, (gint) _tmp14__length1);
#line 29 "../src/librygel-core/agent-matcher.vala"
		_g_free0 (self->priv->agent_pattern);
#line 29 "../src/librygel-core/agent-matcher.vala"
		self->priv->agent_pattern = _tmp15_;
#line 571 "agent-matcher.c"
	} else {
		gchar* _tmp16_;
#line 31 "../src/librygel-core/agent-matcher.vala"
		_tmp16_ = g_strdup ("");
#line 31 "../src/librygel-core/agent-matcher.vala"
		_g_free0 (self->priv->agent_pattern);
#line 31 "../src/librygel-core/agent-matcher.vala"
		self->priv->agent_pattern = _tmp16_;
#line 580 "agent-matcher.c"
	}
#line 34 "../src/librygel-core/agent-matcher.vala"
	_tmp17_ = self->priv->agent_pattern;
#line 34 "../src/librygel-core/agent-matcher.vala"
	g_debug ("agent-matcher.vala:34: Agent matcher configured for matching %s", _tmp17_);
#line 586 "agent-matcher.c"
	{
		GRegex* _tmp18_ = NULL;
		const gchar* _tmp19_;
		GRegex* _tmp20_;
#line 38 "../src/librygel-core/agent-matcher.vala"
		_tmp19_ = self->priv->agent_pattern;
#line 38 "../src/librygel-core/agent-matcher.vala"
		_tmp20_ = g_regex_new (_tmp19_, 0, 0, &_inner_error0_);
#line 38 "../src/librygel-core/agent-matcher.vala"
		_tmp18_ = _tmp20_;
#line 38 "../src/librygel-core/agent-matcher.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 599 "agent-matcher.c"
			goto __catch0_g_error;
		}
#line 38 "../src/librygel-core/agent-matcher.vala"
		rygel_agent_matcher_set_agent_regex (self, _tmp18_);
#line 37 "../src/librygel-core/agent-matcher.vala"
		_g_regex_unref0 (_tmp18_);
#line 606 "agent-matcher.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp21_;
#line 37 "../src/librygel-core/agent-matcher.vala"
		e = _inner_error0_;
#line 37 "../src/librygel-core/agent-matcher.vala"
		_inner_error0_ = NULL;
#line 40 "../src/librygel-core/agent-matcher.vala"
		_tmp21_ = e->message;
#line 40 "../src/librygel-core/agent-matcher.vala"
		g_critical ("agent-matcher.vala:40: Error generating UserAgent regex: %s, Must not " \
"be reached", _tmp21_);
#line 41 "../src/librygel-core/agent-matcher.vala"
		g_assert_not_reached ();
#line 37 "../src/librygel-core/agent-matcher.vala"
		_g_error_free0 (e);
#line 625 "agent-matcher.c"
	}
	__finally0:
#line 37 "../src/librygel-core/agent-matcher.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "../src/librygel-core/agent-matcher.vala"
		agents_with_pattern = (_vala_array_free (agents_with_pattern, agents_with_pattern_length1, (GDestroyNotify) g_free), NULL);
#line 37 "../src/librygel-core/agent-matcher.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "../src/librygel-core/agent-matcher.vala"
		g_clear_error (&_inner_error0_);
#line 37 "../src/librygel-core/agent-matcher.vala"
		return;
#line 638 "agent-matcher.c"
	}
#line 17 "../src/librygel-core/agent-matcher.vala"
	agents_with_pattern = (_vala_array_free (agents_with_pattern, agents_with_pattern_length1, (GDestroyNotify) g_free), NULL);
#line 642 "agent-matcher.c"
}

gboolean
rygel_agent_matcher_empty (RygelAgentMatcher* self)
{
	const gchar* _tmp0_;
	gboolean result;
#line 45 "../src/librygel-core/agent-matcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../src/librygel-core/agent-matcher.vala"
	_tmp0_ = self->priv->agent_pattern;
#line 46 "../src/librygel-core/agent-matcher.vala"
	result = g_strcmp0 (_tmp0_, "") == 0;
#line 46 "../src/librygel-core/agent-matcher.vala"
	return result;
#line 658 "agent-matcher.c"
}

gboolean
rygel_agent_matcher_matches (RygelAgentMatcher* self,
                             const gchar* header)
{
	GRegex* _tmp0_;
	gboolean result;
#line 49 "../src/librygel-core/agent-matcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 49 "../src/librygel-core/agent-matcher.vala"
	g_return_val_if_fail (header != NULL, FALSE);
#line 50 "../src/librygel-core/agent-matcher.vala"
	_tmp0_ = self->priv->_agent_regex;
#line 50 "../src/librygel-core/agent-matcher.vala"
	result = g_regex_match (_tmp0_, header, 0, NULL);
#line 50 "../src/librygel-core/agent-matcher.vala"
	return result;
#line 677 "agent-matcher.c"
}

GeeArrayList*
rygel_agent_matcher_get_agents (RygelAgentMatcher* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 5 "../src/librygel-core/agent-matcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5 "../src/librygel-core/agent-matcher.vala"
	_tmp0_ = self->priv->_agents;
#line 5 "../src/librygel-core/agent-matcher.vala"
	result = _tmp0_;
#line 5 "../src/librygel-core/agent-matcher.vala"
	return result;
#line 693 "agent-matcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 5 "../src/librygel-core/agent-matcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 701 "agent-matcher.c"
}

static void
rygel_agent_matcher_set_agents (RygelAgentMatcher* self,
                                GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 5 "../src/librygel-core/agent-matcher.vala"
	g_return_if_fail (self != NULL);
#line 5 "../src/librygel-core/agent-matcher.vala"
	old_value = rygel_agent_matcher_get_agents (self);
#line 5 "../src/librygel-core/agent-matcher.vala"
	if (old_value != value) {
#line 715 "agent-matcher.c"
		GeeArrayList* _tmp0_;
#line 5 "../src/librygel-core/agent-matcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 5 "../src/librygel-core/agent-matcher.vala"
		_g_object_unref0 (self->priv->_agents);
#line 5 "../src/librygel-core/agent-matcher.vala"
		self->priv->_agents = _tmp0_;
#line 5 "../src/librygel-core/agent-matcher.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_agent_matcher_properties[RYGEL_AGENT_MATCHER_AGENTS_PROPERTY]);
#line 725 "agent-matcher.c"
	}
}

const gchar*
rygel_agent_matcher_get_name (RygelAgentMatcher* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 6 "../src/librygel-core/agent-matcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6 "../src/librygel-core/agent-matcher.vala"
	_tmp0_ = self->priv->_name;
#line 6 "../src/librygel-core/agent-matcher.vala"
	result = _tmp0_;
#line 6 "../src/librygel-core/agent-matcher.vala"
	return result;
#line 742 "agent-matcher.c"
}

static void
rygel_agent_matcher_set_name (RygelAgentMatcher* self,
                              const gchar* value)
{
	gchar* old_value;
#line 6 "../src/librygel-core/agent-matcher.vala"
	g_return_if_fail (self != NULL);
#line 6 "../src/librygel-core/agent-matcher.vala"
	old_value = rygel_agent_matcher_get_name (self);
#line 6 "../src/librygel-core/agent-matcher.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 756 "agent-matcher.c"
		gchar* _tmp0_;
#line 6 "../src/librygel-core/agent-matcher.vala"
		_tmp0_ = g_strdup (value);
#line 6 "../src/librygel-core/agent-matcher.vala"
		_g_free0 (self->priv->_name);
#line 6 "../src/librygel-core/agent-matcher.vala"
		self->priv->_name = _tmp0_;
#line 6 "../src/librygel-core/agent-matcher.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_agent_matcher_properties[RYGEL_AGENT_MATCHER_NAME_PROPERTY]);
#line 766 "agent-matcher.c"
	}
}

GRegex*
rygel_agent_matcher_get_agent_regex (RygelAgentMatcher* self)
{
	GRegex* result;
	GRegex* _tmp0_;
#line 7 "../src/librygel-core/agent-matcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7 "../src/librygel-core/agent-matcher.vala"
	_tmp0_ = self->priv->_agent_regex;
#line 7 "../src/librygel-core/agent-matcher.vala"
	result = _tmp0_;
#line 7 "../src/librygel-core/agent-matcher.vala"
	return result;
#line 783 "agent-matcher.c"
}

static gpointer
_g_regex_ref0 (gpointer self)
{
#line 7 "../src/librygel-core/agent-matcher.vala"
	return self ? g_regex_ref (self) : NULL;
#line 791 "agent-matcher.c"
}

static void
rygel_agent_matcher_set_agent_regex (RygelAgentMatcher* self,
                                     GRegex* value)
{
	GRegex* old_value;
#line 7 "../src/librygel-core/agent-matcher.vala"
	g_return_if_fail (self != NULL);
#line 7 "../src/librygel-core/agent-matcher.vala"
	old_value = rygel_agent_matcher_get_agent_regex (self);
#line 7 "../src/librygel-core/agent-matcher.vala"
	if (old_value != value) {
#line 805 "agent-matcher.c"
		GRegex* _tmp0_;
#line 7 "../src/librygel-core/agent-matcher.vala"
		_tmp0_ = _g_regex_ref0 (value);
#line 7 "../src/librygel-core/agent-matcher.vala"
		_g_regex_unref0 (self->priv->_agent_regex);
#line 7 "../src/librygel-core/agent-matcher.vala"
		self->priv->_agent_regex = _tmp0_;
#line 7 "../src/librygel-core/agent-matcher.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_agent_matcher_properties[RYGEL_AGENT_MATCHER_AGENT_REGEX_PROPERTY]);
#line 815 "agent-matcher.c"
	}
}

static void
rygel_agent_matcher_class_init (RygelAgentMatcherClass * klass,
                                gpointer klass_data)
{
#line 4 "../src/librygel-core/agent-matcher.vala"
	rygel_agent_matcher_parent_class = g_type_class_peek_parent (klass);
#line 4 "../src/librygel-core/agent-matcher.vala"
	g_type_class_adjust_private_offset (klass, &RygelAgentMatcher_private_offset);
#line 4 "../src/librygel-core/agent-matcher.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_agent_matcher_real_constructed;
#line 4 "../src/librygel-core/agent-matcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_agent_matcher_get_property;
#line 4 "../src/librygel-core/agent-matcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_agent_matcher_set_property;
#line 4 "../src/librygel-core/agent-matcher.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_agent_matcher_finalize;
#line 4 "../src/librygel-core/agent-matcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_AGENT_MATCHER_AGENTS_PROPERTY, rygel_agent_matcher_properties[RYGEL_AGENT_MATCHER_AGENTS_PROPERTY] = g_param_spec_object ("agents", "agents", "agents", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 4 "../src/librygel-core/agent-matcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_AGENT_MATCHER_NAME_PROPERTY, rygel_agent_matcher_properties[RYGEL_AGENT_MATCHER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 4 "../src/librygel-core/agent-matcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_AGENT_MATCHER_AGENT_REGEX_PROPERTY, rygel_agent_matcher_properties[RYGEL_AGENT_MATCHER_AGENT_REGEX_PROPERTY] = g_param_spec_boxed ("agent-regex", "agent-regex", "agent-regex", G_TYPE_REGEX, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 841 "agent-matcher.c"
}

static void
rygel_agent_matcher_instance_init (RygelAgentMatcher * self,
                                   gpointer klass)
{
#line 4 "../src/librygel-core/agent-matcher.vala"
	self->priv = rygel_agent_matcher_get_instance_private (self);
#line 850 "agent-matcher.c"
}

static void
rygel_agent_matcher_finalize (GObject * obj)
{
	RygelAgentMatcher * self;
#line 4 "../src/librygel-core/agent-matcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcher);
#line 5 "../src/librygel-core/agent-matcher.vala"
	_g_object_unref0 (self->priv->_agents);
#line 6 "../src/librygel-core/agent-matcher.vala"
	_g_free0 (self->priv->_name);
#line 7 "../src/librygel-core/agent-matcher.vala"
	_g_regex_unref0 (self->priv->_agent_regex);
#line 9 "../src/librygel-core/agent-matcher.vala"
	_g_free0 (self->priv->agent_pattern);
#line 4 "../src/librygel-core/agent-matcher.vala"
	G_OBJECT_CLASS (rygel_agent_matcher_parent_class)->finalize (obj);
#line 869 "agent-matcher.c"
}

 G_GNUC_NO_INLINE static GType
rygel_agent_matcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelAgentMatcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_agent_matcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelAgentMatcher), 0, (GInstanceInitFunc) rygel_agent_matcher_instance_init, NULL };
	GType rygel_agent_matcher_type_id;
	rygel_agent_matcher_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelAgentMatcher", &g_define_type_info, 0);
	RygelAgentMatcher_private_offset = g_type_add_instance_private (rygel_agent_matcher_type_id, sizeof (RygelAgentMatcherPrivate));
	return rygel_agent_matcher_type_id;
}

GType
rygel_agent_matcher_get_type (void)
{
	static volatile gsize rygel_agent_matcher_type_id__once = 0;
	if (g_once_init_enter (&rygel_agent_matcher_type_id__once)) {
		GType rygel_agent_matcher_type_id;
		rygel_agent_matcher_type_id = rygel_agent_matcher_get_type_once ();
		g_once_init_leave (&rygel_agent_matcher_type_id__once, rygel_agent_matcher_type_id);
	}
	return rygel_agent_matcher_type_id__once;
}

static void
_vala_rygel_agent_matcher_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	RygelAgentMatcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcher);
#line 4 "../src/librygel-core/agent-matcher.vala"
	switch (property_id) {
#line 4 "../src/librygel-core/agent-matcher.vala"
		case RYGEL_AGENT_MATCHER_AGENTS_PROPERTY:
#line 4 "../src/librygel-core/agent-matcher.vala"
		g_value_set_object (value, rygel_agent_matcher_get_agents (self));
#line 4 "../src/librygel-core/agent-matcher.vala"
		break;
#line 4 "../src/librygel-core/agent-matcher.vala"
		case RYGEL_AGENT_MATCHER_NAME_PROPERTY:
#line 4 "../src/librygel-core/agent-matcher.vala"
		g_value_set_string (value, rygel_agent_matcher_get_name (self));
#line 4 "../src/librygel-core/agent-matcher.vala"
		break;
#line 4 "../src/librygel-core/agent-matcher.vala"
		case RYGEL_AGENT_MATCHER_AGENT_REGEX_PROPERTY:
#line 4 "../src/librygel-core/agent-matcher.vala"
		g_value_set_boxed (value, rygel_agent_matcher_get_agent_regex (self));
#line 4 "../src/librygel-core/agent-matcher.vala"
		break;
#line 922 "agent-matcher.c"
		default:
#line 4 "../src/librygel-core/agent-matcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "../src/librygel-core/agent-matcher.vala"
		break;
#line 928 "agent-matcher.c"
	}
}

static void
_vala_rygel_agent_matcher_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	RygelAgentMatcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcher);
#line 4 "../src/librygel-core/agent-matcher.vala"
	switch (property_id) {
#line 4 "../src/librygel-core/agent-matcher.vala"
		case RYGEL_AGENT_MATCHER_AGENTS_PROPERTY:
#line 4 "../src/librygel-core/agent-matcher.vala"
		rygel_agent_matcher_set_agents (self, g_value_get_object (value));
#line 4 "../src/librygel-core/agent-matcher.vala"
		break;
#line 4 "../src/librygel-core/agent-matcher.vala"
		case RYGEL_AGENT_MATCHER_NAME_PROPERTY:
#line 4 "../src/librygel-core/agent-matcher.vala"
		rygel_agent_matcher_set_name (self, g_value_get_string (value));
#line 4 "../src/librygel-core/agent-matcher.vala"
		break;
#line 4 "../src/librygel-core/agent-matcher.vala"
		case RYGEL_AGENT_MATCHER_AGENT_REGEX_PROPERTY:
#line 4 "../src/librygel-core/agent-matcher.vala"
		rygel_agent_matcher_set_agent_regex (self, g_value_get_boxed (value));
#line 4 "../src/librygel-core/agent-matcher.vala"
		break;
#line 960 "agent-matcher.c"
		default:
#line 4 "../src/librygel-core/agent-matcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "../src/librygel-core/agent-matcher.vala"
		break;
#line 966 "agent-matcher.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

