/* rygel-energy-management.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-energy-management.vala, do not modify */

/*
 * Copyright (C) 2013 Intel Corporation.
 *
 * Author: Jussi Kukkonen <jussi.kukkonen@intel.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
/* EnergyManagement service implementation. The service will be run on
 * plugins that have
 *     energy-management=true
 * set in their configuration. It requires UPower to function properly.
 *
 * Every network interface that supports Wake-On should have a
 * configuration group:
 *     [EnergyManagement-eth0]
 *     mode-on-suspend=IP-down-WakeOn
 *     supported-transport=UDP-Broadcast
 *     password=FEEDDEADBEEF
 * mode-on-suspend is required (without it the mode will always be
 * "Unimplemented"), other configuration items are not.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <string.h>
#include "rygel-core.h"
#include <glib.h>
#include <stdlib.h>
#include <libgupnp/gupnp.h>
#include <libgssdp/gssdp.h>
#include <glib/gi18n-lib.h>

#define RYGEL_ENERGY_MANAGEMENT_TEMPLATE "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" "<NetworkInterfaceInfo xsi:schemaLocation=\"urn:schemas-upnp-org:lp:em-" \
"NetworkInterfaceInfo http://www.upnp.org/schemas/lp/em-NetworkInterfac" \
"eInfo.xsd\" " "                      xmlns=\"urn:schemas-upnp-org:lp:em-NetworkInterf" \
"aceInfo\" " "                      xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-ins" \
"tance\">" "%s" "</NetworkInterfaceInfo>"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_UPOWER (upower_get_type ())
#define UPOWER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UPOWER, UPower))
#define IS_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UPOWER))
#define UPOWER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_UPOWER, UPowerIface))

typedef struct _UPower UPower;
typedef struct _UPowerIface UPowerIface;

#define TYPE_UPOWER_PROXY (upower_proxy_get_type ())
enum  {
	UPOWER_SLEEPING_SIGNAL,
	UPOWER_RESUMING_SIGNAL,
	UPOWER_NUM_SIGNALS
};
static guint upower_signals[UPOWER_NUM_SIGNALS] = {0};
typedef GDBusProxy UPowerProxy;
typedef GDBusProxyClass UPowerProxyClass;
enum  {
	RYGEL_ENERGY_MANAGEMENT_0_PROPERTY,
	RYGEL_ENERGY_MANAGEMENT_NUM_PROPERTIES
};
static GParamSpec* rygel_energy_management_properties[RYGEL_ENERGY_MANAGEMENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _UPowerIface {
	GTypeInterface parent_iface;
};

struct _RygelEnergyManagementPrivate {
	RygelConfiguration* config;
	gboolean sleeping;
	UPower* upower;
};

static gint RygelEnergyManagement_private_offset;
static gpointer rygel_energy_management_parent_class = NULL;

VALA_EXTERN GType upower_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType upower_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint upower_register_object (void* object,
                              GDBusConnection* connection,
                              const gchar* path,
                              GError** error);
static GType upower_get_type_once (void);
static void upower_proxy_g_signal (GDBusProxy* proxy,
                            const gchar* sender_name,
                            const gchar* signal_name,
                            GVariant* parameters);
static void _dbus_handle_upower_sleeping (UPower* self,
                                   GVariant* parameters);
static void _dbus_handle_upower_resuming (UPower* self,
                                   GVariant* parameters);
static void upower_proxy_upower_interface_init (UPowerIface* iface);
static void upower_dbus_interface_method_call (GDBusConnection* connection,
                                        const gchar* sender,
                                        const gchar* object_path,
                                        const gchar* interface_name,
                                        const gchar* method_name,
                                        GVariant* parameters,
                                        GDBusMethodInvocation* invocation,
                                        gpointer user_data);
static GVariant* upower_dbus_interface_get_property (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GError** error,
                                              gpointer user_data);
static gboolean upower_dbus_interface_set_property (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* property_name,
                                             GVariant* value,
                                             GError** error,
                                             gpointer user_data);
static void _dbus_upower_sleeping (GObject* _sender,
                            gpointer* _data);
static void _dbus_upower_resuming (GObject* _sender,
                            gpointer* _data);
static void _upower_unregister_object (gpointer user_data);
static void rygel_energy_management_real_constructed (GObject* base);
static void rygel_energy_management_upower_sleeping_cb (RygelEnergyManagement* self);
static void _rygel_energy_management_upower_sleeping_cb_upower_sleeping (UPower* _sender,
                                                                  gpointer self);
static void rygel_energy_management_upower_resuming_cb (RygelEnergyManagement* self);
static void _rygel_energy_management_upower_resuming_cb_upower_resuming (UPower* _sender,
                                                                  gpointer self);
static void rygel_energy_management_query_network_interface_info_cb (RygelEnergyManagement* self,
                                                              GUPnPService* em,
                                                              const gchar* var,
                                                              GValue* val);
static void _rygel_energy_management_query_network_interface_info_cb_gupnp_service_query_variable (GUPnPService* _sender,
                                                                                            const gchar* variable,
                                                                                            GValue* value,
                                                                                            gpointer self);
static void rygel_energy_management_query_proxied_network_interface_info_cb (RygelEnergyManagement* self,
                                                                      GUPnPService* em,
                                                                      const gchar* var,
                                                                      GValue* val);
static void _rygel_energy_management_query_proxied_network_interface_info_cb_gupnp_service_query_variable (GUPnPService* _sender,
                                                                                                    const gchar* variable,
                                                                                                    GValue* value,
                                                                                                    gpointer self);
static void rygel_energy_management_get_interface_info_cb (RygelEnergyManagement* self,
                                                    GUPnPService* em,
                                                    GUPnPServiceAction* action);
static void _rygel_energy_management_get_interface_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                                  GUPnPServiceAction* action,
                                                                                  gpointer self);
static gchar* rygel_energy_management_create_network_interface_info (RygelEnergyManagement* self);
gboolean rygel_energy_management_get_mac_and_network_type (const gchar* iface,
                                                           gchar** mac,
                                                           gchar** type);
static gchar* rygel_energy_management_create_proxied_network_interface_info (RygelEnergyManagement* self);
static void rygel_energy_management_finalize (GObject * obj);
static GType rygel_energy_management_get_type_once (void);

static const GDBusMethodInfo * const _upower_dbus_method_info[] = {NULL};
static const GDBusArgInfo * const _upower_dbus_arg_info_sleeping[] = {NULL};
static const GDBusSignalInfo _upower_dbus_signal_info_sleeping = {-1, "Sleeping", (GDBusArgInfo **) (&_upower_dbus_arg_info_sleeping), NULL};
static const GDBusArgInfo * const _upower_dbus_arg_info_resuming[] = {NULL};
static const GDBusSignalInfo _upower_dbus_signal_info_resuming = {-1, "Resuming", (GDBusArgInfo **) (&_upower_dbus_arg_info_resuming), NULL};
static const GDBusSignalInfo * const _upower_dbus_signal_info[] = {&_upower_dbus_signal_info_sleeping, &_upower_dbus_signal_info_resuming, NULL};
static const GDBusPropertyInfo * const _upower_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _upower_dbus_interface_info = {-1, "org.freedesktop.UPower", (GDBusMethodInfo **) (&_upower_dbus_method_info), (GDBusSignalInfo **) (&_upower_dbus_signal_info), (GDBusPropertyInfo **) (&_upower_dbus_property_info), NULL};
static const GDBusInterfaceVTable _upower_dbus_interface_vtable = {upower_dbus_interface_method_call, upower_dbus_interface_get_property, upower_dbus_interface_set_property};

static void
upower_default_init (UPowerIface * iface,
                     gpointer iface_data)
{
#line 44 "../src/librygel-core/rygel-energy-management.vala"
	upower_signals[UPOWER_SLEEPING_SIGNAL] = g_signal_new ("sleeping", TYPE_UPOWER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 44 "../src/librygel-core/rygel-energy-management.vala"
	upower_signals[UPOWER_RESUMING_SIGNAL] = g_signal_new ("resuming", TYPE_UPOWER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 199 "rygel-energy-management.c"
}

 G_GNUC_NO_INLINE static GType
upower_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UPowerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upower_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType upower_type_id;
	upower_type_id = g_type_register_static (G_TYPE_INTERFACE, "UPower", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (upower_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (upower_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) upower_proxy_get_type);
	g_type_set_qdata (upower_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.UPower");
	g_type_set_qdata (upower_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_upower_dbus_interface_info));
	g_type_set_qdata (upower_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) upower_register_object);
	return upower_type_id;
}

GType
upower_get_type (void)
{
	static volatile gsize upower_type_id__once = 0;
	if (g_once_init_enter (&upower_type_id__once)) {
		GType upower_type_id;
		upower_type_id = upower_get_type_once ();
		g_once_init_leave (&upower_type_id__once, upower_type_id);
	}
	return upower_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (UPowerProxy, upower_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_UPOWER, upower_proxy_upower_interface_init) )
static void
upower_proxy_class_init (UPowerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = upower_proxy_g_signal;
}

static void
_dbus_handle_upower_sleeping (UPower* self,
                              GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "sleeping");
}

static void
_dbus_handle_upower_resuming (UPower* self,
                              GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "resuming");
}

static void
upower_proxy_g_signal (GDBusProxy* proxy,
                       const gchar* sender_name,
                       const gchar* signal_name,
                       GVariant* parameters)
{
	if (strcmp (signal_name, "Sleeping") == 0) {
		_dbus_handle_upower_sleeping ((UPower*) proxy, parameters);
	} else if (strcmp (signal_name, "Resuming") == 0) {
		_dbus_handle_upower_resuming ((UPower*) proxy, parameters);
	}
}

static void
upower_proxy_init (UPowerProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_upower_dbus_interface_info));
}

static void
upower_proxy_upower_interface_init (UPowerIface* iface)
{
}

static void
upower_dbus_interface_method_call (GDBusConnection* connection,
                                   const gchar* sender,
                                   const gchar* object_path,
                                   const gchar* interface_name,
                                   const gchar* method_name,
                                   GVariant* parameters,
                                   GDBusMethodInvocation* invocation,
                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
upower_dbus_interface_get_property (GDBusConnection* connection,
                                    const gchar* sender,
                                    const gchar* object_path,
                                    const gchar* interface_name,
                                    const gchar* property_name,
                                    GError** error,
                                    gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
upower_dbus_interface_set_property (GDBusConnection* connection,
                                    const gchar* sender,
                                    const gchar* object_path,
                                    const gchar* interface_name,
                                    const gchar* property_name,
                                    GVariant* value,
                                    GError** error,
                                    gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_upower_sleeping (GObject* _sender,
                       gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "Sleeping", _arguments, NULL);
}

static void
_dbus_upower_resuming (GObject* _sender,
                       gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "Resuming", _arguments, NULL);
}

guint
upower_register_object (gpointer object,
                        GDBusConnection* connection,
                        const gchar* path,
                        GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_upower_dbus_interface_info), &_upower_dbus_interface_vtable, data, _upower_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "sleeping", (GCallback) _dbus_upower_sleeping, data);
	g_signal_connect (object, "resuming", (GCallback) _dbus_upower_resuming, data);
	return result;
}

static void
_upower_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_sleeping, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_resuming, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
rygel_energy_management_get_instance_private (RygelEnergyManagement* self)
{
	return G_STRUCT_MEMBER_P (self, RygelEnergyManagement_private_offset);
}

static void
_rygel_energy_management_upower_sleeping_cb_upower_sleeping (UPower* _sender,
                                                             gpointer self)
{
#line 82 "../src/librygel-core/rygel-energy-management.vala"
	rygel_energy_management_upower_sleeping_cb ((RygelEnergyManagement*) self);
#line 403 "rygel-energy-management.c"
}

static void
_rygel_energy_management_upower_resuming_cb_upower_resuming (UPower* _sender,
                                                             gpointer self)
{
#line 83 "../src/librygel-core/rygel-energy-management.vala"
	rygel_energy_management_upower_resuming_cb ((RygelEnergyManagement*) self);
#line 412 "rygel-energy-management.c"
}

static void
_rygel_energy_management_query_network_interface_info_cb_gupnp_service_query_variable (GUPnPService* _sender,
                                                                                       const gchar* variable,
                                                                                       GValue* value,
                                                                                       gpointer self)
{
#line 88 "../src/librygel-core/rygel-energy-management.vala"
	rygel_energy_management_query_network_interface_info_cb ((RygelEnergyManagement*) self, _sender, variable, value);
#line 423 "rygel-energy-management.c"
}

static void
_rygel_energy_management_query_proxied_network_interface_info_cb_gupnp_service_query_variable (GUPnPService* _sender,
                                                                                               const gchar* variable,
                                                                                               GValue* value,
                                                                                               gpointer self)
{
#line 90 "../src/librygel-core/rygel-energy-management.vala"
	rygel_energy_management_query_proxied_network_interface_info_cb ((RygelEnergyManagement*) self, _sender, variable, value);
#line 434 "rygel-energy-management.c"
}

static void
_rygel_energy_management_get_interface_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                             GUPnPServiceAction* action,
                                                                             gpointer self)
{
#line 93 "../src/librygel-core/rygel-energy-management.vala"
	rygel_energy_management_get_interface_info_cb ((RygelEnergyManagement*) self, _sender, action);
#line 444 "rygel-energy-management.c"
}

static void
rygel_energy_management_real_constructed (GObject* base)
{
	RygelEnergyManagement * self;
	RygelMetaConfig* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 68 "../src/librygel-core/rygel-energy-management.vala"
	self = (RygelEnergyManagement*) base;
#line 69 "../src/librygel-core/rygel-energy-management.vala"
	G_OBJECT_CLASS (rygel_energy_management_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gupnp_service_get_type (), GUPnPService));
#line 71 "../src/librygel-core/rygel-energy-management.vala"
	_tmp0_ = rygel_meta_config_get_default ();
#line 71 "../src/librygel-core/rygel-energy-management.vala"
	_g_object_unref0 (self->priv->config);
#line 71 "../src/librygel-core/rygel-energy-management.vala"
	self->priv->config = (RygelConfiguration*) _tmp0_;
#line 73 "../src/librygel-core/rygel-energy-management.vala"
	self->priv->sleeping = FALSE;
#line 465 "rygel-energy-management.c"
	{
		UPower* _tmp1_ = NULL;
		UPower* _tmp2_;
		UPower* _tmp3_;
		UPower* _tmp4_;
		UPower* _tmp5_;
#line 77 "../src/librygel-core/rygel-energy-management.vala"
		_tmp2_ = (UPower*) g_initable_new (TYPE_UPOWER_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES, "g-name", "org.freedesktop.UPower", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/UPower", "g-interface-name", "org.freedesktop.UPower", NULL);
#line 77 "../src/librygel-core/rygel-energy-management.vala"
		_tmp1_ = (UPower*) _tmp2_;
#line 77 "../src/librygel-core/rygel-energy-management.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/librygel-core/rygel-energy-management.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 480 "rygel-energy-management.c"
				goto __catch0_g_io_error;
			}
#line 77 "../src/librygel-core/rygel-energy-management.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/librygel-core/rygel-energy-management.vala"
			g_clear_error (&_inner_error0_);
#line 77 "../src/librygel-core/rygel-energy-management.vala"
			return;
#line 489 "rygel-energy-management.c"
		}
#line 77 "../src/librygel-core/rygel-energy-management.vala"
		_tmp3_ = _tmp1_;
#line 77 "../src/librygel-core/rygel-energy-management.vala"
		_tmp1_ = NULL;
#line 77 "../src/librygel-core/rygel-energy-management.vala"
		_g_object_unref0 (self->priv->upower);
#line 77 "../src/librygel-core/rygel-energy-management.vala"
		self->priv->upower = _tmp3_;
#line 82 "../src/librygel-core/rygel-energy-management.vala"
		_tmp4_ = self->priv->upower;
#line 82 "../src/librygel-core/rygel-energy-management.vala"
		g_signal_connect_object (_tmp4_, "sleeping", (GCallback) _rygel_energy_management_upower_sleeping_cb_upower_sleeping, self, 0);
#line 83 "../src/librygel-core/rygel-energy-management.vala"
		_tmp5_ = self->priv->upower;
#line 83 "../src/librygel-core/rygel-energy-management.vala"
		g_signal_connect_object (_tmp5_, "resuming", (GCallback) _rygel_energy_management_upower_resuming_cb_upower_resuming, self, 0);
#line 76 "../src/librygel-core/rygel-energy-management.vala"
		_g_object_unref0 (_tmp1_);
#line 509 "rygel-energy-management.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 76 "../src/librygel-core/rygel-energy-management.vala"
		g_clear_error (&_inner_error0_);
#line 516 "rygel-energy-management.c"
	}
	__finally0:
#line 76 "../src/librygel-core/rygel-energy-management.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 76 "../src/librygel-core/rygel-energy-management.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 76 "../src/librygel-core/rygel-energy-management.vala"
		g_clear_error (&_inner_error0_);
#line 76 "../src/librygel-core/rygel-energy-management.vala"
		return;
#line 527 "rygel-energy-management.c"
	}
#line 88 "../src/librygel-core/rygel-energy-management.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::NetworkInterfaceInfo", (GCallback) _rygel_energy_management_query_network_interface_info_cb_gupnp_service_query_variable, self, 0);
#line 90 "../src/librygel-core/rygel-energy-management.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::ProxiedNetworkInterfaceInfo", (GCallback) _rygel_energy_management_query_proxied_network_interface_info_cb_gupnp_service_query_variable, self, 0);
#line 93 "../src/librygel-core/rygel-energy-management.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetInterfaceInfo", (GCallback) _rygel_energy_management_get_interface_info_cb_gupnp_service_action_invoked, self, 0);
#line 535 "rygel-energy-management.c"
}

static void
rygel_energy_management_upower_sleeping_cb (RygelEnergyManagement* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 97 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/librygel-core/rygel-energy-management.vala"
	if (self->priv->sleeping == TRUE) {
#line 99 "../src/librygel-core/rygel-energy-management.vala"
		return;
#line 549 "rygel-energy-management.c"
	}
#line 102 "../src/librygel-core/rygel-energy-management.vala"
	self->priv->sleeping = TRUE;
#line 103 "../src/librygel-core/rygel-energy-management.vala"
	_tmp0_ = rygel_energy_management_create_network_interface_info (self);
#line 103 "../src/librygel-core/rygel-energy-management.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/librygel-core/rygel-energy-management.vala"
	gupnp_service_notify ((GUPnPService*) self, "NetworkInterfaceInfo", G_TYPE_STRING, _tmp1_, NULL);
#line 103 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (_tmp1_);
#line 561 "rygel-energy-management.c"
}

static void
rygel_energy_management_upower_resuming_cb (RygelEnergyManagement* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 108 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/librygel-core/rygel-energy-management.vala"
	if (self->priv->sleeping == FALSE) {
#line 110 "../src/librygel-core/rygel-energy-management.vala"
		return;
#line 575 "rygel-energy-management.c"
	}
#line 113 "../src/librygel-core/rygel-energy-management.vala"
	self->priv->sleeping = FALSE;
#line 114 "../src/librygel-core/rygel-energy-management.vala"
	_tmp0_ = rygel_energy_management_create_network_interface_info (self);
#line 114 "../src/librygel-core/rygel-energy-management.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/librygel-core/rygel-energy-management.vala"
	gupnp_service_notify ((GUPnPService*) self, "NetworkInterfaceInfo", G_TYPE_STRING, _tmp1_, NULL);
#line 114 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (_tmp1_);
#line 587 "rygel-energy-management.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 609 "rygel-energy-management.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 613 "rygel-energy-management.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 619 "rygel-energy-management.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 623 "rygel-energy-management.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 627 "rygel-energy-management.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 635 "rygel-energy-management.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 663 "rygel-energy-management.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 672 "rygel-energy-management.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 686 "rygel-energy-management.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 695 "rygel-energy-management.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 709 "rygel-energy-management.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 718 "rygel-energy-management.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 727 "rygel-energy-management.c"
}

static gchar*
rygel_energy_management_create_network_interface_info (RygelEnergyManagement* self)
{
	gchar* mac_address = NULL;
	gchar* type = NULL;
	gboolean success = FALSE;
	gchar* iface = NULL;
	GUPnPRootDevice* _tmp0_;
	GUPnPRootDevice* _tmp1_;
	GUPnPRootDevice* _tmp2_;
	GUPnPContext* _tmp3_;
	GUPnPContext* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* config_section = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gboolean _tmp12_;
	gchar* mac = NULL;
	gchar* _tmp13_;
	gchar* wake_pattern = NULL;
	gchar* _tmp14_;
	GInetAddress* ip_addr = NULL;
	GUPnPRootDevice* _tmp19_;
	GUPnPRootDevice* _tmp20_;
	GUPnPRootDevice* _tmp21_;
	GUPnPContext* _tmp22_;
	GUPnPContext* _tmp23_;
	GInetAddress* _tmp24_;
	GInetAddress* _tmp25_;
	GInetAddress* _tmp26_;
	gboolean _tmp27_ = FALSE;
	GInetAddress* _tmp28_;
	gboolean is_ipv6 = FALSE;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gchar* associated_ips = NULL;
	GInetAddress* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* mode = NULL;
	gboolean _tmp39_ = FALSE;
	gchar* transport_node = NULL;
	gchar* device_info = NULL;
	GUPnPRootDevice* _tmp52_;
	GUPnPRootDevice* _tmp53_;
	GUPnPRootDevice* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	GUPnPRootDevice* _tmp57_;
	GUPnPRootDevice* _tmp58_;
	GUPnPRootDevice* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 123 "../src/librygel-core/rygel-energy-management.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../src/librygel-core/rygel-energy-management.vala"
	success = TRUE;
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	g_object_get ((GUPnPService*) self, "root-device", &_tmp0_, NULL);
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_tmp1_ = _tmp0_;
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_tmp2_ = _tmp1_;
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_tmp3_ = gupnp_device_info_get_context ((GUPnPDeviceInfo*) _tmp2_);
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_tmp4_ = _tmp3_;
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_tmp5_ = gssdp_client_get_interface ((GSSDPClient*) _tmp4_);
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_tmp6_ = _tmp5_;
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_tmp8_ = _tmp7_;
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	_g_object_unref0 (_tmp2_);
#line 128 "../src/librygel-core/rygel-energy-management.vala"
	iface = _tmp8_;
#line 129 "../src/librygel-core/rygel-energy-management.vala"
	_tmp9_ = g_strdup_printf ("EnergyManagement-%s", iface);
#line 129 "../src/librygel-core/rygel-energy-management.vala"
	config_section = _tmp9_;
#line 131 "../src/librygel-core/rygel-energy-management.vala"
	_tmp12_ = rygel_energy_management_get_mac_and_network_type (iface, &_tmp10_, &_tmp11_);
#line 131 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (mac_address);
#line 131 "../src/librygel-core/rygel-energy-management.vala"
	mac_address = _tmp10_;
#line 131 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (type);
#line 131 "../src/librygel-core/rygel-energy-management.vala"
	type = _tmp11_;
#line 131 "../src/librygel-core/rygel-energy-management.vala"
	success = _tmp12_;
#line 133 "../src/librygel-core/rygel-energy-management.vala"
	_tmp13_ = string_replace (mac_address, ":", "");
#line 133 "../src/librygel-core/rygel-energy-management.vala"
	mac = _tmp13_;
#line 135 "../src/librygel-core/rygel-energy-management.vala"
	_tmp14_ = g_strdup_printf ("FFFFFFFFFFFF%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s", mac, mac, mac, mac, mac, mac, mac, mac, mac, mac, mac, mac, mac, mac, mac, mac);
#line 135 "../src/librygel-core/rygel-energy-management.vala"
	wake_pattern = _tmp14_;
#line 848 "rygel-energy-management.c"
	{
		gchar* password = NULL;
		RygelConfiguration* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 139 "../src/librygel-core/rygel-energy-management.vala"
		_tmp15_ = self->priv->config;
#line 139 "../src/librygel-core/rygel-energy-management.vala"
		_tmp16_ = rygel_configuration_get_string (_tmp15_, config_section, "password", &_inner_error0_);
#line 139 "../src/librygel-core/rygel-energy-management.vala"
		password = _tmp16_;
#line 139 "../src/librygel-core/rygel-energy-management.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 863 "rygel-energy-management.c"
			goto __catch0_g_error;
		}
#line 140 "../src/librygel-core/rygel-energy-management.vala"
		_tmp17_ = wake_pattern;
#line 140 "../src/librygel-core/rygel-energy-management.vala"
		_tmp18_ = g_strconcat (_tmp17_, password, NULL);
#line 140 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (wake_pattern);
#line 140 "../src/librygel-core/rygel-energy-management.vala"
		wake_pattern = _tmp18_;
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (password);
#line 876 "rygel-energy-management.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		g_clear_error (&_inner_error0_);
#line 883 "rygel-energy-management.c"
	}
	__finally0:
#line 138 "../src/librygel-core/rygel-energy-management.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (wake_pattern);
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (mac);
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (config_section);
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (iface);
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (type);
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (mac_address);
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		g_clear_error (&_inner_error0_);
#line 138 "../src/librygel-core/rygel-energy-management.vala"
		return NULL;
#line 906 "rygel-energy-management.c"
	}
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	g_object_get ((GUPnPService*) self, "root-device", &_tmp19_, NULL);
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	_tmp20_ = _tmp19_;
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	_tmp21_ = _tmp20_;
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	_tmp22_ = gupnp_device_info_get_context ((GUPnPDeviceInfo*) _tmp21_);
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	_tmp23_ = _tmp22_;
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	_tmp24_ = gssdp_client_get_address ((GSSDPClient*) _tmp23_);
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	_tmp25_ = _tmp24_;
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	_tmp26_ = _tmp25_;
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	_g_object_unref0 (_tmp21_);
#line 143 "../src/librygel-core/rygel-energy-management.vala"
	ip_addr = _tmp26_;
#line 144 "../src/librygel-core/rygel-energy-management.vala"
	_tmp28_ = ip_addr;
#line 144 "../src/librygel-core/rygel-energy-management.vala"
	if (_tmp28_ != NULL) {
#line 932 "rygel-energy-management.c"
		GInetAddress* _tmp29_;
		GSocketFamily _tmp30_;
		GSocketFamily _tmp31_;
#line 144 "../src/librygel-core/rygel-energy-management.vala"
		_tmp29_ = ip_addr;
#line 144 "../src/librygel-core/rygel-energy-management.vala"
		_tmp30_ = g_inet_address_get_family (_tmp29_);
#line 144 "../src/librygel-core/rygel-energy-management.vala"
		_tmp31_ = _tmp30_;
#line 144 "../src/librygel-core/rygel-energy-management.vala"
		_tmp27_ = _tmp31_ == G_SOCKET_FAMILY_IPV6;
#line 944 "rygel-energy-management.c"
	} else {
#line 144 "../src/librygel-core/rygel-energy-management.vala"
		_tmp27_ = FALSE;
#line 948 "rygel-energy-management.c"
	}
#line 144 "../src/librygel-core/rygel-energy-management.vala"
	is_ipv6 = _tmp27_;
#line 146 "../src/librygel-core/rygel-energy-management.vala"
	if (is_ipv6) {
#line 146 "../src/librygel-core/rygel-energy-management.vala"
		_tmp32_ = 6;
#line 956 "rygel-energy-management.c"
	} else {
#line 146 "../src/librygel-core/rygel-energy-management.vala"
		_tmp32_ = 4;
#line 960 "rygel-energy-management.c"
	}
#line 148 "../src/librygel-core/rygel-energy-management.vala"
	if (is_ipv6) {
#line 148 "../src/librygel-core/rygel-energy-management.vala"
		_tmp33_ = 6;
#line 966 "rygel-energy-management.c"
	} else {
#line 148 "../src/librygel-core/rygel-energy-management.vala"
		_tmp33_ = 4;
#line 970 "rygel-energy-management.c"
	}
#line 145 "../src/librygel-core/rygel-energy-management.vala"
	_tmp34_ = ip_addr;
#line 145 "../src/librygel-core/rygel-energy-management.vala"
	_tmp35_ = g_inet_address_to_string (_tmp34_);
#line 145 "../src/librygel-core/rygel-energy-management.vala"
	_tmp36_ = _tmp35_;
#line 145 "../src/librygel-core/rygel-energy-management.vala"
	_tmp37_ = g_strdup_printf ("<Ipv%d>%s</Ipv%d>", _tmp32_, _tmp36_, _tmp33_);
#line 145 "../src/librygel-core/rygel-energy-management.vala"
	_tmp38_ = _tmp37_;
#line 145 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (_tmp36_);
#line 145 "../src/librygel-core/rygel-energy-management.vala"
	associated_ips = _tmp38_;
#line 151 "../src/librygel-core/rygel-energy-management.vala"
	if (!success) {
#line 151 "../src/librygel-core/rygel-energy-management.vala"
		_tmp39_ = TRUE;
#line 990 "rygel-energy-management.c"
	} else {
		UPower* _tmp40_;
#line 151 "../src/librygel-core/rygel-energy-management.vala"
		_tmp40_ = self->priv->upower;
#line 151 "../src/librygel-core/rygel-energy-management.vala"
		_tmp39_ = _tmp40_ == NULL;
#line 997 "rygel-energy-management.c"
	}
#line 151 "../src/librygel-core/rygel-energy-management.vala"
	if (_tmp39_) {
#line 1001 "rygel-energy-management.c"
		gchar* _tmp41_;
#line 152 "../src/librygel-core/rygel-energy-management.vala"
		_tmp41_ = g_strdup ("Unimplemented");
#line 152 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (mode);
#line 152 "../src/librygel-core/rygel-energy-management.vala"
		mode = _tmp41_;
#line 1009 "rygel-energy-management.c"
	} else {
		{
			gchar* sleep_mode = NULL;
			RygelConfiguration* _tmp42_;
			gchar* _tmp43_;
			const gchar* _tmp44_ = NULL;
			gchar* _tmp46_;
#line 156 "../src/librygel-core/rygel-energy-management.vala"
			_tmp42_ = self->priv->config;
#line 156 "../src/librygel-core/rygel-energy-management.vala"
			_tmp43_ = rygel_configuration_get_string (_tmp42_, config_section, "mode-on-suspend", &_inner_error0_);
#line 156 "../src/librygel-core/rygel-energy-management.vala"
			sleep_mode = _tmp43_;
#line 156 "../src/librygel-core/rygel-energy-management.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1025 "rygel-energy-management.c"
				goto __catch1_g_error;
			}
#line 158 "../src/librygel-core/rygel-energy-management.vala"
			if (self->priv->sleeping) {
#line 1030 "rygel-energy-management.c"
				const gchar* _tmp45_;
#line 158 "../src/librygel-core/rygel-energy-management.vala"
				_tmp45_ = sleep_mode;
#line 158 "../src/librygel-core/rygel-energy-management.vala"
				_tmp44_ = _tmp45_;
#line 1036 "rygel-energy-management.c"
			} else {
#line 158 "../src/librygel-core/rygel-energy-management.vala"
				_tmp44_ = "IP-up";
#line 1040 "rygel-energy-management.c"
			}
#line 158 "../src/librygel-core/rygel-energy-management.vala"
			_tmp46_ = g_strdup (_tmp44_);
#line 158 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (mode);
#line 158 "../src/librygel-core/rygel-energy-management.vala"
			mode = _tmp46_;
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (sleep_mode);
#line 1050 "rygel-energy-management.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			gchar* _tmp47_;
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			g_clear_error (&_inner_error0_);
#line 160 "../src/librygel-core/rygel-energy-management.vala"
			_tmp47_ = g_strdup ("Unimplemented");
#line 160 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (mode);
#line 160 "../src/librygel-core/rygel-energy-management.vala"
			mode = _tmp47_;
#line 1064 "rygel-energy-management.c"
		}
		__finally1:
#line 154 "../src/librygel-core/rygel-energy-management.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (mode);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (associated_ips);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_object_unref0 (ip_addr);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (wake_pattern);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (mac);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (config_section);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (iface);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (type);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			_g_free0 (mac_address);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			g_clear_error (&_inner_error0_);
#line 154 "../src/librygel-core/rygel-energy-management.vala"
			return NULL;
#line 1093 "rygel-energy-management.c"
		}
	}
	{
		gchar* val = NULL;
		RygelConfiguration* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
#line 166 "../src/librygel-core/rygel-energy-management.vala"
		_tmp48_ = self->priv->config;
#line 166 "../src/librygel-core/rygel-energy-management.vala"
		_tmp49_ = rygel_configuration_get_string (_tmp48_, config_section, "supported-transport", &_inner_error0_);
#line 166 "../src/librygel-core/rygel-energy-management.vala"
		val = _tmp49_;
#line 166 "../src/librygel-core/rygel-energy-management.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1109 "rygel-energy-management.c"
			goto __catch2_g_error;
		}
#line 168 "../src/librygel-core/rygel-energy-management.vala"
		_tmp50_ = g_strdup_printf ("<WakeSupportedTransport>%s</WakeSupportedTransport>", val);
#line 168 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (transport_node);
#line 168 "../src/librygel-core/rygel-energy-management.vala"
		transport_node = _tmp50_;
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (val);
#line 1120 "rygel-energy-management.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		gchar* _tmp51_;
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		g_clear_error (&_inner_error0_);
#line 171 "../src/librygel-core/rygel-energy-management.vala"
		_tmp51_ = g_strdup ("");
#line 171 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (transport_node);
#line 171 "../src/librygel-core/rygel-energy-management.vala"
		transport_node = _tmp51_;
#line 1134 "rygel-energy-management.c"
	}
	__finally2:
#line 165 "../src/librygel-core/rygel-energy-management.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (transport_node);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (mode);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (associated_ips);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_object_unref0 (ip_addr);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (wake_pattern);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (mac);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (config_section);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (iface);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (type);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		_g_free0 (mac_address);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		g_clear_error (&_inner_error0_);
#line 165 "../src/librygel-core/rygel-energy-management.vala"
		return NULL;
#line 1165 "rygel-energy-management.c"
	}
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	g_object_get ((GUPnPService*) self, "root-device", &_tmp52_, NULL);
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp53_ = _tmp52_;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp54_ = _tmp53_;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp55_ = gupnp_device_info_get_udn ((GUPnPDeviceInfo*) _tmp54_);
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp56_ = _tmp55_;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	g_object_get ((GUPnPService*) self, "root-device", &_tmp57_, NULL);
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp58_ = _tmp57_;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp59_ = _tmp58_;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp60_ = gupnp_device_info_get_friendly_name ((GUPnPDeviceInfo*) _tmp59_);
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp61_ = _tmp60_;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp62_ = mode;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp63_ = associated_ips;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp64_ = wake_pattern;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp65_ = transport_node;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp66_ = g_strdup_printf ("<DeviceInterface>" "<DeviceUUID>%s</DeviceUUID>" "<FriendlyName>%s</FriendlyName>" "<NetworkInterface>" "<SystemName>%s</SystemName>" "<MacAddress>%s</MacAddress>" "<InterfaceType>%s</InterfaceType>" "<NetworkInterfaceMode>%s</NetworkInterfaceMode>" "<AssociatedIpAddresses>%s</AssociatedIpAddresses>" "<WakeOnPattern>%s</WakeOnPattern>" "%s" "</NetworkInterface>" "</DeviceInterface>", _tmp56_, _tmp61_, iface, mac_address, type, _tmp62_, _tmp63_, _tmp64_, _tmp65_);
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_tmp67_ = _tmp66_;
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (_tmp61_);
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_g_object_unref0 (_tmp59_);
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	_g_object_unref0 (_tmp54_);
#line 174 "../src/librygel-core/rygel-energy-management.vala"
	device_info = _tmp67_;
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_tmp68_ = g_strdup_printf (RYGEL_ENERGY_MANAGEMENT_TEMPLATE, device_info);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	result = _tmp68_;
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (device_info);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (transport_node);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (mode);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (associated_ips);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_object_unref0 (ip_addr);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (wake_pattern);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (mac);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (config_section);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (iface);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (type);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (mac_address);
#line 197 "../src/librygel-core/rygel-energy-management.vala"
	return result;
#line 1235 "rygel-energy-management.c"
}

static gchar*
rygel_energy_management_create_proxied_network_interface_info (RygelEnergyManagement* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 200 "../src/librygel-core/rygel-energy-management.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 203 "../src/librygel-core/rygel-energy-management.vala"
	_tmp0_ = g_strdup_printf (RYGEL_ENERGY_MANAGEMENT_TEMPLATE, "");
#line 203 "../src/librygel-core/rygel-energy-management.vala"
	result = _tmp0_;
#line 203 "../src/librygel-core/rygel-energy-management.vala"
	return result;
#line 1251 "rygel-energy-management.c"
}

static void
rygel_energy_management_query_network_interface_info_cb (RygelEnergyManagement* self,
                                                         GUPnPService* em,
                                                         const gchar* var,
                                                         GValue* val)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 206 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (em != NULL);
#line 206 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (var != NULL);
#line 206 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (val != NULL);
#line 209 "../src/librygel-core/rygel-energy-management.vala"
	g_value_init (val, G_TYPE_STRING);
#line 210 "../src/librygel-core/rygel-energy-management.vala"
	_tmp0_ = rygel_energy_management_create_network_interface_info (self);
#line 210 "../src/librygel-core/rygel-energy-management.vala"
	_tmp1_ = _tmp0_;
#line 210 "../src/librygel-core/rygel-energy-management.vala"
	g_value_set_string (val, _tmp1_);
#line 210 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (_tmp1_);
#line 1280 "rygel-energy-management.c"
}

static void
rygel_energy_management_query_proxied_network_interface_info_cb (RygelEnergyManagement* self,
                                                                 GUPnPService* em,
                                                                 const gchar* var,
                                                                 GValue* val)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 213 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (em != NULL);
#line 213 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (var != NULL);
#line 213 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (val != NULL);
#line 216 "../src/librygel-core/rygel-energy-management.vala"
	g_value_init (val, G_TYPE_STRING);
#line 217 "../src/librygel-core/rygel-energy-management.vala"
	_tmp0_ = rygel_energy_management_create_proxied_network_interface_info (self);
#line 217 "../src/librygel-core/rygel-energy-management.vala"
	_tmp1_ = _tmp0_;
#line 217 "../src/librygel-core/rygel-energy-management.vala"
	g_value_set_string (val, _tmp1_);
#line 217 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (_tmp1_);
#line 1309 "rygel-energy-management.c"
}

static void
rygel_energy_management_get_interface_info_cb (RygelEnergyManagement* self,
                                               GUPnPService* em,
                                               GUPnPServiceAction* action)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 220 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (em != NULL);
#line 220 "../src/librygel-core/rygel-energy-management.vala"
	g_return_if_fail (action != NULL);
#line 222 "../src/librygel-core/rygel-energy-management.vala"
	if (gupnp_service_action_get_argument_count (action) != ((guint) 0)) {
#line 223 "../src/librygel-core/rygel-energy-management.vala"
		gupnp_service_action_return_error (action, (guint) 402, _ ("Invalid argument"));
#line 225 "../src/librygel-core/rygel-energy-management.vala"
		return;
#line 1333 "rygel-energy-management.c"
	}
#line 228 "../src/librygel-core/rygel-energy-management.vala"
	_tmp0_ = rygel_energy_management_create_network_interface_info (self);
#line 228 "../src/librygel-core/rygel-energy-management.vala"
	_tmp1_ = _tmp0_;
#line 228 "../src/librygel-core/rygel-energy-management.vala"
	gupnp_service_action_set (action, "NetworkInterfaceInfo", G_TYPE_STRING, _tmp1_, NULL);
#line 228 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (_tmp1_);
#line 232 "../src/librygel-core/rygel-energy-management.vala"
	_tmp2_ = rygel_energy_management_create_proxied_network_interface_info (self);
#line 232 "../src/librygel-core/rygel-energy-management.vala"
	_tmp3_ = _tmp2_;
#line 232 "../src/librygel-core/rygel-energy-management.vala"
	gupnp_service_action_set (action, "ProxiedNetworkInterfaceInfo", G_TYPE_STRING, _tmp3_, NULL);
#line 232 "../src/librygel-core/rygel-energy-management.vala"
	_g_free0 (_tmp3_);
#line 236 "../src/librygel-core/rygel-energy-management.vala"
	gupnp_service_action_return_success (action);
#line 1353 "rygel-energy-management.c"
}

RygelEnergyManagement*
rygel_energy_management_construct (GType object_type)
{
	RygelEnergyManagement * self = NULL;
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	self = (RygelEnergyManagement*) g_object_new (object_type, NULL);
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	return self;
#line 1364 "rygel-energy-management.c"
}

RygelEnergyManagement*
rygel_energy_management_new (void)
{
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	return rygel_energy_management_construct (RYGEL_TYPE_ENERGY_MANAGEMENT);
#line 1372 "rygel-energy-management.c"
}

static void
rygel_energy_management_class_init (RygelEnergyManagementClass * klass,
                                    gpointer klass_data)
{
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	rygel_energy_management_parent_class = g_type_class_peek_parent (klass);
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	g_type_class_adjust_private_offset (klass, &RygelEnergyManagement_private_offset);
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_energy_management_real_constructed;
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_energy_management_finalize;
#line 1387 "rygel-energy-management.c"
}

static void
rygel_energy_management_instance_init (RygelEnergyManagement * self,
                                       gpointer klass)
{
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	self->priv = rygel_energy_management_get_instance_private (self);
#line 1396 "rygel-energy-management.c"
}

static void
rygel_energy_management_finalize (GObject * obj)
{
	RygelEnergyManagement * self;
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_ENERGY_MANAGEMENT, RygelEnergyManagement);
#line 64 "../src/librygel-core/rygel-energy-management.vala"
	_g_object_unref0 (self->priv->config);
#line 66 "../src/librygel-core/rygel-energy-management.vala"
	_g_object_unref0 (self->priv->upower);
#line 52 "../src/librygel-core/rygel-energy-management.vala"
	G_OBJECT_CLASS (rygel_energy_management_parent_class)->finalize (obj);
#line 1411 "rygel-energy-management.c"
}

/**
 * Implementation of UPnP EnergyManagement service.
 */
 G_GNUC_NO_INLINE static GType
rygel_energy_management_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelEnergyManagementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_energy_management_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelEnergyManagement), 0, (GInstanceInitFunc) rygel_energy_management_instance_init, NULL };
	GType rygel_energy_management_type_id;
	rygel_energy_management_type_id = g_type_register_static (gupnp_service_get_type (), "RygelEnergyManagement", &g_define_type_info, 0);
	RygelEnergyManagement_private_offset = g_type_add_instance_private (rygel_energy_management_type_id, sizeof (RygelEnergyManagementPrivate));
	return rygel_energy_management_type_id;
}

GType
rygel_energy_management_get_type (void)
{
	static volatile gsize rygel_energy_management_type_id__once = 0;
	if (g_once_init_enter (&rygel_energy_management_type_id__once)) {
		GType rygel_energy_management_type_id;
		rygel_energy_management_type_id = rygel_energy_management_get_type_once ();
		g_once_init_leave (&rygel_energy_management_type_id__once, rygel_energy_management_type_id);
	}
	return rygel_energy_management_type_id__once;
}

