/* rygel-log-handler.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-log-handler.vala, do not modify */

/*
 * Copyright (C) 2008 Nokia Corporation.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define RYGEL_LOG_HANDLER_DEFAULT_LEVELS "*:4"
#define RYGEL_LOG_HANDLER_DEFAULT_FLAGS ((((G_LOG_LEVEL_WARNING | G_LOG_LEVEL_CRITICAL) | G_LOG_LEVEL_ERROR) | G_LOG_LEVEL_MESSAGE) | G_LOG_LEVEL_INFO)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_LOG_HANDLER_0_PROPERTY,
	RYGEL_LOG_HANDLER_NUM_PROPERTIES
};
static GParamSpec* rygel_log_handler_properties[RYGEL_LOG_HANDLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _RygelLogHandlerPrivate {
	GeeHashMap* log_level_hash;
};

static gint RygelLogHandler_private_offset;
static gpointer rygel_log_handler_parent_class = NULL;
static RygelLogHandler* rygel_log_handler_log_handler;
static RygelLogHandler* rygel_log_handler_log_handler = NULL;

static RygelLogHandler* rygel_log_handler_new (void);
static RygelLogHandler* rygel_log_handler_construct (GType object_type);
static GLogLevelFlags rygel_log_handler_log_level_to_flags (RygelLogHandler* self,
                                                     RygelLogLevel level);
static void rygel_log_handler_log_func (RygelLogHandler* self,
                                 const gchar* log_domain,
                                 GLogLevelFlags log_levels,
                                 const gchar* message);
static void _rygel_log_handler_log_func_glog_func (const gchar* log_domain,
                                            GLogLevelFlags log_levels,
                                            const gchar* message,
                                            gpointer self);
static void rygel_log_handler_finalize (GObject * obj);
static GType rygel_log_handler_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

 G_GNUC_NO_INLINE static GType
rygel_log_level_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_LOG_LEVEL_INVALID, "RYGEL_LOG_LEVEL_INVALID", "invalid"}, {RYGEL_LOG_LEVEL_ERROR, "RYGEL_LOG_LEVEL_ERROR", "error"}, {RYGEL_LOG_LEVEL_CRITICAL, "RYGEL_LOG_LEVEL_CRITICAL", "critical"}, {RYGEL_LOG_LEVEL_WARNING, "RYGEL_LOG_LEVEL_WARNING", "warning"}, {RYGEL_LOG_LEVEL_INFO, "RYGEL_LOG_LEVEL_INFO", "info"}, {RYGEL_LOG_LEVEL_DEFAULT, "RYGEL_LOG_LEVEL_DEFAULT", "default"}, {RYGEL_LOG_LEVEL_DEBUG, "RYGEL_LOG_LEVEL_DEBUG", "debug"}, {0, NULL, NULL}};
	GType rygel_log_level_type_id;
	rygel_log_level_type_id = g_enum_register_static ("RygelLogLevel", values);
	return rygel_log_level_type_id;
}

GType
rygel_log_level_get_type (void)
{
	static volatile gsize rygel_log_level_type_id__once = 0;
	if (g_once_init_enter (&rygel_log_level_type_id__once)) {
		GType rygel_log_level_type_id;
		rygel_log_level_type_id = rygel_log_level_get_type_once ();
		g_once_init_leave (&rygel_log_level_type_id__once, rygel_log_level_type_id);
	}
	return rygel_log_level_type_id__once;
}

static inline gpointer
rygel_log_handler_get_instance_private (RygelLogHandler* self)
{
	return G_STRUCT_MEMBER_P (self, RygelLogHandler_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "../src/librygel-core/rygel-log-handler.vala"
	return self ? g_object_ref (self) : NULL;
#line 119 "rygel-log-handler.c"
}

RygelLogHandler*
rygel_log_handler_get_default (void)
{
	RygelLogHandler* _tmp0_;
	RygelLogHandler* _tmp2_;
	RygelLogHandler* _tmp3_;
	RygelLogHandler* result;
#line 49 "../src/librygel-core/rygel-log-handler.vala"
	_tmp0_ = rygel_log_handler_log_handler;
#line 49 "../src/librygel-core/rygel-log-handler.vala"
	if (_tmp0_ == NULL) {
#line 133 "rygel-log-handler.c"
		RygelLogHandler* _tmp1_;
#line 50 "../src/librygel-core/rygel-log-handler.vala"
		_tmp1_ = rygel_log_handler_new ();
#line 50 "../src/librygel-core/rygel-log-handler.vala"
		_g_object_unref0 (rygel_log_handler_log_handler);
#line 50 "../src/librygel-core/rygel-log-handler.vala"
		rygel_log_handler_log_handler = _tmp1_;
#line 141 "rygel-log-handler.c"
	}
#line 53 "../src/librygel-core/rygel-log-handler.vala"
	_tmp2_ = rygel_log_handler_log_handler;
#line 53 "../src/librygel-core/rygel-log-handler.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 53 "../src/librygel-core/rygel-log-handler.vala"
	result = _tmp3_;
#line 53 "../src/librygel-core/rygel-log-handler.vala"
	return result;
#line 151 "rygel-log-handler.c"
}

static void
_rygel_log_handler_log_func_glog_func (const gchar* log_domain,
                                       GLogLevelFlags log_levels,
                                       const gchar* message,
                                       gpointer self)
{
#line 94 "../src/librygel-core/rygel-log-handler.vala"
	rygel_log_handler_log_func ((RygelLogHandler*) self, log_domain, log_levels, message);
#line 162 "rygel-log-handler.c"
}

static RygelLogHandler*
rygel_log_handler_construct (GType object_type)
{
	RygelLogHandler * self = NULL;
	GeeHashMap* _tmp0_;
	RygelMetaConfig* config = NULL;
	RygelMetaConfig* _tmp1_;
	gchar* log_levels = NULL;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	GError* _inner_error0_ = NULL;
#line 56 "../src/librygel-core/rygel-log-handler.vala"
	self = (RygelLogHandler*) g_object_new (object_type, NULL);
#line 57 "../src/librygel-core/rygel-log-handler.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 57 "../src/librygel-core/rygel-log-handler.vala"
	_g_object_unref0 (self->priv->log_level_hash);
#line 57 "../src/librygel-core/rygel-log-handler.vala"
	self->priv->log_level_hash = _tmp0_;
#line 60 "../src/librygel-core/rygel-log-handler.vala"
	_tmp1_ = rygel_meta_config_get_default ();
#line 60 "../src/librygel-core/rygel-log-handler.vala"
	config = _tmp1_;
#line 189 "rygel-log-handler.c"
	{
		gchar* _tmp2_ = NULL;
		RygelMetaConfig* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 64 "../src/librygel-core/rygel-log-handler.vala"
		_tmp3_ = config;
#line 64 "../src/librygel-core/rygel-log-handler.vala"
		_tmp4_ = rygel_configuration_get_log_levels ((RygelConfiguration*) _tmp3_, &_inner_error0_);
#line 64 "../src/librygel-core/rygel-log-handler.vala"
		_tmp2_ = _tmp4_;
#line 64 "../src/librygel-core/rygel-log-handler.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "rygel-log-handler.c"
			goto __catch0_g_error;
		}
#line 64 "../src/librygel-core/rygel-log-handler.vala"
		_tmp5_ = _tmp2_;
#line 64 "../src/librygel-core/rygel-log-handler.vala"
		_tmp2_ = NULL;
#line 64 "../src/librygel-core/rygel-log-handler.vala"
		_g_free0 (log_levels);
#line 64 "../src/librygel-core/rygel-log-handler.vala"
		log_levels = _tmp5_;
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		_g_free0 (_tmp2_);
#line 216 "rygel-log-handler.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		err = _inner_error0_;
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		_inner_error0_ = NULL;
#line 66 "../src/librygel-core/rygel-log-handler.vala"
		_tmp6_ = g_strdup (RYGEL_LOG_HANDLER_DEFAULT_LEVELS);
#line 66 "../src/librygel-core/rygel-log-handler.vala"
		_g_free0 (log_levels);
#line 66 "../src/librygel-core/rygel-log-handler.vala"
		log_levels = _tmp6_;
#line 68 "../src/librygel-core/rygel-log-handler.vala"
		_tmp7_ = err;
#line 68 "../src/librygel-core/rygel-log-handler.vala"
		_tmp8_ = _tmp7_->message;
#line 68 "../src/librygel-core/rygel-log-handler.vala"
		g_warning (_ ("Failed to get log level from configuration: %s"), _tmp8_);
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		_g_error_free0 (err);
#line 243 "rygel-log-handler.c"
	}
	__finally0:
#line 63 "../src/librygel-core/rygel-log-handler.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		_g_free0 (log_levels);
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		_g_object_unref0 (config);
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		g_clear_error (&_inner_error0_);
#line 63 "../src/librygel-core/rygel-log-handler.vala"
		return NULL;
#line 258 "rygel-log-handler.c"
	}
#line 72 "../src/librygel-core/rygel-log-handler.vala"
	_tmp9_ = log_levels;
#line 72 "../src/librygel-core/rygel-log-handler.vala"
	_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, ",", 0);
#line 264 "rygel-log-handler.c"
	{
		gchar** pair_collection = NULL;
		gint pair_collection_length1 = 0;
		gint _pair_collection_size_ = 0;
		gint pair_it = 0;
#line 72 "../src/librygel-core/rygel-log-handler.vala"
		pair_collection = _tmp11_;
#line 72 "../src/librygel-core/rygel-log-handler.vala"
		pair_collection_length1 = _vala_array_length (_tmp10_);
#line 72 "../src/librygel-core/rygel-log-handler.vala"
		for (pair_it = 0; pair_it < pair_collection_length1; pair_it = pair_it + 1) {
#line 276 "rygel-log-handler.c"
			gchar* _tmp12_;
			gchar* pair = NULL;
#line 72 "../src/librygel-core/rygel-log-handler.vala"
			_tmp12_ = g_strdup (pair_collection[pair_it]);
#line 72 "../src/librygel-core/rygel-log-handler.vala"
			pair = _tmp12_;
#line 283 "rygel-log-handler.c"
			{
				gchar** tokens = NULL;
				const gchar* _tmp13_;
				gchar** _tmp14_;
				gchar** _tmp15_;
				gint tokens_length1;
				gint _tokens_size_;
				gchar** _tmp16_;
				gint _tmp16__length1;
				gchar* domain = NULL;
				RygelLogLevel level = 0;
				gchar** _tmp17_;
				gint _tmp17__length1;
				GLogLevelFlags flags = 0U;
				GeeHashMap* _tmp26_;
				const gchar* _tmp27_;
#line 73 "../src/librygel-core/rygel-log-handler.vala"
				_tmp13_ = pair;
#line 73 "../src/librygel-core/rygel-log-handler.vala"
				_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, ":", 0);
#line 73 "../src/librygel-core/rygel-log-handler.vala"
				tokens = _tmp15_;
#line 73 "../src/librygel-core/rygel-log-handler.vala"
				tokens_length1 = _vala_array_length (_tmp14_);
#line 73 "../src/librygel-core/rygel-log-handler.vala"
				_tokens_size_ = tokens_length1;
#line 74 "../src/librygel-core/rygel-log-handler.vala"
				_tmp16_ = tokens;
#line 74 "../src/librygel-core/rygel-log-handler.vala"
				_tmp16__length1 = tokens_length1;
#line 74 "../src/librygel-core/rygel-log-handler.vala"
				if (_tmp16__length1 < 1) {
#line 75 "../src/librygel-core/rygel-log-handler.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/librygel-core/rygel-log-handler.vala"
					_g_free0 (pair);
#line 75 "../src/librygel-core/rygel-log-handler.vala"
					break;
#line 322 "rygel-log-handler.c"
				}
#line 81 "../src/librygel-core/rygel-log-handler.vala"
				_tmp17_ = tokens;
#line 81 "../src/librygel-core/rygel-log-handler.vala"
				_tmp17__length1 = tokens_length1;
#line 81 "../src/librygel-core/rygel-log-handler.vala"
				if (_tmp17__length1 == 1) {
#line 330 "rygel-log-handler.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 82 "../src/librygel-core/rygel-log-handler.vala"
					_tmp18_ = tokens;
#line 82 "../src/librygel-core/rygel-log-handler.vala"
					_tmp18__length1 = tokens_length1;
#line 82 "../src/librygel-core/rygel-log-handler.vala"
					_tmp19_ = _tmp18_[0];
#line 82 "../src/librygel-core/rygel-log-handler.vala"
					level = (RygelLogLevel) atoi (_tmp19_);
#line 83 "../src/librygel-core/rygel-log-handler.vala"
					_tmp20_ = g_strdup ("*");
#line 83 "../src/librygel-core/rygel-log-handler.vala"
					_g_free0 (domain);
#line 83 "../src/librygel-core/rygel-log-handler.vala"
					domain = _tmp20_;
#line 349 "rygel-log-handler.c"
				} else {
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gchar** _tmp24_;
					gint _tmp24__length1;
					const gchar* _tmp25_;
#line 85 "../src/librygel-core/rygel-log-handler.vala"
					_tmp21_ = tokens;
#line 85 "../src/librygel-core/rygel-log-handler.vala"
					_tmp21__length1 = tokens_length1;
#line 85 "../src/librygel-core/rygel-log-handler.vala"
					_tmp22_ = _tmp21_[0];
#line 85 "../src/librygel-core/rygel-log-handler.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 85 "../src/librygel-core/rygel-log-handler.vala"
					_g_free0 (domain);
#line 85 "../src/librygel-core/rygel-log-handler.vala"
					domain = _tmp23_;
#line 86 "../src/librygel-core/rygel-log-handler.vala"
					_tmp24_ = tokens;
#line 86 "../src/librygel-core/rygel-log-handler.vala"
					_tmp24__length1 = tokens_length1;
#line 86 "../src/librygel-core/rygel-log-handler.vala"
					_tmp25_ = _tmp24_[1];
#line 86 "../src/librygel-core/rygel-log-handler.vala"
					level = (RygelLogLevel) atoi (_tmp25_);
#line 378 "rygel-log-handler.c"
				}
#line 89 "../src/librygel-core/rygel-log-handler.vala"
				flags = rygel_log_handler_log_level_to_flags (self, level);
#line 91 "../src/librygel-core/rygel-log-handler.vala"
				_tmp26_ = self->priv->log_level_hash;
#line 91 "../src/librygel-core/rygel-log-handler.vala"
				_tmp27_ = domain;
#line 91 "../src/librygel-core/rygel-log-handler.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp26_, _tmp27_, (gpointer) ((gintptr) flags));
#line 72 "../src/librygel-core/rygel-log-handler.vala"
				_g_free0 (domain);
#line 72 "../src/librygel-core/rygel-log-handler.vala"
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/librygel-core/rygel-log-handler.vala"
				_g_free0 (pair);
#line 394 "rygel-log-handler.c"
			}
		}
#line 72 "../src/librygel-core/rygel-log-handler.vala"
		pair_collection = (_vala_array_free (pair_collection, pair_collection_length1, (GDestroyNotify) g_free), NULL);
#line 399 "rygel-log-handler.c"
	}
#line 94 "../src/librygel-core/rygel-log-handler.vala"
	g_log_set_default_handler (_rygel_log_handler_log_func_glog_func, self);
#line 56 "../src/librygel-core/rygel-log-handler.vala"
	_g_free0 (log_levels);
#line 56 "../src/librygel-core/rygel-log-handler.vala"
	_g_object_unref0 (config);
#line 56 "../src/librygel-core/rygel-log-handler.vala"
	return self;
#line 409 "rygel-log-handler.c"
}

static RygelLogHandler*
rygel_log_handler_new (void)
{
#line 56 "../src/librygel-core/rygel-log-handler.vala"
	return rygel_log_handler_construct (RYGEL_TYPE_LOG_HANDLER);
#line 417 "rygel-log-handler.c"
}

static void
rygel_log_handler_log_func (RygelLogHandler* self,
                            const gchar* log_domain,
                            GLogLevelFlags log_levels,
                            const gchar* message)
{
	GLogLevelFlags flags = 0U;
#line 97 "../src/librygel-core/rygel-log-handler.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/librygel-core/rygel-log-handler.vala"
	g_return_if_fail (message != NULL);
#line 100 "../src/librygel-core/rygel-log-handler.vala"
	flags = 0;
#line 102 "../src/librygel-core/rygel-log-handler.vala"
	if (log_domain != NULL) {
#line 435 "rygel-log-handler.c"
		GeeHashMap* _tmp0_;
		gpointer _tmp1_;
#line 103 "../src/librygel-core/rygel-log-handler.vala"
		_tmp0_ = self->priv->log_level_hash;
#line 103 "../src/librygel-core/rygel-log-handler.vala"
		_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, log_domain);
#line 103 "../src/librygel-core/rygel-log-handler.vala"
		flags = (GLogLevelFlags) ((gintptr) _tmp1_);
#line 444 "rygel-log-handler.c"
	}
#line 106 "../src/librygel-core/rygel-log-handler.vala"
	if (flags == 0) {
#line 448 "rygel-log-handler.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
#line 107 "../src/librygel-core/rygel-log-handler.vala"
		_tmp2_ = self->priv->log_level_hash;
#line 107 "../src/librygel-core/rygel-log-handler.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, "*");
#line 107 "../src/librygel-core/rygel-log-handler.vala"
		flags = (GLogLevelFlags) ((gintptr) _tmp3_);
#line 457 "rygel-log-handler.c"
	}
#line 110 "../src/librygel-core/rygel-log-handler.vala"
	if ((flags & log_levels) == log_levels) {
#line 461 "rygel-log-handler.c"
		GLogFunc _tmp4_;
		gpointer _tmp4__target;
#line 112 "../src/librygel-core/rygel-log-handler.vala"
		_tmp4_ = g_log_default_handler;
#line 112 "../src/librygel-core/rygel-log-handler.vala"
		_tmp4__target = NULL;
#line 112 "../src/librygel-core/rygel-log-handler.vala"
		_tmp4_ (log_domain, log_levels, message, _tmp4__target);
#line 470 "rygel-log-handler.c"
	}
}

static GLogLevelFlags
rygel_log_handler_log_level_to_flags (RygelLogHandler* self,
                                      RygelLogLevel level)
{
	GLogLevelFlags flags = 0U;
	GLogLevelFlags result;
#line 116 "../src/librygel-core/rygel-log-handler.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 117 "../src/librygel-core/rygel-log-handler.vala"
	flags = RYGEL_LOG_HANDLER_DEFAULT_FLAGS;
#line 119 "../src/librygel-core/rygel-log-handler.vala"
	switch (level) {
#line 119 "../src/librygel-core/rygel-log-handler.vala"
		case RYGEL_LOG_LEVEL_ERROR:
#line 488 "rygel-log-handler.c"
		{
#line 121 "../src/librygel-core/rygel-log-handler.vala"
			flags = G_LOG_LEVEL_ERROR;
#line 122 "../src/librygel-core/rygel-log-handler.vala"
			break;
#line 494 "rygel-log-handler.c"
		}
#line 119 "../src/librygel-core/rygel-log-handler.vala"
		case RYGEL_LOG_LEVEL_CRITICAL:
#line 498 "rygel-log-handler.c"
		{
#line 124 "../src/librygel-core/rygel-log-handler.vala"
			flags = G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_ERROR;
#line 126 "../src/librygel-core/rygel-log-handler.vala"
			break;
#line 504 "rygel-log-handler.c"
		}
#line 119 "../src/librygel-core/rygel-log-handler.vala"
		case RYGEL_LOG_LEVEL_WARNING:
#line 508 "rygel-log-handler.c"
		{
#line 128 "../src/librygel-core/rygel-log-handler.vala"
			flags = (G_LOG_LEVEL_WARNING | G_LOG_LEVEL_CRITICAL) | G_LOG_LEVEL_ERROR;
#line 131 "../src/librygel-core/rygel-log-handler.vala"
			break;
#line 514 "rygel-log-handler.c"
		}
#line 119 "../src/librygel-core/rygel-log-handler.vala"
		case RYGEL_LOG_LEVEL_INFO:
#line 518 "rygel-log-handler.c"
		{
#line 133 "../src/librygel-core/rygel-log-handler.vala"
			flags = (((G_LOG_LEVEL_WARNING | G_LOG_LEVEL_CRITICAL) | G_LOG_LEVEL_ERROR) | G_LOG_LEVEL_MESSAGE) | G_LOG_LEVEL_INFO;
#line 138 "../src/librygel-core/rygel-log-handler.vala"
			break;
#line 524 "rygel-log-handler.c"
		}
#line 119 "../src/librygel-core/rygel-log-handler.vala"
		case RYGEL_LOG_LEVEL_DEBUG:
#line 528 "rygel-log-handler.c"
		{
#line 140 "../src/librygel-core/rygel-log-handler.vala"
			flags = ((((G_LOG_LEVEL_WARNING | G_LOG_LEVEL_CRITICAL) | G_LOG_LEVEL_ERROR) | G_LOG_LEVEL_MESSAGE) | G_LOG_LEVEL_INFO) | G_LOG_LEVEL_DEBUG;
#line 146 "../src/librygel-core/rygel-log-handler.vala"
			break;
#line 534 "rygel-log-handler.c"
		}
		default:
		{
#line 148 "../src/librygel-core/rygel-log-handler.vala"
			flags = RYGEL_LOG_HANDLER_DEFAULT_FLAGS;
#line 149 "../src/librygel-core/rygel-log-handler.vala"
			break;
#line 542 "rygel-log-handler.c"
		}
	}
#line 152 "../src/librygel-core/rygel-log-handler.vala"
	result = flags;
#line 152 "../src/librygel-core/rygel-log-handler.vala"
	return result;
#line 549 "rygel-log-handler.c"
}

static void
rygel_log_handler_class_init (RygelLogHandlerClass * klass,
                              gpointer klass_data)
{
#line 36 "../src/librygel-core/rygel-log-handler.vala"
	rygel_log_handler_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/librygel-core/rygel-log-handler.vala"
	g_type_class_adjust_private_offset (klass, &RygelLogHandler_private_offset);
#line 36 "../src/librygel-core/rygel-log-handler.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_log_handler_finalize;
#line 562 "rygel-log-handler.c"
}

static void
rygel_log_handler_instance_init (RygelLogHandler * self,
                                 gpointer klass)
{
#line 36 "../src/librygel-core/rygel-log-handler.vala"
	self->priv = rygel_log_handler_get_instance_private (self);
#line 571 "rygel-log-handler.c"
}

static void
rygel_log_handler_finalize (GObject * obj)
{
	RygelLogHandler * self;
#line 36 "../src/librygel-core/rygel-log-handler.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_LOG_HANDLER, RygelLogHandler);
#line 44 "../src/librygel-core/rygel-log-handler.vala"
	_g_object_unref0 (self->priv->log_level_hash);
#line 36 "../src/librygel-core/rygel-log-handler.vala"
	G_OBJECT_CLASS (rygel_log_handler_parent_class)->finalize (obj);
#line 584 "rygel-log-handler.c"
}

 G_GNUC_NO_INLINE static GType
rygel_log_handler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelLogHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_log_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelLogHandler), 0, (GInstanceInitFunc) rygel_log_handler_instance_init, NULL };
	GType rygel_log_handler_type_id;
	rygel_log_handler_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelLogHandler", &g_define_type_info, 0);
	RygelLogHandler_private_offset = g_type_add_instance_private (rygel_log_handler_type_id, sizeof (RygelLogHandlerPrivate));
	return rygel_log_handler_type_id;
}

GType
rygel_log_handler_get_type (void)
{
	static volatile gsize rygel_log_handler_type_id__once = 0;
	if (g_once_init_enter (&rygel_log_handler_type_id__once)) {
		GType rygel_log_handler_type_id;
		rygel_log_handler_type_id = rygel_log_handler_get_type_once ();
		g_once_init_leave (&rygel_log_handler_type_id__once, rygel_log_handler_type_id);
	}
	return rygel_log_handler_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

