/* rygel-plugin-loader.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-plugin-loader.vala, do not modify */

/*
 * Copyright (C) 2008 Nokia Corporation.
 * Copyright (C) 2008 Zeeshan Ali (Khattak) <zeeshanak@gnome.org>.
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *         Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>
#include "config.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_PLUGIN_LOADER_0_PROPERTY,
	RYGEL_PLUGIN_LOADER_NUM_PROPERTIES
};
static GParamSpec* rygel_plugin_loader_properties[RYGEL_PLUGIN_LOADER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
typedef void (*RygelPluginLoaderModuleInitFunc) (RygelPluginLoader* loader, gpointer user_data);
enum  {
	RYGEL_PLUGIN_LOADER_PLUGIN_AVAILABLE_SIGNAL,
	RYGEL_PLUGIN_LOADER_NUM_SIGNALS
};
static guint rygel_plugin_loader_signals[RYGEL_PLUGIN_LOADER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _RygelPluginLoaderPrivate {
	GeeHashMap* plugin_hash;
	GeeHashMap* available_plugins;
	GeeHashSet* loaded_modules;
	RygelConfiguration* config;
};

static gint RygelPluginLoader_private_offset;
static gpointer rygel_plugin_loader_parent_class = NULL;

static gchar* rygel_plugin_loader_get_config_path (void);
static void rygel_plugin_loader_real_constructed (GObject* base);
static void rygel_plugin_loader_on_section_changed (RygelPluginLoader* self,
                                             const gchar* section,
                                             RygelSectionEntry entry);
static void _rygel_plugin_loader_on_section_changed_rygel_configuration_section_changed (RygelConfiguration* _sender,
                                                                                  const gchar* section,
                                                                                  RygelSectionEntry entry,
                                                                                  gpointer self);
static gboolean rygel_plugin_loader_real_load_module_from_file (RygelRecursiveModuleLoader* base,
                                                         GFile* module_file);
static gboolean rygel_plugin_loader_real_load_module_from_info (RygelRecursiveModuleLoader* base,
                                                         RygelPluginInformation* info);
static void rygel_plugin_loader_finalize (GObject * obj);
static GType rygel_plugin_loader_get_type_once (void);

static inline gpointer
rygel_plugin_loader_get_instance_private (RygelPluginLoader* self)
{
	return G_STRUCT_MEMBER_P (self, RygelPluginLoader_private_offset);
}

RygelPluginLoader*
rygel_plugin_loader_construct (GType object_type)
{
	RygelPluginLoader * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 52 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp0_ = rygel_plugin_loader_get_config_path ();
#line 52 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp1_ = _tmp0_;
#line 52 "../src/librygel-core/rygel-plugin-loader.vala"
	self = (RygelPluginLoader*) g_object_new (object_type, "base-path", _tmp1_, NULL);
#line 52 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_free0 (_tmp1_);
#line 51 "../src/librygel-core/rygel-plugin-loader.vala"
	return self;
#line 118 "rygel-plugin-loader.c"
}

RygelPluginLoader*
rygel_plugin_loader_new (void)
{
#line 51 "../src/librygel-core/rygel-plugin-loader.vala"
	return rygel_plugin_loader_construct (RYGEL_TYPE_PLUGIN_LOADER);
#line 126 "rygel-plugin-loader.c"
}

static void
_rygel_plugin_loader_on_section_changed_rygel_configuration_section_changed (RygelConfiguration* _sender,
                                                                             const gchar* section,
                                                                             RygelSectionEntry entry,
                                                                             gpointer self)
{
#line 64 "../src/librygel-core/rygel-plugin-loader.vala"
	rygel_plugin_loader_on_section_changed ((RygelPluginLoader*) self, section, entry);
#line 137 "rygel-plugin-loader.c"
}

static void
rygel_plugin_loader_real_constructed (GObject* base)
{
	RygelPluginLoader * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GeeHashMap* _tmp4_;
	GeeHashSet* _tmp5_;
	RygelMetaConfig* _tmp6_;
	RygelConfiguration* _tmp7_;
	GeeHashMap* _tmp8_;
#line 55 "../src/librygel-core/rygel-plugin-loader.vala"
	self = (RygelPluginLoader*) base;
#line 56 "../src/librygel-core/rygel-plugin-loader.vala"
	G_OBJECT_CLASS (rygel_plugin_loader_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_RECURSIVE_MODULE_LOADER, RygelRecursiveModuleLoader));
#line 58 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp0_ = rygel_recursive_module_loader_get_base_path ((RygelRecursiveModuleLoader*) self);
#line 58 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/librygel-core/rygel-plugin-loader.vala"
	if (_tmp1_ == NULL) {
#line 161 "rygel-plugin-loader.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 59 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp2_ = rygel_plugin_loader_get_config_path ();
#line 59 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp3_ = _tmp2_;
#line 59 "../src/librygel-core/rygel-plugin-loader.vala"
		rygel_recursive_module_loader_set_base_path ((RygelRecursiveModuleLoader*) self, _tmp3_);
#line 59 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_free0 (_tmp3_);
#line 172 "rygel-plugin-loader.c"
	}
#line 61 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, RYGEL_TYPE_PLUGIN, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 61 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (self->priv->plugin_hash);
#line 61 "../src/librygel-core/rygel-plugin-loader.vala"
	self->priv->plugin_hash = _tmp4_;
#line 62 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp5_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 62 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (self->priv->loaded_modules);
#line 62 "../src/librygel-core/rygel-plugin-loader.vala"
	self->priv->loaded_modules = _tmp5_;
#line 63 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp6_ = rygel_meta_config_get_default ();
#line 63 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (self->priv->config);
#line 63 "../src/librygel-core/rygel-plugin-loader.vala"
	self->priv->config = (RygelConfiguration*) _tmp6_;
#line 64 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp7_ = self->priv->config;
#line 64 "../src/librygel-core/rygel-plugin-loader.vala"
	g_signal_connect_object (_tmp7_, "section-changed", (GCallback) _rygel_plugin_loader_on_section_changed_rygel_configuration_section_changed, self, 0);
#line 65 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, RYGEL_TYPE_PLUGIN_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 65 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (self->priv->available_plugins);
#line 65 "../src/librygel-core/rygel-plugin-loader.vala"
	self->priv->available_plugins = _tmp8_;
#line 202 "rygel-plugin-loader.c"
}

/**
     * Checks if a plugin is disabled by the user
     *
     * @param name the name of plugin to check for.
     *
     * @return true if plugin is disabled, false if not.
     */
gboolean
rygel_plugin_loader_plugin_disabled (RygelPluginLoader* self,
                                     const gchar* name)
{
	gboolean enabled = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 75 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 76 "../src/librygel-core/rygel-plugin-loader.vala"
	enabled = TRUE;
#line 225 "rygel-plugin-loader.c"
	{
		gboolean _tmp0_ = FALSE;
		RygelConfiguration* _tmp1_;
#line 78 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp1_ = self->priv->config;
#line 78 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp0_ = rygel_configuration_get_enabled (_tmp1_, name, &_inner_error0_);
#line 78 "../src/librygel-core/rygel-plugin-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 235 "rygel-plugin-loader.c"
			goto __catch0_g_error;
		}
#line 78 "../src/librygel-core/rygel-plugin-loader.vala"
		enabled = _tmp0_;
#line 240 "rygel-plugin-loader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 77 "../src/librygel-core/rygel-plugin-loader.vala"
		err = _inner_error0_;
#line 77 "../src/librygel-core/rygel-plugin-loader.vala"
		_inner_error0_ = NULL;
#line 80 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp2_ = err;
#line 80 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp3_ = _tmp2_->message;
#line 80 "../src/librygel-core/rygel-plugin-loader.vala"
		g_debug ("rygel-plugin-loader.vala:80: Could not find plugin '%s' in configurati" \
"on: %s", name, _tmp3_);
#line 77 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_error_free0 (err);
#line 260 "rygel-plugin-loader.c"
	}
	__finally0:
#line 77 "../src/librygel-core/rygel-plugin-loader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 265 "rygel-plugin-loader.c"
		gboolean _tmp4_ = FALSE;
#line 77 "../src/librygel-core/rygel-plugin-loader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/librygel-core/rygel-plugin-loader.vala"
		g_clear_error (&_inner_error0_);
#line 77 "../src/librygel-core/rygel-plugin-loader.vala"
		return _tmp4_;
#line 273 "rygel-plugin-loader.c"
	}
#line 85 "../src/librygel-core/rygel-plugin-loader.vala"
	result = !enabled;
#line 85 "../src/librygel-core/rygel-plugin-loader.vala"
	return result;
#line 279 "rygel-plugin-loader.c"
}

void
rygel_plugin_loader_add_plugin (RygelPluginLoader* self,
                                RygelPlugin* plugin)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 88 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_if_fail (plugin != NULL);
#line 89 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp0_ = rygel_plugin_get_name (plugin);
#line 89 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp1_ = _tmp0_;
#line 89 "../src/librygel-core/rygel-plugin-loader.vala"
	g_message (_ ("New plugin “%s” available"), _tmp1_);
#line 90 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp2_ = self->priv->plugin_hash;
#line 90 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp3_ = rygel_plugin_get_name (plugin);
#line 90 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp4_ = _tmp3_;
#line 90 "../src/librygel-core/rygel-plugin-loader.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, _tmp4_, plugin);
#line 91 "../src/librygel-core/rygel-plugin-loader.vala"
	g_signal_emit (self, rygel_plugin_loader_signals[RYGEL_PLUGIN_LOADER_PLUGIN_AVAILABLE_SIGNAL], 0, plugin);
#line 311 "rygel-plugin-loader.c"
}

RygelPlugin*
rygel_plugin_loader_get_plugin_by_name (RygelPluginLoader* self,
                                        const gchar* name)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	RygelPlugin* result;
#line 94 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 95 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp0_ = self->priv->plugin_hash;
#line 95 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, name);
#line 95 "../src/librygel-core/rygel-plugin-loader.vala"
	result = (RygelPlugin*) _tmp1_;
#line 95 "../src/librygel-core/rygel-plugin-loader.vala"
	return result;
#line 333 "rygel-plugin-loader.c"
}

GeeCollection*
rygel_plugin_loader_list_plugins (RygelPluginLoader* self)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result;
#line 98 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp0_ = self->priv->plugin_hash;
#line 99 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 99 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp2_ = _tmp1_;
#line 99 "../src/librygel-core/rygel-plugin-loader.vala"
	result = _tmp2_;
#line 99 "../src/librygel-core/rygel-plugin-loader.vala"
	return result;
#line 355 "rygel-plugin-loader.c"
}

static gboolean
rygel_plugin_loader_real_load_module_from_file (RygelRecursiveModuleLoader* base,
                                                GFile* module_file)
{
	RygelPluginLoader * self;
	GeeHashSet* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	GModule* module = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GModule* _tmp8_;
	GModule* _tmp9_;
	GModule* _tmp10_;
	void* function = NULL;
	GModule* _tmp14_;
	void* _tmp15_ = NULL;
	gboolean _tmp16_;
	RygelPluginLoaderModuleInitFunc module_init = NULL;
	void* _tmp20_;
	gpointer module_init_target;
	RygelPluginLoaderModuleInitFunc _tmp21_;
	gpointer _tmp21__target;
	GeeHashSet* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GModule* _tmp25_;
	RygelPluginLoaderModuleInitFunc _tmp26_;
	gpointer _tmp26__target;
	GModule* _tmp27_;
	const gchar* _tmp28_;
	gboolean result;
#line 102 "../src/librygel-core/rygel-plugin-loader.vala"
	self = (RygelPluginLoader*) base;
#line 102 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_val_if_fail (module_file != NULL, FALSE);
#line 103 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp0_ = self->priv->loaded_modules;
#line 103 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp1_ = g_file_get_basename (module_file);
#line 103 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp2_ = _tmp1_;
#line 103 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp3_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp2_);
#line 103 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_free0 (_tmp2_);
#line 103 "../src/librygel-core/rygel-plugin-loader.vala"
	if (_tmp3_) {
#line 407 "rygel-plugin-loader.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 104 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp4_ = g_file_get_basename (module_file);
#line 104 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp5_ = _tmp4_;
#line 104 "../src/librygel-core/rygel-plugin-loader.vala"
		g_warning (_ ("A module named %s is already loaded"), _tmp5_);
#line 104 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_free0 (_tmp5_);
#line 107 "../src/librygel-core/rygel-plugin-loader.vala"
		result = TRUE;
#line 107 "../src/librygel-core/rygel-plugin-loader.vala"
		return result;
#line 422 "rygel-plugin-loader.c"
	}
#line 111 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp6_ = g_file_get_path (module_file);
#line 111 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp7_ = _tmp6_;
#line 111 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp8_ = g_module_open (_tmp7_, G_MODULE_BIND_LOCAL);
#line 111 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp9_ = _tmp8_;
#line 111 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_free0 (_tmp7_);
#line 111 "../src/librygel-core/rygel-plugin-loader.vala"
	module = _tmp9_;
#line 117 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp10_ = module;
#line 117 "../src/librygel-core/rygel-plugin-loader.vala"
	if (_tmp10_ == NULL) {
#line 440 "rygel-plugin-loader.c"
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
#line 118 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp11_ = g_file_get_path (module_file);
#line 118 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp12_ = _tmp11_;
#line 118 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp13_ = g_module_error ();
#line 118 "../src/librygel-core/rygel-plugin-loader.vala"
		g_warning (_ ("Failed to load module from path “%s”: %s"), _tmp12_, _tmp13_);
#line 118 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_free0 (_tmp12_);
#line 122 "../src/librygel-core/rygel-plugin-loader.vala"
		result = TRUE;
#line 122 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_module_close0 (module);
#line 122 "../src/librygel-core/rygel-plugin-loader.vala"
		return result;
#line 460 "rygel-plugin-loader.c"
	}
#line 127 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp14_ = module;
#line 127 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp16_ = g_module_symbol (_tmp14_, "module_init", &_tmp15_);
#line 127 "../src/librygel-core/rygel-plugin-loader.vala"
	function = _tmp15_;
#line 127 "../src/librygel-core/rygel-plugin-loader.vala"
	if (!_tmp16_) {
#line 470 "rygel-plugin-loader.c"
		gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
#line 128 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp17_ = g_file_get_path (module_file);
#line 128 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp18_ = _tmp17_;
#line 128 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp19_ = g_module_error ();
#line 128 "../src/librygel-core/rygel-plugin-loader.vala"
		g_warning (_ ("Failed to find entry point function “%s” in “%s”: %s"), "module_init", _tmp18_, _tmp19_);
#line 128 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_free0 (_tmp18_);
#line 133 "../src/librygel-core/rygel-plugin-loader.vala"
		result = TRUE;
#line 133 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_module_close0 (module);
#line 133 "../src/librygel-core/rygel-plugin-loader.vala"
		return result;
#line 490 "rygel-plugin-loader.c"
	}
#line 136 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp20_ = function;
#line 136 "../src/librygel-core/rygel-plugin-loader.vala"
	module_init = (RygelPluginLoaderModuleInitFunc) _tmp20_;
#line 136 "../src/librygel-core/rygel-plugin-loader.vala"
	module_init_target = NULL;
#line 137 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp21_ = module_init;
#line 137 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp21__target = module_init_target;
#line 137 "../src/librygel-core/rygel-plugin-loader.vala"
	_vala_assert (_tmp21_ != NULL, "module_init != null");
#line 138 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp22_ = self->priv->loaded_modules;
#line 138 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp23_ = g_file_get_basename (module_file);
#line 138 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp24_ = _tmp23_;
#line 138 "../src/librygel-core/rygel-plugin-loader.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp24_);
#line 138 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_free0 (_tmp24_);
#line 141 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp25_ = module;
#line 141 "../src/librygel-core/rygel-plugin-loader.vala"
	g_module_make_resident (_tmp25_);
#line 143 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp26_ = module_init;
#line 143 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp26__target = module_init_target;
#line 143 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp26_ (self, _tmp26__target);
#line 145 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp27_ = module;
#line 145 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp28_ = g_module_name (_tmp27_);
#line 145 "../src/librygel-core/rygel-plugin-loader.vala"
	g_debug ("rygel-plugin-loader.vala:145: Loaded module source: '%s'", _tmp28_);
#line 147 "../src/librygel-core/rygel-plugin-loader.vala"
	result = TRUE;
#line 147 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_module_close0 (module);
#line 147 "../src/librygel-core/rygel-plugin-loader.vala"
	return result;
#line 536 "rygel-plugin-loader.c"
}

static gboolean
rygel_plugin_loader_real_load_module_from_info (RygelRecursiveModuleLoader* base,
                                                RygelPluginInformation* info)
{
	RygelPluginLoader * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	GList* _tmp4_;
	GeeHashMap* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GFile* module_file = NULL;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GFile* _tmp26_;
	gboolean loaded = FALSE;
	GFile* _tmp27_;
	gboolean result;
#line 150 "../src/librygel-core/rygel-plugin-loader.vala"
	self = (RygelPluginLoader*) base;
#line 150 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 151 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp0_ = rygel_plugin_information_get_name (info);
#line 151 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp1_ = _tmp0_;
#line 151 "../src/librygel-core/rygel-plugin-loader.vala"
	g_debug ("rygel-plugin-loader.vala:151: Trying to load plugin '%s'", _tmp1_);
#line 153 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp2_ = rygel_plugin_information_get_conflicts (info);
#line 153 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp3_ = _tmp2_;
#line 153 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp4_ = g_hash_table_get_values (_tmp3_);
#line 577 "rygel-plugin-loader.c"
	{
		GList* conflicting_collection = NULL;
		GList* conflicting_it = NULL;
#line 153 "../src/librygel-core/rygel-plugin-loader.vala"
		conflicting_collection = _tmp4_;
#line 153 "../src/librygel-core/rygel-plugin-loader.vala"
		for (conflicting_it = conflicting_collection; conflicting_it != NULL; conflicting_it = conflicting_it->next) {
#line 585 "rygel-plugin-loader.c"
			const gchar* conflicting = NULL;
#line 153 "../src/librygel-core/rygel-plugin-loader.vala"
			conflicting = (const gchar*) conflicting_it->data;
#line 589 "rygel-plugin-loader.c"
			{
				gboolean _tmp5_ = FALSE;
				GeeHashMap* _tmp6_;
				const gchar* _tmp7_;
#line 154 "../src/librygel-core/rygel-plugin-loader.vala"
				_tmp6_ = self->priv->available_plugins;
#line 154 "../src/librygel-core/rygel-plugin-loader.vala"
				_tmp7_ = conflicting;
#line 154 "../src/librygel-core/rygel-plugin-loader.vala"
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, _tmp7_)) {
#line 600 "rygel-plugin-loader.c"
					GeeHashMap* _tmp8_;
					const gchar* _tmp9_;
					gpointer _tmp10_;
					RygelPluginInformation* _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
#line 155 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp8_ = self->priv->available_plugins;
#line 155 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp9_ = conflicting;
#line 155 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, _tmp9_);
#line 155 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp11_ = (RygelPluginInformation*) _tmp10_;
#line 155 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp12_ = rygel_plugin_information_get_module_loaded (_tmp11_);
#line 155 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp13_ = _tmp12_;
#line 155 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp5_ = _tmp13_;
#line 155 "../src/librygel-core/rygel-plugin-loader.vala"
					_g_object_unref0 (_tmp11_);
#line 623 "rygel-plugin-loader.c"
				} else {
#line 154 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp5_ = FALSE;
#line 627 "rygel-plugin-loader.c"
				}
#line 154 "../src/librygel-core/rygel-plugin-loader.vala"
				if (_tmp5_) {
#line 631 "rygel-plugin-loader.c"
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
#line 156 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp14_ = rygel_plugin_information_get_name (info);
#line 156 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp15_ = _tmp14_;
#line 156 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp16_ = conflicting;
#line 156 "../src/librygel-core/rygel-plugin-loader.vala"
					g_message (_ ("Module '%s' conflicts with already loaded module '%s'. Skipping"), _tmp15_, _tmp16_);
#line 160 "../src/librygel-core/rygel-plugin-loader.vala"
					result = FALSE;
#line 160 "../src/librygel-core/rygel-plugin-loader.vala"
					(conflicting_collection == NULL) ? NULL : (conflicting_collection = (g_list_free (conflicting_collection), NULL));
#line 160 "../src/librygel-core/rygel-plugin-loader.vala"
					return result;
#line 649 "rygel-plugin-loader.c"
				}
			}
		}
#line 153 "../src/librygel-core/rygel-plugin-loader.vala"
		(conflicting_collection == NULL) ? NULL : (conflicting_collection = (g_list_free (conflicting_collection), NULL));
#line 655 "rygel-plugin-loader.c"
	}
#line 164 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp17_ = self->priv->available_plugins;
#line 164 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp18_ = rygel_plugin_information_get_name (info);
#line 164 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp19_ = _tmp18_;
#line 164 "../src/librygel-core/rygel-plugin-loader.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, _tmp19_, info);
#line 165 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp20_ = rygel_plugin_information_get_name (info);
#line 165 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp21_ = _tmp20_;
#line 165 "../src/librygel-core/rygel-plugin-loader.vala"
	if (rygel_plugin_loader_plugin_disabled (self, _tmp21_)) {
#line 671 "rygel-plugin-loader.c"
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 166 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp22_ = rygel_plugin_information_get_name (info);
#line 166 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp23_ = _tmp22_;
#line 166 "../src/librygel-core/rygel-plugin-loader.vala"
		g_debug ("rygel-plugin-loader.vala:166: Module '%s' disabled by user. Ignoring…", _tmp23_);
#line 169 "../src/librygel-core/rygel-plugin-loader.vala"
		result = TRUE;
#line 169 "../src/librygel-core/rygel-plugin-loader.vala"
		return result;
#line 684 "rygel-plugin-loader.c"
	}
#line 172 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp24_ = rygel_plugin_information_get_module_path (info);
#line 172 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp25_ = _tmp24_;
#line 172 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp26_ = g_file_new_for_path (_tmp25_);
#line 172 "../src/librygel-core/rygel-plugin-loader.vala"
	module_file = _tmp26_;
#line 174 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp27_ = module_file;
#line 174 "../src/librygel-core/rygel-plugin-loader.vala"
	loaded = rygel_recursive_module_loader_load_module_from_file ((RygelRecursiveModuleLoader*) self, _tmp27_);
#line 175 "../src/librygel-core/rygel-plugin-loader.vala"
	rygel_plugin_information_set_module_loaded (info, loaded);
#line 177 "../src/librygel-core/rygel-plugin-loader.vala"
	result = loaded;
#line 177 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (module_file);
#line 177 "../src/librygel-core/rygel-plugin-loader.vala"
	return result;
#line 706 "rygel-plugin-loader.c"
}

static void
rygel_plugin_loader_on_section_changed (RygelPluginLoader* self,
                                        const gchar* section,
                                        RygelSectionEntry entry)
{
	GError* _inner_error0_ = NULL;
#line 180 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/librygel-core/rygel-plugin-loader.vala"
	g_return_if_fail (section != NULL);
#line 181 "../src/librygel-core/rygel-plugin-loader.vala"
	if (entry == RYGEL_SECTION_ENTRY_ENABLED) {
#line 721 "rygel-plugin-loader.c"
		{
			gboolean enabled = FALSE;
			RygelConfiguration* _tmp0_;
#line 183 "../src/librygel-core/rygel-plugin-loader.vala"
			_tmp0_ = self->priv->config;
#line 183 "../src/librygel-core/rygel-plugin-loader.vala"
			enabled = rygel_configuration_get_enabled (_tmp0_, section, &_inner_error0_);
#line 183 "../src/librygel-core/rygel-plugin-loader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 731 "rygel-plugin-loader.c"
				goto __catch0_g_error;
			}
#line 184 "../src/librygel-core/rygel-plugin-loader.vala"
			if (!enabled) {
#line 736 "rygel-plugin-loader.c"
				GeeHashMap* _tmp1_;
#line 185 "../src/librygel-core/rygel-plugin-loader.vala"
				_tmp1_ = self->priv->plugin_hash;
#line 185 "../src/librygel-core/rygel-plugin-loader.vala"
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, section)) {
#line 742 "rygel-plugin-loader.c"
					GeeHashMap* _tmp2_;
					gpointer _tmp3_;
					RygelPlugin* _tmp4_;
#line 186 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp2_ = self->priv->plugin_hash;
#line 186 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, section);
#line 186 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp4_ = (RygelPlugin*) _tmp3_;
#line 186 "../src/librygel-core/rygel-plugin-loader.vala"
					rygel_plugin_set_active (_tmp4_, enabled);
#line 186 "../src/librygel-core/rygel-plugin-loader.vala"
					_g_object_unref0 (_tmp4_);
#line 756 "rygel-plugin-loader.c"
				}
			} else {
				GeeHashMap* _tmp5_;
#line 189 "../src/librygel-core/rygel-plugin-loader.vala"
				_tmp5_ = self->priv->plugin_hash;
#line 189 "../src/librygel-core/rygel-plugin-loader.vala"
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, section)) {
#line 764 "rygel-plugin-loader.c"
					GeeHashMap* _tmp6_;
					gpointer _tmp7_;
					RygelPlugin* _tmp8_;
#line 190 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp6_ = self->priv->plugin_hash;
#line 190 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, section);
#line 190 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp8_ = (RygelPlugin*) _tmp7_;
#line 190 "../src/librygel-core/rygel-plugin-loader.vala"
					rygel_plugin_set_active (_tmp8_, enabled);
#line 190 "../src/librygel-core/rygel-plugin-loader.vala"
					_g_object_unref0 (_tmp8_);
#line 778 "rygel-plugin-loader.c"
				} else {
					GeeHashMap* _tmp9_;
#line 192 "../src/librygel-core/rygel-plugin-loader.vala"
					_tmp9_ = self->priv->available_plugins;
#line 192 "../src/librygel-core/rygel-plugin-loader.vala"
					if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp9_, section)) {
#line 785 "rygel-plugin-loader.c"
						GeeHashMap* _tmp10_;
						gpointer _tmp11_;
						RygelPluginInformation* _tmp12_;
#line 193 "../src/librygel-core/rygel-plugin-loader.vala"
						_tmp10_ = self->priv->available_plugins;
#line 193 "../src/librygel-core/rygel-plugin-loader.vala"
						_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, section);
#line 193 "../src/librygel-core/rygel-plugin-loader.vala"
						_tmp12_ = (RygelPluginInformation*) _tmp11_;
#line 193 "../src/librygel-core/rygel-plugin-loader.vala"
						rygel_recursive_module_loader_load_module_from_info ((RygelRecursiveModuleLoader*) self, _tmp12_);
#line 193 "../src/librygel-core/rygel-plugin-loader.vala"
						_g_object_unref0 (_tmp12_);
#line 799 "rygel-plugin-loader.c"
					}
				}
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 182 "../src/librygel-core/rygel-plugin-loader.vala"
			_error_ = _inner_error0_;
#line 182 "../src/librygel-core/rygel-plugin-loader.vala"
			_inner_error0_ = NULL;
#line 199 "../src/librygel-core/rygel-plugin-loader.vala"
			_tmp13_ = _error_;
#line 199 "../src/librygel-core/rygel-plugin-loader.vala"
			_tmp14_ = _tmp13_->message;
#line 199 "../src/librygel-core/rygel-plugin-loader.vala"
			g_debug ("rygel-plugin-loader.vala:199: Failed to get enabled state for %s: %s", section, _tmp14_);
#line 182 "../src/librygel-core/rygel-plugin-loader.vala"
			_g_error_free0 (_error_);
#line 822 "rygel-plugin-loader.c"
		}
		__finally0:
#line 182 "../src/librygel-core/rygel-plugin-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "../src/librygel-core/rygel-plugin-loader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../src/librygel-core/rygel-plugin-loader.vala"
			g_clear_error (&_inner_error0_);
#line 182 "../src/librygel-core/rygel-plugin-loader.vala"
			return;
#line 833 "rygel-plugin-loader.c"
		}
	}
}

static gchar*
rygel_plugin_loader_get_config_path (void)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 207 "../src/librygel-core/rygel-plugin-loader.vala"
	_tmp0_ = g_strdup (PLUGIN_DIR);
#line 207 "../src/librygel-core/rygel-plugin-loader.vala"
	path = _tmp0_;
#line 849 "rygel-plugin-loader.c"
	{
		gchar* _tmp1_ = NULL;
		RygelMetaConfig* _tmp2_;
		RygelMetaConfig* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp2_ = rygel_meta_config_get_default ();
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp3_ = _tmp2_;
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp4_ = rygel_configuration_get_plugin_path ((RygelConfiguration*) _tmp3_, &_inner_error0_);
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp5_ = _tmp4_;
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_object_unref0 (_tmp3_);
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp1_ = _tmp5_;
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 871 "rygel-plugin-loader.c"
			goto __catch0_g_error;
		}
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp6_ = _tmp1_;
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp1_ = NULL;
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_free0 (path);
#line 209 "../src/librygel-core/rygel-plugin-loader.vala"
		path = _tmp6_;
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_free0 (_tmp1_);
#line 884 "rygel-plugin-loader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
		_error_ = _inner_error0_;
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
		_inner_error0_ = NULL;
#line 211 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp7_ = _error_;
#line 211 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp8_ = _tmp7_->message;
#line 211 "../src/librygel-core/rygel-plugin-loader.vala"
		_tmp9_ = path;
#line 211 "../src/librygel-core/rygel-plugin-loader.vala"
		g_debug ("rygel-plugin-loader.vala:211: Could not get plugin path from config: %" \
"s, using %s", _tmp8_, _tmp9_);
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_error_free0 (_error_);
#line 907 "rygel-plugin-loader.c"
	}
	__finally0:
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
		_g_free0 (path);
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
		g_clear_error (&_inner_error0_);
#line 208 "../src/librygel-core/rygel-plugin-loader.vala"
		return NULL;
#line 920 "rygel-plugin-loader.c"
	}
#line 216 "../src/librygel-core/rygel-plugin-loader.vala"
	result = path;
#line 216 "../src/librygel-core/rygel-plugin-loader.vala"
	return result;
#line 926 "rygel-plugin-loader.c"
}

static void
rygel_plugin_loader_class_init (RygelPluginLoaderClass * klass,
                                gpointer klass_data)
{
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	rygel_plugin_loader_parent_class = g_type_class_peek_parent (klass);
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	g_type_class_adjust_private_offset (klass, &RygelPluginLoader_private_offset);
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_plugin_loader_real_constructed;
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	((RygelRecursiveModuleLoaderClass *) klass)->load_module_from_file = (gboolean (*) (RygelRecursiveModuleLoader*, GFile*)) rygel_plugin_loader_real_load_module_from_file;
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	((RygelRecursiveModuleLoaderClass *) klass)->load_module_from_info = (gboolean (*) (RygelRecursiveModuleLoader*, RygelPluginInformation*)) rygel_plugin_loader_real_load_module_from_info;
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_plugin_loader_finalize;
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	rygel_plugin_loader_signals[RYGEL_PLUGIN_LOADER_PLUGIN_AVAILABLE_SIGNAL] = g_signal_new ("plugin-available", RYGEL_TYPE_PLUGIN_LOADER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, RYGEL_TYPE_PLUGIN);
#line 947 "rygel-plugin-loader.c"
}

static void
rygel_plugin_loader_instance_init (RygelPluginLoader * self,
                                   gpointer klass)
{
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	self->priv = rygel_plugin_loader_get_instance_private (self);
#line 956 "rygel-plugin-loader.c"
}

static void
rygel_plugin_loader_finalize (GObject * obj)
{
	RygelPluginLoader * self;
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_PLUGIN_LOADER, RygelPluginLoader);
#line 43 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (self->priv->plugin_hash);
#line 44 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (self->priv->available_plugins);
#line 45 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (self->priv->loaded_modules);
#line 46 "../src/librygel-core/rygel-plugin-loader.vala"
	_g_object_unref0 (self->priv->config);
#line 40 "../src/librygel-core/rygel-plugin-loader.vala"
	G_OBJECT_CLASS (rygel_plugin_loader_parent_class)->finalize (obj);
#line 975 "rygel-plugin-loader.c"
}

/**
 * This class is responsible for plugin loading.
 *
 * It probes for shared library files in a specific directory, tries to
 * find a module_init() function with this signature:
 * ``void module_init (RygelPluginLoader* loader);``
 *
 * It then calls that function, passing a pointer to itself. The loaded
 * module can then add plugins to Rygel by calling the
 * rygel_plugin_loader_add_plugin() function.
 */
 G_GNUC_NO_INLINE static GType
rygel_plugin_loader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelPluginLoaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_plugin_loader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelPluginLoader), 0, (GInstanceInitFunc) rygel_plugin_loader_instance_init, NULL };
	GType rygel_plugin_loader_type_id;
	rygel_plugin_loader_type_id = g_type_register_static (RYGEL_TYPE_RECURSIVE_MODULE_LOADER, "RygelPluginLoader", &g_define_type_info, 0);
	RygelPluginLoader_private_offset = g_type_add_instance_private (rygel_plugin_loader_type_id, sizeof (RygelPluginLoaderPrivate));
	return rygel_plugin_loader_type_id;
}

GType
rygel_plugin_loader_get_type (void)
{
	static volatile gsize rygel_plugin_loader_type_id__once = 0;
	if (g_once_init_enter (&rygel_plugin_loader_type_id__once)) {
		GType rygel_plugin_loader_type_id;
		rygel_plugin_loader_type_id = rygel_plugin_loader_get_type_once ();
		g_once_init_leave (&rygel_plugin_loader_type_id__once, rygel_plugin_loader_type_id);
	}
	return rygel_plugin_loader_type_id__once;
}

