/* rygel-recursive-module-loader.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-recursive-module-loader.vala, do not modify */

/*
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gmodule.h>
#include <glib/gi18n-lib.h>

#define RYGEL_RECURSIVE_MODULE_LOADER_LOADER_ATTRIBUTES G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_RECURSIVE_MODULE_LOADER_0_PROPERTY,
	RYGEL_RECURSIVE_MODULE_LOADER_BASE_PATH_PROPERTY,
	RYGEL_RECURSIVE_MODULE_LOADER_NUM_PROPERTIES
};
static GParamSpec* rygel_recursive_module_loader_properties[RYGEL_RECURSIVE_MODULE_LOADER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef void (*RygelRecursiveModuleLoaderFolderHandler) (GFile* folder, gpointer user_data);
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _RygelRecursiveModuleLoaderLoadModulesFromFolderData RygelRecursiveModuleLoaderLoadModulesFromFolderData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _RygelRecursiveModuleLoaderPrivate {
	gboolean done;
	gchar* _base_path;
};

struct _Block2Data {
	int _ref_count_;
	RygelRecursiveModuleLoader* self;
	GQueue* queue;
};

struct _RygelRecursiveModuleLoaderLoadModulesFromFolderData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelRecursiveModuleLoader* self;
	GFile* folder;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GList* infos;
	GFileEnumerator* enumerator;
	GFileEnumerator* _tmp2_;
	GFileEnumerator* _tmp3_;
	GFileEnumerator* _tmp4_;
	GList* _tmp5_;
	GFileEnumerator* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
	GError* _error_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GList* _tmp13_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* _tmp14_;
	GFileInfo* info;
	GFileInfo* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _inner_error0_;
};

static gint RygelRecursiveModuleLoader_private_offset;
static gpointer rygel_recursive_module_loader_parent_class = NULL;

static void rygel_recursive_module_loader_real_constructed (GObject* base);
static gboolean rygel_recursive_module_loader_is_folder (RygelRecursiveModuleLoader* self,
                                                  GFile* file);
static void rygel_recursive_module_loader_load_modules_from_folder (RygelRecursiveModuleLoader* self,
                                                             GFile* folder,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_);
static void rygel_recursive_module_loader_load_modules_from_folder_finish (RygelRecursiveModuleLoader* self,
                                                                    GAsyncResult* _res_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_queue_free__g_object_unref0_ (GQueue* self);
static void block2_data_unref (void * _userdata_);
static void rygel_recursive_module_loader_handle_file_info (RygelRecursiveModuleLoader* self,
                                                     GFile* folder,
                                                     GFileInfo* info,
                                                     RygelRecursiveModuleLoaderFolderHandler handler,
                                                     gpointer handler_target);
static void _____lambda8_ (Block2Data* _data2_,
                    GFile* subfolder);
static void ______lambda8__rygel_recursive_module_loader_folder_handler (GFile* folder,
                                                                  gpointer self);
static gboolean rygel_recursive_module_loader_real_load_module_from_file (RygelRecursiveModuleLoader* self,
                                                                   GFile* file);
static gboolean rygel_recursive_module_loader_real_load_module_from_info (RygelRecursiveModuleLoader* self,
                                                                   RygelPluginInformation* info);
static void rygel_recursive_module_loader_load_modules_from_folder_data_free (gpointer _data);
static gboolean rygel_recursive_module_loader_load_modules_from_folder_co (RygelRecursiveModuleLoaderLoadModulesFromFolderData* _data_);
static void rygel_recursive_module_loader_load_modules_from_folder_ready (GObject* source_object,
                                                                   GAsyncResult* _res_,
                                                                   gpointer _user_data_);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gint ___lambda6_ (GFileInfo* info_a,
                  GFileInfo* info_b);
static gint ____lambda6__gcompare_func (gconstpointer a,
                                 gconstpointer b);
static void ____lambda7_ (RygelRecursiveModuleLoader* self,
                   GFile* subfolder);
static void _____lambda7__rygel_recursive_module_loader_folder_handler (GFile* folder,
                                                                 gpointer self);
static gboolean rygel_recursive_module_loader_is_folder_eligible (RygelRecursiveModuleLoader* self,
                                                           GFileInfo* file_info);
static void rygel_recursive_module_loader_finalize (GObject * obj);
static GType rygel_recursive_module_loader_get_type_once (void);
static void _vala_rygel_recursive_module_loader_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_rygel_recursive_module_loader_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
rygel_recursive_module_loader_get_instance_private (RygelRecursiveModuleLoader* self)
{
	return G_STRUCT_MEMBER_P (self, RygelRecursiveModuleLoader_private_offset);
}

/**
     * Create a recursive module loader for a given path.
     *
     * Either call load_modules() or load_modules_sync() to start descending
     * into the folder hierarchy and load the modules.
     *
     * @param path base path of the loader.
     */
RygelRecursiveModuleLoader*
rygel_recursive_module_loader_construct (GType object_type,
                                         const gchar* path)
{
	RygelRecursiveModuleLoader * self = NULL;
#line 51 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 52 "../src/librygel-core/rygel-recursive-module-loader.vala"
	self = (RygelRecursiveModuleLoader*) g_object_new (object_type, "base-path", path, NULL);
#line 51 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return self;
#line 189 "rygel-recursive-module-loader.c"
}

static void
rygel_recursive_module_loader_real_constructed (GObject* base)
{
	RygelRecursiveModuleLoader * self;
#line 55 "../src/librygel-core/rygel-recursive-module-loader.vala"
	self = (RygelRecursiveModuleLoader*) base;
#line 56 "../src/librygel-core/rygel-recursive-module-loader.vala"
	G_OBJECT_CLASS (rygel_recursive_module_loader_parent_class)->constructed (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 57 "../src/librygel-core/rygel-recursive-module-loader.vala"
	self->priv->done = FALSE;
#line 202 "rygel-recursive-module-loader.c"
}

/**
     * Walk asynchronously through the tree and load modules.
     */
void
rygel_recursive_module_loader_load_modules (RygelRecursiveModuleLoader* self)
{
	GFile* folder = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	GFile* _tmp6_;
#line 65 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_vala_assert (g_module_supported (), "Module.supported()");
#line 68 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp0_ = self->priv->_base_path;
#line 68 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 68 "../src/librygel-core/rygel-recursive-module-loader.vala"
	folder = _tmp1_;
#line 69 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp3_ = folder;
#line 69 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (_tmp3_ == NULL) {
#line 69 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp2_ = TRUE;
#line 233 "rygel-recursive-module-loader.c"
	} else {
		GFile* _tmp4_;
#line 69 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp4_ = folder;
#line 69 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp2_ = !rygel_recursive_module_loader_is_folder (self, _tmp4_);
#line 240 "rygel-recursive-module-loader.c"
	}
#line 69 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (_tmp2_) {
#line 244 "rygel-recursive-module-loader.c"
		const gchar* _tmp5_;
#line 70 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp5_ = self->priv->_base_path;
#line 70 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_warning (_ ("Failed to open plugins folder: “%s”"), _tmp5_);
#line 73 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_object_unref0 (folder);
#line 73 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return;
#line 254 "rygel-recursive-module-loader.c"
	}
#line 76 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp6_ = folder;
#line 76 "../src/librygel-core/rygel-recursive-module-loader.vala"
	rygel_recursive_module_loader_load_modules_from_folder (self, _tmp6_, NULL, NULL);
#line 65 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_object_unref0 (folder);
#line 262 "rygel-recursive-module-loader.c"
}

/**
     * Walk synchronously through the tree and load modules.
     */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return _data2_;
#line 275 "rygel-recursive-module-loader.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 283 "rygel-recursive-module-loader.c"
}

static inline void
_g_queue_free__g_object_unref0_ (GQueue* self)
{
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 291 "rygel-recursive-module-loader.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 301 "rygel-recursive-module-loader.c"
		RygelRecursiveModuleLoader* self;
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
		self = _data2_->self;
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
		(_data2_->queue == NULL) ? NULL : (_data2_->queue = (_g_queue_free__g_object_unref0_ (_data2_->queue), NULL));
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_object_unref0 (self);
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_slice_free (Block2Data, _data2_);
#line 311 "rygel-recursive-module-loader.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 102 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return self ? g_object_ref (self) : NULL;
#line 320 "rygel-recursive-module-loader.c"
}

static void
_____lambda8_ (Block2Data* _data2_,
               GFile* subfolder)
{
	RygelRecursiveModuleLoader* self;
	GQueue* _tmp0_;
	GFile* _tmp1_;
#line 101 "../src/librygel-core/rygel-recursive-module-loader.vala"
	self = _data2_->self;
#line 101 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (subfolder != NULL);
#line 102 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp0_ = _data2_->queue;
#line 102 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp1_ = _g_object_ref0 (subfolder);
#line 102 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_queue_push_head (_tmp0_, _tmp1_);
#line 340 "rygel-recursive-module-loader.c"
}

static void
______lambda8__rygel_recursive_module_loader_folder_handler (GFile* folder,
                                                             gpointer self)
{
#line 101 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_____lambda8_ (self, folder);
#line 349 "rygel-recursive-module-loader.c"
}

void
rygel_recursive_module_loader_load_modules_sync (RygelRecursiveModuleLoader* self,
                                                 GCancellable* cancellable)
{
	Block2Data* _data2_;
	const gchar* _tmp0_;
	GQueue* _tmp1_;
	GQueue* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data2_->_ref_count_ = 1;
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data2_->self = g_object_ref (self);
#line 83 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp0_ = self->priv->_base_path;
#line 83 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_debug ("rygel-recursive-module-loader.vala:83: Searching for modules in folder" \
" '%s'", _tmp0_);
#line 85 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp1_ = g_queue_new ();
#line 85 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data2_->queue = _tmp1_;
#line 87 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp2_ = _data2_->queue;
#line 87 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp3_ = self->priv->_base_path;
#line 87 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 87 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_queue_push_head (_tmp2_, _tmp4_);
#line 88 "../src/librygel-core/rygel-recursive-module-loader.vala"
	while (TRUE) {
#line 389 "rygel-recursive-module-loader.c"
		GQueue* _tmp5_;
		gboolean _tmp6_ = FALSE;
		GFile* folder = NULL;
		GQueue* _tmp7_;
		gpointer _tmp8_;
#line 88 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp5_ = _data2_->queue;
#line 88 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (!(!g_queue_is_empty (_tmp5_))) {
#line 88 "../src/librygel-core/rygel-recursive-module-loader.vala"
			break;
#line 401 "rygel-recursive-module-loader.c"
		}
#line 89 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (cancellable != NULL) {
#line 89 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp6_ = g_cancellable_is_cancelled (cancellable);
#line 407 "rygel-recursive-module-loader.c"
		} else {
#line 89 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp6_ = FALSE;
#line 411 "rygel-recursive-module-loader.c"
		}
#line 89 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (_tmp6_) {
#line 90 "../src/librygel-core/rygel-recursive-module-loader.vala"
			break;
#line 417 "rygel-recursive-module-loader.c"
		}
#line 93 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp7_ = _data2_->queue;
#line 93 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp8_ = g_queue_pop_head (_tmp7_);
#line 93 "../src/librygel-core/rygel-recursive-module-loader.vala"
		folder = (GFile*) _tmp8_;
#line 425 "rygel-recursive-module-loader.c"
		{
			GFileEnumerator* enumerator = NULL;
			GFile* _tmp9_;
			GFileEnumerator* _tmp10_;
			GFileInfo* info = NULL;
			GFileEnumerator* _tmp11_;
			GFileInfo* _tmp12_;
#line 95 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp9_ = folder;
#line 95 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp10_ = g_file_enumerate_children (_tmp9_, RYGEL_RECURSIVE_MODULE_LOADER_LOADER_ATTRIBUTES, G_FILE_QUERY_INFO_NONE, cancellable, &_inner_error0_);
#line 95 "../src/librygel-core/rygel-recursive-module-loader.vala"
			enumerator = _tmp10_;
#line 95 "../src/librygel-core/rygel-recursive-module-loader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 441 "rygel-recursive-module-loader.c"
				goto __catch0_g_error;
			}
#line 99 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp11_ = enumerator;
#line 99 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp12_ = g_file_enumerator_next_file (_tmp11_, cancellable, &_inner_error0_);
#line 99 "../src/librygel-core/rygel-recursive-module-loader.vala"
			info = _tmp12_;
#line 99 "../src/librygel-core/rygel-recursive-module-loader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_g_object_unref0 (enumerator);
#line 454 "rygel-recursive-module-loader.c"
				goto __catch0_g_error;
			}
#line 100 "../src/librygel-core/rygel-recursive-module-loader.vala"
			while (TRUE) {
#line 459 "rygel-recursive-module-loader.c"
				GFileInfo* _tmp13_;
				GFile* _tmp14_;
				GFileInfo* _tmp15_;
				GFileInfo* _tmp16_ = NULL;
				GFileEnumerator* _tmp17_;
				GFileInfo* _tmp18_;
				GFileInfo* _tmp19_;
#line 100 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp13_ = info;
#line 100 "../src/librygel-core/rygel-recursive-module-loader.vala"
				if (!(_tmp13_ != NULL)) {
#line 100 "../src/librygel-core/rygel-recursive-module-loader.vala"
					break;
#line 473 "rygel-recursive-module-loader.c"
				}
#line 101 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp14_ = folder;
#line 101 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp15_ = info;
#line 101 "../src/librygel-core/rygel-recursive-module-loader.vala"
				rygel_recursive_module_loader_handle_file_info (self, _tmp14_, _tmp15_, ______lambda8__rygel_recursive_module_loader_folder_handler, _data2_);
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp17_ = enumerator;
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp18_ = g_file_enumerator_next_file (_tmp17_, cancellable, &_inner_error0_);
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp16_ = _tmp18_;
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
					_g_object_unref0 (info);
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
					_g_object_unref0 (enumerator);
#line 493 "rygel-recursive-module-loader.c"
					goto __catch0_g_error;
				}
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp19_ = _tmp16_;
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp16_ = NULL;
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_g_object_unref0 (info);
#line 104 "../src/librygel-core/rygel-recursive-module-loader.vala"
				info = _tmp19_;
#line 100 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_g_object_unref0 (_tmp16_);
#line 506 "rygel-recursive-module-loader.c"
			}
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_g_object_unref0 (info);
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_g_object_unref0 (enumerator);
#line 512 "rygel-recursive-module-loader.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			GFile* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_error_ = _inner_error0_;
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_inner_error0_ = NULL;
#line 107 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp20_ = folder;
#line 107 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp21_ = g_file_get_path (_tmp20_);
#line 107 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp22_ = _tmp21_;
#line 107 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp23_ = _error_;
#line 107 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_tmp24_ = _tmp23_->message;
#line 107 "../src/librygel-core/rygel-recursive-module-loader.vala"
			g_debug ("rygel-recursive-module-loader.vala:107: Failed to enumerate folder %s:" \
" %s", _tmp22_, _tmp24_);
#line 107 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_g_free0 (_tmp22_);
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_g_error_free0 (_error_);
#line 543 "rygel-recursive-module-loader.c"
		}
		__finally0:
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_g_object_unref0 (folder);
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			block2_data_unref (_data2_);
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_data2_ = NULL;
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			g_clear_error (&_inner_error0_);
#line 94 "../src/librygel-core/rygel-recursive-module-loader.vala"
			return;
#line 560 "rygel-recursive-module-loader.c"
		}
#line 88 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_object_unref0 (folder);
#line 564 "rygel-recursive-module-loader.c"
	}
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	block2_data_unref (_data2_);
#line 82 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data2_ = NULL;
#line 570 "rygel-recursive-module-loader.c"
}

/**
     * Load module from file.
     * @param file File to load the module from
     * @return The implementation should return true if the class should
     * continue to search for modules, false otherwise.
     */
static gboolean
rygel_recursive_module_loader_real_load_module_from_file (RygelRecursiveModuleLoader* self,
                                                          GFile* file)
{
	gboolean _tmp0_ = FALSE;
#line 120 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_critical ("Type `%s' does not implement abstract method `rygel_recursive_module_loader_load_module_from_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 120 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return _tmp0_;
#line 588 "rygel-recursive-module-loader.c"
}

gboolean
rygel_recursive_module_loader_load_module_from_file (RygelRecursiveModuleLoader* self,
                                                     GFile* file)
{
	RygelRecursiveModuleLoaderClass* _klass_;
#line 120 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_klass_ = RYGEL_RECURSIVE_MODULE_LOADER_GET_CLASS (self);
#line 120 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (_klass_->load_module_from_file) {
#line 120 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return _klass_->load_module_from_file (self, file);
#line 604 "rygel-recursive-module-loader.c"
	}
#line 120 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return FALSE;
#line 608 "rygel-recursive-module-loader.c"
}

static gboolean
rygel_recursive_module_loader_real_load_module_from_info (RygelRecursiveModuleLoader* self,
                                                          RygelPluginInformation* info)
{
	gboolean _tmp0_ = FALSE;
#line 122 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_critical ("Type `%s' does not implement abstract method `rygel_recursive_module_loader_load_module_from_info'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 122 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return _tmp0_;
#line 620 "rygel-recursive-module-loader.c"
}

gboolean
rygel_recursive_module_loader_load_module_from_info (RygelRecursiveModuleLoader* self,
                                                     RygelPluginInformation* info)
{
	RygelRecursiveModuleLoaderClass* _klass_;
#line 122 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 122 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_klass_ = RYGEL_RECURSIVE_MODULE_LOADER_GET_CLASS (self);
#line 122 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (_klass_->load_module_from_info) {
#line 122 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return _klass_->load_module_from_info (self, info);
#line 636 "rygel-recursive-module-loader.c"
	}
#line 122 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return FALSE;
#line 640 "rygel-recursive-module-loader.c"
}

static void
rygel_recursive_module_loader_load_modules_from_folder_data_free (gpointer _data)
{
	RygelRecursiveModuleLoaderLoadModulesFromFolderData* _data_;
	_data_ = _data;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_object_unref0 (_data_->folder);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_object_unref0 (_data_->self);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_slice_free (RygelRecursiveModuleLoaderLoadModulesFromFolderData, _data_);
#line 654 "rygel-recursive-module-loader.c"
}

static void
rygel_recursive_module_loader_load_modules_from_folder (RygelRecursiveModuleLoader* self,
                                                        GFile* folder,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	RygelRecursiveModuleLoaderLoadModulesFromFolderData* _data_;
	RygelRecursiveModuleLoader* _tmp0_;
	GFile* _tmp1_;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (folder != NULL);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_ = g_slice_new0 (RygelRecursiveModuleLoaderLoadModulesFromFolderData);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_recursive_module_loader_load_modules_from_folder_data_free);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->self = _tmp0_;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp1_ = _g_object_ref0 (folder);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_object_unref0 (_data_->folder);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->folder = _tmp1_;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	rygel_recursive_module_loader_load_modules_from_folder_co (_data_);
#line 688 "rygel-recursive-module-loader.c"
}

static void
rygel_recursive_module_loader_load_modules_from_folder_finish (RygelRecursiveModuleLoader* self,
                                                               GAsyncResult* _res_)
{
	RygelRecursiveModuleLoaderLoadModulesFromFolderData* _data_;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 698 "rygel-recursive-module-loader.c"
}

/**
     * Process children of a folder.
     *
     * Recurse into folders or call load_module_from_file() if it looks
     * like a shared library.
     *
     * @param folder the folder
     */
static void
rygel_recursive_module_loader_load_modules_from_folder_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_)
{
	RygelRecursiveModuleLoaderLoadModulesFromFolderData* _data_;
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_ = _user_data_;
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->_source_object_ = source_object;
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->_res_ = _res_;
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
	rygel_recursive_module_loader_load_modules_from_folder_co (_data_);
#line 723 "rygel-recursive-module-loader.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 731 "rygel-recursive-module-loader.c"
}

static gint
___lambda6_ (GFileInfo* info_a,
             GFileInfo* info_b)
{
	GFileType type_a = 0;
	GFileType type_b = 0;
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint result;
#line 148 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (info_a != NULL, 0);
#line 148 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (info_b != NULL, 0);
#line 149 "../src/librygel-core/rygel-recursive-module-loader.vala"
	type_a = g_file_info_get_file_type (info_a);
#line 150 "../src/librygel-core/rygel-recursive-module-loader.vala"
	type_b = g_file_info_get_file_type (info_b);
#line 152 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (type_a != type_b) {
#line 153 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (type_a == G_FILE_TYPE_DIRECTORY) {
#line 153 "../src/librygel-core/rygel-recursive-module-loader.vala"
			result = -1;
#line 153 "../src/librygel-core/rygel-recursive-module-loader.vala"
			return result;
#line 760 "rygel-recursive-module-loader.c"
		}
#line 154 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (type_b == G_FILE_TYPE_DIRECTORY) {
#line 154 "../src/librygel-core/rygel-recursive-module-loader.vala"
			result = 1;
#line 154 "../src/librygel-core/rygel-recursive-module-loader.vala"
			return result;
#line 768 "rygel-recursive-module-loader.c"
		}
	}
#line 157 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 157 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp1_ = g_file_info_get_name (info_a);
#line 157 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp2_ = g_file_info_get_name (info_b);
#line 157 "../src/librygel-core/rygel-recursive-module-loader.vala"
	result = _tmp0_ (_tmp1_, _tmp2_);
#line 157 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return result;
#line 781 "rygel-recursive-module-loader.c"
}

static gint
____lambda6__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = ___lambda6_ ((GFileInfo*) a, (GFileInfo*) b);
#line 148 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return result;
#line 792 "rygel-recursive-module-loader.c"
}

static void
____lambda7_ (RygelRecursiveModuleLoader* self,
              GFile* subfolder)
{
#line 172 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (subfolder != NULL);
#line 173 "../src/librygel-core/rygel-recursive-module-loader.vala"
	rygel_recursive_module_loader_load_modules_from_folder (self, subfolder, NULL, NULL);
#line 803 "rygel-recursive-module-loader.c"
}

static void
_____lambda7__rygel_recursive_module_loader_folder_handler (GFile* folder,
                                                            gpointer self)
{
#line 172 "../src/librygel-core/rygel-recursive-module-loader.vala"
	____lambda7_ ((RygelRecursiveModuleLoader*) self, folder);
#line 812 "rygel-recursive-module-loader.c"
}

static gboolean
rygel_recursive_module_loader_load_modules_from_folder_co (RygelRecursiveModuleLoaderLoadModulesFromFolderData* _data_)
{
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
	switch (_data_->_state_) {
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
		case 0:
#line 822 "rygel-recursive-module-loader.c"
		goto _state_0;
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
		case 1:
#line 826 "rygel-recursive-module-loader.c"
		goto _state_1;
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
		case 2:
#line 830 "rygel-recursive-module-loader.c"
		goto _state_2;
		default:
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_assert_not_reached ();
#line 835 "rygel-recursive-module-loader.c"
	}
	_state_0:
#line 133 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->_tmp0_ = g_file_get_path (_data_->folder);
#line 133 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 133 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_debug ("rygel-recursive-module-loader.vala:133: Searching for modules in folde" \
"r '%s'.", _data_->_tmp1_);
#line 133 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_free0 (_data_->_tmp1_);
#line 846 "rygel-recursive-module-loader.c"
	{
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_state_ = 1;
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_file_enumerate_children_async (_data_->folder, RYGEL_RECURSIVE_MODULE_LOADER_LOADER_ATTRIBUTES, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, rygel_recursive_module_loader_load_modules_from_folder_ready, _data_);
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return FALSE;
#line 854 "rygel-recursive-module-loader.c"
		_state_1:
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp3_ = g_file_enumerate_children_finish (_data_->folder, _data_->_res_, &_data_->_inner_error0_);
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp2_ = _data_->_tmp3_;
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 862 "rygel-recursive-module-loader.c"
			goto __catch0_g_error;
		}
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp4_ = _data_->_tmp2_;
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp2_ = NULL;
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_object_unref0 (_data_->enumerator);
#line 139 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->enumerator = _data_->_tmp4_;
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp6_ = _data_->enumerator;
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_state_ = 2;
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_file_enumerator_next_files_async (_data_->_tmp6_, G_MAXINT, G_PRIORITY_DEFAULT, NULL, rygel_recursive_module_loader_load_modules_from_folder_ready, _data_);
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return FALSE;
#line 881 "rygel-recursive-module-loader.c"
		_state_2:
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp7_ = g_file_enumerator_next_files_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp5_ = _data_->_tmp7_;
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_g_object_unref0 (_data_->_tmp2_);
#line 891 "rygel-recursive-module-loader.c"
			goto __catch0_g_error;
		}
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp8_ = _data_->_tmp5_;
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp5_ = NULL;
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 145 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->infos = _data_->_tmp8_;
#line 148 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->infos = g_list_sort (_data_->infos, ____lambda6__gcompare_func);
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		(_data_->_tmp5_ == NULL) ? NULL : (_data_->_tmp5_ = (_g_list_free__g_object_unref0_ (_data_->_tmp5_), NULL));
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_object_unref0 (_data_->_tmp2_);
#line 908 "rygel-recursive-module-loader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_inner_error0_ = NULL;
#line 160 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp9_ = g_file_get_path (_data_->folder);
#line 160 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 160 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp11_ = _data_->_error_;
#line 160 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 160 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_critical (_ ("Error listing contents of folder “%s”: %s"), _data_->_tmp10_, _data_->_tmp12_);
#line 160 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_free0 (_data_->_tmp10_);
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_error_free0 (_data_->_error_);
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_object_unref0 (_data_->enumerator);
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
		(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (_data_->_state_ != 0) {
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 943 "rygel-recursive-module-loader.c"
			}
		}
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_object_unref (_data_->_async_result);
#line 164 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return FALSE;
#line 950 "rygel-recursive-module-loader.c"
	}
	__finally0:
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_object_unref0 (_data_->enumerator);
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_object_unref (_data_->_async_result);
#line 138 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return FALSE;
#line 967 "rygel-recursive-module-loader.c"
	}
#line 167 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->_tmp13_ = _data_->infos;
#line 971 "rygel-recursive-module-loader.c"
	{
#line 167 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_data_->info_collection = _data_->_tmp13_;
#line 167 "../src/librygel-core/rygel-recursive-module-loader.vala"
		for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 167 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_data_->_tmp14_ = _g_object_ref0 ((GFileInfo*) _data_->info_it->data);
#line 167 "../src/librygel-core/rygel-recursive-module-loader.vala"
			_data_->info = _data_->_tmp14_;
#line 981 "rygel-recursive-module-loader.c"
			{
#line 168 "../src/librygel-core/rygel-recursive-module-loader.vala"
				if (_data_->self->priv->done) {
#line 169 "../src/librygel-core/rygel-recursive-module-loader.vala"
					_g_object_unref0 (_data_->info);
#line 169 "../src/librygel-core/rygel-recursive-module-loader.vala"
					break;
#line 989 "rygel-recursive-module-loader.c"
				}
#line 172 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_data_->_tmp15_ = _data_->info;
#line 172 "../src/librygel-core/rygel-recursive-module-loader.vala"
				rygel_recursive_module_loader_handle_file_info (_data_->self, _data_->folder, _data_->_tmp15_, _____lambda7__rygel_recursive_module_loader_folder_handler, _data_->self);
#line 167 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_g_object_unref0 (_data_->info);
#line 997 "rygel-recursive-module-loader.c"
			}
		}
	}
#line 177 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->_tmp16_ = g_file_get_path (_data_->folder);
#line 177 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 177 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_debug ("rygel-recursive-module-loader.vala:177: Finished searching for modules" \
" in folder '%s'", _data_->_tmp17_);
#line 177 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_free0 (_data_->_tmp17_);
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_object_unref0 (_data_->enumerator);
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
	(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (_data_->_state_ != 0) {
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1021 "rygel-recursive-module-loader.c"
		}
	}
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_object_unref (_data_->_async_result);
#line 132 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return FALSE;
#line 1028 "rygel-recursive-module-loader.c"
}

/**
     * Process a file info.
     *
     * Utility method used by sync and async tree walk.
     * @param folder parent folder
     * @param info the FileInfo of the file to process
     * @param handler a call-back if the FileInfo represents a folder.
     */
static void
rygel_recursive_module_loader_handle_file_info (RygelRecursiveModuleLoader* self,
                                                GFile* folder,
                                                GFileInfo* info,
                                                RygelRecursiveModuleLoaderFolderHandler handler,
                                                gpointer handler_target)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 189 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (folder != NULL);
#line 189 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (info != NULL);
#line 192 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp0_ = g_file_info_get_name (info);
#line 192 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp1_ = g_file_get_child (folder, _tmp0_);
#line 192 "../src/librygel-core/rygel-recursive-module-loader.vala"
	file = _tmp1_;
#line 194 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (rygel_recursive_module_loader_is_folder_eligible (self, info)) {
#line 1064 "rygel-recursive-module-loader.c"
		GFile* _tmp2_;
#line 195 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp2_ = file;
#line 195 "../src/librygel-core/rygel-recursive-module-loader.vala"
		handler (_tmp2_, handler_target);
#line 1070 "rygel-recursive-module-loader.c"
	} else {
		const gchar* _tmp3_;
#line 196 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp3_ = g_file_info_get_name (info);
#line 196 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (g_str_has_suffix (_tmp3_, ".plugin")) {
#line 1077 "rygel-recursive-module-loader.c"
			{
				RygelPluginInformation* plugin_info = NULL;
				GFile* _tmp4_;
				RygelPluginInformation* _tmp5_;
				RygelPluginInformation* _tmp6_;
#line 198 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp4_ = file;
#line 198 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp5_ = rygel_plugin_information_new_from_file (_tmp4_, &_inner_error0_);
#line 198 "../src/librygel-core/rygel-recursive-module-loader.vala"
				plugin_info = _tmp5_;
#line 198 "../src/librygel-core/rygel-recursive-module-loader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1091 "rygel-recursive-module-loader.c"
					goto __catch0_g_error;
				}
#line 200 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp6_ = plugin_info;
#line 200 "../src/librygel-core/rygel-recursive-module-loader.vala"
				if (!rygel_recursive_module_loader_load_module_from_info (self, _tmp6_)) {
#line 201 "../src/librygel-core/rygel-recursive-module-loader.vala"
					self->priv->done = TRUE;
#line 1100 "rygel-recursive-module-loader.c"
				}
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_g_object_unref0 (plugin_info);
#line 1104 "rygel-recursive-module-loader.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* _error_ = NULL;
				GError* _tmp7_;
				const gchar* _tmp8_;
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_error_ = _inner_error0_;
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_inner_error0_ = NULL;
#line 204 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp7_ = _error_;
#line 204 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_tmp8_ = _tmp7_->message;
#line 204 "../src/librygel-core/rygel-recursive-module-loader.vala"
				g_warning (_ ("Could not load plugin: %s"), _tmp8_);
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_g_error_free0 (_error_);
#line 1124 "rygel-recursive-module-loader.c"
			}
			__finally0:
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
				_g_object_unref0 (file);
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
				g_clear_error (&_inner_error0_);
#line 197 "../src/librygel-core/rygel-recursive-module-loader.vala"
				return;
#line 1137 "rygel-recursive-module-loader.c"
			}
		}
	}
#line 189 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_object_unref0 (file);
#line 1143 "rygel-recursive-module-loader.c"
}

static gboolean
rygel_recursive_module_loader_is_folder_eligible (RygelRecursiveModuleLoader* self,
                                                  GFileInfo* file_info)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 211 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (file_info != NULL, FALSE);
#line 212 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (g_file_info_get_file_type (file_info) == G_FILE_TYPE_DIRECTORY) {
#line 213 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp0_ = !g_file_info_get_is_hidden (file_info);
#line 1160 "rygel-recursive-module-loader.c"
	} else {
#line 212 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp0_ = FALSE;
#line 1164 "rygel-recursive-module-loader.c"
	}
#line 212 "../src/librygel-core/rygel-recursive-module-loader.vala"
	result = _tmp0_;
#line 212 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return result;
#line 1170 "rygel-recursive-module-loader.c"
}

/**
     * Check if a File is a folder.
     *
     * @param file the File to check
     * @return true, if file is folder, false otherwise.
     */
static gboolean
rygel_recursive_module_loader_is_folder (RygelRecursiveModuleLoader* self,
                                         GFile* file)
{
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 222 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 222 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1190 "rygel-recursive-module-loader.c"
	{
		GFileInfo* file_info = NULL;
		GFileInfo* _tmp0_;
#line 224 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 224 "../src/librygel-core/rygel-recursive-module-loader.vala"
		file_info = _tmp0_;
#line 224 "../src/librygel-core/rygel-recursive-module-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1200 "rygel-recursive-module-loader.c"
			goto __catch0_g_error;
		}
#line 229 "../src/librygel-core/rygel-recursive-module-loader.vala"
		result = rygel_recursive_module_loader_is_folder_eligible (self, file_info);
#line 229 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_object_unref0 (file_info);
#line 229 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return result;
#line 1209 "rygel-recursive-module-loader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 223 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_clear_error (&_inner_error0_);
#line 231 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp1_ = g_file_get_path (file);
#line 231 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp2_ = _tmp1_;
#line 231 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_critical (_ ("Failed to query content type for “%s”"), _tmp2_);
#line 231 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_free0 (_tmp2_);
#line 234 "../src/librygel-core/rygel-recursive-module-loader.vala"
		result = FALSE;
#line 234 "../src/librygel-core/rygel-recursive-module-loader.vala"
		return result;
#line 1230 "rygel-recursive-module-loader.c"
	}
	__finally0:
#line 223 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 223 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_clear_error (&_inner_error0_);
#line 223 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return _tmp3_;
#line 1239 "rygel-recursive-module-loader.c"
}

const gchar*
rygel_recursive_module_loader_get_base_path (RygelRecursiveModuleLoader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_tmp0_ = self->priv->_base_path;
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
	result = _tmp0_;
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
	return result;
#line 1255 "rygel-recursive-module-loader.c"
}

void
rygel_recursive_module_loader_set_base_path (RygelRecursiveModuleLoader* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
	old_value = rygel_recursive_module_loader_get_base_path (self);
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1269 "rygel-recursive-module-loader.c"
		gchar* _tmp0_;
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_tmp0_ = g_strdup (value);
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
		_g_free0 (self->priv->_base_path);
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
		self->priv->_base_path = _tmp0_;
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_recursive_module_loader_properties[RYGEL_RECURSIVE_MODULE_LOADER_BASE_PATH_PROPERTY]);
#line 1279 "rygel-recursive-module-loader.c"
	}
}

static void
rygel_recursive_module_loader_class_init (RygelRecursiveModuleLoaderClass * klass,
                                          gpointer klass_data)
{
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	rygel_recursive_module_loader_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_type_class_adjust_private_offset (klass, &RygelRecursiveModuleLoader_private_offset);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_recursive_module_loader_real_constructed;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	((RygelRecursiveModuleLoaderClass *) klass)->load_module_from_file = (gboolean (*) (RygelRecursiveModuleLoader*, GFile*)) rygel_recursive_module_loader_real_load_module_from_file;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	((RygelRecursiveModuleLoaderClass *) klass)->load_module_from_info = (gboolean (*) (RygelRecursiveModuleLoader*, RygelPluginInformation*)) rygel_recursive_module_loader_real_load_module_from_info;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_recursive_module_loader_get_property;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_recursive_module_loader_set_property;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_recursive_module_loader_finalize;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_RECURSIVE_MODULE_LOADER_BASE_PATH_PROPERTY, rygel_recursive_module_loader_properties[RYGEL_RECURSIVE_MODULE_LOADER_BASE_PATH_PROPERTY] = g_param_spec_string ("base-path", "base-path", "base-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1305 "rygel-recursive-module-loader.c"
}

static void
rygel_recursive_module_loader_instance_init (RygelRecursiveModuleLoader * self,
                                             gpointer klass)
{
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	self->priv = rygel_recursive_module_loader_get_instance_private (self);
#line 1314 "rygel-recursive-module-loader.c"
}

static void
rygel_recursive_module_loader_finalize (GObject * obj)
{
	RygelRecursiveModuleLoader * self;
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_RECURSIVE_MODULE_LOADER, RygelRecursiveModuleLoader);
#line 41 "../src/librygel-core/rygel-recursive-module-loader.vala"
	_g_free0 (self->priv->_base_path);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	G_OBJECT_CLASS (rygel_recursive_module_loader_parent_class)->finalize (obj);
#line 1327 "rygel-recursive-module-loader.c"
}

/**
 * Recursively walk a folder looking for shared libraries.
 *
 * The folder can either be walked synchronously or asynchronously.
 * Implementing classes need to implement the abstract method
 * load_module_from_file() which is called when the walker encounters a
 * dynamic module file.
 */
 G_GNUC_NO_INLINE static GType
rygel_recursive_module_loader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelRecursiveModuleLoaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_recursive_module_loader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelRecursiveModuleLoader), 0, (GInstanceInitFunc) rygel_recursive_module_loader_instance_init, NULL };
	GType rygel_recursive_module_loader_type_id;
	rygel_recursive_module_loader_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelRecursiveModuleLoader", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	RygelRecursiveModuleLoader_private_offset = g_type_add_instance_private (rygel_recursive_module_loader_type_id, sizeof (RygelRecursiveModuleLoaderPrivate));
	return rygel_recursive_module_loader_type_id;
}

GType
rygel_recursive_module_loader_get_type (void)
{
	static volatile gsize rygel_recursive_module_loader_type_id__once = 0;
	if (g_once_init_enter (&rygel_recursive_module_loader_type_id__once)) {
		GType rygel_recursive_module_loader_type_id;
		rygel_recursive_module_loader_type_id = rygel_recursive_module_loader_get_type_once ();
		g_once_init_leave (&rygel_recursive_module_loader_type_id__once, rygel_recursive_module_loader_type_id);
	}
	return rygel_recursive_module_loader_type_id__once;
}

static void
_vala_rygel_recursive_module_loader_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	RygelRecursiveModuleLoader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_RECURSIVE_MODULE_LOADER, RygelRecursiveModuleLoader);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	switch (property_id) {
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		case RYGEL_RECURSIVE_MODULE_LOADER_BASE_PATH_PROPERTY:
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		g_value_set_string (value, rygel_recursive_module_loader_get_base_path (self));
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		break;
#line 1376 "rygel-recursive-module-loader.c"
		default:
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		break;
#line 1382 "rygel-recursive-module-loader.c"
	}
}

static void
_vala_rygel_recursive_module_loader_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	RygelRecursiveModuleLoader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_RECURSIVE_MODULE_LOADER, RygelRecursiveModuleLoader);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
	switch (property_id) {
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		case RYGEL_RECURSIVE_MODULE_LOADER_BASE_PATH_PROPERTY:
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		rygel_recursive_module_loader_set_base_path (self, g_value_get_string (value));
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		break;
#line 1402 "rygel-recursive-module-loader.c"
		default:
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/librygel-core/rygel-recursive-module-loader.vala"
		break;
#line 1408 "rygel-recursive-module-loader.c"
	}
}

