/* rygel-root-device-factory.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-root-device-factory.vala, do not modify */

/*
 * Copyright (C) 2008-2010 Nokia Corporation.
 * Copyright (C) 2008 Zeeshan Ali (Khattak) <zeeshanak@gnome.org>.
 * Copyright (C) 2007 OpenedHand Ltd.
 * Copyright (C) 2012 Openismus GmbH.
 *
 * Authors: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                                <zeeshan.ali@nokia.com>
 *          Jorn Baayen <jorn@openedhand.com>
 *          Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "rygel-core.h"
#include <glib/gstdio.h>
#include <libgupnp/gupnp.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "config.h"
#include <gee.h>
#include <libgssdp/gssdp.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	RYGEL_ROOT_DEVICE_FACTORY_0_PROPERTY,
	RYGEL_ROOT_DEVICE_FACTORY_CONTEXT_PROPERTY,
	RYGEL_ROOT_DEVICE_FACTORY_NUM_PROPERTIES
};
static GParamSpec* rygel_root_device_factory_properties[RYGEL_ROOT_DEVICE_FACTORY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _rygel_resource_info_unref0(var) ((var == NULL) ? NULL : (var = (rygel_resource_info_unref (var), NULL)))
#define _rygel_icon_info_unref0(var) ((var == NULL) ? NULL : (var = (rygel_icon_info_unref (var), NULL)))

struct _RygelRootDeviceFactoryPrivate {
	GUPnPContext* _context;
	RygelConfiguration* config;
	gchar* desc_dir;
};

VALA_EXTERN gchar* rygel_pretty_host_name;
gchar* rygel_pretty_host_name = NULL;
static gint RygelRootDeviceFactory_private_offset;
static gpointer rygel_root_device_factory_parent_class = NULL;
static GInitableIface * rygel_root_device_factory_g_initable_parent_iface = NULL;

static gboolean rygel_root_device_factory_real_init (GInitable* base,
                                              GCancellable* cancellable,
                                              GError** error);
static void rygel_root_device_factory_ensure_dir_exists (RygelRootDeviceFactory* self,
                                                  const gchar* dir_path,
                                                  GError** error);
static GUPnPXMLDoc* rygel_root_device_factory_create_desc (RygelRootDeviceFactory* self,
                                                    RygelPlugin* plugin,
                                                    const gchar* desc_path,
                                                    const gchar* template_path,
                                                    GError** error);
static GUPnPXMLDoc* rygel_root_device_factory_get_latest_doc (RygelRootDeviceFactory* self,
                                                       const gchar* path1,
                                                       const gchar* path2,
                                                       GError** error);
static void rygel_root_device_factory_add_services_to_desc (RygelRootDeviceFactory* self,
                                                     RygelDescriptionFile* file,
                                                     RygelPlugin* plugin);
static void rygel_root_device_factory_add_icons_to_desc (RygelRootDeviceFactory* self,
                                                  RygelDescriptionFile* file,
                                                  RygelPlugin* plugin);
static gchar* rygel_root_device_factory_get_friendly_name (RygelRootDeviceFactory* self,
                                                    RygelPlugin* plugin);
static gchar* rygel_root_device_factory_get_icon_remote_path (RygelRootDeviceFactory* self,
                                                       RygelIconInfo* icon_info,
                                                       RygelPlugin* plugin);
static void rygel_root_device_factory_finalize (GObject * obj);
static GType rygel_root_device_factory_get_type_once (void);
static void _vala_rygel_root_device_factory_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_rygel_root_device_factory_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 134 "rygel-root-device-factory.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 138 "rygel-root-device-factory.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 144 "rygel-root-device-factory.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 149 "rygel-root-device-factory.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 155 "rygel-root-device-factory.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 159 "rygel-root-device-factory.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 163 "rygel-root-device-factory.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 167 "rygel-root-device-factory.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 171 "rygel-root-device-factory.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 175 "rygel-root-device-factory.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 190 "rygel-root-device-factory.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 199 "rygel-root-device-factory.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 206 "rygel-root-device-factory.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 212 "rygel-root-device-factory.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 220 "rygel-root-device-factory.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 224 "rygel-root-device-factory.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 230 "rygel-root-device-factory.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 235 "rygel-root-device-factory.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 241 "rygel-root-device-factory.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 245 "rygel-root-device-factory.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 249 "rygel-root-device-factory.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 255 "rygel-root-device-factory.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 261 "rygel-root-device-factory.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 273 "rygel-root-device-factory.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 277 "rygel-root-device-factory.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 281 "rygel-root-device-factory.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 286 "rygel-root-device-factory.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 294 "rygel-root-device-factory.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 312 "rygel-root-device-factory.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 318 "rygel-root-device-factory.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 322 "rygel-root-device-factory.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 330 "rygel-root-device-factory.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 339 "rygel-root-device-factory.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 348 "rygel-root-device-factory.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 354 "rygel-root-device-factory.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 362 "rygel-root-device-factory.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 374 "rygel-root-device-factory.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 380 "rygel-root-device-factory.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 384 "rygel-root-device-factory.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 392 "rygel-root-device-factory.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 403 "rygel-root-device-factory.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 412 "rygel-root-device-factory.c"
	}
}

gchar*
rygel_get_pretty_host_name (void)
{
	const gchar* _tmp0_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 36 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp0_ = rygel_pretty_host_name;
#line 36 "../src/librygel-core/rygel-root-device-factory.vala"
	if (_tmp0_ == NULL) {
#line 428 "rygel-root-device-factory.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 37 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp1_ = g_get_host_name ();
#line 37 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 37 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (rygel_pretty_host_name);
#line 37 "../src/librygel-core/rygel-root-device-factory.vala"
		rygel_pretty_host_name = _tmp2_;
#line 439 "rygel-root-device-factory.c"
		{
			gchar* machine_info = NULL;
			gchar* _tmp3_ = NULL;
			gchar** lines = NULL;
			const gchar* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_;
			gint lines_length1;
			gint _lines_size_;
			gchar** _tmp7_;
			gint _tmp7__length1;
#line 42 "../src/librygel-core/rygel-root-device-factory.vala"
			g_file_get_contents ("/etc/machine-info", &_tmp3_, NULL, &_inner_error0_);
#line 42 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_free0 (machine_info);
#line 42 "../src/librygel-core/rygel-root-device-factory.vala"
			machine_info = _tmp3_;
#line 42 "../src/librygel-core/rygel-root-device-factory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 42 "../src/librygel-core/rygel-root-device-factory.vala"
				_g_free0 (machine_info);
#line 461 "rygel-root-device-factory.c"
				goto __catch0_g_error;
			}
#line 44 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp4_ = machine_info;
#line 44 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "\n", 0);
#line 44 "../src/librygel-core/rygel-root-device-factory.vala"
			lines = _tmp6_;
#line 44 "../src/librygel-core/rygel-root-device-factory.vala"
			lines_length1 = _vala_array_length (_tmp5_);
#line 44 "../src/librygel-core/rygel-root-device-factory.vala"
			_lines_size_ = lines_length1;
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp7_ = lines;
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp7__length1 = lines_length1;
#line 478 "rygel-root-device-factory.c"
			{
				gchar** line_collection = NULL;
				gint line_collection_length1 = 0;
				gint _line_collection_size_ = 0;
				gint line_it = 0;
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
				line_collection = _tmp7_;
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
				line_collection_length1 = _tmp7__length1;
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
				for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 490 "rygel-root-device-factory.c"
					gchar* _tmp8_;
					gchar* line = NULL;
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
					_tmp8_ = g_strdup (line_collection[line_it]);
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
					line = _tmp8_;
#line 497 "rygel-root-device-factory.c"
					{
						gchar** parts = NULL;
						const gchar* _tmp9_;
						gchar** _tmp10_;
						gchar** _tmp11_;
						gint parts_length1;
						gint _parts_size_;
						gchar** _tmp12_;
						gint _tmp12__length1;
						const gchar* _tmp13_;
#line 47 "../src/librygel-core/rygel-root-device-factory.vala"
						_tmp9_ = line;
#line 47 "../src/librygel-core/rygel-root-device-factory.vala"
						_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, "=", 0);
#line 47 "../src/librygel-core/rygel-root-device-factory.vala"
						parts = _tmp11_;
#line 47 "../src/librygel-core/rygel-root-device-factory.vala"
						parts_length1 = _vala_array_length (_tmp10_);
#line 47 "../src/librygel-core/rygel-root-device-factory.vala"
						_parts_size_ = parts_length1;
#line 49 "../src/librygel-core/rygel-root-device-factory.vala"
						_tmp12_ = parts;
#line 49 "../src/librygel-core/rygel-root-device-factory.vala"
						_tmp12__length1 = parts_length1;
#line 49 "../src/librygel-core/rygel-root-device-factory.vala"
						_tmp13_ = _tmp12_[0];
#line 49 "../src/librygel-core/rygel-root-device-factory.vala"
						if (g_strcmp0 (_tmp13_, "PRETTY_HOSTNAME") == 0) {
#line 526 "rygel-root-device-factory.c"
							gchar** _tmp14_;
							gint _tmp14__length1;
							gchar** _tmp15_;
							gint _tmp15__length1;
							gchar* _tmp16_;
#line 50 "../src/librygel-core/rygel-root-device-factory.vala"
							_tmp14_ = parts;
#line 50 "../src/librygel-core/rygel-root-device-factory.vala"
							_tmp14__length1 = parts_length1;
#line 50 "../src/librygel-core/rygel-root-device-factory.vala"
							_tmp15_ = parts;
#line 50 "../src/librygel-core/rygel-root-device-factory.vala"
							_tmp15__length1 = parts_length1;
#line 50 "../src/librygel-core/rygel-root-device-factory.vala"
							_tmp16_ = _vala_g_strjoinv ("=", _tmp14_ + 1, (gint) (_tmp15__length1 - 1));
#line 50 "../src/librygel-core/rygel-root-device-factory.vala"
							_g_free0 (rygel_pretty_host_name);
#line 50 "../src/librygel-core/rygel-root-device-factory.vala"
							rygel_pretty_host_name = _tmp16_;
#line 546 "rygel-root-device-factory.c"
						}
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../src/librygel-core/rygel-root-device-factory.vala"
						_g_free0 (line);
#line 552 "rygel-root-device-factory.c"
					}
				}
			}
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
			lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_free0 (machine_info);
#line 560 "rygel-root-device-factory.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp17_;
			const gchar* _tmp18_;
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
			e = _inner_error0_;
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
			_inner_error0_ = NULL;
#line 54 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp17_ = e;
#line 54 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp18_ = _tmp17_->message;
#line 54 "../src/librygel-core/rygel-root-device-factory.vala"
			g_debug ("rygel-root-device-factory.vala:54: Failed to parse /etc/machine-info: " \
"%s", _tmp18_);
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_error_free0 (e);
#line 580 "rygel-root-device-factory.c"
		}
		__finally0:
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
			g_clear_error (&_inner_error0_);
#line 39 "../src/librygel-core/rygel-root-device-factory.vala"
			return NULL;
#line 591 "rygel-root-device-factory.c"
		}
	}
#line 58 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp19_ = rygel_pretty_host_name;
#line 58 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 58 "../src/librygel-core/rygel-root-device-factory.vala"
	result = _tmp20_;
#line 58 "../src/librygel-core/rygel-root-device-factory.vala"
	return result;
#line 602 "rygel-root-device-factory.c"
}

static inline gpointer
rygel_root_device_factory_get_instance_private (RygelRootDeviceFactory* self)
{
	return G_STRUCT_MEMBER_P (self, RygelRootDeviceFactory_private_offset);
}

RygelRootDeviceFactory*
rygel_root_device_factory_construct (GType object_type,
                                     GUPnPContext* context,
                                     GError** error)
{
	RygelRootDeviceFactory * self = NULL;
	GError* _inner_error0_ = NULL;
#line 77 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 78 "../src/librygel-core/rygel-root-device-factory.vala"
	self = (RygelRootDeviceFactory*) g_object_new (object_type, "context", context, NULL);
#line 79 "../src/librygel-core/rygel-root-device-factory.vala"
	g_initable_init ((GInitable*) self, NULL, &_inner_error0_);
#line 79 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 79 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (self);
#line 79 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 632 "rygel-root-device-factory.c"
	}
#line 77 "../src/librygel-core/rygel-root-device-factory.vala"
	return self;
#line 636 "rygel-root-device-factory.c"
}

RygelRootDeviceFactory*
rygel_root_device_factory_new (GUPnPContext* context,
                               GError** error)
{
#line 77 "../src/librygel-core/rygel-root-device-factory.vala"
	return rygel_root_device_factory_construct (RYGEL_TYPE_ROOT_DEVICE_FACTORY, context, error);
#line 645 "rygel-root-device-factory.c"
}

static gboolean
rygel_root_device_factory_real_init (GInitable* base,
                                     GCancellable* cancellable,
                                     GError** error)
{
	RygelRootDeviceFactory * self;
	RygelConfiguration* _tmp0_;
	RygelMetaConfig* _tmp1_;
	gchar* config_dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 82 "../src/librygel-core/rygel-root-device-factory.vala"
	self = (RygelRootDeviceFactory*) base;
#line 83 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp0_ = self->priv->config;
#line 83 "../src/librygel-core/rygel-root-device-factory.vala"
	if (_tmp0_ != NULL) {
#line 84 "../src/librygel-core/rygel-root-device-factory.vala"
		result = TRUE;
#line 84 "../src/librygel-core/rygel-root-device-factory.vala"
		return result;
#line 675 "rygel-root-device-factory.c"
	}
#line 87 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp1_ = rygel_meta_config_get_default ();
#line 87 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_object_unref0 (self->priv->config);
#line 87 "../src/librygel-core/rygel-root-device-factory.vala"
	self->priv->config = (RygelConfiguration*) _tmp1_;
#line 90 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp2_ = g_get_user_config_dir ();
#line 90 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 90 "../src/librygel-core/rygel-root-device-factory.vala"
	config_dir = _tmp3_;
#line 91 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp4_ = config_dir;
#line 91 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_root_device_factory_ensure_dir_exists (self, _tmp4_, &_inner_error0_);
#line 91 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 695 "rygel-root-device-factory.c"
		gboolean _tmp5_ = FALSE;
#line 91 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 91 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (config_dir);
#line 91 "../src/librygel-core/rygel-root-device-factory.vala"
		return _tmp5_;
#line 703 "rygel-root-device-factory.c"
	}
#line 92 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp6_ = config_dir;
#line 92 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp7_ = g_build_filename (_tmp6_, "Rygel", NULL);
#line 92 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (self->priv->desc_dir);
#line 92 "../src/librygel-core/rygel-root-device-factory.vala"
	self->priv->desc_dir = _tmp7_;
#line 93 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp8_ = self->priv->desc_dir;
#line 93 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_root_device_factory_ensure_dir_exists (self, _tmp8_, &_inner_error0_);
#line 93 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 719 "rygel-root-device-factory.c"
		gboolean _tmp9_ = FALSE;
#line 93 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 93 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (config_dir);
#line 93 "../src/librygel-core/rygel-root-device-factory.vala"
		return _tmp9_;
#line 727 "rygel-root-device-factory.c"
	}
#line 95 "../src/librygel-core/rygel-root-device-factory.vala"
	result = TRUE;
#line 95 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (config_dir);
#line 95 "../src/librygel-core/rygel-root-device-factory.vala"
	return result;
#line 735 "rygel-root-device-factory.c"
}

RygelRootDevice*
rygel_root_device_factory_create (RygelRootDeviceFactory* self,
                                  RygelPlugin* plugin,
                                  GError** error)
{
	gchar* desc_path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* template_path = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GUPnPXMLDoc* doc = NULL;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GUPnPXMLDoc* _tmp12_;
	RygelRootDevice* device = NULL;
	GUPnPContext* _tmp13_;
	GUPnPXMLDoc* _tmp14_;
	const gchar* _tmp15_;
	RygelRootDevice* _tmp16_;
	RygelRootDevice* _tmp17_;
	const gchar* _tmp18_;
	GError* _inner_error0_ = NULL;
	RygelRootDevice* result;
#line 98 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (plugin != NULL, NULL);
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp0_ = self->priv->desc_dir;
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp1_ = rygel_plugin_get_name (plugin);
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp2_ = _tmp1_;
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp3_ = g_strconcat (_tmp2_, ".xml", NULL);
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp4_ = _tmp3_;
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp5_ = g_build_filename (_tmp0_, _tmp4_, NULL);
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp6_ = _tmp5_;
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (_tmp4_);
#line 99 "../src/librygel-core/rygel-root-device-factory.vala"
	desc_path = _tmp6_;
#line 101 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp7_ = rygel_plugin_get_desc_path (plugin);
#line 101 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp8_ = _tmp7_;
#line 101 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 101 "../src/librygel-core/rygel-root-device-factory.vala"
	template_path = _tmp9_;
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp10_ = desc_path;
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp11_ = template_path;
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp12_ = rygel_root_device_factory_create_desc (self, plugin, _tmp10_, _tmp11_, &_inner_error0_);
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
	doc = _tmp12_;
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (template_path);
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (desc_path);
#line 104 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 816 "rygel-root-device-factory.c"
	}
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp13_ = self->priv->_context;
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp14_ = doc;
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp15_ = desc_path;
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp16_ = rygel_root_device_new (_tmp13_, plugin, _tmp14_, _tmp15_, DATA_DIR, &_inner_error0_);
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
	device = _tmp16_;
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (doc);
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (template_path);
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (desc_path);
#line 106 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 840 "rygel-root-device-factory.c"
	}
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp17_ = device;
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp18_ = desc_path;
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_plugin_apply_hacks (plugin, _tmp17_, _tmp18_, &_inner_error0_);
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (device);
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (doc);
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (template_path);
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (desc_path);
#line 111 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 862 "rygel-root-device-factory.c"
	}
#line 113 "../src/librygel-core/rygel-root-device-factory.vala"
	result = device;
#line 113 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_object_unref0 (doc);
#line 113 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (template_path);
#line 113 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (desc_path);
#line 113 "../src/librygel-core/rygel-root-device-factory.vala"
	return result;
#line 874 "rygel-root-device-factory.c"
}

static GUPnPXMLDoc*
rygel_root_device_factory_create_desc (RygelRootDeviceFactory* self,
                                       RygelPlugin* plugin,
                                       const gchar* desc_path,
                                       const gchar* template_path,
                                       GError** error)
{
	GUPnPXMLDoc* doc = NULL;
	GUPnPXMLDoc* _tmp0_;
	RygelDescriptionFile* file = NULL;
	GUPnPXMLDoc* _tmp1_;
	RygelDescriptionFile* _tmp2_;
	RygelDescriptionFile* _tmp3_;
	RygelDescriptionFile* _tmp4_;
	RygelDescriptionFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RygelDescriptionFile* _tmp8_;
	RygelPluginCapabilities _tmp9_;
	RygelPluginCapabilities _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* udn = NULL;
	RygelDescriptionFile* _tmp16_;
	gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	RygelDescriptionFile* _tmp32_;
	GError* _inner_error0_ = NULL;
	GUPnPXMLDoc* result;
#line 116 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (plugin != NULL, NULL);
#line 116 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (desc_path != NULL, NULL);
#line 116 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (template_path != NULL, NULL);
#line 119 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp0_ = rygel_root_device_factory_get_latest_doc (self, desc_path, template_path, &_inner_error0_);
#line 119 "../src/librygel-core/rygel-root-device-factory.vala"
	doc = _tmp0_;
#line 119 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 119 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 925 "rygel-root-device-factory.c"
	}
#line 123 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp1_ = doc;
#line 123 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp2_ = rygel_description_file_new_from_xml_document (_tmp1_);
#line 123 "../src/librygel-core/rygel-root-device-factory.vala"
	file = _tmp2_;
#line 125 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp3_ = file;
#line 125 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_root_device_factory_add_services_to_desc (self, _tmp3_, plugin);
#line 126 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp4_ = file;
#line 126 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_root_device_factory_add_icons_to_desc (self, _tmp4_, plugin);
#line 128 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp5_ = file;
#line 128 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp6_ = rygel_root_device_factory_get_friendly_name (self, plugin);
#line 128 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp7_ = _tmp6_;
#line 128 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_description_file_set_friendly_name (_tmp5_, _tmp7_);
#line 128 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (_tmp7_);
#line 129 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp8_ = file;
#line 129 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp9_ = rygel_plugin_get_capabilities (plugin);
#line 129 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp10_ = _tmp9_;
#line 129 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_description_file_set_dlna_caps (_tmp8_, _tmp10_);
#line 130 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp11_ = rygel_plugin_get_description (plugin);
#line 130 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp12_ = _tmp11_;
#line 130 "../src/librygel-core/rygel-root-device-factory.vala"
	if (_tmp12_ != NULL) {
#line 965 "rygel-root-device-factory.c"
		RygelDescriptionFile* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 131 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp13_ = file;
#line 131 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp14_ = rygel_plugin_get_description (plugin);
#line 131 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp15_ = _tmp14_;
#line 131 "../src/librygel-core/rygel-root-device-factory.vala"
		rygel_description_file_set_model_description (_tmp13_, _tmp15_);
#line 977 "rygel-root-device-factory.c"
	}
#line 133 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp16_ = file;
#line 133 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp17_ = rygel_description_file_get_udn (_tmp16_);
#line 133 "../src/librygel-core/rygel-root-device-factory.vala"
	udn = _tmp17_;
#line 134 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp19_ = udn;
#line 134 "../src/librygel-core/rygel-root-device-factory.vala"
	if (_tmp19_ == NULL) {
#line 134 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp18_ = TRUE;
#line 991 "rygel-root-device-factory.c"
	} else {
		const gchar* _tmp20_;
#line 134 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp20_ = udn;
#line 134 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp18_ = g_strcmp0 (_tmp20_, "") == 0;
#line 998 "rygel-root-device-factory.c"
	}
#line 134 "../src/librygel-core/rygel-root-device-factory.vala"
	if (_tmp18_) {
#line 1002 "rygel-root-device-factory.c"
		RygelDescriptionFile* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		{
			gchar* _tmp21_ = NULL;
			RygelConfiguration* _tmp22_;
			const gchar* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp22_ = self->priv->config;
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp23_ = rygel_plugin_get_name (plugin);
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp24_ = _tmp23_;
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp25_ = rygel_configuration_get_string (_tmp22_, _tmp24_, "uuid", &_inner_error0_);
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp21_ = _tmp25_;
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1026 "rygel-root-device-factory.c"
				goto __catch0_g_error;
			}
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp26_ = _tmp21_;
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp21_ = NULL;
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_free0 (udn);
#line 137 "../src/librygel-core/rygel-root-device-factory.vala"
			udn = _tmp26_;
#line 136 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_free0 (_tmp21_);
#line 1039 "rygel-root-device-factory.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			gchar* _tmp27_;
#line 136 "../src/librygel-core/rygel-root-device-factory.vala"
			g_clear_error (&_inner_error0_);
#line 139 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp27_ = g_uuid_string_random ();
#line 139 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_free0 (udn);
#line 139 "../src/librygel-core/rygel-root-device-factory.vala"
			udn = _tmp27_;
#line 1053 "rygel-root-device-factory.c"
		}
		__finally0:
#line 136 "../src/librygel-core/rygel-root-device-factory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "../src/librygel-core/rygel-root-device-factory.vala"
			g_propagate_error (error, _inner_error0_);
#line 136 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_free0 (udn);
#line 136 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (file);
#line 136 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (doc);
#line 136 "../src/librygel-core/rygel-root-device-factory.vala"
			return NULL;
#line 1068 "rygel-root-device-factory.c"
		}
#line 141 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp28_ = file;
#line 141 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp29_ = udn;
#line 141 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp30_ = g_strconcat ("uuid:", _tmp29_, NULL);
#line 141 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp31_ = _tmp30_;
#line 141 "../src/librygel-core/rygel-root-device-factory.vala"
		rygel_description_file_set_udn (_tmp28_, _tmp31_);
#line 141 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp31_);
#line 1082 "rygel-root-device-factory.c"
	}
#line 144 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp32_ = file;
#line 144 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_description_file_save (_tmp32_, desc_path, &_inner_error0_);
#line 144 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 144 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (udn);
#line 144 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (file);
#line 144 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (doc);
#line 144 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 1100 "rygel-root-device-factory.c"
	}
#line 146 "../src/librygel-core/rygel-root-device-factory.vala"
	result = doc;
#line 146 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (udn);
#line 146 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_object_unref0 (file);
#line 146 "../src/librygel-core/rygel-root-device-factory.vala"
	return result;
#line 1110 "rygel-root-device-factory.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1132 "rygel-root-device-factory.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1136 "rygel-root-device-factory.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1142 "rygel-root-device-factory.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1146 "rygel-root-device-factory.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1150 "rygel-root-device-factory.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1158 "rygel-root-device-factory.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1186 "rygel-root-device-factory.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1195 "rygel-root-device-factory.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1209 "rygel-root-device-factory.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1218 "rygel-root-device-factory.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1232 "rygel-root-device-factory.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1241 "rygel-root-device-factory.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1250 "rygel-root-device-factory.c"
}

static gchar*
rygel_root_device_factory_get_friendly_name (RygelRootDeviceFactory* self,
                                             RygelPlugin* plugin)
{
	gchar* title = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 149 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (plugin != NULL, NULL);
#line 1277 "rygel-root-device-factory.c"
	{
		gchar* _tmp0_ = NULL;
		RygelConfiguration* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp1_ = self->priv->config;
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp2_ = rygel_plugin_get_name (plugin);
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp3_ = _tmp2_;
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp4_ = rygel_configuration_get_title (_tmp1_, _tmp3_, &_inner_error0_);
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp0_ = _tmp4_;
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1297 "rygel-root-device-factory.c"
			goto __catch0_g_error;
		}
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp5_ = _tmp0_;
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp0_ = NULL;
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (title);
#line 152 "../src/librygel-core/rygel-root-device-factory.vala"
		title = _tmp5_;
#line 151 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp0_);
#line 1310 "rygel-root-device-factory.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 151 "../src/librygel-core/rygel-root-device-factory.vala"
		g_clear_error (&_inner_error0_);
#line 154 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp6_ = rygel_plugin_get_title (plugin);
#line 154 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp7_ = _tmp6_;
#line 154 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 154 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (title);
#line 154 "../src/librygel-core/rygel-root-device-factory.vala"
		title = _tmp8_;
#line 1330 "rygel-root-device-factory.c"
	}
	__finally0:
#line 151 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (title);
#line 151 "../src/librygel-core/rygel-root-device-factory.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/librygel-core/rygel-root-device-factory.vala"
		g_clear_error (&_inner_error0_);
#line 151 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 1343 "rygel-root-device-factory.c"
	}
#line 157 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp9_ = title;
#line 157 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp10_ = g_get_real_name ();
#line 157 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp11_ = string_replace (_tmp9_, "@REALNAME@", _tmp10_);
#line 157 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (title);
#line 157 "../src/librygel-core/rygel-root-device-factory.vala"
	title = _tmp11_;
#line 158 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp12_ = title;
#line 158 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp13_ = g_get_user_name ();
#line 158 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp14_ = string_replace (_tmp12_, "@USERNAME@", _tmp13_);
#line 158 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (title);
#line 158 "../src/librygel-core/rygel-root-device-factory.vala"
	title = _tmp14_;
#line 159 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp15_ = title;
#line 159 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp16_ = g_get_host_name ();
#line 159 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp17_ = string_replace (_tmp15_, "@HOSTNAME@", _tmp16_);
#line 159 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (title);
#line 159 "../src/librygel-core/rygel-root-device-factory.vala"
	title = _tmp17_;
#line 160 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp18_ = title;
#line 160 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp19_ = rygel_get_pretty_host_name ();
#line 160 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp20_ = _tmp19_;
#line 160 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp21_ = string_replace (_tmp18_, "@PRETTY_HOSTNAME@", _tmp20_);
#line 160 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (title);
#line 160 "../src/librygel-core/rygel-root-device-factory.vala"
	title = _tmp21_;
#line 160 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (_tmp20_);
#line 162 "../src/librygel-core/rygel-root-device-factory.vala"
	result = title;
#line 162 "../src/librygel-core/rygel-root-device-factory.vala"
	return result;
#line 1393 "rygel-root-device-factory.c"
}

static void
rygel_root_device_factory_add_services_to_desc (RygelRootDeviceFactory* self,
                                                RygelDescriptionFile* file,
                                                RygelPlugin* plugin)
{
#line 165 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (file != NULL);
#line 165 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (plugin != NULL);
#line 167 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_description_file_clear_service_list (file);
#line 1409 "rygel-root-device-factory.c"
	{
		GeeArrayList* _resource_info_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _resource_info_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _resource_info_index = 0;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp0_ = rygel_plugin_get_resource_infos (plugin);
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp1_ = _tmp0_;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		_resource_info_list = _tmp1_;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp2_ = _resource_info_list;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp4_ = _tmp3_;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		_resource_info_size = _tmp4_;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		_resource_info_index = -1;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
		while (TRUE) {
#line 1437 "rygel-root-device-factory.c"
			gint _tmp5_;
			gint _tmp6_;
			RygelResourceInfo* resource_info = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			RygelResourceInfo* _tmp9_;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
			_resource_info_index = _resource_info_index + 1;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp5_ = _resource_info_index;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp6_ = _resource_info_size;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
				break;
#line 1454 "rygel-root-device-factory.c"
			}
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp7_ = _resource_info_list;
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _resource_info_index);
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
			resource_info = (RygelResourceInfo*) _tmp8_;
#line 170 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp9_ = resource_info;
#line 170 "../src/librygel-core/rygel-root-device-factory.vala"
			if (g_type_is_a (_tmp9_->type, gupnp_service_get_type ())) {
#line 1466 "rygel-root-device-factory.c"
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				RygelResourceInfo* _tmp12_;
#line 171 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp10_ = rygel_plugin_get_name (plugin);
#line 171 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp11_ = _tmp10_;
#line 171 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp12_ = resource_info;
#line 171 "../src/librygel-core/rygel-root-device-factory.vala"
				rygel_description_file_add_service (file, _tmp11_, _tmp12_);
#line 1478 "rygel-root-device-factory.c"
			}
#line 168 "../src/librygel-core/rygel-root-device-factory.vala"
			_rygel_resource_info_unref0 (resource_info);
#line 1482 "rygel-root-device-factory.c"
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 178 "../src/librygel-core/rygel-root-device-factory.vala"
	return self ? g_object_ref (self) : NULL;
#line 1492 "rygel-root-device-factory.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1515 "rygel-root-device-factory.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1524 "rygel-root-device-factory.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1543 "rygel-root-device-factory.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1547 "rygel-root-device-factory.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1553 "rygel-root-device-factory.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1563 "rygel-root-device-factory.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1571 "rygel-root-device-factory.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1575 "rygel-root-device-factory.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 1581 "rygel-root-device-factory.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1591 "rygel-root-device-factory.c"
}

static void
rygel_root_device_factory_add_icons_to_desc (RygelRootDeviceFactory* self,
                                             RygelDescriptionFile* file,
                                             RygelPlugin* plugin)
{
	GeeArrayList* icons = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeArrayList* _tmp4_;
#line 176 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (file != NULL);
#line 176 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (plugin != NULL);
#line 178 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp0_ = rygel_plugin_get_icon_infos (plugin);
#line 178 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp1_ = _tmp0_;
#line 178 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 178 "../src/librygel-core/rygel-root-device-factory.vala"
	icons = _tmp2_;
#line 180 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp4_ = icons;
#line 180 "../src/librygel-core/rygel-root-device-factory.vala"
	if (_tmp4_ == NULL) {
#line 180 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp3_ = TRUE;
#line 1625 "rygel-root-device-factory.c"
	} else {
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 180 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp5_ = icons;
#line 180 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 180 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp7_ = _tmp6_;
#line 180 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp3_ = _tmp7_ == 0;
#line 1638 "rygel-root-device-factory.c"
	}
#line 180 "../src/librygel-core/rygel-root-device-factory.vala"
	if (_tmp3_) {
#line 1642 "rygel-root-device-factory.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GeeArrayList* _tmp10_;
		GeeArrayList* _tmp11_;
		GeeArrayList* _tmp12_;
#line 181 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp8_ = rygel_plugin_get_name (plugin);
#line 181 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp9_ = _tmp8_;
#line 181 "../src/librygel-core/rygel-root-device-factory.vala"
		g_debug ("rygel-root-device-factory.vala:181: No icon provided by plugin '%s'. U" \
"sing Rygel logo.", _tmp9_);
#line 184 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp10_ = rygel_plugin_get_default_icons (plugin);
#line 184 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp11_ = _tmp10_;
#line 184 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 184 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (icons);
#line 184 "../src/librygel-core/rygel-root-device-factory.vala"
		icons = _tmp12_;
#line 1664 "rygel-root-device-factory.c"
	}
#line 187 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_description_file_clear_icon_list (file);
#line 1668 "rygel-root-device-factory.c"
	{
		GeeArrayList* _icon_list = NULL;
		GeeArrayList* _tmp13_;
		gint _icon_size = 0;
		GeeArrayList* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _icon_index = 0;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp13_ = icons;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
		_icon_list = _tmp13_;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp14_ = _icon_list;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp16_ = _tmp15_;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
		_icon_size = _tmp16_;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
		_icon_index = -1;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
		while (TRUE) {
#line 1693 "rygel-root-device-factory.c"
			gint _tmp17_;
			gint _tmp18_;
			RygelIconInfo* icon = NULL;
			GeeArrayList* _tmp19_;
			gpointer _tmp20_;
			gchar* remote_path = NULL;
			RygelIconInfo* _tmp21_;
			gchar* _tmp22_;
			RygelIconInfo* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			RygelIconInfo* _tmp33_;
			const gchar* _tmp34_;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			_icon_index = _icon_index + 1;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp17_ = _icon_index;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp18_ = _icon_size;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			if (!(_tmp17_ < _tmp18_)) {
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
				break;
#line 1718 "rygel-root-device-factory.c"
			}
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp19_ = _icon_list;
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _icon_index);
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			icon = (RygelIconInfo*) _tmp20_;
#line 189 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp21_ = icon;
#line 189 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp22_ = rygel_root_device_factory_get_icon_remote_path (self, _tmp21_, plugin);
#line 189 "../src/librygel-core/rygel-root-device-factory.vala"
			remote_path = _tmp22_;
#line 190 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp23_ = icon;
#line 190 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp24_ = _tmp23_->uri;
#line 190 "../src/librygel-core/rygel-root-device-factory.vala"
			if (g_str_has_prefix (_tmp24_, "file://")) {
#line 1738 "rygel-root-device-factory.c"
				gchar* local_path = NULL;
				RygelIconInfo* _tmp25_;
				const gchar* _tmp26_;
				gchar* _tmp27_;
				GUPnPContext* _tmp28_;
				const gchar* _tmp29_;
				const gchar* _tmp30_;
#line 191 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp25_ = icon;
#line 191 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp26_ = _tmp25_->uri;
#line 191 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp27_ = string_substring (_tmp26_, (glong) 7, (glong) -1);
#line 191 "../src/librygel-core/rygel-root-device-factory.vala"
				local_path = _tmp27_;
#line 192 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp28_ = self->priv->_context;
#line 192 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp29_ = local_path;
#line 192 "../src/librygel-core/rygel-root-device-factory.vala"
				_tmp30_ = remote_path;
#line 192 "../src/librygel-core/rygel-root-device-factory.vala"
				gupnp_context_host_path (_tmp28_, _tmp29_, _tmp30_);
#line 190 "../src/librygel-core/rygel-root-device-factory.vala"
				_g_free0 (local_path);
#line 1764 "rygel-root-device-factory.c"
			}
#line 195 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp31_ = rygel_plugin_get_name (plugin);
#line 195 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp32_ = _tmp31_;
#line 195 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp33_ = icon;
#line 195 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp34_ = remote_path;
#line 195 "../src/librygel-core/rygel-root-device-factory.vala"
			rygel_description_file_add_icon (file, _tmp32_, _tmp33_, _tmp34_);
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_free0 (remote_path);
#line 188 "../src/librygel-core/rygel-root-device-factory.vala"
			_rygel_icon_info_unref0 (icon);
#line 1780 "rygel-root-device-factory.c"
		}
	}
#line 176 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_object_unref0 (icons);
#line 1785 "rygel-root-device-factory.c"
}

static gchar*
rygel_root_device_factory_get_icon_remote_path (RygelRootDeviceFactory* self,
                                                RygelIconInfo* icon_info,
                                                RygelPlugin* plugin)
{
	const gchar* _tmp0_;
	gchar* result;
#line 199 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 199 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (icon_info != NULL, NULL);
#line 199 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (plugin != NULL, NULL);
#line 201 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp0_ = icon_info->uri;
#line 201 "../src/librygel-core/rygel-root-device-factory.vala"
	if (g_str_has_prefix (_tmp0_, "file://")) {
#line 1805 "rygel-root-device-factory.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp1_ = rygel_plugin_get_name (plugin);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp2_ = _tmp1_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp3_ = g_strconcat ("/", _tmp2_, NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp4_ = _tmp3_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp5_ = g_strconcat (_tmp4_, "-", NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp6_ = _tmp5_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp7_ = g_strdup_printf ("%i", icon_info->width);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp8_ = _tmp7_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp9_ = g_strconcat (_tmp6_, _tmp8_, NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp10_ = _tmp9_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp11_ = g_strconcat (_tmp10_, "x", NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp12_ = _tmp11_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp13_ = g_strdup_printf ("%i", icon_info->height);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp14_ = _tmp13_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp15_ = g_strconcat (_tmp12_, _tmp14_, NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp16_ = _tmp15_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp17_ = g_strconcat (_tmp16_, "x", NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp18_ = _tmp17_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp19_ = g_strdup_printf ("%i", icon_info->depth);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp20_ = _tmp19_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp21_ = g_strconcat (_tmp18_, _tmp20_, NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp22_ = _tmp21_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp23_ = g_strconcat (_tmp22_, ".", NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp24_ = _tmp23_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp25_ = icon_info->file_extension;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp27_ = _tmp26_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp24_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp22_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp20_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp18_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp16_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp14_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp12_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp10_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp8_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp6_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp4_);
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		result = _tmp27_;
#line 203 "../src/librygel-core/rygel-root-device-factory.vala"
		return result;
#line 1913 "rygel-root-device-factory.c"
	} else {
		gchar* uri = NULL;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		GUPnPContext* _tmp31_;
		GInetAddress* _tmp32_;
		GInetAddress* _tmp33_;
		GInetAddress* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
#line 209 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp28_ = icon_info->uri;
#line 209 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp29_ = g_strdup (_tmp28_);
#line 209 "../src/librygel-core/rygel-root-device-factory.vala"
		uri = _tmp29_;
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp30_ = uri;
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp31_ = self->priv->_context;
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp32_ = gssdp_client_get_address ((GSSDPClient*) _tmp31_);
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp33_ = _tmp32_;
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp34_ = _tmp33_;
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp35_ = g_inet_address_to_string (_tmp34_);
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp36_ = _tmp35_;
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp37_ = string_replace (_tmp30_, "@ADDRESS@", _tmp36_);
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp38_ = _tmp37_;
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp38_);
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_free0 (_tmp36_);
#line 210 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (_tmp34_);
#line 211 "../src/librygel-core/rygel-root-device-factory.vala"
		result = uri;
#line 211 "../src/librygel-core/rygel-root-device-factory.vala"
		return result;
#line 1961 "rygel-root-device-factory.c"
	}
}

static GUPnPXMLDoc*
rygel_root_device_factory_get_latest_doc (RygelRootDeviceFactory* self,
                                          const gchar* path1,
                                          const gchar* path2,
                                          GError** error)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
	guint64 mod1 = 0ULL;
	GFileInfo* _tmp7_;
	GFile* _tmp8_;
	GFileInfo* _tmp9_ = NULL;
	GFile* _tmp10_;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp12_;
	guint64 mod2 = 0ULL;
	GFileInfo* _tmp13_;
	GError* _inner_error0_ = NULL;
	GUPnPXMLDoc* result;
#line 215 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (path1 != NULL, NULL);
#line 215 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (path2 != NULL, NULL);
#line 217 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp0_ = g_file_new_for_path (path1);
#line 217 "../src/librygel-core/rygel-root-device-factory.vala"
	file = _tmp0_;
#line 218 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp1_ = file;
#line 218 "../src/librygel-core/rygel-root-device-factory.vala"
	if (!g_file_query_exists (_tmp1_, NULL)) {
#line 2002 "rygel-root-device-factory.c"
		GUPnPXMLDoc* _tmp2_ = NULL;
		GUPnPXMLDoc* _tmp3_;
		GUPnPXMLDoc* _tmp4_;
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp3_ = gupnp_xml_doc_new_from_path (path2, &_inner_error0_);
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp2_ = _tmp3_;
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
			g_propagate_error (error, _inner_error0_);
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (file);
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
			return NULL;
#line 2018 "rygel-root-device-factory.c"
		}
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp4_ = _tmp2_;
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp2_ = NULL;
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		result = _tmp4_;
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (_tmp2_);
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (file);
#line 219 "../src/librygel-core/rygel-root-device-factory.vala"
		return result;
#line 2032 "rygel-root-device-factory.c"
	}
#line 222 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp5_ = file;
#line 222 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp6_ = g_file_query_info (_tmp5_, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 222 "../src/librygel-core/rygel-root-device-factory.vala"
	info = _tmp6_;
#line 222 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 222 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (file);
#line 222 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 2048 "rygel-root-device-factory.c"
	}
#line 224 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp7_ = info;
#line 224 "../src/librygel-core/rygel-root-device-factory.vala"
	mod1 = g_file_info_get_attribute_uint64 (_tmp7_, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 226 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp8_ = g_file_new_for_path (path2);
#line 226 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_object_unref0 (file);
#line 226 "../src/librygel-core/rygel-root-device-factory.vala"
	file = _tmp8_;
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp10_ = file;
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp11_ = g_file_query_info (_tmp10_, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp9_ = _tmp11_;
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (info);
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (file);
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 2076 "rygel-root-device-factory.c"
	}
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp12_ = _tmp9_;
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp9_ = NULL;
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_object_unref0 (info);
#line 227 "../src/librygel-core/rygel-root-device-factory.vala"
	info = _tmp12_;
#line 229 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp13_ = info;
#line 229 "../src/librygel-core/rygel-root-device-factory.vala"
	mod2 = g_file_info_get_attribute_uint64 (_tmp13_, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 231 "../src/librygel-core/rygel-root-device-factory.vala"
	if (mod1 > mod2) {
#line 2092 "rygel-root-device-factory.c"
		{
			GUPnPXMLDoc* _tmp14_ = NULL;
			GUPnPXMLDoc* _tmp15_;
			GUPnPXMLDoc* _tmp16_;
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp15_ = gupnp_xml_doc_new_from_path (path1, &_inner_error0_);
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp14_ = _tmp15_;
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2103 "rygel-root-device-factory.c"
				goto __catch0_g_error;
			}
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp16_ = _tmp14_;
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp14_ = NULL;
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			result = _tmp16_;
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (_tmp14_);
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (_tmp9_);
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (info);
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (file);
#line 235 "../src/librygel-core/rygel-root-device-factory.vala"
			return result;
#line 2122 "rygel-root-device-factory.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GUPnPXMLDoc* _tmp17_ = NULL;
			GUPnPXMLDoc* _tmp18_;
			GUPnPXMLDoc* _tmp19_;
#line 234 "../src/librygel-core/rygel-root-device-factory.vala"
			g_clear_error (&_inner_error0_);
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp18_ = gupnp_xml_doc_new_from_path (path2, &_inner_error0_);
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp17_ = _tmp18_;
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2138 "rygel-root-device-factory.c"
				goto __finally0;
			}
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp19_ = _tmp17_;
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			_tmp17_ = NULL;
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			result = _tmp19_;
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (_tmp17_);
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (_tmp9_);
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (info);
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (file);
#line 237 "../src/librygel-core/rygel-root-device-factory.vala"
			return result;
#line 2157 "rygel-root-device-factory.c"
		}
		__finally0:
#line 234 "../src/librygel-core/rygel-root-device-factory.vala"
		g_propagate_error (error, _inner_error0_);
#line 234 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (_tmp9_);
#line 234 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (info);
#line 234 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (file);
#line 234 "../src/librygel-core/rygel-root-device-factory.vala"
		return NULL;
#line 2170 "rygel-root-device-factory.c"
	} else {
		GUPnPXMLDoc* _tmp20_ = NULL;
		GUPnPXMLDoc* _tmp21_;
		GUPnPXMLDoc* _tmp22_;
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp21_ = gupnp_xml_doc_new_from_path (path2, &_inner_error0_);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp20_ = _tmp21_;
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
			g_propagate_error (error, _inner_error0_);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (_tmp9_);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (info);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
			_g_object_unref0 (file);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
			return NULL;
#line 2191 "rygel-root-device-factory.c"
		}
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp22_ = _tmp20_;
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp20_ = NULL;
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		result = _tmp22_;
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (_tmp20_);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (_tmp9_);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (info);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (file);
#line 240 "../src/librygel-core/rygel-root-device-factory.vala"
		return result;
#line 2209 "rygel-root-device-factory.c"
	}
}

static void
rygel_root_device_factory_ensure_dir_exists (RygelRootDeviceFactory* self,
                                             const gchar* dir_path,
                                             GError** error)
{
#line 244 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (dir_path != NULL);
#line 245 "../src/librygel-core/rygel-root-device-factory.vala"
	g_mkdir_with_parents (dir_path, 0750);
#line 2224 "rygel-root-device-factory.c"
}

GUPnPContext*
rygel_root_device_factory_get_context (RygelRootDeviceFactory* self)
{
	GUPnPContext* result;
	GUPnPContext* _tmp0_;
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
	_tmp0_ = self->priv->_context;
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
	result = _tmp0_;
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
	return result;
#line 2240 "rygel-root-device-factory.c"
}

static void
rygel_root_device_factory_set_context (RygelRootDeviceFactory* self,
                                       GUPnPContext* value)
{
	GUPnPContext* old_value;
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
	old_value = rygel_root_device_factory_get_context (self);
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
	if (old_value != value) {
#line 2254 "rygel-root-device-factory.c"
		GUPnPContext* _tmp0_;
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
		_g_object_unref0 (self->priv->_context);
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
		self->priv->_context = _tmp0_;
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_root_device_factory_properties[RYGEL_ROOT_DEVICE_FACTORY_CONTEXT_PROPERTY]);
#line 2264 "rygel-root-device-factory.c"
	}
}

static void
rygel_root_device_factory_class_init (RygelRootDeviceFactoryClass * klass,
                                      gpointer klass_data)
{
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_root_device_factory_parent_class = g_type_class_peek_parent (klass);
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	g_type_class_adjust_private_offset (klass, &RygelRootDeviceFactory_private_offset);
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_root_device_factory_get_property;
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_root_device_factory_set_property;
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_root_device_factory_finalize;
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_ROOT_DEVICE_FACTORY_CONTEXT_PROPERTY, rygel_root_device_factory_properties[RYGEL_ROOT_DEVICE_FACTORY_CONTEXT_PROPERTY] = g_param_spec_object ("context", "context", "context", gupnp_context_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2284 "rygel-root-device-factory.c"
}

static void
rygel_root_device_factory_g_initable_interface_init (GInitableIface * iface,
                                                     gpointer iface_data)
{
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	rygel_root_device_factory_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	iface->init = (gboolean (*) (GInitable*, GCancellable*, GError**)) rygel_root_device_factory_real_init;
#line 2295 "rygel-root-device-factory.c"
}

static void
rygel_root_device_factory_instance_init (RygelRootDeviceFactory * self,
                                         gpointer klass)
{
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	self->priv = rygel_root_device_factory_get_instance_private (self);
#line 2304 "rygel-root-device-factory.c"
}

static void
rygel_root_device_factory_finalize (GObject * obj)
{
	RygelRootDeviceFactory * self;
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_ROOT_DEVICE_FACTORY, RygelRootDeviceFactory);
#line 71 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_object_unref0 (self->priv->_context);
#line 73 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_object_unref0 (self->priv->config);
#line 75 "../src/librygel-core/rygel-root-device-factory.vala"
	_g_free0 (self->priv->desc_dir);
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	G_OBJECT_CLASS (rygel_root_device_factory_parent_class)->finalize (obj);
#line 2321 "rygel-root-device-factory.c"
}

/**
 * This is a factory to create #RygelRootDevice objects for
 * a given UPnP context.
 *
 * Call rygel_root_device_factory_create() with a plugin
 * to create a root device for the plugin.
 */
 G_GNUC_NO_INLINE static GType
rygel_root_device_factory_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelRootDeviceFactoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_root_device_factory_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelRootDeviceFactory), 0, (GInstanceInitFunc) rygel_root_device_factory_instance_init, NULL };
	static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) rygel_root_device_factory_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType rygel_root_device_factory_type_id;
	rygel_root_device_factory_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelRootDeviceFactory", &g_define_type_info, 0);
	g_type_add_interface_static (rygel_root_device_factory_type_id, g_initable_get_type (), &g_initable_info);
	RygelRootDeviceFactory_private_offset = g_type_add_instance_private (rygel_root_device_factory_type_id, sizeof (RygelRootDeviceFactoryPrivate));
	return rygel_root_device_factory_type_id;
}

GType
rygel_root_device_factory_get_type (void)
{
	static volatile gsize rygel_root_device_factory_type_id__once = 0;
	if (g_once_init_enter (&rygel_root_device_factory_type_id__once)) {
		GType rygel_root_device_factory_type_id;
		rygel_root_device_factory_type_id = rygel_root_device_factory_get_type_once ();
		g_once_init_leave (&rygel_root_device_factory_type_id__once, rygel_root_device_factory_type_id);
	}
	return rygel_root_device_factory_type_id__once;
}

static void
_vala_rygel_root_device_factory_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	RygelRootDeviceFactory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_ROOT_DEVICE_FACTORY, RygelRootDeviceFactory);
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	switch (property_id) {
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		case RYGEL_ROOT_DEVICE_FACTORY_CONTEXT_PROPERTY:
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		g_value_set_object (value, rygel_root_device_factory_get_context (self));
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		break;
#line 2371 "rygel-root-device-factory.c"
		default:
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		break;
#line 2377 "rygel-root-device-factory.c"
	}
}

static void
_vala_rygel_root_device_factory_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	RygelRootDeviceFactory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_ROOT_DEVICE_FACTORY, RygelRootDeviceFactory);
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
	switch (property_id) {
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		case RYGEL_ROOT_DEVICE_FACTORY_CONTEXT_PROPERTY:
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		rygel_root_device_factory_set_context (self, g_value_get_object (value));
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		break;
#line 2397 "rygel-root-device-factory.c"
		default:
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 69 "../src/librygel-core/rygel-root-device-factory.vala"
		break;
#line 2403 "rygel-root-device-factory.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

