/* rygel-v1-hacks.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-v1-hacks.vala, do not modify */

/*
 * Copyright (C) 2011 Nokia Corporation.
 * Copyright (C) 2012 Jens Georg.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *         Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <libgupnp/gupnp.h>

#define RYGEL_V1_HACKS_MATCHING_PATTERN ".*%s.*"
#define RYGEL_V1_HACKS_SERVICE_TYPE_PATTERN ":[0-9]+$"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_V1_HACKS_0_PROPERTY,
	RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY,
	RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY,
	RYGEL_V1_HACKS_NUM_PROPERTIES
};
static GParamSpec* rygel_v1_hacks_properties[RYGEL_V1_HACKS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define RYGEL_TYPE_AGENT_MATCHER (rygel_agent_matcher_get_type ())
#define RYGEL_AGENT_MATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcher))
#define RYGEL_AGENT_MATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcherClass))
#define RYGEL_IS_AGENT_MATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_AGENT_MATCHER))
#define RYGEL_IS_AGENT_MATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_AGENT_MATCHER))
#define RYGEL_AGENT_MATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_AGENT_MATCHER, RygelAgentMatcherClass))

typedef struct _RygelAgentMatcher RygelAgentMatcher;
typedef struct _RygelAgentMatcherClass RygelAgentMatcherClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _RygelV1HacksPrivate {
	gchar* _device_type;
	gchar* device_type_v1;
	gchar** _service_types;
	gint _service_types_length1;
	gint __service_types_size_;
	GRegex* service_type_regex;
};

static gint RygelV1Hacks_private_offset;
static gpointer rygel_v1_hacks_parent_class = NULL;
static RygelAgentMatcher* rygel_v1_hacks_agent_matcher;
static RygelAgentMatcher* rygel_v1_hacks_agent_matcher = NULL;

VALA_EXTERN GType rygel_agent_matcher_get_type (void) G_GNUC_CONST ;
static void rygel_v1_hacks_real_constructed (GObject* base);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
VALA_EXTERN RygelAgentMatcher* rygel_agent_matcher_new (const gchar* name,
                                            GeeArrayList* agents);
VALA_EXTERN RygelAgentMatcher* rygel_agent_matcher_construct (GType object_type,
                                                  const gchar* name,
                                                  GeeArrayList* agents);
VALA_EXTERN GRegex* rygel_agent_matcher_get_agent_regex (RygelAgentMatcher* self);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static void rygel_v1_hacks_finalize (GObject * obj);
static GType rygel_v1_hacks_get_type_once (void);
static void _vala_rygel_v1_hacks_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_rygel_v1_hacks_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* RYGEL_V1_HACKS_AGENTS[9] = {"Allegro-Software-WebClient", "SEC HHP", "SEC_HHP", "Mediabolic-IMHTTP/1.", "TwoPlayer", "Reciva", "FDSSDP", "Portable SDK for UPnP devices", "Darwin"};

static inline gpointer
rygel_v1_hacks_get_instance_private (RygelV1Hacks* self)
{
	return G_STRUCT_MEMBER_P (self, RygelV1Hacks_private_offset);
}

RygelV1Hacks*
rygel_v1_hacks_construct (GType object_type,
                          const gchar* device_type,
                          gchar** service_types,
                          gint service_types_length1)
{
	RygelV1Hacks * self = NULL;
#line 65 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_val_if_fail (device_type != NULL, NULL);
#line 67 "../src/librygel-core/rygel-v1-hacks.vala"
	self = (RygelV1Hacks*) g_object_new (object_type, "device-type", device_type, "service-types", service_types, NULL);
#line 65 "../src/librygel-core/rygel-v1-hacks.vala"
	return self;
#line 133 "rygel-v1-hacks.c"
}

RygelV1Hacks*
rygel_v1_hacks_new (const gchar* device_type,
                    gchar** service_types,
                    gint service_types_length1)
{
#line 65 "../src/librygel-core/rygel-v1-hacks.vala"
	return rygel_v1_hacks_construct (RYGEL_TYPE_V1_HACKS, device_type, service_types, service_types_length1);
#line 143 "rygel-v1-hacks.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
	if (length >= 0) {
#line 152 "rygel-v1-hacks.c"
		gchar** result;
		gssize i;
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
		result = g_new0 (gchar*, length + 1);
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
		for (i = 0; i < length; i++) {
#line 159 "rygel-v1-hacks.c"
			gchar* _tmp0_;
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
			_tmp0_ = g_strdup (self[i]);
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
			result[i] = _tmp0_;
#line 165 "rygel-v1-hacks.c"
		}
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
		return result;
#line 169 "rygel-v1-hacks.c"
	}
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
	return NULL;
#line 173 "rygel-v1-hacks.c"
}

static void
rygel_v1_hacks_real_constructed (GObject* base)
{
	RygelV1Hacks * self;
	RygelAgentMatcher* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 71 "../src/librygel-core/rygel-v1-hacks.vala"
	self = (RygelV1Hacks*) base;
#line 72 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (rygel_v1_hacks_parent_class)->constructed (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 74 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = rygel_v1_hacks_agent_matcher;
#line 74 "../src/librygel-core/rygel-v1-hacks.vala"
	if (_tmp0_ == NULL) {
#line 190 "rygel-v1-hacks.c"
		GeeArrayList* defaults = NULL;
		gchar** _tmp1_;
		gint _tmp1__length1;
		GEqualFunc _tmp2_;
		GeeArrayList* _tmp3_;
		RygelMetaConfig* config = NULL;
		RygelMetaConfig* _tmp4_;
		GeeArrayList* agents = NULL;
		RygelMetaConfig* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		GeeArrayList* _tmp8_;
		RygelAgentMatcher* _tmp9_;
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp1_ = _vala_array_dup2 (RYGEL_V1_HACKS_AGENTS, G_N_ELEMENTS (RYGEL_V1_HACKS_AGENTS));
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp1__length1 = G_N_ELEMENTS (RYGEL_V1_HACKS_AGENTS);
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp2_ = g_str_equal;
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp3_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp1_, _tmp1__length1, (GeeEqualDataFunc) _tmp2_, NULL, NULL);
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
		defaults = _tmp3_;
#line 76 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp4_ = rygel_meta_config_get_default ();
#line 76 "../src/librygel-core/rygel-v1-hacks.vala"
		config = _tmp4_;
#line 77 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp5_ = config;
#line 77 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp6_ = defaults;
#line 77 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp7_ = rygel_configuration_get_string_list_with_default ((RygelConfiguration*) _tmp5_, "general", "force-downgrade-for", _tmp6_);
#line 77 "../src/librygel-core/rygel-v1-hacks.vala"
		agents = _tmp7_;
#line 78 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp8_ = agents;
#line 78 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp9_ = rygel_agent_matcher_new ("V1 hacks", _tmp8_);
#line 78 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_object_unref0 (rygel_v1_hacks_agent_matcher);
#line 78 "../src/librygel-core/rygel-v1-hacks.vala"
		rygel_v1_hacks_agent_matcher = _tmp9_;
#line 74 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_object_unref0 (agents);
#line 74 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_object_unref0 (config);
#line 74 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_object_unref0 (defaults);
#line 240 "rygel-v1-hacks.c"
	}
	{
		GRegex* _tmp10_ = NULL;
		GRegex* _tmp11_;
		GRegex* _tmp12_;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp11_ = g_regex_new (RYGEL_V1_HACKS_SERVICE_TYPE_PATTERN, 0, 0, &_inner_error0_);
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp10_ = _tmp11_;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "rygel-v1-hacks.c"
			goto __catch0_g_error;
		}
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp12_ = _tmp10_;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp10_ = NULL;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_regex_unref0 (self->priv->service_type_regex);
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->service_type_regex = _tmp12_;
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_regex_unref0 (_tmp10_);
#line 265 "rygel-v1-hacks.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		g_clear_error (&_inner_error0_);
#line 83 "../src/librygel-core/rygel-v1-hacks.vala"
		g_assert_not_reached ();
#line 274 "rygel-v1-hacks.c"
	}
	__finally0:
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		g_clear_error (&_inner_error0_);
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 285 "rygel-v1-hacks.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 308 "rygel-v1-hacks.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 312 "rygel-v1-hacks.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 318 "rygel-v1-hacks.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 322 "rygel-v1-hacks.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 326 "rygel-v1-hacks.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 334 "rygel-v1-hacks.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 362 "rygel-v1-hacks.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 371 "rygel-v1-hacks.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 385 "rygel-v1-hacks.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 394 "rygel-v1-hacks.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 408 "rygel-v1-hacks.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 417 "rygel-v1-hacks.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 426 "rygel-v1-hacks.c"
}

void
rygel_v1_hacks_apply_on_device (RygelV1Hacks* self,
                                RygelRootDevice* device,
                                const gchar* template_path,
                                GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	RygelDescriptionFile* description_file = NULL;
	RygelDescriptionFile* _tmp3_;
	RygelDescriptionFile* _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp16_;
	RygelDescriptionFile* _tmp17_;
	const gchar* _tmp18_;
	gchar* server_path = NULL;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	RygelAgentMatcher* _tmp21_;
	GRegex* _tmp22_;
	GRegex* _tmp23_;
	const gchar* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 86 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_if_fail (device != NULL);
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = gupnp_device_info_get_device_type ((GUPnPDeviceInfo*) device);
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp1_ = rygel_v1_hacks_get_device_type (self);
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp2_ = _tmp1_;
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
	if (!g_str_has_prefix (_tmp0_, _tmp2_)) {
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 472 "rygel-v1-hacks.c"
	}
#line 92 "../src/librygel-core/rygel-v1-hacks.vala"
	if (template_path == NULL) {
#line 93 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 478 "rygel-v1-hacks.c"
	}
#line 96 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp3_ = rygel_description_file_new (template_path, &_inner_error0_);
#line 96 "../src/librygel-core/rygel-v1-hacks.vala"
	description_file = _tmp3_;
#line 96 "../src/librygel-core/rygel-v1-hacks.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../src/librygel-core/rygel-v1-hacks.vala"
		g_propagate_error (error, _inner_error0_);
#line 96 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 490 "rygel-v1-hacks.c"
	}
#line 97 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp4_ = description_file;
#line 97 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp5_ = self->priv->device_type_v1;
#line 97 "../src/librygel-core/rygel-v1-hacks.vala"
	rygel_description_file_set_device_type (_tmp4_, _tmp5_);
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp6_ = rygel_v1_hacks_get_service_types (self, &_tmp7_);
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp6__length1 = _tmp7_;
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp8_ = _tmp6_;
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp8__length1 = _tmp6__length1;
#line 506 "rygel-v1-hacks.c"
	{
		gchar** service_type_collection = NULL;
		gint service_type_collection_length1 = 0;
		gint _service_type_collection_size_ = 0;
		gint service_type_it = 0;
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
		service_type_collection = _tmp8_;
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
		service_type_collection_length1 = _tmp8__length1;
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
		for (service_type_it = 0; service_type_it < service_type_collection_length1; service_type_it = service_type_it + 1) {
#line 518 "rygel-v1-hacks.c"
			gchar* _tmp9_;
			gchar* service_type = NULL;
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
			_tmp9_ = g_strdup (service_type_collection[service_type_it]);
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
			service_type = _tmp9_;
#line 525 "rygel-v1-hacks.c"
			{
				gchar* service_type_v1 = NULL;
				GRegex* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				RygelDescriptionFile* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp10_ = self->priv->service_type_regex;
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp11_ = service_type;
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp12_ = g_regex_replace_literal (_tmp10_, _tmp11_, (gssize) -1, 0, ":1", 0, &_inner_error0_);
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
				service_type_v1 = _tmp12_;
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
					g_propagate_error (error, _inner_error0_);
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
					_g_free0 (service_type);
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
					_g_object_unref0 (description_file);
#line 100 "../src/librygel-core/rygel-v1-hacks.vala"
					return;
#line 552 "rygel-v1-hacks.c"
				}
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp13_ = description_file;
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp14_ = service_type;
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp15_ = service_type_v1;
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
				rygel_description_file_modify_service_type (_tmp13_, _tmp14_, _tmp15_);
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
				_g_free0 (service_type_v1);
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
				_g_free0 (service_type);
#line 566 "rygel-v1-hacks.c"
			}
		}
	}
#line 105 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp16_ = string_replace (template_path, ".xml", "-v1.xml");
#line 105 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->description_path);
#line 105 "../src/librygel-core/rygel-v1-hacks.vala"
	self->description_path = _tmp16_;
#line 106 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp17_ = description_file;
#line 106 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp18_ = self->description_path;
#line 106 "../src/librygel-core/rygel-v1-hacks.vala"
	rygel_description_file_save (_tmp17_, _tmp18_, &_inner_error0_);
#line 106 "../src/librygel-core/rygel-v1-hacks.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/librygel-core/rygel-v1-hacks.vala"
		g_propagate_error (error, _inner_error0_);
#line 106 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_object_unref0 (description_file);
#line 106 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 590 "rygel-v1-hacks.c"
	}
#line 108 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp19_ = gupnp_root_device_get_description_document_name ((GUPnPRootDevice*) device);
#line 108 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp20_ = g_strconcat ("/", _tmp19_, NULL);
#line 108 "../src/librygel-core/rygel-v1-hacks.vala"
	server_path = _tmp20_;
#line 109 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp21_ = rygel_v1_hacks_agent_matcher;
#line 109 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp22_ = rygel_agent_matcher_get_agent_regex (_tmp21_);
#line 109 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp23_ = _tmp22_;
#line 109 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp24_ = g_regex_get_pattern (_tmp23_);
#line 109 "../src/librygel-core/rygel-v1-hacks.vala"
	if (g_strcmp0 (_tmp24_, "") != 0) {
#line 608 "rygel-v1-hacks.c"
		GUPnPContext* _tmp25_;
		GUPnPContext* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		RygelAgentMatcher* _tmp29_;
		GRegex* _tmp30_;
		GRegex* _tmp31_;
#line 110 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp25_ = gupnp_device_info_get_context ((GUPnPDeviceInfo*) device);
#line 110 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp26_ = _tmp25_;
#line 110 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp27_ = self->description_path;
#line 110 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp28_ = server_path;
#line 110 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp29_ = rygel_v1_hacks_agent_matcher;
#line 110 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp30_ = rygel_agent_matcher_get_agent_regex (_tmp29_);
#line 110 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp31_ = _tmp30_;
#line 110 "../src/librygel-core/rygel-v1-hacks.vala"
		gupnp_context_host_path_for_agent (_tmp26_, _tmp27_, _tmp28_, _tmp31_);
#line 632 "rygel-v1-hacks.c"
	}
#line 86 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (server_path);
#line 86 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_object_unref0 (description_file);
#line 638 "rygel-v1-hacks.c"
}

const gchar*
rygel_v1_hacks_get_device_type (RygelV1Hacks* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = self->priv->_device_type;
#line 51 "../src/librygel-core/rygel-v1-hacks.vala"
	result = _tmp0_;
#line 51 "../src/librygel-core/rygel-v1-hacks.vala"
	return result;
#line 654 "rygel-v1-hacks.c"
}

void
rygel_v1_hacks_set_device_type (RygelV1Hacks* self,
                                const gchar* value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 47 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = g_strdup (value);
#line 48 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->priv->_device_type);
#line 48 "../src/librygel-core/rygel-v1-hacks.vala"
	self->priv->_device_type = _tmp0_;
#line 49 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp1_ = g_strconcat (value, ":1", NULL);
#line 49 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->priv->device_type_v1);
#line 49 "../src/librygel-core/rygel-v1-hacks.vala"
	self->priv->device_type_v1 = _tmp1_;
#line 47 "../src/librygel-core/rygel-v1-hacks.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_v1_hacks_properties[RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY]);
#line 679 "rygel-v1-hacks.c"
}

gchar**
rygel_v1_hacks_get_service_types (RygelV1Hacks* self,
                                  gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = self->priv->_service_types;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0__length1 = self->priv->_service_types_length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp1_ = _tmp0_;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp1__length1 = _tmp0__length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	if (result_length1) {
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		*result_length1 = _tmp1__length1;
#line 705 "rygel-v1-hacks.c"
	}
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	result = _tmp1_;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	return result;
#line 711 "rygel-v1-hacks.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	if (length >= 0) {
#line 720 "rygel-v1-hacks.c"
		gchar** result;
		gssize i;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		result = g_new0 (gchar*, length + 1);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		for (i = 0; i < length; i++) {
#line 727 "rygel-v1-hacks.c"
			gchar* _tmp0_;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
			_tmp0_ = g_strdup (self[i]);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
			result[i] = _tmp0_;
#line 733 "rygel-v1-hacks.c"
		}
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		return result;
#line 737 "rygel-v1-hacks.c"
	}
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	return NULL;
#line 741 "rygel-v1-hacks.c"
}

static void
rygel_v1_hacks_set_service_types (RygelV1Hacks* self,
                                  gchar** value,
                                  gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	old_value = rygel_v1_hacks_get_service_types (self, &old_value_length);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	if (old_value != value) {
#line 757 "rygel-v1-hacks.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup3 (value, value_length1) : value;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp0__length1 = value_length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->_service_types = (_vala_array_free (self->priv->_service_types, self->priv->_service_types_length1, (GDestroyNotify) g_free), NULL);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->_service_types = _tmp0_;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->_service_types_length1 = _tmp0__length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->__service_types_size_ = self->priv->_service_types_length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_v1_hacks_properties[RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY]);
#line 774 "rygel-v1-hacks.c"
	}
}

static void
rygel_v1_hacks_class_init (RygelV1HacksClass * klass,
                           gpointer klass_data)
{
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	rygel_v1_hacks_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	g_type_class_adjust_private_offset (klass, &RygelV1Hacks_private_offset);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_v1_hacks_real_constructed;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_v1_hacks_get_property;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_v1_hacks_set_property;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_v1_hacks_finalize;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY, rygel_v1_hacks_properties[RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY] = g_param_spec_string ("device-type", "device-type", "device-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY, rygel_v1_hacks_properties[RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY] = g_param_spec_boxed ("service-types", "service-types", "service-types", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 798 "rygel-v1-hacks.c"
}

static void
rygel_v1_hacks_instance_init (RygelV1Hacks * self,
                              gpointer klass)
{
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	self->priv = rygel_v1_hacks_get_instance_private (self);
#line 807 "rygel-v1-hacks.c"
}

static void
rygel_v1_hacks_finalize (GObject * obj)
{
	RygelV1Hacks * self;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_V1_HACKS, RygelV1Hacks);
#line 45 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->priv->_device_type);
#line 53 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->priv->device_type_v1);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	self->priv->_service_types = (_vala_array_free (self->priv->_service_types, self->priv->_service_types_length1, (GDestroyNotify) g_free), NULL);
#line 60 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->description_path);
#line 63 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_regex_unref0 (self->priv->service_type_regex);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (rygel_v1_hacks_parent_class)->finalize (obj);
#line 828 "rygel-v1-hacks.c"
}

/**
 * Various devices that need a downgrade to MediaServer:1 and
 * ContentDirectory:1 because they ignore that higher versions are
 * required to be backwards-compatible.
 */
 G_GNUC_NO_INLINE static GType
rygel_v1_hacks_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelV1HacksClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_v1_hacks_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelV1Hacks), 0, (GInstanceInitFunc) rygel_v1_hacks_instance_init, NULL };
	GType rygel_v1_hacks_type_id;
	rygel_v1_hacks_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelV1Hacks", &g_define_type_info, 0);
	RygelV1Hacks_private_offset = g_type_add_instance_private (rygel_v1_hacks_type_id, sizeof (RygelV1HacksPrivate));
	return rygel_v1_hacks_type_id;
}

GType
rygel_v1_hacks_get_type (void)
{
	static volatile gsize rygel_v1_hacks_type_id__once = 0;
	if (g_once_init_enter (&rygel_v1_hacks_type_id__once)) {
		GType rygel_v1_hacks_type_id;
		rygel_v1_hacks_type_id = rygel_v1_hacks_get_type_once ();
		g_once_init_leave (&rygel_v1_hacks_type_id__once, rygel_v1_hacks_type_id);
	}
	return rygel_v1_hacks_type_id__once;
}

static void
_vala_rygel_v1_hacks_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	RygelV1Hacks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_V1_HACKS, RygelV1Hacks);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	switch (property_id) {
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		case RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY:
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		g_value_set_string (value, rygel_v1_hacks_get_device_type (self));
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		case RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY:
#line 876 "rygel-v1-hacks.c"
		{
			int length;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
			g_value_set_boxed (value, rygel_v1_hacks_get_service_types (self, &length));
#line 881 "rygel-v1-hacks.c"
		}
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 885 "rygel-v1-hacks.c"
		default:
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 891 "rygel-v1-hacks.c"
	}
}

static void
_vala_rygel_v1_hacks_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	RygelV1Hacks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_V1_HACKS, RygelV1Hacks);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	switch (property_id) {
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		case RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY:
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		rygel_v1_hacks_set_device_type (self, g_value_get_string (value));
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		case RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY:
#line 913 "rygel-v1-hacks.c"
		{
			gpointer boxed;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
			boxed = g_value_get_boxed (value);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
			rygel_v1_hacks_set_service_types (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 920 "rygel-v1-hacks.c"
		}
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 924 "rygel-v1-hacks.c"
		default:
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 930 "rygel-v1-hacks.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

