/* database-cursor.c generated by valac 0.56.18, the Vala compiler
 * generated from database-cursor.vala, do not modify */

/*
 * Copyright (C) 2011 Jens Georg <mail@jensge.org>.
 *
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-db.h"
#include <sqlite3.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_DATABASE_CURSOR_0_PROPERTY,
	RYGEL_DATABASE_CURSOR_NUM_PROPERTIES
};
static GParamSpec* rygel_database_cursor_properties[RYGEL_DATABASE_CURSOR_NUM_PROPERTIES];
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _RygelDatabaseCursorParamSpecIterator RygelDatabaseCursorParamSpecIterator;

struct _RygelDatabaseCursorPrivate {
	sqlite3_stmt* statement;
	gint current_state;
	gboolean dirty;
	sqlite3* db;
};

struct _RygelDatabaseCursorParamSpecIterator {
	GParamSpec parent_instance;
};

static gint RygelDatabaseCursor_private_offset;
static gpointer rygel_database_cursor_parent_class = NULL;
static gpointer rygel_database_cursor_iterator_parent_class = NULL;

static void rygel_database_cursor_iterator_finalize (RygelDatabaseCursorIterator * obj);
static GType rygel_database_cursor_iterator_get_type_once (void);
static void rygel_database_cursor_finalize (GObject * obj);
static GType rygel_database_cursor_get_type_once (void);

static inline gpointer
rygel_database_cursor_get_instance_private (RygelDatabaseCursor* self)
{
	return G_STRUCT_MEMBER_P (self, RygelDatabaseCursor_private_offset);
}

/**
     * Prepare a SQLite statement from a SQL string
     *
     * If @arguments is non-null, it will call bind()
     *
     * @param db SQLite database this cursor belongs to
     * @param sql statement to execute
     * @param arguments array of values to bind to the SQL statement or null if
     * none
     */
RygelDatabaseCursor*
rygel_database_cursor_construct (GType object_type,
                                 sqlite3* db,
                                 const gchar* sql,
                                 GValue* arguments,
                                 gint arguments_length1,
                                 GError** error)
{
	RygelDatabaseCursor * self = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
#line 41 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (db != NULL, NULL);
#line 41 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 41 "../src/librygel-db/database-cursor.vala"
	self = (RygelDatabaseCursor*) g_object_new (object_type, NULL);
#line 44 "../src/librygel-db/database-cursor.vala"
	self->priv->db = db;
#line 46 "../src/librygel-db/database-cursor.vala"
	_tmp1_ = sqlite3_prepare_v2 (db, sql, -1, &_tmp0_, NULL);
#line 46 "../src/librygel-db/database-cursor.vala"
	_sqlite3_finalize0 (self->priv->statement);
#line 46 "../src/librygel-db/database-cursor.vala"
	self->priv->statement = _tmp0_;
#line 46 "../src/librygel-db/database-cursor.vala"
	rygel_database_cursor_throw_if_code_is_error (self, _tmp1_, &_inner_error0_);
#line 46 "../src/librygel-db/database-cursor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/librygel-db/database-cursor.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 46 "../src/librygel-db/database-cursor.vala"
			g_propagate_error (error, _inner_error0_);
#line 46 "../src/librygel-db/database-cursor.vala"
			_g_object_unref0 (self);
#line 46 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 128 "database-cursor.c"
		} else {
#line 46 "../src/librygel-db/database-cursor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/librygel-db/database-cursor.vala"
			g_clear_error (&_inner_error0_);
#line 46 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 136 "database-cursor.c"
		}
	}
#line 50 "../src/librygel-db/database-cursor.vala"
	if (arguments == NULL) {
#line 51 "../src/librygel-db/database-cursor.vala"
		return self;
#line 143 "database-cursor.c"
	}
#line 54 "../src/librygel-db/database-cursor.vala"
	rygel_database_cursor_bind (self, arguments, (gint) arguments_length1, &_inner_error0_);
#line 54 "../src/librygel-db/database-cursor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../src/librygel-db/database-cursor.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 54 "../src/librygel-db/database-cursor.vala"
			g_propagate_error (error, _inner_error0_);
#line 54 "../src/librygel-db/database-cursor.vala"
			_g_object_unref0 (self);
#line 54 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 157 "database-cursor.c"
		} else {
#line 54 "../src/librygel-db/database-cursor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "../src/librygel-db/database-cursor.vala"
			g_clear_error (&_inner_error0_);
#line 54 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 165 "database-cursor.c"
		}
	}
#line 41 "../src/librygel-db/database-cursor.vala"
	return self;
#line 170 "database-cursor.c"
}

RygelDatabaseCursor*
rygel_database_cursor_new (sqlite3* db,
                           const gchar* sql,
                           GValue* arguments,
                           gint arguments_length1,
                           GError** error)
{
#line 41 "../src/librygel-db/database-cursor.vala"
	return rygel_database_cursor_construct (RYGEL_DATABASE_TYPE_CURSOR, db, sql, arguments, arguments_length1, error);
#line 182 "database-cursor.c"
}

/**
     * Bind new values to a cursor.
     *
     * The cursor will be reset.
     *
     * This function uses the type of the GValue passed in values to determine
     * which _bind function to use.
     *
     * Supported types are: int, long, int64, uint64, string and pointer.
     * Note: The only pointer supported is the null pointer as provided by
     * Database.@null. This is a special value to bind a column to NULL
     * @param arguments array of values to bind to the SQL statement or null if
     * none
     */
void
rygel_database_cursor_bind (RygelDatabaseCursor* self,
                            GValue* arguments,
                            gint arguments_length1,
                            GError** error)
{
	sqlite3_stmt* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 71 "../src/librygel-db/database-cursor.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/librygel-db/database-cursor.vala"
	_tmp0_ = self->priv->statement;
#line 72 "../src/librygel-db/database-cursor.vala"
	sqlite3_reset (_tmp0_);
#line 73 "../src/librygel-db/database-cursor.vala"
	self->priv->dirty = TRUE;
#line 74 "../src/librygel-db/database-cursor.vala"
	self->priv->current_state = -1;
#line 217 "database-cursor.c"
	{
		gint i = 0;
#line 76 "../src/librygel-db/database-cursor.vala"
		i = 1;
#line 222 "database-cursor.c"
		{
			gboolean _tmp1_ = FALSE;
#line 76 "../src/librygel-db/database-cursor.vala"
			_tmp1_ = TRUE;
#line 76 "../src/librygel-db/database-cursor.vala"
			while (TRUE) {
#line 229 "database-cursor.c"
				GValue current_value = {0};
				GValue _tmp3_;
				sqlite3* _tmp16_;
#line 76 "../src/librygel-db/database-cursor.vala"
				if (!_tmp1_) {
#line 235 "database-cursor.c"
					gint _tmp2_;
#line 76 "../src/librygel-db/database-cursor.vala"
					i = i + 1;
#line 76 "../src/librygel-db/database-cursor.vala"
					_tmp2_ = i;
#line 241 "database-cursor.c"
				}
#line 76 "../src/librygel-db/database-cursor.vala"
				_tmp1_ = FALSE;
#line 76 "../src/librygel-db/database-cursor.vala"
				if (!(i <= arguments_length1)) {
#line 76 "../src/librygel-db/database-cursor.vala"
					break;
#line 249 "database-cursor.c"
				}
#line 77 "../src/librygel-db/database-cursor.vala"
				_tmp3_ = arguments[i - 1];
#line 77 "../src/librygel-db/database-cursor.vala"
				current_value = _tmp3_;
#line 79 "../src/librygel-db/database-cursor.vala"
				if (G_VALUE_HOLDS (&current_value, G_TYPE_INT)) {
#line 257 "database-cursor.c"
					sqlite3_stmt* _tmp4_;
#line 80 "../src/librygel-db/database-cursor.vala"
					_tmp4_ = self->priv->statement;
#line 80 "../src/librygel-db/database-cursor.vala"
					sqlite3_bind_int (_tmp4_, i, g_value_get_int (&current_value));
#line 263 "database-cursor.c"
				} else {
#line 81 "../src/librygel-db/database-cursor.vala"
					if (G_VALUE_HOLDS (&current_value, G_TYPE_INT64)) {
#line 267 "database-cursor.c"
						sqlite3_stmt* _tmp5_;
#line 82 "../src/librygel-db/database-cursor.vala"
						_tmp5_ = self->priv->statement;
#line 82 "../src/librygel-db/database-cursor.vala"
						sqlite3_bind_int64 (_tmp5_, i, g_value_get_int64 (&current_value));
#line 273 "database-cursor.c"
					} else {
#line 83 "../src/librygel-db/database-cursor.vala"
						if (G_VALUE_HOLDS (&current_value, G_TYPE_UINT64)) {
#line 277 "database-cursor.c"
							sqlite3_stmt* _tmp6_;
#line 84 "../src/librygel-db/database-cursor.vala"
							_tmp6_ = self->priv->statement;
#line 84 "../src/librygel-db/database-cursor.vala"
							sqlite3_bind_int64 (_tmp6_, i, (gint64) g_value_get_uint64 (&current_value));
#line 283 "database-cursor.c"
						} else {
#line 85 "../src/librygel-db/database-cursor.vala"
							if (G_VALUE_HOLDS (&current_value, G_TYPE_LONG)) {
#line 287 "database-cursor.c"
								sqlite3_stmt* _tmp7_;
#line 86 "../src/librygel-db/database-cursor.vala"
								_tmp7_ = self->priv->statement;
#line 86 "../src/librygel-db/database-cursor.vala"
								sqlite3_bind_int64 (_tmp7_, i, (gint64) g_value_get_long (&current_value));
#line 293 "database-cursor.c"
							} else {
#line 87 "../src/librygel-db/database-cursor.vala"
								if (G_VALUE_HOLDS (&current_value, G_TYPE_UINT)) {
#line 297 "database-cursor.c"
									sqlite3_stmt* _tmp8_;
#line 88 "../src/librygel-db/database-cursor.vala"
									_tmp8_ = self->priv->statement;
#line 88 "../src/librygel-db/database-cursor.vala"
									sqlite3_bind_int64 (_tmp8_, i, (gint64) g_value_get_uint (&current_value));
#line 303 "database-cursor.c"
								} else {
#line 89 "../src/librygel-db/database-cursor.vala"
									if (G_VALUE_HOLDS (&current_value, G_TYPE_STRING)) {
#line 307 "database-cursor.c"
										sqlite3_stmt* _tmp9_;
										const gchar* _tmp10_;
										gchar* _tmp11_;
										GDestroyNotify _tmp12_;
#line 90 "../src/librygel-db/database-cursor.vala"
										_tmp9_ = self->priv->statement;
#line 90 "../src/librygel-db/database-cursor.vala"
										_tmp10_ = g_value_get_string (&current_value);
#line 90 "../src/librygel-db/database-cursor.vala"
										_tmp11_ = g_strdup (_tmp10_);
#line 90 "../src/librygel-db/database-cursor.vala"
										_tmp12_ = g_free;
#line 90 "../src/librygel-db/database-cursor.vala"
										sqlite3_bind_text (_tmp9_, i, _tmp11_, -1, _tmp12_);
#line 322 "database-cursor.c"
									} else {
#line 91 "../src/librygel-db/database-cursor.vala"
										if (G_VALUE_HOLDS (&current_value, G_TYPE_POINTER)) {
#line 326 "database-cursor.c"
											void* _tmp13_;
#line 92 "../src/librygel-db/database-cursor.vala"
											_tmp13_ = g_value_peek_pointer (&current_value);
#line 92 "../src/librygel-db/database-cursor.vala"
											if (_tmp13_ == NULL) {
#line 332 "database-cursor.c"
												sqlite3_stmt* _tmp14_;
#line 93 "../src/librygel-db/database-cursor.vala"
												_tmp14_ = self->priv->statement;
#line 93 "../src/librygel-db/database-cursor.vala"
												sqlite3_bind_null (_tmp14_, i);
#line 338 "database-cursor.c"
											} else {
#line 95 "../src/librygel-db/database-cursor.vala"
												g_assert_not_reached ();
#line 342 "database-cursor.c"
											}
										} else {
											GType type = 0UL;
											const gchar* _tmp15_;
#line 98 "../src/librygel-db/database-cursor.vala"
											type = G_VALUE_TYPE (&current_value);
#line 99 "../src/librygel-db/database-cursor.vala"
											_tmp15_ = g_type_name (type);
#line 99 "../src/librygel-db/database-cursor.vala"
											g_warning (_ ("Unsupported type %s"), _tmp15_);
#line 100 "../src/librygel-db/database-cursor.vala"
											g_assert_not_reached ();
#line 355 "database-cursor.c"
										}
									}
								}
							}
						}
					}
				}
#line 103 "../src/librygel-db/database-cursor.vala"
				_tmp16_ = self->priv->db;
#line 103 "../src/librygel-db/database-cursor.vala"
				if (sqlite3_errcode (_tmp16_) != SQLITE_OK) {
#line 367 "database-cursor.c"
					sqlite3_stmt* _tmp17_;
					const gchar* _tmp18_;
					sqlite3* _tmp19_;
					const gchar* _tmp20_;
					GError* _tmp21_;
#line 104 "../src/librygel-db/database-cursor.vala"
					_tmp17_ = self->priv->statement;
#line 104 "../src/librygel-db/database-cursor.vala"
					_tmp18_ = sqlite3_sql (_tmp17_);
#line 104 "../src/librygel-db/database-cursor.vala"
					_tmp19_ = self->priv->db;
#line 104 "../src/librygel-db/database-cursor.vala"
					_tmp20_ = sqlite3_errmsg (_tmp19_);
#line 104 "../src/librygel-db/database-cursor.vala"
					_tmp21_ = g_error_new (RYGEL_DATABASE_DATABASE_ERROR, RYGEL_DATABASE_DATABASE_ERROR_BIND, "Failed to bind value %d in %s: %s", i, _tmp18_, _tmp20_);
#line 104 "../src/librygel-db/database-cursor.vala"
					_inner_error0_ = _tmp21_;
#line 104 "../src/librygel-db/database-cursor.vala"
					if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 104 "../src/librygel-db/database-cursor.vala"
						g_propagate_error (error, _inner_error0_);
#line 104 "../src/librygel-db/database-cursor.vala"
						return;
#line 391 "database-cursor.c"
					} else {
#line 104 "../src/librygel-db/database-cursor.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../src/librygel-db/database-cursor.vala"
						g_clear_error (&_inner_error0_);
#line 104 "../src/librygel-db/database-cursor.vala"
						return;
#line 399 "database-cursor.c"
					}
				}
			}
		}
	}
}

/**
     * Check if the cursor has more rows left
     *
     * @return true if more rows left, false otherwise
     */
gboolean
rygel_database_cursor_has_next (RygelDatabaseCursor* self,
                                GError** error)
{
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 117 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 118 "../src/librygel-db/database-cursor.vala"
	if (self->priv->dirty) {
#line 423 "database-cursor.c"
		sqlite3_stmt* _tmp0_;
#line 119 "../src/librygel-db/database-cursor.vala"
		_tmp0_ = self->priv->statement;
#line 119 "../src/librygel-db/database-cursor.vala"
		self->priv->current_state = sqlite3_step (_tmp0_);
#line 120 "../src/librygel-db/database-cursor.vala"
		self->priv->dirty = FALSE;
#line 431 "database-cursor.c"
	}
#line 123 "../src/librygel-db/database-cursor.vala"
	rygel_database_cursor_throw_if_code_is_error (self, self->priv->current_state, &_inner_error0_);
#line 123 "../src/librygel-db/database-cursor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/librygel-db/database-cursor.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 439 "database-cursor.c"
			gboolean _tmp1_ = FALSE;
#line 123 "../src/librygel-db/database-cursor.vala"
			g_propagate_error (error, _inner_error0_);
#line 123 "../src/librygel-db/database-cursor.vala"
			return _tmp1_;
#line 445 "database-cursor.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 123 "../src/librygel-db/database-cursor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/librygel-db/database-cursor.vala"
			g_clear_error (&_inner_error0_);
#line 123 "../src/librygel-db/database-cursor.vala"
			return _tmp2_;
#line 454 "database-cursor.c"
		}
	}
#line 125 "../src/librygel-db/database-cursor.vala"
	if (self->priv->current_state == SQLITE_ROW) {
#line 125 "../src/librygel-db/database-cursor.vala"
		_tmp3_ = TRUE;
#line 461 "database-cursor.c"
	} else {
#line 125 "../src/librygel-db/database-cursor.vala"
		_tmp3_ = self->priv->current_state == -1;
#line 465 "database-cursor.c"
	}
#line 125 "../src/librygel-db/database-cursor.vala"
	result = _tmp3_;
#line 125 "../src/librygel-db/database-cursor.vala"
	return result;
#line 471 "database-cursor.c"
}

/**
     * Get the next row of this cursor.
     *
     * This function uses pointers instead of unowned because var doesn't work
     * with unowned.
     *
     * @return a pointer to the current row
     */
sqlite3_stmt*
rygel_database_cursor_next (RygelDatabaseCursor* self,
                            GError** error)
{
	sqlite3_stmt* _tmp0_;
	GError* _inner_error0_ = NULL;
	sqlite3_stmt* result;
#line 136 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 137 "../src/librygel-db/database-cursor.vala"
	rygel_database_cursor_has_next (self, &_inner_error0_);
#line 137 "../src/librygel-db/database-cursor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 137 "../src/librygel-db/database-cursor.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 137 "../src/librygel-db/database-cursor.vala"
			g_propagate_error (error, _inner_error0_);
#line 137 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 501 "database-cursor.c"
		} else {
#line 137 "../src/librygel-db/database-cursor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 137 "../src/librygel-db/database-cursor.vala"
			g_clear_error (&_inner_error0_);
#line 137 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 509 "database-cursor.c"
		}
	}
#line 138 "../src/librygel-db/database-cursor.vala"
	rygel_database_cursor_throw_if_code_is_error (self, self->priv->current_state, &_inner_error0_);
#line 138 "../src/librygel-db/database-cursor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../src/librygel-db/database-cursor.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 138 "../src/librygel-db/database-cursor.vala"
			g_propagate_error (error, _inner_error0_);
#line 138 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 522 "database-cursor.c"
		} else {
#line 138 "../src/librygel-db/database-cursor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 138 "../src/librygel-db/database-cursor.vala"
			g_clear_error (&_inner_error0_);
#line 138 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 530 "database-cursor.c"
		}
	}
#line 139 "../src/librygel-db/database-cursor.vala"
	self->priv->dirty = TRUE;
#line 141 "../src/librygel-db/database-cursor.vala"
	_tmp0_ = self->priv->statement;
#line 141 "../src/librygel-db/database-cursor.vala"
	result = _tmp0_;
#line 141 "../src/librygel-db/database-cursor.vala"
	return result;
#line 541 "database-cursor.c"
}

/**
     * Return an iterator to the cursor to use with foreach
     *
     * @return an iterator wrapping the cursor
     */
RygelDatabaseCursorIterator*
rygel_database_cursor_iterator (RygelDatabaseCursor* self)
{
	RygelDatabaseCursorIterator* _tmp0_;
	RygelDatabaseCursorIterator* result;
#line 151 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 152 "../src/librygel-db/database-cursor.vala"
	_tmp0_ = rygel_database_cursor_iterator_new (self);
#line 152 "../src/librygel-db/database-cursor.vala"
	result = _tmp0_;
#line 152 "../src/librygel-db/database-cursor.vala"
	return result;
#line 562 "database-cursor.c"
}

/**
     * Convert a SQLite return code to a DatabaseError
     */
void
rygel_database_cursor_throw_if_code_is_error (RygelDatabaseCursor* self,
                                              gint sqlite_error,
                                              GError** error)
{
	GError* _inner_error0_ = NULL;
#line 174 "../src/librygel-db/database-cursor.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/librygel-db/database-cursor.vala"
	switch (sqlite_error) {
#line 176 "../src/librygel-db/database-cursor.vala"
		case SQLITE_OK:
#line 176 "../src/librygel-db/database-cursor.vala"
		case SQLITE_DONE:
#line 176 "../src/librygel-db/database-cursor.vala"
		case SQLITE_ROW:
#line 584 "database-cursor.c"
		{
#line 180 "../src/librygel-db/database-cursor.vala"
			return;
#line 588 "database-cursor.c"
		}
		default:
		{
			sqlite3* _tmp0_;
			const gchar* _tmp1_;
			GError* _tmp2_;
#line 182 "../src/librygel-db/database-cursor.vala"
			_tmp0_ = self->priv->db;
#line 182 "../src/librygel-db/database-cursor.vala"
			_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 182 "../src/librygel-db/database-cursor.vala"
			_tmp2_ = g_error_new (RYGEL_DATABASE_DATABASE_ERROR, RYGEL_DATABASE_DATABASE_ERROR_SQLITE_ERROR, "SQLite error %d: %s", sqlite_error, _tmp1_);
#line 182 "../src/librygel-db/database-cursor.vala"
			_inner_error0_ = _tmp2_;
#line 182 "../src/librygel-db/database-cursor.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 182 "../src/librygel-db/database-cursor.vala"
				g_propagate_error (error, _inner_error0_);
#line 182 "../src/librygel-db/database-cursor.vala"
				return;
#line 609 "database-cursor.c"
			} else {
#line 182 "../src/librygel-db/database-cursor.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../src/librygel-db/database-cursor.vala"
				g_clear_error (&_inner_error0_);
#line 182 "../src/librygel-db/database-cursor.vala"
				return;
#line 617 "database-cursor.c"
			}
		}
	}
}

/**
     * Check if the last operation on the database was an error
     */
void
rygel_database_cursor_throw_if_db_has_error (RygelDatabaseCursor* self,
                                             GError** error)
{
	sqlite3* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 192 "../src/librygel-db/database-cursor.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/librygel-db/database-cursor.vala"
	_tmp0_ = self->priv->db;
#line 193 "../src/librygel-db/database-cursor.vala"
	rygel_database_cursor_throw_if_code_is_error (self, sqlite3_errcode (_tmp0_), &_inner_error0_);
#line 193 "../src/librygel-db/database-cursor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 193 "../src/librygel-db/database-cursor.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 193 "../src/librygel-db/database-cursor.vala"
			g_propagate_error (error, _inner_error0_);
#line 193 "../src/librygel-db/database-cursor.vala"
			return;
#line 646 "database-cursor.c"
		} else {
#line 193 "../src/librygel-db/database-cursor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 193 "../src/librygel-db/database-cursor.vala"
			g_clear_error (&_inner_error0_);
#line 193 "../src/librygel-db/database-cursor.vala"
			return;
#line 654 "database-cursor.c"
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 159 "../src/librygel-db/database-cursor.vala"
	return self ? g_object_ref (self) : NULL;
#line 664 "database-cursor.c"
}

RygelDatabaseCursorIterator*
rygel_database_cursor_iterator_construct (GType object_type,
                                          RygelDatabaseCursor* cursor)
{
	RygelDatabaseCursorIterator* self = NULL;
	RygelDatabaseCursor* _tmp0_;
#line 158 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (cursor != NULL, NULL);
#line 158 "../src/librygel-db/database-cursor.vala"
	self = (RygelDatabaseCursorIterator*) g_type_create_instance (object_type);
#line 159 "../src/librygel-db/database-cursor.vala"
	_tmp0_ = _g_object_ref0 (cursor);
#line 159 "../src/librygel-db/database-cursor.vala"
	_g_object_unref0 (self->cursor);
#line 159 "../src/librygel-db/database-cursor.vala"
	self->cursor = _tmp0_;
#line 158 "../src/librygel-db/database-cursor.vala"
	return self;
#line 685 "database-cursor.c"
}

RygelDatabaseCursorIterator*
rygel_database_cursor_iterator_new (RygelDatabaseCursor* cursor)
{
#line 158 "../src/librygel-db/database-cursor.vala"
	return rygel_database_cursor_iterator_construct (RYGEL_DATABASE_CURSOR_TYPE_ITERATOR, cursor);
#line 693 "database-cursor.c"
}

gboolean
rygel_database_cursor_iterator_next (RygelDatabaseCursorIterator* self,
                                     GError** error)
{
	gboolean _tmp0_ = FALSE;
	RygelDatabaseCursor* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 162 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/librygel-db/database-cursor.vala"
	_tmp1_ = self->cursor;
#line 163 "../src/librygel-db/database-cursor.vala"
	_tmp0_ = rygel_database_cursor_has_next (_tmp1_, &_inner_error0_);
#line 163 "../src/librygel-db/database-cursor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "../src/librygel-db/database-cursor.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 714 "database-cursor.c"
			gboolean _tmp2_ = FALSE;
#line 163 "../src/librygel-db/database-cursor.vala"
			g_propagate_error (error, _inner_error0_);
#line 163 "../src/librygel-db/database-cursor.vala"
			return _tmp2_;
#line 720 "database-cursor.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 163 "../src/librygel-db/database-cursor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 163 "../src/librygel-db/database-cursor.vala"
			g_clear_error (&_inner_error0_);
#line 163 "../src/librygel-db/database-cursor.vala"
			return _tmp3_;
#line 729 "database-cursor.c"
		}
	}
#line 163 "../src/librygel-db/database-cursor.vala"
	result = _tmp0_;
#line 163 "../src/librygel-db/database-cursor.vala"
	return result;
#line 736 "database-cursor.c"
}

sqlite3_stmt*
rygel_database_cursor_iterator_get (RygelDatabaseCursorIterator* self,
                                    GError** error)
{
	sqlite3_stmt* _tmp0_ = NULL;
	RygelDatabaseCursor* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
	sqlite3_stmt* result;
#line 166 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "../src/librygel-db/database-cursor.vala"
	_tmp1_ = self->cursor;
#line 167 "../src/librygel-db/database-cursor.vala"
	_tmp2_ = rygel_database_cursor_next (_tmp1_, &_inner_error0_);
#line 167 "../src/librygel-db/database-cursor.vala"
	_tmp0_ = _tmp2_;
#line 167 "../src/librygel-db/database-cursor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "../src/librygel-db/database-cursor.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 167 "../src/librygel-db/database-cursor.vala"
			g_propagate_error (error, _inner_error0_);
#line 167 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 764 "database-cursor.c"
		} else {
#line 167 "../src/librygel-db/database-cursor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "../src/librygel-db/database-cursor.vala"
			g_clear_error (&_inner_error0_);
#line 167 "../src/librygel-db/database-cursor.vala"
			return NULL;
#line 772 "database-cursor.c"
		}
	}
#line 167 "../src/librygel-db/database-cursor.vala"
	result = _tmp0_;
#line 167 "../src/librygel-db/database-cursor.vala"
	return result;
#line 779 "database-cursor.c"
}

static void
rygel_database_cursor_value_iterator_init (GValue* value)
{
#line 155 "../src/librygel-db/database-cursor.vala"
	value->data[0].v_pointer = NULL;
#line 787 "database-cursor.c"
}

static void
rygel_database_cursor_value_iterator_free_value (GValue* value)
{
#line 155 "../src/librygel-db/database-cursor.vala"
	if (value->data[0].v_pointer) {
#line 155 "../src/librygel-db/database-cursor.vala"
		rygel_database_cursor_iterator_unref (value->data[0].v_pointer);
#line 797 "database-cursor.c"
	}
}

static void
rygel_database_cursor_value_iterator_copy_value (const GValue* src_value,
                                                 GValue* dest_value)
{
#line 155 "../src/librygel-db/database-cursor.vala"
	if (src_value->data[0].v_pointer) {
#line 155 "../src/librygel-db/database-cursor.vala"
		dest_value->data[0].v_pointer = rygel_database_cursor_iterator_ref (src_value->data[0].v_pointer);
#line 809 "database-cursor.c"
	} else {
#line 155 "../src/librygel-db/database-cursor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 813 "database-cursor.c"
	}
}

static gpointer
rygel_database_cursor_value_iterator_peek_pointer (const GValue* value)
{
#line 155 "../src/librygel-db/database-cursor.vala"
	return value->data[0].v_pointer;
#line 822 "database-cursor.c"
}

static gchar*
rygel_database_cursor_value_iterator_collect_value (GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
#line 155 "../src/librygel-db/database-cursor.vala"
	if (collect_values[0].v_pointer) {
#line 833 "database-cursor.c"
		RygelDatabaseCursorIterator * object;
		object = collect_values[0].v_pointer;
#line 155 "../src/librygel-db/database-cursor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 155 "../src/librygel-db/database-cursor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 840 "database-cursor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 155 "../src/librygel-db/database-cursor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 844 "database-cursor.c"
		}
#line 155 "../src/librygel-db/database-cursor.vala"
		value->data[0].v_pointer = rygel_database_cursor_iterator_ref (object);
#line 848 "database-cursor.c"
	} else {
#line 155 "../src/librygel-db/database-cursor.vala"
		value->data[0].v_pointer = NULL;
#line 852 "database-cursor.c"
	}
#line 155 "../src/librygel-db/database-cursor.vala"
	return NULL;
#line 856 "database-cursor.c"
}

static gchar*
rygel_database_cursor_value_iterator_lcopy_value (const GValue* value,
                                                  guint n_collect_values,
                                                  GTypeCValue* collect_values,
                                                  guint collect_flags)
{
	RygelDatabaseCursorIterator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 155 "../src/librygel-db/database-cursor.vala"
	if (!object_p) {
#line 155 "../src/librygel-db/database-cursor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 871 "database-cursor.c"
	}
#line 155 "../src/librygel-db/database-cursor.vala"
	if (!value->data[0].v_pointer) {
#line 155 "../src/librygel-db/database-cursor.vala"
		*object_p = NULL;
#line 877 "database-cursor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 155 "../src/librygel-db/database-cursor.vala"
		*object_p = value->data[0].v_pointer;
#line 881 "database-cursor.c"
	} else {
#line 155 "../src/librygel-db/database-cursor.vala"
		*object_p = rygel_database_cursor_iterator_ref (value->data[0].v_pointer);
#line 885 "database-cursor.c"
	}
#line 155 "../src/librygel-db/database-cursor.vala"
	return NULL;
#line 889 "database-cursor.c"
}

GParamSpec*
rygel_database_cursor_param_spec_iterator (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags)
{
	RygelDatabaseCursorParamSpecIterator* spec;
#line 155 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, RYGEL_DATABASE_CURSOR_TYPE_ITERATOR), NULL);
#line 155 "../src/librygel-db/database-cursor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 155 "../src/librygel-db/database-cursor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 155 "../src/librygel-db/database-cursor.vala"
	return G_PARAM_SPEC (spec);
#line 908 "database-cursor.c"
}

gpointer
rygel_database_cursor_value_get_iterator (const GValue* value)
{
#line 155 "../src/librygel-db/database-cursor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, RYGEL_DATABASE_CURSOR_TYPE_ITERATOR), NULL);
#line 155 "../src/librygel-db/database-cursor.vala"
	return value->data[0].v_pointer;
#line 918 "database-cursor.c"
}

void
rygel_database_cursor_value_set_iterator (GValue* value,
                                          gpointer v_object)
{
	RygelDatabaseCursorIterator * old;
#line 155 "../src/librygel-db/database-cursor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, RYGEL_DATABASE_CURSOR_TYPE_ITERATOR));
#line 155 "../src/librygel-db/database-cursor.vala"
	old = value->data[0].v_pointer;
#line 155 "../src/librygel-db/database-cursor.vala"
	if (v_object) {
#line 155 "../src/librygel-db/database-cursor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, RYGEL_DATABASE_CURSOR_TYPE_ITERATOR));
#line 155 "../src/librygel-db/database-cursor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 155 "../src/librygel-db/database-cursor.vala"
		value->data[0].v_pointer = v_object;
#line 155 "../src/librygel-db/database-cursor.vala"
		rygel_database_cursor_iterator_ref (value->data[0].v_pointer);
#line 940 "database-cursor.c"
	} else {
#line 155 "../src/librygel-db/database-cursor.vala"
		value->data[0].v_pointer = NULL;
#line 944 "database-cursor.c"
	}
#line 155 "../src/librygel-db/database-cursor.vala"
	if (old) {
#line 155 "../src/librygel-db/database-cursor.vala"
		rygel_database_cursor_iterator_unref (old);
#line 950 "database-cursor.c"
	}
}

void
rygel_database_cursor_value_take_iterator (GValue* value,
                                           gpointer v_object)
{
	RygelDatabaseCursorIterator * old;
#line 155 "../src/librygel-db/database-cursor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, RYGEL_DATABASE_CURSOR_TYPE_ITERATOR));
#line 155 "../src/librygel-db/database-cursor.vala"
	old = value->data[0].v_pointer;
#line 155 "../src/librygel-db/database-cursor.vala"
	if (v_object) {
#line 155 "../src/librygel-db/database-cursor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, RYGEL_DATABASE_CURSOR_TYPE_ITERATOR));
#line 155 "../src/librygel-db/database-cursor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 155 "../src/librygel-db/database-cursor.vala"
		value->data[0].v_pointer = v_object;
#line 971 "database-cursor.c"
	} else {
#line 155 "../src/librygel-db/database-cursor.vala"
		value->data[0].v_pointer = NULL;
#line 975 "database-cursor.c"
	}
#line 155 "../src/librygel-db/database-cursor.vala"
	if (old) {
#line 155 "../src/librygel-db/database-cursor.vala"
		rygel_database_cursor_iterator_unref (old);
#line 981 "database-cursor.c"
	}
}

static void
rygel_database_cursor_iterator_class_init (RygelDatabaseCursorIteratorClass * klass,
                                           gpointer klass_data)
{
#line 155 "../src/librygel-db/database-cursor.vala"
	rygel_database_cursor_iterator_parent_class = g_type_class_peek_parent (klass);
#line 155 "../src/librygel-db/database-cursor.vala"
	((RygelDatabaseCursorIteratorClass *) klass)->finalize = rygel_database_cursor_iterator_finalize;
#line 993 "database-cursor.c"
}

static void
rygel_database_cursor_iterator_instance_init (RygelDatabaseCursorIterator * self,
                                              gpointer klass)
{
#line 155 "../src/librygel-db/database-cursor.vala"
	self->ref_count = 1;
#line 1002 "database-cursor.c"
}

static void
rygel_database_cursor_iterator_finalize (RygelDatabaseCursorIterator * obj)
{
	RygelDatabaseCursorIterator * self;
#line 155 "../src/librygel-db/database-cursor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_DATABASE_CURSOR_TYPE_ITERATOR, RygelDatabaseCursorIterator);
#line 155 "../src/librygel-db/database-cursor.vala"
	g_signal_handlers_destroy (self);
#line 156 "../src/librygel-db/database-cursor.vala"
	_g_object_unref0 (self->cursor);
#line 1015 "database-cursor.c"
}

 G_GNUC_NO_INLINE static GType
rygel_database_cursor_iterator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { rygel_database_cursor_value_iterator_init, rygel_database_cursor_value_iterator_free_value, rygel_database_cursor_value_iterator_copy_value, rygel_database_cursor_value_iterator_peek_pointer, "p", rygel_database_cursor_value_iterator_collect_value, "p", rygel_database_cursor_value_iterator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (RygelDatabaseCursorIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_database_cursor_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelDatabaseCursorIterator), 0, (GInstanceInitFunc) rygel_database_cursor_iterator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType rygel_database_cursor_iterator_type_id;
	rygel_database_cursor_iterator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "RygelDatabaseCursorIterator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return rygel_database_cursor_iterator_type_id;
}

GType
rygel_database_cursor_iterator_get_type (void)
{
	static volatile gsize rygel_database_cursor_iterator_type_id__once = 0;
	if (g_once_init_enter (&rygel_database_cursor_iterator_type_id__once)) {
		GType rygel_database_cursor_iterator_type_id;
		rygel_database_cursor_iterator_type_id = rygel_database_cursor_iterator_get_type_once ();
		g_once_init_leave (&rygel_database_cursor_iterator_type_id__once, rygel_database_cursor_iterator_type_id);
	}
	return rygel_database_cursor_iterator_type_id__once;
}

gpointer
rygel_database_cursor_iterator_ref (gpointer instance)
{
	RygelDatabaseCursorIterator * self;
	self = instance;
#line 155 "../src/librygel-db/database-cursor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 155 "../src/librygel-db/database-cursor.vala"
	return instance;
#line 1050 "database-cursor.c"
}

void
rygel_database_cursor_iterator_unref (gpointer instance)
{
	RygelDatabaseCursorIterator * self;
	self = instance;
#line 155 "../src/librygel-db/database-cursor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 155 "../src/librygel-db/database-cursor.vala"
		RYGEL_DATABASE_CURSOR_ITERATOR_GET_CLASS (self)->finalize (self);
#line 155 "../src/librygel-db/database-cursor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1064 "database-cursor.c"
	}
}

static void
rygel_database_cursor_class_init (RygelDatabaseCursorClass * klass,
                                  gpointer klass_data)
{
#line 25 "../src/librygel-db/database-cursor.vala"
	rygel_database_cursor_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/librygel-db/database-cursor.vala"
	g_type_class_adjust_private_offset (klass, &RygelDatabaseCursor_private_offset);
#line 25 "../src/librygel-db/database-cursor.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_database_cursor_finalize;
#line 1078 "database-cursor.c"
}

static void
rygel_database_cursor_instance_init (RygelDatabaseCursor * self,
                                     gpointer klass)
{
#line 25 "../src/librygel-db/database-cursor.vala"
	self->priv = rygel_database_cursor_get_instance_private (self);
#line 27 "../src/librygel-db/database-cursor.vala"
	self->priv->current_state = -1;
#line 28 "../src/librygel-db/database-cursor.vala"
	self->priv->dirty = TRUE;
#line 1091 "database-cursor.c"
}

static void
rygel_database_cursor_finalize (GObject * obj)
{
	RygelDatabaseCursor * self;
#line 25 "../src/librygel-db/database-cursor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_DATABASE_TYPE_CURSOR, RygelDatabaseCursor);
#line 26 "../src/librygel-db/database-cursor.vala"
	_sqlite3_finalize0 (self->priv->statement);
#line 25 "../src/librygel-db/database-cursor.vala"
	G_OBJECT_CLASS (rygel_database_cursor_parent_class)->finalize (obj);
#line 1104 "database-cursor.c"
}

 G_GNUC_NO_INLINE static GType
rygel_database_cursor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelDatabaseCursorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_database_cursor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelDatabaseCursor), 0, (GInstanceInitFunc) rygel_database_cursor_instance_init, NULL };
	GType rygel_database_cursor_type_id;
	rygel_database_cursor_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelDatabaseCursor", &g_define_type_info, 0);
	RygelDatabaseCursor_private_offset = g_type_add_instance_private (rygel_database_cursor_type_id, sizeof (RygelDatabaseCursorPrivate));
	return rygel_database_cursor_type_id;
}

GType
rygel_database_cursor_get_type (void)
{
	static volatile gsize rygel_database_cursor_type_id__once = 0;
	if (g_once_init_enter (&rygel_database_cursor_type_id__once)) {
		GType rygel_database_cursor_type_id;
		rygel_database_cursor_type_id = rygel_database_cursor_get_type_once ();
		g_once_init_leave (&rygel_database_cursor_type_id__once, rygel_database_cursor_type_id);
	}
	return rygel_database_cursor_type_id__once;
}

