/* database.c generated by valac 0.56.18, the Vala compiler
 * generated from database.vala, do not modify */

/*
 * Copyright (C) 2009,2011 Jens Georg <mail@jensge.org>.
 *
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-db.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include "rygel-core.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_DATABASE_DATABASE_0_PROPERTY,
	RYGEL_DATABASE_DATABASE_NAME_PROPERTY,
	RYGEL_DATABASE_DATABASE_FLAVOR_PROPERTY,
	RYGEL_DATABASE_DATABASE_FLAGS_PROPERTY,
	RYGEL_DATABASE_DATABASE_NUM_PROPERTIES
};
static GParamSpec* rygel_database_database_properties[RYGEL_DATABASE_DATABASE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _RygelDatabaseDatabasePrivate {
	gchar* _name;
	RygelDatabaseFlavor _flavor;
	RygelDatabaseFlags _flags;
	sqlite3* db;
};

static gint RygelDatabaseDatabase_private_offset;
static gpointer rygel_database_database_parent_class = NULL;
static GInitableIface * rygel_database_database_g_initable_parent_iface = NULL;

gint rygel_database_utf8_collate_str (guint8* a,
                                      gint a_length1,
                                      guint8* b,
                                      gint b_length1);
static gchar* rygel_database_database_build_path (RygelDatabaseDatabase* self);
static const gchar* rygel_database_database_get_name (RygelDatabaseDatabase* self);
static RygelDatabaseFlavor rygel_database_database_get_flavor (RygelDatabaseDatabase* self);
static gboolean rygel_database_database_real_init (GInitable* base,
                                            GCancellable* cancellable,
                                            GError** error);
static RygelDatabaseFlags rygel_database_database_get_flags (RygelDatabaseDatabase* self);
static void _rygel_database_database_utf8_contains_sqlite_user_func_callback (sqlite3_context* context,
                                                                       gint values_length1,
                                                                       sqlite3_value** values);
static gint _rygel_database_database_utf8_collate_sqlite_compare_callback (gpointer self,
                                                                    gint alen,
                                                                    void* a,
                                                                    gint blen,
                                                                    void* b);
static void rygel_database_database_on_trace (RygelDatabaseDatabase* self,
                                       const gchar* message);
static void _rygel_database_database_on_trace_sqlite_trace_callback (gpointer self,
                                                              const gchar* message);
static void rygel_database_database_finalize (GObject * obj);
static GType rygel_database_database_get_type_once (void);
static void _vala_rygel_database_database_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_rygel_database_database_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

GQuark
rygel_database_database_error_quark (void)
{
	return g_quark_from_static_string ("rygel-database-database-error-quark");
}

 G_GNUC_NO_INLINE static GType
rygel_database_database_error_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_DATABASE_DATABASE_ERROR_SQLITE_ERROR, "RYGEL_DATABASE_DATABASE_ERROR_SQLITE_ERROR", "sqlite-error"}, {RYGEL_DATABASE_DATABASE_ERROR_OPEN, "RYGEL_DATABASE_DATABASE_ERROR_OPEN", "open"}, {RYGEL_DATABASE_DATABASE_ERROR_PREPARE, "RYGEL_DATABASE_DATABASE_ERROR_PREPARE", "prepare"}, {RYGEL_DATABASE_DATABASE_ERROR_BIND, "RYGEL_DATABASE_DATABASE_ERROR_BIND", "bind"}, {RYGEL_DATABASE_DATABASE_ERROR_STEP, "RYGEL_DATABASE_DATABASE_ERROR_STEP", "step"}, {0, NULL, NULL}};
	GType rygel_database_database_error_type_id;
	rygel_database_database_error_type_id = g_enum_register_static ("RygelDatabaseDatabaseError", values);
	return rygel_database_database_error_type_id;
}

GType
rygel_database_database_error_get_type (void)
{
	static volatile gsize rygel_database_database_error_type_id__once = 0;
	if (g_once_init_enter (&rygel_database_database_error_type_id__once)) {
		GType rygel_database_database_error_type_id;
		rygel_database_database_error_type_id = rygel_database_database_error_get_type_once ();
		g_once_init_leave (&rygel_database_database_error_type_id__once, rygel_database_database_error_type_id);
	}
	return rygel_database_database_error_type_id__once;
}

 G_GNUC_NO_INLINE static GType
rygel_database_flavor_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_DATABASE_FLAVOR_CACHE, "RYGEL_DATABASE_FLAVOR_CACHE", "cache"}, {RYGEL_DATABASE_FLAVOR_CONFIG, "RYGEL_DATABASE_FLAVOR_CONFIG", "config"}, {RYGEL_DATABASE_FLAVOR_FOREIGN, "RYGEL_DATABASE_FLAVOR_FOREIGN", "foreign"}, {0, NULL, NULL}};
	GType rygel_database_flavor_type_id;
	rygel_database_flavor_type_id = g_enum_register_static ("RygelDatabaseFlavor", values);
	return rygel_database_flavor_type_id;
}

GType
rygel_database_flavor_get_type (void)
{
	static volatile gsize rygel_database_flavor_type_id__once = 0;
	if (g_once_init_enter (&rygel_database_flavor_type_id__once)) {
		GType rygel_database_flavor_type_id;
		rygel_database_flavor_type_id = rygel_database_flavor_get_type_once ();
		g_once_init_leave (&rygel_database_flavor_type_id__once, rygel_database_flavor_type_id);
	}
	return rygel_database_flavor_type_id__once;
}

 G_GNUC_NO_INLINE static GType
rygel_database_flags_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_DATABASE_FLAGS_READ_ONLY, "RYGEL_DATABASE_FLAGS_READ_ONLY", "read-only"}, {RYGEL_DATABASE_FLAGS_WRITE_ONLY, "RYGEL_DATABASE_FLAGS_WRITE_ONLY", "write-only"}, {RYGEL_DATABASE_FLAGS_READ_WRITE, "RYGEL_DATABASE_FLAGS_READ_WRITE", "read-write"}, {RYGEL_DATABASE_FLAGS_SHARED, "RYGEL_DATABASE_FLAGS_SHARED", "shared"}, {0, NULL, NULL}};
	GType rygel_database_flags_type_id;
	rygel_database_flags_type_id = g_enum_register_static ("RygelDatabaseFlags", values);
	return rygel_database_flags_type_id;
}

GType
rygel_database_flags_get_type (void)
{
	static volatile gsize rygel_database_flags_type_id__once = 0;
	if (g_once_init_enter (&rygel_database_flags_type_id__once)) {
		GType rygel_database_flags_type_id;
		rygel_database_flags_type_id = rygel_database_flags_get_type_once ();
		g_once_init_leave (&rygel_database_flags_type_id__once, rygel_database_flags_type_id);
	}
	return rygel_database_flags_type_id__once;
}

/**
     * Special GValue to pass to exec or exec_cursor to bind a column to
     * NULL
     */
void
rygel_database_null (GValue* result)
{
	GValue v = {0};
	GValue _tmp0_ = {0};
#line 59 "../src/librygel-db/database.vala"
	g_value_init (&_tmp0_, G_TYPE_POINTER);
#line 59 "../src/librygel-db/database.vala"
	v = _tmp0_;
#line 60 "../src/librygel-db/database.vala"
	g_value_set_pointer (&v, NULL);
#line 62 "../src/librygel-db/database.vala"
	*result = v;
#line 62 "../src/librygel-db/database.vala"
	return;
#line 197 "database.c"
}

static inline gpointer
rygel_database_database_get_instance_private (RygelDatabaseDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, RygelDatabaseDatabase_private_offset);
}

/**
     * Function to implement the custom SQL function 'contains'
     */
void
rygel_database_database_utf8_contains (sqlite3_context* context,
                                       sqlite3_value** args,
                                       gint args_length1)
{
	gboolean _tmp0_ = FALSE;
	sqlite3_value* _tmp1_;
	const gchar* _tmp2_;
	gchar* pattern = NULL;
	sqlite3_value* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	sqlite3_value* _tmp9_;
	const gchar* _tmp10_;
#line 85 "../src/librygel-db/database.vala"
	g_return_if_fail (context != NULL);
#line 85 "../src/librygel-db/database.vala"
	_vala_return_if_fail (args_length1 == 2, "args.length == 2");
#line 88 "../src/librygel-db/database.vala"
	_tmp1_ = args[0];
#line 88 "../src/librygel-db/database.vala"
	_tmp2_ = (const gchar*) sqlite3_value_text (_tmp1_);
#line 88 "../src/librygel-db/database.vala"
	if (_tmp2_ == NULL) {
#line 88 "../src/librygel-db/database.vala"
		_tmp0_ = TRUE;
#line 236 "database.c"
	} else {
		sqlite3_value* _tmp3_;
		const gchar* _tmp4_;
#line 89 "../src/librygel-db/database.vala"
		_tmp3_ = args[1];
#line 89 "../src/librygel-db/database.vala"
		_tmp4_ = (const gchar*) sqlite3_value_text (_tmp3_);
#line 89 "../src/librygel-db/database.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 246 "database.c"
	}
#line 88 "../src/librygel-db/database.vala"
	if (_tmp0_) {
#line 90 "../src/librygel-db/database.vala"
		sqlite3_result_int (context, 0);
#line 92 "../src/librygel-db/database.vala"
		return;
#line 254 "database.c"
	}
#line 95 "../src/librygel-db/database.vala"
	_tmp5_ = args[1];
#line 95 "../src/librygel-db/database.vala"
	_tmp6_ = (const gchar*) sqlite3_value_text (_tmp5_);
#line 95 "../src/librygel-db/database.vala"
	_tmp7_ = g_regex_escape_string (_tmp6_, -1);
#line 95 "../src/librygel-db/database.vala"
	pattern = _tmp7_;
#line 96 "../src/librygel-db/database.vala"
	_tmp8_ = pattern;
#line 96 "../src/librygel-db/database.vala"
	_tmp9_ = args[0];
#line 96 "../src/librygel-db/database.vala"
	_tmp10_ = (const gchar*) sqlite3_value_text (_tmp9_);
#line 96 "../src/librygel-db/database.vala"
	if (g_regex_match_simple (_tmp8_, _tmp10_, G_REGEX_CASELESS, 0)) {
#line 99 "../src/librygel-db/database.vala"
		sqlite3_result_int (context, 1);
#line 274 "database.c"
	} else {
#line 101 "../src/librygel-db/database.vala"
		sqlite3_result_int (context, 0);
#line 278 "database.c"
	}
#line 85 "../src/librygel-db/database.vala"
	_g_free0 (pattern);
#line 282 "database.c"
}

/**
     * Function to implement the custom SQLite collation 'CASEFOLD'.
     *
     * Uses utf8 case-fold to compare the strings.
     */
gint
rygel_database_database_utf8_collate (gint alen,
                                      void* a,
                                      gint blen,
                                      void* b)
{
	guint8* _a = NULL;
	gint _a_length1;
	gint __a_size_;
	guint8* _b = NULL;
	gint _b_length1;
	gint __b_size_;
	gint result;
#line 112 "../src/librygel-db/database.vala"
	_a = (guint8*) a;
#line 112 "../src/librygel-db/database.vala"
	_a_length1 = -1;
#line 112 "../src/librygel-db/database.vala"
	__a_size_ = _a_length1;
#line 113 "../src/librygel-db/database.vala"
	_a_length1 = alen;
#line 115 "../src/librygel-db/database.vala"
	_b = (guint8*) b;
#line 115 "../src/librygel-db/database.vala"
	_b_length1 = -1;
#line 115 "../src/librygel-db/database.vala"
	__b_size_ = _b_length1;
#line 116 "../src/librygel-db/database.vala"
	_b_length1 = blen;
#line 118 "../src/librygel-db/database.vala"
	result = rygel_database_utf8_collate_str (_a, (gint) _a_length1, _b, (gint) _b_length1);
#line 118 "../src/librygel-db/database.vala"
	return result;
#line 323 "database.c"
}

static gchar*
rygel_database_database_build_path (RygelDatabaseDatabase* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean name_is_path = FALSE;
	gchar* result;
#line 121 "../src/librygel-db/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "../src/librygel-db/database.vala"
	_tmp2_ = self->priv->_name;
#line 122 "../src/librygel-db/database.vala"
	if (g_strcmp0 (_tmp2_, ":memory:") == 0) {
#line 122 "../src/librygel-db/database.vala"
		_tmp1_ = TRUE;
#line 342 "database.c"
	} else {
		const gchar* _tmp3_;
#line 123 "../src/librygel-db/database.vala"
		_tmp3_ = self->priv->_name;
#line 123 "../src/librygel-db/database.vala"
		_tmp1_ = g_path_is_absolute (_tmp3_);
#line 349 "database.c"
	}
#line 122 "../src/librygel-db/database.vala"
	if (_tmp1_) {
#line 122 "../src/librygel-db/database.vala"
		_tmp0_ = TRUE;
#line 355 "database.c"
	} else {
		RygelDatabaseFlavor _tmp4_;
#line 124 "../src/librygel-db/database.vala"
		_tmp4_ = self->priv->_flavor;
#line 124 "../src/librygel-db/database.vala"
		_tmp0_ = _tmp4_ == RYGEL_DATABASE_FLAVOR_FOREIGN;
#line 362 "database.c"
	}
#line 122 "../src/librygel-db/database.vala"
	name_is_path = _tmp0_;
#line 126 "../src/librygel-db/database.vala"
	if (!name_is_path) {
#line 368 "database.c"
		const gchar* _tmp5_ = NULL;
		RygelDatabaseFlavor _tmp6_;
		gchar* dirname = NULL;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 128 "../src/librygel-db/database.vala"
		_tmp6_ = self->priv->_flavor;
#line 128 "../src/librygel-db/database.vala"
		if (_tmp6_ == RYGEL_DATABASE_FLAVOR_CACHE) {
#line 384 "database.c"
			const gchar* _tmp7_;
#line 129 "../src/librygel-db/database.vala"
			_tmp7_ = g_get_user_cache_dir ();
#line 129 "../src/librygel-db/database.vala"
			_tmp5_ = _tmp7_;
#line 390 "database.c"
		} else {
			const gchar* _tmp8_;
#line 130 "../src/librygel-db/database.vala"
			_tmp8_ = g_get_user_config_dir ();
#line 130 "../src/librygel-db/database.vala"
			_tmp5_ = _tmp8_;
#line 397 "database.c"
		}
#line 127 "../src/librygel-db/database.vala"
		_tmp9_ = g_build_filename (_tmp5_, "rygel", NULL);
#line 127 "../src/librygel-db/database.vala"
		dirname = _tmp9_;
#line 132 "../src/librygel-db/database.vala"
		_tmp10_ = dirname;
#line 132 "../src/librygel-db/database.vala"
		g_mkdir_with_parents (_tmp10_, 0750);
#line 134 "../src/librygel-db/database.vala"
		_tmp11_ = dirname;
#line 134 "../src/librygel-db/database.vala"
		_tmp12_ = self->priv->_name;
#line 134 "../src/librygel-db/database.vala"
		_tmp13_ = g_strdup_printf ("%s.db", _tmp12_);
#line 134 "../src/librygel-db/database.vala"
		_tmp14_ = _tmp13_;
#line 134 "../src/librygel-db/database.vala"
		_tmp15_ = g_build_filename (_tmp11_, _tmp14_, NULL);
#line 134 "../src/librygel-db/database.vala"
		_tmp16_ = _tmp15_;
#line 134 "../src/librygel-db/database.vala"
		_g_free0 (_tmp14_);
#line 134 "../src/librygel-db/database.vala"
		result = _tmp16_;
#line 134 "../src/librygel-db/database.vala"
		_g_free0 (dirname);
#line 134 "../src/librygel-db/database.vala"
		return result;
#line 427 "database.c"
	} else {
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 136 "../src/librygel-db/database.vala"
		rygel_database_database_set_flavor (self, RYGEL_DATABASE_FLAVOR_FOREIGN);
#line 138 "../src/librygel-db/database.vala"
		_tmp17_ = self->priv->_name;
#line 138 "../src/librygel-db/database.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 138 "../src/librygel-db/database.vala"
		result = _tmp18_;
#line 138 "../src/librygel-db/database.vala"
		return result;
#line 441 "database.c"
	}
}

/**
     * Connect to a SQLite database file
     *
     * @param name Name of the database which is used to create the file-name
     * @param flavor Specifies the flavor of the database
     * @param flags How to open the database
     */
RygelDatabaseDatabase*
rygel_database_database_construct (GType object_type,
                                   const gchar* name,
                                   RygelDatabaseFlavor flavor,
                                   RygelDatabaseFlags flags,
                                   GError** error)
{
	RygelDatabaseDatabase * self = NULL;
	GError* _inner_error0_ = NULL;
#line 151 "../src/librygel-db/database.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 155 "../src/librygel-db/database.vala"
	self = (RygelDatabaseDatabase*) g_object_new (object_type, "name", name, "flavor", flavor, "flags", flags, NULL);
#line 156 "../src/librygel-db/database.vala"
	g_initable_init ((GInitable*) self, NULL, &_inner_error0_);
#line 156 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/librygel-db/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 156 "../src/librygel-db/database.vala"
		_g_object_unref0 (self);
#line 156 "../src/librygel-db/database.vala"
		return NULL;
#line 475 "database.c"
	}
#line 151 "../src/librygel-db/database.vala"
	return self;
#line 479 "database.c"
}

RygelDatabaseDatabase*
rygel_database_database_new (const gchar* name,
                             RygelDatabaseFlavor flavor,
                             RygelDatabaseFlags flags,
                             GError** error)
{
#line 151 "../src/librygel-db/database.vala"
	return rygel_database_database_construct (RYGEL_DATABASE_TYPE_DATABASE, name, flavor, flags, error);
#line 490 "database.c"
}

/**
     * Initialize database. Implemented for Initiable interface.
     *
     * @param cancellable a cancellable (unused)
     * @return true on success, false on error
     * @throws DatabaseError if anything goes wrong
     */
static void
_rygel_database_database_utf8_contains_sqlite_user_func_callback (sqlite3_context* context,
                                                                  gint values_length1,
                                                                  sqlite3_value** values)
{
#line 191 "../src/librygel-db/database.vala"
	rygel_database_database_utf8_contains (context, values, values_length1);
#line 507 "database.c"
}

static gint
_rygel_database_database_utf8_collate_sqlite_compare_callback (gpointer self,
                                                               gint alen,
                                                               void* a,
                                                               gint blen,
                                                               void* b)
{
	gint result;
	result = rygel_database_database_utf8_collate (alen, a, blen, b);
#line 199 "../src/librygel-db/database.vala"
	return result;
#line 521 "database.c"
}

static void
_rygel_database_database_on_trace_sqlite_trace_callback (gpointer self,
                                                         const gchar* message)
{
#line 206 "../src/librygel-db/database.vala"
	rygel_database_database_on_trace ((RygelDatabaseDatabase*) self, message);
#line 530 "database.c"
}

static gboolean
rygel_database_database_real_init (GInitable* base,
                                   GCancellable* cancellable,
                                   GError** error)
{
	RygelDatabaseDatabase * self;
	gchar* path = NULL;
	gchar* _tmp0_;
	RygelDatabaseFlags _tmp1_;
	sqlite3* _tmp6_;
	const gchar* _tmp14_;
	RygelDatabaseFlags _tmp15_;
	RygelDatabaseFlags _tmp17_;
	sqlite3* _tmp20_;
	sqlite3* _tmp21_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 166 "../src/librygel-db/database.vala"
	self = (RygelDatabaseDatabase*) base;
#line 167 "../src/librygel-db/database.vala"
	_tmp0_ = rygel_database_database_build_path (self);
#line 167 "../src/librygel-db/database.vala"
	path = _tmp0_;
#line 168 "../src/librygel-db/database.vala"
	_tmp1_ = self->priv->_flags;
#line 168 "../src/librygel-db/database.vala"
	if (_tmp1_ == RYGEL_DATABASE_FLAGS_READ_ONLY) {
#line 560 "database.c"
		const gchar* _tmp2_;
		sqlite3* _tmp3_ = NULL;
#line 169 "../src/librygel-db/database.vala"
		_tmp2_ = path;
#line 169 "../src/librygel-db/database.vala"
		sqlite3_open_v2 (_tmp2_, &_tmp3_, SQLITE_OPEN_READONLY, NULL);
#line 169 "../src/librygel-db/database.vala"
		_sqlite3_close0 (self->priv->db);
#line 169 "../src/librygel-db/database.vala"
		self->priv->db = _tmp3_;
#line 571 "database.c"
	} else {
		const gchar* _tmp4_;
		sqlite3* _tmp5_ = NULL;
#line 171 "../src/librygel-db/database.vala"
		_tmp4_ = path;
#line 171 "../src/librygel-db/database.vala"
		sqlite3_open (_tmp4_, &_tmp5_);
#line 171 "../src/librygel-db/database.vala"
		_sqlite3_close0 (self->priv->db);
#line 171 "../src/librygel-db/database.vala"
		self->priv->db = _tmp5_;
#line 583 "database.c"
	}
#line 174 "../src/librygel-db/database.vala"
	_tmp6_ = self->priv->db;
#line 174 "../src/librygel-db/database.vala"
	if (sqlite3_errcode (_tmp6_) != SQLITE_OK) {
#line 589 "database.c"
		gchar* msg = NULL;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		sqlite3* _tmp10_;
		const gchar* _tmp11_;
		GError* _tmp12_;
		gboolean _tmp13_ = FALSE;
#line 175 "../src/librygel-db/database.vala"
		_tmp7_ = g_strdup (_ ("Error while opening SQLite database %s: %s"));
#line 175 "../src/librygel-db/database.vala"
		msg = _tmp7_;
#line 176 "../src/librygel-db/database.vala"
		_tmp8_ = msg;
#line 176 "../src/librygel-db/database.vala"
		_tmp9_ = path;
#line 176 "../src/librygel-db/database.vala"
		_tmp10_ = self->priv->db;
#line 176 "../src/librygel-db/database.vala"
		_tmp11_ = sqlite3_errmsg (_tmp10_);
#line 176 "../src/librygel-db/database.vala"
		_tmp12_ = g_error_new (RYGEL_DATABASE_DATABASE_ERROR, RYGEL_DATABASE_DATABASE_ERROR_OPEN, _tmp8_, _tmp9_, _tmp11_);
#line 176 "../src/librygel-db/database.vala"
		_inner_error0_ = _tmp12_;
#line 176 "../src/librygel-db/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 176 "../src/librygel-db/database.vala"
		_g_free0 (msg);
#line 176 "../src/librygel-db/database.vala"
		_g_free0 (path);
#line 176 "../src/librygel-db/database.vala"
		return _tmp13_;
#line 622 "database.c"
	}
#line 179 "../src/librygel-db/database.vala"
	_tmp14_ = path;
#line 179 "../src/librygel-db/database.vala"
	g_debug ("database.vala:179: Using database file %s", _tmp14_);
#line 181 "../src/librygel-db/database.vala"
	_tmp15_ = self->priv->_flags;
#line 181 "../src/librygel-db/database.vala"
	if (_tmp15_ != RYGEL_DATABASE_FLAGS_READ_ONLY) {
#line 182 "../src/librygel-db/database.vala"
		rygel_database_database_exec (self, "PRAGMA synchronous = OFF", NULL, (gint) 0, &_inner_error0_);
#line 182 "../src/librygel-db/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 636 "database.c"
			gboolean _tmp16_ = FALSE;
#line 182 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 182 "../src/librygel-db/database.vala"
			_g_free0 (path);
#line 182 "../src/librygel-db/database.vala"
			return _tmp16_;
#line 644 "database.c"
		}
	}
#line 185 "../src/librygel-db/database.vala"
	_tmp17_ = self->priv->_flags;
#line 185 "../src/librygel-db/database.vala"
	if ((_tmp17_ & RYGEL_DATABASE_FLAGS_SHARED) == RYGEL_DATABASE_FLAGS_SHARED) {
#line 186 "../src/librygel-db/database.vala"
		rygel_database_database_exec (self, "PRAGMA journal_mode = WAL", NULL, (gint) 0, &_inner_error0_);
#line 186 "../src/librygel-db/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 655 "database.c"
			gboolean _tmp18_ = FALSE;
#line 186 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 186 "../src/librygel-db/database.vala"
			_g_free0 (path);
#line 186 "../src/librygel-db/database.vala"
			return _tmp18_;
#line 663 "database.c"
		}
	} else {
#line 188 "../src/librygel-db/database.vala"
		rygel_database_database_exec (self, "PRAGMA temp_store = MEMORY", NULL, (gint) 0, &_inner_error0_);
#line 188 "../src/librygel-db/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 670 "database.c"
			gboolean _tmp19_ = FALSE;
#line 188 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 188 "../src/librygel-db/database.vala"
			_g_free0 (path);
#line 188 "../src/librygel-db/database.vala"
			return _tmp19_;
#line 678 "database.c"
		}
	}
#line 191 "../src/librygel-db/database.vala"
	_tmp20_ = self->priv->db;
#line 191 "../src/librygel-db/database.vala"
	sqlite3_create_function (_tmp20_, "contains", 2, SQLITE_UTF8, NULL, _rygel_database_database_utf8_contains_sqlite_user_func_callback, NULL, NULL);
#line 199 "../src/librygel-db/database.vala"
	_tmp21_ = self->priv->db;
#line 199 "../src/librygel-db/database.vala"
	sqlite3_create_collation (_tmp21_, "CASEFOLD", SQLITE_UTF8, NULL, (int (*)(void *, int,  const void *, int,  const void *)) _rygel_database_database_utf8_collate_sqlite_compare_callback);
#line 689 "database.c"
	{
		RygelMetaConfig* config = NULL;
		RygelMetaConfig* _tmp22_;
		gboolean _tmp23_ = FALSE;
		RygelMetaConfig* _tmp24_;
#line 204 "../src/librygel-db/database.vala"
		_tmp22_ = rygel_meta_config_get_default ();
#line 204 "../src/librygel-db/database.vala"
		config = _tmp22_;
#line 205 "../src/librygel-db/database.vala"
		_tmp24_ = config;
#line 205 "../src/librygel-db/database.vala"
		_tmp23_ = rygel_configuration_get_bool ((RygelConfiguration*) _tmp24_, "Database", "Debug", &_inner_error0_);
#line 205 "../src/librygel-db/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "../src/librygel-db/database.vala"
			_g_object_unref0 (config);
#line 707 "database.c"
			goto __catch0_g_error;
		}
#line 205 "../src/librygel-db/database.vala"
		if (_tmp23_) {
#line 712 "database.c"
			sqlite3* _tmp25_;
#line 206 "../src/librygel-db/database.vala"
			_tmp25_ = self->priv->db;
#line 206 "../src/librygel-db/database.vala"
			sqlite3_trace (_tmp25_, _rygel_database_database_on_trace_sqlite_trace_callback, self);
#line 718 "database.c"
		}
#line 203 "../src/librygel-db/database.vala"
		_g_object_unref0 (config);
#line 722 "database.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 203 "../src/librygel-db/database.vala"
		g_clear_error (&_inner_error0_);
#line 209 "../src/librygel-db/database.vala"
		g_debug ("database.vala:209: Not setting up SQL tracing");
#line 731 "database.c"
	}
	__finally0:
#line 203 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 736 "database.c"
		gboolean _tmp26_ = FALSE;
#line 203 "../src/librygel-db/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 203 "../src/librygel-db/database.vala"
		_g_free0 (path);
#line 203 "../src/librygel-db/database.vala"
		return _tmp26_;
#line 744 "database.c"
	}
#line 212 "../src/librygel-db/database.vala"
	result = TRUE;
#line 212 "../src/librygel-db/database.vala"
	_g_free0 (path);
#line 212 "../src/librygel-db/database.vala"
	return result;
#line 752 "database.c"
}

static void
rygel_database_database_on_trace (RygelDatabaseDatabase* self,
                                  const gchar* message)
{
#line 215 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/librygel-db/database.vala"
	g_return_if_fail (message != NULL);
#line 216 "../src/librygel-db/database.vala"
	g_debug ("database.vala:216: SQLITE: %s", message);
#line 765 "database.c"
}

/**
     * SQL query function.
     *
     * Use for all queries that return a result set.
     *
     * @param sql The SQL query to run.
     * @param arguments Values to bind in the SQL query or null.
     * @throws DatabaseError if the underlying SQLite operation fails.
     */
RygelDatabaseCursor*
rygel_database_database_exec_cursor (RygelDatabaseDatabase* self,
                                     const gchar* sql,
                                     GValue* arguments,
                                     gint arguments_length1,
                                     GError** error)
{
	RygelDatabaseCursor* _tmp0_ = NULL;
	sqlite3* _tmp1_;
	RygelDatabaseCursor* _tmp2_;
	RygelDatabaseCursor* _tmp3_;
	GError* _inner_error0_ = NULL;
	RygelDatabaseCursor* result;
#line 228 "../src/librygel-db/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../src/librygel-db/database.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 231 "../src/librygel-db/database.vala"
	_tmp1_ = self->priv->db;
#line 231 "../src/librygel-db/database.vala"
	_tmp2_ = rygel_database_cursor_new (_tmp1_, sql, arguments, arguments_length1, &_inner_error0_);
#line 231 "../src/librygel-db/database.vala"
	_tmp0_ = _tmp2_;
#line 231 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 231 "../src/librygel-db/database.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 231 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 231 "../src/librygel-db/database.vala"
			return NULL;
#line 808 "database.c"
		} else {
#line 231 "../src/librygel-db/database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 231 "../src/librygel-db/database.vala"
			g_clear_error (&_inner_error0_);
#line 231 "../src/librygel-db/database.vala"
			return NULL;
#line 816 "database.c"
		}
	}
#line 231 "../src/librygel-db/database.vala"
	_tmp3_ = _tmp0_;
#line 231 "../src/librygel-db/database.vala"
	_tmp0_ = NULL;
#line 231 "../src/librygel-db/database.vala"
	result = _tmp3_;
#line 231 "../src/librygel-db/database.vala"
	_g_object_unref0 (_tmp0_);
#line 231 "../src/librygel-db/database.vala"
	return result;
#line 829 "database.c"
}

/**
     * Simple SQL query execution function.
     *
     * Use for all queries that don't return anything.
     *
     * @param sql The SQL query to run.
     * @param arguments Values to bind in the SQL query or null.
     * @throws DatabaseError if the underlying SQLite operation fails.
     */
static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar** errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 867 "database.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 878 "database.c"
	} else {
#line 40 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 40 "sqlite3.vapi"
		_vala_errmsg = NULL;
#line 884 "database.c"
	}
#line 42 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 42 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 43 "sqlite3.vapi"
	result = ec;
#line 43 "sqlite3.vapi"
	if (errmsg) {
#line 43 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 896 "database.c"
	} else {
#line 43 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 900 "database.c"
	}
#line 43 "sqlite3.vapi"
	return result;
#line 904 "database.c"
}

void
rygel_database_database_exec (RygelDatabaseDatabase* self,
                              const gchar* sql,
                              GValue* arguments,
                              gint arguments_length1,
                              GError** error)
{
	RygelDatabaseCursor* cursor = NULL;
	RygelDatabaseCursor* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 243 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/librygel-db/database.vala"
	g_return_if_fail (sql != NULL);
#line 246 "../src/librygel-db/database.vala"
	if (arguments == NULL) {
#line 923 "database.c"
		sqlite3* _tmp0_;
		sqlite3* _tmp1_;
#line 247 "../src/librygel-db/database.vala"
		_tmp0_ = self->priv->db;
#line 247 "../src/librygel-db/database.vala"
		_sqlite3_exec (_tmp0_, sql, NULL, NULL, NULL);
#line 248 "../src/librygel-db/database.vala"
		_tmp1_ = self->priv->db;
#line 248 "../src/librygel-db/database.vala"
		if (sqlite3_errcode (_tmp1_) != SQLITE_OK) {
#line 934 "database.c"
			gchar* msg = NULL;
			gchar* _tmp2_;
			const gchar* _tmp3_;
			sqlite3* _tmp4_;
			const gchar* _tmp5_;
			GError* _tmp6_;
#line 249 "../src/librygel-db/database.vala"
			_tmp2_ = g_strdup ("Failed to run query %s: %s");
#line 249 "../src/librygel-db/database.vala"
			msg = _tmp2_;
#line 250 "../src/librygel-db/database.vala"
			_tmp3_ = msg;
#line 250 "../src/librygel-db/database.vala"
			_tmp4_ = self->priv->db;
#line 250 "../src/librygel-db/database.vala"
			_tmp5_ = sqlite3_errmsg (_tmp4_);
#line 250 "../src/librygel-db/database.vala"
			_tmp6_ = g_error_new (RYGEL_DATABASE_DATABASE_ERROR, RYGEL_DATABASE_DATABASE_ERROR_SQLITE_ERROR, _tmp3_, sql, _tmp5_);
#line 250 "../src/librygel-db/database.vala"
			_inner_error0_ = _tmp6_;
#line 250 "../src/librygel-db/database.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 250 "../src/librygel-db/database.vala"
				g_propagate_error (error, _inner_error0_);
#line 250 "../src/librygel-db/database.vala"
				_g_free0 (msg);
#line 250 "../src/librygel-db/database.vala"
				return;
#line 963 "database.c"
			} else {
#line 250 "../src/librygel-db/database.vala"
				_g_free0 (msg);
#line 250 "../src/librygel-db/database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 250 "../src/librygel-db/database.vala"
				g_clear_error (&_inner_error0_);
#line 250 "../src/librygel-db/database.vala"
				return;
#line 973 "database.c"
			}
#line 248 "../src/librygel-db/database.vala"
			_g_free0 (msg);
#line 977 "database.c"
		}
#line 253 "../src/librygel-db/database.vala"
		return;
#line 981 "database.c"
	}
#line 256 "../src/librygel-db/database.vala"
	_tmp7_ = rygel_database_database_exec_cursor (self, sql, arguments, (gint) arguments_length1, &_inner_error0_);
#line 256 "../src/librygel-db/database.vala"
	cursor = _tmp7_;
#line 256 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 256 "../src/librygel-db/database.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 256 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 256 "../src/librygel-db/database.vala"
			return;
#line 995 "database.c"
		} else {
#line 256 "../src/librygel-db/database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 256 "../src/librygel-db/database.vala"
			g_clear_error (&_inner_error0_);
#line 256 "../src/librygel-db/database.vala"
			return;
#line 1003 "database.c"
		}
	}
#line 257 "../src/librygel-db/database.vala"
	while (TRUE) {
#line 1008 "database.c"
		gboolean _tmp8_ = FALSE;
		RygelDatabaseCursor* _tmp9_;
		RygelDatabaseCursor* _tmp10_;
#line 257 "../src/librygel-db/database.vala"
		_tmp9_ = cursor;
#line 257 "../src/librygel-db/database.vala"
		_tmp8_ = rygel_database_cursor_has_next (_tmp9_, &_inner_error0_);
#line 257 "../src/librygel-db/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 257 "../src/librygel-db/database.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 257 "../src/librygel-db/database.vala"
				g_propagate_error (error, _inner_error0_);
#line 257 "../src/librygel-db/database.vala"
				_g_object_unref0 (cursor);
#line 257 "../src/librygel-db/database.vala"
				return;
#line 1026 "database.c"
			} else {
#line 257 "../src/librygel-db/database.vala"
				_g_object_unref0 (cursor);
#line 257 "../src/librygel-db/database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 257 "../src/librygel-db/database.vala"
				g_clear_error (&_inner_error0_);
#line 257 "../src/librygel-db/database.vala"
				return;
#line 1036 "database.c"
			}
		}
#line 257 "../src/librygel-db/database.vala"
		if (!_tmp8_) {
#line 257 "../src/librygel-db/database.vala"
			break;
#line 1043 "database.c"
		}
#line 258 "../src/librygel-db/database.vala"
		_tmp10_ = cursor;
#line 258 "../src/librygel-db/database.vala"
		rygel_database_cursor_next (_tmp10_, &_inner_error0_);
#line 258 "../src/librygel-db/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "../src/librygel-db/database.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 258 "../src/librygel-db/database.vala"
				g_propagate_error (error, _inner_error0_);
#line 258 "../src/librygel-db/database.vala"
				_g_object_unref0 (cursor);
#line 258 "../src/librygel-db/database.vala"
				return;
#line 1059 "database.c"
			} else {
#line 258 "../src/librygel-db/database.vala"
				_g_object_unref0 (cursor);
#line 258 "../src/librygel-db/database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "../src/librygel-db/database.vala"
				g_clear_error (&_inner_error0_);
#line 258 "../src/librygel-db/database.vala"
				return;
#line 1069 "database.c"
			}
		}
	}
#line 243 "../src/librygel-db/database.vala"
	_g_object_unref0 (cursor);
#line 1075 "database.c"
}

/**
     * Execute a SQL query that returns a single number.
     *
     * @param sql The SQL query to run.
     * @param args Values to bind in the SQL query or null.
     * @return The contents of the first row's column as an int.
     * @throws DatabaseError if the underlying SQLite operation fails.
     */
gint
rygel_database_database_query_value (RygelDatabaseDatabase* self,
                                     const gchar* sql,
                                     GValue* args,
                                     gint args_length1,
                                     GError** error)
{
	RygelDatabaseCursor* cursor = NULL;
	RygelDatabaseCursor* _tmp0_;
	sqlite3_stmt* statement = NULL;
	RygelDatabaseCursor* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp7_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 270 "../src/librygel-db/database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 270 "../src/librygel-db/database.vala"
	g_return_val_if_fail (sql != NULL, 0);
#line 273 "../src/librygel-db/database.vala"
	_tmp0_ = rygel_database_database_exec_cursor (self, sql, args, (gint) args_length1, &_inner_error0_);
#line 273 "../src/librygel-db/database.vala"
	cursor = _tmp0_;
#line 273 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../src/librygel-db/database.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1113 "database.c"
			gint _tmp1_ = -1;
#line 273 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 273 "../src/librygel-db/database.vala"
			return _tmp1_;
#line 1119 "database.c"
		} else {
			gint _tmp2_ = -1;
#line 273 "../src/librygel-db/database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "../src/librygel-db/database.vala"
			g_clear_error (&_inner_error0_);
#line 273 "../src/librygel-db/database.vala"
			return _tmp2_;
#line 1128 "database.c"
		}
	}
#line 274 "../src/librygel-db/database.vala"
	_tmp3_ = cursor;
#line 274 "../src/librygel-db/database.vala"
	_tmp4_ = rygel_database_cursor_next (_tmp3_, &_inner_error0_);
#line 274 "../src/librygel-db/database.vala"
	statement = _tmp4_;
#line 274 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 274 "../src/librygel-db/database.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1141 "database.c"
			gint _tmp5_ = -1;
#line 274 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 274 "../src/librygel-db/database.vala"
			_g_object_unref0 (cursor);
#line 274 "../src/librygel-db/database.vala"
			return _tmp5_;
#line 1149 "database.c"
		} else {
			gint _tmp6_ = -1;
#line 274 "../src/librygel-db/database.vala"
			_g_object_unref0 (cursor);
#line 274 "../src/librygel-db/database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 274 "../src/librygel-db/database.vala"
			g_clear_error (&_inner_error0_);
#line 274 "../src/librygel-db/database.vala"
			return _tmp6_;
#line 1160 "database.c"
		}
	}
#line 275 "../src/librygel-db/database.vala"
	_tmp7_ = statement;
#line 275 "../src/librygel-db/database.vala"
	result = sqlite3_column_int (_tmp7_, 0);
#line 275 "../src/librygel-db/database.vala"
	_g_object_unref0 (cursor);
#line 275 "../src/librygel-db/database.vala"
	return result;
#line 1171 "database.c"
}

/**
     * Analyze triggers of database
     */
void
rygel_database_database_analyze (RygelDatabaseDatabase* self)
{
	sqlite3* _tmp0_;
#line 281 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/librygel-db/database.vala"
	_tmp0_ = self->priv->db;
#line 282 "../src/librygel-db/database.vala"
	_sqlite3_exec (_tmp0_, "ANALYZE", NULL, NULL, NULL);
#line 1187 "database.c"
}

/**
     * Start a transaction
     */
void
rygel_database_database_begin (RygelDatabaseDatabase* self,
                               GError** error)
{
	GError* _inner_error0_ = NULL;
#line 288 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/librygel-db/database.vala"
	rygel_database_database_exec (self, "BEGIN", NULL, (gint) 0, &_inner_error0_);
#line 289 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 289 "../src/librygel-db/database.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 289 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 289 "../src/librygel-db/database.vala"
			return;
#line 1210 "database.c"
		} else {
#line 289 "../src/librygel-db/database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 289 "../src/librygel-db/database.vala"
			g_clear_error (&_inner_error0_);
#line 289 "../src/librygel-db/database.vala"
			return;
#line 1218 "database.c"
		}
	}
}

/**
     * Commit a transaction
     */
void
rygel_database_database_commit (RygelDatabaseDatabase* self,
                                GError** error)
{
	GError* _inner_error0_ = NULL;
#line 295 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/librygel-db/database.vala"
	rygel_database_database_exec (self, "COMMIT", NULL, (gint) 0, &_inner_error0_);
#line 296 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 296 "../src/librygel-db/database.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 296 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 296 "../src/librygel-db/database.vala"
			return;
#line 1243 "database.c"
		} else {
#line 296 "../src/librygel-db/database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 296 "../src/librygel-db/database.vala"
			g_clear_error (&_inner_error0_);
#line 296 "../src/librygel-db/database.vala"
			return;
#line 1251 "database.c"
		}
	}
}

/**
     * Rollback a transaction
     */
void
rygel_database_database_rollback (RygelDatabaseDatabase* self)
{
	GError* _inner_error0_ = NULL;
#line 302 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 1265 "database.c"
	{
#line 304 "../src/librygel-db/database.vala"
		rygel_database_database_exec (self, "ROLLBACK", NULL, (gint) 0, &_inner_error0_);
#line 304 "../src/librygel-db/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 304 "../src/librygel-db/database.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1273 "database.c"
				goto __catch0_rygel_database_database_error;
			}
#line 304 "../src/librygel-db/database.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 304 "../src/librygel-db/database.vala"
			g_clear_error (&_inner_error0_);
#line 304 "../src/librygel-db/database.vala"
			return;
#line 1282 "database.c"
		}
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 303 "../src/librygel-db/database.vala"
		_error_ = _inner_error0_;
#line 303 "../src/librygel-db/database.vala"
		_inner_error0_ = NULL;
#line 306 "../src/librygel-db/database.vala"
		_tmp0_ = _error_;
#line 306 "../src/librygel-db/database.vala"
		_tmp1_ = _tmp0_->message;
#line 306 "../src/librygel-db/database.vala"
		g_critical (_ ("Failed to roll back transaction: %s"), _tmp1_);
#line 303 "../src/librygel-db/database.vala"
		_g_error_free0 (_error_);
#line 1303 "database.c"
	}
	__finally0:
#line 303 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 303 "../src/librygel-db/database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 303 "../src/librygel-db/database.vala"
		g_clear_error (&_inner_error0_);
#line 303 "../src/librygel-db/database.vala"
		return;
#line 1314 "database.c"
	}
}

/**
     * Check for an empty SQLite database.
     * @return true if the file is an empty SQLite database, false otherwise
     * @throws DatabaseError if the SQLite meta table does not exist which
     * usually indicates that the file is not a databsae
     */
gboolean
rygel_database_database_is_empty (RygelDatabaseDatabase* self,
                                  GError** error)
{
	gint _tmp0_ = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 317 "../src/librygel-db/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 318 "../src/librygel-db/database.vala"
	_tmp0_ = rygel_database_database_query_value (self, "SELECT count(type) FROM " "sqlite_master WHERE rowid = 1", NULL, (gint) 0, &_inner_error0_);
#line 318 "../src/librygel-db/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "../src/librygel-db/database.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1339 "database.c"
			gboolean _tmp1_ = FALSE;
#line 318 "../src/librygel-db/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 318 "../src/librygel-db/database.vala"
			return _tmp1_;
#line 1345 "database.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 318 "../src/librygel-db/database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 318 "../src/librygel-db/database.vala"
			g_clear_error (&_inner_error0_);
#line 318 "../src/librygel-db/database.vala"
			return _tmp2_;
#line 1354 "database.c"
		}
	}
#line 318 "../src/librygel-db/database.vala"
	result = _tmp0_ == 0;
#line 318 "../src/librygel-db/database.vala"
	return result;
#line 1361 "database.c"
}

static const gchar*
rygel_database_database_get_name (RygelDatabaseDatabase* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 74 "../src/librygel-db/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/librygel-db/database.vala"
	_tmp0_ = self->priv->_name;
#line 74 "../src/librygel-db/database.vala"
	result = _tmp0_;
#line 74 "../src/librygel-db/database.vala"
	return result;
#line 1377 "database.c"
}

void
rygel_database_database_set_name (RygelDatabaseDatabase* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 74 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/librygel-db/database.vala"
	old_value = rygel_database_database_get_name (self);
#line 74 "../src/librygel-db/database.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1391 "database.c"
		gchar* _tmp0_;
#line 74 "../src/librygel-db/database.vala"
		_tmp0_ = g_strdup (value);
#line 74 "../src/librygel-db/database.vala"
		_g_free0 (self->priv->_name);
#line 74 "../src/librygel-db/database.vala"
		self->priv->_name = _tmp0_;
#line 74 "../src/librygel-db/database.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_database_database_properties[RYGEL_DATABASE_DATABASE_NAME_PROPERTY]);
#line 1401 "database.c"
	}
}

static RygelDatabaseFlavor
rygel_database_database_get_flavor (RygelDatabaseDatabase* self)
{
	RygelDatabaseFlavor result;
#line 75 "../src/librygel-db/database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 75 "../src/librygel-db/database.vala"
	result = self->priv->_flavor;
#line 75 "../src/librygel-db/database.vala"
	return result;
#line 1415 "database.c"
}

void
rygel_database_database_set_flavor (RygelDatabaseDatabase* self,
                                    RygelDatabaseFlavor value)
{
	RygelDatabaseFlavor old_value;
#line 75 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/librygel-db/database.vala"
	old_value = rygel_database_database_get_flavor (self);
#line 75 "../src/librygel-db/database.vala"
	if (old_value != value) {
#line 75 "../src/librygel-db/database.vala"
		self->priv->_flavor = value;
#line 75 "../src/librygel-db/database.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_database_database_properties[RYGEL_DATABASE_DATABASE_FLAVOR_PROPERTY]);
#line 1433 "database.c"
	}
}

static RygelDatabaseFlags
rygel_database_database_get_flags (RygelDatabaseDatabase* self)
{
	RygelDatabaseFlags result;
#line 77 "../src/librygel-db/database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../src/librygel-db/database.vala"
	result = self->priv->_flags;
#line 77 "../src/librygel-db/database.vala"
	return result;
#line 1447 "database.c"
}

void
rygel_database_database_set_flags (RygelDatabaseDatabase* self,
                                   RygelDatabaseFlags value)
{
	RygelDatabaseFlags old_value;
#line 78 "../src/librygel-db/database.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/librygel-db/database.vala"
	old_value = rygel_database_database_get_flags (self);
#line 78 "../src/librygel-db/database.vala"
	if (old_value != value) {
#line 78 "../src/librygel-db/database.vala"
		self->priv->_flags = value;
#line 78 "../src/librygel-db/database.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_database_database_properties[RYGEL_DATABASE_DATABASE_FLAGS_PROPERTY]);
#line 1465 "database.c"
	}
}

static void
rygel_database_database_class_init (RygelDatabaseDatabaseClass * klass,
                                    gpointer klass_data)
{
#line 72 "../src/librygel-db/database.vala"
	rygel_database_database_parent_class = g_type_class_peek_parent (klass);
#line 72 "../src/librygel-db/database.vala"
	g_type_class_adjust_private_offset (klass, &RygelDatabaseDatabase_private_offset);
#line 72 "../src/librygel-db/database.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_database_database_get_property;
#line 72 "../src/librygel-db/database.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_database_database_set_property;
#line 72 "../src/librygel-db/database.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_database_database_finalize;
#line 72 "../src/librygel-db/database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DATABASE_DATABASE_NAME_PROPERTY, rygel_database_database_properties[RYGEL_DATABASE_DATABASE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 72 "../src/librygel-db/database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DATABASE_DATABASE_FLAVOR_PROPERTY, rygel_database_database_properties[RYGEL_DATABASE_DATABASE_FLAVOR_PROPERTY] = g_param_spec_enum ("flavor", "flavor", "flavor", RYGEL_DATABASE_TYPE_FLAVOR, RYGEL_DATABASE_FLAVOR_CACHE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 72 "../src/librygel-db/database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DATABASE_DATABASE_FLAGS_PROPERTY, rygel_database_database_properties[RYGEL_DATABASE_DATABASE_FLAGS_PROPERTY] = g_param_spec_enum ("flags", "flags", "flags", RYGEL_DATABASE_TYPE_FLAGS, RYGEL_DATABASE_FLAGS_READ_WRITE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1489 "database.c"
}

static void
rygel_database_database_g_initable_interface_init (GInitableIface * iface,
                                                   gpointer iface_data)
{
#line 72 "../src/librygel-db/database.vala"
	rygel_database_database_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 72 "../src/librygel-db/database.vala"
	iface->init = (gboolean (*) (GInitable*, GCancellable*, GError**)) rygel_database_database_real_init;
#line 1500 "database.c"
}

static void
rygel_database_database_instance_init (RygelDatabaseDatabase * self,
                                       gpointer klass)
{
#line 72 "../src/librygel-db/database.vala"
	self->priv = rygel_database_database_get_instance_private (self);
#line 75 "../src/librygel-db/database.vala"
	self->priv->_flavor = RYGEL_DATABASE_FLAVOR_CACHE;
#line 76 "../src/librygel-db/database.vala"
	self->priv->_flags = RYGEL_DATABASE_FLAGS_READ_WRITE;
#line 1513 "database.c"
}

static void
rygel_database_database_finalize (GObject * obj)
{
	RygelDatabaseDatabase * self;
#line 72 "../src/librygel-db/database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_DATABASE_TYPE_DATABASE, RygelDatabaseDatabase);
#line 74 "../src/librygel-db/database.vala"
	_g_free0 (self->priv->_name);
#line 142 "../src/librygel-db/database.vala"
	_sqlite3_close0 (self->priv->db);
#line 72 "../src/librygel-db/database.vala"
	G_OBJECT_CLASS (rygel_database_database_parent_class)->finalize (obj);
#line 1528 "database.c"
}

/**
 * This class is a thin wrapper around SQLite's database object.
 *
 * It adds statement preparation based on GValue and a cancellable exec
 * function.
 */
 G_GNUC_NO_INLINE static GType
rygel_database_database_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelDatabaseDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_database_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelDatabaseDatabase), 0, (GInstanceInitFunc) rygel_database_database_instance_init, NULL };
	static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) rygel_database_database_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType rygel_database_database_type_id;
	rygel_database_database_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelDatabaseDatabase", &g_define_type_info, 0);
	g_type_add_interface_static (rygel_database_database_type_id, g_initable_get_type (), &g_initable_info);
	RygelDatabaseDatabase_private_offset = g_type_add_instance_private (rygel_database_database_type_id, sizeof (RygelDatabaseDatabasePrivate));
	return rygel_database_database_type_id;
}

GType
rygel_database_database_get_type (void)
{
	static volatile gsize rygel_database_database_type_id__once = 0;
	if (g_once_init_enter (&rygel_database_database_type_id__once)) {
		GType rygel_database_database_type_id;
		rygel_database_database_type_id = rygel_database_database_get_type_once ();
		g_once_init_leave (&rygel_database_database_type_id__once, rygel_database_database_type_id);
	}
	return rygel_database_database_type_id__once;
}

static void
_vala_rygel_database_database_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	RygelDatabaseDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_DATABASE_TYPE_DATABASE, RygelDatabaseDatabase);
#line 72 "../src/librygel-db/database.vala"
	switch (property_id) {
#line 72 "../src/librygel-db/database.vala"
		case RYGEL_DATABASE_DATABASE_NAME_PROPERTY:
#line 72 "../src/librygel-db/database.vala"
		g_value_set_string (value, rygel_database_database_get_name (self));
#line 72 "../src/librygel-db/database.vala"
		break;
#line 72 "../src/librygel-db/database.vala"
		case RYGEL_DATABASE_DATABASE_FLAVOR_PROPERTY:
#line 72 "../src/librygel-db/database.vala"
		g_value_set_enum (value, rygel_database_database_get_flavor (self));
#line 72 "../src/librygel-db/database.vala"
		break;
#line 72 "../src/librygel-db/database.vala"
		case RYGEL_DATABASE_DATABASE_FLAGS_PROPERTY:
#line 72 "../src/librygel-db/database.vala"
		g_value_set_enum (value, rygel_database_database_get_flags (self));
#line 72 "../src/librygel-db/database.vala"
		break;
#line 1589 "database.c"
		default:
#line 72 "../src/librygel-db/database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 72 "../src/librygel-db/database.vala"
		break;
#line 1595 "database.c"
	}
}

static void
_vala_rygel_database_database_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	RygelDatabaseDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_DATABASE_TYPE_DATABASE, RygelDatabaseDatabase);
#line 72 "../src/librygel-db/database.vala"
	switch (property_id) {
#line 72 "../src/librygel-db/database.vala"
		case RYGEL_DATABASE_DATABASE_NAME_PROPERTY:
#line 72 "../src/librygel-db/database.vala"
		rygel_database_database_set_name (self, g_value_get_string (value));
#line 72 "../src/librygel-db/database.vala"
		break;
#line 72 "../src/librygel-db/database.vala"
		case RYGEL_DATABASE_DATABASE_FLAVOR_PROPERTY:
#line 72 "../src/librygel-db/database.vala"
		rygel_database_database_set_flavor (self, g_value_get_enum (value));
#line 72 "../src/librygel-db/database.vala"
		break;
#line 72 "../src/librygel-db/database.vala"
		case RYGEL_DATABASE_DATABASE_FLAGS_PROPERTY:
#line 72 "../src/librygel-db/database.vala"
		rygel_database_database_set_flags (self, g_value_get_enum (value));
#line 72 "../src/librygel-db/database.vala"
		break;
#line 1627 "database.c"
		default:
#line 72 "../src/librygel-db/database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 72 "../src/librygel-db/database.vala"
		break;
#line 1633 "database.c"
	}
}

