/* sql-operator.c generated by valac 0.56.18, the Vala compiler
 * generated from sql-operator.vala, do not modify */

/*
 * Copyright (C) 2010 Jens Georg <mail@jensge.org>.
 *
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-db.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <libgupnp-av/gupnp-av.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_DATABASE_SQL_OPERATOR_0_PROPERTY,
	RYGEL_DATABASE_SQL_OPERATOR_NUM_PROPERTIES
};
static GParamSpec* rygel_database_sql_operator_properties[RYGEL_DATABASE_SQL_OPERATOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer rygel_database_sql_operator_parent_class = NULL;

static gchar* rygel_database_sql_operator_real_to_string (RygelDatabaseSqlOperator* self);
static void rygel_database_sql_operator_finalize (GObject * obj);
static GType rygel_database_sql_operator_get_type_once (void);

RygelDatabaseSqlOperator*
rygel_database_sql_operator_construct (GType object_type,
                                       const gchar* name,
                                       const gchar* arg,
                                       const gchar* collate)
{
	RygelDatabaseSqlOperator * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 30 "../src/librygel-db/sql-operator.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 30 "../src/librygel-db/sql-operator.vala"
	g_return_val_if_fail (arg != NULL, NULL);
#line 30 "../src/librygel-db/sql-operator.vala"
	g_return_val_if_fail (collate != NULL, NULL);
#line 30 "../src/librygel-db/sql-operator.vala"
	self = (RygelDatabaseSqlOperator*) g_object_new (object_type, NULL);
#line 33 "../src/librygel-db/sql-operator.vala"
	_tmp0_ = g_strdup (name);
#line 33 "../src/librygel-db/sql-operator.vala"
	_g_free0 (self->name);
#line 33 "../src/librygel-db/sql-operator.vala"
	self->name = _tmp0_;
#line 34 "../src/librygel-db/sql-operator.vala"
	_tmp1_ = g_strdup (arg);
#line 34 "../src/librygel-db/sql-operator.vala"
	_g_free0 (self->arg);
#line 34 "../src/librygel-db/sql-operator.vala"
	self->arg = _tmp1_;
#line 35 "../src/librygel-db/sql-operator.vala"
	_tmp2_ = g_strdup (collate);
#line 35 "../src/librygel-db/sql-operator.vala"
	_g_free0 (self->collate);
#line 35 "../src/librygel-db/sql-operator.vala"
	self->collate = _tmp2_;
#line 30 "../src/librygel-db/sql-operator.vala"
	return self;
#line 94 "sql-operator.c"
}

RygelDatabaseSqlOperator*
rygel_database_sql_operator_new (const gchar* name,
                                 const gchar* arg,
                                 const gchar* collate)
{
#line 30 "../src/librygel-db/sql-operator.vala"
	return rygel_database_sql_operator_construct (RYGEL_DATABASE_TYPE_SQL_OPERATOR, name, arg, collate);
#line 104 "sql-operator.c"
}

RygelDatabaseSqlOperator*
rygel_database_sql_operator_construct_from_search_criteria_op (GType object_type,
                                                               GUPnPSearchCriteriaOp op,
                                                               const gchar* arg,
                                                               const gchar* collate)
{
	RygelDatabaseSqlOperator * self = NULL;
	gchar* sql = NULL;
	const gchar* _tmp6_;
#line 38 "../src/librygel-db/sql-operator.vala"
	g_return_val_if_fail (arg != NULL, NULL);
#line 38 "../src/librygel-db/sql-operator.vala"
	g_return_val_if_fail (collate != NULL, NULL);
#line 41 "../src/librygel-db/sql-operator.vala"
	sql = NULL;
#line 42 "../src/librygel-db/sql-operator.vala"
	switch (op) {
#line 42 "../src/librygel-db/sql-operator.vala"
		case GUPNP_SEARCH_CRITERIA_OP_EQ:
#line 126 "sql-operator.c"
		{
			gchar* _tmp0_;
#line 44 "../src/librygel-db/sql-operator.vala"
			_tmp0_ = g_strdup ("=");
#line 44 "../src/librygel-db/sql-operator.vala"
			_g_free0 (sql);
#line 44 "../src/librygel-db/sql-operator.vala"
			sql = _tmp0_;
#line 45 "../src/librygel-db/sql-operator.vala"
			break;
#line 137 "sql-operator.c"
		}
#line 42 "../src/librygel-db/sql-operator.vala"
		case GUPNP_SEARCH_CRITERIA_OP_NEQ:
#line 141 "sql-operator.c"
		{
			gchar* _tmp1_;
#line 47 "../src/librygel-db/sql-operator.vala"
			_tmp1_ = g_strdup ("!=");
#line 47 "../src/librygel-db/sql-operator.vala"
			_g_free0 (sql);
#line 47 "../src/librygel-db/sql-operator.vala"
			sql = _tmp1_;
#line 48 "../src/librygel-db/sql-operator.vala"
			break;
#line 152 "sql-operator.c"
		}
#line 42 "../src/librygel-db/sql-operator.vala"
		case GUPNP_SEARCH_CRITERIA_OP_LESS:
#line 156 "sql-operator.c"
		{
			gchar* _tmp2_;
#line 50 "../src/librygel-db/sql-operator.vala"
			_tmp2_ = g_strdup ("<");
#line 50 "../src/librygel-db/sql-operator.vala"
			_g_free0 (sql);
#line 50 "../src/librygel-db/sql-operator.vala"
			sql = _tmp2_;
#line 51 "../src/librygel-db/sql-operator.vala"
			break;
#line 167 "sql-operator.c"
		}
#line 42 "../src/librygel-db/sql-operator.vala"
		case GUPNP_SEARCH_CRITERIA_OP_LEQ:
#line 171 "sql-operator.c"
		{
			gchar* _tmp3_;
#line 53 "../src/librygel-db/sql-operator.vala"
			_tmp3_ = g_strdup ("<=");
#line 53 "../src/librygel-db/sql-operator.vala"
			_g_free0 (sql);
#line 53 "../src/librygel-db/sql-operator.vala"
			sql = _tmp3_;
#line 54 "../src/librygel-db/sql-operator.vala"
			break;
#line 182 "sql-operator.c"
		}
#line 42 "../src/librygel-db/sql-operator.vala"
		case GUPNP_SEARCH_CRITERIA_OP_GREATER:
#line 186 "sql-operator.c"
		{
			gchar* _tmp4_;
#line 56 "../src/librygel-db/sql-operator.vala"
			_tmp4_ = g_strdup (">");
#line 56 "../src/librygel-db/sql-operator.vala"
			_g_free0 (sql);
#line 56 "../src/librygel-db/sql-operator.vala"
			sql = _tmp4_;
#line 57 "../src/librygel-db/sql-operator.vala"
			break;
#line 197 "sql-operator.c"
		}
#line 42 "../src/librygel-db/sql-operator.vala"
		case GUPNP_SEARCH_CRITERIA_OP_GEQ:
#line 201 "sql-operator.c"
		{
			gchar* _tmp5_;
#line 59 "../src/librygel-db/sql-operator.vala"
			_tmp5_ = g_strdup (">=");
#line 59 "../src/librygel-db/sql-operator.vala"
			_g_free0 (sql);
#line 59 "../src/librygel-db/sql-operator.vala"
			sql = _tmp5_;
#line 60 "../src/librygel-db/sql-operator.vala"
			break;
#line 212 "sql-operator.c"
		}
		default:
		{
#line 62 "../src/librygel-db/sql-operator.vala"
			g_assert_not_reached ();
#line 218 "sql-operator.c"
		}
	}
#line 65 "../src/librygel-db/sql-operator.vala"
	_tmp6_ = sql;
#line 65 "../src/librygel-db/sql-operator.vala"
	self = (RygelDatabaseSqlOperator*) rygel_database_sql_operator_construct (object_type, _tmp6_, arg, collate);
#line 38 "../src/librygel-db/sql-operator.vala"
	_g_free0 (sql);
#line 38 "../src/librygel-db/sql-operator.vala"
	return self;
#line 229 "sql-operator.c"
}

RygelDatabaseSqlOperator*
rygel_database_sql_operator_new_from_search_criteria_op (GUPnPSearchCriteriaOp op,
                                                         const gchar* arg,
                                                         const gchar* collate)
{
#line 38 "../src/librygel-db/sql-operator.vala"
	return rygel_database_sql_operator_construct_from_search_criteria_op (RYGEL_DATABASE_TYPE_SQL_OPERATOR, op, arg, collate);
#line 239 "sql-operator.c"
}

static gchar*
rygel_database_sql_operator_real_to_string (RygelDatabaseSqlOperator* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 69 "../src/librygel-db/sql-operator.vala"
	_tmp0_ = self->arg;
#line 69 "../src/librygel-db/sql-operator.vala"
	_tmp1_ = self->name;
#line 69 "../src/librygel-db/sql-operator.vala"
	_tmp2_ = self->collate;
#line 69 "../src/librygel-db/sql-operator.vala"
	_tmp3_ = g_strdup_printf ("(%s %s ? %s)", _tmp0_, _tmp1_, _tmp2_);
#line 69 "../src/librygel-db/sql-operator.vala"
	result = _tmp3_;
#line 69 "../src/librygel-db/sql-operator.vala"
	return result;
#line 262 "sql-operator.c"
}

gchar*
rygel_database_sql_operator_to_string (RygelDatabaseSqlOperator* self)
{
	RygelDatabaseSqlOperatorClass* _klass_;
#line 68 "../src/librygel-db/sql-operator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/librygel-db/sql-operator.vala"
	_klass_ = RYGEL_DATABASE_SQL_OPERATOR_GET_CLASS (self);
#line 68 "../src/librygel-db/sql-operator.vala"
	if (_klass_->to_string) {
#line 68 "../src/librygel-db/sql-operator.vala"
		return _klass_->to_string (self);
#line 277 "sql-operator.c"
	}
#line 68 "../src/librygel-db/sql-operator.vala"
	return NULL;
#line 281 "sql-operator.c"
}

static void
rygel_database_sql_operator_class_init (RygelDatabaseSqlOperatorClass * klass,
                                        gpointer klass_data)
{
#line 25 "../src/librygel-db/sql-operator.vala"
	rygel_database_sql_operator_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/librygel-db/sql-operator.vala"
	((RygelDatabaseSqlOperatorClass *) klass)->to_string = (gchar* (*) (RygelDatabaseSqlOperator*)) rygel_database_sql_operator_real_to_string;
#line 25 "../src/librygel-db/sql-operator.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_database_sql_operator_finalize;
#line 294 "sql-operator.c"
}

static void
rygel_database_sql_operator_instance_init (RygelDatabaseSqlOperator * self,
                                           gpointer klass)
{
}

static void
rygel_database_sql_operator_finalize (GObject * obj)
{
	RygelDatabaseSqlOperator * self;
#line 25 "../src/librygel-db/sql-operator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_DATABASE_TYPE_SQL_OPERATOR, RygelDatabaseSqlOperator);
#line 26 "../src/librygel-db/sql-operator.vala"
	_g_free0 (self->name);
#line 27 "../src/librygel-db/sql-operator.vala"
	_g_free0 (self->arg);
#line 28 "../src/librygel-db/sql-operator.vala"
	_g_free0 (self->collate);
#line 25 "../src/librygel-db/sql-operator.vala"
	G_OBJECT_CLASS (rygel_database_sql_operator_parent_class)->finalize (obj);
#line 317 "sql-operator.c"
}

 G_GNUC_NO_INLINE static GType
rygel_database_sql_operator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelDatabaseSqlOperatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_database_sql_operator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelDatabaseSqlOperator), 0, (GInstanceInitFunc) rygel_database_sql_operator_instance_init, NULL };
	GType rygel_database_sql_operator_type_id;
	rygel_database_sql_operator_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelDatabaseSqlOperator", &g_define_type_info, 0);
	return rygel_database_sql_operator_type_id;
}

GType
rygel_database_sql_operator_get_type (void)
{
	static volatile gsize rygel_database_sql_operator_type_id__once = 0;
	if (g_once_init_enter (&rygel_database_sql_operator_type_id__once)) {
		GType rygel_database_sql_operator_type_id;
		rygel_database_sql_operator_type_id = rygel_database_sql_operator_get_type_once ();
		g_once_init_leave (&rygel_database_sql_operator_type_id__once, rygel_database_sql_operator_type_id);
	}
	return rygel_database_sql_operator_type_id__once;
}

