/* rygel-rendering-control.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-rendering-control.vala, do not modify */

/*
 * Copyright (C) 2008 OpenedHand Ltd.
 * Copyright (C) 2009 Nokia Corporation.
 *
 * Author: Jorn Baayen <jorn@openedhand.com>
 *         Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <libgupnp/gupnp.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "rygel-renderer.h"
#include <float.h>
#include <math.h>
#include <errno.h>
#include <glib/gi18n-lib.h>

#define RYGEL_RENDERING_CONTROL_UPNP_ID "urn:upnp-org:serviceId:RenderingControl"
#define RYGEL_RENDERING_CONTROL_UPNP_TYPE "urn:schemas-upnp-org:service:RenderingControl:2"
#define RYGEL_RENDERING_CONTROL_DESCRIPTION_PATH "xml/RenderingControl2.xml"
#define RYGEL_RENDERING_CONTROL_LAST_CHANGE_NS "urn:schemas-upnp-org:metadata-1-0/RCS/"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_RENDERING_CONTROL (rygel_rendering_control_get_type ())
#define RYGEL_RENDERING_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_RENDERING_CONTROL, RygelRenderingControl))
#define RYGEL_RENDERING_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_RENDERING_CONTROL, RygelRenderingControlClass))
#define RYGEL_IS_RENDERING_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_RENDERING_CONTROL))
#define RYGEL_IS_RENDERING_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_RENDERING_CONTROL))
#define RYGEL_RENDERING_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_RENDERING_CONTROL, RygelRenderingControlClass))

typedef struct _RygelRenderingControl RygelRenderingControl;
typedef struct _RygelRenderingControlClass RygelRenderingControlClass;
typedef struct _RygelRenderingControlPrivate RygelRenderingControlPrivate;

#define RYGEL_TYPE_CHANGE_LOG (rygel_change_log_get_type ())
#define RYGEL_CHANGE_LOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CHANGE_LOG, RygelChangeLog))
#define RYGEL_CHANGE_LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CHANGE_LOG, RygelChangeLogClass))
#define RYGEL_IS_CHANGE_LOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CHANGE_LOG))
#define RYGEL_IS_CHANGE_LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CHANGE_LOG))
#define RYGEL_CHANGE_LOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CHANGE_LOG, RygelChangeLogClass))

typedef struct _RygelChangeLog RygelChangeLog;
typedef struct _RygelChangeLogClass RygelChangeLogClass;
enum  {
	RYGEL_RENDERING_CONTROL_0_PROPERTY,
	RYGEL_RENDERING_CONTROL_MUTE_PROPERTY,
	RYGEL_RENDERING_CONTROL_VOLUME_PROPERTY,
	RYGEL_RENDERING_CONTROL_NUM_PROPERTIES
};
static GParamSpec* rygel_rendering_control_properties[RYGEL_RENDERING_CONTROL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _RygelRenderingControl {
	GUPnPService parent_instance;
	RygelRenderingControlPrivate * priv;
};

struct _RygelRenderingControlClass {
	GUPnPServiceClass parent_class;
};

struct _RygelRenderingControlPrivate {
	gboolean _mute;
	guint _volume;
	gchar* preset_name_list;
	RygelChangeLog* changelog;
	RygelMediaPlayer* player;
};

static gint RygelRenderingControl_private_offset;
static gpointer rygel_rendering_control_parent_class = NULL;

VALA_EXTERN GType rygel_rendering_control_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_change_log_get_type (void) G_GNUC_CONST ;
static void rygel_rendering_control_real_constructed (GObject* base);
VALA_EXTERN RygelChangeLog* rygel_change_log_new (GUPnPService* service,
                                      const gchar* service_ns);
VALA_EXTERN RygelChangeLog* rygel_change_log_construct (GType object_type,
                                            GUPnPService* service,
                                            const gchar* service_ns);
static RygelMediaPlayer* rygel_rendering_control_get_player (RygelRenderingControl* self);
static void rygel_rendering_control_query_last_change_cb (RygelRenderingControl* self,
                                                   GUPnPService* service,
                                                   const gchar* variable,
                                                   GValue* value);
static void _rygel_rendering_control_query_last_change_cb_gupnp_service_query_variable (GUPnPService* _sender,
                                                                                 const gchar* variable,
                                                                                 GValue* value,
                                                                                 gpointer self);
static void rygel_rendering_control_list_presets_cb (RygelRenderingControl* self,
                                              GUPnPService* service,
                                              GUPnPServiceAction* action);
static void _rygel_rendering_control_list_presets_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                            GUPnPServiceAction* action,
                                                                            gpointer self);
static void rygel_rendering_control_select_preset_cb (RygelRenderingControl* self,
                                               GUPnPService* service,
                                               GUPnPServiceAction* action);
static void _rygel_rendering_control_select_preset_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                             GUPnPServiceAction* action,
                                                                             gpointer self);
static void rygel_rendering_control_get_mute_cb (RygelRenderingControl* self,
                                          GUPnPService* service,
                                          GUPnPServiceAction* action);
static void _rygel_rendering_control_get_mute_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                        GUPnPServiceAction* action,
                                                                        gpointer self);
static void rygel_rendering_control_set_mute_cb (RygelRenderingControl* self,
                                          GUPnPService* service,
                                          GUPnPServiceAction* action);
static void _rygel_rendering_control_set_mute_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                        GUPnPServiceAction* action,
                                                                        gpointer self);
static void rygel_rendering_control_get_volume_cb (RygelRenderingControl* self,
                                            GUPnPService* service,
                                            GUPnPServiceAction* action);
static void _rygel_rendering_control_get_volume_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                          GUPnPServiceAction* action,
                                                                          gpointer self);
static void rygel_rendering_control_set_volume_cb (RygelRenderingControl* self,
                                            GUPnPService* service,
                                            GUPnPServiceAction* action);
static void _rygel_rendering_control_set_volume_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                          GUPnPServiceAction* action,
                                                                          gpointer self);
static void rygel_rendering_control_notify_volume_cb (RygelRenderingControl* self,
                                               GObject* player,
                                               GParamSpec* p);
static void _rygel_rendering_control_notify_volume_cb_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
VALA_EXTERN guint rygel_volume_to_percentage (gdouble volume);
VALA_EXTERN gboolean rygel_rendering_control_get_mute (RygelRenderingControl* self);
VALA_EXTERN void rygel_change_log_log_with_channel (RygelChangeLog* self,
                                        const gchar* variable,
                                        const gchar* value,
                                        const gchar* channel);
VALA_EXTERN guint rygel_rendering_control_get_volume (RygelRenderingControl* self);
VALA_EXTERN gchar* rygel_change_log_finish (RygelChangeLog* self);
static gboolean rygel_rendering_control_check_instance_id (RygelRenderingControl* self,
                                                    GUPnPServiceAction* action);
static gboolean rygel_rendering_control_check_channel (RygelRenderingControl* self,
                                                GUPnPServiceAction* action);
VALA_EXTERN void rygel_rendering_control_set_mute (RygelRenderingControl* self,
                                       gboolean value);
VALA_EXTERN void rygel_rendering_control_set_volume (RygelRenderingControl* self,
                                         guint value);
VALA_EXTERN RygelRenderingControl* rygel_rendering_control_new (void);
VALA_EXTERN RygelRenderingControl* rygel_rendering_control_construct (GType object_type);
VALA_EXTERN gdouble rygel_volume_from_percentage (guint percentage);
static void rygel_rendering_control_finalize (GObject * obj);
static GType rygel_rendering_control_get_type_once (void);
static void _vala_rygel_rendering_control_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_rygel_rendering_control_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
rygel_rendering_control_get_instance_private (RygelRenderingControl* self)
{
	return G_STRUCT_MEMBER_P (self, RygelRenderingControl_private_offset);
}

static void
_rygel_rendering_control_query_last_change_cb_gupnp_service_query_variable (GUPnPService* _sender,
                                                                            const gchar* variable,
                                                                            GValue* value,
                                                                            gpointer self)
{
#line 86 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_query_last_change_cb ((RygelRenderingControl*) self, _sender, variable, value);
#line 205 "rygel-rendering-control.c"
}

static void
_rygel_rendering_control_list_presets_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                       GUPnPServiceAction* action,
                                                                       gpointer self)
{
#line 88 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_list_presets_cb ((RygelRenderingControl*) self, _sender, action);
#line 215 "rygel-rendering-control.c"
}

static void
_rygel_rendering_control_select_preset_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                        GUPnPServiceAction* action,
                                                                        gpointer self)
{
#line 89 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_select_preset_cb ((RygelRenderingControl*) self, _sender, action);
#line 225 "rygel-rendering-control.c"
}

static void
_rygel_rendering_control_get_mute_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                   GUPnPServiceAction* action,
                                                                   gpointer self)
{
#line 90 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_get_mute_cb ((RygelRenderingControl*) self, _sender, action);
#line 235 "rygel-rendering-control.c"
}

static void
_rygel_rendering_control_set_mute_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                   GUPnPServiceAction* action,
                                                                   gpointer self)
{
#line 91 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_set_mute_cb ((RygelRenderingControl*) self, _sender, action);
#line 245 "rygel-rendering-control.c"
}

static void
_rygel_rendering_control_get_volume_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                     GUPnPServiceAction* action,
                                                                     gpointer self)
{
#line 92 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_get_volume_cb ((RygelRenderingControl*) self, _sender, action);
#line 255 "rygel-rendering-control.c"
}

static void
_rygel_rendering_control_set_volume_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                     GUPnPServiceAction* action,
                                                                     gpointer self)
{
#line 93 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_set_volume_cb ((RygelRenderingControl*) self, _sender, action);
#line 265 "rygel-rendering-control.c"
}

static void
_rygel_rendering_control_notify_volume_cb_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 95 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_notify_volume_cb ((RygelRenderingControl*) self, _sender, pspec);
#line 275 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_real_constructed (GObject* base)
{
	RygelRenderingControl * self;
	RygelChangeLog* _tmp0_;
	RygelMediaPlayer* _tmp1_;
	RygelMediaPlayer* _tmp2_;
	RygelMediaPlayer* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	RygelMediaPlayer* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
#line 80 "../src/librygel-renderer/rygel-rendering-control.vala"
	self = (RygelRenderingControl*) base;
#line 81 "../src/librygel-renderer/rygel-rendering-control.vala"
	G_OBJECT_CLASS (rygel_rendering_control_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gupnp_service_get_type (), GUPnPService));
#line 83 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp0_ = rygel_change_log_new ((GUPnPService*) self, RYGEL_RENDERING_CONTROL_LAST_CHANGE_NS);
#line 83 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_object_unref0 (self->priv->changelog);
#line 83 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->changelog = _tmp0_;
#line 84 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = rygel_rendering_control_get_player (self);
#line 84 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_object_unref0 (self->priv->player);
#line 84 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->player = _tmp1_;
#line 86 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::LastChange", (GCallback) _rygel_rendering_control_query_last_change_cb_gupnp_service_query_variable, self, 0);
#line 88 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::ListPresets", (GCallback) _rygel_rendering_control_list_presets_cb_gupnp_service_action_invoked, self, 0);
#line 89 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::SelectPreset", (GCallback) _rygel_rendering_control_select_preset_cb_gupnp_service_action_invoked, self, 0);
#line 90 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetMute", (GCallback) _rygel_rendering_control_get_mute_cb_gupnp_service_action_invoked, self, 0);
#line 91 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::SetMute", (GCallback) _rygel_rendering_control_set_mute_cb_gupnp_service_action_invoked, self, 0);
#line 92 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetVolume", (GCallback) _rygel_rendering_control_get_volume_cb_gupnp_service_action_invoked, self, 0);
#line 93 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::SetVolume", (GCallback) _rygel_rendering_control_set_volume_cb_gupnp_service_action_invoked, self, 0);
#line 95 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp2_ = self->priv->player;
#line 95 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::volume", (GCallback) _rygel_rendering_control_notify_volume_cb_g_object_notify, self, 0);
#line 97 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp3_ = self->priv->player;
#line 97 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp4_ = rygel_media_player_get_volume (_tmp3_);
#line 97 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp5_ = _tmp4_;
#line 97 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->_mute = _tmp5_ == ((gdouble) 0);
#line 98 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp6_ = self->priv->player;
#line 98 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp7_ = rygel_media_player_get_volume (_tmp6_);
#line 98 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp8_ = _tmp7_;
#line 98 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->_volume = rygel_volume_to_percentage (_tmp8_);
#line 341 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_query_last_change_cb (RygelRenderingControl* self,
                                              GUPnPService* service,
                                              const gchar* variable,
                                              GValue* value)
{
	RygelChangeLog* log = NULL;
	RygelChangeLog* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_;
	RygelChangeLog* _tmp4_;
	RygelChangeLog* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RygelChangeLog* _tmp10_;
	const gchar* _tmp11_;
	RygelChangeLog* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
#line 101 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (service != NULL);
#line 101 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (variable != NULL);
#line 101 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (value != NULL);
#line 105 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp0_ = rygel_change_log_new (NULL, RYGEL_RENDERING_CONTROL_LAST_CHANGE_NS);
#line 105 "../src/librygel-renderer/rygel-rendering-control.vala"
	log = _tmp0_;
#line 107 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp2_ = rygel_rendering_control_get_mute (self);
#line 107 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp3_ = _tmp2_;
#line 107 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (_tmp3_) {
#line 107 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp1_ = "1";
#line 386 "rygel-rendering-control.c"
	} else {
#line 107 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp1_ = "0";
#line 390 "rygel-rendering-control.c"
	}
#line 107 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp4_ = log;
#line 107 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_change_log_log_with_channel (_tmp4_, "Mute", _tmp1_, "Master");
#line 108 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp5_ = log;
#line 108 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp6_ = rygel_rendering_control_get_volume (self);
#line 108 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp7_ = _tmp6_;
#line 108 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp8_ = g_strdup_printf ("%u", _tmp7_);
#line 108 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp9_ = _tmp8_;
#line 108 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_change_log_log_with_channel (_tmp5_, "Volume", _tmp9_, "Master");
#line 108 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (_tmp9_);
#line 109 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp10_ = log;
#line 109 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp11_ = self->priv->preset_name_list;
#line 109 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_change_log_log_with_channel (_tmp10_, "PresetNameList", _tmp11_, "Master");
#line 113 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_value_init (value, G_TYPE_STRING);
#line 114 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp12_ = log;
#line 114 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp13_ = rygel_change_log_finish (_tmp12_);
#line 114 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp14_ = _tmp13_;
#line 114 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_value_set_string (value, _tmp14_);
#line 114 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (_tmp14_);
#line 101 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_object_unref0 (log);
#line 430 "rygel-rendering-control.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	return self ? g_object_ref (self) : NULL;
#line 438 "rygel-rendering-control.c"
}

static RygelMediaPlayer*
rygel_rendering_control_get_player (RygelRenderingControl* self)
{
	RygelMediaRendererPlugin* plugin = NULL;
	GUPnPRootDevice* _tmp0_;
	GUPnPRootDevice* _tmp1_;
	GUPnPRootDevice* _tmp2_;
	GUPnPResourceFactory* _tmp3_;
	GUPnPResourceFactory* _tmp4_;
	RygelMediaRendererPlugin* _tmp5_;
	RygelMediaRendererPlugin* _tmp6_;
	RygelMediaPlayer* _tmp7_;
	RygelMediaPlayer* result;
#line 117 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_object_get ((GUPnPService*) self, "root-device", &_tmp0_, NULL);
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = _tmp0_;
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp2_ = _tmp1_;
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp3_ = gupnp_device_info_get_resource_factory ((GUPnPDeviceInfo*) _tmp2_);
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp4_ = _tmp3_;
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp5_ = _g_object_ref0 (RYGEL_IS_MEDIA_RENDERER_PLUGIN (_tmp4_) ? ((RygelMediaRendererPlugin*) _tmp4_) : NULL);
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp6_ = _tmp5_;
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_object_unref0 (_tmp2_);
#line 118 "../src/librygel-renderer/rygel-rendering-control.vala"
	plugin = _tmp6_;
#line 120 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp7_ = rygel_media_renderer_plugin_get_player (plugin);
#line 120 "../src/librygel-renderer/rygel-rendering-control.vala"
	result = _tmp7_;
#line 120 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_object_unref0 (plugin);
#line 120 "../src/librygel-renderer/rygel-rendering-control.vala"
	return result;
#line 482 "rygel-rendering-control.c"
}

static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar** unparsed,
                 guint _base)
{
	gint64 _vala__result_ = 0LL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 783 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 785 "glib-2.0.vapi"
	errno = 0;
#line 786 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, _base);
#line 786 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 786 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 787 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 787 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 787 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 787 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 518 "rygel-rendering-control.c"
		gboolean _tmp5_ = FALSE;
#line 788 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 789 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 789 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 526 "rygel-rendering-control.c"
		} else {
#line 789 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 530 "rygel-rendering-control.c"
		}
#line 789 "glib-2.0.vapi"
		result = _tmp5_;
#line 789 "glib-2.0.vapi"
		if (_result_) {
#line 789 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 538 "rygel-rendering-control.c"
		}
#line 789 "glib-2.0.vapi"
		if (unparsed) {
#line 789 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 544 "rygel-rendering-control.c"
		}
#line 789 "glib-2.0.vapi"
		return result;
#line 548 "rygel-rendering-control.c"
	} else {
		gchar* _tmp6_;
#line 791 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 791 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 792 "glib-2.0.vapi"
		result = FALSE;
#line 792 "glib-2.0.vapi"
		if (_result_) {
#line 792 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 561 "rygel-rendering-control.c"
		}
#line 792 "glib-2.0.vapi"
		if (unparsed) {
#line 792 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 567 "rygel-rendering-control.c"
		}
#line 792 "glib-2.0.vapi"
		return result;
#line 571 "rygel-rendering-control.c"
	}
}

static gboolean
rygel_rendering_control_check_instance_id (RygelRenderingControl* self,
                                           GUPnPServiceAction* action)
{
	gchar* instance_id_string = NULL;
	gint64 instance_id = 0LL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result;
#line 124 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_val_if_fail (action != NULL, FALSE);
#line 126 "../src/librygel-renderer/rygel-rendering-control.vala"
	instance_id = (gint64) -1;
#line 128 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_get (action, "InstanceID", G_TYPE_STRING, &_tmp0_, NULL);
#line 128 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (instance_id_string);
#line 128 "../src/librygel-renderer/rygel-rendering-control.vala"
	instance_id_string = _tmp0_;
#line 129 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp2_ = instance_id_string;
#line 129 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (_tmp2_ == NULL) {
#line 129 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp1_ = TRUE;
#line 603 "rygel-rendering-control.c"
	} else {
		const gchar* _tmp3_;
		gint64 _tmp4_ = 0LL;
		gboolean _tmp5_;
#line 130 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp3_ = instance_id_string;
#line 130 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp5_ = int64_try_parse (_tmp3_, &_tmp4_, NULL, (guint) 0);
#line 130 "../src/librygel-renderer/rygel-rendering-control.vala"
		instance_id = _tmp4_;
#line 130 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp1_ = !_tmp5_;
#line 616 "rygel-rendering-control.c"
	}
#line 129 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (_tmp1_) {
#line 131 "../src/librygel-renderer/rygel-rendering-control.vala"
		gupnp_service_action_return_error (action, (guint) 402, _ ("Invalid argument"));
#line 133 "../src/librygel-renderer/rygel-rendering-control.vala"
		result = FALSE;
#line 133 "../src/librygel-renderer/rygel-rendering-control.vala"
		_g_free0 (instance_id_string);
#line 133 "../src/librygel-renderer/rygel-rendering-control.vala"
		return result;
#line 628 "rygel-rendering-control.c"
	}
#line 136 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (instance_id != ((gint64) 0)) {
#line 137 "../src/librygel-renderer/rygel-rendering-control.vala"
		gupnp_service_action_return_error (action, (guint) 702, _ ("Invalid InstanceID"));
#line 139 "../src/librygel-renderer/rygel-rendering-control.vala"
		result = FALSE;
#line 139 "../src/librygel-renderer/rygel-rendering-control.vala"
		_g_free0 (instance_id_string);
#line 139 "../src/librygel-renderer/rygel-rendering-control.vala"
		return result;
#line 640 "rygel-rendering-control.c"
	}
#line 142 "../src/librygel-renderer/rygel-rendering-control.vala"
	result = TRUE;
#line 142 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (instance_id_string);
#line 142 "../src/librygel-renderer/rygel-rendering-control.vala"
	return result;
#line 648 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_list_presets_cb (RygelRenderingControl* self,
                                         GUPnPService* service,
                                         GUPnPServiceAction* action)
{
	const gchar* _tmp0_;
#line 145 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (service != NULL);
#line 145 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (action != NULL);
#line 147 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_instance_id (self, action)) {
#line 148 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 667 "rygel-rendering-control.c"
	}
#line 151 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp0_ = self->priv->preset_name_list;
#line 151 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_set (action, "CurrentPresetNameList", G_TYPE_STRING, _tmp0_, NULL);
#line 155 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_return_success (action);
#line 675 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_select_preset_cb (RygelRenderingControl* self,
                                          GUPnPService* service,
                                          GUPnPServiceAction* action)
{
	gchar* preset_name = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 158 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (service != NULL);
#line 158 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (action != NULL);
#line 160 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_instance_id (self, action)) {
#line 161 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 696 "rygel-rendering-control.c"
	}
#line 166 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_get (action, "PresetName", G_TYPE_STRING, &_tmp0_, NULL);
#line 166 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (preset_name);
#line 166 "../src/librygel-renderer/rygel-rendering-control.vala"
	preset_name = _tmp0_;
#line 167 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = preset_name;
#line 167 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 168 "../src/librygel-renderer/rygel-rendering-control.vala"
		gupnp_service_action_return_error (action, (guint) 701, _ ("Invalid Name"));
#line 170 "../src/librygel-renderer/rygel-rendering-control.vala"
		_g_free0 (preset_name);
#line 170 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 714 "rygel-rendering-control.c"
	}
#line 173 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_return_success (action);
#line 158 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (preset_name);
#line 720 "rygel-rendering-control.c"
}

static gboolean
rygel_rendering_control_check_channel (RygelRenderingControl* self,
                                       GUPnPServiceAction* action)
{
	gchar* channel = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gboolean result;
#line 177 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_val_if_fail (action != NULL, FALSE);
#line 180 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_get (action, "Channel", G_TYPE_STRING, &_tmp0_, NULL);
#line 180 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (channel);
#line 180 "../src/librygel-renderer/rygel-rendering-control.vala"
	channel = _tmp0_;
#line 181 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = channel;
#line 181 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (g_strcmp0 (_tmp1_, "Master") != 0) {
#line 182 "../src/librygel-renderer/rygel-rendering-control.vala"
		gupnp_service_action_return_error (action, (guint) 703, _ ("Invalid Channel"));
#line 184 "../src/librygel-renderer/rygel-rendering-control.vala"
		result = FALSE;
#line 184 "../src/librygel-renderer/rygel-rendering-control.vala"
		_g_free0 (channel);
#line 184 "../src/librygel-renderer/rygel-rendering-control.vala"
		return result;
#line 753 "rygel-rendering-control.c"
	}
#line 187 "../src/librygel-renderer/rygel-rendering-control.vala"
	result = TRUE;
#line 187 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (channel);
#line 187 "../src/librygel-renderer/rygel-rendering-control.vala"
	return result;
#line 761 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_get_mute_cb (RygelRenderingControl* self,
                                     GUPnPService* service,
                                     GUPnPServiceAction* action)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 190 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (service != NULL);
#line 190 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (action != NULL);
#line 192 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_instance_id (self, action)) {
#line 193 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 781 "rygel-rendering-control.c"
	}
#line 196 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_channel (self, action)) {
#line 197 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 787 "rygel-rendering-control.c"
	}
#line 200 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp0_ = rygel_rendering_control_get_mute (self);
#line 200 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = _tmp0_;
#line 200 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_set (action, "CurrentMute", G_TYPE_BOOLEAN, _tmp1_, NULL);
#line 202 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_return_success (action);
#line 797 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_set_mute_cb (RygelRenderingControl* self,
                                     GUPnPService* service,
                                     GUPnPServiceAction* action)
{
	gchar* mute_str = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gboolean mute = FALSE;
	gboolean _tmp2_ = FALSE;
#line 205 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (service != NULL);
#line 205 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (action != NULL);
#line 207 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_instance_id (self, action)) {
#line 208 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 820 "rygel-rendering-control.c"
	}
#line 211 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_channel (self, action)) {
#line 212 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 826 "rygel-rendering-control.c"
	}
#line 216 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_get (action, "DesiredMute", G_TYPE_STRING, &_tmp0_, NULL);
#line 216 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (mute_str);
#line 216 "../src/librygel-renderer/rygel-rendering-control.vala"
	mute_str = _tmp0_;
#line 217 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = mute_str;
#line 217 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (g_str_has_prefix (_tmp1_, "-")) {
#line 218 "../src/librygel-renderer/rygel-rendering-control.vala"
		gupnp_service_action_return_error (action, (guint) 501, _ ("Action Failed"));
#line 220 "../src/librygel-renderer/rygel-rendering-control.vala"
		_g_free0 (mute_str);
#line 220 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 844 "rygel-rendering-control.c"
	}
#line 225 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_get (action, "DesiredMute", G_TYPE_BOOLEAN, &_tmp2_, NULL);
#line 225 "../src/librygel-renderer/rygel-rendering-control.vala"
	mute = _tmp2_;
#line 227 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_set_mute (self, mute);
#line 229 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_return_success (action);
#line 205 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (mute_str);
#line 856 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_get_volume_cb (RygelRenderingControl* self,
                                       GUPnPService* service,
                                       GUPnPServiceAction* action)
{
	guint _tmp0_;
	guint _tmp1_;
#line 232 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (service != NULL);
#line 232 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (action != NULL);
#line 234 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_instance_id (self, action)) {
#line 235 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 876 "rygel-rendering-control.c"
	}
#line 238 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_channel (self, action)) {
#line 239 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 882 "rygel-rendering-control.c"
	}
#line 242 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp0_ = rygel_rendering_control_get_volume (self);
#line 242 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = _tmp0_;
#line 242 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_set (action, "CurrentVolume", G_TYPE_UINT, _tmp1_, NULL);
#line 244 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_return_success (action);
#line 892 "rygel-rendering-control.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 911 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_set_volume_cb (RygelRenderingControl* self,
                                       GUPnPService* service,
                                       GUPnPServiceAction* action)
{
	gchar* volume_str = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	guint volume = 0U;
	guint _tmp4_ = 0U;
#line 247 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (service != NULL);
#line 247 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (action != NULL);
#line 249 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_instance_id (self, action)) {
#line 250 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 935 "rygel-rendering-control.c"
	}
#line 253 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!rygel_rendering_control_check_channel (self, action)) {
#line 254 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 941 "rygel-rendering-control.c"
	}
#line 258 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_get (action, "DesiredVolume", G_TYPE_STRING, &_tmp0_, NULL);
#line 258 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (volume_str);
#line 258 "../src/librygel-renderer/rygel-rendering-control.vala"
	volume_str = _tmp0_;
#line 259 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp2_ = volume_str;
#line 259 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (string_contains (_tmp2_, ".")) {
#line 259 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp1_ = TRUE;
#line 955 "rygel-rendering-control.c"
	} else {
		const gchar* _tmp3_;
#line 259 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp3_ = volume_str;
#line 259 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp1_ = string_contains (_tmp3_, ",");
#line 962 "rygel-rendering-control.c"
	}
#line 259 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (_tmp1_) {
#line 260 "../src/librygel-renderer/rygel-rendering-control.vala"
		gupnp_service_action_return_error (action, (guint) 501, _ ("Action Failed"));
#line 262 "../src/librygel-renderer/rygel-rendering-control.vala"
		_g_free0 (volume_str);
#line 262 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 972 "rygel-rendering-control.c"
	}
#line 267 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_get (action, "DesiredVolume", G_TYPE_UINT, &_tmp4_, NULL);
#line 267 "../src/librygel-renderer/rygel-rendering-control.vala"
	volume = _tmp4_;
#line 268 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (volume > ((guint) 100)) {
#line 269 "../src/librygel-renderer/rygel-rendering-control.vala"
		gupnp_service_action_return_error (action, (guint) 501, _ ("Action Failed"));
#line 271 "../src/librygel-renderer/rygel-rendering-control.vala"
		_g_free0 (volume_str);
#line 271 "../src/librygel-renderer/rygel-rendering-control.vala"
		return;
#line 986 "rygel-rendering-control.c"
	}
#line 274 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_set_volume (self, volume);
#line 276 "../src/librygel-renderer/rygel-rendering-control.vala"
	gupnp_service_action_return_success (action);
#line 247 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (volume_str);
#line 994 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_notify_volume_cb (RygelRenderingControl* self,
                                          GObject* player,
                                          GParamSpec* p)
{
	RygelMediaPlayer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gboolean _tmp3_ = FALSE;
	RygelChangeLog* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
#line 279 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (player != NULL);
#line 279 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (p != NULL);
#line 280 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp0_ = self->priv->player;
#line 280 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = rygel_media_player_get_volume (_tmp0_);
#line 280 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp2_ = _tmp1_;
#line 280 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->_volume = rygel_volume_to_percentage (_tmp2_);
#line 282 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (self->priv->_mute) {
#line 1027 "rygel-rendering-control.c"
		RygelMediaPlayer* _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
#line 282 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp4_ = self->priv->player;
#line 282 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp5_ = rygel_media_player_get_volume (_tmp4_);
#line 282 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp6_ = _tmp5_;
#line 282 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp3_ = _tmp6_ > ((gdouble) 0);
#line 1039 "rygel-rendering-control.c"
	} else {
#line 282 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp3_ = FALSE;
#line 1043 "rygel-rendering-control.c"
	}
#line 282 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (_tmp3_) {
#line 1047 "rygel-rendering-control.c"
		RygelChangeLog* _tmp7_;
#line 284 "../src/librygel-renderer/rygel-rendering-control.vala"
		self->priv->_mute = FALSE;
#line 285 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp7_ = self->priv->changelog;
#line 285 "../src/librygel-renderer/rygel-rendering-control.vala"
		rygel_change_log_log_with_channel (_tmp7_, "Mute", "0", "Master");
#line 1055 "rygel-rendering-control.c"
	}
#line 290 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp8_ = self->priv->changelog;
#line 290 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp9_ = rygel_rendering_control_get_volume (self);
#line 290 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp10_ = _tmp9_;
#line 290 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp11_ = g_strdup_printf ("%u", _tmp10_);
#line 290 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp12_ = _tmp11_;
#line 290 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_change_log_log_with_channel (_tmp8_, "Volume", _tmp12_, "Master");
#line 290 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (_tmp12_);
#line 1071 "rygel-rendering-control.c"
}

RygelRenderingControl*
rygel_rendering_control_construct (GType object_type)
{
	RygelRenderingControl * self = NULL;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	self = (RygelRenderingControl*) g_object_new (object_type, NULL);
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	return self;
#line 1082 "rygel-rendering-control.c"
}

RygelRenderingControl*
rygel_rendering_control_new (void)
{
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	return rygel_rendering_control_construct (RYGEL_TYPE_RENDERING_CONTROL);
#line 1090 "rygel-rendering-control.c"
}

gboolean
rygel_rendering_control_get_mute (RygelRenderingControl* self)
{
	gboolean result;
#line 37 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/librygel-renderer/rygel-rendering-control.vala"
	result = self->priv->_mute;
#line 38 "../src/librygel-renderer/rygel-rendering-control.vala"
	return result;
#line 1103 "rygel-rendering-control.c"
}

void
rygel_rendering_control_set_mute (RygelRenderingControl* self,
                                  gboolean value)
{
	const gchar* _tmp4_ = NULL;
	gboolean _tmp5_;
	gboolean _tmp6_;
	RygelChangeLog* _tmp7_;
#line 41 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->_mute = value;
#line 44 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (self->priv->_mute) {
#line 1120 "rygel-rendering-control.c"
		RygelMediaPlayer* _tmp0_;
#line 45 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp0_ = self->priv->player;
#line 45 "../src/librygel-renderer/rygel-rendering-control.vala"
		rygel_media_player_set_volume (_tmp0_, (gdouble) 0);
#line 1126 "rygel-rendering-control.c"
	} else {
		RygelMediaPlayer* _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 47 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp1_ = self->priv->player;
#line 47 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp2_ = rygel_rendering_control_get_volume (self);
#line 47 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp3_ = _tmp2_;
#line 47 "../src/librygel-renderer/rygel-rendering-control.vala"
		rygel_media_player_set_volume (_tmp1_, rygel_volume_from_percentage (_tmp3_));
#line 1139 "rygel-rendering-control.c"
	}
#line 51 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp5_ = rygel_rendering_control_get_mute (self);
#line 51 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp6_ = _tmp5_;
#line 51 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (_tmp6_) {
#line 51 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp4_ = "1";
#line 1149 "rygel-rendering-control.c"
	} else {
#line 51 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp4_ = "0";
#line 1153 "rygel-rendering-control.c"
	}
#line 50 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp7_ = self->priv->changelog;
#line 50 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_change_log_log_with_channel (_tmp7_, "Mute", _tmp4_, "Master");
#line 41 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_rendering_control_properties[RYGEL_RENDERING_CONTROL_MUTE_PROPERTY]);
#line 1161 "rygel-rendering-control.c"
}

guint
rygel_rendering_control_get_volume (RygelRenderingControl* self)
{
	guint result;
#line 58 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 59 "../src/librygel-renderer/rygel-rendering-control.vala"
	result = self->priv->_volume;
#line 59 "../src/librygel-renderer/rygel-rendering-control.vala"
	return result;
#line 1174 "rygel-rendering-control.c"
}

void
rygel_rendering_control_set_volume (RygelRenderingControl* self,
                                    guint value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	RygelChangeLog* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 62 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->_volume = value;
#line 65 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp0_ = rygel_rendering_control_get_mute (self);
#line 65 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/librygel-renderer/rygel-rendering-control.vala"
	if (!_tmp1_) {
#line 1198 "rygel-rendering-control.c"
		RygelMediaPlayer* _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
#line 66 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp2_ = self->priv->player;
#line 66 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp3_ = rygel_rendering_control_get_volume (self);
#line 66 "../src/librygel-renderer/rygel-rendering-control.vala"
		_tmp4_ = _tmp3_;
#line 66 "../src/librygel-renderer/rygel-rendering-control.vala"
		rygel_media_player_set_volume (_tmp2_, rygel_volume_from_percentage (_tmp4_));
#line 1210 "rygel-rendering-control.c"
	}
#line 69 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp5_ = self->priv->changelog;
#line 69 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp6_ = rygel_rendering_control_get_volume (self);
#line 69 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp7_ = _tmp6_;
#line 69 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp8_ = g_strdup_printf ("%u", _tmp7_);
#line 69 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp9_ = _tmp8_;
#line 69 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_change_log_log_with_channel (_tmp5_, "Volume", _tmp9_, "Master");
#line 69 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (_tmp9_);
#line 62 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_rendering_control_properties[RYGEL_RENDERING_CONTROL_VOLUME_PROPERTY]);
#line 1228 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_class_init (RygelRenderingControlClass * klass,
                                    gpointer klass_data)
{
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	rygel_rendering_control_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_type_class_adjust_private_offset (klass, &RygelRenderingControl_private_offset);
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_rendering_control_real_constructed;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_rendering_control_get_property;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_rendering_control_set_property;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_rendering_control_finalize;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_RENDERING_CONTROL_MUTE_PROPERTY, rygel_rendering_control_properties[RYGEL_RENDERING_CONTROL_MUTE_PROPERTY] = g_param_spec_boolean ("mute", "mute", "mute", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_RENDERING_CONTROL_VOLUME_PROPERTY, rygel_rendering_control_properties[RYGEL_RENDERING_CONTROL_VOLUME_PROPERTY] = g_param_spec_uint ("volume", "volume", "volume", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1251 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_instance_init (RygelRenderingControl * self,
                                       gpointer klass)
{
	gchar* _tmp0_;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv = rygel_rendering_control_get_instance_private (self);
#line 35 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->_mute = FALSE;
#line 56 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->_volume = (guint) 0;
#line 75 "../src/librygel-renderer/rygel-rendering-control.vala"
	_tmp0_ = g_strdup ("FactoryDefaults");
#line 75 "../src/librygel-renderer/rygel-rendering-control.vala"
	self->priv->preset_name_list = _tmp0_;
#line 1269 "rygel-rendering-control.c"
}

static void
rygel_rendering_control_finalize (GObject * obj)
{
	RygelRenderingControl * self;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_RENDERING_CONTROL, RygelRenderingControl);
#line 75 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_free0 (self->priv->preset_name_list);
#line 77 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_object_unref0 (self->priv->changelog);
#line 78 "../src/librygel-renderer/rygel-rendering-control.vala"
	_g_object_unref0 (self->priv->player);
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	G_OBJECT_CLASS (rygel_rendering_control_parent_class)->finalize (obj);
#line 1286 "rygel-rendering-control.c"
}

 G_GNUC_NO_INLINE static GType
rygel_rendering_control_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelRenderingControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_rendering_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelRenderingControl), 0, (GInstanceInitFunc) rygel_rendering_control_instance_init, NULL };
	GType rygel_rendering_control_type_id;
	rygel_rendering_control_type_id = g_type_register_static (gupnp_service_get_type (), "RygelRenderingControl", &g_define_type_info, 0);
	RygelRenderingControl_private_offset = g_type_add_instance_private (rygel_rendering_control_type_id, sizeof (RygelRenderingControlPrivate));
	return rygel_rendering_control_type_id;
}

GType
rygel_rendering_control_get_type (void)
{
	static volatile gsize rygel_rendering_control_type_id__once = 0;
	if (g_once_init_enter (&rygel_rendering_control_type_id__once)) {
		GType rygel_rendering_control_type_id;
		rygel_rendering_control_type_id = rygel_rendering_control_get_type_once ();
		g_once_init_leave (&rygel_rendering_control_type_id__once, rygel_rendering_control_type_id);
	}
	return rygel_rendering_control_type_id__once;
}

static void
_vala_rygel_rendering_control_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	RygelRenderingControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_RENDERING_CONTROL, RygelRenderingControl);
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	switch (property_id) {
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		case RYGEL_RENDERING_CONTROL_MUTE_PROPERTY:
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		g_value_set_boolean (value, rygel_rendering_control_get_mute (self));
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		break;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		case RYGEL_RENDERING_CONTROL_VOLUME_PROPERTY:
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		g_value_set_uint (value, rygel_rendering_control_get_volume (self));
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		break;
#line 1333 "rygel-rendering-control.c"
		default:
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		break;
#line 1339 "rygel-rendering-control.c"
	}
}

static void
_vala_rygel_rendering_control_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	RygelRenderingControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_RENDERING_CONTROL, RygelRenderingControl);
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
	switch (property_id) {
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		case RYGEL_RENDERING_CONTROL_MUTE_PROPERTY:
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		rygel_rendering_control_set_mute (self, g_value_get_boolean (value));
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		break;
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		case RYGEL_RENDERING_CONTROL_VOLUME_PROPERTY:
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		rygel_rendering_control_set_volume (self, g_value_get_uint (value));
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		break;
#line 1365 "rygel-rendering-control.c"
		default:
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/librygel-renderer/rygel-rendering-control.vala"
		break;
#line 1371 "rygel-rendering-control.c"
	}
}

