/* rygel-http-byte-seek-request.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-http-byte-seek-request.vala, do not modify */

/*
 * Copyright (C) 2009 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <glib.h>
#include <libsoup/soup.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_HTTP_BYTE_SEEK_REQUEST_0_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_REQUEST_START_BYTE_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_REQUEST_END_BYTE_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_REQUEST_RANGE_LENGTH_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_REQUEST_TOTAL_SIZE_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_REQUEST_NUM_PROPERTIES
};
static GParamSpec* rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define RYGEL_TYPE_CLIENT_HACKS (rygel_client_hacks_get_type ())
#define RYGEL_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacks))
#define RYGEL_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))
#define RYGEL_IS_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_IS_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_CLIENT_HACKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))

typedef struct _RygelClientHacks RygelClientHacks;
typedef struct _RygelClientHacksClass RygelClientHacksClass;

#define RYGEL_TYPE_CLIENT_HACKS_ERROR (rygel_client_hacks_error_get_type ())

struct _RygelHTTPByteSeekRequestPrivate {
	gint64 _start_byte;
	gint64 _end_byte;
	gint64 _range_length;
	gint64 _total_size;
};

typedef enum  {
	RYGEL_CLIENT_HACKS_ERROR_NA
} RygelClientHacksError;
#define RYGEL_CLIENT_HACKS_ERROR rygel_client_hacks_error_quark ()

static gint RygelHTTPByteSeekRequest_private_offset;
static gpointer rygel_http_byte_seek_request_parent_class = NULL;

static void rygel_http_byte_seek_request_set_range_length (RygelHTTPByteSeekRequest* self,
                                                    gint64 value);
VALA_EXTERN GType rygel_client_hacks_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GQuark rygel_client_hacks_error_quark (void);
VALA_EXTERN GType rygel_client_hacks_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelClientHacks* rygel_client_hacks_create (SoupServerMessage* message,
                                             GError** error);
VALA_EXTERN gboolean rygel_client_hacks_force_seek (RygelClientHacks* self);
static void rygel_http_byte_seek_request_finalize (GObject * obj);
static GType rygel_http_byte_seek_request_get_type_once (void);
static void _vala_rygel_http_byte_seek_request_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_rygel_http_byte_seek_request_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rygel_http_byte_seek_request_get_instance_private (RygelHTTPByteSeekRequest* self)
{
	return G_STRUCT_MEMBER_P (self, RygelHTTPByteSeekRequest_private_offset);
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 143 "rygel-http-byte-seek-request.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 152 "rygel-http-byte-seek-request.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 171 "rygel-http-byte-seek-request.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 175 "rygel-http-byte-seek-request.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 181 "rygel-http-byte-seek-request.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 191 "rygel-http-byte-seek-request.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 199 "rygel-http-byte-seek-request.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 203 "rygel-http-byte-seek-request.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 209 "rygel-http-byte-seek-request.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 219 "rygel-http-byte-seek-request.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 238 "rygel-http-byte-seek-request.c"
}

static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar** unparsed,
                 guint _base)
{
	gint64 _vala__result_ = 0LL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 783 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 785 "glib-2.0.vapi"
	errno = 0;
#line 786 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, _base);
#line 786 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 786 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 787 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 787 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 787 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 787 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 274 "rygel-http-byte-seek-request.c"
		gboolean _tmp5_ = FALSE;
#line 788 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 789 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 789 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 282 "rygel-http-byte-seek-request.c"
		} else {
#line 789 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 286 "rygel-http-byte-seek-request.c"
		}
#line 789 "glib-2.0.vapi"
		result = _tmp5_;
#line 789 "glib-2.0.vapi"
		if (_result_) {
#line 789 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 294 "rygel-http-byte-seek-request.c"
		}
#line 789 "glib-2.0.vapi"
		if (unparsed) {
#line 789 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 300 "rygel-http-byte-seek-request.c"
		}
#line 789 "glib-2.0.vapi"
		return result;
#line 304 "rygel-http-byte-seek-request.c"
	} else {
		gchar* _tmp6_;
#line 791 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 791 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 792 "glib-2.0.vapi"
		result = FALSE;
#line 792 "glib-2.0.vapi"
		if (_result_) {
#line 792 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 317 "rygel-http-byte-seek-request.c"
		}
#line 792 "glib-2.0.vapi"
		if (unparsed) {
#line 792 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 323 "rygel-http-byte-seek-request.c"
		}
#line 792 "glib-2.0.vapi"
		return result;
#line 327 "rygel-http-byte-seek-request.c"
	}
}

RygelHTTPByteSeekRequest*
rygel_http_byte_seek_request_construct (GType object_type,
                                        SoupServerMessage* msg,
                                        RygelHTTPGetHandler* handler,
                                        GError** error)
{
	RygelHTTPByteSeekRequest * self = NULL;
	const gchar* range = NULL;
	SoupMessageHeaders* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint64 start_byte = 0LL;
	gint64 end_byte = 0LL;
	gint64 total_size = 0LL;
	const gchar* _tmp4_;
	gchar* parsed_range = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** range_tokens = NULL;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint range_tokens_length1;
	gint _range_tokens_size_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	const gchar* _tmp16_;
	gint64 _tmp17_ = 0LL;
	gboolean _tmp18_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gchar** _tmp27_;
	gint _tmp27__length1;
	const gchar* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 52 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (msg != NULL, NULL);
#line 52 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (handler != NULL, NULL);
#line 56 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	self = (RygelHTTPByteSeekRequest*) rygel_http_seek_request_construct (object_type);
#line 57 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp0_ = soup_server_message_get_request_headers (msg);
#line 57 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp1_ = soup_message_headers_get_one (_tmp0_, "Range");
#line 57 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	range = _tmp1_;
#line 58 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp2_ = range;
#line 58 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (_tmp2_ == NULL) {
#line 381 "rygel-http-byte-seek-request.c"
		GError* _tmp3_;
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp3_ = g_error_new_literal (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, "Range header not present");
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_inner_error0_ = _tmp3_;
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if ((_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) || (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR)) {
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_object_unref0 (self);
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 395 "rygel-http-byte-seek-request.c"
		} else {
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 59 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 403 "rygel-http-byte-seek-request.c"
		}
	}
#line 66 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	total_size = rygel_http_get_handler_get_resource_size (handler);
#line 67 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (total_size < ((gint64) 0)) {
#line 68 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		total_size = RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED;
#line 412 "rygel-http-byte-seek-request.c"
	}
#line 76 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp4_ = range;
#line 76 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (!g_str_has_prefix (_tmp4_, "bytes=")) {
#line 418 "rygel-http-byte-seek-request.c"
		gchar* message = NULL;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GError* _tmp8_;
#line 77 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp5_ = g_strdup ("Invalid Range value (missing 'bytes=' field): '%s'");
#line 77 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		message = _tmp5_;
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp6_ = message;
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp7_ = range;
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp8_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, _tmp6_, _tmp7_);
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_inner_error0_ = _tmp8_;
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if ((_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) || (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR)) {
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (message);
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_object_unref0 (self);
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 446 "rygel-http-byte-seek-request.c"
		} else {
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (message);
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 78 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 456 "rygel-http-byte-seek-request.c"
		}
#line 76 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_g_free0 (message);
#line 460 "rygel-http-byte-seek-request.c"
	}
#line 81 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp9_ = range;
#line 81 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp10_ = string_substring (_tmp9_, (glong) 6, (glong) -1);
#line 81 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	parsed_range = _tmp10_;
#line 82 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (!string_contains (parsed_range, "-")) {
#line 470 "rygel-http-byte-seek-request.c"
		const gchar* _tmp11_;
		GError* _tmp12_;
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp11_ = range;
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp12_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, "Invalid Range request with no '-': '%s'", _tmp11_);
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_inner_error0_ = _tmp12_;
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if ((_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) || (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR)) {
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (parsed_range);
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_object_unref0 (self);
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 489 "rygel-http-byte-seek-request.c"
		} else {
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (parsed_range);
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 83 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 499 "rygel-http-byte-seek-request.c"
		}
	}
#line 87 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp14_ = _tmp13_ = g_strsplit (parsed_range, "-", 2);
#line 87 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	range_tokens = _tmp14_;
#line 87 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	range_tokens_length1 = _vala_array_length (_tmp13_);
#line 87 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_range_tokens_size_ = range_tokens_length1;
#line 89 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp15_ = range_tokens;
#line 89 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp15__length1 = range_tokens_length1;
#line 89 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp16_ = _tmp15_[0];
#line 89 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp18_ = int64_try_parse (_tmp16_, &_tmp17_, NULL, (guint) 10);
#line 89 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	start_byte = _tmp17_;
#line 89 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (!_tmp18_) {
#line 522 "rygel-http-byte-seek-request.c"
		const gchar* _tmp19_;
		GError* _tmp20_;
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp19_ = range;
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp20_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, "Invalid Range start value: '%s'", _tmp19_);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_inner_error0_ = _tmp20_;
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if ((_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) || (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR)) {
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (parsed_range);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_object_unref0 (self);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 543 "rygel-http-byte-seek-request.c"
		} else {
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (parsed_range);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 90 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 555 "rygel-http-byte-seek-request.c"
		}
	}
#line 94 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (total_size != RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED) {
#line 94 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp21_ = start_byte >= total_size;
#line 562 "rygel-http-byte-seek-request.c"
	} else {
#line 94 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp21_ = FALSE;
#line 566 "rygel-http-byte-seek-request.c"
	}
#line 94 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (_tmp21_) {
#line 570 "rygel-http-byte-seek-request.c"
		gchar* message = NULL;
		gchar* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		GError* _tmp25_;
#line 95 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp22_ = g_strdup ("Range start value %lld is larger than content size %lld: '%s'");
#line 95 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		message = _tmp22_;
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp23_ = message;
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp24_ = range;
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp25_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_OUT_OF_RANGE, _tmp23_, start_byte, total_size, _tmp24_);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_inner_error0_ = _tmp25_;
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if ((_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) || (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR)) {
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (message);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (parsed_range);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_object_unref0 (self);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 602 "rygel-http-byte-seek-request.c"
		} else {
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (message);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (parsed_range);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 96 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			return NULL;
#line 616 "rygel-http-byte-seek-request.c"
		}
#line 94 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_g_free0 (message);
#line 620 "rygel-http-byte-seek-request.c"
	}
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp27_ = range_tokens;
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp27__length1 = range_tokens_length1;
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp28_ = _tmp27_[1];
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (_tmp28_ == NULL) {
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp26_ = TRUE;
#line 632 "rygel-http-byte-seek-request.c"
	} else {
		gchar** _tmp29_;
		gint _tmp29__length1;
		const gchar* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp29_ = range_tokens;
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp29__length1 = range_tokens_length1;
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp30_ = _tmp29_[1];
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp31_ = strlen (_tmp30_);
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp32_ = _tmp31_;
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp26_ = _tmp32_ == 0;
#line 651 "rygel-http-byte-seek-request.c"
	}
#line 102 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (_tmp26_) {
#line 103 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if (total_size != RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED) {
#line 104 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			end_byte = total_size - 1;
#line 105 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			rygel_http_byte_seek_request_set_range_length (self, (end_byte - start_byte) + 1);
#line 661 "rygel-http-byte-seek-request.c"
		} else {
#line 107 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			end_byte = RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED;
#line 108 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			rygel_http_byte_seek_request_set_range_length (self, RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED);
#line 667 "rygel-http-byte-seek-request.c"
		}
	} else {
		gchar** _tmp33_;
		gint _tmp33__length1;
		const gchar* _tmp34_;
		gint64 _tmp35_ = 0LL;
		gboolean _tmp36_;
		gboolean _tmp43_ = FALSE;
#line 111 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp33_ = range_tokens;
#line 111 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp33__length1 = range_tokens_length1;
#line 111 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp34_ = _tmp33_[1];
#line 111 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp36_ = int64_try_parse (_tmp34_, &_tmp35_, NULL, (guint) 10);
#line 111 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		end_byte = _tmp35_;
#line 111 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if (!_tmp36_) {
#line 688 "rygel-http-byte-seek-request.c"
			const gchar* _tmp37_;
			GError* _tmp38_;
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_tmp37_ = range;
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_tmp38_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, "Invalid Range end value: '%s'", _tmp37_);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_inner_error0_ = _tmp38_;
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			if ((_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) || (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR)) {
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				g_propagate_error (error, _inner_error0_);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				_g_free0 (parsed_range);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				_g_object_unref0 (self);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				return NULL;
#line 709 "rygel-http-byte-seek-request.c"
			} else {
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				_g_free0 (parsed_range);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				g_clear_error (&_inner_error0_);
#line 112 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				return NULL;
#line 721 "rygel-http-byte-seek-request.c"
			}
		}
#line 115 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if (end_byte < start_byte) {
#line 726 "rygel-http-byte-seek-request.c"
			gchar* message = NULL;
			gchar* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			GError* _tmp42_;
#line 116 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_tmp39_ = g_strdup (_ ("Range end value %lld is smaller than range start value %lld: '%s'"));
#line 116 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			message = _tmp39_;
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_tmp40_ = message;
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_tmp41_ = range;
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_tmp42_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, _tmp40_, end_byte, start_byte, _tmp41_);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_inner_error0_ = _tmp42_;
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			if ((_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) || (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR)) {
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				g_propagate_error (error, _inner_error0_);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				_g_free0 (message);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				_g_free0 (parsed_range);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				_g_object_unref0 (self);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				return NULL;
#line 758 "rygel-http-byte-seek-request.c"
			} else {
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				_g_free0 (message);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				_g_free0 (parsed_range);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				g_clear_error (&_inner_error0_);
#line 117 "../src/librygel-server/rygel-http-byte-seek-request.vala"
				return NULL;
#line 772 "rygel-http-byte-seek-request.c"
			}
#line 115 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_g_free0 (message);
#line 776 "rygel-http-byte-seek-request.c"
		}
#line 122 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if (total_size != RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED) {
#line 122 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_tmp43_ = end_byte >= total_size;
#line 782 "rygel-http-byte-seek-request.c"
		} else {
#line 122 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			_tmp43_ = FALSE;
#line 786 "rygel-http-byte-seek-request.c"
		}
#line 122 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if (_tmp43_) {
#line 123 "../src/librygel-server/rygel-http-byte-seek-request.vala"
			end_byte = total_size - 1;
#line 792 "rygel-http-byte-seek-request.c"
		}
#line 125 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		rygel_http_byte_seek_request_set_range_length (self, (end_byte - start_byte) + 1);
#line 796 "rygel-http-byte-seek-request.c"
	}
#line 127 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	rygel_http_byte_seek_request_set_start_byte (self, start_byte);
#line 128 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	rygel_http_byte_seek_request_set_end_byte (self, end_byte);
#line 129 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	rygel_http_byte_seek_request_set_total_size (self, total_size);
#line 52 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 52 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_g_free0 (parsed_range);
#line 52 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	return self;
#line 810 "rygel-http-byte-seek-request.c"
}

RygelHTTPByteSeekRequest*
rygel_http_byte_seek_request_new (SoupServerMessage* msg,
                                  RygelHTTPGetHandler* handler,
                                  GError** error)
{
#line 52 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	return rygel_http_byte_seek_request_construct (RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST, msg, handler, error);
#line 820 "rygel-http-byte-seek-request.c"
}

gboolean
rygel_http_byte_seek_request_supported (SoupServerMessage* message,
                                        RygelHTTPGetHandler* handler)
{
	gboolean force_seek = FALSE;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 132 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 132 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (handler != NULL, FALSE);
#line 134 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	force_seek = FALSE;
#line 837 "rygel-http-byte-seek-request.c"
	{
		RygelClientHacks* hack = NULL;
		RygelClientHacks* _tmp0_;
#line 137 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp0_ = rygel_client_hacks_create (message, &_inner_error0_);
#line 137 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		hack = _tmp0_;
#line 137 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 847 "rygel-http-byte-seek-request.c"
			goto __catch0_g_error;
		}
#line 138 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		force_seek = rygel_client_hacks_force_seek (hack);
#line 136 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_g_object_unref0 (hack);
#line 854 "rygel-http-byte-seek-request.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 136 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_clear_error (&_inner_error0_);
#line 861 "rygel-http-byte-seek-request.c"
	}
	__finally0:
#line 136 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 866 "rygel-http-byte-seek-request.c"
		gboolean _tmp1_ = FALSE;
#line 136 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 136 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_clear_error (&_inner_error0_);
#line 136 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		return _tmp1_;
#line 874 "rygel-http-byte-seek-request.c"
	}
#line 141 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (force_seek) {
#line 141 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp2_ = TRUE;
#line 880 "rygel-http-byte-seek-request.c"
	} else {
#line 141 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		_tmp2_ = rygel_http_get_handler_supports_byte_seek (handler);
#line 884 "rygel-http-byte-seek-request.c"
	}
#line 141 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	result = _tmp2_;
#line 141 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	return result;
#line 890 "rygel-http-byte-seek-request.c"
}

gboolean
rygel_http_byte_seek_request_requested (SoupServerMessage* msg)
{
	SoupMessageHeaders* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 144 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (msg != NULL, FALSE);
#line 145 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp0_ = soup_server_message_get_request_headers (msg);
#line 145 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	_tmp1_ = soup_message_headers_get_one (_tmp0_, "Range");
#line 145 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	result = _tmp1_ != NULL;
#line 145 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	return result;
#line 909 "rygel-http-byte-seek-request.c"
}

gint64
rygel_http_byte_seek_request_get_start_byte (RygelHTTPByteSeekRequest* self)
{
	gint64 result;
#line 34 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 34 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	result = self->priv->_start_byte;
#line 34 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	return result;
#line 922 "rygel-http-byte-seek-request.c"
}

void
rygel_http_byte_seek_request_set_start_byte (RygelHTTPByteSeekRequest* self,
                                             gint64 value)
{
	gint64 old_value;
#line 34 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	old_value = rygel_http_byte_seek_request_get_start_byte (self);
#line 34 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (old_value != value) {
#line 34 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		self->priv->_start_byte = value;
#line 34 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_START_BYTE_PROPERTY]);
#line 940 "rygel-http-byte-seek-request.c"
	}
}

gint64
rygel_http_byte_seek_request_get_end_byte (RygelHTTPByteSeekRequest* self)
{
	gint64 result;
#line 39 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 39 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	result = self->priv->_end_byte;
#line 39 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	return result;
#line 954 "rygel-http-byte-seek-request.c"
}

void
rygel_http_byte_seek_request_set_end_byte (RygelHTTPByteSeekRequest* self,
                                           gint64 value)
{
	gint64 old_value;
#line 39 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	old_value = rygel_http_byte_seek_request_get_end_byte (self);
#line 39 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (old_value != value) {
#line 39 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		self->priv->_end_byte = value;
#line 39 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_END_BYTE_PROPERTY]);
#line 972 "rygel-http-byte-seek-request.c"
	}
}

gint64
rygel_http_byte_seek_request_get_range_length (RygelHTTPByteSeekRequest* self)
{
	gint64 result;
#line 44 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 44 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	result = self->priv->_range_length;
#line 44 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	return result;
#line 986 "rygel-http-byte-seek-request.c"
}

static void
rygel_http_byte_seek_request_set_range_length (RygelHTTPByteSeekRequest* self,
                                               gint64 value)
{
	gint64 old_value;
#line 44 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	old_value = rygel_http_byte_seek_request_get_range_length (self);
#line 44 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (old_value != value) {
#line 44 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		self->priv->_range_length = value;
#line 44 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_RANGE_LENGTH_PROPERTY]);
#line 1004 "rygel-http-byte-seek-request.c"
	}
}

gint64
rygel_http_byte_seek_request_get_total_size (RygelHTTPByteSeekRequest* self)
{
	gint64 result;
#line 49 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 49 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	result = self->priv->_total_size;
#line 49 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	return result;
#line 1018 "rygel-http-byte-seek-request.c"
}

void
rygel_http_byte_seek_request_set_total_size (RygelHTTPByteSeekRequest* self,
                                             gint64 value)
{
	gint64 old_value;
#line 49 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	old_value = rygel_http_byte_seek_request_get_total_size (self);
#line 49 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	if (old_value != value) {
#line 49 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		self->priv->_total_size = value;
#line 49 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_TOTAL_SIZE_PROPERTY]);
#line 1036 "rygel-http-byte-seek-request.c"
	}
}

static void
rygel_http_byte_seek_request_class_init (RygelHTTPByteSeekRequestClass * klass,
                                         gpointer klass_data)
{
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	rygel_http_byte_seek_request_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_type_class_adjust_private_offset (klass, &RygelHTTPByteSeekRequest_private_offset);
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_http_byte_seek_request_get_property;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_http_byte_seek_request_set_property;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_http_byte_seek_request_finalize;
#line 1054 "rygel-http-byte-seek-request.c"
	/**
	     * The start of the range in bytes
	     */
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_BYTE_SEEK_REQUEST_START_BYTE_PROPERTY, rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_START_BYTE_PROPERTY] = g_param_spec_int64 ("start-byte", "start-byte", "start-byte", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1060 "rygel-http-byte-seek-request.c"
	/**
	     * The end of the range in bytes (inclusive)
	     */
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_BYTE_SEEK_REQUEST_END_BYTE_PROPERTY, rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_END_BYTE_PROPERTY] = g_param_spec_int64 ("end-byte", "end-byte", "end-byte", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1066 "rygel-http-byte-seek-request.c"
	/**
	     * The length of the range in bytes
	     */
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_BYTE_SEEK_REQUEST_RANGE_LENGTH_PROPERTY, rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_RANGE_LENGTH_PROPERTY] = g_param_spec_int64 ("range-length", "range-length", "range-length", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1072 "rygel-http-byte-seek-request.c"
	/**
	     * The length of the resource in bytes
	     */
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_BYTE_SEEK_REQUEST_TOTAL_SIZE_PROPERTY, rygel_http_byte_seek_request_properties[RYGEL_HTTP_BYTE_SEEK_REQUEST_TOTAL_SIZE_PROPERTY] = g_param_spec_int64 ("total-size", "total-size", "total-size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1078 "rygel-http-byte-seek-request.c"
}

static void
rygel_http_byte_seek_request_instance_init (RygelHTTPByteSeekRequest * self,
                                            gpointer klass)
{
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	self->priv = rygel_http_byte_seek_request_get_instance_private (self);
#line 1087 "rygel-http-byte-seek-request.c"
}

static void
rygel_http_byte_seek_request_finalize (GObject * obj)
{
	RygelHTTPByteSeekRequest * self;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST, RygelHTTPByteSeekRequest);
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	G_OBJECT_CLASS (rygel_http_byte_seek_request_parent_class)->finalize (obj);
#line 1098 "rygel-http-byte-seek-request.c"
}

 G_GNUC_NO_INLINE static GType
rygel_http_byte_seek_request_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelHTTPByteSeekRequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_http_byte_seek_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelHTTPByteSeekRequest), 0, (GInstanceInitFunc) rygel_http_byte_seek_request_instance_init, NULL };
	GType rygel_http_byte_seek_request_type_id;
	rygel_http_byte_seek_request_type_id = g_type_register_static (RYGEL_TYPE_HTTP_SEEK_REQUEST, "RygelHTTPByteSeekRequest", &g_define_type_info, 0);
	RygelHTTPByteSeekRequest_private_offset = g_type_add_instance_private (rygel_http_byte_seek_request_type_id, sizeof (RygelHTTPByteSeekRequestPrivate));
	return rygel_http_byte_seek_request_type_id;
}

GType
rygel_http_byte_seek_request_get_type (void)
{
	static volatile gsize rygel_http_byte_seek_request_type_id__once = 0;
	if (g_once_init_enter (&rygel_http_byte_seek_request_type_id__once)) {
		GType rygel_http_byte_seek_request_type_id;
		rygel_http_byte_seek_request_type_id = rygel_http_byte_seek_request_get_type_once ();
		g_once_init_leave (&rygel_http_byte_seek_request_type_id__once, rygel_http_byte_seek_request_type_id);
	}
	return rygel_http_byte_seek_request_type_id__once;
}

static void
_vala_rygel_http_byte_seek_request_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	RygelHTTPByteSeekRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST, RygelHTTPByteSeekRequest);
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	switch (property_id) {
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		case RYGEL_HTTP_BYTE_SEEK_REQUEST_START_BYTE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_value_set_int64 (value, rygel_http_byte_seek_request_get_start_byte (self));
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		case RYGEL_HTTP_BYTE_SEEK_REQUEST_END_BYTE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_value_set_int64 (value, rygel_http_byte_seek_request_get_end_byte (self));
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		case RYGEL_HTTP_BYTE_SEEK_REQUEST_RANGE_LENGTH_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_value_set_int64 (value, rygel_http_byte_seek_request_get_range_length (self));
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		case RYGEL_HTTP_BYTE_SEEK_REQUEST_TOTAL_SIZE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		g_value_set_int64 (value, rygel_http_byte_seek_request_get_total_size (self));
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 1157 "rygel-http-byte-seek-request.c"
		default:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 1163 "rygel-http-byte-seek-request.c"
	}
}

static void
_vala_rygel_http_byte_seek_request_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	RygelHTTPByteSeekRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST, RygelHTTPByteSeekRequest);
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
	switch (property_id) {
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		case RYGEL_HTTP_BYTE_SEEK_REQUEST_START_BYTE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		rygel_http_byte_seek_request_set_start_byte (self, g_value_get_int64 (value));
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		case RYGEL_HTTP_BYTE_SEEK_REQUEST_END_BYTE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		rygel_http_byte_seek_request_set_end_byte (self, g_value_get_int64 (value));
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		case RYGEL_HTTP_BYTE_SEEK_REQUEST_RANGE_LENGTH_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		rygel_http_byte_seek_request_set_range_length (self, g_value_get_int64 (value));
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		case RYGEL_HTTP_BYTE_SEEK_REQUEST_TOTAL_SIZE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		rygel_http_byte_seek_request_set_total_size (self, g_value_get_int64 (value));
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 1201 "rygel-http-byte-seek-request.c"
		default:
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/librygel-server/rygel-http-byte-seek-request.vala"
		break;
#line 1207 "rygel-http-byte-seek-request.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

