/* rygel-http-byte-seek-response.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-http-byte-seek-response.vala, do not modify */

/*
 * Copyright (C) 2009 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <libsoup/soup.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_HTTP_BYTE_SEEK_RESPONSE_0_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_RESPONSE_START_BYTE_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_RESPONSE_END_BYTE_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_RESPONSE_RANGE_LENGTH_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY,
	RYGEL_HTTP_BYTE_SEEK_RESPONSE_NUM_PROPERTIES
};
static GParamSpec* rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_NUM_PROPERTIES];

struct _RygelHTTPByteSeekResponsePrivate {
	gint64 _start_byte;
	gint64 _end_byte;
	gint64 _range_length;
	gint64 _total_size;
};

static gint RygelHTTPByteSeekResponse_private_offset;
static gpointer rygel_http_byte_seek_response_parent_class = NULL;

static void rygel_http_byte_seek_response_set_range_length (RygelHTTPByteSeekResponse* self,
                                                     gint64 value);
static void rygel_http_byte_seek_response_real_add_response_headers (RygelHTTPResponseElement* base,
                                                              RygelHTTPRequest* request);
static gchar* rygel_http_byte_seek_response_real_to_string (RygelHTTPResponseElement* base);
static void rygel_http_byte_seek_response_finalize (GObject * obj);
static GType rygel_http_byte_seek_response_get_type_once (void);
static void _vala_rygel_http_byte_seek_response_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_rygel_http_byte_seek_response_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rygel_http_byte_seek_response_get_instance_private (RygelHTTPByteSeekResponse* self)
{
	return G_STRUCT_MEMBER_P (self, RygelHTTPByteSeekResponse_private_offset);
}

RygelHTTPByteSeekResponse*
rygel_http_byte_seek_response_construct (GType object_type,
                                         gint64 start_byte,
                                         gint64 end_byte,
                                         gint64 total_size)
{
	RygelHTTPByteSeekResponse * self = NULL;
#line 51 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	self = (RygelHTTPByteSeekResponse*) rygel_http_response_element_construct (object_type);
#line 54 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_set_start_byte (self, start_byte);
#line 55 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_set_end_byte (self, end_byte);
#line 57 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_set_range_length (self, (end_byte - start_byte) + 1);
#line 58 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_set_total_size (self, total_size);
#line 51 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return self;
#line 111 "rygel-http-byte-seek-response.c"
}

RygelHTTPByteSeekResponse*
rygel_http_byte_seek_response_new (gint64 start_byte,
                                   gint64 end_byte,
                                   gint64 total_size)
{
#line 51 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return rygel_http_byte_seek_response_construct (RYGEL_TYPE_HTTP_BYTE_SEEK_RESPONSE, start_byte, end_byte, total_size);
#line 121 "rygel-http-byte-seek-response.c"
}

RygelHTTPByteSeekResponse*
rygel_http_byte_seek_response_construct_from_request (GType object_type,
                                                      RygelHTTPByteSeekRequest* request)
{
	RygelHTTPByteSeekResponse * self = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
#line 61 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_val_if_fail (request != NULL, NULL);
#line 61 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	self = (RygelHTTPByteSeekResponse*) rygel_http_response_element_construct (object_type);
#line 62 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp0_ = rygel_http_byte_seek_request_get_start_byte (request);
#line 62 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp1_ = _tmp0_;
#line 62 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_set_start_byte (self, _tmp1_);
#line 63 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp2_ = rygel_http_byte_seek_request_get_end_byte (request);
#line 63 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp3_ = _tmp2_;
#line 63 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_set_end_byte (self, _tmp3_);
#line 64 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp4_ = rygel_http_byte_seek_request_get_range_length (request);
#line 64 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp5_ = _tmp4_;
#line 64 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_set_range_length (self, _tmp5_);
#line 65 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp6_ = rygel_http_byte_seek_request_get_total_size (request);
#line 65 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp7_ = _tmp6_;
#line 65 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_set_total_size (self, _tmp7_);
#line 61 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return self;
#line 167 "rygel-http-byte-seek-response.c"
}

RygelHTTPByteSeekResponse*
rygel_http_byte_seek_response_new_from_request (RygelHTTPByteSeekRequest* request)
{
#line 61 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return rygel_http_byte_seek_response_construct_from_request (RYGEL_TYPE_HTTP_BYTE_SEEK_RESPONSE, request);
#line 175 "rygel-http-byte-seek-response.c"
}

static void
rygel_http_byte_seek_response_real_add_response_headers (RygelHTTPResponseElement* base,
                                                         RygelHTTPRequest* request)
{
	RygelHTTPByteSeekResponse * self;
	gint64 _tmp0_;
#line 68 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	self = (RygelHTTPByteSeekResponse*) base;
#line 68 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_if_fail (request != NULL);
#line 69 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp0_ = self->priv->_end_byte;
#line 69 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	if (_tmp0_ != ((gint64) -1)) {
#line 192 "rygel-http-byte-seek-response.c"
		SoupServerMessage* _tmp1_;
		SoupMessageHeaders* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		gint64 _tmp5_;
		SoupServerMessage* _tmp6_;
		SoupMessageHeaders* _tmp7_;
		SoupServerMessage* _tmp8_;
		SoupMessageHeaders* _tmp9_;
		gint64 _tmp10_;
#line 71 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp1_ = request->msg;
#line 71 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp2_ = soup_server_message_get_response_headers (_tmp1_);
#line 71 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp3_ = self->priv->_start_byte;
#line 71 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp4_ = self->priv->_end_byte;
#line 71 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp5_ = self->priv->_total_size;
#line 71 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		soup_message_headers_set_content_range (_tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 74 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp6_ = request->msg;
#line 74 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp7_ = soup_server_message_get_response_headers (_tmp6_);
#line 74 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		soup_message_headers_append (_tmp7_, "Accept-Ranges", "bytes");
#line 75 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp8_ = request->msg;
#line 75 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp9_ = soup_server_message_get_response_headers (_tmp8_);
#line 75 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		_tmp10_ = self->priv->_range_length;
#line 75 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		soup_message_headers_set_content_length (_tmp9_, _tmp10_);
#line 229 "rygel-http-byte-seek-response.c"
	}
}

static gchar*
rygel_http_byte_seek_response_real_to_string (RygelHTTPResponseElement* base)
{
	RygelHTTPByteSeekResponse * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 79 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	self = (RygelHTTPByteSeekResponse*) base;
#line 80 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp0_ = self->priv->_start_byte;
#line 80 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp1_ = self->priv->_end_byte;
#line 80 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp2_ = self->priv->_total_size;
#line 80 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp3_ = self->priv->_range_length;
#line 80 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	_tmp4_ = g_strdup_printf ("HTTPByteSeekResponse(bytes=%lld-%lld/%lld (%lld bytes))", _tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 80 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	result = _tmp4_;
#line 80 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return result;
#line 259 "rygel-http-byte-seek-response.c"
}

gint64
rygel_http_byte_seek_response_get_start_byte (RygelHTTPByteSeekResponse* self)
{
	gint64 result;
#line 34 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 34 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	result = self->priv->_start_byte;
#line 34 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return result;
#line 272 "rygel-http-byte-seek-response.c"
}

void
rygel_http_byte_seek_response_set_start_byte (RygelHTTPByteSeekResponse* self,
                                              gint64 value)
{
	gint64 old_value;
#line 34 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	old_value = rygel_http_byte_seek_response_get_start_byte (self);
#line 34 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	if (old_value != value) {
#line 34 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		self->priv->_start_byte = value;
#line 34 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_START_BYTE_PROPERTY]);
#line 290 "rygel-http-byte-seek-response.c"
	}
}

gint64
rygel_http_byte_seek_response_get_end_byte (RygelHTTPByteSeekResponse* self)
{
	gint64 result;
#line 39 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 39 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	result = self->priv->_end_byte;
#line 39 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return result;
#line 304 "rygel-http-byte-seek-response.c"
}

void
rygel_http_byte_seek_response_set_end_byte (RygelHTTPByteSeekResponse* self,
                                            gint64 value)
{
	gint64 old_value;
#line 39 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	old_value = rygel_http_byte_seek_response_get_end_byte (self);
#line 39 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	if (old_value != value) {
#line 39 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		self->priv->_end_byte = value;
#line 39 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_END_BYTE_PROPERTY]);
#line 322 "rygel-http-byte-seek-response.c"
	}
}

gint64
rygel_http_byte_seek_response_get_range_length (RygelHTTPByteSeekResponse* self)
{
	gint64 result;
#line 44 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 44 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	result = self->priv->_range_length;
#line 44 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return result;
#line 336 "rygel-http-byte-seek-response.c"
}

static void
rygel_http_byte_seek_response_set_range_length (RygelHTTPByteSeekResponse* self,
                                                gint64 value)
{
	gint64 old_value;
#line 44 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	old_value = rygel_http_byte_seek_response_get_range_length (self);
#line 44 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	if (old_value != value) {
#line 44 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		self->priv->_range_length = value;
#line 44 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_RANGE_LENGTH_PROPERTY]);
#line 354 "rygel-http-byte-seek-response.c"
	}
}

gint64
rygel_http_byte_seek_response_get_total_size (RygelHTTPByteSeekResponse* self)
{
	gint64 result;
#line 49 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 49 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	result = self->priv->_total_size;
#line 49 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	return result;
#line 368 "rygel-http-byte-seek-response.c"
}

void
rygel_http_byte_seek_response_set_total_size (RygelHTTPByteSeekResponse* self,
                                              gint64 value)
{
	gint64 old_value;
#line 49 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	old_value = rygel_http_byte_seek_response_get_total_size (self);
#line 49 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	if (old_value != value) {
#line 49 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		self->priv->_total_size = value;
#line 49 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY]);
#line 386 "rygel-http-byte-seek-response.c"
	}
}

static void
rygel_http_byte_seek_response_class_init (RygelHTTPByteSeekResponseClass * klass,
                                          gpointer klass_data)
{
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	rygel_http_byte_seek_response_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_type_class_adjust_private_offset (klass, &RygelHTTPByteSeekResponse_private_offset);
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	((RygelHTTPResponseElementClass *) klass)->add_response_headers = (void (*) (RygelHTTPResponseElement*, RygelHTTPRequest*)) rygel_http_byte_seek_response_real_add_response_headers;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	((RygelHTTPResponseElementClass *) klass)->to_string = (gchar* (*) (RygelHTTPResponseElement*)) rygel_http_byte_seek_response_real_to_string;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_http_byte_seek_response_get_property;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_http_byte_seek_response_set_property;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_http_byte_seek_response_finalize;
#line 408 "rygel-http-byte-seek-response.c"
	/**
	     * The start of the range in bytes
	     */
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_BYTE_SEEK_RESPONSE_START_BYTE_PROPERTY, rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_START_BYTE_PROPERTY] = g_param_spec_int64 ("start-byte", "start-byte", "start-byte", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 414 "rygel-http-byte-seek-response.c"
	/**
	     * The end of the range in bytes (inclusive)
	     */
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_BYTE_SEEK_RESPONSE_END_BYTE_PROPERTY, rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_END_BYTE_PROPERTY] = g_param_spec_int64 ("end-byte", "end-byte", "end-byte", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 420 "rygel-http-byte-seek-response.c"
	/**
	     * The length of the range in bytes
	     */
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_BYTE_SEEK_RESPONSE_RANGE_LENGTH_PROPERTY, rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_RANGE_LENGTH_PROPERTY] = g_param_spec_int64 ("range-length", "range-length", "range-length", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 426 "rygel-http-byte-seek-response.c"
	/**
	     * The length of the resource in bytes
	     */
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_BYTE_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY, rygel_http_byte_seek_response_properties[RYGEL_HTTP_BYTE_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY] = g_param_spec_int64 ("total-size", "total-size", "total-size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 432 "rygel-http-byte-seek-response.c"
}

static void
rygel_http_byte_seek_response_instance_init (RygelHTTPByteSeekResponse * self,
                                             gpointer klass)
{
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	self->priv = rygel_http_byte_seek_response_get_instance_private (self);
#line 441 "rygel-http-byte-seek-response.c"
}

static void
rygel_http_byte_seek_response_finalize (GObject * obj)
{
	RygelHTTPByteSeekResponse * self;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_HTTP_BYTE_SEEK_RESPONSE, RygelHTTPByteSeekResponse);
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	G_OBJECT_CLASS (rygel_http_byte_seek_response_parent_class)->finalize (obj);
#line 452 "rygel-http-byte-seek-response.c"
}

 G_GNUC_NO_INLINE static GType
rygel_http_byte_seek_response_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelHTTPByteSeekResponseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_http_byte_seek_response_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelHTTPByteSeekResponse), 0, (GInstanceInitFunc) rygel_http_byte_seek_response_instance_init, NULL };
	GType rygel_http_byte_seek_response_type_id;
	rygel_http_byte_seek_response_type_id = g_type_register_static (RYGEL_TYPE_HTTP_RESPONSE_ELEMENT, "RygelHTTPByteSeekResponse", &g_define_type_info, 0);
	RygelHTTPByteSeekResponse_private_offset = g_type_add_instance_private (rygel_http_byte_seek_response_type_id, sizeof (RygelHTTPByteSeekResponsePrivate));
	return rygel_http_byte_seek_response_type_id;
}

GType
rygel_http_byte_seek_response_get_type (void)
{
	static volatile gsize rygel_http_byte_seek_response_type_id__once = 0;
	if (g_once_init_enter (&rygel_http_byte_seek_response_type_id__once)) {
		GType rygel_http_byte_seek_response_type_id;
		rygel_http_byte_seek_response_type_id = rygel_http_byte_seek_response_get_type_once ();
		g_once_init_leave (&rygel_http_byte_seek_response_type_id__once, rygel_http_byte_seek_response_type_id);
	}
	return rygel_http_byte_seek_response_type_id__once;
}

static void
_vala_rygel_http_byte_seek_response_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	RygelHTTPByteSeekResponse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_HTTP_BYTE_SEEK_RESPONSE, RygelHTTPByteSeekResponse);
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	switch (property_id) {
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		case RYGEL_HTTP_BYTE_SEEK_RESPONSE_START_BYTE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		g_value_set_int64 (value, rygel_http_byte_seek_response_get_start_byte (self));
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		case RYGEL_HTTP_BYTE_SEEK_RESPONSE_END_BYTE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		g_value_set_int64 (value, rygel_http_byte_seek_response_get_end_byte (self));
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		case RYGEL_HTTP_BYTE_SEEK_RESPONSE_RANGE_LENGTH_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		g_value_set_int64 (value, rygel_http_byte_seek_response_get_range_length (self));
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		case RYGEL_HTTP_BYTE_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		g_value_set_int64 (value, rygel_http_byte_seek_response_get_total_size (self));
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 511 "rygel-http-byte-seek-response.c"
		default:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 517 "rygel-http-byte-seek-response.c"
	}
}

static void
_vala_rygel_http_byte_seek_response_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	RygelHTTPByteSeekResponse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_HTTP_BYTE_SEEK_RESPONSE, RygelHTTPByteSeekResponse);
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
	switch (property_id) {
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		case RYGEL_HTTP_BYTE_SEEK_RESPONSE_START_BYTE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		rygel_http_byte_seek_response_set_start_byte (self, g_value_get_int64 (value));
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		case RYGEL_HTTP_BYTE_SEEK_RESPONSE_END_BYTE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		rygel_http_byte_seek_response_set_end_byte (self, g_value_get_int64 (value));
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		case RYGEL_HTTP_BYTE_SEEK_RESPONSE_RANGE_LENGTH_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		rygel_http_byte_seek_response_set_range_length (self, g_value_get_int64 (value));
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		case RYGEL_HTTP_BYTE_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		rygel_http_byte_seek_response_set_total_size (self, g_value_get_int64 (value));
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 555 "rygel-http-byte-seek-response.c"
		default:
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/librygel-server/rygel-http-byte-seek-response.vala"
		break;
#line 561 "rygel-http-byte-seek-response.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

