/* rygel-http-get.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-http-get.vala, do not modify */

/*
 * Copyright (C) 2008-2010 Nokia Corporation.
 * Copyright (C) 2006, 2007, 2008 OpenedHand Ltd.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jorn Baayen <jorn.baayen@gmail.com>
 *         Jens Georg <jensg@openismus.com>
 *         Craig Pratt <craig@ecaspia.com>
 *         Parthiban Balasubramanian <P.Balasubramanian-contractor@cablelabs.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <glib/gi18n-lib.h>
#include "rygel-core.h"
#include <gee.h>

#define RYGEL_HTTP_GET_TRANSFER_MODE_HEADER "transferMode.dlna.org"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_HTTP_GET_0_PROPERTY,
	RYGEL_HTTP_GET_NUM_PROPERTIES
};
static GParamSpec* rygel_http_get_properties[RYGEL_HTTP_GET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define RYGEL_TYPE_HTTP_MEDIA_RESOURCE_HANDLER (rygel_http_media_resource_handler_get_type ())
#define RYGEL_HTTP_MEDIA_RESOURCE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_HTTP_MEDIA_RESOURCE_HANDLER, RygelHTTPMediaResourceHandler))
#define RYGEL_HTTP_MEDIA_RESOURCE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_HTTP_MEDIA_RESOURCE_HANDLER, RygelHTTPMediaResourceHandlerClass))
#define RYGEL_IS_HTTP_MEDIA_RESOURCE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_HTTP_MEDIA_RESOURCE_HANDLER))
#define RYGEL_IS_HTTP_MEDIA_RESOURCE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_HTTP_MEDIA_RESOURCE_HANDLER))
#define RYGEL_HTTP_MEDIA_RESOURCE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_HTTP_MEDIA_RESOURCE_HANDLER, RygelHTTPMediaResourceHandlerClass))

typedef struct _RygelHTTPMediaResourceHandler RygelHTTPMediaResourceHandler;
typedef struct _RygelHTTPMediaResourceHandlerClass RygelHTTPMediaResourceHandlerClass;

#define RYGEL_TYPE_HTTP_THUMBNAIL_HANDLER (rygel_http_thumbnail_handler_get_type ())
#define RYGEL_HTTP_THUMBNAIL_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_HTTP_THUMBNAIL_HANDLER, RygelHTTPThumbnailHandler))
#define RYGEL_HTTP_THUMBNAIL_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_HTTP_THUMBNAIL_HANDLER, RygelHTTPThumbnailHandlerClass))
#define RYGEL_IS_HTTP_THUMBNAIL_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_HTTP_THUMBNAIL_HANDLER))
#define RYGEL_IS_HTTP_THUMBNAIL_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_HTTP_THUMBNAIL_HANDLER))
#define RYGEL_HTTP_THUMBNAIL_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_HTTP_THUMBNAIL_HANDLER, RygelHTTPThumbnailHandlerClass))

typedef struct _RygelHTTPThumbnailHandler RygelHTTPThumbnailHandler;
typedef struct _RygelHTTPThumbnailHandlerClass RygelHTTPThumbnailHandlerClass;

#define RYGEL_TYPE_HTTP_SUBTITLE_HANDLER (rygel_http_subtitle_handler_get_type ())
#define RYGEL_HTTP_SUBTITLE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_HTTP_SUBTITLE_HANDLER, RygelHTTPSubtitleHandler))
#define RYGEL_HTTP_SUBTITLE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_HTTP_SUBTITLE_HANDLER, RygelHTTPSubtitleHandlerClass))
#define RYGEL_IS_HTTP_SUBTITLE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_HTTP_SUBTITLE_HANDLER))
#define RYGEL_IS_HTTP_SUBTITLE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_HTTP_SUBTITLE_HANDLER))
#define RYGEL_HTTP_SUBTITLE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_HTTP_SUBTITLE_HANDLER, RygelHTTPSubtitleHandlerClass))

typedef struct _RygelHTTPSubtitleHandler RygelHTTPSubtitleHandler;
typedef struct _RygelHTTPSubtitleHandlerClass RygelHTTPSubtitleHandlerClass;
#define _soup_message_headers_unref0(var) ((var == NULL) ? NULL : (var = (soup_message_headers_unref (var), NULL)))
typedef struct _RygelHttpGetHandleData RygelHttpGetHandleData;

#define RYGEL_TYPE_CLIENT_HACKS (rygel_client_hacks_get_type ())
#define RYGEL_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacks))
#define RYGEL_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))
#define RYGEL_IS_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_IS_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_CLIENT_HACKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))

typedef struct _RygelClientHacks RygelClientHacks;
typedef struct _RygelClientHacksClass RygelClientHacksClass;
typedef struct _RygelHttpGetFindItemData RygelHttpGetFindItemData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _rygel_play_speed_unref0(var) ((var == NULL) ? NULL : (var = (rygel_play_speed_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _RygelHttpGetHandleItemRequestData RygelHttpGetHandleItemRequestData;

struct _RygelHttpGetHandleData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelHTTPGet* self;
	gboolean _tmp0_;
	SoupServerMessage* _tmp1_;
	const gchar* _tmp2_;
	SoupServerMessage* _tmp3_;
	const gchar* _tmp4_;
	GError* _tmp5_;
	gchar* cf_header;
	gchar* _tmp6_;
	gchar* cf_val;
	SoupServerMessage* _tmp7_;
	SoupMessageHeaders* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _tmp18_;
	GError* _tmp19_;
	RygelHTTPItemURI* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	RygelHTTPMediaResourceHandler* _tmp23_;
	RygelMediaObject* _tmp24_;
	RygelHTTPItemURI* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	GCancellable* _tmp28_;
	GCancellable* _tmp29_;
	RygelHTTPMediaResourceHandler* _tmp30_;
	RygelHTTPMediaResourceHandler* _tmp31_;
	RygelHTTPItemURI* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	RygelHTTPThumbnailHandler* _tmp35_;
	RygelMediaObject* _tmp36_;
	RygelHTTPItemURI* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	GCancellable* _tmp40_;
	GCancellable* _tmp41_;
	RygelHTTPThumbnailHandler* _tmp42_;
	RygelHTTPThumbnailHandler* _tmp43_;
	RygelHTTPItemURI* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	RygelHTTPSubtitleHandler* _tmp47_;
	RygelMediaObject* _tmp48_;
	RygelHTTPItemURI* _tmp49_;
	gint _tmp50_;
	gint _tmp51_;
	GCancellable* _tmp52_;
	GCancellable* _tmp53_;
	RygelHTTPSubtitleHandler* _tmp54_;
	RygelHTTPSubtitleHandler* _tmp55_;
	RygelHTTPItemURI* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	GError* _tmp59_;
	GError* _tmp60_;
	SoupMessageHeaders* headers;
	SoupServerMessage* _tmp61_;
	SoupMessageHeaders* _tmp62_;
	SoupMessageHeaders* _tmp63_;
	gchar* transfer_mode;
	SoupMessageHeaders* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	const gchar* _tmp67_;
	RygelHTTPGetHandler* _tmp68_;
	gchar* _tmp69_;
	RygelHTTPGetHandler* _tmp70_;
	const gchar* _tmp71_;
	gchar* msg;
	gchar* _tmp72_;
	const gchar* _tmp73_;
	const gchar* _tmp74_;
	RygelHTTPItemURI* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	GError* _tmp78_;
	GError* _tmp79_;
	GError* _inner_error0_;
};

struct _RygelHttpGetFindItemData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelHTTPGet* self;
	RygelMediaObject* _tmp0_;
	RygelMediaFileItem* item;
	RygelMediaObject* _tmp1_;
	RygelMediaFileItem* _tmp2_;
	gboolean _tmp3_;
	RygelMediaFileItem* _tmp4_;
	RygelMediaFileItem* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	RygelMediaObject* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GError* _tmp11_;
	RygelClientHacks* _tmp12_;
	RygelClientHacks* _tmp13_;
	RygelMediaObject* _tmp14_;
	GError* _inner_error0_;
};

struct _RygelHttpGetHandleItemRequestData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelHTTPGet* self;
	gboolean supports_time_seek;
	SoupServerMessage* _tmp0_;
	RygelHTTPGetHandler* _tmp1_;
	gboolean requested_time_seek;
	SoupServerMessage* _tmp2_;
	gboolean supports_byte_seek;
	SoupServerMessage* _tmp3_;
	RygelHTTPGetHandler* _tmp4_;
	gboolean requested_byte_seek;
	SoupServerMessage* _tmp5_;
	gboolean supports_cleartext_seek;
	SoupServerMessage* _tmp6_;
	RygelHTTPGetHandler* _tmp7_;
	gboolean requested_cleartext_seek;
	SoupServerMessage* _tmp8_;
	SoupMessageHeaders* response_headers;
	SoupServerMessage* _tmp9_;
	SoupMessageHeaders* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	gchar* msg;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	RygelHTTPItemURI* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GError* _tmp17_;
	GError* _tmp18_;
	gchar* _vala1_msg;
	gchar* _tmp19_;
	const gchar* _tmp20_;
	RygelHTTPItemURI* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GError* _tmp24_;
	GError* _tmp25_;
	gchar* _vala2_msg;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	RygelHTTPItemURI* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GError* _tmp31_;
	GError* _tmp32_;
	gchar* _vala3_msg;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	RygelHTTPItemURI* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	GError* _tmp38_;
	GError* _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	RygelPlaySpeedRequest* _tmp42_;
	RygelPlaySpeedRequest* _tmp43_;
	RygelPlaySpeedRequest* _tmp44_;
	RygelPlaySpeedRequest* _tmp45_;
	RygelPlaySpeed* _tmp46_;
	RygelPlaySpeed* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	RygelPlaySpeedRequest* _tmp50_;
	RygelPlaySpeed* _tmp51_;
	RygelPlaySpeed* _tmp52_;
	GError* _error_;
	SoupServerMessage* _tmp53_;
	GError* _tmp54_;
	GError* _tmp55_;
	const gchar* _tmp56_;
	GError* _tmp57_;
	GError* _tmp58_;
	const gchar* _tmp59_;
	GError* _tmp60_;
	GError* _tmp61_;
	GError* _tmp62_;
	const gchar* _tmp63_;
	gboolean _tmp64_;
	RygelDTCPCleartextRequest* cleartext_seek;
	SoupServerMessage* _tmp65_;
	RygelHTTPGetHandler* _tmp66_;
	RygelDTCPCleartextRequest* _tmp67_;
	RygelDTCPCleartextRequest* _tmp68_;
	gint64 _tmp69_;
	gint64 _tmp70_;
	RygelDTCPCleartextRequest* _tmp71_;
	gint64 _tmp72_;
	gint64 _tmp73_;
	RygelDTCPCleartextRequest* _tmp74_;
	RygelHTTPSeekRequest* _tmp75_;
	gboolean _tmp76_;
	RygelHTTPByteSeekRequest* byte_seek;
	SoupServerMessage* _tmp77_;
	RygelHTTPGetHandler* _tmp78_;
	RygelHTTPByteSeekRequest* _tmp79_;
	RygelHTTPByteSeekRequest* _tmp80_;
	gint64 _tmp81_;
	gint64 _tmp82_;
	RygelHTTPByteSeekRequest* _tmp83_;
	gint64 _tmp84_;
	gint64 _tmp85_;
	RygelHTTPByteSeekRequest* _tmp86_;
	RygelHTTPSeekRequest* _tmp87_;
	gboolean _tmp88_;
	RygelPlaySpeed* _tmp89_;
	RygelPlaySpeedRequest* _tmp90_;
	RygelPlaySpeedRequest* _tmp91_;
	RygelPlaySpeed* _tmp92_;
	RygelPlaySpeed* _tmp93_;
	RygelPlaySpeed* speed;
	RygelPlaySpeed* _tmp94_;
	RygelHTTPTimeSeekRequest* time_seek;
	SoupServerMessage* _tmp95_;
	RygelHTTPGetHandler* _tmp96_;
	RygelPlaySpeed* _tmp97_;
	RygelHTTPTimeSeekRequest* _tmp98_;
	RygelHTTPTimeSeekRequest* _tmp99_;
	gchar* _tmp100_;
	gchar* _tmp101_;
	RygelHTTPTimeSeekRequest* _tmp102_;
	RygelHTTPSeekRequest* _tmp103_;
	GError* _vala1__error_;
	GError* _tmp104_;
	const gchar* _tmp105_;
	SoupServerMessage* _tmp106_;
	GError* _tmp107_;
	GError* _tmp108_;
	const gchar* _tmp109_;
	RygelHTTPGetHandler* _tmp110_;
	SoupServerMessage* _tmp111_;
	SoupMessageHeaders* _tmp112_;
	RygelHTTPServer* _tmp113_;
	const gchar* _tmp114_;
	const gchar* _tmp115_;
	RygelHTTPResponse* response;
	RygelHTTPGetHandler* _tmp116_;
	RygelHTTPResponse* _tmp117_;
	GeeList* responses;
	RygelHTTPResponse* _tmp118_;
	GeeList* _tmp119_;
	GeeList* _tmp120_;
	GeeList* _response_elem_list;
	GeeList* _tmp121_;
	gint _response_elem_size;
	GeeList* _tmp122_;
	gint _tmp123_;
	gint _tmp124_;
	gint _response_elem_index;
	gint _tmp125_;
	gint _tmp126_;
	RygelHTTPResponseElement* response_elem;
	GeeList* _tmp127_;
	gpointer _tmp128_;
	RygelHTTPResponseElement* _tmp129_;
	GError* _vala2__error_;
	GError* _tmp130_;
	const gchar* _tmp131_;
	SoupServerMessage* _tmp132_;
	GError* _tmp133_;
	GError* _tmp134_;
	const gchar* _tmp135_;
	gint64 response_size;
	SoupMessageHeaders* _tmp136_;
	SoupMessageHeaders* _tmp137_;
	gchar* _tmp138_;
	gchar* _tmp139_;
	gchar* _tmp140_;
	gchar* _tmp141_;
	RygelHTTPGetHandler* _tmp142_;
	SoupMessageHeaders* _tmp143_;
	gchar* _tmp144_;
	gchar* _tmp145_;
	gchar* _tmp146_;
	gchar* _tmp147_;
	SoupEncoding response_body_encoding;
	gboolean _tmp148_;
	RygelPlaySpeedRequest* _tmp149_;
	SoupServerMessage* _tmp150_;
	SoupServerMessage* _tmp151_;
	SoupMessageHeaders* _tmp152_;
	gboolean supports_playspeed;
	gboolean _tmp153_;
	SoupServerMessage* _tmp154_;
	GString* vary_header;
	SoupMessageHeaders* _tmp155_;
	const gchar* _tmp156_;
	GString* _tmp157_;
	GString* _tmp158_;
	GString* _tmp159_;
	GString* _tmp160_;
	GString* _tmp161_;
	GString* _tmp162_;
	GString* _tmp163_;
	SoupServerMessage* _tmp164_;
	SoupMessageHeaders* _tmp165_;
	GString* _tmp166_;
	const gchar* _tmp167_;
	gint response_code;
	SoupServerMessage* _tmp168_;
	SoupMessageHeaders* _tmp169_;
	const gchar* _tmp170_;
	SoupServerMessage* _tmp171_;
	SoupServerMessage* _tmp172_;
	SoupServerMessage* _tmp173_;
	SoupServerMessage* _tmp174_;
	SoupMessageHeaders* _tmp175_;
	SoupServerMessage* _tmp176_;
	SoupMessageHeaders* _tmp177_;
	SoupServerMessage* _tmp178_;
	const gchar* _tmp179_;
	SoupServerMessage* _tmp180_;
	RygelHTTPResponse* _tmp181_;
	GError* _inner_error0_;
};

static gpointer rygel_http_get_parent_class = NULL;

static void rygel_http_get_real_handle_data_free (gpointer _data);
static void rygel_http_get_real_handle (RygelHTTPRequest* base,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static gboolean rygel_http_get_real_handle_co (RygelHttpGetHandleData* _data_);
VALA_EXTERN GType rygel_http_media_resource_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelHTTPMediaResourceHandler* rygel_http_media_resource_handler_new (RygelMediaObject* media_object,
                                                                      const gchar* media_resource_name,
                                                                      GCancellable* cancellable,
                                                                      GError** error);
VALA_EXTERN RygelHTTPMediaResourceHandler* rygel_http_media_resource_handler_construct (GType object_type,
                                                                            RygelMediaObject* media_object,
                                                                            const gchar* media_resource_name,
                                                                            GCancellable* cancellable,
                                                                            GError** error);
VALA_EXTERN GType rygel_http_thumbnail_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelHTTPThumbnailHandler* rygel_http_thumbnail_handler_new (RygelMediaFileItem* media_item,
                                                             gint thumbnail_index,
                                                             GCancellable* cancellable,
                                                             GError** error);
VALA_EXTERN RygelHTTPThumbnailHandler* rygel_http_thumbnail_handler_construct (GType object_type,
                                                                   RygelMediaFileItem* media_item,
                                                                   gint thumbnail_index,
                                                                   GCancellable* cancellable,
                                                                   GError** error);
VALA_EXTERN GType rygel_http_subtitle_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelHTTPSubtitleHandler* rygel_http_subtitle_handler_new (RygelMediaFileItem* media_item,
                                                           gint subtitle_index,
                                                           GCancellable* cancellable,
                                                           GError** error);
VALA_EXTERN RygelHTTPSubtitleHandler* rygel_http_subtitle_handler_construct (GType object_type,
                                                                 RygelMediaFileItem* media_item,
                                                                 gint subtitle_index,
                                                                 GCancellable* cancellable,
                                                                 GError** error);
static void rygel_http_get_handle_item_request (RygelHTTPGet* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void rygel_http_get_handle_item_request_finish (RygelHTTPGet* self,
                                                GAsyncResult* _res_,
                                                GError** error);
static void rygel_http_get_handle_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_);
static void rygel_http_get_real_find_item_data_free (gpointer _data);
static void rygel_http_get_real_find_item (RygelHTTPRequest* base,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static gboolean rygel_http_get_real_find_item_co (RygelHttpGetFindItemData* _data_);
static void rygel_http_get_find_item_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
VALA_EXTERN GType rygel_client_hacks_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void rygel_client_hacks_apply (RygelClientHacks* self,
                               RygelMediaObject* object);
static void rygel_http_get_handle_item_request_data_free (gpointer _data);
static gboolean rygel_http_get_handle_item_request_co (RygelHttpGetHandleItemRequestData* _data_);
VALA_EXTERN gboolean rygel_play_speed_request_requested (RygelHTTPGet* request);
VALA_EXTERN RygelPlaySpeedRequest* rygel_play_speed_request_new_from_request (RygelHTTPGet* request,
                                                                  GError** error);
VALA_EXTERN RygelPlaySpeedRequest* rygel_play_speed_request_construct_from_request (GType object_type,
                                                                        RygelHTTPGet* request,
                                                                        GError** error);
VALA_EXTERN RygelHTTPTimeSeekRequest* rygel_http_time_seek_request_new (SoupServerMessage* message,
                                                            RygelHTTPGetHandler* handler,
                                                            RygelPlaySpeed* speed,
                                                            GError** error);
VALA_EXTERN RygelHTTPTimeSeekRequest* rygel_http_time_seek_request_construct (GType object_type,
                                                                  SoupServerMessage* message,
                                                                  RygelHTTPGetHandler* handler,
                                                                  RygelPlaySpeed* speed,
                                                                  GError** error);
static void __lambda18_ (RygelHTTPGet* self,
                  const gchar* name,
                  const gchar* value);
static void ___lambda18__soup_message_headers_foreach_func (const gchar* name,
                                                     const gchar* value,
                                                     gpointer self);
static void rygel_http_get_handle_item_request_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void rygel_http_get_finalize (GObject * obj);
static GType rygel_http_get_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

RygelHTTPGet*
rygel_http_get_construct (GType object_type,
                          RygelHTTPServer* http_server,
                          SoupServer* server,
                          SoupServerMessage* msg)
{
	RygelHTTPGet * self = NULL;
#line 42 "../src/librygel-server/rygel-http-get.vala"
	g_return_val_if_fail (http_server != NULL, NULL);
#line 42 "../src/librygel-server/rygel-http-get.vala"
	g_return_val_if_fail (server != NULL, NULL);
#line 42 "../src/librygel-server/rygel-http-get.vala"
	g_return_val_if_fail (msg != NULL, NULL);
#line 45 "../src/librygel-server/rygel-http-get.vala"
	self = (RygelHTTPGet*) rygel_http_request_construct (object_type, http_server, server, msg);
#line 42 "../src/librygel-server/rygel-http-get.vala"
	return self;
#line 555 "rygel-http-get.c"
}

RygelHTTPGet*
rygel_http_get_new (RygelHTTPServer* http_server,
                    SoupServer* server,
                    SoupServerMessage* msg)
{
#line 42 "../src/librygel-server/rygel-http-get.vala"
	return rygel_http_get_construct (RYGEL_TYPE_HTTP_GET, http_server, server, msg);
#line 565 "rygel-http-get.c"
}

static void
rygel_http_get_real_handle_data_free (gpointer _data)
{
	RygelHttpGetHandleData* _data_;
	_data_ = _data;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_g_object_unref0 (_data_->self);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	g_slice_free (RygelHttpGetHandleData, _data_);
#line 577 "rygel-http-get.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 34 "../src/librygel-server/rygel-http-get.vala"
	return self ? g_object_ref (self) : NULL;
#line 585 "rygel-http-get.c"
}

static void
rygel_http_get_real_handle (RygelHTTPRequest* base,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	RygelHTTPGet * self;
	RygelHttpGetHandleData* _data_;
	RygelHTTPGet* _tmp0_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	self = (RygelHTTPGet*) base;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_ = g_slice_new0 (RygelHttpGetHandleData);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_http_get_real_handle_data_free);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_->self = _tmp0_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_real_handle_co (_data_);
#line 610 "rygel-http-get.c"
}

static void
rygel_http_get_handle_finish (RygelHTTPRequest* base,
                              GAsyncResult* _res_,
                              GError** error)
{
	RygelHttpGetHandleData* _data_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	if (NULL == _data_) {
#line 34 "../src/librygel-server/rygel-http-get.vala"
		return;
#line 625 "rygel-http-get.c"
	}
}

static gpointer
_soup_message_headers_ref0 (gpointer self)
{
#line 83 "../src/librygel-server/rygel-http-get.vala"
	return self ? soup_message_headers_ref (self) : NULL;
#line 634 "rygel-http-get.c"
}

static void
rygel_http_get_handle_ready (GObject* source_object,
                             GAsyncResult* _res_,
                             gpointer _user_data_)
{
	RygelHttpGetHandleData* _data_;
#line 98 "../src/librygel-server/rygel-http-get.vala"
	_data_ = _user_data_;
#line 98 "../src/librygel-server/rygel-http-get.vala"
	_data_->_source_object_ = source_object;
#line 98 "../src/librygel-server/rygel-http-get.vala"
	_data_->_res_ = _res_;
#line 98 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_real_handle_co (_data_);
#line 651 "rygel-http-get.c"
}

static gboolean
rygel_http_get_real_handle_co (RygelHttpGetHandleData* _data_)
{
#line 48 "../src/librygel-server/rygel-http-get.vala"
	switch (_data_->_state_) {
#line 48 "../src/librygel-server/rygel-http-get.vala"
		case 0:
#line 661 "rygel-http-get.c"
		goto _state_0;
#line 48 "../src/librygel-server/rygel-http-get.vala"
		case 1:
#line 665 "rygel-http-get.c"
		goto _state_1;
		default:
#line 48 "../src/librygel-server/rygel-http-get.vala"
		g_assert_not_reached ();
#line 670 "rygel-http-get.c"
	}
	_state_0:
#line 50 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp1_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 50 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp2_ = soup_server_message_get_method (_data_->_tmp1_);
#line 50 "../src/librygel-server/rygel-http-get.vala"
	if (g_strcmp0 (_data_->_tmp2_, "HEAD") == 0) {
#line 50 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp0_ = TRUE;
#line 681 "rygel-http-get.c"
	} else {
#line 51 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp3_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 51 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp4_ = soup_server_message_get_method (_data_->_tmp3_);
#line 51 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp0_ = g_strcmp0 (_data_->_tmp4_, "GET") == 0;
#line 689 "rygel-http-get.c"
	}
#line 50 "../src/librygel-server/rygel-http-get.vala"
	if (!_data_->_tmp0_) {
#line 52 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp5_ = g_error_new_literal (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_BAD_REQUEST, _ ("Invalid Request (only GET and HEAD supported)"));
#line 52 "../src/librygel-server/rygel-http-get.vala"
		_data_->_inner_error0_ = _data_->_tmp5_;
#line 52 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 52 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 52 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 703 "rygel-http-get.c"
	}
	{
#line 57 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp6_ = g_strdup ("getcontentFeatures.dlna.org");
#line 57 "../src/librygel-server/rygel-http-get.vala"
		_data_->cf_header = _data_->_tmp6_;
#line 58 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp7_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 58 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp8_ = soup_server_message_get_request_headers (_data_->_tmp7_);
#line 58 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp9_ = _data_->cf_header;
#line 58 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp10_ = soup_message_headers_get_one (_data_->_tmp8_, _data_->_tmp9_);
#line 58 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp11_ = g_strdup (_data_->_tmp10_);
#line 58 "../src/librygel-server/rygel-http-get.vala"
		_data_->cf_val = _data_->_tmp11_;
#line 60 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp13_ = _data_->cf_val;
#line 60 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp13_ != NULL) {
#line 60 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp14_ = _data_->cf_val;
#line 60 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp12_ = g_strcmp0 (_data_->_tmp14_, "1") != 0;
#line 730 "rygel-http-get.c"
		} else {
#line 60 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp12_ = FALSE;
#line 734 "rygel-http-get.c"
		}
#line 60 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp12_) {
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp15_ = _data_->cf_header;
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp16_ = g_strconcat (_data_->_tmp15_, " must be 1", NULL);
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp18_ = g_error_new_literal (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_BAD_REQUEST, _ (_data_->_tmp17_));
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->_tmp17_);
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_data_->_inner_error0_ = _data_->_tmp19_;
#line 61 "../src/librygel-server/rygel-http-get.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->cf_val);
#line 61 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->cf_header);
#line 61 "../src/librygel-server/rygel-http-get.vala"
			g_object_unref (_data_->_async_result);
#line 61 "../src/librygel-server/rygel-http-get.vala"
			return FALSE;
#line 762 "rygel-http-get.c"
		}
#line 56 "../src/librygel-server/rygel-http-get.vala"
		_g_free0 (_data_->cf_val);
#line 56 "../src/librygel-server/rygel-http-get.vala"
		_g_free0 (_data_->cf_header);
#line 768 "rygel-http-get.c"
	}
#line 65 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp20_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 65 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp21_ = rygel_http_item_uri_get_resource_name (_data_->_tmp20_);
#line 65 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 65 "../src/librygel-server/rygel-http-get.vala"
	if (_data_->_tmp22_ != NULL) {
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp24_ = ((RygelHTTPRequest*) _data_->self)->object;
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp25_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp26_ = rygel_http_item_uri_get_resource_name (_data_->_tmp25_);
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp27_ = _data_->_tmp26_;
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp28_ = rygel_state_machine_get_cancellable ((RygelStateMachine*) _data_->self);
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp30_ = rygel_http_media_resource_handler_new (_data_->_tmp24_, _data_->_tmp27_, _data_->_tmp29_, &_data_->_inner_error0_);
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp23_ = _data_->_tmp30_;
#line 66 "../src/librygel-server/rygel-http-get.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 66 "../src/librygel-server/rygel-http-get.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 66 "../src/librygel-server/rygel-http-get.vala"
			g_object_unref (_data_->_async_result);
#line 66 "../src/librygel-server/rygel-http-get.vala"
			return FALSE;
#line 802 "rygel-http-get.c"
		}
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp31_ = _data_->_tmp23_;
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp23_ = NULL;
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_g_object_unref0 (_data_->self->handler);
#line 66 "../src/librygel-server/rygel-http-get.vala"
		_data_->self->handler = (RygelHTTPGetHandler*) _data_->_tmp31_;
#line 65 "../src/librygel-server/rygel-http-get.vala"
		_g_object_unref0 (_data_->_tmp23_);
#line 814 "rygel-http-get.c"
	} else {
#line 69 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp32_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 69 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp33_ = rygel_http_item_uri_get_thumbnail_index (_data_->_tmp32_);
#line 69 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp34_ = _data_->_tmp33_;
#line 69 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp34_ >= 0) {
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp36_ = ((RygelHTTPRequest*) _data_->self)->object;
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp37_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp38_ = rygel_http_item_uri_get_thumbnail_index (_data_->_tmp37_);
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp39_ = _data_->_tmp38_;
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp40_ = rygel_state_machine_get_cancellable ((RygelStateMachine*) _data_->self);
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp41_ = _data_->_tmp40_;
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp42_ = rygel_http_thumbnail_handler_new (RYGEL_IS_MEDIA_FILE_ITEM (_data_->_tmp36_) ? ((RygelMediaFileItem*) _data_->_tmp36_) : NULL, _data_->_tmp39_, _data_->_tmp41_, &_data_->_inner_error0_);
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp35_ = _data_->_tmp42_;
#line 70 "../src/librygel-server/rygel-http-get.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 70 "../src/librygel-server/rygel-http-get.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 70 "../src/librygel-server/rygel-http-get.vala"
				g_object_unref (_data_->_async_result);
#line 70 "../src/librygel-server/rygel-http-get.vala"
				return FALSE;
#line 848 "rygel-http-get.c"
			}
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp43_ = _data_->_tmp35_;
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp35_ = NULL;
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_g_object_unref0 (_data_->self->handler);
#line 70 "../src/librygel-server/rygel-http-get.vala"
			_data_->self->handler = (RygelHTTPGetHandler*) _data_->_tmp43_;
#line 69 "../src/librygel-server/rygel-http-get.vala"
			_g_object_unref0 (_data_->_tmp35_);
#line 860 "rygel-http-get.c"
		} else {
#line 73 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp44_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 73 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp45_ = rygel_http_item_uri_get_subtitle_index (_data_->_tmp44_);
#line 73 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp46_ = _data_->_tmp45_;
#line 73 "../src/librygel-server/rygel-http-get.vala"
			if (_data_->_tmp46_ >= 0) {
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp48_ = ((RygelHTTPRequest*) _data_->self)->object;
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp49_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp50_ = rygel_http_item_uri_get_subtitle_index (_data_->_tmp49_);
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp51_ = _data_->_tmp50_;
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp52_ = rygel_state_machine_get_cancellable ((RygelStateMachine*) _data_->self);
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp53_ = _data_->_tmp52_;
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp54_ = rygel_http_subtitle_handler_new (RYGEL_IS_MEDIA_FILE_ITEM (_data_->_tmp48_) ? ((RygelMediaFileItem*) _data_->_tmp48_) : NULL, _data_->_tmp51_, _data_->_tmp53_, &_data_->_inner_error0_);
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp47_ = _data_->_tmp54_;
#line 74 "../src/librygel-server/rygel-http-get.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 74 "../src/librygel-server/rygel-http-get.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 74 "../src/librygel-server/rygel-http-get.vala"
					g_object_unref (_data_->_async_result);
#line 74 "../src/librygel-server/rygel-http-get.vala"
					return FALSE;
#line 894 "rygel-http-get.c"
				}
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp55_ = _data_->_tmp47_;
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp47_ = NULL;
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_g_object_unref0 (_data_->self->handler);
#line 74 "../src/librygel-server/rygel-http-get.vala"
				_data_->self->handler = (RygelHTTPGetHandler*) _data_->_tmp55_;
#line 73 "../src/librygel-server/rygel-http-get.vala"
				_g_object_unref0 (_data_->_tmp47_);
#line 906 "rygel-http-get.c"
			} else {
#line 78 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp56_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 78 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp57_ = rygel_http_item_uri_to_string (_data_->_tmp56_);
#line 78 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp58_ = _data_->_tmp57_;
#line 78 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp59_ = g_error_new (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_NOT_FOUND, "No handler found for '%s'", _data_->_tmp58_);
#line 78 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp60_ = _data_->_tmp59_;
#line 78 "../src/librygel-server/rygel-http-get.vala"
				_g_free0 (_data_->_tmp58_);
#line 78 "../src/librygel-server/rygel-http-get.vala"
				_data_->_inner_error0_ = _data_->_tmp60_;
#line 78 "../src/librygel-server/rygel-http-get.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 78 "../src/librygel-server/rygel-http-get.vala"
				g_object_unref (_data_->_async_result);
#line 78 "../src/librygel-server/rygel-http-get.vala"
				return FALSE;
#line 928 "rygel-http-get.c"
			}
		}
	}
	{
#line 83 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp61_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 83 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp62_ = soup_server_message_get_request_headers (_data_->_tmp61_);
#line 83 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp63_ = _soup_message_headers_ref0 (_data_->_tmp62_);
#line 83 "../src/librygel-server/rygel-http-get.vala"
		_data_->headers = _data_->_tmp63_;
#line 84 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp64_ = _data_->headers;
#line 84 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp65_ = soup_message_headers_get_one (_data_->_tmp64_, RYGEL_HTTP_GET_TRANSFER_MODE_HEADER);
#line 84 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp66_ = g_strdup (_data_->_tmp65_);
#line 84 "../src/librygel-server/rygel-http-get.vala"
		_data_->transfer_mode = _data_->_tmp66_;
#line 86 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp67_ = _data_->transfer_mode;
#line 86 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp67_ == NULL) {
#line 87 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp68_ = _data_->self->handler;
#line 87 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp69_ = rygel_http_get_handler_get_default_transfer_mode (_data_->_tmp68_);
#line 87 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->transfer_mode);
#line 87 "../src/librygel-server/rygel-http-get.vala"
			_data_->transfer_mode = _data_->_tmp69_;
#line 961 "rygel-http-get.c"
		}
#line 90 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp70_ = _data_->self->handler;
#line 90 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp71_ = _data_->transfer_mode;
#line 90 "../src/librygel-server/rygel-http-get.vala"
		if (!rygel_http_get_handler_supports_transfer_mode (_data_->_tmp70_, _data_->_tmp71_)) {
#line 91 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp72_ = g_strdup (_ ("%s transfer mode not supported for '%s'"));
#line 91 "../src/librygel-server/rygel-http-get.vala"
			_data_->msg = _data_->_tmp72_;
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp73_ = _data_->msg;
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp74_ = _data_->transfer_mode;
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp75_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp76_ = rygel_http_item_uri_to_string (_data_->_tmp75_);
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp77_ = _data_->_tmp76_;
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp78_ = g_error_new (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_UNACCEPTABLE, _data_->_tmp73_, _data_->_tmp74_, _data_->_tmp77_);
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp79_ = _data_->_tmp78_;
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->_tmp77_);
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_data_->_inner_error0_ = _data_->_tmp79_;
#line 92 "../src/librygel-server/rygel-http-get.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->msg);
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->transfer_mode);
#line 92 "../src/librygel-server/rygel-http-get.vala"
			_soup_message_headers_unref0 (_data_->headers);
#line 92 "../src/librygel-server/rygel-http-get.vala"
			g_object_unref (_data_->_async_result);
#line 92 "../src/librygel-server/rygel-http-get.vala"
			return FALSE;
#line 1003 "rygel-http-get.c"
		}
#line 82 "../src/librygel-server/rygel-http-get.vala"
		_g_free0 (_data_->transfer_mode);
#line 82 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->headers);
#line 1009 "rygel-http-get.c"
	}
#line 98 "../src/librygel-server/rygel-http-get.vala"
	_data_->_state_ = 1;
#line 98 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_handle_item_request (_data_->self, rygel_http_get_handle_ready, _data_);
#line 98 "../src/librygel-server/rygel-http-get.vala"
	return FALSE;
#line 1017 "rygel-http-get.c"
	_state_1:
#line 98 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_handle_item_request_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 98 "../src/librygel-server/rygel-http-get.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 98 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 98 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 98 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 1029 "rygel-http-get.c"
	}
#line 48 "../src/librygel-server/rygel-http-get.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 48 "../src/librygel-server/rygel-http-get.vala"
	if (_data_->_state_ != 0) {
#line 48 "../src/librygel-server/rygel-http-get.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 48 "../src/librygel-server/rygel-http-get.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1039 "rygel-http-get.c"
		}
	}
#line 48 "../src/librygel-server/rygel-http-get.vala"
	g_object_unref (_data_->_async_result);
#line 48 "../src/librygel-server/rygel-http-get.vala"
	return FALSE;
#line 1046 "rygel-http-get.c"
}

static void
rygel_http_get_real_find_item_data_free (gpointer _data)
{
	RygelHttpGetFindItemData* _data_;
	_data_ = _data;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_g_object_unref0 (_data_->self);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	g_slice_free (RygelHttpGetFindItemData, _data_);
#line 1058 "rygel-http-get.c"
}

static void
rygel_http_get_real_find_item (RygelHTTPRequest* base,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	RygelHTTPGet * self;
	RygelHttpGetFindItemData* _data_;
	RygelHTTPGet* _tmp0_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	self = (RygelHTTPGet*) base;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_ = g_slice_new0 (RygelHttpGetFindItemData);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_http_get_real_find_item_data_free);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_->self = _tmp0_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_real_find_item_co (_data_);
#line 1083 "rygel-http-get.c"
}

static void
rygel_http_get_find_item_finish (RygelHTTPRequest* base,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	RygelHttpGetFindItemData* _data_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	if (NULL == _data_) {
#line 34 "../src/librygel-server/rygel-http-get.vala"
		return;
#line 1098 "rygel-http-get.c"
	}
}

static void
rygel_http_get_find_item_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	RygelHttpGetFindItemData* _data_;
#line 102 "../src/librygel-server/rygel-http-get.vala"
	_data_ = _user_data_;
#line 102 "../src/librygel-server/rygel-http-get.vala"
	_data_->_source_object_ = source_object;
#line 102 "../src/librygel-server/rygel-http-get.vala"
	_data_->_res_ = _res_;
#line 102 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_real_find_item_co (_data_);
#line 1116 "rygel-http-get.c"
}

static gboolean
rygel_http_get_real_find_item_co (RygelHttpGetFindItemData* _data_)
{
#line 101 "../src/librygel-server/rygel-http-get.vala"
	switch (_data_->_state_) {
#line 101 "../src/librygel-server/rygel-http-get.vala"
		case 0:
#line 1126 "rygel-http-get.c"
		goto _state_0;
#line 101 "../src/librygel-server/rygel-http-get.vala"
		case 1:
#line 1130 "rygel-http-get.c"
		goto _state_1;
		default:
#line 101 "../src/librygel-server/rygel-http-get.vala"
		g_assert_not_reached ();
#line 1135 "rygel-http-get.c"
	}
	_state_0:
#line 102 "../src/librygel-server/rygel-http-get.vala"
	_data_->_state_ = 1;
#line 102 "../src/librygel-server/rygel-http-get.vala"
	RYGEL_HTTP_REQUEST_CLASS (rygel_http_get_parent_class)->find_item (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, RYGEL_TYPE_HTTP_REQUEST, RygelHTTPRequest), rygel_http_get_find_item_ready, _data_);
#line 102 "../src/librygel-server/rygel-http-get.vala"
	return FALSE;
#line 1144 "rygel-http-get.c"
	_state_1:
#line 102 "../src/librygel-server/rygel-http-get.vala"
	RYGEL_HTTP_REQUEST_CLASS (rygel_http_get_parent_class)->find_item_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, RYGEL_TYPE_HTTP_REQUEST, RygelHTTPRequest), _data_->_res_, &_data_->_inner_error0_);
#line 102 "../src/librygel-server/rygel-http-get.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 102 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 102 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 102 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 1156 "rygel-http-get.c"
	}
#line 105 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp0_ = ((RygelHTTPRequest*) _data_->self)->object;
#line 105 "../src/librygel-server/rygel-http-get.vala"
	if (RYGEL_IS_MEDIA_CONTAINER (_data_->_tmp0_)) {
#line 106 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 106 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_state_ != 0) {
#line 106 "../src/librygel-server/rygel-http-get.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 106 "../src/librygel-server/rygel-http-get.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1170 "rygel-http-get.c"
			}
		}
#line 106 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 106 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 1177 "rygel-http-get.c"
	}
#line 109 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp1_ = ((RygelHTTPRequest*) _data_->self)->object;
#line 109 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp2_ = _g_object_ref0 (RYGEL_IS_MEDIA_FILE_ITEM (_data_->_tmp1_) ? ((RygelMediaFileItem*) _data_->_tmp1_) : NULL);
#line 109 "../src/librygel-server/rygel-http-get.vala"
	_data_->item = _data_->_tmp2_;
#line 110 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp4_ = _data_->item;
#line 110 "../src/librygel-server/rygel-http-get.vala"
	if (_data_->_tmp4_ != NULL) {
#line 110 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp5_ = _data_->item;
#line 110 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp6_ = rygel_media_file_item_get_place_holder (_data_->_tmp5_);
#line 110 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 110 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp3_ = _data_->_tmp7_;
#line 1197 "rygel-http-get.c"
	} else {
#line 110 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp3_ = FALSE;
#line 1201 "rygel-http-get.c"
	}
#line 110 "../src/librygel-server/rygel-http-get.vala"
	if (_data_->_tmp3_) {
#line 111 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp8_ = ((RygelHTTPRequest*) _data_->self)->object;
#line 111 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp9_ = rygel_media_object_get_id (_data_->_tmp8_);
#line 111 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 111 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp11_ = g_error_new (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_NOT_FOUND, "Item '%s' is empty", _data_->_tmp10_);
#line 111 "../src/librygel-server/rygel-http-get.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 111 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 111 "../src/librygel-server/rygel-http-get.vala"
		_g_object_unref0 (_data_->item);
#line 111 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 111 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 1223 "rygel-http-get.c"
	}
#line 115 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp12_ = ((RygelHTTPRequest*) _data_->self)->hack;
#line 115 "../src/librygel-server/rygel-http-get.vala"
	if (_data_->_tmp12_ != NULL) {
#line 116 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp13_ = ((RygelHTTPRequest*) _data_->self)->hack;
#line 116 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp14_ = ((RygelHTTPRequest*) _data_->self)->object;
#line 116 "../src/librygel-server/rygel-http-get.vala"
		rygel_client_hacks_apply (_data_->_tmp13_, _data_->_tmp14_);
#line 1235 "rygel-http-get.c"
	}
#line 101 "../src/librygel-server/rygel-http-get.vala"
	_g_object_unref0 (_data_->item);
#line 101 "../src/librygel-server/rygel-http-get.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 101 "../src/librygel-server/rygel-http-get.vala"
	if (_data_->_state_ != 0) {
#line 101 "../src/librygel-server/rygel-http-get.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 101 "../src/librygel-server/rygel-http-get.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1247 "rygel-http-get.c"
		}
	}
#line 101 "../src/librygel-server/rygel-http-get.vala"
	g_object_unref (_data_->_async_result);
#line 101 "../src/librygel-server/rygel-http-get.vala"
	return FALSE;
#line 1254 "rygel-http-get.c"
}

static void
rygel_http_get_handle_item_request_data_free (gpointer _data)
{
	RygelHttpGetHandleItemRequestData* _data_;
	_data_ = _data;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_g_object_unref0 (_data_->self);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	g_slice_free (RygelHttpGetHandleItemRequestData, _data_);
#line 1266 "rygel-http-get.c"
}

static void
rygel_http_get_handle_item_request (RygelHTTPGet* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	RygelHttpGetHandleItemRequestData* _data_;
	RygelHTTPGet* _tmp0_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_ = g_slice_new0 (RygelHttpGetHandleItemRequestData);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_http_get_handle_item_request_data_free);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_->self = _tmp0_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_handle_item_request_co (_data_);
#line 1290 "rygel-http-get.c"
}

static void
rygel_http_get_handle_item_request_finish (RygelHTTPGet* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	RygelHttpGetHandleItemRequestData* _data_;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	if (NULL == _data_) {
#line 34 "../src/librygel-server/rygel-http-get.vala"
		return;
#line 1305 "rygel-http-get.c"
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 190 "../src/librygel-server/rygel-http-get.vala"
	return self ? g_error_copy (self) : NULL;
#line 1314 "rygel-http-get.c"
}

static gpointer
_rygel_play_speed_ref0 (gpointer self)
{
#line 211 "../src/librygel-server/rygel-http-get.vala"
	return self ? rygel_play_speed_ref (self) : NULL;
#line 1322 "rygel-http-get.c"
}

static void
__lambda18_ (RygelHTTPGet* self,
             const gchar* name,
             const gchar* value)
{
#line 353 "../src/librygel-server/rygel-http-get.vala"
	g_return_if_fail (name != NULL);
#line 353 "../src/librygel-server/rygel-http-get.vala"
	g_return_if_fail (value != NULL);
#line 354 "../src/librygel-server/rygel-http-get.vala"
	g_debug ("rygel-http-get.vala:354:     %s : %s", name, value);
#line 1336 "rygel-http-get.c"
}

static void
___lambda18__soup_message_headers_foreach_func (const gchar* name,
                                                const gchar* value,
                                                gpointer self)
{
#line 353 "../src/librygel-server/rygel-http-get.vala"
	__lambda18_ ((RygelHTTPGet*) self, name, value);
#line 1346 "rygel-http-get.c"
}

static void
rygel_http_get_handle_item_request_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	RygelHttpGetHandleItemRequestData* _data_;
#line 364 "../src/librygel-server/rygel-http-get.vala"
	_data_ = _user_data_;
#line 364 "../src/librygel-server/rygel-http-get.vala"
	_data_->_source_object_ = source_object;
#line 364 "../src/librygel-server/rygel-http-get.vala"
	_data_->_res_ = _res_;
#line 364 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_handle_item_request_co (_data_);
#line 1363 "rygel-http-get.c"
}

static gboolean
rygel_http_get_handle_item_request_co (RygelHttpGetHandleItemRequestData* _data_)
{
#line 120 "../src/librygel-server/rygel-http-get.vala"
	switch (_data_->_state_) {
#line 120 "../src/librygel-server/rygel-http-get.vala"
		case 0:
#line 1373 "rygel-http-get.c"
		goto _state_0;
#line 120 "../src/librygel-server/rygel-http-get.vala"
		case 1:
#line 1377 "rygel-http-get.c"
		goto _state_1;
		default:
#line 120 "../src/librygel-server/rygel-http-get.vala"
		g_assert_not_reached ();
#line 1382 "rygel-http-get.c"
	}
	_state_0:
#line 121 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp0_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 121 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp1_ = _data_->self->handler;
#line 121 "../src/librygel-server/rygel-http-get.vala"
	_data_->supports_time_seek = rygel_http_time_seek_request_supported (_data_->_tmp0_, _data_->_tmp1_);
#line 123 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp2_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 123 "../src/librygel-server/rygel-http-get.vala"
	_data_->requested_time_seek = rygel_http_time_seek_request_requested (_data_->_tmp2_);
#line 124 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp3_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 124 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp4_ = _data_->self->handler;
#line 124 "../src/librygel-server/rygel-http-get.vala"
	_data_->supports_byte_seek = rygel_http_byte_seek_request_supported (_data_->_tmp3_, _data_->_tmp4_);
#line 126 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp5_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 126 "../src/librygel-server/rygel-http-get.vala"
	_data_->requested_byte_seek = rygel_http_byte_seek_request_requested (_data_->_tmp5_);
#line 127 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp6_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 127 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp7_ = _data_->self->handler;
#line 127 "../src/librygel-server/rygel-http-get.vala"
	_data_->supports_cleartext_seek = rygel_dtcp_cleartext_request_supported (_data_->_tmp6_, _data_->_tmp7_);
#line 129 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp8_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 129 "../src/librygel-server/rygel-http-get.vala"
	_data_->requested_cleartext_seek = rygel_dtcp_cleartext_request_requested (_data_->_tmp8_);
#line 132 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp9_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 132 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp10_ = soup_server_message_get_response_headers (_data_->_tmp9_);
#line 132 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp11_ = _soup_message_headers_ref0 (_data_->_tmp10_);
#line 132 "../src/librygel-server/rygel-http-get.vala"
	_data_->response_headers = _data_->_tmp11_;
#line 136 "../src/librygel-server/rygel-http-get.vala"
	if (_data_->requested_cleartext_seek) {
#line 137 "../src/librygel-server/rygel-http-get.vala"
		if (!_data_->supports_cleartext_seek) {
#line 138 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp12_ = g_strdup ("Cleartext seek not supported for %s");
#line 138 "../src/librygel-server/rygel-http-get.vala"
			_data_->msg = _data_->_tmp12_;
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp13_ = _data_->msg;
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp14_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp15_ = rygel_http_item_uri_to_string (_data_->_tmp14_);
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp16_ = _data_->_tmp15_;
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp17_ = g_error_new (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_UNACCEPTABLE, _data_->_tmp13_, _data_->_tmp16_);
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->_tmp16_);
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_data_->_inner_error0_ = _data_->_tmp18_;
#line 139 "../src/librygel-server/rygel-http-get.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->msg);
#line 139 "../src/librygel-server/rygel-http-get.vala"
			_soup_message_headers_unref0 (_data_->response_headers);
#line 139 "../src/librygel-server/rygel-http-get.vala"
			g_object_unref (_data_->_async_result);
#line 139 "../src/librygel-server/rygel-http-get.vala"
			return FALSE;
#line 1457 "rygel-http-get.c"
		}
#line 142 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->requested_byte_seek) {
#line 143 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp19_ = g_strdup ("Both Cleartext and Range seek requested for %s");
#line 143 "../src/librygel-server/rygel-http-get.vala"
			_data_->_vala1_msg = _data_->_tmp19_;
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp20_ = _data_->_vala1_msg;
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp21_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp22_ = rygel_http_item_uri_to_string (_data_->_tmp21_);
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp23_ = _data_->_tmp22_;
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp24_ = g_error_new (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_UNACCEPTABLE, _data_->_tmp20_, _data_->_tmp23_);
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->_tmp23_);
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_data_->_inner_error0_ = _data_->_tmp25_;
#line 145 "../src/librygel-server/rygel-http-get.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->_vala1_msg);
#line 145 "../src/librygel-server/rygel-http-get.vala"
			_soup_message_headers_unref0 (_data_->response_headers);
#line 145 "../src/librygel-server/rygel-http-get.vala"
			g_object_unref (_data_->_async_result);
#line 145 "../src/librygel-server/rygel-http-get.vala"
			return FALSE;
#line 1491 "rygel-http-get.c"
		}
	} else {
#line 148 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->requested_byte_seek) {
#line 149 "../src/librygel-server/rygel-http-get.vala"
			if (!_data_->supports_byte_seek) {
#line 150 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp26_ = g_strdup ("Byte seek not supported for %s");
#line 150 "../src/librygel-server/rygel-http-get.vala"
				_data_->_vala2_msg = _data_->_tmp26_;
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp27_ = _data_->_vala2_msg;
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp28_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp29_ = rygel_http_item_uri_to_string (_data_->_tmp28_);
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp30_ = _data_->_tmp29_;
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp31_ = g_error_new (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_UNACCEPTABLE, _data_->_tmp27_, _data_->_tmp30_);
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp32_ = _data_->_tmp31_;
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_g_free0 (_data_->_tmp30_);
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_data_->_inner_error0_ = _data_->_tmp32_;
#line 151 "../src/librygel-server/rygel-http-get.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_g_free0 (_data_->_vala2_msg);
#line 151 "../src/librygel-server/rygel-http-get.vala"
				_soup_message_headers_unref0 (_data_->response_headers);
#line 151 "../src/librygel-server/rygel-http-get.vala"
				g_object_unref (_data_->_async_result);
#line 151 "../src/librygel-server/rygel-http-get.vala"
				return FALSE;
#line 1528 "rygel-http-get.c"
			}
		} else {
#line 154 "../src/librygel-server/rygel-http-get.vala"
			if (_data_->requested_time_seek) {
#line 155 "../src/librygel-server/rygel-http-get.vala"
				if (!_data_->supports_time_seek) {
#line 156 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp33_ = g_strdup ("Time seek not supported for %s");
#line 156 "../src/librygel-server/rygel-http-get.vala"
					_data_->_vala3_msg = _data_->_tmp33_;
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp34_ = _data_->_vala3_msg;
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp35_ = ((RygelHTTPRequest*) _data_->self)->uri;
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp36_ = rygel_http_item_uri_to_string (_data_->_tmp35_);
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp37_ = _data_->_tmp36_;
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp38_ = g_error_new (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_UNACCEPTABLE, _data_->_tmp34_, _data_->_tmp37_);
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp39_ = _data_->_tmp38_;
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_g_free0 (_data_->_tmp37_);
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_data_->_inner_error0_ = _data_->_tmp39_;
#line 157 "../src/librygel-server/rygel-http-get.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_g_free0 (_data_->_vala3_msg);
#line 157 "../src/librygel-server/rygel-http-get.vala"
					_soup_message_headers_unref0 (_data_->response_headers);
#line 157 "../src/librygel-server/rygel-http-get.vala"
					g_object_unref (_data_->_async_result);
#line 157 "../src/librygel-server/rygel-http-get.vala"
					return FALSE;
#line 1565 "rygel-http-get.c"
				}
			}
		}
	}
	{
#line 169 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->requested_byte_seek) {
#line 169 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp41_ = TRUE;
#line 1575 "rygel-http-get.c"
		} else {
#line 169 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp41_ = _data_->requested_cleartext_seek;
#line 1579 "rygel-http-get.c"
		}
#line 169 "../src/librygel-server/rygel-http-get.vala"
		if (!_data_->_tmp41_) {
#line 170 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp40_ = rygel_play_speed_request_requested (_data_->self);
#line 1585 "rygel-http-get.c"
		} else {
#line 169 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp40_ = FALSE;
#line 1589 "rygel-http-get.c"
		}
#line 169 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp40_) {
#line 171 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp43_ = rygel_play_speed_request_new_from_request (_data_->self, &_data_->_inner_error0_);
#line 171 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp42_ = _data_->_tmp43_;
#line 171 "../src/librygel-server/rygel-http-get.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 171 "../src/librygel-server/rygel-http-get.vala"
				if (_data_->_inner_error0_->domain == RYGEL_PLAY_SPEED_ERROR) {
#line 1601 "rygel-http-get.c"
					goto __catch0_rygel_play_speed_error;
				}
#line 171 "../src/librygel-server/rygel-http-get.vala"
				_soup_message_headers_unref0 (_data_->response_headers);
#line 171 "../src/librygel-server/rygel-http-get.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 171 "../src/librygel-server/rygel-http-get.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 171 "../src/librygel-server/rygel-http-get.vala"
				g_object_unref (_data_->_async_result);
#line 171 "../src/librygel-server/rygel-http-get.vala"
				return FALSE;
#line 1614 "rygel-http-get.c"
			}
#line 171 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp44_ = _data_->_tmp42_;
#line 171 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp42_ = NULL;
#line 171 "../src/librygel-server/rygel-http-get.vala"
			_g_object_unref0 (_data_->self->speed_request);
#line 171 "../src/librygel-server/rygel-http-get.vala"
			_data_->self->speed_request = _data_->_tmp44_;
#line 172 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp45_ = _data_->self->speed_request;
#line 172 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp46_ = rygel_play_speed_request_get_speed (_data_->_tmp45_);
#line 172 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp47_ = _data_->_tmp46_;
#line 172 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp48_ = rygel_play_speed_to_string (_data_->_tmp47_);
#line 172 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp49_ = _data_->_tmp48_;
#line 172 "../src/librygel-server/rygel-http-get.vala"
			g_debug ("rygel-http-get.vala:172: Processing playspeed %s", _data_->_tmp49_);
#line 172 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->_tmp49_);
#line 173 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp50_ = _data_->self->speed_request;
#line 173 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp51_ = rygel_play_speed_request_get_speed (_data_->_tmp50_);
#line 173 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp52_ = _data_->_tmp51_;
#line 173 "../src/librygel-server/rygel-http-get.vala"
			if (rygel_play_speed_is_normal_rate (_data_->_tmp52_)) {
#line 176 "../src/librygel-server/rygel-http-get.vala"
				_g_object_unref0 (_data_->self->speed_request);
#line 176 "../src/librygel-server/rygel-http-get.vala"
				_data_->self->speed_request = NULL;
#line 1650 "rygel-http-get.c"
			}
#line 169 "../src/librygel-server/rygel-http-get.vala"
			_g_object_unref0 (_data_->_tmp42_);
#line 1654 "rygel-http-get.c"
		} else {
#line 179 "../src/librygel-server/rygel-http-get.vala"
			_g_object_unref0 (_data_->self->speed_request);
#line 179 "../src/librygel-server/rygel-http-get.vala"
			_data_->self->speed_request = NULL;
#line 1660 "rygel-http-get.c"
		}
	}
	goto __finally0;
	__catch0_rygel_play_speed_error:
	{
#line 168 "../src/librygel-server/rygel-http-get.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 168 "../src/librygel-server/rygel-http-get.vala"
		_data_->_inner_error0_ = NULL;
#line 182 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp53_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 182 "../src/librygel-server/rygel-http-get.vala"
		soup_server_message_unpause (_data_->_tmp53_);
#line 183 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp54_ = _data_->_error_;
#line 183 "../src/librygel-server/rygel-http-get.vala"
		if (g_error_matches (_data_->_tmp54_, RYGEL_PLAY_SPEED_ERROR, RYGEL_PLAY_SPEED_ERROR_INVALID_SPEED_FORMAT)) {
#line 184 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp55_ = _data_->_error_;
#line 184 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp56_ = _data_->_tmp55_->message;
#line 184 "../src/librygel-server/rygel-http-get.vala"
			rygel_http_request_end ((RygelHTTPRequest*) _data_->self, (guint) SOUP_STATUS_BAD_REQUEST, _data_->_tmp56_);
#line 1684 "rygel-http-get.c"
		} else {
#line 186 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp57_ = _data_->_error_;
#line 186 "../src/librygel-server/rygel-http-get.vala"
			if (g_error_matches (_data_->_tmp57_, RYGEL_PLAY_SPEED_ERROR, RYGEL_PLAY_SPEED_ERROR_SPEED_NOT_PRESENT)) {
#line 187 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp58_ = _data_->_error_;
#line 187 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp59_ = _data_->_tmp58_->message;
#line 187 "../src/librygel-server/rygel-http-get.vala"
				rygel_http_request_end ((RygelHTTPRequest*) _data_->self, (guint) SOUP_STATUS_NOT_ACCEPTABLE, _data_->_tmp59_);
#line 1696 "rygel-http-get.c"
			} else {
#line 190 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp60_ = _data_->_error_;
#line 190 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp61_ = _g_error_copy0 (_data_->_tmp60_);
#line 190 "../src/librygel-server/rygel-http-get.vala"
				_data_->_inner_error0_ = _data_->_tmp61_;
#line 190 "../src/librygel-server/rygel-http-get.vala"
				_g_error_free0 (_data_->_error_);
#line 1706 "rygel-http-get.c"
				goto __finally0;
			}
		}
#line 192 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp62_ = _data_->_error_;
#line 192 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp63_ = _data_->_tmp62_->message;
#line 192 "../src/librygel-server/rygel-http-get.vala"
		g_warning ("rygel-http-get.vala:192: Error processing PlaySpeed: %s", _data_->_tmp63_);
#line 194 "../src/librygel-server/rygel-http-get.vala"
		_g_error_free0 (_data_->_error_);
#line 194 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 194 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 194 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_state_ != 0) {
#line 194 "../src/librygel-server/rygel-http-get.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 194 "../src/librygel-server/rygel-http-get.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1728 "rygel-http-get.c"
			}
		}
#line 194 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 194 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 1735 "rygel-http-get.c"
	}
	__finally0:
#line 168 "../src/librygel-server/rygel-http-get.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 168 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 168 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 168 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 168 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 1748 "rygel-http-get.c"
	}
	{
#line 198 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->supports_cleartext_seek) {
#line 198 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp64_ = _data_->requested_cleartext_seek;
#line 1755 "rygel-http-get.c"
		} else {
#line 198 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp64_ = FALSE;
#line 1759 "rygel-http-get.c"
		}
#line 198 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp64_) {
#line 199 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp65_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 199 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp66_ = _data_->self->handler;
#line 199 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp67_ = rygel_dtcp_cleartext_request_new (_data_->_tmp65_, _data_->_tmp66_, &_data_->_inner_error0_);
#line 199 "../src/librygel-server/rygel-http-get.vala"
			_data_->cleartext_seek = _data_->_tmp67_;
#line 199 "../src/librygel-server/rygel-http-get.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 199 "../src/librygel-server/rygel-http-get.vala"
				if (_data_->_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 1775 "rygel-http-get.c"
					goto __catch1_rygel_http_seek_request_error;
				}
				goto __finally1;
			}
#line 201 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp68_ = _data_->cleartext_seek;
#line 201 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp69_ = rygel_dtcp_cleartext_request_get_start_byte (_data_->_tmp68_);
#line 201 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp70_ = _data_->_tmp69_;
#line 201 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp71_ = _data_->cleartext_seek;
#line 201 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp72_ = rygel_dtcp_cleartext_request_get_end_byte (_data_->_tmp71_);
#line 201 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp73_ = _data_->_tmp72_;
#line 201 "../src/librygel-server/rygel-http-get.vala"
			g_debug ("rygel-http-get.vala:201: Processing DTCP cleartext byte range request " \
"(bytes %lld to %lld)", _data_->_tmp70_, _data_->_tmp73_);
#line 203 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp74_ = _data_->cleartext_seek;
#line 203 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp75_ = _g_object_ref0 ((RygelHTTPSeekRequest*) _data_->_tmp74_);
#line 203 "../src/librygel-server/rygel-http-get.vala"
			_g_object_unref0 (_data_->self->seek);
#line 203 "../src/librygel-server/rygel-http-get.vala"
			_data_->self->seek = _data_->_tmp75_;
#line 198 "../src/librygel-server/rygel-http-get.vala"
			_g_object_unref0 (_data_->cleartext_seek);
#line 1804 "rygel-http-get.c"
		} else {
#line 204 "../src/librygel-server/rygel-http-get.vala"
			if (_data_->supports_byte_seek) {
#line 204 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp76_ = _data_->requested_byte_seek;
#line 1810 "rygel-http-get.c"
			} else {
#line 204 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp76_ = FALSE;
#line 1814 "rygel-http-get.c"
			}
#line 204 "../src/librygel-server/rygel-http-get.vala"
			if (_data_->_tmp76_) {
#line 205 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp77_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 205 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp78_ = _data_->self->handler;
#line 205 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp79_ = rygel_http_byte_seek_request_new (_data_->_tmp77_, _data_->_tmp78_, &_data_->_inner_error0_);
#line 205 "../src/librygel-server/rygel-http-get.vala"
				_data_->byte_seek = _data_->_tmp79_;
#line 205 "../src/librygel-server/rygel-http-get.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 205 "../src/librygel-server/rygel-http-get.vala"
					if (_data_->_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 1830 "rygel-http-get.c"
						goto __catch1_rygel_http_seek_request_error;
					}
					goto __finally1;
				}
#line 206 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp80_ = _data_->byte_seek;
#line 206 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp81_ = rygel_http_byte_seek_request_get_start_byte (_data_->_tmp80_);
#line 206 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp82_ = _data_->_tmp81_;
#line 206 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp83_ = _data_->byte_seek;
#line 206 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp84_ = rygel_http_byte_seek_request_get_end_byte (_data_->_tmp83_);
#line 206 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp85_ = _data_->_tmp84_;
#line 206 "../src/librygel-server/rygel-http-get.vala"
				g_debug ("rygel-http-get.vala:206: Processing byte range request (bytes %lld to " \
"%lld)", _data_->_tmp82_, _data_->_tmp85_);
#line 208 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp86_ = _data_->byte_seek;
#line 208 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp87_ = _g_object_ref0 ((RygelHTTPSeekRequest*) _data_->_tmp86_);
#line 208 "../src/librygel-server/rygel-http-get.vala"
				_g_object_unref0 (_data_->self->seek);
#line 208 "../src/librygel-server/rygel-http-get.vala"
				_data_->self->seek = _data_->_tmp87_;
#line 204 "../src/librygel-server/rygel-http-get.vala"
				_g_object_unref0 (_data_->byte_seek);
#line 1859 "rygel-http-get.c"
			} else {
#line 209 "../src/librygel-server/rygel-http-get.vala"
				if (_data_->supports_time_seek) {
#line 209 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp88_ = _data_->requested_time_seek;
#line 1865 "rygel-http-get.c"
				} else {
#line 209 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp88_ = FALSE;
#line 1869 "rygel-http-get.c"
				}
#line 209 "../src/librygel-server/rygel-http-get.vala"
				if (_data_->_tmp88_) {
#line 211 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp90_ = _data_->self->speed_request;
#line 211 "../src/librygel-server/rygel-http-get.vala"
					if (_data_->_tmp90_ == NULL) {
#line 211 "../src/librygel-server/rygel-http-get.vala"
						_data_->_tmp89_ = NULL;
#line 1879 "rygel-http-get.c"
					} else {
#line 212 "../src/librygel-server/rygel-http-get.vala"
						_data_->_tmp91_ = _data_->self->speed_request;
#line 212 "../src/librygel-server/rygel-http-get.vala"
						_data_->_tmp92_ = rygel_play_speed_request_get_speed (_data_->_tmp91_);
#line 212 "../src/librygel-server/rygel-http-get.vala"
						_data_->_tmp93_ = _data_->_tmp92_;
#line 212 "../src/librygel-server/rygel-http-get.vala"
						_data_->_tmp89_ = _data_->_tmp93_;
#line 1889 "rygel-http-get.c"
					}
#line 211 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp94_ = _rygel_play_speed_ref0 (_data_->_tmp89_);
#line 211 "../src/librygel-server/rygel-http-get.vala"
					_data_->speed = _data_->_tmp94_;
#line 213 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp95_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 213 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp96_ = _data_->self->handler;
#line 213 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp97_ = _data_->speed;
#line 213 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp98_ = rygel_http_time_seek_request_new (_data_->_tmp95_, _data_->_tmp96_, _data_->_tmp97_, &_data_->_inner_error0_);
#line 213 "../src/librygel-server/rygel-http-get.vala"
					_data_->time_seek = _data_->_tmp98_;
#line 213 "../src/librygel-server/rygel-http-get.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 213 "../src/librygel-server/rygel-http-get.vala"
						_rygel_play_speed_unref0 (_data_->speed);
#line 213 "../src/librygel-server/rygel-http-get.vala"
						if (_data_->_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 1911 "rygel-http-get.c"
							goto __catch1_rygel_http_seek_request_error;
						}
#line 213 "../src/librygel-server/rygel-http-get.vala"
						_soup_message_headers_unref0 (_data_->response_headers);
#line 213 "../src/librygel-server/rygel-http-get.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 213 "../src/librygel-server/rygel-http-get.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 213 "../src/librygel-server/rygel-http-get.vala"
						g_object_unref (_data_->_async_result);
#line 213 "../src/librygel-server/rygel-http-get.vala"
						return FALSE;
#line 1924 "rygel-http-get.c"
					}
#line 215 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp99_ = _data_->time_seek;
#line 215 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp100_ = rygel_http_time_seek_request_to_string (_data_->_tmp99_);
#line 215 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp101_ = _data_->_tmp100_;
#line 215 "../src/librygel-server/rygel-http-get.vala"
					g_debug ("rygel-http-get.vala:215: Processing time seek %s", _data_->_tmp101_);
#line 215 "../src/librygel-server/rygel-http-get.vala"
					_g_free0 (_data_->_tmp101_);
#line 216 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp102_ = _data_->time_seek;
#line 216 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp103_ = _g_object_ref0 ((RygelHTTPSeekRequest*) _data_->_tmp102_);
#line 216 "../src/librygel-server/rygel-http-get.vala"
					_g_object_unref0 (_data_->self->seek);
#line 216 "../src/librygel-server/rygel-http-get.vala"
					_data_->self->seek = _data_->_tmp103_;
#line 209 "../src/librygel-server/rygel-http-get.vala"
					_g_object_unref0 (_data_->time_seek);
#line 209 "../src/librygel-server/rygel-http-get.vala"
					_rygel_play_speed_unref0 (_data_->speed);
#line 1948 "rygel-http-get.c"
				} else {
#line 218 "../src/librygel-server/rygel-http-get.vala"
					_g_object_unref0 (_data_->self->seek);
#line 218 "../src/librygel-server/rygel-http-get.vala"
					_data_->self->seek = NULL;
#line 1954 "rygel-http-get.c"
				}
			}
		}
	}
	goto __finally1;
	__catch1_rygel_http_seek_request_error:
	{
#line 196 "../src/librygel-server/rygel-http-get.vala"
		_data_->_vala1__error_ = _data_->_inner_error0_;
#line 196 "../src/librygel-server/rygel-http-get.vala"
		_data_->_inner_error0_ = NULL;
#line 221 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp104_ = _data_->_vala1__error_;
#line 221 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp105_ = _data_->_tmp104_->message;
#line 221 "../src/librygel-server/rygel-http-get.vala"
		g_warning ("rygel-http-get.vala:221: Caught HTTPSeekRequestError: %s", _data_->_tmp105_);
#line 222 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp106_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 222 "../src/librygel-server/rygel-http-get.vala"
		soup_server_message_unpause (_data_->_tmp106_);
#line 223 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp107_ = _data_->_vala1__error_;
#line 223 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp108_ = _data_->_vala1__error_;
#line 223 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp109_ = _data_->_tmp108_->message;
#line 223 "../src/librygel-server/rygel-http-get.vala"
		rygel_http_request_end ((RygelHTTPRequest*) _data_->self, (guint) _data_->_tmp107_->code, _data_->_tmp109_);
#line 226 "../src/librygel-server/rygel-http-get.vala"
		_g_error_free0 (_data_->_vala1__error_);
#line 226 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 226 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 226 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_state_ != 0) {
#line 226 "../src/librygel-server/rygel-http-get.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 226 "../src/librygel-server/rygel-http-get.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1996 "rygel-http-get.c"
			}
		}
#line 226 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 226 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 2003 "rygel-http-get.c"
	}
	__finally1:
#line 196 "../src/librygel-server/rygel-http-get.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 196 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 196 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 196 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 196 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 2016 "rygel-http-get.c"
	}
#line 230 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp110_ = _data_->self->handler;
#line 230 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_handler_add_response_headers (_data_->_tmp110_, _data_->self, &_data_->_inner_error0_);
#line 230 "../src/librygel-server/rygel-http-get.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 230 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 230 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 230 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 230 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 2032 "rygel-http-get.c"
	}
#line 231 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp111_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 231 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp112_ = soup_server_message_get_response_headers (_data_->_tmp111_);
#line 231 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp113_ = ((RygelHTTPRequest*) _data_->self)->http_server;
#line 231 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp114_ = rygel_http_server_get_server_name (_data_->_tmp113_);
#line 231 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp115_ = _data_->_tmp114_;
#line 231 "../src/librygel-server/rygel-http-get.vala"
	soup_message_headers_append (_data_->_tmp112_, "Server", _data_->_tmp115_);
#line 234 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp116_ = _data_->self->handler;
#line 234 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp117_ = rygel_http_get_handler_render_body (_data_->_tmp116_, _data_->self, &_data_->_inner_error0_);
#line 234 "../src/librygel-server/rygel-http-get.vala"
	_data_->response = _data_->_tmp117_;
#line 234 "../src/librygel-server/rygel-http-get.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 234 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 234 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 234 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 234 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 2062 "rygel-http-get.c"
	}
	{
#line 238 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp118_ = _data_->response;
#line 238 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp119_ = rygel_http_response_preroll (_data_->_tmp118_, &_data_->_inner_error0_);
#line 238 "../src/librygel-server/rygel-http-get.vala"
		_data_->responses = _data_->_tmp119_;
#line 238 "../src/librygel-server/rygel-http-get.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 238 "../src/librygel-server/rygel-http-get.vala"
			if (_data_->_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 2075 "rygel-http-get.c"
				goto __catch2_rygel_http_seek_request_error;
			}
			goto __finally2;
		}
#line 241 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp120_ = _data_->responses;
#line 241 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp120_ != NULL) {
#line 2084 "rygel-http-get.c"
			{
#line 242 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp121_ = _data_->responses;
#line 242 "../src/librygel-server/rygel-http-get.vala"
				_data_->_response_elem_list = _data_->_tmp121_;
#line 242 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp122_ = _data_->_response_elem_list;
#line 242 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp123_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp122_);
#line 242 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp124_ = _data_->_tmp123_;
#line 242 "../src/librygel-server/rygel-http-get.vala"
				_data_->_response_elem_size = _data_->_tmp124_;
#line 242 "../src/librygel-server/rygel-http-get.vala"
				_data_->_response_elem_index = -1;
#line 242 "../src/librygel-server/rygel-http-get.vala"
				while (TRUE) {
#line 242 "../src/librygel-server/rygel-http-get.vala"
					_data_->_response_elem_index = _data_->_response_elem_index + 1;
#line 242 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp125_ = _data_->_response_elem_index;
#line 242 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp126_ = _data_->_response_elem_size;
#line 242 "../src/librygel-server/rygel-http-get.vala"
					if (!(_data_->_tmp125_ < _data_->_tmp126_)) {
#line 242 "../src/librygel-server/rygel-http-get.vala"
						break;
#line 2112 "rygel-http-get.c"
					}
#line 242 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp127_ = _data_->_response_elem_list;
#line 242 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp128_ = gee_list_get (_data_->_tmp127_, _data_->_response_elem_index);
#line 242 "../src/librygel-server/rygel-http-get.vala"
					_data_->response_elem = (RygelHTTPResponseElement*) _data_->_tmp128_;
#line 243 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp129_ = _data_->response_elem;
#line 243 "../src/librygel-server/rygel-http-get.vala"
					rygel_http_response_element_add_response_headers (_data_->_tmp129_, (RygelHTTPRequest*) _data_->self);
#line 242 "../src/librygel-server/rygel-http-get.vala"
					_g_object_unref0 (_data_->response_elem);
#line 2126 "rygel-http-get.c"
				}
			}
		}
#line 237 "../src/librygel-server/rygel-http-get.vala"
		_g_object_unref0 (_data_->responses);
#line 2132 "rygel-http-get.c"
	}
	goto __finally2;
	__catch2_rygel_http_seek_request_error:
	{
#line 237 "../src/librygel-server/rygel-http-get.vala"
		_data_->_vala2__error_ = _data_->_inner_error0_;
#line 237 "../src/librygel-server/rygel-http-get.vala"
		_data_->_inner_error0_ = NULL;
#line 247 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp130_ = _data_->_vala2__error_;
#line 247 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp131_ = _data_->_tmp130_->message;
#line 247 "../src/librygel-server/rygel-http-get.vala"
		g_warning ("rygel-http-get.vala:247: Caught HTTPSeekRequestError on preroll: %s", _data_->_tmp131_);
#line 249 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp132_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 249 "../src/librygel-server/rygel-http-get.vala"
		soup_server_message_unpause (_data_->_tmp132_);
#line 250 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp133_ = _data_->_vala2__error_;
#line 250 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp134_ = _data_->_vala2__error_;
#line 250 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp135_ = _data_->_tmp134_->message;
#line 250 "../src/librygel-server/rygel-http-get.vala"
		rygel_http_request_end ((RygelHTTPRequest*) _data_->self, (guint) _data_->_tmp133_->code, _data_->_tmp135_);
#line 253 "../src/librygel-server/rygel-http-get.vala"
		_g_error_free0 (_data_->_vala2__error_);
#line 253 "../src/librygel-server/rygel-http-get.vala"
		_g_object_unref0 (_data_->response);
#line 253 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 253 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 253 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_state_ != 0) {
#line 253 "../src/librygel-server/rygel-http-get.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 253 "../src/librygel-server/rygel-http-get.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2173 "rygel-http-get.c"
			}
		}
#line 253 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 253 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 2180 "rygel-http-get.c"
	}
	__finally2:
#line 237 "../src/librygel-server/rygel-http-get.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 237 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 237 "../src/librygel-server/rygel-http-get.vala"
		_g_object_unref0 (_data_->response);
#line 237 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 237 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 237 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 2195 "rygel-http-get.c"
	}
	{
#line 261 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp136_ = _data_->response_headers;
#line 261 "../src/librygel-server/rygel-http-get.vala"
		_data_->response_size = soup_message_headers_get_content_length (_data_->_tmp136_);
#line 263 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->response_size > ((gint64) 0)) {
#line 264 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp137_ = _data_->response_headers;
#line 264 "../src/librygel-server/rygel-http-get.vala"
			soup_message_headers_set_content_length (_data_->_tmp137_, _data_->response_size);
#line 265 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp138_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->response_size);
#line 265 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp139_ = _data_->_tmp138_;
#line 265 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp140_ = g_strconcat ("Response size set via response element: size ", _data_->_tmp139_, NULL);
#line 265 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp141_ = _data_->_tmp140_;
#line 265 "../src/librygel-server/rygel-http-get.vala"
			g_debug ("rygel-http-get.vala:265: %s", _data_->_tmp141_);
#line 265 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->_tmp141_);
#line 265 "../src/librygel-server/rygel-http-get.vala"
			_g_free0 (_data_->_tmp139_);
#line 2222 "rygel-http-get.c"
		} else {
#line 270 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp142_ = _data_->self->handler;
#line 270 "../src/librygel-server/rygel-http-get.vala"
			_data_->response_size = rygel_http_get_handler_get_resource_size (_data_->_tmp142_);
#line 270 "../src/librygel-server/rygel-http-get.vala"
			if (_data_->response_size > ((gint64) 0)) {
#line 271 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp143_ = _data_->response_headers;
#line 271 "../src/librygel-server/rygel-http-get.vala"
				soup_message_headers_set_content_length (_data_->_tmp143_, _data_->response_size);
#line 272 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp144_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->response_size);
#line 272 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp145_ = _data_->_tmp144_;
#line 272 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp146_ = g_strconcat ("Response size set via response element: size ", _data_->_tmp145_, NULL);
#line 272 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp147_ = _data_->_tmp146_;
#line 272 "../src/librygel-server/rygel-http-get.vala"
				g_debug ("rygel-http-get.vala:272: %s", _data_->_tmp147_);
#line 272 "../src/librygel-server/rygel-http-get.vala"
				_g_free0 (_data_->_tmp147_);
#line 272 "../src/librygel-server/rygel-http-get.vala"
				_g_free0 (_data_->_tmp145_);
#line 2248 "rygel-http-get.c"
			} else {
#line 275 "../src/librygel-server/rygel-http-get.vala"
				g_debug ("rygel-http-get.vala:275: Response size unknown");
#line 2252 "rygel-http-get.c"
			}
		}
	}
	{
#line 285 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp149_ = _data_->self->speed_request;
#line 285 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp149_ != NULL) {
#line 286 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp150_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 286 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp148_ = soup_server_message_get_http_version (_data_->_tmp150_) != SOUP_HTTP_1_0;
#line 2265 "rygel-http-get.c"
		} else {
#line 285 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp148_ = FALSE;
#line 2269 "rygel-http-get.c"
		}
#line 285 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp148_) {
#line 289 "../src/librygel-server/rygel-http-get.vala"
			_data_->response_body_encoding = SOUP_ENCODING_CHUNKED;
#line 290 "../src/librygel-server/rygel-http-get.vala"
			g_debug ("rygel-http-get.vala:290: Response encoding set to CHUNKED");
#line 2277 "rygel-http-get.c"
		} else {
#line 291 "../src/librygel-server/rygel-http-get.vala"
			if (_data_->response_size > ((gint64) 0)) {
#line 293 "../src/librygel-server/rygel-http-get.vala"
				_data_->response_body_encoding = SOUP_ENCODING_CONTENT_LENGTH;
#line 294 "../src/librygel-server/rygel-http-get.vala"
				g_debug ("rygel-http-get.vala:294: Response encoding set to CONTENT-LENGTH");
#line 2285 "rygel-http-get.c"
			} else {
#line 296 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp151_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 296 "../src/librygel-server/rygel-http-get.vala"
				if (soup_server_message_get_http_version (_data_->_tmp151_) == SOUP_HTTP_1_0) {
#line 298 "../src/librygel-server/rygel-http-get.vala"
					_data_->response_body_encoding = SOUP_ENCODING_EOF;
#line 299 "../src/librygel-server/rygel-http-get.vala"
					g_debug ("rygel-http-get.vala:299: Response encoding set to EOF");
#line 2295 "rygel-http-get.c"
				} else {
#line 301 "../src/librygel-server/rygel-http-get.vala"
					_data_->response_body_encoding = SOUP_ENCODING_CHUNKED;
#line 302 "../src/librygel-server/rygel-http-get.vala"
					g_debug ("rygel-http-get.vala:302: Response encoding set to CHUNKED");
#line 2301 "rygel-http-get.c"
				}
			}
		}
#line 305 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp152_ = _data_->response_headers;
#line 305 "../src/librygel-server/rygel-http-get.vala"
		soup_message_headers_set_encoding (_data_->_tmp152_, _data_->response_body_encoding);
#line 2309 "rygel-http-get.c"
	}
	{
#line 313 "../src/librygel-server/rygel-http-get.vala"
		_data_->supports_playspeed = rygel_play_speed_request_supported (_data_->self);
#line 314 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->supports_time_seek) {
#line 314 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp153_ = TRUE;
#line 2318 "rygel-http-get.c"
		} else {
#line 314 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp153_ = _data_->supports_playspeed;
#line 2322 "rygel-http-get.c"
		}
#line 314 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp153_) {
#line 315 "../src/librygel-server/rygel-http-get.vala"
			_data_->_tmp154_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 315 "../src/librygel-server/rygel-http-get.vala"
			if (soup_server_message_get_http_version (_data_->_tmp154_) != SOUP_HTTP_1_0) {
#line 316 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp155_ = _data_->response_headers;
#line 316 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp156_ = soup_message_headers_get_list (_data_->_tmp155_, "Vary");
#line 316 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp157_ = g_string_new (_data_->_tmp156_);
#line 316 "../src/librygel-server/rygel-http-get.vala"
				_data_->vary_header = _data_->_tmp157_;
#line 318 "../src/librygel-server/rygel-http-get.vala"
				if (_data_->supports_time_seek) {
#line 319 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp158_ = _data_->vary_header;
#line 319 "../src/librygel-server/rygel-http-get.vala"
					if (_data_->_tmp158_->len > ((gssize) 0)) {
#line 320 "../src/librygel-server/rygel-http-get.vala"
						_data_->_tmp159_ = _data_->vary_header;
#line 320 "../src/librygel-server/rygel-http-get.vala"
						g_string_append (_data_->_tmp159_, ",");
#line 2348 "rygel-http-get.c"
					}
#line 322 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp160_ = _data_->vary_header;
#line 322 "../src/librygel-server/rygel-http-get.vala"
					g_string_append (_data_->_tmp160_, RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER);
#line 2354 "rygel-http-get.c"
				}
#line 324 "../src/librygel-server/rygel-http-get.vala"
				if (_data_->supports_playspeed) {
#line 325 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp161_ = _data_->vary_header;
#line 325 "../src/librygel-server/rygel-http-get.vala"
					if (_data_->_tmp161_->len > ((gssize) 0)) {
#line 326 "../src/librygel-server/rygel-http-get.vala"
						_data_->_tmp162_ = _data_->vary_header;
#line 326 "../src/librygel-server/rygel-http-get.vala"
						g_string_append (_data_->_tmp162_, ",");
#line 2366 "rygel-http-get.c"
					}
#line 328 "../src/librygel-server/rygel-http-get.vala"
					_data_->_tmp163_ = _data_->vary_header;
#line 328 "../src/librygel-server/rygel-http-get.vala"
					g_string_append (_data_->_tmp163_, RYGEL_PLAY_SPEED_REQUEST_PLAYSPEED_HEADER);
#line 2372 "rygel-http-get.c"
				}
#line 330 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp164_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 330 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp165_ = soup_server_message_get_response_headers (_data_->_tmp164_);
#line 330 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp166_ = _data_->vary_header;
#line 330 "../src/librygel-server/rygel-http-get.vala"
				_data_->_tmp167_ = _data_->_tmp166_->str;
#line 330 "../src/librygel-server/rygel-http-get.vala"
				soup_message_headers_replace (_data_->_tmp165_, "Vary", _data_->_tmp167_);
#line 315 "../src/librygel-server/rygel-http-get.vala"
				_g_string_free0 (_data_->vary_header);
#line 2386 "rygel-http-get.c"
			}
		}
	}
	{
#line 338 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp168_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 338 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp169_ = soup_server_message_get_response_headers (_data_->_tmp168_);
#line 338 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp170_ = soup_message_headers_get_one (_data_->_tmp169_, "Content-Range");
#line 338 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_tmp170_ != NULL) {
#line 339 "../src/librygel-server/rygel-http-get.vala"
			_data_->response_code = (gint) SOUP_STATUS_PARTIAL_CONTENT;
#line 2401 "rygel-http-get.c"
		} else {
#line 341 "../src/librygel-server/rygel-http-get.vala"
			_data_->response_code = (gint) SOUP_STATUS_OK;
#line 2405 "rygel-http-get.c"
		}
#line 343 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp171_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 343 "../src/librygel-server/rygel-http-get.vala"
		soup_server_message_set_status (_data_->_tmp171_, (guint) _data_->response_code, NULL);
#line 2411 "rygel-http-get.c"
	}
#line 346 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp172_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 346 "../src/librygel-server/rygel-http-get.vala"
	if (soup_server_message_get_http_version (_data_->_tmp172_) == SOUP_HTTP_1_0) {
#line 348 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp173_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 348 "../src/librygel-server/rygel-http-get.vala"
		soup_server_message_set_http_version (_data_->_tmp173_, SOUP_HTTP_1_1);
#line 349 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp174_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 349 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp175_ = soup_server_message_get_response_headers (_data_->_tmp174_);
#line 349 "../src/librygel-server/rygel-http-get.vala"
		soup_message_headers_append (_data_->_tmp175_, "Connection", "close");
#line 2427 "rygel-http-get.c"
	}
#line 352 "../src/librygel-server/rygel-http-get.vala"
	g_debug ("rygel-http-get.vala:352: Following HTTP headers appended to response:");
#line 353 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp176_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 353 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp177_ = soup_server_message_get_response_headers (_data_->_tmp176_);
#line 353 "../src/librygel-server/rygel-http-get.vala"
	soup_message_headers_foreach (_data_->_tmp177_, ___lambda18__soup_message_headers_foreach_func, _data_->self);
#line 357 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp178_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 357 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp179_ = soup_server_message_get_method (_data_->_tmp178_);
#line 357 "../src/librygel-server/rygel-http-get.vala"
	if (g_strcmp0 (_data_->_tmp179_, "HEAD") == 0) {
#line 359 "../src/librygel-server/rygel-http-get.vala"
		_data_->_tmp180_ = ((RygelHTTPRequest*) _data_->self)->msg;
#line 359 "../src/librygel-server/rygel-http-get.vala"
		soup_server_message_unpause (_data_->_tmp180_);
#line 361 "../src/librygel-server/rygel-http-get.vala"
		_g_object_unref0 (_data_->response);
#line 361 "../src/librygel-server/rygel-http-get.vala"
		_soup_message_headers_unref0 (_data_->response_headers);
#line 361 "../src/librygel-server/rygel-http-get.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 361 "../src/librygel-server/rygel-http-get.vala"
		if (_data_->_state_ != 0) {
#line 361 "../src/librygel-server/rygel-http-get.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 361 "../src/librygel-server/rygel-http-get.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2459 "rygel-http-get.c"
			}
		}
#line 361 "../src/librygel-server/rygel-http-get.vala"
		g_object_unref (_data_->_async_result);
#line 361 "../src/librygel-server/rygel-http-get.vala"
		return FALSE;
#line 2466 "rygel-http-get.c"
	}
#line 364 "../src/librygel-server/rygel-http-get.vala"
	_data_->_tmp181_ = _data_->response;
#line 364 "../src/librygel-server/rygel-http-get.vala"
	_data_->_state_ = 1;
#line 364 "../src/librygel-server/rygel-http-get.vala"
	rygel_state_machine_run ((RygelStateMachine*) _data_->_tmp181_, rygel_http_get_handle_item_request_ready, _data_);
#line 364 "../src/librygel-server/rygel-http-get.vala"
	return FALSE;
#line 2476 "rygel-http-get.c"
	_state_1:
#line 364 "../src/librygel-server/rygel-http-get.vala"
	rygel_state_machine_run_finish ((RygelStateMachine*) _data_->_tmp181_, _data_->_res_);
#line 366 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_request_end ((RygelHTTPRequest*) _data_->self, (guint) SOUP_STATUS_NONE, NULL);
#line 120 "../src/librygel-server/rygel-http-get.vala"
	_g_object_unref0 (_data_->response);
#line 120 "../src/librygel-server/rygel-http-get.vala"
	_soup_message_headers_unref0 (_data_->response_headers);
#line 120 "../src/librygel-server/rygel-http-get.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 120 "../src/librygel-server/rygel-http-get.vala"
	if (_data_->_state_ != 0) {
#line 120 "../src/librygel-server/rygel-http-get.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 120 "../src/librygel-server/rygel-http-get.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2494 "rygel-http-get.c"
		}
	}
#line 120 "../src/librygel-server/rygel-http-get.vala"
	g_object_unref (_data_->_async_result);
#line 120 "../src/librygel-server/rygel-http-get.vala"
	return FALSE;
#line 2501 "rygel-http-get.c"
}

static void
rygel_http_get_class_init (RygelHTTPGetClass * klass,
                           gpointer klass_data)
{
#line 34 "../src/librygel-server/rygel-http-get.vala"
	rygel_http_get_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	((RygelHTTPRequestClass *) klass)->handle = (void (*) (RygelHTTPRequest*, GAsyncReadyCallback, gpointer)) rygel_http_get_real_handle;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	((RygelHTTPRequestClass *) klass)->handle_finish = (void (*) (RygelHTTPRequest*, GAsyncResult*, GError**)) rygel_http_get_handle_finish;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	((RygelHTTPRequestClass *) klass)->find_item = (void (*) (RygelHTTPRequest*, GAsyncReadyCallback, gpointer)) rygel_http_get_real_find_item;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	((RygelHTTPRequestClass *) klass)->find_item_finish = (void (*) (RygelHTTPRequest*, GAsyncResult*, GError**)) rygel_http_get_find_item_finish;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_http_get_finalize;
#line 2520 "rygel-http-get.c"
}

static void
rygel_http_get_instance_init (RygelHTTPGet * self,
                              gpointer klass)
{
}

static void
rygel_http_get_finalize (GObject * obj)
{
	RygelHTTPGet * self;
#line 34 "../src/librygel-server/rygel-http-get.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_HTTP_GET, RygelHTTPGet);
#line 37 "../src/librygel-server/rygel-http-get.vala"
	_g_object_unref0 (self->seek);
#line 38 "../src/librygel-server/rygel-http-get.vala"
	_g_object_unref0 (self->speed_request);
#line 40 "../src/librygel-server/rygel-http-get.vala"
	_g_object_unref0 (self->handler);
#line 34 "../src/librygel-server/rygel-http-get.vala"
	G_OBJECT_CLASS (rygel_http_get_parent_class)->finalize (obj);
#line 2543 "rygel-http-get.c"
}

/**
 * Responsible for handling HTTP GET & HEAD client requests.
 */
 G_GNUC_NO_INLINE static GType
rygel_http_get_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelHTTPGetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_http_get_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelHTTPGet), 0, (GInstanceInitFunc) rygel_http_get_instance_init, NULL };
	GType rygel_http_get_type_id;
	rygel_http_get_type_id = g_type_register_static (RYGEL_TYPE_HTTP_REQUEST, "RygelHTTPGet", &g_define_type_info, 0);
	return rygel_http_get_type_id;
}

GType
rygel_http_get_get_type (void)
{
	static volatile gsize rygel_http_get_type_id__once = 0;
	if (g_once_init_enter (&rygel_http_get_type_id__once)) {
		GType rygel_http_get_type_id;
		rygel_http_get_type_id = rygel_http_get_get_type_once ();
		g_once_init_leave (&rygel_http_get_type_id__once, rygel_http_get_type_id);
	}
	return rygel_http_get_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

