/* rygel-http-item-uri.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-http-item-uri.vala, do not modify */

/*
 * Copyright (C) 2009 Jens Georg <mail@jensge.org>.
 * Copyright (C) 2010 Nokia Corporation.
 *
 * Authors: Jens Georg <mail@jensge.org>
 *          Zeeshan Ali (Khattak) <zeeshan.ali@nokia.com>
 *                                <zeeshanak@gnome.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include "rygel-core.h"
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <libgupnp/gupnp.h>
#include <libgssdp/gssdp.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_HTTP_ITEM_URI_0_PROPERTY,
	RYGEL_HTTP_ITEM_URI_ITEM_ID_PROPERTY,
	RYGEL_HTTP_ITEM_URI_THUMBNAIL_INDEX_PROPERTY,
	RYGEL_HTTP_ITEM_URI_SUBTITLE_INDEX_PROPERTY,
	RYGEL_HTTP_ITEM_URI_RESOURCE_NAME_PROPERTY,
	RYGEL_HTTP_ITEM_URI_HTTP_SERVER_PROPERTY,
	RYGEL_HTTP_ITEM_URI_EXTENSION_PROPERTY,
	RYGEL_HTTP_ITEM_URI_NUM_PROPERTIES
};
static GParamSpec* rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _rygel_icon_info_unref0(var) ((var == NULL) ? NULL : (var = (rygel_icon_info_unref (var), NULL)))
#define _rygel_subtitle_unref0(var) ((var == NULL) ? NULL : (var = (rygel_subtitle_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _RygelHTTPItemURIPrivate {
	gchar* _item_id;
	gint _thumbnail_index;
	gint _subtitle_index;
	gchar* _resource_name;
	RygelHTTPServer* _http_server;
	gchar* real_extension;
};

static gint RygelHTTPItemURI_private_offset;
static gpointer rygel_http_item_uri_parent_class = NULL;
GeeHashMap* rygel_http_item_uri_mime_to_ext = NULL;

static gchar* rygel_http_item_uri_ext_from_mime_type (RygelHTTPItemURI* self,
                                               const gchar* mime_type);
static gchar* rygel_http_item_uri_base64_urlencode (RygelHTTPItemURI* self,
                                             const gchar* data);
static guchar* rygel_http_item_uri_base64_urldecode (RygelHTTPItemURI* self,
                                              const gchar* data,
                                              gint* result_length1);
static gchar* rygel_http_item_uri_create_uri_for_path (RygelHTTPItemURI* self,
                                                const gchar* path);
static void rygel_http_item_uri_finalize (GObject * obj);
static GType rygel_http_item_uri_get_type_once (void);
static void _vala_rygel_http_item_uri_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_rygel_http_item_uri_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rygel_http_item_uri_get_instance_private (RygelHTTPItemURI* self)
{
	return G_STRUCT_MEMBER_P (self, RygelHTTPItemURI_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../src/librygel-server/rygel-http-item-uri.vala"
	return self ? g_object_ref (self) : NULL;
#line 122 "rygel-http-item-uri.c"
}

static gpointer
_rygel_icon_info_ref0 (gpointer self)
{
#line 85 "../src/librygel-server/rygel-http-item-uri.vala"
	return self ? rygel_icon_info_ref (self) : NULL;
#line 130 "rygel-http-item-uri.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1195 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1195 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1197 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1197 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 154 "rygel-http-item-uri.c"
		gchar* _tmp2_;
#line 1198 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1198 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1198 "glib-2.0.vapi"
		return result;
#line 162 "rygel-http-item-uri.c"
	} else {
#line 1200 "glib-2.0.vapi"
		result = -1;
#line 1200 "glib-2.0.vapi"
		return result;
#line 168 "rygel-http-item-uri.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 192 "rygel-http-item-uri.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 201 "rygel-http-item-uri.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 220 "rygel-http-item-uri.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 224 "rygel-http-item-uri.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 230 "rygel-http-item-uri.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 240 "rygel-http-item-uri.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 248 "rygel-http-item-uri.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 252 "rygel-http-item-uri.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 258 "rygel-http-item-uri.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 268 "rygel-http-item-uri.c"
}

RygelHTTPItemURI*
rygel_http_item_uri_construct (GType object_type,
                               RygelMediaObject* object,
                               RygelHTTPServer* http_server,
                               gint thumbnail_index,
                               gint subtitle_index,
                               const gchar* resource_name)
{
	RygelHTTPItemURI * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	RygelMediaFileItem* item = NULL;
	RygelMediaFileItem* _tmp9_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gboolean _tmp45_;
#line 50 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 50 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (http_server != NULL, NULL);
#line 50 "../src/librygel-server/rygel-http-item-uri.vala"
	self = (RygelHTTPItemURI*) g_object_new (object_type, NULL);
#line 55 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = rygel_media_object_get_id (object);
#line 55 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp1_ = _tmp0_;
#line 55 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_item_id (self, _tmp1_);
#line 56 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_thumbnail_index (self, thumbnail_index);
#line 57 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_subtitle_index (self, subtitle_index);
#line 58 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_http_server (self, http_server);
#line 59 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_resource_name (self, resource_name);
#line 60 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_extension (self, "");
#line 62 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp2_ = self->priv->_resource_name;
#line 62 "../src/librygel-server/rygel-http-item-uri.vala"
	if (_tmp2_ != NULL) {
#line 315 "rygel-http-item-uri.c"
		RygelMediaResource* resource = NULL;
		const gchar* _tmp3_;
		RygelMediaResource* _tmp4_;
		RygelMediaResource* _tmp5_;
#line 63 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp3_ = self->priv->_resource_name;
#line 63 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp4_ = rygel_media_object_get_resource_by_name (object, _tmp3_);
#line 63 "../src/librygel-server/rygel-http-item-uri.vala"
		resource = _tmp4_;
#line 65 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp5_ = resource;
#line 65 "../src/librygel-server/rygel-http-item-uri.vala"
		if (_tmp5_ != NULL) {
#line 330 "rygel-http-item-uri.c"
			RygelMediaResource* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 66 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp6_ = resource;
#line 66 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp7_ = rygel_media_resource_get_extension (_tmp6_);
#line 66 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp8_ = _tmp7_;
#line 66 "../src/librygel-server/rygel-http-item-uri.vala"
			rygel_http_item_uri_set_extension (self, _tmp8_);
#line 342 "rygel-http-item-uri.c"
		}
#line 69 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_object_unref0 (resource);
#line 69 "../src/librygel-server/rygel-http-item-uri.vala"
		return self;
#line 348 "rygel-http-item-uri.c"
	} else {
#line 71 "../src/librygel-server/rygel-http-item-uri.vala"
		if (!RYGEL_IS_MEDIA_FILE_ITEM (object)) {
#line 72 "../src/librygel-server/rygel-http-item-uri.vala"
			return self;
#line 354 "rygel-http-item-uri.c"
		}
	}
#line 76 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp9_ = _g_object_ref0 (RYGEL_IS_MEDIA_FILE_ITEM (object) ? ((RygelMediaFileItem*) object) : NULL);
#line 76 "../src/librygel-server/rygel-http-item-uri.vala"
	item = _tmp9_;
#line 77 "../src/librygel-server/rygel-http-item-uri.vala"
	if (thumbnail_index > -1) {
#line 363 "rygel-http-item-uri.c"
		RygelMediaFileItem* _tmp10_;
#line 78 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp10_ = item;
#line 78 "../src/librygel-server/rygel-http-item-uri.vala"
		if (RYGEL_IS_VISUAL_ITEM (_tmp10_)) {
#line 369 "rygel-http-item-uri.c"
			GeeArrayList* thumbnails = NULL;
			RygelMediaFileItem* _tmp11_;
			GeeArrayList* _tmp12_;
			GeeArrayList* _tmp13_;
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
#line 79 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp11_ = item;
#line 79 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp12_ = rygel_visual_item_get_thumbnails (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, RYGEL_TYPE_VISUAL_ITEM, RygelVisualItem));
#line 79 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp13_ = _tmp12_;
#line 79 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp14_ = _g_object_ref0 (_tmp13_);
#line 79 "../src/librygel-server/rygel-http-item-uri.vala"
			thumbnails = _tmp14_;
#line 81 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp15_ = thumbnails;
#line 81 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 81 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp17_ = _tmp16_;
#line 81 "../src/librygel-server/rygel-http-item-uri.vala"
			if (_tmp17_ > thumbnail_index) {
#line 396 "rygel-http-item-uri.c"
				GeeArrayList* _tmp18_;
				gpointer _tmp19_;
				RygelThumbnail* _tmp20_;
				const gchar* _tmp21_;
#line 82 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp18_ = thumbnails;
#line 82 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, thumbnail_index);
#line 82 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp20_ = (RygelThumbnail*) _tmp19_;
#line 82 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp21_ = ((RygelIconInfo*) _tmp20_)->file_extension;
#line 82 "../src/librygel-server/rygel-http-item-uri.vala"
				rygel_http_item_uri_set_extension (self, _tmp21_);
#line 82 "../src/librygel-server/rygel-http-item-uri.vala"
				_rygel_icon_info_unref0 (_tmp20_);
#line 413 "rygel-http-item-uri.c"
			}
#line 78 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_object_unref0 (thumbnails);
#line 417 "rygel-http-item-uri.c"
		} else {
			RygelMediaFileItem* _tmp22_;
#line 84 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp22_ = item;
#line 84 "../src/librygel-server/rygel-http-item-uri.vala"
			if (RYGEL_IS_MUSIC_ITEM (_tmp22_)) {
#line 424 "rygel-http-item-uri.c"
				RygelThumbnail* album_art = NULL;
				RygelMediaFileItem* _tmp23_;
				RygelThumbnail* _tmp24_;
				RygelThumbnail* _tmp25_;
				RygelThumbnail* _tmp26_;
				RygelThumbnail* _tmp27_;
#line 85 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp23_ = item;
#line 85 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp24_ = rygel_music_item_get_album_art (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, RYGEL_TYPE_MUSIC_ITEM, RygelMusicItem));
#line 85 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp25_ = _tmp24_;
#line 85 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp26_ = _rygel_icon_info_ref0 (_tmp25_);
#line 85 "../src/librygel-server/rygel-http-item-uri.vala"
				album_art = _tmp26_;
#line 87 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp27_ = album_art;
#line 87 "../src/librygel-server/rygel-http-item-uri.vala"
				if (_tmp27_ != NULL) {
#line 445 "rygel-http-item-uri.c"
					RygelThumbnail* _tmp28_;
					const gchar* _tmp29_;
#line 88 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp28_ = album_art;
#line 88 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp29_ = ((RygelIconInfo*) _tmp28_)->file_extension;
#line 88 "../src/librygel-server/rygel-http-item-uri.vala"
					rygel_http_item_uri_set_extension (self, _tmp29_);
#line 454 "rygel-http-item-uri.c"
				}
#line 84 "../src/librygel-server/rygel-http-item-uri.vala"
				_rygel_icon_info_unref0 (album_art);
#line 458 "rygel-http-item-uri.c"
			}
		}
	} else {
#line 91 "../src/librygel-server/rygel-http-item-uri.vala"
		if (subtitle_index > -1) {
#line 464 "rygel-http-item-uri.c"
			RygelMediaFileItem* _tmp30_;
#line 92 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp30_ = item;
#line 92 "../src/librygel-server/rygel-http-item-uri.vala"
			if (RYGEL_IS_VIDEO_ITEM (_tmp30_)) {
#line 470 "rygel-http-item-uri.c"
				GeeArrayList* subtitles = NULL;
				RygelMediaFileItem* _tmp31_;
				GeeArrayList* _tmp32_;
				GeeArrayList* _tmp33_;
				GeeArrayList* _tmp34_;
				GeeArrayList* _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
#line 93 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp31_ = item;
#line 93 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp32_ = rygel_video_item_get_subtitles (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, RYGEL_TYPE_VIDEO_ITEM, RygelVideoItem));
#line 93 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp33_ = _tmp32_;
#line 93 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp34_ = _g_object_ref0 (_tmp33_);
#line 93 "../src/librygel-server/rygel-http-item-uri.vala"
				subtitles = _tmp34_;
#line 95 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp35_ = subtitles;
#line 95 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp36_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp35_);
#line 95 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp37_ = _tmp36_;
#line 95 "../src/librygel-server/rygel-http-item-uri.vala"
				if (_tmp37_ > subtitle_index) {
#line 497 "rygel-http-item-uri.c"
					GeeArrayList* _tmp38_;
					gpointer _tmp39_;
					RygelSubtitle* _tmp40_;
					const gchar* _tmp41_;
#line 96 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp38_ = subtitles;
#line 96 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) _tmp38_, subtitle_index);
#line 96 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp40_ = (RygelSubtitle*) _tmp39_;
#line 96 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp41_ = _tmp40_->caption_type;
#line 96 "../src/librygel-server/rygel-http-item-uri.vala"
					rygel_http_item_uri_set_extension (self, _tmp41_);
#line 96 "../src/librygel-server/rygel-http-item-uri.vala"
					_rygel_subtitle_unref0 (_tmp40_);
#line 514 "rygel-http-item-uri.c"
				}
#line 92 "../src/librygel-server/rygel-http-item-uri.vala"
				_g_object_unref0 (subtitles);
#line 518 "rygel-http-item-uri.c"
			}
		}
	}
#line 101 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp42_ = rygel_http_item_uri_get_extension (self);
#line 101 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp43_ = _tmp42_;
#line 101 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp44_ = _tmp43_;
#line 101 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp45_ = g_strcmp0 (_tmp44_, "") == 0;
#line 101 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (_tmp44_);
#line 101 "../src/librygel-server/rygel-http-item-uri.vala"
	if (_tmp45_) {
#line 534 "rygel-http-item-uri.c"
		gchar* uri_extension = NULL;
		gchar* _tmp46_;
		const gchar* _tmp61_;
#line 102 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp46_ = g_strdup ("");
#line 102 "../src/librygel-server/rygel-http-item-uri.vala"
		uri_extension = _tmp46_;
#line 542 "rygel-http-item-uri.c"
		{
			GeeList* _uri_string_list = NULL;
			RygelMediaFileItem* _tmp47_;
			GeeList* _tmp48_;
			gint _uri_string_size = 0;
			GeeList* _tmp49_;
			gint _tmp50_;
			gint _tmp51_;
			gint _uri_string_index = 0;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp47_ = item;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp48_ = rygel_media_object_get_uris ((RygelMediaObject*) _tmp47_);
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_uri_string_list = _tmp48_;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp49_ = _uri_string_list;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp50_ = gee_collection_get_size ((GeeCollection*) _tmp49_);
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp51_ = _tmp50_;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_uri_string_size = _tmp51_;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_uri_string_index = -1;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			while (TRUE) {
#line 570 "rygel-http-item-uri.c"
				gint _tmp52_;
				gint _tmp53_;
				gchar* uri_string = NULL;
				GeeList* _tmp54_;
				gpointer _tmp55_;
				gchar* basename = NULL;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				gint dot_index = 0;
				const gchar* _tmp58_;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				_uri_string_index = _uri_string_index + 1;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp52_ = _uri_string_index;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp53_ = _uri_string_size;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				if (!(_tmp52_ < _tmp53_)) {
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
					break;
#line 591 "rygel-http-item-uri.c"
				}
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp54_ = _uri_string_list;
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp55_ = gee_list_get (_tmp54_, _uri_string_index);
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				uri_string = (gchar*) _tmp55_;
#line 105 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp56_ = uri_string;
#line 105 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp57_ = g_path_get_basename (_tmp56_);
#line 105 "../src/librygel-server/rygel-http-item-uri.vala"
				basename = _tmp57_;
#line 106 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp58_ = basename;
#line 106 "../src/librygel-server/rygel-http-item-uri.vala"
				dot_index = string_last_index_of (_tmp58_, ".", 0);
#line 108 "../src/librygel-server/rygel-http-item-uri.vala"
				if (dot_index > -1) {
#line 611 "rygel-http-item-uri.c"
					const gchar* _tmp59_;
					gchar* _tmp60_;
#line 109 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp59_ = basename;
#line 109 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp60_ = string_substring (_tmp59_, (glong) (dot_index + 1), (glong) -1);
#line 109 "../src/librygel-server/rygel-http-item-uri.vala"
					_g_free0 (uri_extension);
#line 109 "../src/librygel-server/rygel-http-item-uri.vala"
					uri_extension = _tmp60_;
#line 111 "../src/librygel-server/rygel-http-item-uri.vala"
					_g_free0 (basename);
#line 111 "../src/librygel-server/rygel-http-item-uri.vala"
					_g_free0 (uri_string);
#line 111 "../src/librygel-server/rygel-http-item-uri.vala"
					break;
#line 628 "rygel-http-item-uri.c"
				}
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				_g_free0 (basename);
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
				_g_free0 (uri_string);
#line 634 "rygel-http-item-uri.c"
			}
#line 104 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_object_unref0 (_uri_string_list);
#line 638 "rygel-http-item-uri.c"
		}
#line 115 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp61_ = uri_extension;
#line 115 "../src/librygel-server/rygel-http-item-uri.vala"
		if (g_strcmp0 (_tmp61_, "") == 0) {
#line 644 "rygel-http-item-uri.c"
			RygelMediaFileItem* _tmp62_;
			const gchar* _tmp63_;
			const gchar* _tmp64_;
			gchar* _tmp65_;
			gchar* _tmp66_;
#line 116 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp62_ = item;
#line 116 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp63_ = rygel_media_file_item_get_mime_type (_tmp62_);
#line 116 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp64_ = _tmp63_;
#line 116 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp65_ = rygel_http_item_uri_ext_from_mime_type (self, _tmp64_);
#line 116 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp66_ = _tmp65_;
#line 116 "../src/librygel-server/rygel-http-item-uri.vala"
			rygel_http_item_uri_set_extension (self, _tmp66_);
#line 116 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (_tmp66_);
#line 664 "rygel-http-item-uri.c"
		} else {
			const gchar* _tmp67_;
#line 118 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp67_ = uri_extension;
#line 118 "../src/librygel-server/rygel-http-item-uri.vala"
			rygel_http_item_uri_set_extension (self, _tmp67_);
#line 671 "rygel-http-item-uri.c"
		}
#line 101 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (uri_extension);
#line 675 "rygel-http-item-uri.c"
	}
#line 50 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_object_unref0 (item);
#line 50 "../src/librygel-server/rygel-http-item-uri.vala"
	return self;
#line 681 "rygel-http-item-uri.c"
}

RygelHTTPItemURI*
rygel_http_item_uri_new (RygelMediaObject* object,
                         RygelHTTPServer* http_server,
                         gint thumbnail_index,
                         gint subtitle_index,
                         const gchar* resource_name)
{
#line 50 "../src/librygel-server/rygel-http-item-uri.vala"
	return rygel_http_item_uri_construct (RYGEL_TYPE_HTTP_ITEM_URI, object, http_server, thumbnail_index, subtitle_index, resource_name);
#line 693 "rygel-http-item-uri.c"
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1616 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1617 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1617 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1617 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1618 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1618 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1618 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1618 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1620 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1621 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1621 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1621 "glib-2.0.vapi"
	if (result_length1) {
#line 1621 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 741 "rygel-http-item-uri.c"
	}
#line 1621 "glib-2.0.vapi"
	result = _tmp4_;
#line 1621 "glib-2.0.vapi"
	return result;
#line 747 "rygel-http-item-uri.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 769 "rygel-http-item-uri.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 773 "rygel-http-item-uri.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 779 "rygel-http-item-uri.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 783 "rygel-http-item-uri.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 787 "rygel-http-item-uri.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 795 "rygel-http-item-uri.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 823 "rygel-http-item-uri.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 832 "rygel-http-item-uri.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 846 "rygel-http-item-uri.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 855 "rygel-http-item-uri.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 869 "rygel-http-item-uri.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 878 "rygel-http-item-uri.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 887 "rygel-http-item-uri.c"
}

static gchar*
rygel_http_item_uri_base64_urlencode (RygelHTTPItemURI* self,
                                      const gchar* data)
{
	gchar* enc64 = NULL;
	gint _tmp0_ = 0;
	gchar* _tmp1_;
	guchar* _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 125 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 126 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp1_ = string_to_utf8 (data, &_tmp0_);
#line 126 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp2_ = (guchar*) _tmp1_;
#line 126 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp2__length1 = (_tmp0_ * sizeof (gchar)) / sizeof (guchar);
#line 126 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp3_ = g_base64_encode (_tmp2_, (gint) ((_tmp0_ * sizeof (gchar)) / sizeof (guchar)));
#line 126 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp4_ = _tmp3_;
#line 126 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 126 "../src/librygel-server/rygel-http-item-uri.vala"
	enc64 = _tmp4_;
#line 127 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp5_ = enc64;
#line 127 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp6_ = string_replace (_tmp5_, "/", "_");
#line 127 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (enc64);
#line 127 "../src/librygel-server/rygel-http-item-uri.vala"
	enc64 = _tmp6_;
#line 129 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp7_ = enc64;
#line 129 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp8_ = string_replace (_tmp7_, "+", "-");
#line 129 "../src/librygel-server/rygel-http-item-uri.vala"
	result = _tmp8_;
#line 129 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (enc64);
#line 129 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 942 "rygel-http-item-uri.c"
}

static guchar*
rygel_http_item_uri_base64_urldecode (RygelHTTPItemURI* self,
                                      const gchar* data,
                                      gint* result_length1)
{
	gchar* dec64 = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gsize _tmp4_ = 0;
	guchar* _tmp5_;
	guchar* _tmp6_;
	gint _tmp6__length1;
	guchar* result;
#line 132 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 133 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = string_replace (data, "_", "/");
#line 133 "../src/librygel-server/rygel-http-item-uri.vala"
	dec64 = _tmp0_;
#line 134 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp1_ = dec64;
#line 134 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp2_ = string_replace (_tmp1_, "-", "+");
#line 134 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (dec64);
#line 134 "../src/librygel-server/rygel-http-item-uri.vala"
	dec64 = _tmp2_;
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp3_ = dec64;
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp5_ = g_base64_decode (_tmp3_, &_tmp4_);
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp6_ = _tmp5_;
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp6__length1 = _tmp4_;
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
	if (result_length1) {
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
		*result_length1 = _tmp6__length1;
#line 988 "rygel-http-item-uri.c"
	}
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
	result = _tmp6_;
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (dec64);
#line 136 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 996 "rygel-http-item-uri.c"
}

RygelHTTPItemURI*
rygel_http_item_uri_construct_from_string (GType object_type,
                                           const gchar* uri,
                                           RygelHTTPServer* http_server,
                                           GError** error)
{
	RygelHTTPItemURI * self = NULL;
	gchar* request_uri = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** parts = NULL;
	const gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint parts_length1;
	gint _parts_size_;
	gboolean _tmp6_ = FALSE;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* last_part = NULL;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gint dot_index = 0;
	const gchar* _tmp15_;
	const gchar* _tmp50_;
	GError* _inner_error0_ = NULL;
#line 139 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 139 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (http_server != NULL, NULL);
#line 139 "../src/librygel-server/rygel-http-item-uri.vala"
	self = (RygelHTTPItemURI*) g_object_new (object_type, NULL);
#line 143 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_thumbnail_index (self, -1);
#line 144 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_subtitle_index (self, -1);
#line 145 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_http_server (self, http_server);
#line 146 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_set_extension (self, "");
#line 148 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = rygel_http_server_get_path_root (http_server);
#line 148 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp1_ = _tmp0_;
#line 148 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp2_ = string_replace (uri, _tmp1_, "");
#line 148 "../src/librygel-server/rygel-http-item-uri.vala"
	request_uri = _tmp2_;
#line 149 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp3_ = request_uri;
#line 149 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, "/", 0);
#line 149 "../src/librygel-server/rygel-http-item-uri.vala"
	parts = _tmp5_;
#line 149 "../src/librygel-server/rygel-http-item-uri.vala"
	parts_length1 = _vala_array_length (_tmp4_);
#line 149 "../src/librygel-server/rygel-http-item-uri.vala"
	_parts_size_ = parts_length1;
#line 151 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp7_ = parts;
#line 151 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp7__length1 = parts_length1;
#line 151 "../src/librygel-server/rygel-http-item-uri.vala"
	if (_tmp7__length1 < 2) {
#line 151 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp6_ = TRUE;
#line 1070 "rygel-http-item-uri.c"
	} else {
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 151 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp8_ = parts;
#line 151 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp8__length1 = parts_length1;
#line 151 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp6_ = (_tmp8__length1 % 2) == 0;
#line 1080 "rygel-http-item-uri.c"
	}
#line 151 "../src/librygel-server/rygel-http-item-uri.vala"
	if (_tmp6_) {
#line 1084 "rygel-http-item-uri.c"
		const gchar* _tmp9_;
		GError* _tmp10_;
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp9_ = request_uri;
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp10_ = g_error_new (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_BAD_REQUEST, _ ("Invalid URI “%s”"), _tmp9_);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
		_inner_error0_ = _tmp10_;
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
		if (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR) {
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			g_propagate_error (error, _inner_error0_);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (request_uri);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_object_unref0 (self);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			return NULL;
#line 1105 "rygel-http-item-uri.c"
		} else {
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (request_uri);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			g_clear_error (&_inner_error0_);
#line 152 "../src/librygel-server/rygel-http-item-uri.vala"
			return NULL;
#line 1117 "rygel-http-item-uri.c"
		}
	}
#line 156 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp11_ = parts;
#line 156 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp11__length1 = parts_length1;
#line 156 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp12_ = parts;
#line 156 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp12__length1 = parts_length1;
#line 156 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp13_ = _tmp11_[_tmp12__length1 - 1];
#line 156 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 156 "../src/librygel-server/rygel-http-item-uri.vala"
	last_part = _tmp14_;
#line 157 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp15_ = last_part;
#line 157 "../src/librygel-server/rygel-http-item-uri.vala"
	dot_index = string_last_index_of (_tmp15_, ".", 0);
#line 159 "../src/librygel-server/rygel-http-item-uri.vala"
	if (dot_index > -1) {
#line 1140 "rygel-http-item-uri.c"
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		gchar** _tmp20_;
		gint _tmp20__length1;
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 160 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp16_ = last_part;
#line 160 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp17_ = string_substring (_tmp16_, (glong) (dot_index + 1), (glong) -1);
#line 160 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp18_ = _tmp17_;
#line 160 "../src/librygel-server/rygel-http-item-uri.vala"
		rygel_http_item_uri_set_extension (self, _tmp18_);
#line 160 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (_tmp18_);
#line 161 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp19_ = parts;
#line 161 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp19__length1 = parts_length1;
#line 161 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp20_ = parts;
#line 161 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp20__length1 = parts_length1;
#line 161 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp21_ = last_part;
#line 161 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp22_ = string_substring (_tmp21_, (glong) 0, (glong) dot_index);
#line 161 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (_tmp19_[_tmp20__length1 - 1]);
#line 161 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp19_[_tmp20__length1 - 1] = _tmp22_;
#line 1176 "rygel-http-item-uri.c"
	}
	{
		gint i = 0;
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
		i = 1;
#line 1182 "rygel-http-item-uri.c"
		{
			gboolean _tmp23_ = FALSE;
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp23_ = TRUE;
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
			while (TRUE) {
#line 1189 "rygel-http-item-uri.c"
				gchar** _tmp24_;
				gint _tmp24__length1;
				gchar** _tmp25_;
				gint _tmp25__length1;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				GQuark _tmp29_ = 0U;
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				static GQuark _tmp28_label0 = 0;
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				static GQuark _tmp28_label1 = 0;
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				static GQuark _tmp28_label2 = 0;
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				static GQuark _tmp28_label3 = 0;
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
				if (!_tmp23_) {
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
					i += 2;
#line 1209 "rygel-http-item-uri.c"
				}
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp23_ = FALSE;
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp24_ = parts;
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp24__length1 = parts_length1;
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
				if (!(i < (_tmp24__length1 - 1))) {
#line 164 "../src/librygel-server/rygel-http-item-uri.vala"
					break;
#line 1221 "rygel-http-item-uri.c"
				}
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp25_ = parts;
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp25__length1 = parts_length1;
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp26_ = _tmp25_[i];
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp27_ = _tmp26_;
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp29_ = (NULL == _tmp27_) ? 0 : g_quark_from_string (_tmp27_);
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
				if (_tmp29_ == ((0 != _tmp28_label0) ? _tmp28_label0 : (_tmp28_label0 = g_quark_from_static_string ("i")))) {
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
					switch (0) {
#line 1237 "rygel-http-item-uri.c"
						default:
						{
							guchar* data = NULL;
							gchar** _tmp30_;
							gint _tmp30__length1;
							const gchar* _tmp31_;
							gchar* _tmp32_;
							gchar* _tmp33_;
							gint _tmp34_ = 0;
							guchar* _tmp35_;
							guchar* _tmp36_;
							gint _tmp36__length1;
							gint data_length1;
							gint _data_size_;
							GString* builder = NULL;
							GString* _tmp37_;
							GString* _tmp38_;
							guchar* _tmp39_;
							gint _tmp39__length1;
							GString* _tmp40_;
							const gchar* _tmp41_;
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp30_ = parts;
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp30__length1 = parts_length1;
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp31_ = _tmp30_[i + 1];
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp32_ = g_uri_unescape_string (_tmp31_, NULL);
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp33_ = _tmp32_;
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp35_ = rygel_http_item_uri_base64_urldecode (self, _tmp33_, &_tmp34_);
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp36_ = _tmp35_;
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp36__length1 = _tmp34_;
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_g_free0 (_tmp33_);
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							data = _tmp36_;
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							data_length1 = _tmp36__length1;
#line 167 "../src/librygel-server/rygel-http-item-uri.vala"
							_data_size_ = data_length1;
#line 169 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp37_ = g_string_new ("");
#line 169 "../src/librygel-server/rygel-http-item-uri.vala"
							builder = _tmp37_;
#line 170 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp38_ = builder;
#line 170 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp39_ = data;
#line 170 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp39__length1 = data_length1;
#line 170 "../src/librygel-server/rygel-http-item-uri.vala"
							g_string_append (_tmp38_, (const gchar*) _tmp39_);
#line 171 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp40_ = builder;
#line 171 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp41_ = _tmp40_->str;
#line 171 "../src/librygel-server/rygel-http-item-uri.vala"
							rygel_http_item_uri_set_item_id (self, _tmp41_);
#line 173 "../src/librygel-server/rygel-http-item-uri.vala"
							_g_string_free0 (builder);
#line 173 "../src/librygel-server/rygel-http-item-uri.vala"
							data = (g_free (data), NULL);
#line 173 "../src/librygel-server/rygel-http-item-uri.vala"
							break;
#line 1307 "rygel-http-item-uri.c"
						}
					}
				} else if (_tmp29_ == ((0 != _tmp28_label1) ? _tmp28_label1 : (_tmp28_label1 = g_quark_from_static_string ("th")))) {
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
					switch (0) {
#line 1313 "rygel-http-item-uri.c"
						default:
						{
							gchar** _tmp42_;
							gint _tmp42__length1;
							const gchar* _tmp43_;
#line 175 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp42_ = parts;
#line 175 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp42__length1 = parts_length1;
#line 175 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp43_ = _tmp42_[i + 1];
#line 175 "../src/librygel-server/rygel-http-item-uri.vala"
							rygel_http_item_uri_set_thumbnail_index (self, atoi (_tmp43_));
#line 177 "../src/librygel-server/rygel-http-item-uri.vala"
							break;
#line 1329 "rygel-http-item-uri.c"
						}
					}
				} else if (_tmp29_ == ((0 != _tmp28_label2) ? _tmp28_label2 : (_tmp28_label2 = g_quark_from_static_string ("sub")))) {
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
					switch (0) {
#line 1335 "rygel-http-item-uri.c"
						default:
						{
							gchar** _tmp44_;
							gint _tmp44__length1;
							const gchar* _tmp45_;
#line 179 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp44_ = parts;
#line 179 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp44__length1 = parts_length1;
#line 179 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp45_ = _tmp44_[i + 1];
#line 179 "../src/librygel-server/rygel-http-item-uri.vala"
							rygel_http_item_uri_set_subtitle_index (self, atoi (_tmp45_));
#line 181 "../src/librygel-server/rygel-http-item-uri.vala"
							break;
#line 1351 "rygel-http-item-uri.c"
						}
					}
				} else if (_tmp29_ == ((0 != _tmp28_label3) ? _tmp28_label3 : (_tmp28_label3 = g_quark_from_static_string ("res")))) {
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
					switch (0) {
#line 1357 "rygel-http-item-uri.c"
						default:
						{
							gchar** _tmp46_;
							gint _tmp46__length1;
							const gchar* _tmp47_;
							gchar* _tmp48_;
							gchar* _tmp49_;
#line 183 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp46_ = parts;
#line 183 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp46__length1 = parts_length1;
#line 183 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp47_ = _tmp46_[i + 1];
#line 183 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp48_ = g_uri_unescape_string (_tmp47_, NULL);
#line 183 "../src/librygel-server/rygel-http-item-uri.vala"
							_tmp49_ = _tmp48_;
#line 183 "../src/librygel-server/rygel-http-item-uri.vala"
							rygel_http_item_uri_set_resource_name (self, _tmp49_);
#line 183 "../src/librygel-server/rygel-http-item-uri.vala"
							_g_free0 (_tmp49_);
#line 185 "../src/librygel-server/rygel-http-item-uri.vala"
							break;
#line 1381 "rygel-http-item-uri.c"
						}
					}
				} else {
#line 165 "../src/librygel-server/rygel-http-item-uri.vala"
					switch (0) {
#line 1387 "rygel-http-item-uri.c"
						default:
						{
#line 187 "../src/librygel-server/rygel-http-item-uri.vala"
							break;
#line 1392 "rygel-http-item-uri.c"
						}
					}
				}
			}
		}
	}
#line 191 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp50_ = self->priv->_item_id;
#line 191 "../src/librygel-server/rygel-http-item-uri.vala"
	if (_tmp50_ == NULL) {
#line 1403 "rygel-http-item-uri.c"
		GError* _tmp51_;
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp51_ = g_error_new_literal (RYGEL_HTTP_REQUEST_ERROR, RYGEL_HTTP_REQUEST_ERROR_NOT_FOUND, _ ("Not found"));
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
		_inner_error0_ = _tmp51_;
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
		if (_inner_error0_->domain == RYGEL_HTTP_REQUEST_ERROR) {
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			g_propagate_error (error, _inner_error0_);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (last_part);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (request_uri);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_object_unref0 (self);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			return NULL;
#line 1423 "rygel-http-item-uri.c"
		} else {
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (last_part);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (request_uri);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			g_clear_error (&_inner_error0_);
#line 192 "../src/librygel-server/rygel-http-item-uri.vala"
			return NULL;
#line 1437 "rygel-http-item-uri.c"
		}
	}
#line 139 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (last_part);
#line 139 "../src/librygel-server/rygel-http-item-uri.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 139 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (request_uri);
#line 139 "../src/librygel-server/rygel-http-item-uri.vala"
	return self;
#line 1448 "rygel-http-item-uri.c"
}

RygelHTTPItemURI*
rygel_http_item_uri_new_from_string (const gchar* uri,
                                     RygelHTTPServer* http_server,
                                     GError** error)
{
#line 139 "../src/librygel-server/rygel-http-item-uri.vala"
	return rygel_http_item_uri_construct_from_string (RYGEL_TYPE_HTTP_ITEM_URI, uri, http_server, error);
#line 1458 "rygel-http-item-uri.c"
}

gchar*
rygel_http_item_uri_to_string (RygelHTTPItemURI* self)
{
	gchar* data = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* escaped = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* path = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* result;
#line 196 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = self->priv->_item_id;
#line 201 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp1_ = rygel_http_item_uri_base64_urlencode (self, _tmp0_);
#line 201 "../src/librygel-server/rygel-http-item-uri.vala"
	data = _tmp1_;
#line 202 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp2_ = data;
#line 202 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp3_ = g_uri_escape_string (_tmp2_, "", TRUE);
#line 202 "../src/librygel-server/rygel-http-item-uri.vala"
	escaped = _tmp3_;
#line 203 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp4_ = escaped;
#line 203 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp5_ = g_strconcat ("/i/", _tmp4_, NULL);
#line 203 "../src/librygel-server/rygel-http-item-uri.vala"
	path = _tmp5_;
#line 205 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp6_ = self->priv->_thumbnail_index;
#line 205 "../src/librygel-server/rygel-http-item-uri.vala"
	if (_tmp6_ >= 0) {
#line 1506 "rygel-http-item-uri.c"
		const gchar* _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp7_ = path;
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp8_ = self->priv->_thumbnail_index;
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp9_ = g_strdup_printf ("%i", _tmp8_);
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp10_ = _tmp9_;
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp11_ = g_strconcat ("/th/", _tmp10_, NULL);
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp12_ = _tmp11_;
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp13_ = g_strconcat (_tmp7_, _tmp12_, NULL);
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (path);
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		path = _tmp13_;
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (_tmp12_);
#line 206 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (_tmp10_);
#line 1536 "rygel-http-item-uri.c"
	} else {
		gint _tmp14_;
#line 207 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp14_ = self->priv->_subtitle_index;
#line 207 "../src/librygel-server/rygel-http-item-uri.vala"
		if (_tmp14_ >= 0) {
#line 1543 "rygel-http-item-uri.c"
			const gchar* _tmp15_;
			gint _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp15_ = path;
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp16_ = self->priv->_subtitle_index;
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp17_ = g_strdup_printf ("%i", _tmp16_);
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp18_ = _tmp17_;
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp19_ = g_strconcat ("/sub/", _tmp18_, NULL);
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp20_ = _tmp19_;
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp21_ = g_strconcat (_tmp15_, _tmp20_, NULL);
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (path);
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			path = _tmp21_;
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (_tmp20_);
#line 208 "../src/librygel-server/rygel-http-item-uri.vala"
			_g_free0 (_tmp18_);
#line 1573 "rygel-http-item-uri.c"
		} else {
			const gchar* _tmp22_;
#line 209 "../src/librygel-server/rygel-http-item-uri.vala"
			_tmp22_ = self->priv->_resource_name;
#line 209 "../src/librygel-server/rygel-http-item-uri.vala"
			if (_tmp22_ != NULL) {
#line 1580 "rygel-http-item-uri.c"
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp23_ = path;
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp24_ = self->priv->_resource_name;
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp25_ = g_uri_escape_string (_tmp24_, "", TRUE);
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp26_ = _tmp25_;
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp27_ = g_strconcat ("/res/", _tmp26_, NULL);
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp28_ = _tmp27_;
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp29_ = g_strconcat (_tmp23_, _tmp28_, NULL);
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_g_free0 (path);
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				path = _tmp29_;
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_g_free0 (_tmp28_);
#line 210 "../src/librygel-server/rygel-http-item-uri.vala"
				_g_free0 (_tmp26_);
#line 1610 "rygel-http-item-uri.c"
			}
		}
	}
#line 213 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp30_ = path;
#line 213 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp31_ = rygel_http_item_uri_get_extension (self);
#line 213 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp32_ = _tmp31_;
#line 213 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp33_ = _tmp32_;
#line 213 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp34_ = g_strconcat (_tmp30_, _tmp33_, NULL);
#line 213 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (path);
#line 213 "../src/librygel-server/rygel-http-item-uri.vala"
	path = _tmp34_;
#line 213 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (_tmp33_);
#line 215 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp35_ = path;
#line 215 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp36_ = rygel_http_item_uri_create_uri_for_path (self, _tmp35_);
#line 215 "../src/librygel-server/rygel-http-item-uri.vala"
	result = _tmp36_;
#line 215 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (path);
#line 215 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (escaped);
#line 215 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (data);
#line 215 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 1644 "rygel-http-item-uri.c"
}

static gchar*
rygel_http_item_uri_create_uri_for_path (RygelHTTPItemURI* self,
                                         const gchar* path)
{
	GInetAddress* addr = NULL;
	RygelHTTPServer* _tmp0_;
	GUPnPContext* _tmp1_;
	GInetAddress* _tmp2_;
	GInetAddress* _tmp3_;
	GSocketFamily _tmp4_;
	GSocketFamily _tmp5_;
	gchar* result;
#line 218 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 219 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = self->priv->_http_server;
#line 219 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp1_ = _tmp0_->context;
#line 219 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp2_ = gssdp_client_get_address ((GSSDPClient*) _tmp1_);
#line 219 "../src/librygel-server/rygel-http-item-uri.vala"
	addr = _tmp2_;
#line 220 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp3_ = addr;
#line 220 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp4_ = g_inet_address_get_family (_tmp3_);
#line 220 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp5_ = _tmp4_;
#line 220 "../src/librygel-server/rygel-http-item-uri.vala"
	if (_tmp5_ == G_SOCKET_FAMILY_IPV6) {
#line 1679 "rygel-http-item-uri.c"
		GInetAddress* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		RygelHTTPServer* _tmp9_;
		GUPnPContext* _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
		RygelHTTPServer* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp6_ = addr;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp7_ = g_inet_address_to_string (_tmp6_);
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp8_ = _tmp7_;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp9_ = self->priv->_http_server;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp10_ = _tmp9_->context;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp11_ = gssdp_client_get_port ((GSSDPClient*) _tmp10_);
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp12_ = _tmp11_;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp13_ = self->priv->_http_server;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp14_ = rygel_http_server_get_path_root (_tmp13_);
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp15_ = _tmp14_;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp16_ = g_strdup_printf ("http://[%s]:%u%s%s", _tmp8_, _tmp12_, _tmp15_, path);
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp17_ = _tmp16_;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (_tmp8_);
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		result = _tmp17_;
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_object_unref0 (addr);
#line 221 "../src/librygel-server/rygel-http-item-uri.vala"
		return result;
#line 1724 "rygel-http-item-uri.c"
	} else {
		GInetAddress* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		RygelHTTPServer* _tmp21_;
		GUPnPContext* _tmp22_;
		guint _tmp23_;
		guint _tmp24_;
		RygelHTTPServer* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp18_ = addr;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp19_ = g_inet_address_to_string (_tmp18_);
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp20_ = _tmp19_;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp21_ = self->priv->_http_server;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp22_ = _tmp21_->context;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp23_ = gssdp_client_get_port ((GSSDPClient*) _tmp22_);
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp24_ = _tmp23_;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp25_ = self->priv->_http_server;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp26_ = rygel_http_server_get_path_root (_tmp25_);
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp27_ = _tmp26_;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp28_ = g_strdup_printf ("http://%s:%u%s%s", _tmp20_, _tmp24_, _tmp27_, path);
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp29_ = _tmp28_;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (_tmp20_);
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		result = _tmp29_;
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_object_unref0 (addr);
#line 226 "../src/librygel-server/rygel-http-item-uri.vala"
		return result;
#line 1770 "rygel-http-item-uri.c"
	}
}

static gchar*
rygel_http_item_uri_ext_from_mime_type (RygelHTTPItemURI* self,
                                        const gchar* mime_type)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp29_;
	gchar* _tmp32_;
	gchar* result;
#line 233 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 234 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = rygel_http_item_uri_mime_to_ext;
#line 234 "../src/librygel-server/rygel-http-item-uri.vala"
	if (_tmp0_ == NULL) {
#line 1790 "rygel-http-item-uri.c"
		GeeHashMap* _tmp1_;
		gchar** videos = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar** _tmp5_;
		gint videos_length1;
		gint _videos_size_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		GeeHashMap* _tmp13_;
		GeeHashMap* _tmp14_;
		GeeHashMap* _tmp15_;
		gchar** images = NULL;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar** _tmp18_;
		gint images_length1;
		gint _images_size_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		GeeHashMap* _tmp26_;
		GeeHashMap* _tmp27_;
		GeeHashMap* _tmp28_;
#line 235 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 235 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_object_unref0 (rygel_http_item_uri_mime_to_ext);
#line 235 "../src/librygel-server/rygel-http-item-uri.vala"
		rygel_http_item_uri_mime_to_ext = _tmp1_;
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp2_ = g_strdup ("mpeg");
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp3_ = g_strdup ("webm");
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp4_ = g_strdup ("ogg");
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp5_ = g_new0 (gchar*, 3 + 1);
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp5_[0] = _tmp2_;
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp5_[1] = _tmp3_;
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp5_[2] = _tmp4_;
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		videos = _tmp5_;
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		videos_length1 = 3;
#line 237 "../src/librygel-server/rygel-http-item-uri.vala"
		_videos_size_ = videos_length1;
#line 239 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp6_ = videos;
#line 239 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp6__length1 = videos_length1;
#line 1845 "rygel-http-item-uri.c"
		{
			gchar** video_collection = NULL;
			gint video_collection_length1 = 0;
			gint _video_collection_size_ = 0;
			gint video_it = 0;
#line 239 "../src/librygel-server/rygel-http-item-uri.vala"
			video_collection = _tmp6_;
#line 239 "../src/librygel-server/rygel-http-item-uri.vala"
			video_collection_length1 = _tmp6__length1;
#line 239 "../src/librygel-server/rygel-http-item-uri.vala"
			for (video_it = 0; video_it < video_collection_length1; video_it = video_it + 1) {
#line 1857 "rygel-http-item-uri.c"
				gchar* _tmp7_;
				gchar* video = NULL;
#line 239 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp7_ = g_strdup (video_collection[video_it]);
#line 239 "../src/librygel-server/rygel-http-item-uri.vala"
				video = _tmp7_;
#line 1864 "rygel-http-item-uri.c"
				{
					GeeHashMap* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					const gchar* _tmp12_;
#line 240 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp8_ = rygel_http_item_uri_mime_to_ext;
#line 240 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp9_ = video;
#line 240 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp10_ = g_strconcat ("video/", _tmp9_, NULL);
#line 240 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp11_ = _tmp10_;
#line 240 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp12_ = video;
#line 240 "../src/librygel-server/rygel-http-item-uri.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, _tmp11_, _tmp12_);
#line 240 "../src/librygel-server/rygel-http-item-uri.vala"
					_g_free0 (_tmp11_);
#line 239 "../src/librygel-server/rygel-http-item-uri.vala"
					_g_free0 (video);
#line 1887 "rygel-http-item-uri.c"
				}
			}
		}
#line 242 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp13_ = rygel_http_item_uri_mime_to_ext;
#line 242 "../src/librygel-server/rygel-http-item-uri.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, "video/x-matroska", "mkv");
#line 245 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp14_ = rygel_http_item_uri_mime_to_ext;
#line 245 "../src/librygel-server/rygel-http-item-uri.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, "audio/x-wav", "wav");
#line 246 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp15_ = rygel_http_item_uri_mime_to_ext;
#line 246 "../src/librygel-server/rygel-http-item-uri.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, "audio/x-matroska", "mka");
#line 249 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp16_ = g_strdup ("jpeg");
#line 249 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp17_ = g_strdup ("png");
#line 249 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp18_ = g_new0 (gchar*, 2 + 1);
#line 249 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp18_[0] = _tmp16_;
#line 249 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp18_[1] = _tmp17_;
#line 249 "../src/librygel-server/rygel-http-item-uri.vala"
		images = _tmp18_;
#line 249 "../src/librygel-server/rygel-http-item-uri.vala"
		images_length1 = 2;
#line 249 "../src/librygel-server/rygel-http-item-uri.vala"
		_images_size_ = images_length1;
#line 251 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp19_ = images;
#line 251 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp19__length1 = images_length1;
#line 1923 "rygel-http-item-uri.c"
		{
			gchar** image_collection = NULL;
			gint image_collection_length1 = 0;
			gint _image_collection_size_ = 0;
			gint image_it = 0;
#line 251 "../src/librygel-server/rygel-http-item-uri.vala"
			image_collection = _tmp19_;
#line 251 "../src/librygel-server/rygel-http-item-uri.vala"
			image_collection_length1 = _tmp19__length1;
#line 251 "../src/librygel-server/rygel-http-item-uri.vala"
			for (image_it = 0; image_it < image_collection_length1; image_it = image_it + 1) {
#line 1935 "rygel-http-item-uri.c"
				gchar* _tmp20_;
				gchar* image = NULL;
#line 251 "../src/librygel-server/rygel-http-item-uri.vala"
				_tmp20_ = g_strdup (image_collection[image_it]);
#line 251 "../src/librygel-server/rygel-http-item-uri.vala"
				image = _tmp20_;
#line 1942 "rygel-http-item-uri.c"
				{
					GeeHashMap* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					const gchar* _tmp25_;
#line 252 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp21_ = rygel_http_item_uri_mime_to_ext;
#line 252 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp22_ = image;
#line 252 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp23_ = g_strconcat ("image/", _tmp22_, NULL);
#line 252 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp24_ = _tmp23_;
#line 252 "../src/librygel-server/rygel-http-item-uri.vala"
					_tmp25_ = image;
#line 252 "../src/librygel-server/rygel-http-item-uri.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, _tmp24_, _tmp25_);
#line 252 "../src/librygel-server/rygel-http-item-uri.vala"
					_g_free0 (_tmp24_);
#line 251 "../src/librygel-server/rygel-http-item-uri.vala"
					_g_free0 (image);
#line 1965 "rygel-http-item-uri.c"
				}
			}
		}
#line 256 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp26_ = rygel_http_item_uri_mime_to_ext;
#line 256 "../src/librygel-server/rygel-http-item-uri.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp26_, "text/srt", "srt");
#line 257 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp27_ = rygel_http_item_uri_mime_to_ext;
#line 257 "../src/librygel-server/rygel-http-item-uri.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp27_, "text/xml", "xml");
#line 260 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp28_ = rygel_http_item_uri_mime_to_ext;
#line 260 "../src/librygel-server/rygel-http-item-uri.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, "application/ogg", "ogg");
#line 234 "../src/librygel-server/rygel-http-item-uri.vala"
		images = (_vala_array_free (images, images_length1, (GDestroyNotify) g_free), NULL);
#line 234 "../src/librygel-server/rygel-http-item-uri.vala"
		videos = (_vala_array_free (videos, videos_length1, (GDestroyNotify) g_free), NULL);
#line 1985 "rygel-http-item-uri.c"
	}
#line 263 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp29_ = rygel_http_item_uri_mime_to_ext;
#line 263 "../src/librygel-server/rygel-http-item-uri.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp29_, mime_type)) {
#line 1991 "rygel-http-item-uri.c"
		GeeHashMap* _tmp30_;
		gpointer _tmp31_;
#line 264 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp30_ = rygel_http_item_uri_mime_to_ext;
#line 264 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp30_, mime_type);
#line 264 "../src/librygel-server/rygel-http-item-uri.vala"
		result = (gchar*) _tmp31_;
#line 264 "../src/librygel-server/rygel-http-item-uri.vala"
		return result;
#line 2002 "rygel-http-item-uri.c"
	}
#line 267 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp32_ = g_strdup ("");
#line 267 "../src/librygel-server/rygel-http-item-uri.vala"
	result = _tmp32_;
#line 267 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 2010 "rygel-http-item-uri.c"
}

const gchar*
rygel_http_item_uri_get_item_id (RygelHTTPItemURI* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = self->priv->_item_id;
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
	result = _tmp0_;
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 2026 "rygel-http-item-uri.c"
}

void
rygel_http_item_uri_set_item_id (RygelHTTPItemURI* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
	old_value = rygel_http_item_uri_get_item_id (self);
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2040 "rygel-http-item-uri.c"
		gchar* _tmp0_;
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (self->priv->_item_id);
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
		self->priv->_item_id = _tmp0_;
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_ITEM_ID_PROPERTY]);
#line 2050 "rygel-http-item-uri.c"
	}
}

gint
rygel_http_item_uri_get_thumbnail_index (RygelHTTPItemURI* self)
{
	gint result;
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
	result = self->priv->_thumbnail_index;
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 2064 "rygel-http-item-uri.c"
}

void
rygel_http_item_uri_set_thumbnail_index (RygelHTTPItemURI* self,
                                         gint value)
{
	gint old_value;
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
	old_value = rygel_http_item_uri_get_thumbnail_index (self);
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
	if (old_value != value) {
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
		self->priv->_thumbnail_index = value;
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_THUMBNAIL_INDEX_PROPERTY]);
#line 2082 "rygel-http-item-uri.c"
	}
}

gint
rygel_http_item_uri_get_subtitle_index (RygelHTTPItemURI* self)
{
	gint result;
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
	result = self->priv->_subtitle_index;
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 2096 "rygel-http-item-uri.c"
}

void
rygel_http_item_uri_set_subtitle_index (RygelHTTPItemURI* self,
                                        gint value)
{
	gint old_value;
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
	old_value = rygel_http_item_uri_get_subtitle_index (self);
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
	if (old_value != value) {
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
		self->priv->_subtitle_index = value;
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_SUBTITLE_INDEX_PROPERTY]);
#line 2114 "rygel-http-item-uri.c"
	}
}

const gchar*
rygel_http_item_uri_get_resource_name (RygelHTTPItemURI* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = self->priv->_resource_name;
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	result = _tmp0_;
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 2131 "rygel-http-item-uri.c"
}

void
rygel_http_item_uri_set_resource_name (RygelHTTPItemURI* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	old_value = rygel_http_item_uri_get_resource_name (self);
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2145 "rygel-http-item-uri.c"
		gchar* _tmp0_;
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
		_g_free0 (self->priv->_resource_name);
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
		self->priv->_resource_name = _tmp0_;
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_RESOURCE_NAME_PROPERTY]);
#line 2155 "rygel-http-item-uri.c"
	}
}

RygelHTTPServer*
rygel_http_item_uri_get_http_server (RygelHTTPItemURI* self)
{
	RygelHTTPServer* result;
	RygelHTTPServer* _tmp0_;
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = self->priv->_http_server;
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
	result = _tmp0_;
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 2172 "rygel-http-item-uri.c"
}

void
rygel_http_item_uri_set_http_server (RygelHTTPItemURI* self,
                                     RygelHTTPServer* value)
{
	RygelHTTPServer* old_value;
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
	old_value = rygel_http_item_uri_get_http_server (self);
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
	if (old_value != value) {
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
		self->priv->_http_server = value;
#line 33 "../src/librygel-server/rygel-http-item-uri.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_HTTP_SERVER_PROPERTY]);
#line 2190 "rygel-http-item-uri.c"
	}
}

gchar*
rygel_http_item_uri_get_extension (RygelHTTPItemURI* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp3_;
#line 37 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = self->priv->real_extension;
#line 38 "../src/librygel-server/rygel-http-item-uri.vala"
	if (g_strcmp0 (_tmp0_, "") != 0) {
#line 2206 "rygel-http-item-uri.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 39 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp1_ = self->priv->real_extension;
#line 39 "../src/librygel-server/rygel-http-item-uri.vala"
		_tmp2_ = g_strconcat (".", _tmp1_, NULL);
#line 39 "../src/librygel-server/rygel-http-item-uri.vala"
		result = _tmp2_;
#line 39 "../src/librygel-server/rygel-http-item-uri.vala"
		return result;
#line 2217 "rygel-http-item-uri.c"
	}
#line 41 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp3_ = g_strdup ("");
#line 41 "../src/librygel-server/rygel-http-item-uri.vala"
	result = _tmp3_;
#line 41 "../src/librygel-server/rygel-http-item-uri.vala"
	return result;
#line 2225 "rygel-http-item-uri.c"
}

void
rygel_http_item_uri_set_extension (RygelHTTPItemURI* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 43 "../src/librygel-server/rygel-http-item-uri.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/librygel-server/rygel-http-item-uri.vala"
	_tmp0_ = g_strdup (value);
#line 44 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (self->priv->real_extension);
#line 44 "../src/librygel-server/rygel-http-item-uri.vala"
	self->priv->real_extension = _tmp0_;
#line 43 "../src/librygel-server/rygel-http-item-uri.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_EXTENSION_PROPERTY]);
#line 2243 "rygel-http-item-uri.c"
}

static void
rygel_http_item_uri_class_init (RygelHTTPItemURIClass * klass,
                                gpointer klass_data)
{
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	rygel_http_item_uri_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	g_type_class_adjust_private_offset (klass, &RygelHTTPItemURI_private_offset);
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_http_item_uri_get_property;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_http_item_uri_set_property;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_http_item_uri_finalize;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_ITEM_URI_ITEM_ID_PROPERTY, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_ITEM_ID_PROPERTY] = g_param_spec_string ("item-id", "item-id", "item-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_ITEM_URI_THUMBNAIL_INDEX_PROPERTY, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_THUMBNAIL_INDEX_PROPERTY] = g_param_spec_int ("thumbnail-index", "thumbnail-index", "thumbnail-index", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_ITEM_URI_SUBTITLE_INDEX_PROPERTY, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_SUBTITLE_INDEX_PROPERTY] = g_param_spec_int ("subtitle-index", "subtitle-index", "subtitle-index", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_ITEM_URI_RESOURCE_NAME_PROPERTY, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_RESOURCE_NAME_PROPERTY] = g_param_spec_string ("resource-name", "resource-name", "resource-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_ITEM_URI_HTTP_SERVER_PROPERTY, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_HTTP_SERVER_PROPERTY] = g_param_spec_object ("http-server", "http-server", "http-server", RYGEL_TYPE_HTTP_SERVER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_ITEM_URI_EXTENSION_PROPERTY, rygel_http_item_uri_properties[RYGEL_HTTP_ITEM_URI_EXTENSION_PROPERTY] = g_param_spec_string ("extension", "extension", "extension", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2272 "rygel-http-item-uri.c"
}

static void
rygel_http_item_uri_instance_init (RygelHTTPItemURI * self,
                                   gpointer klass)
{
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	self->priv = rygel_http_item_uri_get_instance_private (self);
#line 30 "../src/librygel-server/rygel-http-item-uri.vala"
	self->priv->_thumbnail_index = -1;
#line 31 "../src/librygel-server/rygel-http-item-uri.vala"
	self->priv->_subtitle_index = -1;
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	self->priv->_resource_name = NULL;
#line 2287 "rygel-http-item-uri.c"
}

static void
rygel_http_item_uri_finalize (GObject * obj)
{
	RygelHTTPItemURI * self;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_HTTP_ITEM_URI, RygelHTTPItemURI);
#line 29 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (self->priv->_item_id);
#line 32 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (self->priv->_resource_name);
#line 35 "../src/librygel-server/rygel-http-item-uri.vala"
	_g_free0 (self->priv->real_extension);
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	G_OBJECT_CLASS (rygel_http_item_uri_parent_class)->finalize (obj);
#line 2304 "rygel-http-item-uri.c"
}

 G_GNUC_NO_INLINE static GType
rygel_http_item_uri_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelHTTPItemURIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_http_item_uri_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelHTTPItemURI), 0, (GInstanceInitFunc) rygel_http_item_uri_instance_init, NULL };
	GType rygel_http_item_uri_type_id;
	rygel_http_item_uri_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelHTTPItemURI", &g_define_type_info, 0);
	RygelHTTPItemURI_private_offset = g_type_add_instance_private (rygel_http_item_uri_type_id, sizeof (RygelHTTPItemURIPrivate));
	return rygel_http_item_uri_type_id;
}

GType
rygel_http_item_uri_get_type (void)
{
	static volatile gsize rygel_http_item_uri_type_id__once = 0;
	if (g_once_init_enter (&rygel_http_item_uri_type_id__once)) {
		GType rygel_http_item_uri_type_id;
		rygel_http_item_uri_type_id = rygel_http_item_uri_get_type_once ();
		g_once_init_leave (&rygel_http_item_uri_type_id__once, rygel_http_item_uri_type_id);
	}
	return rygel_http_item_uri_type_id__once;
}

static void
_vala_rygel_http_item_uri_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	RygelHTTPItemURI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_HTTP_ITEM_URI, RygelHTTPItemURI);
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	switch (property_id) {
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_ITEM_ID_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		g_value_set_string (value, rygel_http_item_uri_get_item_id (self));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_THUMBNAIL_INDEX_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		g_value_set_int (value, rygel_http_item_uri_get_thumbnail_index (self));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_SUBTITLE_INDEX_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		g_value_set_int (value, rygel_http_item_uri_get_subtitle_index (self));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_RESOURCE_NAME_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		g_value_set_string (value, rygel_http_item_uri_get_resource_name (self));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_HTTP_SERVER_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		g_value_set_object (value, rygel_http_item_uri_get_http_server (self));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_EXTENSION_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		g_value_take_string (value, rygel_http_item_uri_get_extension (self));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 2375 "rygel-http-item-uri.c"
		default:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 2381 "rygel-http-item-uri.c"
	}
}

static void
_vala_rygel_http_item_uri_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	RygelHTTPItemURI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_HTTP_ITEM_URI, RygelHTTPItemURI);
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
	switch (property_id) {
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_ITEM_ID_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		rygel_http_item_uri_set_item_id (self, g_value_get_string (value));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_THUMBNAIL_INDEX_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		rygel_http_item_uri_set_thumbnail_index (self, g_value_get_int (value));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_SUBTITLE_INDEX_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		rygel_http_item_uri_set_subtitle_index (self, g_value_get_int (value));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_RESOURCE_NAME_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		rygel_http_item_uri_set_resource_name (self, g_value_get_string (value));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_HTTP_SERVER_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		rygel_http_item_uri_set_http_server (self, g_value_get_object (value));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		case RYGEL_HTTP_ITEM_URI_EXTENSION_PROPERTY:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		rygel_http_item_uri_set_extension (self, g_value_get_string (value));
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 2431 "rygel-http-item-uri.c"
		default:
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/librygel-server/rygel-http-item-uri.vala"
		break;
#line 2437 "rygel-http-item-uri.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

