/* rygel-http-time-seek-request.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-http-time-seek-request.vala, do not modify */

/*
 * Copyright (C) 2009 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <libsoup/soup.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_HTTP_TIME_SEEK_REQUEST_0_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_REQUEST_NUM_PROPERTIES
};
static GParamSpec* rygel_http_time_seek_request_properties[RYGEL_HTTP_TIME_SEEK_REQUEST_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define RYGEL_TYPE_CLIENT_HACKS (rygel_client_hacks_get_type ())
#define RYGEL_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacks))
#define RYGEL_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))
#define RYGEL_IS_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_IS_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_CLIENT_HACKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))

typedef struct _RygelClientHacks RygelClientHacks;
typedef struct _RygelClientHacksClass RygelClientHacksClass;

#define RYGEL_TYPE_CLIENT_HACKS_ERROR (rygel_client_hacks_error_get_type ())

typedef enum  {
	RYGEL_CLIENT_HACKS_ERROR_NA
} RygelClientHacksError;
#define RYGEL_CLIENT_HACKS_ERROR rygel_client_hacks_error_quark ()

static gpointer rygel_http_time_seek_request_parent_class = NULL;

VALA_EXTERN RygelHTTPTimeSeekRequest* rygel_http_time_seek_request_new (SoupServerMessage* message,
                                                            RygelHTTPGetHandler* handler,
                                                            RygelPlaySpeed* speed,
                                                            GError** error);
VALA_EXTERN RygelHTTPTimeSeekRequest* rygel_http_time_seek_request_construct (GType object_type,
                                                                  SoupServerMessage* message,
                                                                  RygelHTTPGetHandler* handler,
                                                                  RygelPlaySpeed* speed,
                                                                  GError** error);
static gboolean rygel_http_time_seek_request_parse_npt_time (const gchar* range_token,
                                                      gint64* value);
VALA_EXTERN GType rygel_client_hacks_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GQuark rygel_client_hacks_error_quark (void);
VALA_EXTERN GType rygel_client_hacks_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelClientHacks* rygel_client_hacks_create (SoupServerMessage* message,
                                             GError** error);
VALA_EXTERN gboolean rygel_client_hacks_force_seek (RygelClientHacks* self);
static gboolean rygel_http_time_seek_request_parse_npt_seconds (const gchar* range_token,
                                                         gint64* value);
static void rygel_http_time_seek_request_finalize (GObject * obj);
static GType rygel_http_time_seek_request_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
     * Create a HTTPTimeSeekRequest corresponding with a HTTPGet that contains a
     * TimeSeekRange.dlna.org header value.
     *
     * Note: This constructor will check the syntax of the request (per DLNA
     * 7.5.4.3.2.24.3) as well as perform some range validation. If the
     * provided request is associated with a handler that can provide content
     * duration, the start and end time will be checked for out-of-bounds
     * conditions. Additionally, the start and end will be checked according
     * to playspeed direction (with rate +1.0 assumed when speed is not
     * provided). When speed is provided, the range end parameter check is
     * relaxed when the rate is not +1.0 (per DLNA 7.5.4.3.2.24.4).
     *
     * @param request The HTTP GET/HEAD request
     * @param speed An associated speed request
     */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 144 "rygel-http-time-seek-request.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 153 "rygel-http-time-seek-request.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 172 "rygel-http-time-seek-request.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 176 "rygel-http-time-seek-request.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 182 "rygel-http-time-seek-request.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 192 "rygel-http-time-seek-request.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 200 "rygel-http-time-seek-request.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 204 "rygel-http-time-seek-request.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 210 "rygel-http-time-seek-request.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 220 "rygel-http-time-seek-request.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 239 "rygel-http-time-seek-request.c"
}

RygelHTTPTimeSeekRequest*
rygel_http_time_seek_request_construct (GType object_type,
                                        SoupServerMessage* message,
                                        RygelHTTPGetHandler* handler,
                                        RygelPlaySpeed* speed,
                                        GError** error)
{
	RygelHTTPTimeSeekRequest * self = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean positive_rate = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean trick_mode = FALSE;
	gchar* range = NULL;
	SoupMessageHeaders* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp7_;
	gchar* parsed_range = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar** range_tokens = NULL;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint range_tokens_length1;
	gint _range_tokens_size_;
	gint64 start = 0LL;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp23_ = FALSE;
	gint64 end = 0LL;
	gchar** _tmp28_;
	gint _tmp28__length1;
	const gchar* _tmp29_;
	gboolean _tmp30_;
	GError* _inner_error0_ = NULL;
#line 71 "../src/librygel-server/rygel-http-time-seek-request.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 71 "../src/librygel-server/rygel-http-time-seek-request.vala"
	g_return_val_if_fail (handler != NULL, NULL);
#line 75 "../src/librygel-server/rygel-http-time-seek-request.vala"
	self = (RygelHTTPTimeSeekRequest*) rygel_http_seek_request_construct (object_type);
#line 77 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (speed == NULL) {
#line 77 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp0_ = TRUE;
#line 292 "rygel-http-time-seek-request.c"
	} else {
#line 77 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp0_ = rygel_play_speed_is_positive (speed);
#line 296 "rygel-http-time-seek-request.c"
	}
#line 77 "../src/librygel-server/rygel-http-time-seek-request.vala"
	positive_rate = _tmp0_;
#line 78 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (speed != NULL) {
#line 78 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp1_ = !rygel_play_speed_is_normal_rate (speed);
#line 304 "rygel-http-time-seek-request.c"
	} else {
#line 78 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp1_ = FALSE;
#line 308 "rygel-http-time-seek-request.c"
	}
#line 78 "../src/librygel-server/rygel-http-time-seek-request.vala"
	trick_mode = _tmp1_;
#line 80 "../src/librygel-server/rygel-http-time-seek-request.vala"
	self->total_duration = rygel_http_get_handler_get_resource_duration (handler);
#line 81 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (self->total_duration <= ((gint64) 0)) {
#line 82 "../src/librygel-server/rygel-http-time-seek-request.vala"
		self->total_duration = RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED;
#line 318 "rygel-http-time-seek-request.c"
	}
#line 85 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp2_ = soup_server_message_get_request_headers (message);
#line 85 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp3_ = soup_message_headers_get_one (_tmp2_, RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER);
#line 85 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 85 "../src/librygel-server/rygel-http-time-seek-request.vala"
	range = _tmp4_;
#line 87 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp5_ = range;
#line 87 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (_tmp5_ == NULL) {
#line 332 "rygel-http-time-seek-request.c"
		GError* _tmp6_;
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp6_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, "%s not present", RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER);
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_inner_error0_ = _tmp6_;
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (range);
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_object_unref0 (self);
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
			return NULL;
#line 348 "rygel-http-time-seek-request.c"
		} else {
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (range);
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 88 "../src/librygel-server/rygel-http-time-seek-request.vala"
			return NULL;
#line 358 "rygel-http-time-seek-request.c"
		}
	}
#line 92 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp7_ = range;
#line 92 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (!g_str_has_prefix (_tmp7_, "npt=")) {
#line 365 "rygel-http-time-seek-request.c"
		const gchar* _tmp8_;
		GError* _tmp9_;
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp8_ = range;
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp9_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, "Invalid %s value (missing npt field): '%s'", RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER, _tmp8_);
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_inner_error0_ = _tmp9_;
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (range);
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_object_unref0 (self);
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
			return NULL;
#line 384 "rygel-http-time-seek-request.c"
		} else {
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (range);
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 93 "../src/librygel-server/rygel-http-time-seek-request.vala"
			return NULL;
#line 394 "rygel-http-time-seek-request.c"
		}
	}
#line 98 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp10_ = range;
#line 98 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp11_ = string_substring (_tmp10_, (glong) 4, (glong) -1);
#line 98 "../src/librygel-server/rygel-http-time-seek-request.vala"
	parsed_range = _tmp11_;
#line 99 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp12_ = parsed_range;
#line 99 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (!string_contains (_tmp12_, "-")) {
#line 407 "rygel-http-time-seek-request.c"
		const gchar* _tmp13_;
		GError* _tmp14_;
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp13_ = range;
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp14_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, "Invalid %s request with no '-': '%s'", RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER, _tmp13_);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_inner_error0_ = _tmp14_;
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (parsed_range);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (range);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_object_unref0 (self);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			return NULL;
#line 428 "rygel-http-time-seek-request.c"
		} else {
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (parsed_range);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (range);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 100 "../src/librygel-server/rygel-http-time-seek-request.vala"
			return NULL;
#line 440 "rygel-http-time-seek-request.c"
		}
	}
#line 105 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp15_ = parsed_range;
#line 105 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, "-", 2);
#line 105 "../src/librygel-server/rygel-http-time-seek-request.vala"
	range_tokens = _tmp17_;
#line 105 "../src/librygel-server/rygel-http-time-seek-request.vala"
	range_tokens_length1 = _vala_array_length (_tmp16_);
#line 105 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_range_tokens_size_ = range_tokens_length1;
#line 107 "../src/librygel-server/rygel-http-time-seek-request.vala"
	start = RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED;
#line 108 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp18_ = range_tokens;
#line 108 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp18__length1 = range_tokens_length1;
#line 108 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp19_ = _tmp18_[0];
#line 108 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp20_ = rygel_http_time_seek_request_parse_npt_time (_tmp19_, &start);
#line 108 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (!_tmp20_) {
#line 465 "rygel-http-time-seek-request.c"
		const gchar* _tmp21_;
		GError* _tmp22_;
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp21_ = range;
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp22_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, "Invalid %s value (no start): '%s'", RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER, _tmp21_);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_inner_error0_ = _tmp22_;
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_propagate_error (error, _inner_error0_);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (parsed_range);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (range);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_object_unref0 (self);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			return NULL;
#line 488 "rygel-http-time-seek-request.c"
		} else {
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (parsed_range);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (range);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			g_clear_error (&_inner_error0_);
#line 109 "../src/librygel-server/rygel-http-time-seek-request.vala"
			return NULL;
#line 502 "rygel-http-time-seek-request.c"
		}
	}
#line 115 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (self->total_duration != RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED) {
#line 115 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp23_ = start > self->total_duration;
#line 509 "rygel-http-time-seek-request.c"
	} else {
#line 115 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp23_ = FALSE;
#line 513 "rygel-http-time-seek-request.c"
	}
#line 115 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (_tmp23_) {
#line 517 "rygel-http-time-seek-request.c"
		gboolean _tmp24_ = FALSE;
#line 116 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (trick_mode) {
#line 116 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_tmp24_ = !positive_rate;
#line 523 "rygel-http-time-seek-request.c"
		} else {
#line 116 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_tmp24_ = FALSE;
#line 527 "rygel-http-time-seek-request.c"
		}
#line 116 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (_tmp24_) {
#line 117 "../src/librygel-server/rygel-http-time-seek-request.vala"
			self->start_time = self->total_duration;
#line 533 "rygel-http-time-seek-request.c"
		} else {
			gchar* msg = NULL;
			gchar* _tmp25_;
			const gchar* _tmp26_;
			GError* _tmp27_;
#line 119 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_tmp25_ = g_strdup ("Invalid %s start time %lldns is beyond the content duration of %lldns");
#line 119 "../src/librygel-server/rygel-http-time-seek-request.vala"
			msg = _tmp25_;
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_tmp26_ = msg;
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_tmp27_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_OUT_OF_RANGE, _tmp26_, RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER, start, self->total_duration);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_inner_error0_ = _tmp27_;
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
			if (_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				g_propagate_error (error, _inner_error0_);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (msg);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (parsed_range);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (range);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_object_unref0 (self);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				return NULL;
#line 565 "rygel-http-time-seek-request.c"
			} else {
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (msg);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (parsed_range);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (range);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				g_clear_error (&_inner_error0_);
#line 121 "../src/librygel-server/rygel-http-time-seek-request.vala"
				return NULL;
#line 581 "rygel-http-time-seek-request.c"
			}
#line 116 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_g_free0 (msg);
#line 585 "rygel-http-time-seek-request.c"
		}
	} else {
#line 128 "../src/librygel-server/rygel-http-time-seek-request.vala"
		self->start_time = start;
#line 590 "rygel-http-time-seek-request.c"
	}
#line 132 "../src/librygel-server/rygel-http-time-seek-request.vala"
	end = RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED;
#line 133 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp28_ = range_tokens;
#line 133 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp28__length1 = range_tokens_length1;
#line 133 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp29_ = _tmp28_[1];
#line 133 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp30_ = rygel_http_time_seek_request_parse_npt_time (_tmp29_, &end);
#line 133 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (_tmp30_) {
#line 136 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (positive_rate) {
#line 606 "rygel-http-time-seek-request.c"
			gboolean _tmp31_ = FALSE;
#line 138 "../src/librygel-server/rygel-http-time-seek-request.vala"
			if (self->total_duration != RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED) {
#line 139 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp31_ = end > self->total_duration;
#line 612 "rygel-http-time-seek-request.c"
			} else {
#line 138 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp31_ = FALSE;
#line 616 "rygel-http-time-seek-request.c"
			}
#line 138 "../src/librygel-server/rygel-http-time-seek-request.vala"
			if (_tmp31_) {
#line 140 "../src/librygel-server/rygel-http-time-seek-request.vala"
				if (trick_mode) {
#line 141 "../src/librygel-server/rygel-http-time-seek-request.vala"
					self->end_time = self->total_duration;
#line 624 "rygel-http-time-seek-request.c"
				} else {
					gchar* msg = NULL;
					gchar* _tmp32_;
					const gchar* _tmp33_;
					GError* _tmp34_;
#line 143 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_tmp32_ = g_strdup ("Invalid %s start time %lldns is beyond the content duration of %lldns");
#line 143 "../src/librygel-server/rygel-http-time-seek-request.vala"
					msg = _tmp32_;
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_tmp33_ = msg;
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_tmp34_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_OUT_OF_RANGE, _tmp33_, RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER, end, self->total_duration);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_inner_error0_ = _tmp34_;
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
					if (_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						g_propagate_error (error, _inner_error0_);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						_g_free0 (msg);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						_g_free0 (parsed_range);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						_g_free0 (range);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						_g_object_unref0 (self);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						return NULL;
#line 656 "rygel-http-time-seek-request.c"
					} else {
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						_g_free0 (msg);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						_g_free0 (parsed_range);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						_g_free0 (range);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						g_clear_error (&_inner_error0_);
#line 144 "../src/librygel-server/rygel-http-time-seek-request.vala"
						return NULL;
#line 672 "rygel-http-time-seek-request.c"
					}
#line 140 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (msg);
#line 676 "rygel-http-time-seek-request.c"
				}
			} else {
#line 151 "../src/librygel-server/rygel-http-time-seek-request.vala"
				self->end_time = end;
#line 681 "rygel-http-time-seek-request.c"
			}
#line 154 "../src/librygel-server/rygel-http-time-seek-request.vala"
			self->range_duration = self->end_time - self->start_time;
#line 156 "../src/librygel-server/rygel-http-time-seek-request.vala"
			if (self->range_duration <= ((gint64) 0)) {
#line 687 "rygel-http-time-seek-request.c"
				gchar* msg = NULL;
				gchar* _tmp35_;
				const gchar* _tmp36_;
				const gchar* _tmp37_;
				GError* _tmp38_;
#line 157 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp35_ = g_strdup ("Invalid %s value (start time after end time - forward scan): '%s'");
#line 157 "../src/librygel-server/rygel-http-time-seek-request.vala"
				msg = _tmp35_;
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp36_ = msg;
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp37_ = range;
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp38_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, _tmp36_, RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER, _tmp37_);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_inner_error0_ = _tmp38_;
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
				if (_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					g_propagate_error (error, _inner_error0_);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (msg);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (parsed_range);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (range);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_object_unref0 (self);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					return NULL;
#line 721 "rygel-http-time-seek-request.c"
				} else {
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (msg);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (parsed_range);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (range);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					g_clear_error (&_inner_error0_);
#line 158 "../src/librygel-server/rygel-http-time-seek-request.vala"
					return NULL;
#line 737 "rygel-http-time-seek-request.c"
				}
#line 156 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (msg);
#line 741 "rygel-http-time-seek-request.c"
			}
		} else {
#line 165 "../src/librygel-server/rygel-http-time-seek-request.vala"
			self->end_time = end;
#line 166 "../src/librygel-server/rygel-http-time-seek-request.vala"
			self->range_duration = self->start_time - self->end_time;
#line 168 "../src/librygel-server/rygel-http-time-seek-request.vala"
			if (self->range_duration <= ((gint64) 0)) {
#line 750 "rygel-http-time-seek-request.c"
				gchar* msg = NULL;
				gchar* _tmp39_;
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				GError* _tmp42_;
#line 169 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp39_ = g_strdup ("Invalid %s value (start time before end time - reverse scan): '%s'");
#line 169 "../src/librygel-server/rygel-http-time-seek-request.vala"
				msg = _tmp39_;
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp40_ = msg;
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp41_ = range;
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp42_ = g_error_new (RYGEL_HTTP_SEEK_REQUEST_ERROR, RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE, _tmp40_, RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER, _tmp41_);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_inner_error0_ = _tmp42_;
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
				if (_inner_error0_->domain == RYGEL_HTTP_SEEK_REQUEST_ERROR) {
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					g_propagate_error (error, _inner_error0_);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (msg);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (parsed_range);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (range);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_object_unref0 (self);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					return NULL;
#line 784 "rygel-http-time-seek-request.c"
				} else {
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (msg);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (parsed_range);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (range);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					g_clear_error (&_inner_error0_);
#line 170 "../src/librygel-server/rygel-http-time-seek-request.vala"
					return NULL;
#line 800 "rygel-http-time-seek-request.c"
				}
#line 168 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (msg);
#line 804 "rygel-http-time-seek-request.c"
			}
		}
	} else {
#line 178 "../src/librygel-server/rygel-http-time-seek-request.vala"
		self->end_time = RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED;
#line 179 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (self->total_duration == RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED) {
#line 180 "../src/librygel-server/rygel-http-time-seek-request.vala"
			self->range_duration = RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED;
#line 814 "rygel-http-time-seek-request.c"
		} else {
#line 182 "../src/librygel-server/rygel-http-time-seek-request.vala"
			if (positive_rate) {
#line 183 "../src/librygel-server/rygel-http-time-seek-request.vala"
				self->end_time = self->total_duration - G_TIME_SPAN_MILLISECOND;
#line 184 "../src/librygel-server/rygel-http-time-seek-request.vala"
				self->range_duration = self->total_duration - self->start_time;
#line 822 "rygel-http-time-seek-request.c"
			} else {
#line 186 "../src/librygel-server/rygel-http-time-seek-request.vala"
				self->end_time = (gint64) 0;
#line 188 "../src/librygel-server/rygel-http-time-seek-request.vala"
				self->range_duration = self->start_time;
#line 828 "rygel-http-time-seek-request.c"
			}
		}
	}
#line 71 "../src/librygel-server/rygel-http-time-seek-request.vala"
	range_tokens = (_vala_array_free (range_tokens, range_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 71 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_g_free0 (parsed_range);
#line 71 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_g_free0 (range);
#line 71 "../src/librygel-server/rygel-http-time-seek-request.vala"
	return self;
#line 840 "rygel-http-time-seek-request.c"
}

RygelHTTPTimeSeekRequest*
rygel_http_time_seek_request_new (SoupServerMessage* message,
                                  RygelHTTPGetHandler* handler,
                                  RygelPlaySpeed* speed,
                                  GError** error)
{
#line 71 "../src/librygel-server/rygel-http-time-seek-request.vala"
	return rygel_http_time_seek_request_construct (RYGEL_TYPE_HTTP_TIME_SEEK_REQUEST, message, handler, speed, error);
#line 851 "rygel-http-time-seek-request.c"
}

gchar*
rygel_http_time_seek_request_to_string (RygelHTTPTimeSeekRequest* self)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_;
	gchar* result;
#line 194 "../src/librygel-server/rygel-http-time-seek-request.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 197 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (self->end_time != RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED) {
#line 864 "rygel-http-time-seek-request.c"
		gchar* _tmp1_;
#line 198 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, self->end_time);
#line 198 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_g_free0 (_tmp0_);
#line 198 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp0_ = _tmp1_;
#line 872 "rygel-http-time-seek-request.c"
	} else {
		gchar* _tmp2_;
#line 199 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp2_ = g_strdup ("*");
#line 199 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_g_free0 (_tmp0_);
#line 199 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp0_ = _tmp2_;
#line 881 "rygel-http-time-seek-request.c"
	}
#line 195 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp3_ = g_strdup_printf ("HTTPTimeSeekRequest (npt=%lld-%s)", self->start_time, _tmp0_);
#line 195 "../src/librygel-server/rygel-http-time-seek-request.vala"
	result = _tmp3_;
#line 195 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_g_free0 (_tmp0_);
#line 195 "../src/librygel-server/rygel-http-time-seek-request.vala"
	return result;
#line 891 "rygel-http-time-seek-request.c"
}

/**
     * Return true if time-seek is supported.
     *
     * This method utilizes elements associated with the request to determine if
     * a TimeSeekRange request is supported for the given request/resource.
     */
gboolean
rygel_http_time_seek_request_supported (SoupServerMessage* message,
                                        RygelHTTPGetHandler* handler)
{
	gboolean force_seek = FALSE;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 208 "../src/librygel-server/rygel-http-time-seek-request.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 208 "../src/librygel-server/rygel-http-time-seek-request.vala"
	g_return_val_if_fail (handler != NULL, FALSE);
#line 210 "../src/librygel-server/rygel-http-time-seek-request.vala"
	force_seek = FALSE;
#line 914 "rygel-http-time-seek-request.c"
	{
		RygelClientHacks* hack = NULL;
		RygelClientHacks* _tmp0_;
#line 213 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp0_ = rygel_client_hacks_create (message, &_inner_error0_);
#line 213 "../src/librygel-server/rygel-http-time-seek-request.vala"
		hack = _tmp0_;
#line 213 "../src/librygel-server/rygel-http-time-seek-request.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 924 "rygel-http-time-seek-request.c"
			goto __catch0_g_error;
		}
#line 214 "../src/librygel-server/rygel-http-time-seek-request.vala"
		force_seek = rygel_client_hacks_force_seek (hack);
#line 212 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_g_object_unref0 (hack);
#line 931 "rygel-http-time-seek-request.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 212 "../src/librygel-server/rygel-http-time-seek-request.vala"
		g_clear_error (&_inner_error0_);
#line 938 "rygel-http-time-seek-request.c"
	}
	__finally0:
#line 212 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 943 "rygel-http-time-seek-request.c"
		gboolean _tmp1_ = FALSE;
#line 212 "../src/librygel-server/rygel-http-time-seek-request.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 212 "../src/librygel-server/rygel-http-time-seek-request.vala"
		g_clear_error (&_inner_error0_);
#line 212 "../src/librygel-server/rygel-http-time-seek-request.vala"
		return _tmp1_;
#line 951 "rygel-http-time-seek-request.c"
	}
#line 217 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (force_seek) {
#line 217 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp2_ = TRUE;
#line 957 "rygel-http-time-seek-request.c"
	} else {
#line 217 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp2_ = rygel_http_get_handler_supports_time_seek (handler);
#line 961 "rygel-http-time-seek-request.c"
	}
#line 217 "../src/librygel-server/rygel-http-time-seek-request.vala"
	result = _tmp2_;
#line 217 "../src/librygel-server/rygel-http-time-seek-request.vala"
	return result;
#line 967 "rygel-http-time-seek-request.c"
}

/**
     * Return true of the HTTPGet contains a TimeSeekRange request.
     */
gboolean
rygel_http_time_seek_request_requested (SoupServerMessage* message)
{
	gchar* header = NULL;
	SoupMessageHeaders* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean result;
#line 223 "../src/librygel-server/rygel-http-time-seek-request.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 224 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp0_ = soup_server_message_get_request_headers (message);
#line 224 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp1_ = soup_message_headers_get_one (_tmp0_, RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER);
#line 224 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 224 "../src/librygel-server/rygel-http-time-seek-request.vala"
	header = _tmp2_;
#line 226 "../src/librygel-server/rygel-http-time-seek-request.vala"
	result = header != NULL;
#line 226 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_g_free0 (header);
#line 226 "../src/librygel-server/rygel-http-time-seek-request.vala"
	return result;
#line 997 "rygel-http-time-seek-request.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 1014 "rygel-http-time-seek-request.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 1027 "rygel-http-time-seek-request.c"
}

static gboolean
rygel_http_time_seek_request_parse_npt_seconds (const gchar* range_token,
                                                gint64* value)
{
	gboolean result;
#line 231 "../src/librygel-server/rygel-http-time-seek-request.vala"
	g_return_val_if_fail (range_token != NULL, FALSE);
#line 233 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (g_ascii_isdigit (string_get (range_token, (glong) 0))) {
#line 234 "../src/librygel-server/rygel-http-time-seek-request.vala"
		*value = (gint64) (double_parse (range_token) * G_TIME_SPAN_SECOND);
#line 1041 "rygel-http-time-seek-request.c"
	} else {
#line 236 "../src/librygel-server/rygel-http-time-seek-request.vala"
		result = FALSE;
#line 236 "../src/librygel-server/rygel-http-time-seek-request.vala"
		return result;
#line 1047 "rygel-http-time-seek-request.c"
	}
#line 239 "../src/librygel-server/rygel-http-time-seek-request.vala"
	result = TRUE;
#line 239 "../src/librygel-server/rygel-http-time-seek-request.vala"
	return result;
#line 1053 "rygel-http-time-seek-request.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1077 "rygel-http-time-seek-request.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 1085 "rygel-http-time-seek-request.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 1091 "rygel-http-time-seek-request.c"
	}
}

static gboolean
rygel_http_time_seek_request_parse_npt_time (const gchar* range_token,
                                             gint64* value)
{
	gint64 seconds_sum = 0LL;
	gint time_factor = 0;
	gchar** time_tokens = NULL;
	gint time_tokens_length1 = 0;
	gint _time_tokens_size_ = 0;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gchar** _tmp5_;
	gint _tmp5__length1;
	const gchar* _tmp6_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gboolean result;
#line 246 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (range_token == NULL) {
#line 247 "../src/librygel-server/rygel-http-time-seek-request.vala"
		result = FALSE;
#line 247 "../src/librygel-server/rygel-http-time-seek-request.vala"
		return result;
#line 1120 "rygel-http-time-seek-request.c"
	}
#line 250 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (string_index_of (range_token, ":", 0) == -1) {
#line 1124 "rygel-http-time-seek-request.c"
		gboolean _tmp0_;
#line 251 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp0_ = rygel_http_time_seek_request_parse_npt_seconds (range_token, value);
#line 251 "../src/librygel-server/rygel-http-time-seek-request.vala"
		result = _tmp0_;
#line 251 "../src/librygel-server/rygel-http-time-seek-request.vala"
		return result;
#line 1132 "rygel-http-time-seek-request.c"
	}
#line 254 "../src/librygel-server/rygel-http-time-seek-request.vala"
	seconds_sum = (gint64) 0;
#line 255 "../src/librygel-server/rygel-http-time-seek-request.vala"
	time_factor = 0;
#line 258 "../src/librygel-server/rygel-http-time-seek-request.vala"
	seconds_sum = (gint64) 0;
#line 259 "../src/librygel-server/rygel-http-time-seek-request.vala"
	time_factor = 3600;
#line 261 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp2_ = _tmp1_ = g_strsplit (range_token, ":", 3);
#line 261 "../src/librygel-server/rygel-http-time-seek-request.vala"
	time_tokens = (_vala_array_free (time_tokens, time_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 261 "../src/librygel-server/rygel-http-time-seek-request.vala"
	time_tokens = _tmp2_;
#line 261 "../src/librygel-server/rygel-http-time-seek-request.vala"
	time_tokens_length1 = _vala_array_length (_tmp1_);
#line 261 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_time_tokens_size_ = time_tokens_length1;
#line 262 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp5_ = time_tokens;
#line 262 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp5__length1 = time_tokens_length1;
#line 262 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp6_ = _tmp5_[0];
#line 262 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (_tmp6_ == NULL) {
#line 262 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp4_ = TRUE;
#line 1162 "rygel-http-time-seek-request.c"
	} else {
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
#line 263 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp7_ = time_tokens;
#line 263 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp7__length1 = time_tokens_length1;
#line 263 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp8_ = _tmp7_[1];
#line 263 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp4_ = _tmp8_ == NULL;
#line 1175 "rygel-http-time-seek-request.c"
	}
#line 262 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (_tmp4_) {
#line 262 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp3_ = TRUE;
#line 1181 "rygel-http-time-seek-request.c"
	} else {
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
#line 264 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp9_ = time_tokens;
#line 264 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp9__length1 = time_tokens_length1;
#line 264 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp10_ = _tmp9_[2];
#line 264 "../src/librygel-server/rygel-http-time-seek-request.vala"
		_tmp3_ = _tmp10_ == NULL;
#line 1194 "rygel-http-time-seek-request.c"
	}
#line 262 "../src/librygel-server/rygel-http-time-seek-request.vala"
	if (_tmp3_) {
#line 265 "../src/librygel-server/rygel-http-time-seek-request.vala"
		result = FALSE;
#line 265 "../src/librygel-server/rygel-http-time-seek-request.vala"
		time_tokens = (_vala_array_free (time_tokens, time_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 265 "../src/librygel-server/rygel-http-time-seek-request.vala"
		return result;
#line 1204 "rygel-http-time-seek-request.c"
	}
#line 268 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp11_ = time_tokens;
#line 268 "../src/librygel-server/rygel-http-time-seek-request.vala"
	_tmp11__length1 = time_tokens_length1;
#line 1210 "rygel-http-time-seek-request.c"
	{
		gchar** time_collection = NULL;
		gint time_collection_length1 = 0;
		gint _time_collection_size_ = 0;
		gint time_it = 0;
#line 268 "../src/librygel-server/rygel-http-time-seek-request.vala"
		time_collection = _tmp11_;
#line 268 "../src/librygel-server/rygel-http-time-seek-request.vala"
		time_collection_length1 = _tmp11__length1;
#line 268 "../src/librygel-server/rygel-http-time-seek-request.vala"
		for (time_it = 0; time_it < time_collection_length1; time_it = time_it + 1) {
#line 1222 "rygel-http-time-seek-request.c"
			gchar* _tmp12_;
			gchar* time = NULL;
#line 268 "../src/librygel-server/rygel-http-time-seek-request.vala"
			_tmp12_ = g_strdup (time_collection[time_it]);
#line 268 "../src/librygel-server/rygel-http-time-seek-request.vala"
			time = _tmp12_;
#line 1229 "rygel-http-time-seek-request.c"
			{
				const gchar* _tmp13_;
#line 269 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_tmp13_ = time;
#line 269 "../src/librygel-server/rygel-http-time-seek-request.vala"
				if (g_ascii_isdigit (string_get (_tmp13_, (glong) 0))) {
#line 1236 "rygel-http-time-seek-request.c"
					const gchar* _tmp14_;
#line 270 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_tmp14_ = time;
#line 270 "../src/librygel-server/rygel-http-time-seek-request.vala"
					seconds_sum += (gint64) ((double_parse (_tmp14_) * G_TIME_SPAN_SECOND) * time_factor);
#line 1242 "rygel-http-time-seek-request.c"
				} else {
#line 273 "../src/librygel-server/rygel-http-time-seek-request.vala"
					result = FALSE;
#line 273 "../src/librygel-server/rygel-http-time-seek-request.vala"
					_g_free0 (time);
#line 273 "../src/librygel-server/rygel-http-time-seek-request.vala"
					time_tokens = (_vala_array_free (time_tokens, time_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 273 "../src/librygel-server/rygel-http-time-seek-request.vala"
					return result;
#line 1252 "rygel-http-time-seek-request.c"
				}
#line 275 "../src/librygel-server/rygel-http-time-seek-request.vala"
				time_factor /= 60;
#line 268 "../src/librygel-server/rygel-http-time-seek-request.vala"
				_g_free0 (time);
#line 1258 "rygel-http-time-seek-request.c"
			}
		}
	}
#line 277 "../src/librygel-server/rygel-http-time-seek-request.vala"
	*value = seconds_sum;
#line 279 "../src/librygel-server/rygel-http-time-seek-request.vala"
	result = TRUE;
#line 279 "../src/librygel-server/rygel-http-time-seek-request.vala"
	time_tokens = (_vala_array_free (time_tokens, time_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 279 "../src/librygel-server/rygel-http-time-seek-request.vala"
	return result;
#line 1270 "rygel-http-time-seek-request.c"
}

static void
rygel_http_time_seek_request_class_init (RygelHTTPTimeSeekRequestClass * klass,
                                         gpointer klass_data)
{
#line 33 "../src/librygel-server/rygel-http-time-seek-request.vala"
	rygel_http_time_seek_request_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/librygel-server/rygel-http-time-seek-request.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_http_time_seek_request_finalize;
#line 1281 "rygel-http-time-seek-request.c"
}

static void
rygel_http_time_seek_request_instance_init (RygelHTTPTimeSeekRequest * self,
                                            gpointer klass)
{
}

static void
rygel_http_time_seek_request_finalize (GObject * obj)
{
	RygelHTTPTimeSeekRequest * self;
#line 33 "../src/librygel-server/rygel-http-time-seek-request.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_HTTP_TIME_SEEK_REQUEST, RygelHTTPTimeSeekRequest);
#line 33 "../src/librygel-server/rygel-http-time-seek-request.vala"
	G_OBJECT_CLASS (rygel_http_time_seek_request_parent_class)->finalize (obj);
#line 1298 "rygel-http-time-seek-request.c"
}

/**
 * This class represents a DLNA TimeSeekRange request.
 *
 * A TimeSeekRange request can only have a time range ("npt=start-end").
 */
 G_GNUC_NO_INLINE static GType
rygel_http_time_seek_request_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelHTTPTimeSeekRequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_http_time_seek_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelHTTPTimeSeekRequest), 0, (GInstanceInitFunc) rygel_http_time_seek_request_instance_init, NULL };
	GType rygel_http_time_seek_request_type_id;
	rygel_http_time_seek_request_type_id = g_type_register_static (RYGEL_TYPE_HTTP_SEEK_REQUEST, "RygelHTTPTimeSeekRequest", &g_define_type_info, 0);
	return rygel_http_time_seek_request_type_id;
}

GType
rygel_http_time_seek_request_get_type (void)
{
	static volatile gsize rygel_http_time_seek_request_type_id__once = 0;
	if (g_once_init_enter (&rygel_http_time_seek_request_type_id__once)) {
		GType rygel_http_time_seek_request_type_id;
		rygel_http_time_seek_request_type_id = rygel_http_time_seek_request_get_type_once ();
		g_once_init_leave (&rygel_http_time_seek_request_type_id__once, rygel_http_time_seek_request_type_id);
	}
	return rygel_http_time_seek_request_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

