/* rygel-http-time-seek-response.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-http-time-seek-response.vala, do not modify */

/*
 * Copyright (C) 2013  Cable Television Laboratories, Inc.
 * Contact: http://www.cablelabs.com/
 *
 * Author: Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <locale.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_HTTP_TIME_SEEK_RESPONSE_0_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_START_TIME_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_END_TIME_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_RANGE_DURATION_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_DURATION_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_START_BYTE_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_END_BYTE_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_RESPONSE_LENGTH_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY,
	RYGEL_HTTP_TIME_SEEK_RESPONSE_NUM_PROPERTIES
};
static GParamSpec* rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_NUM_PROPERTIES];
#define _soup_message_headers_unref0(var) ((var == NULL) ? NULL : (var = (soup_message_headers_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _RygelHTTPTimeSeekResponsePrivate {
	gint64 _start_time;
	gint64 _end_time;
	gint64 _range_duration;
	gint64 _total_duration;
	gint64 _start_byte;
	gint64 _end_byte;
	gint64 _response_length;
	gint64 _total_size;
};

static gint RygelHTTPTimeSeekResponse_private_offset;
static gpointer rygel_http_time_seek_response_parent_class = NULL;

static void rygel_http_time_seek_response_set_start_time (RygelHTTPTimeSeekResponse* self,
                                                   gint64 value);
static void rygel_http_time_seek_response_set_end_time (RygelHTTPTimeSeekResponse* self,
                                                 gint64 value);
static void rygel_http_time_seek_response_set_total_duration (RygelHTTPTimeSeekResponse* self,
                                                       gint64 value);
static void rygel_http_time_seek_response_set_start_byte (RygelHTTPTimeSeekResponse* self,
                                                   gint64 value);
static void rygel_http_time_seek_response_set_end_byte (RygelHTTPTimeSeekResponse* self,
                                                 gint64 value);
static void rygel_http_time_seek_response_set_response_length (RygelHTTPTimeSeekResponse* self,
                                                        gint64 value);
static void rygel_http_time_seek_response_set_total_size (RygelHTTPTimeSeekResponse* self,
                                                   gint64 value);
static void rygel_http_time_seek_response_real_add_response_headers (RygelHTTPResponseElement* base,
                                                              RygelHTTPRequest* request);
static gchar* rygel_http_time_seek_response_get_response_string (RygelHTTPTimeSeekResponse* self);
static gchar* rygel_http_time_seek_response_real_to_string (RygelHTTPResponseElement* base);
static void rygel_http_time_seek_response_set_range_duration (RygelHTTPTimeSeekResponse* self,
                                                       gint64 value);
static void rygel_http_time_seek_response_finalize (GObject * obj);
static GType rygel_http_time_seek_response_get_type_once (void);
static void _vala_rygel_http_time_seek_response_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_rygel_http_time_seek_response_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rygel_http_time_seek_response_get_instance_private (RygelHTTPTimeSeekResponse* self)
{
	return G_STRUCT_MEMBER_P (self, RygelHTTPTimeSeekResponse_private_offset);
}

/**
     * Construct a HTTPTimeSeekResponse with time and byte range
     *
     * start_time and start_byte must be specified.
     *
     * if total_duration and total_size are UNSPECIFIED, then the content
     * duration/size will be signaled as unknown ("*")
     *
     * if end_time is UNSPECIFIED, then the time range end will be omitted
     * from the response. If the end_byte is UNSPECIFIED, the entire byte
     * range response will be omitted. (see DLNA 7.5.4.3.2.24.3)
     */
RygelHTTPTimeSeekResponse*
rygel_http_time_seek_response_construct (GType object_type,
                                         gint64 start_time,
                                         gint64 end_time,
                                         gint64 total_duration,
                                         gint64 start_byte,
                                         gint64 end_byte,
                                         gint64 total_size)
{
	RygelHTTPTimeSeekResponse * self = NULL;
	gint64 _tmp0_;
#line 83 "../src/librygel-server/rygel-http-time-seek-response.vala"
	self = (RygelHTTPTimeSeekResponse*) rygel_http_response_element_construct (object_type);
#line 84 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_start_time (self, start_time);
#line 85 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_end_time (self, end_time);
#line 86 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_total_duration (self, total_duration);
#line 88 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_start_byte (self, start_byte);
#line 89 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_end_byte (self, end_byte);
#line 90 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_response_length (self, end_byte);
#line 92 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp0_ = self->priv->_response_length;
#line 92 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (_tmp0_ != RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED) {
#line 158 "rygel-http-time-seek-response.c"
		gint64 _tmp1_;
#line 93 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp1_ = self->priv->_response_length;
#line 93 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_response_length (self, _tmp1_ - (start_byte - 1));
#line 164 "rygel-http-time-seek-response.c"
	}
#line 96 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_total_size (self, total_size);
#line 77 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return self;
#line 170 "rygel-http-time-seek-response.c"
}

RygelHTTPTimeSeekResponse*
rygel_http_time_seek_response_new (gint64 start_time,
                                   gint64 end_time,
                                   gint64 total_duration,
                                   gint64 start_byte,
                                   gint64 end_byte,
                                   gint64 total_size)
{
#line 77 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return rygel_http_time_seek_response_construct (RYGEL_TYPE_HTTP_TIME_SEEK_RESPONSE, start_time, end_time, total_duration, start_byte, end_byte, total_size);
#line 183 "rygel-http-time-seek-response.c"
}

/**
     * Create a HTTPTimeSeekResponse only containing a time range
     *
     * Note: This form is only valid when byte-seek is not supported,
     * according to the associated resource's ProtocolInfo (see DLNA
     * 7.5.4.3.2.24.5)
     */
RygelHTTPTimeSeekResponse*
rygel_http_time_seek_response_construct_time_only (GType object_type,
                                                   gint64 start_time,
                                                   gint64 end_time,
                                                   gint64 total_duration)
{
	RygelHTTPTimeSeekResponse * self = NULL;
#line 109 "../src/librygel-server/rygel-http-time-seek-response.vala"
	self = (RygelHTTPTimeSeekResponse*) rygel_http_response_element_construct (object_type);
#line 110 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_start_time (self, start_time);
#line 111 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_end_time (self, end_time);
#line 112 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_total_duration (self, total_duration);
#line 114 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_start_byte (self, RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED);
#line 115 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_end_byte (self, RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED);
#line 116 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_response_length (self, RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED);
#line 117 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_total_size (self, RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED);
#line 106 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return self;
#line 218 "rygel-http-time-seek-response.c"
}

RygelHTTPTimeSeekResponse*
rygel_http_time_seek_response_new_time_only (gint64 start_time,
                                             gint64 end_time,
                                             gint64 total_duration)
{
#line 106 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return rygel_http_time_seek_response_construct_time_only (RYGEL_TYPE_HTTP_TIME_SEEK_RESPONSE, start_time, end_time, total_duration);
#line 228 "rygel-http-time-seek-response.c"
}

/**
     * Construct a HTTPTimeSeekResponse with time and byte range and allowing
     * for a response length override. This is useful when the response body
     * is larger than the specified byte range from the original content
     * binary.
     *
     * start_time and start_byte must be specified.
     *
     * If total_duration and total_size are UNSPECIFIED, then the content
     * duration/size will be signaled as unknown ("*")
     *
     * if end_time is UNSPECIFIED, then the time range end will be omitted
     * from the response. If the end_byte is UNSPECIFIED, the entire byte
     * range response will be omitted. (see DLNA 7.5.4.3.2.24.3)
     */
RygelHTTPTimeSeekResponse*
rygel_http_time_seek_response_construct_with_length (GType object_type,
                                                     gint64 start_time,
                                                     gint64 end_time,
                                                     gint64 total_duration,
                                                     gint64 start_byte,
                                                     gint64 end_byte,
                                                     gint64 total_size,
                                                     gint64 response_length)
{
	RygelHTTPTimeSeekResponse * self = NULL;
#line 142 "../src/librygel-server/rygel-http-time-seek-response.vala"
	self = (RygelHTTPTimeSeekResponse*) rygel_http_response_element_construct (object_type);
#line 143 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_start_time (self, start_time);
#line 144 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_end_time (self, end_time);
#line 145 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_total_duration (self, total_duration);
#line 147 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_start_byte (self, start_byte);
#line 148 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_end_byte (self, end_byte);
#line 149 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_response_length (self, response_length);
#line 150 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_set_total_size (self, total_size);
#line 135 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return self;
#line 275 "rygel-http-time-seek-response.c"
}

RygelHTTPTimeSeekResponse*
rygel_http_time_seek_response_new_with_length (gint64 start_time,
                                               gint64 end_time,
                                               gint64 total_duration,
                                               gint64 start_byte,
                                               gint64 end_byte,
                                               gint64 total_size,
                                               gint64 response_length)
{
#line 135 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return rygel_http_time_seek_response_construct_with_length (RYGEL_TYPE_HTTP_TIME_SEEK_RESPONSE, start_time, end_time, total_duration, start_byte, end_byte, total_size, response_length);
#line 289 "rygel-http-time-seek-response.c"
}

/**
     * Create a HTTPTimeSeekResponse from a HTTPTimeSeekRequest
     *
     * Note: This form is only valid when byte-seek is not supported,
     * according to the associated resource's ProtocolInfo (see DLNA
     * 7.5.4.3.2.24.5)
     */
RygelHTTPTimeSeekResponse*
rygel_http_time_seek_response_construct_from_request (GType object_type,
                                                      RygelHTTPTimeSeekRequest* time_seek_request,
                                                      gint64 total_duration)
{
	RygelHTTPTimeSeekResponse * self = NULL;
#line 160 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (time_seek_request != NULL, NULL);
#line 163 "../src/librygel-server/rygel-http-time-seek-response.vala"
	self = (RygelHTTPTimeSeekResponse*) rygel_http_time_seek_response_construct_time_only (object_type, time_seek_request->start_time, time_seek_request->end_time, total_duration);
#line 160 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return self;
#line 311 "rygel-http-time-seek-response.c"
}

RygelHTTPTimeSeekResponse*
rygel_http_time_seek_response_new_from_request (RygelHTTPTimeSeekRequest* time_seek_request,
                                                gint64 total_duration)
{
#line 160 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return rygel_http_time_seek_response_construct_from_request (RYGEL_TYPE_HTTP_TIME_SEEK_RESPONSE, time_seek_request, total_duration);
#line 320 "rygel-http-time-seek-response.c"
}

static gpointer
_soup_message_headers_ref0 (gpointer self)
{
#line 171 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return self ? soup_message_headers_ref (self) : NULL;
#line 328 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_real_add_response_headers (RygelHTTPResponseElement* base,
                                                         RygelHTTPRequest* request)
{
	RygelHTTPTimeSeekResponse * self;
	gchar* response = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 168 "../src/librygel-server/rygel-http-time-seek-response.vala"
	self = (RygelHTTPTimeSeekResponse*) base;
#line 168 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (request != NULL);
#line 169 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp0_ = rygel_http_time_seek_response_get_response_string (self);
#line 169 "../src/librygel-server/rygel-http-time-seek-response.vala"
	response = _tmp0_;
#line 170 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp1_ = response;
#line 170 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (_tmp1_ != NULL) {
#line 351 "rygel-http-time-seek-response.c"
		SoupMessageHeaders* headers = NULL;
		SoupServerMessage* _tmp2_;
		SoupMessageHeaders* _tmp3_;
		SoupMessageHeaders* _tmp4_;
		SoupMessageHeaders* _tmp5_;
		const gchar* _tmp6_;
		gint64 _tmp7_;
		SoupServerMessage* _tmp10_;
#line 171 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp2_ = request->msg;
#line 171 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp3_ = soup_server_message_get_response_headers (_tmp2_);
#line 171 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp4_ = _soup_message_headers_ref0 (_tmp3_);
#line 171 "../src/librygel-server/rygel-http-time-seek-response.vala"
		headers = _tmp4_;
#line 172 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp5_ = headers;
#line 172 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp6_ = response;
#line 172 "../src/librygel-server/rygel-http-time-seek-response.vala"
		soup_message_headers_append (_tmp5_, RYGEL_HTTP_TIME_SEEK_REQUEST_TIMESEEKRANGE_HEADER, _tmp6_);
#line 173 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp7_ = self->priv->_response_length;
#line 173 "../src/librygel-server/rygel-http-time-seek-response.vala"
		if (_tmp7_ != RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED) {
#line 378 "rygel-http-time-seek-response.c"
			SoupMessageHeaders* _tmp8_;
			gint64 _tmp9_;
#line 176 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_tmp8_ = headers;
#line 176 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_tmp9_ = self->priv->_response_length;
#line 176 "../src/librygel-server/rygel-http-time-seek-response.vala"
			soup_message_headers_set_content_length (_tmp8_, _tmp9_);
#line 387 "rygel-http-time-seek-response.c"
		}
#line 179 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp10_ = request->msg;
#line 179 "../src/librygel-server/rygel-http-time-seek-response.vala"
		if (soup_server_message_get_http_version (_tmp10_) == SOUP_HTTP_1_0) {
#line 393 "rygel-http-time-seek-response.c"
			SoupMessageHeaders* _tmp11_;
#line 180 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_tmp11_ = headers;
#line 180 "../src/librygel-server/rygel-http-time-seek-response.vala"
			soup_message_headers_replace (_tmp11_, "Pragma", "no-cache");
#line 399 "rygel-http-time-seek-response.c"
		}
#line 170 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_soup_message_headers_unref0 (headers);
#line 403 "rygel-http-time-seek-response.c"
	}
#line 168 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_g_free0 (response);
#line 407 "rygel-http-time-seek-response.c"
}

static gchar*
rygel_http_time_seek_response_get_response_string (RygelHTTPTimeSeekResponse* self)
{
	gint64 _tmp0_;
	GString* response = NULL;
	GString* _tmp1_;
	gchar* locale = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GString* _tmp4_;
	GString* _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
	gint64 _tmp10_;
	const gchar* _tmp14_;
	gboolean _tmp15_ = FALSE;
	gint64 _tmp16_;
	GString* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* result;
#line 185 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 186 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp0_ = self->priv->_start_time;
#line 186 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (_tmp0_ == RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED) {
#line 187 "../src/librygel-server/rygel-http-time-seek-response.vala"
		result = NULL;
#line 187 "../src/librygel-server/rygel-http-time-seek-response.vala"
		return result;
#line 441 "rygel-http-time-seek-response.c"
	}
#line 206 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp1_ = g_string_new ("");
#line 206 "../src/librygel-server/rygel-http-time-seek-response.vala"
	response = _tmp1_;
#line 207 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp2_ = setlocale (LC_NUMERIC, "C");
#line 207 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 207 "../src/librygel-server/rygel-http-time-seek-response.vala"
	locale = _tmp3_;
#line 208 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp4_ = response;
#line 208 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_string_append (_tmp4_, "npt=");
#line 209 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp5_ = response;
#line 209 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp6_ = self->priv->_start_time;
#line 209 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_string_append_printf (_tmp5_, "%.3f-", ((gdouble) _tmp6_) / G_TIME_SPAN_SECOND);
#line 211 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp7_ = self->priv->_end_time;
#line 211 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (_tmp7_ != RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED) {
#line 467 "rygel-http-time-seek-response.c"
		GString* _tmp8_;
		gint64 _tmp9_;
#line 212 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp8_ = response;
#line 212 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp9_ = self->priv->_end_time;
#line 212 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_string_append_printf (_tmp8_, "%.3f", ((gdouble) _tmp9_) / G_TIME_SPAN_SECOND);
#line 476 "rygel-http-time-seek-response.c"
	}
#line 215 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp10_ = self->priv->_total_duration;
#line 215 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (_tmp10_ != RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED) {
#line 482 "rygel-http-time-seek-response.c"
		gdouble total = 0.0;
		gint64 _tmp11_;
		GString* _tmp12_;
#line 216 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp11_ = self->priv->_total_duration;
#line 216 "../src/librygel-server/rygel-http-time-seek-response.vala"
		total = ((gdouble) _tmp11_) / G_TIME_SPAN_SECOND;
#line 217 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp12_ = response;
#line 217 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_string_append_printf (_tmp12_, "/%.3f", total);
#line 494 "rygel-http-time-seek-response.c"
	} else {
		GString* _tmp13_;
#line 219 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp13_ = response;
#line 219 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_string_append (_tmp13_, "/*");
#line 501 "rygel-http-time-seek-response.c"
	}
#line 221 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp14_ = locale;
#line 221 "../src/librygel-server/rygel-http-time-seek-response.vala"
	setlocale (LC_NUMERIC, _tmp14_);
#line 223 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp16_ = self->priv->_start_byte;
#line 223 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (_tmp16_ != RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED) {
#line 511 "rygel-http-time-seek-response.c"
		gint64 _tmp17_;
#line 224 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp17_ = self->priv->_end_byte;
#line 224 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp15_ = _tmp17_ != RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED;
#line 517 "rygel-http-time-seek-response.c"
	} else {
#line 223 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp15_ = FALSE;
#line 521 "rygel-http-time-seek-response.c"
	}
#line 223 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (_tmp15_) {
#line 525 "rygel-http-time-seek-response.c"
		GString* _tmp18_;
		GString* _tmp19_;
		gint64 _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GString* _tmp23_;
		GString* _tmp24_;
		gint64 _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GString* _tmp28_;
		gint64 _tmp29_;
#line 225 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp18_ = response;
#line 225 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_string_append (_tmp18_, " bytes=");
#line 226 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp19_ = response;
#line 226 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp20_ = self->priv->_start_byte;
#line 226 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp21_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp20_);
#line 226 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp22_ = _tmp21_;
#line 226 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_string_append (_tmp19_, _tmp22_);
#line 226 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_g_free0 (_tmp22_);
#line 227 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp23_ = response;
#line 227 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_string_append (_tmp23_, "-");
#line 228 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp24_ = response;
#line 228 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp25_ = self->priv->_end_byte;
#line 228 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp26_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp25_);
#line 228 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp27_ = _tmp26_;
#line 228 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_string_append (_tmp24_, _tmp27_);
#line 228 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_g_free0 (_tmp27_);
#line 229 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp28_ = response;
#line 229 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_string_append (_tmp28_, "/");
#line 230 "../src/librygel-server/rygel-http-time-seek-response.vala"
		_tmp29_ = self->priv->_total_size;
#line 230 "../src/librygel-server/rygel-http-time-seek-response.vala"
		if (_tmp29_ != RYGEL_HTTP_RESPONSE_ELEMENT_UNSPECIFIED) {
#line 578 "rygel-http-time-seek-response.c"
			GString* _tmp30_;
			gint64 _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
#line 231 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_tmp30_ = response;
#line 231 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_tmp31_ = self->priv->_total_size;
#line 231 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_tmp32_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp31_);
#line 231 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_tmp33_ = _tmp32_;
#line 231 "../src/librygel-server/rygel-http-time-seek-response.vala"
			g_string_append (_tmp30_, _tmp33_);
#line 231 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_g_free0 (_tmp33_);
#line 595 "rygel-http-time-seek-response.c"
		} else {
			GString* _tmp34_;
#line 233 "../src/librygel-server/rygel-http-time-seek-response.vala"
			_tmp34_ = response;
#line 233 "../src/librygel-server/rygel-http-time-seek-response.vala"
			g_string_append (_tmp34_, "*");
#line 602 "rygel-http-time-seek-response.c"
		}
	}
#line 237 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp35_ = response;
#line 237 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp36_ = _tmp35_->str;
#line 237 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp37_ = g_strdup (_tmp36_);
#line 237 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = _tmp37_;
#line 237 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_g_free0 (locale);
#line 237 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_g_string_free0 (response);
#line 237 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 619 "rygel-http-time-seek-response.c"
}

static gchar*
rygel_http_time_seek_response_real_to_string (RygelHTTPResponseElement* base)
{
	RygelHTTPTimeSeekResponse * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 240 "../src/librygel-server/rygel-http-time-seek-response.vala"
	self = (RygelHTTPTimeSeekResponse*) base;
#line 241 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp0_ = rygel_http_time_seek_response_get_response_string (self);
#line 241 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp1_ = _tmp0_;
#line 241 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp2_ = g_strdup_printf ("HTTPTimeSeekResponse (%s)", _tmp1_);
#line 241 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_tmp3_ = _tmp2_;
#line 241 "../src/librygel-server/rygel-http-time-seek-response.vala"
	_g_free0 (_tmp1_);
#line 241 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = _tmp3_;
#line 241 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 647 "rygel-http-time-seek-response.c"
}

gint64
rygel_http_time_seek_response_get_start_time (RygelHTTPTimeSeekResponse* self)
{
	gint64 result;
#line 28 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 28 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = self->priv->_start_time;
#line 28 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 660 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_set_start_time (RygelHTTPTimeSeekResponse* self,
                                              gint64 value)
{
	gint64 old_value;
#line 28 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/librygel-server/rygel-http-time-seek-response.vala"
	old_value = rygel_http_time_seek_response_get_start_time (self);
#line 28 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (old_value != value) {
#line 28 "../src/librygel-server/rygel-http-time-seek-response.vala"
		self->priv->_start_time = value;
#line 28 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_START_TIME_PROPERTY]);
#line 678 "rygel-http-time-seek-response.c"
	}
}

gint64
rygel_http_time_seek_response_get_end_time (RygelHTTPTimeSeekResponse* self)
{
	gint64 result;
#line 33 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 33 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = self->priv->_end_time;
#line 33 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 692 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_set_end_time (RygelHTTPTimeSeekResponse* self,
                                            gint64 value)
{
	gint64 old_value;
#line 33 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/librygel-server/rygel-http-time-seek-response.vala"
	old_value = rygel_http_time_seek_response_get_end_time (self);
#line 33 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (old_value != value) {
#line 33 "../src/librygel-server/rygel-http-time-seek-response.vala"
		self->priv->_end_time = value;
#line 33 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_END_TIME_PROPERTY]);
#line 710 "rygel-http-time-seek-response.c"
	}
}

gint64
rygel_http_time_seek_response_get_range_duration (RygelHTTPTimeSeekResponse* self)
{
	gint64 result;
#line 38 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 38 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = self->priv->_range_duration;
#line 38 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 724 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_set_range_duration (RygelHTTPTimeSeekResponse* self,
                                                  gint64 value)
{
	gint64 old_value;
#line 38 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/librygel-server/rygel-http-time-seek-response.vala"
	old_value = rygel_http_time_seek_response_get_range_duration (self);
#line 38 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (old_value != value) {
#line 38 "../src/librygel-server/rygel-http-time-seek-response.vala"
		self->priv->_range_duration = value;
#line 38 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_RANGE_DURATION_PROPERTY]);
#line 742 "rygel-http-time-seek-response.c"
	}
}

gint64
rygel_http_time_seek_response_get_total_duration (RygelHTTPTimeSeekResponse* self)
{
	gint64 result;
#line 43 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 43 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = self->priv->_total_duration;
#line 43 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 756 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_set_total_duration (RygelHTTPTimeSeekResponse* self,
                                                  gint64 value)
{
	gint64 old_value;
#line 43 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/librygel-server/rygel-http-time-seek-response.vala"
	old_value = rygel_http_time_seek_response_get_total_duration (self);
#line 43 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (old_value != value) {
#line 43 "../src/librygel-server/rygel-http-time-seek-response.vala"
		self->priv->_total_duration = value;
#line 43 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_DURATION_PROPERTY]);
#line 774 "rygel-http-time-seek-response.c"
	}
}

gint64
rygel_http_time_seek_response_get_start_byte (RygelHTTPTimeSeekResponse* self)
{
	gint64 result;
#line 48 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 48 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = self->priv->_start_byte;
#line 48 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 788 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_set_start_byte (RygelHTTPTimeSeekResponse* self,
                                              gint64 value)
{
	gint64 old_value;
#line 48 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/librygel-server/rygel-http-time-seek-response.vala"
	old_value = rygel_http_time_seek_response_get_start_byte (self);
#line 48 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (old_value != value) {
#line 48 "../src/librygel-server/rygel-http-time-seek-response.vala"
		self->priv->_start_byte = value;
#line 48 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_START_BYTE_PROPERTY]);
#line 806 "rygel-http-time-seek-response.c"
	}
}

gint64
rygel_http_time_seek_response_get_end_byte (RygelHTTPTimeSeekResponse* self)
{
	gint64 result;
#line 53 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 53 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = self->priv->_end_byte;
#line 53 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 820 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_set_end_byte (RygelHTTPTimeSeekResponse* self,
                                            gint64 value)
{
	gint64 old_value;
#line 53 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/librygel-server/rygel-http-time-seek-response.vala"
	old_value = rygel_http_time_seek_response_get_end_byte (self);
#line 53 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (old_value != value) {
#line 53 "../src/librygel-server/rygel-http-time-seek-response.vala"
		self->priv->_end_byte = value;
#line 53 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_END_BYTE_PROPERTY]);
#line 838 "rygel-http-time-seek-response.c"
	}
}

gint64
rygel_http_time_seek_response_get_response_length (RygelHTTPTimeSeekResponse* self)
{
	gint64 result;
#line 58 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 58 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = self->priv->_response_length;
#line 58 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 852 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_set_response_length (RygelHTTPTimeSeekResponse* self,
                                                   gint64 value)
{
	gint64 old_value;
#line 58 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/librygel-server/rygel-http-time-seek-response.vala"
	old_value = rygel_http_time_seek_response_get_response_length (self);
#line 58 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (old_value != value) {
#line 58 "../src/librygel-server/rygel-http-time-seek-response.vala"
		self->priv->_response_length = value;
#line 58 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_RESPONSE_LENGTH_PROPERTY]);
#line 870 "rygel-http-time-seek-response.c"
	}
}

gint64
rygel_http_time_seek_response_get_total_size (RygelHTTPTimeSeekResponse* self)
{
	gint64 result;
#line 63 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 63 "../src/librygel-server/rygel-http-time-seek-response.vala"
	result = self->priv->_total_size;
#line 63 "../src/librygel-server/rygel-http-time-seek-response.vala"
	return result;
#line 884 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_set_total_size (RygelHTTPTimeSeekResponse* self,
                                              gint64 value)
{
	gint64 old_value;
#line 63 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/librygel-server/rygel-http-time-seek-response.vala"
	old_value = rygel_http_time_seek_response_get_total_size (self);
#line 63 "../src/librygel-server/rygel-http-time-seek-response.vala"
	if (old_value != value) {
#line 63 "../src/librygel-server/rygel-http-time-seek-response.vala"
		self->priv->_total_size = value;
#line 63 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY]);
#line 902 "rygel-http-time-seek-response.c"
	}
}

static void
rygel_http_time_seek_response_class_init (RygelHTTPTimeSeekResponseClass * klass,
                                          gpointer klass_data)
{
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	rygel_http_time_seek_response_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_type_class_adjust_private_offset (klass, &RygelHTTPTimeSeekResponse_private_offset);
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	((RygelHTTPResponseElementClass *) klass)->add_response_headers = (void (*) (RygelHTTPResponseElement*, RygelHTTPRequest*)) rygel_http_time_seek_response_real_add_response_headers;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	((RygelHTTPResponseElementClass *) klass)->to_string = (gchar* (*) (RygelHTTPResponseElement*)) rygel_http_time_seek_response_real_to_string;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_http_time_seek_response_get_property;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_http_time_seek_response_set_property;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_http_time_seek_response_finalize;
#line 924 "rygel-http-time-seek-response.c"
	/**
	     * Effective range start time, in microseconds
	     */
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_TIME_SEEK_RESPONSE_START_TIME_PROPERTY, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_START_TIME_PROPERTY] = g_param_spec_int64 ("start-time", "start-time", "start-time", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 930 "rygel-http-time-seek-response.c"
	/**
	     * Effective range end time, in microseconds
	     */
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_TIME_SEEK_RESPONSE_END_TIME_PROPERTY, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_END_TIME_PROPERTY] = g_param_spec_int64 ("end-time", "end-time", "end-time", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 936 "rygel-http-time-seek-response.c"
	/**
	     * Effective range duration, in microseconds
	     */
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_TIME_SEEK_RESPONSE_RANGE_DURATION_PROPERTY, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_RANGE_DURATION_PROPERTY] = g_param_spec_int64 ("range-duration", "range-duration", "range-duration", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 942 "rygel-http-time-seek-response.c"
	/**
	     * The total duration of the resource, in microseconds
	     */
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_DURATION_PROPERTY, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_DURATION_PROPERTY] = g_param_spec_int64 ("total-duration", "total-duration", "total-duration", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 948 "rygel-http-time-seek-response.c"
	/**
	     * The start of the range in bytes
	     */
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_TIME_SEEK_RESPONSE_START_BYTE_PROPERTY, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_START_BYTE_PROPERTY] = g_param_spec_int64 ("start-byte", "start-byte", "start-byte", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 954 "rygel-http-time-seek-response.c"
	/**
	     * The end of the range in bytes (inclusive)
	     */
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_TIME_SEEK_RESPONSE_END_BYTE_PROPERTY, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_END_BYTE_PROPERTY] = g_param_spec_int64 ("end-byte", "end-byte", "end-byte", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 960 "rygel-http-time-seek-response.c"
	/**
	     * The response length in bytes
	     */
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_TIME_SEEK_RESPONSE_RESPONSE_LENGTH_PROPERTY, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_RESPONSE_LENGTH_PROPERTY] = g_param_spec_int64 ("response-length", "response-length", "response-length", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 966 "rygel-http-time-seek-response.c"
	/**
	     * The length of the resource in bytes
	     */
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY, rygel_http_time_seek_response_properties[RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY] = g_param_spec_int64 ("total-size", "total-size", "total-size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 972 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_instance_init (RygelHTTPTimeSeekResponse * self,
                                             gpointer klass)
{
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	self->priv = rygel_http_time_seek_response_get_instance_private (self);
#line 981 "rygel-http-time-seek-response.c"
}

static void
rygel_http_time_seek_response_finalize (GObject * obj)
{
	RygelHTTPTimeSeekResponse * self;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_HTTP_TIME_SEEK_RESPONSE, RygelHTTPTimeSeekResponse);
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	G_OBJECT_CLASS (rygel_http_time_seek_response_parent_class)->finalize (obj);
#line 992 "rygel-http-time-seek-response.c"
}

 G_GNUC_NO_INLINE static GType
rygel_http_time_seek_response_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelHTTPTimeSeekResponseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_http_time_seek_response_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelHTTPTimeSeekResponse), 0, (GInstanceInitFunc) rygel_http_time_seek_response_instance_init, NULL };
	GType rygel_http_time_seek_response_type_id;
	rygel_http_time_seek_response_type_id = g_type_register_static (RYGEL_TYPE_HTTP_RESPONSE_ELEMENT, "RygelHTTPTimeSeekResponse", &g_define_type_info, 0);
	RygelHTTPTimeSeekResponse_private_offset = g_type_add_instance_private (rygel_http_time_seek_response_type_id, sizeof (RygelHTTPTimeSeekResponsePrivate));
	return rygel_http_time_seek_response_type_id;
}

GType
rygel_http_time_seek_response_get_type (void)
{
	static volatile gsize rygel_http_time_seek_response_type_id__once = 0;
	if (g_once_init_enter (&rygel_http_time_seek_response_type_id__once)) {
		GType rygel_http_time_seek_response_type_id;
		rygel_http_time_seek_response_type_id = rygel_http_time_seek_response_get_type_once ();
		g_once_init_leave (&rygel_http_time_seek_response_type_id__once, rygel_http_time_seek_response_type_id);
	}
	return rygel_http_time_seek_response_type_id__once;
}

static void
_vala_rygel_http_time_seek_response_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	RygelHTTPTimeSeekResponse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_HTTP_TIME_SEEK_RESPONSE, RygelHTTPTimeSeekResponse);
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	switch (property_id) {
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_START_TIME_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_value_set_int64 (value, rygel_http_time_seek_response_get_start_time (self));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_END_TIME_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_value_set_int64 (value, rygel_http_time_seek_response_get_end_time (self));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_RANGE_DURATION_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_value_set_int64 (value, rygel_http_time_seek_response_get_range_duration (self));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_DURATION_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_value_set_int64 (value, rygel_http_time_seek_response_get_total_duration (self));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_START_BYTE_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_value_set_int64 (value, rygel_http_time_seek_response_get_start_byte (self));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_END_BYTE_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_value_set_int64 (value, rygel_http_time_seek_response_get_end_byte (self));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_RESPONSE_LENGTH_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_value_set_int64 (value, rygel_http_time_seek_response_get_response_length (self));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		g_value_set_int64 (value, rygel_http_time_seek_response_get_total_size (self));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 1075 "rygel-http-time-seek-response.c"
		default:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 1081 "rygel-http-time-seek-response.c"
	}
}

static void
_vala_rygel_http_time_seek_response_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	RygelHTTPTimeSeekResponse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_HTTP_TIME_SEEK_RESPONSE, RygelHTTPTimeSeekResponse);
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
	switch (property_id) {
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_START_TIME_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_start_time (self, g_value_get_int64 (value));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_END_TIME_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_end_time (self, g_value_get_int64 (value));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_RANGE_DURATION_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_range_duration (self, g_value_get_int64 (value));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_DURATION_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_total_duration (self, g_value_get_int64 (value));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_START_BYTE_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_start_byte (self, g_value_get_int64 (value));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_END_BYTE_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_end_byte (self, g_value_get_int64 (value));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_RESPONSE_LENGTH_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_response_length (self, g_value_get_int64 (value));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		case RYGEL_HTTP_TIME_SEEK_RESPONSE_TOTAL_SIZE_PROPERTY:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		rygel_http_time_seek_response_set_total_size (self, g_value_get_int64 (value));
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 1143 "rygel-http-time-seek-response.c"
		default:
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/librygel-server/rygel-http-time-seek-response.vala"
		break;
#line 1149 "rygel-http-time-seek-response.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

