/* rygel-item-updater.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-item-updater.vala, do not modify */

/*
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Krzesimir Nowak <krnowak@openismus.com>
 *         Doug Galligan <doug@sentosatech.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib-object.h>
#include "rygel-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "rygel-server.h"
#include <libgupnp/gupnp.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <gee.h>
#include <libgupnp-av/gupnp-av.h>

#define RYGEL_ITEM_UPDATER_QN_UPNP_DATE "dc:date"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_ITEM_UPDATER (rygel_item_updater_get_type ())
#define RYGEL_ITEM_UPDATER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_ITEM_UPDATER, RygelItemUpdater))
#define RYGEL_ITEM_UPDATER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_ITEM_UPDATER, RygelItemUpdaterClass))
#define RYGEL_IS_ITEM_UPDATER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_ITEM_UPDATER))
#define RYGEL_IS_ITEM_UPDATER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_ITEM_UPDATER))
#define RYGEL_ITEM_UPDATER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_ITEM_UPDATER, RygelItemUpdaterClass))

typedef struct _RygelItemUpdater RygelItemUpdater;
typedef struct _RygelItemUpdaterClass RygelItemUpdaterClass;
typedef struct _RygelItemUpdaterPrivate RygelItemUpdaterPrivate;
enum  {
	RYGEL_ITEM_UPDATER_0_PROPERTY,
	RYGEL_ITEM_UPDATER_CANCELLABLE_PROPERTY,
	RYGEL_ITEM_UPDATER_NUM_PROPERTIES
};
static GParamSpec* rygel_item_updater_properties[RYGEL_ITEM_UPDATER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GUPnPServiceAction_free0(var) ((var == NULL) ? NULL : (var = (_vala_GUPnPServiceAction_free (var), NULL)))

#define RYGEL_TYPE_CONTENT_DIRECTORY_ERROR (rygel_content_directory_error_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _RygelItemUpdaterRunData RygelItemUpdaterRunData;
typedef struct _RygelItemUpdaterUpdateObjectData RygelItemUpdaterUpdateObjectData;
typedef struct _RygelItemUpdaterFetchObjectData RygelItemUpdaterFetchObjectData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _RygelItemUpdater {
	GObject parent_instance;
	RygelItemUpdaterPrivate * priv;
};

struct _RygelItemUpdaterClass {
	GObjectClass parent_class;
};

struct _RygelItemUpdaterPrivate {
	gchar* object_id;
	gchar* current_tag_value;
	gchar* new_tag_value;
	RygelContentDirectory* content_dir;
	GUPnPServiceAction* action;
	GCancellable* _cancellable;
};

typedef enum  {
	RYGEL_CONTENT_DIRECTORY_ERROR_NO_SUCH_OBJECT = 701,
	RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_CURRENT_TAG_VALUE = 702,
	RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_NEW_TAG_VALUE = 703,
	RYGEL_CONTENT_DIRECTORY_ERROR_REQUIRED_TAG = 704,
	RYGEL_CONTENT_DIRECTORY_ERROR_READ_ONLY_TAG = 705,
	RYGEL_CONTENT_DIRECTORY_ERROR_PARAMETER_MISMATCH = 706,
	RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_SEARCH_CRITERIA = 708,
	RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_SORT_CRITERIA = 709,
	RYGEL_CONTENT_DIRECTORY_ERROR_NO_SUCH_CONTAINER = 710,
	RYGEL_CONTENT_DIRECTORY_ERROR_RESTRICTED_OBJECT = 711,
	RYGEL_CONTENT_DIRECTORY_ERROR_BAD_METADATA = 712,
	RYGEL_CONTENT_DIRECTORY_ERROR_RESTRICTED_PARENT = 713,
	RYGEL_CONTENT_DIRECTORY_ERROR_NO_SUCH_FILE_TRANSFER = 717,
	RYGEL_CONTENT_DIRECTORY_ERROR_NO_SUCH_DESTINATION_RESOURCE = 718,
	RYGEL_CONTENT_DIRECTORY_ERROR_CANT_PROCESS = 720,
	RYGEL_CONTENT_DIRECTORY_ERROR_OUTDATED_OBJECT_METADATA = 728,
	RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_ARGS = 402
} RygelContentDirectoryError;
#define RYGEL_CONTENT_DIRECTORY_ERROR rygel_content_directory_error_quark ()

struct _RygelItemUpdaterRunData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelItemUpdater* self;
	GUPnPServiceAction* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* _tmp5_;
	GUPnPServiceAction* _tmp6_;
	const gchar* _tmp7_;
	GError* _error_;
	GError* _tmp8_;
	GUPnPServiceAction* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GUPnPServiceAction* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GError* _tmp17_;
	const gchar* _tmp18_;
	GError* _inner_error0_;
};

struct _RygelItemUpdaterUpdateObjectData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelItemUpdater* self;
	RygelMediaObject* media_object;
	RygelMediaObject* _tmp0_;
	GeeLinkedList* current_list;
	const gchar* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* new_list;
	const gchar* _tmp3_;
	GeeLinkedList* _tmp4_;
	GeeLinkedList* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GeeLinkedList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GeeLinkedList* _tmp11_;
	gint _tmp12_;
	gpointer* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	GeeLinkedList* _tmp15_;
	gint _tmp16_;
	gpointer* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GUPnPDIDLLiteFragmentResult _result_;
	RygelMediaObject* _tmp19_;
	GeeLinkedList* _tmp20_;
	GeeLinkedList* _tmp21_;
	RygelContentDirectory* _tmp22_;
	RygelHTTPServer* _tmp23_;
	GError* _tmp24_;
	GError* _tmp25_;
	GError* _tmp26_;
	GError* _tmp27_;
	GError* _tmp28_;
	GError* _tmp29_;
	GError* _inner_error0_;
};

struct _RygelItemUpdaterFetchObjectData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelItemUpdater* self;
	RygelMediaObject* result;
	RygelMediaObject* media_object;
	RygelContentDirectory* _tmp0_;
	RygelMediaContainer* _tmp1_;
	const gchar* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	RygelMediaObject* _tmp5_;
	RygelMediaObject* _tmp6_;
	GError* _tmp7_;
	RygelMediaObject* _tmp8_;
	GUPnPOCMFlags _tmp9_;
	GUPnPOCMFlags _tmp10_;
	gchar* msg;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	RygelMediaObject* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GError* _tmp16_;
	RygelMediaObject* _tmp17_;
	RygelMediaContainer* _tmp18_;
	RygelMediaContainer* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gchar* _vala1_msg;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	RygelMediaObject* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	RygelMediaObject* _tmp27_;
	RygelMediaContainer* _tmp28_;
	RygelMediaContainer* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GError* _tmp32_;
	GError* _inner_error0_;
};

static gint RygelItemUpdater_private_offset;
static gpointer rygel_item_updater_parent_class = NULL;
static GRegex* rygel_item_updater_escape_regex;
static GRegex* rygel_item_updater_escape_regex = NULL;
static RygelStateMachineIface * rygel_item_updater_rygel_state_machine_parent_iface = NULL;

VALA_EXTERN GType rygel_item_updater_get_type (void) G_GNUC_CONST ;
static void _vala_GUPnPServiceAction_free (GUPnPServiceAction* self);
VALA_EXTERN RygelItemUpdater* rygel_item_updater_new (RygelContentDirectory* content_dir,
                                          GUPnPServiceAction* action);
VALA_EXTERN RygelItemUpdater* rygel_item_updater_construct (GType object_type,
                                                RygelContentDirectory* content_dir,
                                                GUPnPServiceAction* action);
static void rygel_item_updater_real_run_data_free (gpointer _data);
static void rygel_item_updater_real_run (RygelStateMachine* base,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
static gboolean rygel_item_updater_real_run_co (RygelItemUpdaterRunData* _data_);
VALA_EXTERN GQuark rygel_content_directory_error_quark (void);
VALA_EXTERN GType rygel_content_directory_error_get_type (void) G_GNUC_CONST ;
static void rygel_item_updater_update_object (RygelItemUpdater* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static void rygel_item_updater_update_object_finish (RygelItemUpdater* self,
                                              GAsyncResult* _res_,
                                              GError** error);
static void rygel_item_updater_run_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
static gchar* rygel_item_updater_unescape (const gchar* value);
static gchar* rygel_item_updater_format_tag_values (const gchar* tag_values);
static void rygel_item_updater_check_date_tag (gchar** current_tag,
                                        gint current_tag_length1,
                                        gchar** new_tag,
                                        gint new_tag_length1,
                                        GError** error);
static void rygel_item_updater_check_date (const gchar* date_value,
                                    GError** error);
static GeeLinkedList* rygel_item_updater_csv_split (const gchar* tag_values);
static void rygel_item_updater_update_object_data_free (gpointer _data);
static gboolean rygel_item_updater_update_object_co (RygelItemUpdaterUpdateObjectData* _data_);
static void rygel_item_updater_fetch_object (RygelItemUpdater* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static RygelMediaObject* rygel_item_updater_fetch_object_finish (RygelItemUpdater* self,
                                                          GAsyncResult* _res_,
                                                          GError** error);
static void rygel_item_updater_update_object_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
VALA_EXTERN void rygel_media_object_apply_fragments (RygelMediaObject* self,
                                         GeeLinkedList* current_fragments,
                                         GeeLinkedList* new_fragments,
                                         RygelHTTPServer* http_server,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN GUPnPDIDLLiteFragmentResult rygel_media_object_apply_fragments_finish (RygelMediaObject* self,
                                                                       GAsyncResult* _res_);
static void rygel_item_updater_fetch_object_data_free (gpointer _data);
static gboolean rygel_item_updater_fetch_object_co (RygelItemUpdaterFetchObjectData* _data_);
static void rygel_item_updater_fetch_object_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
VALA_EXTERN gboolean rygel_media_object_get_restricted (RygelMediaObject* self);
static void rygel_item_updater_finalize (GObject * obj);
static GType rygel_item_updater_get_type_once (void);
static void _vala_rygel_item_updater_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_rygel_item_updater_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rygel_item_updater_get_instance_private (RygelItemUpdater* self)
{
	return G_STRUCT_MEMBER_P (self, RygelItemUpdater_private_offset);
}

static void
_vala_GUPnPServiceAction_free (GUPnPServiceAction* self)
{
#line 41 "../src/librygel-server/rygel-item-updater.vala"
	g_boxed_free (gupnp_service_action_get_type (), self);
#line 333 "rygel-item-updater.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/librygel-server/rygel-item-updater.vala"
	return self ? g_object_ref (self) : NULL;
#line 341 "rygel-item-updater.c"
}

RygelItemUpdater*
rygel_item_updater_construct (GType object_type,
                              RygelContentDirectory* content_dir,
                              GUPnPServiceAction* action)
{
	RygelItemUpdater * self = NULL;
	RygelContentDirectory* _tmp0_;
	GCancellable* _tmp1_;
	GUPnPServiceAction* _tmp2_;
#line 53 "../src/librygel-server/rygel-item-updater.vala"
	g_return_val_if_fail (content_dir != NULL, NULL);
#line 53 "../src/librygel-server/rygel-item-updater.vala"
	g_return_val_if_fail (action != NULL, NULL);
#line 53 "../src/librygel-server/rygel-item-updater.vala"
	self = (RygelItemUpdater*) g_object_new (object_type, NULL);
#line 55 "../src/librygel-server/rygel-item-updater.vala"
	_tmp0_ = _g_object_ref0 (content_dir);
#line 55 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (self->priv->content_dir);
#line 55 "../src/librygel-server/rygel-item-updater.vala"
	self->priv->content_dir = _tmp0_;
#line 56 "../src/librygel-server/rygel-item-updater.vala"
	_tmp1_ = content_dir->cancellable;
#line 56 "../src/librygel-server/rygel-item-updater.vala"
	rygel_state_machine_set_cancellable ((RygelStateMachine*) self, _tmp1_);
#line 57 "../src/librygel-server/rygel-item-updater.vala"
	_tmp2_ = action;
#line 57 "../src/librygel-server/rygel-item-updater.vala"
	action = NULL;
#line 57 "../src/librygel-server/rygel-item-updater.vala"
	__vala_GUPnPServiceAction_free0 (self->priv->action);
#line 57 "../src/librygel-server/rygel-item-updater.vala"
	self->priv->action = _tmp2_;
#line 53 "../src/librygel-server/rygel-item-updater.vala"
	__vala_GUPnPServiceAction_free0 (action);
#line 53 "../src/librygel-server/rygel-item-updater.vala"
	return self;
#line 381 "rygel-item-updater.c"
}

RygelItemUpdater*
rygel_item_updater_new (RygelContentDirectory* content_dir,
                        GUPnPServiceAction* action)
{
#line 53 "../src/librygel-server/rygel-item-updater.vala"
	return rygel_item_updater_construct (RYGEL_TYPE_ITEM_UPDATER, content_dir, action);
#line 390 "rygel-item-updater.c"
}

static void
rygel_item_updater_real_run_data_free (gpointer _data)
{
	RygelItemUpdaterRunData* _data_;
	_data_ = _data;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (_data_->self);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_slice_free (RygelItemUpdaterRunData, _data_);
#line 402 "rygel-item-updater.c"
}

static void
rygel_item_updater_real_run (RygelStateMachine* base,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	RygelItemUpdater * self;
	RygelItemUpdaterRunData* _data_;
	RygelItemUpdater* _tmp0_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	self = (RygelItemUpdater*) base;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = g_slice_new0 (RygelItemUpdaterRunData);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_item_updater_real_run_data_free);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_->self = _tmp0_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_real_run_co (_data_);
#line 427 "rygel-item-updater.c"
}

static void
rygel_item_updater_run_finish (RygelStateMachine* base,
                               GAsyncResult* _res_)
{
	RygelItemUpdaterRunData* _data_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 437 "rygel-item-updater.c"
}

static void
rygel_item_updater_run_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	RygelItemUpdaterRunData* _data_;
#line 77 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = _user_data_;
#line 77 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_source_object_ = source_object;
#line 77 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_res_ = _res_;
#line 77 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_real_run_co (_data_);
#line 454 "rygel-item-updater.c"
}

static gboolean
rygel_item_updater_real_run_co (RygelItemUpdaterRunData* _data_)
{
#line 60 "../src/librygel-server/rygel-item-updater.vala"
	switch (_data_->_state_) {
#line 60 "../src/librygel-server/rygel-item-updater.vala"
		case 0:
#line 464 "rygel-item-updater.c"
		goto _state_0;
#line 60 "../src/librygel-server/rygel-item-updater.vala"
		case 1:
#line 468 "rygel-item-updater.c"
		goto _state_1;
		default:
#line 60 "../src/librygel-server/rygel-item-updater.vala"
		g_assert_not_reached ();
#line 473 "rygel-item-updater.c"
	}
	_state_0:
	{
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp0_ = _data_->self->priv->action;
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp1_ = NULL;
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp2_ = NULL;
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp3_ = NULL;
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		gupnp_service_action_get (_data_->_tmp0_, "ObjectID", G_TYPE_STRING, &_data_->_tmp1_, "CurrentTagValue", G_TYPE_STRING, &_data_->_tmp2_, "NewTagValue", G_TYPE_STRING, &_data_->_tmp3_, NULL);
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_g_free0 (_data_->self->priv->object_id);
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_data_->self->priv->object_id = _data_->_tmp1_;
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_g_free0 (_data_->self->priv->current_tag_value);
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_data_->self->priv->current_tag_value = _data_->_tmp2_;
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_g_free0 (_data_->self->priv->new_tag_value);
#line 62 "../src/librygel-server/rygel-item-updater.vala"
		_data_->self->priv->new_tag_value = _data_->_tmp3_;
#line 71 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp4_ = _data_->self->priv->object_id;
#line 71 "../src/librygel-server/rygel-item-updater.vala"
		if (_data_->_tmp4_ == NULL) {
#line 73 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp5_ = g_error_new_literal (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_ARGS, _ ("Object ID missing"));
#line 73 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_inner_error0_ = _data_->_tmp5_;
#line 507 "rygel-item-updater.c"
			goto __catch0_g_error;
		}
#line 77 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_state_ = 1;
#line 77 "../src/librygel-server/rygel-item-updater.vala"
		rygel_item_updater_update_object (_data_->self, rygel_item_updater_run_ready, _data_);
#line 77 "../src/librygel-server/rygel-item-updater.vala"
		return FALSE;
#line 516 "rygel-item-updater.c"
		_state_1:
#line 77 "../src/librygel-server/rygel-item-updater.vala"
		rygel_item_updater_update_object_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 77 "../src/librygel-server/rygel-item-updater.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 522 "rygel-item-updater.c"
			goto __catch0_g_error;
		}
#line 79 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp6_ = _data_->self->priv->action;
#line 79 "../src/librygel-server/rygel-item-updater.vala"
		gupnp_service_action_return_success (_data_->_tmp6_);
#line 81 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp7_ = _data_->self->priv->object_id;
#line 81 "../src/librygel-server/rygel-item-updater.vala"
		g_debug (_ ("Successfully updated object “%s”"), _data_->_tmp7_);
#line 533 "rygel-item-updater.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 61 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 61 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_inner_error0_ = NULL;
#line 83 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp8_ = _data_->_error_;
#line 83 "../src/librygel-server/rygel-item-updater.vala"
		if (_data_->_tmp8_->domain == RYGEL_CONTENT_DIRECTORY_ERROR) {
#line 84 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp9_ = _data_->self->priv->action;
#line 84 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp10_ = _data_->_error_;
#line 84 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp11_ = _data_->_error_;
#line 84 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp12_ = _data_->_tmp11_->message;
#line 84 "../src/librygel-server/rygel-item-updater.vala"
			gupnp_service_action_return_error (_data_->_tmp9_, (guint) _data_->_tmp10_->code, _data_->_tmp12_);
#line 556 "rygel-item-updater.c"
		} else {
#line 86 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp13_ = _data_->self->priv->action;
#line 86 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp14_ = _data_->_error_;
#line 86 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp15_ = _data_->_tmp14_->message;
#line 86 "../src/librygel-server/rygel-item-updater.vala"
			gupnp_service_action_return_error (_data_->_tmp13_, (guint) 701, _data_->_tmp15_);
#line 566 "rygel-item-updater.c"
		}
#line 89 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp16_ = _data_->self->priv->object_id;
#line 89 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp17_ = _data_->_error_;
#line 89 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp18_ = _data_->_tmp17_->message;
#line 89 "../src/librygel-server/rygel-item-updater.vala"
		g_warning (_ ("Failed to update object “%s”: %s"), _data_->_tmp16_, _data_->_tmp18_);
#line 61 "../src/librygel-server/rygel-item-updater.vala"
		_g_error_free0 (_data_->_error_);
#line 578 "rygel-item-updater.c"
	}
	__finally0:
#line 61 "../src/librygel-server/rygel-item-updater.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 61 "../src/librygel-server/rygel-item-updater.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 61 "../src/librygel-server/rygel-item-updater.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 61 "../src/librygel-server/rygel-item-updater.vala"
		g_object_unref (_data_->_async_result);
#line 61 "../src/librygel-server/rygel-item-updater.vala"
		return FALSE;
#line 591 "rygel-item-updater.c"
	}
#line 94 "../src/librygel-server/rygel-item-updater.vala"
	g_signal_emit_by_name ((RygelStateMachine*) _data_->self, "completed");
#line 60 "../src/librygel-server/rygel-item-updater.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 60 "../src/librygel-server/rygel-item-updater.vala"
	if (_data_->_state_ != 0) {
#line 60 "../src/librygel-server/rygel-item-updater.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 60 "../src/librygel-server/rygel-item-updater.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 603 "rygel-item-updater.c"
		}
	}
#line 60 "../src/librygel-server/rygel-item-updater.vala"
	g_object_unref (_data_->_async_result);
#line 60 "../src/librygel-server/rygel-item-updater.vala"
	return FALSE;
#line 610 "rygel-item-updater.c"
}

static gchar*
rygel_item_updater_unescape (const gchar* value)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 97 "../src/librygel-server/rygel-item-updater.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 620 "rygel-item-updater.c"
	{
		gchar* _tmp0_ = NULL;
		GRegex* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		_tmp1_ = rygel_item_updater_escape_regex;
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		_tmp2_ = g_regex_replace (_tmp1_, value, (gssize) -1, 0, "\\1", 0, &_inner_error0_);
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		_tmp0_ = _tmp2_;
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/librygel-server/rygel-item-updater.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 636 "rygel-item-updater.c"
				goto __catch0_g_regex_error;
			}
#line 99 "../src/librygel-server/rygel-item-updater.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/librygel-server/rygel-item-updater.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../src/librygel-server/rygel-item-updater.vala"
			return NULL;
#line 645 "rygel-item-updater.c"
		}
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		_tmp3_ = _tmp0_;
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		_tmp0_ = NULL;
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		result = _tmp3_;
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		_g_free0 (_tmp0_);
#line 99 "../src/librygel-server/rygel-item-updater.vala"
		return result;
#line 657 "rygel-item-updater.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		gchar* _tmp4_;
#line 98 "../src/librygel-server/rygel-item-updater.vala"
		g_clear_error (&_inner_error0_);
#line 101 "../src/librygel-server/rygel-item-updater.vala"
		_tmp4_ = g_strdup (value);
#line 101 "../src/librygel-server/rygel-item-updater.vala"
		result = _tmp4_;
#line 101 "../src/librygel-server/rygel-item-updater.vala"
		return result;
#line 671 "rygel-item-updater.c"
	}
	__finally0:
#line 98 "../src/librygel-server/rygel-item-updater.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/librygel-server/rygel-item-updater.vala"
	g_clear_error (&_inner_error0_);
#line 98 "../src/librygel-server/rygel-item-updater.vala"
	return NULL;
#line 680 "rygel-item-updater.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 694 "rygel-item-updater.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 717 "rygel-item-updater.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 726 "rygel-item-updater.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 745 "rygel-item-updater.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 749 "rygel-item-updater.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 755 "rygel-item-updater.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 765 "rygel-item-updater.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 773 "rygel-item-updater.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 777 "rygel-item-updater.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 783 "rygel-item-updater.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 793 "rygel-item-updater.c"
}

static gchar*
rygel_item_updater_format_tag_values (const gchar* tag_values)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp31_;
	gchar* result;
#line 106 "../src/librygel-server/rygel-item-updater.vala"
	g_return_val_if_fail (tag_values != NULL, NULL);
#line 107 "../src/librygel-server/rygel-item-updater.vala"
	_tmp1_ = strlen (tag_values);
#line 107 "../src/librygel-server/rygel-item-updater.vala"
	_tmp2_ = _tmp1_;
#line 107 "../src/librygel-server/rygel-item-updater.vala"
	if (_tmp2_ > 0) {
#line 107 "../src/librygel-server/rygel-item-updater.vala"
		_tmp0_ = string_get_char (tag_values, (glong) 0) == ((gunichar) '<');
#line 814 "rygel-item-updater.c"
	} else {
#line 107 "../src/librygel-server/rygel-item-updater.vala"
		_tmp0_ = FALSE;
#line 818 "rygel-item-updater.c"
	}
#line 107 "../src/librygel-server/rygel-item-updater.vala"
	if (_tmp0_) {
#line 822 "rygel-item-updater.c"
		gchar** init_split = NULL;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint init_split_length1;
		gint _init_split_size_;
		gchar* tag_name = NULL;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* tag_value = NULL;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gchar** _tmp20_;
		gint _tmp20__length1;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
#line 108 "../src/librygel-server/rygel-item-updater.vala"
		_tmp4_ = _tmp3_ = g_strsplit (tag_values, "</", 0);
#line 108 "../src/librygel-server/rygel-item-updater.vala"
		init_split = _tmp4_;
#line 108 "../src/librygel-server/rygel-item-updater.vala"
		init_split_length1 = _vala_array_length (_tmp3_);
#line 108 "../src/librygel-server/rygel-item-updater.vala"
		_init_split_size_ = init_split_length1;
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp5_ = init_split;
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp5__length1 = init_split_length1;
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp6_ = _tmp5_[1];
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp7_ = init_split;
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp7__length1 = init_split_length1;
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp8_ = _tmp7_[1];
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp9_ = strlen (_tmp8_);
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp10_ = _tmp9_;
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp11_ = string_substring (_tmp6_, (glong) 0, (glong) (_tmp10_ - 1));
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp12_ = _tmp11_;
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp13_ = g_strstrip (_tmp12_);
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_tmp15_ = _tmp14_;
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		_g_free0 (_tmp12_);
#line 109 "../src/librygel-server/rygel-item-updater.vala"
		tag_name = _tmp15_;
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp16_ = init_split;
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp16__length1 = init_split_length1;
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp17_ = _tmp16_[0];
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, ">", 0);
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp20_ = _tmp19_;
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp20__length1 = _vala_array_length (_tmp18_);
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp21_ = _tmp20_[1];
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp22_ = g_strstrip (_tmp21_);
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp24_ = _tmp23_;
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 112 "../src/librygel-server/rygel-item-updater.vala"
		tag_value = _tmp24_;
#line 113 "../src/librygel-server/rygel-item-updater.vala"
		_tmp25_ = tag_name;
#line 113 "../src/librygel-server/rygel-item-updater.vala"
		g_debug ("rygel-item-updater.vala:113: Tag Name formatted :%s", _tmp25_);
#line 114 "../src/librygel-server/rygel-item-updater.vala"
		_tmp26_ = tag_value;
#line 114 "../src/librygel-server/rygel-item-updater.vala"
		g_debug ("rygel-item-updater.vala:114: Tag Value formatted :%s", _tmp26_);
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		_tmp27_ = tag_name;
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		_tmp28_ = tag_value;
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		_tmp29_ = tag_name;
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		_tmp30_ = g_strdup_printf ("<%s>%s</%s>", _tmp27_, _tmp28_, _tmp29_);
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		result = _tmp30_;
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		_g_free0 (tag_value);
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		_g_free0 (tag_name);
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		init_split = (_vala_array_free (init_split, init_split_length1, (GDestroyNotify) g_free), NULL);
#line 116 "../src/librygel-server/rygel-item-updater.vala"
		return result;
#line 948 "rygel-item-updater.c"
	}
#line 119 "../src/librygel-server/rygel-item-updater.vala"
	_tmp31_ = g_strdup (tag_values);
#line 119 "../src/librygel-server/rygel-item-updater.vala"
	result = _tmp31_;
#line 119 "../src/librygel-server/rygel-item-updater.vala"
	return result;
#line 956 "rygel-item-updater.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 980 "rygel-item-updater.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 988 "rygel-item-updater.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 994 "rygel-item-updater.c"
	}
}

static void
rygel_item_updater_check_date_tag (gchar** current_tag,
                                   gint current_tag_length1,
                                   gchar** new_tag,
                                   gint new_tag_length1,
                                   GError** error)
{
	gint date_index = 0;
	GError* _inner_error0_ = NULL;
#line 125 "../src/librygel-server/rygel-item-updater.vala"
	date_index = -1;
#line 1009 "rygel-item-updater.c"
	{
		gchar** cur_str_collection = NULL;
		gint cur_str_collection_length1 = 0;
		gint _cur_str_collection_size_ = 0;
		gint cur_str_it = 0;
#line 129 "../src/librygel-server/rygel-item-updater.vala"
		cur_str_collection = current_tag;
#line 129 "../src/librygel-server/rygel-item-updater.vala"
		cur_str_collection_length1 = current_tag_length1;
#line 129 "../src/librygel-server/rygel-item-updater.vala"
		for (cur_str_it = 0; cur_str_it < cur_str_collection_length1; cur_str_it = cur_str_it + 1) {
#line 1021 "rygel-item-updater.c"
			const gchar* cur_str = NULL;
#line 129 "../src/librygel-server/rygel-item-updater.vala"
			cur_str = cur_str_collection[cur_str_it];
#line 1025 "rygel-item-updater.c"
			{
				gint _tmp0_;
				const gchar* _tmp1_;
#line 130 "../src/librygel-server/rygel-item-updater.vala"
				_tmp0_ = date_index;
#line 130 "../src/librygel-server/rygel-item-updater.vala"
				date_index = _tmp0_ + 1;
#line 131 "../src/librygel-server/rygel-item-updater.vala"
				_tmp1_ = cur_str;
#line 131 "../src/librygel-server/rygel-item-updater.vala"
				if (string_index_of (_tmp1_, RYGEL_ITEM_UPDATER_QN_UPNP_DATE, 0) != -1) {
#line 1037 "rygel-item-updater.c"
					gchar* date_val = NULL;
					const gchar* _tmp2_;
					gchar** _tmp3_;
					gchar** _tmp4_;
					gchar** _tmp5_;
					gint _tmp5__length1;
					const gchar* _tmp6_;
					gchar** _tmp7_;
					gchar** _tmp8_;
					gchar** _tmp9_;
					gint _tmp9__length1;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					const gchar* _tmp14_;
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp2_ = new_tag[date_index];
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "</", 0);
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp5_ = _tmp4_;
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp5__length1 = _vala_array_length (_tmp3_);
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp6_ = _tmp5_[0];
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, ">", 0);
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp9_ = _tmp8_;
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp9__length1 = _vala_array_length (_tmp7_);
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp10_ = _tmp9_[1];
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp11_ = g_strstrip (_tmp10_);
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp12_ = g_strdup (_tmp11_);
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp13_ = _tmp12_;
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 132 "../src/librygel-server/rygel-item-updater.vala"
					date_val = _tmp13_;
#line 134 "../src/librygel-server/rygel-item-updater.vala"
					_tmp14_ = date_val;
#line 134 "../src/librygel-server/rygel-item-updater.vala"
					rygel_item_updater_check_date (_tmp14_, &_inner_error0_);
#line 134 "../src/librygel-server/rygel-item-updater.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../src/librygel-server/rygel-item-updater.vala"
						g_propagate_error (error, _inner_error0_);
#line 134 "../src/librygel-server/rygel-item-updater.vala"
						_g_free0 (date_val);
#line 134 "../src/librygel-server/rygel-item-updater.vala"
						return;
#line 1096 "rygel-item-updater.c"
					}
#line 136 "../src/librygel-server/rygel-item-updater.vala"
					_g_free0 (date_val);
#line 136 "../src/librygel-server/rygel-item-updater.vala"
					break;
#line 1102 "rygel-item-updater.c"
				}
			}
		}
	}
#line 140 "../src/librygel-server/rygel-item-updater.vala"
	date_index = -1;
#line 1109 "rygel-item-updater.c"
	{
		gchar** new_str_collection = NULL;
		gint new_str_collection_length1 = 0;
		gint _new_str_collection_size_ = 0;
		gint new_str_it = 0;
#line 142 "../src/librygel-server/rygel-item-updater.vala"
		new_str_collection = new_tag;
#line 142 "../src/librygel-server/rygel-item-updater.vala"
		new_str_collection_length1 = new_tag_length1;
#line 142 "../src/librygel-server/rygel-item-updater.vala"
		for (new_str_it = 0; new_str_it < new_str_collection_length1; new_str_it = new_str_it + 1) {
#line 1121 "rygel-item-updater.c"
			const gchar* new_str = NULL;
#line 142 "../src/librygel-server/rygel-item-updater.vala"
			new_str = new_str_collection[new_str_it];
#line 1125 "rygel-item-updater.c"
			{
				gint _tmp15_;
				const gchar* _tmp16_;
#line 143 "../src/librygel-server/rygel-item-updater.vala"
				_tmp15_ = date_index;
#line 143 "../src/librygel-server/rygel-item-updater.vala"
				date_index = _tmp15_ + 1;
#line 144 "../src/librygel-server/rygel-item-updater.vala"
				_tmp16_ = new_str;
#line 144 "../src/librygel-server/rygel-item-updater.vala"
				if (string_index_of (_tmp16_, RYGEL_ITEM_UPDATER_QN_UPNP_DATE, 0) != -1) {
#line 1137 "rygel-item-updater.c"
					gchar* date_val = NULL;
					const gchar* _tmp17_;
					gchar** _tmp18_;
					gchar** _tmp19_;
					gchar** _tmp20_;
					gint _tmp20__length1;
					const gchar* _tmp21_;
					gchar** _tmp22_;
					gchar** _tmp23_;
					gchar** _tmp24_;
					gint _tmp24__length1;
					const gchar* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					const gchar* _tmp29_;
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp17_ = new_tag[date_index];
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "</", 0);
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp20_ = _tmp19_;
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp20__length1 = _vala_array_length (_tmp18_);
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp21_ = _tmp20_[0];
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, ">", 0);
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp24_ = _tmp23_;
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp24__length1 = _vala_array_length (_tmp22_);
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp25_ = _tmp24_[1];
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp26_ = g_strstrip (_tmp25_);
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp27_ = g_strdup (_tmp26_);
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp28_ = _tmp27_;
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) g_free), NULL);
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 145 "../src/librygel-server/rygel-item-updater.vala"
					date_val = _tmp28_;
#line 147 "../src/librygel-server/rygel-item-updater.vala"
					_tmp29_ = date_val;
#line 147 "../src/librygel-server/rygel-item-updater.vala"
					rygel_item_updater_check_date (_tmp29_, &_inner_error0_);
#line 147 "../src/librygel-server/rygel-item-updater.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/librygel-server/rygel-item-updater.vala"
						g_propagate_error (error, _inner_error0_);
#line 147 "../src/librygel-server/rygel-item-updater.vala"
						_g_free0 (date_val);
#line 147 "../src/librygel-server/rygel-item-updater.vala"
						return;
#line 1196 "rygel-item-updater.c"
					}
#line 149 "../src/librygel-server/rygel-item-updater.vala"
					_g_free0 (date_val);
#line 149 "../src/librygel-server/rygel-item-updater.vala"
					break;
#line 1202 "rygel-item-updater.c"
				}
			}
		}
	}
}

static void
rygel_item_updater_check_date (const gchar* date_value,
                               GError** error)
{
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_;
	GDate date = {0};
	GError* _inner_error0_ = NULL;
#line 155 "../src/librygel-server/rygel-item-updater.vala"
	g_return_if_fail (date_value != NULL);
#line 156 "../src/librygel-server/rygel-item-updater.vala"
	year = 0;
#line 156 "../src/librygel-server/rygel-item-updater.vala"
	month = 0;
#line 156 "../src/librygel-server/rygel-item-updater.vala"
	day = 0;
#line 157 "../src/librygel-server/rygel-item-updater.vala"
	_tmp3_ = sscanf (date_value, "%4d-%02d-%02d", &_tmp0_, &_tmp1_, &_tmp2_);
#line 157 "../src/librygel-server/rygel-item-updater.vala"
	year = _tmp0_;
#line 157 "../src/librygel-server/rygel-item-updater.vala"
	month = _tmp1_;
#line 157 "../src/librygel-server/rygel-item-updater.vala"
	day = _tmp2_;
#line 157 "../src/librygel-server/rygel-item-updater.vala"
	if (_tmp3_ != 3) {
#line 1240 "rygel-item-updater.c"
		GError* _tmp4_;
#line 161 "../src/librygel-server/rygel-item-updater.vala"
		_tmp4_ = g_error_new (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_NEW_TAG_VALUE, _ ("Invalid date format: %s"), date_value);
#line 161 "../src/librygel-server/rygel-item-updater.vala"
		_inner_error0_ = _tmp4_;
#line 161 "../src/librygel-server/rygel-item-updater.vala"
		g_propagate_error (error, _inner_error0_);
#line 161 "../src/librygel-server/rygel-item-updater.vala"
		return;
#line 1250 "rygel-item-updater.c"
	}
#line 166 "../src/librygel-server/rygel-item-updater.vala"
	memset (&date, 0, sizeof (GDate));
#line 167 "../src/librygel-server/rygel-item-updater.vala"
	g_date_set_dmy (&date, (GDateDay) day, (gint) ((GDateMonth) month), (GDateYear) year);
#line 169 "../src/librygel-server/rygel-item-updater.vala"
	if (!g_date_valid (&date)) {
#line 1258 "rygel-item-updater.c"
		GError* _tmp5_;
#line 170 "../src/librygel-server/rygel-item-updater.vala"
		_tmp5_ = g_error_new (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_NEW_TAG_VALUE, _ ("Invalid date: %s"), date_value);
#line 170 "../src/librygel-server/rygel-item-updater.vala"
		_inner_error0_ = _tmp5_;
#line 170 "../src/librygel-server/rygel-item-updater.vala"
		g_propagate_error (error, _inner_error0_);
#line 170 "../src/librygel-server/rygel-item-updater.vala"
		return;
#line 1268 "rygel-item-updater.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 1286 "rygel-item-updater.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1307 "rygel-item-updater.c"
}

static GeeLinkedList*
rygel_item_updater_csv_split (const gchar* tag_values)
{
	GeeLinkedList* list = NULL;
	GeeLinkedList* _tmp0_;
	gboolean escape = FALSE;
	gint token_start = 0;
	gint token_length = 0;
	gint len = 0;
	gint _tmp1_;
	gint _tmp2_;
	gchar* stripped_values = NULL;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GeeLinkedList* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GeeLinkedList* result;
#line 177 "../src/librygel-server/rygel-item-updater.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 177 "../src/librygel-server/rygel-item-updater.vala"
	list = _tmp0_;
#line 179 "../src/librygel-server/rygel-item-updater.vala"
	if (tag_values == NULL) {
#line 180 "../src/librygel-server/rygel-item-updater.vala"
		result = list;
#line 180 "../src/librygel-server/rygel-item-updater.vala"
		return result;
#line 1343 "rygel-item-updater.c"
	}
#line 183 "../src/librygel-server/rygel-item-updater.vala"
	escape = FALSE;
#line 184 "../src/librygel-server/rygel-item-updater.vala"
	token_start = 0;
#line 185 "../src/librygel-server/rygel-item-updater.vala"
	token_length = 0;
#line 186 "../src/librygel-server/rygel-item-updater.vala"
	_tmp1_ = strlen (tag_values);
#line 186 "../src/librygel-server/rygel-item-updater.vala"
	_tmp2_ = _tmp1_;
#line 186 "../src/librygel-server/rygel-item-updater.vala"
	len = _tmp2_;
#line 1357 "rygel-item-updater.c"
	{
		gint iter = 0;
#line 188 "../src/librygel-server/rygel-item-updater.vala"
		iter = 0;
#line 1362 "rygel-item-updater.c"
		{
			gboolean _tmp3_ = FALSE;
#line 188 "../src/librygel-server/rygel-item-updater.vala"
			_tmp3_ = TRUE;
#line 188 "../src/librygel-server/rygel-item-updater.vala"
			while (TRUE) {
#line 1369 "rygel-item-updater.c"
				gchar c = '\0';
				gboolean increase = FALSE;
#line 188 "../src/librygel-server/rygel-item-updater.vala"
				if (!_tmp3_) {
#line 1374 "rygel-item-updater.c"
					gint _tmp4_;
#line 188 "../src/librygel-server/rygel-item-updater.vala"
					iter = iter + 1;
#line 188 "../src/librygel-server/rygel-item-updater.vala"
					_tmp4_ = iter;
#line 1380 "rygel-item-updater.c"
				}
#line 188 "../src/librygel-server/rygel-item-updater.vala"
				_tmp3_ = FALSE;
#line 188 "../src/librygel-server/rygel-item-updater.vala"
				if (!(iter < len)) {
#line 188 "../src/librygel-server/rygel-item-updater.vala"
					break;
#line 1388 "rygel-item-updater.c"
				}
#line 189 "../src/librygel-server/rygel-item-updater.vala"
				c = string_get (tag_values, (glong) iter);
#line 190 "../src/librygel-server/rygel-item-updater.vala"
				increase = TRUE;
#line 192 "../src/librygel-server/rygel-item-updater.vala"
				if (escape) {
#line 193 "../src/librygel-server/rygel-item-updater.vala"
					escape = FALSE;
#line 1398 "rygel-item-updater.c"
				} else {
#line 195 "../src/librygel-server/rygel-item-updater.vala"
					switch (c) {
#line 195 "../src/librygel-server/rygel-item-updater.vala"
						case '\\':
#line 1404 "rygel-item-updater.c"
						{
#line 197 "../src/librygel-server/rygel-item-updater.vala"
							escape = TRUE;
#line 199 "../src/librygel-server/rygel-item-updater.vala"
							break;
#line 1410 "rygel-item-updater.c"
						}
#line 195 "../src/librygel-server/rygel-item-updater.vala"
						case ',':
#line 1414 "rygel-item-updater.c"
						{
							gchar* value = NULL;
							gchar* _tmp5_;
							gboolean _tmp6_ = FALSE;
							const gchar* _tmp7_;
							gint _tmp8_;
							gint _tmp9_;
							GeeLinkedList* _tmp15_;
							const gchar* _tmp16_;
							gchar* _tmp17_;
							gchar* _tmp18_;
#line 201 "../src/librygel-server/rygel-item-updater.vala"
							_tmp5_ = string_substring (tag_values, (glong) token_start, (glong) token_length);
#line 201 "../src/librygel-server/rygel-item-updater.vala"
							value = _tmp5_;
#line 204 "../src/librygel-server/rygel-item-updater.vala"
							_tmp7_ = value;
#line 204 "../src/librygel-server/rygel-item-updater.vala"
							_tmp8_ = strlen (_tmp7_);
#line 204 "../src/librygel-server/rygel-item-updater.vala"
							_tmp9_ = _tmp8_;
#line 204 "../src/librygel-server/rygel-item-updater.vala"
							if (_tmp9_ > 0) {
#line 1438 "rygel-item-updater.c"
								const gchar* _tmp10_;
#line 204 "../src/librygel-server/rygel-item-updater.vala"
								_tmp10_ = value;
#line 204 "../src/librygel-server/rygel-item-updater.vala"
								_tmp6_ = string_get (_tmp10_, (glong) 0) == '<';
#line 1444 "rygel-item-updater.c"
							} else {
#line 204 "../src/librygel-server/rygel-item-updater.vala"
								_tmp6_ = FALSE;
#line 1448 "rygel-item-updater.c"
							}
#line 204 "../src/librygel-server/rygel-item-updater.vala"
							if (_tmp6_) {
#line 1452 "rygel-item-updater.c"
								const gchar* _tmp11_;
								const gchar* _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
#line 206 "../src/librygel-server/rygel-item-updater.vala"
								_tmp11_ = value;
#line 206 "../src/librygel-server/rygel-item-updater.vala"
								_tmp12_ = value;
#line 206 "../src/librygel-server/rygel-item-updater.vala"
								_tmp13_ = strlen (_tmp12_);
#line 206 "../src/librygel-server/rygel-item-updater.vala"
								_tmp14_ = _tmp13_;
#line 206 "../src/librygel-server/rygel-item-updater.vala"
								if (!(string_get (_tmp11_, (glong) (_tmp14_ - 1)) == '>')) {
#line 208 "../src/librygel-server/rygel-item-updater.vala"
									_g_free0 (value);
#line 208 "../src/librygel-server/rygel-item-updater.vala"
									break;
#line 1471 "rygel-item-updater.c"
								}
							}
#line 212 "../src/librygel-server/rygel-item-updater.vala"
							_tmp15_ = list;
#line 212 "../src/librygel-server/rygel-item-updater.vala"
							_tmp16_ = value;
#line 212 "../src/librygel-server/rygel-item-updater.vala"
							_tmp17_ = rygel_item_updater_unescape (_tmp16_);
#line 212 "../src/librygel-server/rygel-item-updater.vala"
							_tmp18_ = _tmp17_;
#line 212 "../src/librygel-server/rygel-item-updater.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp18_);
#line 212 "../src/librygel-server/rygel-item-updater.vala"
							_g_free0 (_tmp18_);
#line 213 "../src/librygel-server/rygel-item-updater.vala"
							token_start += token_length + 1;
#line 214 "../src/librygel-server/rygel-item-updater.vala"
							token_length = 0;
#line 215 "../src/librygel-server/rygel-item-updater.vala"
							increase = FALSE;
#line 217 "../src/librygel-server/rygel-item-updater.vala"
							_g_free0 (value);
#line 217 "../src/librygel-server/rygel-item-updater.vala"
							break;
#line 1496 "rygel-item-updater.c"
						}
						default:
#line 195 "../src/librygel-server/rygel-item-updater.vala"
						break;
#line 1501 "rygel-item-updater.c"
					}
				}
#line 220 "../src/librygel-server/rygel-item-updater.vala"
				if (increase) {
#line 1506 "rygel-item-updater.c"
					gint _tmp19_;
#line 221 "../src/librygel-server/rygel-item-updater.vala"
					token_length = token_length + 1;
#line 221 "../src/librygel-server/rygel-item-updater.vala"
					_tmp19_ = token_length;
#line 1512 "rygel-item-updater.c"
				}
			}
		}
	}
#line 225 "../src/librygel-server/rygel-item-updater.vala"
	_tmp20_ = string_substring (tag_values, (glong) token_start, (glong) -1);
#line 225 "../src/librygel-server/rygel-item-updater.vala"
	_tmp21_ = _tmp20_;
#line 225 "../src/librygel-server/rygel-item-updater.vala"
	_tmp22_ = string_strip (_tmp21_);
#line 225 "../src/librygel-server/rygel-item-updater.vala"
	_tmp23_ = _tmp22_;
#line 225 "../src/librygel-server/rygel-item-updater.vala"
	_g_free0 (_tmp21_);
#line 225 "../src/librygel-server/rygel-item-updater.vala"
	stripped_values = _tmp23_;
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	_tmp24_ = list;
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	_tmp25_ = stripped_values;
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	_tmp26_ = rygel_item_updater_unescape (_tmp25_);
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	_tmp27_ = _tmp26_;
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	_tmp28_ = rygel_item_updater_format_tag_values (_tmp27_);
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	_tmp29_ = _tmp28_;
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp29_);
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	_g_free0 (_tmp29_);
#line 227 "../src/librygel-server/rygel-item-updater.vala"
	_g_free0 (_tmp27_);
#line 230 "../src/librygel-server/rygel-item-updater.vala"
	result = list;
#line 230 "../src/librygel-server/rygel-item-updater.vala"
	_g_free0 (stripped_values);
#line 230 "../src/librygel-server/rygel-item-updater.vala"
	return result;
#line 1553 "rygel-item-updater.c"
}

static void
rygel_item_updater_update_object_data_free (gpointer _data)
{
	RygelItemUpdaterUpdateObjectData* _data_;
	_data_ = _data;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (_data_->self);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_slice_free (RygelItemUpdaterUpdateObjectData, _data_);
#line 1565 "rygel-item-updater.c"
}

static void
rygel_item_updater_update_object (RygelItemUpdater* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	RygelItemUpdaterUpdateObjectData* _data_;
	RygelItemUpdater* _tmp0_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = g_slice_new0 (RygelItemUpdaterUpdateObjectData);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_item_updater_update_object_data_free);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_->self = _tmp0_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_update_object_co (_data_);
#line 1589 "rygel-item-updater.c"
}

static void
rygel_item_updater_update_object_finish (RygelItemUpdater* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	RygelItemUpdaterUpdateObjectData* _data_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	if (NULL == _data_) {
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		return;
#line 1604 "rygel-item-updater.c"
	}
}

static void
rygel_item_updater_update_object_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	RygelItemUpdaterUpdateObjectData* _data_;
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = _user_data_;
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_source_object_ = source_object;
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_res_ = _res_;
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_update_object_co (_data_);
#line 1622 "rygel-item-updater.c"
}

static gboolean
rygel_item_updater_update_object_co (RygelItemUpdaterUpdateObjectData* _data_)
{
#line 233 "../src/librygel-server/rygel-item-updater.vala"
	switch (_data_->_state_) {
#line 233 "../src/librygel-server/rygel-item-updater.vala"
		case 0:
#line 1632 "rygel-item-updater.c"
		goto _state_0;
#line 233 "../src/librygel-server/rygel-item-updater.vala"
		case 1:
#line 1636 "rygel-item-updater.c"
		goto _state_1;
#line 233 "../src/librygel-server/rygel-item-updater.vala"
		case 2:
#line 1640 "rygel-item-updater.c"
		goto _state_2;
		default:
#line 233 "../src/librygel-server/rygel-item-updater.vala"
		g_assert_not_reached ();
#line 1645 "rygel-item-updater.c"
	}
	_state_0:
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_state_ = 1;
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_fetch_object (_data_->self, rygel_item_updater_update_object_ready, _data_);
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	return FALSE;
#line 1654 "rygel-item-updater.c"
	_state_1:
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp0_ = rygel_item_updater_fetch_object_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	_data_->media_object = _data_->_tmp0_;
#line 234 "../src/librygel-server/rygel-item-updater.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 234 "../src/librygel-server/rygel-item-updater.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 234 "../src/librygel-server/rygel-item-updater.vala"
		g_object_unref (_data_->_async_result);
#line 234 "../src/librygel-server/rygel-item-updater.vala"
		return FALSE;
#line 1668 "rygel-item-updater.c"
	}
#line 235 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp1_ = _data_->self->priv->current_tag_value;
#line 235 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp2_ = rygel_item_updater_csv_split (_data_->_tmp1_);
#line 235 "../src/librygel-server/rygel-item-updater.vala"
	_data_->current_list = _data_->_tmp2_;
#line 236 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp3_ = _data_->self->priv->new_tag_value;
#line 236 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp4_ = rygel_item_updater_csv_split (_data_->_tmp3_);
#line 236 "../src/librygel-server/rygel-item-updater.vala"
	_data_->new_list = _data_->_tmp4_;
#line 240 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp5_ = _data_->current_list;
#line 240 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp5_);
#line 240 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 240 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp8_ = _data_->new_list;
#line 240 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp8_);
#line 240 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 240 "../src/librygel-server/rygel-item-updater.vala"
	if (_data_->_tmp7_ == _data_->_tmp10_) {
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp11_ = _data_->current_list;
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp12_ = 0;
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp13_ = gee_collection_to_array ((GeeCollection*) _data_->_tmp11_, &_data_->_tmp12_);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp14__length1 = _data_->_tmp12_;
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp15_ = _data_->new_list;
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp16_ = 0;
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp17_ = gee_collection_to_array ((GeeCollection*) _data_->_tmp15_, &_data_->_tmp16_);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp18__length1 = _data_->_tmp16_;
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		rygel_item_updater_check_date_tag (_data_->_tmp14_, (gint) _data_->_tmp12_, _data_->_tmp18_, (gint) _data_->_tmp16_, &_data_->_inner_error0_);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp18_ = (_vala_array_free (_data_->_tmp18_, _data_->_tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp14_ = (_vala_array_free (_data_->_tmp14_, _data_->_tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 241 "../src/librygel-server/rygel-item-updater.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->new_list);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->current_list);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->media_object);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
			g_object_unref (_data_->_async_result);
#line 241 "../src/librygel-server/rygel-item-updater.vala"
			return FALSE;
#line 1736 "rygel-item-updater.c"
		}
	}
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp19_ = _data_->media_object;
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp20_ = _data_->current_list;
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp21_ = _data_->new_list;
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp22_ = _data_->self->priv->content_dir;
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp23_ = _data_->_tmp22_->http_server;
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_state_ = 2;
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	rygel_media_object_apply_fragments (_data_->_tmp19_, _data_->_tmp20_, _data_->_tmp21_, _data_->_tmp23_, rygel_item_updater_update_object_ready, _data_);
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	return FALSE;
#line 1755 "rygel-item-updater.c"
	_state_2:
#line 245 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_result_ = rygel_media_object_apply_fragments_finish (_data_->_tmp19_, _data_->_res_);
#line 250 "../src/librygel-server/rygel-item-updater.vala"
	switch (_data_->_result_) {
#line 250 "../src/librygel-server/rygel-item-updater.vala"
		case GUPNP_DIDL_LITE_FRAGMENT_RESULT_OK:
#line 1763 "rygel-item-updater.c"
		{
#line 252 "../src/librygel-server/rygel-item-updater.vala"
			break;
#line 1767 "rygel-item-updater.c"
		}
#line 250 "../src/librygel-server/rygel-item-updater.vala"
		case GUPNP_DIDL_LITE_FRAGMENT_RESULT_CURRENT_BAD_XML:
#line 250 "../src/librygel-server/rygel-item-updater.vala"
		case GUPNP_DIDL_LITE_FRAGMENT_RESULT_CURRENT_INVALID:
#line 1773 "rygel-item-updater.c"
		{
#line 255 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp24_ = g_error_new_literal (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_CURRENT_TAG_VALUE, _ ("Bad current tag value."));
#line 255 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_inner_error0_ = _data_->_tmp24_;
#line 255 "../src/librygel-server/rygel-item-updater.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 255 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->new_list);
#line 255 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->current_list);
#line 255 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->media_object);
#line 255 "../src/librygel-server/rygel-item-updater.vala"
			g_object_unref (_data_->_async_result);
#line 255 "../src/librygel-server/rygel-item-updater.vala"
			return FALSE;
#line 1791 "rygel-item-updater.c"
		}
#line 250 "../src/librygel-server/rygel-item-updater.vala"
		case GUPNP_DIDL_LITE_FRAGMENT_RESULT_NEW_BAD_XML:
#line 250 "../src/librygel-server/rygel-item-updater.vala"
		case GUPNP_DIDL_LITE_FRAGMENT_RESULT_NEW_INVALID:
#line 1797 "rygel-item-updater.c"
		{
#line 259 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp25_ = g_error_new_literal (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_INVALID_NEW_TAG_VALUE, _ ("Bad new tag value."));
#line 259 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_inner_error0_ = _data_->_tmp25_;
#line 259 "../src/librygel-server/rygel-item-updater.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 259 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->new_list);
#line 259 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->current_list);
#line 259 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->media_object);
#line 259 "../src/librygel-server/rygel-item-updater.vala"
			g_object_unref (_data_->_async_result);
#line 259 "../src/librygel-server/rygel-item-updater.vala"
			return FALSE;
#line 1815 "rygel-item-updater.c"
		}
#line 250 "../src/librygel-server/rygel-item-updater.vala"
		case GUPNP_DIDL_LITE_FRAGMENT_RESULT_REQUIRED_TAG:
#line 1819 "rygel-item-updater.c"
		{
#line 262 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp26_ = g_error_new_literal (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_REQUIRED_TAG, _ ("Tried to delete required tag."));
#line 262 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_inner_error0_ = _data_->_tmp26_;
#line 262 "../src/librygel-server/rygel-item-updater.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 262 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->new_list);
#line 262 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->current_list);
#line 262 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->media_object);
#line 262 "../src/librygel-server/rygel-item-updater.vala"
			g_object_unref (_data_->_async_result);
#line 262 "../src/librygel-server/rygel-item-updater.vala"
			return FALSE;
#line 1837 "rygel-item-updater.c"
		}
#line 250 "../src/librygel-server/rygel-item-updater.vala"
		case GUPNP_DIDL_LITE_FRAGMENT_RESULT_READONLY_TAG:
#line 1841 "rygel-item-updater.c"
		{
#line 265 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp27_ = g_error_new_literal (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_READ_ONLY_TAG, _ ("Tried to change read-only property."));
#line 265 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_inner_error0_ = _data_->_tmp27_;
#line 265 "../src/librygel-server/rygel-item-updater.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 265 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->new_list);
#line 265 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->current_list);
#line 265 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->media_object);
#line 265 "../src/librygel-server/rygel-item-updater.vala"
			g_object_unref (_data_->_async_result);
#line 265 "../src/librygel-server/rygel-item-updater.vala"
			return FALSE;
#line 1859 "rygel-item-updater.c"
		}
#line 250 "../src/librygel-server/rygel-item-updater.vala"
		case GUPNP_DIDL_LITE_FRAGMENT_RESULT_MISMATCH:
#line 1863 "rygel-item-updater.c"
		{
#line 268 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp28_ = g_error_new_literal (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_PARAMETER_MISMATCH, _ ("Parameter count mismatch."));
#line 268 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_inner_error0_ = _data_->_tmp28_;
#line 268 "../src/librygel-server/rygel-item-updater.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 268 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->new_list);
#line 268 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->current_list);
#line 268 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->media_object);
#line 268 "../src/librygel-server/rygel-item-updater.vala"
			g_object_unref (_data_->_async_result);
#line 268 "../src/librygel-server/rygel-item-updater.vala"
			return FALSE;
#line 1881 "rygel-item-updater.c"
		}
		default:
		{
#line 271 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp29_ = g_error_new_literal (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_NO_SUCH_OBJECT, _ ("Unknown error."));
#line 271 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_inner_error0_ = _data_->_tmp29_;
#line 271 "../src/librygel-server/rygel-item-updater.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 271 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->new_list);
#line 271 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->current_list);
#line 271 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->media_object);
#line 271 "../src/librygel-server/rygel-item-updater.vala"
			g_object_unref (_data_->_async_result);
#line 271 "../src/librygel-server/rygel-item-updater.vala"
			return FALSE;
#line 1901 "rygel-item-updater.c"
		}
	}
#line 233 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (_data_->new_list);
#line 233 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (_data_->current_list);
#line 233 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (_data_->media_object);
#line 233 "../src/librygel-server/rygel-item-updater.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 233 "../src/librygel-server/rygel-item-updater.vala"
	if (_data_->_state_ != 0) {
#line 233 "../src/librygel-server/rygel-item-updater.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 233 "../src/librygel-server/rygel-item-updater.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1918 "rygel-item-updater.c"
		}
	}
#line 233 "../src/librygel-server/rygel-item-updater.vala"
	g_object_unref (_data_->_async_result);
#line 233 "../src/librygel-server/rygel-item-updater.vala"
	return FALSE;
#line 1925 "rygel-item-updater.c"
}

static void
rygel_item_updater_fetch_object_data_free (gpointer _data)
{
	RygelItemUpdaterFetchObjectData* _data_;
	_data_ = _data;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (_data_->result);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (_data_->self);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_slice_free (RygelItemUpdaterFetchObjectData, _data_);
#line 1939 "rygel-item-updater.c"
}

static void
rygel_item_updater_fetch_object (RygelItemUpdater* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	RygelItemUpdaterFetchObjectData* _data_;
	RygelItemUpdater* _tmp0_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = g_slice_new0 (RygelItemUpdaterFetchObjectData);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_item_updater_fetch_object_data_free);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_->self = _tmp0_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_fetch_object_co (_data_);
#line 1963 "rygel-item-updater.c"
}

static RygelMediaObject*
rygel_item_updater_fetch_object_finish (RygelItemUpdater* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	RygelMediaObject* result;
	RygelItemUpdaterFetchObjectData* _data_;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	if (NULL == _data_) {
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		return NULL;
#line 1979 "rygel-item-updater.c"
	}
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	result = _data_->result;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	_data_->result = NULL;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	return result;
#line 1987 "rygel-item-updater.c"
}

static void
rygel_item_updater_fetch_object_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	RygelItemUpdaterFetchObjectData* _data_;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_ = _user_data_;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_source_object_ = source_object;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_res_ = _res_;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_fetch_object_co (_data_);
#line 2004 "rygel-item-updater.c"
}

static gboolean
rygel_item_updater_fetch_object_co (RygelItemUpdaterFetchObjectData* _data_)
{
#line 276 "../src/librygel-server/rygel-item-updater.vala"
	switch (_data_->_state_) {
#line 276 "../src/librygel-server/rygel-item-updater.vala"
		case 0:
#line 2014 "rygel-item-updater.c"
		goto _state_0;
#line 276 "../src/librygel-server/rygel-item-updater.vala"
		case 1:
#line 2018 "rygel-item-updater.c"
		goto _state_1;
		default:
#line 276 "../src/librygel-server/rygel-item-updater.vala"
		g_assert_not_reached ();
#line 2023 "rygel-item-updater.c"
	}
	_state_0:
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp0_ = _data_->self->priv->content_dir;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp1_ = _data_->_tmp0_->root_container;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp2_ = _data_->self->priv->object_id;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp3_ = rygel_state_machine_get_cancellable ((RygelStateMachine*) _data_->self);
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_state_ = 1;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	rygel_media_container_find_object (_data_->_tmp1_, _data_->_tmp2_, _data_->_tmp4_, rygel_item_updater_fetch_object_ready, _data_);
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	return FALSE;
#line 2042 "rygel-item-updater.c"
	_state_1:
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp5_ = rygel_media_container_find_object_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	_data_->media_object = _data_->_tmp5_;
#line 277 "../src/librygel-server/rygel-item-updater.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 277 "../src/librygel-server/rygel-item-updater.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 277 "../src/librygel-server/rygel-item-updater.vala"
		g_object_unref (_data_->_async_result);
#line 277 "../src/librygel-server/rygel-item-updater.vala"
		return FALSE;
#line 2056 "rygel-item-updater.c"
	}
#line 281 "../src/librygel-server/rygel-item-updater.vala"
	_data_->_tmp6_ = _data_->media_object;
#line 281 "../src/librygel-server/rygel-item-updater.vala"
	if (_data_->_tmp6_ == NULL) {
#line 282 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp7_ = g_error_new_literal (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_NO_SUCH_OBJECT, _ ("No such object"));
#line 282 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_inner_error0_ = _data_->_tmp7_;
#line 282 "../src/librygel-server/rygel-item-updater.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 282 "../src/librygel-server/rygel-item-updater.vala"
		_g_object_unref0 (_data_->media_object);
#line 282 "../src/librygel-server/rygel-item-updater.vala"
		g_object_unref (_data_->_async_result);
#line 282 "../src/librygel-server/rygel-item-updater.vala"
		return FALSE;
#line 2074 "rygel-item-updater.c"
	} else {
#line 284 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp8_ = _data_->media_object;
#line 284 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp9_ = rygel_media_object_get_ocm_flags (_data_->_tmp8_);
#line 284 "../src/librygel-server/rygel-item-updater.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 284 "../src/librygel-server/rygel-item-updater.vala"
		if (!((_data_->_tmp10_ & GUPNP_OCM_FLAGS_CHANGE_METADATA) == GUPNP_OCM_FLAGS_CHANGE_METADATA)) {
#line 285 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp11_ = g_strdup (_ ("Metadata modification of object %s not allowed"));
#line 285 "../src/librygel-server/rygel-item-updater.vala"
			_data_->msg = _data_->_tmp11_;
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp12_ = _data_->msg;
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp13_ = _data_->media_object;
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp14_ = rygel_media_object_get_id (_data_->_tmp13_);
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp16_ = g_error_new (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_RESTRICTED_OBJECT, _data_->_tmp12_, _data_->_tmp15_);
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_inner_error0_ = _data_->_tmp16_;
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			_g_free0 (_data_->msg);
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			_g_object_unref0 (_data_->media_object);
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			g_object_unref (_data_->_async_result);
#line 287 "../src/librygel-server/rygel-item-updater.vala"
			return FALSE;
#line 2110 "rygel-item-updater.c"
		} else {
#line 289 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp17_ = _data_->media_object;
#line 289 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp18_ = rygel_media_object_get_parent (_data_->_tmp17_);
#line 289 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 289 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp20_ = rygel_media_object_get_restricted ((RygelMediaObject*) _data_->_tmp19_);
#line 289 "../src/librygel-server/rygel-item-updater.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 289 "../src/librygel-server/rygel-item-updater.vala"
			if (_data_->_tmp21_) {
#line 290 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp22_ = g_strdup (_ ("Metadata modification of object %s being a child of restricted object " \
"%s not allowed"));
#line 290 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_vala1_msg = _data_->_tmp22_;
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp23_ = _data_->_vala1_msg;
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp24_ = _data_->media_object;
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp25_ = rygel_media_object_get_id (_data_->_tmp24_);
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp26_ = _data_->_tmp25_;
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp27_ = _data_->media_object;
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp28_ = rygel_media_object_get_parent (_data_->_tmp27_);
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp29_ = _data_->_tmp28_;
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp30_ = rygel_media_object_get_id ((RygelMediaObject*) _data_->_tmp29_);
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp31_ = _data_->_tmp30_;
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_tmp32_ = g_error_new (RYGEL_CONTENT_DIRECTORY_ERROR, RYGEL_CONTENT_DIRECTORY_ERROR_RESTRICTED_PARENT, _data_->_tmp23_, _data_->_tmp26_, _data_->_tmp31_);
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_data_->_inner_error0_ = _data_->_tmp32_;
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_g_free0 (_data_->_vala1_msg);
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				_g_object_unref0 (_data_->media_object);
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				g_object_unref (_data_->_async_result);
#line 292 "../src/librygel-server/rygel-item-updater.vala"
				return FALSE;
#line 2160 "rygel-item-updater.c"
			}
		}
	}
#line 298 "../src/librygel-server/rygel-item-updater.vala"
	_data_->result = _data_->media_object;
#line 298 "../src/librygel-server/rygel-item-updater.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 298 "../src/librygel-server/rygel-item-updater.vala"
	if (_data_->_state_ != 0) {
#line 298 "../src/librygel-server/rygel-item-updater.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 298 "../src/librygel-server/rygel-item-updater.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2174 "rygel-item-updater.c"
		}
	}
#line 298 "../src/librygel-server/rygel-item-updater.vala"
	g_object_unref (_data_->_async_result);
#line 298 "../src/librygel-server/rygel-item-updater.vala"
	return FALSE;
#line 2181 "rygel-item-updater.c"
}

static GCancellable*
rygel_item_updater_real_get_cancellable (RygelStateMachine* base)
{
	GCancellable* result;
	RygelItemUpdater* self;
	GCancellable* _tmp0_;
#line 43 "../src/librygel-server/rygel-item-updater.vala"
	self = (RygelItemUpdater*) base;
#line 43 "../src/librygel-server/rygel-item-updater.vala"
	_tmp0_ = self->priv->_cancellable;
#line 43 "../src/librygel-server/rygel-item-updater.vala"
	result = _tmp0_;
#line 43 "../src/librygel-server/rygel-item-updater.vala"
	return result;
#line 2198 "rygel-item-updater.c"
}

static void
rygel_item_updater_real_set_cancellable (RygelStateMachine* base,
                                         GCancellable* value)
{
	RygelItemUpdater* self;
	GCancellable* old_value;
#line 43 "../src/librygel-server/rygel-item-updater.vala"
	self = (RygelItemUpdater*) base;
#line 43 "../src/librygel-server/rygel-item-updater.vala"
	old_value = rygel_item_updater_real_get_cancellable (base);
#line 43 "../src/librygel-server/rygel-item-updater.vala"
	if (old_value != value) {
#line 2213 "rygel-item-updater.c"
		GCancellable* _tmp0_;
#line 43 "../src/librygel-server/rygel-item-updater.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 43 "../src/librygel-server/rygel-item-updater.vala"
		_g_object_unref0 (self->priv->_cancellable);
#line 43 "../src/librygel-server/rygel-item-updater.vala"
		self->priv->_cancellable = _tmp0_;
#line 43 "../src/librygel-server/rygel-item-updater.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_item_updater_properties[RYGEL_ITEM_UPDATER_CANCELLABLE_PROPERTY]);
#line 2223 "rygel-item-updater.c"
	}
}

static void
rygel_item_updater_class_init (RygelItemUpdaterClass * klass,
                               gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_type_class_adjust_private_offset (klass, &RygelItemUpdater_private_offset);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_item_updater_get_property;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_item_updater_set_property;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_item_updater_finalize;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_ITEM_UPDATER_CANCELLABLE_PROPERTY, rygel_item_updater_properties[RYGEL_ITEM_UPDATER_CANCELLABLE_PROPERTY] = g_param_spec_object ("cancellable", "cancellable", "cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2244 "rygel-item-updater.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 47 "../src/librygel-server/rygel-item-updater.vala"
		_tmp1_ = g_regex_new ("\\\\(.)", 0, 0, &_inner_error0_);
#line 47 "../src/librygel-server/rygel-item-updater.vala"
		_tmp0_ = _tmp1_;
#line 47 "../src/librygel-server/rygel-item-updater.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 47 "../src/librygel-server/rygel-item-updater.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2257 "rygel-item-updater.c"
				goto __catch0_g_regex_error;
			}
#line 47 "../src/librygel-server/rygel-item-updater.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 47 "../src/librygel-server/rygel-item-updater.vala"
			g_clear_error (&_inner_error0_);
#line 2264 "rygel-item-updater.c"
		}
#line 47 "../src/librygel-server/rygel-item-updater.vala"
		_tmp2_ = _tmp0_;
#line 47 "../src/librygel-server/rygel-item-updater.vala"
		_tmp0_ = NULL;
#line 47 "../src/librygel-server/rygel-item-updater.vala"
		_g_regex_unref0 (rygel_item_updater_escape_regex);
#line 47 "../src/librygel-server/rygel-item-updater.vala"
		rygel_item_updater_escape_regex = _tmp2_;
#line 46 "../src/librygel-server/rygel-item-updater.vala"
		_g_regex_unref0 (_tmp0_);
#line 2276 "rygel-item-updater.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 46 "../src/librygel-server/rygel-item-updater.vala"
		g_clear_error (&_inner_error0_);
#line 49 "../src/librygel-server/rygel-item-updater.vala"
		g_assert_not_reached ();
#line 2285 "rygel-item-updater.c"
	}
	__finally0:
#line 46 "../src/librygel-server/rygel-item-updater.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/librygel-server/rygel-item-updater.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/librygel-server/rygel-item-updater.vala"
		g_clear_error (&_inner_error0_);
#line 2294 "rygel-item-updater.c"
	}
}

static void
rygel_item_updater_rygel_state_machine_interface_init (RygelStateMachineIface * iface,
                                                       gpointer iface_data)
{
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	rygel_item_updater_rygel_state_machine_parent_iface = g_type_interface_peek_parent (iface);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	iface->run = (void (*) (RygelStateMachine*, GAsyncReadyCallback, gpointer)) rygel_item_updater_real_run;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	iface->run_finish = (void (*) (RygelStateMachine*, GAsyncResult*)) rygel_item_updater_run_finish;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	iface->get_cancellable = rygel_item_updater_real_get_cancellable;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	iface->set_cancellable = rygel_item_updater_real_set_cancellable;
#line 2312 "rygel-item-updater.c"
}

static void
rygel_item_updater_instance_init (RygelItemUpdater * self,
                                  gpointer klass)
{
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	self->priv = rygel_item_updater_get_instance_private (self);
#line 2321 "rygel-item-updater.c"
}

static void
rygel_item_updater_finalize (GObject * obj)
{
	RygelItemUpdater * self;
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_ITEM_UPDATER, RygelItemUpdater);
#line 36 "../src/librygel-server/rygel-item-updater.vala"
	_g_free0 (self->priv->object_id);
#line 37 "../src/librygel-server/rygel-item-updater.vala"
	_g_free0 (self->priv->current_tag_value);
#line 38 "../src/librygel-server/rygel-item-updater.vala"
	_g_free0 (self->priv->new_tag_value);
#line 40 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (self->priv->content_dir);
#line 41 "../src/librygel-server/rygel-item-updater.vala"
	__vala_GUPnPServiceAction_free0 (self->priv->action);
#line 43 "../src/librygel-server/rygel-item-updater.vala"
	_g_object_unref0 (self->priv->_cancellable);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	G_OBJECT_CLASS (rygel_item_updater_parent_class)->finalize (obj);
#line 2344 "rygel-item-updater.c"
}

/**
 * UpdateObject action implementation.
 */
 G_GNUC_NO_INLINE static GType
rygel_item_updater_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelItemUpdaterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_item_updater_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelItemUpdater), 0, (GInstanceInitFunc) rygel_item_updater_instance_init, NULL };
	static const GInterfaceInfo rygel_state_machine_info = { (GInterfaceInitFunc) rygel_item_updater_rygel_state_machine_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType rygel_item_updater_type_id;
	rygel_item_updater_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelItemUpdater", &g_define_type_info, 0);
	g_type_add_interface_static (rygel_item_updater_type_id, RYGEL_TYPE_STATE_MACHINE, &rygel_state_machine_info);
	RygelItemUpdater_private_offset = g_type_add_instance_private (rygel_item_updater_type_id, sizeof (RygelItemUpdaterPrivate));
	return rygel_item_updater_type_id;
}

GType
rygel_item_updater_get_type (void)
{
	static volatile gsize rygel_item_updater_type_id__once = 0;
	if (g_once_init_enter (&rygel_item_updater_type_id__once)) {
		GType rygel_item_updater_type_id;
		rygel_item_updater_type_id = rygel_item_updater_get_type_once ();
		g_once_init_leave (&rygel_item_updater_type_id__once, rygel_item_updater_type_id);
	}
	return rygel_item_updater_type_id__once;
}

static void
_vala_rygel_item_updater_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	RygelItemUpdater * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_ITEM_UPDATER, RygelItemUpdater);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	switch (property_id) {
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		case RYGEL_ITEM_UPDATER_CANCELLABLE_PROPERTY:
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		g_value_set_object (value, rygel_state_machine_get_cancellable ((RygelStateMachine*) self));
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		break;
#line 2390 "rygel-item-updater.c"
		default:
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		break;
#line 2396 "rygel-item-updater.c"
	}
}

static void
_vala_rygel_item_updater_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	RygelItemUpdater * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_ITEM_UPDATER, RygelItemUpdater);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
	switch (property_id) {
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		case RYGEL_ITEM_UPDATER_CANCELLABLE_PROPERTY:
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		rygel_state_machine_set_cancellable ((RygelStateMachine*) self, g_value_get_object (value));
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		break;
#line 2416 "rygel-item-updater.c"
		default:
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/librygel-server/rygel-item-updater.vala"
		break;
#line 2422 "rygel-item-updater.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

