/* rygel-media-container.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-media-container.vala, do not modify */

/*
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 * Copyright (C) 2010 MediaNet Inh.
 * Copyright (C) 2010 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Authors: Zeeshan Ali <zeenix@gmail.com>
 *          Sunil Mohan Adapa <sunil@medhas.org>
 *          Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <libgupnp-av/gupnp-av.h>
#include "rygel-core.h"

#define RYGEL_MEDIA_CONTAINER_DEFAULT_SORT_CRITERIA "+upnp:class,+dc:title"
#define RYGEL_MEDIA_CONTAINER_DIDL_S_PLAYLIST_RESNAME "didl_s_playlist"
#define RYGEL_MEDIA_CONTAINER_M3U_PLAYLIST_RESNAME "m3u_playlist"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_PLAYLIST_DATASOURCE (rygel_playlist_datasource_get_type ())
#define RYGEL_PLAYLIST_DATASOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_PLAYLIST_DATASOURCE, RygelPlaylistDatasource))
#define RYGEL_PLAYLIST_DATASOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_PLAYLIST_DATASOURCE, RygelPlaylistDatasourceClass))
#define RYGEL_IS_PLAYLIST_DATASOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_PLAYLIST_DATASOURCE))
#define RYGEL_IS_PLAYLIST_DATASOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_PLAYLIST_DATASOURCE))
#define RYGEL_PLAYLIST_DATASOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_PLAYLIST_DATASOURCE, RygelPlaylistDatasourceClass))

typedef struct _RygelPlaylistDatasource RygelPlaylistDatasource;
typedef struct _RygelPlaylistDatasourceClass RygelPlaylistDatasourceClass;
typedef struct _RygelPlaylistDatasourcePrivate RygelPlaylistDatasourcePrivate;

#define RYGEL_TYPE_CLIENT_HACKS (rygel_client_hacks_get_type ())
#define RYGEL_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacks))
#define RYGEL_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))
#define RYGEL_IS_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_IS_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_CLIENT_HACKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))

typedef struct _RygelClientHacks RygelClientHacks;
typedef struct _RygelClientHacksClass RygelClientHacksClass;
enum  {
	RYGEL_PLAYLIST_DATASOURCE_0_PROPERTY,
	RYGEL_PLAYLIST_DATASOURCE_NUM_PROPERTIES
};
static GParamSpec* rygel_playlist_datasource_properties[RYGEL_PLAYLIST_DATASOURCE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _RygelPlaylistDatasourceGenerateDataData RygelPlaylistDatasourceGenerateDataData;
enum  {
	RYGEL_PLAYLIST_DATASOURCE_DATA_READY_SIGNAL,
	RYGEL_PLAYLIST_DATASOURCE_NUM_SIGNALS
};
static guint rygel_playlist_datasource_signals[RYGEL_PLAYLIST_DATASOURCE_NUM_SIGNALS] = {0};
enum  {
	RYGEL_MEDIA_CONTAINER_0_PROPERTY,
	RYGEL_MEDIA_CONTAINER_CHILD_COUNT_PROPERTY,
	RYGEL_MEDIA_CONTAINER_EMPTY_CHILD_COUNT_PROPERTY,
	RYGEL_MEDIA_CONTAINER_ALL_CHILD_COUNT_PROPERTY,
	RYGEL_MEDIA_CONTAINER_CREATE_MODE_ENABLED_PROPERTY,
	RYGEL_MEDIA_CONTAINER_SORT_CRITERIA_PROPERTY,
	RYGEL_MEDIA_CONTAINER_OCM_FLAGS_PROPERTY,
	RYGEL_MEDIA_CONTAINER_NUM_PROPERTIES
};
static GParamSpec* rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_NUM_PROPERTIES];
#define _rygel_search_expression_unref0(var) ((var == NULL) ? NULL : (var = (rygel_search_expression_unref (var), NULL)))
enum  {
	RYGEL_MEDIA_CONTAINER_CONTAINER_UPDATED_SIGNAL,
	RYGEL_MEDIA_CONTAINER_SUB_TREE_UPDATES_FINISHED_SIGNAL,
	RYGEL_MEDIA_CONTAINER_NUM_SIGNALS
};
static guint rygel_media_container_signals[RYGEL_MEDIA_CONTAINER_NUM_SIGNALS] = {0};

struct _RygelPlaylistDatasource {
	GObject parent_instance;
	RygelPlaylistDatasourcePrivate * priv;
};

struct _RygelPlaylistDatasourceClass {
	GObjectClass parent_class;
};

struct _RygelPlaylistDatasourcePrivate {
	RygelMediaContainer* container;
	guint8* data;
	gint data_length1;
	gint _data_size_;
	RygelHTTPServer* server;
	RygelClientHacks* hacks;
	RygelSerializerType playlist_type;
};

struct _RygelPlaylistDatasourceGenerateDataData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelPlaylistDatasource* self;
	gchar* sort_criteria;
	RygelMediaContainer* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gint count;
	RygelMediaContainer* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	RygelMediaObjects* children;
	RygelMediaContainer* _tmp7_;
	const gchar* _tmp8_;
	RygelMediaObjects* _tmp9_;
	RygelMediaObjects* _tmp10_;
	RygelSerializer* serializer;
	RygelSerializer* _tmp11_;
	RygelMediaObjects* _tmp12_;
	RygelSerializer* _tmp13_;
	RygelHTTPServer* _tmp14_;
	RygelClientHacks* _tmp15_;
	gchar* xml;
	RygelSerializer* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	gint _tmp20_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	guint8* _tmp22_;
	gint _tmp22__length1;
	GError* _tmp23_;
	GError* _tmp24_;
	GError* _error_;
	GError* _tmp25_;
	const gchar* _tmp26_;
	GError* _tmp27_;
	GError* _inner_error0_;
};

struct _RygelMediaContainerPrivate {
	gint _child_count;
	gint _empty_child_count;
	gboolean _create_mode_enabled;
	gchar* _sort_criteria;
};

static gint RygelPlaylistDatasource_private_offset;
static gpointer rygel_playlist_datasource_parent_class = NULL;
static RygelDataSourceIface * rygel_playlist_datasource_rygel_data_source_parent_iface = NULL;
static gint RygelMediaContainer_private_offset;
static gpointer rygel_media_container_parent_class = NULL;

VALA_EXTERN GType rygel_playlist_datasource_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_client_hacks_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelPlaylistDatasource* rygel_playlist_datasource_new (RygelSerializerType playlist_type,
                                                        RygelMediaContainer* container,
                                                        RygelHTTPServer* server,
                                                        RygelClientHacks* hacks);
VALA_EXTERN RygelPlaylistDatasource* rygel_playlist_datasource_construct (GType object_type,
                                                              RygelSerializerType playlist_type,
                                                              RygelMediaContainer* container,
                                                              RygelHTTPServer* server,
                                                              RygelClientHacks* hacks);
VALA_EXTERN void rygel_playlist_datasource_generate_data (RygelPlaylistDatasource* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN void rygel_playlist_datasource_generate_data_finish (RygelPlaylistDatasource* self,
                                                     GAsyncResult* _res_);
static GeeList* rygel_playlist_datasource_real_preroll (RygelDataSource* base,
                                                 RygelHTTPSeekRequest* seek_request,
                                                 RygelPlaySpeedRequest* playspeed_request,
                                                 GError** error);
static void rygel_playlist_datasource_real_start (RygelDataSource* base,
                                           GError** error);
static void ___lambda19_ (RygelPlaylistDatasource* self);
static void ____lambda19__rygel_playlist_datasource_data_ready (RygelPlaylistDatasource* _sender,
                                                         gpointer self);
static gboolean __lambda20_ (RygelPlaylistDatasource* self);
static gboolean ___lambda20__gsource_func (gpointer self);
static void rygel_playlist_datasource_real_freeze (RygelDataSource* base);
static void rygel_playlist_datasource_real_thaw (RygelDataSource* base);
static void rygel_playlist_datasource_real_stop (RygelDataSource* base);
static void rygel_playlist_datasource_generate_data_data_free (gpointer _data);
static gboolean rygel_playlist_datasource_generate_data_co (RygelPlaylistDatasourceGenerateDataData* _data_);
static void rygel_playlist_datasource_generate_data_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
VALA_EXTERN void rygel_media_objects_serialize (RygelMediaObjects* self,
                                    RygelSerializer* serializer,
                                    RygelHTTPServer* http_server,
                                    RygelClientHacks* hacks,
                                    GError** error);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
static void rygel_playlist_datasource_finalize (GObject * obj);
static GType rygel_playlist_datasource_get_type_once (void);
static void rygel_media_container_real_constructed (GObject* base);
static void rygel_media_container_on_container_updated (RygelMediaContainer* self,
                                                 RygelMediaContainer* container,
                                                 RygelMediaContainer* updated_container,
                                                 RygelMediaObject* object,
                                                 RygelObjectEventType event_type,
                                                 gboolean sub_tree_update);
static void _rygel_media_container_on_container_updated_rygel_media_container_container_updated (RygelMediaContainer* _sender,
                                                                                          RygelMediaContainer* container,
                                                                                          RygelMediaObject* object,
                                                                                          RygelObjectEventType event_type,
                                                                                          gboolean sub_tree_update,
                                                                                          gpointer self);
static void rygel_media_container_on_sub_tree_updates_finished (RygelMediaContainer* self,
                                                         RygelMediaContainer* container,
                                                         RygelMediaObject* sub_tree_root);
static void _rygel_media_container_on_sub_tree_updates_finished_rygel_media_container_sub_tree_updates_finished (RygelMediaContainer* _sender,
                                                                                                          RygelMediaObject* sub_tree_root,
                                                                                                          gpointer self);
VALA_EXTERN void rygel_media_container_add_playlist_resources (RygelMediaContainer* self);
static GUPnPDIDLLiteObject* rygel_media_container_real_serialize (RygelMediaObject* base,
                                                           RygelSerializer* serializer,
                                                           RygelHTTPServer* http_server,
                                                           GError** error);
VALA_EXTERN void rygel_searchable_container_serialize_search_parameters (RygelSearchableContainer* self,
                                                             GUPnPDIDLLiteContainer* didl_container);
VALA_EXTERN gboolean rygel_media_object_get_restricted (RygelMediaObject* self);
static RygelDataSource* rygel_media_container_real_create_stream_source_for_resource (RygelMediaObject* base,
                                                                               RygelHTTPRequest* request,
                                                                               RygelMediaResource* resource,
                                                                               GError** error);
VALA_EXTERN void rygel_media_container_check_search_expression (RygelMediaContainer* self,
                                                    RygelSearchExpression* expression);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM_BOOLEAN (GClosure * closure,
                                                               GValue * return_value,
                                                               guint n_param_values,
                                                               const GValue * param_values,
                                                               gpointer invocation_hint,
                                                               gpointer marshal_data);
static void rygel_media_container_finalize (GObject * obj);
static GType rygel_media_container_get_type_once (void);
static void _vala_rygel_media_container_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_rygel_media_container_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

 G_GNUC_NO_INLINE static GType
rygel_object_event_type_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_OBJECT_EVENT_TYPE_ADDED, "RYGEL_OBJECT_EVENT_TYPE_ADDED", "added"}, {RYGEL_OBJECT_EVENT_TYPE_MODIFIED, "RYGEL_OBJECT_EVENT_TYPE_MODIFIED", "modified"}, {RYGEL_OBJECT_EVENT_TYPE_DELETED, "RYGEL_OBJECT_EVENT_TYPE_DELETED", "deleted"}, {0, NULL, NULL}};
	GType rygel_object_event_type_type_id;
	rygel_object_event_type_type_id = g_enum_register_static ("RygelObjectEventType", values);
	return rygel_object_event_type_type_id;
}

GType
rygel_object_event_type_get_type (void)
{
	static volatile gsize rygel_object_event_type_type_id__once = 0;
	if (g_once_init_enter (&rygel_object_event_type_type_id__once)) {
		GType rygel_object_event_type_type_id;
		rygel_object_event_type_type_id = rygel_object_event_type_get_type_once ();
		g_once_init_leave (&rygel_object_event_type_type_id__once, rygel_object_event_type_type_id);
	}
	return rygel_object_event_type_type_id__once;
}

static inline gpointer
rygel_playlist_datasource_get_instance_private (RygelPlaylistDatasource* self)
{
	return G_STRUCT_MEMBER_P (self, RygelPlaylistDatasource_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "../src/librygel-server/rygel-media-container.vala"
	return self ? g_object_ref (self) : NULL;
#line 315 "rygel-media-container.c"
}

RygelPlaylistDatasource*
rygel_playlist_datasource_construct (GType object_type,
                                     RygelSerializerType playlist_type,
                                     RygelMediaContainer* container,
                                     RygelHTTPServer* server,
                                     RygelClientHacks* hacks)
{
	RygelPlaylistDatasource * self = NULL;
	RygelMediaContainer* _tmp0_;
	RygelHTTPServer* _tmp1_;
	RygelClientHacks* _tmp2_;
#line 48 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (container != NULL, NULL);
#line 48 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (server != NULL, NULL);
#line 48 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelPlaylistDatasource*) g_object_new (object_type, NULL);
#line 52 "../src/librygel-server/rygel-media-container.vala"
	self->priv->playlist_type = playlist_type;
#line 53 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = _g_object_ref0 (container);
#line 53 "../src/librygel-server/rygel-media-container.vala"
	_g_object_unref0 (self->priv->container);
#line 53 "../src/librygel-server/rygel-media-container.vala"
	self->priv->container = _tmp0_;
#line 54 "../src/librygel-server/rygel-media-container.vala"
	_tmp1_ = _g_object_ref0 (server);
#line 54 "../src/librygel-server/rygel-media-container.vala"
	_g_object_unref0 (self->priv->server);
#line 54 "../src/librygel-server/rygel-media-container.vala"
	self->priv->server = _tmp1_;
#line 55 "../src/librygel-server/rygel-media-container.vala"
	_tmp2_ = _g_object_ref0 (hacks);
#line 55 "../src/librygel-server/rygel-media-container.vala"
	_g_object_unref0 (self->priv->hacks);
#line 55 "../src/librygel-server/rygel-media-container.vala"
	self->priv->hacks = _tmp2_;
#line 56 "../src/librygel-server/rygel-media-container.vala"
	rygel_playlist_datasource_generate_data (self, NULL, NULL);
#line 48 "../src/librygel-server/rygel-media-container.vala"
	return self;
#line 359 "rygel-media-container.c"
}

RygelPlaylistDatasource*
rygel_playlist_datasource_new (RygelSerializerType playlist_type,
                               RygelMediaContainer* container,
                               RygelHTTPServer* server,
                               RygelClientHacks* hacks)
{
#line 48 "../src/librygel-server/rygel-media-container.vala"
	return rygel_playlist_datasource_construct (RYGEL_TYPE_PLAYLIST_DATASOURCE, playlist_type, container, server, hacks);
#line 370 "rygel-media-container.c"
}

static GeeList*
rygel_playlist_datasource_real_preroll (RygelDataSource* base,
                                        RygelHTTPSeekRequest* seek_request,
                                        RygelPlaySpeedRequest* playspeed_request,
                                        GError** error)
{
	RygelPlaylistDatasource * self;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 61 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelPlaylistDatasource*) base;
#line 65 "../src/librygel-server/rygel-media-container.vala"
	if (seek_request != NULL) {
#line 386 "rygel-media-container.c"
		GError* _tmp0_;
#line 66 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_SEEK_FAILED, _ ("Seeking not supported"));
#line 66 "../src/librygel-server/rygel-media-container.vala"
		_inner_error0_ = _tmp0_;
#line 66 "../src/librygel-server/rygel-media-container.vala"
		g_propagate_error (error, _inner_error0_);
#line 66 "../src/librygel-server/rygel-media-container.vala"
		return NULL;
#line 396 "rygel-media-container.c"
	}
#line 70 "../src/librygel-server/rygel-media-container.vala"
	if (playspeed_request != NULL) {
#line 400 "rygel-media-container.c"
		GError* _tmp1_;
#line 71 "../src/librygel-server/rygel-media-container.vala"
		_tmp1_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_PLAYSPEED_FAILED, _ ("Speed not supported"));
#line 71 "../src/librygel-server/rygel-media-container.vala"
		_inner_error0_ = _tmp1_;
#line 71 "../src/librygel-server/rygel-media-container.vala"
		g_propagate_error (error, _inner_error0_);
#line 71 "../src/librygel-server/rygel-media-container.vala"
		return NULL;
#line 410 "rygel-media-container.c"
	}
#line 75 "../src/librygel-server/rygel-media-container.vala"
	result = NULL;
#line 75 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 416 "rygel-media-container.c"
}

static void
___lambda19_ (RygelPlaylistDatasource* self)
{
	GError* _inner_error0_ = NULL;
	{
#line 82 "../src/librygel-server/rygel-media-container.vala"
		rygel_data_source_start ((RygelDataSource*) self, &_inner_error0_);
#line 82 "../src/librygel-server/rygel-media-container.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 428 "rygel-media-container.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 81 "../src/librygel-server/rygel-media-container.vala"
		g_clear_error (&_inner_error0_);
#line 437 "rygel-media-container.c"
	}
	__finally0:
#line 81 "../src/librygel-server/rygel-media-container.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/librygel-server/rygel-media-container.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/librygel-server/rygel-media-container.vala"
		g_clear_error (&_inner_error0_);
#line 81 "../src/librygel-server/rygel-media-container.vala"
		return;
#line 448 "rygel-media-container.c"
	}
}

static void
____lambda19__rygel_playlist_datasource_data_ready (RygelPlaylistDatasource* _sender,
                                                    gpointer self)
{
#line 80 "../src/librygel-server/rygel-media-container.vala"
	___lambda19_ ((RygelPlaylistDatasource*) self);
#line 458 "rygel-media-container.c"
}

static gboolean
__lambda20_ (RygelPlaylistDatasource* self)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gboolean result;
#line 90 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = self->priv->data;
#line 90 "../src/librygel-server/rygel-media-container.vala"
	_tmp0__length1 = self->priv->data_length1;
#line 90 "../src/librygel-server/rygel-media-container.vala"
	g_signal_emit_by_name ((RygelDataSource*) self, "data-available", _tmp0_, (gint) _tmp0__length1);
#line 91 "../src/librygel-server/rygel-media-container.vala"
	g_signal_emit_by_name ((RygelDataSource*) self, "done");
#line 93 "../src/librygel-server/rygel-media-container.vala"
	result = FALSE;
#line 93 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 479 "rygel-media-container.c"
}

static gboolean
___lambda20__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda20_ ((RygelPlaylistDatasource*) self);
#line 89 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 489 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_real_start (RygelDataSource* base,
                                      GError** error)
{
	RygelPlaylistDatasource * self;
	guint8* _tmp0_;
	gint _tmp0__length1;
#line 78 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelPlaylistDatasource*) base;
#line 79 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = self->priv->data;
#line 79 "../src/librygel-server/rygel-media-container.vala"
	_tmp0__length1 = self->priv->data_length1;
#line 79 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp0_ == NULL) {
#line 80 "../src/librygel-server/rygel-media-container.vala"
		g_signal_connect_object (self, "data-ready", (GCallback) ____lambda19__rygel_playlist_datasource_data_ready, self, 0);
#line 86 "../src/librygel-server/rygel-media-container.vala"
		return;
#line 511 "rygel-media-container.c"
	}
#line 89 "../src/librygel-server/rygel-media-container.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda20__gsource_func, g_object_ref (self), g_object_unref);
#line 515 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_real_freeze (RygelDataSource* base)
{
	RygelPlaylistDatasource * self;
#line 97 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelPlaylistDatasource*) base;
#line 524 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_real_thaw (RygelDataSource* base)
{
	RygelPlaylistDatasource * self;
#line 99 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelPlaylistDatasource*) base;
#line 533 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_real_stop (RygelDataSource* base)
{
	RygelPlaylistDatasource * self;
#line 101 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelPlaylistDatasource*) base;
#line 542 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_generate_data_data_free (gpointer _data)
{
	RygelPlaylistDatasourceGenerateDataData* _data_;
	_data_ = _data;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	g_slice_free (RygelPlaylistDatasourceGenerateDataData, _data_);
#line 554 "rygel-media-container.c"
}

void
rygel_playlist_datasource_generate_data (RygelPlaylistDatasource* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	RygelPlaylistDatasourceGenerateDataData* _data_;
	RygelPlaylistDatasource* _tmp0_;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	_data_ = g_slice_new0 (RygelPlaylistDatasourceGenerateDataData);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_playlist_datasource_generate_data_data_free);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	_data_->self = _tmp0_;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	rygel_playlist_datasource_generate_data_co (_data_);
#line 578 "rygel-media-container.c"
}

void
rygel_playlist_datasource_generate_data_finish (RygelPlaylistDatasource* self,
                                                GAsyncResult* _res_)
{
	RygelPlaylistDatasourceGenerateDataData* _data_;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 588 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_generate_data_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	RygelPlaylistDatasourceGenerateDataData* _data_;
#line 108 "../src/librygel-server/rygel-media-container.vala"
	_data_ = _user_data_;
#line 108 "../src/librygel-server/rygel-media-container.vala"
	_data_->_source_object_ = source_object;
#line 108 "../src/librygel-server/rygel-media-container.vala"
	_data_->_res_ = _res_;
#line 108 "../src/librygel-server/rygel-media-container.vala"
	rygel_playlist_datasource_generate_data_co (_data_);
#line 605 "rygel-media-container.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 642 "rygel-media-container.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 648 "rygel-media-container.c"
}

static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
#line 119 "../src/librygel-server/rygel-media-container.vala"
	if (length > 0) {
#line 119 "../src/librygel-server/rygel-media-container.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 659 "rygel-media-container.c"
	}
#line 119 "../src/librygel-server/rygel-media-container.vala"
	return NULL;
#line 663 "rygel-media-container.c"
}

static gboolean
rygel_playlist_datasource_generate_data_co (RygelPlaylistDatasourceGenerateDataData* _data_)
{
#line 103 "../src/librygel-server/rygel-media-container.vala"
	switch (_data_->_state_) {
#line 103 "../src/librygel-server/rygel-media-container.vala"
		case 0:
#line 673 "rygel-media-container.c"
		goto _state_0;
#line 103 "../src/librygel-server/rygel-media-container.vala"
		case 1:
#line 677 "rygel-media-container.c"
		goto _state_1;
		default:
#line 103 "../src/librygel-server/rygel-media-container.vala"
		g_assert_not_reached ();
#line 682 "rygel-media-container.c"
	}
	_state_0:
	{
#line 105 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp0_ = _data_->self->priv->container;
#line 105 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp1_ = rygel_media_container_get_sort_criteria (_data_->_tmp0_);
#line 105 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 105 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp3_ = g_strdup (_data_->_tmp2_);
#line 105 "../src/librygel-server/rygel-media-container.vala"
		_data_->sort_criteria = _data_->_tmp3_;
#line 106 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp4_ = _data_->self->priv->container;
#line 106 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp5_ = rygel_media_container_get_child_count (_data_->_tmp4_);
#line 106 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 106 "../src/librygel-server/rygel-media-container.vala"
		_data_->count = _data_->_tmp6_;
#line 108 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp7_ = _data_->self->priv->container;
#line 108 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp8_ = _data_->sort_criteria;
#line 108 "../src/librygel-server/rygel-media-container.vala"
		_data_->_state_ = 1;
#line 108 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_container_get_children (_data_->_tmp7_, (guint) 0, (guint) _data_->count, _data_->_tmp8_, NULL, rygel_playlist_datasource_generate_data_ready, _data_);
#line 108 "../src/librygel-server/rygel-media-container.vala"
		return FALSE;
#line 714 "rygel-media-container.c"
		_state_1:
#line 108 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp9_ = rygel_media_container_get_children_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error0_);
#line 108 "../src/librygel-server/rygel-media-container.vala"
		_data_->children = _data_->_tmp9_;
#line 108 "../src/librygel-server/rygel-media-container.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 108 "../src/librygel-server/rygel-media-container.vala"
			_g_free0 (_data_->sort_criteria);
#line 724 "rygel-media-container.c"
			goto __catch0_g_error;
		}
#line 113 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp10_ = _data_->children;
#line 113 "../src/librygel-server/rygel-media-container.vala"
		if (_data_->_tmp10_ != NULL) {
#line 114 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp11_ = rygel_serializer_new (_data_->self->priv->playlist_type);
#line 114 "../src/librygel-server/rygel-media-container.vala"
			_data_->serializer = _data_->_tmp11_;
#line 115 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp12_ = _data_->children;
#line 115 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp13_ = _data_->serializer;
#line 115 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp14_ = _data_->self->priv->server;
#line 115 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp15_ = _data_->self->priv->hacks;
#line 115 "../src/librygel-server/rygel-media-container.vala"
			rygel_media_objects_serialize (_data_->_tmp12_, _data_->_tmp13_, _data_->_tmp14_, _data_->_tmp15_, &_data_->_inner_error0_);
#line 115 "../src/librygel-server/rygel-media-container.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 115 "../src/librygel-server/rygel-media-container.vala"
				_g_object_unref0 (_data_->serializer);
#line 115 "../src/librygel-server/rygel-media-container.vala"
				_g_object_unref0 (_data_->children);
#line 115 "../src/librygel-server/rygel-media-container.vala"
				_g_free0 (_data_->sort_criteria);
#line 753 "rygel-media-container.c"
				goto __catch0_g_error;
			}
#line 117 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp16_ = _data_->serializer;
#line 117 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp17_ = rygel_serializer_get_string (_data_->_tmp16_);
#line 117 "../src/librygel-server/rygel-media-container.vala"
			_data_->xml = _data_->_tmp17_;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp18_ = _data_->xml;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp20_ = 0;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp19_ = string_get_data (_data_->_tmp18_, &_data_->_tmp20_);
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp19__length1 = _data_->_tmp20_;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp21_ = _data_->_tmp19_;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp21__length1 = _data_->_tmp19__length1;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp22_ = (_data_->_tmp21_ != NULL) ? _vala_array_dup1 (_data_->_tmp21_, _data_->_tmp21__length1) : _data_->_tmp21_;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp22__length1 = _data_->_tmp21__length1;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->self->priv->data = (g_free (_data_->self->priv->data), NULL);
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->self->priv->data = _data_->_tmp22_;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->self->priv->data_length1 = _data_->_tmp22__length1;
#line 119 "../src/librygel-server/rygel-media-container.vala"
			_data_->self->priv->_data_size_ = _data_->self->priv->data_length1;
#line 120 "../src/librygel-server/rygel-media-container.vala"
			g_signal_emit (_data_->self, rygel_playlist_datasource_signals[RYGEL_PLAYLIST_DATASOURCE_DATA_READY_SIGNAL], 0);
#line 113 "../src/librygel-server/rygel-media-container.vala"
			_g_free0 (_data_->xml);
#line 113 "../src/librygel-server/rygel-media-container.vala"
			_g_object_unref0 (_data_->serializer);
#line 792 "rygel-media-container.c"
		} else {
#line 122 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp23_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_GENERAL, _ ("Failed to generate playlist"));
#line 122 "../src/librygel-server/rygel-media-container.vala"
			_data_->_tmp24_ = _data_->_tmp23_;
#line 122 "../src/librygel-server/rygel-media-container.vala"
			g_signal_emit_by_name ((RygelDataSource*) _data_->self, "error", _data_->_tmp24_);
#line 122 "../src/librygel-server/rygel-media-container.vala"
			_g_error_free0 (_data_->_tmp24_);
#line 802 "rygel-media-container.c"
		}
#line 104 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (_data_->children);
#line 104 "../src/librygel-server/rygel-media-container.vala"
		_g_free0 (_data_->sort_criteria);
#line 808 "rygel-media-container.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 104 "../src/librygel-server/rygel-media-container.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 104 "../src/librygel-server/rygel-media-container.vala"
		_data_->_inner_error0_ = NULL;
#line 126 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp25_ = _data_->_error_;
#line 126 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp26_ = _data_->_tmp25_->message;
#line 126 "../src/librygel-server/rygel-media-container.vala"
		g_warning ("rygel-media-container.vala:126: Could not generate playlist: %s", _data_->_tmp26_);
#line 127 "../src/librygel-server/rygel-media-container.vala"
		_data_->_tmp27_ = _data_->_error_;
#line 127 "../src/librygel-server/rygel-media-container.vala"
		g_signal_emit_by_name ((RygelDataSource*) _data_->self, "error", _data_->_tmp27_);
#line 104 "../src/librygel-server/rygel-media-container.vala"
		_g_error_free0 (_data_->_error_);
#line 829 "rygel-media-container.c"
	}
	__finally0:
#line 104 "../src/librygel-server/rygel-media-container.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 104 "../src/librygel-server/rygel-media-container.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 104 "../src/librygel-server/rygel-media-container.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 104 "../src/librygel-server/rygel-media-container.vala"
		g_object_unref (_data_->_async_result);
#line 104 "../src/librygel-server/rygel-media-container.vala"
		return FALSE;
#line 842 "rygel-media-container.c"
	}
#line 103 "../src/librygel-server/rygel-media-container.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 103 "../src/librygel-server/rygel-media-container.vala"
	if (_data_->_state_ != 0) {
#line 103 "../src/librygel-server/rygel-media-container.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 103 "../src/librygel-server/rygel-media-container.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 852 "rygel-media-container.c"
		}
	}
#line 103 "../src/librygel-server/rygel-media-container.vala"
	g_object_unref (_data_->_async_result);
#line 103 "../src/librygel-server/rygel-media-container.vala"
	return FALSE;
#line 859 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_class_init (RygelPlaylistDatasourceClass * klass,
                                      gpointer klass_data)
{
#line 41 "../src/librygel-server/rygel-media-container.vala"
	rygel_playlist_datasource_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	g_type_class_adjust_private_offset (klass, &RygelPlaylistDatasource_private_offset);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_playlist_datasource_finalize;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	rygel_playlist_datasource_signals[RYGEL_PLAYLIST_DATASOURCE_DATA_READY_SIGNAL] = g_signal_new ("data-ready", RYGEL_TYPE_PLAYLIST_DATASOURCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 874 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_rygel_data_source_interface_init (RygelDataSourceIface * iface,
                                                            gpointer iface_data)
{
#line 41 "../src/librygel-server/rygel-media-container.vala"
	rygel_playlist_datasource_rygel_data_source_parent_iface = g_type_interface_peek_parent (iface);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	iface->preroll = (GeeList* (*) (RygelDataSource*, RygelHTTPSeekRequest*, RygelPlaySpeedRequest*, GError**)) rygel_playlist_datasource_real_preroll;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	iface->start = (void (*) (RygelDataSource*, GError**)) rygel_playlist_datasource_real_start;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	iface->freeze = (void (*) (RygelDataSource*)) rygel_playlist_datasource_real_freeze;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	iface->thaw = (void (*) (RygelDataSource*)) rygel_playlist_datasource_real_thaw;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	iface->stop = (void (*) (RygelDataSource*)) rygel_playlist_datasource_real_stop;
#line 893 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_instance_init (RygelPlaylistDatasource * self,
                                         gpointer klass)
{
#line 41 "../src/librygel-server/rygel-media-container.vala"
	self->priv = rygel_playlist_datasource_get_instance_private (self);
#line 902 "rygel-media-container.c"
}

static void
rygel_playlist_datasource_finalize (GObject * obj)
{
	RygelPlaylistDatasource * self;
#line 41 "../src/librygel-server/rygel-media-container.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_PLAYLIST_DATASOURCE, RygelPlaylistDatasource);
#line 42 "../src/librygel-server/rygel-media-container.vala"
	_g_object_unref0 (self->priv->container);
#line 43 "../src/librygel-server/rygel-media-container.vala"
	self->priv->data = (g_free (self->priv->data), NULL);
#line 44 "../src/librygel-server/rygel-media-container.vala"
	_g_object_unref0 (self->priv->server);
#line 45 "../src/librygel-server/rygel-media-container.vala"
	_g_object_unref0 (self->priv->hacks);
#line 41 "../src/librygel-server/rygel-media-container.vala"
	G_OBJECT_CLASS (rygel_playlist_datasource_parent_class)->finalize (obj);
#line 921 "rygel-media-container.c"
}

/**
 * Implementation of RygelDataSource to serve generated playlists to a client.
 */
 G_GNUC_NO_INLINE static GType
rygel_playlist_datasource_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelPlaylistDatasourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_playlist_datasource_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelPlaylistDatasource), 0, (GInstanceInitFunc) rygel_playlist_datasource_instance_init, NULL };
	static const GInterfaceInfo rygel_data_source_info = { (GInterfaceInitFunc) rygel_playlist_datasource_rygel_data_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType rygel_playlist_datasource_type_id;
	rygel_playlist_datasource_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelPlaylistDatasource", &g_define_type_info, 0);
	g_type_add_interface_static (rygel_playlist_datasource_type_id, RYGEL_TYPE_DATA_SOURCE, &rygel_data_source_info);
	RygelPlaylistDatasource_private_offset = g_type_add_instance_private (rygel_playlist_datasource_type_id, sizeof (RygelPlaylistDatasourcePrivate));
	return rygel_playlist_datasource_type_id;
}

GType
rygel_playlist_datasource_get_type (void)
{
	static volatile gsize rygel_playlist_datasource_type_id__once = 0;
	if (g_once_init_enter (&rygel_playlist_datasource_type_id__once)) {
		GType rygel_playlist_datasource_type_id;
		rygel_playlist_datasource_type_id = rygel_playlist_datasource_get_type_once ();
		g_once_init_leave (&rygel_playlist_datasource_type_id__once, rygel_playlist_datasource_type_id);
	}
	return rygel_playlist_datasource_type_id__once;
}

static inline gpointer
rygel_media_container_get_instance_private (RygelMediaContainer* self)
{
	return G_STRUCT_MEMBER_P (self, RygelMediaContainer_private_offset);
}

gboolean
rygel_media_container_equal_func (RygelMediaContainer* a,
                                  RygelMediaContainer* b)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 177 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 177 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 178 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = rygel_media_object_get_id ((RygelMediaObject*) a);
#line 178 "../src/librygel-server/rygel-media-container.vala"
	_tmp1_ = _tmp0_;
#line 178 "../src/librygel-server/rygel-media-container.vala"
	_tmp2_ = rygel_media_object_get_id ((RygelMediaObject*) b);
#line 178 "../src/librygel-server/rygel-media-container.vala"
	_tmp3_ = _tmp2_;
#line 178 "../src/librygel-server/rygel-media-container.vala"
	result = g_strcmp0 (_tmp1_, _tmp3_) == 0;
#line 178 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 982 "rygel-media-container.c"
}

/**
     * Create a media container with the specified details.
     *
     * @param id See the id property of the #RygelMediaObject class.
     * @param parent The parent container, if any.
     * @param title See the title property of the #RygelMediaObject class.
     * @param child_count The initially-known number of child items.
     */
RygelMediaContainer*
rygel_media_container_construct (GType object_type,
                                 const gchar* id,
                                 RygelMediaContainer* parent,
                                 const gchar* title,
                                 gint child_count)
{
	RygelMediaContainer * self = NULL;
#line 272 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 272 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 276 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelMediaContainer*) g_object_new (object_type, "id", id, "parent", parent, "title", title, "child-count", child_count, NULL);
#line 272 "../src/librygel-server/rygel-media-container.vala"
	return self;
#line 1009 "rygel-media-container.c"
}

/**
     * Create a root media container with the specified details,
     * with no parent container, and with an appropriate ID.
     *
     * @param title See the title property of the #RygelMediaObject.
     * @param child_count The initially-known number of child items.
     */
RygelMediaContainer*
rygel_media_container_construct_root (GType object_type,
                                      const gchar* title,
                                      gint child_count)
{
	RygelMediaContainer * self = NULL;
#line 289 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 291 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelMediaContainer*) g_object_new (object_type, "id", "0", "parent", NULL, "title", title, "child-count", child_count, NULL);
#line 289 "../src/librygel-server/rygel-media-container.vala"
	return self;
#line 1031 "rygel-media-container.c"
}

static void
_rygel_media_container_on_container_updated_rygel_media_container_container_updated (RygelMediaContainer* _sender,
                                                                                     RygelMediaContainer* container,
                                                                                     RygelMediaObject* object,
                                                                                     RygelObjectEventType event_type,
                                                                                     gboolean sub_tree_update,
                                                                                     gpointer self)
{
#line 307 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_on_container_updated ((RygelMediaContainer*) self, _sender, container, object, event_type, sub_tree_update);
#line 1044 "rygel-media-container.c"
}

static void
_rygel_media_container_on_sub_tree_updates_finished_rygel_media_container_sub_tree_updates_finished (RygelMediaContainer* _sender,
                                                                                                     RygelMediaObject* sub_tree_root,
                                                                                                     gpointer self)
{
#line 308 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_on_sub_tree_updates_finished ((RygelMediaContainer*) self, _sender, sub_tree_root);
#line 1054 "rygel-media-container.c"
}

static void
rygel_media_container_real_constructed (GObject* base)
{
	RygelMediaContainer * self;
#line 297 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelMediaContainer*) base;
#line 298 "../src/librygel-server/rygel-media-container.vala"
	G_OBJECT_CLASS (rygel_media_container_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_MEDIA_OBJECT, RygelMediaObject));
#line 300 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_set_empty_child_count (self, 0);
#line 301 "../src/librygel-server/rygel-media-container.vala"
	self->update_id = (guint32) 0;
#line 302 "../src/librygel-server/rygel-media-container.vala"
	self->storage_used = (gint64) -1;
#line 303 "../src/librygel-server/rygel-media-container.vala"
	self->total_deleted_child_count = (gint64) 0;
#line 304 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_object_set_upnp_class ((RygelMediaObject*) self, RYGEL_MEDIA_CONTAINER_UPNP_CLASS);
#line 305 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_set_create_mode_enabled (self, FALSE);
#line 307 "../src/librygel-server/rygel-media-container.vala"
	g_signal_connect_object (self, "container-updated", (GCallback) _rygel_media_container_on_container_updated_rygel_media_container_container_updated, self, 0);
#line 308 "../src/librygel-server/rygel-media-container.vala"
	g_signal_connect_object (self, "sub-tree-updates-finished", (GCallback) _rygel_media_container_on_sub_tree_updates_finished_rygel_media_container_sub_tree_updates_finished, self, 0);
#line 310 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_add_playlist_resources (self);
#line 1083 "rygel-media-container.c"
}

void
rygel_media_container_get_children (RygelMediaContainer* self,
                                    guint offset,
                                    guint max_count,
                                    const gchar* sort_criteria,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	RygelMediaContainerClass* _klass_;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	_klass_ = RYGEL_MEDIA_CONTAINER_GET_CLASS (self);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	if (_klass_->get_children) {
#line 158 "../src/librygel-server/rygel-media-container.vala"
		_klass_->get_children (self, offset, max_count, sort_criteria, cancellable, _callback_, _user_data_);
#line 1102 "rygel-media-container.c"
	}
}

RygelMediaObjects*
rygel_media_container_get_children_finish (RygelMediaContainer* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	RygelMediaContainerClass* _klass_;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	_klass_ = RYGEL_MEDIA_CONTAINER_GET_CLASS (self);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	if (_klass_->get_children_finish) {
#line 158 "../src/librygel-server/rygel-media-container.vala"
		return _klass_->get_children_finish (self, _res_, error);
#line 1118 "rygel-media-container.c"
	}
#line 158 "../src/librygel-server/rygel-media-container.vala"
	return NULL;
#line 1122 "rygel-media-container.c"
}

void
rygel_media_container_find_object (RygelMediaContainer* self,
                                   const gchar* id,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	RygelMediaContainerClass* _klass_;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	_klass_ = RYGEL_MEDIA_CONTAINER_GET_CLASS (self);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	if (_klass_->find_object) {
#line 158 "../src/librygel-server/rygel-media-container.vala"
		_klass_->find_object (self, id, cancellable, _callback_, _user_data_);
#line 1139 "rygel-media-container.c"
	}
}

RygelMediaObject*
rygel_media_container_find_object_finish (RygelMediaContainer* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	RygelMediaContainerClass* _klass_;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	_klass_ = RYGEL_MEDIA_CONTAINER_GET_CLASS (self);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	if (_klass_->find_object_finish) {
#line 158 "../src/librygel-server/rygel-media-container.vala"
		return _klass_->find_object_finish (self, _res_, error);
#line 1155 "rygel-media-container.c"
	}
#line 158 "../src/librygel-server/rygel-media-container.vala"
	return NULL;
#line 1159 "rygel-media-container.c"
}

/**
     * This method should be called each time this container is updated.
     *
     * For instance, this should be called if there are metadata changes
     * for this container, if items under it are removed or added, if
     * there are metadata changes to items under it, etc.
     *
     * If sub_tree_update is true then the caller should later emit the
     * sub_tree_updates_finished signal on the root container of the sub-tree
     * that was updated.
     *
     * It will eventually result in the server emitting a UPnP LastChange event,
     * though that may be for a batch of these calls.
     *
     * See the #RygelMediaContainer::container_updated signal.
     *
     * @param object The object that has changed, or null to mean the container itself.
     * @param event_type This describes what actually happened to the object.
     * @param sub_tree_update Whether the modification is part of a sub-tree update.
     */
void
rygel_media_container_updated (RygelMediaContainer* self,
                               RygelMediaObject* object,
                               RygelObjectEventType event_type,
                               gboolean sub_tree_update)
{
	RygelMediaObject* _tmp0_ = NULL;
#line 361 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 366 "../src/librygel-server/rygel-media-container.vala"
	if (object != NULL) {
#line 366 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = object;
#line 1195 "rygel-media-container.c"
	} else {
#line 366 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = (RygelMediaObject*) self;
#line 1199 "rygel-media-container.c"
	}
#line 365 "../src/librygel-server/rygel-media-container.vala"
	g_signal_emit (self, rygel_media_container_signals[RYGEL_MEDIA_CONTAINER_CONTAINER_UPDATED_SIGNAL], 0, self, _tmp0_, event_type, sub_tree_update);
#line 1203 "rygel-media-container.c"
}

/**
     * Add playlist resources to the MediaObject resource list
     */
void
rygel_media_container_add_playlist_resources (RygelMediaContainer* self)
{
#line 375 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 1214 "rygel-media-container.c"
	{
		RygelMediaResource* didl_s_res = NULL;
		RygelMediaResource* _tmp0_;
		GeeList* _tmp1_;
		GeeList* _tmp2_;
#line 377 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = rygel_media_resource_new (RYGEL_MEDIA_CONTAINER_DIDL_S_PLAYLIST_RESNAME);
#line 377 "../src/librygel-server/rygel-media-container.vala"
		didl_s_res = _tmp0_;
#line 378 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_extension (didl_s_res, "xml");
#line 379 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_mime_type (didl_s_res, "text/xml");
#line 380 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_dlna_profile (didl_s_res, "DIDL_S");
#line 381 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_dlna_flags (didl_s_res, (GUPNP_DLNA_FLAGS_CONNECTION_STALL | GUPNP_DLNA_FLAGS_BACKGROUND_TRANSFER_MODE) | GUPNP_DLNA_FLAGS_INTERACTIVE_TRANSFER_MODE);
#line 384 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_uri (didl_s_res, "");
#line 385 "../src/librygel-server/rygel-media-container.vala"
		_tmp1_ = rygel_media_object_get_resource_list ((RygelMediaObject*) self);
#line 385 "../src/librygel-server/rygel-media-container.vala"
		_tmp2_ = _tmp1_;
#line 385 "../src/librygel-server/rygel-media-container.vala"
		gee_collection_add ((GeeCollection*) _tmp2_, didl_s_res);
#line 385 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (_tmp2_);
#line 376 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (didl_s_res);
#line 1244 "rygel-media-container.c"
	}
	{
		RygelMediaResource* m3u_res = NULL;
		RygelMediaResource* _tmp3_;
		GeeList* _tmp4_;
		GeeList* _tmp5_;
#line 389 "../src/librygel-server/rygel-media-container.vala"
		_tmp3_ = rygel_media_resource_new (RYGEL_MEDIA_CONTAINER_M3U_PLAYLIST_RESNAME);
#line 389 "../src/librygel-server/rygel-media-container.vala"
		m3u_res = _tmp3_;
#line 390 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_extension (m3u_res, "m3u");
#line 391 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_mime_type (m3u_res, "audio/x-mpegurl");
#line 392 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_dlna_profile (m3u_res, NULL);
#line 393 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_dlna_flags (m3u_res, (GUPNP_DLNA_FLAGS_CONNECTION_STALL | GUPNP_DLNA_FLAGS_BACKGROUND_TRANSFER_MODE) | GUPNP_DLNA_FLAGS_INTERACTIVE_TRANSFER_MODE);
#line 396 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_resource_set_uri (m3u_res, "");
#line 397 "../src/librygel-server/rygel-media-container.vala"
		_tmp4_ = rygel_media_object_get_resource_list ((RygelMediaObject*) self);
#line 397 "../src/librygel-server/rygel-media-container.vala"
		_tmp5_ = _tmp4_;
#line 397 "../src/librygel-server/rygel-media-container.vala"
		gee_collection_add ((GeeCollection*) _tmp5_, m3u_res);
#line 397 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (_tmp5_);
#line 388 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (m3u_res);
#line 1275 "rygel-media-container.c"
	}
}

static GUPnPDIDLLiteObject*
rygel_media_container_real_serialize (RygelMediaObject* base,
                                      RygelSerializer* serializer,
                                      RygelHTTPServer* http_server,
                                      GError** error)
{
	RygelMediaContainer * self;
	GUPnPDIDLLiteContainer* didl_container = NULL;
	GUPnPDIDLLiteContainer* _tmp0_;
	GUPnPDIDLLiteContainer* _tmp1_;
	RygelMediaContainer* _tmp2_;
	RygelMediaContainer* _tmp3_;
	GUPnPDIDLLiteContainer* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GUPnPDIDLLiteContainer* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	GUPnPDIDLLiteContainer* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GUPnPDIDLLiteContainer* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	gint _tmp52_;
	GError* _inner_error0_ = NULL;
	GUPnPDIDLLiteObject* result;
#line 401 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelMediaContainer*) base;
#line 401 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (serializer != NULL, NULL);
#line 401 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (http_server != NULL, NULL);
#line 404 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = rygel_serializer_add_container (serializer);
#line 404 "../src/librygel-server/rygel-media-container.vala"
	didl_container = _tmp0_;
#line 405 "../src/librygel-server/rygel-media-container.vala"
	_tmp1_ = didl_container;
#line 405 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp1_ == NULL) {
#line 406 "../src/librygel-server/rygel-media-container.vala"
		result = NULL;
#line 406 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (didl_container);
#line 406 "../src/librygel-server/rygel-media-container.vala"
		return result;
#line 1329 "rygel-media-container.c"
	}
#line 409 "../src/librygel-server/rygel-media-container.vala"
	_tmp2_ = rygel_media_object_get_parent ((RygelMediaObject*) self);
#line 409 "../src/librygel-server/rygel-media-container.vala"
	_tmp3_ = _tmp2_;
#line 409 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp3_ != NULL) {
#line 1337 "rygel-media-container.c"
		GUPnPDIDLLiteContainer* _tmp4_;
		RygelMediaContainer* _tmp5_;
		RygelMediaContainer* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 410 "../src/librygel-server/rygel-media-container.vala"
		_tmp4_ = didl_container;
#line 410 "../src/librygel-server/rygel-media-container.vala"
		_tmp5_ = rygel_media_object_get_parent ((RygelMediaObject*) self);
#line 410 "../src/librygel-server/rygel-media-container.vala"
		_tmp6_ = _tmp5_;
#line 410 "../src/librygel-server/rygel-media-container.vala"
		_tmp7_ = rygel_media_object_get_id ((RygelMediaObject*) _tmp6_);
#line 410 "../src/librygel-server/rygel-media-container.vala"
		_tmp8_ = _tmp7_;
#line 410 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_object_set_parent_id ((GUPnPDIDLLiteObject*) _tmp4_, _tmp8_);
#line 1355 "rygel-media-container.c"
	} else {
		GUPnPDIDLLiteContainer* _tmp9_;
#line 412 "../src/librygel-server/rygel-media-container.vala"
		_tmp9_ = didl_container;
#line 412 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_object_set_parent_id ((GUPnPDIDLLiteObject*) _tmp9_, "-1");
#line 1362 "rygel-media-container.c"
	}
#line 415 "../src/librygel-server/rygel-media-container.vala"
	_tmp10_ = didl_container;
#line 415 "../src/librygel-server/rygel-media-container.vala"
	_tmp11_ = rygel_media_object_get_id ((RygelMediaObject*) self);
#line 415 "../src/librygel-server/rygel-media-container.vala"
	_tmp12_ = _tmp11_;
#line 415 "../src/librygel-server/rygel-media-container.vala"
	gupnp_didl_lite_object_set_id ((GUPnPDIDLLiteObject*) _tmp10_, _tmp12_);
#line 416 "../src/librygel-server/rygel-media-container.vala"
	_tmp13_ = didl_container;
#line 416 "../src/librygel-server/rygel-media-container.vala"
	_tmp14_ = rygel_media_object_get_title ((RygelMediaObject*) self);
#line 416 "../src/librygel-server/rygel-media-container.vala"
	_tmp15_ = _tmp14_;
#line 416 "../src/librygel-server/rygel-media-container.vala"
	gupnp_didl_lite_object_set_title ((GUPnPDIDLLiteObject*) _tmp13_, _tmp15_);
#line 417 "../src/librygel-server/rygel-media-container.vala"
	_tmp16_ = self->priv->_child_count;
#line 417 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp16_ > -1) {
#line 1384 "rygel-media-container.c"
		GUPnPDIDLLiteContainer* _tmp17_;
		gint _tmp18_;
#line 418 "../src/librygel-server/rygel-media-container.vala"
		_tmp17_ = didl_container;
#line 418 "../src/librygel-server/rygel-media-container.vala"
		_tmp18_ = self->priv->_child_count;
#line 418 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_container_set_child_count (_tmp17_, _tmp18_);
#line 1393 "rygel-media-container.c"
	}
#line 420 "../src/librygel-server/rygel-media-container.vala"
	_tmp19_ = didl_container;
#line 420 "../src/librygel-server/rygel-media-container.vala"
	_tmp20_ = rygel_media_object_get_upnp_class ((RygelMediaObject*) self);
#line 420 "../src/librygel-server/rygel-media-container.vala"
	_tmp21_ = _tmp20_;
#line 420 "../src/librygel-server/rygel-media-container.vala"
	gupnp_didl_lite_object_set_upnp_class ((GUPnPDIDLLiteObject*) _tmp19_, _tmp21_);
#line 421 "../src/librygel-server/rygel-media-container.vala"
	_tmp22_ = didl_container;
#line 421 "../src/librygel-server/rygel-media-container.vala"
	gupnp_didl_lite_container_set_searchable (_tmp22_, RYGEL_IS_SEARCHABLE_CONTAINER (self));
#line 422 "../src/librygel-server/rygel-media-container.vala"
	_tmp23_ = rygel_media_object_get_upnp_class ((RygelMediaObject*) self);
#line 422 "../src/librygel-server/rygel-media-container.vala"
	_tmp24_ = _tmp23_;
#line 422 "../src/librygel-server/rygel-media-container.vala"
	if (g_strcmp0 (_tmp24_, RYGEL_MEDIA_CONTAINER_STORAGE_FOLDER) == 0) {
#line 1413 "rygel-media-container.c"
		GUPnPDIDLLiteContainer* _tmp25_;
#line 423 "../src/librygel-server/rygel-media-container.vala"
		_tmp25_ = didl_container;
#line 423 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_container_set_storage_used (_tmp25_, self->storage_used);
#line 1419 "rygel-media-container.c"
	}
#line 426 "../src/librygel-server/rygel-media-container.vala"
	if (RYGEL_IS_TRACKABLE_CONTAINER (self)) {
#line 1423 "rygel-media-container.c"
		GUPnPDIDLLiteContainer* _tmp26_;
		GUPnPDIDLLiteContainer* _tmp27_;
		guint _tmp28_;
		guint _tmp29_;
		GUPnPDIDLLiteContainer* _tmp30_;
#line 427 "../src/librygel-server/rygel-media-container.vala"
		_tmp26_ = didl_container;
#line 427 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_container_set_container_update_id (_tmp26_, (guint) self->update_id);
#line 428 "../src/librygel-server/rygel-media-container.vala"
		_tmp27_ = didl_container;
#line 428 "../src/librygel-server/rygel-media-container.vala"
		_tmp28_ = rygel_media_object_get_object_update_id ((RygelMediaObject*) self);
#line 428 "../src/librygel-server/rygel-media-container.vala"
		_tmp29_ = _tmp28_;
#line 428 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_object_set_update_id ((GUPnPDIDLLiteObject*) _tmp27_, _tmp29_);
#line 429 "../src/librygel-server/rygel-media-container.vala"
		_tmp30_ = didl_container;
#line 429 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_container_set_total_deleted_child_count (_tmp30_, (guint) self->total_deleted_child_count);
#line 1445 "rygel-media-container.c"
	}
#line 434 "../src/librygel-server/rygel-media-container.vala"
	if (RYGEL_IS_SEARCHABLE_CONTAINER (self)) {
#line 1449 "rygel-media-container.c"
		GUPnPDIDLLiteContainer* _tmp31_;
#line 435 "../src/librygel-server/rygel-media-container.vala"
		_tmp31_ = didl_container;
#line 435 "../src/librygel-server/rygel-media-container.vala"
		rygel_searchable_container_serialize_search_parameters (G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_SEARCHABLE_CONTAINER, RygelSearchableContainer), _tmp31_);
#line 1455 "rygel-media-container.c"
	}
#line 439 "../src/librygel-server/rygel-media-container.vala"
	_tmp32_ = rygel_media_object_get_restricted ((RygelMediaObject*) self);
#line 439 "../src/librygel-server/rygel-media-container.vala"
	_tmp33_ = _tmp32_;
#line 439 "../src/librygel-server/rygel-media-container.vala"
	if (!_tmp33_) {
#line 1463 "rygel-media-container.c"
		GUPnPDIDLLiteContainer* _tmp34_;
		GUPnPDIDLLiteContainer* _tmp35_;
		GUPnPOCMFlags _tmp36_;
		GUPnPOCMFlags _tmp37_;
		RygelWritableContainer* writable = NULL;
		RygelWritableContainer* _tmp38_;
#line 440 "../src/librygel-server/rygel-media-container.vala"
		_tmp34_ = didl_container;
#line 440 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_object_set_restricted ((GUPnPDIDLLiteObject*) _tmp34_, FALSE);
#line 441 "../src/librygel-server/rygel-media-container.vala"
		_tmp35_ = didl_container;
#line 441 "../src/librygel-server/rygel-media-container.vala"
		_tmp36_ = rygel_media_object_get_ocm_flags ((RygelMediaObject*) self);
#line 441 "../src/librygel-server/rygel-media-container.vala"
		_tmp37_ = _tmp36_;
#line 441 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_object_set_dlna_managed ((GUPnPDIDLLiteObject*) _tmp35_, _tmp37_);
#line 443 "../src/librygel-server/rygel-media-container.vala"
		_tmp38_ = _g_object_ref0 (RYGEL_IS_WRITABLE_CONTAINER (self) ? ((RygelWritableContainer*) self) : NULL);
#line 443 "../src/librygel-server/rygel-media-container.vala"
		writable = _tmp38_;
#line 1486 "rygel-media-container.c"
		{
			GeeArrayList* _create_class_list = NULL;
			RygelWritableContainer* _tmp39_;
			GeeArrayList* _tmp40_;
			GeeArrayList* _tmp41_;
			gint _create_class_size = 0;
			GeeArrayList* _tmp42_;
			gint _tmp43_;
			gint _tmp44_;
			gint _create_class_index = 0;
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_tmp39_ = writable;
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_tmp40_ = rygel_writable_container_get_create_classes (_tmp39_);
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_tmp41_ = _tmp40_;
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_create_class_list = _tmp41_;
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_tmp42_ = _create_class_list;
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_tmp44_ = _tmp43_;
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_create_class_size = _tmp44_;
#line 444 "../src/librygel-server/rygel-media-container.vala"
			_create_class_index = -1;
#line 444 "../src/librygel-server/rygel-media-container.vala"
			while (TRUE) {
#line 1517 "rygel-media-container.c"
				gint _tmp45_;
				gint _tmp46_;
				gchar* create_class = NULL;
				GeeArrayList* _tmp47_;
				gpointer _tmp48_;
				GUPnPDIDLLiteContainer* _tmp49_;
				const gchar* _tmp50_;
#line 444 "../src/librygel-server/rygel-media-container.vala"
				_create_class_index = _create_class_index + 1;
#line 444 "../src/librygel-server/rygel-media-container.vala"
				_tmp45_ = _create_class_index;
#line 444 "../src/librygel-server/rygel-media-container.vala"
				_tmp46_ = _create_class_size;
#line 444 "../src/librygel-server/rygel-media-container.vala"
				if (!(_tmp45_ < _tmp46_)) {
#line 444 "../src/librygel-server/rygel-media-container.vala"
					break;
#line 1535 "rygel-media-container.c"
				}
#line 444 "../src/librygel-server/rygel-media-container.vala"
				_tmp47_ = _create_class_list;
#line 444 "../src/librygel-server/rygel-media-container.vala"
				_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, _create_class_index);
#line 444 "../src/librygel-server/rygel-media-container.vala"
				create_class = (gchar*) _tmp48_;
#line 445 "../src/librygel-server/rygel-media-container.vala"
				_tmp49_ = didl_container;
#line 445 "../src/librygel-server/rygel-media-container.vala"
				_tmp50_ = create_class;
#line 445 "../src/librygel-server/rygel-media-container.vala"
				gupnp_didl_lite_container_add_create_class (_tmp49_, _tmp50_);
#line 444 "../src/librygel-server/rygel-media-container.vala"
				_g_free0 (create_class);
#line 1551 "rygel-media-container.c"
			}
		}
#line 439 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (writable);
#line 1556 "rygel-media-container.c"
	} else {
		GUPnPDIDLLiteContainer* _tmp51_;
#line 448 "../src/librygel-server/rygel-media-container.vala"
		_tmp51_ = didl_container;
#line 448 "../src/librygel-server/rygel-media-container.vala"
		gupnp_didl_lite_object_set_restricted ((GUPnPDIDLLiteObject*) _tmp51_, TRUE);
#line 1563 "rygel-media-container.c"
	}
#line 451 "../src/librygel-server/rygel-media-container.vala"
	_tmp52_ = self->priv->_child_count;
#line 451 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp52_ > 0) {
#line 1569 "rygel-media-container.c"
		GUPnPDIDLLiteContainer* _tmp53_;
#line 452 "../src/librygel-server/rygel-media-container.vala"
		_tmp53_ = didl_container;
#line 452 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_object_serialize_resource_list ((RygelMediaObject*) self, (GUPnPDIDLLiteObject*) _tmp53_, http_server, &_inner_error0_);
#line 452 "../src/librygel-server/rygel-media-container.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 452 "../src/librygel-server/rygel-media-container.vala"
			g_propagate_error (error, _inner_error0_);
#line 452 "../src/librygel-server/rygel-media-container.vala"
			_g_object_unref0 (didl_container);
#line 452 "../src/librygel-server/rygel-media-container.vala"
			return NULL;
#line 1583 "rygel-media-container.c"
		}
	}
#line 455 "../src/librygel-server/rygel-media-container.vala"
	result = (GUPnPDIDLLiteObject*) didl_container;
#line 455 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 1590 "rygel-media-container.c"
}

static RygelDataSource*
rygel_media_container_real_create_stream_source_for_resource (RygelMediaObject* base,
                                                              RygelHTTPRequest* request,
                                                              RygelMediaResource* resource,
                                                              GError** error)
{
	RygelMediaContainer * self;
	RygelSerializerType playlist_type = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 464 "../src/librygel-server/rygel-media-container.vala"
	static GQuark _tmp2_label0 = 0;
#line 464 "../src/librygel-server/rygel-media-container.vala"
	static GQuark _tmp2_label1 = 0;
#line 1608 "rygel-media-container.c"
	RygelHTTPServer* _tmp6_;
	RygelClientHacks* _tmp7_;
	RygelPlaylistDatasource* _tmp8_;
	RygelDataSource* result;
#line 458 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelMediaContainer*) base;
#line 458 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (request != NULL, NULL);
#line 458 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (resource != NULL, NULL);
#line 464 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = rygel_media_resource_get_name (resource);
#line 464 "../src/librygel-server/rygel-media-container.vala"
	_tmp1_ = _tmp0_;
#line 464 "../src/librygel-server/rygel-media-container.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 464 "../src/librygel-server/rygel-media-container.vala"
	g_free (_tmp1_);
#line 464 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string (RYGEL_MEDIA_CONTAINER_DIDL_S_PLAYLIST_RESNAME)))) {
#line 464 "../src/librygel-server/rygel-media-container.vala"
		switch (0) {
#line 1631 "rygel-media-container.c"
			default:
			{
#line 466 "../src/librygel-server/rygel-media-container.vala"
				playlist_type = RYGEL_SERIALIZER_TYPE_DIDL_S;
#line 467 "../src/librygel-server/rygel-media-container.vala"
				break;
#line 1638 "rygel-media-container.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string (RYGEL_MEDIA_CONTAINER_M3U_PLAYLIST_RESNAME)))) {
#line 464 "../src/librygel-server/rygel-media-container.vala"
		switch (0) {
#line 1644 "rygel-media-container.c"
			default:
			{
#line 469 "../src/librygel-server/rygel-media-container.vala"
				playlist_type = RYGEL_SERIALIZER_TYPE_M3UEXT;
#line 470 "../src/librygel-server/rygel-media-container.vala"
				break;
#line 1651 "rygel-media-container.c"
			}
		}
	} else {
#line 464 "../src/librygel-server/rygel-media-container.vala"
		switch (0) {
#line 1657 "rygel-media-container.c"
			default:
			{
				gchar* _tmp4_;
				gchar* _tmp5_;
#line 472 "../src/librygel-server/rygel-media-container.vala"
				_tmp4_ = rygel_media_resource_get_name (resource);
#line 472 "../src/librygel-server/rygel-media-container.vala"
				_tmp5_ = _tmp4_;
#line 472 "../src/librygel-server/rygel-media-container.vala"
				g_warning (_ ("Unknown MediaContainer resource: %s"), _tmp5_);
#line 472 "../src/librygel-server/rygel-media-container.vala"
				_g_free0 (_tmp5_);
#line 474 "../src/librygel-server/rygel-media-container.vala"
				result = NULL;
#line 474 "../src/librygel-server/rygel-media-container.vala"
				return result;
#line 1674 "rygel-media-container.c"
			}
		}
	}
#line 477 "../src/librygel-server/rygel-media-container.vala"
	_tmp6_ = request->http_server;
#line 477 "../src/librygel-server/rygel-media-container.vala"
	_tmp7_ = request->hack;
#line 477 "../src/librygel-server/rygel-media-container.vala"
	_tmp8_ = rygel_playlist_datasource_new (playlist_type, self, _tmp6_, _tmp7_);
#line 477 "../src/librygel-server/rygel-media-container.vala"
	result = (RygelDataSource*) _tmp8_;
#line 477 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 1688 "rygel-media-container.c"
}

/**
     * The handler for the container_updated signal on this container. We only forward
     * it to the parent, hoping someone will get it from the root container
     * and act upon it.
     *
     * @param container The container that emitted the signal
     * @param updated_container The container that just got updated
     */
static void
rygel_media_container_on_container_updated (RygelMediaContainer* self,
                                            RygelMediaContainer* container,
                                            RygelMediaContainer* updated_container,
                                            RygelMediaObject* object,
                                            RygelObjectEventType event_type,
                                            gboolean sub_tree_update)
{
	RygelMediaContainer* _tmp0_;
	RygelMediaContainer* _tmp1_;
#line 492 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 492 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (container != NULL);
#line 492 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (updated_container != NULL);
#line 492 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (object != NULL);
#line 497 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = rygel_media_object_get_parent ((RygelMediaObject*) self);
#line 497 "../src/librygel-server/rygel-media-container.vala"
	_tmp1_ = _tmp0_;
#line 497 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp1_ != NULL) {
#line 1723 "rygel-media-container.c"
		RygelMediaContainer* _tmp2_;
		RygelMediaContainer* _tmp3_;
#line 498 "../src/librygel-server/rygel-media-container.vala"
		_tmp2_ = rygel_media_object_get_parent ((RygelMediaObject*) self);
#line 498 "../src/librygel-server/rygel-media-container.vala"
		_tmp3_ = _tmp2_;
#line 498 "../src/librygel-server/rygel-media-container.vala"
		g_signal_emit (_tmp3_, rygel_media_container_signals[RYGEL_MEDIA_CONTAINER_CONTAINER_UPDATED_SIGNAL], 0, updated_container, object, event_type, sub_tree_update);
#line 1732 "rygel-media-container.c"
	}
}

static void
rygel_media_container_on_sub_tree_updates_finished (RygelMediaContainer* self,
                                                    RygelMediaContainer* container,
                                                    RygelMediaObject* sub_tree_root)
{
	RygelMediaContainer* _tmp0_;
	RygelMediaContainer* _tmp1_;
#line 505 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 505 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (container != NULL);
#line 505 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (sub_tree_root != NULL);
#line 507 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = rygel_media_object_get_parent ((RygelMediaObject*) self);
#line 507 "../src/librygel-server/rygel-media-container.vala"
	_tmp1_ = _tmp0_;
#line 507 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp1_ != NULL) {
#line 1755 "rygel-media-container.c"
		RygelMediaContainer* _tmp2_;
		RygelMediaContainer* _tmp3_;
#line 508 "../src/librygel-server/rygel-media-container.vala"
		_tmp2_ = rygel_media_object_get_parent ((RygelMediaObject*) self);
#line 508 "../src/librygel-server/rygel-media-container.vala"
		_tmp3_ = _tmp2_;
#line 508 "../src/librygel-server/rygel-media-container.vala"
		g_signal_emit (_tmp3_, rygel_media_container_signals[RYGEL_MEDIA_CONTAINER_SUB_TREE_UPDATES_FINISHED_SIGNAL], 0, sub_tree_root);
#line 1764 "rygel-media-container.c"
	}
}

static gpointer
_rygel_search_expression_ref0 (gpointer self)
{
#line 515 "../src/librygel-server/rygel-media-container.vala"
	return self ? rygel_search_expression_ref (self) : NULL;
#line 1773 "rygel-media-container.c"
}

void
rygel_media_container_check_search_expression (RygelMediaContainer* self,
                                               RygelSearchExpression* expression)
{
	gboolean _tmp0_ = FALSE;
#line 512 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 513 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_set_create_mode_enabled (self, FALSE);
#line 514 "../src/librygel-server/rygel-media-container.vala"
	if (expression != NULL) {
#line 514 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = RYGEL_IS_RELATIONAL_EXPRESSION (expression);
#line 1789 "rygel-media-container.c"
	} else {
#line 514 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = FALSE;
#line 1793 "rygel-media-container.c"
	}
#line 514 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp0_) {
#line 1797 "rygel-media-container.c"
		RygelRelationalExpression* relational_exp = NULL;
		RygelRelationalExpression* _tmp1_;
		gboolean _tmp2_ = FALSE;
		RygelRelationalExpression* _tmp3_;
		gconstpointer _tmp4_;
#line 515 "../src/librygel-server/rygel-media-container.vala"
		_tmp1_ = _rygel_search_expression_ref0 (RYGEL_IS_RELATIONAL_EXPRESSION (expression) ? ((RygelRelationalExpression*) expression) : NULL);
#line 515 "../src/librygel-server/rygel-media-container.vala"
		relational_exp = _tmp1_;
#line 516 "../src/librygel-server/rygel-media-container.vala"
		_tmp3_ = relational_exp;
#line 516 "../src/librygel-server/rygel-media-container.vala"
		_tmp4_ = ((RygelSearchExpression*) _tmp3_)->op;
#line 516 "../src/librygel-server/rygel-media-container.vala"
		if (((GUPnPSearchCriteriaOp) ((gintptr) _tmp4_)) == GUPNP_SEARCH_CRITERIA_OP_DERIVED_FROM) {
#line 1813 "rygel-media-container.c"
			RygelRelationalExpression* _tmp5_;
			gconstpointer _tmp6_;
#line 517 "../src/librygel-server/rygel-media-container.vala"
			_tmp5_ = relational_exp;
#line 517 "../src/librygel-server/rygel-media-container.vala"
			_tmp6_ = ((RygelSearchExpression*) _tmp5_)->operand1;
#line 517 "../src/librygel-server/rygel-media-container.vala"
			_tmp2_ = g_strcmp0 ((const gchar*) _tmp6_, "upnp:createClass") == 0;
#line 1822 "rygel-media-container.c"
		} else {
#line 516 "../src/librygel-server/rygel-media-container.vala"
			_tmp2_ = FALSE;
#line 1826 "rygel-media-container.c"
		}
#line 516 "../src/librygel-server/rygel-media-container.vala"
		if (_tmp2_) {
#line 518 "../src/librygel-server/rygel-media-container.vala"
			rygel_media_container_set_create_mode_enabled (self, TRUE);
#line 1832 "rygel-media-container.c"
		}
#line 514 "../src/librygel-server/rygel-media-container.vala"
		_rygel_search_expression_unref0 (relational_exp);
#line 1836 "rygel-media-container.c"
	}
}

gint
rygel_media_container_get_child_count (RygelMediaContainer* self)
{
	gint result;
#line 209 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 209 "../src/librygel-server/rygel-media-container.vala"
	result = self->priv->_child_count;
#line 209 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 1850 "rygel-media-container.c"
}

void
rygel_media_container_set_child_count (RygelMediaContainer* self,
                                       gint value)
{
	gint old_value;
#line 209 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/librygel-server/rygel-media-container.vala"
	old_value = rygel_media_container_get_child_count (self);
#line 209 "../src/librygel-server/rygel-media-container.vala"
	if (old_value != value) {
#line 209 "../src/librygel-server/rygel-media-container.vala"
		self->priv->_child_count = value;
#line 209 "../src/librygel-server/rygel-media-container.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_CHILD_COUNT_PROPERTY]);
#line 1868 "rygel-media-container.c"
	}
}

gint
rygel_media_container_get_empty_child_count (RygelMediaContainer* self)
{
	gint result;
#line 210 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 210 "../src/librygel-server/rygel-media-container.vala"
	result = self->priv->_empty_child_count;
#line 210 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 1882 "rygel-media-container.c"
}

void
rygel_media_container_set_empty_child_count (RygelMediaContainer* self,
                                             gint value)
{
	gint old_value;
#line 210 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/librygel-server/rygel-media-container.vala"
	old_value = rygel_media_container_get_empty_child_count (self);
#line 210 "../src/librygel-server/rygel-media-container.vala"
	if (old_value != value) {
#line 210 "../src/librygel-server/rygel-media-container.vala"
		self->priv->_empty_child_count = value;
#line 210 "../src/librygel-server/rygel-media-container.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_EMPTY_CHILD_COUNT_PROPERTY]);
#line 1900 "rygel-media-container.c"
	}
}

gint
rygel_media_container_get_all_child_count (RygelMediaContainer* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 212 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 213 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = self->priv->_child_count;
#line 213 "../src/librygel-server/rygel-media-container.vala"
	_tmp1_ = self->priv->_empty_child_count;
#line 213 "../src/librygel-server/rygel-media-container.vala"
	result = _tmp0_ + _tmp1_;
#line 213 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 1920 "rygel-media-container.c"
}

gboolean
rygel_media_container_get_create_mode_enabled (RygelMediaContainer* self)
{
	gboolean result;
#line 219 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 219 "../src/librygel-server/rygel-media-container.vala"
	result = self->priv->_create_mode_enabled;
#line 219 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 1933 "rygel-media-container.c"
}

void
rygel_media_container_set_create_mode_enabled (RygelMediaContainer* self,
                                               gboolean value)
{
	gboolean old_value;
#line 219 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/librygel-server/rygel-media-container.vala"
	old_value = rygel_media_container_get_create_mode_enabled (self);
#line 219 "../src/librygel-server/rygel-media-container.vala"
	if (old_value != value) {
#line 219 "../src/librygel-server/rygel-media-container.vala"
		self->priv->_create_mode_enabled = value;
#line 219 "../src/librygel-server/rygel-media-container.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_CREATE_MODE_ENABLED_PROPERTY]);
#line 1951 "rygel-media-container.c"
	}
}

const gchar*
rygel_media_container_get_sort_criteria (RygelMediaContainer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 225 "../src/librygel-server/rygel-media-container.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 225 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = self->priv->_sort_criteria;
#line 225 "../src/librygel-server/rygel-media-container.vala"
	result = _tmp0_;
#line 225 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 1968 "rygel-media-container.c"
}

void
rygel_media_container_set_sort_criteria (RygelMediaContainer* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 225 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/librygel-server/rygel-media-container.vala"
	old_value = rygel_media_container_get_sort_criteria (self);
#line 225 "../src/librygel-server/rygel-media-container.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1982 "rygel-media-container.c"
		gchar* _tmp0_;
#line 225 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = g_strdup (value);
#line 225 "../src/librygel-server/rygel-media-container.vala"
		_g_free0 (self->priv->_sort_criteria);
#line 225 "../src/librygel-server/rygel-media-container.vala"
		self->priv->_sort_criteria = _tmp0_;
#line 225 "../src/librygel-server/rygel-media-container.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_SORT_CRITERIA_PROPERTY]);
#line 1992 "rygel-media-container.c"
	}
}

static GUPnPOCMFlags
rygel_media_container_real_get_ocm_flags (RygelMediaObject* base)
{
	GUPnPOCMFlags result;
	RygelMediaContainer* self;
	gboolean _tmp0_ = FALSE;
	GUPnPOCMFlags flags = 0U;
	gboolean allow_upload = FALSE;
	RygelMetaConfig* config = NULL;
	RygelMetaConfig* _tmp5_;
	gboolean allow_deletion = FALSE;
	GError* _inner_error0_ = NULL;
#line 228 "../src/librygel-server/rygel-media-container.vala"
	self = (RygelMediaContainer*) base;
#line 229 "../src/librygel-server/rygel-media-container.vala"
	if (!RYGEL_IS_WRITABLE_CONTAINER (self)) {
#line 229 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = TRUE;
#line 2014 "rygel-media-container.c"
	} else {
		GeeList* _tmp1_;
		GeeList* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 229 "../src/librygel-server/rygel-media-container.vala"
		_tmp1_ = rygel_media_object_get_uris ((RygelMediaObject*) self);
#line 229 "../src/librygel-server/rygel-media-container.vala"
		_tmp2_ = _tmp1_;
#line 229 "../src/librygel-server/rygel-media-container.vala"
		_tmp3_ = gee_collection_get_is_empty ((GeeCollection*) _tmp2_);
#line 229 "../src/librygel-server/rygel-media-container.vala"
		_tmp4_ = _tmp3_;
#line 229 "../src/librygel-server/rygel-media-container.vala"
		_tmp0_ = _tmp4_;
#line 229 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (_tmp2_);
#line 2032 "rygel-media-container.c"
	}
#line 229 "../src/librygel-server/rygel-media-container.vala"
	if (_tmp0_) {
#line 230 "../src/librygel-server/rygel-media-container.vala"
		result = GUPNP_OCM_FLAGS_NONE;
#line 230 "../src/librygel-server/rygel-media-container.vala"
		return result;
#line 2040 "rygel-media-container.c"
	}
#line 233 "../src/librygel-server/rygel-media-container.vala"
	flags = GUPNP_OCM_FLAGS_NONE;
#line 235 "../src/librygel-server/rygel-media-container.vala"
	allow_upload = TRUE;
#line 236 "../src/librygel-server/rygel-media-container.vala"
	_tmp5_ = rygel_meta_config_get_default ();
#line 236 "../src/librygel-server/rygel-media-container.vala"
	config = _tmp5_;
#line 2050 "rygel-media-container.c"
	{
		gboolean _tmp6_ = FALSE;
		RygelMetaConfig* _tmp7_;
#line 238 "../src/librygel-server/rygel-media-container.vala"
		_tmp7_ = config;
#line 238 "../src/librygel-server/rygel-media-container.vala"
		_tmp6_ = rygel_configuration_get_allow_upload ((RygelConfiguration*) _tmp7_, &_inner_error0_);
#line 238 "../src/librygel-server/rygel-media-container.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2060 "rygel-media-container.c"
			goto __catch0_g_error;
		}
#line 238 "../src/librygel-server/rygel-media-container.vala"
		allow_upload = _tmp6_;
#line 2065 "rygel-media-container.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 237 "../src/librygel-server/rygel-media-container.vala"
		g_clear_error (&_inner_error0_);
#line 2072 "rygel-media-container.c"
	}
	__finally0:
#line 237 "../src/librygel-server/rygel-media-container.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 237 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (config);
#line 237 "../src/librygel-server/rygel-media-container.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 237 "../src/librygel-server/rygel-media-container.vala"
		g_clear_error (&_inner_error0_);
#line 237 "../src/librygel-server/rygel-media-container.vala"
		return 0U;
#line 2085 "rygel-media-container.c"
	}
#line 241 "../src/librygel-server/rygel-media-container.vala"
	if (allow_upload) {
#line 242 "../src/librygel-server/rygel-media-container.vala"
		flags |= (GUPNP_OCM_FLAGS_UPLOAD | GUPNP_OCM_FLAGS_UPLOAD_DESTROYABLE) | GUPNP_OCM_FLAGS_CREATE_CONTAINER;
#line 2091 "rygel-media-container.c"
	}
#line 247 "../src/librygel-server/rygel-media-container.vala"
	allow_deletion = TRUE;
#line 2095 "rygel-media-container.c"
	{
		gboolean _tmp8_ = FALSE;
		RygelMetaConfig* _tmp9_;
#line 249 "../src/librygel-server/rygel-media-container.vala"
		_tmp9_ = config;
#line 249 "../src/librygel-server/rygel-media-container.vala"
		_tmp8_ = rygel_configuration_get_allow_deletion ((RygelConfiguration*) _tmp9_, &_inner_error0_);
#line 249 "../src/librygel-server/rygel-media-container.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2105 "rygel-media-container.c"
			goto __catch1_g_error;
		}
#line 249 "../src/librygel-server/rygel-media-container.vala"
		allow_deletion = _tmp8_;
#line 2110 "rygel-media-container.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 248 "../src/librygel-server/rygel-media-container.vala"
		g_clear_error (&_inner_error0_);
#line 2117 "rygel-media-container.c"
	}
	__finally1:
#line 248 "../src/librygel-server/rygel-media-container.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/librygel-server/rygel-media-container.vala"
		_g_object_unref0 (config);
#line 248 "../src/librygel-server/rygel-media-container.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 248 "../src/librygel-server/rygel-media-container.vala"
		g_clear_error (&_inner_error0_);
#line 248 "../src/librygel-server/rygel-media-container.vala"
		return 0U;
#line 2130 "rygel-media-container.c"
	}
#line 252 "../src/librygel-server/rygel-media-container.vala"
	if (allow_deletion) {
#line 253 "../src/librygel-server/rygel-media-container.vala"
		flags |= GUPNP_OCM_FLAGS_DESTROYABLE;
#line 2136 "rygel-media-container.c"
	}
#line 256 "../src/librygel-server/rygel-media-container.vala"
	if (RYGEL_IS_UPDATABLE_OBJECT (self)) {
#line 257 "../src/librygel-server/rygel-media-container.vala"
		flags |= GUPNP_OCM_FLAGS_CHANGE_METADATA;
#line 2142 "rygel-media-container.c"
	}
#line 260 "../src/librygel-server/rygel-media-container.vala"
	result = flags;
#line 260 "../src/librygel-server/rygel-media-container.vala"
	_g_object_unref0 (config);
#line 260 "../src/librygel-server/rygel-media-container.vala"
	return result;
#line 2150 "rygel-media-container.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM_BOOLEAN (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_ENUM_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gboolean arg_4, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_ENUM_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	g_return_if_fail (n_param_values == 5);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "../src/librygel-server/rygel-media-container.vala"
		data1 = closure->data;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		data2 = param_values->data[0].v_pointer;
#line 2175 "rygel-media-container.c"
	} else {
#line 158 "../src/librygel-server/rygel-media-container.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		data2 = closure->data;
#line 2181 "rygel-media-container.c"
	}
#line 158 "../src/librygel-server/rygel-media-container.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_ENUM_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_enum (param_values + 3), g_value_get_boolean (param_values + 4), data2);
#line 2187 "rygel-media-container.c"
}

static void
rygel_media_container_class_init (RygelMediaContainerClass * klass,
                                  gpointer klass_data)
{
#line 158 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_parent_class = g_type_class_peek_parent (klass);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	g_type_class_adjust_private_offset (klass, &RygelMediaContainer_private_offset);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_media_container_real_constructed;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	((RygelMediaObjectClass *) klass)->serialize = (GUPnPDIDLLiteObject* (*) (RygelMediaObject*, RygelSerializer*, RygelHTTPServer*, GError**)) rygel_media_container_real_serialize;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	((RygelMediaObjectClass *) klass)->create_stream_source_for_resource = (RygelDataSource* (*) (RygelMediaObject*, RygelHTTPRequest*, RygelMediaResource*, GError**)) rygel_media_container_real_create_stream_source_for_resource;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	RYGEL_MEDIA_OBJECT_CLASS (klass)->get_ocm_flags = (GUPnPOCMFlags (*) (RygelMediaObject*)) rygel_media_container_real_get_ocm_flags;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_media_container_get_property;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_media_container_set_property;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_media_container_finalize;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_CONTAINER_CHILD_COUNT_PROPERTY, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_CHILD_COUNT_PROPERTY] = g_param_spec_int ("child-count", "child-count", "child-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 158 "../src/librygel-server/rygel-media-container.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_CONTAINER_EMPTY_CHILD_COUNT_PROPERTY, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_EMPTY_CHILD_COUNT_PROPERTY] = g_param_spec_int ("empty-child-count", "empty-child-count", "empty-child-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 158 "../src/librygel-server/rygel-media-container.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_CONTAINER_ALL_CHILD_COUNT_PROPERTY, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_ALL_CHILD_COUNT_PROPERTY] = g_param_spec_int ("all-child-count", "all-child-count", "all-child-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 158 "../src/librygel-server/rygel-media-container.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_CONTAINER_CREATE_MODE_ENABLED_PROPERTY, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_CREATE_MODE_ENABLED_PROPERTY] = g_param_spec_boolean ("create-mode-enabled", "create-mode-enabled", "create-mode-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 158 "../src/librygel-server/rygel-media-container.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_CONTAINER_SORT_CRITERIA_PROPERTY, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_SORT_CRITERIA_PROPERTY] = g_param_spec_string ("sort-criteria", "sort-criteria", "sort-criteria", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 158 "../src/librygel-server/rygel-media-container.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_CONTAINER_OCM_FLAGS_PROPERTY, rygel_media_container_properties[RYGEL_MEDIA_CONTAINER_OCM_FLAGS_PROPERTY] = g_param_spec_flags ("ocm-flags", "ocm-flags", "ocm-flags", gupnp_ocm_flags_get_type (), 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2224 "rygel-media-container.c"
	/**
	     * The container_updated signal is emitted if the subtree unter this
	     * container has been modified. The object parameter is set to
	     * the MediaObject that is the source of the container update. Note that
	     * it may even be set to the container itself.
	     *
	     * @see rygel_media_container_updated().
	     *
	     * @param container The child container that has been updated.
	     * @param object The object that has changed. This may be the container itself, or a child item.
	     * @param event_type This describes what actually happened to the object.
	     * @param sub_tree_update Whether the modification is part of a sub-tree update. See the #RygelMediaContainer::sub_tree_updates_finished signal.
	     */
#line 158 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_signals[RYGEL_MEDIA_CONTAINER_CONTAINER_UPDATED_SIGNAL] = g_signal_new ("container-updated", RYGEL_TYPE_MEDIA_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM_BOOLEAN, G_TYPE_NONE, 4, RYGEL_TYPE_MEDIA_CONTAINER, RYGEL_TYPE_MEDIA_OBJECT, RYGEL_TYPE_OBJECT_EVENT_TYPE, G_TYPE_BOOLEAN);
#line 2240 "rygel-media-container.c"
	/**
	     * The sub_tree_updates_finished signal is emitted when all of
	     * the sub-tree operations are finished.
	     * See the #RygelMediaContainer::container_updated signal.
	     *
	     * @param sub_tree_root - root of a sub-tree where all operations
	     * were performed.
	     */
#line 158 "../src/librygel-server/rygel-media-container.vala"
	rygel_media_container_signals[RYGEL_MEDIA_CONTAINER_SUB_TREE_UPDATES_FINISHED_SIGNAL] = g_signal_new ("sub-tree-updates-finished", RYGEL_TYPE_MEDIA_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, RYGEL_TYPE_MEDIA_OBJECT);
#line 2251 "rygel-media-container.c"
}

static void
rygel_media_container_instance_init (RygelMediaContainer * self,
                                     gpointer klass)
{
	gchar* _tmp0_;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	self->priv = rygel_media_container_get_instance_private (self);
#line 225 "../src/librygel-server/rygel-media-container.vala"
	_tmp0_ = g_strdup (RYGEL_MEDIA_CONTAINER_DEFAULT_SORT_CRITERIA);
#line 225 "../src/librygel-server/rygel-media-container.vala"
	self->priv->_sort_criteria = _tmp0_;
#line 2265 "rygel-media-container.c"
}

static void
rygel_media_container_finalize (GObject * obj)
{
	RygelMediaContainer * self;
#line 158 "../src/librygel-server/rygel-media-container.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_MEDIA_CONTAINER, RygelMediaContainer);
#line 225 "../src/librygel-server/rygel-media-container.vala"
	_g_free0 (self->priv->_sort_criteria);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	G_OBJECT_CLASS (rygel_media_container_parent_class)->finalize (obj);
#line 2278 "rygel-media-container.c"
}

/**
 * This is a container (folder) for media items and child containers.
 *
 * It provides a basic serialization implementation (to DIDLLiteWriter).
 *
 * A derived class should provide a working implementation of get_children
 * and should emit the container_updated signal.
 *
 * When used as a root container, you may wish to use the variables, such as
 * REALNAME, in in the title. See the title property of the #RygelMediaObject.
 *
 * If the container should support UPnP search operations then you also implement
 * the #RygelSearchableContainer interface.
 *
 * If the container should be writable, meaning that it allows adding (via upload),
 * removal and editing of items then you should also implement the #RygelWritableContainer
 * interface.
 *
 * If the container should support the change tracking profile of the UPnP
 * ContentDirectory:3 specification then you should also implement the
 * #RygelTrackableContainer interface.
 *
 * The #RygelSimpleContainer class contains a simple memory-based container
 * implementation, but most real-world uses will require custom container
 * implementations.
 */
 G_GNUC_NO_INLINE static GType
rygel_media_container_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelMediaContainerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_container_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaContainer), 0, (GInstanceInitFunc) rygel_media_container_instance_init, NULL };
	GType rygel_media_container_type_id;
	rygel_media_container_type_id = g_type_register_static (RYGEL_TYPE_MEDIA_OBJECT, "RygelMediaContainer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	RygelMediaContainer_private_offset = g_type_add_instance_private (rygel_media_container_type_id, sizeof (RygelMediaContainerPrivate));
	return rygel_media_container_type_id;
}

GType
rygel_media_container_get_type (void)
{
	static volatile gsize rygel_media_container_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_container_type_id__once)) {
		GType rygel_media_container_type_id;
		rygel_media_container_type_id = rygel_media_container_get_type_once ();
		g_once_init_leave (&rygel_media_container_type_id__once, rygel_media_container_type_id);
	}
	return rygel_media_container_type_id__once;
}

static void
_vala_rygel_media_container_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	RygelMediaContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MEDIA_CONTAINER, RygelMediaContainer);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	switch (property_id) {
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_CHILD_COUNT_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		g_value_set_int (value, rygel_media_container_get_child_count (self));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_EMPTY_CHILD_COUNT_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		g_value_set_int (value, rygel_media_container_get_empty_child_count (self));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_ALL_CHILD_COUNT_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		g_value_set_int (value, rygel_media_container_get_all_child_count (self));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_CREATE_MODE_ENABLED_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		g_value_set_boolean (value, rygel_media_container_get_create_mode_enabled (self));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_SORT_CRITERIA_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		g_value_set_string (value, rygel_media_container_get_sort_criteria (self));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_OCM_FLAGS_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		g_value_set_flags (value, rygel_media_object_get_ocm_flags ((RygelMediaObject*) self));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 2375 "rygel-media-container.c"
		default:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 2381 "rygel-media-container.c"
	}
}

static void
_vala_rygel_media_container_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	RygelMediaContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MEDIA_CONTAINER, RygelMediaContainer);
#line 158 "../src/librygel-server/rygel-media-container.vala"
	switch (property_id) {
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_CHILD_COUNT_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_container_set_child_count (self, g_value_get_int (value));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_EMPTY_CHILD_COUNT_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_container_set_empty_child_count (self, g_value_get_int (value));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_CREATE_MODE_ENABLED_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_container_set_create_mode_enabled (self, g_value_get_boolean (value));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 158 "../src/librygel-server/rygel-media-container.vala"
		case RYGEL_MEDIA_CONTAINER_SORT_CRITERIA_PROPERTY:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		rygel_media_container_set_sort_criteria (self, g_value_get_string (value));
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 2419 "rygel-media-container.c"
		default:
#line 158 "../src/librygel-server/rygel-media-container.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "../src/librygel-server/rygel-media-container.vala"
		break;
#line 2425 "rygel-media-container.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

