/* rygel-media-file-item.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-media-file-item.vala, do not modify */

/*
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 * Copyright (C) 2010 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Doug Galligan <doug@sentosatech.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib.h>
#include <glib-object.h>
#include "rygel-server.h"
#include <stdlib.h>
#include <string.h>
#include <libgupnp-av/gupnp-av.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include "rygel-core.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_MEDIA_FILE_ITEM_ERROR (rygel_media_file_item_error_get_type ())
enum  {
	RYGEL_MEDIA_FILE_ITEM_0_PROPERTY,
	RYGEL_MEDIA_FILE_ITEM_MIME_TYPE_PROPERTY,
	RYGEL_MEDIA_FILE_ITEM_DLNA_PROFILE_PROPERTY,
	RYGEL_MEDIA_FILE_ITEM_SIZE_PROPERTY,
	RYGEL_MEDIA_FILE_ITEM_PLACE_HOLDER_PROPERTY,
	RYGEL_MEDIA_FILE_ITEM_OCM_FLAGS_PROPERTY,
	RYGEL_MEDIA_FILE_ITEM_NUM_PROPERTIES
};
static GParamSpec* rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
typedef struct _RygelMediaFileItemAddEngineResourcesData RygelMediaFileItemAddEngineResourcesData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

typedef enum  {
	RYGEL_MEDIA_FILE_ITEM_ERROR_BAD_URI
} RygelMediaFileItemError;
#define RYGEL_MEDIA_FILE_ITEM_ERROR rygel_media_file_item_error_quark ()

struct _RygelMediaFileItemPrivate {
	gchar* _mime_type;
	gchar* _dlna_profile;
	gint64 _size;
	gboolean _place_holder;
};

struct _RygelMediaFileItemAddEngineResourcesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelMediaFileItem* self;
	RygelMediaEngine* media_engine;
	RygelMediaEngine* _tmp0_;
	GeeList* added_resources;
	RygelMediaEngine* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GeeList* _resource_list;
	GeeList* _tmp8_;
	gint _resource_size;
	GeeList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _resource_index;
	gint _tmp12_;
	gint _tmp13_;
	RygelMediaResource* resource;
	GeeList* _tmp14_;
	gpointer _tmp15_;
	RygelMediaResource* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GeeList* _tmp19_;
	GeeList* _tmp20_;
	GeeList* _tmp21_;
};

static gint RygelMediaFileItem_private_offset;
static gpointer rygel_media_file_item_parent_class = NULL;
GRegex* rygel_media_file_item_address_regex = NULL;
GeeHashMap* rygel_media_file_item_mime_to_ext = NULL;

VALA_EXTERN GQuark rygel_media_file_item_error_quark (void);
VALA_EXTERN GType rygel_media_file_item_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void rygel_media_file_item_add_additional_resources (RygelMediaFileItem* self,
                                                     RygelHTTPServer* server);
static RygelDataSource* rygel_media_file_item_real_create_stream_source_for_resource (RygelMediaObject* base,
                                                                               RygelHTTPRequest* request,
                                                                               RygelMediaResource* resource,
                                                                               GError** error);
static GUPnPDIDLLiteObject* rygel_media_file_item_real_serialize (RygelMediaObject* base,
                                                           RygelSerializer* serializer,
                                                           RygelHTTPServer* http_server,
                                                           GError** error);
static RygelMediaResource* rygel_media_file_item_real_get_primary_resource (RygelMediaFileItem* self);
VALA_EXTERN gchar* rygel_media_object_get_protocol_for_uri (RygelMediaObject* self,
                                                const gchar* uri,
                                                GError** error);
static gchar* rygel_media_file_item_real_get_extension (RygelMediaFileItem* self);
static void rygel_media_file_item_real_add_engine_resources_data_free (gpointer _data);
static void rygel_media_file_item_real_add_engine_resources (RygelMediaFileItem* self,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static gboolean rygel_media_file_item_real_add_engine_resources_co (RygelMediaFileItemAddEngineResourcesData* _data_);
static void rygel_media_file_item_add_engine_resources_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void rygel_media_file_item_real_add_additional_resources (RygelMediaFileItem* self,
                                                          RygelHTTPServer* server);
static void rygel_media_file_item_finalize (GObject * obj);
static GType rygel_media_file_item_get_type_once (void);
static void _vala_rygel_media_file_item_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_rygel_media_file_item_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
rygel_media_file_item_error_quark (void)
{
	return g_quark_from_static_string ("rygel-media-file-item-error-quark");
}

 G_GNUC_NO_INLINE static GType
rygel_media_file_item_error_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_MEDIA_FILE_ITEM_ERROR_BAD_URI, "RYGEL_MEDIA_FILE_ITEM_ERROR_BAD_URI", "bad-uri"}, {0, NULL, NULL}};
	GType rygel_media_file_item_error_type_id;
	rygel_media_file_item_error_type_id = g_enum_register_static ("RygelMediaFileItemError", values);
	return rygel_media_file_item_error_type_id;
}

GType
rygel_media_file_item_error_get_type (void)
{
	static volatile gsize rygel_media_file_item_error_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_file_item_error_type_id__once)) {
		GType rygel_media_file_item_error_type_id;
		rygel_media_file_item_error_type_id = rygel_media_file_item_error_get_type_once ();
		g_once_init_leave (&rygel_media_file_item_error_type_id__once, rygel_media_file_item_error_type_id);
	}
	return rygel_media_file_item_error_type_id__once;
}

static inline gpointer
rygel_media_file_item_get_instance_private (RygelMediaFileItem* self)
{
	return G_STRUCT_MEMBER_P (self, RygelMediaFileItem_private_offset);
}

RygelMediaFileItem*
rygel_media_file_item_construct (GType object_type,
                                 const gchar* id,
                                 RygelMediaContainer* parent,
                                 const gchar* title,
                                 const gchar* upnp_class)
{
	RygelMediaFileItem * self = NULL;
#line 107 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 107 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 107 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 107 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (upnp_class != NULL, NULL);
#line 111 "../src/librygel-server/rygel-media-file-item.vala"
	self = (RygelMediaFileItem*) g_object_new (object_type, "id", id, "parent", parent, "title", title, "upnp-class", upnp_class, NULL);
#line 107 "../src/librygel-server/rygel-media-file-item.vala"
	return self;
#line 223 "rygel-media-file-item.c"
}

static RygelDataSource*
rygel_media_file_item_real_create_stream_source_for_resource (RygelMediaObject* base,
                                                              RygelHTTPRequest* request,
                                                              RygelMediaResource* resource,
                                                              GError** error)
{
	RygelMediaFileItem * self;
	RygelDataSource* _tmp0_ = NULL;
	RygelMediaEngine* _tmp1_;
	RygelMediaEngine* _tmp2_;
	RygelHTTPServer* _tmp3_;
	GHashTable* _tmp4_;
	RygelDataSource* _tmp5_;
	RygelDataSource* _tmp6_;
	RygelDataSource* _tmp7_;
	GError* _inner_error0_ = NULL;
	RygelDataSource* result;
#line 127 "../src/librygel-server/rygel-media-file-item.vala"
	self = (RygelMediaFileItem*) base;
#line 127 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (request != NULL, NULL);
#line 127 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (resource != NULL, NULL);
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp1_ = rygel_media_engine_get_default ();
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp2_ = _tmp1_;
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp3_ = request->http_server;
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp4_ = _tmp3_->replacements;
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp5_ = rygel_media_engine_create_data_source_for_resource (_tmp2_, (RygelMediaObject*) self, resource, _tmp4_, &_inner_error0_);
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp6_ = _tmp5_;
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_g_object_unref0 (_tmp2_);
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = _tmp6_;
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
		g_propagate_error (error, _inner_error0_);
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
		return NULL;
#line 271 "rygel-media-file-item.c"
	}
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp7_ = _tmp0_;
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = NULL;
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	result = _tmp7_;
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	_g_object_unref0 (_tmp0_);
#line 131 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 283 "rygel-media-file-item.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 138 "../src/librygel-server/rygel-media-file-item.vala"
	return self ? g_object_ref (self) : NULL;
#line 291 "rygel-media-file-item.c"
}

static GUPnPDIDLLiteObject*
rygel_media_file_item_real_serialize (RygelMediaObject* base,
                                      RygelSerializer* serializer,
                                      RygelHTTPServer* http_server,
                                      GError** error)
{
	RygelMediaFileItem * self;
	GUPnPDIDLLiteObject* _tmp0_ = NULL;
	GUPnPDIDLLiteObject* _tmp1_;
	GUPnPDIDLLiteItem* didl_item = NULL;
	GUPnPDIDLLiteItem* _tmp2_;
	gboolean _tmp3_;
	GUPnPDIDLLiteItem* _tmp4_;
	GError* _inner_error0_ = NULL;
	GUPnPDIDLLiteObject* result;
#line 135 "../src/librygel-server/rygel-media-file-item.vala"
	self = (RygelMediaFileItem*) base;
#line 135 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (serializer != NULL, NULL);
#line 135 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (http_server != NULL, NULL);
#line 138 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp1_ = RYGEL_MEDIA_OBJECT_CLASS (rygel_media_file_item_parent_class)->serialize ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_MEDIA_ITEM, RygelMediaItem), serializer, http_server, &_inner_error0_);
#line 138 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = _tmp1_;
#line 138 "../src/librygel-server/rygel-media-file-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../src/librygel-server/rygel-media-file-item.vala"
		g_propagate_error (error, _inner_error0_);
#line 138 "../src/librygel-server/rygel-media-file-item.vala"
		return NULL;
#line 325 "rygel-media-file-item.c"
	}
#line 138 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gupnp_didl_lite_item_get_type ()) ? ((GUPnPDIDLLiteItem*) _tmp0_) : NULL);
#line 138 "../src/librygel-server/rygel-media-file-item.vala"
	didl_item = _tmp2_;
#line 140 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp3_ = self->priv->_place_holder;
#line 140 "../src/librygel-server/rygel-media-file-item.vala"
	if (!_tmp3_) {
#line 146 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_file_item_add_additional_resources (self, http_server);
#line 337 "rygel-media-file-item.c"
	}
#line 148 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp4_ = didl_item;
#line 148 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_object_serialize_resource_list ((RygelMediaObject*) self, (GUPnPDIDLLiteObject*) _tmp4_, http_server, &_inner_error0_);
#line 148 "../src/librygel-server/rygel-media-file-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/librygel-server/rygel-media-file-item.vala"
		g_propagate_error (error, _inner_error0_);
#line 148 "../src/librygel-server/rygel-media-file-item.vala"
		_g_object_unref0 (didl_item);
#line 148 "../src/librygel-server/rygel-media-file-item.vala"
		_g_object_unref0 (_tmp0_);
#line 148 "../src/librygel-server/rygel-media-file-item.vala"
		return NULL;
#line 353 "rygel-media-file-item.c"
	}
#line 150 "../src/librygel-server/rygel-media-file-item.vala"
	result = (GUPnPDIDLLiteObject*) didl_item;
#line 150 "../src/librygel-server/rygel-media-file-item.vala"
	_g_object_unref0 (_tmp0_);
#line 150 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 361 "rygel-media-file-item.c"
}

/**
     * Subclasses override this method to create the type-specific primary
     * MediaResource.
     *
     * The resource returned is presumed to represent the "internal" file
     * resource and a uri referring to the source file. Transport-specific
     * variants can be created by the caller.
     *
     * @return a RygelMediaResource for the on-disk file represented by this
     * instance.
     */
static RygelMediaResource*
rygel_media_file_item_real_get_primary_resource (RygelMediaFileItem* self)
{
	RygelMediaResource* res = NULL;
	RygelMediaResource* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gint64 _tmp13_;
	gint64 _tmp14_;
	GError* _inner_error0_ = NULL;
	RygelMediaResource* result;
#line 165 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = rygel_media_resource_new ("primary");
#line 165 "../src/librygel-server/rygel-media-file-item.vala"
	res = _tmp0_;
#line 167 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp1_ = self->priv->_mime_type;
#line 167 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_resource_set_mime_type (res, _tmp1_);
#line 168 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp2_ = self->priv->_dlna_profile;
#line 168 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_resource_set_dlna_profile (res, _tmp2_);
#line 169 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_resource_set_dlna_flags (res, GUPNP_DLNA_FLAGS_BACKGROUND_TRANSFER_MODE);
#line 170 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_resource_set_dlna_operation (res, GUPNP_DLNA_OPERATION_RANGE);
#line 173 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp3_ = rygel_media_object_get_primary_uri ((RygelMediaObject*) self);
#line 173 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp4_ = _tmp3_;
#line 173 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_resource_set_uri (res, _tmp4_);
#line 173 "../src/librygel-server/rygel-media-file-item.vala"
	_g_free0 (_tmp4_);
#line 414 "rygel-media-file-item.c"
	{
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 175 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp6_ = rygel_media_resource_get_uri (res);
#line 175 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp7_ = _tmp6_;
#line 175 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp8_ = rygel_media_object_get_protocol_for_uri ((RygelMediaObject*) self, _tmp7_, &_inner_error0_);
#line 175 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp5_ = _tmp8_;
#line 175 "../src/librygel-server/rygel-media-file-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 430 "rygel-media-file-item.c"
			goto __catch0_g_error;
		}
#line 175 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_resource_set_protocol (res, _tmp5_);
#line 174 "../src/librygel-server/rygel-media-file-item.vala"
		_g_free0 (_tmp5_);
#line 437 "rygel-media-file-item.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 174 "../src/librygel-server/rygel-media-file-item.vala"
		g_clear_error (&_inner_error0_);
#line 177 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp9_ = rygel_media_resource_get_uri (res);
#line 177 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp10_ = _tmp9_;
#line 177 "../src/librygel-server/rygel-media-file-item.vala"
		g_warning (_ ("Could not determine protocol for URI %s"), _tmp10_);
#line 452 "rygel-media-file-item.c"
	}
	__finally0:
#line 174 "../src/librygel-server/rygel-media-file-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "../src/librygel-server/rygel-media-file-item.vala"
		_g_object_unref0 (res);
#line 174 "../src/librygel-server/rygel-media-file-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 174 "../src/librygel-server/rygel-media-file-item.vala"
		g_clear_error (&_inner_error0_);
#line 174 "../src/librygel-server/rygel-media-file-item.vala"
		return NULL;
#line 465 "rygel-media-file-item.c"
	}
#line 181 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp11_ = rygel_media_file_item_get_extension (self);
#line 181 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp12_ = _tmp11_;
#line 181 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_resource_set_extension (res, _tmp12_);
#line 181 "../src/librygel-server/rygel-media-file-item.vala"
	_g_free0 (_tmp12_);
#line 182 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp13_ = rygel_media_file_item_get_size (self);
#line 182 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp14_ = _tmp13_;
#line 182 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_resource_set_size (res, _tmp14_);
#line 184 "../src/librygel-server/rygel-media-file-item.vala"
	result = res;
#line 184 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 485 "rygel-media-file-item.c"
}

RygelMediaResource*
rygel_media_file_item_get_primary_resource (RygelMediaFileItem* self)
{
	RygelMediaFileItemClass* _klass_;
#line 164 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/librygel-server/rygel-media-file-item.vala"
	_klass_ = RYGEL_MEDIA_FILE_ITEM_GET_CLASS (self);
#line 164 "../src/librygel-server/rygel-media-file-item.vala"
	if (_klass_->get_primary_resource) {
#line 164 "../src/librygel-server/rygel-media-file-item.vala"
		return _klass_->get_primary_resource (self);
#line 500 "rygel-media-file-item.c"
	}
#line 164 "../src/librygel-server/rygel-media-file-item.vala"
	return NULL;
#line 504 "rygel-media-file-item.c"
}

/**
     * Return the file/uri extension that best represents the item's primary
     * resource.
     */
static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1195 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1195 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1197 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1197 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 532 "rygel-media-file-item.c"
		gchar* _tmp2_;
#line 1198 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1198 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1198 "glib-2.0.vapi"
		return result;
#line 540 "rygel-media-file-item.c"
	} else {
#line 1200 "glib-2.0.vapi"
		result = -1;
#line 1200 "glib-2.0.vapi"
		return result;
#line 546 "rygel-media-file-item.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 570 "rygel-media-file-item.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 579 "rygel-media-file-item.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 598 "rygel-media-file-item.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 602 "rygel-media-file-item.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 608 "rygel-media-file-item.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 618 "rygel-media-file-item.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 626 "rygel-media-file-item.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 630 "rygel-media-file-item.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 636 "rygel-media-file-item.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 646 "rygel-media-file-item.c"
}

static gchar*
rygel_media_file_item_real_get_extension (RygelMediaFileItem* self)
{
	gchar* uri_extension = NULL;
	const gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 192 "../src/librygel-server/rygel-media-file-item.vala"
	uri_extension = NULL;
#line 658 "rygel-media-file-item.c"
	{
		GUri* uri = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GUri* _tmp2_;
		GUri* _tmp3_;
		const gchar* _tmp4_;
#line 197 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp0_ = rygel_media_object_get_primary_uri ((RygelMediaObject*) self);
#line 197 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp1_ = _tmp0_;
#line 197 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp2_ = g_uri_parse (_tmp1_, G_URI_FLAGS_NONE, &_inner_error0_);
#line 197 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp3_ = _tmp2_;
#line 197 "../src/librygel-server/rygel-media-file-item.vala"
		_g_free0 (_tmp1_);
#line 197 "../src/librygel-server/rygel-media-file-item.vala"
		uri = _tmp3_;
#line 197 "../src/librygel-server/rygel-media-file-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 680 "rygel-media-file-item.c"
			goto __catch0_g_error;
		}
#line 198 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp4_ = g_uri_get_scheme (uri);
#line 198 "../src/librygel-server/rygel-media-file-item.vala"
		if (g_strcmp0 (_tmp4_, "file") == 0) {
#line 687 "rygel-media-file-item.c"
			gchar* basename = NULL;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gint dot_index = 0;
			const gchar* _tmp9_;
#line 199 "../src/librygel-server/rygel-media-file-item.vala"
			_tmp5_ = rygel_media_object_get_primary_uri ((RygelMediaObject*) self);
#line 199 "../src/librygel-server/rygel-media-file-item.vala"
			_tmp6_ = _tmp5_;
#line 199 "../src/librygel-server/rygel-media-file-item.vala"
			_tmp7_ = g_path_get_basename (_tmp6_);
#line 199 "../src/librygel-server/rygel-media-file-item.vala"
			_tmp8_ = _tmp7_;
#line 199 "../src/librygel-server/rygel-media-file-item.vala"
			_g_free0 (_tmp6_);
#line 199 "../src/librygel-server/rygel-media-file-item.vala"
			basename = _tmp8_;
#line 200 "../src/librygel-server/rygel-media-file-item.vala"
			dot_index = -1;
#line 201 "../src/librygel-server/rygel-media-file-item.vala"
			_tmp9_ = basename;
#line 201 "../src/librygel-server/rygel-media-file-item.vala"
			if (_tmp9_ != NULL) {
#line 713 "rygel-media-file-item.c"
				const gchar* _tmp10_;
#line 202 "../src/librygel-server/rygel-media-file-item.vala"
				_tmp10_ = basename;
#line 202 "../src/librygel-server/rygel-media-file-item.vala"
				dot_index = string_last_index_of (_tmp10_, ".", 0);
#line 203 "../src/librygel-server/rygel-media-file-item.vala"
				if (dot_index > -1) {
#line 721 "rygel-media-file-item.c"
					const gchar* _tmp11_;
					gchar* _tmp12_;
#line 204 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp11_ = basename;
#line 204 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp12_ = string_substring (_tmp11_, (glong) (dot_index + 1), (glong) -1);
#line 204 "../src/librygel-server/rygel-media-file-item.vala"
					_g_free0 (uri_extension);
#line 204 "../src/librygel-server/rygel-media-file-item.vala"
					uri_extension = _tmp12_;
#line 732 "rygel-media-file-item.c"
				}
			}
#line 198 "../src/librygel-server/rygel-media-file-item.vala"
			_g_free0 (basename);
#line 737 "rygel-media-file-item.c"
		} else {
			const gchar* _tmp13_;
#line 208 "../src/librygel-server/rygel-media-file-item.vala"
			_tmp13_ = g_uri_get_scheme (uri);
#line 208 "../src/librygel-server/rygel-media-file-item.vala"
			g_debug ("rygel-media-file-item.vala:208: Uri is not a file, but %s, skipping ex" \
"tension detection", _tmp13_);
#line 744 "rygel-media-file-item.c"
		}
#line 196 "../src/librygel-server/rygel-media-file-item.vala"
		_g_uri_unref0 (uri);
#line 748 "rygel-media-file-item.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 196 "../src/librygel-server/rygel-media-file-item.vala"
		g_clear_error (&_inner_error0_);
#line 211 "../src/librygel-server/rygel-media-file-item.vala"
		g_debug ("rygel-media-file-item.vala:211: Failed to parse primary uri, skipping " \
"extension detection");
#line 757 "rygel-media-file-item.c"
	}
	__finally0:
#line 196 "../src/librygel-server/rygel-media-file-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/librygel-server/rygel-media-file-item.vala"
		_g_free0 (uri_extension);
#line 196 "../src/librygel-server/rygel-media-file-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "../src/librygel-server/rygel-media-file-item.vala"
		g_clear_error (&_inner_error0_);
#line 196 "../src/librygel-server/rygel-media-file-item.vala"
		return NULL;
#line 770 "rygel-media-file-item.c"
	}
#line 214 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp14_ = uri_extension;
#line 214 "../src/librygel-server/rygel-media-file-item.vala"
	if (_tmp14_ == NULL) {
#line 776 "rygel-media-file-item.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 215 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp15_ = self->priv->_mime_type;
#line 215 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp16_ = rygel_media_file_item_ext_from_mime_type (self, _tmp15_);
#line 215 "../src/librygel-server/rygel-media-file-item.vala"
		_g_free0 (uri_extension);
#line 215 "../src/librygel-server/rygel-media-file-item.vala"
		uri_extension = _tmp16_;
#line 787 "rygel-media-file-item.c"
	}
#line 218 "../src/librygel-server/rygel-media-file-item.vala"
	result = uri_extension;
#line 218 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 793 "rygel-media-file-item.c"
}

gchar*
rygel_media_file_item_get_extension (RygelMediaFileItem* self)
{
	RygelMediaFileItemClass* _klass_;
#line 191 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../src/librygel-server/rygel-media-file-item.vala"
	_klass_ = RYGEL_MEDIA_FILE_ITEM_GET_CLASS (self);
#line 191 "../src/librygel-server/rygel-media-file-item.vala"
	if (_klass_->get_extension) {
#line 191 "../src/librygel-server/rygel-media-file-item.vala"
		return _klass_->get_extension (self);
#line 808 "rygel-media-file-item.c"
	}
#line 191 "../src/librygel-server/rygel-media-file-item.vala"
	return NULL;
#line 812 "rygel-media-file-item.c"
}

gchar*
rygel_media_file_item_ext_from_mime_type (RygelMediaFileItem* self,
                                          const gchar* mime_type)
{
	GeeHashMap* _tmp0_;
	gchar* short_mime = NULL;
	gchar** _tmp38_;
	gchar** _tmp39_;
	gchar** _tmp40_;
	gint _tmp40__length1;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GeeHashMap* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp49_;
	gchar* result;
#line 221 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 221 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 222 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = rygel_media_file_item_mime_to_ext;
#line 222 "../src/librygel-server/rygel-media-file-item.vala"
	if (_tmp0_ == NULL) {
#line 840 "rygel-media-file-item.c"
		GeeHashMap* _tmp1_;
		gchar** videos = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gint videos_length1;
		gint _videos_size_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		GeeHashMap* _tmp14_;
		GeeHashMap* _tmp15_;
		GeeHashMap* _tmp16_;
		GeeHashMap* _tmp17_;
		GeeHashMap* _tmp18_;
		GeeHashMap* _tmp19_;
		GeeHashMap* _tmp20_;
		GeeHashMap* _tmp21_;
		GeeHashMap* _tmp22_;
		GeeHashMap* _tmp23_;
		GeeHashMap* _tmp24_;
		gchar** images = NULL;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar** _tmp27_;
		gint images_length1;
		gint _images_size_;
		gchar** _tmp28_;
		gint _tmp28__length1;
		GeeHashMap* _tmp35_;
		GeeHashMap* _tmp36_;
		GeeHashMap* _tmp37_;
#line 224 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 224 "../src/librygel-server/rygel-media-file-item.vala"
		_g_object_unref0 (rygel_media_file_item_mime_to_ext);
#line 224 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_file_item_mime_to_ext = _tmp1_;
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp2_ = g_strdup ("mpeg");
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp3_ = g_strdup ("webm");
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp4_ = g_strdup ("ogg");
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp5_ = g_strdup ("mp4");
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp6_ = g_new0 (gchar*, 4 + 1);
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp6_[0] = _tmp2_;
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp6_[1] = _tmp3_;
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp6_[2] = _tmp4_;
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp6_[3] = _tmp5_;
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		videos = _tmp6_;
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		videos_length1 = 4;
#line 226 "../src/librygel-server/rygel-media-file-item.vala"
		_videos_size_ = videos_length1;
#line 228 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp7_ = videos;
#line 228 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp7__length1 = videos_length1;
#line 908 "rygel-media-file-item.c"
		{
			gchar** video_collection = NULL;
			gint video_collection_length1 = 0;
			gint _video_collection_size_ = 0;
			gint video_it = 0;
#line 228 "../src/librygel-server/rygel-media-file-item.vala"
			video_collection = _tmp7_;
#line 228 "../src/librygel-server/rygel-media-file-item.vala"
			video_collection_length1 = _tmp7__length1;
#line 228 "../src/librygel-server/rygel-media-file-item.vala"
			for (video_it = 0; video_it < video_collection_length1; video_it = video_it + 1) {
#line 920 "rygel-media-file-item.c"
				gchar* _tmp8_;
				gchar* video = NULL;
#line 228 "../src/librygel-server/rygel-media-file-item.vala"
				_tmp8_ = g_strdup (video_collection[video_it]);
#line 228 "../src/librygel-server/rygel-media-file-item.vala"
				video = _tmp8_;
#line 927 "rygel-media-file-item.c"
				{
					GeeHashMap* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					const gchar* _tmp13_;
#line 229 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp9_ = rygel_media_file_item_mime_to_ext;
#line 229 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp10_ = video;
#line 229 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp11_ = g_strconcat ("video/", _tmp10_, NULL);
#line 229 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp12_ = _tmp11_;
#line 229 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp13_ = video;
#line 229 "../src/librygel-server/rygel-media-file-item.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp12_, _tmp13_);
#line 229 "../src/librygel-server/rygel-media-file-item.vala"
					_g_free0 (_tmp12_);
#line 228 "../src/librygel-server/rygel-media-file-item.vala"
					_g_free0 (video);
#line 950 "rygel-media-file-item.c"
				}
			}
		}
#line 231 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp14_ = rygel_media_file_item_mime_to_ext;
#line 231 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, "video/x-matroska", "mkv");
#line 232 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp15_ = rygel_media_file_item_mime_to_ext;
#line 232 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, "video/x-mkv", "mkv");
#line 235 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp16_ = rygel_media_file_item_mime_to_ext;
#line 235 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, "audio/x-wav", "wav");
#line 236 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp17_ = rygel_media_file_item_mime_to_ext;
#line 236 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, "audio/x-matroska", "mka");
#line 237 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp18_ = rygel_media_file_item_mime_to_ext;
#line 237 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, "audio/x-mkv", "mka");
#line 238 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp19_ = rygel_media_file_item_mime_to_ext;
#line 238 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, "audio/x-mka", "mka");
#line 239 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp20_ = rygel_media_file_item_mime_to_ext;
#line 239 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp20_, "audio/L16", "lpcm");
#line 240 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp21_ = rygel_media_file_item_mime_to_ext;
#line 240 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, "audio/vnd.dlna.adts", "adts");
#line 241 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp22_ = rygel_media_file_item_mime_to_ext;
#line 241 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, "audio/mpeg", "mp3");
#line 242 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp23_ = rygel_media_file_item_mime_to_ext;
#line 242 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, "audio/3gpp", "3gp");
#line 243 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp24_ = rygel_media_file_item_mime_to_ext;
#line 243 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp24_, "audio/flac", "flac");
#line 246 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp25_ = g_strdup ("jpeg");
#line 246 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp26_ = g_strdup ("png");
#line 246 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp27_ = g_new0 (gchar*, 2 + 1);
#line 246 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp27_[0] = _tmp25_;
#line 246 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp27_[1] = _tmp26_;
#line 246 "../src/librygel-server/rygel-media-file-item.vala"
		images = _tmp27_;
#line 246 "../src/librygel-server/rygel-media-file-item.vala"
		images_length1 = 2;
#line 246 "../src/librygel-server/rygel-media-file-item.vala"
		_images_size_ = images_length1;
#line 248 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp28_ = images;
#line 248 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp28__length1 = images_length1;
#line 1018 "rygel-media-file-item.c"
		{
			gchar** image_collection = NULL;
			gint image_collection_length1 = 0;
			gint _image_collection_size_ = 0;
			gint image_it = 0;
#line 248 "../src/librygel-server/rygel-media-file-item.vala"
			image_collection = _tmp28_;
#line 248 "../src/librygel-server/rygel-media-file-item.vala"
			image_collection_length1 = _tmp28__length1;
#line 248 "../src/librygel-server/rygel-media-file-item.vala"
			for (image_it = 0; image_it < image_collection_length1; image_it = image_it + 1) {
#line 1030 "rygel-media-file-item.c"
				gchar* _tmp29_;
				gchar* image = NULL;
#line 248 "../src/librygel-server/rygel-media-file-item.vala"
				_tmp29_ = g_strdup (image_collection[image_it]);
#line 248 "../src/librygel-server/rygel-media-file-item.vala"
				image = _tmp29_;
#line 1037 "rygel-media-file-item.c"
				{
					GeeHashMap* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					const gchar* _tmp34_;
#line 249 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp30_ = rygel_media_file_item_mime_to_ext;
#line 249 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp31_ = image;
#line 249 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp32_ = g_strconcat ("image/", _tmp31_, NULL);
#line 249 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp33_ = _tmp32_;
#line 249 "../src/librygel-server/rygel-media-file-item.vala"
					_tmp34_ = image;
#line 249 "../src/librygel-server/rygel-media-file-item.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp33_, _tmp34_);
#line 249 "../src/librygel-server/rygel-media-file-item.vala"
					_g_free0 (_tmp33_);
#line 248 "../src/librygel-server/rygel-media-file-item.vala"
					_g_free0 (image);
#line 1060 "rygel-media-file-item.c"
				}
			}
		}
#line 253 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp35_ = rygel_media_file_item_mime_to_ext;
#line 253 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp35_, "text/srt", "srt");
#line 254 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp36_ = rygel_media_file_item_mime_to_ext;
#line 254 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp36_, "text/xml", "xml");
#line 257 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp37_ = rygel_media_file_item_mime_to_ext;
#line 257 "../src/librygel-server/rygel-media-file-item.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp37_, "application/ogg", "ogg");
#line 222 "../src/librygel-server/rygel-media-file-item.vala"
		images = (_vala_array_free (images, images_length1, (GDestroyNotify) g_free), NULL);
#line 222 "../src/librygel-server/rygel-media-file-item.vala"
		videos = (_vala_array_free (videos, videos_length1, (GDestroyNotify) g_free), NULL);
#line 1080 "rygel-media-file-item.c"
	}
#line 261 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp39_ = _tmp38_ = g_strsplit (mime_type, ";", 0);
#line 261 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp40_ = _tmp39_;
#line 261 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp40__length1 = _vala_array_length (_tmp38_);
#line 261 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp41_ = _tmp40_[0];
#line 261 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp42_ = g_strdup (_tmp41_);
#line 261 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp43_ = _tmp42_;
#line 261 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp40_ = (_vala_array_free (_tmp40_, _tmp40__length1, (GDestroyNotify) g_free), NULL);
#line 261 "../src/librygel-server/rygel-media-file-item.vala"
	short_mime = _tmp43_;
#line 263 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp44_ = rygel_media_file_item_mime_to_ext;
#line 263 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp45_ = short_mime;
#line 263 "../src/librygel-server/rygel-media-file-item.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp44_, _tmp45_)) {
#line 1104 "rygel-media-file-item.c"
		GeeHashMap* _tmp46_;
		const gchar* _tmp47_;
		gpointer _tmp48_;
#line 264 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp46_ = rygel_media_file_item_mime_to_ext;
#line 264 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp47_ = short_mime;
#line 264 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp48_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, _tmp47_);
#line 264 "../src/librygel-server/rygel-media-file-item.vala"
		result = (gchar*) _tmp48_;
#line 264 "../src/librygel-server/rygel-media-file-item.vala"
		_g_free0 (short_mime);
#line 264 "../src/librygel-server/rygel-media-file-item.vala"
		return result;
#line 1120 "rygel-media-file-item.c"
	}
#line 267 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp49_ = g_strdup ("");
#line 267 "../src/librygel-server/rygel-media-file-item.vala"
	result = _tmp49_;
#line 267 "../src/librygel-server/rygel-media-file-item.vala"
	_g_free0 (short_mime);
#line 267 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 1130 "rygel-media-file-item.c"
}

static void
rygel_media_file_item_real_add_engine_resources_data_free (gpointer _data)
{
	RygelMediaFileItemAddEngineResourcesData* _data_;
	_data_ = _data;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	_g_object_unref0 (_data_->self);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	g_slice_free (RygelMediaFileItemAddEngineResourcesData, _data_);
#line 1142 "rygel-media-file-item.c"
}

static void
rygel_media_file_item_real_add_engine_resources (RygelMediaFileItem* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	RygelMediaFileItemAddEngineResourcesData* _data_;
	RygelMediaFileItem* _tmp0_;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	_data_ = g_slice_new0 (RygelMediaFileItemAddEngineResourcesData);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_media_file_item_real_add_engine_resources_data_free);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->self = _tmp0_;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_file_item_real_add_engine_resources_co (_data_);
#line 1164 "rygel-media-file-item.c"
}

static void
rygel_media_file_item_real_add_engine_resources_finish (RygelMediaFileItem* self,
                                                        GAsyncResult* _res_)
{
	RygelMediaFileItemAddEngineResourcesData* _data_;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1174 "rygel-media-file-item.c"
}

/**
     * Request the media engine for the resources it can provide for this
     * item. Typically these are the transcoded resources.
     */
static void
rygel_media_file_item_add_engine_resources_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	RygelMediaFileItemAddEngineResourcesData* _data_;
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	_data_ = _user_data_;
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_source_object_ = source_object;
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_res_ = _res_;
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_file_item_real_add_engine_resources_co (_data_);
#line 1195 "rygel-media-file-item.c"
}

static gboolean
rygel_media_file_item_real_add_engine_resources_co (RygelMediaFileItemAddEngineResourcesData* _data_)
{
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
	switch (_data_->_state_) {
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
		case 0:
#line 1205 "rygel-media-file-item.c"
		goto _state_0;
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
		case 1:
#line 1209 "rygel-media-file-item.c"
		goto _state_1;
		default:
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
		g_assert_not_reached ();
#line 1214 "rygel-media-file-item.c"
	}
	_state_0:
#line 275 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp0_ = rygel_media_engine_get_default ();
#line 275 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->media_engine = _data_->_tmp0_;
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp1_ = _data_->media_engine;
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_state_ = 1;
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_engine_get_resources_for_item (_data_->_tmp1_, (RygelMediaObject*) _data_->self, rygel_media_file_item_add_engine_resources_ready, _data_);
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	return FALSE;
#line 1229 "rygel-media-file-item.c"
	_state_1:
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp2_ = rygel_media_engine_get_resources_for_item_finish (_data_->_tmp1_, _data_->_res_);
#line 276 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->added_resources = _data_->_tmp2_;
#line 277 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp3_ = _data_->added_resources;
#line 277 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp4_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp3_);
#line 277 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 277 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp6_ = rygel_media_object_get_primary_uri ((RygelMediaObject*) _data_->self);
#line 277 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 277 "../src/librygel-server/rygel-media-file-item.vala"
	g_debug ("rygel-media-file-item.vala:277: Adding %d resources to item source %s:", _data_->_tmp5_, _data_->_tmp7_);
#line 277 "../src/librygel-server/rygel-media-file-item.vala"
	_g_free0 (_data_->_tmp7_);
#line 1249 "rygel-media-file-item.c"
	{
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
		_data_->_tmp8_ = _data_->added_resources;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
		_data_->_resource_list = _data_->_tmp8_;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
		_data_->_tmp9_ = _data_->_resource_list;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
		_data_->_tmp10_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp9_);
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
		_data_->_resource_size = _data_->_tmp11_;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
		_data_->_resource_index = -1;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
		while (TRUE) {
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->_resource_index = _data_->_resource_index + 1;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->_tmp12_ = _data_->_resource_index;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->_tmp13_ = _data_->_resource_size;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
			if (!(_data_->_tmp12_ < _data_->_tmp13_)) {
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
				break;
#line 1277 "rygel-media-file-item.c"
			}
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->_tmp14_ = _data_->_resource_list;
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->_tmp15_ = gee_list_get (_data_->_tmp14_, _data_->_resource_index);
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->resource = (RygelMediaResource*) _data_->_tmp15_;
#line 282 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->_tmp16_ = _data_->resource;
#line 282 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->_tmp17_ = rygel_media_resource_get_name (_data_->_tmp16_);
#line 282 "../src/librygel-server/rygel-media-file-item.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 282 "../src/librygel-server/rygel-media-file-item.vala"
			g_debug ("rygel-media-file-item.vala:282:     %s", _data_->_tmp18_);
#line 282 "../src/librygel-server/rygel-media-file-item.vala"
			_g_free0 (_data_->_tmp18_);
#line 281 "../src/librygel-server/rygel-media-file-item.vala"
			_g_object_unref0 (_data_->resource);
#line 1297 "rygel-media-file-item.c"
		}
	}
#line 284 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp19_ = rygel_media_object_get_resource_list ((RygelMediaObject*) _data_->self);
#line 284 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 284 "../src/librygel-server/rygel-media-file-item.vala"
	_data_->_tmp21_ = _data_->added_resources;
#line 284 "../src/librygel-server/rygel-media-file-item.vala"
	gee_collection_add_all ((GeeCollection*) _data_->_tmp20_, (GeeCollection*) _data_->_tmp21_);
#line 284 "../src/librygel-server/rygel-media-file-item.vala"
	_g_object_unref0 (_data_->_tmp20_);
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
	_g_object_unref0 (_data_->added_resources);
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
	_g_object_unref0 (_data_->media_engine);
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
	if (_data_->_state_ != 0) {
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1322 "rygel-media-file-item.c"
		}
	}
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
	g_object_unref (_data_->_async_result);
#line 274 "../src/librygel-server/rygel-media-file-item.vala"
	return FALSE;
#line 1329 "rygel-media-file-item.c"
}

void
rygel_media_file_item_add_engine_resources (RygelMediaFileItem* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	RygelMediaFileItemClass* _klass_;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	_klass_ = RYGEL_MEDIA_FILE_ITEM_GET_CLASS (self);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	if (_klass_->add_engine_resources) {
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		_klass_->add_engine_resources (self, _callback_, _user_data_);
#line 1344 "rygel-media-file-item.c"
	}
}

void
rygel_media_file_item_add_engine_resources_finish (RygelMediaFileItem* self,
                                                   GAsyncResult* _res_)
{
	RygelMediaFileItemClass* _klass_;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	_klass_ = RYGEL_MEDIA_FILE_ITEM_GET_CLASS (self);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	if (_klass_->add_engine_resources_finish) {
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		_klass_->add_engine_resources_finish (self, _res_);
#line 1359 "rygel-media-file-item.c"
	}
}

/**
     * Subclasses can override this method to augment the MediaObject MediaResource
     * list with secondary MediaResource objects representing derivative resources.
     *
     * Note: Implementations should add both internal/file-based resources and HTTP-accessible
     *       resources to the MediaResource list.
     * FIXME: Will be renamed once we can safely remove old add_resources
     */
static void
rygel_media_file_item_real_add_additional_resources (RygelMediaFileItem* self,
                                                     RygelHTTPServer* server)
{
#line 295 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_if_fail (server != NULL);
#line 1377 "rygel-media-file-item.c"
}

void
rygel_media_file_item_add_additional_resources (RygelMediaFileItem* self,
                                                RygelHTTPServer* server)
{
	RygelMediaFileItemClass* _klass_;
#line 295 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_if_fail (self != NULL);
#line 295 "../src/librygel-server/rygel-media-file-item.vala"
	_klass_ = RYGEL_MEDIA_FILE_ITEM_GET_CLASS (self);
#line 295 "../src/librygel-server/rygel-media-file-item.vala"
	if (_klass_->add_additional_resources) {
#line 295 "../src/librygel-server/rygel-media-file-item.vala"
		_klass_->add_additional_resources (self, server);
#line 1393 "rygel-media-file-item.c"
	}
}

const gchar*
rygel_media_file_item_get_mime_type (RygelMediaFileItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = self->priv->_mime_type;
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
	result = _tmp0_;
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 1410 "rygel-media-file-item.c"
}

void
rygel_media_file_item_set_mime_type (RygelMediaFileItem* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
	old_value = rygel_media_file_item_get_mime_type (self);
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1424 "rygel-media-file-item.c"
		gchar* _tmp0_;
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp0_ = g_strdup (value);
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
		_g_free0 (self->priv->_mime_type);
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
		self->priv->_mime_type = _tmp0_;
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_MIME_TYPE_PROPERTY]);
#line 1434 "rygel-media-file-item.c"
	}
}

const gchar*
rygel_media_file_item_get_dlna_profile (RygelMediaFileItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = self->priv->_dlna_profile;
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
	result = _tmp0_;
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 1451 "rygel-media-file-item.c"
}

void
rygel_media_file_item_set_dlna_profile (RygelMediaFileItem* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
	old_value = rygel_media_file_item_get_dlna_profile (self);
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1465 "rygel-media-file-item.c"
		gchar* _tmp0_;
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
		_g_free0 (self->priv->_dlna_profile);
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
		self->priv->_dlna_profile = _tmp0_;
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_DLNA_PROFILE_PROPERTY]);
#line 1475 "rygel-media-file-item.c"
	}
}

gint64
rygel_media_file_item_get_size (RygelMediaFileItem* self)
{
	gint64 result;
#line 62 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 63 "../src/librygel-server/rygel-media-file-item.vala"
	result = self->priv->_size;
#line 63 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 1489 "rygel-media-file-item.c"
}

void
rygel_media_file_item_set_size (RygelMediaFileItem* self,
                                gint64 value)
{
#line 66 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/librygel-server/rygel-media-file-item.vala"
	if (value == ((gint64) 0)) {
#line 68 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_file_item_set_place_holder (self, TRUE);
#line 1502 "rygel-media-file-item.c"
	}
#line 71 "../src/librygel-server/rygel-media-file-item.vala"
	self->priv->_size = value;
#line 66 "../src/librygel-server/rygel-media-file-item.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_SIZE_PROPERTY]);
#line 1508 "rygel-media-file-item.c"
}

gboolean
rygel_media_file_item_get_place_holder (RygelMediaFileItem* self)
{
	gboolean result;
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
	result = self->priv->_place_holder;
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 1521 "rygel-media-file-item.c"
}

void
rygel_media_file_item_set_place_holder (RygelMediaFileItem* self,
                                        gboolean value)
{
	gboolean old_value;
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
	old_value = rygel_media_file_item_get_place_holder (self);
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
	if (old_value != value) {
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
		self->priv->_place_holder = value;
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_PLACE_HOLDER_PROPERTY]);
#line 1539 "rygel-media-file-item.c"
	}
}

static GUPnPOCMFlags
rygel_media_file_item_real_get_ocm_flags (RygelMediaObject* base)
{
	GUPnPOCMFlags result;
	RygelMediaFileItem* self;
	GUPnPOCMFlags flags = 0U;
	gboolean _tmp0_;
	GError* _inner_error0_ = NULL;
#line 78 "../src/librygel-server/rygel-media-file-item.vala"
	self = (RygelMediaFileItem*) base;
#line 79 "../src/librygel-server/rygel-media-file-item.vala"
	flags = GUPNP_OCM_FLAGS_NONE;
#line 81 "../src/librygel-server/rygel-media-file-item.vala"
	_tmp0_ = self->priv->_place_holder;
#line 81 "../src/librygel-server/rygel-media-file-item.vala"
	if (_tmp0_) {
#line 83 "../src/librygel-server/rygel-media-file-item.vala"
		flags |= GUPNP_OCM_FLAGS_DESTROYABLE;
#line 1561 "rygel-media-file-item.c"
	} else {
		RygelMetaConfig* config = NULL;
		RygelMetaConfig* _tmp1_;
		gboolean allow_deletion = FALSE;
#line 85 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp1_ = rygel_meta_config_get_default ();
#line 85 "../src/librygel-server/rygel-media-file-item.vala"
		config = _tmp1_;
#line 86 "../src/librygel-server/rygel-media-file-item.vala"
		allow_deletion = TRUE;
#line 1572 "rygel-media-file-item.c"
		{
			gboolean _tmp2_ = FALSE;
			RygelMetaConfig* _tmp3_;
#line 89 "../src/librygel-server/rygel-media-file-item.vala"
			_tmp3_ = config;
#line 89 "../src/librygel-server/rygel-media-file-item.vala"
			_tmp2_ = rygel_configuration_get_allow_deletion ((RygelConfiguration*) _tmp3_, &_inner_error0_);
#line 89 "../src/librygel-server/rygel-media-file-item.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1582 "rygel-media-file-item.c"
				goto __catch0_g_error;
			}
#line 89 "../src/librygel-server/rygel-media-file-item.vala"
			allow_deletion = _tmp2_;
#line 1587 "rygel-media-file-item.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 88 "../src/librygel-server/rygel-media-file-item.vala"
			g_clear_error (&_inner_error0_);
#line 1594 "rygel-media-file-item.c"
		}
		__finally0:
#line 88 "../src/librygel-server/rygel-media-file-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../src/librygel-server/rygel-media-file-item.vala"
			_g_object_unref0 (config);
#line 88 "../src/librygel-server/rygel-media-file-item.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "../src/librygel-server/rygel-media-file-item.vala"
			g_clear_error (&_inner_error0_);
#line 88 "../src/librygel-server/rygel-media-file-item.vala"
			return 0U;
#line 1607 "rygel-media-file-item.c"
		}
#line 92 "../src/librygel-server/rygel-media-file-item.vala"
		if (allow_deletion) {
#line 93 "../src/librygel-server/rygel-media-file-item.vala"
			flags |= GUPNP_OCM_FLAGS_DESTROYABLE;
#line 1613 "rygel-media-file-item.c"
		}
#line 81 "../src/librygel-server/rygel-media-file-item.vala"
		_g_object_unref0 (config);
#line 1617 "rygel-media-file-item.c"
	}
#line 97 "../src/librygel-server/rygel-media-file-item.vala"
	if (RYGEL_IS_UPDATABLE_OBJECT (self)) {
#line 98 "../src/librygel-server/rygel-media-file-item.vala"
		flags |= GUPNP_OCM_FLAGS_CHANGE_METADATA;
#line 1623 "rygel-media-file-item.c"
	}
#line 101 "../src/librygel-server/rygel-media-file-item.vala"
	result = flags;
#line 101 "../src/librygel-server/rygel-media-file-item.vala"
	return result;
#line 1629 "rygel-media-file-item.c"
}

static void
rygel_media_file_item_class_init (RygelMediaFileItemClass * klass,
                                  gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	rygel_media_file_item_parent_class = g_type_class_peek_parent (klass);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	g_type_class_adjust_private_offset (klass, &RygelMediaFileItem_private_offset);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	((RygelMediaObjectClass *) klass)->create_stream_source_for_resource = (RygelDataSource* (*) (RygelMediaObject*, RygelHTTPRequest*, RygelMediaResource*, GError**)) rygel_media_file_item_real_create_stream_source_for_resource;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	((RygelMediaObjectClass *) klass)->serialize = (GUPnPDIDLLiteObject* (*) (RygelMediaObject*, RygelSerializer*, RygelHTTPServer*, GError**)) rygel_media_file_item_real_serialize;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	((RygelMediaFileItemClass *) klass)->get_primary_resource = (RygelMediaResource* (*) (RygelMediaFileItem*)) rygel_media_file_item_real_get_primary_resource;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	((RygelMediaFileItemClass *) klass)->get_extension = (gchar* (*) (RygelMediaFileItem*)) rygel_media_file_item_real_get_extension;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	((RygelMediaFileItemClass *) klass)->add_engine_resources = (void (*) (RygelMediaFileItem*, GAsyncReadyCallback, gpointer)) rygel_media_file_item_real_add_engine_resources;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	((RygelMediaFileItemClass *) klass)->add_engine_resources_finish = (void (*) (RygelMediaFileItem*, GAsyncResult*)) rygel_media_file_item_real_add_engine_resources_finish;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	((RygelMediaFileItemClass *) klass)->add_additional_resources = (void (*) (RygelMediaFileItem*, RygelHTTPServer*)) rygel_media_file_item_real_add_additional_resources;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	RYGEL_MEDIA_OBJECT_CLASS (klass)->get_ocm_flags = (GUPnPOCMFlags (*) (RygelMediaObject*)) rygel_media_file_item_real_get_ocm_flags;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_media_file_item_get_property;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_media_file_item_set_property;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_media_file_item_finalize;
#line 1663 "rygel-media-file-item.c"
	/**
	     * The mime type of the source content (this.uri).
	     * A null/empty value means that the mime-type is unknown
	     */
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_FILE_ITEM_MIME_TYPE_PROPERTY, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_MIME_TYPE_PROPERTY] = g_param_spec_string ("mime-type", "mime-type", "mime-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1670 "rygel-media-file-item.c"
	/**
	     * The DLNA profile of the source content (this.uri).
	     * A null/empty value means that the DLNA profile is unknown
	     */
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_FILE_ITEM_DLNA_PROFILE_PROPERTY, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_DLNA_PROFILE_PROPERTY] = g_param_spec_string ("dlna-profile", "dlna-profile", "dlna-profile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_FILE_ITEM_SIZE_PROPERTY, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_SIZE_PROPERTY] = g_param_spec_int64 ("size", "size", "size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_FILE_ITEM_PLACE_HOLDER_PROPERTY, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_PLACE_HOLDER_PROPERTY] = g_param_spec_boolean ("place-holder", "place-holder", "place-holder", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_FILE_ITEM_OCM_FLAGS_PROPERTY, rygel_media_file_item_properties[RYGEL_MEDIA_FILE_ITEM_OCM_FLAGS_PROPERTY] = g_param_spec_flags ("ocm-flags", "ocm-flags", "ocm-flags", gupnp_ocm_flags_get_type (), 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1683 "rygel-media-file-item.c"
	{
		GRegex* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp1_ = g_regex_escape_string ("@ADDRESS@", -1);
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp2_ = _tmp1_;
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error0_);
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp4_ = _tmp3_;
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_g_free0 (_tmp2_);
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp0_ = _tmp4_;
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1707 "rygel-media-file-item.c"
				goto __catch0_g_regex_error;
			}
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
			g_clear_error (&_inner_error0_);
#line 1714 "rygel-media-file-item.c"
		}
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp5_ = _tmp0_;
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_tmp0_ = NULL;
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		_g_regex_unref0 (rygel_media_file_item_address_regex);
#line 121 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_file_item_address_regex = _tmp5_;
#line 120 "../src/librygel-server/rygel-media-file-item.vala"
		_g_regex_unref0 (_tmp0_);
#line 1726 "rygel-media-file-item.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 120 "../src/librygel-server/rygel-media-file-item.vala"
		g_clear_error (&_inner_error0_);
#line 123 "../src/librygel-server/rygel-media-file-item.vala"
		g_assert_not_reached ();
#line 1735 "rygel-media-file-item.c"
	}
	__finally0:
#line 120 "../src/librygel-server/rygel-media-file-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../src/librygel-server/rygel-media-file-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/librygel-server/rygel-media-file-item.vala"
		g_clear_error (&_inner_error0_);
#line 1744 "rygel-media-file-item.c"
	}
}

static void
rygel_media_file_item_instance_init (RygelMediaFileItem * self,
                                     gpointer klass)
{
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	self->priv = rygel_media_file_item_get_instance_private (self);
#line 60 "../src/librygel-server/rygel-media-file-item.vala"
	self->priv->_size = (gint64) -1;
#line 75 "../src/librygel-server/rygel-media-file-item.vala"
	self->priv->_place_holder = FALSE;
#line 1758 "rygel-media-file-item.c"
}

static void
rygel_media_file_item_finalize (GObject * obj)
{
	RygelMediaFileItem * self;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_MEDIA_FILE_ITEM, RygelMediaFileItem);
#line 48 "../src/librygel-server/rygel-media-file-item.vala"
	_g_free0 (self->priv->_mime_type);
#line 54 "../src/librygel-server/rygel-media-file-item.vala"
	_g_free0 (self->priv->_dlna_profile);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	G_OBJECT_CLASS (rygel_media_file_item_parent_class)->finalize (obj);
#line 1773 "rygel-media-file-item.c"
}

/**
 * Represents a file-accessible or http-accessible media item (music file,
 * image file, video file, etc) with some pre-established metadata or a
 * content placeholder for uploaded content.
 *
 * Items representing non-file-accessible content should create their own
 * MediaItem subclass.
 */
 G_GNUC_NO_INLINE static GType
rygel_media_file_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelMediaFileItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_file_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaFileItem), 0, (GInstanceInitFunc) rygel_media_file_item_instance_init, NULL };
	GType rygel_media_file_item_type_id;
	rygel_media_file_item_type_id = g_type_register_static (RYGEL_TYPE_MEDIA_ITEM, "RygelMediaFileItem", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	RygelMediaFileItem_private_offset = g_type_add_instance_private (rygel_media_file_item_type_id, sizeof (RygelMediaFileItemPrivate));
	return rygel_media_file_item_type_id;
}

GType
rygel_media_file_item_get_type (void)
{
	static volatile gsize rygel_media_file_item_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_file_item_type_id__once)) {
		GType rygel_media_file_item_type_id;
		rygel_media_file_item_type_id = rygel_media_file_item_get_type_once ();
		g_once_init_leave (&rygel_media_file_item_type_id__once, rygel_media_file_item_type_id);
	}
	return rygel_media_file_item_type_id__once;
}

static void
_vala_rygel_media_file_item_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	RygelMediaFileItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MEDIA_FILE_ITEM, RygelMediaFileItem);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	switch (property_id) {
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_MIME_TYPE_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		g_value_set_string (value, rygel_media_file_item_get_mime_type (self));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_DLNA_PROFILE_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		g_value_set_string (value, rygel_media_file_item_get_dlna_profile (self));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_SIZE_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		g_value_set_int64 (value, rygel_media_file_item_get_size (self));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_PLACE_HOLDER_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		g_value_set_boolean (value, rygel_media_file_item_get_place_holder (self));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_OCM_FLAGS_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		g_value_set_flags (value, rygel_media_object_get_ocm_flags ((RygelMediaObject*) self));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 1846 "rygel-media-file-item.c"
		default:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 1852 "rygel-media-file-item.c"
	}
}

static void
_vala_rygel_media_file_item_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	RygelMediaFileItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MEDIA_FILE_ITEM, RygelMediaFileItem);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
	switch (property_id) {
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_MIME_TYPE_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_file_item_set_mime_type (self, g_value_get_string (value));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_DLNA_PROFILE_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_file_item_set_dlna_profile (self, g_value_get_string (value));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_SIZE_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_file_item_set_size (self, g_value_get_int64 (value));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		case RYGEL_MEDIA_FILE_ITEM_PLACE_HOLDER_PROPERTY:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		rygel_media_file_item_set_place_holder (self, g_value_get_boolean (value));
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 1890 "rygel-media-file-item.c"
		default:
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 43 "../src/librygel-server/rygel-media-file-item.vala"
		break;
#line 1896 "rygel-media-file-item.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

