/* rygel-media-resource.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-media-resource.vala, do not modify */

/*
 * Copyright (C) 2013  Cable Television Laboratories, Inc.
 *
 * Author: Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <libgupnp-av/gupnp-av.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_MEDIA_RESOURCE_0_PROPERTY,
	RYGEL_MEDIA_RESOURCE_URI_PROPERTY,
	RYGEL_MEDIA_RESOURCE_IMPORT_URI_PROPERTY,
	RYGEL_MEDIA_RESOURCE_EXTENSION_PROPERTY,
	RYGEL_MEDIA_RESOURCE_SIZE_PROPERTY,
	RYGEL_MEDIA_RESOURCE_CLEARTEXT_SIZE_PROPERTY,
	RYGEL_MEDIA_RESOURCE_DURATION_PROPERTY,
	RYGEL_MEDIA_RESOURCE_BITRATE_PROPERTY,
	RYGEL_MEDIA_RESOURCE_BITS_PER_SAMPLE_PROPERTY,
	RYGEL_MEDIA_RESOURCE_COLOR_DEPTH_PROPERTY,
	RYGEL_MEDIA_RESOURCE_WIDTH_PROPERTY,
	RYGEL_MEDIA_RESOURCE_HEIGHT_PROPERTY,
	RYGEL_MEDIA_RESOURCE_AUDIO_CHANNELS_PROPERTY,
	RYGEL_MEDIA_RESOURCE_SAMPLE_FREQ_PROPERTY,
	RYGEL_MEDIA_RESOURCE_PROTOCOL_PROPERTY,
	RYGEL_MEDIA_RESOURCE_MIME_TYPE_PROPERTY,
	RYGEL_MEDIA_RESOURCE_DLNA_PROFILE_PROPERTY,
	RYGEL_MEDIA_RESOURCE_NETWORK_PROPERTY,
	RYGEL_MEDIA_RESOURCE_DLNA_CONVERSION_PROPERTY,
	RYGEL_MEDIA_RESOURCE_DLNA_FLAGS_PROPERTY,
	RYGEL_MEDIA_RESOURCE_DLNA_OPERATION_PROPERTY,
	RYGEL_MEDIA_RESOURCE_NUM_PROPERTIES
};
static GParamSpec* rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _RygelMediaResourcePrivate {
	gchar* name;
	gchar* _uri;
	gchar* _import_uri;
	gchar* _extension;
	gint64 _size;
	gint64 _cleartext_size;
	glong _duration;
	gint _bitrate;
	gint _bits_per_sample;
	gint _color_depth;
	gint _width;
	gint _height;
	gint _audio_channels;
	gint _sample_freq;
	gchar* _protocol;
	gchar* _mime_type;
	gchar* _dlna_profile;
	gchar* _network;
	GUPnPDLNAConversion _dlna_conversion;
	GUPnPDLNAFlags _dlna_flags;
	GUPnPDLNAOperation _dlna_operation;
};

static gint RygelMediaResource_private_offset;
static gpointer rygel_media_resource_parent_class = NULL;

static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
static void rygel_media_resource_finalize (GObject * obj);
static GType rygel_media_resource_get_type_once (void);
static void _vala_rygel_media_resource_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_rygel_media_resource_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rygel_media_resource_get_instance_private (RygelMediaResource* self)
{
	return G_STRUCT_MEMBER_P (self, RygelMediaResource_private_offset);
}

RygelMediaResource*
rygel_media_resource_construct (GType object_type,
                                const gchar* name)
{
	RygelMediaResource * self = NULL;
	gchar* _tmp0_;
#line 66 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 66 "../src/librygel-server/rygel-media-resource.vala"
	self = (RygelMediaResource*) g_object_new (object_type, NULL);
#line 67 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = g_strdup (name);
#line 67 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->name);
#line 67 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->name = _tmp0_;
#line 66 "../src/librygel-server/rygel-media-resource.vala"
	return self;
#line 149 "rygel-media-resource.c"
}

RygelMediaResource*
rygel_media_resource_new (const gchar* name)
{
#line 66 "../src/librygel-server/rygel-media-resource.vala"
	return rygel_media_resource_construct (RYGEL_TYPE_MEDIA_RESOURCE, name);
#line 157 "rygel-media-resource.c"
}

/**
     * Copy constructor
     */
static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	if (length >= 0) {
#line 169 "rygel-media-resource.c"
		gchar** result;
		gssize i;
#line 94 "../src/librygel-server/rygel-media-resource.vala"
		result = g_new0 (gchar*, length + 1);
#line 94 "../src/librygel-server/rygel-media-resource.vala"
		for (i = 0; i < length; i++) {
#line 176 "rygel-media-resource.c"
			gchar* _tmp0_;
#line 94 "../src/librygel-server/rygel-media-resource.vala"
			_tmp0_ = g_strdup (self[i]);
#line 94 "../src/librygel-server/rygel-media-resource.vala"
			result[i] = _tmp0_;
#line 182 "rygel-media-resource.c"
		}
#line 94 "../src/librygel-server/rygel-media-resource.vala"
		return result;
#line 186 "rygel-media-resource.c"
	}
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	return NULL;
#line 190 "rygel-media-resource.c"
}

RygelMediaResource*
rygel_media_resource_construct_from_resource (GType object_type,
                                              const gchar* name,
                                              RygelMediaResource* that)
{
	RygelMediaResource * self = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	glong _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GUPnPDLNAConversion _tmp20_;
	GUPnPDLNAFlags _tmp21_;
	GUPnPDLNAOperation _tmp22_;
#line 73 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 73 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (that != NULL, NULL);
#line 73 "../src/librygel-server/rygel-media-resource.vala"
	self = (RygelMediaResource*) g_object_new (object_type, NULL);
#line 74 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = g_strdup (name);
#line 74 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->name);
#line 74 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->name = _tmp0_;
#line 76 "../src/librygel-server/rygel-media-resource.vala"
	_tmp1_ = that->priv->_uri;
#line 76 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_uri (self, _tmp1_);
#line 77 "../src/librygel-server/rygel-media-resource.vala"
	_tmp2_ = that->priv->_import_uri;
#line 77 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_import_uri (self, _tmp2_);
#line 78 "../src/librygel-server/rygel-media-resource.vala"
	_tmp3_ = that->priv->_extension;
#line 78 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_extension (self, _tmp3_);
#line 79 "../src/librygel-server/rygel-media-resource.vala"
	_tmp4_ = that->priv->_size;
#line 79 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_size (self, _tmp4_);
#line 80 "../src/librygel-server/rygel-media-resource.vala"
	_tmp5_ = that->priv->_cleartext_size;
#line 80 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_cleartext_size (self, _tmp5_);
#line 81 "../src/librygel-server/rygel-media-resource.vala"
	_tmp6_ = that->priv->_duration;
#line 81 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_duration (self, _tmp6_);
#line 82 "../src/librygel-server/rygel-media-resource.vala"
	_tmp7_ = that->priv->_bitrate;
#line 82 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_bitrate (self, _tmp7_);
#line 83 "../src/librygel-server/rygel-media-resource.vala"
	_tmp8_ = that->priv->_bits_per_sample;
#line 83 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_bits_per_sample (self, _tmp8_);
#line 84 "../src/librygel-server/rygel-media-resource.vala"
	_tmp9_ = that->priv->_color_depth;
#line 84 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_color_depth (self, _tmp9_);
#line 85 "../src/librygel-server/rygel-media-resource.vala"
	_tmp10_ = that->priv->_width;
#line 85 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_width (self, _tmp10_);
#line 86 "../src/librygel-server/rygel-media-resource.vala"
	_tmp11_ = that->priv->_height;
#line 86 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_height (self, _tmp11_);
#line 87 "../src/librygel-server/rygel-media-resource.vala"
	_tmp12_ = that->priv->_audio_channels;
#line 87 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_audio_channels (self, _tmp12_);
#line 88 "../src/librygel-server/rygel-media-resource.vala"
	_tmp13_ = that->priv->_sample_freq;
#line 88 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_sample_freq (self, _tmp13_);
#line 90 "../src/librygel-server/rygel-media-resource.vala"
	_tmp14_ = that->priv->_protocol;
#line 90 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_protocol (self, _tmp14_);
#line 91 "../src/librygel-server/rygel-media-resource.vala"
	_tmp15_ = that->priv->_mime_type;
#line 91 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_mime_type (self, _tmp15_);
#line 92 "../src/librygel-server/rygel-media-resource.vala"
	_tmp16_ = that->priv->_dlna_profile;
#line 92 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_dlna_profile (self, _tmp16_);
#line 93 "../src/librygel-server/rygel-media-resource.vala"
	_tmp17_ = that->priv->_network;
#line 93 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_network (self, _tmp17_);
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	_tmp18_ = that->play_speeds;
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	_tmp18__length1 = that->play_speeds_length1;
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup2 (_tmp18_, _tmp18__length1) : _tmp18_;
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	_tmp19__length1 = _tmp18__length1;
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds = (_vala_array_free (self->play_speeds, self->play_speeds_length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds = _tmp19_;
#line 94 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds_length1 = _tmp19__length1;
#line 95 "../src/librygel-server/rygel-media-resource.vala"
	_tmp20_ = that->priv->_dlna_conversion;
#line 95 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_dlna_conversion (self, _tmp20_);
#line 96 "../src/librygel-server/rygel-media-resource.vala"
	_tmp21_ = that->priv->_dlna_flags;
#line 96 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_dlna_flags (self, _tmp21_);
#line 97 "../src/librygel-server/rygel-media-resource.vala"
	_tmp22_ = that->priv->_dlna_operation;
#line 97 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_dlna_operation (self, _tmp22_);
#line 73 "../src/librygel-server/rygel-media-resource.vala"
	return self;
#line 332 "rygel-media-resource.c"
}

RygelMediaResource*
rygel_media_resource_new_from_resource (const gchar* name,
                                        RygelMediaResource* that)
{
#line 73 "../src/librygel-server/rygel-media-resource.vala"
	return rygel_media_resource_construct_from_resource (RYGEL_TYPE_MEDIA_RESOURCE, name, that);
#line 341 "rygel-media-resource.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 124 "../src/librygel-server/rygel-media-resource.vala"
	if (length >= 0) {
#line 350 "rygel-media-resource.c"
		gchar** result;
		gssize i;
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		result = g_new0 (gchar*, length + 1);
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		for (i = 0; i < length; i++) {
#line 357 "rygel-media-resource.c"
			gchar* _tmp0_;
#line 124 "../src/librygel-server/rygel-media-resource.vala"
			_tmp0_ = g_strdup (self[i]);
#line 124 "../src/librygel-server/rygel-media-resource.vala"
			result[i] = _tmp0_;
#line 363 "rygel-media-resource.c"
		}
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		return result;
#line 367 "rygel-media-resource.c"
	}
#line 124 "../src/librygel-server/rygel-media-resource.vala"
	return NULL;
#line 371 "rygel-media-resource.c"
}

RygelMediaResource*
rygel_media_resource_construct_from_didl_lite_resource (GType object_type,
                                                        const gchar* name,
                                                        GUPnPDIDLLiteResource* didl_resource)
{
	RygelMediaResource * self = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	glong _tmp7_;
	glong _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	GUPnPProtocolInfo* _tmp23_;
	GUPnPProtocolInfo* _tmp24_;
#line 100 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 100 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (didl_resource != NULL, NULL);
#line 100 "../src/librygel-server/rygel-media-resource.vala"
	self = (RygelMediaResource*) g_object_new (object_type, NULL);
#line 105 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = g_strdup (name);
#line 105 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->name);
#line 105 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->name = _tmp0_;
#line 107 "../src/librygel-server/rygel-media-resource.vala"
	_tmp1_ = gupnp_didl_lite_resource_get_uri (didl_resource);
#line 107 "../src/librygel-server/rygel-media-resource.vala"
	_tmp2_ = _tmp1_;
#line 107 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_uri (self, _tmp2_);
#line 108 "../src/librygel-server/rygel-media-resource.vala"
	_tmp3_ = gupnp_didl_lite_resource_get_size64 (didl_resource);
#line 108 "../src/librygel-server/rygel-media-resource.vala"
	_tmp4_ = _tmp3_;
#line 108 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_size (self, _tmp4_);
#line 109 "../src/librygel-server/rygel-media-resource.vala"
	_tmp5_ = gupnp_didl_lite_resource_get_cleartext_size (didl_resource);
#line 109 "../src/librygel-server/rygel-media-resource.vala"
	_tmp6_ = _tmp5_;
#line 109 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_cleartext_size (self, _tmp6_);
#line 110 "../src/librygel-server/rygel-media-resource.vala"
	_tmp7_ = gupnp_didl_lite_resource_get_duration (didl_resource);
#line 110 "../src/librygel-server/rygel-media-resource.vala"
	_tmp8_ = _tmp7_;
#line 110 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_duration (self, _tmp8_);
#line 111 "../src/librygel-server/rygel-media-resource.vala"
	_tmp9_ = gupnp_didl_lite_resource_get_bitrate (didl_resource);
#line 111 "../src/librygel-server/rygel-media-resource.vala"
	_tmp10_ = _tmp9_;
#line 111 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_bitrate (self, _tmp10_);
#line 112 "../src/librygel-server/rygel-media-resource.vala"
	_tmp11_ = gupnp_didl_lite_resource_get_bits_per_sample (didl_resource);
#line 112 "../src/librygel-server/rygel-media-resource.vala"
	_tmp12_ = _tmp11_;
#line 112 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_bits_per_sample (self, _tmp12_);
#line 113 "../src/librygel-server/rygel-media-resource.vala"
	_tmp13_ = gupnp_didl_lite_resource_get_color_depth (didl_resource);
#line 113 "../src/librygel-server/rygel-media-resource.vala"
	_tmp14_ = _tmp13_;
#line 113 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_color_depth (self, _tmp14_);
#line 114 "../src/librygel-server/rygel-media-resource.vala"
	_tmp15_ = gupnp_didl_lite_resource_get_width (didl_resource);
#line 114 "../src/librygel-server/rygel-media-resource.vala"
	_tmp16_ = _tmp15_;
#line 114 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_width (self, _tmp16_);
#line 115 "../src/librygel-server/rygel-media-resource.vala"
	_tmp17_ = gupnp_didl_lite_resource_get_height (didl_resource);
#line 115 "../src/librygel-server/rygel-media-resource.vala"
	_tmp18_ = _tmp17_;
#line 115 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_height (self, _tmp18_);
#line 116 "../src/librygel-server/rygel-media-resource.vala"
	_tmp19_ = gupnp_didl_lite_resource_get_audio_channels (didl_resource);
#line 116 "../src/librygel-server/rygel-media-resource.vala"
	_tmp20_ = _tmp19_;
#line 116 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_audio_channels (self, _tmp20_);
#line 117 "../src/librygel-server/rygel-media-resource.vala"
	_tmp21_ = gupnp_didl_lite_resource_get_sample_freq (didl_resource);
#line 117 "../src/librygel-server/rygel-media-resource.vala"
	_tmp22_ = _tmp21_;
#line 117 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_sample_freq (self, _tmp22_);
#line 119 "../src/librygel-server/rygel-media-resource.vala"
	_tmp23_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 119 "../src/librygel-server/rygel-media-resource.vala"
	_tmp24_ = _tmp23_;
#line 119 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp24_ != NULL) {
#line 489 "rygel-media-resource.c"
		GUPnPProtocolInfo* _tmp25_;
		GUPnPProtocolInfo* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		GUPnPProtocolInfo* _tmp29_;
		GUPnPProtocolInfo* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		GUPnPProtocolInfo* _tmp33_;
		GUPnPProtocolInfo* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		GUPnPProtocolInfo* _tmp37_;
		GUPnPProtocolInfo* _tmp38_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		GUPnPProtocolInfo* _tmp41_;
		GUPnPProtocolInfo* _tmp42_;
		gchar** _tmp43_;
		gint _tmp43__length1;
		gchar** _tmp44_;
		gint _tmp44__length1;
		gchar** _tmp45_;
		gint _tmp45__length1;
		GUPnPProtocolInfo* _tmp46_;
		GUPnPProtocolInfo* _tmp47_;
		GUPnPDLNAConversion _tmp48_;
		GUPnPDLNAConversion _tmp49_;
		GUPnPProtocolInfo* _tmp50_;
		GUPnPProtocolInfo* _tmp51_;
		GUPnPDLNAFlags _tmp52_;
		GUPnPDLNAFlags _tmp53_;
		GUPnPProtocolInfo* _tmp54_;
		GUPnPProtocolInfo* _tmp55_;
		GUPnPDLNAOperation _tmp56_;
		GUPnPDLNAOperation _tmp57_;
#line 120 "../src/librygel-server/rygel-media-resource.vala"
		_tmp25_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 120 "../src/librygel-server/rygel-media-resource.vala"
		_tmp26_ = _tmp25_;
#line 120 "../src/librygel-server/rygel-media-resource.vala"
		_tmp27_ = gupnp_protocol_info_get_protocol (_tmp26_);
#line 120 "../src/librygel-server/rygel-media-resource.vala"
		_tmp28_ = _tmp27_;
#line 120 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_protocol (self, _tmp28_);
#line 121 "../src/librygel-server/rygel-media-resource.vala"
		_tmp29_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 121 "../src/librygel-server/rygel-media-resource.vala"
		_tmp30_ = _tmp29_;
#line 121 "../src/librygel-server/rygel-media-resource.vala"
		_tmp31_ = gupnp_protocol_info_get_mime_type (_tmp30_);
#line 121 "../src/librygel-server/rygel-media-resource.vala"
		_tmp32_ = _tmp31_;
#line 121 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_mime_type (self, _tmp32_);
#line 122 "../src/librygel-server/rygel-media-resource.vala"
		_tmp33_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 122 "../src/librygel-server/rygel-media-resource.vala"
		_tmp34_ = _tmp33_;
#line 122 "../src/librygel-server/rygel-media-resource.vala"
		_tmp35_ = gupnp_protocol_info_get_dlna_profile (_tmp34_);
#line 122 "../src/librygel-server/rygel-media-resource.vala"
		_tmp36_ = _tmp35_;
#line 122 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_dlna_profile (self, _tmp36_);
#line 123 "../src/librygel-server/rygel-media-resource.vala"
		_tmp37_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 123 "../src/librygel-server/rygel-media-resource.vala"
		_tmp38_ = _tmp37_;
#line 123 "../src/librygel-server/rygel-media-resource.vala"
		_tmp39_ = gupnp_protocol_info_get_network (_tmp38_);
#line 123 "../src/librygel-server/rygel-media-resource.vala"
		_tmp40_ = _tmp39_;
#line 123 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_network (self, _tmp40_);
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		_tmp41_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		_tmp42_ = _tmp41_;
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		_tmp43_ = gupnp_protocol_info_get_play_speeds (_tmp42_);
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		_tmp43__length1 = _vala_array_length (_tmp43_);
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		_tmp44_ = _tmp43_;
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		_tmp44__length1 = _tmp43__length1;
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		_tmp45_ = (_tmp44_ != NULL) ? _vala_array_dup3 (_tmp44_, _tmp44__length1) : _tmp44_;
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		_tmp45__length1 = _tmp44__length1;
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		self->play_speeds = (_vala_array_free (self->play_speeds, self->play_speeds_length1, (GDestroyNotify) g_free), NULL);
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		self->play_speeds = _tmp45_;
#line 124 "../src/librygel-server/rygel-media-resource.vala"
		self->play_speeds_length1 = _tmp45__length1;
#line 125 "../src/librygel-server/rygel-media-resource.vala"
		_tmp46_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 125 "../src/librygel-server/rygel-media-resource.vala"
		_tmp47_ = _tmp46_;
#line 125 "../src/librygel-server/rygel-media-resource.vala"
		_tmp48_ = gupnp_protocol_info_get_dlna_conversion (_tmp47_);
#line 125 "../src/librygel-server/rygel-media-resource.vala"
		_tmp49_ = _tmp48_;
#line 125 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_dlna_conversion (self, _tmp49_);
#line 126 "../src/librygel-server/rygel-media-resource.vala"
		_tmp50_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 126 "../src/librygel-server/rygel-media-resource.vala"
		_tmp51_ = _tmp50_;
#line 126 "../src/librygel-server/rygel-media-resource.vala"
		_tmp52_ = gupnp_protocol_info_get_dlna_flags (_tmp51_);
#line 126 "../src/librygel-server/rygel-media-resource.vala"
		_tmp53_ = _tmp52_;
#line 126 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_dlna_flags (self, _tmp53_);
#line 127 "../src/librygel-server/rygel-media-resource.vala"
		_tmp54_ = gupnp_didl_lite_resource_get_protocol_info (didl_resource);
#line 127 "../src/librygel-server/rygel-media-resource.vala"
		_tmp55_ = _tmp54_;
#line 127 "../src/librygel-server/rygel-media-resource.vala"
		_tmp56_ = gupnp_protocol_info_get_dlna_operation (_tmp55_);
#line 127 "../src/librygel-server/rygel-media-resource.vala"
		_tmp57_ = _tmp56_;
#line 127 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_dlna_operation (self, _tmp57_);
#line 618 "rygel-media-resource.c"
	}
#line 100 "../src/librygel-server/rygel-media-resource.vala"
	return self;
#line 622 "rygel-media-resource.c"
}

RygelMediaResource*
rygel_media_resource_new_from_didl_lite_resource (const gchar* name,
                                                  GUPnPDIDLLiteResource* didl_resource)
{
#line 100 "../src/librygel-server/rygel-media-resource.vala"
	return rygel_media_resource_construct_from_didl_lite_resource (RYGEL_TYPE_MEDIA_RESOURCE, name, didl_resource);
#line 631 "rygel-media-resource.c"
}

RygelMediaResource*
rygel_media_resource_dup (RygelMediaResource* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	RygelMediaResource* _tmp2_;
	RygelMediaResource* _tmp3_;
	RygelMediaResource* result;
#line 131 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = rygel_media_resource_get_name (self);
#line 132 "../src/librygel-server/rygel-media-resource.vala"
	_tmp1_ = _tmp0_;
#line 132 "../src/librygel-server/rygel-media-resource.vala"
	_tmp2_ = rygel_media_resource_new_from_resource (_tmp1_, self);
#line 132 "../src/librygel-server/rygel-media-resource.vala"
	_tmp3_ = _tmp2_;
#line 132 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (_tmp1_);
#line 132 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp3_;
#line 132 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 658 "rygel-media-resource.c"
}

gchar*
rygel_media_resource_get_name (RygelMediaResource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 135 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 136 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->name;
#line 136 "../src/librygel-server/rygel-media-resource.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 136 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp1_;
#line 136 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 677 "rygel-media-resource.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 170 "../src/librygel-server/rygel-media-resource.vala"
	return self ? g_object_ref (self) : NULL;
#line 685 "rygel-media-resource.c"
}

GUPnPDIDLLiteResource*
rygel_media_resource_serialize (RygelMediaResource* self,
                                GUPnPDIDLLiteResource* didl_resource,
                                GHashTable* replacements)
{
	gint64 _tmp10_;
	gint64 _tmp11_;
	glong _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	GUPnPProtocolInfo* _tmp20_;
	GUPnPProtocolInfo* _tmp21_;
	GUPnPDIDLLiteResource* _tmp22_;
	GUPnPDIDLLiteResource* result;
#line 139 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (didl_resource != NULL, NULL);
#line 143 "../src/librygel-server/rygel-media-resource.vala"
	if (replacements == NULL) {
#line 713 "rygel-media-resource.c"
		const gchar* _tmp0_;
#line 144 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = self->priv->_import_uri;
#line 144 "../src/librygel-server/rygel-media-resource.vala"
		if (_tmp0_ != NULL) {
#line 719 "rygel-media-resource.c"
			const gchar* _tmp1_;
#line 145 "../src/librygel-server/rygel-media-resource.vala"
			_tmp1_ = self->priv->_import_uri;
#line 145 "../src/librygel-server/rygel-media-resource.vala"
			gupnp_didl_lite_resource_set_import_uri (didl_resource, _tmp1_);
#line 725 "rygel-media-resource.c"
		} else {
			const gchar* _tmp2_;
#line 147 "../src/librygel-server/rygel-media-resource.vala"
			_tmp2_ = self->priv->_uri;
#line 147 "../src/librygel-server/rygel-media-resource.vala"
			gupnp_didl_lite_resource_set_uri (didl_resource, _tmp2_);
#line 732 "rygel-media-resource.c"
		}
	} else {
		const gchar* _tmp3_;
#line 150 "../src/librygel-server/rygel-media-resource.vala"
		_tmp3_ = self->priv->_import_uri;
#line 150 "../src/librygel-server/rygel-media-resource.vala"
		if (_tmp3_ != NULL) {
#line 740 "rygel-media-resource.c"
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 151 "../src/librygel-server/rygel-media-resource.vala"
			_tmp4_ = self->priv->_import_uri;
#line 151 "../src/librygel-server/rygel-media-resource.vala"
			_tmp5_ = rygel_media_object_apply_replacements (replacements, _tmp4_);
#line 151 "../src/librygel-server/rygel-media-resource.vala"
			_tmp6_ = _tmp5_;
#line 151 "../src/librygel-server/rygel-media-resource.vala"
			gupnp_didl_lite_resource_set_import_uri (didl_resource, _tmp6_);
#line 151 "../src/librygel-server/rygel-media-resource.vala"
			_g_free0 (_tmp6_);
#line 754 "rygel-media-resource.c"
		} else {
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 154 "../src/librygel-server/rygel-media-resource.vala"
			_tmp7_ = self->priv->_uri;
#line 154 "../src/librygel-server/rygel-media-resource.vala"
			_tmp8_ = rygel_media_object_apply_replacements (replacements, _tmp7_);
#line 154 "../src/librygel-server/rygel-media-resource.vala"
			_tmp9_ = _tmp8_;
#line 154 "../src/librygel-server/rygel-media-resource.vala"
			gupnp_didl_lite_resource_set_uri (didl_resource, _tmp9_);
#line 154 "../src/librygel-server/rygel-media-resource.vala"
			_g_free0 (_tmp9_);
#line 769 "rygel-media-resource.c"
		}
	}
#line 158 "../src/librygel-server/rygel-media-resource.vala"
	_tmp10_ = self->priv->_size;
#line 158 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_size64 (didl_resource, _tmp10_);
#line 159 "../src/librygel-server/rygel-media-resource.vala"
	_tmp11_ = self->priv->_cleartext_size;
#line 159 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_cleartext_size (didl_resource, _tmp11_);
#line 160 "../src/librygel-server/rygel-media-resource.vala"
	_tmp12_ = self->priv->_duration;
#line 160 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_duration (didl_resource, _tmp12_);
#line 161 "../src/librygel-server/rygel-media-resource.vala"
	_tmp13_ = self->priv->_bitrate;
#line 161 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_bitrate (didl_resource, _tmp13_);
#line 162 "../src/librygel-server/rygel-media-resource.vala"
	_tmp14_ = self->priv->_bits_per_sample;
#line 162 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_bits_per_sample (didl_resource, _tmp14_);
#line 163 "../src/librygel-server/rygel-media-resource.vala"
	_tmp15_ = self->priv->_color_depth;
#line 163 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_color_depth (didl_resource, _tmp15_);
#line 164 "../src/librygel-server/rygel-media-resource.vala"
	_tmp16_ = self->priv->_width;
#line 164 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_width (didl_resource, _tmp16_);
#line 165 "../src/librygel-server/rygel-media-resource.vala"
	_tmp17_ = self->priv->_height;
#line 165 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_height (didl_resource, _tmp17_);
#line 166 "../src/librygel-server/rygel-media-resource.vala"
	_tmp18_ = self->priv->_audio_channels;
#line 166 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_audio_channels (didl_resource, _tmp18_);
#line 167 "../src/librygel-server/rygel-media-resource.vala"
	_tmp19_ = self->priv->_sample_freq;
#line 167 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_sample_freq (didl_resource, _tmp19_);
#line 168 "../src/librygel-server/rygel-media-resource.vala"
	_tmp20_ = rygel_media_resource_get_protocol_info (self, NULL);
#line 168 "../src/librygel-server/rygel-media-resource.vala"
	_tmp21_ = _tmp20_;
#line 168 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_didl_lite_resource_set_protocol_info (didl_resource, _tmp21_);
#line 168 "../src/librygel-server/rygel-media-resource.vala"
	_g_object_unref0 (_tmp21_);
#line 170 "../src/librygel-server/rygel-media-resource.vala"
	_tmp22_ = _g_object_ref0 (didl_resource);
#line 170 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp22_;
#line 170 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 826 "rygel-media-resource.c"
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	if (length >= 0) {
#line 835 "rygel-media-resource.c"
		gchar** result;
		gssize i;
#line 181 "../src/librygel-server/rygel-media-resource.vala"
		result = g_new0 (gchar*, length + 1);
#line 181 "../src/librygel-server/rygel-media-resource.vala"
		for (i = 0; i < length; i++) {
#line 842 "rygel-media-resource.c"
			gchar* _tmp0_;
#line 181 "../src/librygel-server/rygel-media-resource.vala"
			_tmp0_ = g_strdup (self[i]);
#line 181 "../src/librygel-server/rygel-media-resource.vala"
			result[i] = _tmp0_;
#line 848 "rygel-media-resource.c"
		}
#line 181 "../src/librygel-server/rygel-media-resource.vala"
		return result;
#line 852 "rygel-media-resource.c"
	}
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	return NULL;
#line 856 "rygel-media-resource.c"
}

void
rygel_media_resource_set_protocol_info (RygelMediaResource* self,
                                        GUPnPProtocolInfo* pi)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GUPnPDLNAConversion _tmp8_;
	GUPnPDLNAConversion _tmp9_;
	GUPnPDLNAOperation _tmp10_;
	GUPnPDLNAOperation _tmp11_;
	GUPnPDLNAFlags _tmp12_;
	GUPnPDLNAFlags _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar** _tmp16_;
	gint _tmp16__length1;
#line 173 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (pi != NULL);
#line 174 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = gupnp_protocol_info_get_protocol (pi);
#line 174 "../src/librygel-server/rygel-media-resource.vala"
	_tmp1_ = _tmp0_;
#line 174 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_protocol (self, _tmp1_);
#line 175 "../src/librygel-server/rygel-media-resource.vala"
	_tmp2_ = gupnp_protocol_info_get_network (pi);
#line 175 "../src/librygel-server/rygel-media-resource.vala"
	_tmp3_ = _tmp2_;
#line 175 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_network (self, _tmp3_);
#line 176 "../src/librygel-server/rygel-media-resource.vala"
	_tmp4_ = gupnp_protocol_info_get_mime_type (pi);
#line 176 "../src/librygel-server/rygel-media-resource.vala"
	_tmp5_ = _tmp4_;
#line 176 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_mime_type (self, _tmp5_);
#line 177 "../src/librygel-server/rygel-media-resource.vala"
	_tmp6_ = gupnp_protocol_info_get_dlna_profile (pi);
#line 177 "../src/librygel-server/rygel-media-resource.vala"
	_tmp7_ = _tmp6_;
#line 177 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_dlna_profile (self, _tmp7_);
#line 178 "../src/librygel-server/rygel-media-resource.vala"
	_tmp8_ = gupnp_protocol_info_get_dlna_conversion (pi);
#line 178 "../src/librygel-server/rygel-media-resource.vala"
	_tmp9_ = _tmp8_;
#line 178 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_dlna_conversion (self, _tmp9_);
#line 179 "../src/librygel-server/rygel-media-resource.vala"
	_tmp10_ = gupnp_protocol_info_get_dlna_operation (pi);
#line 179 "../src/librygel-server/rygel-media-resource.vala"
	_tmp11_ = _tmp10_;
#line 179 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_dlna_operation (self, _tmp11_);
#line 180 "../src/librygel-server/rygel-media-resource.vala"
	_tmp12_ = gupnp_protocol_info_get_dlna_flags (pi);
#line 180 "../src/librygel-server/rygel-media-resource.vala"
	_tmp13_ = _tmp12_;
#line 180 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_set_dlna_flags (self, _tmp13_);
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	_tmp14_ = gupnp_protocol_info_get_play_speeds (pi);
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	_tmp14__length1 = _vala_array_length (_tmp14_);
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	_tmp15_ = _tmp14_;
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	_tmp15__length1 = _tmp14__length1;
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	_tmp16_ = (_tmp15_ != NULL) ? _vala_array_dup4 (_tmp15_, _tmp15__length1) : _tmp15_;
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	_tmp16__length1 = _tmp15__length1;
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds = (_vala_array_free (self->play_speeds, self->play_speeds_length1, (GDestroyNotify) g_free), NULL);
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds = _tmp16_;
#line 181 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds_length1 = _tmp16__length1;
#line 947 "rygel-media-resource.c"
}

GUPnPProtocolInfo*
rygel_media_resource_get_protocol_info (RygelMediaResource* self,
                                        GHashTable* replacements)
{
	GUPnPProtocolInfo* new_pi = NULL;
	GUPnPProtocolInfo* _tmp0_;
	GUPnPProtocolInfo* _tmp1_;
	const gchar* _tmp2_;
	GUPnPProtocolInfo* _tmp3_;
	const gchar* _tmp4_;
	GUPnPProtocolInfo* _tmp11_;
	const gchar* _tmp12_;
	GUPnPProtocolInfo* _tmp13_;
	GUPnPDLNAConversion _tmp14_;
	GUPnPProtocolInfo* _tmp15_;
	GUPnPDLNAOperation _tmp16_;
	GUPnPProtocolInfo* _tmp17_;
	GUPnPDLNAFlags _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GUPnPProtocolInfo* result;
#line 184 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 186 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = gupnp_protocol_info_new ();
#line 186 "../src/librygel-server/rygel-media-resource.vala"
	new_pi = _tmp0_;
#line 188 "../src/librygel-server/rygel-media-resource.vala"
	_tmp1_ = new_pi;
#line 188 "../src/librygel-server/rygel-media-resource.vala"
	_tmp2_ = self->priv->_protocol;
#line 188 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_protocol_info_set_protocol (_tmp1_, _tmp2_);
#line 189 "../src/librygel-server/rygel-media-resource.vala"
	_tmp3_ = new_pi;
#line 189 "../src/librygel-server/rygel-media-resource.vala"
	_tmp4_ = self->priv->_network;
#line 189 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_protocol_info_set_network (_tmp3_, _tmp4_);
#line 190 "../src/librygel-server/rygel-media-resource.vala"
	if (replacements == NULL) {
#line 991 "rygel-media-resource.c"
		GUPnPProtocolInfo* _tmp5_;
		const gchar* _tmp6_;
#line 191 "../src/librygel-server/rygel-media-resource.vala"
		_tmp5_ = new_pi;
#line 191 "../src/librygel-server/rygel-media-resource.vala"
		_tmp6_ = self->priv->_mime_type;
#line 191 "../src/librygel-server/rygel-media-resource.vala"
		gupnp_protocol_info_set_mime_type (_tmp5_, _tmp6_);
#line 1000 "rygel-media-resource.c"
	} else {
		GUPnPProtocolInfo* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 193 "../src/librygel-server/rygel-media-resource.vala"
		_tmp7_ = new_pi;
#line 193 "../src/librygel-server/rygel-media-resource.vala"
		_tmp8_ = self->priv->_mime_type;
#line 193 "../src/librygel-server/rygel-media-resource.vala"
		_tmp9_ = rygel_media_object_apply_replacements (replacements, _tmp8_);
#line 193 "../src/librygel-server/rygel-media-resource.vala"
		_tmp10_ = _tmp9_;
#line 193 "../src/librygel-server/rygel-media-resource.vala"
		gupnp_protocol_info_set_mime_type (_tmp7_, _tmp10_);
#line 193 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp10_);
#line 1018 "rygel-media-resource.c"
	}
#line 196 "../src/librygel-server/rygel-media-resource.vala"
	_tmp11_ = new_pi;
#line 196 "../src/librygel-server/rygel-media-resource.vala"
	_tmp12_ = self->priv->_dlna_profile;
#line 196 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_protocol_info_set_dlna_profile (_tmp11_, _tmp12_);
#line 197 "../src/librygel-server/rygel-media-resource.vala"
	_tmp13_ = new_pi;
#line 197 "../src/librygel-server/rygel-media-resource.vala"
	_tmp14_ = self->priv->_dlna_conversion;
#line 197 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_protocol_info_set_dlna_conversion (_tmp13_, _tmp14_);
#line 198 "../src/librygel-server/rygel-media-resource.vala"
	_tmp15_ = new_pi;
#line 198 "../src/librygel-server/rygel-media-resource.vala"
	_tmp16_ = self->priv->_dlna_operation;
#line 198 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_protocol_info_set_dlna_operation (_tmp15_, _tmp16_);
#line 199 "../src/librygel-server/rygel-media-resource.vala"
	_tmp17_ = new_pi;
#line 199 "../src/librygel-server/rygel-media-resource.vala"
	_tmp18_ = self->priv->_dlna_flags;
#line 199 "../src/librygel-server/rygel-media-resource.vala"
	gupnp_protocol_info_set_dlna_flags (_tmp17_, _tmp18_);
#line 201 "../src/librygel-server/rygel-media-resource.vala"
	_tmp19_ = self->play_speeds;
#line 201 "../src/librygel-server/rygel-media-resource.vala"
	_tmp19__length1 = self->play_speeds_length1;
#line 201 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp19_ != NULL) {
#line 1050 "rygel-media-resource.c"
		GUPnPProtocolInfo* _tmp20_;
		gchar** _tmp21_;
		gint _tmp21__length1;
#line 202 "../src/librygel-server/rygel-media-resource.vala"
		_tmp20_ = new_pi;
#line 202 "../src/librygel-server/rygel-media-resource.vala"
		_tmp21_ = self->play_speeds;
#line 202 "../src/librygel-server/rygel-media-resource.vala"
		_tmp21__length1 = self->play_speeds_length1;
#line 202 "../src/librygel-server/rygel-media-resource.vala"
		gupnp_protocol_info_set_play_speeds (_tmp20_, _tmp21_);
#line 1062 "rygel-media-resource.c"
	}
#line 205 "../src/librygel-server/rygel-media-resource.vala"
	result = new_pi;
#line 205 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1068 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_supports_arbitrary_byte_seek (RygelMediaResource* self)
{
	gboolean result;
#line 208 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 209 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_operation_mode_set (self, (glong) GUPNP_DLNA_OPERATION_RANGE);
#line 209 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1081 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_supports_arbitrary_time_seek (RygelMediaResource* self)
{
	gboolean result;
#line 212 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 213 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_operation_mode_set (self, (glong) GUPNP_DLNA_OPERATION_TIMESEEK);
#line 213 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1094 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_supports_limited_byte_seek (RygelMediaResource* self)
{
	gboolean result;
#line 216 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 217 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_BYTE_BASED_SEEK);
#line 217 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1107 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_supports_limited_time_seek (RygelMediaResource* self)
{
	gboolean result;
#line 220 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 221 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_TIME_BASED_SEEK);
#line 221 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1120 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_supports_limited_cleartext_byte_seek (RygelMediaResource* self)
{
	gboolean result;
#line 224 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 225 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_LOP_CLEAR_TEXT_BYTE_SEEK);
#line 225 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1133 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_supports_full_cleartext_byte_seek (RygelMediaResource* self)
{
	gboolean result;
#line 228 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 229 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_CLEAR_TEXT_BYTE_SEEK_FULL);
#line 229 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1146 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_is_link_protection_enabled (RygelMediaResource* self)
{
	gboolean result;
#line 232 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 233 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_LINK_PROTECTED_CONTENT);
#line 233 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1159 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_is_dlna_content (RygelMediaResource* self)
{
	const gchar* _tmp0_;
	gboolean result;
#line 236 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 237 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_dlna_profile;
#line 237 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0_ != NULL;
#line 237 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1175 "rygel-media-resource.c"
}

gchar*
rygel_media_resource_get_default_transfer_mode (RygelMediaResource* self)
{
	gchar* result;
#line 240 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_STREAMING_TRANSFER_MODE)) {
#line 1186 "rygel-media-resource.c"
		gchar* _tmp0_;
#line 242 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = g_strdup ("Streaming");
#line 242 "../src/librygel-server/rygel-media-resource.vala"
		result = _tmp0_;
#line 242 "../src/librygel-server/rygel-media-resource.vala"
		return result;
#line 1194 "rygel-media-resource.c"
	} else {
		gchar* _tmp1_;
#line 244 "../src/librygel-server/rygel-media-resource.vala"
		_tmp1_ = g_strdup ("Interactive");
#line 244 "../src/librygel-server/rygel-media-resource.vala"
		result = _tmp1_;
#line 244 "../src/librygel-server/rygel-media-resource.vala"
		return result;
#line 1203 "rygel-media-resource.c"
	}
}

gboolean
rygel_media_resource_supports_transfer_mode (RygelMediaResource* self,
                                             const gchar* transfer_mode)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 253 "../src/librygel-server/rygel-media-resource.vala"
	static GQuark _tmp1_label0 = 0;
#line 253 "../src/librygel-server/rygel-media-resource.vala"
	static GQuark _tmp1_label1 = 0;
#line 253 "../src/librygel-server/rygel-media-resource.vala"
	static GQuark _tmp1_label2 = 0;
#line 1219 "rygel-media-resource.c"
	gboolean result;
#line 248 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 248 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (transfer_mode != NULL, FALSE);
#line 249 "../src/librygel-server/rygel-media-resource.vala"
	if (!rygel_media_resource_is_dlna_content (self)) {
#line 250 "../src/librygel-server/rygel-media-resource.vala"
		result = TRUE;
#line 250 "../src/librygel-server/rygel-media-resource.vala"
		return result;
#line 1231 "rygel-media-resource.c"
	}
#line 253 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = transfer_mode;
#line 253 "../src/librygel-server/rygel-media-resource.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 253 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("Streaming")))) {
#line 253 "../src/librygel-server/rygel-media-resource.vala"
		switch (0) {
#line 1241 "rygel-media-resource.c"
			default:
			{
#line 255 "../src/librygel-server/rygel-media-resource.vala"
				result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_STREAMING_TRANSFER_MODE);
#line 255 "../src/librygel-server/rygel-media-resource.vala"
				return result;
#line 1248 "rygel-media-resource.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Interactive")))) {
#line 253 "../src/librygel-server/rygel-media-resource.vala"
		switch (0) {
#line 1254 "rygel-media-resource.c"
			default:
			{
#line 258 "../src/librygel-server/rygel-media-resource.vala"
				result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_INTERACTIVE_TRANSFER_MODE);
#line 258 "../src/librygel-server/rygel-media-resource.vala"
				return result;
#line 1261 "rygel-media-resource.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Background")))) {
#line 253 "../src/librygel-server/rygel-media-resource.vala"
		switch (0) {
#line 1267 "rygel-media-resource.c"
			default:
			{
#line 261 "../src/librygel-server/rygel-media-resource.vala"
				result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_BACKGROUND_TRANSFER_MODE);
#line 261 "../src/librygel-server/rygel-media-resource.vala"
				return result;
#line 1274 "rygel-media-resource.c"
			}
		}
	} else {
#line 253 "../src/librygel-server/rygel-media-resource.vala"
		switch (0) {
#line 1280 "rygel-media-resource.c"
			default:
			{
#line 264 "../src/librygel-server/rygel-media-resource.vala"
				result = FALSE;
#line 264 "../src/librygel-server/rygel-media-resource.vala"
				return result;
#line 1287 "rygel-media-resource.c"
			}
		}
	}
}

gboolean
rygel_media_resource_is_streamable (RygelMediaResource* self)
{
	gboolean result;
#line 268 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 269 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_STREAMING_TRANSFER_MODE);
#line 269 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1303 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_is_cleartext_range_support_enabled (RygelMediaResource* self)
{
	gboolean result;
#line 274 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 275 "../src/librygel-server/rygel-media-resource.vala"
	result = rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) (GUPNP_DLNA_FLAGS_CLEAR_TEXT_BYTE_SEEK_FULL | GUPNP_DLNA_FLAGS_LOP_CLEAR_TEXT_BYTE_SEEK));
#line 275 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1316 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_supports_playspeed (RygelMediaResource* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gboolean result;
#line 280 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 281 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->play_speeds;
#line 281 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0__length1 = self->play_speeds_length1;
#line 281 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0__length1 > 0;
#line 281 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1335 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_is_dlna_protocol_flag_set (RygelMediaResource* self,
                                                glong flags)
{
	GUPnPDLNAFlags _tmp0_;
	gboolean result;
#line 284 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 285 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_dlna_flags;
#line 285 "../src/librygel-server/rygel-media-resource.vala"
	result = (_tmp0_ & flags) != 0;
#line 285 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1352 "rygel-media-resource.c"
}

gboolean
rygel_media_resource_is_dlna_operation_mode_set (RygelMediaResource* self,
                                                 glong flags)
{
	GUPnPDLNAOperation _tmp0_;
	gboolean result;
#line 288 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 289 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_dlna_operation;
#line 289 "../src/librygel-server/rygel-media-resource.vala"
	result = (_tmp0_ & flags) != 0;
#line 289 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 1369 "rygel-media-resource.c"
}

gchar*
rygel_media_resource_to_string (RygelMediaResource* self)
{
	GString* strbuf = NULL;
	const gchar* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp10_;
	glong _tmp17_;
	gint _tmp24_;
	gint _tmp31_;
	gint _tmp38_;
	gint _tmp45_;
	gint _tmp52_;
	gint _tmp59_;
	gint _tmp66_;
	const gchar* _tmp73_;
	const gchar* _tmp78_ = NULL;
	const gchar* _tmp79_;
	GString* _tmp81_;
	GString* _tmp82_;
	GString* _tmp83_;
	const gchar* _tmp84_ = NULL;
	const gchar* _tmp85_;
	GString* _tmp87_;
	GString* _tmp88_;
	GString* _tmp89_;
	const gchar* _tmp90_ = NULL;
	const gchar* _tmp91_;
	GString* _tmp93_;
	GString* _tmp94_;
	GString* _tmp95_;
	GString* _tmp96_;
	GUPnPDLNAFlags _tmp97_;
	GString* _tmp111_;
	GString* _tmp112_;
	GUPnPDLNAConversion _tmp113_;
	GUPnPDLNAOperation _tmp116_;
	gchar** _tmp123_;
	gint _tmp123__length1;
	const gchar* _tmp132_ = NULL;
	const gchar* _tmp133_;
	GString* _tmp135_;
	GString* _tmp136_;
	GString* _tmp137_;
	GString* _tmp138_;
	const gchar* _tmp139_;
	gchar* _tmp140_;
	gchar* result;
#line 292 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 293 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->name;
#line 293 "../src/librygel-server/rygel-media-resource.vala"
	_tmp1_ = g_string_new (_tmp0_);
#line 293 "../src/librygel-server/rygel-media-resource.vala"
	strbuf = _tmp1_;
#line 294 "../src/librygel-server/rygel-media-resource.vala"
	_tmp2_ = strbuf;
#line 294 "../src/librygel-server/rygel-media-resource.vala"
	g_string_append_unichar (_tmp2_, (gunichar) '(');
#line 295 "../src/librygel-server/rygel-media-resource.vala"
	_tmp3_ = self->priv->_size;
#line 295 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp3_ >= ((gint64) 0)) {
#line 1438 "rygel-media-resource.c"
		GString* _tmp4_;
		GString* _tmp5_;
		gint64 _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GString* _tmp9_;
#line 296 "../src/librygel-server/rygel-media-resource.vala"
		_tmp4_ = strbuf;
#line 296 "../src/librygel-server/rygel-media-resource.vala"
		_tmp5_ = g_string_append (_tmp4_, "size ");
#line 296 "../src/librygel-server/rygel-media-resource.vala"
		_tmp6_ = self->priv->_size;
#line 296 "../src/librygel-server/rygel-media-resource.vala"
		_tmp7_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp6_);
#line 296 "../src/librygel-server/rygel-media-resource.vala"
		_tmp8_ = _tmp7_;
#line 296 "../src/librygel-server/rygel-media-resource.vala"
		_tmp9_ = g_string_append (_tmp5_, _tmp8_);
#line 296 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp9_, (gunichar) ',');
#line 296 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp8_);
#line 1461 "rygel-media-resource.c"
	}
#line 299 "../src/librygel-server/rygel-media-resource.vala"
	_tmp10_ = self->priv->_cleartext_size;
#line 299 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp10_ >= ((gint64) 0)) {
#line 1467 "rygel-media-resource.c"
		GString* _tmp11_;
		GString* _tmp12_;
		gint64 _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GString* _tmp16_;
#line 300 "../src/librygel-server/rygel-media-resource.vala"
		_tmp11_ = strbuf;
#line 300 "../src/librygel-server/rygel-media-resource.vala"
		_tmp12_ = g_string_append (_tmp11_, "cleartextsize ");
#line 300 "../src/librygel-server/rygel-media-resource.vala"
		_tmp13_ = self->priv->_cleartext_size;
#line 300 "../src/librygel-server/rygel-media-resource.vala"
		_tmp14_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp13_);
#line 300 "../src/librygel-server/rygel-media-resource.vala"
		_tmp15_ = _tmp14_;
#line 300 "../src/librygel-server/rygel-media-resource.vala"
		_tmp16_ = g_string_append (_tmp12_, _tmp15_);
#line 300 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp16_, (gunichar) ',');
#line 300 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp15_);
#line 1490 "rygel-media-resource.c"
	}
#line 304 "../src/librygel-server/rygel-media-resource.vala"
	_tmp17_ = self->priv->_duration;
#line 304 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp17_ >= ((glong) 0)) {
#line 1496 "rygel-media-resource.c"
		GString* _tmp18_;
		GString* _tmp19_;
		glong _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GString* _tmp23_;
#line 305 "../src/librygel-server/rygel-media-resource.vala"
		_tmp18_ = strbuf;
#line 305 "../src/librygel-server/rygel-media-resource.vala"
		_tmp19_ = g_string_append (_tmp18_, "duration ");
#line 305 "../src/librygel-server/rygel-media-resource.vala"
		_tmp20_ = self->priv->_duration;
#line 305 "../src/librygel-server/rygel-media-resource.vala"
		_tmp21_ = g_strdup_printf ("%li", _tmp20_);
#line 305 "../src/librygel-server/rygel-media-resource.vala"
		_tmp22_ = _tmp21_;
#line 305 "../src/librygel-server/rygel-media-resource.vala"
		_tmp23_ = g_string_append (_tmp19_, _tmp22_);
#line 305 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp23_, (gunichar) ',');
#line 305 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp22_);
#line 1519 "rygel-media-resource.c"
	}
#line 308 "../src/librygel-server/rygel-media-resource.vala"
	_tmp24_ = self->priv->_bitrate;
#line 308 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp24_ >= 0) {
#line 1525 "rygel-media-resource.c"
		GString* _tmp25_;
		GString* _tmp26_;
		gint _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GString* _tmp30_;
#line 309 "../src/librygel-server/rygel-media-resource.vala"
		_tmp25_ = strbuf;
#line 309 "../src/librygel-server/rygel-media-resource.vala"
		_tmp26_ = g_string_append (_tmp25_, "bitrate ");
#line 309 "../src/librygel-server/rygel-media-resource.vala"
		_tmp27_ = self->priv->_bitrate;
#line 309 "../src/librygel-server/rygel-media-resource.vala"
		_tmp28_ = g_strdup_printf ("%i", _tmp27_);
#line 309 "../src/librygel-server/rygel-media-resource.vala"
		_tmp29_ = _tmp28_;
#line 309 "../src/librygel-server/rygel-media-resource.vala"
		_tmp30_ = g_string_append (_tmp26_, _tmp29_);
#line 309 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp30_, (gunichar) ',');
#line 309 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp29_);
#line 1548 "rygel-media-resource.c"
	}
#line 312 "../src/librygel-server/rygel-media-resource.vala"
	_tmp31_ = self->priv->_bits_per_sample;
#line 312 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp31_ >= 0) {
#line 1554 "rygel-media-resource.c"
		GString* _tmp32_;
		GString* _tmp33_;
		gint _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		GString* _tmp37_;
#line 313 "../src/librygel-server/rygel-media-resource.vala"
		_tmp32_ = strbuf;
#line 313 "../src/librygel-server/rygel-media-resource.vala"
		_tmp33_ = g_string_append (_tmp32_, "bits_per_sample ");
#line 313 "../src/librygel-server/rygel-media-resource.vala"
		_tmp34_ = self->priv->_bits_per_sample;
#line 313 "../src/librygel-server/rygel-media-resource.vala"
		_tmp35_ = g_strdup_printf ("%i", _tmp34_);
#line 313 "../src/librygel-server/rygel-media-resource.vala"
		_tmp36_ = _tmp35_;
#line 313 "../src/librygel-server/rygel-media-resource.vala"
		_tmp37_ = g_string_append (_tmp33_, _tmp36_);
#line 313 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp37_, (gunichar) ',');
#line 313 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp36_);
#line 1577 "rygel-media-resource.c"
	}
#line 317 "../src/librygel-server/rygel-media-resource.vala"
	_tmp38_ = self->priv->_width;
#line 317 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp38_ >= 0) {
#line 1583 "rygel-media-resource.c"
		GString* _tmp39_;
		GString* _tmp40_;
		gint _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		GString* _tmp44_;
#line 318 "../src/librygel-server/rygel-media-resource.vala"
		_tmp39_ = strbuf;
#line 318 "../src/librygel-server/rygel-media-resource.vala"
		_tmp40_ = g_string_append (_tmp39_, "width ");
#line 318 "../src/librygel-server/rygel-media-resource.vala"
		_tmp41_ = self->priv->_width;
#line 318 "../src/librygel-server/rygel-media-resource.vala"
		_tmp42_ = g_strdup_printf ("%i", _tmp41_);
#line 318 "../src/librygel-server/rygel-media-resource.vala"
		_tmp43_ = _tmp42_;
#line 318 "../src/librygel-server/rygel-media-resource.vala"
		_tmp44_ = g_string_append (_tmp40_, _tmp43_);
#line 318 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp44_, (gunichar) ',');
#line 318 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp43_);
#line 1606 "rygel-media-resource.c"
	}
#line 321 "../src/librygel-server/rygel-media-resource.vala"
	_tmp45_ = self->priv->_height;
#line 321 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp45_ >= 0) {
#line 1612 "rygel-media-resource.c"
		GString* _tmp46_;
		GString* _tmp47_;
		gint _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		GString* _tmp51_;
#line 322 "../src/librygel-server/rygel-media-resource.vala"
		_tmp46_ = strbuf;
#line 322 "../src/librygel-server/rygel-media-resource.vala"
		_tmp47_ = g_string_append (_tmp46_, "height ");
#line 322 "../src/librygel-server/rygel-media-resource.vala"
		_tmp48_ = self->priv->_height;
#line 322 "../src/librygel-server/rygel-media-resource.vala"
		_tmp49_ = g_strdup_printf ("%i", _tmp48_);
#line 322 "../src/librygel-server/rygel-media-resource.vala"
		_tmp50_ = _tmp49_;
#line 322 "../src/librygel-server/rygel-media-resource.vala"
		_tmp51_ = g_string_append (_tmp47_, _tmp50_);
#line 322 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp51_, (gunichar) ',');
#line 322 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp50_);
#line 1635 "rygel-media-resource.c"
	}
#line 325 "../src/librygel-server/rygel-media-resource.vala"
	_tmp52_ = self->priv->_color_depth;
#line 325 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp52_ >= 0) {
#line 1641 "rygel-media-resource.c"
		GString* _tmp53_;
		GString* _tmp54_;
		gint _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		GString* _tmp58_;
#line 326 "../src/librygel-server/rygel-media-resource.vala"
		_tmp53_ = strbuf;
#line 326 "../src/librygel-server/rygel-media-resource.vala"
		_tmp54_ = g_string_append (_tmp53_, "color_depth ");
#line 326 "../src/librygel-server/rygel-media-resource.vala"
		_tmp55_ = self->priv->_color_depth;
#line 326 "../src/librygel-server/rygel-media-resource.vala"
		_tmp56_ = g_strdup_printf ("%i", _tmp55_);
#line 326 "../src/librygel-server/rygel-media-resource.vala"
		_tmp57_ = _tmp56_;
#line 326 "../src/librygel-server/rygel-media-resource.vala"
		_tmp58_ = g_string_append (_tmp54_, _tmp57_);
#line 326 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp58_, (gunichar) ',');
#line 326 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp57_);
#line 1664 "rygel-media-resource.c"
	}
#line 330 "../src/librygel-server/rygel-media-resource.vala"
	_tmp59_ = self->priv->_audio_channels;
#line 330 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp59_ >= 0) {
#line 1670 "rygel-media-resource.c"
		GString* _tmp60_;
		GString* _tmp61_;
		gint _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		GString* _tmp65_;
#line 331 "../src/librygel-server/rygel-media-resource.vala"
		_tmp60_ = strbuf;
#line 331 "../src/librygel-server/rygel-media-resource.vala"
		_tmp61_ = g_string_append (_tmp60_, "audio_channels ");
#line 331 "../src/librygel-server/rygel-media-resource.vala"
		_tmp62_ = self->priv->_audio_channels;
#line 331 "../src/librygel-server/rygel-media-resource.vala"
		_tmp63_ = g_strdup_printf ("%i", _tmp62_);
#line 331 "../src/librygel-server/rygel-media-resource.vala"
		_tmp64_ = _tmp63_;
#line 331 "../src/librygel-server/rygel-media-resource.vala"
		_tmp65_ = g_string_append (_tmp61_, _tmp64_);
#line 331 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp65_, (gunichar) ',');
#line 331 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp64_);
#line 1693 "rygel-media-resource.c"
	}
#line 335 "../src/librygel-server/rygel-media-resource.vala"
	_tmp66_ = self->priv->_sample_freq;
#line 335 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp66_ >= 0) {
#line 1699 "rygel-media-resource.c"
		GString* _tmp67_;
		GString* _tmp68_;
		gint _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		GString* _tmp72_;
#line 336 "../src/librygel-server/rygel-media-resource.vala"
		_tmp67_ = strbuf;
#line 336 "../src/librygel-server/rygel-media-resource.vala"
		_tmp68_ = g_string_append (_tmp67_, "sample_freq ");
#line 336 "../src/librygel-server/rygel-media-resource.vala"
		_tmp69_ = self->priv->_sample_freq;
#line 336 "../src/librygel-server/rygel-media-resource.vala"
		_tmp70_ = g_strdup_printf ("%i", _tmp69_);
#line 336 "../src/librygel-server/rygel-media-resource.vala"
		_tmp71_ = _tmp70_;
#line 336 "../src/librygel-server/rygel-media-resource.vala"
		_tmp72_ = g_string_append (_tmp68_, _tmp71_);
#line 336 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp72_, (gunichar) ',');
#line 336 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (_tmp71_);
#line 1722 "rygel-media-resource.c"
	}
#line 340 "../src/librygel-server/rygel-media-resource.vala"
	_tmp73_ = self->priv->_network;
#line 340 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp73_ != NULL) {
#line 1728 "rygel-media-resource.c"
		GString* _tmp74_;
		GString* _tmp75_;
		const gchar* _tmp76_;
		GString* _tmp77_;
#line 341 "../src/librygel-server/rygel-media-resource.vala"
		_tmp74_ = strbuf;
#line 341 "../src/librygel-server/rygel-media-resource.vala"
		_tmp75_ = g_string_append (_tmp74_, "network ");
#line 341 "../src/librygel-server/rygel-media-resource.vala"
		_tmp76_ = self->priv->_network;
#line 341 "../src/librygel-server/rygel-media-resource.vala"
		_tmp77_ = g_string_append (_tmp75_, _tmp76_);
#line 341 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_unichar (_tmp77_, (gunichar) ',');
#line 1743 "rygel-media-resource.c"
	}
#line 345 "../src/librygel-server/rygel-media-resource.vala"
	_tmp79_ = self->priv->_protocol;
#line 345 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp79_ == NULL) {
#line 345 "../src/librygel-server/rygel-media-resource.vala"
		_tmp78_ = "null";
#line 1751 "rygel-media-resource.c"
	} else {
		const gchar* _tmp80_;
#line 345 "../src/librygel-server/rygel-media-resource.vala"
		_tmp80_ = self->priv->_protocol;
#line 345 "../src/librygel-server/rygel-media-resource.vala"
		_tmp78_ = _tmp80_;
#line 1758 "rygel-media-resource.c"
	}
#line 344 "../src/librygel-server/rygel-media-resource.vala"
	_tmp81_ = strbuf;
#line 344 "../src/librygel-server/rygel-media-resource.vala"
	_tmp82_ = g_string_append (_tmp81_, "protocol ");
#line 344 "../src/librygel-server/rygel-media-resource.vala"
	_tmp83_ = g_string_append (_tmp82_, _tmp78_);
#line 344 "../src/librygel-server/rygel-media-resource.vala"
	g_string_append_unichar (_tmp83_, (gunichar) ',');
#line 348 "../src/librygel-server/rygel-media-resource.vala"
	_tmp85_ = self->priv->_mime_type;
#line 348 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp85_ == NULL) {
#line 348 "../src/librygel-server/rygel-media-resource.vala"
		_tmp84_ = "null";
#line 1774 "rygel-media-resource.c"
	} else {
		const gchar* _tmp86_;
#line 348 "../src/librygel-server/rygel-media-resource.vala"
		_tmp86_ = self->priv->_mime_type;
#line 348 "../src/librygel-server/rygel-media-resource.vala"
		_tmp84_ = _tmp86_;
#line 1781 "rygel-media-resource.c"
	}
#line 347 "../src/librygel-server/rygel-media-resource.vala"
	_tmp87_ = strbuf;
#line 347 "../src/librygel-server/rygel-media-resource.vala"
	_tmp88_ = g_string_append (_tmp87_, "mime_type ");
#line 347 "../src/librygel-server/rygel-media-resource.vala"
	_tmp89_ = g_string_append (_tmp88_, _tmp84_);
#line 347 "../src/librygel-server/rygel-media-resource.vala"
	g_string_append_unichar (_tmp89_, (gunichar) ',');
#line 351 "../src/librygel-server/rygel-media-resource.vala"
	_tmp91_ = self->priv->_dlna_profile;
#line 351 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp91_ == NULL) {
#line 351 "../src/librygel-server/rygel-media-resource.vala"
		_tmp90_ = "null";
#line 1797 "rygel-media-resource.c"
	} else {
		const gchar* _tmp92_;
#line 351 "../src/librygel-server/rygel-media-resource.vala"
		_tmp92_ = self->priv->_dlna_profile;
#line 351 "../src/librygel-server/rygel-media-resource.vala"
		_tmp90_ = _tmp92_;
#line 1804 "rygel-media-resource.c"
	}
#line 350 "../src/librygel-server/rygel-media-resource.vala"
	_tmp93_ = strbuf;
#line 350 "../src/librygel-server/rygel-media-resource.vala"
	_tmp94_ = g_string_append (_tmp93_, "dlna_profile ");
#line 350 "../src/librygel-server/rygel-media-resource.vala"
	_tmp95_ = g_string_append (_tmp94_, _tmp90_);
#line 350 "../src/librygel-server/rygel-media-resource.vala"
	g_string_append_unichar (_tmp95_, (gunichar) ',');
#line 353 "../src/librygel-server/rygel-media-resource.vala"
	_tmp96_ = strbuf;
#line 353 "../src/librygel-server/rygel-media-resource.vala"
	_tmp97_ = self->priv->_dlna_flags;
#line 353 "../src/librygel-server/rygel-media-resource.vala"
	g_string_append_printf (_tmp96_, "dlna_flags %.8X [", (guint) _tmp97_);
#line 354 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_SENDER_PACED)) {
#line 1822 "rygel-media-resource.c"
		GString* _tmp98_;
#line 355 "../src/librygel-server/rygel-media-resource.vala"
		_tmp98_ = strbuf;
#line 355 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp98_, "sp-flag ");
#line 1828 "rygel-media-resource.c"
	}
#line 357 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_TIME_BASED_SEEK)) {
#line 1832 "rygel-media-resource.c"
		GString* _tmp99_;
#line 358 "../src/librygel-server/rygel-media-resource.vala"
		_tmp99_ = strbuf;
#line 358 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp99_, "lop-time ");
#line 1838 "rygel-media-resource.c"
	}
#line 360 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_BYTE_BASED_SEEK)) {
#line 1842 "rygel-media-resource.c"
		GString* _tmp100_;
#line 361 "../src/librygel-server/rygel-media-resource.vala"
		_tmp100_ = strbuf;
#line 361 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp100_, "lop-byte ");
#line 1848 "rygel-media-resource.c"
	}
#line 363 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_S0_INCREASE)) {
#line 1852 "rygel-media-resource.c"
		GString* _tmp101_;
#line 364 "../src/librygel-server/rygel-media-resource.vala"
		_tmp101_ = strbuf;
#line 364 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp101_, "s0-increase ");
#line 1858 "rygel-media-resource.c"
	}
#line 366 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_SN_INCREASE)) {
#line 1862 "rygel-media-resource.c"
		GString* _tmp102_;
#line 367 "../src/librygel-server/rygel-media-resource.vala"
		_tmp102_ = strbuf;
#line 367 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp102_, "sn-increase ");
#line 1868 "rygel-media-resource.c"
	}
#line 369 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_STREAMING_TRANSFER_MODE)) {
#line 1872 "rygel-media-resource.c"
		GString* _tmp103_;
#line 371 "../src/librygel-server/rygel-media-resource.vala"
		_tmp103_ = strbuf;
#line 371 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp103_, "streaming ");
#line 1878 "rygel-media-resource.c"
	}
#line 373 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_INTERACTIVE_TRANSFER_MODE)) {
#line 1882 "rygel-media-resource.c"
		GString* _tmp104_;
#line 375 "../src/librygel-server/rygel-media-resource.vala"
		_tmp104_ = strbuf;
#line 375 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp104_, "interactive ");
#line 1888 "rygel-media-resource.c"
	}
#line 377 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_BACKGROUND_TRANSFER_MODE)) {
#line 1892 "rygel-media-resource.c"
		GString* _tmp105_;
#line 379 "../src/librygel-server/rygel-media-resource.vala"
		_tmp105_ = strbuf;
#line 379 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp105_, "background ");
#line 1898 "rygel-media-resource.c"
	}
#line 381 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_CONNECTION_STALL)) {
#line 1902 "rygel-media-resource.c"
		GString* _tmp106_;
#line 382 "../src/librygel-server/rygel-media-resource.vala"
		_tmp106_ = strbuf;
#line 382 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp106_, "stall ");
#line 1908 "rygel-media-resource.c"
	}
#line 384 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_DLNA_V15)) {
#line 1912 "rygel-media-resource.c"
		GString* _tmp107_;
#line 385 "../src/librygel-server/rygel-media-resource.vala"
		_tmp107_ = strbuf;
#line 385 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp107_, "v1.5 ");
#line 1918 "rygel-media-resource.c"
	}
#line 387 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_LINK_PROTECTED_CONTENT)) {
#line 1922 "rygel-media-resource.c"
		GString* _tmp108_;
#line 388 "../src/librygel-server/rygel-media-resource.vala"
		_tmp108_ = strbuf;
#line 388 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp108_, "link-protected ");
#line 1928 "rygel-media-resource.c"
	}
#line 390 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_CLEAR_TEXT_BYTE_SEEK_FULL)) {
#line 1932 "rygel-media-resource.c"
		GString* _tmp109_;
#line 392 "../src/librygel-server/rygel-media-resource.vala"
		_tmp109_ = strbuf;
#line 392 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp109_, "cleartext-full ");
#line 1938 "rygel-media-resource.c"
	}
#line 394 "../src/librygel-server/rygel-media-resource.vala"
	if (rygel_media_resource_is_dlna_protocol_flag_set (self, (glong) GUPNP_DLNA_FLAGS_LOP_CLEAR_TEXT_BYTE_SEEK)) {
#line 1942 "rygel-media-resource.c"
		GString* _tmp110_;
#line 395 "../src/librygel-server/rygel-media-resource.vala"
		_tmp110_ = strbuf;
#line 395 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp110_, "cleartext-lop ");
#line 1948 "rygel-media-resource.c"
	}
#line 397 "../src/librygel-server/rygel-media-resource.vala"
	_tmp111_ = strbuf;
#line 397 "../src/librygel-server/rygel-media-resource.vala"
	_tmp112_ = strbuf;
#line 397 "../src/librygel-server/rygel-media-resource.vala"
	g_string_overwrite (_tmp111_, (gsize) (_tmp112_->len - 1), "],");
#line 399 "../src/librygel-server/rygel-media-resource.vala"
	_tmp113_ = self->priv->_dlna_conversion;
#line 399 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp113_ != GUPNP_DLNA_CONVERSION_NONE) {
#line 1960 "rygel-media-resource.c"
		GString* _tmp114_;
		GUPnPDLNAConversion _tmp115_;
#line 400 "../src/librygel-server/rygel-media-resource.vala"
		_tmp114_ = strbuf;
#line 400 "../src/librygel-server/rygel-media-resource.vala"
		_tmp115_ = self->priv->_dlna_conversion;
#line 400 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_printf (_tmp114_, "dlna_conversion %1d,", (gint) _tmp115_);
#line 1969 "rygel-media-resource.c"
	}
#line 403 "../src/librygel-server/rygel-media-resource.vala"
	_tmp116_ = self->priv->_dlna_operation;
#line 403 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp116_ != GUPNP_DLNA_OPERATION_NONE) {
#line 1975 "rygel-media-resource.c"
		GString* _tmp117_;
		GUPnPDLNAOperation _tmp118_;
		GString* _tmp121_;
		GString* _tmp122_;
#line 404 "../src/librygel-server/rygel-media-resource.vala"
		_tmp117_ = strbuf;
#line 404 "../src/librygel-server/rygel-media-resource.vala"
		_tmp118_ = self->priv->_dlna_operation;
#line 404 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append_printf (_tmp117_, "dlna_operation %.2X [", (guint) _tmp118_);
#line 405 "../src/librygel-server/rygel-media-resource.vala"
		if (rygel_media_resource_is_dlna_operation_mode_set (self, (glong) GUPNP_DLNA_OPERATION_RANGE)) {
#line 1988 "rygel-media-resource.c"
			GString* _tmp119_;
#line 406 "../src/librygel-server/rygel-media-resource.vala"
			_tmp119_ = strbuf;
#line 406 "../src/librygel-server/rygel-media-resource.vala"
			g_string_append (_tmp119_, "byte-seek ");
#line 1994 "rygel-media-resource.c"
		}
#line 409 "../src/librygel-server/rygel-media-resource.vala"
		if (rygel_media_resource_is_dlna_operation_mode_set (self, (glong) GUPNP_DLNA_OPERATION_TIMESEEK)) {
#line 1998 "rygel-media-resource.c"
			GString* _tmp120_;
#line 410 "../src/librygel-server/rygel-media-resource.vala"
			_tmp120_ = strbuf;
#line 410 "../src/librygel-server/rygel-media-resource.vala"
			g_string_append (_tmp120_, "time-seek ");
#line 2004 "rygel-media-resource.c"
		}
#line 412 "../src/librygel-server/rygel-media-resource.vala"
		_tmp121_ = strbuf;
#line 412 "../src/librygel-server/rygel-media-resource.vala"
		_tmp122_ = strbuf;
#line 412 "../src/librygel-server/rygel-media-resource.vala"
		g_string_overwrite (_tmp121_, (gsize) (_tmp122_->len - 1), "],");
#line 2012 "rygel-media-resource.c"
	}
#line 415 "../src/librygel-server/rygel-media-resource.vala"
	_tmp123_ = self->play_speeds;
#line 415 "../src/librygel-server/rygel-media-resource.vala"
	_tmp123__length1 = self->play_speeds_length1;
#line 415 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp123_ != NULL) {
#line 2020 "rygel-media-resource.c"
		GString* _tmp124_;
		gchar** _tmp125_;
		gint _tmp125__length1;
		GString* _tmp130_;
		GString* _tmp131_;
#line 416 "../src/librygel-server/rygel-media-resource.vala"
		_tmp124_ = strbuf;
#line 416 "../src/librygel-server/rygel-media-resource.vala"
		g_string_append (_tmp124_, "play_speeds [");
#line 417 "../src/librygel-server/rygel-media-resource.vala"
		_tmp125_ = self->play_speeds;
#line 417 "../src/librygel-server/rygel-media-resource.vala"
		_tmp125__length1 = self->play_speeds_length1;
#line 2034 "rygel-media-resource.c"
		{
			gchar** speed_collection = NULL;
			gint speed_collection_length1 = 0;
			gint _speed_collection_size_ = 0;
			gint speed_it = 0;
#line 417 "../src/librygel-server/rygel-media-resource.vala"
			speed_collection = _tmp125_;
#line 417 "../src/librygel-server/rygel-media-resource.vala"
			speed_collection_length1 = _tmp125__length1;
#line 417 "../src/librygel-server/rygel-media-resource.vala"
			for (speed_it = 0; speed_it < speed_collection_length1; speed_it = speed_it + 1) {
#line 2046 "rygel-media-resource.c"
				gchar* _tmp126_;
				gchar* speed = NULL;
#line 417 "../src/librygel-server/rygel-media-resource.vala"
				_tmp126_ = g_strdup (speed_collection[speed_it]);
#line 417 "../src/librygel-server/rygel-media-resource.vala"
				speed = _tmp126_;
#line 2053 "rygel-media-resource.c"
				{
					GString* _tmp127_;
					const gchar* _tmp128_;
					GString* _tmp129_;
#line 418 "../src/librygel-server/rygel-media-resource.vala"
					_tmp127_ = strbuf;
#line 418 "../src/librygel-server/rygel-media-resource.vala"
					_tmp128_ = speed;
#line 418 "../src/librygel-server/rygel-media-resource.vala"
					_tmp129_ = g_string_append (_tmp127_, _tmp128_);
#line 418 "../src/librygel-server/rygel-media-resource.vala"
					g_string_append_unichar (_tmp129_, (gunichar) ',');
#line 417 "../src/librygel-server/rygel-media-resource.vala"
					_g_free0 (speed);
#line 2068 "rygel-media-resource.c"
				}
			}
		}
#line 420 "../src/librygel-server/rygel-media-resource.vala"
		_tmp130_ = strbuf;
#line 420 "../src/librygel-server/rygel-media-resource.vala"
		_tmp131_ = strbuf;
#line 420 "../src/librygel-server/rygel-media-resource.vala"
		g_string_overwrite (_tmp130_, (gsize) (_tmp131_->len - 1), "]");
#line 2078 "rygel-media-resource.c"
	}
#line 422 "../src/librygel-server/rygel-media-resource.vala"
	_tmp133_ = self->priv->_uri;
#line 422 "../src/librygel-server/rygel-media-resource.vala"
	if (_tmp133_ == NULL) {
#line 422 "../src/librygel-server/rygel-media-resource.vala"
		_tmp132_ = "null";
#line 2086 "rygel-media-resource.c"
	} else {
		const gchar* _tmp134_;
#line 422 "../src/librygel-server/rygel-media-resource.vala"
		_tmp134_ = self->priv->_uri;
#line 422 "../src/librygel-server/rygel-media-resource.vala"
		_tmp132_ = _tmp134_;
#line 2093 "rygel-media-resource.c"
	}
#line 422 "../src/librygel-server/rygel-media-resource.vala"
	_tmp135_ = strbuf;
#line 422 "../src/librygel-server/rygel-media-resource.vala"
	_tmp136_ = g_string_append (_tmp135_, ",uri ");
#line 422 "../src/librygel-server/rygel-media-resource.vala"
	g_string_append (_tmp136_, _tmp132_);
#line 423 "../src/librygel-server/rygel-media-resource.vala"
	_tmp137_ = strbuf;
#line 423 "../src/librygel-server/rygel-media-resource.vala"
	g_string_append_unichar (_tmp137_, (gunichar) ')');
#line 425 "../src/librygel-server/rygel-media-resource.vala"
	_tmp138_ = strbuf;
#line 425 "../src/librygel-server/rygel-media-resource.vala"
	_tmp139_ = _tmp138_->str;
#line 425 "../src/librygel-server/rygel-media-resource.vala"
	_tmp140_ = g_strdup (_tmp139_);
#line 425 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp140_;
#line 425 "../src/librygel-server/rygel-media-resource.vala"
	_g_string_free0 (strbuf);
#line 425 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2117 "rygel-media-resource.c"
}

const gchar*
rygel_media_resource_get_uri (RygelMediaResource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_uri;
#line 33 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0_;
#line 33 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2133 "rygel-media-resource.c"
}

void
rygel_media_resource_set_uri (RygelMediaResource* self,
                              const gchar* value)
{
	gchar* old_value;
#line 33 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_uri (self);
#line 33 "../src/librygel-server/rygel-media-resource.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2147 "rygel-media-resource.c"
		gchar* _tmp0_;
#line 33 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (self->priv->_uri);
#line 33 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_uri = _tmp0_;
#line 33 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_URI_PROPERTY]);
#line 2157 "rygel-media-resource.c"
	}
}

const gchar*
rygel_media_resource_get_import_uri (RygelMediaResource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_import_uri;
#line 34 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0_;
#line 34 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2174 "rygel-media-resource.c"
}

void
rygel_media_resource_set_import_uri (RygelMediaResource* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 34 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_import_uri (self);
#line 34 "../src/librygel-server/rygel-media-resource.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2188 "rygel-media-resource.c"
		gchar* _tmp0_;
#line 34 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (self->priv->_import_uri);
#line 34 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_import_uri = _tmp0_;
#line 34 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_IMPORT_URI_PROPERTY]);
#line 2198 "rygel-media-resource.c"
	}
}

const gchar*
rygel_media_resource_get_extension (RygelMediaResource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_extension;
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0_;
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2215 "rygel-media-resource.c"
}

void
rygel_media_resource_set_extension (RygelMediaResource* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_extension (self);
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2229 "rygel-media-resource.c"
		gchar* _tmp0_;
#line 35 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (self->priv->_extension);
#line 35 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_extension = _tmp0_;
#line 35 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_EXTENSION_PROPERTY]);
#line 2239 "rygel-media-resource.c"
	}
}

gint64
rygel_media_resource_get_size (RygelMediaResource* self)
{
	gint64 result;
#line 36 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 36 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_size;
#line 36 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2253 "rygel-media-resource.c"
}

void
rygel_media_resource_set_size (RygelMediaResource* self,
                               gint64 value)
{
	gint64 old_value;
#line 36 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_size (self);
#line 36 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 36 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_size = value;
#line 36 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_SIZE_PROPERTY]);
#line 2271 "rygel-media-resource.c"
	}
}

gint64
rygel_media_resource_get_cleartext_size (RygelMediaResource* self)
{
	gint64 result;
#line 37 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 37 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_cleartext_size;
#line 37 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2285 "rygel-media-resource.c"
}

void
rygel_media_resource_set_cleartext_size (RygelMediaResource* self,
                                         gint64 value)
{
	gint64 old_value;
#line 37 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_cleartext_size (self);
#line 37 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 37 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_cleartext_size = value;
#line 37 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_CLEARTEXT_SIZE_PROPERTY]);
#line 2303 "rygel-media-resource.c"
	}
}

glong
rygel_media_resource_get_duration (RygelMediaResource* self)
{
	glong result;
#line 38 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0L);
#line 38 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_duration;
#line 38 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2317 "rygel-media-resource.c"
}

void
rygel_media_resource_set_duration (RygelMediaResource* self,
                                   glong value)
{
	glong old_value;
#line 38 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_duration (self);
#line 38 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 38 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_duration = value;
#line 38 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DURATION_PROPERTY]);
#line 2335 "rygel-media-resource.c"
	}
}

gint
rygel_media_resource_get_bitrate (RygelMediaResource* self)
{
	gint result;
#line 39 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_bitrate;
#line 39 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2349 "rygel-media-resource.c"
}

void
rygel_media_resource_set_bitrate (RygelMediaResource* self,
                                  gint value)
{
	gint old_value;
#line 39 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_bitrate (self);
#line 39 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 39 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_bitrate = value;
#line 39 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_BITRATE_PROPERTY]);
#line 2367 "rygel-media-resource.c"
	}
}

gint
rygel_media_resource_get_bits_per_sample (RygelMediaResource* self)
{
	gint result;
#line 40 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_bits_per_sample;
#line 40 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2381 "rygel-media-resource.c"
}

void
rygel_media_resource_set_bits_per_sample (RygelMediaResource* self,
                                          gint value)
{
	gint old_value;
#line 40 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_bits_per_sample (self);
#line 40 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 40 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_bits_per_sample = value;
#line 40 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_BITS_PER_SAMPLE_PROPERTY]);
#line 2399 "rygel-media-resource.c"
	}
}

gint
rygel_media_resource_get_color_depth (RygelMediaResource* self)
{
	gint result;
#line 41 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_color_depth;
#line 41 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2413 "rygel-media-resource.c"
}

void
rygel_media_resource_set_color_depth (RygelMediaResource* self,
                                      gint value)
{
	gint old_value;
#line 41 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_color_depth (self);
#line 41 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 41 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_color_depth = value;
#line 41 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_COLOR_DEPTH_PROPERTY]);
#line 2431 "rygel-media-resource.c"
	}
}

gint
rygel_media_resource_get_width (RygelMediaResource* self)
{
	gint result;
#line 42 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_width;
#line 42 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2445 "rygel-media-resource.c"
}

void
rygel_media_resource_set_width (RygelMediaResource* self,
                                gint value)
{
	gint old_value;
#line 42 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_width (self);
#line 42 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 42 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_width = value;
#line 42 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_WIDTH_PROPERTY]);
#line 2463 "rygel-media-resource.c"
	}
}

gint
rygel_media_resource_get_height (RygelMediaResource* self)
{
	gint result;
#line 43 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_height;
#line 43 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2477 "rygel-media-resource.c"
}

void
rygel_media_resource_set_height (RygelMediaResource* self,
                                 gint value)
{
	gint old_value;
#line 43 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_height (self);
#line 43 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 43 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_height = value;
#line 43 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_HEIGHT_PROPERTY]);
#line 2495 "rygel-media-resource.c"
	}
}

gint
rygel_media_resource_get_audio_channels (RygelMediaResource* self)
{
	gint result;
#line 44 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_audio_channels;
#line 44 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2509 "rygel-media-resource.c"
}

void
rygel_media_resource_set_audio_channels (RygelMediaResource* self,
                                         gint value)
{
	gint old_value;
#line 44 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_audio_channels (self);
#line 44 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 44 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_audio_channels = value;
#line 44 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_AUDIO_CHANNELS_PROPERTY]);
#line 2527 "rygel-media-resource.c"
	}
}

gint
rygel_media_resource_get_sample_freq (RygelMediaResource* self)
{
	gint result;
#line 45 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_sample_freq;
#line 45 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2541 "rygel-media-resource.c"
}

void
rygel_media_resource_set_sample_freq (RygelMediaResource* self,
                                      gint value)
{
	gint old_value;
#line 45 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_sample_freq (self);
#line 45 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 45 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_sample_freq = value;
#line 45 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_SAMPLE_FREQ_PROPERTY]);
#line 2559 "rygel-media-resource.c"
	}
}

const gchar*
rygel_media_resource_get_protocol (RygelMediaResource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_protocol;
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0_;
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2576 "rygel-media-resource.c"
}

void
rygel_media_resource_set_protocol (RygelMediaResource* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_protocol (self);
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2590 "rygel-media-resource.c"
		gchar* _tmp0_;
#line 48 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = g_strdup (value);
#line 48 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (self->priv->_protocol);
#line 48 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_protocol = _tmp0_;
#line 48 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_PROTOCOL_PROPERTY]);
#line 2600 "rygel-media-resource.c"
	}
}

const gchar*
rygel_media_resource_get_mime_type (RygelMediaResource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_mime_type;
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0_;
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2617 "rygel-media-resource.c"
}

void
rygel_media_resource_set_mime_type (RygelMediaResource* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_mime_type (self);
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2631 "rygel-media-resource.c"
		gchar* _tmp0_;
#line 49 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (self->priv->_mime_type);
#line 49 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_mime_type = _tmp0_;
#line 49 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_MIME_TYPE_PROPERTY]);
#line 2641 "rygel-media-resource.c"
	}
}

const gchar*
rygel_media_resource_get_dlna_profile (RygelMediaResource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_dlna_profile;
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0_;
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2658 "rygel-media-resource.c"
}

void
rygel_media_resource_set_dlna_profile (RygelMediaResource* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_dlna_profile (self);
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2672 "rygel-media-resource.c"
		gchar* _tmp0_;
#line 50 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (self->priv->_dlna_profile);
#line 50 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_dlna_profile = _tmp0_;
#line 50 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DLNA_PROFILE_PROPERTY]);
#line 2682 "rygel-media-resource.c"
	}
}

const gchar*
rygel_media_resource_get_network (RygelMediaResource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	_tmp0_ = self->priv->_network;
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	result = _tmp0_;
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2699 "rygel-media-resource.c"
}

void
rygel_media_resource_set_network (RygelMediaResource* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_network (self);
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2713 "rygel-media-resource.c"
		gchar* _tmp0_;
#line 51 "../src/librygel-server/rygel-media-resource.vala"
		_tmp0_ = g_strdup (value);
#line 51 "../src/librygel-server/rygel-media-resource.vala"
		_g_free0 (self->priv->_network);
#line 51 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_network = _tmp0_;
#line 51 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_NETWORK_PROPERTY]);
#line 2723 "rygel-media-resource.c"
	}
}

GUPnPDLNAConversion
rygel_media_resource_get_dlna_conversion (RygelMediaResource* self)
{
	GUPnPDLNAConversion result;
#line 53 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 53 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_dlna_conversion;
#line 53 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2737 "rygel-media-resource.c"
}

void
rygel_media_resource_set_dlna_conversion (RygelMediaResource* self,
                                          GUPnPDLNAConversion value)
{
	GUPnPDLNAConversion old_value;
#line 53 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_dlna_conversion (self);
#line 53 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 53 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_dlna_conversion = value;
#line 53 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DLNA_CONVERSION_PROPERTY]);
#line 2755 "rygel-media-resource.c"
	}
}

GUPnPDLNAFlags
rygel_media_resource_get_dlna_flags (RygelMediaResource* self)
{
	GUPnPDLNAFlags result;
#line 55 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 55 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_dlna_flags;
#line 55 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2769 "rygel-media-resource.c"
}

void
rygel_media_resource_set_dlna_flags (RygelMediaResource* self,
                                     GUPnPDLNAFlags value)
{
	GUPnPDLNAFlags old_value;
#line 55 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_dlna_flags (self);
#line 55 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 55 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_dlna_flags = value;
#line 55 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DLNA_FLAGS_PROPERTY]);
#line 2787 "rygel-media-resource.c"
	}
}

GUPnPDLNAOperation
rygel_media_resource_get_dlna_operation (RygelMediaResource* self)
{
	GUPnPDLNAOperation result;
#line 56 "../src/librygel-server/rygel-media-resource.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 56 "../src/librygel-server/rygel-media-resource.vala"
	result = self->priv->_dlna_operation;
#line 56 "../src/librygel-server/rygel-media-resource.vala"
	return result;
#line 2801 "rygel-media-resource.c"
}

void
rygel_media_resource_set_dlna_operation (RygelMediaResource* self,
                                         GUPnPDLNAOperation value)
{
	GUPnPDLNAOperation old_value;
#line 56 "../src/librygel-server/rygel-media-resource.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/librygel-server/rygel-media-resource.vala"
	old_value = rygel_media_resource_get_dlna_operation (self);
#line 56 "../src/librygel-server/rygel-media-resource.vala"
	if (old_value != value) {
#line 56 "../src/librygel-server/rygel-media-resource.vala"
		self->priv->_dlna_operation = value;
#line 56 "../src/librygel-server/rygel-media-resource.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DLNA_OPERATION_PROPERTY]);
#line 2819 "rygel-media-resource.c"
	}
}

static void
rygel_media_resource_class_init (RygelMediaResourceClass * klass,
                                 gpointer klass_data)
{
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	rygel_media_resource_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_type_class_adjust_private_offset (klass, &RygelMediaResource_private_offset);
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_media_resource_get_property;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_media_resource_set_property;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_media_resource_finalize;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_URI_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_IMPORT_URI_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_IMPORT_URI_PROPERTY] = g_param_spec_string ("import-uri", "import-uri", "import-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_EXTENSION_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_EXTENSION_PROPERTY] = g_param_spec_string ("extension", "extension", "extension", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_SIZE_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_SIZE_PROPERTY] = g_param_spec_int64 ("size", "size", "size", G_MININT64, G_MAXINT64, (gint64) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_CLEARTEXT_SIZE_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_CLEARTEXT_SIZE_PROPERTY] = g_param_spec_int64 ("cleartext-size", "cleartext-size", "cleartext-size", G_MININT64, G_MAXINT64, (gint64) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_DURATION_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DURATION_PROPERTY] = g_param_spec_long ("duration", "duration", "duration", G_MINLONG, G_MAXLONG, (glong) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_BITRATE_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_BITRATE_PROPERTY] = g_param_spec_int ("bitrate", "bitrate", "bitrate", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_BITS_PER_SAMPLE_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_BITS_PER_SAMPLE_PROPERTY] = g_param_spec_int ("bits-per-sample", "bits-per-sample", "bits-per-sample", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_COLOR_DEPTH_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_COLOR_DEPTH_PROPERTY] = g_param_spec_int ("color-depth", "color-depth", "color-depth", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_WIDTH_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_HEIGHT_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_AUDIO_CHANNELS_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_AUDIO_CHANNELS_PROPERTY] = g_param_spec_int ("audio-channels", "audio-channels", "audio-channels", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_SAMPLE_FREQ_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_SAMPLE_FREQ_PROPERTY] = g_param_spec_int ("sample-freq", "sample-freq", "sample-freq", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_PROTOCOL_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_PROTOCOL_PROPERTY] = g_param_spec_string ("protocol", "protocol", "protocol", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_MIME_TYPE_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_MIME_TYPE_PROPERTY] = g_param_spec_string ("mime-type", "mime-type", "mime-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_DLNA_PROFILE_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DLNA_PROFILE_PROPERTY] = g_param_spec_string ("dlna-profile", "dlna-profile", "dlna-profile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_NETWORK_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_NETWORK_PROPERTY] = g_param_spec_string ("network", "network", "network", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_DLNA_CONVERSION_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DLNA_CONVERSION_PROPERTY] = g_param_spec_flags ("dlna-conversion", "dlna-conversion", "dlna-conversion", gupnp_dlna_conversion_get_type (), GUPNP_DLNA_CONVERSION_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_DLNA_FLAGS_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DLNA_FLAGS_PROPERTY] = g_param_spec_flags ("dlna-flags", "dlna-flags", "dlna-flags", gupnp_dlna_flags_get_type (), GUPNP_DLNA_FLAGS_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_RESOURCE_DLNA_OPERATION_PROPERTY, rygel_media_resource_properties[RYGEL_MEDIA_RESOURCE_DLNA_OPERATION_PROPERTY] = g_param_spec_flags ("dlna-operation", "dlna-operation", "dlna-operation", gupnp_dlna_operation_get_type (), GUPNP_DLNA_OPERATION_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2877 "rygel-media-resource.c"
}

static void
rygel_media_resource_instance_init (RygelMediaResource * self,
                                    gpointer klass)
{
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	self->priv = rygel_media_resource_get_instance_private (self);
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_extension = NULL;
#line 36 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_size = (gint64) -1;
#line 37 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_cleartext_size = (gint64) -1;
#line 38 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_duration = (glong) -1;
#line 39 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_bitrate = -1;
#line 40 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_bits_per_sample = -1;
#line 41 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_color_depth = -1;
#line 42 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_width = -1;
#line 43 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_height = -1;
#line 44 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_audio_channels = -1;
#line 45 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_sample_freq = -1;
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_protocol = NULL;
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_mime_type = NULL;
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_dlna_profile = NULL;
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_network = NULL;
#line 52 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds = NULL;
#line 52 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds_length1 = 0;
#line 53 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_dlna_conversion = GUPNP_DLNA_CONVERSION_NONE;
#line 55 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_dlna_flags = GUPNP_DLNA_FLAGS_NONE;
#line 56 "../src/librygel-server/rygel-media-resource.vala"
	self->priv->_dlna_operation = GUPNP_DLNA_OPERATION_NONE;
#line 2926 "rygel-media-resource.c"
}

static void
rygel_media_resource_finalize (GObject * obj)
{
	RygelMediaResource * self;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_MEDIA_RESOURCE, RygelMediaResource);
#line 30 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->name);
#line 33 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->_uri);
#line 34 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->_import_uri);
#line 35 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->_extension);
#line 48 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->_protocol);
#line 49 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->_mime_type);
#line 50 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->_dlna_profile);
#line 51 "../src/librygel-server/rygel-media-resource.vala"
	_g_free0 (self->priv->_network);
#line 52 "../src/librygel-server/rygel-media-resource.vala"
	self->play_speeds = (_vala_array_free (self->play_speeds, self->play_speeds_length1, (GDestroyNotify) g_free), NULL);
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	G_OBJECT_CLASS (rygel_media_resource_parent_class)->finalize (obj);
#line 2955 "rygel-media-resource.c"
}

/**
 * Represents a media resource (Music, Video, Image, etc).
 */
 G_GNUC_NO_INLINE static GType
rygel_media_resource_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelMediaResourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_resource_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaResource), 0, (GInstanceInitFunc) rygel_media_resource_instance_init, NULL };
	GType rygel_media_resource_type_id;
	rygel_media_resource_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelMediaResource", &g_define_type_info, 0);
	RygelMediaResource_private_offset = g_type_add_instance_private (rygel_media_resource_type_id, sizeof (RygelMediaResourcePrivate));
	return rygel_media_resource_type_id;
}

GType
rygel_media_resource_get_type (void)
{
	static volatile gsize rygel_media_resource_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_resource_type_id__once)) {
		GType rygel_media_resource_type_id;
		rygel_media_resource_type_id = rygel_media_resource_get_type_once ();
		g_once_init_leave (&rygel_media_resource_type_id__once, rygel_media_resource_type_id);
	}
	return rygel_media_resource_type_id__once;
}

static void
_vala_rygel_media_resource_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	RygelMediaResource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MEDIA_RESOURCE, RygelMediaResource);
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	switch (property_id) {
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_URI_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_string (value, rygel_media_resource_get_uri (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_IMPORT_URI_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_string (value, rygel_media_resource_get_import_uri (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_EXTENSION_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_string (value, rygel_media_resource_get_extension (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_SIZE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int64 (value, rygel_media_resource_get_size (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_CLEARTEXT_SIZE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int64 (value, rygel_media_resource_get_cleartext_size (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DURATION_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_long (value, rygel_media_resource_get_duration (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_BITRATE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int (value, rygel_media_resource_get_bitrate (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_BITS_PER_SAMPLE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int (value, rygel_media_resource_get_bits_per_sample (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_COLOR_DEPTH_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int (value, rygel_media_resource_get_color_depth (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_WIDTH_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int (value, rygel_media_resource_get_width (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_HEIGHT_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int (value, rygel_media_resource_get_height (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_AUDIO_CHANNELS_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int (value, rygel_media_resource_get_audio_channels (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_SAMPLE_FREQ_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_int (value, rygel_media_resource_get_sample_freq (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_PROTOCOL_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_string (value, rygel_media_resource_get_protocol (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_MIME_TYPE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_string (value, rygel_media_resource_get_mime_type (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DLNA_PROFILE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_string (value, rygel_media_resource_get_dlna_profile (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_NETWORK_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_string (value, rygel_media_resource_get_network (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DLNA_CONVERSION_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_flags (value, rygel_media_resource_get_dlna_conversion (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DLNA_FLAGS_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_flags (value, rygel_media_resource_get_dlna_flags (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DLNA_OPERATION_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		g_value_set_flags (value, rygel_media_resource_get_dlna_operation (self));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 3113 "rygel-media-resource.c"
		default:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 3119 "rygel-media-resource.c"
	}
}

static void
_vala_rygel_media_resource_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	RygelMediaResource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MEDIA_RESOURCE, RygelMediaResource);
#line 29 "../src/librygel-server/rygel-media-resource.vala"
	switch (property_id) {
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_URI_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_uri (self, g_value_get_string (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_IMPORT_URI_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_import_uri (self, g_value_get_string (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_EXTENSION_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_extension (self, g_value_get_string (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_SIZE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_size (self, g_value_get_int64 (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_CLEARTEXT_SIZE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_cleartext_size (self, g_value_get_int64 (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DURATION_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_duration (self, g_value_get_long (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_BITRATE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_bitrate (self, g_value_get_int (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_BITS_PER_SAMPLE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_bits_per_sample (self, g_value_get_int (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_COLOR_DEPTH_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_color_depth (self, g_value_get_int (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_WIDTH_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_width (self, g_value_get_int (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_HEIGHT_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_height (self, g_value_get_int (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_AUDIO_CHANNELS_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_audio_channels (self, g_value_get_int (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_SAMPLE_FREQ_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_sample_freq (self, g_value_get_int (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_PROTOCOL_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_protocol (self, g_value_get_string (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_MIME_TYPE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_mime_type (self, g_value_get_string (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DLNA_PROFILE_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_dlna_profile (self, g_value_get_string (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_NETWORK_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_network (self, g_value_get_string (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DLNA_CONVERSION_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_dlna_conversion (self, g_value_get_flags (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DLNA_FLAGS_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_dlna_flags (self, g_value_get_flags (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		case RYGEL_MEDIA_RESOURCE_DLNA_OPERATION_PROPERTY:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		rygel_media_resource_set_dlna_operation (self, g_value_get_flags (value));
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 3253 "rygel-media-resource.c"
		default:
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/librygel-server/rygel-media-resource.vala"
		break;
#line 3259 "rygel-media-resource.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

