/* rygel-object-removal-queue.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-object-removal-queue.vala, do not modify */

/*
 * Copyright (C) 2010 Nokia Corporation.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "rygel-server.h"
#include <gio/gio.h>

#define RYGEL_OBJECT_REMOVAL_QUEUE_TIMEOUT ((guint) 35)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_OBJECT_REMOVAL_QUEUE (rygel_object_removal_queue_get_type ())
#define RYGEL_OBJECT_REMOVAL_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_OBJECT_REMOVAL_QUEUE, RygelObjectRemovalQueue))
#define RYGEL_OBJECT_REMOVAL_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_OBJECT_REMOVAL_QUEUE, RygelObjectRemovalQueueClass))
#define RYGEL_IS_OBJECT_REMOVAL_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_OBJECT_REMOVAL_QUEUE))
#define RYGEL_IS_OBJECT_REMOVAL_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_OBJECT_REMOVAL_QUEUE))
#define RYGEL_OBJECT_REMOVAL_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_OBJECT_REMOVAL_QUEUE, RygelObjectRemovalQueueClass))

typedef struct _RygelObjectRemovalQueue RygelObjectRemovalQueue;
typedef struct _RygelObjectRemovalQueueClass RygelObjectRemovalQueueClass;
typedef struct _RygelObjectRemovalQueuePrivate RygelObjectRemovalQueuePrivate;
enum  {
	RYGEL_OBJECT_REMOVAL_QUEUE_0_PROPERTY,
	RYGEL_OBJECT_REMOVAL_QUEUE_NUM_PROPERTIES
};
static GParamSpec* rygel_object_removal_queue_properties[RYGEL_OBJECT_REMOVAL_QUEUE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _RygelObjectRemovalQueueRemoveNowData RygelObjectRemovalQueueRemoveNowData;

struct _RygelObjectRemovalQueue {
	GObject parent_instance;
	RygelObjectRemovalQueuePrivate * priv;
};

struct _RygelObjectRemovalQueueClass {
	GObjectClass parent_class;
};

struct _RygelObjectRemovalQueuePrivate {
	GeeHashMap* object_timeouts;
};

struct _Block10Data {
	int _ref_count_;
	RygelObjectRemovalQueue* self;
	RygelMediaObject* object;
	GCancellable* cancellable;
};

struct _RygelObjectRemovalQueueRemoveNowData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelObjectRemovalQueue* self;
	RygelMediaObject* object;
	GCancellable* cancellable;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	RygelWritableContainer* parent;
	RygelMediaContainer* _tmp3_;
	RygelMediaContainer* _tmp4_;
	RygelWritableContainer* _tmp5_;
	RygelWritableContainer* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	RygelWritableContainer* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GError* err;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GError* _tmp16_;
	const gchar* _tmp17_;
	GError* _inner_error0_;
};

static gint RygelObjectRemovalQueue_private_offset;
static gpointer rygel_object_removal_queue_parent_class = NULL;
static RygelObjectRemovalQueue* rygel_object_removal_queue_removal_queue;
static RygelObjectRemovalQueue* rygel_object_removal_queue_removal_queue = NULL;

VALA_EXTERN GType rygel_object_removal_queue_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelObjectRemovalQueue* rygel_object_removal_queue_get_default (void);
static RygelObjectRemovalQueue* rygel_object_removal_queue_new (void);
static RygelObjectRemovalQueue* rygel_object_removal_queue_construct (GType object_type);
VALA_EXTERN void rygel_object_removal_queue_queue (RygelObjectRemovalQueue* self,
                                       RygelMediaObject* object,
                                       GCancellable* cancellable);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block10Data* _data10_);
VALA_EXTERN void rygel_object_removal_queue_remove_now (RygelObjectRemovalQueue* self,
                                            RygelMediaObject* object,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void rygel_object_removal_queue_remove_now_finish (RygelObjectRemovalQueue* self,
                                                   GAsyncResult* _res_);
static gboolean ___lambda7__gsource_func (gpointer self);
VALA_EXTERN gboolean rygel_object_removal_queue_dequeue (RygelObjectRemovalQueue* self,
                                             RygelMediaObject* object);
static void rygel_object_removal_queue_remove_now_data_free (gpointer _data);
static gboolean rygel_object_removal_queue_remove_now_co (RygelObjectRemovalQueueRemoveNowData* _data_);
static void rygel_object_removal_queue_remove_now_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void rygel_object_removal_queue_finalize (GObject * obj);
static GType rygel_object_removal_queue_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rygel_object_removal_queue_get_instance_private (RygelObjectRemovalQueue* self)
{
	return G_STRUCT_MEMBER_P (self, RygelObjectRemovalQueue_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../src/librygel-server/rygel-object-removal-queue.vala"
	return self ? g_object_ref (self) : NULL;
#line 162 "rygel-object-removal-queue.c"
}

RygelObjectRemovalQueue*
rygel_object_removal_queue_get_default (void)
{
	RygelObjectRemovalQueue* _tmp0_;
	RygelObjectRemovalQueue* _tmp2_;
	RygelObjectRemovalQueue* _tmp3_;
	RygelObjectRemovalQueue* result;
#line 38 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp0_ = rygel_object_removal_queue_removal_queue;
#line 38 "../src/librygel-server/rygel-object-removal-queue.vala"
	if (G_UNLIKELY (_tmp0_ == NULL)) {
#line 176 "rygel-object-removal-queue.c"
		RygelObjectRemovalQueue* _tmp1_;
#line 39 "../src/librygel-server/rygel-object-removal-queue.vala"
		_tmp1_ = rygel_object_removal_queue_new ();
#line 39 "../src/librygel-server/rygel-object-removal-queue.vala"
		_g_object_unref0 (rygel_object_removal_queue_removal_queue);
#line 39 "../src/librygel-server/rygel-object-removal-queue.vala"
		rygel_object_removal_queue_removal_queue = _tmp1_;
#line 184 "rygel-object-removal-queue.c"
	}
#line 42 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp2_ = rygel_object_removal_queue_removal_queue;
#line 42 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 42 "../src/librygel-server/rygel-object-removal-queue.vala"
	result = _tmp3_;
#line 42 "../src/librygel-server/rygel-object-removal-queue.vala"
	return result;
#line 194 "rygel-object-removal-queue.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	return _data10_;
#line 204 "rygel-object-removal-queue.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 214 "rygel-object-removal-queue.c"
		RygelObjectRemovalQueue* self;
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
		self = _data10_->self;
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
		_g_object_unref0 (_data10_->object);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
		_g_object_unref0 (_data10_->cancellable);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
		_g_object_unref0 (self);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
		g_slice_free (Block10Data, _data10_);
#line 226 "rygel-object-removal-queue.c"
	}
}

static gboolean
__lambda7_ (Block10Data* _data10_)
{
	RygelObjectRemovalQueue* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 50 "../src/librygel-server/rygel-object-removal-queue.vala"
	self = _data10_->self;
#line 51 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp0_ = rygel_media_object_get_id (_data10_->object);
#line 51 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_debug ("rygel-object-removal-queue.vala:51: Timeout on temporary object '%s'.", _tmp1_);
#line 52 "../src/librygel-server/rygel-object-removal-queue.vala"
	rygel_object_removal_queue_remove_now (self, _data10_->object, _data10_->cancellable, NULL, NULL);
#line 54 "../src/librygel-server/rygel-object-removal-queue.vala"
	result = FALSE;
#line 54 "../src/librygel-server/rygel-object-removal-queue.vala"
	return result;
#line 251 "rygel-object-removal-queue.c"
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ (self);
#line 50 "../src/librygel-server/rygel-object-removal-queue.vala"
	return result;
#line 261 "rygel-object-removal-queue.c"
}

void
rygel_object_removal_queue_queue (RygelObjectRemovalQueue* self,
                                  RygelMediaObject* object,
                                  GCancellable* cancellable)
{
	Block10Data* _data10_;
	RygelMediaObject* _tmp0_;
	GCancellable* _tmp1_;
	RygelMediaContainer* _tmp2_;
	RygelMediaContainer* _tmp3_;
	guint timeout = 0U;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_return_if_fail (object != NULL);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data10_->_ref_count_ = 1;
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data10_->self = g_object_ref (self);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (_data10_->object);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data10_->object = _tmp0_;
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (_data10_->cancellable);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data10_->cancellable = _tmp1_;
#line 46 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp2_ = rygel_media_object_get_parent_ref (_data10_->object);
#line 46 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp3_ = _tmp2_;
#line 46 "../src/librygel-server/rygel-object-removal-queue.vala"
	if (_tmp3_ == NULL) {
#line 306 "rygel-object-removal-queue.c"
		RygelMediaContainer* _tmp4_;
		RygelMediaContainer* _tmp5_;
#line 47 "../src/librygel-server/rygel-object-removal-queue.vala"
		_tmp4_ = rygel_media_object_get_parent (_data10_->object);
#line 47 "../src/librygel-server/rygel-object-removal-queue.vala"
		_tmp5_ = _tmp4_;
#line 47 "../src/librygel-server/rygel-object-removal-queue.vala"
		rygel_media_object_set_parent_ref (_data10_->object, _tmp5_);
#line 315 "rygel-object-removal-queue.c"
	}
#line 50 "../src/librygel-server/rygel-object-removal-queue.vala"
	timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, RYGEL_OBJECT_REMOVAL_QUEUE_TIMEOUT, ___lambda7__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 57 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp6_ = self->priv->object_timeouts;
#line 57 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp7_ = rygel_media_object_get_id (_data10_->object);
#line 57 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp8_ = _tmp7_;
#line 57 "../src/librygel-server/rygel-object-removal-queue.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp8_, (gpointer) ((guintptr) timeout));
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	block10_data_unref (_data10_);
#line 45 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data10_ = NULL;
#line 331 "rygel-object-removal-queue.c"
}

gboolean
rygel_object_removal_queue_dequeue (RygelObjectRemovalQueue* self,
                                    RygelMediaObject* object)
{
	guint timeout = 0U;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gpointer _tmp3_ = NULL;
	gboolean _tmp4_;
	gboolean result;
#line 60 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 63 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp0_ = self->priv->object_timeouts;
#line 63 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp1_ = rygel_media_object_get_id (object);
#line 63 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp2_ = _tmp1_;
#line 63 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp4_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _tmp2_, &_tmp3_);
#line 63 "../src/librygel-server/rygel-object-removal-queue.vala"
	timeout = (guint) ((guintptr) _tmp3_);
#line 63 "../src/librygel-server/rygel-object-removal-queue.vala"
	if (_tmp4_) {
#line 64 "../src/librygel-server/rygel-object-removal-queue.vala"
		g_source_remove (timeout);
#line 66 "../src/librygel-server/rygel-object-removal-queue.vala"
		result = TRUE;
#line 66 "../src/librygel-server/rygel-object-removal-queue.vala"
		return result;
#line 367 "rygel-object-removal-queue.c"
	} else {
#line 68 "../src/librygel-server/rygel-object-removal-queue.vala"
		result = FALSE;
#line 68 "../src/librygel-server/rygel-object-removal-queue.vala"
		return result;
#line 373 "rygel-object-removal-queue.c"
	}
}

static void
rygel_object_removal_queue_remove_now_data_free (gpointer _data)
{
	RygelObjectRemovalQueueRemoveNowData* _data_;
	_data_ = _data;
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (_data_->object);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (_data_->cancellable);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_slice_free (RygelObjectRemovalQueueRemoveNowData, _data_);
#line 390 "rygel-object-removal-queue.c"
}

void
rygel_object_removal_queue_remove_now (RygelObjectRemovalQueue* self,
                                       RygelMediaObject* object,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	RygelObjectRemovalQueueRemoveNowData* _data_;
	RygelObjectRemovalQueue* _tmp0_;
	RygelMediaObject* _tmp1_;
	GCancellable* _tmp2_;
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_return_if_fail (object != NULL);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_ = g_slice_new0 (RygelObjectRemovalQueueRemoveNowData);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_object_removal_queue_remove_now_data_free);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->self = _tmp0_;
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp1_ = _g_object_ref0 (object);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (_data_->object);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->object = _tmp1_;
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (_data_->cancellable);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->cancellable = _tmp2_;
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	rygel_object_removal_queue_remove_now_co (_data_);
#line 432 "rygel-object-removal-queue.c"
}

void
rygel_object_removal_queue_remove_now_finish (RygelObjectRemovalQueue* self,
                                              GAsyncResult* _res_)
{
	RygelObjectRemovalQueueRemoveNowData* _data_;
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	if (NULL == _data_) {
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
		return;
#line 446 "rygel-object-removal-queue.c"
	}
}

static void
rygel_object_removal_queue_remove_now_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	RygelObjectRemovalQueueRemoveNowData* _data_;
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_ = _user_data_;
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_source_object_ = source_object;
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_res_ = _res_;
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
	rygel_object_removal_queue_remove_now_co (_data_);
#line 464 "rygel-object-removal-queue.c"
}

static gboolean
rygel_object_removal_queue_remove_now_co (RygelObjectRemovalQueueRemoveNowData* _data_)
{
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
	switch (_data_->_state_) {
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
		case 0:
#line 474 "rygel-object-removal-queue.c"
		goto _state_0;
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
		case 1:
#line 478 "rygel-object-removal-queue.c"
		goto _state_1;
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
		case 2:
#line 482 "rygel-object-removal-queue.c"
		goto _state_2;
		default:
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
		g_assert_not_reached ();
#line 487 "rygel-object-removal-queue.c"
	}
	_state_0:
#line 73 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_tmp0_ = _data_->self->priv->object_timeouts;
#line 73 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_tmp1_ = rygel_media_object_get_id (_data_->object);
#line 73 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 73 "../src/librygel-server/rygel-object-removal-queue.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _data_->_tmp0_, _data_->_tmp2_, NULL);
#line 75 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_tmp3_ = rygel_media_object_get_parent (_data_->object);
#line 75 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 75 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->_tmp5_ = _g_object_ref0 (RYGEL_IS_WRITABLE_CONTAINER (_data_->_tmp4_) ? ((RygelWritableContainer*) _data_->_tmp4_) : NULL);
#line 75 "../src/librygel-server/rygel-object-removal-queue.vala"
	_data_->parent = _data_->_tmp5_;
#line 506 "rygel-object-removal-queue.c"
	{
#line 78 "../src/librygel-server/rygel-object-removal-queue.vala"
		if (RYGEL_IS_MEDIA_ITEM (_data_->object)) {
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
			_data_->_tmp6_ = _data_->parent;
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
			_data_->_tmp7_ = rygel_media_object_get_id (_data_->object);
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
			_data_->_state_ = 1;
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
			rygel_writable_container_remove_item (_data_->_tmp6_, _data_->_tmp8_, _data_->cancellable, rygel_object_removal_queue_remove_now_ready, _data_);
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
			return FALSE;
#line 522 "rygel-object-removal-queue.c"
			_state_1:
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
			rygel_writable_container_remove_item_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 79 "../src/librygel-server/rygel-object-removal-queue.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 528 "rygel-object-removal-queue.c"
				goto __catch0_g_error;
			}
		} else {
#line 81 "../src/librygel-server/rygel-object-removal-queue.vala"
			_data_->_tmp9_ = _data_->parent;
#line 81 "../src/librygel-server/rygel-object-removal-queue.vala"
			_data_->_tmp10_ = rygel_media_object_get_id (_data_->object);
#line 81 "../src/librygel-server/rygel-object-removal-queue.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 81 "../src/librygel-server/rygel-object-removal-queue.vala"
			_data_->_state_ = 2;
#line 81 "../src/librygel-server/rygel-object-removal-queue.vala"
			rygel_writable_container_remove_container (_data_->_tmp9_, _data_->_tmp11_, _data_->cancellable, rygel_object_removal_queue_remove_now_ready, _data_);
#line 81 "../src/librygel-server/rygel-object-removal-queue.vala"
			return FALSE;
#line 544 "rygel-object-removal-queue.c"
			_state_2:
#line 81 "../src/librygel-server/rygel-object-removal-queue.vala"
			rygel_writable_container_remove_container_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
#line 81 "../src/librygel-server/rygel-object-removal-queue.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 550 "rygel-object-removal-queue.c"
				goto __catch0_g_error;
			}
		}
#line 84 "../src/librygel-server/rygel-object-removal-queue.vala"
		_data_->_tmp12_ = rygel_media_object_get_id (_data_->object);
#line 84 "../src/librygel-server/rygel-object-removal-queue.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 84 "../src/librygel-server/rygel-object-removal-queue.vala"
		g_debug ("rygel-object-removal-queue.vala:84: Auto-destroyed object '%s'!", _data_->_tmp13_);
#line 560 "rygel-object-removal-queue.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
		_data_->err = _data_->_inner_error0_;
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
		_data_->_inner_error0_ = NULL;
#line 86 "../src/librygel-server/rygel-object-removal-queue.vala"
		_data_->_tmp14_ = rygel_media_object_get_id (_data_->object);
#line 86 "../src/librygel-server/rygel-object-removal-queue.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 86 "../src/librygel-server/rygel-object-removal-queue.vala"
		_data_->_tmp16_ = _data_->err;
#line 86 "../src/librygel-server/rygel-object-removal-queue.vala"
		_data_->_tmp17_ = _data_->_tmp16_->message;
#line 86 "../src/librygel-server/rygel-object-removal-queue.vala"
		g_warning ("rygel-object-removal-queue.vala:86: Failed to auto-destroy temporary o" \
"bject '%s': %s", _data_->_tmp15_, _data_->_tmp17_);
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
		_g_error_free0 (_data_->err);
#line 581 "rygel-object-removal-queue.c"
	}
	__finally0:
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
		_g_object_unref0 (_data_->parent);
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
		g_object_unref (_data_->_async_result);
#line 77 "../src/librygel-server/rygel-object-removal-queue.vala"
		return FALSE;
#line 596 "rygel-object-removal-queue.c"
	}
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (_data_->parent);
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
	if (_data_->_state_ != 0) {
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 608 "rygel-object-removal-queue.c"
		}
	}
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_object_unref (_data_->_async_result);
#line 72 "../src/librygel-server/rygel-object-removal-queue.vala"
	return FALSE;
#line 615 "rygel-object-removal-queue.c"
}

static RygelObjectRemovalQueue*
rygel_object_removal_queue_construct (GType object_type)
{
	RygelObjectRemovalQueue * self = NULL;
	GeeHashMap* _tmp0_;
#line 92 "../src/librygel-server/rygel-object-removal-queue.vala"
	self = (RygelObjectRemovalQueue*) g_object_new (object_type, NULL);
#line 93 "../src/librygel-server/rygel-object-removal-queue.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 93 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (self->priv->object_timeouts);
#line 93 "../src/librygel-server/rygel-object-removal-queue.vala"
	self->priv->object_timeouts = _tmp0_;
#line 92 "../src/librygel-server/rygel-object-removal-queue.vala"
	return self;
#line 633 "rygel-object-removal-queue.c"
}

static RygelObjectRemovalQueue*
rygel_object_removal_queue_new (void)
{
#line 92 "../src/librygel-server/rygel-object-removal-queue.vala"
	return rygel_object_removal_queue_construct (RYGEL_TYPE_OBJECT_REMOVAL_QUEUE);
#line 641 "rygel-object-removal-queue.c"
}

static void
rygel_object_removal_queue_class_init (RygelObjectRemovalQueueClass * klass,
                                       gpointer klass_data)
{
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	rygel_object_removal_queue_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	g_type_class_adjust_private_offset (klass, &RygelObjectRemovalQueue_private_offset);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_object_removal_queue_finalize;
#line 654 "rygel-object-removal-queue.c"
}

static void
rygel_object_removal_queue_instance_init (RygelObjectRemovalQueue * self,
                                          gpointer klass)
{
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	self->priv = rygel_object_removal_queue_get_instance_private (self);
#line 663 "rygel-object-removal-queue.c"
}

static void
rygel_object_removal_queue_finalize (GObject * obj)
{
	RygelObjectRemovalQueue * self;
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_OBJECT_REMOVAL_QUEUE, RygelObjectRemovalQueue);
#line 35 "../src/librygel-server/rygel-object-removal-queue.vala"
	_g_object_unref0 (self->priv->object_timeouts);
#line 30 "../src/librygel-server/rygel-object-removal-queue.vala"
	G_OBJECT_CLASS (rygel_object_removal_queue_parent_class)->finalize (obj);
#line 676 "rygel-object-removal-queue.c"
}

/**
 * Queues objects for removal after 35 seconds or immediately.
 *
 * The 35s timeout comes from the DLNA documentation.
 */
 G_GNUC_NO_INLINE static GType
rygel_object_removal_queue_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelObjectRemovalQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_object_removal_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelObjectRemovalQueue), 0, (GInstanceInitFunc) rygel_object_removal_queue_instance_init, NULL };
	GType rygel_object_removal_queue_type_id;
	rygel_object_removal_queue_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelObjectRemovalQueue", &g_define_type_info, 0);
	RygelObjectRemovalQueue_private_offset = g_type_add_instance_private (rygel_object_removal_queue_type_id, sizeof (RygelObjectRemovalQueuePrivate));
	return rygel_object_removal_queue_type_id;
}

GType
rygel_object_removal_queue_get_type (void)
{
	static volatile gsize rygel_object_removal_queue_type_id__once = 0;
	if (g_once_init_enter (&rygel_object_removal_queue_type_id__once)) {
		GType rygel_object_removal_queue_type_id;
		rygel_object_removal_queue_type_id = rygel_object_removal_queue_get_type_once ();
		g_once_init_leave (&rygel_object_removal_queue_type_id__once, rygel_object_removal_queue_type_id);
	}
	return rygel_object_removal_queue_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

