/* rygel-photo-item.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-photo-item.vala, do not modify */

/*
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 * Copyright (C) 2010 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <libgupnp-av/gupnp-av.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_PHOTO_ITEM_0_PROPERTY,
	RYGEL_PHOTO_ITEM_NUM_PROPERTIES
};
static GParamSpec* rygel_photo_item_properties[RYGEL_PHOTO_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer rygel_photo_item_parent_class = NULL;

VALA_EXTERN gint rygel_media_object_compare_by_property (RygelMediaObject* self,
                                             RygelMediaObject* media_object,
                                             const gchar* property);
VALA_EXTERN void rygel_media_object_apply_didl_lite (RygelMediaObject* self,
                                         GUPnPDIDLLiteObject* didl_object);
static gint rygel_photo_item_real_compare_by_property (RygelMediaObject* base,
                                                RygelMediaObject* media_object,
                                                const gchar* property);
static gchar* rygel_photo_item_get_first (RygelPhotoItem* self,
                                   GList* contributors);
static void rygel_photo_item_real_apply_didl_lite (RygelMediaObject* base,
                                            GUPnPDIDLLiteObject* didl_object);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GUPnPDIDLLiteObject* rygel_photo_item_real_serialize (RygelMediaObject* base,
                                                      RygelSerializer* serializer,
                                                      RygelHTTPServer* http_server,
                                                      GError** error);
static GType rygel_photo_item_get_type_once (void);

RygelPhotoItem*
rygel_photo_item_construct (GType object_type,
                            const gchar* id,
                            RygelMediaContainer* parent,
                            const gchar* title,
                            const gchar* upnp_class)
{
	RygelPhotoItem * self = NULL;
#line 36 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 36 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 36 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 36 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (upnp_class != NULL, NULL);
#line 40 "../src/librygel-server/rygel-photo-item.vala"
	self = (RygelPhotoItem*) g_object_new (object_type, "id", id, "parent", parent, "title", title, "upnp-class", upnp_class, NULL);
#line 36 "../src/librygel-server/rygel-photo-item.vala"
	return self;
#line 97 "rygel-photo-item.c"
}

RygelPhotoItem*
rygel_photo_item_new (const gchar* id,
                      RygelMediaContainer* parent,
                      const gchar* title,
                      const gchar* upnp_class)
{
#line 36 "../src/librygel-server/rygel-photo-item.vala"
	return rygel_photo_item_construct (RYGEL_TYPE_PHOTO_ITEM, id, parent, title, upnp_class);
#line 108 "rygel-photo-item.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/librygel-server/rygel-photo-item.vala"
	return self ? g_object_ref (self) : NULL;
#line 116 "rygel-photo-item.c"
}

static gint
rygel_photo_item_real_compare_by_property (RygelMediaObject* base,
                                           RygelMediaObject* media_object,
                                           const gchar* property)
{
	RygelPhotoItem * self;
	RygelPhotoItem* item = NULL;
	RygelPhotoItem* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	gint result;
#line 46 "../src/librygel-server/rygel-photo-item.vala"
	self = (RygelPhotoItem*) base;
#line 46 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (media_object != NULL, 0);
#line 46 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (property != NULL, 0);
#line 48 "../src/librygel-server/rygel-photo-item.vala"
	if (!RYGEL_IS_PHOTO_ITEM (media_object)) {
#line 49 "../src/librygel-server/rygel-photo-item.vala"
		result = 1;
#line 49 "../src/librygel-server/rygel-photo-item.vala"
		return result;
#line 142 "rygel-photo-item.c"
	}
#line 52 "../src/librygel-server/rygel-photo-item.vala"
	_tmp0_ = _g_object_ref0 (RYGEL_IS_PHOTO_ITEM (media_object) ? ((RygelPhotoItem*) media_object) : NULL);
#line 52 "../src/librygel-server/rygel-photo-item.vala"
	item = _tmp0_;
#line 54 "../src/librygel-server/rygel-photo-item.vala"
	_tmp1_ = property;
#line 54 "../src/librygel-server/rygel-photo-item.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 54 "../src/librygel-server/rygel-photo-item.vala"
	switch (0) {
#line 154 "rygel-photo-item.c"
		default:
		{
			RygelPhotoItem* _tmp4_;
#line 56 "../src/librygel-server/rygel-photo-item.vala"
			_tmp4_ = item;
#line 56 "../src/librygel-server/rygel-photo-item.vala"
			result = RYGEL_MEDIA_OBJECT_CLASS (rygel_photo_item_parent_class)->compare_by_property ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_IMAGE_ITEM, RygelImageItem), (RygelMediaObject*) _tmp4_, property);
#line 56 "../src/librygel-server/rygel-photo-item.vala"
			_g_object_unref0 (item);
#line 56 "../src/librygel-server/rygel-photo-item.vala"
			return result;
#line 166 "rygel-photo-item.c"
		}
	}
}

static gchar*
rygel_photo_item_get_first (RygelPhotoItem* self,
                            GList* contributors)
{
	gchar* _tmp4_;
	gchar* result;
#line 60 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/librygel-server/rygel-photo-item.vala"
	if (contributors != NULL) {
#line 181 "rygel-photo-item.c"
		gconstpointer _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 62 "../src/librygel-server/rygel-photo-item.vala"
		_tmp0_ = contributors->data;
#line 62 "../src/librygel-server/rygel-photo-item.vala"
		_tmp1_ = gupnp_didl_lite_contributor_get_name ((GUPnPDIDLLiteContributor*) _tmp0_);
#line 62 "../src/librygel-server/rygel-photo-item.vala"
		_tmp2_ = _tmp1_;
#line 62 "../src/librygel-server/rygel-photo-item.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 62 "../src/librygel-server/rygel-photo-item.vala"
		result = _tmp3_;
#line 62 "../src/librygel-server/rygel-photo-item.vala"
		return result;
#line 198 "rygel-photo-item.c"
	}
#line 65 "../src/librygel-server/rygel-photo-item.vala"
	_tmp4_ = g_strdup ("");
#line 65 "../src/librygel-server/rygel-photo-item.vala"
	result = _tmp4_;
#line 65 "../src/librygel-server/rygel-photo-item.vala"
	return result;
#line 206 "rygel-photo-item.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 214 "rygel-photo-item.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 222 "rygel-photo-item.c"
}

static void
rygel_photo_item_real_apply_didl_lite (RygelMediaObject* base,
                                       GUPnPDIDLLiteObject* didl_object)
{
	RygelPhotoItem * self;
	GList* _tmp0_;
	GList* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 68 "../src/librygel-server/rygel-photo-item.vala"
	self = (RygelPhotoItem*) base;
#line 68 "../src/librygel-server/rygel-photo-item.vala"
	g_return_if_fail (didl_object != NULL);
#line 69 "../src/librygel-server/rygel-photo-item.vala"
	RYGEL_MEDIA_OBJECT_CLASS (rygel_photo_item_parent_class)->apply_didl_lite ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_IMAGE_ITEM, RygelImageItem), didl_object);
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	_tmp0_ = gupnp_didl_lite_object_get_creators (didl_object);
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	_tmp1_ = _tmp0_;
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	_tmp2_ = rygel_photo_item_get_first (self, _tmp1_);
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	_tmp3_ = _tmp2_;
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	rygel_media_object_set_creator ((RygelMediaObject*) self, _tmp3_);
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	_g_free0 (_tmp3_);
#line 71 "../src/librygel-server/rygel-photo-item.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 254 "rygel-photo-item.c"
}

static GUPnPDIDLLiteObject*
rygel_photo_item_real_serialize (RygelMediaObject* base,
                                 RygelSerializer* serializer,
                                 RygelHTTPServer* http_server,
                                 GError** error)
{
	RygelPhotoItem * self;
	GUPnPDIDLLiteObject* didl_item = NULL;
	GUPnPDIDLLiteObject* _tmp0_;
	GError* _inner_error0_ = NULL;
	GUPnPDIDLLiteObject* result;
#line 74 "../src/librygel-server/rygel-photo-item.vala"
	self = (RygelPhotoItem*) base;
#line 74 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (serializer != NULL, NULL);
#line 74 "../src/librygel-server/rygel-photo-item.vala"
	g_return_val_if_fail (http_server != NULL, NULL);
#line 77 "../src/librygel-server/rygel-photo-item.vala"
	_tmp0_ = RYGEL_MEDIA_OBJECT_CLASS (rygel_photo_item_parent_class)->serialize ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_IMAGE_ITEM, RygelImageItem), serializer, http_server, &_inner_error0_);
#line 77 "../src/librygel-server/rygel-photo-item.vala"
	didl_item = _tmp0_;
#line 77 "../src/librygel-server/rygel-photo-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/librygel-server/rygel-photo-item.vala"
		g_propagate_error (error, _inner_error0_);
#line 77 "../src/librygel-server/rygel-photo-item.vala"
		return NULL;
#line 284 "rygel-photo-item.c"
	}
#line 79 "../src/librygel-server/rygel-photo-item.vala"
	result = didl_item;
#line 79 "../src/librygel-server/rygel-photo-item.vala"
	return result;
#line 290 "rygel-photo-item.c"
}

static void
rygel_photo_item_class_init (RygelPhotoItemClass * klass,
                             gpointer klass_data)
{
#line 33 "../src/librygel-server/rygel-photo-item.vala"
	rygel_photo_item_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/librygel-server/rygel-photo-item.vala"
	((RygelMediaObjectClass *) klass)->compare_by_property = (gint (*) (RygelMediaObject*, RygelMediaObject*, const gchar*)) rygel_photo_item_real_compare_by_property;
#line 33 "../src/librygel-server/rygel-photo-item.vala"
	((RygelMediaObjectClass *) klass)->apply_didl_lite = (void (*) (RygelMediaObject*, GUPnPDIDLLiteObject*)) rygel_photo_item_real_apply_didl_lite;
#line 33 "../src/librygel-server/rygel-photo-item.vala"
	((RygelMediaObjectClass *) klass)->serialize = (GUPnPDIDLLiteObject* (*) (RygelMediaObject*, RygelSerializer*, RygelHTTPServer*, GError**)) rygel_photo_item_real_serialize;
#line 305 "rygel-photo-item.c"
}

static void
rygel_photo_item_instance_init (RygelPhotoItem * self,
                                gpointer klass)
{
}

/**
 * Represents a photo item.
 */
 G_GNUC_NO_INLINE static GType
rygel_photo_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelPhotoItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_photo_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelPhotoItem), 0, (GInstanceInitFunc) rygel_photo_item_instance_init, NULL };
	GType rygel_photo_item_type_id;
	rygel_photo_item_type_id = g_type_register_static (RYGEL_TYPE_IMAGE_ITEM, "RygelPhotoItem", &g_define_type_info, 0);
	return rygel_photo_item_type_id;
}

GType
rygel_photo_item_get_type (void)
{
	static volatile gsize rygel_photo_item_type_id__once = 0;
	if (g_once_init_enter (&rygel_photo_item_type_id__once)) {
		GType rygel_photo_item_type_id;
		rygel_photo_item_type_id = rygel_photo_item_get_type_once ();
		g_once_init_leave (&rygel_photo_item_type_id__once, rygel_photo_item_type_id);
	}
	return rygel_photo_item_type_id__once;
}

