/* rygel-video-item.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-video-item.vala, do not modify */

/*
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 * Copyright (C) 2010 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <libgupnp-av/gupnp-av.h>
#include "rygel-core.h"
#include <libgupnp/gupnp.h>
#include <libgssdp/gssdp.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_VIDEO_ITEM_0_PROPERTY,
	RYGEL_VIDEO_ITEM_AUTHOR_PROPERTY,
	RYGEL_VIDEO_ITEM_WIDTH_PROPERTY,
	RYGEL_VIDEO_ITEM_HEIGHT_PROPERTY,
	RYGEL_VIDEO_ITEM_COLOR_DEPTH_PROPERTY,
	RYGEL_VIDEO_ITEM_THUMBNAILS_PROPERTY,
	RYGEL_VIDEO_ITEM_SUBTITLES_PROPERTY,
	RYGEL_VIDEO_ITEM_NUM_PROPERTIES
};
static GParamSpec* rygel_video_item_properties[RYGEL_VIDEO_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define RYGEL_TYPE_SUBTITLE_MANAGER (rygel_subtitle_manager_get_type ())
#define RYGEL_SUBTITLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_SUBTITLE_MANAGER, RygelSubtitleManager))
#define RYGEL_SUBTITLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_SUBTITLE_MANAGER, RygelSubtitleManagerClass))
#define RYGEL_IS_SUBTITLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_SUBTITLE_MANAGER))
#define RYGEL_IS_SUBTITLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_SUBTITLE_MANAGER))
#define RYGEL_SUBTITLE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_SUBTITLE_MANAGER, RygelSubtitleManagerClass))

typedef struct _RygelSubtitleManager RygelSubtitleManager;
typedef struct _RygelSubtitleManagerClass RygelSubtitleManagerClass;
#define _rygel_subtitle_unref0(var) ((var == NULL) ? NULL : (var = (rygel_subtitle_unref (var), NULL)))
#define _rygel_icon_info_unref0(var) ((var == NULL) ? NULL : (var = (rygel_icon_info_unref (var), NULL)))

struct _RygelVideoItemPrivate {
	gchar* _author;
	gint _width;
	gint _height;
	gint _color_depth;
	GeeArrayList* _thumbnails;
	GeeArrayList* _subtitles;
};

static gint RygelVideoItem_private_offset;
static gpointer rygel_video_item_parent_class = NULL;
static RygelVisualItemIface * rygel_video_item_rygel_visual_item_parent_iface = NULL;

VALA_EXTERN gint rygel_media_object_compare_by_property (RygelMediaObject* self,
                                             RygelMediaObject* media_object,
                                             const gchar* property);
VALA_EXTERN void rygel_media_object_apply_didl_lite (RygelMediaObject* self,
                                         GUPnPDIDLLiteObject* didl_object);
VALA_EXTERN void rygel_video_item_add_subtitle_resources (RygelVideoItem* self,
                                              RygelHTTPServer* http_server);
VALA_EXTERN void rygel_media_file_item_add_additional_resources (RygelMediaFileItem* self,
                                                     RygelHTTPServer* server);
static void rygel_video_item_real_constructed (GObject* base);
static void rygel_video_item_real_add_uri (RygelMediaObject* base,
                                    const gchar* uri);
VALA_EXTERN void rygel_visual_item_add_thumbnail_for_uri (RygelVisualItem* self,
                                              const gchar* uri);
VALA_EXTERN GType rygel_subtitle_manager_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelSubtitleManager* rygel_subtitle_manager_get_default (void);
VALA_EXTERN GeeArrayList* rygel_subtitle_manager_get_subtitles (RygelSubtitleManager* self,
                                                    const gchar* uri,
                                                    GError** error);
static RygelMediaResource* rygel_video_item_real_get_primary_resource (RygelMediaFileItem* base);
VALA_EXTERN void rygel_visual_item_set_visual_resource_properties (RygelVisualItem* self,
                                                       RygelMediaResource* res);
static gint rygel_video_item_real_compare_by_property (RygelMediaObject* base,
                                                RygelMediaObject* media_object,
                                                const gchar* property);
static gchar* rygel_video_item_get_first (RygelVideoItem* self,
                                   GList* contributors);
static void rygel_video_item_real_apply_didl_lite (RygelMediaObject* base,
                                            GUPnPDIDLLiteObject* didl_object);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GUPnPDIDLLiteObject* rygel_video_item_real_serialize (RygelMediaObject* base,
                                                      RygelSerializer* serializer,
                                                      RygelHTTPServer* http_server,
                                                      GError** error);
VALA_EXTERN gchar* rygel_media_object_get_protocol_for_uri (RygelMediaObject* self,
                                                const gchar* uri,
                                                GError** error);
VALA_EXTERN gchar* rygel_http_server_create_uri_for_object (RygelHTTPServer* self,
                                                RygelMediaObject* object,
                                                gint thumbnail_index,
                                                gint subtitle_index,
                                                const gchar* resource_name);
VALA_EXTERN void rygel_subtitle_add_didl_node (RygelSubtitle* self,
                                   GUPnPDIDLLiteItem* didl_item);
static void rygel_video_item_real_add_subtitle_resources (RygelVideoItem* self,
                                                   RygelHTTPServer* http_server);
VALA_EXTERN RygelMediaResource* rygel_subtitle_get_resource (RygelSubtitle* self,
                                                 const gchar* protocol,
                                                 gint index);
VALA_EXTERN gchar* rygel_http_server_get_protocol (RygelHTTPServer* self);
static void rygel_video_item_real_add_additional_resources (RygelMediaFileItem* base,
                                                     RygelHTTPServer* server);
VALA_EXTERN void rygel_visual_item_add_thumbnail_resources (RygelVisualItem* self,
                                                RygelHTTPServer* http_server);
static void rygel_video_item_finalize (GObject * obj);
static GType rygel_video_item_get_type_once (void);
static void _vala_rygel_video_item_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_rygel_video_item_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
rygel_video_item_get_instance_private (RygelVideoItem* self)
{
	return G_STRUCT_MEMBER_P (self, RygelVideoItem_private_offset);
}

RygelVideoItem*
rygel_video_item_construct (GType object_type,
                            const gchar* id,
                            RygelMediaContainer* parent,
                            const gchar* title,
                            const gchar* upnp_class)
{
	RygelVideoItem * self = NULL;
#line 68 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 68 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 68 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 68 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (upnp_class != NULL, NULL);
#line 72 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) g_object_new (object_type, "id", id, "parent", parent, "title", title, "upnp-class", upnp_class, NULL);
#line 68 "../src/librygel-server/rygel-video-item.vala"
	return self;
#line 186 "rygel-video-item.c"
}

RygelVideoItem*
rygel_video_item_new (const gchar* id,
                      RygelMediaContainer* parent,
                      const gchar* title,
                      const gchar* upnp_class)
{
#line 68 "../src/librygel-server/rygel-video-item.vala"
	return rygel_video_item_construct (RYGEL_TYPE_VIDEO_ITEM, id, parent, title, upnp_class);
#line 197 "rygel-video-item.c"
}

static void
rygel_video_item_real_constructed (GObject* base)
{
	RygelVideoItem * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
#line 78 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 79 "../src/librygel-server/rygel-video-item.vala"
	G_OBJECT_CLASS (rygel_video_item_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem));
#line 81 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = gee_array_list_new (RYGEL_TYPE_THUMBNAIL, (GBoxedCopyFunc) rygel_icon_info_ref, (GDestroyNotify) rygel_icon_info_unref, NULL, NULL, NULL);
#line 81 "../src/librygel-server/rygel-video-item.vala"
	_tmp1_ = _tmp0_;
#line 81 "../src/librygel-server/rygel-video-item.vala"
	rygel_visual_item_set_thumbnails ((RygelVisualItem*) self, _tmp1_);
#line 81 "../src/librygel-server/rygel-video-item.vala"
	_g_object_unref0 (_tmp1_);
#line 82 "../src/librygel-server/rygel-video-item.vala"
	_tmp2_ = gee_array_list_new (RYGEL_TYPE_SUBTITLE, (GBoxedCopyFunc) rygel_subtitle_ref, (GDestroyNotify) rygel_subtitle_unref, NULL, NULL, NULL);
#line 82 "../src/librygel-server/rygel-video-item.vala"
	_tmp3_ = _tmp2_;
#line 82 "../src/librygel-server/rygel-video-item.vala"
	rygel_video_item_set_subtitles (self, _tmp3_);
#line 82 "../src/librygel-server/rygel-video-item.vala"
	_g_object_unref0 (_tmp3_);
#line 228 "rygel-video-item.c"
}

static void
rygel_video_item_real_add_uri (RygelMediaObject* base,
                               const gchar* uri)
{
	RygelVideoItem * self;
	RygelSubtitleManager* subtitle_manager = NULL;
	RygelSubtitleManager* _tmp0_;
	RygelSubtitleManager* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 85 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 85 "../src/librygel-server/rygel-video-item.vala"
	g_return_if_fail (uri != NULL);
#line 86 "../src/librygel-server/rygel-video-item.vala"
	RYGEL_MEDIA_OBJECT_CLASS (rygel_video_item_parent_class)->add_uri ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem), uri);
#line 88 "../src/librygel-server/rygel-video-item.vala"
	rygel_visual_item_add_thumbnail_for_uri ((RygelVisualItem*) self, uri);
#line 90 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = rygel_subtitle_manager_get_default ();
#line 90 "../src/librygel-server/rygel-video-item.vala"
	subtitle_manager = _tmp0_;
#line 92 "../src/librygel-server/rygel-video-item.vala"
	_tmp1_ = subtitle_manager;
#line 92 "../src/librygel-server/rygel-video-item.vala"
	if (_tmp1_ != NULL) {
#line 256 "rygel-video-item.c"
		{
			GeeArrayList* subtitles = NULL;
			RygelSubtitleManager* _tmp2_;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			GeeArrayList* _tmp5_;
#line 94 "../src/librygel-server/rygel-video-item.vala"
			_tmp2_ = subtitle_manager;
#line 94 "../src/librygel-server/rygel-video-item.vala"
			_tmp3_ = rygel_subtitle_manager_get_subtitles (_tmp2_, uri, &_inner_error0_);
#line 94 "../src/librygel-server/rygel-video-item.vala"
			subtitles = _tmp3_;
#line 94 "../src/librygel-server/rygel-video-item.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "rygel-video-item.c"
				goto __catch0_g_error;
			}
#line 95 "../src/librygel-server/rygel-video-item.vala"
			_tmp4_ = self->priv->_subtitles;
#line 95 "../src/librygel-server/rygel-video-item.vala"
			_tmp5_ = subtitles;
#line 95 "../src/librygel-server/rygel-video-item.vala"
			gee_array_list_add_all (_tmp4_, (GeeCollection*) _tmp5_);
#line 93 "../src/librygel-server/rygel-video-item.vala"
			_g_object_unref0 (subtitles);
#line 282 "rygel-video-item.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 93 "../src/librygel-server/rygel-video-item.vala"
			g_clear_error (&_inner_error0_);
#line 289 "rygel-video-item.c"
		}
		__finally0:
#line 93 "../src/librygel-server/rygel-video-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../src/librygel-server/rygel-video-item.vala"
			_g_object_unref0 (subtitle_manager);
#line 93 "../src/librygel-server/rygel-video-item.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "../src/librygel-server/rygel-video-item.vala"
			g_clear_error (&_inner_error0_);
#line 93 "../src/librygel-server/rygel-video-item.vala"
			return;
#line 302 "rygel-video-item.c"
		}
	}
#line 85 "../src/librygel-server/rygel-video-item.vala"
	_g_object_unref0 (subtitle_manager);
#line 307 "rygel-video-item.c"
}

static RygelMediaResource*
rygel_video_item_real_get_primary_resource (RygelMediaFileItem* base)
{
	RygelVideoItem * self;
	RygelMediaResource* res = NULL;
	RygelMediaResource* _tmp0_;
	RygelMediaResource* result;
#line 100 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 101 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = RYGEL_MEDIA_FILE_ITEM_CLASS (rygel_video_item_parent_class)->get_primary_resource ((RygelMediaFileItem*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem));
#line 101 "../src/librygel-server/rygel-video-item.vala"
	res = _tmp0_;
#line 103 "../src/librygel-server/rygel-video-item.vala"
	rygel_visual_item_set_visual_resource_properties ((RygelVisualItem*) self, res);
#line 105 "../src/librygel-server/rygel-video-item.vala"
	result = res;
#line 105 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 329 "rygel-video-item.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 114 "../src/librygel-server/rygel-video-item.vala"
	return self ? g_object_ref (self) : NULL;
#line 337 "rygel-video-item.c"
}

static gint
rygel_video_item_real_compare_by_property (RygelMediaObject* base,
                                           RygelMediaObject* media_object,
                                           const gchar* property)
{
	RygelVideoItem * self;
	RygelVideoItem* item = NULL;
	RygelVideoItem* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 116 "../src/librygel-server/rygel-video-item.vala"
	static GQuark _tmp2_label0 = 0;
#line 352 "rygel-video-item.c"
	gint result;
#line 108 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 108 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (media_object != NULL, 0);
#line 108 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (property != NULL, 0);
#line 110 "../src/librygel-server/rygel-video-item.vala"
	if (!RYGEL_IS_VIDEO_ITEM (media_object)) {
#line 111 "../src/librygel-server/rygel-video-item.vala"
		result = 1;
#line 111 "../src/librygel-server/rygel-video-item.vala"
		return result;
#line 366 "rygel-video-item.c"
	}
#line 114 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = _g_object_ref0 (RYGEL_IS_VIDEO_ITEM (media_object) ? ((RygelVideoItem*) media_object) : NULL);
#line 114 "../src/librygel-server/rygel-video-item.vala"
	item = _tmp0_;
#line 116 "../src/librygel-server/rygel-video-item.vala"
	_tmp1_ = property;
#line 116 "../src/librygel-server/rygel-video-item.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 116 "../src/librygel-server/rygel-video-item.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("upnp:author")))) {
#line 116 "../src/librygel-server/rygel-video-item.vala"
		switch (0) {
#line 380 "rygel-video-item.c"
			default:
			{
				const gchar* _tmp4_;
				RygelVideoItem* _tmp5_;
				const gchar* _tmp6_;
#line 118 "../src/librygel-server/rygel-video-item.vala"
				_tmp4_ = self->priv->_author;
#line 118 "../src/librygel-server/rygel-video-item.vala"
				_tmp5_ = item;
#line 118 "../src/librygel-server/rygel-video-item.vala"
				_tmp6_ = _tmp5_->priv->_author;
#line 118 "../src/librygel-server/rygel-video-item.vala"
				result = rygel_media_object_compare_string_props ((RygelMediaObject*) self, _tmp4_, _tmp6_);
#line 118 "../src/librygel-server/rygel-video-item.vala"
				_g_object_unref0 (item);
#line 118 "../src/librygel-server/rygel-video-item.vala"
				return result;
#line 398 "rygel-video-item.c"
			}
		}
	} else {
#line 116 "../src/librygel-server/rygel-video-item.vala"
		switch (0) {
#line 404 "rygel-video-item.c"
			default:
			{
				RygelVideoItem* _tmp7_;
#line 120 "../src/librygel-server/rygel-video-item.vala"
				_tmp7_ = item;
#line 120 "../src/librygel-server/rygel-video-item.vala"
				result = RYGEL_MEDIA_OBJECT_CLASS (rygel_video_item_parent_class)->compare_by_property ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem), (RygelMediaObject*) _tmp7_, property);
#line 120 "../src/librygel-server/rygel-video-item.vala"
				_g_object_unref0 (item);
#line 120 "../src/librygel-server/rygel-video-item.vala"
				return result;
#line 416 "rygel-video-item.c"
			}
		}
	}
}

static gchar*
rygel_video_item_get_first (RygelVideoItem* self,
                            GList* contributors)
{
	gchar* _tmp4_;
	gchar* result;
#line 124 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../src/librygel-server/rygel-video-item.vala"
	if (contributors != NULL) {
#line 432 "rygel-video-item.c"
		gconstpointer _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 126 "../src/librygel-server/rygel-video-item.vala"
		_tmp0_ = contributors->data;
#line 126 "../src/librygel-server/rygel-video-item.vala"
		_tmp1_ = gupnp_didl_lite_contributor_get_name ((GUPnPDIDLLiteContributor*) _tmp0_);
#line 126 "../src/librygel-server/rygel-video-item.vala"
		_tmp2_ = _tmp1_;
#line 126 "../src/librygel-server/rygel-video-item.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 126 "../src/librygel-server/rygel-video-item.vala"
		result = _tmp3_;
#line 126 "../src/librygel-server/rygel-video-item.vala"
		return result;
#line 449 "rygel-video-item.c"
	}
#line 129 "../src/librygel-server/rygel-video-item.vala"
	_tmp4_ = g_strdup ("");
#line 129 "../src/librygel-server/rygel-video-item.vala"
	result = _tmp4_;
#line 129 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 457 "rygel-video-item.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 135 "../src/librygel-server/rygel-video-item.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 465 "rygel-video-item.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 135 "../src/librygel-server/rygel-video-item.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 473 "rygel-video-item.c"
}

static void
rygel_video_item_real_apply_didl_lite (RygelMediaObject* base,
                                       GUPnPDIDLLiteObject* didl_object)
{
	RygelVideoItem * self;
	GList* _tmp0_;
	GList* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 132 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 132 "../src/librygel-server/rygel-video-item.vala"
	g_return_if_fail (didl_object != NULL);
#line 133 "../src/librygel-server/rygel-video-item.vala"
	RYGEL_MEDIA_OBJECT_CLASS (rygel_video_item_parent_class)->apply_didl_lite ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem), didl_object);
#line 135 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = gupnp_didl_lite_object_get_authors (didl_object);
#line 135 "../src/librygel-server/rygel-video-item.vala"
	_tmp1_ = _tmp0_;
#line 135 "../src/librygel-server/rygel-video-item.vala"
	_tmp2_ = rygel_video_item_get_first (self, _tmp1_);
#line 135 "../src/librygel-server/rygel-video-item.vala"
	_tmp3_ = _tmp2_;
#line 135 "../src/librygel-server/rygel-video-item.vala"
	rygel_video_item_set_author (self, _tmp3_);
#line 135 "../src/librygel-server/rygel-video-item.vala"
	_g_free0 (_tmp3_);
#line 135 "../src/librygel-server/rygel-video-item.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 505 "rygel-video-item.c"
}

static gpointer
_rygel_subtitle_ref0 (gpointer self)
{
#line 149 "../src/librygel-server/rygel-video-item.vala"
	return self ? rygel_subtitle_ref (self) : NULL;
#line 513 "rygel-video-item.c"
}

static GUPnPDIDLLiteObject*
rygel_video_item_real_serialize (RygelMediaObject* base,
                                 RygelSerializer* serializer,
                                 RygelHTTPServer* http_server,
                                 GError** error)
{
	RygelVideoItem * self;
	GUPnPDIDLLiteObject* _tmp0_ = NULL;
	GUPnPDIDLLiteObject* _tmp1_;
	GUPnPDIDLLiteItem* didl_item = NULL;
	GUPnPDIDLLiteItem* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GError* _inner_error0_ = NULL;
	GUPnPDIDLLiteObject* result;
#line 138 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 138 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (serializer != NULL, NULL);
#line 138 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (http_server != NULL, NULL);
#line 141 "../src/librygel-server/rygel-video-item.vala"
	_tmp1_ = RYGEL_MEDIA_OBJECT_CLASS (rygel_video_item_parent_class)->serialize ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem), serializer, http_server, &_inner_error0_);
#line 141 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = _tmp1_;
#line 141 "../src/librygel-server/rygel-video-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "../src/librygel-server/rygel-video-item.vala"
		g_propagate_error (error, _inner_error0_);
#line 141 "../src/librygel-server/rygel-video-item.vala"
		return NULL;
#line 549 "rygel-video-item.c"
	}
#line 141 "../src/librygel-server/rygel-video-item.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gupnp_didl_lite_item_get_type ()) ? ((GUPnPDIDLLiteItem*) _tmp0_) : NULL);
#line 141 "../src/librygel-server/rygel-video-item.vala"
	didl_item = _tmp2_;
#line 143 "../src/librygel-server/rygel-video-item.vala"
	_tmp4_ = self->priv->_author;
#line 143 "../src/librygel-server/rygel-video-item.vala"
	if (_tmp4_ != NULL) {
#line 559 "rygel-video-item.c"
		const gchar* _tmp5_;
#line 143 "../src/librygel-server/rygel-video-item.vala"
		_tmp5_ = self->priv->_author;
#line 143 "../src/librygel-server/rygel-video-item.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") != 0;
#line 565 "rygel-video-item.c"
	} else {
#line 143 "../src/librygel-server/rygel-video-item.vala"
		_tmp3_ = FALSE;
#line 569 "rygel-video-item.c"
	}
#line 143 "../src/librygel-server/rygel-video-item.vala"
	if (_tmp3_) {
#line 573 "rygel-video-item.c"
		GUPnPDIDLLiteContributor* contributor = NULL;
		GUPnPDIDLLiteItem* _tmp6_;
		GUPnPDIDLLiteContributor* _tmp7_;
		GUPnPDIDLLiteContributor* _tmp8_;
		const gchar* _tmp9_;
#line 144 "../src/librygel-server/rygel-video-item.vala"
		_tmp6_ = didl_item;
#line 144 "../src/librygel-server/rygel-video-item.vala"
		_tmp7_ = gupnp_didl_lite_object_add_author ((GUPnPDIDLLiteObject*) _tmp6_);
#line 144 "../src/librygel-server/rygel-video-item.vala"
		contributor = _tmp7_;
#line 145 "../src/librygel-server/rygel-video-item.vala"
		_tmp8_ = contributor;
#line 145 "../src/librygel-server/rygel-video-item.vala"
		_tmp9_ = self->priv->_author;
#line 145 "../src/librygel-server/rygel-video-item.vala"
		gupnp_didl_lite_contributor_set_name (_tmp8_, _tmp9_);
#line 143 "../src/librygel-server/rygel-video-item.vala"
		_g_object_unref0 (contributor);
#line 593 "rygel-video-item.c"
	}
#line 148 "../src/librygel-server/rygel-video-item.vala"
	_tmp10_ = rygel_media_file_item_get_place_holder ((RygelMediaFileItem*) self);
#line 148 "../src/librygel-server/rygel-video-item.vala"
	_tmp11_ = _tmp10_;
#line 148 "../src/librygel-server/rygel-video-item.vala"
	if (!_tmp11_) {
#line 601 "rygel-video-item.c"
		RygelSubtitle* main_subtitle = NULL;
		gpointer _tmp12_;
		RygelSubtitle* _tmp13_;
		RygelSubtitle* _tmp60_;
		GeeArrayList* _tmp80_;
		GeeArrayList* _tmp81_;
		gint _tmp82_;
		gint _tmp83_;
#line 149 "../src/librygel-server/rygel-video-item.vala"
		_tmp12_ = NULL;
#line 149 "../src/librygel-server/rygel-video-item.vala"
		_tmp13_ = _rygel_subtitle_ref0 (RYGEL_IS_SUBTITLE (_tmp12_) ? ((RygelSubtitle*) _tmp12_) : NULL);
#line 149 "../src/librygel-server/rygel-video-item.vala"
		main_subtitle = _tmp13_;
#line 616 "rygel-video-item.c"
		{
			GeeArrayList* _subtitle_list = NULL;
			GeeArrayList* _tmp14_;
			gint _subtitle_size = 0;
			GeeArrayList* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _subtitle_index = 0;
#line 150 "../src/librygel-server/rygel-video-item.vala"
			_tmp14_ = self->priv->_subtitles;
#line 150 "../src/librygel-server/rygel-video-item.vala"
			_subtitle_list = _tmp14_;
#line 150 "../src/librygel-server/rygel-video-item.vala"
			_tmp15_ = _subtitle_list;
#line 150 "../src/librygel-server/rygel-video-item.vala"
			_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 150 "../src/librygel-server/rygel-video-item.vala"
			_tmp17_ = _tmp16_;
#line 150 "../src/librygel-server/rygel-video-item.vala"
			_subtitle_size = _tmp17_;
#line 150 "../src/librygel-server/rygel-video-item.vala"
			_subtitle_index = -1;
#line 150 "../src/librygel-server/rygel-video-item.vala"
			while (TRUE) {
#line 641 "rygel-video-item.c"
				gint _tmp18_;
				gint _tmp19_;
				RygelSubtitle* subtitle = NULL;
				GeeArrayList* _tmp20_;
				gpointer _tmp21_;
				gchar* protocol = NULL;
				RygelSubtitle* _tmp29_;
				const gchar* _tmp30_;
				gboolean _tmp56_ = FALSE;
#line 150 "../src/librygel-server/rygel-video-item.vala"
				_subtitle_index = _subtitle_index + 1;
#line 150 "../src/librygel-server/rygel-video-item.vala"
				_tmp18_ = _subtitle_index;
#line 150 "../src/librygel-server/rygel-video-item.vala"
				_tmp19_ = _subtitle_size;
#line 150 "../src/librygel-server/rygel-video-item.vala"
				if (!(_tmp18_ < _tmp19_)) {
#line 150 "../src/librygel-server/rygel-video-item.vala"
					break;
#line 661 "rygel-video-item.c"
				}
#line 150 "../src/librygel-server/rygel-video-item.vala"
				_tmp20_ = _subtitle_list;
#line 150 "../src/librygel-server/rygel-video-item.vala"
				_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _subtitle_index);
#line 150 "../src/librygel-server/rygel-video-item.vala"
				subtitle = (RygelSubtitle*) _tmp21_;
#line 669 "rygel-video-item.c"
				{
					gchar* _tmp22_ = NULL;
					RygelSubtitle* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
#line 153 "../src/librygel-server/rygel-video-item.vala"
					_tmp23_ = subtitle;
#line 153 "../src/librygel-server/rygel-video-item.vala"
					_tmp24_ = _tmp23_->uri;
#line 153 "../src/librygel-server/rygel-video-item.vala"
					_tmp25_ = rygel_media_object_get_protocol_for_uri ((RygelMediaObject*) self, _tmp24_, &_inner_error0_);
#line 153 "../src/librygel-server/rygel-video-item.vala"
					_tmp22_ = _tmp25_;
#line 153 "../src/librygel-server/rygel-video-item.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 686 "rygel-video-item.c"
						goto __catch0_g_error;
					}
#line 153 "../src/librygel-server/rygel-video-item.vala"
					_tmp26_ = _tmp22_;
#line 153 "../src/librygel-server/rygel-video-item.vala"
					_tmp22_ = NULL;
#line 153 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (protocol);
#line 153 "../src/librygel-server/rygel-video-item.vala"
					protocol = _tmp26_;
#line 152 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (_tmp22_);
#line 699 "rygel-video-item.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					RygelSubtitle* _tmp27_;
					const gchar* _tmp28_;
#line 152 "../src/librygel-server/rygel-video-item.vala"
					g_clear_error (&_inner_error0_);
#line 155 "../src/librygel-server/rygel-video-item.vala"
					_tmp27_ = subtitle;
#line 155 "../src/librygel-server/rygel-video-item.vala"
					_tmp28_ = _tmp27_->uri;
#line 155 "../src/librygel-server/rygel-video-item.vala"
					g_message ("rygel-video-item.vala:155: Could not determine protocol for URI %s", _tmp28_);
#line 158 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (protocol);
#line 158 "../src/librygel-server/rygel-video-item.vala"
					_rygel_subtitle_unref0 (subtitle);
#line 158 "../src/librygel-server/rygel-video-item.vala"
					continue;
#line 720 "rygel-video-item.c"
				}
				__finally0:
#line 152 "../src/librygel-server/rygel-video-item.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "../src/librygel-server/rygel-video-item.vala"
					g_propagate_error (error, _inner_error0_);
#line 152 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (protocol);
#line 152 "../src/librygel-server/rygel-video-item.vala"
					_rygel_subtitle_unref0 (subtitle);
#line 152 "../src/librygel-server/rygel-video-item.vala"
					_rygel_subtitle_unref0 (main_subtitle);
#line 152 "../src/librygel-server/rygel-video-item.vala"
					_g_object_unref0 (didl_item);
#line 152 "../src/librygel-server/rygel-video-item.vala"
					_g_object_unref0 (_tmp0_);
#line 152 "../src/librygel-server/rygel-video-item.vala"
					return NULL;
#line 739 "rygel-video-item.c"
				}
#line 161 "../src/librygel-server/rygel-video-item.vala"
				_tmp29_ = subtitle;
#line 161 "../src/librygel-server/rygel-video-item.vala"
				_tmp30_ = _tmp29_->uri;
#line 161 "../src/librygel-server/rygel-video-item.vala"
				if (rygel_http_server_need_proxy (http_server, _tmp30_)) {
#line 747 "rygel-video-item.c"
					gchar* uri = NULL;
					RygelSubtitle* _tmp31_;
					const gchar* _tmp32_;
					gchar* _tmp33_;
					gint index = 0;
					GeeArrayList* _tmp34_;
					RygelSubtitle* _tmp35_;
					RygelSubtitle* _tmp36_;
					gchar* _tmp37_;
					RygelSubtitle* _tmp38_;
					GUPnPDIDLLiteItem* _tmp39_;
					RygelSubtitle* _tmp40_;
					RygelSubtitle* _tmp50_;
					const gchar* _tmp51_;
					gchar* _tmp52_;
#line 162 "../src/librygel-server/rygel-video-item.vala"
					_tmp31_ = subtitle;
#line 162 "../src/librygel-server/rygel-video-item.vala"
					_tmp32_ = _tmp31_->uri;
#line 162 "../src/librygel-server/rygel-video-item.vala"
					_tmp33_ = g_strdup (_tmp32_);
#line 162 "../src/librygel-server/rygel-video-item.vala"
					uri = _tmp33_;
#line 163 "../src/librygel-server/rygel-video-item.vala"
					_tmp34_ = self->priv->_subtitles;
#line 163 "../src/librygel-server/rygel-video-item.vala"
					_tmp35_ = subtitle;
#line 163 "../src/librygel-server/rygel-video-item.vala"
					index = gee_abstract_list_index_of ((GeeAbstractList*) _tmp34_, _tmp35_);
#line 165 "../src/librygel-server/rygel-video-item.vala"
					_tmp36_ = subtitle;
#line 165 "../src/librygel-server/rygel-video-item.vala"
					_tmp37_ = rygel_http_server_create_uri_for_object (http_server, (RygelMediaObject*) self, -1, index, NULL);
#line 165 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (_tmp36_->uri);
#line 165 "../src/librygel-server/rygel-video-item.vala"
					_tmp36_->uri = _tmp37_;
#line 169 "../src/librygel-server/rygel-video-item.vala"
					_tmp38_ = subtitle;
#line 169 "../src/librygel-server/rygel-video-item.vala"
					_tmp39_ = didl_item;
#line 169 "../src/librygel-server/rygel-video-item.vala"
					rygel_subtitle_add_didl_node (_tmp38_, _tmp39_);
#line 171 "../src/librygel-server/rygel-video-item.vala"
					_tmp40_ = main_subtitle;
#line 171 "../src/librygel-server/rygel-video-item.vala"
					if (_tmp40_ == NULL) {
#line 795 "rygel-video-item.c"
						RygelSubtitle* _tmp41_;
						const gchar* _tmp42_;
						RygelSubtitle* _tmp43_;
						const gchar* _tmp44_;
						RygelSubtitle* _tmp45_;
						RygelSubtitle* _tmp46_;
						RygelSubtitle* _tmp47_;
						const gchar* _tmp48_;
						gchar* _tmp49_;
#line 172 "../src/librygel-server/rygel-video-item.vala"
						_tmp41_ = subtitle;
#line 172 "../src/librygel-server/rygel-video-item.vala"
						_tmp42_ = _tmp41_->mime_type;
#line 172 "../src/librygel-server/rygel-video-item.vala"
						_tmp43_ = subtitle;
#line 172 "../src/librygel-server/rygel-video-item.vala"
						_tmp44_ = _tmp43_->caption_type;
#line 172 "../src/librygel-server/rygel-video-item.vala"
						_tmp45_ = rygel_subtitle_new (_tmp42_, _tmp44_, "srt");
#line 172 "../src/librygel-server/rygel-video-item.vala"
						_rygel_subtitle_unref0 (main_subtitle);
#line 172 "../src/librygel-server/rygel-video-item.vala"
						main_subtitle = _tmp45_;
#line 174 "../src/librygel-server/rygel-video-item.vala"
						_tmp46_ = main_subtitle;
#line 174 "../src/librygel-server/rygel-video-item.vala"
						_tmp47_ = subtitle;
#line 174 "../src/librygel-server/rygel-video-item.vala"
						_tmp48_ = _tmp47_->uri;
#line 174 "../src/librygel-server/rygel-video-item.vala"
						_tmp49_ = g_strdup (_tmp48_);
#line 174 "../src/librygel-server/rygel-video-item.vala"
						_g_free0 (_tmp46_->uri);
#line 174 "../src/librygel-server/rygel-video-item.vala"
						_tmp46_->uri = _tmp49_;
#line 831 "rygel-video-item.c"
					}
#line 176 "../src/librygel-server/rygel-video-item.vala"
					_tmp50_ = subtitle;
#line 176 "../src/librygel-server/rygel-video-item.vala"
					_tmp51_ = uri;
#line 176 "../src/librygel-server/rygel-video-item.vala"
					_tmp52_ = g_strdup (_tmp51_);
#line 176 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (_tmp50_->uri);
#line 176 "../src/librygel-server/rygel-video-item.vala"
					_tmp50_->uri = _tmp52_;
#line 161 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (uri);
#line 845 "rygel-video-item.c"
				} else {
					RygelSubtitle* _tmp53_;
#line 177 "../src/librygel-server/rygel-video-item.vala"
					_tmp53_ = main_subtitle;
#line 177 "../src/librygel-server/rygel-video-item.vala"
					if (_tmp53_ == NULL) {
#line 852 "rygel-video-item.c"
						RygelSubtitle* _tmp54_;
						RygelSubtitle* _tmp55_;
#line 178 "../src/librygel-server/rygel-video-item.vala"
						_tmp54_ = subtitle;
#line 178 "../src/librygel-server/rygel-video-item.vala"
						_tmp55_ = _rygel_subtitle_ref0 (_tmp54_);
#line 178 "../src/librygel-server/rygel-video-item.vala"
						_rygel_subtitle_unref0 (main_subtitle);
#line 178 "../src/librygel-server/rygel-video-item.vala"
						main_subtitle = _tmp55_;
#line 863 "rygel-video-item.c"
					}
				}
#line 181 "../src/librygel-server/rygel-video-item.vala"
				if (rygel_http_server_is_local (http_server)) {
#line 181 "../src/librygel-server/rygel-video-item.vala"
					_tmp56_ = TRUE;
#line 870 "rygel-video-item.c"
				} else {
					const gchar* _tmp57_;
#line 181 "../src/librygel-server/rygel-video-item.vala"
					_tmp57_ = protocol;
#line 181 "../src/librygel-server/rygel-video-item.vala"
					_tmp56_ = g_strcmp0 (_tmp57_, "internal") != 0;
#line 877 "rygel-video-item.c"
				}
#line 181 "../src/librygel-server/rygel-video-item.vala"
				if (_tmp56_) {
#line 881 "rygel-video-item.c"
					RygelSubtitle* _tmp58_;
					GUPnPDIDLLiteItem* _tmp59_;
#line 182 "../src/librygel-server/rygel-video-item.vala"
					_tmp58_ = subtitle;
#line 182 "../src/librygel-server/rygel-video-item.vala"
					_tmp59_ = didl_item;
#line 182 "../src/librygel-server/rygel-video-item.vala"
					rygel_subtitle_add_didl_node (_tmp58_, _tmp59_);
#line 890 "rygel-video-item.c"
				}
#line 150 "../src/librygel-server/rygel-video-item.vala"
				_g_free0 (protocol);
#line 150 "../src/librygel-server/rygel-video-item.vala"
				_rygel_subtitle_unref0 (subtitle);
#line 896 "rygel-video-item.c"
			}
		}
#line 186 "../src/librygel-server/rygel-video-item.vala"
		_tmp60_ = main_subtitle;
#line 186 "../src/librygel-server/rygel-video-item.vala"
		if (_tmp60_ != NULL) {
#line 903 "rygel-video-item.c"
			GList* resources = NULL;
			GUPnPDIDLLiteItem* _tmp61_;
			GList* _tmp62_;
			GList* _tmp63_;
#line 192 "../src/librygel-server/rygel-video-item.vala"
			_tmp61_ = didl_item;
#line 192 "../src/librygel-server/rygel-video-item.vala"
			_tmp62_ = gupnp_didl_lite_object_get_resources ((GUPnPDIDLLiteObject*) _tmp61_);
#line 192 "../src/librygel-server/rygel-video-item.vala"
			resources = _tmp62_;
#line 193 "../src/librygel-server/rygel-video-item.vala"
			_tmp63_ = resources;
#line 916 "rygel-video-item.c"
			{
				GList* resource_collection = NULL;
				GList* resource_it = NULL;
#line 193 "../src/librygel-server/rygel-video-item.vala"
				resource_collection = _tmp63_;
#line 193 "../src/librygel-server/rygel-video-item.vala"
				for (resource_it = resource_collection; resource_it != NULL; resource_it = resource_it->next) {
#line 924 "rygel-video-item.c"
					GUPnPDIDLLiteResource* _tmp64_;
					GUPnPDIDLLiteResource* resource = NULL;
#line 193 "../src/librygel-server/rygel-video-item.vala"
					_tmp64_ = _g_object_ref0 ((GUPnPDIDLLiteResource*) resource_it->data);
#line 193 "../src/librygel-server/rygel-video-item.vala"
					resource = _tmp64_;
#line 931 "rygel-video-item.c"
					{
						GUPnPDIDLLiteResource* _tmp65_;
						GUPnPProtocolInfo* _tmp66_;
						GUPnPProtocolInfo* _tmp67_;
						const gchar* _tmp68_;
						const gchar* _tmp69_;
						RygelSubtitle* _tmp70_;
						const gchar* _tmp71_;
						GUPnPDIDLLiteResource* _tmp72_;
						RygelSubtitle* _tmp73_;
						const gchar* _tmp74_;
						gchar* _tmp75_;
						gchar* _tmp76_;
						GUPnPDIDLLiteResource* _tmp77_;
						RygelSubtitle* _tmp78_;
						const gchar* _tmp79_;
#line 195 "../src/librygel-server/rygel-video-item.vala"
						_tmp65_ = resource;
#line 195 "../src/librygel-server/rygel-video-item.vala"
						_tmp66_ = gupnp_didl_lite_resource_get_protocol_info (_tmp65_);
#line 195 "../src/librygel-server/rygel-video-item.vala"
						_tmp67_ = _tmp66_;
#line 195 "../src/librygel-server/rygel-video-item.vala"
						_tmp68_ = gupnp_protocol_info_get_mime_type (_tmp67_);
#line 195 "../src/librygel-server/rygel-video-item.vala"
						_tmp69_ = _tmp68_;
#line 195 "../src/librygel-server/rygel-video-item.vala"
						_tmp70_ = main_subtitle;
#line 195 "../src/librygel-server/rygel-video-item.vala"
						_tmp71_ = _tmp70_->mime_type;
#line 195 "../src/librygel-server/rygel-video-item.vala"
						if (g_strcmp0 (_tmp69_, _tmp71_) == 0) {
#line 196 "../src/librygel-server/rygel-video-item.vala"
							_g_object_unref0 (resource);
#line 196 "../src/librygel-server/rygel-video-item.vala"
							continue;
#line 968 "rygel-video-item.c"
						}
#line 199 "../src/librygel-server/rygel-video-item.vala"
						_tmp72_ = resource;
#line 199 "../src/librygel-server/rygel-video-item.vala"
						_tmp73_ = main_subtitle;
#line 199 "../src/librygel-server/rygel-video-item.vala"
						_tmp74_ = _tmp73_->caption_type;
#line 199 "../src/librygel-server/rygel-video-item.vala"
						_tmp75_ = g_utf8_strup (_tmp74_, (gssize) -1);
#line 199 "../src/librygel-server/rygel-video-item.vala"
						_tmp76_ = _tmp75_;
#line 199 "../src/librygel-server/rygel-video-item.vala"
						gupnp_didl_lite_resource_set_subtitle_file_type (_tmp72_, _tmp76_);
#line 199 "../src/librygel-server/rygel-video-item.vala"
						_g_free0 (_tmp76_);
#line 201 "../src/librygel-server/rygel-video-item.vala"
						_tmp77_ = resource;
#line 201 "../src/librygel-server/rygel-video-item.vala"
						_tmp78_ = main_subtitle;
#line 201 "../src/librygel-server/rygel-video-item.vala"
						_tmp79_ = _tmp78_->uri;
#line 201 "../src/librygel-server/rygel-video-item.vala"
						gupnp_didl_lite_resource_set_subtitle_file_uri (_tmp77_, _tmp79_);
#line 193 "../src/librygel-server/rygel-video-item.vala"
						_g_object_unref0 (resource);
#line 994 "rygel-video-item.c"
					}
				}
			}
#line 186 "../src/librygel-server/rygel-video-item.vala"
			(resources == NULL) ? NULL : (resources = (_g_list_free__g_object_unref0_ (resources), NULL));
#line 1000 "rygel-video-item.c"
		}
#line 207 "../src/librygel-server/rygel-video-item.vala"
		_tmp80_ = rygel_visual_item_get_thumbnails ((RygelVisualItem*) self);
#line 207 "../src/librygel-server/rygel-video-item.vala"
		_tmp81_ = _tmp80_;
#line 207 "../src/librygel-server/rygel-video-item.vala"
		_tmp82_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp81_);
#line 207 "../src/librygel-server/rygel-video-item.vala"
		_tmp83_ = _tmp82_;
#line 207 "../src/librygel-server/rygel-video-item.vala"
		if (_tmp83_ != 0) {
#line 1012 "rygel-video-item.c"
			gchar* protocol = NULL;
			GeeArrayList* _tmp84_;
			GeeArrayList* _tmp85_;
			gpointer _tmp86_;
			RygelThumbnail* _tmp87_;
			const gchar* _tmp88_;
			gchar* _tmp89_;
			gchar* _tmp90_;
			gboolean _tmp91_ = FALSE;
#line 208 "../src/librygel-server/rygel-video-item.vala"
			_tmp84_ = rygel_visual_item_get_thumbnails ((RygelVisualItem*) self);
#line 208 "../src/librygel-server/rygel-video-item.vala"
			_tmp85_ = _tmp84_;
#line 208 "../src/librygel-server/rygel-video-item.vala"
			_tmp86_ = gee_abstract_list_get ((GeeAbstractList*) _tmp85_, 0);
#line 208 "../src/librygel-server/rygel-video-item.vala"
			_tmp87_ = (RygelThumbnail*) _tmp86_;
#line 208 "../src/librygel-server/rygel-video-item.vala"
			_tmp88_ = ((RygelIconInfo*) _tmp87_)->uri;
#line 208 "../src/librygel-server/rygel-video-item.vala"
			_tmp89_ = rygel_media_object_get_protocol_for_uri ((RygelMediaObject*) self, _tmp88_, &_inner_error0_);
#line 208 "../src/librygel-server/rygel-video-item.vala"
			_tmp90_ = _tmp89_;
#line 208 "../src/librygel-server/rygel-video-item.vala"
			_rygel_icon_info_unref0 (_tmp87_);
#line 208 "../src/librygel-server/rygel-video-item.vala"
			protocol = _tmp90_;
#line 208 "../src/librygel-server/rygel-video-item.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../src/librygel-server/rygel-video-item.vala"
				g_propagate_error (error, _inner_error0_);
#line 208 "../src/librygel-server/rygel-video-item.vala"
				_rygel_subtitle_unref0 (main_subtitle);
#line 208 "../src/librygel-server/rygel-video-item.vala"
				_g_object_unref0 (didl_item);
#line 208 "../src/librygel-server/rygel-video-item.vala"
				_g_object_unref0 (_tmp0_);
#line 208 "../src/librygel-server/rygel-video-item.vala"
				return NULL;
#line 1052 "rygel-video-item.c"
			}
#line 209 "../src/librygel-server/rygel-video-item.vala"
			if (rygel_http_server_is_local (http_server)) {
#line 209 "../src/librygel-server/rygel-video-item.vala"
				_tmp91_ = TRUE;
#line 1058 "rygel-video-item.c"
			} else {
				const gchar* _tmp92_;
#line 209 "../src/librygel-server/rygel-video-item.vala"
				_tmp92_ = protocol;
#line 209 "../src/librygel-server/rygel-video-item.vala"
				_tmp91_ = g_strcmp0 (_tmp92_, "internal") != 0;
#line 1065 "rygel-video-item.c"
			}
#line 209 "../src/librygel-server/rygel-video-item.vala"
			if (_tmp91_) {
#line 1069 "rygel-video-item.c"
				GUPnPDIDLLiteItem* _tmp93_;
				GeeArrayList* _tmp94_;
				GeeArrayList* _tmp95_;
				gpointer _tmp96_;
				RygelThumbnail* _tmp97_;
				const gchar* _tmp98_;
#line 210 "../src/librygel-server/rygel-video-item.vala"
				_tmp93_ = didl_item;
#line 210 "../src/librygel-server/rygel-video-item.vala"
				_tmp94_ = rygel_visual_item_get_thumbnails ((RygelVisualItem*) self);
#line 210 "../src/librygel-server/rygel-video-item.vala"
				_tmp95_ = _tmp94_;
#line 210 "../src/librygel-server/rygel-video-item.vala"
				_tmp96_ = gee_abstract_list_get ((GeeAbstractList*) _tmp95_, 0);
#line 210 "../src/librygel-server/rygel-video-item.vala"
				_tmp97_ = (RygelThumbnail*) _tmp96_;
#line 210 "../src/librygel-server/rygel-video-item.vala"
				_tmp98_ = ((RygelIconInfo*) _tmp97_)->uri;
#line 210 "../src/librygel-server/rygel-video-item.vala"
				gupnp_didl_lite_object_set_album_art ((GUPnPDIDLLiteObject*) _tmp93_, _tmp98_);
#line 210 "../src/librygel-server/rygel-video-item.vala"
				_rygel_icon_info_unref0 (_tmp97_);
#line 1092 "rygel-video-item.c"
			} else {
				gchar* http_uri = NULL;
				gchar* _tmp99_;
				gchar* _tmp100_ = NULL;
				GRegex* _tmp101_;
				const gchar* _tmp102_;
				GUPnPContext* _tmp103_;
				GInetAddress* _tmp104_;
				GInetAddress* _tmp105_;
				GInetAddress* _tmp106_;
				gchar* _tmp107_;
				gchar* _tmp108_;
				gchar* _tmp109_;
				gchar* _tmp110_;
				GUPnPDIDLLiteItem* _tmp111_;
#line 213 "../src/librygel-server/rygel-video-item.vala"
				_tmp99_ = rygel_http_server_create_uri_for_object (http_server, (RygelMediaObject*) self, 0, -1, NULL);
#line 213 "../src/librygel-server/rygel-video-item.vala"
				http_uri = _tmp99_;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp101_ = rygel_media_file_item_address_regex;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp102_ = http_uri;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp103_ = http_server->context;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp104_ = gssdp_client_get_address ((GSSDPClient*) _tmp103_);
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp105_ = _tmp104_;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp106_ = _tmp105_;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp107_ = g_inet_address_to_string (_tmp106_);
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp108_ = _tmp107_;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp109_ = g_regex_replace_literal (_tmp101_, _tmp102_, (gssize) -1, 0, _tmp108_, 0, &_inner_error0_);
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp110_ = _tmp109_;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_g_free0 (_tmp108_);
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_g_object_unref0 (_tmp106_);
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp100_ = _tmp110_;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "../src/librygel-server/rygel-video-item.vala"
					g_propagate_error (error, _inner_error0_);
#line 217 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (http_uri);
#line 217 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (protocol);
#line 217 "../src/librygel-server/rygel-video-item.vala"
					_rygel_subtitle_unref0 (main_subtitle);
#line 217 "../src/librygel-server/rygel-video-item.vala"
					_g_object_unref0 (didl_item);
#line 217 "../src/librygel-server/rygel-video-item.vala"
					_g_object_unref0 (_tmp0_);
#line 217 "../src/librygel-server/rygel-video-item.vala"
					return NULL;
#line 1154 "rygel-video-item.c"
				}
#line 217 "../src/librygel-server/rygel-video-item.vala"
				_tmp111_ = didl_item;
#line 217 "../src/librygel-server/rygel-video-item.vala"
				gupnp_didl_lite_object_set_album_art ((GUPnPDIDLLiteObject*) _tmp111_, _tmp100_);
#line 209 "../src/librygel-server/rygel-video-item.vala"
				_g_free0 (_tmp100_);
#line 209 "../src/librygel-server/rygel-video-item.vala"
				_g_free0 (http_uri);
#line 1164 "rygel-video-item.c"
			}
#line 207 "../src/librygel-server/rygel-video-item.vala"
			_g_free0 (protocol);
#line 1168 "rygel-video-item.c"
		}
#line 148 "../src/librygel-server/rygel-video-item.vala"
		_rygel_subtitle_unref0 (main_subtitle);
#line 1172 "rygel-video-item.c"
	}
#line 226 "../src/librygel-server/rygel-video-item.vala"
	result = (GUPnPDIDLLiteObject*) didl_item;
#line 226 "../src/librygel-server/rygel-video-item.vala"
	_g_object_unref0 (_tmp0_);
#line 226 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 1180 "rygel-video-item.c"
}

static void
rygel_video_item_real_add_subtitle_resources (RygelVideoItem* self,
                                              RygelHTTPServer* http_server)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError* _inner_error0_ = NULL;
#line 229 "../src/librygel-server/rygel-video-item.vala"
	g_return_if_fail (http_server != NULL);
#line 230 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = rygel_media_file_item_get_place_holder ((RygelMediaFileItem*) self);
#line 230 "../src/librygel-server/rygel-video-item.vala"
	_tmp1_ = _tmp0_;
#line 230 "../src/librygel-server/rygel-video-item.vala"
	if (_tmp1_) {
#line 231 "../src/librygel-server/rygel-video-item.vala"
		return;
#line 1200 "rygel-video-item.c"
	}
	{
		gint i = 0;
#line 234 "../src/librygel-server/rygel-video-item.vala"
		i = 0;
#line 1206 "rygel-video-item.c"
		{
			gboolean _tmp2_ = FALSE;
#line 234 "../src/librygel-server/rygel-video-item.vala"
			_tmp2_ = TRUE;
#line 234 "../src/librygel-server/rygel-video-item.vala"
			while (TRUE) {
#line 1213 "rygel-video-item.c"
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				RygelSubtitle* subtitle = NULL;
				GeeArrayList* _tmp7_;
				gpointer _tmp8_;
				gchar* protocol = NULL;
				RygelMediaResource* subtitle_resource = NULL;
				RygelSubtitle* _tmp16_;
				const gchar* _tmp17_;
				RygelMediaResource* _tmp18_;
				RygelMediaResource* _tmp19_;
				RygelSubtitle* _tmp20_;
				const gchar* _tmp21_;
				GeeList* _tmp22_;
				GeeList* _tmp23_;
				RygelMediaResource* _tmp24_;
				RygelSubtitle* _tmp25_;
				const gchar* _tmp26_;
#line 234 "../src/librygel-server/rygel-video-item.vala"
				if (!_tmp2_) {
#line 1235 "rygel-video-item.c"
					gint _tmp3_;
#line 234 "../src/librygel-server/rygel-video-item.vala"
					_tmp3_ = i;
#line 234 "../src/librygel-server/rygel-video-item.vala"
					i = _tmp3_ + 1;
#line 1241 "rygel-video-item.c"
				}
#line 234 "../src/librygel-server/rygel-video-item.vala"
				_tmp2_ = FALSE;
#line 234 "../src/librygel-server/rygel-video-item.vala"
				_tmp4_ = self->priv->_subtitles;
#line 234 "../src/librygel-server/rygel-video-item.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 234 "../src/librygel-server/rygel-video-item.vala"
				_tmp6_ = _tmp5_;
#line 234 "../src/librygel-server/rygel-video-item.vala"
				if (!(i < _tmp6_)) {
#line 234 "../src/librygel-server/rygel-video-item.vala"
					break;
#line 1255 "rygel-video-item.c"
				}
#line 235 "../src/librygel-server/rygel-video-item.vala"
				_tmp7_ = self->priv->_subtitles;
#line 235 "../src/librygel-server/rygel-video-item.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, i);
#line 235 "../src/librygel-server/rygel-video-item.vala"
				subtitle = (RygelSubtitle*) _tmp8_;
#line 1263 "rygel-video-item.c"
				{
					gchar* _tmp9_ = NULL;
					RygelSubtitle* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
#line 240 "../src/librygel-server/rygel-video-item.vala"
					_tmp10_ = subtitle;
#line 240 "../src/librygel-server/rygel-video-item.vala"
					_tmp11_ = _tmp10_->uri;
#line 240 "../src/librygel-server/rygel-video-item.vala"
					_tmp12_ = rygel_media_object_get_protocol_for_uri ((RygelMediaObject*) self, _tmp11_, &_inner_error0_);
#line 240 "../src/librygel-server/rygel-video-item.vala"
					_tmp9_ = _tmp12_;
#line 240 "../src/librygel-server/rygel-video-item.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1280 "rygel-video-item.c"
						goto __catch0_g_error;
					}
#line 240 "../src/librygel-server/rygel-video-item.vala"
					_tmp13_ = _tmp9_;
#line 240 "../src/librygel-server/rygel-video-item.vala"
					_tmp9_ = NULL;
#line 240 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (protocol);
#line 240 "../src/librygel-server/rygel-video-item.vala"
					protocol = _tmp13_;
#line 239 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (_tmp9_);
#line 1293 "rygel-video-item.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					RygelSubtitle* _tmp14_;
					const gchar* _tmp15_;
#line 239 "../src/librygel-server/rygel-video-item.vala"
					g_clear_error (&_inner_error0_);
#line 242 "../src/librygel-server/rygel-video-item.vala"
					_tmp14_ = subtitle;
#line 242 "../src/librygel-server/rygel-video-item.vala"
					_tmp15_ = _tmp14_->uri;
#line 242 "../src/librygel-server/rygel-video-item.vala"
					g_message (_ ("Could not determine protocol for URI %s"), _tmp15_);
#line 245 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (protocol);
#line 245 "../src/librygel-server/rygel-video-item.vala"
					_rygel_subtitle_unref0 (subtitle);
#line 245 "../src/librygel-server/rygel-video-item.vala"
					continue;
#line 1314 "rygel-video-item.c"
				}
				__finally0:
#line 239 "../src/librygel-server/rygel-video-item.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 239 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (protocol);
#line 239 "../src/librygel-server/rygel-video-item.vala"
					_rygel_subtitle_unref0 (subtitle);
#line 239 "../src/librygel-server/rygel-video-item.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 239 "../src/librygel-server/rygel-video-item.vala"
					g_clear_error (&_inner_error0_);
#line 239 "../src/librygel-server/rygel-video-item.vala"
					return;
#line 1329 "rygel-video-item.c"
				}
#line 248 "../src/librygel-server/rygel-video-item.vala"
				_tmp16_ = subtitle;
#line 248 "../src/librygel-server/rygel-video-item.vala"
				_tmp17_ = protocol;
#line 248 "../src/librygel-server/rygel-video-item.vala"
				_tmp18_ = rygel_subtitle_get_resource (_tmp16_, _tmp17_, i);
#line 248 "../src/librygel-server/rygel-video-item.vala"
				subtitle_resource = _tmp18_;
#line 249 "../src/librygel-server/rygel-video-item.vala"
				_tmp19_ = subtitle_resource;
#line 249 "../src/librygel-server/rygel-video-item.vala"
				_tmp20_ = subtitle;
#line 249 "../src/librygel-server/rygel-video-item.vala"
				_tmp21_ = _tmp20_->uri;
#line 249 "../src/librygel-server/rygel-video-item.vala"
				rygel_media_resource_set_uri (_tmp19_, _tmp21_);
#line 250 "../src/librygel-server/rygel-video-item.vala"
				_tmp22_ = rygel_media_object_get_resource_list ((RygelMediaObject*) self);
#line 250 "../src/librygel-server/rygel-video-item.vala"
				_tmp23_ = _tmp22_;
#line 250 "../src/librygel-server/rygel-video-item.vala"
				_tmp24_ = subtitle_resource;
#line 250 "../src/librygel-server/rygel-video-item.vala"
				gee_collection_add ((GeeCollection*) _tmp23_, _tmp24_);
#line 250 "../src/librygel-server/rygel-video-item.vala"
				_g_object_unref0 (_tmp23_);
#line 251 "../src/librygel-server/rygel-video-item.vala"
				_tmp25_ = subtitle;
#line 251 "../src/librygel-server/rygel-video-item.vala"
				_tmp26_ = _tmp25_->uri;
#line 251 "../src/librygel-server/rygel-video-item.vala"
				if (rygel_http_server_need_proxy (http_server, _tmp26_)) {
#line 1363 "rygel-video-item.c"
					RygelMediaResource* http_sub_res = NULL;
					RygelSubtitle* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					RygelMediaResource* _tmp30_;
					RygelMediaResource* _tmp31_;
					RygelMediaResource* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
					GeeList* _tmp35_;
					GeeList* _tmp36_;
					RygelMediaResource* _tmp37_;
#line 252 "../src/librygel-server/rygel-video-item.vala"
					_tmp27_ = subtitle;
#line 252 "../src/librygel-server/rygel-video-item.vala"
					_tmp28_ = rygel_http_server_get_protocol (http_server);
#line 252 "../src/librygel-server/rygel-video-item.vala"
					_tmp29_ = _tmp28_;
#line 252 "../src/librygel-server/rygel-video-item.vala"
					_tmp30_ = rygel_subtitle_get_resource (_tmp27_, _tmp29_, i);
#line 252 "../src/librygel-server/rygel-video-item.vala"
					_tmp31_ = _tmp30_;
#line 252 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (_tmp29_);
#line 252 "../src/librygel-server/rygel-video-item.vala"
					http_sub_res = _tmp31_;
#line 256 "../src/librygel-server/rygel-video-item.vala"
					_tmp32_ = http_sub_res;
#line 256 "../src/librygel-server/rygel-video-item.vala"
					_tmp33_ = rygel_http_server_create_uri_for_object (http_server, (RygelMediaObject*) self, -1, i, NULL);
#line 256 "../src/librygel-server/rygel-video-item.vala"
					_tmp34_ = _tmp33_;
#line 256 "../src/librygel-server/rygel-video-item.vala"
					rygel_media_resource_set_uri (_tmp32_, _tmp34_);
#line 256 "../src/librygel-server/rygel-video-item.vala"
					_g_free0 (_tmp34_);
#line 261 "../src/librygel-server/rygel-video-item.vala"
					_tmp35_ = rygel_media_object_get_resource_list ((RygelMediaObject*) self);
#line 261 "../src/librygel-server/rygel-video-item.vala"
					_tmp36_ = _tmp35_;
#line 261 "../src/librygel-server/rygel-video-item.vala"
					_tmp37_ = http_sub_res;
#line 261 "../src/librygel-server/rygel-video-item.vala"
					gee_collection_add ((GeeCollection*) _tmp36_, _tmp37_);
#line 261 "../src/librygel-server/rygel-video-item.vala"
					_g_object_unref0 (_tmp36_);
#line 251 "../src/librygel-server/rygel-video-item.vala"
					_g_object_unref0 (http_sub_res);
#line 1412 "rygel-video-item.c"
				}
#line 234 "../src/librygel-server/rygel-video-item.vala"
				_g_object_unref0 (subtitle_resource);
#line 234 "../src/librygel-server/rygel-video-item.vala"
				_g_free0 (protocol);
#line 234 "../src/librygel-server/rygel-video-item.vala"
				_rygel_subtitle_unref0 (subtitle);
#line 1420 "rygel-video-item.c"
			}
		}
	}
}

void
rygel_video_item_add_subtitle_resources (RygelVideoItem* self,
                                         RygelHTTPServer* http_server)
{
	RygelVideoItemClass* _klass_;
#line 229 "../src/librygel-server/rygel-video-item.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/librygel-server/rygel-video-item.vala"
	_klass_ = RYGEL_VIDEO_ITEM_GET_CLASS (self);
#line 229 "../src/librygel-server/rygel-video-item.vala"
	if (_klass_->add_subtitle_resources) {
#line 229 "../src/librygel-server/rygel-video-item.vala"
		_klass_->add_subtitle_resources (self, http_server);
#line 1439 "rygel-video-item.c"
	}
}

static void
rygel_video_item_real_add_additional_resources (RygelMediaFileItem* base,
                                                RygelHTTPServer* server)
{
	RygelVideoItem * self;
#line 266 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 266 "../src/librygel-server/rygel-video-item.vala"
	g_return_if_fail (server != NULL);
#line 267 "../src/librygel-server/rygel-video-item.vala"
	RYGEL_MEDIA_FILE_ITEM_CLASS (rygel_video_item_parent_class)->add_additional_resources ((RygelMediaFileItem*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem), server);
#line 269 "../src/librygel-server/rygel-video-item.vala"
	rygel_visual_item_add_thumbnail_resources ((RygelVisualItem*) self, server);
#line 270 "../src/librygel-server/rygel-video-item.vala"
	rygel_video_item_add_subtitle_resources (self, server);
#line 1458 "rygel-video-item.c"
}

const gchar*
rygel_video_item_get_author (RygelVideoItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = self->priv->_author;
#line 38 "../src/librygel-server/rygel-video-item.vala"
	result = _tmp0_;
#line 38 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 1474 "rygel-video-item.c"
}

void
rygel_video_item_set_author (RygelVideoItem* self,
                             const gchar* value)
{
	gchar* old_value;
#line 38 "../src/librygel-server/rygel-video-item.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/librygel-server/rygel-video-item.vala"
	old_value = rygel_video_item_get_author (self);
#line 38 "../src/librygel-server/rygel-video-item.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1488 "rygel-video-item.c"
		gchar* _tmp0_;
#line 38 "../src/librygel-server/rygel-video-item.vala"
		_tmp0_ = g_strdup (value);
#line 38 "../src/librygel-server/rygel-video-item.vala"
		_g_free0 (self->priv->_author);
#line 38 "../src/librygel-server/rygel-video-item.vala"
		self->priv->_author = _tmp0_;
#line 38 "../src/librygel-server/rygel-video-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_video_item_properties[RYGEL_VIDEO_ITEM_AUTHOR_PROPERTY]);
#line 1498 "rygel-video-item.c"
	}
}

static gint
rygel_video_item_real_get_width (RygelVisualItem* base)
{
	gint result;
	RygelVideoItem* self;
#line 47 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 47 "../src/librygel-server/rygel-video-item.vala"
	result = self->priv->_width;
#line 47 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 1513 "rygel-video-item.c"
}

static void
rygel_video_item_real_set_width (RygelVisualItem* base,
                                 gint value)
{
	RygelVideoItem* self;
	gint old_value;
#line 47 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 47 "../src/librygel-server/rygel-video-item.vala"
	old_value = rygel_video_item_real_get_width (base);
#line 47 "../src/librygel-server/rygel-video-item.vala"
	if (old_value != value) {
#line 47 "../src/librygel-server/rygel-video-item.vala"
		self->priv->_width = value;
#line 47 "../src/librygel-server/rygel-video-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_video_item_properties[RYGEL_VIDEO_ITEM_WIDTH_PROPERTY]);
#line 1532 "rygel-video-item.c"
	}
}

static gint
rygel_video_item_real_get_height (RygelVisualItem* base)
{
	gint result;
	RygelVideoItem* self;
#line 53 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 53 "../src/librygel-server/rygel-video-item.vala"
	result = self->priv->_height;
#line 53 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 1547 "rygel-video-item.c"
}

static void
rygel_video_item_real_set_height (RygelVisualItem* base,
                                  gint value)
{
	RygelVideoItem* self;
	gint old_value;
#line 53 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 53 "../src/librygel-server/rygel-video-item.vala"
	old_value = rygel_video_item_real_get_height (base);
#line 53 "../src/librygel-server/rygel-video-item.vala"
	if (old_value != value) {
#line 53 "../src/librygel-server/rygel-video-item.vala"
		self->priv->_height = value;
#line 53 "../src/librygel-server/rygel-video-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_video_item_properties[RYGEL_VIDEO_ITEM_HEIGHT_PROPERTY]);
#line 1566 "rygel-video-item.c"
	}
}

static gint
rygel_video_item_real_get_color_depth (RygelVisualItem* base)
{
	gint result;
	RygelVideoItem* self;
#line 59 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 59 "../src/librygel-server/rygel-video-item.vala"
	result = self->priv->_color_depth;
#line 59 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 1581 "rygel-video-item.c"
}

static void
rygel_video_item_real_set_color_depth (RygelVisualItem* base,
                                       gint value)
{
	RygelVideoItem* self;
	gint old_value;
#line 59 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 59 "../src/librygel-server/rygel-video-item.vala"
	old_value = rygel_video_item_real_get_color_depth (base);
#line 59 "../src/librygel-server/rygel-video-item.vala"
	if (old_value != value) {
#line 59 "../src/librygel-server/rygel-video-item.vala"
		self->priv->_color_depth = value;
#line 59 "../src/librygel-server/rygel-video-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_video_item_properties[RYGEL_VIDEO_ITEM_COLOR_DEPTH_PROPERTY]);
#line 1600 "rygel-video-item.c"
	}
}

static GeeArrayList*
rygel_video_item_real_get_thumbnails (RygelVisualItem* base)
{
	GeeArrayList* result;
	RygelVideoItem* self;
	GeeArrayList* _tmp0_;
#line 64 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 64 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = self->priv->_thumbnails;
#line 64 "../src/librygel-server/rygel-video-item.vala"
	result = _tmp0_;
#line 64 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 1618 "rygel-video-item.c"
}

static void
rygel_video_item_real_set_thumbnails (RygelVisualItem* base,
                                      GeeArrayList* value)
{
	RygelVideoItem* self;
	GeeArrayList* old_value;
#line 64 "../src/librygel-server/rygel-video-item.vala"
	self = (RygelVideoItem*) base;
#line 64 "../src/librygel-server/rygel-video-item.vala"
	old_value = rygel_video_item_real_get_thumbnails (base);
#line 64 "../src/librygel-server/rygel-video-item.vala"
	if (old_value != value) {
#line 1633 "rygel-video-item.c"
		GeeArrayList* _tmp0_;
#line 64 "../src/librygel-server/rygel-video-item.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 64 "../src/librygel-server/rygel-video-item.vala"
		_g_object_unref0 (self->priv->_thumbnails);
#line 64 "../src/librygel-server/rygel-video-item.vala"
		self->priv->_thumbnails = _tmp0_;
#line 64 "../src/librygel-server/rygel-video-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_video_item_properties[RYGEL_VIDEO_ITEM_THUMBNAILS_PROPERTY]);
#line 1643 "rygel-video-item.c"
	}
}

GeeArrayList*
rygel_video_item_get_subtitles (RygelVideoItem* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 66 "../src/librygel-server/rygel-video-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/librygel-server/rygel-video-item.vala"
	_tmp0_ = self->priv->_subtitles;
#line 66 "../src/librygel-server/rygel-video-item.vala"
	result = _tmp0_;
#line 66 "../src/librygel-server/rygel-video-item.vala"
	return result;
#line 1660 "rygel-video-item.c"
}

void
rygel_video_item_set_subtitles (RygelVideoItem* self,
                                GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 66 "../src/librygel-server/rygel-video-item.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/librygel-server/rygel-video-item.vala"
	old_value = rygel_video_item_get_subtitles (self);
#line 66 "../src/librygel-server/rygel-video-item.vala"
	if (old_value != value) {
#line 1674 "rygel-video-item.c"
		GeeArrayList* _tmp0_;
#line 66 "../src/librygel-server/rygel-video-item.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 66 "../src/librygel-server/rygel-video-item.vala"
		_g_object_unref0 (self->priv->_subtitles);
#line 66 "../src/librygel-server/rygel-video-item.vala"
		self->priv->_subtitles = _tmp0_;
#line 66 "../src/librygel-server/rygel-video-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_video_item_properties[RYGEL_VIDEO_ITEM_SUBTITLES_PROPERTY]);
#line 1684 "rygel-video-item.c"
	}
}

static void
rygel_video_item_class_init (RygelVideoItemClass * klass,
                             gpointer klass_data)
{
#line 35 "../src/librygel-server/rygel-video-item.vala"
	rygel_video_item_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/librygel-server/rygel-video-item.vala"
	g_type_class_adjust_private_offset (klass, &RygelVideoItem_private_offset);
#line 35 "../src/librygel-server/rygel-video-item.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_video_item_real_constructed;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	((RygelMediaObjectClass *) klass)->add_uri = (void (*) (RygelMediaObject*, const gchar*)) rygel_video_item_real_add_uri;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	((RygelMediaFileItemClass *) klass)->get_primary_resource = (RygelMediaResource* (*) (RygelMediaFileItem*)) rygel_video_item_real_get_primary_resource;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	((RygelMediaObjectClass *) klass)->compare_by_property = (gint (*) (RygelMediaObject*, RygelMediaObject*, const gchar*)) rygel_video_item_real_compare_by_property;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	((RygelMediaObjectClass *) klass)->apply_didl_lite = (void (*) (RygelMediaObject*, GUPnPDIDLLiteObject*)) rygel_video_item_real_apply_didl_lite;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	((RygelMediaObjectClass *) klass)->serialize = (GUPnPDIDLLiteObject* (*) (RygelMediaObject*, RygelSerializer*, RygelHTTPServer*, GError**)) rygel_video_item_real_serialize;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	((RygelVideoItemClass *) klass)->add_subtitle_resources = (void (*) (RygelVideoItem*, RygelHTTPServer*)) rygel_video_item_real_add_subtitle_resources;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	((RygelMediaFileItemClass *) klass)->add_additional_resources = (void (*) (RygelMediaFileItem*, RygelHTTPServer*)) rygel_video_item_real_add_additional_resources;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_video_item_get_property;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_video_item_set_property;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_video_item_finalize;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_VIDEO_ITEM_AUTHOR_PROPERTY, rygel_video_item_properties[RYGEL_VIDEO_ITEM_AUTHOR_PROPERTY] = g_param_spec_string ("author", "author", "author", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1720 "rygel-video-item.c"
	/**
	     * The width of the item source content (this.uri) in pixels
	     * A value of -1 means that the width is unknown
	     */
#line 35 "../src/librygel-server/rygel-video-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_VIDEO_ITEM_WIDTH_PROPERTY, rygel_video_item_properties[RYGEL_VIDEO_ITEM_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1727 "rygel-video-item.c"
	/**
	     * The height of the item source content (this.uri) in pixels
	     * A value of -1 means that the height is unknown
	     */
#line 35 "../src/librygel-server/rygel-video-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_VIDEO_ITEM_HEIGHT_PROPERTY, rygel_video_item_properties[RYGEL_VIDEO_ITEM_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1734 "rygel-video-item.c"
	/**
	     * The number of bits per pixel in the source video resource (this.uri)
	     * A value of -1 means that the color depth is unknown
	     */
#line 35 "../src/librygel-server/rygel-video-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_VIDEO_ITEM_COLOR_DEPTH_PROPERTY, rygel_video_item_properties[RYGEL_VIDEO_ITEM_COLOR_DEPTH_PROPERTY] = g_param_spec_int ("color-depth", "color-depth", "color-depth", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1741 "rygel-video-item.c"
	/**
	     * Thumbnail pictures to represent the video.
	     */
#line 35 "../src/librygel-server/rygel-video-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_VIDEO_ITEM_THUMBNAILS_PROPERTY, rygel_video_item_properties[RYGEL_VIDEO_ITEM_THUMBNAILS_PROPERTY] = g_param_spec_object ("thumbnails", "thumbnails", "thumbnails", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/librygel-server/rygel-video-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_VIDEO_ITEM_SUBTITLES_PROPERTY, rygel_video_item_properties[RYGEL_VIDEO_ITEM_SUBTITLES_PROPERTY] = g_param_spec_object ("subtitles", "subtitles", "subtitles", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1749 "rygel-video-item.c"
}

static void
rygel_video_item_rygel_visual_item_interface_init (RygelVisualItemIface * iface,
                                                   gpointer iface_data)
{
#line 35 "../src/librygel-server/rygel-video-item.vala"
	rygel_video_item_rygel_visual_item_parent_iface = g_type_interface_peek_parent (iface);
#line 35 "../src/librygel-server/rygel-video-item.vala"
	iface->get_width = rygel_video_item_real_get_width;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	iface->set_width = rygel_video_item_real_set_width;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	iface->get_height = rygel_video_item_real_get_height;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	iface->set_height = rygel_video_item_real_set_height;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	iface->get_color_depth = rygel_video_item_real_get_color_depth;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	iface->set_color_depth = rygel_video_item_real_set_color_depth;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	iface->get_thumbnails = rygel_video_item_real_get_thumbnails;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	iface->set_thumbnails = rygel_video_item_real_set_thumbnails;
#line 1774 "rygel-video-item.c"
}

static void
rygel_video_item_instance_init (RygelVideoItem * self,
                                gpointer klass)
{
#line 35 "../src/librygel-server/rygel-video-item.vala"
	self->priv = rygel_video_item_get_instance_private (self);
#line 47 "../src/librygel-server/rygel-video-item.vala"
	self->priv->_width = -1;
#line 53 "../src/librygel-server/rygel-video-item.vala"
	self->priv->_height = -1;
#line 59 "../src/librygel-server/rygel-video-item.vala"
	self->priv->_color_depth = -1;
#line 1789 "rygel-video-item.c"
}

static void
rygel_video_item_finalize (GObject * obj)
{
	RygelVideoItem * self;
#line 35 "../src/librygel-server/rygel-video-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_VIDEO_ITEM, RygelVideoItem);
#line 38 "../src/librygel-server/rygel-video-item.vala"
	_g_free0 (self->priv->_author);
#line 64 "../src/librygel-server/rygel-video-item.vala"
	_g_object_unref0 (self->priv->_thumbnails);
#line 66 "../src/librygel-server/rygel-video-item.vala"
	_g_object_unref0 (self->priv->_subtitles);
#line 35 "../src/librygel-server/rygel-video-item.vala"
	G_OBJECT_CLASS (rygel_video_item_parent_class)->finalize (obj);
#line 1806 "rygel-video-item.c"
}

/**
 * Represents a video item.
 */
 G_GNUC_NO_INLINE static GType
rygel_video_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelVideoItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_video_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelVideoItem), 0, (GInstanceInitFunc) rygel_video_item_instance_init, NULL };
	static const GInterfaceInfo rygel_visual_item_info = { (GInterfaceInitFunc) rygel_video_item_rygel_visual_item_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType rygel_video_item_type_id;
	rygel_video_item_type_id = g_type_register_static (RYGEL_TYPE_AUDIO_ITEM, "RygelVideoItem", &g_define_type_info, 0);
	g_type_add_interface_static (rygel_video_item_type_id, RYGEL_TYPE_VISUAL_ITEM, &rygel_visual_item_info);
	RygelVideoItem_private_offset = g_type_add_instance_private (rygel_video_item_type_id, sizeof (RygelVideoItemPrivate));
	return rygel_video_item_type_id;
}

GType
rygel_video_item_get_type (void)
{
	static volatile gsize rygel_video_item_type_id__once = 0;
	if (g_once_init_enter (&rygel_video_item_type_id__once)) {
		GType rygel_video_item_type_id;
		rygel_video_item_type_id = rygel_video_item_get_type_once ();
		g_once_init_leave (&rygel_video_item_type_id__once, rygel_video_item_type_id);
	}
	return rygel_video_item_type_id__once;
}

static void
_vala_rygel_video_item_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	RygelVideoItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_VIDEO_ITEM, RygelVideoItem);
#line 35 "../src/librygel-server/rygel-video-item.vala"
	switch (property_id) {
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_AUTHOR_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		g_value_set_string (value, rygel_video_item_get_author (self));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_WIDTH_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		g_value_set_int (value, rygel_visual_item_get_width ((RygelVisualItem*) self));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_HEIGHT_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		g_value_set_int (value, rygel_visual_item_get_height ((RygelVisualItem*) self));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_COLOR_DEPTH_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		g_value_set_int (value, rygel_visual_item_get_color_depth ((RygelVisualItem*) self));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_THUMBNAILS_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		g_value_set_object (value, rygel_visual_item_get_thumbnails ((RygelVisualItem*) self));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_SUBTITLES_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		g_value_set_object (value, rygel_video_item_get_subtitles (self));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 1882 "rygel-video-item.c"
		default:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 1888 "rygel-video-item.c"
	}
}

static void
_vala_rygel_video_item_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	RygelVideoItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_VIDEO_ITEM, RygelVideoItem);
#line 35 "../src/librygel-server/rygel-video-item.vala"
	switch (property_id) {
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_AUTHOR_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		rygel_video_item_set_author (self, g_value_get_string (value));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_WIDTH_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		rygel_visual_item_set_width ((RygelVisualItem*) self, g_value_get_int (value));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_HEIGHT_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		rygel_visual_item_set_height ((RygelVisualItem*) self, g_value_get_int (value));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_COLOR_DEPTH_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		rygel_visual_item_set_color_depth ((RygelVisualItem*) self, g_value_get_int (value));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_THUMBNAILS_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		rygel_visual_item_set_thumbnails ((RygelVisualItem*) self, g_value_get_object (value));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-video-item.vala"
		case RYGEL_VIDEO_ITEM_SUBTITLES_PROPERTY:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		rygel_video_item_set_subtitles (self, g_value_get_object (value));
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 1938 "rygel-video-item.c"
		default:
#line 35 "../src/librygel-server/rygel-video-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/librygel-server/rygel-video-item.vala"
		break;
#line 1944 "rygel-video-item.c"
	}
}

