/* rygel-audio-transcoder.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-audio-transcoder.vala, do not modify */

/*
 * Copyright (C) 2011 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *         Prasanna Modem <prasanna@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib-object.h>
#include "rygel-server.h"
#include <glib.h>
#include <gst/pbutils/pbutils.h>
#include <gst/gst.h>
#include <stdlib.h>
#include <string.h>
#include "rygel-media-engine-gst.h"

#define RYGEL_AUDIO_TRANSCODER_NO_CONTAINER NULL
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_GST_TRANSCODER (rygel_gst_transcoder_get_type ())
#define RYGEL_GST_TRANSCODER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_GST_TRANSCODER, RygelGstTranscoder))
#define RYGEL_GST_TRANSCODER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_GST_TRANSCODER, RygelGstTranscoderClass))
#define RYGEL_IS_GST_TRANSCODER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_GST_TRANSCODER))
#define RYGEL_IS_GST_TRANSCODER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_GST_TRANSCODER))
#define RYGEL_GST_TRANSCODER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_GST_TRANSCODER, RygelGstTranscoderClass))

typedef struct _RygelGstTranscoder RygelGstTranscoder;
typedef struct _RygelGstTranscoderClass RygelGstTranscoderClass;
typedef struct _RygelGstTranscoderPrivate RygelGstTranscoderPrivate;

#define RYGEL_TYPE_AUDIO_TRANSCODER (rygel_audio_transcoder_get_type ())
#define RYGEL_AUDIO_TRANSCODER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_AUDIO_TRANSCODER, RygelAudioTranscoder))
#define RYGEL_AUDIO_TRANSCODER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_AUDIO_TRANSCODER, RygelAudioTranscoderClass))
#define RYGEL_IS_AUDIO_TRANSCODER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_AUDIO_TRANSCODER))
#define RYGEL_IS_AUDIO_TRANSCODER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_AUDIO_TRANSCODER))
#define RYGEL_AUDIO_TRANSCODER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_AUDIO_TRANSCODER, RygelAudioTranscoderClass))

typedef struct _RygelAudioTranscoder RygelAudioTranscoder;
typedef struct _RygelAudioTranscoderClass RygelAudioTranscoderClass;
typedef struct _RygelAudioTranscoderPrivate RygelAudioTranscoderPrivate;
enum  {
	RYGEL_AUDIO_TRANSCODER_0_PROPERTY,
	RYGEL_AUDIO_TRANSCODER_NUM_PROPERTIES
};
static GParamSpec* rygel_audio_transcoder_properties[RYGEL_AUDIO_TRANSCODER_NUM_PROPERTIES];
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _RygelGstTranscoder {
	GObject parent_instance;
	RygelGstTranscoderPrivate * priv;
};

struct _RygelGstTranscoderClass {
	GObjectClass parent_class;
	RygelMediaResource* (*get_resource_for_item) (RygelGstTranscoder* self, RygelMediaFileItem* item);
	guint (*get_distance) (RygelGstTranscoder* self, RygelMediaFileItem* item);
	GstEncodingProfile* (*get_encoding_profile) (RygelGstTranscoder* self, RygelMediaFileItem* item);
};

struct _RygelAudioTranscoder {
	RygelGstTranscoder parent_instance;
	RygelAudioTranscoderPrivate * priv;
	gint audio_bitrate;
	GstCaps* container_format;
	GstCaps* audio_codec_format;
};

struct _RygelAudioTranscoderClass {
	RygelGstTranscoderClass parent_class;
};

static gpointer rygel_audio_transcoder_parent_class = NULL;

VALA_EXTERN GType rygel_gst_transcoder_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_audio_transcoder_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint rygel_gst_transcoder_get_distance (RygelGstTranscoder* self,
                                         RygelMediaFileItem* item);
VALA_EXTERN GstEncodingProfile* rygel_gst_transcoder_get_encoding_profile (RygelGstTranscoder* self,
                                                               RygelMediaFileItem* item);
VALA_EXTERN RygelMediaResource* rygel_gst_transcoder_get_resource_for_item (RygelGstTranscoder* self,
                                                                RygelMediaFileItem* item);
VALA_EXTERN RygelAudioTranscoder* rygel_audio_transcoder_construct (GType object_type,
                                                        const gchar* name,
                                                        const gchar* content_type,
                                                        const gchar* dlna_profile,
                                                        gint audio_bitrate,
                                                        const gchar* container_caps,
                                                        const gchar* audio_codec_caps,
                                                        const gchar* extension);
VALA_EXTERN RygelGstTranscoder* rygel_gst_transcoder_construct (GType object_type,
                                                    const gchar* name,
                                                    const gchar* mime_type,
                                                    const gchar* dlna_profile,
                                                    const gchar* extension);
VALA_EXTERN RygelAudioTranscoder* rygel_audio_transcoder_construct_with_class (GType object_type,
                                                                   const gchar* name,
                                                                   const gchar* content_type,
                                                                   const gchar* dlna_profile,
                                                                   gint audio_bitrate,
                                                                   const gchar* container_caps,
                                                                   const gchar* audio_codec_caps,
                                                                   const gchar* extension);
static guint rygel_audio_transcoder_real_get_distance (RygelGstTranscoder* base,
                                                RygelMediaFileItem* item);
static GstEncodingProfile* rygel_audio_transcoder_real_get_encoding_profile (RygelGstTranscoder* base,
                                                                      RygelMediaFileItem* item);
VALA_EXTERN const gchar* rygel_gst_transcoder_get_preset (RygelGstTranscoder* self);
static RygelMediaResource* rygel_audio_transcoder_real_get_resource_for_item (RygelGstTranscoder* base,
                                                                       RygelMediaFileItem* item);
static void rygel_audio_transcoder_finalize (GObject * obj);
static GType rygel_audio_transcoder_get_type_once (void);

RygelAudioTranscoder*
rygel_audio_transcoder_construct (GType object_type,
                                  const gchar* name,
                                  const gchar* content_type,
                                  const gchar* dlna_profile,
                                  gint audio_bitrate,
                                  const gchar* container_caps,
                                  const gchar* audio_codec_caps,
                                  const gchar* extension)
{
	RygelAudioTranscoder * self = NULL;
	GstCaps* _tmp1_;
#line 40 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 40 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (content_type != NULL, NULL);
#line 40 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (dlna_profile != NULL, NULL);
#line 40 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (audio_codec_caps != NULL, NULL);
#line 40 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 47 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) rygel_gst_transcoder_construct (object_type, name, content_type, dlna_profile, extension);
#line 49 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_bitrate = audio_bitrate;
#line 50 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (container_caps != NULL) {
#line 171 "rygel-audio-transcoder.c"
		GstCaps* _tmp0_;
#line 51 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp0_ = gst_caps_from_string (container_caps);
#line 51 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_gst_caps_unref0 (self->container_format);
#line 51 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		self->container_format = _tmp0_;
#line 179 "rygel-audio-transcoder.c"
	}
#line 54 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = gst_caps_from_string (audio_codec_caps);
#line 54 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_gst_caps_unref0 (self->audio_codec_format);
#line 54 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_codec_format = _tmp1_;
#line 40 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return self;
#line 189 "rygel-audio-transcoder.c"
}

RygelAudioTranscoder*
rygel_audio_transcoder_construct_with_class (GType object_type,
                                             const gchar* name,
                                             const gchar* content_type,
                                             const gchar* dlna_profile,
                                             gint audio_bitrate,
                                             const gchar* container_caps,
                                             const gchar* audio_codec_caps,
                                             const gchar* extension)
{
	RygelAudioTranscoder * self = NULL;
	GstCaps* _tmp1_;
#line 57 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 57 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (content_type != NULL, NULL);
#line 57 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (dlna_profile != NULL, NULL);
#line 57 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (audio_codec_caps != NULL, NULL);
#line 57 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 64 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) rygel_gst_transcoder_construct (object_type, name, content_type, dlna_profile, extension);
#line 66 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_bitrate = audio_bitrate;
#line 67 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (container_caps != NULL) {
#line 220 "rygel-audio-transcoder.c"
		GstCaps* _tmp0_;
#line 68 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp0_ = gst_caps_from_string (container_caps);
#line 68 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_gst_caps_unref0 (self->container_format);
#line 68 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		self->container_format = _tmp0_;
#line 228 "rygel-audio-transcoder.c"
	}
#line 71 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = gst_caps_from_string (audio_codec_caps);
#line 71 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_gst_caps_unref0 (self->audio_codec_format);
#line 71 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_codec_format = _tmp1_;
#line 57 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return self;
#line 238 "rygel-audio-transcoder.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 79 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return self ? g_object_ref (self) : NULL;
#line 246 "rygel-audio-transcoder.c"
}

static guint
rygel_audio_transcoder_real_get_distance (RygelGstTranscoder* base,
                                          RygelMediaFileItem* item)
{
	RygelAudioTranscoder * self;
	gboolean _tmp0_ = FALSE;
	RygelAudioItem* audio_item = NULL;
	RygelAudioItem* _tmp1_;
	guint distance = 0U;
	RygelAudioItem* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	guint result;
#line 74 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) base;
#line 74 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (item != NULL, 0U);
#line 75 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_AUDIO_ITEM)) {
#line 75 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp0_ = TRUE;
#line 270 "rygel-audio-transcoder.c"
	} else {
#line 75 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_VIDEO_ITEM);
#line 274 "rygel-audio-transcoder.c"
	}
#line 75 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp0_) {
#line 76 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		result = G_MAXUINT;
#line 76 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		return result;
#line 282 "rygel-audio-transcoder.c"
	}
#line 79 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_AUDIO_ITEM) ? ((RygelAudioItem*) item) : NULL);
#line 79 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	audio_item = _tmp1_;
#line 80 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	distance = 0;
#line 82 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp2_ = audio_item;
#line 82 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp3_ = rygel_audio_item_get_bitrate (_tmp2_);
#line 82 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp4_ = _tmp3_;
#line 82 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp4_ > 0) {
#line 298 "rygel-audio-transcoder.c"
		RygelAudioItem* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 83 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp5_ = audio_item;
#line 83 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp6_ = rygel_audio_item_get_bitrate (_tmp5_);
#line 83 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp7_ = _tmp6_;
#line 83 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		distance += (guint) abs (_tmp7_ - self->audio_bitrate);
#line 310 "rygel-audio-transcoder.c"
	}
#line 86 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	result = distance;
#line 86 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_g_object_unref0 (audio_item);
#line 86 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return result;
#line 318 "rygel-audio-transcoder.c"
}

static GstEncodingProfile*
rygel_audio_transcoder_real_get_encoding_profile (RygelGstTranscoder* base,
                                                  RygelMediaFileItem* item)
{
	RygelAudioTranscoder * self;
	GstEncodingAudioProfile* enc_audio_profile = NULL;
	GstCaps* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GstEncodingAudioProfile* _tmp3_;
	GstEncodingAudioProfile* _tmp4_;
	GstCaps* _tmp5_;
	GstEncodingProfile* result;
#line 89 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) base;
#line 89 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 91 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp0_ = self->audio_codec_format;
#line 91 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = rygel_gst_transcoder_get_preset ((RygelGstTranscoder*) self);
#line 91 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp2_ = _tmp1_;
#line 91 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp3_ = gst_encoding_audio_profile_new (_tmp0_, _tmp2_, NULL, (guint) 1);
#line 91 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	enc_audio_profile = _tmp3_;
#line 95 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp4_ = enc_audio_profile;
#line 95 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	gst_encoding_profile_set_name ((GstEncodingProfile*) _tmp4_, "audio");
#line 97 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp5_ = self->container_format;
#line 97 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp5_ != NULL) {
#line 356 "rygel-audio-transcoder.c"
		GstEncodingContainerProfile* enc_container_profile = NULL;
		GstCaps* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GstEncodingContainerProfile* _tmp9_;
		GstEncodingContainerProfile* _tmp10_;
		GstEncodingAudioProfile* _tmp11_;
		GstEncodingProfile* _tmp12_;
#line 98 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp6_ = self->container_format;
#line 98 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp7_ = rygel_gst_transcoder_get_preset ((RygelGstTranscoder*) self);
#line 98 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp8_ = _tmp7_;
#line 98 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp9_ = gst_encoding_container_profile_new ("container", NULL, _tmp6_, _tmp8_);
#line 98 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		enc_container_profile = _tmp9_;
#line 102 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp10_ = enc_container_profile;
#line 102 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp11_ = enc_audio_profile;
#line 102 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp12_ = _g_object_ref0 ((GstEncodingProfile*) _tmp11_);
#line 102 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		gst_encoding_container_profile_add_profile (_tmp10_, _tmp12_);
#line 104 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		result = (GstEncodingProfile*) enc_container_profile;
#line 104 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_g_object_unref0 (enc_audio_profile);
#line 104 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		return result;
#line 389 "rygel-audio-transcoder.c"
	}
#line 107 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	result = (GstEncodingProfile*) enc_audio_profile;
#line 107 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return result;
#line 395 "rygel-audio-transcoder.c"
}

static RygelMediaResource*
rygel_audio_transcoder_real_get_resource_for_item (RygelGstTranscoder* base,
                                                   RygelMediaFileItem* item)
{
	RygelAudioTranscoder * self;
	RygelMediaResource* resource = NULL;
	RygelMediaResource* _tmp0_;
	RygelMediaResource* _tmp1_;
	RygelMediaResource* _tmp2_;
	RygelMediaResource* result;
#line 110 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) base;
#line 110 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 111 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp0_ = RYGEL_GST_TRANSCODER_CLASS (rygel_audio_transcoder_parent_class)->get_resource_for_item (G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_GST_TRANSCODER, RygelGstTranscoder), item);
#line 111 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	resource = _tmp0_;
#line 112 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = resource;
#line 112 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp1_ == NULL) {
#line 113 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		result = NULL;
#line 113 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_g_object_unref0 (resource);
#line 113 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		return result;
#line 426 "rygel-audio-transcoder.c"
	}
#line 116 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp2_ = resource;
#line 116 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	rygel_media_resource_set_sample_freq (_tmp2_, self->audio_bitrate);
#line 118 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	result = resource;
#line 118 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return result;
#line 436 "rygel-audio-transcoder.c"
}

static void
rygel_audio_transcoder_class_init (RygelAudioTranscoderClass * klass,
                                   gpointer klass_data)
{
#line 33 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	rygel_audio_transcoder_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	((RygelGstTranscoderClass *) klass)->get_distance = (guint (*) (RygelGstTranscoder*, RygelMediaFileItem*)) rygel_audio_transcoder_real_get_distance;
#line 33 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	((RygelGstTranscoderClass *) klass)->get_encoding_profile = (GstEncodingProfile* (*) (RygelGstTranscoder*, RygelMediaFileItem*)) rygel_audio_transcoder_real_get_encoding_profile;
#line 33 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	((RygelGstTranscoderClass *) klass)->get_resource_for_item = (RygelMediaResource* (*) (RygelGstTranscoder*, RygelMediaFileItem*)) rygel_audio_transcoder_real_get_resource_for_item;
#line 33 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_audio_transcoder_finalize;
#line 453 "rygel-audio-transcoder.c"
}

static void
rygel_audio_transcoder_instance_init (RygelAudioTranscoder * self,
                                      gpointer klass)
{
#line 35 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->container_format = NULL;
#line 36 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_codec_format = NULL;
#line 464 "rygel-audio-transcoder.c"
}

static void
rygel_audio_transcoder_finalize (GObject * obj)
{
	RygelAudioTranscoder * self;
#line 33 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_AUDIO_TRANSCODER, RygelAudioTranscoder);
#line 35 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_gst_caps_unref0 (self->container_format);
#line 36 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_gst_caps_unref0 (self->audio_codec_format);
#line 33 "../src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	G_OBJECT_CLASS (rygel_audio_transcoder_parent_class)->finalize (obj);
#line 479 "rygel-audio-transcoder.c"
}

/**
 * Base class for all transcoders that handle audio.
 */
 G_GNUC_NO_INLINE static GType
rygel_audio_transcoder_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelAudioTranscoderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_audio_transcoder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelAudioTranscoder), 0, (GInstanceInitFunc) rygel_audio_transcoder_instance_init, NULL };
	GType rygel_audio_transcoder_type_id;
	rygel_audio_transcoder_type_id = g_type_register_static (RYGEL_TYPE_GST_TRANSCODER, "RygelAudioTranscoder", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return rygel_audio_transcoder_type_id;
}

GType
rygel_audio_transcoder_get_type (void)
{
	static volatile gsize rygel_audio_transcoder_type_id__once = 0;
	if (g_once_init_enter (&rygel_audio_transcoder_type_id__once)) {
		GType rygel_audio_transcoder_type_id;
		rygel_audio_transcoder_type_id = rygel_audio_transcoder_get_type_once ();
		g_once_init_leave (&rygel_audio_transcoder_type_id__once, rygel_audio_transcoder_type_id);
	}
	return rygel_audio_transcoder_type_id__once;
}

