/* rygel-gst-data-source.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-gst-data-source.vala, do not modify */

/*
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *         Prasanna Modem <prasanna@ecaspia.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib.h>
#include <glib-object.h>
#include "rygel-server.h"
#include <gee.h>
#include <gst/gst.h>
#include <gst/base/base.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include "rygel-media-engine-gst.h"

#define RYGEL_GST_SINK_NAME "http-gst-sink"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_GST_DATA_SOURCE_ERROR (rygel_gst_data_source_error_get_type ())

#define RYGEL_TYPE_GST_DATA_SOURCE (rygel_gst_data_source_get_type ())
#define RYGEL_GST_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_GST_DATA_SOURCE, RygelGstDataSource))
#define RYGEL_GST_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_GST_DATA_SOURCE, RygelGstDataSourceClass))
#define RYGEL_IS_GST_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_GST_DATA_SOURCE))
#define RYGEL_IS_GST_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_GST_DATA_SOURCE))
#define RYGEL_GST_DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_GST_DATA_SOURCE, RygelGstDataSourceClass))

typedef struct _RygelGstDataSource RygelGstDataSource;
typedef struct _RygelGstDataSourceClass RygelGstDataSourceClass;
typedef struct _RygelGstDataSourcePrivate RygelGstDataSourcePrivate;

#define RYGEL_TYPE_GST_SINK (rygel_gst_sink_get_type ())
#define RYGEL_GST_SINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_GST_SINK, RygelGstSink))
#define RYGEL_GST_SINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_GST_SINK, RygelGstSinkClass))
#define RYGEL_IS_GST_SINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_GST_SINK))
#define RYGEL_IS_GST_SINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_GST_SINK))
#define RYGEL_GST_SINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_GST_SINK, RygelGstSinkClass))

typedef struct _RygelGstSink RygelGstSink;
typedef struct _RygelGstSinkClass RygelGstSinkClass;
enum  {
	RYGEL_GST_DATA_SOURCE_0_PROPERTY,
	RYGEL_GST_DATA_SOURCE_NUM_PROPERTIES
};
static GParamSpec* rygel_gst_data_source_properties[RYGEL_GST_DATA_SOURCE_NUM_PROPERTIES];
typedef struct _RygelGstSinkPrivate RygelGstSinkPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define RYGEL_TYPE_GST_ERROR (rygel_gst_error_get_type ())
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	RYGEL_GST_DATA_SOURCE_ERROR_NOT_COMPATIBLE
} RygelGstDataSourceError;
#define RYGEL_GST_DATA_SOURCE_ERROR rygel_gst_data_source_error_quark ()

struct _RygelGstDataSource {
	GObject parent_instance;
	RygelGstDataSourcePrivate * priv;
	GstElement* src;
	RygelMediaResource* res;
};

struct _RygelGstDataSourceClass {
	GObjectClass parent_class;
	GeeList* (*preroll) (RygelGstDataSource* self, RygelHTTPSeekRequest* seek_request, RygelPlaySpeedRequest* playspeed_request, GError** error);
	gboolean (*perform_seek) (RygelGstDataSource* self);
};

struct _RygelGstDataSourcePrivate {
	GstPipeline* pipeline;
	RygelHTTPSeekRequest* seek;
	RygelGstSink* sink;
	guint bus_watch_id;
	gchar* uri;
};

struct _RygelGstSink {
	GstBaseSink parent_instance;
	RygelGstSinkPrivate * priv;
	GCancellable* cancellable;
};

struct _RygelGstSinkClass {
	GstBaseSinkClass parent_class;
};

typedef enum  {
	RYGEL_GST_ERROR_MISSING_PLUGIN,
	RYGEL_GST_ERROR_LINK
} RygelGstError;
#define RYGEL_GST_ERROR rygel_gst_error_quark ()

static gint RygelGstDataSource_private_offset;
static gpointer rygel_gst_data_source_parent_class = NULL;
static RygelDataSourceIface * rygel_gst_data_source_rygel_data_source_parent_iface = NULL;

VALA_EXTERN GQuark rygel_gst_data_source_error_quark (void);
VALA_EXTERN GType rygel_gst_data_source_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_gst_data_source_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_gst_sink_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeList* rygel_gst_data_source_preroll (RygelGstDataSource* self,
                                        RygelHTTPSeekRequest* seek_request,
                                        RygelPlaySpeedRequest* playspeed_request,
                                        GError** error);
VALA_EXTERN gboolean rygel_gst_data_source_perform_seek (RygelGstDataSource* self);
VALA_EXTERN RygelGstDataSource* rygel_gst_data_source_new (const gchar* uri,
                                               RygelMediaResource* resource,
                                               GError** error);
VALA_EXTERN RygelGstDataSource* rygel_gst_data_source_construct (GType object_type,
                                                     const gchar* uri,
                                                     RygelMediaResource* resource,
                                                     GError** error);
VALA_EXTERN GstElement* rygel_gst_utils_create_source_for_uri (const gchar* uri);
VALA_EXTERN RygelGstDataSource* rygel_gst_data_source_new_from_element (GstElement* element);
VALA_EXTERN RygelGstDataSource* rygel_gst_data_source_construct_from_element (GType object_type,
                                                                  GstElement* element);
VALA_EXTERN gchar* rygel_gst_data_source_get_uri (RygelGstDataSource* self);
static GeeList* rygel_gst_data_source_real_preroll (RygelGstDataSource* self,
                                             RygelHTTPSeekRequest* seek_request,
                                             RygelPlaySpeedRequest* playspeed_request,
                                             GError** error);
static void rygel_gst_data_source_real_start (RygelDataSource* base,
                                       GError** error);
static void rygel_gst_data_source_prepare_pipeline (RygelGstDataSource* self,
                                             const gchar* name,
                                             GstElement* src,
                                             GError** error);
static void rygel_gst_data_source_real_freeze (RygelDataSource* base);
VALA_EXTERN void rygel_gst_sink_freeze (RygelGstSink* self);
static void rygel_gst_data_source_real_thaw (RygelDataSource* base);
VALA_EXTERN void rygel_gst_sink_thaw (RygelGstSink* self);
static void rygel_gst_data_source_real_stop (RygelDataSource* base);
static gboolean __lambda6_ (RygelGstDataSource* self);
static gboolean ___lambda6__gsource_func (gpointer self);
VALA_EXTERN RygelGstSink* rygel_gst_sink_new (RygelDataSource* source,
                                  RygelHTTPSeekRequest* offsets);
VALA_EXTERN RygelGstSink* rygel_gst_sink_construct (GType object_type,
                                        RygelDataSource* source,
                                        RygelHTTPSeekRequest* offsets);
static void rygel_gst_data_source_src_pad_added (RygelGstDataSource* self,
                                          GstElement* src,
                                          GstPad* src_pad);
static void _rygel_gst_data_source_src_pad_added_gst_element_pad_added (GstElement* _sender,
                                                                 GstPad* pad,
                                                                 gpointer self);
VALA_EXTERN GQuark rygel_gst_error_quark (void);
VALA_EXTERN GType rygel_gst_error_get_type (void) G_GNUC_CONST ;
static gboolean rygel_gst_data_source_bus_handler (RygelGstDataSource* self,
                                            GstBus* bus,
                                            GstMessage* message);
static gboolean _rygel_gst_data_source_bus_handler_gst_bus_func (GstBus* bus,
                                                          GstMessage* message,
                                                          gpointer self);
VALA_EXTERN GstElement* rygel_gst_utils_get_rtp_depayloader (GstCaps* caps);
static gboolean ___lambda5_ (RygelGstDataSource* self);
static gboolean ____lambda5__gsource_func (gpointer self);
static gboolean rygel_gst_data_source_real_perform_seek (RygelGstDataSource* self);
static void rygel_gst_data_source_finalize (GObject * obj);
static GType rygel_gst_data_source_get_type_once (void);

GQuark
rygel_gst_data_source_error_quark (void)
{
	return g_quark_from_static_string ("rygel-gst-data-source-error-quark");
}

 G_GNUC_NO_INLINE static GType
rygel_gst_data_source_error_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_GST_DATA_SOURCE_ERROR_NOT_COMPATIBLE, "RYGEL_GST_DATA_SOURCE_ERROR_NOT_COMPATIBLE", "not-compatible"}, {0, NULL, NULL}};
	GType rygel_gst_data_source_error_type_id;
	rygel_gst_data_source_error_type_id = g_enum_register_static ("RygelGstDataSourceError", values);
	return rygel_gst_data_source_error_type_id;
}

GType
rygel_gst_data_source_error_get_type (void)
{
	static volatile gsize rygel_gst_data_source_error_type_id__once = 0;
	if (g_once_init_enter (&rygel_gst_data_source_error_type_id__once)) {
		GType rygel_gst_data_source_error_type_id;
		rygel_gst_data_source_error_type_id = rygel_gst_data_source_error_get_type_once ();
		g_once_init_leave (&rygel_gst_data_source_error_type_id__once, rygel_gst_data_source_error_type_id);
	}
	return rygel_gst_data_source_error_type_id__once;
}

static inline gpointer
rygel_gst_data_source_get_instance_private (RygelGstDataSource* self)
{
	return G_STRUCT_MEMBER_P (self, RygelGstDataSource_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return self ? g_object_ref (self) : NULL;
#line 235 "rygel-gst-data-source.c"
}

RygelGstDataSource*
rygel_gst_data_source_construct (GType object_type,
                                 const gchar* uri,
                                 RygelMediaResource* resource,
                                 GError** error)
{
	RygelGstDataSource * self = NULL;
	gchar* _tmp0_;
	RygelMediaResource* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 41 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 41 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self = (RygelGstDataSource*) g_object_new (object_type, NULL);
#line 42 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = g_strdup (uri);
#line 42 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_free0 (self->priv->uri);
#line 42 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->priv->uri = _tmp0_;
#line 43 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp1_ = _g_object_ref0 (resource);
#line 43 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->res);
#line 43 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->res = _tmp1_;
#line 44 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp2_ = rygel_gst_utils_create_source_for_uri (uri);
#line 44 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->src);
#line 44 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->src = _tmp2_;
#line 45 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp3_ = self->src;
#line 45 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_tmp3_ == NULL) {
#line 276 "rygel-gst-data-source.c"
		gchar* msg = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		GError* _tmp6_;
#line 46 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp4_ = g_strdup (_ ("Could not create GstElement for URI %s"));
#line 46 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		msg = _tmp4_;
#line 48 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp5_ = msg;
#line 48 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp6_ = g_error_new (RYGEL_GST_DATA_SOURCE_ERROR, RYGEL_GST_DATA_SOURCE_ERROR_NOT_COMPATIBLE, _tmp5_, uri);
#line 48 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_inner_error0_ = _tmp6_;
#line 48 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_propagate_error (error, _inner_error0_);
#line 48 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_free0 (msg);
#line 48 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_object_unref0 (self);
#line 48 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		return NULL;
#line 299 "rygel-gst-data-source.c"
	}
#line 41 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return self;
#line 303 "rygel-gst-data-source.c"
}

RygelGstDataSource*
rygel_gst_data_source_new (const gchar* uri,
                           RygelMediaResource* resource,
                           GError** error)
{
#line 41 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return rygel_gst_data_source_construct (RYGEL_TYPE_GST_DATA_SOURCE, uri, resource, error);
#line 313 "rygel-gst-data-source.c"
}

RygelGstDataSource*
rygel_gst_data_source_construct_from_element (GType object_type,
                                              GstElement* element)
{
	RygelGstDataSource * self = NULL;
	GstElement* _tmp0_;
#line 62 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_val_if_fail (element != NULL, NULL);
#line 62 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self = (RygelGstDataSource*) g_object_new (object_type, NULL);
#line 63 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = _g_object_ref0 (element);
#line 63 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->src);
#line 63 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->src = _tmp0_;
#line 62 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return self;
#line 334 "rygel-gst-data-source.c"
}

RygelGstDataSource*
rygel_gst_data_source_new_from_element (GstElement* element)
{
#line 62 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return rygel_gst_data_source_construct_from_element (RYGEL_TYPE_GST_DATA_SOURCE, element);
#line 342 "rygel-gst-data-source.c"
}

gchar*
rygel_gst_data_source_get_uri (RygelGstDataSource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 66 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = self->priv->uri;
#line 67 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 67 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	result = _tmp1_;
#line 67 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 361 "rygel-gst-data-source.c"
}

static GeeList*
rygel_gst_data_source_real_preroll (RygelGstDataSource* self,
                                    RygelHTTPSeekRequest* seek_request,
                                    RygelPlaySpeedRequest* playspeed_request,
                                    GError** error)
{
	GeeArrayList* response_list = NULL;
	GeeArrayList* _tmp0_;
	RygelHTTPSeekRequest* _tmp25_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 74 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = gee_array_list_new (RYGEL_TYPE_HTTP_RESPONSE_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 74 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	response_list = _tmp0_;
#line 76 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (playspeed_request != NULL) {
#line 381 "rygel-gst-data-source.c"
		GError* _tmp1_;
#line 77 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp1_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_PLAYSPEED_FAILED, _ ("Playspeed not supported"));
#line 77 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_inner_error0_ = _tmp1_;
#line 77 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_propagate_error (error, _inner_error0_);
#line 77 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_object_unref0 (response_list);
#line 77 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		return NULL;
#line 393 "rygel-gst-data-source.c"
	}
#line 81 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (seek_request == NULL) {
#line 82 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_debug ("rygel-gst-data-source.vala:82: No seek requested - sending entire bina" \
"ry");
#line 399 "rygel-gst-data-source.c"
	} else {
#line 83 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (seek_request, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST)) {
#line 403 "rygel-gst-data-source.c"
			RygelHTTPByteSeekResponse* seek_response = NULL;
			RygelHTTPByteSeekResponse* _tmp2_;
			RygelHTTPByteSeekResponse* _tmp3_;
			gint64 _tmp4_;
			gint64 _tmp5_;
			RygelHTTPByteSeekResponse* _tmp6_;
			gint64 _tmp7_;
			gint64 _tmp8_;
			RygelHTTPByteSeekResponse* _tmp9_;
#line 85 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp2_ = rygel_http_byte_seek_response_new_from_request (G_TYPE_CHECK_INSTANCE_TYPE (seek_request, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST) ? ((RygelHTTPByteSeekRequest*) seek_request) : NULL);
#line 85 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			seek_response = _tmp2_;
#line 87 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp3_ = seek_response;
#line 87 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp4_ = rygel_http_byte_seek_response_get_start_byte (_tmp3_);
#line 87 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp5_ = _tmp4_;
#line 87 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp6_ = seek_response;
#line 87 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp7_ = rygel_http_byte_seek_response_get_end_byte (_tmp6_);
#line 87 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp8_ = _tmp7_;
#line 87 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			g_debug ("rygel-gst-data-source.vala:87: Processing byte seek request for bytes " \
"%lld-%lld", _tmp5_, _tmp8_);
#line 90 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp9_ = seek_response;
#line 90 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) response_list, (RygelHTTPResponseElement*) _tmp9_);
#line 83 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_object_unref0 (seek_response);
#line 437 "rygel-gst-data-source.c"
		} else {
#line 91 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (seek_request, RYGEL_TYPE_HTTP_TIME_SEEK_REQUEST)) {
#line 441 "rygel-gst-data-source.c"
				RygelHTTPTimeSeekRequest* time_seek = NULL;
				RygelHTTPTimeSeekRequest* _tmp10_;
				RygelHTTPTimeSeekResponse* seek_response = NULL;
				RygelHTTPTimeSeekRequest* _tmp11_;
				RygelMediaResource* _tmp12_;
				glong _tmp13_;
				glong _tmp14_;
				RygelHTTPTimeSeekResponse* _tmp15_;
				RygelHTTPTimeSeekResponse* _tmp16_;
				gint64 _tmp17_;
				gint64 _tmp18_;
				RygelHTTPTimeSeekResponse* _tmp19_;
				gint64 _tmp20_;
				gint64 _tmp21_;
				RygelHTTPTimeSeekResponse* _tmp22_;
#line 92 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (seek_request, RYGEL_TYPE_HTTP_TIME_SEEK_REQUEST) ? ((RygelHTTPTimeSeekRequest*) seek_request) : NULL);
#line 92 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				time_seek = _tmp10_;
#line 98 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp11_ = time_seek;
#line 98 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp12_ = self->res;
#line 98 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp13_ = rygel_media_resource_get_duration (_tmp12_);
#line 98 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp14_ = _tmp13_;
#line 98 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp15_ = rygel_http_time_seek_response_new_from_request (_tmp11_, (gint64) (_tmp14_ * G_TIME_SPAN_SECOND));
#line 98 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				seek_response = _tmp15_;
#line 101 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp16_ = seek_response;
#line 101 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp17_ = rygel_http_time_seek_response_get_start_time (_tmp16_);
#line 101 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp18_ = _tmp17_;
#line 101 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp19_ = seek_response;
#line 101 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp20_ = rygel_http_time_seek_response_get_end_time (_tmp19_);
#line 101 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp21_ = _tmp20_;
#line 101 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				g_debug ("rygel-gst-data-source.vala:101: Processing time seek request for %lldm" \
"s-%lldms", _tmp18_, _tmp21_);
#line 104 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp22_ = seek_response;
#line 104 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) response_list, (RygelHTTPResponseElement*) _tmp22_);
#line 91 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_g_object_unref0 (seek_response);
#line 91 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_g_object_unref0 (time_seek);
#line 495 "rygel-gst-data-source.c"
			} else {
				const gchar* _tmp23_;
				GError* _tmp24_;
#line 107 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp23_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) seek_request));
#line 107 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp24_ = g_error_new (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_SEEK_FAILED, _ ("HTTPSeekRequest type %s unsupported"), _tmp23_);
#line 107 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_inner_error0_ = _tmp24_;
#line 107 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				g_propagate_error (error, _inner_error0_);
#line 107 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_g_object_unref0 (response_list);
#line 107 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				return NULL;
#line 511 "rygel-gst-data-source.c"
			}
		}
	}
#line 112 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp25_ = _g_object_ref0 (seek_request);
#line 112 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->priv->seek);
#line 112 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->priv->seek = _tmp25_;
#line 114 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	result = (GeeList*) response_list;
#line 114 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 525 "rygel-gst-data-source.c"
}

GeeList*
rygel_gst_data_source_preroll (RygelGstDataSource* self,
                               RygelHTTPSeekRequest* seek_request,
                               RygelPlaySpeedRequest* playspeed_request,
                               GError** error)
{
	RygelGstDataSourceClass* _klass_;
#line 70 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_klass_ = RYGEL_GST_DATA_SOURCE_GET_CLASS (self);
#line 70 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_klass_->preroll) {
#line 70 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		return _klass_->preroll (self, seek_request, playspeed_request, error);
#line 543 "rygel-gst-data-source.c"
	}
#line 70 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return NULL;
#line 547 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_real_start (RygelDataSource* base,
                                  GError** error)
{
	RygelGstDataSource * self;
	GstElement* _tmp0_;
	RygelHTTPSeekRequest* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 117 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self = (RygelGstDataSource*) base;
#line 118 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = self->src;
#line 118 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	rygel_gst_data_source_prepare_pipeline (self, "RygelGstDataSource", _tmp0_, &_inner_error0_);
#line 118 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_propagate_error (error, _inner_error0_);
#line 118 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		return;
#line 570 "rygel-gst-data-source.c"
	}
#line 119 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp1_ = self->priv->seek;
#line 119 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_tmp1_ != NULL) {
#line 576 "rygel-gst-data-source.c"
		GstPipeline* _tmp2_;
#line 120 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp2_ = self->priv->pipeline;
#line 120 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		gst_element_set_state ((GstElement*) _tmp2_, GST_STATE_PAUSED);
#line 582 "rygel-gst-data-source.c"
	} else {
		GstPipeline* _tmp3_;
#line 122 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp3_ = self->priv->pipeline;
#line 122 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		gst_element_set_state ((GstElement*) _tmp3_, GST_STATE_PLAYING);
#line 589 "rygel-gst-data-source.c"
	}
}

static void
rygel_gst_data_source_real_freeze (RygelDataSource* base)
{
	RygelGstDataSource * self;
	RygelGstSink* _tmp0_;
#line 126 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self = (RygelGstDataSource*) base;
#line 127 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = self->priv->sink;
#line 127 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	rygel_gst_sink_freeze (_tmp0_);
#line 604 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_real_thaw (RygelDataSource* base)
{
	RygelGstDataSource * self;
	RygelGstSink* _tmp0_;
#line 130 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self = (RygelGstDataSource*) base;
#line 131 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = self->priv->sink;
#line 131 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	rygel_gst_sink_thaw (_tmp0_);
#line 618 "rygel-gst-data-source.c"
}

static gboolean
__lambda6_ (RygelGstDataSource* self)
{
	gboolean result;
#line 142 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_signal_emit_by_name ((RygelDataSource*) self, "done");
#line 142 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	result = FALSE;
#line 142 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 631 "rygel-gst-data-source.c"
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ ((RygelGstDataSource*) self);
#line 142 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 641 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_real_stop (RygelDataSource* base)
{
	RygelGstDataSource * self;
	RygelGstSink* _tmp0_;
	GCancellable* _tmp1_;
	GstPipeline* _tmp2_;
#line 134 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self = (RygelGstDataSource*) base;
#line 136 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = self->priv->sink;
#line 136 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp1_ = _tmp0_->cancellable;
#line 136 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_cancellable_cancel (_tmp1_);
#line 137 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp2_ = self->priv->pipeline;
#line 137 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	gst_element_set_state ((GstElement*) _tmp2_, GST_STATE_NULL);
#line 138 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (self->priv->bus_watch_id != ((guint) 0)) {
#line 139 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_source_remove (self->priv->bus_watch_id);
#line 140 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		self->priv->bus_watch_id = (guint) 0;
#line 669 "rygel-gst-data-source.c"
	}
#line 142 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 673 "rygel-gst-data-source.c"
}

static void
_rygel_gst_data_source_src_pad_added_gst_element_pad_added (GstElement* _sender,
                                                            GstPad* pad,
                                                            gpointer self)
{
#line 159 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	rygel_gst_data_source_src_pad_added ((RygelGstDataSource*) self, _sender, pad);
#line 683 "rygel-gst-data-source.c"
}

static gboolean
_rygel_gst_data_source_bus_handler_gst_bus_func (GstBus* bus,
                                                 GstMessage* message,
                                                 gpointer self)
{
	gboolean result;
	result = rygel_gst_data_source_bus_handler ((RygelGstDataSource*) self, bus, message);
#line 171 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 695 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_prepare_pipeline (RygelGstDataSource* self,
                                        const gchar* name,
                                        GstElement* src,
                                        GError** error)
{
	RygelHTTPSeekRequest* _tmp0_;
	RygelGstSink* _tmp1_;
	GstPipeline* _tmp2_;
	GstPipeline* _tmp3_;
	GstPipeline* _tmp5_;
	RygelGstSink* _tmp6_;
	GstBus* bus = NULL;
	GstPipeline* _tmp17_;
	GstBus* _tmp18_;
	GstBus* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 145 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_if_fail (name != NULL);
#line 145 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_if_fail (src != NULL);
#line 147 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = self->priv->seek;
#line 147 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp1_ = rygel_gst_sink_new ((RygelDataSource*) self, _tmp0_);
#line 147 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_object_ref_sink (_tmp1_);
#line 147 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->priv->sink);
#line 147 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->priv->sink = _tmp1_;
#line 149 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp2_ = (GstPipeline*) gst_pipeline_new (name);
#line 149 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_object_ref_sink (_tmp2_);
#line 149 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 149 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->priv->pipeline = _tmp2_;
#line 150 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp3_ = self->priv->pipeline;
#line 150 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_tmp3_ == NULL) {
#line 743 "rygel-gst-data-source.c"
		GError* _tmp4_;
#line 151 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp4_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_GENERAL, _ ("Failed to create pipeline"));
#line 151 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_inner_error0_ = _tmp4_;
#line 151 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_propagate_error (error, _inner_error0_);
#line 151 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		return;
#line 753 "rygel-gst-data-source.c"
	}
#line 155 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp5_ = self->priv->pipeline;
#line 155 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp6_ = self->priv->sink;
#line 155 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	gst_bin_add_many ((GstBin*) _tmp5_, src, (GstElement*) _tmp6_, NULL);
#line 157 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (((gint) src->numsrcpads) == 0) {
#line 159 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_signal_connect_object (src, "pad-added", (GCallback) _rygel_gst_data_source_src_pad_added_gst_element_pad_added, self, 0);
#line 765 "rygel-gst-data-source.c"
	} else {
		RygelGstSink* _tmp7_;
#line 162 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp7_ = self->priv->sink;
#line 162 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		if (!gst_element_link (src, (GstElement*) _tmp7_)) {
#line 772 "rygel-gst-data-source.c"
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			RygelGstSink* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			GError* _tmp15_;
			GError* _tmp16_;
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp8_ = gst_object_get_name ((GstObject*) src);
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp9_ = _tmp8_;
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp10_ = _tmp9_;
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp11_ = self->priv->sink;
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp12_ = gst_object_get_name ((GstObject*) _tmp11_);
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp13_ = _tmp12_;
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp14_ = _tmp13_;
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp15_ = g_error_new (RYGEL_GST_ERROR, RYGEL_GST_ERROR_LINK, _ ("Failed to link %s to %s"), _tmp10_, _tmp14_);
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp16_ = _tmp15_;
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_free0 (_tmp14_);
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_free0 (_tmp10_);
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_inner_error0_ = _tmp16_;
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			g_propagate_error (error, _inner_error0_);
#line 163 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			return;
#line 810 "rygel-gst-data-source.c"
		}
	}
#line 170 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp17_ = self->priv->pipeline;
#line 170 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp18_ = gst_pipeline_get_bus (_tmp17_);
#line 170 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	bus = _tmp18_;
#line 171 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp19_ = bus;
#line 171 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->priv->bus_watch_id = gst_bus_add_watch_full (_tmp19_, G_PRIORITY_DEFAULT, _rygel_gst_data_source_bus_handler_gst_bus_func, g_object_ref (self), g_object_unref);
#line 145 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (bus);
#line 825 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_src_pad_added (RygelGstDataSource* self,
                                     GstElement* src,
                                     GstPad* src_pad)
{
	GstCaps* caps = NULL;
	GstCaps* _tmp0_;
	GstElement* sink = NULL;
	GstPipeline* _tmp1_;
	GstElement* _tmp2_;
	GstPad* sink_pad = NULL;
	GstElement* depay = NULL;
	GstCaps* _tmp3_;
	GstElement* _tmp4_;
	GstElement* _tmp5_;
	GstPad* _tmp24_;
	GstElement* _tmp32_;
#line 174 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_if_fail (src != NULL);
#line 174 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_if_fail (src_pad != NULL);
#line 175 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = gst_pad_query_caps (src_pad, NULL);
#line 175 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	caps = _tmp0_;
#line 177 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp1_ = self->priv->pipeline;
#line 177 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp2_ = gst_bin_get_by_name ((GstBin*) _tmp1_, RYGEL_GST_SINK_NAME);
#line 177 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	sink = _tmp2_;
#line 180 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp3_ = caps;
#line 180 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp4_ = rygel_gst_utils_get_rtp_depayloader (_tmp3_);
#line 180 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	depay = _tmp4_;
#line 181 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp5_ = depay;
#line 181 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_tmp5_ != NULL) {
#line 871 "rygel-gst-data-source.c"
		GstPipeline* _tmp6_;
		GstElement* _tmp7_;
		GstElement* _tmp8_;
		GstElement* _tmp9_;
		GstElement* _tmp18_;
		GstCaps* _tmp19_;
		GstPad* _tmp20_;
#line 182 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp6_ = self->priv->pipeline;
#line 182 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp7_ = depay;
#line 182 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		gst_bin_add ((GstBin*) _tmp6_, _tmp7_);
#line 183 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp8_ = depay;
#line 183 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp9_ = sink;
#line 183 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		if (!gst_element_link (_tmp8_, _tmp9_)) {
#line 891 "rygel-gst-data-source.c"
			GstElement* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GstElement* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp10_ = depay;
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp11_ = gst_object_get_name ((GstObject*) _tmp10_);
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp12_ = _tmp11_;
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp13_ = _tmp12_;
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp14_ = sink;
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp15_ = gst_object_get_name ((GstObject*) _tmp14_);
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp16_ = _tmp15_;
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp17_ = _tmp16_;
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			g_critical (_ ("Failed to link %s to %s"), _tmp13_, _tmp17_);
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_free0 (_tmp17_);
#line 184 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_free0 (_tmp13_);
#line 187 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			g_signal_emit_by_name ((RygelDataSource*) self, "done");
#line 189 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_object_unref0 (depay);
#line 189 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_object_unref0 (sink_pad);
#line 189 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_object_unref0 (sink);
#line 189 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_gst_caps_unref0 (caps);
#line 189 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			return;
#line 934 "rygel-gst-data-source.c"
		}
#line 192 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp18_ = depay;
#line 192 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp19_ = caps;
#line 192 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp20_ = gst_element_get_compatible_pad (_tmp18_, src_pad, _tmp19_);
#line 192 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_object_unref0 (sink_pad);
#line 192 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		sink_pad = _tmp20_;
#line 946 "rygel-gst-data-source.c"
	} else {
		GstElement* _tmp21_;
		GstCaps* _tmp22_;
		GstPad* _tmp23_;
#line 194 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp21_ = sink;
#line 194 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp22_ = caps;
#line 194 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp23_ = gst_element_get_compatible_pad (_tmp21_, src_pad, _tmp22_);
#line 194 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_object_unref0 (sink_pad);
#line 194 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		sink_pad = _tmp23_;
#line 961 "rygel-gst-data-source.c"
	}
#line 197 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp24_ = sink_pad;
#line 197 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (gst_pad_link_full (src_pad, _tmp24_, GST_PAD_LINK_CHECK_DEFAULT) != GST_PAD_LINK_OK) {
#line 967 "rygel-gst-data-source.c"
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GstPad* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp25_ = gst_object_get_name ((GstObject*) src_pad);
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp26_ = _tmp25_;
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp27_ = _tmp26_;
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp28_ = sink_pad;
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp29_ = gst_object_get_name ((GstObject*) _tmp28_);
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp30_ = _tmp29_;
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp31_ = _tmp30_;
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_critical (_ ("Failed to link pad %s to %s"), _tmp27_, _tmp31_);
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_free0 (_tmp31_);
#line 198 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_free0 (_tmp27_);
#line 201 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_signal_emit_by_name ((RygelDataSource*) self, "done");
#line 203 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_object_unref0 (depay);
#line 203 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_object_unref0 (sink_pad);
#line 203 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_object_unref0 (sink);
#line 203 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_gst_caps_unref0 (caps);
#line 203 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		return;
#line 1007 "rygel-gst-data-source.c"
	}
#line 206 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp32_ = depay;
#line 206 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_tmp32_ != NULL) {
#line 1013 "rygel-gst-data-source.c"
		GstElement* _tmp33_;
#line 207 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp33_ = depay;
#line 207 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		gst_element_sync_state_with_parent (_tmp33_);
#line 1019 "rygel-gst-data-source.c"
	}
#line 174 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (depay);
#line 174 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (sink_pad);
#line 174 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (sink);
#line 174 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_gst_caps_unref0 (caps);
#line 1029 "rygel-gst-data-source.c"
}

static gboolean
___lambda5_ (RygelGstDataSource* self)
{
	gboolean result;
#line 278 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_signal_emit_by_name ((RygelDataSource*) self, "done");
#line 280 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	result = FALSE;
#line 280 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 1042 "rygel-gst-data-source.c"
}

static gboolean
____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda5_ ((RygelGstDataSource*) self);
#line 277 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 1052 "rygel-gst-data-source.c"
}

static gboolean
rygel_gst_data_source_bus_handler (RygelGstDataSource* self,
                                   GstBus* bus,
                                   GstMessage* message)
{
	gboolean ret = FALSE;
	gboolean result;
#line 211 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 211 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 212 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	ret = TRUE;
#line 214 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (message->type == GST_MESSAGE_EOS) {
#line 215 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		ret = FALSE;
#line 1074 "rygel-gst-data-source.c"
	} else {
#line 216 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		if (message->type == GST_MESSAGE_STATE_CHANGED) {
#line 1078 "rygel-gst-data-source.c"
			GstObject* _tmp0_;
			GstPipeline* _tmp1_;
			GstState old_state = 0;
			GstState new_state = 0;
			GstState _tmp2_ = 0;
			GstState _tmp3_ = 0;
			gboolean _tmp4_ = FALSE;
			gchar* filename = NULL;
			gchar* _tmp14_;
			GstPipeline* _tmp15_;
			const gchar* _tmp16_;
			RygelHTTPSeekRequest* _tmp17_;
#line 217 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp0_ = message->src;
#line 217 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp1_ = self->priv->pipeline;
#line 217 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			if (_tmp0_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gst_object_get_type (), GstObject)) {
#line 218 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				result = TRUE;
#line 218 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				return result;
#line 1101 "rygel-gst-data-source.c"
			}
#line 224 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			gst_message_parse_state_changed (message, &_tmp2_, &_tmp3_, NULL);
#line 224 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			old_state = _tmp2_;
#line 224 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			new_state = _tmp3_;
#line 228 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			if (old_state == GST_STATE_NULL) {
#line 228 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp4_ = new_state == GST_STATE_READY;
#line 1113 "rygel-gst-data-source.c"
			} else {
#line 228 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp4_ = FALSE;
#line 1117 "rygel-gst-data-source.c"
			}
#line 228 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			if (_tmp4_) {
#line 1121 "rygel-gst-data-source.c"
				GstElement* element = NULL;
				GstPipeline* _tmp5_;
				GstElement* _tmp6_;
				GstElement* _tmp7_;
#line 229 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp5_ = self->priv->pipeline;
#line 229 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp6_ = gst_bin_get_by_name ((GstBin*) _tmp5_, "muxer");
#line 229 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				element = _tmp6_;
#line 230 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp7_ = element;
#line 230 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				if (_tmp7_ != NULL) {
#line 1136 "rygel-gst-data-source.c"
					gchar* name = NULL;
					GstElement* _tmp8_;
					GstElementFactory* _tmp9_;
					gchar* _tmp10_;
					const gchar* _tmp11_;
#line 231 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp8_ = element;
#line 231 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp9_ = gst_element_get_factory (_tmp8_);
#line 231 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp10_ = gst_object_get_name ((GstObject*) _tmp9_);
#line 231 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					name = _tmp10_;
#line 233 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp11_ = name;
#line 233 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					if (g_strcmp0 (_tmp11_, "mp4mux") == 0) {
#line 1154 "rygel-gst-data-source.c"
						GstElement* _tmp12_;
						GstElement* _tmp13_;
#line 234 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
						_tmp12_ = element;
#line 234 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
						g_object_set (_tmp12_, "streamable", TRUE, NULL);
#line 235 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
						_tmp13_ = element;
#line 235 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
						g_object_set (_tmp13_, "fragment-duration", 1000, NULL);
#line 1165 "rygel-gst-data-source.c"
					}
#line 230 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_g_free0 (name);
#line 1169 "rygel-gst-data-source.c"
				}
#line 228 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_g_object_unref0 (element);
#line 1173 "rygel-gst-data-source.c"
			}
#line 240 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp14_ = g_strdup_printf ("rygel_media_engine_%d_%d", (gint) old_state, (gint) new_state);
#line 240 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			filename = _tmp14_;
#line 242 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp15_ = self->priv->pipeline;
#line 242 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp16_ = filename;
#line 242 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			gst_debug_bin_to_dot_file_with_ts ((GstBin*) _tmp15_, GST_DEBUG_GRAPH_SHOW_ALL, _tmp16_);
#line 246 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp17_ = self->priv->seek;
#line 246 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			if (_tmp17_ != NULL) {
#line 1189 "rygel-gst-data-source.c"
				gboolean _tmp18_ = FALSE;
#line 247 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				if (old_state == GST_STATE_READY) {
#line 247 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp18_ = new_state == GST_STATE_PAUSED;
#line 1195 "rygel-gst-data-source.c"
				} else {
#line 247 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp18_ = FALSE;
#line 1199 "rygel-gst-data-source.c"
				}
#line 247 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				if (_tmp18_) {
#line 248 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					if (rygel_gst_data_source_perform_seek (self)) {
#line 1205 "rygel-gst-data-source.c"
						GstPipeline* _tmp19_;
#line 249 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
						_tmp19_ = self->priv->pipeline;
#line 249 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
						gst_element_set_state ((GstElement*) _tmp19_, GST_STATE_PLAYING);
#line 1211 "rygel-gst-data-source.c"
					}
				}
			}
#line 216 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_free0 (filename);
#line 1217 "rygel-gst-data-source.c"
		} else {
			GError* err = NULL;
			gchar* err_msg = NULL;
#line 257 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			if (message->type == GST_MESSAGE_ERROR) {
#line 1223 "rygel-gst-data-source.c"
				GstPipeline* _tmp20_;
				GError* _tmp21_ = NULL;
				gchar* _tmp22_ = NULL;
				GstPipeline* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
#line 258 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp20_ = self->priv->pipeline;
#line 258 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				gst_debug_bin_to_dot_file_with_ts ((GstBin*) _tmp20_, GST_DEBUG_GRAPH_SHOW_ALL, "rygel_media_engine_error");
#line 262 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				gst_message_parse_error (message, &_tmp21_, &_tmp22_);
#line 262 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_g_error_free0 (err);
#line 262 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				err = _tmp21_;
#line 262 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_g_free0 (err_msg);
#line 262 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				err_msg = _tmp22_;
#line 263 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp23_ = self->priv->pipeline;
#line 263 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp24_ = gst_object_get_name ((GstObject*) _tmp23_);
#line 263 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp25_ = _tmp24_;
#line 263 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp26_ = _tmp25_;
#line 263 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_tmp27_ = err_msg;
#line 263 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				g_critical (_ ("Error from pipeline %s: %s"), _tmp26_, _tmp27_);
#line 263 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_g_free0 (_tmp26_);
#line 267 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				ret = FALSE;
#line 1262 "rygel-gst-data-source.c"
			} else {
#line 268 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				if (message->type == GST_MESSAGE_WARNING) {
#line 1266 "rygel-gst-data-source.c"
					GError* _tmp28_ = NULL;
					gchar* _tmp29_ = NULL;
					GstPipeline* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					const gchar* _tmp34_;
#line 269 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					gst_message_parse_warning (message, &_tmp28_, &_tmp29_);
#line 269 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_g_error_free0 (err);
#line 269 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					err = _tmp28_;
#line 269 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_g_free0 (err_msg);
#line 269 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					err_msg = _tmp29_;
#line 270 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp30_ = self->priv->pipeline;
#line 270 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp31_ = gst_object_get_name ((GstObject*) _tmp30_);
#line 270 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp32_ = _tmp31_;
#line 270 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp33_ = _tmp32_;
#line 270 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_tmp34_ = err_msg;
#line 270 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					g_warning (_ ("Warning from pipeline %s: %s"), _tmp33_, _tmp34_);
#line 270 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
					_g_free0 (_tmp33_);
#line 1298 "rygel-gst-data-source.c"
				}
			}
#line 216 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_free0 (err_msg);
#line 216 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_error_free0 (err);
#line 1305 "rygel-gst-data-source.c"
		}
	}
#line 276 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (!ret) {
#line 277 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT, ____lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 283 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		self->priv->bus_watch_id = (guint) 0;
#line 1314 "rygel-gst-data-source.c"
	}
#line 286 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	result = ret;
#line 286 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 1320 "rygel-gst-data-source.c"
}

static gboolean
rygel_gst_data_source_real_perform_seek (RygelGstDataSource* self)
{
	GstSeekType stop_type = 0;
	GstFormat format = 0;
	GstSeekFlags flags = 0U;
	gint64 start = 0LL;
	gint64 stop = 0LL;
	RygelHTTPSeekRequest* _tmp0_;
	GstPipeline* _tmp28_;
	gboolean result;
#line 290 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	stop_type = GST_SEEK_TYPE_NONE;
#line 292 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	flags = GST_SEEK_FLAG_FLUSH;
#line 295 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = self->priv->seek;
#line 295 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, RYGEL_TYPE_HTTP_TIME_SEEK_REQUEST)) {
#line 1342 "rygel-gst-data-source.c"
		RygelHTTPTimeSeekRequest* time_seek = NULL;
		RygelHTTPSeekRequest* _tmp1_;
		RygelHTTPTimeSeekRequest* _tmp2_;
		RygelHTTPTimeSeekRequest* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GstElement* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gboolean _tmp9_;
		RygelHTTPTimeSeekRequest* _tmp10_;
#line 296 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp1_ = self->priv->seek;
#line 296 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, RYGEL_TYPE_HTTP_TIME_SEEK_REQUEST) ? ((RygelHTTPTimeSeekRequest*) _tmp1_) : NULL);
#line 296 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		time_seek = _tmp2_;
#line 297 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		format = GST_FORMAT_TIME;
#line 298 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		flags |= GST_SEEK_FLAG_KEY_UNIT;
#line 299 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp3_ = time_seek;
#line 299 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		start = _tmp3_->start_time * GST_USECOND;
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp5_ = self->src;
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp6_ = gst_object_get_name ((GstObject*) _tmp5_);
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp7_ = _tmp6_;
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp8_ = _tmp7_;
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp9_ = g_strcmp0 (_tmp8_, "dvdreadsrc") == 0;
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_free0 (_tmp8_);
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		if (_tmp9_) {
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp4_ = start == ((gint64) 0);
#line 1384 "rygel-gst-data-source.c"
		} else {
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp4_ = FALSE;
#line 1388 "rygel-gst-data-source.c"
		}
#line 301 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		if (_tmp4_) {
#line 302 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			start += (gint64) (1 * GST_SECOND);
#line 1394 "rygel-gst-data-source.c"
		}
#line 304 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp10_ = time_seek;
#line 304 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		stop = _tmp10_->end_time * GST_USECOND;
#line 305 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_debug ("rygel-gst-data-source.vala:305: Performing time-range seek: %lldns to " \
"%lldns", start, stop);
#line 295 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_object_unref0 (time_seek);
#line 1404 "rygel-gst-data-source.c"
	} else {
		RygelHTTPSeekRequest* _tmp11_;
#line 306 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp11_ = self->priv->seek;
#line 306 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST)) {
#line 1411 "rygel-gst-data-source.c"
			RygelHTTPByteSeekRequest* byte_seek = NULL;
			RygelHTTPSeekRequest* _tmp12_;
			RygelHTTPByteSeekRequest* _tmp13_;
			RygelHTTPByteSeekRequest* _tmp14_;
			gint64 _tmp15_;
			gint64 _tmp16_;
			RygelHTTPByteSeekRequest* _tmp17_;
			gint64 _tmp18_;
			gint64 _tmp19_;
			RygelHTTPByteSeekRequest* _tmp20_;
			gint64 _tmp21_;
			gint64 _tmp22_;
			RygelHTTPByteSeekRequest* _tmp23_;
			gint64 _tmp24_;
			gint64 _tmp25_;
#line 307 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp12_ = self->priv->seek;
#line 307 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST) ? ((RygelHTTPByteSeekRequest*) _tmp12_) : NULL);
#line 307 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			byte_seek = _tmp13_;
#line 308 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp14_ = byte_seek;
#line 308 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp15_ = rygel_http_byte_seek_request_get_range_length (_tmp14_);
#line 308 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp16_ = _tmp15_;
#line 308 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp17_ = byte_seek;
#line 308 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp18_ = rygel_http_byte_seek_request_get_total_size (_tmp17_);
#line 308 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp19_ = _tmp18_;
#line 308 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			if (_tmp16_ >= _tmp19_) {
#line 311 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				result = TRUE;
#line 311 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				_g_object_unref0 (byte_seek);
#line 311 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
				return result;
#line 1453 "rygel-gst-data-source.c"
			}
#line 314 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			format = GST_FORMAT_BYTES;
#line 315 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			flags |= GST_SEEK_FLAG_ACCURATE;
#line 316 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp20_ = byte_seek;
#line 316 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp21_ = rygel_http_byte_seek_request_get_start_byte (_tmp20_);
#line 316 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp22_ = _tmp21_;
#line 316 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			start = _tmp22_;
#line 317 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp23_ = byte_seek;
#line 317 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp24_ = rygel_http_byte_seek_request_get_end_byte (_tmp23_);
#line 317 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp25_ = _tmp24_;
#line 317 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			stop = _tmp25_;
#line 318 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			g_debug ("rygel-gst-data-source.vala:318: Performing byte-range seek: bytes %lld" \
" to %lld", start, stop);
#line 306 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_object_unref0 (byte_seek);
#line 1479 "rygel-gst-data-source.c"
		} else {
			GError* _result_ = NULL;
			GError* _tmp26_;
			GError* _tmp27_;
#line 322 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp26_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_SEEK_FAILED, _ ("Unsupported seek type"));
#line 322 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_result_ = _tmp26_;
#line 324 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_tmp27_ = _result_;
#line 324 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			g_signal_emit_by_name ((RygelDataSource*) self, "error", _tmp27_);
#line 326 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			result = FALSE;
#line 326 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			_g_error_free0 (_result_);
#line 326 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
			return result;
#line 1498 "rygel-gst-data-source.c"
		}
	}
#line 329 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (stop > ((gint64) 0)) {
#line 330 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		stop_type = GST_SEEK_TYPE_SET;
#line 1505 "rygel-gst-data-source.c"
	}
#line 333 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp28_ = self->priv->pipeline;
#line 333 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (!gst_element_seek ((GstElement*) _tmp28_, 1.0, format, flags, GST_SEEK_TYPE_SET, start, stop_type, stop + 1)) {
#line 1511 "rygel-gst-data-source.c"
		GError* _tmp29_;
		GError* _tmp30_;
#line 340 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_warning (_ ("Failed to seek to offsets %lld:%lld"), start, stop);
#line 342 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp29_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_SEEK_FAILED, _ ("Failed to seek"));
#line 342 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp30_ = _tmp29_;
#line 342 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_signal_emit_by_name ((RygelDataSource*) self, "error", _tmp30_);
#line 342 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_g_error_free0 (_tmp30_);
#line 344 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		result = FALSE;
#line 344 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		return result;
#line 1528 "rygel-gst-data-source.c"
	}
#line 347 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	result = TRUE;
#line 347 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return result;
#line 1534 "rygel-gst-data-source.c"
}

gboolean
rygel_gst_data_source_perform_seek (RygelGstDataSource* self)
{
	RygelGstDataSourceClass* _klass_;
#line 289 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 289 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_klass_ = RYGEL_GST_DATA_SOURCE_GET_CLASS (self);
#line 289 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_klass_->perform_seek) {
#line 289 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		return _klass_->perform_seek (self);
#line 1549 "rygel-gst-data-source.c"
	}
#line 289 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	return FALSE;
#line 1553 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_class_init (RygelGstDataSourceClass * klass,
                                  gpointer klass_data)
{
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	rygel_gst_data_source_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	g_type_class_adjust_private_offset (klass, &RygelGstDataSource_private_offset);
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	((RygelGstDataSourceClass *) klass)->preroll = (GeeList* (*) (RygelGstDataSource*, RygelHTTPSeekRequest*, RygelPlaySpeedRequest*, GError**)) rygel_gst_data_source_real_preroll;
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	((RygelGstDataSourceClass *) klass)->perform_seek = (gboolean (*) (RygelGstDataSource*)) rygel_gst_data_source_real_perform_seek;
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_gst_data_source_finalize;
#line 1570 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_rygel_data_source_interface_init (RygelDataSourceIface * iface,
                                                        gpointer iface_data)
{
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	rygel_gst_data_source_rygel_data_source_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	iface->preroll = (GeeList* (*) (RygelDataSource*, RygelHTTPSeekRequest*, RygelPlaySpeedRequest*, GError**)) rygel_gst_data_source_preroll;
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	iface->start = (void (*) (RygelDataSource*, GError**)) rygel_gst_data_source_real_start;
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	iface->freeze = (void (*) (RygelDataSource*)) rygel_gst_data_source_real_freeze;
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	iface->thaw = (void (*) (RygelDataSource*)) rygel_gst_data_source_real_thaw;
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	iface->stop = (void (*) (RygelDataSource*)) rygel_gst_data_source_real_stop;
#line 1589 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_instance_init (RygelGstDataSource * self,
                                     gpointer klass)
{
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->priv = rygel_gst_data_source_get_instance_private (self);
#line 36 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->priv->seek = NULL;
#line 39 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self->priv->uri = NULL;
#line 1602 "rygel-gst-data-source.c"
}

static void
rygel_gst_data_source_finalize (GObject * obj)
{
	RygelGstDataSource * self;
	RygelGstSink* _tmp0_;
	GstPipeline* _tmp3_;
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_GST_DATA_SOURCE, RygelGstDataSource);
#line 53 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp0_ = self->priv->sink;
#line 53 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_tmp0_ != NULL) {
#line 1617 "rygel-gst-data-source.c"
		RygelGstSink* _tmp1_;
		GCancellable* _tmp2_;
#line 54 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp1_ = self->priv->sink;
#line 54 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp2_ = _tmp1_->cancellable;
#line 54 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		g_cancellable_cancel (_tmp2_);
#line 1626 "rygel-gst-data-source.c"
	}
#line 57 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_tmp3_ = self->priv->pipeline;
#line 57 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	if (_tmp3_ != NULL) {
#line 1632 "rygel-gst-data-source.c"
		GstPipeline* _tmp4_;
#line 58 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		_tmp4_ = self->priv->pipeline;
#line 58 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
		gst_element_set_state ((GstElement*) _tmp4_, GST_STATE_NULL);
#line 1638 "rygel-gst-data-source.c"
	}
#line 33 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->src);
#line 34 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->res);
#line 35 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 36 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->priv->seek);
#line 37 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_object_unref0 (self->priv->sink);
#line 39 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	_g_free0 (self->priv->uri);
#line 32 "../src/media-engines/gstreamer/rygel-gst-data-source.vala"
	G_OBJECT_CLASS (rygel_gst_data_source_parent_class)->finalize (obj);
#line 1654 "rygel-gst-data-source.c"
}

 G_GNUC_NO_INLINE static GType
rygel_gst_data_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelGstDataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_gst_data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelGstDataSource), 0, (GInstanceInitFunc) rygel_gst_data_source_instance_init, NULL };
	static const GInterfaceInfo rygel_data_source_info = { (GInterfaceInitFunc) rygel_gst_data_source_rygel_data_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType rygel_gst_data_source_type_id;
	rygel_gst_data_source_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelGstDataSource", &g_define_type_info, 0);
	g_type_add_interface_static (rygel_gst_data_source_type_id, RYGEL_TYPE_DATA_SOURCE, &rygel_data_source_info);
	RygelGstDataSource_private_offset = g_type_add_instance_private (rygel_gst_data_source_type_id, sizeof (RygelGstDataSourcePrivate));
	return rygel_gst_data_source_type_id;
}

GType
rygel_gst_data_source_get_type (void)
{
	static volatile gsize rygel_gst_data_source_type_id__once = 0;
	if (g_once_init_enter (&rygel_gst_data_source_type_id__once)) {
		GType rygel_gst_data_source_type_id;
		rygel_gst_data_source_type_id = rygel_gst_data_source_get_type_once ();
		g_once_init_leave (&rygel_gst_data_source_type_id__once, rygel_gst_data_source_type_id);
	}
	return rygel_gst_data_source_type_id__once;
}

