/* rygel-gst-sink.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-gst-sink.vala, do not modify */

/*
 * Copyright (C) 2011 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <gst/base/base.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "rygel-server.h"
#include <gst/gst.h>
#include <stdlib.h>
#include <string.h>
#include "rygel-media-engine-gst.h"

#define RYGEL_GST_SINK_NAME "http-gst-sink"
#define RYGEL_GST_SINK_PAD_NAME "sink"
#define RYGEL_GST_SINK_MAX_BUFFERED_CHUNKS ((guint) 32)
#define RYGEL_GST_SINK_MIN_BUFFERED_CHUNKS ((guint) 4)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_GST_SINK (rygel_gst_sink_get_type ())
#define RYGEL_GST_SINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_GST_SINK, RygelGstSink))
#define RYGEL_GST_SINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_GST_SINK, RygelGstSinkClass))
#define RYGEL_IS_GST_SINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_GST_SINK))
#define RYGEL_IS_GST_SINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_GST_SINK))
#define RYGEL_GST_SINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_GST_SINK, RygelGstSinkClass))

typedef struct _RygelGstSink RygelGstSink;
typedef struct _RygelGstSinkClass RygelGstSinkClass;
typedef struct _RygelGstSinkPrivate RygelGstSinkPrivate;
enum  {
	RYGEL_GST_SINK_0_PROPERTY,
	RYGEL_GST_SINK_NUM_PROPERTIES
};
static GParamSpec* rygel_gst_sink_properties[RYGEL_GST_SINK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gst_buffer_unref0(var) ((var == NULL) ? NULL : (var = (gst_buffer_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))

struct _RygelGstSink {
	GstBaseSink parent_instance;
	RygelGstSinkPrivate * priv;
	GCancellable* cancellable;
};

struct _RygelGstSinkClass {
	GstBaseSinkClass parent_class;
};

struct _RygelGstSinkPrivate {
	gint priority;
	gint64 bytes_sent;
	gint64 max_bytes;
	GMutex buffer_mutex;
	GCond buffer_condition;
	RygelDataSource* source;
	RygelHTTPSeekRequest* offsets;
	gboolean frozen;
};

struct _Block2Data {
	int _ref_count_;
	RygelGstSink* self;
	GstBuffer* buffer;
};

static gint RygelGstSink_private_offset;
static gpointer rygel_gst_sink_parent_class = NULL;

VALA_EXTERN GType rygel_gst_sink_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelGstSink* rygel_gst_sink_new (RygelDataSource* source,
                                  RygelHTTPSeekRequest* offsets);
VALA_EXTERN RygelGstSink* rygel_gst_sink_construct (GType object_type,
                                        RygelDataSource* source,
                                        RygelHTTPSeekRequest* offsets);
static void rygel_gst_sink_on_cancelled (RygelGstSink* self);
static void _rygel_gst_sink_on_cancelled_g_cancellable_cancelled (GCancellable* _sender,
                                                           gpointer self);
VALA_EXTERN void rygel_gst_sink_freeze (RygelGstSink* self);
VALA_EXTERN void rygel_gst_sink_thaw (RygelGstSink* self);
static GstFlowReturn rygel_gst_sink_real_render (GstBaseSink* base,
                                          GstBuffer* buffer);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block2Data* _data2_);
VALA_EXTERN gboolean rygel_gst_sink_push_data (RygelGstSink* self,
                                   GstBuffer* buffer);
static gboolean ___lambda4__gsource_func (gpointer self);
static void rygel_gst_sink_finalize (GObject * obj);
static GType rygel_gst_sink_get_type_once (void);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

static inline gpointer
rygel_gst_sink_get_instance_private (RygelGstSink* self)
{
	return G_STRUCT_MEMBER_P (self, RygelGstSink_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return self ? g_object_ref (self) : NULL;
#line 140 "rygel-gst-sink.c"
}

static void
_rygel_gst_sink_on_cancelled_g_cancellable_cancelled (GCancellable* _sender,
                                                      gpointer self)
{
#line 78 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	rygel_gst_sink_on_cancelled ((RygelGstSink*) self);
#line 149 "rygel-gst-sink.c"
}

RygelGstSink*
rygel_gst_sink_construct (GType object_type,
                          RygelDataSource* source,
                          RygelHTTPSeekRequest* offsets)
{
	RygelGstSink * self = NULL;
	RygelHTTPSeekRequest* _tmp0_;
	GCancellable* _tmp1_;
	gboolean _tmp2_ = FALSE;
	RygelHTTPSeekRequest* _tmp3_;
	GCancellable* _tmp8_;
#line 59 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 59 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self = (RygelGstSink*) g_object_new (object_type, NULL);
#line 60 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->bytes_sent = (gint64) 0;
#line 61 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->max_bytes = G_MAXINT64;
#line 62 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->source = source;
#line 63 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = _g_object_ref0 (offsets);
#line 63 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (self->priv->offsets);
#line 63 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->offsets = _tmp0_;
#line 65 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp1_ = g_cancellable_new ();
#line 65 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (self->cancellable);
#line 65 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->cancellable = _tmp1_;
#line 67 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_base_sink_set_sync ((GstBaseSink*) self, FALSE);
#line 68 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_object_set_name ((GstObject*) self, RYGEL_GST_SINK_NAME);
#line 69 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->frozen = FALSE;
#line 71 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp3_ = self->priv->offsets;
#line 71 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (_tmp3_ != NULL) {
#line 195 "rygel-gst-sink.c"
		RygelHTTPSeekRequest* _tmp4_;
#line 71 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp4_ = self->priv->offsets;
#line 71 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST);
#line 201 "rygel-gst-sink.c"
	} else {
#line 71 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp2_ = FALSE;
#line 205 "rygel-gst-sink.c"
	}
#line 71 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (_tmp2_) {
#line 209 "rygel-gst-sink.c"
		RygelHTTPSeekRequest* _tmp5_;
		gint64 _tmp6_;
		gint64 _tmp7_;
#line 72 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp5_ = self->priv->offsets;
#line 72 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp6_ = rygel_http_byte_seek_request_get_total_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST, RygelHTTPByteSeekRequest));
#line 72 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp7_ = _tmp6_;
#line 72 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		self->priv->max_bytes = _tmp7_;
#line 73 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		if (self->priv->max_bytes == ((gint64) -1)) {
#line 74 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
			self->priv->max_bytes = G_MAXINT64;
#line 225 "rygel-gst-sink.c"
		}
	}
#line 78 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp8_ = self->cancellable;
#line 78 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_signal_connect_object (_tmp8_, "cancelled", (GCallback) _rygel_gst_sink_on_cancelled_g_cancellable_cancelled, self, 0);
#line 59 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return self;
#line 234 "rygel-gst-sink.c"
}

RygelGstSink*
rygel_gst_sink_new (RygelDataSource* source,
                    RygelHTTPSeekRequest* offsets)
{
#line 59 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return rygel_gst_sink_construct (RYGEL_TYPE_GST_SINK, source, offsets);
#line 243 "rygel-gst-sink.c"
}

void
rygel_gst_sink_freeze (RygelGstSink* self)
{
#line 81 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_lock (&self->priv->buffer_mutex);
#line 84 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (!self->priv->frozen) {
#line 85 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		self->priv->frozen = TRUE;
#line 257 "rygel-gst-sink.c"
	}
#line 88 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_unlock (&self->priv->buffer_mutex);
#line 261 "rygel-gst-sink.c"
}

void
rygel_gst_sink_thaw (RygelGstSink* self)
{
#line 91 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_lock (&self->priv->buffer_mutex);
#line 94 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (self->priv->frozen) {
#line 95 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		self->priv->frozen = FALSE;
#line 96 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		g_cond_broadcast (&self->priv->buffer_condition);
#line 277 "rygel-gst-sink.c"
	}
#line 99 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_unlock (&self->priv->buffer_mutex);
#line 281 "rygel-gst-sink.c"
}

static gpointer
_gst_buffer_ref0 (gpointer self)
{
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return self ? gst_buffer_ref (self) : NULL;
#line 289 "rygel-gst-sink.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return _data2_;
#line 299 "rygel-gst-sink.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 309 "rygel-gst-sink.c"
		RygelGstSink* self;
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		self = _data2_->self;
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_gst_buffer_unref0 (_data2_->buffer);
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_g_object_unref0 (self);
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		g_slice_free (Block2Data, _data2_);
#line 319 "rygel-gst-sink.c"
	}
}

static gboolean
__lambda4_ (Block2Data* _data2_)
{
	RygelGstSink* self;
	gboolean result;
#line 115 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self = _data2_->self;
#line 116 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	result = rygel_gst_sink_push_data (self, _data2_->buffer);
#line 116 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return result;
#line 334 "rygel-gst-sink.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
#line 115 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return result;
#line 344 "rygel-gst-sink.c"
}

static GstFlowReturn
rygel_gst_sink_real_render (GstBaseSink* base,
                            GstBuffer* buffer)
{
	RygelGstSink * self;
	Block2Data* _data2_;
	GstBuffer* _tmp0_;
	GCancellable* _tmp3_;
	GstFlowReturn result;
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self = (RygelGstSink*) base;
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_val_if_fail (buffer != NULL, 0);
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data2_->_ref_count_ = 1;
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data2_->self = g_object_ref (self);
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = _gst_buffer_ref0 (buffer);
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_gst_buffer_unref0 (_data2_->buffer);
#line 102 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data2_->buffer = _tmp0_;
#line 103 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_lock (&self->priv->buffer_mutex);
#line 104 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	while (TRUE) {
#line 376 "rygel-gst-sink.c"
		gboolean _tmp1_ = FALSE;
		GCancellable* _tmp2_;
#line 104 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp2_ = self->cancellable;
#line 104 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		if (!g_cancellable_is_cancelled (_tmp2_)) {
#line 105 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
			_tmp1_ = self->priv->frozen;
#line 385 "rygel-gst-sink.c"
		} else {
#line 104 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
			_tmp1_ = FALSE;
#line 389 "rygel-gst-sink.c"
		}
#line 104 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		if (!_tmp1_) {
#line 104 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
			break;
#line 395 "rygel-gst-sink.c"
		}
#line 107 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		g_cond_wait (&self->priv->buffer_condition, &self->priv->buffer_mutex);
#line 399 "rygel-gst-sink.c"
	}
#line 109 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_unlock (&self->priv->buffer_mutex);
#line 111 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp3_ = self->cancellable;
#line 111 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (g_cancellable_is_cancelled (_tmp3_)) {
#line 112 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		result = GST_FLOW_OK;
#line 112 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		block2_data_unref (_data2_);
#line 112 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_data2_ = NULL;
#line 112 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		return result;
#line 415 "rygel-gst-sink.c"
	}
#line 115 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_idle_add_full (self->priv->priority, ___lambda4__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 119 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	result = GST_FLOW_OK;
#line 119 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	block2_data_unref (_data2_);
#line 119 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data2_ = NULL;
#line 119 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return result;
#line 427 "rygel-gst-sink.c"
}

gboolean
rygel_gst_sink_push_data (RygelGstSink* self,
                          GstBuffer* buffer)
{
	gint64 left = 0LL;
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_;
	gsize bufsize = 0UL;
	gint64 to_send = 0LL;
	GstMapInfo info = {0};
	GstMapInfo _tmp2_ = {0};
	guint8* tmp = NULL;
	GstMapInfo _tmp3_;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint tmp_length1;
	gint _tmp_size_;
	RygelDataSource* _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	GstMapInfo _tmp7_;
	gboolean result;
#line 123 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 123 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_val_if_fail (buffer != NULL, FALSE);
#line 124 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	left = self->priv->max_bytes - self->priv->bytes_sent;
#line 126 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp1_ = self->cancellable;
#line 126 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (g_cancellable_is_cancelled (_tmp1_)) {
#line 126 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp0_ = TRUE;
#line 464 "rygel-gst-sink.c"
	} else {
#line 126 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp0_ = left <= ((gint64) 0);
#line 468 "rygel-gst-sink.c"
	}
#line 126 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (_tmp0_) {
#line 127 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		result = FALSE;
#line 127 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
		return result;
#line 476 "rygel-gst-sink.c"
	}
#line 130 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	bufsize = gst_buffer_get_size (buffer);
#line 131 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	to_send = MIN ((gint64) bufsize, left);
#line 134 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_buffer_map (buffer, &_tmp2_, GST_MAP_READ);
#line 134 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	info = _tmp2_;
#line 136 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp3_ = info;
#line 136 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp4_ = _tmp3_.data;
#line 136 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp4__length1 = _tmp3_.size;
#line 136 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	tmp = _tmp4_ + 0;
#line 136 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	tmp_length1 = ((gint) to_send) - 0;
#line 136 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp_size_ = tmp_length1;
#line 138 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp5_ = self->priv->source;
#line 138 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp6_ = tmp;
#line 138 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp6__length1 = tmp_length1;
#line 138 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_signal_emit_by_name (_tmp5_, "data-available", _tmp6_, (gint) _tmp6__length1);
#line 139 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->bytes_sent = self->priv->bytes_sent + to_send;
#line 140 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp7_ = info;
#line 140 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_buffer_unmap (buffer, &_tmp7_);
#line 142 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	result = FALSE;
#line 142 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	return result;
#line 516 "rygel-gst-sink.c"
}

static void
rygel_gst_sink_on_cancelled (RygelGstSink* self)
{
#line 145 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_lock (&self->priv->buffer_mutex);
#line 147 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_cond_broadcast (&self->priv->buffer_condition);
#line 148 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_unlock (&self->priv->buffer_mutex);
#line 530 "rygel-gst-sink.c"
}

static void
rygel_gst_sink_class_init (RygelGstSinkClass * klass,
                           gpointer klass_data)
{
	GstCaps* caps = NULL;
	GstCaps* _tmp0_;
	GstPadTemplate* template = NULL;
	GstCaps* _tmp1_;
	GstPadTemplate* _tmp2_;
	GstPadTemplate* _tmp3_;
#line 29 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	rygel_gst_sink_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_type_class_adjust_private_offset (klass, &RygelGstSink_private_offset);
#line 29 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	((GstBaseSinkClass *) klass)->render = (GstFlowReturn (*) (GstBaseSink*, GstBuffer*)) rygel_gst_sink_real_render;
#line 29 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_gst_sink_finalize;
#line 51 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = gst_caps_new_any ();
#line 51 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	caps = _tmp0_;
#line 52 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp1_ = caps;
#line 52 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp2_ = gst_pad_template_new (RYGEL_GST_SINK_PAD_NAME, GST_PAD_SINK, GST_PAD_ALWAYS, _tmp1_);
#line 52 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_object_ref_sink (_tmp2_);
#line 52 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	template = _tmp2_;
#line 56 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp3_ = template;
#line 56 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_element_class_add_pad_template (GST_ELEMENT_CLASS (klass), _tmp3_);
#line 50 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (template);
#line 50 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_gst_caps_unref0 (caps);
#line 571 "rygel-gst-sink.c"
}

static void
rygel_gst_sink_instance_init (RygelGstSink * self,
                              gpointer klass)
{
#line 29 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv = rygel_gst_sink_get_instance_private (self);
#line 43 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_init (&self->priv->buffer_mutex);
#line 44 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_cond_init (&self->priv->buffer_condition);
#line 584 "rygel-gst-sink.c"
}

static void
rygel_gst_sink_finalize (GObject * obj)
{
	RygelGstSink * self;
#line 29 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_GST_SINK, RygelGstSink);
#line 36 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (self->cancellable);
#line 43 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_vala_clear_GMutex (&self->priv->buffer_mutex);
#line 44 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_vala_clear_GCond (&self->priv->buffer_condition);
#line 46 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (self->priv->offsets);
#line 29 "../src/media-engines/gstreamer/rygel-gst-sink.vala"
	G_OBJECT_CLASS (rygel_gst_sink_parent_class)->finalize (obj);
#line 603 "rygel-gst-sink.c"
}

 G_GNUC_NO_INLINE static GType
rygel_gst_sink_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelGstSinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_gst_sink_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelGstSink), 0, (GInstanceInitFunc) rygel_gst_sink_instance_init, NULL };
	GType rygel_gst_sink_type_id;
	rygel_gst_sink_type_id = g_type_register_static (gst_base_sink_get_type (), "RygelGstSink", &g_define_type_info, 0);
	RygelGstSink_private_offset = g_type_add_instance_private (rygel_gst_sink_type_id, sizeof (RygelGstSinkPrivate));
	return rygel_gst_sink_type_id;
}

GType
rygel_gst_sink_get_type (void)
{
	static volatile gsize rygel_gst_sink_type_id__once = 0;
	if (g_once_init_enter (&rygel_gst_sink_type_id__once)) {
		GType rygel_gst_sink_type_id;
		rygel_gst_sink_type_id = rygel_gst_sink_get_type_once ();
		g_once_init_leave (&rygel_gst_sink_type_id__once, rygel_gst_sink_type_id);
	}
	return rygel_gst_sink_type_id__once;
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

