/* rygel-simple-data-source.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-simple-data-source.vala, do not modify */

/*
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib-object.h>
#include "rygel-server.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <sys/types.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include "rygel-media-engine-simple.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_SIMPLE_DATA_SOURCE (rygel_simple_data_source_get_type ())
#define RYGEL_SIMPLE_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_SIMPLE_DATA_SOURCE, RygelSimpleDataSource))
#define RYGEL_SIMPLE_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_SIMPLE_DATA_SOURCE, RygelSimpleDataSourceClass))
#define RYGEL_IS_SIMPLE_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_SIMPLE_DATA_SOURCE))
#define RYGEL_IS_SIMPLE_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_SIMPLE_DATA_SOURCE))
#define RYGEL_SIMPLE_DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_SIMPLE_DATA_SOURCE, RygelSimpleDataSourceClass))

typedef struct _RygelSimpleDataSource RygelSimpleDataSource;
typedef struct _RygelSimpleDataSourceClass RygelSimpleDataSourceClass;
typedef struct _RygelSimpleDataSourcePrivate RygelSimpleDataSourcePrivate;
enum  {
	RYGEL_SIMPLE_DATA_SOURCE_0_PROPERTY,
	RYGEL_SIMPLE_DATA_SOURCE_NUM_PROPERTIES
};
static GParamSpec* rygel_simple_data_source_properties[RYGEL_SIMPLE_DATA_SOURCE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _RygelSimpleDataSource {
	GObject parent_instance;
	RygelSimpleDataSourcePrivate * priv;
};

struct _RygelSimpleDataSourceClass {
	GObjectClass parent_class;
};

struct _RygelSimpleDataSourcePrivate {
	gchar* uri;
	GThread* thread;
	GMutex mutex;
	GCond cond;
	off_t first_byte;
	off_t last_byte;
	gboolean frozen;
	gboolean stop_thread;
	GThreadPool* pool;
};

struct _Block1Data {
	int _ref_count_;
	RygelSimpleDataSource* self;
	guint8* slice;
	gint slice_length1;
	gint _slice_size_;
};

static gint RygelSimpleDataSource_private_offset;
static gpointer rygel_simple_data_source_parent_class = NULL;
static RygelDataSourceIface * rygel_simple_data_source_rygel_data_source_parent_iface = NULL;

VALA_EXTERN GType rygel_simple_data_source_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelSimpleDataSource* rygel_simple_data_source_new (GThreadPool* pool,
                                                     const gchar* uri);
VALA_EXTERN RygelSimpleDataSource* rygel_simple_data_source_construct (GType object_type,
                                                           GThreadPool* pool,
                                                           const gchar* uri);
static GeeList* rygel_simple_data_source_real_preroll (RygelDataSource* base,
                                                RygelHTTPSeekRequest* seek_request,
                                                RygelPlaySpeedRequest* playspeed_request,
                                                GError** error);
static void rygel_simple_data_source_real_start (RygelDataSource* base,
                                          GError** error);
static void* rygel_simple_data_source_thread_func (RygelSimpleDataSource* self);
static gpointer _rygel_simple_data_source_thread_func_gthread_func (gpointer self);
static void rygel_simple_data_source_real_freeze (RygelDataSource* base);
static void rygel_simple_data_source_real_thaw (RygelDataSource* base);
static void rygel_simple_data_source_real_stop (RygelDataSource* base);
VALA_EXTERN void rygel_simple_data_source_pool_func (RygelSimpleDataSource* data);
static void rygel_simple_data_source_run (RygelSimpleDataSource* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean ____lambda4_ (Block1Data* _data1_);
static gboolean _____lambda4__gsource_func (gpointer self);
static gboolean __lambda5_ (RygelSimpleDataSource* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static void rygel_simple_data_source_finalize (GObject * obj);
static GType rygel_simple_data_source_get_type_once (void);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

static inline gpointer
rygel_simple_data_source_get_instance_private (RygelSimpleDataSource* self)
{
	return G_STRUCT_MEMBER_P (self, RygelSimpleDataSource_private_offset);
}

RygelSimpleDataSource*
rygel_simple_data_source_construct (GType object_type,
                                    GThreadPool* pool,
                                    const gchar* uri)
{
	RygelSimpleDataSource * self = NULL;
	gchar* _tmp0_;
#line 45 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 45 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self = (RygelSimpleDataSource*) g_object_new (object_type, NULL);
#line 47 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_debug ("rygel-simple-data-source.vala:47: Creating new data source for %s", uri);
#line 48 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_tmp0_ = g_strdup (uri);
#line 48 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_g_free0 (self->priv->uri);
#line 48 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self->priv->uri = _tmp0_;
#line 49 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self->priv->pool = pool;
#line 45 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return self;
#line 167 "rygel-simple-data-source.c"
}

RygelSimpleDataSource*
rygel_simple_data_source_new (GThreadPool* pool,
                              const gchar* uri)
{
#line 45 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return rygel_simple_data_source_construct (RYGEL_TYPE_SIMPLE_DATA_SOURCE, pool, uri);
#line 176 "rygel-simple-data-source.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 67 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return self ? g_object_ref (self) : NULL;
#line 184 "rygel-simple-data-source.c"
}

static GeeList*
rygel_simple_data_source_real_preroll (RygelDataSource* base,
                                       RygelHTTPSeekRequest* seek_request,
                                       RygelPlaySpeedRequest* playspeed_request,
                                       GError** error)
{
	RygelSimpleDataSource * self;
	GeeArrayList* response_list = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 56 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self = (RygelSimpleDataSource*) base;
#line 59 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_tmp0_ = gee_array_list_new (RYGEL_TYPE_HTTP_RESPONSE_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 59 "../src/media-engines/simple/rygel-simple-data-source.vala"
	response_list = _tmp0_;
#line 61 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (seek_request != NULL) {
#line 206 "rygel-simple-data-source.c"
		RygelHTTPByteSeekRequest* byte_seek = NULL;
		RygelHTTPByteSeekRequest* _tmp2_;
		RygelHTTPByteSeekRequest* _tmp3_;
		gint64 _tmp4_;
		gint64 _tmp5_;
		RygelHTTPByteSeekRequest* _tmp6_;
		gint64 _tmp7_;
		gint64 _tmp8_;
		RygelHTTPByteSeekRequest* _tmp9_;
		gint64 _tmp10_;
		gint64 _tmp11_;
		RygelHTTPByteSeekRequest* _tmp12_;
		gint64 _tmp13_;
		gint64 _tmp14_;
		const gchar* _tmp15_;
		RygelHTTPByteSeekResponse* seek_response = NULL;
		RygelHTTPByteSeekRequest* _tmp16_;
		RygelHTTPByteSeekResponse* _tmp17_;
		GeeArrayList* _tmp18_;
		RygelHTTPByteSeekResponse* _tmp19_;
#line 62 "../src/media-engines/simple/rygel-simple-data-source.vala"
		if (!G_TYPE_CHECK_INSTANCE_TYPE (seek_request, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST)) {
#line 229 "rygel-simple-data-source.c"
			GError* _tmp1_;
#line 63 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_tmp1_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_SEEK_FAILED, _ ("Only byte-based seek supported"));
#line 63 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_inner_error0_ = _tmp1_;
#line 63 "../src/media-engines/simple/rygel-simple-data-source.vala"
			g_propagate_error (error, _inner_error0_);
#line 63 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_g_object_unref0 (response_list);
#line 63 "../src/media-engines/simple/rygel-simple-data-source.vala"
			return NULL;
#line 241 "rygel-simple-data-source.c"
		}
#line 67 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (seek_request, RYGEL_TYPE_HTTP_BYTE_SEEK_REQUEST) ? ((RygelHTTPByteSeekRequest*) seek_request) : NULL);
#line 67 "../src/media-engines/simple/rygel-simple-data-source.vala"
		byte_seek = _tmp2_;
#line 68 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp3_ = byte_seek;
#line 68 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp4_ = rygel_http_byte_seek_request_get_start_byte (_tmp3_);
#line 68 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp5_ = _tmp4_;
#line 68 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->first_byte = (off_t) _tmp5_;
#line 69 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp6_ = byte_seek;
#line 69 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp7_ = rygel_http_byte_seek_request_get_end_byte (_tmp6_);
#line 69 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp8_ = _tmp7_;
#line 69 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->last_byte = (off_t) (_tmp8_ + 1);
#line 70 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp9_ = byte_seek;
#line 70 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp10_ = rygel_http_byte_seek_request_get_start_byte (_tmp9_);
#line 70 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp11_ = _tmp10_;
#line 70 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp12_ = byte_seek;
#line 70 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp13_ = rygel_http_byte_seek_request_get_end_byte (_tmp12_);
#line 70 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp14_ = _tmp13_;
#line 70 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp15_ = self->priv->uri;
#line 70 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_debug ("rygel-simple-data-source.vala:70: Processing byte seek request for byt" \
"es %lld-%lld of %s", _tmp11_, _tmp14_, _tmp15_);
#line 74 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp16_ = byte_seek;
#line 74 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp17_ = rygel_http_byte_seek_response_new_from_request (_tmp16_);
#line 74 "../src/media-engines/simple/rygel-simple-data-source.vala"
		seek_response = _tmp17_;
#line 76 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp18_ = response_list;
#line 76 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp19_ = seek_response;
#line 76 "../src/media-engines/simple/rygel-simple-data-source.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, (RygelHTTPResponseElement*) _tmp19_);
#line 61 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_object_unref0 (seek_response);
#line 61 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_object_unref0 (byte_seek);
#line 295 "rygel-simple-data-source.c"
	} else {
#line 78 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->first_byte = (off_t) 0;
#line 79 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->last_byte = (off_t) 0;
#line 301 "rygel-simple-data-source.c"
	}
#line 82 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (playspeed_request != NULL) {
#line 305 "rygel-simple-data-source.c"
		GError* _tmp20_;
#line 83 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp20_ = g_error_new_literal (RYGEL_DATA_SOURCE_ERROR, RYGEL_DATA_SOURCE_ERROR_PLAYSPEED_FAILED, _ ("Playspeed not supported"));
#line 83 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_inner_error0_ = _tmp20_;
#line 83 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_propagate_error (error, _inner_error0_);
#line 83 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_object_unref0 (response_list);
#line 83 "../src/media-engines/simple/rygel-simple-data-source.vala"
		return NULL;
#line 317 "rygel-simple-data-source.c"
	}
#line 87 "../src/media-engines/simple/rygel-simple-data-source.vala"
	result = (GeeList*) response_list;
#line 87 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return result;
#line 323 "rygel-simple-data-source.c"
}

static gpointer
_rygel_simple_data_source_thread_func_gthread_func (gpointer self)
{
	gpointer result;
	result = rygel_simple_data_source_thread_func ((RygelSimpleDataSource*) self);
#line 95 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_object_unref (self);
#line 95 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return result;
#line 335 "rygel-simple-data-source.c"
}

static void
rygel_simple_data_source_real_start (RygelDataSource* base,
                                     GError** error)
{
	RygelSimpleDataSource * self;
	const gchar* _tmp0_;
	GThreadPool* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 90 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self = (RygelSimpleDataSource*) base;
#line 91 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_tmp0_ = self->priv->uri;
#line 91 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_debug ("rygel-simple-data-source.vala:91: Starting data source for uri %s", _tmp0_);
#line 92 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_tmp1_ = self->priv->pool;
#line 92 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (_tmp1_ != NULL) {
#line 356 "rygel-simple-data-source.c"
		GThreadPool* _tmp2_;
		RygelSimpleDataSource* _tmp3_;
#line 93 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp2_ = self->priv->pool;
#line 93 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp3_ = _g_object_ref0 (self);
#line 93 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_thread_pool_push (_tmp2_, _tmp3_, &_inner_error0_);
#line 93 "../src/media-engines/simple/rygel-simple-data-source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../src/media-engines/simple/rygel-simple-data-source.vala"
			g_propagate_error (error, _inner_error0_);
#line 93 "../src/media-engines/simple/rygel-simple-data-source.vala"
			return;
#line 371 "rygel-simple-data-source.c"
		}
	} else {
		GThread* _tmp4_;
#line 95 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp4_ = g_thread_new ("Rygel Serving Thread", _rygel_simple_data_source_thread_func_gthread_func, g_object_ref (self));
#line 95 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_thread_unref0 (self->priv->thread);
#line 95 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->thread = _tmp4_;
#line 381 "rygel-simple-data-source.c"
	}
}

static void
rygel_simple_data_source_real_freeze (RygelDataSource* base)
{
	RygelSimpleDataSource * self;
#line 100 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self = (RygelSimpleDataSource*) base;
#line 101 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_mutex_lock (&self->priv->mutex);
#line 102 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (!self->priv->frozen) {
#line 103 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->frozen = TRUE;
#line 397 "rygel-simple-data-source.c"
	}
#line 106 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 401 "rygel-simple-data-source.c"
}

static void
rygel_simple_data_source_real_thaw (RygelDataSource* base)
{
	RygelSimpleDataSource * self;
#line 109 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self = (RygelSimpleDataSource*) base;
#line 110 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_mutex_lock (&self->priv->mutex);
#line 111 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (self->priv->frozen) {
#line 112 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->frozen = FALSE;
#line 113 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_cond_broadcast (&self->priv->cond);
#line 418 "rygel-simple-data-source.c"
	}
#line 116 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 422 "rygel-simple-data-source.c"
}

static void
rygel_simple_data_source_real_stop (RygelDataSource* base)
{
	RygelSimpleDataSource * self;
#line 119 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self = (RygelSimpleDataSource*) base;
#line 120 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_mutex_lock (&self->priv->mutex);
#line 121 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (!self->priv->stop_thread) {
#line 122 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->frozen = FALSE;
#line 123 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self->priv->stop_thread = TRUE;
#line 124 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_cond_broadcast (&self->priv->cond);
#line 441 "rygel-simple-data-source.c"
	}
#line 127 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 445 "rygel-simple-data-source.c"
}

void
rygel_simple_data_source_pool_func (RygelSimpleDataSource* data)
{
#line 130 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_return_if_fail (data != NULL);
#line 131 "../src/media-engines/simple/rygel-simple-data-source.vala"
	rygel_simple_data_source_run (data);
#line 130 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_g_object_unref0 (data);
#line 457 "rygel-simple-data-source.c"
}

static void*
rygel_simple_data_source_thread_func (RygelSimpleDataSource* self)
{
	void* result;
#line 134 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../src/media-engines/simple/rygel-simple-data-source.vala"
	rygel_simple_data_source_run (self);
#line 137 "../src/media-engines/simple/rygel-simple-data-source.vala"
	result = NULL;
#line 137 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return result;
#line 472 "rygel-simple-data-source.c"
}

static GError*
vala_g_io_error_from_errno (gint err_no)
{
	const gchar* _tmp0_;
	GError* _tmp1_;
	GError* result;
#line 5157 "gio-2.0.vapi"
	_tmp0_ = g_strerror (err_no);
#line 5157 "gio-2.0.vapi"
	_tmp1_ = g_error_new (g_io_error_quark (), g_io_error_from_errno (err_no), "%s", _tmp0_);
#line 5157 "gio-2.0.vapi"
	result = (GError*) _tmp1_;
#line 5157 "gio-2.0.vapi"
	return result;
#line 489 "rygel-simple-data-source.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return _data1_;
#line 499 "rygel-simple-data-source.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 509 "rygel-simple-data-source.c"
		RygelSimpleDataSource* self;
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
		self = _data1_->self;
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_data1_->slice = (g_free (_data1_->slice), NULL);
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_object_unref0 (self);
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_slice_free (Block1Data, _data1_);
#line 519 "rygel-simple-data-source.c"
	}
}

static gboolean
____lambda4_ (Block1Data* _data1_)
{
	RygelSimpleDataSource* self;
	gboolean result;
#line 199 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self = _data1_->self;
#line 200 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (!self->priv->stop_thread) {
#line 532 "rygel-simple-data-source.c"
		guint8* _tmp0_;
		gint _tmp0__length1;
#line 201 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp0_ = _data1_->slice;
#line 201 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp0__length1 = _data1_->slice_length1;
#line 201 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_signal_emit_by_name ((RygelDataSource*) self, "data-available", _tmp0_, (gint) _tmp0__length1);
#line 541 "rygel-simple-data-source.c"
	}
#line 204 "../src/media-engines/simple/rygel-simple-data-source.vala"
	result = FALSE;
#line 204 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return result;
#line 547 "rygel-simple-data-source.c"
}

static gboolean
_____lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda4_ (self);
#line 199 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return result;
#line 557 "rygel-simple-data-source.c"
}

static gboolean
__lambda5_ (RygelSimpleDataSource* self)
{
	gboolean result;
#line 216 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_signal_emit_by_name ((RygelDataSource*) self, "done");
#line 216 "../src/media-engines/simple/rygel-simple-data-source.vala"
	result = FALSE;
#line 216 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return result;
#line 570 "rygel-simple-data-source.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((RygelSimpleDataSource*) self);
#line 216 "../src/media-engines/simple/rygel-simple-data-source.vala"
	return result;
#line 580 "rygel-simple-data-source.c"
}

static void
rygel_simple_data_source_run (RygelSimpleDataSource* self)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	gint fd = 0;
	GError* _inner_error0_ = NULL;
#line 140 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_tmp0_ = self->priv->uri;
#line 141 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_tmp1_ = g_file_new_for_commandline_arg (_tmp0_);
#line 141 "../src/media-engines/simple/rygel-simple-data-source.vala"
	file = _tmp1_;
#line 142 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_tmp2_ = self->priv->uri;
#line 142 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_debug ("rygel-simple-data-source.vala:142: Spawning new thread for streaming f" \
"ile %s", _tmp2_);
#line 143 "../src/media-engines/simple/rygel-simple-data-source.vala"
	fd = -1;
#line 606 "rygel-simple-data-source.c"
	{
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 145 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp3_ = file;
#line 145 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 145 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp5_ = _tmp4_;
#line 145 "../src/media-engines/simple/rygel-simple-data-source.vala"
		fd = open (_tmp5_, O_RDONLY, (mode_t) 0);
#line 145 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_free0 (_tmp5_);
#line 146 "../src/media-engines/simple/rygel-simple-data-source.vala"
		if (fd < 0) {
#line 623 "rygel-simple-data-source.c"
			GError* _tmp6_;
#line 147 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_tmp6_ = vala_g_io_error_from_errno (errno);
#line 147 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_inner_error0_ = _tmp6_;
#line 629 "rygel-simple-data-source.c"
			goto __catch0_g_error;
		}
#line 150 "../src/media-engines/simple/rygel-simple-data-source.vala"
		if (self->priv->last_byte == ((off_t) 0)) {
#line 151 "../src/media-engines/simple/rygel-simple-data-source.vala"
			self->priv->last_byte = lseek (fd, (off_t) 0, SEEK_END);
#line 152 "../src/media-engines/simple/rygel-simple-data-source.vala"
			if (self->priv->last_byte < ((off_t) 0)) {
#line 638 "rygel-simple-data-source.c"
				GError* _tmp7_;
#line 153 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_tmp7_ = vala_g_io_error_from_errno (errno);
#line 153 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_inner_error0_ = _tmp7_;
#line 644 "rygel-simple-data-source.c"
				goto __catch0_g_error;
			}
#line 156 "../src/media-engines/simple/rygel-simple-data-source.vala"
			if (lseek (fd, (off_t) 0, SEEK_SET) < ((off_t) 0)) {
#line 649 "rygel-simple-data-source.c"
				GError* _tmp8_;
#line 157 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_tmp8_ = vala_g_io_error_from_errno (errno);
#line 157 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_inner_error0_ = _tmp8_;
#line 655 "rygel-simple-data-source.c"
				goto __catch0_g_error;
			}
		}
#line 162 "../src/media-engines/simple/rygel-simple-data-source.vala"
		if (self->priv->first_byte != ((off_t) 0)) {
#line 163 "../src/media-engines/simple/rygel-simple-data-source.vala"
			if (lseek (fd, self->priv->first_byte, SEEK_SET) < ((off_t) 0)) {
#line 663 "rygel-simple-data-source.c"
				GError* _tmp9_;
#line 164 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_tmp9_ = vala_g_io_error_from_errno (errno);
#line 164 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_inner_error0_ = _tmp9_;
#line 669 "rygel-simple-data-source.c"
				goto __catch0_g_error;
			}
		}
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
		while (TRUE) {
#line 675 "rygel-simple-data-source.c"
			Block1Data* _data1_;
			gboolean exit = FALSE;
			gboolean _tmp10_ = FALSE;
			off_t start = {0};
			off_t stop = {0};
			guint8* _tmp11_;
			gint len = 0;
			guint8* _tmp12_;
			gint _tmp12__length1;
			guint8* _tmp13_;
			gint _tmp13__length1;
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_data1_ = g_slice_new0 (Block1Data);
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_data1_->_ref_count_ = 1;
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_data1_->self = g_object_ref (self);
#line 169 "../src/media-engines/simple/rygel-simple-data-source.vala"
			g_mutex_lock (&self->priv->mutex);
#line 170 "../src/media-engines/simple/rygel-simple-data-source.vala"
			while (TRUE) {
#line 170 "../src/media-engines/simple/rygel-simple-data-source.vala"
				if (!self->priv->frozen) {
#line 170 "../src/media-engines/simple/rygel-simple-data-source.vala"
					break;
#line 701 "rygel-simple-data-source.c"
				}
#line 171 "../src/media-engines/simple/rygel-simple-data-source.vala"
				g_cond_wait (&self->priv->cond, &self->priv->mutex);
#line 705 "rygel-simple-data-source.c"
			}
#line 174 "../src/media-engines/simple/rygel-simple-data-source.vala"
			exit = self->priv->stop_thread;
#line 175 "../src/media-engines/simple/rygel-simple-data-source.vala"
			g_mutex_unlock (&self->priv->mutex);
#line 177 "../src/media-engines/simple/rygel-simple-data-source.vala"
			if (exit) {
#line 177 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_tmp10_ = TRUE;
#line 715 "rygel-simple-data-source.c"
			} else {
#line 177 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_tmp10_ = self->priv->first_byte == self->priv->last_byte;
#line 719 "rygel-simple-data-source.c"
			}
#line 177 "../src/media-engines/simple/rygel-simple-data-source.vala"
			if (_tmp10_) {
#line 178 "../src/media-engines/simple/rygel-simple-data-source.vala"
				g_debug ("rygel-simple-data-source.vala:178: Done streaming!");
#line 180 "../src/media-engines/simple/rygel-simple-data-source.vala"
				block1_data_unref (_data1_);
#line 180 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_data1_ = NULL;
#line 180 "../src/media-engines/simple/rygel-simple-data-source.vala"
				break;
#line 731 "rygel-simple-data-source.c"
			}
#line 183 "../src/media-engines/simple/rygel-simple-data-source.vala"
			start = self->priv->first_byte;
#line 184 "../src/media-engines/simple/rygel-simple-data-source.vala"
			stop = start + G_MAXUINT16;
#line 185 "../src/media-engines/simple/rygel-simple-data-source.vala"
			if (stop > self->priv->last_byte) {
#line 186 "../src/media-engines/simple/rygel-simple-data-source.vala"
				stop = self->priv->last_byte;
#line 741 "rygel-simple-data-source.c"
			}
#line 189 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_tmp11_ = g_new0 (guint8, stop - start);
#line 189 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_data1_->slice = _tmp11_;
#line 189 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_data1_->slice_length1 = stop - start;
#line 189 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_data1_->_slice_size_ = _data1_->slice_length1;
#line 190 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_tmp12_ = _data1_->slice;
#line 190 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_tmp12__length1 = _data1_->slice_length1;
#line 190 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_tmp13_ = _data1_->slice;
#line 190 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_tmp13__length1 = _data1_->slice_length1;
#line 190 "../src/media-engines/simple/rygel-simple-data-source.vala"
			len = (gint) read (fd, _tmp12_, (gsize) _tmp13__length1);
#line 191 "../src/media-engines/simple/rygel-simple-data-source.vala"
			if (len < 0) {
#line 763 "rygel-simple-data-source.c"
				GError* _tmp14_;
#line 192 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_tmp14_ = vala_g_io_error_from_errno (errno);
#line 192 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_inner_error0_ = _tmp14_;
#line 192 "../src/media-engines/simple/rygel-simple-data-source.vala"
				block1_data_unref (_data1_);
#line 192 "../src/media-engines/simple/rygel-simple-data-source.vala"
				_data1_ = NULL;
#line 773 "rygel-simple-data-source.c"
				goto __catch0_g_error;
			}
#line 195 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_data1_->slice_length1 = len;
#line 196 "../src/media-engines/simple/rygel-simple-data-source.vala"
			self->priv->first_byte = stop;
#line 199 "../src/media-engines/simple/rygel-simple-data-source.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda4__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
			block1_data_unref (_data1_);
#line 167 "../src/media-engines/simple/rygel-simple-data-source.vala"
			_data1_ = NULL;
#line 786 "rygel-simple-data-source.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GFile* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 144 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_error_ = _inner_error0_;
#line 144 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_inner_error0_ = NULL;
#line 208 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp15_ = file;
#line 208 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp16_ = g_file_get_path (_tmp15_);
#line 208 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp17_ = _tmp16_;
#line 208 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp18_ = _error_;
#line 208 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_tmp19_ = _tmp18_->message;
#line 208 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_warning ("rygel-simple-data-source.vala:208: Failed to stream file %s: %s", _tmp17_, _tmp19_);
#line 208 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_free0 (_tmp17_);
#line 144 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_error_free0 (_error_);
#line 818 "rygel-simple-data-source.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
#line 212 "../src/media-engines/simple/rygel-simple-data-source.vala"
		close (fd);
#line 825 "rygel-simple-data-source.c"
	}
#line 144 "../src/media-engines/simple/rygel-simple-data-source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/media-engines/simple/rygel-simple-data-source.vala"
		_g_object_unref0 (file);
#line 144 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/media-engines/simple/rygel-simple-data-source.vala"
		g_clear_error (&_inner_error0_);
#line 144 "../src/media-engines/simple/rygel-simple-data-source.vala"
		return;
#line 837 "rygel-simple-data-source.c"
	}
#line 216 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 140 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_g_object_unref0 (file);
#line 843 "rygel-simple-data-source.c"
}

static void
rygel_simple_data_source_class_init (RygelSimpleDataSourceClass * klass,
                                     gpointer klass_data)
{
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	rygel_simple_data_source_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_type_class_adjust_private_offset (klass, &RygelSimpleDataSource_private_offset);
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_simple_data_source_finalize;
#line 856 "rygel-simple-data-source.c"
}

static void
rygel_simple_data_source_rygel_data_source_interface_init (RygelDataSourceIface * iface,
                                                           gpointer iface_data)
{
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	rygel_simple_data_source_rygel_data_source_parent_iface = g_type_interface_peek_parent (iface);
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	iface->preroll = (GeeList* (*) (RygelDataSource*, RygelHTTPSeekRequest*, RygelPlaySpeedRequest*, GError**)) rygel_simple_data_source_real_preroll;
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	iface->start = (void (*) (RygelDataSource*, GError**)) rygel_simple_data_source_real_start;
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	iface->freeze = (void (*) (RygelDataSource*)) rygel_simple_data_source_real_freeze;
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	iface->thaw = (void (*) (RygelDataSource*)) rygel_simple_data_source_real_thaw;
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	iface->stop = (void (*) (RygelDataSource*)) rygel_simple_data_source_real_stop;
#line 875 "rygel-simple-data-source.c"
}

static void
rygel_simple_data_source_instance_init (RygelSimpleDataSource * self,
                                        gpointer klass)
{
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self->priv = rygel_simple_data_source_get_instance_private (self);
#line 37 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_mutex_init (&self->priv->mutex);
#line 38 "../src/media-engines/simple/rygel-simple-data-source.vala"
	g_cond_init (&self->priv->cond);
#line 39 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self->priv->first_byte = (off_t) 0;
#line 40 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self->priv->last_byte = (off_t) 0;
#line 41 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self->priv->frozen = FALSE;
#line 42 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self->priv->stop_thread = FALSE;
#line 896 "rygel-simple-data-source.c"
}

static void
rygel_simple_data_source_finalize (GObject * obj)
{
	RygelSimpleDataSource * self;
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_SIMPLE_DATA_SOURCE, RygelSimpleDataSource);
#line 53 "../src/media-engines/simple/rygel-simple-data-source.vala"
	rygel_data_source_stop ((RygelDataSource*) self);
#line 35 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_g_free0 (self->priv->uri);
#line 36 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_g_thread_unref0 (self->priv->thread);
#line 37 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_vala_clear_GMutex (&self->priv->mutex);
#line 38 "../src/media-engines/simple/rygel-simple-data-source.vala"
	_vala_clear_GCond (&self->priv->cond);
#line 34 "../src/media-engines/simple/rygel-simple-data-source.vala"
	G_OBJECT_CLASS (rygel_simple_data_source_parent_class)->finalize (obj);
#line 917 "rygel-simple-data-source.c"
}

/**
 * A simple data source for use with the simple media engine (RygelSimpleMediaEngine).
 *
 * This does not support time-base seeking with
 * rygel_data_source_start() because it does not
 * use any multimedia framework. Therefore, calling start() with
 * RYGEL_HTTP_SEEK_TYPE_TIME will fail with a
 * RYGEL_DATA_SOURCE_ERROR_SEEK_FAILED GError code,
 */
 G_GNUC_NO_INLINE static GType
rygel_simple_data_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelSimpleDataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_simple_data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelSimpleDataSource), 0, (GInstanceInitFunc) rygel_simple_data_source_instance_init, NULL };
	static const GInterfaceInfo rygel_data_source_info = { (GInterfaceInitFunc) rygel_simple_data_source_rygel_data_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType rygel_simple_data_source_type_id;
	rygel_simple_data_source_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelSimpleDataSource", &g_define_type_info, 0);
	g_type_add_interface_static (rygel_simple_data_source_type_id, RYGEL_TYPE_DATA_SOURCE, &rygel_data_source_info);
	RygelSimpleDataSource_private_offset = g_type_add_instance_private (rygel_simple_data_source_type_id, sizeof (RygelSimpleDataSourcePrivate));
	return rygel_simple_data_source_type_id;
}

GType
rygel_simple_data_source_get_type (void)
{
	static volatile gsize rygel_simple_data_source_type_id__once = 0;
	if (g_once_init_enter (&rygel_simple_data_source_type_id__once)) {
		GType rygel_simple_data_source_type_id;
		rygel_simple_data_source_type_id = rygel_simple_data_source_get_type_once ();
		g_once_init_leave (&rygel_simple_data_source_type_id__once, rygel_simple_data_source_type_id);
	}
	return rygel_simple_data_source_type_id__once;
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

