/* rygel-external-variant-util.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-external-variant-util.vala, do not modify */

/*
 * Copyright (C) 2012 Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-external.h"
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

static gchar* _variant_get33 (GVariant* value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gchar** _variant_get34 (GVariant* value,
                        gint* result_length1);

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 29 "../src/plugins/external/rygel-external-variant-util.vala"
	return self ? g_variant_ref (self) : NULL;
#line 53 "rygel-external-variant-util.c"
}

GVariant*
rygel_external_get_mandatory (GHashTable* props,
                              const gchar* key,
                              const gchar* service_name)
{
	GVariant* value = NULL;
	gconstpointer _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* result;
#line 25 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 25 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 25 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (service_name != NULL, NULL);
#line 29 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp0_ = g_hash_table_lookup (props, key);
#line 29 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp1_ = _g_variant_ref0 ((GVariant*) _tmp0_);
#line 29 "../src/plugins/external/rygel-external-variant-util.vala"
	value = _tmp1_;
#line 30 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp2_ = value;
#line 30 "../src/plugins/external/rygel-external-variant-util.vala"
	if (_tmp2_ == NULL) {
#line 31 "../src/plugins/external/rygel-external-variant-util.vala"
		g_warning (_ (RYGEL_EXTERNAL_MANDATORY_MISSING_MESSAGE), service_name, key);
#line 33 "../src/plugins/external/rygel-external-variant-util.vala"
		result = NULL;
#line 33 "../src/plugins/external/rygel-external-variant-util.vala"
		_g_variant_unref0 (value);
#line 33 "../src/plugins/external/rygel-external-variant-util.vala"
		return result;
#line 90 "rygel-external-variant-util.c"
	}
#line 36 "../src/plugins/external/rygel-external-variant-util.vala"
	result = value;
#line 36 "../src/plugins/external/rygel-external-variant-util.vala"
	return result;
#line 96 "rygel-external-variant-util.c"
}

static gchar*
_variant_get33 (GVariant* value)
{
#line 50 "../src/plugins/external/rygel-external-variant-util.vala"
	return g_variant_dup_string (value, NULL);
#line 104 "rygel-external-variant-util.c"
}

gchar*
rygel_external_get_mandatory_string_value (GHashTable* props,
                                           const gchar* key,
                                           const gchar* _default_,
                                           const gchar* service_name)
{
	GVariant* value = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 39 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 39 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 39 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (_default_ != NULL, NULL);
#line 39 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (service_name != NULL, NULL);
#line 44 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp0_ = rygel_external_get_mandatory (props, key, service_name);
#line 44 "../src/plugins/external/rygel-external-variant-util.vala"
	value = _tmp0_;
#line 46 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp1_ = value;
#line 46 "../src/plugins/external/rygel-external-variant-util.vala"
	if (_tmp1_ == NULL) {
#line 135 "rygel-external-variant-util.c"
		gchar* _tmp2_;
#line 47 "../src/plugins/external/rygel-external-variant-util.vala"
		_tmp2_ = g_strdup (_default_);
#line 47 "../src/plugins/external/rygel-external-variant-util.vala"
		result = _tmp2_;
#line 47 "../src/plugins/external/rygel-external-variant-util.vala"
		_g_variant_unref0 (value);
#line 47 "../src/plugins/external/rygel-external-variant-util.vala"
		return result;
#line 145 "rygel-external-variant-util.c"
	}
#line 50 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp3_ = value;
#line 50 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp4_ = _variant_get33 (_tmp3_);
#line 50 "../src/plugins/external/rygel-external-variant-util.vala"
	result = _tmp4_;
#line 50 "../src/plugins/external/rygel-external-variant-util.vala"
	_g_variant_unref0 (value);
#line 50 "../src/plugins/external/rygel-external-variant-util.vala"
	return result;
#line 157 "rygel-external-variant-util.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
	if (length >= 0) {
#line 166 "rygel-external-variant-util.c"
		gchar** result;
		gssize i;
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		result = g_new0 (gchar*, length + 1);
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		for (i = 0; i < length; i++) {
#line 173 "rygel-external-variant-util.c"
			gchar* _tmp0_;
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
			_tmp0_ = g_strdup (self[i]);
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
			result[i] = _tmp0_;
#line 179 "rygel-external-variant-util.c"
		}
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		return result;
#line 183 "rygel-external-variant-util.c"
	}
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
	return NULL;
#line 187 "rygel-external-variant-util.c"
}

static gchar**
_variant_get34 (GVariant* value,
                gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length;
	gint _tmp0__size;
	gint _tmp0__length1;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	_tmp0_ = g_new (gchar*, 5);
	_tmp0__length = 0;
	_tmp0__size = 4;
	_tmp0__length1 = 0;
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	g_variant_iter_init (&_tmp1_, value);
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	for (; (_tmp2_ = g_variant_iter_next_value (&_tmp1_)) != NULL; _tmp0__length1++) {
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
		if (_tmp0__size == _tmp0__length) {
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
			_tmp0__size = 2 * _tmp0__size;
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
			_tmp0_ = g_renew (gchar*, _tmp0_, _tmp0__size + 1);
#line 214 "rygel-external-variant-util.c"
		}
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
		_tmp0_[_tmp0__length++] = g_variant_dup_string (_tmp2_, NULL);
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
		g_variant_unref (_tmp2_);
#line 220 "rygel-external-variant-util.c"
	}
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	*result_length1 = _tmp0__length1;
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp0_[_tmp0__length] = NULL;
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	return _tmp0_;
#line 228 "rygel-external-variant-util.c"
}

gchar**
rygel_external_get_mandatory_string_list_value (GHashTable* props,
                                                const gchar* key,
                                                gchar** _default_,
                                                gint _default__length1,
                                                const gchar* service_name,
                                                gint* result_length1)
{
	GVariant* value = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp4_;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** result;
#line 53 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 53 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 53 "../src/plugins/external/rygel-external-variant-util.vala"
	g_return_val_if_fail (service_name != NULL, NULL);
#line 58 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp0_ = rygel_external_get_mandatory (props, key, service_name);
#line 58 "../src/plugins/external/rygel-external-variant-util.vala"
	value = _tmp0_;
#line 60 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp1_ = value;
#line 60 "../src/plugins/external/rygel-external-variant-util.vala"
	if (_tmp1_ == NULL) {
#line 262 "rygel-external-variant-util.c"
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		_tmp2_ = (_default_ != NULL) ? _vala_array_dup1 (_default_, _default__length1) : _default_;
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		_tmp2__length1 = _default__length1;
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		_tmp3_ = _tmp2_;
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		_tmp3__length1 = _tmp2__length1;
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		if (result_length1) {
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
			*result_length1 = _tmp3__length1;
#line 279 "rygel-external-variant-util.c"
		}
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		result = _tmp3_;
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		_g_variant_unref0 (value);
#line 61 "../src/plugins/external/rygel-external-variant-util.vala"
		return result;
#line 287 "rygel-external-variant-util.c"
	}
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp4_ = value;
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp5_ = _variant_get34 (_tmp4_, &_tmp5__length1);
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp6_ = _tmp5_;
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	_tmp6__length1 = _tmp5__length1;
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	if (result_length1) {
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
		*result_length1 = _tmp6__length1;
#line 301 "rygel-external-variant-util.c"
	}
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	result = _tmp6_;
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	_g_variant_unref0 (value);
#line 64 "../src/plugins/external/rygel-external-variant-util.vala"
	return result;
#line 309 "rygel-external-variant-util.c"
}

