/* rygel-media-export-extractor.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-media-export-extractor.vala, do not modify */

/*
 * Copyright (C) 2016 Jens Georg <mail@jensge.org>
 *
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include "mx-constants.h"
#include <libgupnp-av/gupnp-av.h>

#define RYGEL_MEDIA_EXPORT_EXTRACTOR_INVALID_CHARS "()[]<>{}!@#$^&*+=|\\/\"'?~"
#define RYGEL_MEDIA_EXPORT_EXTRACTOR_CONVERT_CHARS "\t_\\."
#define RYGEL_MEDIA_EXPORT_EXTRACTOR_BLOCK_PATTERN "%s[^%s]*%s"
#define UPNP_CLASS_VIDEO "object.item.videoItem"
#define UPNP_CLASS_PHOTO "object.item.imageItem.photo"
#define UPNP_CLASS_MUSIC "object.item.audioItem.musicTrack"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_EXTRACTOR_ERROR (extractor_error_get_type ())

#define RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR (rygel_media_export_extractor_get_type ())
#define RYGEL_MEDIA_EXPORT_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR, RygelMediaExportExtractor))
#define RYGEL_MEDIA_EXPORT_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR, RygelMediaExportExtractorClass))
#define RYGEL_MEDIA_EXPORT_IS_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_IS_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_EXTRACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR, RygelMediaExportExtractorClass))

typedef struct _RygelMediaExportExtractor RygelMediaExportExtractor;
typedef struct _RygelMediaExportExtractorClass RygelMediaExportExtractorClass;
typedef struct _RygelMediaExportExtractorPrivate RygelMediaExportExtractorPrivate;
enum  {
	RYGEL_MEDIA_EXPORT_EXTRACTOR_0_PROPERTY,
	RYGEL_MEDIA_EXPORT_EXTRACTOR_FILE_PROPERTY,
	RYGEL_MEDIA_EXPORT_EXTRACTOR_EXTRACT_METADATA_PROPERTY,
	RYGEL_MEDIA_EXPORT_EXTRACTOR_NUM_PROPERTIES
};
static GParamSpec* rygel_media_export_extractor_properties[RYGEL_MEDIA_EXPORT_EXTRACTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_dict_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_dict_unref (var), NULL)))

#define RYGEL_MEDIA_EXPORT_TYPE_DVD_PARSER (rygel_media_export_dvd_parser_get_type ())
#define RYGEL_MEDIA_EXPORT_DVD_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_DVD_PARSER, RygelMediaExportDVDParser))
#define RYGEL_MEDIA_EXPORT_DVD_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_DVD_PARSER, RygelMediaExportDVDParserClass))
#define RYGEL_MEDIA_EXPORT_IS_DVD_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_DVD_PARSER))
#define RYGEL_MEDIA_EXPORT_IS_DVD_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_DVD_PARSER))
#define RYGEL_MEDIA_EXPORT_DVD_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_DVD_PARSER, RygelMediaExportDVDParserClass))

typedef struct _RygelMediaExportDVDParser RygelMediaExportDVDParser;
typedef struct _RygelMediaExportDVDParserClass RygelMediaExportDVDParserClass;

#define RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_EXTRACTOR (rygel_media_export_playlist_extractor_get_type ())
#define RYGEL_MEDIA_EXPORT_PLAYLIST_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_EXTRACTOR, RygelMediaExportPlaylistExtractor))
#define RYGEL_MEDIA_EXPORT_PLAYLIST_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_EXTRACTOR, RygelMediaExportPlaylistExtractorClass))
#define RYGEL_MEDIA_EXPORT_IS_PLAYLIST_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_IS_PLAYLIST_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_PLAYLIST_EXTRACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_EXTRACTOR, RygelMediaExportPlaylistExtractorClass))

typedef struct _RygelMediaExportPlaylistExtractor RygelMediaExportPlaylistExtractor;
typedef struct _RygelMediaExportPlaylistExtractorClass RygelMediaExportPlaylistExtractorClass;

#define RYGEL_MEDIA_EXPORT_TYPE_IMAGE_EXTRACTOR (rygel_media_export_image_extractor_get_type ())
#define RYGEL_MEDIA_EXPORT_IMAGE_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_IMAGE_EXTRACTOR, RygelMediaExportImageExtractor))
#define RYGEL_MEDIA_EXPORT_IMAGE_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_IMAGE_EXTRACTOR, RygelMediaExportImageExtractorClass))
#define RYGEL_MEDIA_EXPORT_IS_IMAGE_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_IMAGE_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_IS_IMAGE_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_IMAGE_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_IMAGE_EXTRACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_IMAGE_EXTRACTOR, RygelMediaExportImageExtractorClass))

typedef struct _RygelMediaExportImageExtractor RygelMediaExportImageExtractor;
typedef struct _RygelMediaExportImageExtractorClass RygelMediaExportImageExtractorClass;

#define RYGEL_MEDIA_EXPORT_TYPE_GENERIC_EXTRACTOR (rygel_media_export_generic_extractor_get_type ())
#define RYGEL_MEDIA_EXPORT_GENERIC_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_GENERIC_EXTRACTOR, RygelMediaExportGenericExtractor))
#define RYGEL_MEDIA_EXPORT_GENERIC_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_GENERIC_EXTRACTOR, RygelMediaExportGenericExtractorClass))
#define RYGEL_MEDIA_EXPORT_IS_GENERIC_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_GENERIC_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_IS_GENERIC_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_GENERIC_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_GENERIC_EXTRACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_GENERIC_EXTRACTOR, RygelMediaExportGenericExtractorClass))

typedef struct _RygelMediaExportGenericExtractor RygelMediaExportGenericExtractor;
typedef struct _RygelMediaExportGenericExtractorClass RygelMediaExportGenericExtractorClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _RygelMediaExportExtractorRunData RygelMediaExportExtractorRunData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

typedef enum  {
	EXTRACTOR_ERROR_GENERAL,
	EXTRACTOR_ERROR_INVALID
} ExtractorError;
#define EXTRACTOR_ERROR extractor_error_quark ()

struct _RygelMediaExportExtractor {
	GObject parent_instance;
	RygelMediaExportExtractorPrivate * priv;
	GVariantDict* serialized_info;
};

struct _RygelMediaExportExtractorClass {
	GObjectClass parent_class;
	void (*run) (RygelMediaExportExtractor* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_finish) (RygelMediaExportExtractor* self, GAsyncResult* _res_, GError** error);
};

struct _RygelMediaExportExtractorPrivate {
	GFile* _file;
	gboolean _extract_metadata;
};

struct _RygelMediaExportExtractorRunData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelMediaExportExtractor* self;
	GFileInfo* file_info;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	gchar* display_name;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gchar* title;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GVariantDict* _tmp7_;
	const gchar* _tmp8_;
	GVariantDict* _tmp9_;
	const gchar* _tmp10_;
	guint64 mtime;
	GVariantDict* _tmp11_;
	GDateTime* dt;
	GDateTime* _tmp12_;
	gchar* date;
	GDateTime* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GVariantDict* _tmp18_;
	const gchar* _tmp19_;
	gchar* content_type;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gboolean _tmp22_;
	const gchar* _tmp23_;
	GVariantDict* _tmp24_;
	const gchar* _tmp25_;
	GVariantDict* _tmp26_;
	gboolean _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	GVariantDict* _tmp30_;
	GVariantDict* _tmp31_;
	const gchar* _tmp32_;
	GVariantDict* _tmp33_;
	gchar* id;
	GFile* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GVariantDict* _tmp39_;
	const gchar* _tmp40_;
	GVariantDict* _tmp41_;
	GFile* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GError* _inner_error0_;
};

static gint RygelMediaExportExtractor_private_offset;
static gpointer rygel_media_export_extractor_parent_class = NULL;
static GRegex* rygel_media_export_extractor_char_remove_regex;
static GRegex* rygel_media_export_extractor_char_remove_regex = NULL;
static GRegex* rygel_media_export_extractor_char_convert_regex;
static GRegex* rygel_media_export_extractor_char_convert_regex = NULL;
static GRegex* rygel_media_export_extractor_space_compress_regex;
static GRegex* rygel_media_export_extractor_space_compress_regex = NULL;
static GRegex** rygel_media_export_extractor_block_regexes;
static gint rygel_media_export_extractor_block_regexes_length1;
static GRegex** rygel_media_export_extractor_block_regexes = NULL;
static gint rygel_media_export_extractor_block_regexes_length1 = 0;
static gint _rygel_media_export_extractor_block_regexes_size_ = 0;
static GRegex** rygel_media_export_extractor_blacklist_regexes;
static gint rygel_media_export_extractor_blacklist_regexes_length1;
static GRegex** rygel_media_export_extractor_blacklist_regexes = NULL;
static gint rygel_media_export_extractor_blacklist_regexes_length1 = 0;
static gint _rygel_media_export_extractor_blacklist_regexes_size_ = 0;
static GRegex** rygel_media_export_extractor_video_suffix_regexes;
static gint rygel_media_export_extractor_video_suffix_regexes_length1;
static GRegex** rygel_media_export_extractor_video_suffix_regexes = NULL;
static gint rygel_media_export_extractor_video_suffix_regexes_length1 = 0;
static gint _rygel_media_export_extractor_video_suffix_regexes_size_ = 0;

VALA_EXTERN GQuark extractor_error_quark (void);
VALA_EXTERN GType extractor_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_media_export_extractor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaExportExtractor, g_object_unref)
VALA_EXTERN void rygel_media_export_extractor_run (RygelMediaExportExtractor* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
VALA_EXTERN void rygel_media_export_extractor_run_finish (RygelMediaExportExtractor* self,
                                              GAsyncResult* _res_,
                                              GError** error);
VALA_EXTERN RygelMediaExportExtractor* rygel_media_export_extractor_create_for_file (GFile* file,
                                                                         const gchar* content_type,
                                                                         gboolean extract_metadata);
static RygelMediaExportExtractor* rygel_media_export_extractor_new (GFile* file,
                                                             gboolean extract_metadata);
static RygelMediaExportExtractor* rygel_media_export_extractor_construct (GType object_type,
                                                                   GFile* file,
                                                                   gboolean extract_metadata);
VALA_EXTERN RygelMediaExportDVDParser* rygel_media_export_dvd_parser_new (GFile* file);
VALA_EXTERN RygelMediaExportDVDParser* rygel_media_export_dvd_parser_construct (GType object_type,
                                                                    GFile* file);
VALA_EXTERN GType rygel_media_export_dvd_parser_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaExportDVDParser, g_object_unref)
VALA_EXTERN RygelMediaExportPlaylistExtractor* rygel_media_export_playlist_extractor_new (GFile* file);
VALA_EXTERN RygelMediaExportPlaylistExtractor* rygel_media_export_playlist_extractor_construct (GType object_type,
                                                                                    GFile* file);
VALA_EXTERN GType rygel_media_export_playlist_extractor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaExportPlaylistExtractor, g_object_unref)
VALA_EXTERN RygelMediaExportImageExtractor* rygel_media_export_image_extractor_new (GFile* file);
VALA_EXTERN RygelMediaExportImageExtractor* rygel_media_export_image_extractor_construct (GType object_type,
                                                                              GFile* file);
VALA_EXTERN GType rygel_media_export_image_extractor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaExportImageExtractor, g_object_unref)
VALA_EXTERN RygelMediaExportGenericExtractor* rygel_media_export_generic_extractor_new (GFile* file);
VALA_EXTERN RygelMediaExportGenericExtractor* rygel_media_export_generic_extractor_construct (GType object_type,
                                                                                  GFile* file);
VALA_EXTERN GType rygel_media_export_generic_extractor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaExportGenericExtractor, g_object_unref)
static void rygel_media_export_extractor_real_constructed (GObject* base);
static void rygel_media_export_extractor_real_run_data_free (gpointer _data);
static void rygel_media_export_extractor_real_run (RygelMediaExportExtractor* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static gboolean rygel_media_export_extractor_real_run_co (RygelMediaExportExtractorRunData* _data_);
VALA_EXTERN GFile* rygel_media_export_extractor_get_file (RygelMediaExportExtractor* self);
static void rygel_media_export_extractor_run_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
VALA_EXTERN gboolean rygel_media_export_extractor_get_extract_metadata (RygelMediaExportExtractor* self);
static gchar* rygel_media_export_extractor_strip_invalid_entities (RygelMediaExportExtractor* self,
                                                            const gchar* original);
VALA_EXTERN GVariant* rygel_media_export_extractor_get (RygelMediaExportExtractor* self);
static void _vala_array_add1 (GRegex** * array,
                       gint* length,
                       gint* size,
                       GRegex* value);
static void _vala_array_add2 (GRegex** * array,
                       gint* length,
                       gint* size,
                       GRegex* value);
static void _vala_array_add3 (GRegex** * array,
                       gint* length,
                       gint* size,
                       GRegex* value);
VALA_EXTERN void rygel_media_export_extractor_set_file (RygelMediaExportExtractor* self,
                                            GFile* value);
VALA_EXTERN void rygel_media_export_extractor_set_extract_metadata (RygelMediaExportExtractor* self,
                                                        gboolean value);
static void rygel_media_export_extractor_finalize (GObject * obj);
static GType rygel_media_export_extractor_get_type_once (void);
static void _vala_rygel_media_export_extractor_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_rygel_media_export_extractor_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* RYGEL_MEDIA_EXPORT_EXTRACTOR_BLOCKS[4] = {"()", "{}", "[]", "<>"};
static const gchar* RYGEL_MEDIA_EXPORT_EXTRACTOR_BLACKLIST[14] = {"720p", "1080p", "x264", "ws", "proper", "real.repack", "repack", "hdtv", "pdtv", "notv", "dsr", "DVDRip", "divx", "xvid"};
static const gchar* RYGEL_MEDIA_EXPORT_EXTRACTOR_VIDEO_SUFFIXES[22] = {"webm", "mkv", "flv", "ogv", "ogg", "avi", "mov", "wmv", "mp4", "m4v", "mpeg", "mpg", "iso", "mp3", "m4a", "png", "jpg", "jpeg", "ogv", "oga", "3gp", "xml"};

GQuark
extractor_error_quark (void)
{
	return g_quark_from_static_string ("extractor-error-quark");
}

 G_GNUC_NO_INLINE static GType
extractor_error_get_type_once (void)
{
	static const GEnumValue values[] = {{EXTRACTOR_ERROR_GENERAL, "EXTRACTOR_ERROR_GENERAL", "general"}, {EXTRACTOR_ERROR_INVALID, "EXTRACTOR_ERROR_INVALID", "invalid"}, {0, NULL, NULL}};
	GType extractor_error_type_id;
	extractor_error_type_id = g_enum_register_static ("ExtractorError", values);
	return extractor_error_type_id;
}

GType
extractor_error_get_type (void)
{
	static volatile gsize extractor_error_type_id__once = 0;
	if (g_once_init_enter (&extractor_error_type_id__once)) {
		GType extractor_error_type_id;
		extractor_error_type_id = extractor_error_get_type_once ();
		g_once_init_leave (&extractor_error_type_id__once, extractor_error_type_id);
	}
	return extractor_error_type_id__once;
}

static inline gpointer
rygel_media_export_extractor_get_instance_private (RygelMediaExportExtractor* self)
{
	return G_STRUCT_MEMBER_P (self, RygelMediaExportExtractor_private_offset);
}

/**
     * Factory method for creating specific extractors depending on the
     * content type of the file
     */
RygelMediaExportExtractor*
rygel_media_export_extractor_create_for_file (GFile* file,
                                              const gchar* content_type,
                                              gboolean extract_metadata)
{
	gboolean _tmp1_ = FALSE;
	gboolean is_text = FALSE;
	gboolean _tmp4_ = FALSE;
	RygelMediaExportGenericExtractor* _tmp6_;
	RygelMediaExportExtractor* result;
#line 62 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 62 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_val_if_fail (content_type != NULL, NULL);
#line 65 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (!extract_metadata) {
#line 377 "rygel-media-export-extractor.c"
		RygelMediaExportExtractor* _tmp0_;
#line 66 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp0_ = rygel_media_export_extractor_new (file, FALSE);
#line 66 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		result = _tmp0_;
#line 66 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		return result;
#line 385 "rygel-media-export-extractor.c"
	}
#line 69 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (g_str_has_prefix (content_type, "text/")) {
#line 69 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp1_ = TRUE;
#line 391 "rygel-media-export-extractor.c"
	} else {
#line 70 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp1_ = g_str_has_suffix (content_type, "xml");
#line 395 "rygel-media-export-extractor.c"
	}
#line 69 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	is_text = _tmp1_;
#line 71 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (g_strcmp0 (content_type, "application/x-cd-image") == 0) {
#line 401 "rygel-media-export-extractor.c"
		RygelMediaExportDVDParser* _tmp2_;
#line 72 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp2_ = rygel_media_export_dvd_parser_new (file);
#line 72 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		result = (RygelMediaExportExtractor*) _tmp2_;
#line 72 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		return result;
#line 409 "rygel-media-export-extractor.c"
	}
#line 75 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (is_text) {
#line 413 "rygel-media-export-extractor.c"
		RygelMediaExportPlaylistExtractor* _tmp3_;
#line 76 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp3_ = rygel_media_export_playlist_extractor_new (file);
#line 76 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		result = (RygelMediaExportExtractor*) _tmp3_;
#line 76 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		return result;
#line 421 "rygel-media-export-extractor.c"
	}
#line 79 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (g_strcmp0 (content_type, "image/jpeg") == 0) {
#line 79 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp4_ = TRUE;
#line 427 "rygel-media-export-extractor.c"
	} else {
#line 80 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp4_ = g_strcmp0 (content_type, "image/png") == 0;
#line 431 "rygel-media-export-extractor.c"
	}
#line 79 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (_tmp4_) {
#line 435 "rygel-media-export-extractor.c"
		RygelMediaExportImageExtractor* _tmp5_;
#line 81 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp5_ = rygel_media_export_image_extractor_new (file);
#line 81 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		result = (RygelMediaExportExtractor*) _tmp5_;
#line 81 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		return result;
#line 443 "rygel-media-export-extractor.c"
	}
#line 84 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp6_ = rygel_media_export_generic_extractor_new (file);
#line 84 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	result = (RygelMediaExportExtractor*) _tmp6_;
#line 84 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return result;
#line 451 "rygel-media-export-extractor.c"
}

static RygelMediaExportExtractor*
rygel_media_export_extractor_construct (GType object_type,
                                        GFile* file,
                                        gboolean extract_metadata)
{
	RygelMediaExportExtractor * self = NULL;
#line 87 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 88 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	self = (RygelMediaExportExtractor*) g_object_new (object_type, "file", file, "extract-metadata", extract_metadata, NULL);
#line 87 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return self;
#line 466 "rygel-media-export-extractor.c"
}

static RygelMediaExportExtractor*
rygel_media_export_extractor_new (GFile* file,
                                  gboolean extract_metadata)
{
#line 87 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return rygel_media_export_extractor_construct (RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR, file, extract_metadata);
#line 475 "rygel-media-export-extractor.c"
}

static void
rygel_media_export_extractor_real_constructed (GObject* base)
{
	RygelMediaExportExtractor * self;
	GVariantDict* _tmp0_;
#line 91 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	self = (RygelMediaExportExtractor*) base;
#line 92 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp0_ = g_variant_dict_new (NULL);
#line 92 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_variant_dict_unref0 (self->serialized_info);
#line 92 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	self->serialized_info = _tmp0_;
#line 491 "rygel-media-export-extractor.c"
}

static void
rygel_media_export_extractor_real_run_data_free (gpointer _data)
{
	RygelMediaExportExtractorRunData* _data_;
	_data_ = _data;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_slice_free (RygelMediaExportExtractorRunData, _data_);
#line 503 "rygel-media-export-extractor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return self ? g_object_ref (self) : NULL;
#line 511 "rygel-media-export-extractor.c"
}

static void
rygel_media_export_extractor_real_run (RygelMediaExportExtractor* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	RygelMediaExportExtractorRunData* _data_;
	RygelMediaExportExtractor* _tmp0_;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_ = g_slice_new0 (RygelMediaExportExtractorRunData);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_media_export_extractor_real_run_data_free);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->self = _tmp0_;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	rygel_media_export_extractor_real_run_co (_data_);
#line 533 "rygel-media-export-extractor.c"
}

static void
rygel_media_export_extractor_real_run_finish (RygelMediaExportExtractor* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	RygelMediaExportExtractorRunData* _data_;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (NULL == _data_) {
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		return;
#line 548 "rygel-media-export-extractor.c"
	}
}

static void
rygel_media_export_extractor_run_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	RygelMediaExportExtractorRunData* _data_;
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_ = _user_data_;
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_source_object_ = source_object;
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_res_ = _res_;
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	rygel_media_export_extractor_real_run_co (_data_);
#line 566 "rygel-media-export-extractor.c"
}

static gboolean
rygel_media_export_extractor_real_run_co (RygelMediaExportExtractorRunData* _data_)
{
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	switch (_data_->_state_) {
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		case 0:
#line 576 "rygel-media-export-extractor.c"
		goto _state_0;
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		case 1:
#line 580 "rygel-media-export-extractor.c"
		goto _state_1;
		default:
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_assert_not_reached ();
#line 585 "rygel-media-export-extractor.c"
	}
	_state_0:
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp0_ = _data_->self->priv->_file;
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_state_ = 1;
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_file_query_info_async (_data_->_tmp0_, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_TIME_MODIFIED "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, rygel_media_export_extractor_run_ready, _data_);
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return FALSE;
#line 596 "rygel-media-export-extractor.c"
	_state_1:
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp1_ = g_file_query_info_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->file_info = _data_->_tmp1_;
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_object_unref (_data_->_async_result);
#line 96 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		return FALSE;
#line 610 "rygel-media-export-extractor.c"
	}
#line 102 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp2_ = g_file_info_get_display_name (_data_->file_info);
#line 102 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp3_ = g_strdup (_data_->_tmp2_);
#line 102 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->display_name = _data_->_tmp3_;
#line 104 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp4_ = _data_->self->priv->_extract_metadata;
#line 104 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (_data_->_tmp4_) {
#line 105 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_data_->_tmp5_ = _data_->display_name;
#line 105 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_data_->_tmp6_ = rygel_media_export_extractor_strip_invalid_entities (_data_->self, _data_->_tmp5_);
#line 105 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_data_->title = _data_->_tmp6_;
#line 106 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_data_->_tmp7_ = _data_->self->serialized_info;
#line 106 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_data_->_tmp8_ = _data_->title;
#line 106 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_variant_dict_insert (_data_->_tmp7_, RYGEL_MEDIA_EXPORT_SERIALIZER_TITLE, "s", _data_->_tmp8_, NULL);
#line 104 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_free0 (_data_->title);
#line 636 "rygel-media-export-extractor.c"
	} else {
#line 108 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_data_->_tmp9_ = _data_->self->serialized_info;
#line 108 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_data_->_tmp10_ = _data_->display_name;
#line 108 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_variant_dict_insert (_data_->_tmp9_, RYGEL_MEDIA_EXPORT_SERIALIZER_TITLE, "s", _data_->_tmp10_, NULL);
#line 644 "rygel-media-export-extractor.c"
	}
#line 111 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->mtime = g_file_info_get_attribute_uint64 (_data_->file_info, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 112 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp11_ = _data_->self->serialized_info;
#line 112 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_variant_dict_insert (_data_->_tmp11_, RYGEL_MEDIA_EXPORT_SERIALIZER_MODIFIED, "t", _data_->mtime, NULL);
#line 114 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp12_ = g_date_time_new_from_unix_utc ((gint64) _data_->mtime);
#line 114 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->dt = _data_->_tmp12_;
#line 115 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp13_ = _data_->dt;
#line 115 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp14_ = g_date_time_format (_data_->_tmp13_, "%Y-%m-%dT%H:%M:%S");
#line 115 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 115 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp16_ = g_strdup_printf ("%sZ", _data_->_tmp15_);
#line 115 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 115 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (_data_->_tmp15_);
#line 115 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->date = _data_->_tmp17_;
#line 116 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp18_ = _data_->self->serialized_info;
#line 116 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp19_ = _data_->date;
#line 116 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_variant_dict_insert (_data_->_tmp18_, RYGEL_MEDIA_EXPORT_SERIALIZER_DATE, "s", _data_->_tmp19_, NULL);
#line 118 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp20_ = g_file_info_get_content_type (_data_->file_info);
#line 118 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp21_ = g_content_type_get_mime_type (_data_->_tmp20_);
#line 118 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->content_type = _data_->_tmp21_;
#line 122 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp22_ = _data_->self->priv->_extract_metadata;
#line 122 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (!_data_->_tmp22_) {
#line 123 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_data_->_tmp23_ = _data_->content_type;
#line 123 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		if (g_str_has_prefix (_data_->_tmp23_, "video/")) {
#line 124 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_data_->_tmp24_ = _data_->self->serialized_info;
#line 124 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_variant_dict_insert (_data_->_tmp24_, RYGEL_MEDIA_EXPORT_SERIALIZER_UPNP_CLASS, "s", UPNP_CLASS_VIDEO, NULL);
#line 694 "rygel-media-export-extractor.c"
		} else {
#line 125 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_data_->_tmp25_ = _data_->content_type;
#line 125 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			if (g_str_has_prefix (_data_->_tmp25_, "image/")) {
#line 126 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_data_->_tmp26_ = _data_->self->serialized_info;
#line 126 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				g_variant_dict_insert (_data_->_tmp26_, RYGEL_MEDIA_EXPORT_SERIALIZER_UPNP_CLASS, "s", UPNP_CLASS_PHOTO, NULL);
#line 704 "rygel-media-export-extractor.c"
			} else {
#line 127 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_data_->_tmp28_ = _data_->content_type;
#line 127 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				if (g_str_has_prefix (_data_->_tmp28_, "audio/")) {
#line 127 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_data_->_tmp27_ = TRUE;
#line 712 "rygel-media-export-extractor.c"
				} else {
#line 127 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_data_->_tmp29_ = _data_->content_type;
#line 127 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_data_->_tmp27_ = g_strcmp0 (_data_->_tmp29_, "application/ogg") == 0;
#line 718 "rygel-media-export-extractor.c"
				}
#line 127 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				if (_data_->_tmp27_) {
#line 128 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_data_->_tmp30_ = _data_->self->serialized_info;
#line 128 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					g_variant_dict_insert (_data_->_tmp30_, RYGEL_MEDIA_EXPORT_SERIALIZER_UPNP_CLASS, "s", UPNP_CLASS_MUSIC, NULL);
#line 726 "rygel-media-export-extractor.c"
				} else {
				}
			}
		}
	}
#line 134 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp31_ = _data_->self->serialized_info;
#line 134 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp32_ = _data_->content_type;
#line 134 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_variant_dict_insert (_data_->_tmp31_, RYGEL_MEDIA_EXPORT_SERIALIZER_MIME_TYPE, "s", _data_->_tmp32_, NULL);
#line 135 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp33_ = _data_->self->serialized_info;
#line 135 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_variant_dict_insert (_data_->_tmp33_, RYGEL_MEDIA_EXPORT_SERIALIZER_SIZE, "t", g_file_info_get_size (_data_->file_info), NULL);
#line 136 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp34_ = _data_->self->priv->_file;
#line 136 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp35_ = g_file_get_uri (_data_->_tmp34_);
#line 136 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 136 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp37_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, _data_->_tmp36_, (gsize) -1);
#line 136 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 136 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (_data_->_tmp36_);
#line 136 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->id = _data_->_tmp38_;
#line 138 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp39_ = _data_->self->serialized_info;
#line 138 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp40_ = _data_->id;
#line 138 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_variant_dict_insert (_data_->_tmp39_, RYGEL_MEDIA_EXPORT_SERIALIZER_ID, "s", _data_->_tmp40_, NULL);
#line 139 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp41_ = _data_->self->serialized_info;
#line 139 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp42_ = _data_->self->priv->_file;
#line 139 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp43_ = g_file_get_uri (_data_->_tmp42_);
#line 139 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 139 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_variant_dict_insert (_data_->_tmp41_, RYGEL_MEDIA_EXPORT_SERIALIZER_URI, "s", _data_->_tmp44_, NULL);
#line 139 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (_data_->_tmp44_);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (_data_->id);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (_data_->content_type);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (_data_->date);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_date_time_unref0 (_data_->dt);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (_data_->display_name);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_object_unref0 (_data_->file_info);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (_data_->_state_ != 0) {
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 794 "rygel-media-export-extractor.c"
		}
	}
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_object_unref (_data_->_async_result);
#line 95 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return FALSE;
#line 801 "rygel-media-export-extractor.c"
}

void
rygel_media_export_extractor_run (RygelMediaExportExtractor* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	RygelMediaExportExtractorClass* _klass_;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_klass_ = RYGEL_MEDIA_EXPORT_EXTRACTOR_GET_CLASS (self);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (_klass_->run) {
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_klass_->run (self, _callback_, _user_data_);
#line 816 "rygel-media-export-extractor.c"
	}
}

void
rygel_media_export_extractor_run_finish (RygelMediaExportExtractor* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	RygelMediaExportExtractorClass* _klass_;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_klass_ = RYGEL_MEDIA_EXPORT_EXTRACTOR_GET_CLASS (self);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (_klass_->run_finish) {
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_klass_->run_finish (self, _res_, error);
#line 832 "rygel-media-export-extractor.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 852 "rygel-media-export-extractor.c"
}

GVariant*
rygel_media_export_extractor_get (RygelMediaExportExtractor* self)
{
	GVariant* date = NULL;
	GVariantDict* _tmp0_;
	const GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	const gchar* _tmp4_;
	GVariantDict* _tmp12_;
	GVariant* _tmp13_;
	GVariant* result;
#line 142 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp0_ = self->serialized_info;
#line 145 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp1_ = G_VARIANT_TYPE_STRING;
#line 145 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp2_ = g_variant_dict_lookup_value (_tmp0_, RYGEL_MEDIA_EXPORT_SERIALIZER_DATE, _tmp1_);
#line 145 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	date = _tmp2_;
#line 147 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp3_ = date;
#line 147 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp4_ = g_variant_get_string (_tmp3_, NULL);
#line 147 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (string_contains (_tmp4_, "T")) {
#line 883 "rygel-media-export-extractor.c"
		GDateTime* fixed_date = NULL;
		GVariant* _tmp5_;
		const gchar* _tmp6_;
		GDateTime* _tmp7_;
		gchar* new_date = NULL;
		GDateTime* _tmp8_;
		gchar* _tmp9_;
		GVariantDict* _tmp10_;
		const gchar* _tmp11_;
#line 148 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp5_ = date;
#line 148 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp6_ = g_variant_get_string (_tmp5_, NULL);
#line 148 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp7_ = g_date_time_new_from_iso8601 (_tmp6_, NULL);
#line 148 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		fixed_date = _tmp7_;
#line 149 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp8_ = fixed_date;
#line 149 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp9_ = gupnp_format_date_time_for_didl_lite (_tmp8_, FALSE);
#line 149 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		new_date = _tmp9_;
#line 151 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp10_ = self->serialized_info;
#line 151 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp11_ = new_date;
#line 151 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_variant_dict_insert (_tmp10_, RYGEL_MEDIA_EXPORT_SERIALIZER_DATE, "s", _tmp11_, NULL);
#line 147 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_free0 (new_date);
#line 147 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_date_time_unref0 (fixed_date);
#line 917 "rygel-media-export-extractor.c"
	}
#line 154 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp12_ = self->serialized_info;
#line 154 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp13_ = g_variant_dict_end (_tmp12_);
#line 154 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_variant_ref_sink (_tmp13_);
#line 154 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	result = _tmp13_;
#line 154 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_variant_unref0 (date);
#line 154 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return result;
#line 931 "rygel-media-export-extractor.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 948 "rygel-media-export-extractor.c"
}

static void
_vala_array_add1 (GRegex** * array,
                  gint* length,
                  gint* size,
                  GRegex* value)
{
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if ((*length) == (*size)) {
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		*array = g_renew (GRegex*, *array, (*size) + 1);
#line 963 "rygel-media-export-extractor.c"
	}
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	(*array)[(*length)++] = value;
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	(*array)[*length] = NULL;
#line 969 "rygel-media-export-extractor.c"
}

static void
_vala_array_add2 (GRegex** * array,
                  gint* length,
                  gint* size,
                  GRegex* value)
{
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if ((*length) == (*size)) {
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		*array = g_renew (GRegex*, *array, (*size) + 1);
#line 984 "rygel-media-export-extractor.c"
	}
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	(*array)[(*length)++] = value;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	(*array)[*length] = NULL;
#line 990 "rygel-media-export-extractor.c"
}

static gpointer
_g_regex_ref0 (gpointer self)
{
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return self ? g_regex_ref (self) : NULL;
#line 998 "rygel-media-export-extractor.c"
}

static void
_vala_array_add3 (GRegex** * array,
                  gint* length,
                  gint* size,
                  GRegex* value)
{
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if ((*length) == (*size)) {
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		*array = g_renew (GRegex*, *array, (*size) + 1);
#line 1013 "rygel-media-export-extractor.c"
	}
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	(*array)[(*length)++] = value;
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	(*array)[*length] = NULL;
#line 1019 "rygel-media-export-extractor.c"
}

static gchar*
rygel_media_export_extractor_strip_invalid_entities (RygelMediaExportExtractor* self,
                                                     const gchar* original)
{
	GRegex* _tmp0_;
	gchar* p = NULL;
	gchar* _tmp56_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 157 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 157 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_val_if_fail (original != NULL, NULL);
#line 158 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp0_ = rygel_media_export_extractor_char_remove_regex;
#line 158 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (_tmp0_ == NULL) {
#line 1039 "rygel-media-export-extractor.c"
		{
			gchar* regex_string = NULL;
			gchar* _tmp1_;
			GRegex* _tmp2_ = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GRegex* _tmp6_;
			GRegex* _tmp7_;
			GRegex* _tmp8_;
			gchar* _tmp9_;
			GRegex* _tmp10_ = NULL;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GRegex* _tmp14_;
			GRegex* _tmp15_;
			GRegex* _tmp16_;
			GRegex* _tmp17_ = NULL;
			GRegex* _tmp18_;
			GRegex* _tmp19_;
			GRegex** _tmp20_;
#line 160 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp1_ = g_regex_escape_string (RYGEL_MEDIA_EXPORT_EXTRACTOR_INVALID_CHARS, -1);
#line 160 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			regex_string = _tmp1_;
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp3_ = regex_string;
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp4_ = g_strdup_printf ("[%s]", _tmp3_);
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp5_ = _tmp4_;
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp6_ = g_regex_new (_tmp5_, 0, 0, &_inner_error0_);
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp7_ = _tmp6_;
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (_tmp5_);
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp2_ = _tmp7_;
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_g_free0 (regex_string);
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1086 "rygel-media-export-extractor.c"
					goto __catch0_g_regex_error;
				}
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				g_clear_error (&_inner_error0_);
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				return NULL;
#line 1095 "rygel-media-export-extractor.c"
			}
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp8_ = _tmp2_;
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp2_ = NULL;
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_regex_unref0 (rygel_media_export_extractor_char_remove_regex);
#line 161 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			rygel_media_export_extractor_char_remove_regex = _tmp8_;
#line 162 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp9_ = g_regex_escape_string (RYGEL_MEDIA_EXPORT_EXTRACTOR_CONVERT_CHARS, -1);
#line 162 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (regex_string);
#line 162 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			regex_string = _tmp9_;
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp11_ = regex_string;
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp12_ = g_strdup_printf ("[%s]", _tmp11_);
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp13_ = _tmp12_;
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp14_ = g_regex_new (_tmp13_, 0, 0, &_inner_error0_);
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp15_ = _tmp14_;
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (_tmp13_);
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp10_ = _tmp15_;
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_g_regex_unref0 (_tmp2_);
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_g_free0 (regex_string);
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1133 "rygel-media-export-extractor.c"
					goto __catch0_g_regex_error;
				}
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				g_clear_error (&_inner_error0_);
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				return NULL;
#line 1142 "rygel-media-export-extractor.c"
			}
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp16_ = _tmp10_;
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp10_ = NULL;
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_regex_unref0 (rygel_media_export_extractor_char_convert_regex);
#line 163 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			rygel_media_export_extractor_char_convert_regex = _tmp16_;
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp18_ = g_regex_new ("\\s+", 0, 0, &_inner_error0_);
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp17_ = _tmp18_;
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_g_regex_unref0 (_tmp10_);
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_g_regex_unref0 (_tmp2_);
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_g_free0 (regex_string);
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1166 "rygel-media-export-extractor.c"
					goto __catch0_g_regex_error;
				}
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				g_clear_error (&_inner_error0_);
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				return NULL;
#line 1175 "rygel-media-export-extractor.c"
			}
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp19_ = _tmp17_;
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp17_ = NULL;
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_regex_unref0 (rygel_media_export_extractor_space_compress_regex);
#line 164 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			rygel_media_export_extractor_space_compress_regex = _tmp19_;
#line 165 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_tmp20_ = g_new0 (GRegex*, 0 + 1);
#line 165 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			rygel_media_export_extractor_block_regexes = (_vala_array_free (rygel_media_export_extractor_block_regexes, rygel_media_export_extractor_block_regexes_length1, (GDestroyNotify) g_regex_unref), NULL);
#line 165 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			rygel_media_export_extractor_block_regexes = _tmp20_;
#line 165 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			rygel_media_export_extractor_block_regexes_length1 = 0;
#line 165 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_rygel_media_export_extractor_block_regexes_size_ = rygel_media_export_extractor_block_regexes_length1;
#line 1195 "rygel-media-export-extractor.c"
			{
				const gchar** block_collection = NULL;
				gint block_collection_length1 = 0;
				gint _block_collection_size_ = 0;
				gint block_it = 0;
#line 167 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				block_collection = RYGEL_MEDIA_EXPORT_EXTRACTOR_BLOCKS;
#line 167 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				block_collection_length1 = G_N_ELEMENTS (RYGEL_MEDIA_EXPORT_EXTRACTOR_BLOCKS);
#line 167 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
#line 1207 "rygel-media-export-extractor.c"
					const gchar* block = NULL;
#line 167 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					block = block_collection[block_it];
#line 1211 "rygel-media-export-extractor.c"
					{
						gchar* block_re = NULL;
						const gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						const gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
						GRegex* _tmp38_ = NULL;
						const gchar* _tmp39_;
						GRegex* _tmp40_;
						GRegex* _tmp41_;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp21_ = block;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp22_ = g_strdup_printf ("%C", string_get (_tmp21_, (glong) 0));
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp23_ = _tmp22_;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp24_ = g_regex_escape_string (_tmp23_, -1);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp25_ = _tmp24_;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp26_ = block;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp27_ = g_strdup_printf ("%C", string_get (_tmp26_, (glong) 1));
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp28_ = _tmp27_;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp29_ = g_regex_escape_string (_tmp28_, -1);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp30_ = _tmp29_;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp31_ = block;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp32_ = g_strdup_printf ("%C", string_get (_tmp31_, (glong) 1));
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp33_ = _tmp32_;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp34_ = g_regex_escape_string (_tmp33_, -1);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp35_ = _tmp34_;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp36_ = g_strdup_printf (RYGEL_MEDIA_EXPORT_EXTRACTOR_BLOCK_PATTERN, _tmp25_, _tmp30_, _tmp35_);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp37_ = _tmp36_;
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (_tmp35_);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (_tmp33_);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (_tmp30_);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (_tmp28_);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (_tmp25_);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (_tmp23_);
#line 168 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						block_re = _tmp37_;
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp39_ = block_re;
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp40_ = g_regex_new (_tmp39_, 0, 0, &_inner_error0_);
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp38_ = _tmp40_;
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_free0 (block_re);
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp17_);
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp10_);
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp2_);
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_free0 (regex_string);
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1303 "rygel-media-export-extractor.c"
								goto __catch0_g_regex_error;
							}
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							g_clear_error (&_inner_error0_);
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							return NULL;
#line 1312 "rygel-media-export-extractor.c"
						}
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp41_ = _tmp38_;
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp38_ = NULL;
#line 172 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_vala_array_add1 (&rygel_media_export_extractor_block_regexes, &rygel_media_export_extractor_block_regexes_length1, &_rygel_media_export_extractor_block_regexes_size_, _tmp41_);
#line 167 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_regex_unref0 (_tmp38_);
#line 167 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (block_re);
#line 1324 "rygel-media-export-extractor.c"
					}
				}
			}
			{
				const gchar** blacklist_collection = NULL;
				gint blacklist_collection_length1 = 0;
				gint _blacklist_collection_size_ = 0;
				gint blacklist_it = 0;
#line 175 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				blacklist_collection = RYGEL_MEDIA_EXPORT_EXTRACTOR_BLACKLIST;
#line 175 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				blacklist_collection_length1 = G_N_ELEMENTS (RYGEL_MEDIA_EXPORT_EXTRACTOR_BLACKLIST);
#line 175 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				for (blacklist_it = 0; blacklist_it < blacklist_collection_length1; blacklist_it = blacklist_it + 1) {
#line 1339 "rygel-media-export-extractor.c"
					const gchar* blacklist = NULL;
#line 175 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					blacklist = blacklist_collection[blacklist_it];
#line 1343 "rygel-media-export-extractor.c"
					{
						GRegex* _tmp42_ = NULL;
						const gchar* _tmp43_;
						gchar* _tmp44_;
						gchar* _tmp45_;
						GRegex* _tmp46_;
						GRegex* _tmp47_;
						GRegex* _tmp48_;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp43_ = blacklist;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp44_ = g_regex_escape_string (_tmp43_, -1);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp45_ = _tmp44_;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp46_ = g_regex_new (_tmp45_, 0, 0, &_inner_error0_);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp47_ = _tmp46_;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (_tmp45_);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp42_ = _tmp47_;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp17_);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp10_);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp2_);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_free0 (regex_string);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1378 "rygel-media-export-extractor.c"
								goto __catch0_g_regex_error;
							}
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							g_clear_error (&_inner_error0_);
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							return NULL;
#line 1387 "rygel-media-export-extractor.c"
						}
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp48_ = _tmp42_;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp42_ = NULL;
#line 176 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_vala_array_add2 (&rygel_media_export_extractor_blacklist_regexes, &rygel_media_export_extractor_blacklist_regexes_length1, &_rygel_media_export_extractor_blacklist_regexes_size_, _tmp48_);
#line 175 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_regex_unref0 (_tmp42_);
#line 1397 "rygel-media-export-extractor.c"
					}
				}
			}
			{
				const gchar** suffix_collection = NULL;
				gint suffix_collection_length1 = 0;
				gint _suffix_collection_size_ = 0;
				gint suffix_it = 0;
#line 180 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				suffix_collection = RYGEL_MEDIA_EXPORT_EXTRACTOR_VIDEO_SUFFIXES;
#line 180 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				suffix_collection_length1 = G_N_ELEMENTS (RYGEL_MEDIA_EXPORT_EXTRACTOR_VIDEO_SUFFIXES);
#line 180 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				for (suffix_it = 0; suffix_it < suffix_collection_length1; suffix_it = suffix_it + 1) {
#line 1412 "rygel-media-export-extractor.c"
					const gchar* suffix = NULL;
#line 180 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					suffix = suffix_collection[suffix_it];
#line 1416 "rygel-media-export-extractor.c"
					{
						GRegex* regex = NULL;
						const gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						GRegex* _tmp52_;
						GRegex* _tmp53_;
						GRegex* _tmp54_;
						GRegex* _tmp55_;
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp49_ = suffix;
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp50_ = g_regex_escape_string (_tmp49_, -1);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp51_ = _tmp50_;
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp52_ = g_regex_new (_tmp51_, G_REGEX_CASELESS, 0, &_inner_error0_);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp53_ = _tmp52_;
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (_tmp51_);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						regex = _tmp53_;
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp17_);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp10_);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_regex_unref0 (_tmp2_);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							_g_free0 (regex_string);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1452 "rygel-media-export-extractor.c"
								goto __catch0_g_regex_error;
							}
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							g_clear_error (&_inner_error0_);
#line 181 "../src/plugins/media-export/rygel-media-export-extractor.vala"
							return NULL;
#line 1461 "rygel-media-export-extractor.c"
						}
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp54_ = regex;
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_tmp55_ = _g_regex_ref0 (_tmp54_);
#line 184 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_vala_array_add3 (&rygel_media_export_extractor_video_suffix_regexes, &rygel_media_export_extractor_video_suffix_regexes_length1, &_rygel_media_export_extractor_video_suffix_regexes_size_, _tmp55_);
#line 180 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_regex_unref0 (regex);
#line 1471 "rygel-media-export-extractor.c"
					}
				}
			}
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_regex_unref0 (_tmp17_);
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_regex_unref0 (_tmp10_);
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_regex_unref0 (_tmp2_);
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (regex_string);
#line 1483 "rygel-media-export-extractor.c"
		}
		goto __finally0;
		__catch0_g_regex_error:
		{
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_clear_error (&_inner_error0_);
#line 187 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_assert_not_reached ();
#line 1492 "rygel-media-export-extractor.c"
		}
		__finally0:
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_clear_error (&_inner_error0_);
#line 159 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			return NULL;
#line 1503 "rygel-media-export-extractor.c"
		}
	}
#line 193 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp56_ = g_strdup (original);
#line 193 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (p);
#line 193 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	p = _tmp56_;
#line 1512 "rygel-media-export-extractor.c"
	{
		GRegex** _tmp57_;
		gint _tmp57__length1;
		GRegex** _tmp64_;
		gint _tmp64__length1;
		GRegex** _tmp71_;
		gint _tmp71__length1;
		gchar* _tmp78_ = NULL;
		GRegex* _tmp79_;
		const gchar* _tmp80_;
		gchar* _tmp81_;
		gchar* _tmp82_;
		gchar* _tmp83_ = NULL;
		GRegex* _tmp84_;
		const gchar* _tmp85_;
		gchar* _tmp86_;
		gchar* _tmp87_;
		gchar* _tmp88_ = NULL;
		GRegex* _tmp89_;
		const gchar* _tmp90_;
		gchar* _tmp91_;
		gchar* _tmp92_;
		const gchar* _tmp93_;
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp57_ = rygel_media_export_extractor_blacklist_regexes;
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp57__length1 = rygel_media_export_extractor_blacklist_regexes_length1;
#line 1540 "rygel-media-export-extractor.c"
		{
			GRegex** re_collection = NULL;
			gint re_collection_length1 = 0;
			gint _re_collection_size_ = 0;
			gint re_it = 0;
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			re_collection = _tmp57_;
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			re_collection_length1 = _tmp57__length1;
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			for (re_it = 0; re_it < re_collection_length1; re_it = re_it + 1) {
#line 1552 "rygel-media-export-extractor.c"
				GRegex* _tmp58_;
				GRegex* re = NULL;
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_tmp58_ = _g_regex_ref0 (re_collection[re_it]);
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				re = _tmp58_;
#line 1559 "rygel-media-export-extractor.c"
				{
					gchar* _tmp59_ = NULL;
					GRegex* _tmp60_;
					const gchar* _tmp61_;
					gchar* _tmp62_;
					gchar* _tmp63_;
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp60_ = re;
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp61_ = p;
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp62_ = g_regex_replace_literal (_tmp60_, _tmp61_, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp59_ = _tmp62_;
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_regex_unref0 (re);
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1580 "rygel-media-export-extractor.c"
							goto __catch1_g_regex_error;
						}
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (p);
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						g_clear_error (&_inner_error0_);
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						return NULL;
#line 1591 "rygel-media-export-extractor.c"
					}
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp63_ = _tmp59_;
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp59_ = NULL;
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_free0 (p);
#line 197 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					p = _tmp63_;
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_free0 (_tmp59_);
#line 196 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_regex_unref0 (re);
#line 1605 "rygel-media-export-extractor.c"
				}
			}
		}
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp64_ = rygel_media_export_extractor_video_suffix_regexes;
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp64__length1 = rygel_media_export_extractor_video_suffix_regexes_length1;
#line 1613 "rygel-media-export-extractor.c"
		{
			GRegex** re_collection = NULL;
			gint re_collection_length1 = 0;
			gint _re_collection_size_ = 0;
			gint re_it = 0;
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			re_collection = _tmp64_;
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			re_collection_length1 = _tmp64__length1;
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			for (re_it = 0; re_it < re_collection_length1; re_it = re_it + 1) {
#line 1625 "rygel-media-export-extractor.c"
				GRegex* _tmp65_;
				GRegex* re = NULL;
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_tmp65_ = _g_regex_ref0 (re_collection[re_it]);
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				re = _tmp65_;
#line 1632 "rygel-media-export-extractor.c"
				{
					gchar* _tmp66_ = NULL;
					GRegex* _tmp67_;
					const gchar* _tmp68_;
					gchar* _tmp69_;
					gchar* _tmp70_;
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp67_ = re;
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp68_ = p;
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp69_ = g_regex_replace_literal (_tmp67_, _tmp68_, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp66_ = _tmp69_;
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_regex_unref0 (re);
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1653 "rygel-media-export-extractor.c"
							goto __catch1_g_regex_error;
						}
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (p);
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						g_clear_error (&_inner_error0_);
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						return NULL;
#line 1664 "rygel-media-export-extractor.c"
					}
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp70_ = _tmp66_;
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp66_ = NULL;
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_free0 (p);
#line 201 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					p = _tmp70_;
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_free0 (_tmp66_);
#line 200 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_regex_unref0 (re);
#line 1678 "rygel-media-export-extractor.c"
				}
			}
		}
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp71_ = rygel_media_export_extractor_block_regexes;
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp71__length1 = rygel_media_export_extractor_block_regexes_length1;
#line 1686 "rygel-media-export-extractor.c"
		{
			GRegex** re_collection = NULL;
			gint re_collection_length1 = 0;
			gint _re_collection_size_ = 0;
			gint re_it = 0;
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			re_collection = _tmp71_;
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			re_collection_length1 = _tmp71__length1;
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			for (re_it = 0; re_it < re_collection_length1; re_it = re_it + 1) {
#line 1698 "rygel-media-export-extractor.c"
				GRegex* _tmp72_;
				GRegex* re = NULL;
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				_tmp72_ = _g_regex_ref0 (re_collection[re_it]);
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
				re = _tmp72_;
#line 1705 "rygel-media-export-extractor.c"
				{
					gchar* _tmp73_ = NULL;
					GRegex* _tmp74_;
					const gchar* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp74_ = re;
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp75_ = p;
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp76_ = g_regex_replace_literal (_tmp74_, _tmp75_, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp73_ = _tmp76_;
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_regex_unref0 (re);
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1726 "rygel-media-export-extractor.c"
							goto __catch1_g_regex_error;
						}
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						_g_free0 (p);
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						g_clear_error (&_inner_error0_);
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
						return NULL;
#line 1737 "rygel-media-export-extractor.c"
					}
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp77_ = _tmp73_;
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_tmp73_ = NULL;
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_free0 (p);
#line 205 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					p = _tmp77_;
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_free0 (_tmp73_);
#line 204 "../src/plugins/media-export/rygel-media-export-extractor.vala"
					_g_regex_unref0 (re);
#line 1751 "rygel-media-export-extractor.c"
				}
			}
		}
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp79_ = rygel_media_export_extractor_char_remove_regex;
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp80_ = p;
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp81_ = g_regex_replace_literal (_tmp79_, _tmp80_, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp78_ = _tmp81_;
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1767 "rygel-media-export-extractor.c"
				goto __catch1_g_regex_error;
			}
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (p);
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_clear_error (&_inner_error0_);
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			return NULL;
#line 1778 "rygel-media-export-extractor.c"
		}
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp82_ = _tmp78_;
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp78_ = NULL;
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_free0 (p);
#line 208 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		p = _tmp82_;
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp84_ = rygel_media_export_extractor_char_convert_regex;
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp85_ = p;
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp86_ = g_regex_replace_literal (_tmp84_, _tmp85_, (gssize) -1, 0, " ", 0, &_inner_error0_);
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp83_ = _tmp86_;
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (_tmp78_);
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1802 "rygel-media-export-extractor.c"
				goto __catch1_g_regex_error;
			}
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (p);
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_clear_error (&_inner_error0_);
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			return NULL;
#line 1813 "rygel-media-export-extractor.c"
		}
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp87_ = _tmp83_;
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp83_ = NULL;
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_free0 (p);
#line 209 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		p = _tmp87_;
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp89_ = rygel_media_export_extractor_space_compress_regex;
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp90_ = p;
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp91_ = g_regex_replace_literal (_tmp89_, _tmp90_, (gssize) -1, 0, " ", 0, &_inner_error0_);
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp88_ = _tmp91_;
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (_tmp83_);
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (_tmp78_);
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1839 "rygel-media-export-extractor.c"
				goto __catch1_g_regex_error;
			}
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			_g_free0 (p);
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			g_clear_error (&_inner_error0_);
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
			return NULL;
#line 1850 "rygel-media-export-extractor.c"
		}
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp92_ = _tmp88_;
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp88_ = NULL;
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_free0 (p);
#line 210 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		p = _tmp92_;
#line 212 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp93_ = p;
#line 212 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_strstrip (_tmp93_);
#line 214 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		result = p;
#line 214 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_free0 (_tmp88_);
#line 214 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_free0 (_tmp83_);
#line 214 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_free0 (_tmp78_);
#line 214 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		return result;
#line 1874 "rygel-media-export-extractor.c"
	}
	goto __finally1;
	__catch1_g_regex_error:
	{
#line 195 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_clear_error (&_inner_error0_);
#line 216 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_assert_not_reached ();
#line 1883 "rygel-media-export-extractor.c"
	}
	__finally1:
#line 195 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_free0 (p);
#line 195 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 195 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_clear_error (&_inner_error0_);
#line 195 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return NULL;
#line 1894 "rygel-media-export-extractor.c"
}

GFile*
rygel_media_export_extractor_get_file (RygelMediaExportExtractor* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_tmp0_ = self->priv->_file;
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	result = _tmp0_;
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return result;
#line 1910 "rygel-media-export-extractor.c"
}

void
rygel_media_export_extractor_set_file (RygelMediaExportExtractor* self,
                                       GFile* value)
{
	GFile* old_value;
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	old_value = rygel_media_export_extractor_get_file (self);
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (old_value != value) {
#line 1924 "rygel-media-export-extractor.c"
		GFile* _tmp0_;
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		_g_object_unref0 (self->priv->_file);
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		self->priv->_file = _tmp0_;
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_export_extractor_properties[RYGEL_MEDIA_EXPORT_EXTRACTOR_FILE_PROPERTY]);
#line 1934 "rygel-media-export-extractor.c"
	}
}

gboolean
rygel_media_export_extractor_get_extract_metadata (RygelMediaExportExtractor* self)
{
	gboolean result;
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	result = self->priv->_extract_metadata;
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	return result;
#line 1948 "rygel-media-export-extractor.c"
}

void
rygel_media_export_extractor_set_extract_metadata (RygelMediaExportExtractor* self,
                                                   gboolean value)
{
	gboolean old_value;
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	old_value = rygel_media_export_extractor_get_extract_metadata (self);
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	if (old_value != value) {
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		self->priv->_extract_metadata = value;
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_export_extractor_properties[RYGEL_MEDIA_EXPORT_EXTRACTOR_EXTRACT_METADATA_PROPERTY]);
#line 1966 "rygel-media-export-extractor.c"
	}
}

static void
rygel_media_export_extractor_class_init (RygelMediaExportExtractorClass * klass,
                                         gpointer klass_data)
{
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	rygel_media_export_extractor_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_type_class_adjust_private_offset (klass, &RygelMediaExportExtractor_private_offset);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_media_export_extractor_real_constructed;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	((RygelMediaExportExtractorClass *) klass)->run = (void (*) (RygelMediaExportExtractor*, GAsyncReadyCallback, gpointer)) rygel_media_export_extractor_real_run;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	((RygelMediaExportExtractorClass *) klass)->run_finish = (void (*) (RygelMediaExportExtractor*, GAsyncResult*, GError**)) rygel_media_export_extractor_real_run_finish;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_media_export_extractor_get_property;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_media_export_extractor_set_property;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_media_export_extractor_finalize;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_EXPORT_EXTRACTOR_FILE_PROPERTY, rygel_media_export_extractor_properties[RYGEL_MEDIA_EXPORT_EXTRACTOR_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_EXPORT_EXTRACTOR_EXTRACT_METADATA_PROPERTY, rygel_media_export_extractor_properties[RYGEL_MEDIA_EXPORT_EXTRACTOR_EXTRACT_METADATA_PROPERTY] = g_param_spec_boolean ("extract-metadata", "extract-metadata", "extract-metadata", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1994 "rygel-media-export-extractor.c"
}

static void
rygel_media_export_extractor_instance_init (RygelMediaExportExtractor * self,
                                            gpointer klass)
{
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	self->priv = rygel_media_export_extractor_get_instance_private (self);
#line 54 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	self->priv->_extract_metadata = TRUE;
#line 2005 "rygel-media-export-extractor.c"
}

static void
rygel_media_export_extractor_finalize (GObject * obj)
{
	RygelMediaExportExtractor * self;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR, RygelMediaExportExtractor);
#line 53 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_object_unref0 (self->priv->_file);
#line 56 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	_g_variant_dict_unref0 (self->serialized_info);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	G_OBJECT_CLASS (rygel_media_export_extractor_parent_class)->finalize (obj);
#line 2020 "rygel-media-export-extractor.c"
}

 G_GNUC_NO_INLINE static GType
rygel_media_export_extractor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelMediaExportExtractorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_export_extractor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaExportExtractor), 0, (GInstanceInitFunc) rygel_media_export_extractor_instance_init, NULL };
	GType rygel_media_export_extractor_type_id;
	rygel_media_export_extractor_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelMediaExportExtractor", &g_define_type_info, 0);
	RygelMediaExportExtractor_private_offset = g_type_add_instance_private (rygel_media_export_extractor_type_id, sizeof (RygelMediaExportExtractorPrivate));
	return rygel_media_export_extractor_type_id;
}

GType
rygel_media_export_extractor_get_type (void)
{
	static volatile gsize rygel_media_export_extractor_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_export_extractor_type_id__once)) {
		GType rygel_media_export_extractor_type_id;
		rygel_media_export_extractor_type_id = rygel_media_export_extractor_get_type_once ();
		g_once_init_leave (&rygel_media_export_extractor_type_id__once, rygel_media_export_extractor_type_id);
	}
	return rygel_media_export_extractor_type_id__once;
}

static void
_vala_rygel_media_export_extractor_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	RygelMediaExportExtractor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR, RygelMediaExportExtractor);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	switch (property_id) {
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		case RYGEL_MEDIA_EXPORT_EXTRACTOR_FILE_PROPERTY:
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_value_set_object (value, rygel_media_export_extractor_get_file (self));
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		break;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		case RYGEL_MEDIA_EXPORT_EXTRACTOR_EXTRACT_METADATA_PROPERTY:
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		g_value_set_boolean (value, rygel_media_export_extractor_get_extract_metadata (self));
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		break;
#line 2067 "rygel-media-export-extractor.c"
		default:
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		break;
#line 2073 "rygel-media-export-extractor.c"
	}
}

static void
_vala_rygel_media_export_extractor_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	RygelMediaExportExtractor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_MEDIA_EXPORT_TYPE_EXTRACTOR, RygelMediaExportExtractor);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
	switch (property_id) {
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		case RYGEL_MEDIA_EXPORT_EXTRACTOR_FILE_PROPERTY:
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		rygel_media_export_extractor_set_file (self, g_value_get_object (value));
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		break;
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		case RYGEL_MEDIA_EXPORT_EXTRACTOR_EXTRACT_METADATA_PROPERTY:
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		rygel_media_export_extractor_set_extract_metadata (self, g_value_get_boolean (value));
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		break;
#line 2099 "rygel-media-export-extractor.c"
		default:
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/plugins/media-export/rygel-media-export-extractor.vala"
		break;
#line 2105 "rygel-media-export-extractor.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

