/* rygel-playbin-player.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-playbin-player.vala, do not modify */

/*
 * Copyright (C) 2008 OpenedHand Ltd.
 * Copyright (C) 2009,2010,2011,2012 Nokia Corporation.
 * Copyright (C) 2012 Openismus GmbH
 * Copyright (C) 2012,2013 Intel Corporation.
 * Copyright (C) 2013  Cable Television Laboratories, Inc.
 *
 * Author: Jorn Baayen <jorn@openedhand.com>
 *         Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *         Neha Shanbhag <N.Shanbhag@cablelabs.com>
 *         Sivakumar Mani <siva@orexel.com>
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-renderer-gst.h"
#include <gst/gst.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <libgupnp-av/gupnp-av.h>
#include "rygel-core.h"
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include "rygel-renderer.h"
#include <gio/gio.h>
#include <gst/audio/audio.h>

#define RYGEL_PLAYBIN_PLAYER_TRANSFER_MODE_STREAMING "Streaming"
#define RYGEL_PLAYBIN_PLAYER_TRANSFER_MODE_INTERACTIVE "Interactive"
#define RYGEL_PLAYBIN_PLAYER_PROTOCOL_INFO_TEMPLATE "http-get:%s:*:%s"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_PLAYBIN_PLAYER_0_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_PLAYBIN_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_PLAYBACK_STATE_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_ALLOWED_PLAYBACK_SPEEDS_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_PLAYBACK_SPEED_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_URI_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_MIME_TYPE_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_METADATA_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_CAN_SEEK_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_CAN_SEEK_BYTES_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_USER_AGENT_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_CONTENT_FEATURES_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_VOLUME_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_DURATION_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_SIZE_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_POSITION_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_BYTE_POSITION_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_SUPPORTED_PROFILES_PROPERTY,
	RYGEL_PLAYBIN_PLAYER_NUM_PROPERTIES
};
static GParamSpec* rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_structure_free0(var) ((var == NULL) ? NULL : (var = (gst_structure_free (var), NULL)))

struct _RygelPlaybinPlayerPrivate {
	GstElement* _playbin;
	gchar* _playback_state;
	gchar** _allowed_playback_speeds;
	gint _allowed_playback_speeds_length1;
	gint __allowed_playback_speeds_size_;
	gchar* _new_playback_speed;
	gchar* _playback_speed;
	gchar* transfer_mode;
	gboolean uri_update_hint;
	gchar* _uri;
	gchar* _mime_type;
	gchar* _metadata;
	gchar* _user_agent;
	gchar* _content_features;
	GUPnPProtocolInfo* protocol_info;
	gint64 _parsed_duration;
	GList* _supported_profiles;
	GstElement* source;
};

static gint RygelPlaybinPlayer_private_offset;
static gpointer rygel_playbin_player_parent_class = NULL;
static RygelPlaybinPlayer* rygel_playbin_player_player;
static RygelPlaybinPlayer* rygel_playbin_player_player = NULL;
static gboolean rygel_playbin_player_has_dlna_src;
static gboolean rygel_playbin_player_has_dlna_src = FALSE;
static RygelMediaPlayerIface * rygel_playbin_player_rygel_media_player_parent_iface = NULL;

static void _rygel_dlna_profile_unref0_ (gpointer var);
static inline void _g_list_free__rygel_dlna_profile_unref0_ (GList* self);
static RygelPlaybinPlayer* rygel_playbin_player_new (GError** error);
static RygelPlaybinPlayer* rygel_playbin_player_construct (GType object_type,
                                                    GError** error);
static void rygel_playbin_player_set_playbin (RygelPlaybinPlayer* self,
                                       GstElement* value);
static void rygel_playbin_player_setup_playbin (RygelPlaybinPlayer* self);
static gboolean rygel_playbin_player_seek_with_format (RygelPlaybinPlayer* self,
                                                GstFormat format,
                                                gint64 target);
static gboolean rygel_playbin_player_real_seek (RygelMediaPlayer* base,
                                         gint64 time);
static gboolean rygel_playbin_player_real_seek_bytes (RygelMediaPlayer* base,
                                               gint64 bytes);
static gchar** rygel_playbin_player_real_get_protocols (RygelMediaPlayer* base,
                                                 gint* result_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gchar** rygel_playbin_player_real_get_mime_types (RygelMediaPlayer* base,
                                                  gint* result_length1);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gboolean rygel_playbin_player_is_rendering_image (RygelPlaybinPlayer* self);
static void rygel_playbin_player_bus_handler (RygelPlaybinPlayer* self,
                                       GstBus* bus,
                                       GstMessage* message);
static gchar* rygel_playbin_player_generate_basic_didl (RygelPlaybinPlayer* self);
static void rygel_playbin_player_on_source_setup (RygelPlaybinPlayer* self,
                                           GstElement* pipeline,
                                           GstElement* source);
static void rygel_playbin_player_on_uri_notify (RygelPlaybinPlayer* self,
                                         GParamSpec* pspec);
static void _rygel_playbin_player_on_source_setup_dynamic_source_setup0_ (GstElement* _sender,
                                                                   GstElement* source,
                                                                   gpointer self);
static void _rygel_playbin_player_on_uri_notify_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _rygel_playbin_player_bus_handler_gst_bus_message (GstBus* _sender,
                                                        GstMessage* message,
                                                        gpointer self);
static void rygel_playbin_player_guess_duration (RygelPlaybinPlayer* self);
static void __lambda4_ (RygelPlaybinPlayer* self,
                 GUPnPDIDLLiteObject* object);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void ___lambda4__gupnp_didl_lite_parser_object_available (GUPnPDIDLLiteParser* _sender,
                                                          GUPnPDIDLLiteObject* object,
                                                          gpointer self);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static void rygel_playbin_player_finalize (GObject * obj);
static GType rygel_playbin_player_get_type_once (void);
static void _vala_rygel_playbin_player_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_rygel_playbin_player_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* RYGEL_PLAYBIN_PLAYER_protocols[2] = {"http-get", "rtsp"};
static const gchar* RYGEL_PLAYBIN_PLAYER_mime_types[45] = {"audio/mpeg", "application/ogg", "audio/x-vorbis", "audio/x-vorbis+ogg", "audio/ogg", "audio/x-ms-wma", "audio/x-ms-asf", "audio/x-flac", "audio/x-flac+ogg", "audio/flac", "audio/mp4", "audio/3gpp", "audio/vnd.dlna.adts", "audio/x-mod", "audio/x-wav", "audio/wav", "audio/x-ac3", "audio/x-m4a", "audio/aac", "audio/l16;rate=44100;channels=2", "audio/l16;rate=44100;channels=1", "audio/l16;channels=2;rate=44100", "audio/l16;channels=1;rate=44100", "audio/l16;rate=44100", "image/jpeg", "image/png", "video/x-theora", "video/x-theora+ogg", "video/x-oggm", "video/ogg", "video/x-dirac", "video/x-wmv", "video/x-wma", "video/x-msvideo", "video/x-3ivx", "video/x-3ivx", "video/x-matroska", "video/x-mkv", "video/mpeg", "video/mp4", "video/avi", "application/x-shockwave-flash", "video/x-ms-asf", "video/x-xvid", "video/x-ms-wmv"};

GQuark
rygel_playbin_player_error_quark (void)
{
	return g_quark_from_static_string ("rygel-playbin-player-error-quark");
}

 G_GNUC_NO_INLINE static GType
rygel_playbin_player_error_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_PLAYBIN_PLAYER_ERROR_NO_ELEMENT, "RYGEL_PLAYBIN_PLAYER_ERROR_NO_ELEMENT", "no-element"}, {0, NULL, NULL}};
	GType rygel_playbin_player_error_type_id;
	rygel_playbin_player_error_type_id = g_enum_register_static ("RygelPlaybinPlayerError", values);
	return rygel_playbin_player_error_type_id;
}

GType
rygel_playbin_player_error_get_type (void)
{
	static volatile gsize rygel_playbin_player_error_type_id__once = 0;
	if (g_once_init_enter (&rygel_playbin_player_error_type_id__once)) {
		GType rygel_playbin_player_error_type_id;
		rygel_playbin_player_error_type_id = rygel_playbin_player_error_get_type_once ();
		g_once_init_leave (&rygel_playbin_player_error_type_id__once, rygel_playbin_player_error_type_id);
	}
	return rygel_playbin_player_error_type_id__once;
}

static inline gpointer
rygel_playbin_player_get_instance_private (RygelPlaybinPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, RygelPlaybinPlayer_private_offset);
}

static void
_rygel_dlna_profile_unref0_ (gpointer var)
{
#line 442 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	(var == NULL) ? NULL : (var = (rygel_dlna_profile_unref (var), NULL));
#line 228 "rygel-playbin-player.c"
}

static inline void
_g_list_free__rygel_dlna_profile_unref0_ (GList* self)
{
#line 442 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_list_free_full (self, (GDestroyNotify) _rygel_dlna_profile_unref0_);
#line 236 "rygel-playbin-player.c"
}

static RygelPlaybinPlayer*
rygel_playbin_player_construct (GType object_type,
                                GError** error)
{
	RygelPlaybinPlayer * self = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 366 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) g_object_new (object_type, NULL);
#line 367 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = gst_element_factory_make ("playbin3", NULL);
#line 367 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp0_ != NULL) {
#line 367 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_ref_sink (_tmp0_);
#line 256 "rygel-playbin-player.c"
	}
#line 367 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = _tmp0_;
#line 367 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_playbin_player_set_playbin (self, _tmp1_);
#line 367 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (_tmp1_);
#line 368 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = self->priv->_playbin;
#line 368 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp2_ == NULL) {
#line 268 "rygel-playbin-player.c"
		GError* _tmp3_;
#line 369 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = g_error_new_literal (RYGEL_PLAYBIN_PLAYER_ERROR, RYGEL_PLAYBIN_PLAYER_ERROR_NO_ELEMENT, _ ("Your GStreamer installation seems to be missing the “playbin3” element" \
". The Rygel GStreamer renderer implementation cannot work without it"));
#line 369 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_inner_error0_ = _tmp3_;
#line 369 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_propagate_error (error, _inner_error0_);
#line 369 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (self);
#line 369 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return NULL;
#line 280 "rygel-playbin-player.c"
	}
#line 372 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_playbin_player_setup_playbin (self);
#line 366 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return self;
#line 286 "rygel-playbin-player.c"
}

static RygelPlaybinPlayer*
rygel_playbin_player_new (GError** error)
{
#line 366 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return rygel_playbin_player_construct (RYGEL_TYPE_PLAYBIN_PLAYER, error);
#line 294 "rygel-playbin-player.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 380 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return self ? g_object_ref (self) : NULL;
#line 302 "rygel-playbin-player.c"
}

RygelPlaybinPlayer*
rygel_playbin_player_instance (GError** error)
{
	RygelPlaybinPlayer* _tmp0_;
	RygelPlaybinPlayer* _tmp4_;
	RygelPlaybinPlayer* _tmp5_;
	GError* _inner_error0_ = NULL;
	RygelPlaybinPlayer* result;
#line 376 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = rygel_playbin_player_player;
#line 376 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp0_ == NULL) {
#line 317 "rygel-playbin-player.c"
		RygelPlaybinPlayer* _tmp1_ = NULL;
		RygelPlaybinPlayer* _tmp2_;
		RygelPlaybinPlayer* _tmp3_;
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = rygel_playbin_player_new (&_inner_error0_);
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp1_ = _tmp2_;
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			g_propagate_error (error, _inner_error0_);
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			return NULL;
#line 331 "rygel-playbin-player.c"
		}
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = _tmp1_;
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp1_ = NULL;
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (rygel_playbin_player_player);
#line 377 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_playbin_player_player = _tmp3_;
#line 376 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (_tmp1_);
#line 343 "rygel-playbin-player.c"
	}
#line 380 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp4_ = rygel_playbin_player_player;
#line 380 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 380 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp5_;
#line 380 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 353 "rygel-playbin-player.c"
}

static gboolean
rygel_playbin_player_seek_with_format (RygelPlaybinPlayer* self,
                                       GstFormat format,
                                       gint64 target)
{
	gboolean seeked = FALSE;
	gdouble speed = 0.0;
	const gchar* _tmp0_;
	gboolean result;
#line 383 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 386 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_new_playback_speed;
#line 386 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	speed = rygel_media_player_play_speed_to_double ((RygelMediaPlayer*) self, _tmp0_);
#line 387 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (speed > ((gdouble) 0)) {
#line 373 "rygel-playbin-player.c"
		GstElement* _tmp1_;
#line 388 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp1_ = self->priv->_playbin;
#line 388 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		seeked = gst_element_seek (_tmp1_, speed, format, (GST_SEEK_FLAG_FLUSH | GST_SEEK_FLAG_SKIP) | GST_SEEK_FLAG_ACCURATE, GST_SEEK_TYPE_SET, target, GST_SEEK_TYPE_NONE, (gint64) -1);
#line 379 "rygel-playbin-player.c"
	} else {
		GstElement* _tmp2_;
#line 396 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = self->priv->_playbin;
#line 396 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		seeked = gst_element_seek (_tmp2_, speed, format, (GST_SEEK_FLAG_FLUSH | GST_SEEK_FLAG_SKIP) | GST_SEEK_FLAG_ACCURATE, GST_SEEK_TYPE_SET, (gint64) 0, GST_SEEK_TYPE_SET, target);
#line 386 "rygel-playbin-player.c"
	}
#line 404 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (seeked) {
#line 390 "rygel-playbin-player.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 405 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = self->priv->_new_playback_speed;
#line 405 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 405 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (self->priv->_playback_speed);
#line 405 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_playback_speed = _tmp4_;
#line 401 "rygel-playbin-player.c"
	}
#line 408 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = seeked;
#line 408 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 407 "rygel-playbin-player.c"
}

static gboolean
rygel_playbin_player_real_seek (RygelMediaPlayer* base,
                                gint64 time)
{
	RygelPlaybinPlayer * self;
	const gchar* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	gboolean result;
#line 411 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 412 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_new_playback_speed;
#line 412 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_debug ("rygel-playbin-player.vala:412: Seeking %lld usec, play speed %s", time, _tmp0_);
#line 416 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = rygel_media_player_get_duration ((RygelMediaPlayer*) self);
#line 416 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = _tmp1_;
#line 416 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (time > _tmp2_) {
#line 417 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = FALSE;
#line 417 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 435 "rygel-playbin-player.c"
	}
#line 420 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = rygel_playbin_player_seek_with_format (self, GST_FORMAT_TIME, time * GST_USECOND);
#line 420 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 441 "rygel-playbin-player.c"
}

static gboolean
rygel_playbin_player_real_seek_bytes (RygelMediaPlayer* base,
                                      gint64 bytes)
{
	RygelPlaybinPlayer * self;
	const gchar* _tmp0_;
	gint64 size = 0LL;
	gint64 _tmp1_;
	gint64 _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 423 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 424 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_new_playback_speed;
#line 424 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_debug ("rygel-playbin-player.vala:424: Seeking %lld bytes, play speed %s", bytes, _tmp0_);
#line 426 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = rygel_media_player_get_size ((RygelMediaPlayer*) self);
#line 426 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = _tmp1_;
#line 426 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	size = _tmp2_;
#line 427 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (size > ((gint64) 0)) {
#line 427 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = bytes > size;
#line 471 "rygel-playbin-player.c"
	} else {
#line 427 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = FALSE;
#line 475 "rygel-playbin-player.c"
	}
#line 427 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp3_) {
#line 428 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = FALSE;
#line 428 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 483 "rygel-playbin-player.c"
	}
#line 431 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = rygel_playbin_player_seek_with_format (self, GST_FORMAT_BYTES, bytes);
#line 431 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 489 "rygel-playbin-player.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (length >= 0) {
#line 498 "rygel-playbin-player.c"
		gchar** result;
		gssize i;
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = g_new0 (gchar*, length + 1);
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		for (i = 0; i < length; i++) {
#line 505 "rygel-playbin-player.c"
			gchar* _tmp0_;
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp0_ = g_strdup (self[i]);
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			result[i] = _tmp0_;
#line 511 "rygel-playbin-player.c"
		}
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 515 "rygel-playbin-player.c"
	}
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return NULL;
#line 519 "rygel-playbin-player.c"
}

static gchar**
rygel_playbin_player_real_get_protocols (RygelMediaPlayer* base,
                                         gint* result_length1)
{
	RygelPlaybinPlayer * self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** result;
#line 434 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = _vala_array_dup1 (RYGEL_PLAYBIN_PLAYER_protocols, G_N_ELEMENTS (RYGEL_PLAYBIN_PLAYER_protocols));
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0__length1 = G_N_ELEMENTS (RYGEL_PLAYBIN_PLAYER_protocols);
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = _tmp0_;
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1__length1 = _tmp0__length1;
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (result_length1) {
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		*result_length1 = _tmp1__length1;
#line 546 "rygel-playbin-player.c"
	}
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 435 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 552 "rygel-playbin-player.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (length >= 0) {
#line 561 "rygel-playbin-player.c"
		gchar** result;
		gssize i;
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = g_new0 (gchar*, length + 1);
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		for (i = 0; i < length; i++) {
#line 568 "rygel-playbin-player.c"
			gchar* _tmp0_;
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp0_ = g_strdup (self[i]);
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			result[i] = _tmp0_;
#line 574 "rygel-playbin-player.c"
		}
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 578 "rygel-playbin-player.c"
	}
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return NULL;
#line 582 "rygel-playbin-player.c"
}

static gchar**
rygel_playbin_player_real_get_mime_types (RygelMediaPlayer* base,
                                          gint* result_length1)
{
	RygelPlaybinPlayer * self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** result;
#line 438 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = _vala_array_dup2 (RYGEL_PLAYBIN_PLAYER_mime_types, G_N_ELEMENTS (RYGEL_PLAYBIN_PLAYER_mime_types));
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0__length1 = G_N_ELEMENTS (RYGEL_PLAYBIN_PLAYER_mime_types);
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = _tmp0_;
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1__length1 = _tmp0__length1;
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (result_length1) {
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		*result_length1 = _tmp1__length1;
#line 609 "rygel-playbin-player.c"
	}
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 439 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 615 "rygel-playbin-player.c"
}

static gboolean
rygel_playbin_player_is_rendering_image (RygelPlaybinPlayer* self)
{
	GstElement* typefind = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GstCaps* caps = NULL;
	GstElement* _tmp2_;
	GstCaps* _tmp3_;
	GstCaps* _tmp4_;
	GstStructure* structure = NULL;
	GstCaps* _tmp5_;
	GstStructure* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GstStructure* _tmp8_;
	const gchar* _tmp9_;
	gboolean result;
#line 504 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 507 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playbin;
#line 507 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = gst_bin_get_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gst_bin_get_type (), GstBin), "typefind");
#line 507 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (typefind);
#line 507 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	typefind = _tmp1_;
#line 508 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = typefind;
#line 508 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_get (_tmp2_, "caps", &_tmp3_, NULL);
#line 508 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp4_ = _tmp3_;
#line 508 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	caps = _tmp4_;
#line 509 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp5_ = caps;
#line 509 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp6_ = gst_caps_get_structure (_tmp5_, (guint) 0);
#line 509 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	structure = _tmp6_;
#line 511 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp8_ = structure;
#line 511 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp9_ = gst_structure_get_name (_tmp8_);
#line 511 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (g_strcmp0 (_tmp9_, "image/jpeg") == 0) {
#line 511 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp7_ = TRUE;
#line 667 "rygel-playbin-player.c"
	} else {
		GstStructure* _tmp10_;
		const gchar* _tmp11_;
#line 512 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp10_ = structure;
#line 512 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp11_ = gst_structure_get_name (_tmp10_);
#line 512 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp7_ = g_strcmp0 (_tmp11_, "image/png") == 0;
#line 677 "rygel-playbin-player.c"
	}
#line 511 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp7_;
#line 511 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_gst_caps_unref0 (caps);
#line 511 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (typefind);
#line 511 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 687 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_bus_handler (RygelPlaybinPlayer* self,
                                  GstBus* bus,
                                  GstMessage* message)
{
#line 515 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (self != NULL);
#line 515 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (bus != NULL);
#line 515 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (message != NULL);
#line 517 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	switch (message->type) {
#line 517 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case GST_MESSAGE_DURATION_CHANGED:
#line 705 "rygel-playbin-player.c"
		{
			GstElement* _tmp0_;
#line 519 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp0_ = self->priv->_playbin;
#line 519 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			if (gst_element_query_duration (_tmp0_, GST_FORMAT_TIME, NULL)) {
#line 520 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				g_object_notify ((GObject*) self, "duration");
#line 714 "rygel-playbin-player.c"
			}
#line 522 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			break;
#line 718 "rygel-playbin-player.c"
		}
#line 517 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 722 "rygel-playbin-player.c"
		{
			GstObject* _tmp1_;
			GstElement* _tmp2_;
#line 524 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp1_ = message->src;
#line 524 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp2_ = self->priv->_playbin;
#line 524 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			if (_tmp1_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gst_object_get_type (), GstObject)) {
#line 732 "rygel-playbin-player.c"
				GstState old_state = 0;
				GstState new_state = 0;
				GstState pending = 0;
				GstState _tmp3_ = 0;
				GstState _tmp4_ = 0;
				GstState _tmp5_ = 0;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp20_ = FALSE;
#line 527 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				gst_message_parse_state_changed (message, &_tmp3_, &_tmp4_, &_tmp5_);
#line 527 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				old_state = _tmp3_;
#line 527 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				new_state = _tmp4_;
#line 527 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				pending = _tmp5_;
#line 530 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (old_state == GST_STATE_READY) {
#line 530 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp6_ = new_state == GST_STATE_PAUSED;
#line 753 "rygel-playbin-player.c"
				} else {
#line 530 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp6_ = FALSE;
#line 757 "rygel-playbin-player.c"
				}
#line 530 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (_tmp6_) {
#line 761 "rygel-playbin-player.c"
					GstElement* _tmp19_;
#line 531 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					if (self->priv->uri_update_hint) {
#line 765 "rygel-playbin-player.c"
						gchar* uri = NULL;
						GstElement* _tmp7_;
						gchar* _tmp8_;
						gchar* _tmp9_;
						gboolean _tmp10_ = FALSE;
						const gchar* _tmp11_;
						const gchar* _tmp12_;
#line 532 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						self->priv->uri_update_hint = FALSE;
#line 533 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp7_ = self->priv->_playbin;
#line 533 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						g_object_get (_tmp7_, "current-uri", &_tmp8_, NULL);
#line 533 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp9_ = _tmp8_;
#line 533 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						uri = _tmp9_;
#line 534 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp11_ = self->priv->_uri;
#line 534 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp12_ = uri;
#line 534 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						if (g_strcmp0 (_tmp11_, _tmp12_) != 0) {
#line 789 "rygel-playbin-player.c"
							const gchar* _tmp13_;
#line 534 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_tmp13_ = uri;
#line 534 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_tmp10_ = g_strcmp0 (_tmp13_, "") != 0;
#line 795 "rygel-playbin-player.c"
						} else {
#line 534 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_tmp10_ = FALSE;
#line 799 "rygel-playbin-player.c"
						}
#line 534 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						if (_tmp10_) {
#line 803 "rygel-playbin-player.c"
							GstElement* _tmp14_;
							gchar* _tmp15_;
							gchar* _tmp16_;
							gchar* _tmp17_;
							gchar* _tmp18_;
#line 536 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_tmp14_ = self->priv->_playbin;
#line 536 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							g_object_get (_tmp14_, "uri", &_tmp15_, NULL);
#line 536 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_tmp16_ = _tmp15_;
#line 536 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_g_free0 (self->priv->_uri);
#line 536 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							self->priv->_uri = _tmp16_;
#line 537 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							g_object_notify ((GObject*) self, "uri");
#line 538 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_tmp17_ = rygel_playbin_player_generate_basic_didl (self);
#line 538 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_tmp18_ = _tmp17_;
#line 538 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							rygel_media_player_set_metadata ((RygelMediaPlayer*) self, _tmp18_);
#line 538 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							_g_free0 (_tmp18_);
#line 829 "rygel-playbin-player.c"
						}
#line 531 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_g_free0 (uri);
#line 833 "rygel-playbin-player.c"
					}
#line 542 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp19_ = self->priv->_playbin;
#line 542 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					if (gst_element_query_duration (_tmp19_, GST_FORMAT_TIME, NULL)) {
#line 543 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						g_object_notify ((GObject*) self, "duration");
#line 841 "rygel-playbin-player.c"
					}
				}
#line 547 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (pending == GST_STATE_VOID_PENDING) {
#line 548 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					switch (new_state) {
#line 548 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						case GST_STATE_PAUSED:
#line 850 "rygel-playbin-player.c"
						{
#line 550 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							rygel_media_player_set_playback_state ((RygelMediaPlayer*) self, "PAUSED_PLAYBACK");
#line 551 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							break;
#line 856 "rygel-playbin-player.c"
						}
#line 548 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						case GST_STATE_NULL:
#line 860 "rygel-playbin-player.c"
						{
#line 553 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							rygel_media_player_set_playback_state ((RygelMediaPlayer*) self, "STOPPED");
#line 554 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							break;
#line 866 "rygel-playbin-player.c"
						}
#line 548 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						case GST_STATE_PLAYING:
#line 870 "rygel-playbin-player.c"
						{
#line 556 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							rygel_media_player_set_playback_state ((RygelMediaPlayer*) self, "PLAYING");
#line 557 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							break;
#line 876 "rygel-playbin-player.c"
						}
						default:
						{
#line 559 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
							break;
#line 882 "rygel-playbin-player.c"
						}
					}
				}
#line 563 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (old_state == GST_STATE_PAUSED) {
#line 563 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp20_ = new_state == GST_STATE_PLAYING;
#line 890 "rygel-playbin-player.c"
				} else {
#line 563 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp20_ = FALSE;
#line 894 "rygel-playbin-player.c"
				}
#line 563 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (_tmp20_) {
#line 564 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					rygel_media_player_set_playback_state ((RygelMediaPlayer*) self, "PLAYING");
#line 900 "rygel-playbin-player.c"
				}
			}
#line 567 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			break;
#line 905 "rygel-playbin-player.c"
		}
#line 517 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case GST_MESSAGE_EOS:
#line 909 "rygel-playbin-player.c"
		{
#line 569 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			if (!rygel_playbin_player_is_rendering_image (self)) {
#line 570 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				g_debug ("rygel-playbin-player.vala:570: EOS");
#line 571 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				rygel_media_player_set_playback_state ((RygelMediaPlayer*) self, "EOS");
#line 917 "rygel-playbin-player.c"
			} else {
#line 573 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				g_debug ("rygel-playbin-player.vala:573: Content is image, ignoring EOS");
#line 921 "rygel-playbin-player.c"
			}
#line 576 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			break;
#line 925 "rygel-playbin-player.c"
		}
#line 517 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case GST_MESSAGE_ERROR:
#line 929 "rygel-playbin-player.c"
		{
			GError* _error_ = NULL;
			gchar* debug_message = NULL;
			GError* _tmp21_ = NULL;
			gchar* _tmp22_ = NULL;
			GstElement* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			GError* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 581 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			gst_message_parse_error (message, &_tmp21_, &_tmp22_);
#line 581 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_error_free0 (_error_);
#line 581 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_error_ = _tmp21_;
#line 581 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_free0 (debug_message);
#line 581 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			debug_message = _tmp22_;
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp23_ = self->priv->_playbin;
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp24_ = gst_object_get_name ((GstObject*) _tmp23_);
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp25_ = _tmp24_;
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp26_ = _tmp25_;
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp27_ = _error_;
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp28_ = _tmp27_->message;
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp29_ = debug_message;
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			g_warning ("rygel-playbin-player.vala:583: Error from GStreamer element %s: %s (%s" \
")", _tmp26_, _tmp28_, _tmp29_);
#line 583 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_free0 (_tmp26_);
#line 587 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			g_warning ("rygel-playbin-player.vala:587: Going to STOPPED state");
#line 589 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			rygel_media_player_set_playback_state ((RygelMediaPlayer*) self, "STOPPED");
#line 591 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_free0 (debug_message);
#line 591 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_error_free0 (_error_);
#line 591 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			break;
#line 980 "rygel-playbin-player.c"
		}
		default:
		{
#line 593 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			break;
#line 986 "rygel-playbin-player.c"
		}
	}
}

static void
rygel_playbin_player_on_source_setup (RygelPlaybinPlayer* self,
                                      GstElement* pipeline,
                                      GstElement* source)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GstElement* _tmp12_;
#line 598 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (self != NULL);
#line 598 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (pipeline != NULL);
#line 598 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (source != NULL);
#line 599 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) source));
#line 599 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (g_strcmp0 (_tmp1_, "GstSoupHTTPSrc") == 0) {
#line 1009 "rygel-playbin-player.c"
		const gchar* _tmp2_;
#line 600 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = self->priv->transfer_mode;
#line 600 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 1015 "rygel-playbin-player.c"
	} else {
#line 599 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = FALSE;
#line 1019 "rygel-playbin-player.c"
	}
#line 599 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp0_) {
#line 1023 "rygel-playbin-player.c"
		const gchar* _tmp3_;
		GstStructure* structure = NULL;
		GstStructure* _tmp4_;
		GstStructure* _tmp5_;
		const gchar* _tmp6_;
		GValue _tmp7_ = {0};
		GstStructure* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 601 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = self->priv->transfer_mode;
#line 601 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_debug ("rygel-playbin-player.vala:601: Setting transfer mode to %s", _tmp3_);
#line 603 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = gst_structure_new_empty ("HTTPHeaders");
#line 603 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		structure = _tmp4_;
#line 604 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp5_ = structure;
#line 604 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp6_ = self->priv->transfer_mode;
#line 604 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_init (&_tmp7_, G_TYPE_STRING);
#line 604 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_string (&_tmp7_, _tmp6_);
#line 604 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		gst_structure_set_value (_tmp5_, "transferMode.dlna.org", &_tmp7_);
#line 604 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		G_IS_VALUE (&_tmp7_) ? (g_value_unset (&_tmp7_), NULL) : NULL;
#line 606 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp8_ = structure;
#line 606 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_set (source, "extra-headers", _tmp8_, NULL);
#line 607 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp9_ = rygel_media_player_get_user_agent ((RygelMediaPlayer*) self);
#line 607 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp10_ = _tmp9_;
#line 607 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp11_ = _tmp10_;
#line 607 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_set (source, "user-agent", _tmp11_, NULL);
#line 607 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (_tmp11_);
#line 599 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_gst_structure_free0 (structure);
#line 1070 "rygel-playbin-player.c"
	}
#line 610 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_ = _g_object_ref0 (source);
#line 610 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (self->priv->source);
#line 610 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->source = _tmp12_;
#line 1078 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_on_uri_notify (RygelPlaybinPlayer* self,
                                    GParamSpec* pspec)
{
#line 613 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (self != NULL);
#line 613 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (pspec != NULL);
#line 614 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->uri_update_hint = TRUE;
#line 1091 "rygel-playbin-player.c"
}

/**
     * Generate basic DIDLLite information.
     *
     * This is used when the URI gets changed externally. DLNA requires that a
     * minimum DIDLLite is always present if the URI is not empty.
     */
static gchar*
rygel_playbin_player_generate_basic_didl (RygelPlaybinPlayer* self)
{
	GUPnPDIDLLiteWriter* writer = NULL;
	GUPnPDIDLLiteWriter* _tmp0_;
	GUPnPDIDLLiteItem* item = NULL;
	GUPnPDIDLLiteItem* _tmp1_;
	GUPnPDIDLLiteResource* resource = NULL;
	GUPnPDIDLLiteResource* _tmp2_;
	const gchar* _tmp3_;
	GFile* file = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* result;
#line 623 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 624 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = gupnp_didl_lite_writer_new (NULL);
#line 624 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	writer = _tmp0_;
#line 625 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = gupnp_didl_lite_writer_add_item (writer);
#line 625 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	item = _tmp1_;
#line 626 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gupnp_didl_lite_object_set_id ((GUPnPDIDLLiteObject*) item, "1");
#line 627 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gupnp_didl_lite_object_set_parent_id ((GUPnPDIDLLiteObject*) item, "-1");
#line 628 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gupnp_didl_lite_object_set_upnp_class ((GUPnPDIDLLiteObject*) item, "object.item");
#line 629 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = gupnp_didl_lite_object_add_resource ((GUPnPDIDLLiteObject*) item);
#line 629 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	resource = _tmp2_;
#line 630 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp3_ = self->priv->_uri;
#line 630 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gupnp_didl_lite_resource_set_uri (resource, _tmp3_);
#line 631 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp4_ = rygel_media_player_get_uri ((RygelMediaPlayer*) self);
#line 631 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp5_ = _tmp4_;
#line 631 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp6_ = _tmp5_;
#line 631 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp7_ = g_file_new_for_uri (_tmp6_);
#line 631 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp8_ = _tmp7_;
#line 631 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (_tmp6_);
#line 631 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	file = _tmp8_;
#line 632 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp9_ = g_file_get_basename (file);
#line 632 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp10_ = _tmp9_;
#line 632 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gupnp_didl_lite_object_set_title ((GUPnPDIDLLiteObject*) item, _tmp10_);
#line 632 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (_tmp10_);
#line 634 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp11_ = gupnp_didl_lite_writer_get_string (writer);
#line 634 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp11_;
#line 634 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (file);
#line 634 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (resource);
#line 634 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (item);
#line 634 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (writer);
#line 634 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 1180 "rygel-playbin-player.c"
}

static void
_rygel_playbin_player_on_source_setup_dynamic_source_setup0_ (GstElement* _sender,
                                                              GstElement* source,
                                                              gpointer self)
{
#line 668 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_playbin_player_on_source_setup ((RygelPlaybinPlayer*) self, _sender, source);
#line 1190 "rygel-playbin-player.c"
}

static void
_rygel_playbin_player_on_uri_notify_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 669 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_playbin_player_on_uri_notify ((RygelPlaybinPlayer*) self, pspec);
#line 1200 "rygel-playbin-player.c"
}

static void
_rygel_playbin_player_bus_handler_gst_bus_message (GstBus* _sender,
                                                   GstMessage* message,
                                                   gpointer self)
{
#line 676 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_playbin_player_bus_handler ((RygelPlaybinPlayer*) self, _sender, message);
#line 1210 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_setup_playbin (RygelPlaybinPlayer* self)
{
	GstElement* _tmp20_;
	GstElement* _tmp21_;
	GstElement* _tmp22_;
	GstBus* bus = NULL;
	GstElement* _tmp23_;
	GstBus* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 637 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (self != NULL);
#line 1225 "rygel-playbin-player.c"
	{
		RygelMetaConfig* config = NULL;
		RygelMetaConfig* _tmp0_;
		gchar* sink_launch = NULL;
		RygelMetaConfig* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		GstElement* sink = NULL;
		const gchar* _tmp4_;
		GstElement* _tmp5_;
		GstElement* _tmp6_;
		GstElement* _tmp7_;
#line 639 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = rygel_meta_config_get_default ();
#line 639 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		config = _tmp0_;
#line 640 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp1_ = config;
#line 640 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = rygel_configuration_get_string ((RygelConfiguration*) _tmp1_, "Playbin", "audio-sink", &_inner_error0_);
#line 640 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		sink_launch = _tmp2_;
#line 640 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 640 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_object_unref0 (config);
#line 1252 "rygel-playbin-player.c"
			goto __catch0_g_error;
		}
#line 641 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = sink_launch;
#line 641 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_debug ("rygel-playbin-player.vala:641: Trying to parse audio sink %s", _tmp3_);
#line 642 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = sink_launch;
#line 642 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp5_ = gst_parse_bin_from_description_full (_tmp4_, TRUE, NULL, GST_PARSE_FLAG_FATAL_ERRORS, &_inner_error0_);
#line 642 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (_tmp5_ != NULL) {
#line 642 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			g_object_ref_sink (_tmp5_);
#line 1267 "rygel-playbin-player.c"
		}
#line 642 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		sink = _tmp5_;
#line 642 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 642 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_free0 (sink_launch);
#line 642 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_object_unref0 (config);
#line 1277 "rygel-playbin-player.c"
			goto __catch0_g_error;
		}
#line 646 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp6_ = self->priv->_playbin;
#line 646 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp7_ = sink;
#line 646 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_set (_tmp6_, "audio-sink", _tmp7_, NULL);
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (sink);
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (sink_launch);
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (config);
#line 1292 "rygel-playbin-player.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_error_ = _inner_error0_;
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_inner_error0_ = NULL;
#line 648 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp8_ = _error_;
#line 648 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp9_ = _tmp8_->message;
#line 648 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_debug ("rygel-playbin-player.vala:648: No audio sink configured, using default" \
": %s", _tmp9_);
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_error_free0 (_error_);
#line 1312 "rygel-playbin-player.c"
	}
	__finally0:
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_clear_error (&_inner_error0_);
#line 638 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return;
#line 1323 "rygel-playbin-player.c"
	}
	{
		RygelMetaConfig* config = NULL;
		RygelMetaConfig* _tmp10_;
		gchar* sink_launch = NULL;
		RygelMetaConfig* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		GstElement* sink = NULL;
		const gchar* _tmp14_;
		GstElement* _tmp15_;
		GstElement* _tmp16_;
		GstElement* _tmp17_;
#line 652 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp10_ = rygel_meta_config_get_default ();
#line 652 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		config = _tmp10_;
#line 653 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp11_ = config;
#line 653 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp12_ = rygel_configuration_get_string ((RygelConfiguration*) _tmp11_, "Playbin", "video-sink", &_inner_error0_);
#line 653 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		sink_launch = _tmp12_;
#line 653 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 653 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_object_unref0 (config);
#line 1351 "rygel-playbin-player.c"
			goto __catch1_g_error;
		}
#line 654 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp13_ = sink_launch;
#line 654 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_debug ("rygel-playbin-player.vala:654: Trying to parse video sink %s", _tmp13_);
#line 655 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp14_ = sink_launch;
#line 655 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp15_ = gst_parse_bin_from_description_full (_tmp14_, TRUE, NULL, GST_PARSE_FLAG_FATAL_ERRORS, &_inner_error0_);
#line 655 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (_tmp15_ != NULL) {
#line 655 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			g_object_ref_sink (_tmp15_);
#line 1366 "rygel-playbin-player.c"
		}
#line 655 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		sink = _tmp15_;
#line 655 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 655 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_free0 (sink_launch);
#line 655 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_object_unref0 (config);
#line 1376 "rygel-playbin-player.c"
			goto __catch1_g_error;
		}
#line 659 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp16_ = self->priv->_playbin;
#line 659 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp17_ = sink;
#line 659 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_set (_tmp16_, "video-sink", _tmp17_, NULL);
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (sink);
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (sink_launch);
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (config);
#line 1391 "rygel-playbin-player.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_error_ = _inner_error0_;
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_inner_error0_ = NULL;
#line 661 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp18_ = _error_;
#line 661 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp19_ = _tmp18_->message;
#line 661 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_debug ("rygel-playbin-player.vala:661: No video sink configured, using default" \
": %s", _tmp19_);
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_error_free0 (_error_);
#line 1411 "rygel-playbin-player.c"
	}
	__finally1:
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_clear_error (&_inner_error0_);
#line 651 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return;
#line 1422 "rygel-playbin-player.c"
	}
#line 666 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp20_ = self->priv->_playbin;
#line 666 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_set (_tmp20_, "auto-flush-bus", FALSE, NULL);
#line 668 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp21_ = self->priv->_playbin;
#line 668 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_signal_connect_object (_tmp21_, "source-setup", (GCallback) _rygel_playbin_player_on_source_setup_dynamic_source_setup0_, self, 0);
#line 669 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp22_ = self->priv->_playbin;
#line 669 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_signal_connect_object ((GObject*) _tmp22_, "notify::uri", (GCallback) _rygel_playbin_player_on_uri_notify_g_object_notify, self, 0);
#line 671 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_media_player_set_volume ((RygelMediaPlayer*) self, 0.5);
#line 674 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp23_ = self->priv->_playbin;
#line 674 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp24_ = gst_element_get_bus (_tmp23_);
#line 674 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	bus = _tmp24_;
#line 675 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gst_bus_add_signal_watch_full (bus, G_PRIORITY_DEFAULT);
#line 676 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_signal_connect_object (bus, "message", (GCallback) _rygel_playbin_player_bus_handler_gst_bus_message, self, 0);
#line 637 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (bus);
#line 1450 "rygel-playbin-player.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 687 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1458 "rygel-playbin-player.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 687 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1466 "rygel-playbin-player.c"
}

static void
__lambda4_ (RygelPlaybinPlayer* self,
            GUPnPDIDLLiteObject* object)
{
	GList* resources = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
#line 687 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (object != NULL);
#line 688 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = gupnp_didl_lite_object_get_resources (object);
#line 688 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	resources = _tmp0_;
#line 689 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = resources;
#line 1484 "rygel-playbin-player.c"
	{
		GList* resource_collection = NULL;
		GList* resource_it = NULL;
#line 689 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		resource_collection = _tmp1_;
#line 689 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		for (resource_it = resource_collection; resource_it != NULL; resource_it = resource_it->next) {
#line 1492 "rygel-playbin-player.c"
			GUPnPDIDLLiteResource* _tmp2_;
			GUPnPDIDLLiteResource* resource = NULL;
#line 689 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp2_ = _g_object_ref0 ((GUPnPDIDLLiteResource*) resource_it->data);
#line 689 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			resource = _tmp2_;
#line 1499 "rygel-playbin-player.c"
			{
				gboolean _tmp3_ = FALSE;
				const gchar* _tmp4_;
				GUPnPDIDLLiteResource* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_tmp4_ = self->priv->_uri;
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_tmp5_ = resource;
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_tmp6_ = gupnp_didl_lite_resource_get_uri (_tmp5_);
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_tmp7_ = _tmp6_;
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (g_strcmp0 (_tmp4_, _tmp7_) == 0) {
#line 1516 "rygel-playbin-player.c"
					GUPnPDIDLLiteResource* _tmp8_;
					glong _tmp9_;
					glong _tmp10_;
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp8_ = resource;
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp9_ = gupnp_didl_lite_resource_get_duration (_tmp8_);
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp10_ = _tmp9_;
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp3_ = _tmp10_ > ((glong) 0);
#line 1528 "rygel-playbin-player.c"
				} else {
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp3_ = FALSE;
#line 1532 "rygel-playbin-player.c"
				}
#line 690 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (_tmp3_) {
#line 1536 "rygel-playbin-player.c"
					GUPnPDIDLLiteResource* _tmp11_;
					glong _tmp12_;
					glong _tmp13_;
#line 691 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp11_ = resource;
#line 691 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp12_ = gupnp_didl_lite_resource_get_duration (_tmp11_);
#line 691 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp13_ = _tmp12_;
#line 691 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					self->priv->_parsed_duration = (gint64) (_tmp13_ * G_TIME_SPAN_SECOND);
#line 692 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					g_object_notify ((GObject*) self, "duration");
#line 1550 "rygel-playbin-player.c"
				}
#line 689 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_g_object_unref0 (resource);
#line 1554 "rygel-playbin-player.c"
			}
		}
	}
#line 687 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	(resources == NULL) ? NULL : (resources = (_g_list_free__g_object_unref0_ (resources), NULL));
#line 1560 "rygel-playbin-player.c"
}

static void
___lambda4__gupnp_didl_lite_parser_object_available (GUPnPDIDLLiteParser* _sender,
                                                     GUPnPDIDLLiteObject* object,
                                                     gpointer self)
{
#line 687 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	__lambda4_ ((RygelPlaybinPlayer*) self, object);
#line 1570 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_guess_duration (RygelPlaybinPlayer* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GUPnPDIDLLiteParser* reader = NULL;
	GUPnPDIDLLiteParser* _tmp3_;
	GUPnPDIDLLiteParser* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 679 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (self != NULL);
#line 680 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = self->priv->_metadata;
#line 680 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp1_ == NULL) {
#line 680 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = TRUE;
#line 1590 "rygel-playbin-player.c"
	} else {
		const gchar* _tmp2_;
#line 680 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = self->priv->_metadata;
#line 680 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
#line 1597 "rygel-playbin-player.c"
	}
#line 680 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp0_) {
#line 681 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return;
#line 1603 "rygel-playbin-player.c"
	}
#line 684 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp3_ = gupnp_didl_lite_parser_new ();
#line 684 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	reader = _tmp3_;
#line 687 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp4_ = reader;
#line 687 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_signal_connect_object (_tmp4_, "object-available", (GCallback) ___lambda4__gupnp_didl_lite_parser_object_available, self, 0);
#line 1613 "rygel-playbin-player.c"
	{
		GUPnPDIDLLiteParser* _tmp5_;
		const gchar* _tmp6_;
#line 698 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp5_ = reader;
#line 698 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp6_ = self->priv->_metadata;
#line 698 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		gupnp_didl_lite_parser_parse_didl (_tmp5_, _tmp6_, &_inner_error0_);
#line 698 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1625 "rygel-playbin-player.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 697 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_error_ = _inner_error0_;
#line 697 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_inner_error0_ = NULL;
#line 700 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp7_ = _error_;
#line 700 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp8_ = _tmp7_->message;
#line 700 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_debug ("rygel-playbin-player.vala:700: Failed to parse meta-data: %s", _tmp8_);
#line 697 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_error_free0 (_error_);
#line 1647 "rygel-playbin-player.c"
	}
	__finally0:
#line 697 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 697 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (reader);
#line 697 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 697 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_clear_error (&_inner_error0_);
#line 697 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return;
#line 1660 "rygel-playbin-player.c"
	}
#line 679 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (reader);
#line 1664 "rygel-playbin-player.c"
}

GstElement*
rygel_playbin_player_get_playbin (RygelPlaybinPlayer* self)
{
	GstElement* result;
	GstElement* _tmp0_;
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playbin;
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp0_;
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 1680 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_set_playbin (RygelPlaybinPlayer* self,
                                  GstElement* value)
{
	GstElement* old_value;
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	old_value = rygel_playbin_player_get_playbin (self);
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (old_value != value) {
#line 1694 "rygel-playbin-player.c"
		GstElement* _tmp0_;
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (self->priv->_playbin);
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_playbin = _tmp0_;
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_PLAYBIN_PROPERTY]);
#line 1704 "rygel-playbin-player.c"
	}
}

static gchar*
rygel_playbin_player_real_get_playback_state (RygelMediaPlayer* base)
{
	gchar* result;
	RygelPlaybinPlayer* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 106 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 107 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playback_state;
#line 107 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 107 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 107 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 1725 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_real_set_playback_state (RygelMediaPlayer* base,
                                              const gchar* value)
{
	RygelPlaybinPlayer* self;
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	static GQuark _tmp4_label0 = 0;
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	static GQuark _tmp4_label1 = 0;
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	static GQuark _tmp4_label2 = 0;
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	static GQuark _tmp4_label3 = 0;
#line 110 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 113 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playbin;
#line 113 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) GST_MSECOND);
#line 113 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	state = _tmp1_;
#line 113 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	pending = _tmp2_;
#line 115 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_debug ("rygel-playbin-player.vala:115: Changing playback state to %s.", value);
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp3_ = value;
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("STOPPED")))) {
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		switch (0) {
#line 1768 "rygel-playbin-player.c"
			default:
			{
				gboolean _tmp6_ = FALSE;
#line 119 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (state != GST_STATE_NULL) {
#line 119 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp6_ = TRUE;
#line 1776 "rygel-playbin-player.c"
				} else {
#line 119 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp6_ = pending != GST_STATE_VOID_PENDING;
#line 1780 "rygel-playbin-player.c"
				}
#line 119 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (_tmp6_) {
#line 1784 "rygel-playbin-player.c"
					GstElement* _tmp7_;
#line 120 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp7_ = self->priv->_playbin;
#line 120 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					gst_element_set_state (_tmp7_, GST_STATE_NULL);
#line 1790 "rygel-playbin-player.c"
				} else {
					gchar* _tmp8_;
#line 122 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp8_ = g_strdup (value);
#line 122 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_g_free0 (self->priv->_playback_state);
#line 122 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					self->priv->_playback_state = _tmp8_;
#line 1799 "rygel-playbin-player.c"
				}
#line 124 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				break;
#line 1803 "rygel-playbin-player.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("PAUSED_PLAYBACK")))) {
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		switch (0) {
#line 1809 "rygel-playbin-player.c"
			default:
			{
				gboolean _tmp9_ = FALSE;
#line 126 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (state != GST_STATE_PAUSED) {
#line 126 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp9_ = TRUE;
#line 1817 "rygel-playbin-player.c"
				} else {
#line 126 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp9_ = pending != GST_STATE_VOID_PENDING;
#line 1821 "rygel-playbin-player.c"
				}
#line 126 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (_tmp9_) {
#line 1825 "rygel-playbin-player.c"
					GstElement* _tmp10_;
#line 127 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp10_ = self->priv->_playbin;
#line 127 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					gst_element_set_state (_tmp10_, GST_STATE_PAUSED);
#line 1831 "rygel-playbin-player.c"
				} else {
					gchar* _tmp11_;
#line 129 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp11_ = g_strdup (value);
#line 129 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_g_free0 (self->priv->_playback_state);
#line 129 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					self->priv->_playback_state = _tmp11_;
#line 1840 "rygel-playbin-player.c"
				}
#line 131 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				break;
#line 1844 "rygel-playbin-player.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("PLAYING")))) {
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		switch (0) {
#line 1850 "rygel-playbin-player.c"
			default:
			{
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 133 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_tmp14_ = self->priv->_new_playback_speed;
#line 133 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_tmp15_ = self->priv->_playback_speed;
#line 133 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (g_strcmp0 (_tmp14_, _tmp15_) != 0) {
#line 1863 "rygel-playbin-player.c"
					gboolean _tmp16_ = FALSE;
#line 134 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					if (state == GST_STATE_PLAYING) {
#line 134 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp16_ = TRUE;
#line 1869 "rygel-playbin-player.c"
					} else {
#line 134 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp16_ = state == GST_STATE_PAUSED;
#line 1873 "rygel-playbin-player.c"
					}
#line 134 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp13_ = _tmp16_;
#line 1877 "rygel-playbin-player.c"
				} else {
#line 133 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp13_ = FALSE;
#line 1881 "rygel-playbin-player.c"
				}
#line 133 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (_tmp13_) {
#line 135 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp12_ = pending == GST_STATE_VOID_PENDING;
#line 1887 "rygel-playbin-player.c"
				} else {
#line 133 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp12_ = FALSE;
#line 1891 "rygel-playbin-player.c"
				}
#line 133 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				if (_tmp12_) {
#line 1895 "rygel-playbin-player.c"
					gchar* _tmp17_;
					gint64 _tmp18_;
					gint64 _tmp19_;
#line 137 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp17_ = g_strdup ("TRANSITIONING");
#line 137 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_g_free0 (self->priv->_playback_state);
#line 137 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					self->priv->_playback_state = _tmp17_;
#line 138 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp18_ = rygel_media_player_get_position ((RygelMediaPlayer*) self);
#line 138 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp19_ = _tmp18_;
#line 138 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					rygel_media_player_seek ((RygelMediaPlayer*) self, _tmp19_);
#line 1911 "rygel-playbin-player.c"
				} else {
					gboolean _tmp20_ = FALSE;
#line 139 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					if (state != GST_STATE_PLAYING) {
#line 139 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp20_ = TRUE;
#line 1918 "rygel-playbin-player.c"
					} else {
#line 140 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp20_ = pending != GST_STATE_VOID_PENDING;
#line 1922 "rygel-playbin-player.c"
					}
#line 139 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					if (_tmp20_) {
#line 1926 "rygel-playbin-player.c"
						gchar* _tmp21_;
						GstElement* _tmp22_;
#line 144 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp21_ = g_strdup ("TRANSITIONING");
#line 144 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_g_free0 (self->priv->_playback_state);
#line 144 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						self->priv->_playback_state = _tmp21_;
#line 145 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp22_ = self->priv->_playbin;
#line 145 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						gst_element_set_state (_tmp22_, GST_STATE_PLAYING);
#line 1939 "rygel-playbin-player.c"
					} else {
						gchar* _tmp23_;
#line 147 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_tmp23_ = g_strdup (value);
#line 147 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						_g_free0 (self->priv->_playback_state);
#line 147 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
						self->priv->_playback_state = _tmp23_;
#line 1948 "rygel-playbin-player.c"
					}
				}
#line 149 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				break;
#line 1953 "rygel-playbin-player.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("EOS")))) {
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		switch (0) {
#line 1959 "rygel-playbin-player.c"
			default:
			{
				gchar* _tmp24_;
#line 151 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_tmp24_ = g_strdup (value);
#line 151 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_g_free0 (self->priv->_playback_state);
#line 151 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				self->priv->_playback_state = _tmp24_;
#line 152 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				break;
#line 1971 "rygel-playbin-player.c"
			}
		}
	} else {
#line 117 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		switch (0) {
#line 1977 "rygel-playbin-player.c"
			default:
			{
#line 154 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				break;
#line 1982 "rygel-playbin-player.c"
			}
		}
	}
#line 110 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_PLAYBACK_STATE_PROPERTY]);
#line 1988 "rygel-playbin-player.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (length >= 0) {
#line 1997 "rygel-playbin-player.c"
		gchar** result;
		gssize i;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = g_new0 (gchar*, length + 1);
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		for (i = 0; i < length; i++) {
#line 2004 "rygel-playbin-player.c"
			gchar* _tmp0_;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp0_ = g_strdup (self[i]);
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			result[i] = _tmp0_;
#line 2010 "rygel-playbin-player.c"
		}
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2014 "rygel-playbin-player.c"
	}
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return NULL;
#line 2018 "rygel-playbin-player.c"
}

static gchar**
rygel_playbin_player_real_get_allowed_playback_speeds (RygelMediaPlayer* base,
                                                       gint* result_length1)
{
	gchar** result;
	RygelPlaybinPlayer* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 163 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_allowed_playback_speeds;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0__length1 = self->priv->_allowed_playback_speeds_length1;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup3 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1__length1 = _tmp0__length1;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = _tmp1_;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2__length1 = _tmp1__length1;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (result_length1) {
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		*result_length1 = _tmp2__length1;
#line 2051 "rygel-playbin-player.c"
	}
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp2_;
#line 164 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2057 "rygel-playbin-player.c"
}

static gchar*
rygel_playbin_player_real_get_playback_speed (RygelMediaPlayer* base)
{
	gchar* result;
	RygelPlaybinPlayer* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 177 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 178 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playback_speed;
#line 178 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 178 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 178 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2077 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_real_set_playback_speed (RygelMediaPlayer* base,
                                              const gchar* value)
{
	RygelPlaybinPlayer* self;
	gchar* _tmp0_;
#line 181 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 182 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = g_strdup (value);
#line 182 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_new_playback_speed);
#line 182 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_new_playback_speed = _tmp0_;
#line 181 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_PLAYBACK_SPEED_PROPERTY]);
#line 2096 "rygel-playbin-player.c"
}

static gchar*
rygel_playbin_player_real_get_uri (RygelMediaPlayer* base)
{
	gchar* result;
	RygelPlaybinPlayer* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 194 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 195 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_uri;
#line 195 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 195 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 195 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2116 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_real_set_uri (RygelMediaPlayer* base,
                                   const gchar* value)
{
	RygelPlaybinPlayer* self;
	gchar* _tmp0_;
	GstElement* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 198 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 199 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = g_strdup (value);
#line 199 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_uri);
#line 199 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_uri = _tmp0_;
#line 200 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = self->priv->_playbin;
#line 200 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gst_element_set_state (_tmp1_, GST_STATE_READY);
#line 201 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (rygel_playbin_player_has_dlna_src) {
#line 201 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = g_str_has_prefix (value, "http");
#line 2143 "rygel-playbin-player.c"
	} else {
#line 201 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = FALSE;
#line 2147 "rygel-playbin-player.c"
	}
#line 201 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp2_) {
#line 2151 "rygel-playbin-player.c"
		GstElement* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 202 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_debug ("rygel-playbin-player.vala:202: Trying to use DLNA src element");
#line 203 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = self->priv->_playbin;
#line 203 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = g_strconcat ("dlna+", value, NULL);
#line 203 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp5_ = _tmp4_;
#line 203 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_set (_tmp3_, "uri", _tmp5_, NULL);
#line 203 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (_tmp5_);
#line 2167 "rygel-playbin-player.c"
	} else {
		GstElement* _tmp6_;
#line 205 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp6_ = self->priv->_playbin;
#line 205 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_set (_tmp6_, "uri", value, NULL);
#line 2174 "rygel-playbin-player.c"
	}
#line 208 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (g_strcmp0 (value, "") != 0) {
#line 2178 "rygel-playbin-player.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GQuark _tmp10_ = 0U;
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		static GQuark _tmp9_label0 = 0;
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		static GQuark _tmp9_label1 = 0;
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		static GQuark _tmp9_label2 = 0;
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		static GQuark _tmp9_label3 = 0;
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		static GQuark _tmp9_label4 = 0;
#line 209 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_playbin_player_guess_duration (self);
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp7_ = self->priv->_playback_state;
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp8_ = _tmp7_;
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp10_ = (NULL == _tmp8_) ? 0 : g_quark_from_string (_tmp8_);
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (_tmp10_ == ((0 != _tmp9_label0) ? _tmp9_label0 : (_tmp9_label0 = g_quark_from_static_string ("NO_MEDIA_PRESENT")))) {
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			switch (0) {
#line 2204 "rygel-playbin-player.c"
				default:
				{
					gchar* _tmp11_;
#line 212 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp11_ = g_strdup ("STOPPED");
#line 212 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_g_free0 (self->priv->_playback_state);
#line 212 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					self->priv->_playback_state = _tmp11_;
#line 213 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					g_object_notify ((GObject*) self, "playback-state");
#line 214 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					break;
#line 2218 "rygel-playbin-player.c"
				}
			}
		} else if (_tmp10_ == ((0 != _tmp9_label1) ? _tmp9_label1 : (_tmp9_label1 = g_quark_from_static_string ("STOPPED")))) {
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			switch (0) {
#line 2224 "rygel-playbin-player.c"
				default:
				{
#line 216 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					break;
#line 2229 "rygel-playbin-player.c"
				}
			}
		} else if (_tmp10_ == ((0 != _tmp9_label2) ? _tmp9_label2 : (_tmp9_label2 = g_quark_from_static_string ("PAUSED_PLAYBACK")))) {
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			switch (0) {
#line 2235 "rygel-playbin-player.c"
				default:
				{
					GstElement* _tmp12_;
#line 218 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp12_ = self->priv->_playbin;
#line 218 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					gst_element_set_state (_tmp12_, GST_STATE_PAUSED);
#line 219 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					break;
#line 2245 "rygel-playbin-player.c"
				}
			}
		} else if ((_tmp10_ == ((0 != _tmp9_label3) ? _tmp9_label3 : (_tmp9_label3 = g_quark_from_static_string ("EOS")))) || (_tmp10_ == ((0 != _tmp9_label4) ? _tmp9_label4 : (_tmp9_label4 = g_quark_from_static_string ("PLAYING"))))) {
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			switch (0) {
#line 2251 "rygel-playbin-player.c"
				default:
				{
					GstElement* _tmp13_;
#line 222 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					_tmp13_ = self->priv->_playbin;
#line 222 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					gst_element_set_state (_tmp13_, GST_STATE_PLAYING);
#line 223 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					break;
#line 2261 "rygel-playbin-player.c"
				}
			}
		} else {
#line 210 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			switch (0) {
#line 2267 "rygel-playbin-player.c"
				default:
				{
#line 225 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
					break;
#line 2272 "rygel-playbin-player.c"
				}
			}
		}
	} else {
		gchar* _tmp14_;
#line 228 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp14_ = g_strdup ("NO_MEDIA_PRESENT");
#line 228 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (self->priv->_playback_state);
#line 228 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_playback_state = _tmp14_;
#line 229 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_notify ((GObject*) self, "playback-state");
#line 2286 "rygel-playbin-player.c"
	}
#line 231 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_debug ("rygel-playbin-player.vala:231: URI set to %s.", value);
#line 198 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_URI_PROPERTY]);
#line 2292 "rygel-playbin-player.c"
}

static gchar*
rygel_playbin_player_real_get_mime_type (RygelMediaPlayer* base)
{
	gchar* result;
	RygelPlaybinPlayer* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 237 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 238 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_mime_type;
#line 238 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 238 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 238 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2312 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_real_set_mime_type (RygelMediaPlayer* base,
                                         const gchar* value)
{
	RygelPlaybinPlayer* self;
	gchar* _tmp0_;
#line 241 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 242 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = g_strdup (value);
#line 242 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_mime_type);
#line 242 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_mime_type = _tmp0_;
#line 241 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_MIME_TYPE_PROPERTY]);
#line 2331 "rygel-playbin-player.c"
}

static gchar*
rygel_playbin_player_real_get_metadata (RygelMediaPlayer* base)
{
	gchar* result;
	RygelPlaybinPlayer* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 248 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 249 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_metadata;
#line 249 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 249 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 249 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2351 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_real_set_metadata (RygelMediaPlayer* base,
                                        const gchar* value)
{
	RygelPlaybinPlayer* self;
	gchar* _tmp0_;
#line 252 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 253 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_parsed_duration = (gint64) 0;
#line 254 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = g_strdup (value);
#line 254 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_metadata);
#line 254 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_metadata = _tmp0_;
#line 252 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_METADATA_PROPERTY]);
#line 2372 "rygel-playbin-player.c"
}

static gboolean
rygel_playbin_player_real_get_can_seek (RygelMediaPlayer* base)
{
	gboolean result;
	RygelPlaybinPlayer* self;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 259 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 260 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = self->priv->transfer_mode;
#line 260 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (g_strcmp0 (_tmp1_, RYGEL_PLAYBIN_PLAYER_TRANSFER_MODE_INTERACTIVE) != 0) {
#line 2388 "rygel-playbin-player.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 261 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = rygel_media_player_get_mime_type ((RygelMediaPlayer*) self);
#line 261 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = _tmp2_;
#line 261 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = _tmp3_;
#line 261 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = !g_str_has_prefix (_tmp4_, "image/");
#line 261 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (_tmp4_);
#line 2402 "rygel-playbin-player.c"
	} else {
#line 260 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = FALSE;
#line 2406 "rygel-playbin-player.c"
	}
#line 260 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp0_;
#line 260 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2412 "rygel-playbin-player.c"
}

static gboolean
rygel_playbin_player_real_get_can_seek_bytes (RygelMediaPlayer* base)
{
	gboolean result;
	RygelPlaybinPlayer* self;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 266 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 267 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = self->priv->transfer_mode;
#line 267 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (g_strcmp0 (_tmp1_, RYGEL_PLAYBIN_PLAYER_TRANSFER_MODE_INTERACTIVE) != 0) {
#line 2428 "rygel-playbin-player.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 268 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = rygel_media_player_get_mime_type ((RygelMediaPlayer*) self);
#line 268 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = _tmp2_;
#line 268 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = _tmp3_;
#line 268 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = !g_str_has_prefix (_tmp4_, "image/");
#line 268 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (_tmp4_);
#line 2442 "rygel-playbin-player.c"
	} else {
#line 267 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = FALSE;
#line 2446 "rygel-playbin-player.c"
	}
#line 267 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp0_;
#line 267 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2452 "rygel-playbin-player.c"
}

static gchar*
rygel_playbin_player_real_get_user_agent (RygelMediaPlayer* base)
{
	gchar* result;
	RygelPlaybinPlayer* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_user_agent;
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2472 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_real_set_user_agent (RygelMediaPlayer* base,
                                          const gchar* value)
{
	RygelPlaybinPlayer* self;
	gchar* old_value;
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	old_value = rygel_playbin_player_real_get_user_agent (base);
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2487 "rygel-playbin-player.c"
		gchar* _tmp0_;
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = g_strdup (value);
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (self->priv->_user_agent);
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_user_agent = _tmp0_;
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_USER_AGENT_PROPERTY]);
#line 2497 "rygel-playbin-player.c"
	}
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (old_value);
#line 2501 "rygel-playbin-player.c"
}

static gchar*
rygel_playbin_player_real_get_content_features (RygelMediaPlayer* base)
{
	gchar* result;
	RygelPlaybinPlayer* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 277 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 278 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_content_features;
#line 278 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 278 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp1_;
#line 278 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2521 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_real_set_content_features (RygelMediaPlayer* base,
                                                const gchar* value)
{
	RygelPlaybinPlayer* self;
	gchar* pi_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 281 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 282 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = rygel_media_player_get_mime_type ((RygelMediaPlayer*) self);
#line 282 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = _tmp0_;
#line 282 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = _tmp1_;
#line 282 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp3_ = g_strdup_printf (RYGEL_PLAYBIN_PLAYER_PROTOCOL_INFO_TEMPLATE, _tmp2_, value);
#line 282 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp4_ = _tmp3_;
#line 282 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (_tmp2_);
#line 282 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	pi_string = _tmp4_;
#line 2553 "rygel-playbin-player.c"
	{
		GUPnPProtocolInfo* _tmp5_ = NULL;
		GUPnPProtocolInfo* _tmp6_;
		GUPnPProtocolInfo* _tmp7_;
		GUPnPDLNAFlags flags = 0U;
		GUPnPProtocolInfo* _tmp8_;
		GUPnPDLNAFlags _tmp9_;
		GUPnPDLNAFlags _tmp10_;
#line 285 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp6_ = gupnp_protocol_info_new_from_string (pi_string, &_inner_error0_);
#line 285 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp5_ = _tmp6_;
#line 285 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2568 "rygel-playbin-player.c"
			goto __catch0_g_error;
		}
#line 285 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp7_ = _tmp5_;
#line 285 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp5_ = NULL;
#line 285 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (self->priv->protocol_info);
#line 285 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->protocol_info = _tmp7_;
#line 286 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp8_ = self->priv->protocol_info;
#line 286 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp9_ = gupnp_protocol_info_get_dlna_flags (_tmp8_);
#line 286 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp10_ = _tmp9_;
#line 286 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		flags = _tmp10_;
#line 287 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		if ((flags & GUPNP_DLNA_FLAGS_INTERACTIVE_TRANSFER_MODE) == GUPNP_DLNA_FLAGS_INTERACTIVE_TRANSFER_MODE) {
#line 2589 "rygel-playbin-player.c"
			gchar* _tmp11_;
#line 288 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_tmp11_ = g_strdup (RYGEL_PLAYBIN_PLAYER_TRANSFER_MODE_INTERACTIVE);
#line 288 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			_g_free0 (self->priv->transfer_mode);
#line 288 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			self->priv->transfer_mode = _tmp11_;
#line 2597 "rygel-playbin-player.c"
		} else {
#line 289 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			if ((flags & GUPNP_DLNA_FLAGS_STREAMING_TRANSFER_MODE) == GUPNP_DLNA_FLAGS_STREAMING_TRANSFER_MODE) {
#line 2601 "rygel-playbin-player.c"
				gchar* _tmp12_;
#line 290 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_tmp12_ = g_strdup (RYGEL_PLAYBIN_PLAYER_TRANSFER_MODE_STREAMING);
#line 290 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_g_free0 (self->priv->transfer_mode);
#line 290 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				self->priv->transfer_mode = _tmp12_;
#line 2609 "rygel-playbin-player.c"
			} else {
#line 292 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				_g_free0 (self->priv->transfer_mode);
#line 292 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
				self->priv->transfer_mode = NULL;
#line 2615 "rygel-playbin-player.c"
			}
		}
#line 284 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (_tmp5_);
#line 2620 "rygel-playbin-player.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 284 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_clear_error (&_inner_error0_);
#line 295 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_object_unref0 (self->priv->protocol_info);
#line 295 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->protocol_info = NULL;
#line 296 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (self->priv->transfer_mode);
#line 296 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->transfer_mode = NULL;
#line 2635 "rygel-playbin-player.c"
	}
	__finally0:
#line 284 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 284 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_g_free0 (pi_string);
#line 284 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 284 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_clear_error (&_inner_error0_);
#line 284 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return;
#line 2648 "rygel-playbin-player.c"
	}
#line 298 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp13_ = g_strdup (value);
#line 298 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_content_features);
#line 298 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_content_features = _tmp13_;
#line 281 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (pi_string);
#line 281 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_CONTENT_FEATURES_PROPERTY]);
#line 2660 "rygel-playbin-player.c"
}

static gdouble
rygel_playbin_player_real_get_volume (RygelMediaPlayer* base)
{
	gdouble result;
	RygelPlaybinPlayer* self;
	GstElement* _tmp0_;
#line 303 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 304 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playbin;
#line 304 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = gst_stream_volume_get_volume (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gst_stream_volume_get_type (), GstStreamVolume), GST_STREAM_VOLUME_FORMAT_CUBIC);
#line 304 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2677 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_real_set_volume (RygelMediaPlayer* base,
                                      gdouble value)
{
	RygelPlaybinPlayer* self;
	GstElement* _tmp0_;
#line 308 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 309 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playbin;
#line 309 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	gst_stream_volume_set_volume (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gst_stream_volume_get_type (), GstStreamVolume), GST_STREAM_VOLUME_FORMAT_CUBIC, value);
#line 311 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_debug ("rygel-playbin-player.vala:311: volume set to %f.", value);
#line 308 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_VOLUME_PROPERTY]);
#line 2696 "rygel-playbin-player.c"
}

static gint64
rygel_playbin_player_real_get_duration (RygelMediaPlayer* base)
{
	gint64 result;
	RygelPlaybinPlayer* self;
	gint64 dur = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	gboolean _tmp2_;
#line 317 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 318 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	dur = (gint64) 0;
#line 320 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playbin;
#line 320 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = gst_element_query_duration (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 320 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	dur = _tmp1_;
#line 320 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp2_) {
#line 321 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = dur / GST_USECOND;
#line 321 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2724 "rygel-playbin-player.c"
	} else {
#line 323 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = self->priv->_parsed_duration;
#line 323 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2730 "rygel-playbin-player.c"
	}
}

static gint64
rygel_playbin_player_real_get_size (RygelMediaPlayer* base)
{
	gint64 result;
	RygelPlaybinPlayer* self;
	gint64 dur = 0LL;
	gboolean _tmp0_ = FALSE;
	GstElement* _tmp1_;
#line 329 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 330 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	dur = (gint64) 0;
#line 332 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = self->priv->source;
#line 332 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp1_ != NULL) {
#line 2750 "rygel-playbin-player.c"
		GstElement* _tmp2_;
		gint64 _tmp3_ = 0LL;
		gboolean _tmp4_;
#line 333 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = self->priv->source;
#line 333 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = gst_element_query_duration (_tmp2_, GST_FORMAT_BYTES, &_tmp3_);
#line 333 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		dur = _tmp3_;
#line 333 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = _tmp4_;
#line 2762 "rygel-playbin-player.c"
	} else {
#line 332 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = FALSE;
#line 2766 "rygel-playbin-player.c"
	}
#line 332 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp0_) {
#line 334 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = dur;
#line 334 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2774 "rygel-playbin-player.c"
	} else {
#line 336 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = (gint64) 0;
#line 336 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2780 "rygel-playbin-player.c"
	}
}

static gint64
rygel_playbin_player_real_get_position (RygelMediaPlayer* base)
{
	gint64 result;
	RygelPlaybinPlayer* self;
	gint64 pos = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	gboolean _tmp2_;
#line 342 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 345 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_playbin;
#line 345 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 345 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	pos = _tmp1_;
#line 345 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp2_) {
#line 346 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = pos / GST_USECOND;
#line 346 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2807 "rygel-playbin-player.c"
	} else {
#line 348 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = (gint64) 0;
#line 348 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2813 "rygel-playbin-player.c"
	}
}

static gint64
rygel_playbin_player_real_get_byte_position (RygelMediaPlayer* base)
{
	gint64 result;
	RygelPlaybinPlayer* self;
	gint64 pos = 0LL;
	gboolean _tmp0_ = FALSE;
	GstElement* _tmp1_;
#line 354 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = (RygelPlaybinPlayer*) base;
#line 355 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	pos = (gint64) 0;
#line 357 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = self->priv->source;
#line 357 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp1_ != NULL) {
#line 2833 "rygel-playbin-player.c"
		GstElement* _tmp2_;
		gint64 _tmp3_ = 0LL;
		gboolean _tmp4_;
#line 358 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = self->priv->source;
#line 358 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = gst_element_query_position (_tmp2_, GST_FORMAT_BYTES, &_tmp3_);
#line 358 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		pos = _tmp3_;
#line 358 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = _tmp4_;
#line 2845 "rygel-playbin-player.c"
	} else {
#line 357 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp0_ = FALSE;
#line 2849 "rygel-playbin-player.c"
	}
#line 357 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp0_) {
#line 359 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = pos;
#line 359 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2857 "rygel-playbin-player.c"
	} else {
#line 361 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		result = (gint64) 0;
#line 361 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		return result;
#line 2863 "rygel-playbin-player.c"
	}
}

GList*
rygel_playbin_player_get_supported_profiles (RygelPlaybinPlayer* self)
{
	GList* result;
	GList* _tmp0_;
	GList* _tmp19_;
#line 444 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 445 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = self->priv->_supported_profiles;
#line 445 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	if (_tmp0_ == NULL) {
#line 2879 "rygel-playbin-player.c"
		RygelDLNAProfile* _tmp1_;
		RygelDLNAProfile* _tmp2_;
		RygelDLNAProfile* _tmp3_;
		RygelDLNAProfile* _tmp4_;
		RygelDLNAProfile* _tmp5_;
		RygelDLNAProfile* _tmp6_;
		RygelDLNAProfile* _tmp7_;
		RygelDLNAProfile* _tmp8_;
		RygelDLNAProfile* _tmp9_;
		RygelDLNAProfile* _tmp10_;
		RygelDLNAProfile* _tmp11_;
		RygelDLNAProfile* _tmp12_;
		RygelDLNAProfile* _tmp13_;
		RygelDLNAProfile* _tmp14_;
		RygelDLNAProfile* _tmp15_;
		RygelDLNAProfile* _tmp16_;
		RygelDLNAProfile* _tmp17_;
		RygelDLNAProfile* _tmp18_;
#line 448 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		(self->priv->_supported_profiles == NULL) ? NULL : (self->priv->_supported_profiles = (_g_list_free__rygel_dlna_profile_unref0_ (self->priv->_supported_profiles), NULL));
#line 448 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = NULL;
#line 451 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp1_ = rygel_dlna_profile_new ("JPEG_SM", "image/jpeg");
#line 451 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp1_);
#line 453 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp2_ = rygel_dlna_profile_new ("JPEG_MED", "image/jpeg");
#line 453 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp2_);
#line 455 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp3_ = rygel_dlna_profile_new ("JPEG_LRG", "image/jpeg");
#line 455 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp3_);
#line 457 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp4_ = rygel_dlna_profile_new ("PNG_LRG", "image/png");
#line 457 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp4_);
#line 461 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp5_ = rygel_dlna_profile_new ("MP3", "audio/mpeg");
#line 461 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp5_);
#line 463 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp6_ = rygel_dlna_profile_new ("MP3X", "audio/mpeg");
#line 463 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp6_);
#line 465 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp7_ = rygel_dlna_profile_new ("AAC_ADTS_320", "audio/vnd.dlna.adts");
#line 465 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp7_);
#line 468 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp8_ = rygel_dlna_profile_new ("AAC_ISO_320", "audio/mp4");
#line 468 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp8_);
#line 470 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp9_ = rygel_dlna_profile_new ("AAC_ISO_320", "audio/3gpp");
#line 470 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp9_);
#line 472 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp10_ = rygel_dlna_profile_new ("LPCM", "audio/l16;rate=44100;channels=2");
#line 472 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp10_);
#line 475 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp11_ = rygel_dlna_profile_new ("LPCM", "audio/l16;rate=44100;channels=1");
#line 475 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp11_);
#line 478 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp12_ = rygel_dlna_profile_new ("WMABASE", "audio/x-ms-wma");
#line 478 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp12_);
#line 480 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp13_ = rygel_dlna_profile_new ("WMAFULL", "audio/x-ms-wma");
#line 480 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp13_);
#line 482 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp14_ = rygel_dlna_profile_new ("WMAPRO", "audio/x-ms-wma");
#line 482 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp14_);
#line 486 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp15_ = rygel_dlna_profile_new ("MPEG_TS_SD_EU_ISO", "video/mpeg");
#line 486 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp15_);
#line 489 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp16_ = rygel_dlna_profile_new ("MPEG_TS_SD_NA_ISO", "video/mpeg");
#line 489 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp16_);
#line 492 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp17_ = rygel_dlna_profile_new ("MPEG_TS_HD_NA_ISO", "video/mpeg");
#line 492 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp17_);
#line 495 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		_tmp18_ = rygel_dlna_profile_new ("AVC_MP4_BL_CIF15_AAC_520", "video/mp4");
#line 495 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		self->priv->_supported_profiles = g_list_prepend (self->priv->_supported_profiles, _tmp18_);
#line 2974 "rygel-playbin-player.c"
	}
#line 500 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp19_ = self->priv->_supported_profiles;
#line 500 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	result = _tmp19_;
#line 500 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	return result;
#line 2982 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_class_init (RygelPlaybinPlayerClass * klass,
                                 gpointer klass_data)
{
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_playbin_player_parent_class = g_type_class_peek_parent (klass);
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_type_class_adjust_private_offset (klass, &RygelPlaybinPlayer_private_offset);
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_playbin_player_get_property;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_playbin_player_set_property;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_playbin_player_finalize;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_PLAYBIN_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_PLAYBIN_PROPERTY] = g_param_spec_object ("playbin", "playbin", "playbin", gst_element_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_PLAYBACK_STATE_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_PLAYBACK_STATE_PROPERTY] = g_param_spec_string ("playback-state", "playback-state", "playback-state", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_ALLOWED_PLAYBACK_SPEEDS_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_ALLOWED_PLAYBACK_SPEEDS_PROPERTY] = g_param_spec_boxed ("allowed-playback-speeds", "allowed-playback-speeds", "allowed-playback-speeds", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_PLAYBACK_SPEED_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_PLAYBACK_SPEED_PROPERTY] = g_param_spec_string ("playback-speed", "playback-speed", "playback-speed", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_URI_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_MIME_TYPE_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_MIME_TYPE_PROPERTY] = g_param_spec_string ("mime-type", "mime-type", "mime-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_METADATA_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_METADATA_PROPERTY] = g_param_spec_string ("metadata", "metadata", "metadata", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_CAN_SEEK_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_CAN_SEEK_PROPERTY] = g_param_spec_boolean ("can-seek", "can-seek", "can-seek", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_CAN_SEEK_BYTES_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_CAN_SEEK_BYTES_PROPERTY] = g_param_spec_boolean ("can-seek-bytes", "can-seek-bytes", "can-seek-bytes", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_USER_AGENT_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_USER_AGENT_PROPERTY] = g_param_spec_string ("user-agent", "user-agent", "user-agent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_CONTENT_FEATURES_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_CONTENT_FEATURES_PROPERTY] = g_param_spec_string ("content-features", "content-features", "content-features", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_VOLUME_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_DURATION_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_DURATION_PROPERTY] = g_param_spec_int64 ("duration", "duration", "duration", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_SIZE_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_SIZE_PROPERTY] = g_param_spec_int64 ("size", "size", "size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_POSITION_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_POSITION_PROPERTY] = g_param_spec_int64 ("position", "position", "position", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_BYTE_POSITION_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_BYTE_POSITION_PROPERTY] = g_param_spec_int64 ("byte-position", "byte-position", "byte-position", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_PLAYBIN_PLAYER_SUPPORTED_PROFILES_PROPERTY, rygel_playbin_player_properties[RYGEL_PLAYBIN_PLAYER_SUPPORTED_PROFILES_PROPERTY] = g_param_spec_pointer ("supported-profiles", "supported-profiles", "supported-profiles", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 98 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_playbin_player_has_dlna_src = gst_uri_protocol_is_supported (GST_URI_SRC, "dlna+http");
#line 3035 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_rygel_media_player_interface_init (RygelMediaPlayerIface * iface,
                                                        gpointer iface_data)
{
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	rygel_playbin_player_rygel_media_player_parent_iface = g_type_interface_peek_parent (iface);
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->seek = (gboolean (*) (RygelMediaPlayer*, gint64)) rygel_playbin_player_real_seek;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->seek_bytes = (gboolean (*) (RygelMediaPlayer*, gint64)) rygel_playbin_player_real_seek_bytes;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_protocols = (gchar** (*) (RygelMediaPlayer*, gint*)) rygel_playbin_player_real_get_protocols;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_mime_types = (gchar** (*) (RygelMediaPlayer*, gint*)) rygel_playbin_player_real_get_mime_types;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_playback_state = rygel_playbin_player_real_get_playback_state;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->set_playback_state = rygel_playbin_player_real_set_playback_state;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_allowed_playback_speeds = rygel_playbin_player_real_get_allowed_playback_speeds;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_playback_speed = rygel_playbin_player_real_get_playback_speed;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->set_playback_speed = rygel_playbin_player_real_set_playback_speed;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_uri = rygel_playbin_player_real_get_uri;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->set_uri = rygel_playbin_player_real_set_uri;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_mime_type = rygel_playbin_player_real_get_mime_type;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->set_mime_type = rygel_playbin_player_real_set_mime_type;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_metadata = rygel_playbin_player_real_get_metadata;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->set_metadata = rygel_playbin_player_real_set_metadata;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_can_seek = rygel_playbin_player_real_get_can_seek;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_can_seek_bytes = rygel_playbin_player_real_get_can_seek_bytes;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_user_agent = rygel_playbin_player_real_get_user_agent;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->set_user_agent = rygel_playbin_player_real_set_user_agent;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_content_features = rygel_playbin_player_real_get_content_features;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->set_content_features = rygel_playbin_player_real_set_content_features;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_volume = rygel_playbin_player_real_get_volume;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->set_volume = rygel_playbin_player_real_set_volume;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_duration = rygel_playbin_player_real_get_duration;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_size = rygel_playbin_player_real_get_size;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_position = rygel_playbin_player_real_get_position;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	iface->get_byte_position = rygel_playbin_player_real_get_byte_position;
#line 3098 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_instance_init (RygelPlaybinPlayer * self,
                                    gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv = rygel_playbin_player_get_instance_private (self);
#line 104 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp0_ = g_strdup ("NO_MEDIA_PRESENT");
#line 104 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_playback_state = _tmp0_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp1_ = g_strdup ("1/16");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp2_ = g_strdup ("1/8");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp3_ = g_strdup ("1/4");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp4_ = g_strdup ("1/2");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp5_ = g_strdup ("1");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp6_ = g_strdup ("2");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp7_ = g_strdup ("4");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp8_ = g_strdup ("8");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp9_ = g_strdup ("16");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp10_ = g_strdup ("32");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp11_ = g_strdup ("64");
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_ = g_new0 (gchar*, 11 + 1);
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[0] = _tmp1_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[1] = _tmp2_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[2] = _tmp3_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[3] = _tmp4_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[4] = _tmp5_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[5] = _tmp6_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[6] = _tmp7_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[7] = _tmp8_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[8] = _tmp9_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[9] = _tmp10_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp12_[10] = _tmp11_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_allowed_playback_speeds = _tmp12_;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_allowed_playback_speeds_length1 = 11;
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->__allowed_playback_speeds_size_ = self->priv->_allowed_playback_speeds_length1;
#line 173 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp13_ = g_strdup ("1");
#line 173 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_new_playback_speed = _tmp13_;
#line 175 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp14_ = g_strdup ("1");
#line 175 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_playback_speed = _tmp14_;
#line 189 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->transfer_mode = NULL;
#line 191 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->uri_update_hint = FALSE;
#line 192 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_uri = NULL;
#line 235 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp15_ = g_strdup ("");
#line 235 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_mime_type = _tmp15_;
#line 246 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp16_ = g_strdup ("");
#line 246 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_metadata = _tmp16_;
#line 274 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_tmp17_ = g_strdup ("");
#line 274 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_content_features = _tmp17_;
#line 3207 "rygel-playbin-player.c"
}

static void
rygel_playbin_player_finalize (GObject * obj)
{
	RygelPlaybinPlayer * self;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_PLAYBIN_PLAYER, RygelPlaybinPlayer);
#line 102 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (self->priv->_playbin);
#line 104 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_playback_state);
#line 159 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	self->priv->_allowed_playback_speeds = (_vala_array_free (self->priv->_allowed_playback_speeds, self->priv->_allowed_playback_speeds_length1, (GDestroyNotify) g_free), NULL);
#line 173 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_new_playback_speed);
#line 175 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_playback_speed);
#line 189 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->transfer_mode);
#line 192 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_uri);
#line 235 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_mime_type);
#line 246 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_metadata);
#line 272 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_user_agent);
#line 274 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_free0 (self->priv->_content_features);
#line 275 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (self->priv->protocol_info);
#line 442 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	(self->priv->_supported_profiles == NULL) ? NULL : (self->priv->_supported_profiles = (_g_list_free__rygel_dlna_profile_unref0_ (self->priv->_supported_profiles), NULL));
#line 597 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	_g_object_unref0 (self->priv->source);
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	G_OBJECT_CLASS (rygel_playbin_player_parent_class)->finalize (obj);
#line 3246 "rygel-playbin-player.c"
}

/**
 * Implementation of RygelMediaPlayer for GStreamer.
 *
 * This class is useful only when implementing Rygel plugins.
 */
 G_GNUC_NO_INLINE static GType
rygel_playbin_player_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelPlaybinPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_playbin_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelPlaybinPlayer), 0, (GInstanceInitFunc) rygel_playbin_player_instance_init, NULL };
	static const GInterfaceInfo rygel_media_player_info = { (GInterfaceInitFunc) rygel_playbin_player_rygel_media_player_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType rygel_playbin_player_type_id;
	rygel_playbin_player_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelPlaybinPlayer", &g_define_type_info, 0);
	g_type_add_interface_static (rygel_playbin_player_type_id, RYGEL_TYPE_MEDIA_PLAYER, &rygel_media_player_info);
	RygelPlaybinPlayer_private_offset = g_type_add_instance_private (rygel_playbin_player_type_id, sizeof (RygelPlaybinPlayerPrivate));
	return rygel_playbin_player_type_id;
}

GType
rygel_playbin_player_get_type (void)
{
	static volatile gsize rygel_playbin_player_type_id__once = 0;
	if (g_once_init_enter (&rygel_playbin_player_type_id__once)) {
		GType rygel_playbin_player_type_id;
		rygel_playbin_player_type_id = rygel_playbin_player_get_type_once ();
		g_once_init_leave (&rygel_playbin_player_type_id__once, rygel_playbin_player_type_id);
	}
	return rygel_playbin_player_type_id__once;
}

static void
_vala_rygel_playbin_player_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	RygelPlaybinPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_PLAYBIN_PLAYER, RygelPlaybinPlayer);
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	switch (property_id) {
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_PLAYBIN_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_object (value, rygel_playbin_player_get_playbin (self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_PLAYBACK_STATE_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_take_string (value, rygel_media_player_get_playback_state ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_ALLOWED_PLAYBACK_SPEEDS_PROPERTY:
#line 3302 "rygel-playbin-player.c"
		{
			int length;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
			g_value_take_boxed (value, rygel_media_player_get_allowed_playback_speeds ((RygelMediaPlayer*) self, &length));
#line 3307 "rygel-playbin-player.c"
		}
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_PLAYBACK_SPEED_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_take_string (value, rygel_media_player_get_playback_speed ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_URI_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_take_string (value, rygel_media_player_get_uri ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_MIME_TYPE_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_take_string (value, rygel_media_player_get_mime_type ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_METADATA_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_take_string (value, rygel_media_player_get_metadata ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_CAN_SEEK_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_boolean (value, rygel_media_player_get_can_seek ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_CAN_SEEK_BYTES_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_boolean (value, rygel_media_player_get_can_seek_bytes ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_USER_AGENT_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_take_string (value, rygel_media_player_get_user_agent ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_CONTENT_FEATURES_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_take_string (value, rygel_media_player_get_content_features ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_VOLUME_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_double (value, rygel_media_player_get_volume ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_DURATION_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_int64 (value, rygel_media_player_get_duration ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_SIZE_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_int64 (value, rygel_media_player_get_size ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_POSITION_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_int64 (value, rygel_media_player_get_position ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_BYTE_POSITION_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_int64 (value, rygel_media_player_get_byte_position ((RygelMediaPlayer*) self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_SUPPORTED_PROFILES_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		g_value_set_pointer (value, rygel_playbin_player_get_supported_profiles (self));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 3395 "rygel-playbin-player.c"
		default:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 3401 "rygel-playbin-player.c"
	}
}

static void
_vala_rygel_playbin_player_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	RygelPlaybinPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_PLAYBIN_PLAYER, RygelPlaybinPlayer);
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
	switch (property_id) {
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_PLAYBIN_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_playbin_player_set_playbin (self, g_value_get_object (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_PLAYBACK_STATE_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_media_player_set_playback_state ((RygelMediaPlayer*) self, g_value_get_string (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_PLAYBACK_SPEED_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_media_player_set_playback_speed ((RygelMediaPlayer*) self, g_value_get_string (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_URI_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_media_player_set_uri ((RygelMediaPlayer*) self, g_value_get_string (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_MIME_TYPE_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_media_player_set_mime_type ((RygelMediaPlayer*) self, g_value_get_string (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_METADATA_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_media_player_set_metadata ((RygelMediaPlayer*) self, g_value_get_string (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_USER_AGENT_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_media_player_set_user_agent ((RygelMediaPlayer*) self, g_value_get_string (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_CONTENT_FEATURES_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_media_player_set_content_features ((RygelMediaPlayer*) self, g_value_get_string (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		case RYGEL_PLAYBIN_PLAYER_VOLUME_PROPERTY:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		rygel_media_player_set_volume ((RygelMediaPlayer*) self, g_value_get_double (value));
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 3469 "rygel-playbin-player.c"
		default:
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../src/librygel-renderer-gst/rygel-playbin-player.vala"
		break;
#line 3475 "rygel-playbin-player.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

