/* rygel-av-transport.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-av-transport.vala, do not modify */

/*
 * Copyright (C) 2008 OpenedHand Ltd.
 * Copyright (C) 2009,2010 Nokia Corporation.
 * Copyright (C) 2012 Openismus GmbH.
 * Copyright (C) 2013  Cable Television Laboratories, Inc.
 *
 * Author: Jorn Baayen <jorn@openedhand.com>
 *         Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *         Neha Shanbhag <N.Shanbhag@cablelabs.com>
 *         Sivakumar Mani <siva@orexel.com>
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <libgupnp/gupnp.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "rygel-renderer.h"
#include "config.h"
#include <errno.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <libgupnp-av/gupnp-av.h>

#define RYGEL_AV_TRANSPORT_UPNP_ID "urn:upnp-org:serviceId:AVTransport"
#define RYGEL_AV_TRANSPORT_UPNP_TYPE "urn:schemas-upnp-org:service:AVTransport:2"
#define RYGEL_AV_TRANSPORT_UPNP_TYPE_V1 "urn:schemas-upnp-org:service:AVTransport:1"
#define RYGEL_AV_TRANSPORT_DESCRIPTION_PATH "xml/AVTransport2.xml"
#define RYGEL_AV_TRANSPORT_LAST_CHANGE_NS "urn:schemas-upnp-org:metadata-1-0/AVT/"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define RYGEL_TYPE_AV_TRANSPORT (rygel_av_transport_get_type ())
#define RYGEL_AV_TRANSPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_AV_TRANSPORT, RygelAVTransport))
#define RYGEL_AV_TRANSPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_AV_TRANSPORT, RygelAVTransportClass))
#define RYGEL_IS_AV_TRANSPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_AV_TRANSPORT))
#define RYGEL_IS_AV_TRANSPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_AV_TRANSPORT))
#define RYGEL_AV_TRANSPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_AV_TRANSPORT, RygelAVTransportClass))

typedef struct _RygelAVTransport RygelAVTransport;
typedef struct _RygelAVTransportClass RygelAVTransportClass;
typedef struct _RygelAVTransportPrivate RygelAVTransportPrivate;

#define RYGEL_TYPE_CHANGE_LOG (rygel_change_log_get_type ())
#define RYGEL_CHANGE_LOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CHANGE_LOG, RygelChangeLog))
#define RYGEL_CHANGE_LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CHANGE_LOG, RygelChangeLogClass))
#define RYGEL_IS_CHANGE_LOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CHANGE_LOG))
#define RYGEL_IS_CHANGE_LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CHANGE_LOG))
#define RYGEL_CHANGE_LOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CHANGE_LOG, RygelChangeLogClass))

typedef struct _RygelChangeLog RygelChangeLog;
typedef struct _RygelChangeLogClass RygelChangeLogClass;
enum  {
	RYGEL_AV_TRANSPORT_0_PROPERTY,
	RYGEL_AV_TRANSPORT_STATUS_PROPERTY,
	RYGEL_AV_TRANSPORT_PLAYBACK_MEDIUM_PROPERTY,
	RYGEL_AV_TRANSPORT_POSSIBLE_PLAYBACK_MEDIA_PROPERTY,
	RYGEL_AV_TRANSPORT_SPEED_PROPERTY,
	RYGEL_AV_TRANSPORT_NUM_PROPERTIES
};
static GParamSpec* rygel_av_transport_properties[RYGEL_AV_TRANSPORT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define __vala_GUPnPServiceAction_free0(var) ((var == NULL) ? NULL : (var = (_vala_GUPnPServiceAction_free (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _RygelAvTransportHandlePlaylistData RygelAvTransportHandlePlaylistData;
typedef struct _RygelAvTransportHandleNewTransportUriData RygelAvTransportHandleNewTransportUriData;

struct _RygelAVTransport {
	GUPnPService parent_instance;
	RygelAVTransportPrivate * priv;
};

struct _RygelAVTransportClass {
	GUPnPServiceClass parent_class;
};

struct _RygelAVTransportPrivate {
	SoupSession* session;
	gchar* protocol_info;
	gchar* _status;
	RygelChangeLog* changelog;
	RygelMediaPlayer* player;
	RygelPlayerController* controller;
};

struct _RygelAvTransportHandlePlaylistData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelAVTransport* self;
	GUPnPServiceAction* action;
	gchar* uri;
	gchar* metadata;
	gchar* mime;
	gchar* features;
	SoupMessage* message;
	SoupMessage* _tmp0_;
	GBytes* body;
	GBytes* _tmp1_;
	SoupSession* _tmp2_;
	SoupMessage* _tmp3_;
	GBytes* _tmp4_;
	GBytes* _tmp5_;
	SoupMessage* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	gchar* content_type;
	SoupMessage* _tmp9_;
	SoupMessageHeaders* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	GUPnPMediaCollection* collection;
	const gchar* _tmp14_;
	GUPnPMediaCollection* _tmp15_;
	GBytes* _tmp16_;
	GUPnPMediaCollection* _tmp17_;
	GUPnPMediaCollection* _tmp18_;
	GError* _error_;
	GError* _tmp19_;
	const gchar* _tmp20_;
	const gchar* xml_string;
	GBytes* _tmp21_;
	gsize _tmp22_;
	guint8* _tmp23_;
	const gchar* _tmp24_;
	GUPnPMediaCollection* _tmp25_;
	GUPnPMediaCollection* _tmp26_;
	GList* _tmp27_;
	GList* _tmp28_;
	gboolean _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GQuark _tmp33_;
	RygelPlayerController* _tmp34_;
	GUPnPMediaCollection* _tmp35_;
	RygelPlayerController* _tmp36_;
	GUPnPMediaCollection* _tmp37_;
	GError* _inner_error0_;
};

struct _RygelAvTransportHandleNewTransportUriData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelAVTransport* self;
	GUPnPServiceAction* action;
	gchar* uri;
	gchar* metadata;
	gboolean _tmp0_;
	gchar* new_uri;
	GUPnPContext* _tmp1_;
	GUPnPContext* _tmp2_;
	gchar* _tmp3_;
	SoupMessage* message;
	const gchar* _tmp4_;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	SoupMessageHeaders* _tmp7_;
	SoupMessageHeaders* _tmp8_;
	SoupMessage* _tmp9_;
	SoupMessageHeaders* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	SoupSession* _tmp12_;
	SoupMessage* _tmp13_;
	GInputStream* _tmp14_;
	GInputStream* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	SoupMessage* _tmp18_;
	guint _tmp19_;
	guint _tmp20_;
	SoupMessage* _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	SoupMessage* _tmp24_;
	guint _tmp25_;
	guint _tmp26_;
	SoupMessage* _tmp27_;
	SoupSession* _tmp28_;
	SoupMessage* _tmp29_;
	GInputStream* _tmp30_;
	GInputStream* _tmp31_;
	SoupMessage* _tmp32_;
	guint _tmp33_;
	guint _tmp34_;
	SoupMessage* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gchar* mime;
	SoupMessage* _tmp38_;
	SoupMessageHeaders* _tmp39_;
	SoupMessageHeaders* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* features;
	SoupMessage* _tmp43_;
	SoupMessageHeaders* _tmp44_;
	SoupMessageHeaders* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gboolean _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	SoupMessage* _tmp59_;
	const gchar* _tmp60_;
	const gchar* _tmp61_;
	GError* _inner_error0_;
};

static gint RygelAVTransport_private_offset;
static gpointer rygel_av_transport_parent_class = NULL;

VALA_EXTERN GType rygel_av_transport_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_change_log_get_type (void) G_GNUC_CONST ;
static void rygel_av_transport_real_constructed (GObject* base);
VALA_EXTERN RygelChangeLog* rygel_change_log_new (GUPnPService* service,
                                      const gchar* service_ns);
VALA_EXTERN RygelChangeLog* rygel_change_log_construct (GType object_type,
                                            GUPnPService* service,
                                            const gchar* service_ns);
static RygelMediaPlayer* rygel_av_transport_get_player (RygelAVTransport* self);
VALA_EXTERN RygelPlayerController* rygel_media_renderer_plugin_get_controller (RygelMediaRendererPlugin* self);
static void rygel_av_transport_query_last_change_cb (RygelAVTransport* self,
                                              GUPnPService* service,
                                              const gchar* variable,
                                              GValue* value);
static void _rygel_av_transport_query_last_change_cb_gupnp_service_query_variable (GUPnPService* _sender,
                                                                            const gchar* variable,
                                                                            GValue* value,
                                                                            gpointer self);
static void rygel_av_transport_set_av_transport_uri_cb (RygelAVTransport* self,
                                                 GUPnPService* service,
                                                 GUPnPServiceAction* action);
static void _rygel_av_transport_set_av_transport_uri_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                               GUPnPServiceAction* action,
                                                                               gpointer self);
static void rygel_av_transport_set_next_av_transport_uri_cb (RygelAVTransport* self,
                                                      GUPnPService* service,
                                                      GUPnPServiceAction* action);
static void _rygel_av_transport_set_next_av_transport_uri_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                                    GUPnPServiceAction* action,
                                                                                    gpointer self);
static void rygel_av_transport_get_media_info_cb (RygelAVTransport* self,
                                           GUPnPService* service,
                                           GUPnPServiceAction* action);
static void _rygel_av_transport_get_media_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                         GUPnPServiceAction* action,
                                                                         gpointer self);
static void rygel_av_transport_get_media_info_ex_cb (RygelAVTransport* self,
                                              GUPnPService* service,
                                              GUPnPServiceAction* action);
static void _rygel_av_transport_get_media_info_ex_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                            GUPnPServiceAction* action,
                                                                            gpointer self);
static void rygel_av_transport_get_transport_info_cb (RygelAVTransport* self,
                                               GUPnPService* service,
                                               GUPnPServiceAction* action);
static void _rygel_av_transport_get_transport_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                             GUPnPServiceAction* action,
                                                                             gpointer self);
static void rygel_av_transport_get_position_info_cb (RygelAVTransport* self,
                                              GUPnPService* service,
                                              GUPnPServiceAction* action);
static void _rygel_av_transport_get_position_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                            GUPnPServiceAction* action,
                                                                            gpointer self);
static void rygel_av_transport_get_device_capabilities_cb (RygelAVTransport* self,
                                                    GUPnPService* service,
                                                    GUPnPServiceAction* action);
static void _rygel_av_transport_get_device_capabilities_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                                  GUPnPServiceAction* action,
                                                                                  gpointer self);
static void rygel_av_transport_get_transport_settings_cb (RygelAVTransport* self,
                                                   GUPnPService* service,
                                                   GUPnPServiceAction* action);
static void _rygel_av_transport_get_transport_settings_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                                 GUPnPServiceAction* action,
                                                                                 gpointer self);
static void rygel_av_transport_get_transport_actions_cb (RygelAVTransport* self,
                                                  GUPnPService* service,
                                                  GUPnPServiceAction* action);
static void _rygel_av_transport_get_transport_actions_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                                GUPnPServiceAction* action,
                                                                                gpointer self);
static void rygel_av_transport_stop_cb (RygelAVTransport* self,
                                 GUPnPService* service,
                                 GUPnPServiceAction* action);
static void _rygel_av_transport_stop_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                               GUPnPServiceAction* action,
                                                               gpointer self);
static void rygel_av_transport_play_cb (RygelAVTransport* self,
                                 GUPnPService* service,
                                 GUPnPServiceAction* action);
static void _rygel_av_transport_play_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                               GUPnPServiceAction* action,
                                                               gpointer self);
static void rygel_av_transport_pause_cb (RygelAVTransport* self,
                                  GUPnPService* service,
                                  GUPnPServiceAction* action);
static void _rygel_av_transport_pause_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                GUPnPServiceAction* action,
                                                                gpointer self);
static void rygel_av_transport_seek_cb (RygelAVTransport* self,
                                 GUPnPService* service,
                                 GUPnPServiceAction* action);
static void _rygel_av_transport_seek_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                               GUPnPServiceAction* action,
                                                               gpointer self);
static void rygel_av_transport_next_cb (RygelAVTransport* self,
                                 GUPnPService* service,
                                 GUPnPServiceAction* action);
static void _rygel_av_transport_next_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                               GUPnPServiceAction* action,
                                                               gpointer self);
static void rygel_av_transport_previous_cb (RygelAVTransport* self,
                                     GUPnPService* service,
                                     GUPnPServiceAction* action);
static void _rygel_av_transport_previous_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                   GUPnPServiceAction* action,
                                                                   gpointer self);
static void rygel_av_transport_x_dlna_get_byte_position_info_cb (RygelAVTransport* self,
                                                          GUPnPService* service,
                                                          GUPnPServiceAction* action);
static void _rygel_av_transport_x_dlna_get_byte_position_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                                        GUPnPServiceAction* action,
                                                                                        gpointer self);
static void rygel_av_transport_set_play_mode_cb (RygelAVTransport* self,
                                          GUPnPService* service,
                                          GUPnPServiceAction* action);
static void _rygel_av_transport_set_play_mode_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                        GUPnPServiceAction* action,
                                                                        gpointer self);
static void rygel_av_transport_notify_state_cb (RygelAVTransport* self,
                                         GObject* controller,
                                         GParamSpec* p);
static void _rygel_av_transport_notify_state_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void rygel_av_transport_notify_n_tracks_cb (RygelAVTransport* self,
                                            GObject* controller,
                                            GParamSpec* p);
static void _rygel_av_transport_notify_n_tracks_cb_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void rygel_av_transport_notify_track_cb (RygelAVTransport* self,
                                         GObject* controller,
                                         GParamSpec* p);
static void _rygel_av_transport_notify_track_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void rygel_av_transport_notify_uri_cb (RygelAVTransport* self,
                                       GObject* controller,
                                       GParamSpec* p);
static void _rygel_av_transport_notify_uri_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void rygel_av_transport_notify_meta_data_cb (RygelAVTransport* self,
                                             GObject* player,
                                             GParamSpec* p);
static void _rygel_av_transport_notify_meta_data_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void rygel_av_transport_notify_track_uri_cb (RygelAVTransport* self,
                                             GObject* player,
                                             GParamSpec* p);
static void _rygel_av_transport_notify_track_uri_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void rygel_av_transport_notify_track_meta_data_cb (RygelAVTransport* self,
                                                   GObject* player,
                                                   GParamSpec* p);
static void _rygel_av_transport_notify_track_meta_data_cb_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void rygel_av_transport_notify_next_uri_cb (RygelAVTransport* self,
                                            GObject* controller,
                                            GParamSpec* p);
static void _rygel_av_transport_notify_next_uri_cb_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void rygel_av_transport_notify_next_meta_data_cb (RygelAVTransport* self,
                                                  GObject* player,
                                                  GParamSpec* p);
static void _rygel_av_transport_notify_next_meta_data_cb_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void rygel_av_transport_notify_play_mode_cb (RygelAVTransport* self,
                                             GObject* player,
                                             GParamSpec* p);
static void _rygel_av_transport_notify_play_mode_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void rygel_av_transport_notify_duration_cb (RygelAVTransport* self,
                                            GObject* player,
                                            GParamSpec* p);
static void _rygel_av_transport_notify_duration_cb_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
VALA_EXTERN void rygel_change_log_log (RygelChangeLog* self,
                           const gchar* variable,
                           const gchar* value);
VALA_EXTERN const gchar* rygel_av_transport_get_status (RygelAVTransport* self);
VALA_EXTERN const gchar* rygel_av_transport_get_playback_medium (RygelAVTransport* self);
VALA_EXTERN const gchar* rygel_av_transport_get_possible_playback_media (RygelAVTransport* self);
VALA_EXTERN gchar* rygel_change_log_finish (RygelChangeLog* self);
static gboolean rygel_av_transport_check_instance_id (RygelAVTransport* self,
                                               GUPnPServiceAction* action);
static void rygel_av_transport_handle_new_transport_uri (RygelAVTransport* self,
                                                  GUPnPServiceAction* action,
                                                  const gchar* uri,
                                                  const gchar* metadata,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void rygel_av_transport_handle_new_transport_uri_finish (RygelAVTransport* self,
                                                         GAsyncResult* _res_);
static gboolean rygel_av_transport_is_valid_mime_type (RygelAVTransport* self,
                                                const gchar* mime);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
VALA_EXTERN gint64 rygel_time_utils_time_from_string (const gchar* str);
static GUPnPMediaCollection* rygel_av_transport_parse_m3u_playlist (RygelAVTransport* self,
                                                             GBytes* data,
                                                             GError** error);
static void _vala_GUPnPServiceAction_free (GUPnPServiceAction* self);
static void rygel_av_transport_handle_playlist_data_free (gpointer _data);
static GUPnPServiceAction* _vala_GUPnPServiceAction_copy (GUPnPServiceAction* self);
static void rygel_av_transport_handle_playlist (RygelAVTransport* self,
                                         GUPnPServiceAction* action,
                                         const gchar* uri,
                                         const gchar* metadata,
                                         const gchar* mime,
                                         const gchar* features,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void rygel_av_transport_handle_playlist_finish (RygelAVTransport* self,
                                                GAsyncResult* _res_);
static gboolean rygel_av_transport_handle_playlist_co (RygelAvTransportHandlePlaylistData* _data_);
static void rygel_av_transport_handle_playlist_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean rygel_av_transport_is_playlist (RygelAVTransport* self,
                                         const gchar* mime,
                                         const gchar* features);
static void rygel_av_transport_handle_new_transport_uri_data_free (gpointer _data);
static gboolean rygel_av_transport_handle_new_transport_uri_co (RygelAvTransportHandleNewTransportUriData* _data_);
static void rygel_av_transport_set_single_play_uri (RygelAVTransport* self,
                                             GUPnPServiceAction* action,
                                             const gchar* uri,
                                             const gchar* metadata,
                                             const gchar* mime,
                                             const gchar* features);
static void rygel_av_transport_handle_new_transport_uri_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
VALA_EXTERN RygelAVTransport* rygel_av_transport_new (void);
VALA_EXTERN RygelAVTransport* rygel_av_transport_construct (GType object_type);
VALA_EXTERN void rygel_av_transport_set_status (RygelAVTransport* self,
                                    const gchar* value);
VALA_EXTERN gchar* rygel_av_transport_get_speed (RygelAVTransport* self);
VALA_EXTERN void rygel_av_transport_set_speed (RygelAVTransport* self,
                                   const gchar* value);
static void rygel_av_transport_finalize (GObject * obj);
static GType rygel_av_transport_get_type_once (void);
static void _vala_rygel_av_transport_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_rygel_av_transport_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
rygel_av_transport_get_instance_private (RygelAVTransport* self)
{
	return G_STRUCT_MEMBER_P (self, RygelAVTransport_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	return self ? g_object_ref (self) : NULL;
#line 534 "rygel-av-transport.c"
}

static void
_rygel_av_transport_query_last_change_cb_gupnp_service_query_variable (GUPnPService* _sender,
                                                                       const gchar* variable,
                                                                       GValue* value,
                                                                       gpointer self)
{
#line 98 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_query_last_change_cb ((RygelAVTransport*) self, _sender, variable, value);
#line 545 "rygel-av-transport.c"
}

static void
_rygel_av_transport_set_av_transport_uri_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                          GUPnPServiceAction* action,
                                                                          gpointer self)
{
#line 100 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_set_av_transport_uri_cb ((RygelAVTransport*) self, _sender, action);
#line 555 "rygel-av-transport.c"
}

static void
_rygel_av_transport_set_next_av_transport_uri_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                               GUPnPServiceAction* action,
                                                                               gpointer self)
{
#line 102 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_set_next_av_transport_uri_cb ((RygelAVTransport*) self, _sender, action);
#line 565 "rygel-av-transport.c"
}

static void
_rygel_av_transport_get_media_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                    GUPnPServiceAction* action,
                                                                    gpointer self)
{
#line 104 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_get_media_info_cb ((RygelAVTransport*) self, _sender, action);
#line 575 "rygel-av-transport.c"
}

static void
_rygel_av_transport_get_media_info_ex_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                       GUPnPServiceAction* action,
                                                                       gpointer self)
{
#line 105 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_get_media_info_ex_cb ((RygelAVTransport*) self, _sender, action);
#line 585 "rygel-av-transport.c"
}

static void
_rygel_av_transport_get_transport_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                        GUPnPServiceAction* action,
                                                                        gpointer self)
{
#line 106 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_get_transport_info_cb ((RygelAVTransport*) self, _sender, action);
#line 595 "rygel-av-transport.c"
}

static void
_rygel_av_transport_get_position_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                       GUPnPServiceAction* action,
                                                                       gpointer self)
{
#line 107 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_get_position_info_cb ((RygelAVTransport*) self, _sender, action);
#line 605 "rygel-av-transport.c"
}

static void
_rygel_av_transport_get_device_capabilities_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                             GUPnPServiceAction* action,
                                                                             gpointer self)
{
#line 108 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_get_device_capabilities_cb ((RygelAVTransport*) self, _sender, action);
#line 615 "rygel-av-transport.c"
}

static void
_rygel_av_transport_get_transport_settings_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                            GUPnPServiceAction* action,
                                                                            gpointer self)
{
#line 110 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_get_transport_settings_cb ((RygelAVTransport*) self, _sender, action);
#line 625 "rygel-av-transport.c"
}

static void
_rygel_av_transport_get_transport_actions_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                           GUPnPServiceAction* action,
                                                                           gpointer self)
{
#line 112 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_get_transport_actions_cb ((RygelAVTransport*) self, _sender, action);
#line 635 "rygel-av-transport.c"
}

static void
_rygel_av_transport_stop_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                          GUPnPServiceAction* action,
                                                          gpointer self)
{
#line 114 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_stop_cb ((RygelAVTransport*) self, _sender, action);
#line 645 "rygel-av-transport.c"
}

static void
_rygel_av_transport_play_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                          GUPnPServiceAction* action,
                                                          gpointer self)
{
#line 115 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_play_cb ((RygelAVTransport*) self, _sender, action);
#line 655 "rygel-av-transport.c"
}

static void
_rygel_av_transport_pause_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                           GUPnPServiceAction* action,
                                                           gpointer self)
{
#line 116 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_pause_cb ((RygelAVTransport*) self, _sender, action);
#line 665 "rygel-av-transport.c"
}

static void
_rygel_av_transport_seek_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                          GUPnPServiceAction* action,
                                                          gpointer self)
{
#line 117 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_seek_cb ((RygelAVTransport*) self, _sender, action);
#line 675 "rygel-av-transport.c"
}

static void
_rygel_av_transport_next_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                          GUPnPServiceAction* action,
                                                          gpointer self)
{
#line 118 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_next_cb ((RygelAVTransport*) self, _sender, action);
#line 685 "rygel-av-transport.c"
}

static void
_rygel_av_transport_previous_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                              GUPnPServiceAction* action,
                                                              gpointer self)
{
#line 119 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_previous_cb ((RygelAVTransport*) self, _sender, action);
#line 695 "rygel-av-transport.c"
}

static void
_rygel_av_transport_x_dlna_get_byte_position_info_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                                   GUPnPServiceAction* action,
                                                                                   gpointer self)
{
#line 120 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_x_dlna_get_byte_position_info_cb ((RygelAVTransport*) self, _sender, action);
#line 705 "rygel-av-transport.c"
}

static void
_rygel_av_transport_set_play_mode_cb_gupnp_service_action_invoked (GUPnPService* _sender,
                                                                   GUPnPServiceAction* action,
                                                                   gpointer self)
{
#line 122 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_set_play_mode_cb ((RygelAVTransport*) self, _sender, action);
#line 715 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_state_cb_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 124 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_state_cb ((RygelAVTransport*) self, _sender, pspec);
#line 725 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_n_tracks_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 125 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_n_tracks_cb ((RygelAVTransport*) self, _sender, pspec);
#line 735 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_track_cb_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 126 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_track_cb ((RygelAVTransport*) self, _sender, pspec);
#line 745 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_uri_cb_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 127 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_uri_cb ((RygelAVTransport*) self, _sender, pspec);
#line 755 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_meta_data_cb_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 128 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_meta_data_cb ((RygelAVTransport*) self, _sender, pspec);
#line 765 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_track_uri_cb_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 129 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_track_uri_cb ((RygelAVTransport*) self, _sender, pspec);
#line 775 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_track_meta_data_cb_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 130 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_track_meta_data_cb ((RygelAVTransport*) self, _sender, pspec);
#line 785 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_next_uri_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 131 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_next_uri_cb ((RygelAVTransport*) self, _sender, pspec);
#line 795 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_next_meta_data_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 132 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_next_meta_data_cb ((RygelAVTransport*) self, _sender, pspec);
#line 805 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_play_mode_cb_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 133 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_play_mode_cb ((RygelAVTransport*) self, _sender, pspec);
#line 815 "rygel-av-transport.c"
}

static void
_rygel_av_transport_notify_duration_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 135 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_notify_duration_cb ((RygelAVTransport*) self, _sender, pspec);
#line 825 "rygel-av-transport.c"
}

static void
rygel_av_transport_real_constructed (GObject* base)
{
	RygelAVTransport * self;
	RygelMediaRendererPlugin* plugin = NULL;
	GUPnPRootDevice* _tmp0_;
	GUPnPRootDevice* _tmp1_;
	GUPnPRootDevice* _tmp2_;
	GUPnPResourceFactory* _tmp3_;
	GUPnPResourceFactory* _tmp4_;
	RygelMediaRendererPlugin* _tmp5_;
	RygelMediaRendererPlugin* _tmp6_;
	RygelChangeLog* _tmp7_;
	RygelMediaPlayer* _tmp8_;
	RygelMediaRendererPlugin* _tmp9_;
	RygelPlayerController* _tmp10_;
	RygelPlayerController* _tmp11_;
	RygelPlayerController* _tmp12_;
	RygelPlayerController* _tmp13_;
	RygelPlayerController* _tmp14_;
	RygelPlayerController* _tmp15_;
	RygelPlayerController* _tmp16_;
	RygelPlayerController* _tmp17_;
	RygelPlayerController* _tmp18_;
	RygelPlayerController* _tmp19_;
	RygelPlayerController* _tmp20_;
	RygelMediaPlayer* _tmp21_;
	RygelMediaPlayer* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gboolean _tmp26_;
	SoupSession* _tmp30_;
	SoupSession* _tmp31_;
	RygelMediaPlayer* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	RygelMediaRendererPlugin* _tmp36_;
	gchar* _tmp37_;
#line 90 "../src/librygel-renderer/rygel-av-transport.vala"
	self = (RygelAVTransport*) base;
#line 91 "../src/librygel-renderer/rygel-av-transport.vala"
	G_OBJECT_CLASS (rygel_av_transport_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gupnp_service_get_type (), GUPnPService));
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_get ((GUPnPService*) self, "root-device", &_tmp0_, NULL);
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = _tmp0_;
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = gupnp_device_info_get_resource_factory ((GUPnPDeviceInfo*) _tmp2_);
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = _g_object_ref0 (RYGEL_IS_MEDIA_RENDERER_PLUGIN (_tmp4_) ? ((RygelMediaRendererPlugin*) _tmp4_) : NULL);
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = _tmp5_;
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (_tmp2_);
#line 92 "../src/librygel-renderer/rygel-av-transport.vala"
	plugin = _tmp6_;
#line 94 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = rygel_change_log_new ((GUPnPService*) self, RYGEL_AV_TRANSPORT_LAST_CHANGE_NS);
#line 94 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (self->priv->changelog);
#line 94 "../src/librygel-renderer/rygel-av-transport.vala"
	self->priv->changelog = _tmp7_;
#line 95 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = rygel_av_transport_get_player (self);
#line 95 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (self->priv->player);
#line 95 "../src/librygel-renderer/rygel-av-transport.vala"
	self->priv->player = _tmp8_;
#line 96 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = plugin;
#line 96 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp10_ = rygel_media_renderer_plugin_get_controller (_tmp9_);
#line 96 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (self->priv->controller);
#line 96 "../src/librygel-renderer/rygel-av-transport.vala"
	self->priv->controller = _tmp10_;
#line 98 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::LastChange", (GCallback) _rygel_av_transport_query_last_change_cb_gupnp_service_query_variable, self, 0);
#line 100 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::SetAVTransportURI", (GCallback) _rygel_av_transport_set_av_transport_uri_cb_gupnp_service_action_invoked, self, 0);
#line 102 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::SetNextAVTransportURI", (GCallback) _rygel_av_transport_set_next_av_transport_uri_cb_gupnp_service_action_invoked, self, 0);
#line 104 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetMediaInfo", (GCallback) _rygel_av_transport_get_media_info_cb_gupnp_service_action_invoked, self, 0);
#line 105 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetMediaInfo_Ext", (GCallback) _rygel_av_transport_get_media_info_ex_cb_gupnp_service_action_invoked, self, 0);
#line 106 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetTransportInfo", (GCallback) _rygel_av_transport_get_transport_info_cb_gupnp_service_action_invoked, self, 0);
#line 107 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetPositionInfo", (GCallback) _rygel_av_transport_get_position_info_cb_gupnp_service_action_invoked, self, 0);
#line 108 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetDeviceCapabilities", (GCallback) _rygel_av_transport_get_device_capabilities_cb_gupnp_service_action_invoked, self, 0);
#line 110 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetTransportSettings", (GCallback) _rygel_av_transport_get_transport_settings_cb_gupnp_service_action_invoked, self, 0);
#line 112 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetCurrentTransportActions", (GCallback) _rygel_av_transport_get_transport_actions_cb_gupnp_service_action_invoked, self, 0);
#line 114 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::Stop", (GCallback) _rygel_av_transport_stop_cb_gupnp_service_action_invoked, self, 0);
#line 115 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::Play", (GCallback) _rygel_av_transport_play_cb_gupnp_service_action_invoked, self, 0);
#line 116 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::Pause", (GCallback) _rygel_av_transport_pause_cb_gupnp_service_action_invoked, self, 0);
#line 117 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::Seek", (GCallback) _rygel_av_transport_seek_cb_gupnp_service_action_invoked, self, 0);
#line 118 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::Next", (GCallback) _rygel_av_transport_next_cb_gupnp_service_action_invoked, self, 0);
#line 119 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::Previous", (GCallback) _rygel_av_transport_previous_cb_gupnp_service_action_invoked, self, 0);
#line 120 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::X_DLNA_GetBytePositionInfo", (GCallback) _rygel_av_transport_x_dlna_get_byte_position_info_cb_gupnp_service_action_invoked, self, 0);
#line 122 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::SetPlayMode", (GCallback) _rygel_av_transport_set_play_mode_cb_gupnp_service_action_invoked, self, 0);
#line 124 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp11_ = self->priv->controller;
#line 124 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp11_, "notify::playback-state", (GCallback) _rygel_av_transport_notify_state_cb_g_object_notify, self, 0);
#line 125 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp12_ = self->priv->controller;
#line 125 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify::n-tracks", (GCallback) _rygel_av_transport_notify_n_tracks_cb_g_object_notify, self, 0);
#line 126 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp13_ = self->priv->controller;
#line 126 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::track", (GCallback) _rygel_av_transport_notify_track_cb_g_object_notify, self, 0);
#line 127 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp14_ = self->priv->controller;
#line 127 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp14_, "notify::uri", (GCallback) _rygel_av_transport_notify_uri_cb_g_object_notify, self, 0);
#line 128 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp15_ = self->priv->controller;
#line 128 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::metadata", (GCallback) _rygel_av_transport_notify_meta_data_cb_g_object_notify, self, 0);
#line 129 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp16_ = self->priv->controller;
#line 129 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp16_, "notify::track-uri", (GCallback) _rygel_av_transport_notify_track_uri_cb_g_object_notify, self, 0);
#line 130 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp17_ = self->priv->controller;
#line 130 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp17_, "notify::track-metadata", (GCallback) _rygel_av_transport_notify_track_meta_data_cb_g_object_notify, self, 0);
#line 131 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp18_ = self->priv->controller;
#line 131 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp18_, "notify::next-uri", (GCallback) _rygel_av_transport_notify_next_uri_cb_g_object_notify, self, 0);
#line 132 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp19_ = self->priv->controller;
#line 132 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp19_, "notify::next-metadata", (GCallback) _rygel_av_transport_notify_next_meta_data_cb_g_object_notify, self, 0);
#line 133 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp20_ = self->priv->controller;
#line 133 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp20_, "notify::play-mode", (GCallback) _rygel_av_transport_notify_play_mode_cb_g_object_notify, self, 0);
#line 135 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp21_ = self->priv->player;
#line 135 "../src/librygel-renderer/rygel-av-transport.vala"
	g_signal_connect_object ((GObject*) _tmp21_, "notify::duration", (GCallback) _rygel_av_transport_notify_duration_cb_g_object_notify, self, 0);
#line 139 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp22_ = self->priv->player;
#line 139 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp23_ = rygel_media_player_get_user_agent (_tmp22_);
#line 139 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp24_ = _tmp23_;
#line 139 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp25_ = _tmp24_;
#line 139 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp26_ = _tmp25_ == NULL;
#line 139 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp25_);
#line 139 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp26_) {
#line 1004 "rygel-av-transport.c"
		RygelMediaPlayer* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 140 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp27_ = self->priv->player;
#line 140 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp28_ = g_strdup_printf ("Rygel/%s DLNADOC/1.50 UPnP/1.0", PACKAGE_VERSION);
#line 140 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp29_ = _tmp28_;
#line 140 "../src/librygel-renderer/rygel-av-transport.vala"
		rygel_media_player_set_user_agent (_tmp27_, _tmp29_);
#line 140 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (_tmp29_);
#line 1018 "rygel-av-transport.c"
	}
#line 144 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp30_ = soup_session_new ();
#line 144 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (self->priv->session);
#line 144 "../src/librygel-renderer/rygel-av-transport.vala"
	self->priv->session = _tmp30_;
#line 145 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp31_ = self->priv->session;
#line 145 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp32_ = self->priv->player;
#line 145 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp33_ = rygel_media_player_get_user_agent (_tmp32_);
#line 145 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp34_ = _tmp33_;
#line 145 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp35_ = _tmp34_;
#line 145 "../src/librygel-renderer/rygel-av-transport.vala"
	soup_session_set_user_agent (_tmp31_, _tmp35_);
#line 145 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp35_);
#line 147 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp36_ = plugin;
#line 147 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp37_ = rygel_media_renderer_plugin_get_protocol_info (_tmp36_);
#line 147 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (self->priv->protocol_info);
#line 147 "../src/librygel-renderer/rygel-av-transport.vala"
	self->priv->protocol_info = _tmp37_;
#line 90 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (plugin);
#line 1050 "rygel-av-transport.c"
}

static RygelMediaPlayer*
rygel_av_transport_get_player (RygelAVTransport* self)
{
	RygelMediaRendererPlugin* plugin = NULL;
	GUPnPRootDevice* _tmp0_;
	GUPnPRootDevice* _tmp1_;
	GUPnPRootDevice* _tmp2_;
	GUPnPResourceFactory* _tmp3_;
	GUPnPResourceFactory* _tmp4_;
	RygelMediaRendererPlugin* _tmp5_;
	RygelMediaRendererPlugin* _tmp6_;
	RygelMediaPlayer* _tmp7_;
	RygelMediaPlayer* result;
#line 150 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_get ((GUPnPService*) self, "root-device", &_tmp0_, NULL);
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = _tmp0_;
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = gupnp_device_info_get_resource_factory ((GUPnPDeviceInfo*) _tmp2_);
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = _g_object_ref0 (RYGEL_IS_MEDIA_RENDERER_PLUGIN (_tmp4_) ? ((RygelMediaRendererPlugin*) _tmp4_) : NULL);
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = _tmp5_;
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (_tmp2_);
#line 151 "../src/librygel-renderer/rygel-av-transport.vala"
	plugin = _tmp6_;
#line 153 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = rygel_media_renderer_plugin_get_player (plugin);
#line 153 "../src/librygel-renderer/rygel-av-transport.vala"
	result = _tmp7_;
#line 153 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (plugin);
#line 153 "../src/librygel-renderer/rygel-av-transport.vala"
	return result;
#line 1094 "rygel-av-transport.c"
}

static void
rygel_av_transport_query_last_change_cb (RygelAVTransport* self,
                                         GUPnPService* service,
                                         const gchar* variable,
                                         GValue* value)
{
	RygelChangeLog* log = NULL;
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	RygelPlayerController* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	RygelPlayerController* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	RygelMediaPlayer* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	RygelPlayerController* _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	RygelPlayerController* _tmp26_;
	guint _tmp27_;
	guint _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	RygelMediaPlayer* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	RygelMediaPlayer* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	RygelPlayerController* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	RygelPlayerController* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	RygelPlayerController* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	RygelPlayerController* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	RygelPlayerController* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	RygelPlayerController* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
#line 156 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 156 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (variable != NULL);
#line 156 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (value != NULL);
#line 160 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = rygel_change_log_new (NULL, RYGEL_AV_TRANSPORT_LAST_CHANGE_NS);
#line 160 "../src/librygel-renderer/rygel-av-transport.vala"
	log = _tmp0_;
#line 162 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 162 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_playback_state (_tmp1_);
#line 162 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 162 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "TransportState", _tmp3_);
#line 163 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = self->priv->controller;
#line 163 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = rygel_player_controller_get_current_transport_actions (_tmp4_);
#line 163 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = _tmp5_;
#line 163 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = _tmp6_;
#line 163 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "CurrentTransportActions", _tmp7_);
#line 163 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp7_);
#line 165 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = rygel_av_transport_get_status (self);
#line 165 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = _tmp8_;
#line 165 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "TransportStatus", _tmp9_);
#line 166 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp10_ = rygel_av_transport_get_playback_medium (self);
#line 166 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp11_ = _tmp10_;
#line 166 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "PlaybackStorageMedium", _tmp11_);
#line 167 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "RecordStorageMedium", "NOT_IMPLEMENTED");
#line 168 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp12_ = rygel_av_transport_get_possible_playback_media (self);
#line 168 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp13_ = _tmp12_;
#line 168 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "PossiblePlaybackStorageMedia", _tmp13_);
#line 169 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "PossibleRecordStorageMedia", "NOT_IMPLEMENTED");
#line 170 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp14_ = self->priv->controller;
#line 170 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp15_ = rygel_player_controller_get_play_mode (_tmp14_);
#line 170 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp16_ = _tmp15_;
#line 170 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "CurrentPlayMode", _tmp16_);
#line 171 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp17_ = self->priv->player;
#line 171 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp18_ = rygel_media_player_get_playback_speed (_tmp17_);
#line 171 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp19_ = _tmp18_;
#line 171 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp20_ = _tmp19_;
#line 171 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "TransportPlaySpeed", _tmp20_);
#line 171 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp20_);
#line 172 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "RecordMediumWriteStatus", "NOT_IMPLEMENTED");
#line 173 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "CurrentRecordQualityMode", "NOT_IMPLEMENTED");
#line 174 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "PossibleRecordQualityModes", "NOT_IMPLEMENTED");
#line 175 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp21_ = self->priv->controller;
#line 175 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp22_ = rygel_player_controller_get_n_tracks (_tmp21_);
#line 175 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp23_ = _tmp22_;
#line 175 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp24_ = g_strdup_printf ("%u", _tmp23_);
#line 175 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp25_ = _tmp24_;
#line 175 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "NumberOfTracks", _tmp25_);
#line 175 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp25_);
#line 176 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp26_ = self->priv->controller;
#line 176 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp27_ = rygel_player_controller_get_track (_tmp26_);
#line 176 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp28_ = _tmp27_;
#line 176 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp29_ = g_strdup_printf ("%u", _tmp28_);
#line 176 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp30_ = _tmp29_;
#line 176 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "CurrentTrack", _tmp30_);
#line 176 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp30_);
#line 177 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp31_ = self->priv->player;
#line 177 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp32_ = rygel_media_player_get_duration_as_str (_tmp31_);
#line 177 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp33_ = _tmp32_;
#line 177 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp34_ = _tmp33_;
#line 177 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "CurrentTrackDuration", _tmp34_);
#line 177 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp34_);
#line 178 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp35_ = self->priv->player;
#line 178 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp36_ = rygel_media_player_get_duration_as_str (_tmp35_);
#line 178 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp37_ = _tmp36_;
#line 178 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp38_ = _tmp37_;
#line 178 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "CurrentMediaDuration", _tmp38_);
#line 178 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp38_);
#line 179 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp39_ = self->priv->controller;
#line 179 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp40_ = rygel_player_controller_get_uri (_tmp39_);
#line 179 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp41_ = _tmp40_;
#line 179 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp42_ = _tmp41_;
#line 179 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "AVTransportURI", _tmp42_);
#line 179 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp42_);
#line 180 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp43_ = self->priv->controller;
#line 180 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp44_ = rygel_player_controller_get_metadata (_tmp43_);
#line 180 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp45_ = _tmp44_;
#line 180 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp46_ = _tmp45_;
#line 180 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "AVTransportURIMetaData", _tmp46_);
#line 180 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp46_);
#line 181 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp47_ = self->priv->controller;
#line 181 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp48_ = rygel_player_controller_get_track_uri (_tmp47_);
#line 181 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp49_ = _tmp48_;
#line 181 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp50_ = _tmp49_;
#line 181 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "CurrentTrackURI", _tmp50_);
#line 181 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp50_);
#line 182 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp51_ = self->priv->controller;
#line 182 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp52_ = rygel_player_controller_get_track_metadata (_tmp51_);
#line 182 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp53_ = _tmp52_;
#line 182 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp54_ = _tmp53_;
#line 182 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "CurrentTrackMetaData", _tmp54_);
#line 182 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp54_);
#line 183 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp55_ = self->priv->controller;
#line 183 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp56_ = rygel_player_controller_get_next_uri (_tmp55_);
#line 183 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp57_ = _tmp56_;
#line 183 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp58_ = _tmp57_;
#line 183 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "NextAVTransportURI", _tmp58_);
#line 183 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp58_);
#line 184 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp59_ = self->priv->controller;
#line 184 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp60_ = rygel_player_controller_get_next_metadata (_tmp59_);
#line 184 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp61_ = _tmp60_;
#line 184 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp62_ = _tmp61_;
#line 184 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (log, "NextAVTransportURIMetaData", _tmp62_);
#line 184 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp62_);
#line 186 "../src/librygel-renderer/rygel-av-transport.vala"
	g_value_init (value, G_TYPE_STRING);
#line 187 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp63_ = rygel_change_log_finish (log);
#line 187 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp64_ = _tmp63_;
#line 187 "../src/librygel-renderer/rygel-av-transport.vala"
	g_value_set_string (value, _tmp64_);
#line 187 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp64_);
#line 156 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (log);
#line 1385 "rygel-av-transport.c"
}

static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar** unparsed,
                 guint _base)
{
	gint64 _vala__result_ = 0LL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 783 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 785 "glib-2.0.vapi"
	errno = 0;
#line 786 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, _base);
#line 786 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 786 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 787 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 787 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 787 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 787 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 1421 "rygel-av-transport.c"
		gboolean _tmp5_ = FALSE;
#line 788 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 789 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 789 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 1429 "rygel-av-transport.c"
		} else {
#line 789 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 1433 "rygel-av-transport.c"
		}
#line 789 "glib-2.0.vapi"
		result = _tmp5_;
#line 789 "glib-2.0.vapi"
		if (_result_) {
#line 789 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1441 "rygel-av-transport.c"
		}
#line 789 "glib-2.0.vapi"
		if (unparsed) {
#line 789 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1447 "rygel-av-transport.c"
		}
#line 789 "glib-2.0.vapi"
		return result;
#line 1451 "rygel-av-transport.c"
	} else {
		gchar* _tmp6_;
#line 791 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 791 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 792 "glib-2.0.vapi"
		result = FALSE;
#line 792 "glib-2.0.vapi"
		if (_result_) {
#line 792 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1464 "rygel-av-transport.c"
		}
#line 792 "glib-2.0.vapi"
		if (unparsed) {
#line 792 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1470 "rygel-av-transport.c"
		}
#line 792 "glib-2.0.vapi"
		return result;
#line 1474 "rygel-av-transport.c"
	}
}

static gboolean
rygel_av_transport_check_instance_id (RygelAVTransport* self,
                                      GUPnPServiceAction* action)
{
	gchar* instance_id_string = NULL;
	gint64 instance_id = 0LL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result;
#line 191 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 191 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (action != NULL, FALSE);
#line 193 "../src/librygel-renderer/rygel-av-transport.vala"
	instance_id = (gint64) -1;
#line 195 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_get (action, "InstanceID", G_TYPE_STRING, &_tmp0_, NULL);
#line 195 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (instance_id_string);
#line 195 "../src/librygel-renderer/rygel-av-transport.vala"
	instance_id_string = _tmp0_;
#line 196 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = instance_id_string;
#line 196 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp2_ == NULL) {
#line 196 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp1_ = TRUE;
#line 1506 "rygel-av-transport.c"
	} else {
		const gchar* _tmp3_;
		gint64 _tmp4_ = 0LL;
		gboolean _tmp5_;
#line 197 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp3_ = instance_id_string;
#line 197 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp5_ = int64_try_parse (_tmp3_, &_tmp4_, NULL, (guint) 0);
#line 197 "../src/librygel-renderer/rygel-av-transport.vala"
		instance_id = _tmp4_;
#line 197 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp1_ = !_tmp5_;
#line 1519 "rygel-av-transport.c"
	}
#line 196 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp1_) {
#line 198 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (action, (guint) 402, _ ("Invalid argument"));
#line 200 "../src/librygel-renderer/rygel-av-transport.vala"
		result = FALSE;
#line 200 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (instance_id_string);
#line 200 "../src/librygel-renderer/rygel-av-transport.vala"
		return result;
#line 1531 "rygel-av-transport.c"
	}
#line 203 "../src/librygel-renderer/rygel-av-transport.vala"
	if (instance_id != ((gint64) 0)) {
#line 204 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (action, (guint) 718, _ ("Invalid InstanceID"));
#line 206 "../src/librygel-renderer/rygel-av-transport.vala"
		result = FALSE;
#line 206 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (instance_id_string);
#line 206 "../src/librygel-renderer/rygel-av-transport.vala"
		return result;
#line 1543 "rygel-av-transport.c"
	}
#line 209 "../src/librygel-renderer/rygel-av-transport.vala"
	result = TRUE;
#line 209 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (instance_id_string);
#line 209 "../src/librygel-renderer/rygel-av-transport.vala"
	return result;
#line 1551 "rygel-av-transport.c"
}

static void
rygel_av_transport_set_av_transport_uri_cb (RygelAVTransport* self,
                                            GUPnPService* service,
                                            GUPnPServiceAction* action)
{
	gchar* _uri = NULL;
	gchar* _metadata = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 212 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 212 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 214 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 215 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 1575 "rygel-av-transport.c"
	}
#line 220 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_get (action, "CurrentURI", G_TYPE_STRING, &_tmp0_, "CurrentURIMetaData", G_TYPE_STRING, &_tmp1_, NULL);
#line 220 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_uri);
#line 220 "../src/librygel-renderer/rygel-av-transport.vala"
	_uri = _tmp0_;
#line 220 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_metadata);
#line 220 "../src/librygel-renderer/rygel-av-transport.vala"
	_metadata = _tmp1_;
#line 227 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _uri;
#line 227 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _metadata;
#line 227 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_handle_new_transport_uri (self, action, _tmp2_, _tmp3_, NULL, NULL);
#line 212 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_metadata);
#line 212 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_uri);
#line 1597 "rygel-av-transport.c"
}

static void
rygel_av_transport_set_next_av_transport_uri_cb (RygelAVTransport* self,
                                                 GUPnPService* service,
                                                 GUPnPServiceAction* action)
{
	gchar* _uri = NULL;
	gchar* _metadata = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 230 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 230 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 232 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 233 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 1621 "rygel-av-transport.c"
	}
#line 238 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_get (action, "NextURI", G_TYPE_STRING, &_tmp0_, "NextURIMetaData", G_TYPE_STRING, &_tmp1_, NULL);
#line 238 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_uri);
#line 238 "../src/librygel-renderer/rygel-av-transport.vala"
	_uri = _tmp0_;
#line 238 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_metadata);
#line 238 "../src/librygel-renderer/rygel-av-transport.vala"
	_metadata = _tmp1_;
#line 245 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _uri;
#line 245 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _metadata;
#line 245 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_handle_new_transport_uri (self, action, _tmp2_, _tmp3_, NULL, NULL);
#line 230 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_metadata);
#line 230 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_uri);
#line 1643 "rygel-av-transport.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1665 "rygel-av-transport.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1669 "rygel-av-transport.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1675 "rygel-av-transport.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1679 "rygel-av-transport.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1683 "rygel-av-transport.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1691 "rygel-av-transport.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1719 "rygel-av-transport.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1728 "rygel-av-transport.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1742 "rygel-av-transport.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1751 "rygel-av-transport.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1765 "rygel-av-transport.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1774 "rygel-av-transport.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1783 "rygel-av-transport.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	for (i = 0; i < stack_length; i++) {
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
			return TRUE;
#line 1798 "rygel-av-transport.c"
		}
	}
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	return FALSE;
#line 1803 "rygel-av-transport.c"
}

static gboolean
rygel_av_transport_is_valid_mime_type (RygelAVTransport* self,
                                       const gchar* mime)
{
	gchar* normalized = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	RygelMediaPlayer* _tmp5_;
	gint _tmp6_ = 0;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gboolean _tmp9_;
	gboolean result;
#line 248 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 249 "../src/librygel-renderer/rygel-av-transport.vala"
	if (mime == NULL) {
#line 250 "../src/librygel-renderer/rygel-av-transport.vala"
		result = FALSE;
#line 250 "../src/librygel-renderer/rygel-av-transport.vala"
		return result;
#line 1831 "rygel-av-transport.c"
	}
#line 253 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = g_utf8_strdown (mime, (gssize) -1);
#line 253 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = _tmp0_;
#line 253 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = string_replace (_tmp1_, " ", "");
#line 253 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 253 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp1_);
#line 253 "../src/librygel-renderer/rygel-av-transport.vala"
	normalized = _tmp3_;
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = normalized;
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = self->priv->player;
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = rygel_media_player_get_mime_types (_tmp5_, &_tmp6_);
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = _tmp7_;
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8__length1 = _tmp6_;
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = _vala_string_array_contains (_tmp8_, _tmp6_, _tmp4_);
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	result = _tmp9_;
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (normalized);
#line 255 "../src/librygel-renderer/rygel-av-transport.vala"
	return result;
#line 1865 "rygel-av-transport.c"
}

static void
rygel_av_transport_get_media_info_cb (RygelAVTransport* self,
                                      GUPnPService* service,
                                      GUPnPServiceAction* action)
{
	gchar* media_duration = NULL;
	RygelPlayerController* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	RygelPlayerController* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	const gchar* _tmp10_;
	RygelPlayerController* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	RygelPlayerController* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	RygelPlayerController* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	RygelPlayerController* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
#line 258 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 258 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 260 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 261 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 1909 "rygel-av-transport.c"
	}
#line 265 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 265 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_n_tracks (_tmp0_);
#line 265 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 265 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp2_ > ((guint) 1)) {
#line 1919 "rygel-av-transport.c"
		gchar* _tmp3_;
#line 268 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp3_ = g_strdup ("0:00:00");
#line 268 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (media_duration);
#line 268 "../src/librygel-renderer/rygel-av-transport.vala"
		media_duration = _tmp3_;
#line 1927 "rygel-av-transport.c"
	} else {
		RygelMediaPlayer* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 270 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp4_ = self->priv->player;
#line 270 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp5_ = rygel_media_player_get_duration_as_str (_tmp4_);
#line 270 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp6_ = _tmp5_;
#line 270 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (media_duration);
#line 270 "../src/librygel-renderer/rygel-av-transport.vala"
		media_duration = _tmp6_;
#line 1942 "rygel-av-transport.c"
	}
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = self->priv->controller;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = rygel_player_controller_get_n_tracks (_tmp7_);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = _tmp8_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp10_ = media_duration;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp11_ = self->priv->controller;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp12_ = rygel_player_controller_get_uri (_tmp11_);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp13_ = _tmp12_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp14_ = _tmp13_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp15_ = self->priv->controller;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp16_ = rygel_player_controller_get_metadata (_tmp15_);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp17_ = _tmp16_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp18_ = _tmp17_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp19_ = self->priv->controller;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp20_ = rygel_player_controller_get_next_uri (_tmp19_);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp21_ = _tmp20_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp22_ = _tmp21_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp23_ = self->priv->controller;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp24_ = rygel_player_controller_get_next_metadata (_tmp23_);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp25_ = _tmp24_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp26_ = _tmp25_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp27_ = rygel_av_transport_get_playback_medium (self);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp28_ = _tmp27_;
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_set (action, "NrTracks", G_TYPE_UINT, _tmp9_, "MediaDuration", G_TYPE_STRING, _tmp10_, "CurrentURI", G_TYPE_STRING, _tmp14_, "CurrentURIMetaData", G_TYPE_STRING, _tmp18_, "NextURI", G_TYPE_STRING, _tmp22_, "NextURIMetaData", G_TYPE_STRING, _tmp26_, "PlayMedium", G_TYPE_STRING, _tmp28_, "RecordMedium", G_TYPE_STRING, "NOT_IMPLEMENTED", "WriteStatus", G_TYPE_STRING, "NOT_IMPLEMENTED", NULL);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp26_);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp22_);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp18_);
#line 273 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp14_);
#line 301 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 258 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (media_duration);
#line 2002 "rygel-av-transport.c"
}

static void
rygel_av_transport_get_media_info_ex_cb (RygelAVTransport* self,
                                         GUPnPService* service,
                                         GUPnPServiceAction* action)
{
	gchar* media_duration = NULL;
	RygelPlayerController* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	RygelPlayerController* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	const gchar* _tmp10_;
	RygelPlayerController* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	RygelPlayerController* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	RygelPlayerController* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	RygelPlayerController* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
#line 304 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 304 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 304 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 306 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 307 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2046 "rygel-av-transport.c"
	}
#line 311 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 311 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_n_tracks (_tmp0_);
#line 311 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 311 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp2_ > ((guint) 1)) {
#line 2056 "rygel-av-transport.c"
		gchar* _tmp3_;
#line 314 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp3_ = g_strdup ("0:00:00");
#line 314 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (media_duration);
#line 314 "../src/librygel-renderer/rygel-av-transport.vala"
		media_duration = _tmp3_;
#line 2064 "rygel-av-transport.c"
	} else {
		RygelMediaPlayer* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 316 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp4_ = self->priv->player;
#line 316 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp5_ = rygel_media_player_get_duration_as_str (_tmp4_);
#line 316 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp6_ = _tmp5_;
#line 316 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (media_duration);
#line 316 "../src/librygel-renderer/rygel-av-transport.vala"
		media_duration = _tmp6_;
#line 2079 "rygel-av-transport.c"
	}
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = self->priv->controller;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = rygel_player_controller_get_n_tracks (_tmp7_);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = _tmp8_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp10_ = media_duration;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp11_ = self->priv->controller;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp12_ = rygel_player_controller_get_uri (_tmp11_);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp13_ = _tmp12_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp14_ = _tmp13_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp15_ = self->priv->controller;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp16_ = rygel_player_controller_get_metadata (_tmp15_);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp17_ = _tmp16_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp18_ = _tmp17_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp19_ = self->priv->controller;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp20_ = rygel_player_controller_get_next_uri (_tmp19_);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp21_ = _tmp20_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp22_ = _tmp21_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp23_ = self->priv->controller;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp24_ = rygel_player_controller_get_next_metadata (_tmp23_);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp25_ = _tmp24_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp26_ = _tmp25_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp27_ = rygel_av_transport_get_playback_medium (self);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp28_ = _tmp27_;
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_set (action, "CurrentType", G_TYPE_STRING, "NO_MEDIA", "NrTracks", G_TYPE_UINT, _tmp9_, "MediaDuration", G_TYPE_STRING, _tmp10_, "CurrentURI", G_TYPE_STRING, _tmp14_, "CurrentURIMetaData", G_TYPE_STRING, _tmp18_, "NextURI", G_TYPE_STRING, _tmp22_, "NextURIMetaData", G_TYPE_STRING, _tmp26_, "PlayMedium", G_TYPE_STRING, _tmp28_, "RecordMedium", G_TYPE_STRING, "NOT_IMPLEMENTED", "WriteStatus", G_TYPE_STRING, "NOT_IMPLEMENTED", NULL);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp26_);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp22_);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp18_);
#line 319 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp14_);
#line 350 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 304 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (media_duration);
#line 2139 "rygel-av-transport.c"
}

static void
rygel_av_transport_get_transport_info_cb (RygelAVTransport* self,
                                          GUPnPService* service,
                                          GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	RygelMediaPlayer* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 354 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 354 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 354 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 356 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 357 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2166 "rygel-av-transport.c"
	}
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_playback_state (_tmp0_);
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = rygel_av_transport_get_status (self);
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = self->priv->player;
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = rygel_media_player_get_playback_speed (_tmp5_);
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = _tmp6_;
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = _tmp7_;
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_set (action, "CurrentTransportState", G_TYPE_STRING, _tmp2_, "CurrentTransportStatus", G_TYPE_STRING, _tmp4_, "CurrentSpeed", G_TYPE_STRING, _tmp8_, NULL);
#line 360 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp8_);
#line 370 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 2192 "rygel-av-transport.c"
}

static void
rygel_av_transport_get_transport_actions_cb (RygelAVTransport* self,
                                             GUPnPService* service,
                                             GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 373 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 373 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 373 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 375 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 376 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2214 "rygel-av-transport.c"
	}
#line 379 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 379 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_current_transport_actions (_tmp0_);
#line 379 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 379 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 379 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_set (action, "Actions", G_TYPE_STRING, _tmp3_, NULL);
#line 379 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp3_);
#line 383 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 2230 "rygel-av-transport.c"
}

static void
rygel_av_transport_get_position_info_cb (RygelAVTransport* self,
                                         GUPnPService* service,
                                         GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	RygelMediaPlayer* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RygelPlayerController* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	RygelPlayerController* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	RygelMediaPlayer* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	RygelMediaPlayer* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	RygelMediaPlayer* _tmp23_;
	gint64 _tmp24_;
	gint64 _tmp25_;
	RygelMediaPlayer* _tmp26_;
	gint64 _tmp27_;
	gint64 _tmp28_;
#line 386 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 386 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 388 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 389 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2277 "rygel-av-transport.c"
	}
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_track (_tmp0_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = self->priv->player;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = rygel_media_player_get_duration_as_str (_tmp3_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = _tmp4_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = _tmp5_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = self->priv->controller;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = rygel_player_controller_get_track_metadata (_tmp7_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = _tmp8_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp10_ = _tmp9_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp11_ = self->priv->controller;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp12_ = rygel_player_controller_get_track_uri (_tmp11_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp13_ = _tmp12_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp14_ = _tmp13_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp15_ = self->priv->player;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp16_ = rygel_media_player_get_position_as_str (_tmp15_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp17_ = _tmp16_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp18_ = _tmp17_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp19_ = self->priv->player;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp20_ = rygel_media_player_get_position_as_str (_tmp19_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp21_ = _tmp20_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp22_ = _tmp21_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp23_ = self->priv->player;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp24_ = rygel_media_player_get_byte_position (_tmp23_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp25_ = _tmp24_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp26_ = self->priv->player;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp27_ = rygel_media_player_get_byte_position (_tmp26_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp28_ = _tmp27_;
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_set (action, "Track", G_TYPE_UINT, _tmp2_, "TrackDuration", G_TYPE_STRING, _tmp6_, "TrackMetaData", G_TYPE_STRING, _tmp10_, "TrackURI", G_TYPE_STRING, _tmp14_, "RelTime", G_TYPE_STRING, _tmp18_, "AbsTime", G_TYPE_STRING, _tmp22_, "RelCount", G_TYPE_INT64, _tmp25_, "AbsCount", G_TYPE_INT64, _tmp28_, NULL);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp22_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp18_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp14_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp10_);
#line 392 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp6_);
#line 417 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 2351 "rygel-av-transport.c"
}

static void
rygel_av_transport_get_device_capabilities_cb (RygelAVTransport* self,
                                               GUPnPService* service,
                                               GUPnPServiceAction* action)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 420 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 420 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 422 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 423 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2371 "rygel-av-transport.c"
	}
#line 426 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = rygel_av_transport_get_possible_playback_media (self);
#line 426 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = _tmp0_;
#line 426 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_set (action, "PlayMedia", G_TYPE_STRING, _tmp1_, "RecMedia", G_TYPE_STRING, "NOT_IMPLEMENTED", "RecQualityModes", G_TYPE_STRING, "NOT_IMPLEMENTED", NULL);
#line 436 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 2381 "rygel-av-transport.c"
}

static void
rygel_av_transport_get_transport_settings_cb (RygelAVTransport* self,
                                              GUPnPService* service,
                                              GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 439 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 439 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 439 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 441 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 442 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2402 "rygel-av-transport.c"
	}
#line 445 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 445 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_play_mode (_tmp0_);
#line 445 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 445 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_set (action, "PlayMode", G_TYPE_STRING, _tmp2_, "RecQualityMode", G_TYPE_STRING, "NOT_IMPLEMENTED", NULL);
#line 452 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 2414 "rygel-av-transport.c"
}

static void
rygel_av_transport_stop_cb (RygelAVTransport* self,
                            GUPnPService* service,
                            GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
#line 455 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 455 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 455 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 456 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 457 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2433 "rygel-av-transport.c"
	}
#line 460 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 460 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_player_controller_set_playback_state (_tmp0_, "STOPPED");
#line 462 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 2441 "rygel-av-transport.c"
}

static void
rygel_av_transport_play_cb (RygelAVTransport* self,
                            GUPnPService* service,
                            GUPnPServiceAction* action)
{
	gchar* speed = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	RygelMediaPlayer* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gboolean _tmp7_;
	gboolean _tmp8_ = FALSE;
	RygelPlayerController* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	RygelMediaPlayer* _tmp15_;
	const gchar* _tmp16_;
	RygelPlayerController* _tmp17_;
#line 465 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 465 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 465 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 466 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 467 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2478 "rygel-av-transport.c"
	}
#line 472 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_get (action, "Speed", G_TYPE_STRING, &_tmp0_, NULL);
#line 472 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (speed);
#line 472 "../src/librygel-renderer/rygel-av-transport.vala"
	speed = _tmp0_;
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = speed;
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = self->priv->player;
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = rygel_media_player_get_allowed_playback_speeds (_tmp2_, &_tmp4_);
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3__length1 = _tmp4_;
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = _tmp3_;
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5__length1 = _tmp3__length1;
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = _tmp5_;
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6__length1 = _tmp5__length1;
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = !_vala_string_array_contains (_tmp6_, _tmp5__length1, _tmp1_);
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 473 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp7_) {
#line 474 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (action, (guint) 717, _ ("Play speed not supported"));
#line 476 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (speed);
#line 476 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2514 "rygel-av-transport.c"
	}
#line 479 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = self->priv->controller;
#line 479 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp10_ = rygel_player_controller_get_playback_state (_tmp9_);
#line 479 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp11_ = _tmp10_;
#line 479 "../src/librygel-renderer/rygel-av-transport.vala"
	if (g_strcmp0 (_tmp11_, "STOPPED") != 0) {
#line 2524 "rygel-av-transport.c"
		RygelPlayerController* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 480 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp12_ = self->priv->controller;
#line 480 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp13_ = rygel_player_controller_get_playback_state (_tmp12_);
#line 480 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp14_ = _tmp13_;
#line 480 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp8_ = g_strcmp0 (_tmp14_, "PAUSED_PLAYBACK") != 0;
#line 2536 "rygel-av-transport.c"
	} else {
#line 479 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp8_ = FALSE;
#line 2540 "rygel-av-transport.c"
	}
#line 479 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp8_) {
#line 481 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (action, (guint) 701, _ ("Transition not available"));
#line 483 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (speed);
#line 483 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2550 "rygel-av-transport.c"
	}
#line 487 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp15_ = self->priv->player;
#line 487 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp16_ = speed;
#line 487 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_media_player_set_playback_speed (_tmp15_, _tmp16_);
#line 488 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp17_ = self->priv->controller;
#line 488 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_player_controller_set_playback_state (_tmp17_, "PLAYING");
#line 490 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 465 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (speed);
#line 2566 "rygel-av-transport.c"
}

static void
rygel_av_transport_pause_cb (RygelAVTransport* self,
                             GUPnPService* service,
                             GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	RygelPlayerController* _tmp3_;
#line 493 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 493 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 494 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 495 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2588 "rygel-av-transport.c"
	}
#line 498 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 498 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_can_pause (_tmp0_);
#line 498 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 498 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!_tmp2_) {
#line 499 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (action, (guint) 701, _ ("Transition not available"));
#line 501 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2602 "rygel-av-transport.c"
	}
#line 504 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = self->priv->controller;
#line 504 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_player_controller_set_playback_state (_tmp3_, "PAUSED_PLAYBACK");
#line 506 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 2610 "rygel-av-transport.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 2624 "rygel-av-transport.c"
}

static void
rygel_av_transport_seek_cb (RygelAVTransport* self,
                            GUPnPService* service,
                            GUPnPServiceAction* action)
{
	gchar* unit = NULL;
	gchar* target = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp4_label0 = 0;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp4_label1 = 0;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp4_label2 = 0;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp4_label3 = 0;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp4_label4 = 0;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp4_label5 = 0;
#line 509 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 509 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 509 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 510 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 511 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2661 "rygel-av-transport.c"
	}
#line 516 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_get (action, "Unit", G_TYPE_STRING, &_tmp0_, "Target", G_TYPE_STRING, &_tmp1_, NULL);
#line 516 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (unit);
#line 516 "../src/librygel-renderer/rygel-av-transport.vala"
	unit = _tmp0_;
#line 516 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (target);
#line 516 "../src/librygel-renderer/rygel-av-transport.vala"
	target = _tmp1_;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = unit;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
	if ((_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("ABS_TIME")))) || (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("REL_TIME"))))) {
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 2683 "rygel-av-transport.c"
			default:
			{
				gint64 seek_target = 0LL;
				const gchar* _tmp6_;
				RygelMediaPlayer* _tmp7_;
				gboolean _tmp8_;
				gboolean _tmp9_;
				RygelMediaPlayer* _tmp10_;
#line 525 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp6_ = target;
#line 525 "../src/librygel-renderer/rygel-av-transport.vala"
				seek_target = rygel_time_utils_time_from_string (_tmp6_);
#line 526 "../src/librygel-renderer/rygel-av-transport.vala"
				g_debug ("rygel-av-transport.vala:526: Seeking to %lld sec", seek_target / G_TIME_SPAN_SECOND);
#line 528 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp7_ = self->priv->player;
#line 528 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp8_ = rygel_media_player_get_can_seek (_tmp7_);
#line 528 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp9_ = _tmp8_;
#line 528 "../src/librygel-renderer/rygel-av-transport.vala"
				if (!_tmp9_) {
#line 529 "../src/librygel-renderer/rygel-av-transport.vala"
					gupnp_service_action_return_error (action, (guint) 710, _ ("Seek mode not supported"));
#line 531 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (target);
#line 531 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (unit);
#line 531 "../src/librygel-renderer/rygel-av-transport.vala"
					return;
#line 2714 "rygel-av-transport.c"
				}
#line 534 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp10_ = self->priv->player;
#line 534 "../src/librygel-renderer/rygel-av-transport.vala"
				if (!rygel_media_player_seek (_tmp10_, seek_target)) {
#line 535 "../src/librygel-renderer/rygel-av-transport.vala"
					gupnp_service_action_return_error (action, (guint) 711, _ ("Illegal seek target"));
#line 537 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (target);
#line 537 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (unit);
#line 537 "../src/librygel-renderer/rygel-av-transport.vala"
					return;
#line 2728 "rygel-av-transport.c"
				}
#line 540 "../src/librygel-renderer/rygel-av-transport.vala"
				gupnp_service_action_return_success (action);
#line 542 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_free0 (target);
#line 542 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_free0 (unit);
#line 542 "../src/librygel-renderer/rygel-av-transport.vala"
				return;
#line 2738 "rygel-av-transport.c"
			}
		}
	} else if (((_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("REL_COUNT")))) || (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("X_DLNA_REL_BYTE"))))) || (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("ABS_COUNT"))))) {
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 2744 "rygel-av-transport.c"
			default:
			{
				gint64 seek_target = 0LL;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				RygelMediaPlayer* _tmp16_;
				gboolean _tmp17_;
				gboolean _tmp18_;
				RygelMediaPlayer* _tmp19_;
#line 546 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp11_ = target;
#line 546 "../src/librygel-renderer/rygel-av-transport.vala"
				seek_target = int64_parse (_tmp11_, (guint) 0);
#line 548 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp12_ = unit;
#line 548 "../src/librygel-renderer/rygel-av-transport.vala"
				if (g_strcmp0 (_tmp12_, "ABS_COUNT") != 0) {
#line 2762 "rygel-av-transport.c"
					RygelMediaPlayer* _tmp13_;
					gint64 _tmp14_;
					gint64 _tmp15_;
#line 549 "../src/librygel-renderer/rygel-av-transport.vala"
					_tmp13_ = self->priv->player;
#line 549 "../src/librygel-renderer/rygel-av-transport.vala"
					_tmp14_ = rygel_media_player_get_byte_position (_tmp13_);
#line 549 "../src/librygel-renderer/rygel-av-transport.vala"
					_tmp15_ = _tmp14_;
#line 549 "../src/librygel-renderer/rygel-av-transport.vala"
					seek_target += _tmp15_;
#line 2774 "rygel-av-transport.c"
				}
#line 551 "../src/librygel-renderer/rygel-av-transport.vala"
				g_debug ("rygel-av-transport.vala:551: Seeking to %lld bytes.", seek_target);
#line 553 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp16_ = self->priv->player;
#line 553 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp17_ = rygel_media_player_get_can_seek_bytes (_tmp16_);
#line 553 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp18_ = _tmp17_;
#line 553 "../src/librygel-renderer/rygel-av-transport.vala"
				if (!_tmp18_) {
#line 554 "../src/librygel-renderer/rygel-av-transport.vala"
					gupnp_service_action_return_error (action, (guint) 710, _ ("Seek mode not supported"));
#line 556 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (target);
#line 556 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (unit);
#line 556 "../src/librygel-renderer/rygel-av-transport.vala"
					return;
#line 2794 "rygel-av-transport.c"
				}
#line 559 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp19_ = self->priv->player;
#line 559 "../src/librygel-renderer/rygel-av-transport.vala"
				if (!rygel_media_player_seek_bytes (_tmp19_, seek_target)) {
#line 560 "../src/librygel-renderer/rygel-av-transport.vala"
					gupnp_service_action_return_error (action, (guint) 711, _ ("Illegal seek target"));
#line 562 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (target);
#line 562 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (unit);
#line 562 "../src/librygel-renderer/rygel-av-transport.vala"
					return;
#line 2808 "rygel-av-transport.c"
				}
#line 565 "../src/librygel-renderer/rygel-av-transport.vala"
				gupnp_service_action_return_success (action);
#line 567 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_free0 (target);
#line 567 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_free0 (unit);
#line 567 "../src/librygel-renderer/rygel-av-transport.vala"
				return;
#line 2818 "rygel-av-transport.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("TRACK_NR")))) {
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 2824 "rygel-av-transport.c"
			default:
			{
				const gchar* _tmp20_;
				gint track = 0;
				const gchar* _tmp21_;
				gboolean _tmp22_ = FALSE;
				RygelPlayerController* _tmp26_;
#line 569 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp20_ = target;
#line 569 "../src/librygel-renderer/rygel-av-transport.vala"
				g_debug ("rygel-av-transport.vala:569: Setting track to %s.", _tmp20_);
#line 570 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp21_ = target;
#line 570 "../src/librygel-renderer/rygel-av-transport.vala"
				track = atoi (_tmp21_);
#line 572 "../src/librygel-renderer/rygel-av-transport.vala"
				if (track < 1) {
#line 572 "../src/librygel-renderer/rygel-av-transport.vala"
					_tmp22_ = TRUE;
#line 2844 "rygel-av-transport.c"
				} else {
					RygelPlayerController* _tmp23_;
					guint _tmp24_;
					guint _tmp25_;
#line 572 "../src/librygel-renderer/rygel-av-transport.vala"
					_tmp23_ = self->priv->controller;
#line 572 "../src/librygel-renderer/rygel-av-transport.vala"
					_tmp24_ = rygel_player_controller_get_n_tracks (_tmp23_);
#line 572 "../src/librygel-renderer/rygel-av-transport.vala"
					_tmp25_ = _tmp24_;
#line 572 "../src/librygel-renderer/rygel-av-transport.vala"
					_tmp22_ = ((guint) track) > _tmp25_;
#line 2857 "rygel-av-transport.c"
				}
#line 572 "../src/librygel-renderer/rygel-av-transport.vala"
				if (_tmp22_) {
#line 573 "../src/librygel-renderer/rygel-av-transport.vala"
					gupnp_service_action_return_error (action, (guint) 711, _ ("Illegal seek target"));
#line 575 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (target);
#line 575 "../src/librygel-renderer/rygel-av-transport.vala"
					_g_free0 (unit);
#line 575 "../src/librygel-renderer/rygel-av-transport.vala"
					return;
#line 2869 "rygel-av-transport.c"
				}
#line 578 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp26_ = self->priv->controller;
#line 578 "../src/librygel-renderer/rygel-av-transport.vala"
				rygel_player_controller_set_track (_tmp26_, (guint) track);
#line 580 "../src/librygel-renderer/rygel-av-transport.vala"
				gupnp_service_action_return_success (action);
#line 582 "../src/librygel-renderer/rygel-av-transport.vala"
				break;
#line 2879 "rygel-av-transport.c"
			}
		}
	} else {
#line 522 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 2885 "rygel-av-transport.c"
			default:
			{
#line 584 "../src/librygel-renderer/rygel-av-transport.vala"
				gupnp_service_action_return_error (action, (guint) 710, _ ("Seek mode not supported"));
#line 586 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_free0 (target);
#line 586 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_free0 (unit);
#line 586 "../src/librygel-renderer/rygel-av-transport.vala"
				return;
#line 2896 "rygel-av-transport.c"
			}
		}
	}
#line 509 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (target);
#line 509 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (unit);
#line 2904 "rygel-av-transport.c"
}

static void
rygel_av_transport_next_cb (RygelAVTransport* self,
                            GUPnPService* service,
                            GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
#line 590 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 590 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 590 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 591 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 592 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2923 "rygel-av-transport.c"
	}
#line 595 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 595 "../src/librygel-renderer/rygel-av-transport.vala"
	if (rygel_player_controller_next (_tmp0_)) {
#line 596 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_success (action);
#line 2931 "rygel-av-transport.c"
	} else {
#line 598 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (action, (guint) 711, _ ("Illegal seek target"));
#line 2935 "rygel-av-transport.c"
	}
}

static void
rygel_av_transport_previous_cb (RygelAVTransport* self,
                                GUPnPService* service,
                                GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
#line 602 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 602 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 602 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 603 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 604 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2955 "rygel-av-transport.c"
	}
#line 607 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 607 "../src/librygel-renderer/rygel-av-transport.vala"
	if (rygel_player_controller_previous (_tmp0_)) {
#line 608 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_success (action);
#line 2963 "rygel-av-transport.c"
	} else {
#line 610 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (action, (guint) 711, _ ("Illegal seek target"));
#line 2967 "rygel-av-transport.c"
	}
}

static void
rygel_av_transport_x_dlna_get_byte_position_info_cb (RygelAVTransport* self,
                                                     GUPnPService* service,
                                                     GUPnPServiceAction* action)
{
	RygelPlayerController* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 614 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 614 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 614 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 616 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 617 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 2991 "rygel-av-transport.c"
	}
#line 620 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 620 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_uri (_tmp0_);
#line 620 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 620 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 620 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "") == 0;
#line 620 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp3_);
#line 620 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp4_) {
#line 621 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_set (action, "TrackSize", G_TYPE_STRING, "", "RelByte", G_TYPE_STRING, "", "AbsByte", G_TYPE_STRING, "", NULL);
#line 3009 "rygel-av-transport.c"
	} else {
		gchar* position = NULL;
		RygelMediaPlayer* _tmp5_;
		gint64 _tmp6_;
		gint64 _tmp7_;
		gchar* _tmp8_;
		RygelMediaPlayer* _tmp9_;
		gint64 _tmp10_;
		gint64 _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 631 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp5_ = self->priv->player;
#line 631 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp6_ = rygel_media_player_get_byte_position (_tmp5_);
#line 631 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp7_ = _tmp6_;
#line 631 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp7_);
#line 631 "../src/librygel-renderer/rygel-av-transport.vala"
		position = _tmp8_;
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp9_ = self->priv->player;
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp10_ = rygel_media_player_get_size (_tmp9_);
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp11_ = _tmp10_;
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp11_);
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp13_ = _tmp12_;
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp14_ = position;
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp15_ = position;
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_set (action, "TrackSize", G_TYPE_STRING, _tmp13_, "RelByte", G_TYPE_STRING, _tmp14_, "AbsByte", G_TYPE_STRING, _tmp15_, NULL);
#line 632 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (_tmp13_);
#line 620 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (position);
#line 3053 "rygel-av-transport.c"
	}
#line 643 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 3057 "rygel-av-transport.c"
}

static void
rygel_av_transport_set_play_mode_cb (RygelAVTransport* self,
                                     GUPnPService* service,
                                     GUPnPServiceAction* action)
{
	gchar* play_mode = NULL;
	gchar* _tmp0_ = NULL;
	RygelPlayerController* _tmp1_;
	const gchar* _tmp2_;
	RygelPlayerController* _tmp3_;
	const gchar* _tmp4_;
#line 646 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (service != NULL);
#line 646 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 648 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_av_transport_check_instance_id (self, action)) {
#line 649 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 3081 "rygel-av-transport.c"
	}
#line 654 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_get (action, "NewPlayMode", G_TYPE_STRING, &_tmp0_, NULL);
#line 654 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (play_mode);
#line 654 "../src/librygel-renderer/rygel-av-transport.vala"
	play_mode = _tmp0_;
#line 658 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 658 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = play_mode;
#line 658 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!rygel_player_controller_is_play_mode_valid (_tmp1_, _tmp2_)) {
#line 659 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (action, (guint) 712, _ ("Play mode not supported"));
#line 660 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (play_mode);
#line 660 "../src/librygel-renderer/rygel-av-transport.vala"
		return;
#line 3101 "rygel-av-transport.c"
	}
#line 663 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = self->priv->controller;
#line 663 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = play_mode;
#line 663 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_player_controller_set_play_mode (_tmp3_, _tmp4_);
#line 665 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 646 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (play_mode);
#line 3113 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_state_cb (RygelAVTransport* self,
                                    GObject* controller,
                                    GParamSpec* p)
{
	gchar* state = NULL;
	RygelPlayerController* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	RygelChangeLog* _tmp4_;
	RygelChangeLog* _tmp5_;
	RygelPlayerController* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 668 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 668 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (controller != NULL);
#line 668 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 669 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 669 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_playback_state (_tmp0_);
#line 669 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 669 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 669 "../src/librygel-renderer/rygel-av-transport.vala"
	state = _tmp3_;
#line 670 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = self->priv->changelog;
#line 670 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp4_, "TransportState", state);
#line 671 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = self->priv->changelog;
#line 671 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = self->priv->controller;
#line 671 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = rygel_player_controller_get_current_transport_actions (_tmp6_);
#line 671 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = _tmp7_;
#line 671 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = _tmp8_;
#line 671 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp5_, "CurrentTransportActions", _tmp9_);
#line 671 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp9_);
#line 668 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (state);
#line 3168 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_n_tracks_cb (RygelAVTransport* self,
                                       GObject* controller,
                                       GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 675 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 675 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (controller != NULL);
#line 675 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 676 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 676 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 676 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_n_tracks (_tmp1_);
#line 676 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 676 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = g_strdup_printf ("%u", _tmp3_);
#line 676 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = _tmp4_;
#line 676 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "NumberOfTracks", _tmp5_);
#line 676 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp5_);
#line 3204 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_track_cb (RygelAVTransport* self,
                                    GObject* controller,
                                    GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 680 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 680 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (controller != NULL);
#line 680 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 681 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 681 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 681 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_track (_tmp1_);
#line 681 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 681 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = g_strdup_printf ("%u", _tmp3_);
#line 681 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = _tmp4_;
#line 681 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "CurrentTrack", _tmp5_);
#line 681 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp5_);
#line 3240 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_duration_cb (RygelAVTransport* self,
                                       GObject* player,
                                       GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelMediaPlayer* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	RygelChangeLog* _tmp5_;
	RygelMediaPlayer* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 685 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 685 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (player != NULL);
#line 685 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 686 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 686 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->player;
#line 686 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_media_player_get_duration_as_str (_tmp1_);
#line 686 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 686 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 686 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "CurrentTrackDuration", _tmp4_);
#line 686 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp4_);
#line 688 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = self->priv->changelog;
#line 688 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = self->priv->player;
#line 688 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp7_ = rygel_media_player_get_duration_as_str (_tmp6_);
#line 688 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp8_ = _tmp7_;
#line 688 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp9_ = _tmp8_;
#line 688 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp5_, "CurrentMediaDuration", _tmp9_);
#line 688 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp9_);
#line 3292 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_uri_cb (RygelAVTransport* self,
                                  GObject* controller,
                                  GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 692 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 692 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (controller != NULL);
#line 692 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 693 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 693 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 693 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_uri (_tmp1_);
#line 693 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 693 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 693 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "AVTransportURI", _tmp4_);
#line 693 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp4_);
#line 3325 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_meta_data_cb (RygelAVTransport* self,
                                        GObject* player,
                                        GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 696 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (player != NULL);
#line 696 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 697 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 697 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 697 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_metadata (_tmp1_);
#line 697 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 697 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 697 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "AVTransportURIMetaData", _tmp4_);
#line 697 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp4_);
#line 3358 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_track_uri_cb (RygelAVTransport* self,
                                        GObject* player,
                                        GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 701 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 701 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (player != NULL);
#line 701 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 702 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 702 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 702 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_track_uri (_tmp1_);
#line 702 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 702 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 702 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "CurrentTrackURI", _tmp4_);
#line 702 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp4_);
#line 3391 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_track_meta_data_cb (RygelAVTransport* self,
                                              GObject* player,
                                              GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 705 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 705 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (player != NULL);
#line 705 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 706 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 706 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 706 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_track_metadata (_tmp1_);
#line 706 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 706 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 706 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "CurrentTrackMetaData", _tmp4_);
#line 706 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp4_);
#line 3424 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_next_uri_cb (RygelAVTransport* self,
                                       GObject* controller,
                                       GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 710 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 710 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (controller != NULL);
#line 710 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 711 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 711 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 711 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_next_uri (_tmp1_);
#line 711 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 711 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 711 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "NextAVTransportURI", _tmp4_);
#line 711 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp4_);
#line 3457 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_next_meta_data_cb (RygelAVTransport* self,
                                             GObject* player,
                                             GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 714 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 714 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (player != NULL);
#line 714 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 715 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 715 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 715 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_next_metadata (_tmp1_);
#line 715 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 715 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 715 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "NextAVTransportURIMetaData", _tmp4_);
#line 715 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp4_);
#line 3490 "rygel-av-transport.c"
}

static void
rygel_av_transport_notify_play_mode_cb (RygelAVTransport* self,
                                        GObject* player,
                                        GParamSpec* p)
{
	RygelChangeLog* _tmp0_;
	RygelPlayerController* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 719 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 719 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (player != NULL);
#line 719 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (p != NULL);
#line 720 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->changelog;
#line 720 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->controller;
#line 720 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = rygel_player_controller_get_play_mode (_tmp1_);
#line 720 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 720 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp0_, "CurrentPlayMode", _tmp3_);
#line 3518 "rygel-av-transport.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 3539 "rygel-av-transport.c"
}

static GUPnPMediaCollection*
rygel_av_transport_parse_m3u_playlist (RygelAVTransport* self,
                                       GBytes* data,
                                       GError** error)
{
	GUPnPMediaCollection* collection = NULL;
	GUPnPMediaCollection* _tmp0_;
	GMemoryInputStream* m_stream = NULL;
	GMemoryInputStream* _tmp1_;
	GDataInputStream* stream = NULL;
	GMemoryInputStream* _tmp2_;
	GDataInputStream* _tmp3_;
	gsize length = 0UL;
	gchar* line = NULL;
	GDataInputStream* _tmp4_;
	gsize _tmp5_ = 0UL;
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	GUPnPMediaCollection* result;
#line 723 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 724 "../src/librygel-renderer/rygel-av-transport.vala"
	if (data == NULL) {
#line 725 "../src/librygel-renderer/rygel-av-transport.vala"
		result = NULL;
#line 725 "../src/librygel-renderer/rygel-av-transport.vala"
		return result;
#line 3569 "rygel-av-transport.c"
	}
#line 728 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = gupnp_media_collection_new ();
#line 728 "../src/librygel-renderer/rygel-av-transport.vala"
	collection = _tmp0_;
#line 729 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = (GMemoryInputStream*) g_memory_input_stream_new_from_bytes (data);
#line 729 "../src/librygel-renderer/rygel-av-transport.vala"
	m_stream = _tmp1_;
#line 730 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = m_stream;
#line 730 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = g_data_input_stream_new ((GInputStream*) _tmp2_);
#line 730 "../src/librygel-renderer/rygel-av-transport.vala"
	stream = _tmp3_;
#line 732 "../src/librygel-renderer/rygel-av-transport.vala"
	g_debug ("rygel-av-transport.vala:732: Trying to parse m3u playlist");
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = stream;
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp6_ = g_data_input_stream_read_line (_tmp4_, &_tmp5_, NULL, &_inner_error0_);
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
	length = _tmp5_;
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
	line = _tmp6_;
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
		g_propagate_error (error, _inner_error0_);
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (stream);
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (m_stream);
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (collection);
#line 734 "../src/librygel-renderer/rygel-av-transport.vala"
		return NULL;
#line 3607 "rygel-av-transport.c"
	}
#line 735 "../src/librygel-renderer/rygel-av-transport.vala"
	while (TRUE) {
#line 3611 "rygel-av-transport.c"
		const gchar* _tmp7_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		GUPnPDIDLLiteItem* item = NULL;
		GUPnPMediaCollection* _tmp18_;
		GUPnPDIDLLiteItem* _tmp19_;
		GUPnPDIDLLiteItem* _tmp20_;
		GUPnPDIDLLiteResource* resource = NULL;
		GUPnPDIDLLiteItem* _tmp21_;
		GUPnPDIDLLiteResource* _tmp22_;
		GUPnPProtocolInfo* pi = NULL;
		GUPnPProtocolInfo* _tmp23_;
		GUPnPDIDLLiteResource* _tmp24_;
		GUPnPProtocolInfo* _tmp25_;
		GUPnPDIDLLiteResource* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_ = NULL;
		GDataInputStream* _tmp31_;
		gsize _tmp32_ = 0UL;
		gchar* _tmp33_;
		gchar* _tmp34_;
#line 735 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp7_ = line;
#line 735 "../src/librygel-renderer/rygel-av-transport.vala"
		if (!(_tmp7_ != NULL)) {
#line 735 "../src/librygel-renderer/rygel-av-transport.vala"
			break;
#line 3641 "rygel-av-transport.c"
		}
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
		while (TRUE) {
#line 3645 "rygel-av-transport.c"
			gboolean _tmp8_ = FALSE;
			const gchar* _tmp9_;
			gchar* _tmp11_ = NULL;
			GDataInputStream* _tmp12_;
			gsize _tmp13_ = 0UL;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
			_tmp9_ = line;
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
			if (_tmp9_ != NULL) {
#line 3657 "rygel-av-transport.c"
				const gchar* _tmp10_;
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp10_ = line;
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp8_ = g_str_has_prefix (_tmp10_, "#");
#line 3663 "rygel-av-transport.c"
			} else {
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp8_ = FALSE;
#line 3667 "rygel-av-transport.c"
			}
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
			if (!_tmp8_) {
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
				break;
#line 3673 "rygel-av-transport.c"
			}
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			_tmp12_ = stream;
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			_tmp14_ = g_data_input_stream_read_line (_tmp12_, &_tmp13_, NULL, &_inner_error0_);
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			length = _tmp13_;
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			_tmp11_ = _tmp14_;
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
				g_propagate_error (error, _inner_error0_);
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_free0 (line);
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_object_unref0 (stream);
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_object_unref0 (m_stream);
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
				_g_object_unref0 (collection);
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
				return NULL;
#line 3697 "rygel-av-transport.c"
			}
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			_tmp15_ = _tmp11_;
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			_tmp11_ = NULL;
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (line);
#line 739 "../src/librygel-renderer/rygel-av-transport.vala"
			line = _tmp15_;
#line 738 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (_tmp11_);
#line 3709 "rygel-av-transport.c"
		}
#line 743 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp16_ = line;
#line 743 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_tmp16_ == NULL) {
#line 744 "../src/librygel-renderer/rygel-av-transport.vala"
			break;
#line 3717 "rygel-av-transport.c"
		}
#line 747 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp17_ = line;
#line 747 "../src/librygel-renderer/rygel-av-transport.vala"
		g_debug ("rygel-av-transport.vala:747: Adding uri with %s", _tmp17_);
#line 748 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp18_ = collection;
#line 748 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp19_ = gupnp_media_collection_add_item (_tmp18_);
#line 748 "../src/librygel-renderer/rygel-av-transport.vala"
		item = _tmp19_;
#line 749 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp20_ = item;
#line 749 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_didl_lite_object_set_upnp_class ((GUPnPDIDLLiteObject*) _tmp20_, "object.item.audioItem");
#line 751 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp21_ = item;
#line 751 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp22_ = gupnp_didl_lite_object_add_resource ((GUPnPDIDLLiteObject*) _tmp21_);
#line 751 "../src/librygel-renderer/rygel-av-transport.vala"
		resource = _tmp22_;
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp23_ = gupnp_protocol_info_new_from_string ("*:*:*:*", &_inner_error0_);
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
		pi = _tmp23_;
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
			g_propagate_error (error, _inner_error0_);
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (resource);
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (item);
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (line);
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (stream);
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (m_stream);
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (collection);
#line 752 "../src/librygel-renderer/rygel-av-transport.vala"
			return NULL;
#line 3761 "rygel-av-transport.c"
		}
#line 753 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp24_ = resource;
#line 753 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp25_ = pi;
#line 753 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_didl_lite_resource_set_protocol_info (_tmp24_, _tmp25_);
#line 754 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp26_ = resource;
#line 754 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp27_ = line;
#line 754 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp28_ = string_strip (_tmp27_);
#line 754 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp29_ = _tmp28_;
#line 754 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_didl_lite_resource_set_uri (_tmp26_, _tmp29_);
#line 754 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (_tmp29_);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp31_ = stream;
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp33_ = g_data_input_stream_read_line (_tmp31_, &_tmp32_, NULL, &_inner_error0_);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		length = _tmp32_;
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp30_ = _tmp33_;
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			g_propagate_error (error, _inner_error0_);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (pi);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (resource);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (item);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (line);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (stream);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (m_stream);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (collection);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
			return NULL;
#line 3809 "rygel-av-transport.c"
		}
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp34_ = _tmp30_;
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp30_ = NULL;
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (line);
#line 756 "../src/librygel-renderer/rygel-av-transport.vala"
		line = _tmp34_;
#line 735 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (_tmp30_);
#line 735 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (pi);
#line 735 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (resource);
#line 735 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (item);
#line 3827 "rygel-av-transport.c"
	}
#line 759 "../src/librygel-renderer/rygel-av-transport.vala"
	result = collection;
#line 759 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (line);
#line 759 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (stream);
#line 759 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (m_stream);
#line 759 "../src/librygel-renderer/rygel-av-transport.vala"
	return result;
#line 3839 "rygel-av-transport.c"
}

static void
_vala_GUPnPServiceAction_free (GUPnPServiceAction* self)
{
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_boxed_free (gupnp_service_action_get_type (), self);
#line 3847 "rygel-av-transport.c"
}

static void
rygel_av_transport_handle_playlist_data_free (gpointer _data)
{
	RygelAvTransportHandlePlaylistData* _data_;
	_data_ = _data;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	__vala_GUPnPServiceAction_free0 (_data_->action);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->uri);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->metadata);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->mime);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->features);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (_data_->self);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_slice_free (RygelAvTransportHandlePlaylistData, _data_);
#line 3869 "rygel-av-transport.c"
}

static GUPnPServiceAction*
_vala_GUPnPServiceAction_copy (GUPnPServiceAction* self)
{
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	return g_boxed_copy (gupnp_service_action_get_type (), self);
#line 3877 "rygel-av-transport.c"
}

static gpointer
__vala_GUPnPServiceAction_copy0 (gpointer self)
{
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	return self ? _vala_GUPnPServiceAction_copy (self) : NULL;
#line 3885 "rygel-av-transport.c"
}

static void
rygel_av_transport_handle_playlist (RygelAVTransport* self,
                                    GUPnPServiceAction* action,
                                    const gchar* uri,
                                    const gchar* metadata,
                                    const gchar* mime,
                                    const gchar* features,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	RygelAvTransportHandlePlaylistData* _data_;
	RygelAVTransport* _tmp0_;
	GUPnPServiceAction* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (uri != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (metadata != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (mime != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (features != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_ = g_slice_new0 (RygelAvTransportHandlePlaylistData);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_av_transport_handle_playlist_data_free);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->self = _tmp0_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = __vala_GUPnPServiceAction_copy0 (action);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	__vala_GUPnPServiceAction_free0 (_data_->action);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->action = _tmp1_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = g_strdup (uri);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->uri);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->uri = _tmp2_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = g_strdup (metadata);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->metadata);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->metadata = _tmp3_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = g_strdup (mime);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->mime);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->mime = _tmp4_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = g_strdup (features);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->features);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->features = _tmp5_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_handle_playlist_co (_data_);
#line 3959 "rygel-av-transport.c"
}

static void
rygel_av_transport_handle_playlist_finish (RygelAVTransport* self,
                                           GAsyncResult* _res_)
{
	RygelAvTransportHandlePlaylistData* _data_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3969 "rygel-av-transport.c"
}

static void
rygel_av_transport_handle_playlist_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	RygelAvTransportHandlePlaylistData* _data_;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_ = _user_data_;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_source_object_ = source_object;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_res_ = _res_;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_handle_playlist_co (_data_);
#line 3986 "rygel-av-transport.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 801 "../src/librygel-renderer/rygel-av-transport.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3994 "rygel-av-transport.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 801 "../src/librygel-renderer/rygel-av-transport.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 4002 "rygel-av-transport.c"
}

static gboolean
rygel_av_transport_handle_playlist_co (RygelAvTransportHandlePlaylistData* _data_)
{
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp32_label0 = 0;
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp32_label1 = 0;
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	switch (_data_->_state_) {
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
		case 0:
#line 4016 "rygel-av-transport.c"
		goto _state_0;
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
		case 1:
#line 4020 "rygel-av-transport.c"
		goto _state_1;
		default:
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
		g_assert_not_reached ();
#line 4025 "rygel-av-transport.c"
	}
	_state_0:
#line 767 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp0_ = soup_message_new ("GET", _data_->uri);
#line 767 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->message = _data_->_tmp0_;
#line 768 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->body = NULL;
#line 4034 "rygel-av-transport.c"
	{
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp2_ = _data_->self->priv->session;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp3_ = _data_->message;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_state_ = 1;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		soup_session_send_and_read_async (_data_->_tmp2_, _data_->_tmp3_, G_PRIORITY_DEFAULT, NULL, rygel_av_transport_handle_playlist_ready, _data_);
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		return FALSE;
#line 4046 "rygel-av-transport.c"
		_state_1:
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp4_ = soup_session_send_and_read_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp1_ = _data_->_tmp4_;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4054 "rygel-av-transport.c"
			goto __catch0_g_error;
		}
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp5_ = _data_->_tmp1_;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp1_ = NULL;
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_bytes_unref0 (_data_->body);
#line 771 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->body = _data_->_tmp5_;
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_bytes_unref0 (_data_->_tmp1_);
#line 4067 "rygel-av-transport.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 773 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (_data_->action, (guint) 716, _ ("Resource not found"));
#line 775 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_bytes_unref0 (_data_->body);
#line 775 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (_data_->message);
#line 775 "../src/librygel-renderer/rygel-av-transport.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 775 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_state_ != 0) {
#line 775 "../src/librygel-renderer/rygel-av-transport.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 775 "../src/librygel-renderer/rygel-av-transport.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4088 "rygel-av-transport.c"
			}
		}
#line 775 "../src/librygel-renderer/rygel-av-transport.vala"
		g_object_unref (_data_->_async_result);
#line 775 "../src/librygel-renderer/rygel-av-transport.vala"
		return FALSE;
#line 4095 "rygel-av-transport.c"
	}
	__finally0:
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_bytes_unref0 (_data_->body);
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (_data_->message);
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
		g_object_unref (_data_->_async_result);
#line 770 "../src/librygel-renderer/rygel-av-transport.vala"
		return FALSE;
#line 4112 "rygel-av-transport.c"
	}
#line 778 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp6_ = _data_->message;
#line 778 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_get (_data_->_tmp6_, "status-code", &_data_->_tmp7_, NULL);
#line 778 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 778 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_data_->_tmp8_ != ((guint) 200)) {
#line 779 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (_data_->action, (guint) 716, _ ("Resource not found"));
#line 781 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_bytes_unref0 (_data_->body);
#line 781 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (_data_->message);
#line 781 "../src/librygel-renderer/rygel-av-transport.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 781 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_state_ != 0) {
#line 781 "../src/librygel-renderer/rygel-av-transport.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 781 "../src/librygel-renderer/rygel-av-transport.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4136 "rygel-av-transport.c"
			}
		}
#line 781 "../src/librygel-renderer/rygel-av-transport.vala"
		g_object_unref (_data_->_async_result);
#line 781 "../src/librygel-renderer/rygel-av-transport.vala"
		return FALSE;
#line 4143 "rygel-av-transport.c"
	}
#line 784 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp9_ = _data_->message;
#line 784 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp10_ = soup_message_get_response_headers (_data_->_tmp9_);
#line 784 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 784 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp12_ = soup_message_headers_get_content_type (_data_->_tmp11_, NULL);
#line 784 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp13_ = g_strdup (_data_->_tmp12_);
#line 784 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->content_type = _data_->_tmp13_;
#line 786 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->collection = NULL;
#line 787 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp14_ = _data_->content_type;
#line 787 "../src/librygel-renderer/rygel-av-transport.vala"
	if (g_str_has_suffix (_data_->_tmp14_, "mpegurl")) {
#line 788 "../src/librygel-renderer/rygel-av-transport.vala"
		g_debug ("rygel-av-transport.vala:788: Trying to parse m3u playlist");
#line 4165 "rygel-av-transport.c"
		{
#line 790 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp16_ = _data_->body;
#line 790 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp17_ = rygel_av_transport_parse_m3u_playlist (_data_->self, _data_->_tmp16_, &_data_->_inner_error0_);
#line 790 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp15_ = _data_->_tmp17_;
#line 790 "../src/librygel-renderer/rygel-av-transport.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4175 "rygel-av-transport.c"
				goto __catch1_g_error;
			}
#line 790 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp18_ = _data_->_tmp15_;
#line 790 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp15_ = NULL;
#line 790 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->collection);
#line 790 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->collection = _data_->_tmp18_;
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->_tmp15_);
#line 4188 "rygel-av-transport.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_error_ = _data_->_inner_error0_;
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_inner_error0_ = NULL;
#line 792 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp19_ = _data_->_error_;
#line 792 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp20_ = _data_->_tmp19_->message;
#line 792 "../src/librygel-renderer/rygel-av-transport.vala"
			g_warning (_ ("Problem parsing playlist: %s"), _data_->_tmp20_);
#line 794 "../src/librygel-renderer/rygel-av-transport.vala"
			gupnp_service_action_return_error (_data_->action, (guint) 716, _ ("Resource not found"));
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_error_free0 (_data_->_error_);
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->collection);
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (_data_->content_type);
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_bytes_unref0 (_data_->body);
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->message);
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			if (_data_->_state_ != 0) {
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4223 "rygel-av-transport.c"
				}
			}
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			g_object_unref (_data_->_async_result);
#line 796 "../src/librygel-renderer/rygel-av-transport.vala"
			return FALSE;
#line 4230 "rygel-av-transport.c"
		}
		__finally1:
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->collection);
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (_data_->content_type);
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_bytes_unref0 (_data_->body);
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->message);
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			g_object_unref (_data_->_async_result);
#line 789 "../src/librygel-renderer/rygel-av-transport.vala"
			return FALSE;
#line 4251 "rygel-av-transport.c"
		}
	} else {
#line 799 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp21_ = _data_->body;
#line 799 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp22_ = 0;
#line 799 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp23_ = g_bytes_get_data (_data_->_tmp21_, &_data_->_tmp22_);
#line 799 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->xml_string = (const gchar*) _data_->_tmp23_;
#line 800 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp24_ = _data_->xml_string;
#line 800 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp25_ = gupnp_media_collection_new_from_string (_data_->_tmp24_);
#line 800 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (_data_->collection);
#line 800 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->collection = _data_->_tmp25_;
#line 801 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp26_ = _data_->collection;
#line 801 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp27_ = gupnp_media_collection_get_items (_data_->_tmp26_);
#line 801 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 801 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp29_ = g_list_length (_data_->_tmp28_) == ((guint) 0);
#line 801 "../src/librygel-renderer/rygel-av-transport.vala"
		(_data_->_tmp28_ == NULL) ? NULL : (_data_->_tmp28_ = (_g_list_free__g_object_unref0_ (_data_->_tmp28_), NULL));
#line 801 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_tmp29_) {
#line 803 "../src/librygel-renderer/rygel-av-transport.vala"
			gupnp_service_action_return_error (_data_->action, (guint) 716, _ ("Resource not found"));
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->collection);
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (_data_->content_type);
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_bytes_unref0 (_data_->body);
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->message);
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
			if (_data_->_state_ != 0) {
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4300 "rygel-av-transport.c"
				}
			}
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
			g_object_unref (_data_->_async_result);
#line 805 "../src/librygel-renderer/rygel-av-transport.vala"
			return FALSE;
#line 4307 "rygel-av-transport.c"
		}
	}
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp30_ = gupnp_service_action_get_name (_data_->action);
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp33_ = 0U;
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp31_ = _data_->_tmp30_;
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp33_ = (NULL == _data_->_tmp31_) ? 0 : g_quark_from_string (_data_->_tmp31_);
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_data_->_tmp33_ == ((0 != _tmp32_label0) ? _tmp32_label0 : (_tmp32_label0 = g_quark_from_static_string ("SetAVTransportURI")))) {
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 4322 "rygel-av-transport.c"
			default:
			{
#line 811 "../src/librygel-renderer/rygel-av-transport.vala"
				_data_->_tmp34_ = _data_->self->priv->controller;
#line 811 "../src/librygel-renderer/rygel-av-transport.vala"
				_data_->_tmp35_ = _data_->collection;
#line 811 "../src/librygel-renderer/rygel-av-transport.vala"
				rygel_player_controller_set_playlist_uri (_data_->_tmp34_, _data_->uri, _data_->metadata, _data_->_tmp35_);
#line 812 "../src/librygel-renderer/rygel-av-transport.vala"
				break;
#line 4333 "rygel-av-transport.c"
			}
		}
	} else if (_data_->_tmp33_ == ((0 != _tmp32_label1) ? _tmp32_label1 : (_tmp32_label1 = g_quark_from_static_string ("SetNextAVTransportURI")))) {
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 4339 "rygel-av-transport.c"
			default:
			{
#line 814 "../src/librygel-renderer/rygel-av-transport.vala"
				_data_->_tmp36_ = _data_->self->priv->controller;
#line 814 "../src/librygel-renderer/rygel-av-transport.vala"
				_data_->_tmp37_ = _data_->collection;
#line 814 "../src/librygel-renderer/rygel-av-transport.vala"
				rygel_player_controller_set_next_playlist_uri (_data_->_tmp36_, _data_->uri, _data_->metadata, _data_->_tmp37_);
#line 815 "../src/librygel-renderer/rygel-av-transport.vala"
				break;
#line 4350 "rygel-av-transport.c"
			}
		}
	} else {
#line 809 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 4356 "rygel-av-transport.c"
			default:
			{
#line 817 "../src/librygel-renderer/rygel-av-transport.vala"
				g_assert_not_reached ();
#line 4361 "rygel-av-transport.c"
			}
		}
	}
#line 820 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (_data_->action);
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (_data_->collection);
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->content_type);
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_bytes_unref0 (_data_->body);
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (_data_->message);
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_data_->_state_ != 0) {
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4383 "rygel-av-transport.c"
		}
	}
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_unref (_data_->_async_result);
#line 762 "../src/librygel-renderer/rygel-av-transport.vala"
	return FALSE;
#line 4390 "rygel-av-transport.c"
}

static gboolean
rygel_av_transport_is_playlist (RygelAVTransport* self,
                                const gchar* mime,
                                const gchar* features)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 823 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
	if (mime != NULL) {
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp3_ = g_strcmp0 (mime, "text/xml") == 0;
#line 4409 "rygel-av-transport.c"
	} else {
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp3_ = FALSE;
#line 4413 "rygel-av-transport.c"
	}
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp3_) {
#line 825 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp2_ = features != NULL;
#line 4419 "rygel-av-transport.c"
	} else {
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp2_ = FALSE;
#line 4423 "rygel-av-transport.c"
	}
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp2_) {
#line 826 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp1_ = g_str_has_prefix (features, "DLNA.ORG_PN=DIDL_S");
#line 4429 "rygel-av-transport.c"
	} else {
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp1_ = FALSE;
#line 4433 "rygel-av-transport.c"
	}
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp1_) {
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp0_ = TRUE;
#line 4439 "rygel-av-transport.c"
	} else {
#line 827 "../src/librygel-renderer/rygel-av-transport.vala"
		_tmp0_ = g_str_has_suffix (mime, "mpegurl");
#line 4443 "rygel-av-transport.c"
	}
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
	result = _tmp0_;
#line 824 "../src/librygel-renderer/rygel-av-transport.vala"
	return result;
#line 4449 "rygel-av-transport.c"
}

static void
rygel_av_transport_handle_new_transport_uri_data_free (gpointer _data)
{
	RygelAvTransportHandleNewTransportUriData* _data_;
	_data_ = _data;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	__vala_GUPnPServiceAction_free0 (_data_->action);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->uri);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->metadata);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (_data_->self);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_slice_free (RygelAvTransportHandleNewTransportUriData, _data_);
#line 4467 "rygel-av-transport.c"
}

static void
rygel_av_transport_handle_new_transport_uri (RygelAVTransport* self,
                                             GUPnPServiceAction* action,
                                             const gchar* uri,
                                             const gchar* metadata,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	RygelAvTransportHandleNewTransportUriData* _data_;
	RygelAVTransport* _tmp0_;
	GUPnPServiceAction* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (uri != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (metadata != NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_ = g_slice_new0 (RygelAvTransportHandleNewTransportUriData);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_av_transport_handle_new_transport_uri_data_free);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->self = _tmp0_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = __vala_GUPnPServiceAction_copy0 (action);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	__vala_GUPnPServiceAction_free0 (_data_->action);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->action = _tmp1_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = g_strdup (uri);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->uri);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->uri = _tmp2_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = g_strdup (metadata);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->metadata);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->metadata = _tmp3_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_handle_new_transport_uri_co (_data_);
#line 4521 "rygel-av-transport.c"
}

static void
rygel_av_transport_handle_new_transport_uri_finish (RygelAVTransport* self,
                                                    GAsyncResult* _res_)
{
	RygelAvTransportHandleNewTransportUriData* _data_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4531 "rygel-av-transport.c"
}

static void
rygel_av_transport_handle_new_transport_uri_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	RygelAvTransportHandleNewTransportUriData* _data_;
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_ = _user_data_;
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_source_object_ = source_object;
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_res_ = _res_;
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_handle_new_transport_uri_co (_data_);
#line 4548 "rygel-av-transport.c"
}

static gboolean
rygel_av_transport_handle_new_transport_uri_co (RygelAvTransportHandleNewTransportUriData* _data_)
{
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
	switch (_data_->_state_) {
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
		case 0:
#line 4558 "rygel-av-transport.c"
		goto _state_0;
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
		case 1:
#line 4562 "rygel-av-transport.c"
		goto _state_1;
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
		case 2:
#line 4566 "rygel-av-transport.c"
		goto _state_2;
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
		case 3:
#line 4570 "rygel-av-transport.c"
		goto _state_3;
		default:
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
		g_assert_not_reached ();
#line 4575 "rygel-av-transport.c"
	}
	_state_0:
#line 834 "../src/librygel-renderer/rygel-av-transport.vala"
	if (!g_str_has_prefix (_data_->uri, "http://")) {
#line 834 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp0_ = !g_str_has_prefix (_data_->uri, "https://");
#line 4582 "rygel-av-transport.c"
	} else {
#line 834 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp0_ = FALSE;
#line 4586 "rygel-av-transport.c"
	}
#line 834 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_data_->_tmp0_) {
#line 835 "../src/librygel-renderer/rygel-av-transport.vala"
		rygel_av_transport_set_single_play_uri (_data_->self, _data_->action, _data_->uri, _data_->metadata, NULL, NULL);
#line 837 "../src/librygel-renderer/rygel-av-transport.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 837 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_state_ != 0) {
#line 837 "../src/librygel-renderer/rygel-av-transport.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 837 "../src/librygel-renderer/rygel-av-transport.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4600 "rygel-av-transport.c"
			}
		}
#line 837 "../src/librygel-renderer/rygel-av-transport.vala"
		g_object_unref (_data_->_async_result);
#line 837 "../src/librygel-renderer/rygel-av-transport.vala"
		return FALSE;
#line 4607 "rygel-av-transport.c"
	}
#line 840 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp1_ = gupnp_service_info_get_context ((GUPnPServiceInfo*) _data_->self);
#line 840 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 840 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp3_ = gupnp_context_rewrite_uri (_data_->_tmp2_, _data_->uri);
#line 840 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->new_uri = _data_->_tmp3_;
#line 841 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp4_ = _data_->new_uri;
#line 841 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp5_ = soup_message_new ("HEAD", _data_->_tmp4_);
#line 841 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->message = _data_->_tmp5_;
#line 842 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp6_ = _data_->message;
#line 842 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp7_ = soup_message_get_request_headers (_data_->_tmp6_);
#line 842 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 842 "../src/librygel-renderer/rygel-av-transport.vala"
	soup_message_headers_append (_data_->_tmp8_, "getContentFeatures.dlna.org", "1");
#line 844 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp9_ = _data_->message;
#line 844 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp10_ = soup_message_get_request_headers (_data_->_tmp9_);
#line 844 "../src/librygel-renderer/rygel-av-transport.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 844 "../src/librygel-renderer/rygel-av-transport.vala"
	soup_message_headers_append (_data_->_tmp11_, "Connection", "close");
#line 4639 "rygel-av-transport.c"
	{
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp12_ = _data_->self->priv->session;
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp13_ = _data_->message;
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_state_ = 1;
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		soup_session_send_async (_data_->_tmp12_, _data_->_tmp13_, G_PRIORITY_DEFAULT, NULL, rygel_av_transport_handle_new_transport_uri_ready, _data_);
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		return FALSE;
#line 4651 "rygel-av-transport.c"
		_state_1:
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp14_ = soup_session_send_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (_data_->_tmp15_);
#line 847 "../src/librygel-renderer/rygel-av-transport.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4661 "rygel-av-transport.c"
			goto __catch0_g_error;
		}
#line 848 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp18_ = _data_->message;
#line 848 "../src/librygel-renderer/rygel-av-transport.vala"
		g_object_get (_data_->_tmp18_, "status-code", &_data_->_tmp19_, NULL);
#line 848 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 848 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_tmp20_ == ((guint) SOUP_STATUS_BAD_REQUEST)) {
#line 848 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp17_ = TRUE;
#line 4674 "rygel-av-transport.c"
		} else {
#line 849 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp21_ = _data_->message;
#line 849 "../src/librygel-renderer/rygel-av-transport.vala"
			g_object_get (_data_->_tmp21_, "status-code", &_data_->_tmp22_, NULL);
#line 849 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp23_ = _data_->_tmp22_;
#line 849 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp17_ = _data_->_tmp23_ == ((guint) SOUP_STATUS_METHOD_NOT_ALLOWED);
#line 4684 "rygel-av-transport.c"
		}
#line 848 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_tmp17_) {
#line 848 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp16_ = TRUE;
#line 4690 "rygel-av-transport.c"
		} else {
#line 850 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp24_ = _data_->message;
#line 850 "../src/librygel-renderer/rygel-av-transport.vala"
			g_object_get (_data_->_tmp24_, "status-code", &_data_->_tmp25_, NULL);
#line 850 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp26_ = _data_->_tmp25_;
#line 850 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp16_ = _data_->_tmp26_ == ((guint) SOUP_STATUS_NOT_IMPLEMENTED);
#line 4700 "rygel-av-transport.c"
		}
#line 848 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_tmp16_) {
#line 851 "../src/librygel-renderer/rygel-av-transport.vala"
			g_debug ("rygel-av-transport.vala:851: Peer does not support HEAD, trying GET");
#line 852 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp27_ = _data_->message;
#line 852 "../src/librygel-renderer/rygel-av-transport.vala"
			soup_message_set_method (_data_->_tmp27_, "GET");
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp28_ = _data_->self->priv->session;
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp29_ = _data_->message;
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_state_ = 2;
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			soup_session_send_async (_data_->_tmp28_, _data_->_tmp29_, G_PRIORITY_DEFAULT, NULL, rygel_av_transport_handle_new_transport_uri_ready, _data_);
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			return FALSE;
#line 4720 "rygel-av-transport.c"
			_state_2:
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp30_ = soup_session_send_finish (_data_->_tmp28_, _data_->_res_, &_data_->_inner_error0_);
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp31_ = _data_->_tmp30_;
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->_tmp31_);
#line 853 "../src/librygel-renderer/rygel-av-transport.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4730 "rygel-av-transport.c"
				goto __catch0_g_error;
			}
		}
#line 856 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp32_ = _data_->message;
#line 856 "../src/librygel-renderer/rygel-av-transport.vala"
		g_object_get (_data_->_tmp32_, "status-code", &_data_->_tmp33_, NULL);
#line 856 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp34_ = _data_->_tmp33_;
#line 856 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_tmp34_ != ((guint) SOUP_STATUS_OK)) {
#line 859 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp35_ = _data_->message;
#line 859 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp36_ = soup_message_get_reason_phrase (_data_->_tmp35_);
#line 859 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp37_ = _data_->_tmp36_;
#line 859 "../src/librygel-renderer/rygel-av-transport.vala"
			g_warning (_ ("Failed to access resource at %s: %s"), _data_->uri, _data_->_tmp37_);
#line 863 "../src/librygel-renderer/rygel-av-transport.vala"
			gupnp_service_action_return_error (_data_->action, (guint) 716, _ ("Resource not found"));
#line 865 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->message);
#line 865 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (_data_->new_uri);
#line 865 "../src/librygel-renderer/rygel-av-transport.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 865 "../src/librygel-renderer/rygel-av-transport.vala"
			if (_data_->_state_ != 0) {
#line 865 "../src/librygel-renderer/rygel-av-transport.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 865 "../src/librygel-renderer/rygel-av-transport.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4764 "rygel-av-transport.c"
				}
			}
#line 865 "../src/librygel-renderer/rygel-av-transport.vala"
			g_object_unref (_data_->_async_result);
#line 865 "../src/librygel-renderer/rygel-av-transport.vala"
			return FALSE;
#line 4771 "rygel-av-transport.c"
		}
#line 868 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp38_ = _data_->message;
#line 868 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp39_ = soup_message_get_response_headers (_data_->_tmp38_);
#line 868 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp40_ = _data_->_tmp39_;
#line 868 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp41_ = soup_message_headers_get_one (_data_->_tmp40_, "Content-Type");
#line 868 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp42_ = g_strdup (_data_->_tmp41_);
#line 868 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->mime = _data_->_tmp42_;
#line 869 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp43_ = _data_->message;
#line 869 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp44_ = soup_message_get_response_headers (_data_->_tmp43_);
#line 869 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 869 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp46_ = soup_message_headers_get_one (_data_->_tmp45_, "contentFeatures.dlna.org");
#line 869 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp47_ = g_strdup (_data_->_tmp46_);
#line 869 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->features = _data_->_tmp47_;
#line 872 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp49_ = _data_->mime;
#line 872 "../src/librygel-renderer/rygel-av-transport.vala"
		if (!rygel_av_transport_is_valid_mime_type (_data_->self, _data_->_tmp49_)) {
#line 873 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp50_ = _data_->mime;
#line 873 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp51_ = _data_->features;
#line 873 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp48_ = !rygel_av_transport_is_playlist (_data_->self, _data_->_tmp50_, _data_->_tmp51_);
#line 4807 "rygel-av-transport.c"
		} else {
#line 872 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp48_ = FALSE;
#line 4811 "rygel-av-transport.c"
		}
#line 872 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_tmp48_) {
#line 874 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp52_ = _data_->mime;
#line 874 "../src/librygel-renderer/rygel-av-transport.vala"
			g_debug ("rygel-av-transport.vala:874: Unsupported mime type %s", _data_->_tmp52_);
#line 875 "../src/librygel-renderer/rygel-av-transport.vala"
			gupnp_service_action_return_error (_data_->action, (guint) 714, _ ("Illegal MIME-type"));
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (_data_->features);
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (_data_->mime);
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_object_unref0 (_data_->message);
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
			_g_free0 (_data_->new_uri);
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
			if (_data_->_state_ != 0) {
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4837 "rygel-av-transport.c"
				}
			}
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
			g_object_unref (_data_->_async_result);
#line 877 "../src/librygel-renderer/rygel-av-transport.vala"
			return FALSE;
#line 4844 "rygel-av-transport.c"
		}
#line 880 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp53_ = _data_->mime;
#line 880 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp54_ = _data_->features;
#line 880 "../src/librygel-renderer/rygel-av-transport.vala"
		if (rygel_av_transport_is_playlist (_data_->self, _data_->_tmp53_, _data_->_tmp54_)) {
#line 882 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp55_ = _data_->mime;
#line 882 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp56_ = _data_->features;
#line 882 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_state_ = 3;
#line 882 "../src/librygel-renderer/rygel-av-transport.vala"
			rygel_av_transport_handle_playlist (_data_->self, _data_->action, _data_->uri, _data_->metadata, _data_->_tmp55_, _data_->_tmp56_, rygel_av_transport_handle_new_transport_uri_ready, _data_);
#line 882 "../src/librygel-renderer/rygel-av-transport.vala"
			return FALSE;
#line 4862 "rygel-av-transport.c"
			_state_3:
#line 882 "../src/librygel-renderer/rygel-av-transport.vala"
			rygel_av_transport_handle_playlist_finish (_data_->self, _data_->_res_);
#line 4866 "rygel-av-transport.c"
		} else {
#line 888 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp57_ = _data_->mime;
#line 888 "../src/librygel-renderer/rygel-av-transport.vala"
			_data_->_tmp58_ = _data_->features;
#line 888 "../src/librygel-renderer/rygel-av-transport.vala"
			rygel_av_transport_set_single_play_uri (_data_->self, _data_->action, _data_->uri, _data_->metadata, _data_->_tmp57_, _data_->_tmp58_);
#line 4874 "rygel-av-transport.c"
		}
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (_data_->features);
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (_data_->mime);
#line 4880 "rygel-av-transport.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 894 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp59_ = _data_->message;
#line 894 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp60_ = soup_message_get_reason_phrase (_data_->_tmp59_);
#line 894 "../src/librygel-renderer/rygel-av-transport.vala"
		_data_->_tmp61_ = _data_->_tmp60_;
#line 894 "../src/librygel-renderer/rygel-av-transport.vala"
		g_warning (_ ("Failed to access resource at %s: %s"), _data_->uri, _data_->_tmp61_);
#line 898 "../src/librygel-renderer/rygel-av-transport.vala"
		gupnp_service_action_return_error (_data_->action, (guint) 716, _ ("Resource not found"));
#line 900 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (_data_->message);
#line 900 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (_data_->new_uri);
#line 900 "../src/librygel-renderer/rygel-av-transport.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 900 "../src/librygel-renderer/rygel-av-transport.vala"
		if (_data_->_state_ != 0) {
#line 900 "../src/librygel-renderer/rygel-av-transport.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 900 "../src/librygel-renderer/rygel-av-transport.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4909 "rygel-av-transport.c"
			}
		}
#line 900 "../src/librygel-renderer/rygel-av-transport.vala"
		g_object_unref (_data_->_async_result);
#line 900 "../src/librygel-renderer/rygel-av-transport.vala"
		return FALSE;
#line 4916 "rygel-av-transport.c"
	}
	__finally0:
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_object_unref0 (_data_->message);
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		_g_free0 (_data_->new_uri);
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		g_object_unref (_data_->_async_result);
#line 846 "../src/librygel-renderer/rygel-av-transport.vala"
		return FALSE;
#line 4933 "rygel-av-transport.c"
	}
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (_data_->message);
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_data_->new_uri);
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_data_->_state_ != 0) {
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4947 "rygel-av-transport.c"
		}
	}
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_unref (_data_->_async_result);
#line 830 "../src/librygel-renderer/rygel-av-transport.vala"
	return FALSE;
#line 4954 "rygel-av-transport.c"
}

static void
rygel_av_transport_set_single_play_uri (RygelAVTransport* self,
                                        GUPnPServiceAction* action,
                                        const gchar* uri,
                                        const gchar* metadata,
                                        const gchar* mime,
                                        const gchar* features)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp2_label0 = 0;
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
	static GQuark _tmp2_label1 = 0;
#line 904 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 904 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (action != NULL);
#line 904 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (uri != NULL);
#line 904 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (metadata != NULL);
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = gupnp_service_action_get_name (action);
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = _tmp0_;
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("SetAVTransportURI")))) {
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 4990 "rygel-av-transport.c"
			default:
			{
				RygelPlayerController* _tmp4_;
#line 911 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp4_ = self->priv->controller;
#line 911 "../src/librygel-renderer/rygel-av-transport.vala"
				rygel_player_controller_set_single_play_uri (_tmp4_, uri, metadata, mime, features);
#line 912 "../src/librygel-renderer/rygel-av-transport.vala"
				break;
#line 5000 "rygel-av-transport.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("SetNextAVTransportURI")))) {
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 5006 "rygel-av-transport.c"
			default:
			{
				RygelPlayerController* _tmp5_;
#line 914 "../src/librygel-renderer/rygel-av-transport.vala"
				_tmp5_ = self->priv->controller;
#line 914 "../src/librygel-renderer/rygel-av-transport.vala"
				rygel_player_controller_set_next_single_play_uri (_tmp5_, uri, metadata, mime, features);
#line 915 "../src/librygel-renderer/rygel-av-transport.vala"
				break;
#line 5016 "rygel-av-transport.c"
			}
		}
	} else {
#line 909 "../src/librygel-renderer/rygel-av-transport.vala"
		switch (0) {
#line 5022 "rygel-av-transport.c"
			default:
			{
#line 917 "../src/librygel-renderer/rygel-av-transport.vala"
				g_assert_not_reached ();
#line 5027 "rygel-av-transport.c"
			}
		}
	}
#line 920 "../src/librygel-renderer/rygel-av-transport.vala"
	gupnp_service_action_return_success (action);
#line 5033 "rygel-av-transport.c"
}

RygelAVTransport*
rygel_av_transport_construct (GType object_type)
{
	RygelAVTransport * self = NULL;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	self = (RygelAVTransport*) g_object_new (object_type, NULL);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	return self;
#line 5044 "rygel-av-transport.c"
}

RygelAVTransport*
rygel_av_transport_new (void)
{
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	return rygel_av_transport_construct (RYGEL_TYPE_AV_TRANSPORT);
#line 5052 "rygel-av-transport.c"
}

const gchar*
rygel_av_transport_get_status (RygelAVTransport* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 47 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->_status;
#line 48 "../src/librygel-renderer/rygel-av-transport.vala"
	result = _tmp0_;
#line 48 "../src/librygel-renderer/rygel-av-transport.vala"
	return result;
#line 5068 "rygel-av-transport.c"
}

void
rygel_av_transport_set_status (RygelAVTransport* self,
                               const gchar* value)
{
	gchar* _tmp0_;
	RygelChangeLog* _tmp1_;
	const gchar* _tmp2_;
#line 51 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = g_strdup (value);
#line 52 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (self->priv->_status);
#line 52 "../src/librygel-renderer/rygel-av-transport.vala"
	self->priv->_status = _tmp0_;
#line 54 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->changelog;
#line 54 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = self->priv->_status;
#line 54 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp1_, "TransportStatus", _tmp2_);
#line 51 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_av_transport_properties[RYGEL_AV_TRANSPORT_STATUS_PROPERTY]);
#line 5094 "rygel-av-transport.c"
}

const gchar*
rygel_av_transport_get_playback_medium (RygelAVTransport* self)
{
	const gchar* result;
	RygelPlayerController* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 59 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->controller;
#line 60 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_player_controller_get_uri (_tmp0_);
#line 60 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = _tmp2_;
#line 60 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "") == 0;
#line 60 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp3_);
#line 60 "../src/librygel-renderer/rygel-av-transport.vala"
	if (_tmp4_) {
#line 61 "../src/librygel-renderer/rygel-av-transport.vala"
		result = "NONE";
#line 61 "../src/librygel-renderer/rygel-av-transport.vala"
		return result;
#line 5126 "rygel-av-transport.c"
	} else {
#line 63 "../src/librygel-renderer/rygel-av-transport.vala"
		result = "NETWORK";
#line 63 "../src/librygel-renderer/rygel-av-transport.vala"
		return result;
#line 5132 "rygel-av-transport.c"
	}
}

const gchar*
rygel_av_transport_get_possible_playback_media (RygelAVTransport* self)
{
	const gchar* result;
#line 69 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/librygel-renderer/rygel-av-transport.vala"
	result = "NONE,NETWORK";
#line 70 "../src/librygel-renderer/rygel-av-transport.vala"
	return result;
#line 5146 "rygel-av-transport.c"
}

gchar*
rygel_av_transport_get_speed (RygelAVTransport* self)
{
	gchar* result;
	RygelMediaPlayer* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 75 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->player;
#line 76 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = rygel_media_player_get_playback_speed (_tmp0_);
#line 76 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = _tmp1_;
#line 76 "../src/librygel-renderer/rygel-av-transport.vala"
	result = _tmp2_;
#line 76 "../src/librygel-renderer/rygel-av-transport.vala"
	return result;
#line 5168 "rygel-av-transport.c"
}

void
rygel_av_transport_set_speed (RygelAVTransport* self,
                              const gchar* value)
{
	RygelMediaPlayer* _tmp0_;
	RygelChangeLog* _tmp1_;
	RygelMediaPlayer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 79 "../src/librygel-renderer/rygel-av-transport.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = self->priv->player;
#line 80 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_media_player_set_playback_speed (_tmp0_, value);
#line 82 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp1_ = self->priv->changelog;
#line 82 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp2_ = self->priv->player;
#line 82 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp3_ = rygel_media_player_get_playback_speed (_tmp2_);
#line 82 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp4_ = _tmp3_;
#line 82 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp5_ = _tmp4_;
#line 82 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_change_log_log (_tmp1_, "TransportPlaySpeed", _tmp5_);
#line 82 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (_tmp5_);
#line 79 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_av_transport_properties[RYGEL_AV_TRANSPORT_SPEED_PROPERTY]);
#line 5203 "rygel-av-transport.c"
}

static void
rygel_av_transport_class_init (RygelAVTransportClass * klass,
                               gpointer klass_data)
{
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	rygel_av_transport_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_type_class_adjust_private_offset (klass, &RygelAVTransport_private_offset);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_av_transport_real_constructed;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_av_transport_get_property;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_av_transport_set_property;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_av_transport_finalize;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_AV_TRANSPORT_STATUS_PROPERTY, rygel_av_transport_properties[RYGEL_AV_TRANSPORT_STATUS_PROPERTY] = g_param_spec_string ("status", "status", "status", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_AV_TRANSPORT_PLAYBACK_MEDIUM_PROPERTY, rygel_av_transport_properties[RYGEL_AV_TRANSPORT_PLAYBACK_MEDIUM_PROPERTY] = g_param_spec_string ("playback-medium", "playback-medium", "playback-medium", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_AV_TRANSPORT_POSSIBLE_PLAYBACK_MEDIA_PROPERTY, rygel_av_transport_properties[RYGEL_AV_TRANSPORT_POSSIBLE_PLAYBACK_MEDIA_PROPERTY] = g_param_spec_string ("possible-playback-media", "possible-playback-media", "possible-playback-media", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_AV_TRANSPORT_SPEED_PROPERTY, rygel_av_transport_properties[RYGEL_AV_TRANSPORT_SPEED_PROPERTY] = g_param_spec_string ("speed", "speed", "speed", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5230 "rygel-av-transport.c"
}

static void
rygel_av_transport_instance_init (RygelAVTransport * self,
                                  gpointer klass)
{
	gchar* _tmp0_;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	self->priv = rygel_av_transport_get_instance_private (self);
#line 45 "../src/librygel-renderer/rygel-av-transport.vala"
	_tmp0_ = g_strdup ("OK");
#line 45 "../src/librygel-renderer/rygel-av-transport.vala"
	self->priv->_status = _tmp0_;
#line 5244 "rygel-av-transport.c"
}

static void
rygel_av_transport_finalize (GObject * obj)
{
	RygelAVTransport * self;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_AV_TRANSPORT, RygelAVTransport);
#line 42 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (self->priv->session);
#line 43 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (self->priv->protocol_info);
#line 45 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_free0 (self->priv->_status);
#line 86 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (self->priv->changelog);
#line 87 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (self->priv->player);
#line 88 "../src/librygel-renderer/rygel-av-transport.vala"
	_g_object_unref0 (self->priv->controller);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	G_OBJECT_CLASS (rygel_av_transport_parent_class)->finalize (obj);
#line 5267 "rygel-av-transport.c"
}

 G_GNUC_NO_INLINE static GType
rygel_av_transport_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelAVTransportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_av_transport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelAVTransport), 0, (GInstanceInitFunc) rygel_av_transport_instance_init, NULL };
	GType rygel_av_transport_type_id;
	rygel_av_transport_type_id = g_type_register_static (gupnp_service_get_type (), "RygelAVTransport", &g_define_type_info, 0);
	RygelAVTransport_private_offset = g_type_add_instance_private (rygel_av_transport_type_id, sizeof (RygelAVTransportPrivate));
	return rygel_av_transport_type_id;
}

GType
rygel_av_transport_get_type (void)
{
	static volatile gsize rygel_av_transport_type_id__once = 0;
	if (g_once_init_enter (&rygel_av_transport_type_id__once)) {
		GType rygel_av_transport_type_id;
		rygel_av_transport_type_id = rygel_av_transport_get_type_once ();
		g_once_init_leave (&rygel_av_transport_type_id__once, rygel_av_transport_type_id);
	}
	return rygel_av_transport_type_id__once;
}

static void
_vala_rygel_av_transport_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	RygelAVTransport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_AV_TRANSPORT, RygelAVTransport);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	switch (property_id) {
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		case RYGEL_AV_TRANSPORT_STATUS_PROPERTY:
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		g_value_set_string (value, rygel_av_transport_get_status (self));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		break;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		case RYGEL_AV_TRANSPORT_PLAYBACK_MEDIUM_PROPERTY:
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		g_value_set_string (value, rygel_av_transport_get_playback_medium (self));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		break;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		case RYGEL_AV_TRANSPORT_POSSIBLE_PLAYBACK_MEDIA_PROPERTY:
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		g_value_set_string (value, rygel_av_transport_get_possible_playback_media (self));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		break;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		case RYGEL_AV_TRANSPORT_SPEED_PROPERTY:
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		g_value_take_string (value, rygel_av_transport_get_speed (self));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		break;
#line 5326 "rygel-av-transport.c"
		default:
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		break;
#line 5332 "rygel-av-transport.c"
	}
}

static void
_vala_rygel_av_transport_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	RygelAVTransport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_AV_TRANSPORT, RygelAVTransport);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
	switch (property_id) {
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		case RYGEL_AV_TRANSPORT_STATUS_PROPERTY:
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		rygel_av_transport_set_status (self, g_value_get_string (value));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		break;
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		case RYGEL_AV_TRANSPORT_SPEED_PROPERTY:
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		rygel_av_transport_set_speed (self, g_value_get_string (value));
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		break;
#line 5358 "rygel-av-transport.c"
		default:
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/librygel-renderer/rygel-av-transport.vala"
		break;
#line 5364 "rygel-av-transport.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

