/* rygel-media-object.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-media-object.vala, do not modify */

/*
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali <zeenix@gmail.com>
 *         Doug Galligan <doug@sentosatech.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <libgupnp-av/gupnp-av.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <libxml/tree.h>
#include "rygel-core.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	RYGEL_MEDIA_OBJECT_0_PROPERTY,
	RYGEL_MEDIA_OBJECT_ID_PROPERTY,
	RYGEL_MEDIA_OBJECT_REF_ID_PROPERTY,
	RYGEL_MEDIA_OBJECT_UPNP_CLASS_PROPERTY,
	RYGEL_MEDIA_OBJECT_DATE_PROPERTY,
	RYGEL_MEDIA_OBJECT_CREATOR_PROPERTY,
	RYGEL_MEDIA_OBJECT_MODIFIED_PROPERTY,
	RYGEL_MEDIA_OBJECT_OBJECT_UPDATE_ID_PROPERTY,
	RYGEL_MEDIA_OBJECT_ARTIST_PROPERTY,
	RYGEL_MEDIA_OBJECT_GENRE_PROPERTY,
	RYGEL_MEDIA_OBJECT_PARENT_PROPERTY,
	RYGEL_MEDIA_OBJECT_PARENT_REF_PROPERTY,
	RYGEL_MEDIA_OBJECT_TITLE_PROPERTY,
	RYGEL_MEDIA_OBJECT_OCM_FLAGS_PROPERTY,
	RYGEL_MEDIA_OBJECT_RESTRICTED_PROPERTY,
	RYGEL_MEDIA_OBJECT_NUM_PROPERTIES
};
static GParamSpec* rygel_media_object_properties[RYGEL_MEDIA_OBJECT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _RygelMediaObjectGetWritableData RygelMediaObjectGetWritableData;
typedef struct _RygelMediaObjectGetWritablesData RygelMediaObjectGetWritablesData;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _RygelMediaObjectApplyFragmentsData RygelMediaObjectApplyFragmentsData;
typedef struct _RygelMediaObjectCheckWritableData RygelMediaObjectCheckWritableData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define RYGEL_TYPE_MEDIA_ITEM_ERROR (rygel_media_item_error_get_type ())

struct _RygelMediaObjectPrivate {
	gchar* _id;
	gchar* _ref_id;
	gchar* _upnp_class;
	gchar* _date;
	gchar* _creator;
	guint64 _modified;
	guint _object_update_id;
	gchar* _artist;
	gchar* _genre;
	GeeArrayList* uris;
	GeeList* media_resources;
	RygelMediaContainer* _parent_ref;
	gchar* _title;
};

struct _RygelMediaObjectGetWritableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelMediaObject* self;
	GCancellable* cancellable;
	GFile* result;
	GeeArrayList* _uri_list;
	GeeArrayList* _tmp0_;
	gint _uri_size;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _uri_index;
	gint _tmp4_;
	gint _tmp5_;
	gchar* uri;
	GeeArrayList* _tmp6_;
	gpointer _tmp7_;
	GFile* file;
	const gchar* _tmp8_;
	GFile* _tmp9_;
	gboolean _tmp10_;
	GFile* _tmp11_;
	GError* _inner_error0_;
};

struct _RygelMediaObjectGetWritablesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelMediaObject* self;
	GCancellable* cancellable;
	GeeArrayList* result;
	GeeArrayList* writables;
	GeeArrayList* _tmp0_;
	GeeArrayList* _uri_list;
	GeeArrayList* _tmp1_;
	gint _uri_size;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _uri_index;
	gint _tmp5_;
	gint _tmp6_;
	gchar* uri;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	GFile* file;
	const gchar* _tmp9_;
	GFile* _tmp10_;
	gboolean _tmp11_;
	GFile* _tmp12_;
	GeeArrayList* _tmp13_;
	GFile* _tmp14_;
	GError* _inner_error0_;
};

struct _Block4Data {
	int _ref_count_;
	gchar* replaced_string;
};

struct _RygelMediaObjectApplyFragmentsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelMediaObject* self;
	GeeLinkedList* current_fragments;
	GeeLinkedList* new_fragments;
	RygelHTTPServer* http_server;
	GUPnPDIDLLiteFragmentResult result;
	GUPnPDIDLLiteFragmentResult _result_;
	RygelSerializer* writer;
	RygelSerializer* _tmp0_;
	GUPnPDIDLLiteObject* didl_object;
	RygelSerializer* _tmp1_;
	GUPnPDIDLLiteObject* _tmp2_;
	GUPnPDIDLLiteObject* _tmp3_;
	xmlNode* _tmp4_;
	xmlNode* _tmp5_;
	GUPnPDIDLLiteObject* _tmp6_;
	xmlNs* _tmp7_;
	xmlNs* _tmp8_;
	GUPnPDIDLLiteObject* _tmp9_;
	gint _tmp10_;
	gpointer* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
	gpointer* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	GUPnPDIDLLiteObject* _tmp16_;
	GError* e;
	GError* _tmp17_;
	const gchar* _tmp18_;
	GError* _inner_error0_;
};

struct _RygelMediaObjectCheckWritableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	RygelMediaObject* self;
	GFile* file;
	GCancellable* cancellable;
	gboolean result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	GFileInfo* info;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	GError* _inner_error0_;
};

typedef enum  {
	RYGEL_MEDIA_ITEM_ERROR_BAD_URI
} RygelMediaItemError;
#define RYGEL_MEDIA_ITEM_ERROR rygel_media_item_error_quark ()

static gint RygelMediaObject_private_offset;
static gpointer rygel_media_object_parent_class = NULL;
static GRegex* rygel_media_object_real_name_regex;
static GRegex* rygel_media_object_real_name_regex = NULL;
static GRegex* rygel_media_object_user_name_regex;
static GRegex* rygel_media_object_user_name_regex = NULL;
static GRegex* rygel_media_object_host_name_regex;
static GRegex* rygel_media_object_host_name_regex = NULL;
static GRegex* rygel_media_object_pretty_name_regex;
static GRegex* rygel_media_object_pretty_name_regex = NULL;

VALA_EXTERN void rygel_media_object_apply_didl_lite (RygelMediaObject* self,
                                         GUPnPDIDLLiteObject* didl_object);
VALA_EXTERN gint rygel_media_object_compare_by_property (RygelMediaObject* self,
                                             RygelMediaObject* media_object,
                                             const gchar* property);
static void rygel_media_object_real_add_uri (RygelMediaObject* self,
                                      const gchar* uri);
static void rygel_media_object_real_constructed (GObject* base);
static void rygel_media_object_get_writable_data_free (gpointer _data);
static gboolean rygel_media_object_get_writable_co (RygelMediaObjectGetWritableData* _data_);
static void rygel_media_object_check_writable (RygelMediaObject* self,
                                        GFile* file,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean rygel_media_object_check_writable_finish (RygelMediaObject* self,
                                                   GAsyncResult* _res_,
                                                   GError** error);
static void rygel_media_object_get_writable_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void rygel_media_object_get_writables_data_free (gpointer _data);
static gboolean rygel_media_object_get_writables_co (RygelMediaObjectGetWritablesData* _data_);
static void rygel_media_object_get_writables_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static GUPnPDIDLLiteObject* rygel_media_object_real_serialize (RygelMediaObject* self,
                                                        RygelSerializer* serializer,
                                                        RygelHTTPServer* http_server,
                                                        GError** error);
VALA_EXTERN gchar* rygel_http_server_create_uri_for_object (RygelHTTPServer* self,
                                                RygelMediaObject* object,
                                                gint thumbnail_index,
                                                gint subtitle_index,
                                                const gchar* resource_name);
VALA_EXTERN gchar* rygel_media_object_get_protocol_for_uri (RygelMediaObject* self,
                                                const gchar* uri,
                                                GError** error);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda4_ (Block4Data* _data4_,
                 const gchar* search_string,
                 const gchar* replacement);
static void ___lambda4__gh_func (gconstpointer key,
                          gconstpointer value,
                          gpointer self);
static RygelDataSource* rygel_media_object_real_create_stream_source_for_resource (RygelMediaObject* self,
                                                                            RygelHTTPRequest* request,
                                                                            RygelMediaResource* resource,
                                                                            GError** error);
static void rygel_media_object_real_apply_didl_lite (RygelMediaObject* self,
                                              GUPnPDIDLLiteObject* didl_object);
static gchar* rygel_media_object_get_first (RygelMediaObject* self,
                                     GList* contributors);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void rygel_media_object_clean_node (RygelMediaObject* self,
                                    xmlNode* node,
                                    xmlNs* ns);
static void rygel_media_object_apply_fragments_data_free (gpointer _data);
VALA_EXTERN void rygel_media_object_apply_fragments (RygelMediaObject* self,
                                         GeeLinkedList* current_fragments,
                                         GeeLinkedList* new_fragments,
                                         RygelHTTPServer* http_server,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN GUPnPDIDLLiteFragmentResult rygel_media_object_apply_fragments_finish (RygelMediaObject* self,
                                                                       GAsyncResult* _res_);
static gboolean rygel_media_object_apply_fragments_co (RygelMediaObjectApplyFragmentsData* _data_);
static void rygel_media_object_apply_fragments_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static gint rygel_media_object_real_compare_by_property (RygelMediaObject* self,
                                                  RygelMediaObject* media_object,
                                                  const gchar* property);
static gint rygel_media_object_compare_by_date (RygelMediaObject* self,
                                         RygelMediaObject* object);
static void rygel_media_object_check_writable_data_free (gpointer _data);
static gboolean rygel_media_object_check_writable_co (RygelMediaObjectCheckWritableData* _data_);
static void rygel_media_object_check_writable_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
VALA_EXTERN GQuark rygel_media_item_error_quark (void);
VALA_EXTERN GType rygel_media_item_error_get_type (void) G_GNUC_CONST ;
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
VALA_EXTERN gboolean rygel_media_object_get_restricted (RygelMediaObject* self);
static void rygel_media_object_finalize (GObject * obj);
static GType rygel_media_object_get_type_once (void);
static void _vala_rygel_media_object_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_rygel_media_object_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rygel_media_object_get_instance_private (RygelMediaObject* self)
{
	return G_STRUCT_MEMBER_P (self, RygelMediaObject_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/librygel-server/rygel-media-object.vala"
	return self ? g_object_ref (self) : NULL;
#line 355 "rygel-media-object.c"
}

GeeList*
rygel_media_object_get_uris (RygelMediaObject* self)
{
	GeeArrayList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 58 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->uris;
#line 58 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _g_object_ref0 ((GeeList*) _tmp0_);
#line 58 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp1_;
#line 58 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 374 "rygel-media-object.c"
}

gchar*
rygel_media_object_get_primary_uri (RygelMediaObject* self)
{
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	gchar* result;
#line 60 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->uris;
#line 61 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 61 "../src/librygel-server/rygel-media-object.vala"
	_tmp2_ = _tmp1_;
#line 61 "../src/librygel-server/rygel-media-object.vala"
	if (_tmp2_) {
#line 62 "../src/librygel-server/rygel-media-object.vala"
		result = NULL;
#line 62 "../src/librygel-server/rygel-media-object.vala"
		return result;
#line 400 "rygel-media-object.c"
	}
#line 65 "../src/librygel-server/rygel-media-object.vala"
	_tmp3_ = self->priv->uris;
#line 65 "../src/librygel-server/rygel-media-object.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, 0);
#line 65 "../src/librygel-server/rygel-media-object.vala"
	result = (gchar*) _tmp4_;
#line 65 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 410 "rygel-media-object.c"
}

static void
rygel_media_object_real_add_uri (RygelMediaObject* self,
                                 const gchar* uri)
{
	GeeArrayList* _tmp0_;
#line 68 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (uri != NULL);
#line 69 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->uris;
#line 69 "../src/librygel-server/rygel-media-object.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, uri);
#line 424 "rygel-media-object.c"
}

void
rygel_media_object_add_uri (RygelMediaObject* self,
                            const gchar* uri)
{
	RygelMediaObjectClass* _klass_;
#line 68 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/librygel-server/rygel-media-object.vala"
	_klass_ = RYGEL_MEDIA_OBJECT_GET_CLASS (self);
#line 68 "../src/librygel-server/rygel-media-object.vala"
	if (_klass_->add_uri) {
#line 68 "../src/librygel-server/rygel-media-object.vala"
		_klass_->add_uri (self, uri);
#line 440 "rygel-media-object.c"
	}
}

static void
rygel_media_object_real_constructed (GObject* base)
{
	RygelMediaObject * self;
	GeeArrayList* _tmp0_;
#line 178 "../src/librygel-server/rygel-media-object.vala"
	self = (RygelMediaObject*) base;
#line 179 "../src/librygel-server/rygel-media-object.vala"
	G_OBJECT_CLASS (rygel_media_object_parent_class)->constructed (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 181 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 181 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (self->priv->uris);
#line 181 "../src/librygel-server/rygel-media-object.vala"
	self->priv->uris = _tmp0_;
#line 459 "rygel-media-object.c"
}

static void
rygel_media_object_get_writable_data_free (gpointer _data)
{
	RygelMediaObjectGetWritableData* _data_;
	_data_ = _data;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->result);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_slice_free (RygelMediaObjectGetWritableData, _data_);
#line 475 "rygel-media-object.c"
}

void
rygel_media_object_get_writable (RygelMediaObject* self,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	RygelMediaObjectGetWritableData* _data_;
	RygelMediaObject* _tmp0_;
	GCancellable* _tmp1_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_ = g_slice_new0 (RygelMediaObjectGetWritableData);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_media_object_get_writable_data_free);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->self = _tmp0_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->cancellable = _tmp1_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_get_writable_co (_data_);
#line 507 "rygel-media-object.c"
}

GFile*
rygel_media_object_get_writable_finish (RygelMediaObject* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	GFile* result;
	RygelMediaObjectGetWritableData* _data_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	if (NULL == _data_) {
#line 36 "../src/librygel-server/rygel-media-object.vala"
		return NULL;
#line 523 "rygel-media-object.c"
	}
#line 36 "../src/librygel-server/rygel-media-object.vala"
	result = _data_->result;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->result = NULL;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 531 "rygel-media-object.c"
}

/**
     * Fetches a File object for any writable URI available for this object.
     *
     * @param cancellable A GLib.Cancellable
     */
static void
rygel_media_object_get_writable_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	RygelMediaObjectGetWritableData* _data_;
#line 193 "../src/librygel-server/rygel-media-object.vala"
	_data_ = _user_data_;
#line 193 "../src/librygel-server/rygel-media-object.vala"
	_data_->_source_object_ = source_object;
#line 193 "../src/librygel-server/rygel-media-object.vala"
	_data_->_res_ = _res_;
#line 193 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_get_writable_co (_data_);
#line 553 "rygel-media-object.c"
}

static gboolean
rygel_media_object_get_writable_co (RygelMediaObjectGetWritableData* _data_)
{
#line 189 "../src/librygel-server/rygel-media-object.vala"
	switch (_data_->_state_) {
#line 189 "../src/librygel-server/rygel-media-object.vala"
		case 0:
#line 563 "rygel-media-object.c"
		goto _state_0;
#line 189 "../src/librygel-server/rygel-media-object.vala"
		case 1:
#line 567 "rygel-media-object.c"
		goto _state_1;
		default:
#line 189 "../src/librygel-server/rygel-media-object.vala"
		g_assert_not_reached ();
#line 572 "rygel-media-object.c"
	}
	_state_0:
	{
#line 190 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp0_ = _data_->self->priv->uris;
#line 190 "../src/librygel-server/rygel-media-object.vala"
		_data_->_uri_list = _data_->_tmp0_;
#line 190 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp1_ = _data_->_uri_list;
#line 190 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp1_);
#line 190 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 190 "../src/librygel-server/rygel-media-object.vala"
		_data_->_uri_size = _data_->_tmp3_;
#line 190 "../src/librygel-server/rygel-media-object.vala"
		_data_->_uri_index = -1;
#line 190 "../src/librygel-server/rygel-media-object.vala"
		while (TRUE) {
#line 190 "../src/librygel-server/rygel-media-object.vala"
			_data_->_uri_index = _data_->_uri_index + 1;
#line 190 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp4_ = _data_->_uri_index;
#line 190 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp5_ = _data_->_uri_size;
#line 190 "../src/librygel-server/rygel-media-object.vala"
			if (!(_data_->_tmp4_ < _data_->_tmp5_)) {
#line 190 "../src/librygel-server/rygel-media-object.vala"
				break;
#line 602 "rygel-media-object.c"
			}
#line 190 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp6_ = _data_->_uri_list;
#line 190 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp6_, _data_->_uri_index);
#line 190 "../src/librygel-server/rygel-media-object.vala"
			_data_->uri = (gchar*) _data_->_tmp7_;
#line 191 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp8_ = _data_->uri;
#line 191 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp9_ = g_file_new_for_uri (_data_->_tmp8_);
#line 191 "../src/librygel-server/rygel-media-object.vala"
			_data_->file = _data_->_tmp9_;
#line 193 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp11_ = _data_->file;
#line 193 "../src/librygel-server/rygel-media-object.vala"
			_data_->_state_ = 1;
#line 193 "../src/librygel-server/rygel-media-object.vala"
			rygel_media_object_check_writable (_data_->self, _data_->_tmp11_, _data_->cancellable, rygel_media_object_get_writable_ready, _data_);
#line 193 "../src/librygel-server/rygel-media-object.vala"
			return FALSE;
#line 624 "rygel-media-object.c"
			_state_1:
#line 193 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp10_ = rygel_media_object_check_writable_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 193 "../src/librygel-server/rygel-media-object.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 193 "../src/librygel-server/rygel-media-object.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 193 "../src/librygel-server/rygel-media-object.vala"
				_g_object_unref0 (_data_->file);
#line 193 "../src/librygel-server/rygel-media-object.vala"
				_g_free0 (_data_->uri);
#line 193 "../src/librygel-server/rygel-media-object.vala"
				g_object_unref (_data_->_async_result);
#line 193 "../src/librygel-server/rygel-media-object.vala"
				return FALSE;
#line 640 "rygel-media-object.c"
			}
#line 193 "../src/librygel-server/rygel-media-object.vala"
			if (_data_->_tmp10_) {
#line 194 "../src/librygel-server/rygel-media-object.vala"
				_data_->result = _data_->file;
#line 194 "../src/librygel-server/rygel-media-object.vala"
				_g_free0 (_data_->uri);
#line 194 "../src/librygel-server/rygel-media-object.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 194 "../src/librygel-server/rygel-media-object.vala"
				if (_data_->_state_ != 0) {
#line 194 "../src/librygel-server/rygel-media-object.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 194 "../src/librygel-server/rygel-media-object.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 656 "rygel-media-object.c"
					}
				}
#line 194 "../src/librygel-server/rygel-media-object.vala"
				g_object_unref (_data_->_async_result);
#line 194 "../src/librygel-server/rygel-media-object.vala"
				return FALSE;
#line 663 "rygel-media-object.c"
			}
#line 190 "../src/librygel-server/rygel-media-object.vala"
			_g_object_unref0 (_data_->file);
#line 190 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_data_->uri);
#line 669 "rygel-media-object.c"
		}
	}
#line 198 "../src/librygel-server/rygel-media-object.vala"
	_data_->result = NULL;
#line 198 "../src/librygel-server/rygel-media-object.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 198 "../src/librygel-server/rygel-media-object.vala"
	if (_data_->_state_ != 0) {
#line 198 "../src/librygel-server/rygel-media-object.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 198 "../src/librygel-server/rygel-media-object.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 682 "rygel-media-object.c"
		}
	}
#line 198 "../src/librygel-server/rygel-media-object.vala"
	g_object_unref (_data_->_async_result);
#line 198 "../src/librygel-server/rygel-media-object.vala"
	return FALSE;
#line 689 "rygel-media-object.c"
}

static void
rygel_media_object_get_writables_data_free (gpointer _data)
{
	RygelMediaObjectGetWritablesData* _data_;
	_data_ = _data;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->result);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_slice_free (RygelMediaObjectGetWritablesData, _data_);
#line 705 "rygel-media-object.c"
}

void
rygel_media_object_get_writables (RygelMediaObject* self,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	RygelMediaObjectGetWritablesData* _data_;
	RygelMediaObject* _tmp0_;
	GCancellable* _tmp1_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_ = g_slice_new0 (RygelMediaObjectGetWritablesData);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_media_object_get_writables_data_free);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->self = _tmp0_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->cancellable = _tmp1_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_get_writables_co (_data_);
#line 737 "rygel-media-object.c"
}

GeeArrayList*
rygel_media_object_get_writables_finish (RygelMediaObject* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	GeeArrayList* result;
	RygelMediaObjectGetWritablesData* _data_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	if (NULL == _data_) {
#line 36 "../src/librygel-server/rygel-media-object.vala"
		return NULL;
#line 753 "rygel-media-object.c"
	}
#line 36 "../src/librygel-server/rygel-media-object.vala"
	result = _data_->result;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->result = NULL;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 761 "rygel-media-object.c"
}

/**
     * Fetches File objects for all writable URIs available for this object.
     *
     * @param cancellable A GLib.Cancellable
     */
static void
rygel_media_object_get_writables_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	RygelMediaObjectGetWritablesData* _data_;
#line 213 "../src/librygel-server/rygel-media-object.vala"
	_data_ = _user_data_;
#line 213 "../src/librygel-server/rygel-media-object.vala"
	_data_->_source_object_ = source_object;
#line 213 "../src/librygel-server/rygel-media-object.vala"
	_data_->_res_ = _res_;
#line 213 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_get_writables_co (_data_);
#line 783 "rygel-media-object.c"
}

static gboolean
rygel_media_object_get_writables_co (RygelMediaObjectGetWritablesData* _data_)
{
#line 206 "../src/librygel-server/rygel-media-object.vala"
	switch (_data_->_state_) {
#line 206 "../src/librygel-server/rygel-media-object.vala"
		case 0:
#line 793 "rygel-media-object.c"
		goto _state_0;
#line 206 "../src/librygel-server/rygel-media-object.vala"
		case 1:
#line 797 "rygel-media-object.c"
		goto _state_1;
		default:
#line 206 "../src/librygel-server/rygel-media-object.vala"
		g_assert_not_reached ();
#line 802 "rygel-media-object.c"
	}
	_state_0:
#line 208 "../src/librygel-server/rygel-media-object.vala"
	_data_->_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 208 "../src/librygel-server/rygel-media-object.vala"
	_data_->writables = _data_->_tmp0_;
#line 809 "rygel-media-object.c"
	{
#line 210 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp1_ = _data_->self->priv->uris;
#line 210 "../src/librygel-server/rygel-media-object.vala"
		_data_->_uri_list = _data_->_tmp1_;
#line 210 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp2_ = _data_->_uri_list;
#line 210 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp2_);
#line 210 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 210 "../src/librygel-server/rygel-media-object.vala"
		_data_->_uri_size = _data_->_tmp4_;
#line 210 "../src/librygel-server/rygel-media-object.vala"
		_data_->_uri_index = -1;
#line 210 "../src/librygel-server/rygel-media-object.vala"
		while (TRUE) {
#line 210 "../src/librygel-server/rygel-media-object.vala"
			_data_->_uri_index = _data_->_uri_index + 1;
#line 210 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp5_ = _data_->_uri_index;
#line 210 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp6_ = _data_->_uri_size;
#line 210 "../src/librygel-server/rygel-media-object.vala"
			if (!(_data_->_tmp5_ < _data_->_tmp6_)) {
#line 210 "../src/librygel-server/rygel-media-object.vala"
				break;
#line 837 "rygel-media-object.c"
			}
#line 210 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp7_ = _data_->_uri_list;
#line 210 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp7_, _data_->_uri_index);
#line 210 "../src/librygel-server/rygel-media-object.vala"
			_data_->uri = (gchar*) _data_->_tmp8_;
#line 211 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp9_ = _data_->uri;
#line 211 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp10_ = g_file_new_for_uri (_data_->_tmp9_);
#line 211 "../src/librygel-server/rygel-media-object.vala"
			_data_->file = _data_->_tmp10_;
#line 213 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp12_ = _data_->file;
#line 213 "../src/librygel-server/rygel-media-object.vala"
			_data_->_state_ = 1;
#line 213 "../src/librygel-server/rygel-media-object.vala"
			rygel_media_object_check_writable (_data_->self, _data_->_tmp12_, _data_->cancellable, rygel_media_object_get_writables_ready, _data_);
#line 213 "../src/librygel-server/rygel-media-object.vala"
			return FALSE;
#line 859 "rygel-media-object.c"
			_state_1:
#line 213 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp11_ = rygel_media_object_check_writable_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 213 "../src/librygel-server/rygel-media-object.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 213 "../src/librygel-server/rygel-media-object.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 213 "../src/librygel-server/rygel-media-object.vala"
				_g_object_unref0 (_data_->file);
#line 213 "../src/librygel-server/rygel-media-object.vala"
				_g_free0 (_data_->uri);
#line 213 "../src/librygel-server/rygel-media-object.vala"
				_g_object_unref0 (_data_->writables);
#line 213 "../src/librygel-server/rygel-media-object.vala"
				g_object_unref (_data_->_async_result);
#line 213 "../src/librygel-server/rygel-media-object.vala"
				return FALSE;
#line 877 "rygel-media-object.c"
			}
#line 213 "../src/librygel-server/rygel-media-object.vala"
			if (_data_->_tmp11_) {
#line 214 "../src/librygel-server/rygel-media-object.vala"
				_data_->_tmp13_ = _data_->writables;
#line 214 "../src/librygel-server/rygel-media-object.vala"
				_data_->_tmp14_ = _data_->file;
#line 214 "../src/librygel-server/rygel-media-object.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp13_, _data_->_tmp14_);
#line 887 "rygel-media-object.c"
			}
#line 210 "../src/librygel-server/rygel-media-object.vala"
			_g_object_unref0 (_data_->file);
#line 210 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_data_->uri);
#line 893 "rygel-media-object.c"
		}
	}
#line 218 "../src/librygel-server/rygel-media-object.vala"
	_data_->result = _data_->writables;
#line 218 "../src/librygel-server/rygel-media-object.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 218 "../src/librygel-server/rygel-media-object.vala"
	if (_data_->_state_ != 0) {
#line 218 "../src/librygel-server/rygel-media-object.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 218 "../src/librygel-server/rygel-media-object.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 906 "rygel-media-object.c"
		}
	}
#line 218 "../src/librygel-server/rygel-media-object.vala"
	g_object_unref (_data_->_async_result);
#line 218 "../src/librygel-server/rygel-media-object.vala"
	return FALSE;
#line 913 "rygel-media-object.c"
}

/**
     * Return the MediaResource list.
     */
GeeList*
rygel_media_object_get_resource_list (RygelMediaObject* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 224 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 225 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->media_resources;
#line 225 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 225 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp1_;
#line 225 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 935 "rygel-media-object.c"
}

RygelMediaResource*
rygel_media_object_get_resource_by_name (RygelMediaObject* self,
                                         const gchar* resource_name)
{
	RygelMediaResource* result;
#line 228 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (resource_name != NULL, NULL);
#line 947 "rygel-media-object.c"
	{
		GeeList* _resource_list = NULL;
		GeeList* _tmp0_;
		gint _resource_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _resource_index = 0;
#line 229 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = self->priv->media_resources;
#line 229 "../src/librygel-server/rygel-media-object.vala"
		_resource_list = _tmp0_;
#line 229 "../src/librygel-server/rygel-media-object.vala"
		_tmp1_ = _resource_list;
#line 229 "../src/librygel-server/rygel-media-object.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 229 "../src/librygel-server/rygel-media-object.vala"
		_tmp3_ = _tmp2_;
#line 229 "../src/librygel-server/rygel-media-object.vala"
		_resource_size = _tmp3_;
#line 229 "../src/librygel-server/rygel-media-object.vala"
		_resource_index = -1;
#line 229 "../src/librygel-server/rygel-media-object.vala"
		while (TRUE) {
#line 972 "rygel-media-object.c"
			gint _tmp4_;
			gint _tmp5_;
			RygelMediaResource* resource = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			RygelMediaResource* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gboolean _tmp11_;
#line 229 "../src/librygel-server/rygel-media-object.vala"
			_resource_index = _resource_index + 1;
#line 229 "../src/librygel-server/rygel-media-object.vala"
			_tmp4_ = _resource_index;
#line 229 "../src/librygel-server/rygel-media-object.vala"
			_tmp5_ = _resource_size;
#line 229 "../src/librygel-server/rygel-media-object.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 229 "../src/librygel-server/rygel-media-object.vala"
				break;
#line 992 "rygel-media-object.c"
			}
#line 229 "../src/librygel-server/rygel-media-object.vala"
			_tmp6_ = _resource_list;
#line 229 "../src/librygel-server/rygel-media-object.vala"
			_tmp7_ = gee_list_get (_tmp6_, _resource_index);
#line 229 "../src/librygel-server/rygel-media-object.vala"
			resource = (RygelMediaResource*) _tmp7_;
#line 230 "../src/librygel-server/rygel-media-object.vala"
			_tmp8_ = resource;
#line 230 "../src/librygel-server/rygel-media-object.vala"
			_tmp9_ = rygel_media_resource_get_name (_tmp8_);
#line 230 "../src/librygel-server/rygel-media-object.vala"
			_tmp10_ = _tmp9_;
#line 230 "../src/librygel-server/rygel-media-object.vala"
			_tmp11_ = g_strcmp0 (_tmp10_, resource_name) == 0;
#line 230 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_tmp10_);
#line 230 "../src/librygel-server/rygel-media-object.vala"
			if (_tmp11_) {
#line 231 "../src/librygel-server/rygel-media-object.vala"
				result = resource;
#line 231 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 1016 "rygel-media-object.c"
			}
#line 229 "../src/librygel-server/rygel-media-object.vala"
			_g_object_unref0 (resource);
#line 1020 "rygel-media-object.c"
		}
	}
#line 235 "../src/librygel-server/rygel-media-object.vala"
	result = NULL;
#line 235 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 1027 "rygel-media-object.c"
}

static GUPnPDIDLLiteObject*
rygel_media_object_real_serialize (RygelMediaObject* self,
                                   RygelSerializer* serializer,
                                   RygelHTTPServer* http_server,
                                   GError** error)
{
#line 238 "../src/librygel-server/rygel-media-object.vala"
	g_critical ("Type `%s' does not implement abstract method `rygel_media_object_serialize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 238 "../src/librygel-server/rygel-media-object.vala"
	return NULL;
#line 1040 "rygel-media-object.c"
}

GUPnPDIDLLiteObject*
rygel_media_object_serialize (RygelMediaObject* self,
                              RygelSerializer* serializer,
                              RygelHTTPServer* http_server,
                              GError** error)
{
	RygelMediaObjectClass* _klass_;
#line 238 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 238 "../src/librygel-server/rygel-media-object.vala"
	_klass_ = RYGEL_MEDIA_OBJECT_GET_CLASS (self);
#line 238 "../src/librygel-server/rygel-media-object.vala"
	if (_klass_->serialize) {
#line 238 "../src/librygel-server/rygel-media-object.vala"
		return _klass_->serialize (self, serializer, http_server, error);
#line 1058 "rygel-media-object.c"
	}
#line 238 "../src/librygel-server/rygel-media-object.vala"
	return NULL;
#line 1062 "rygel-media-object.c"
}

/**
     * Serialize the resource list
     *
     * Any resource with an empty URIs will get a resource-based HTTP URI and have its protocol
     * and delivery options adjusted to the HTTPServer.
     *
     * Internal (e.g. "file:") resources will only be included when the http server
     * is on the local host.
     *
     * Resources will be serialized in list order.
     */
void
rygel_media_object_serialize_resource_list (RygelMediaObject* self,
                                            GUPnPDIDLLiteObject* didl_object,
                                            RygelHTTPServer* http_server,
                                            GError** error)
{
	GHashTable* replacements = NULL;
	GHashTable* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 253 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (didl_object != NULL);
#line 253 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (http_server != NULL);
#line 256 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = rygel_http_server_get_replacements (http_server);
#line 256 "../src/librygel-server/rygel-media-object.vala"
	replacements = _tmp0_;
#line 1095 "rygel-media-object.c"
	{
		GeeList* _res_list = NULL;
		GeeList* _tmp1_;
		gint _res_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _res_index = 0;
#line 257 "../src/librygel-server/rygel-media-object.vala"
		_tmp1_ = rygel_media_object_get_resource_list (self);
#line 257 "../src/librygel-server/rygel-media-object.vala"
		_res_list = _tmp1_;
#line 257 "../src/librygel-server/rygel-media-object.vala"
		_tmp2_ = _res_list;
#line 257 "../src/librygel-server/rygel-media-object.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 257 "../src/librygel-server/rygel-media-object.vala"
		_tmp4_ = _tmp3_;
#line 257 "../src/librygel-server/rygel-media-object.vala"
		_res_size = _tmp4_;
#line 257 "../src/librygel-server/rygel-media-object.vala"
		_res_index = -1;
#line 257 "../src/librygel-server/rygel-media-object.vala"
		while (TRUE) {
#line 1120 "rygel-media-object.c"
			gint _tmp5_;
			gint _tmp6_;
			RygelMediaResource* res = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			gboolean _tmp9_ = FALSE;
			RygelMediaResource* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 257 "../src/librygel-server/rygel-media-object.vala"
			_res_index = _res_index + 1;
#line 257 "../src/librygel-server/rygel-media-object.vala"
			_tmp5_ = _res_index;
#line 257 "../src/librygel-server/rygel-media-object.vala"
			_tmp6_ = _res_size;
#line 257 "../src/librygel-server/rygel-media-object.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 257 "../src/librygel-server/rygel-media-object.vala"
				break;
#line 1140 "rygel-media-object.c"
			}
#line 257 "../src/librygel-server/rygel-media-object.vala"
			_tmp7_ = _res_list;
#line 257 "../src/librygel-server/rygel-media-object.vala"
			_tmp8_ = gee_list_get (_tmp7_, _res_index);
#line 257 "../src/librygel-server/rygel-media-object.vala"
			res = (RygelMediaResource*) _tmp8_;
#line 258 "../src/librygel-server/rygel-media-object.vala"
			_tmp10_ = res;
#line 258 "../src/librygel-server/rygel-media-object.vala"
			_tmp11_ = rygel_media_resource_get_uri (_tmp10_);
#line 258 "../src/librygel-server/rygel-media-object.vala"
			_tmp12_ = _tmp11_;
#line 258 "../src/librygel-server/rygel-media-object.vala"
			if (_tmp12_ == NULL) {
#line 258 "../src/librygel-server/rygel-media-object.vala"
				_tmp9_ = TRUE;
#line 1158 "rygel-media-object.c"
			} else {
				RygelMediaResource* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 258 "../src/librygel-server/rygel-media-object.vala"
				_tmp13_ = res;
#line 258 "../src/librygel-server/rygel-media-object.vala"
				_tmp14_ = rygel_media_resource_get_uri (_tmp13_);
#line 258 "../src/librygel-server/rygel-media-object.vala"
				_tmp15_ = _tmp14_;
#line 258 "../src/librygel-server/rygel-media-object.vala"
				_tmp9_ = g_strcmp0 (_tmp15_, "") == 0;
#line 1171 "rygel-media-object.c"
			}
#line 258 "../src/librygel-server/rygel-media-object.vala"
			if (_tmp9_) {
#line 1175 "rygel-media-object.c"
				gchar* uri = NULL;
				RygelMediaResource* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				RygelMediaFileItem* media_item = NULL;
				RygelMediaFileItem* _tmp21_;
				gboolean _tmp22_ = FALSE;
				RygelMediaFileItem* _tmp23_;
				GUPnPDIDLLiteResource* didl_resource = NULL;
				GUPnPDIDLLiteResource* _tmp31_;
				RygelMediaResource* _tmp32_;
				RygelMediaResource* _tmp33_;
				GUPnPDIDLLiteResource* _tmp34_;
				GHashTable* _tmp35_;
				GUPnPDIDLLiteResource* _tmp36_;
				GUPnPDIDLLiteResource* _tmp37_;
				RygelMediaResource* _tmp38_;
				RygelMediaResource* _tmp39_;
#line 259 "../src/librygel-server/rygel-media-object.vala"
				_tmp16_ = res;
#line 259 "../src/librygel-server/rygel-media-object.vala"
				_tmp17_ = rygel_media_resource_get_name (_tmp16_);
#line 259 "../src/librygel-server/rygel-media-object.vala"
				_tmp18_ = _tmp17_;
#line 259 "../src/librygel-server/rygel-media-object.vala"
				_tmp19_ = rygel_http_server_create_uri_for_object (http_server, self, -1, -1, _tmp18_);
#line 259 "../src/librygel-server/rygel-media-object.vala"
				_tmp20_ = _tmp19_;
#line 259 "../src/librygel-server/rygel-media-object.vala"
				_g_free0 (_tmp18_);
#line 259 "../src/librygel-server/rygel-media-object.vala"
				uri = _tmp20_;
#line 263 "../src/librygel-server/rygel-media-object.vala"
				_tmp21_ = _g_object_ref0 (RYGEL_IS_MEDIA_FILE_ITEM (self) ? ((RygelMediaFileItem*) self) : NULL);
#line 263 "../src/librygel-server/rygel-media-object.vala"
				media_item = _tmp21_;
#line 264 "../src/librygel-server/rygel-media-object.vala"
				_tmp23_ = media_item;
#line 264 "../src/librygel-server/rygel-media-object.vala"
				if (_tmp23_ != NULL) {
#line 1218 "rygel-media-object.c"
					RygelMediaFileItem* _tmp24_;
					gboolean _tmp25_;
					gboolean _tmp26_;
#line 264 "../src/librygel-server/rygel-media-object.vala"
					_tmp24_ = media_item;
#line 264 "../src/librygel-server/rygel-media-object.vala"
					_tmp25_ = rygel_media_file_item_get_place_holder (_tmp24_);
#line 264 "../src/librygel-server/rygel-media-object.vala"
					_tmp26_ = _tmp25_;
#line 264 "../src/librygel-server/rygel-media-object.vala"
					_tmp22_ = _tmp26_;
#line 1230 "rygel-media-object.c"
				} else {
#line 264 "../src/librygel-server/rygel-media-object.vala"
					_tmp22_ = FALSE;
#line 1234 "rygel-media-object.c"
				}
#line 264 "../src/librygel-server/rygel-media-object.vala"
				if (_tmp22_) {
#line 1238 "rygel-media-object.c"
					RygelMediaResource* _tmp27_;
					const gchar* _tmp28_;
#line 265 "../src/librygel-server/rygel-media-object.vala"
					_tmp27_ = res;
#line 265 "../src/librygel-server/rygel-media-object.vala"
					_tmp28_ = uri;
#line 265 "../src/librygel-server/rygel-media-object.vala"
					rygel_media_resource_set_import_uri (_tmp27_, _tmp28_);
#line 1247 "rygel-media-object.c"
				} else {
					RygelMediaResource* _tmp29_;
					const gchar* _tmp30_;
#line 267 "../src/librygel-server/rygel-media-object.vala"
					_tmp29_ = res;
#line 267 "../src/librygel-server/rygel-media-object.vala"
					_tmp30_ = uri;
#line 267 "../src/librygel-server/rygel-media-object.vala"
					rygel_media_resource_set_uri (_tmp29_, _tmp30_);
#line 1257 "rygel-media-object.c"
				}
#line 269 "../src/librygel-server/rygel-media-object.vala"
				_tmp31_ = gupnp_didl_lite_object_add_resource (didl_object);
#line 269 "../src/librygel-server/rygel-media-object.vala"
				didl_resource = _tmp31_;
#line 270 "../src/librygel-server/rygel-media-object.vala"
				_tmp32_ = res;
#line 270 "../src/librygel-server/rygel-media-object.vala"
				rygel_http_server_set_resource_delivery_options (http_server, _tmp32_);
#line 271 "../src/librygel-server/rygel-media-object.vala"
				_tmp33_ = res;
#line 271 "../src/librygel-server/rygel-media-object.vala"
				_tmp34_ = didl_resource;
#line 271 "../src/librygel-server/rygel-media-object.vala"
				_tmp35_ = replacements;
#line 271 "../src/librygel-server/rygel-media-object.vala"
				_tmp36_ = rygel_media_resource_serialize (_tmp33_, _tmp34_, _tmp35_);
#line 271 "../src/librygel-server/rygel-media-object.vala"
				_tmp37_ = _tmp36_;
#line 271 "../src/librygel-server/rygel-media-object.vala"
				_g_object_unref0 (_tmp37_);
#line 272 "../src/librygel-server/rygel-media-object.vala"
				_tmp38_ = res;
#line 272 "../src/librygel-server/rygel-media-object.vala"
				rygel_media_resource_set_uri (_tmp38_, NULL);
#line 273 "../src/librygel-server/rygel-media-object.vala"
				_tmp39_ = res;
#line 273 "../src/librygel-server/rygel-media-object.vala"
				rygel_media_resource_set_import_uri (_tmp39_, NULL);
#line 258 "../src/librygel-server/rygel-media-object.vala"
				_g_object_unref0 (didl_resource);
#line 258 "../src/librygel-server/rygel-media-object.vala"
				_g_object_unref0 (media_item);
#line 258 "../src/librygel-server/rygel-media-object.vala"
				_g_free0 (uri);
#line 1293 "rygel-media-object.c"
			} else {
				{
					gchar* protocol = NULL;
					RygelMediaResource* _tmp40_;
					const gchar* _tmp41_;
					const gchar* _tmp42_;
					gchar* _tmp43_;
					gboolean _tmp44_ = FALSE;
					const gchar* _tmp45_;
#line 276 "../src/librygel-server/rygel-media-object.vala"
					_tmp40_ = res;
#line 276 "../src/librygel-server/rygel-media-object.vala"
					_tmp41_ = rygel_media_resource_get_uri (_tmp40_);
#line 276 "../src/librygel-server/rygel-media-object.vala"
					_tmp42_ = _tmp41_;
#line 276 "../src/librygel-server/rygel-media-object.vala"
					_tmp43_ = rygel_media_object_get_protocol_for_uri (self, _tmp42_, &_inner_error0_);
#line 276 "../src/librygel-server/rygel-media-object.vala"
					protocol = _tmp43_;
#line 276 "../src/librygel-server/rygel-media-object.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1315 "rygel-media-object.c"
						goto __catch0_g_error;
					}
#line 277 "../src/librygel-server/rygel-media-object.vala"
					_tmp45_ = protocol;
#line 277 "../src/librygel-server/rygel-media-object.vala"
					if (_tmp45_ != NULL) {
#line 1322 "rygel-media-object.c"
						gboolean _tmp46_ = FALSE;
						const gchar* _tmp47_;
#line 278 "../src/librygel-server/rygel-media-object.vala"
						_tmp47_ = protocol;
#line 278 "../src/librygel-server/rygel-media-object.vala"
						if (g_strcmp0 (_tmp47_, "internal") != 0) {
#line 278 "../src/librygel-server/rygel-media-object.vala"
							_tmp46_ = TRUE;
#line 1331 "rygel-media-object.c"
						} else {
#line 278 "../src/librygel-server/rygel-media-object.vala"
							_tmp46_ = rygel_http_server_is_local (http_server);
#line 1335 "rygel-media-object.c"
						}
#line 278 "../src/librygel-server/rygel-media-object.vala"
						_tmp44_ = _tmp46_;
#line 1339 "rygel-media-object.c"
					} else {
#line 277 "../src/librygel-server/rygel-media-object.vala"
						_tmp44_ = FALSE;
#line 1343 "rygel-media-object.c"
					}
#line 277 "../src/librygel-server/rygel-media-object.vala"
					if (_tmp44_) {
#line 1347 "rygel-media-object.c"
						GUPnPDIDLLiteResource* didl_resource = NULL;
						GUPnPDIDLLiteResource* _tmp48_;
						RygelMediaResource* _tmp49_;
						GUPnPDIDLLiteResource* _tmp50_;
						GHashTable* _tmp51_;
						GUPnPDIDLLiteResource* _tmp52_;
						GUPnPDIDLLiteResource* _tmp53_;
#line 280 "../src/librygel-server/rygel-media-object.vala"
						_tmp48_ = gupnp_didl_lite_object_add_resource (didl_object);
#line 280 "../src/librygel-server/rygel-media-object.vala"
						didl_resource = _tmp48_;
#line 281 "../src/librygel-server/rygel-media-object.vala"
						_tmp49_ = res;
#line 281 "../src/librygel-server/rygel-media-object.vala"
						_tmp50_ = didl_resource;
#line 281 "../src/librygel-server/rygel-media-object.vala"
						_tmp51_ = replacements;
#line 281 "../src/librygel-server/rygel-media-object.vala"
						_tmp52_ = rygel_media_resource_serialize (_tmp49_, _tmp50_, _tmp51_);
#line 281 "../src/librygel-server/rygel-media-object.vala"
						_tmp53_ = _tmp52_;
#line 281 "../src/librygel-server/rygel-media-object.vala"
						_g_object_unref0 (_tmp53_);
#line 277 "../src/librygel-server/rygel-media-object.vala"
						_g_object_unref0 (didl_resource);
#line 1373 "rygel-media-object.c"
					}
#line 275 "../src/librygel-server/rygel-media-object.vala"
					_g_free0 (protocol);
#line 1377 "rygel-media-object.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					RygelMediaResource* _tmp54_;
					const gchar* _tmp55_;
					const gchar* _tmp56_;
#line 275 "../src/librygel-server/rygel-media-object.vala"
					g_clear_error (&_inner_error0_);
#line 284 "../src/librygel-server/rygel-media-object.vala"
					_tmp54_ = res;
#line 284 "../src/librygel-server/rygel-media-object.vala"
					_tmp55_ = rygel_media_resource_get_uri (_tmp54_);
#line 284 "../src/librygel-server/rygel-media-object.vala"
					_tmp56_ = _tmp55_;
#line 284 "../src/librygel-server/rygel-media-object.vala"
					g_warning (_ ("Could not determine protocol for %s"), _tmp56_);
#line 1395 "rygel-media-object.c"
				}
				__finally0:
#line 275 "../src/librygel-server/rygel-media-object.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 275 "../src/librygel-server/rygel-media-object.vala"
					g_propagate_error (error, _inner_error0_);
#line 275 "../src/librygel-server/rygel-media-object.vala"
					_g_object_unref0 (res);
#line 275 "../src/librygel-server/rygel-media-object.vala"
					_g_object_unref0 (_res_list);
#line 275 "../src/librygel-server/rygel-media-object.vala"
					_g_hash_table_unref0 (replacements);
#line 275 "../src/librygel-server/rygel-media-object.vala"
					return;
#line 1410 "rygel-media-object.c"
				}
			}
#line 257 "../src/librygel-server/rygel-media-object.vala"
			_g_object_unref0 (res);
#line 1415 "rygel-media-object.c"
		}
#line 257 "../src/librygel-server/rygel-media-object.vala"
		_g_object_unref0 (_res_list);
#line 1419 "rygel-media-object.c"
	}
#line 253 "../src/librygel-server/rygel-media-object.vala"
	_g_hash_table_unref0 (replacements);
#line 1423 "rygel-media-object.c"
}

/**
     * Replace each key in replacement_pairs with its corresponding
     * value in the source_string and return the result.
     *
     * @param replacement_pairs HashTable of variable -> substitution pairs
     * @param source_string String that shall have the replacements applied
     * to.
     *
     * @return null if source_string is null, string with all replacements
     * applied otherwise.
     */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 301 "../src/librygel-server/rygel-media-object.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 301 "../src/librygel-server/rygel-media-object.vala"
	return _data4_;
#line 1444 "rygel-media-object.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 301 "../src/librygel-server/rygel-media-object.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 301 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_data4_->replaced_string);
#line 301 "../src/librygel-server/rygel-media-object.vala"
		g_slice_free (Block4Data, _data4_);
#line 1458 "rygel-media-object.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1481 "rygel-media-object.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1485 "rygel-media-object.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1491 "rygel-media-object.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1495 "rygel-media-object.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1499 "rygel-media-object.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1507 "rygel-media-object.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1535 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1544 "rygel-media-object.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1558 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1567 "rygel-media-object.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1581 "rygel-media-object.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1590 "rygel-media-object.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1599 "rygel-media-object.c"
}

static void
__lambda4_ (Block4Data* _data4_,
            const gchar* search_string,
            const gchar* replacement)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 309 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (search_string != NULL);
#line 309 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (replacement != NULL);
#line 311 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = _data4_->replaced_string;
#line 311 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = string_replace (_tmp0_, search_string, replacement);
#line 311 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (_data4_->replaced_string);
#line 311 "../src/librygel-server/rygel-media-object.vala"
	_data4_->replaced_string = _tmp1_;
#line 1621 "rygel-media-object.c"
}

static void
___lambda4__gh_func (gconstpointer key,
                     gconstpointer value,
                     gpointer self)
{
#line 309 "../src/librygel-server/rygel-media-object.vala"
	__lambda4_ (self, (const gchar*) key, (const gchar*) value);
#line 1631 "rygel-media-object.c"
}

gchar*
rygel_media_object_apply_replacements (GHashTable* replacement_pairs,
                                       const gchar* source_string)
{
	Block4Data* _data4_;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 301 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (replacement_pairs != NULL, NULL);
#line 301 "../src/librygel-server/rygel-media-object.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 301 "../src/librygel-server/rygel-media-object.vala"
	_data4_->_ref_count_ = 1;
#line 304 "../src/librygel-server/rygel-media-object.vala"
	if (source_string == NULL) {
#line 305 "../src/librygel-server/rygel-media-object.vala"
		result = NULL;
#line 305 "../src/librygel-server/rygel-media-object.vala"
		block4_data_unref (_data4_);
#line 305 "../src/librygel-server/rygel-media-object.vala"
		_data4_ = NULL;
#line 305 "../src/librygel-server/rygel-media-object.vala"
		return result;
#line 1659 "rygel-media-object.c"
	}
#line 308 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = g_strdup (source_string);
#line 308 "../src/librygel-server/rygel-media-object.vala"
	_data4_->replaced_string = _tmp0_;
#line 309 "../src/librygel-server/rygel-media-object.vala"
	g_hash_table_foreach (replacement_pairs, ___lambda4__gh_func, _data4_);
#line 315 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _data4_->replaced_string;
#line 315 "../src/librygel-server/rygel-media-object.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 315 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp2_;
#line 315 "../src/librygel-server/rygel-media-object.vala"
	block4_data_unref (_data4_);
#line 315 "../src/librygel-server/rygel-media-object.vala"
	_data4_ = NULL;
#line 315 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 1679 "rygel-media-object.c"
}

/**
     * Create a stream source for the given resource
     */
static RygelDataSource*
rygel_media_object_real_create_stream_source_for_resource (RygelMediaObject* self,
                                                           RygelHTTPRequest* request,
                                                           RygelMediaResource* resource,
                                                           GError** error)
{
#line 321 "../src/librygel-server/rygel-media-object.vala"
	g_critical ("Type `%s' does not implement abstract method `rygel_media_object_create_stream_source_for_resource'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 321 "../src/librygel-server/rygel-media-object.vala"
	return NULL;
#line 1695 "rygel-media-object.c"
}

RygelDataSource*
rygel_media_object_create_stream_source_for_resource (RygelMediaObject* self,
                                                      RygelHTTPRequest* request,
                                                      RygelMediaResource* resource,
                                                      GError** error)
{
	RygelMediaObjectClass* _klass_;
#line 321 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 321 "../src/librygel-server/rygel-media-object.vala"
	_klass_ = RYGEL_MEDIA_OBJECT_GET_CLASS (self);
#line 321 "../src/librygel-server/rygel-media-object.vala"
	if (_klass_->create_stream_source_for_resource) {
#line 321 "../src/librygel-server/rygel-media-object.vala"
		return _klass_->create_stream_source_for_resource (self, request, resource, error);
#line 1713 "rygel-media-object.c"
	}
#line 321 "../src/librygel-server/rygel-media-object.vala"
	return NULL;
#line 1717 "rygel-media-object.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 328 "../src/librygel-server/rygel-media-object.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1725 "rygel-media-object.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 328 "../src/librygel-server/rygel-media-object.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1733 "rygel-media-object.c"
}

static void
rygel_media_object_real_apply_didl_lite (RygelMediaObject* self,
                                         GUPnPDIDLLiteObject* didl_object)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 326 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (didl_object != NULL);
#line 327 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = gupnp_didl_lite_object_get_title (didl_object);
#line 327 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _tmp0_;
#line 327 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_set_title (self, _tmp1_);
#line 328 "../src/librygel-server/rygel-media-object.vala"
	_tmp2_ = gupnp_didl_lite_object_get_artists (didl_object);
#line 328 "../src/librygel-server/rygel-media-object.vala"
	_tmp3_ = _tmp2_;
#line 328 "../src/librygel-server/rygel-media-object.vala"
	_tmp4_ = rygel_media_object_get_first (self, _tmp3_);
#line 328 "../src/librygel-server/rygel-media-object.vala"
	_tmp5_ = _tmp4_;
#line 328 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_set_artist (self, _tmp5_);
#line 328 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (_tmp5_);
#line 328 "../src/librygel-server/rygel-media-object.vala"
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (_g_list_free__g_object_unref0_ (_tmp3_), NULL));
#line 329 "../src/librygel-server/rygel-media-object.vala"
	_tmp6_ = gupnp_didl_lite_object_get_genre (didl_object);
#line 329 "../src/librygel-server/rygel-media-object.vala"
	_tmp7_ = _tmp6_;
#line 329 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_set_genre (self, _tmp7_);
#line 1776 "rygel-media-object.c"
}

void
rygel_media_object_apply_didl_lite (RygelMediaObject* self,
                                    GUPnPDIDLLiteObject* didl_object)
{
	RygelMediaObjectClass* _klass_;
#line 326 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 326 "../src/librygel-server/rygel-media-object.vala"
	_klass_ = RYGEL_MEDIA_OBJECT_GET_CLASS (self);
#line 326 "../src/librygel-server/rygel-media-object.vala"
	if (_klass_->apply_didl_lite) {
#line 326 "../src/librygel-server/rygel-media-object.vala"
		_klass_->apply_didl_lite (self, didl_object);
#line 1792 "rygel-media-object.c"
	}
}

static void
rygel_media_object_clean_node (RygelMediaObject* self,
                               xmlNode* node,
                               xmlNs* ns)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	xmlAttr* attr = NULL;
	xmlAttr* _tmp1_;
	xmlNode* child = NULL;
	xmlNode* _tmp19_;
#line 333 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 334 "../src/librygel-server/rygel-media-object.vala"
	list = _tmp0_;
#line 335 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = node->properties;
#line 335 "../src/librygel-server/rygel-media-object.vala"
	attr = _tmp1_;
#line 336 "../src/librygel-server/rygel-media-object.vala"
	while (TRUE) {
#line 1819 "rygel-media-object.c"
		xmlAttr* _tmp2_;
		xmlAttr* _tmp3_;
		xmlNs* _tmp4_;
		xmlAttr* _tmp8_;
		xmlAttr* _tmp9_;
#line 336 "../src/librygel-server/rygel-media-object.vala"
		_tmp2_ = attr;
#line 336 "../src/librygel-server/rygel-media-object.vala"
		if (!(_tmp2_ != NULL)) {
#line 336 "../src/librygel-server/rygel-media-object.vala"
			break;
#line 1831 "rygel-media-object.c"
		}
#line 337 "../src/librygel-server/rygel-media-object.vala"
		_tmp3_ = attr;
#line 337 "../src/librygel-server/rygel-media-object.vala"
		_tmp4_ = _tmp3_->ns;
#line 337 "../src/librygel-server/rygel-media-object.vala"
		if (_tmp4_ == ns) {
#line 1839 "rygel-media-object.c"
			GeeArrayList* _tmp5_;
			xmlAttr* _tmp6_;
			const gchar* _tmp7_;
#line 338 "../src/librygel-server/rygel-media-object.vala"
			_tmp5_ = list;
#line 338 "../src/librygel-server/rygel-media-object.vala"
			_tmp6_ = attr;
#line 338 "../src/librygel-server/rygel-media-object.vala"
			_tmp7_ = _tmp6_->name;
#line 338 "../src/librygel-server/rygel-media-object.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp7_);
#line 1851 "rygel-media-object.c"
		}
#line 341 "../src/librygel-server/rygel-media-object.vala"
		_tmp8_ = attr;
#line 341 "../src/librygel-server/rygel-media-object.vala"
		_tmp9_ = _tmp8_->next;
#line 341 "../src/librygel-server/rygel-media-object.vala"
		attr = _tmp9_;
#line 1859 "rygel-media-object.c"
	}
	{
		GeeArrayList* _name_list = NULL;
		GeeArrayList* _tmp10_;
		gint _name_size = 0;
		GeeArrayList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _name_index = 0;
#line 344 "../src/librygel-server/rygel-media-object.vala"
		_tmp10_ = list;
#line 344 "../src/librygel-server/rygel-media-object.vala"
		_name_list = _tmp10_;
#line 344 "../src/librygel-server/rygel-media-object.vala"
		_tmp11_ = _name_list;
#line 344 "../src/librygel-server/rygel-media-object.vala"
		_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 344 "../src/librygel-server/rygel-media-object.vala"
		_tmp13_ = _tmp12_;
#line 344 "../src/librygel-server/rygel-media-object.vala"
		_name_size = _tmp13_;
#line 344 "../src/librygel-server/rygel-media-object.vala"
		_name_index = -1;
#line 344 "../src/librygel-server/rygel-media-object.vala"
		while (TRUE) {
#line 1885 "rygel-media-object.c"
			gint _tmp14_;
			gint _tmp15_;
			gchar* name = NULL;
			GeeArrayList* _tmp16_;
			gpointer _tmp17_;
			const gchar* _tmp18_;
#line 344 "../src/librygel-server/rygel-media-object.vala"
			_name_index = _name_index + 1;
#line 344 "../src/librygel-server/rygel-media-object.vala"
			_tmp14_ = _name_index;
#line 344 "../src/librygel-server/rygel-media-object.vala"
			_tmp15_ = _name_size;
#line 344 "../src/librygel-server/rygel-media-object.vala"
			if (!(_tmp14_ < _tmp15_)) {
#line 344 "../src/librygel-server/rygel-media-object.vala"
				break;
#line 1902 "rygel-media-object.c"
			}
#line 344 "../src/librygel-server/rygel-media-object.vala"
			_tmp16_ = _name_list;
#line 344 "../src/librygel-server/rygel-media-object.vala"
			_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _name_index);
#line 344 "../src/librygel-server/rygel-media-object.vala"
			name = (gchar*) _tmp17_;
#line 345 "../src/librygel-server/rygel-media-object.vala"
			_tmp18_ = name;
#line 345 "../src/librygel-server/rygel-media-object.vala"
			xmlUnsetNsProp (node, ns, (xmlChar*) _tmp18_);
#line 344 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (name);
#line 1916 "rygel-media-object.c"
		}
	}
#line 348 "../src/librygel-server/rygel-media-object.vala"
	_tmp19_ = node->children;
#line 348 "../src/librygel-server/rygel-media-object.vala"
	child = _tmp19_;
#line 349 "../src/librygel-server/rygel-media-object.vala"
	while (TRUE) {
#line 1925 "rygel-media-object.c"
		xmlNode* _tmp20_;
		xmlNode* _tmp21_;
		xmlNode* _tmp22_;
		xmlNode* _tmp23_;
#line 349 "../src/librygel-server/rygel-media-object.vala"
		_tmp20_ = child;
#line 349 "../src/librygel-server/rygel-media-object.vala"
		if (!(_tmp20_ != NULL)) {
#line 349 "../src/librygel-server/rygel-media-object.vala"
			break;
#line 1936 "rygel-media-object.c"
		}
#line 350 "../src/librygel-server/rygel-media-object.vala"
		_tmp21_ = child;
#line 350 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_clean_node (self, _tmp21_, ns);
#line 351 "../src/librygel-server/rygel-media-object.vala"
		_tmp22_ = child;
#line 351 "../src/librygel-server/rygel-media-object.vala"
		_tmp23_ = _tmp22_->next;
#line 351 "../src/librygel-server/rygel-media-object.vala"
		child = _tmp23_;
#line 1948 "rygel-media-object.c"
	}
#line 333 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (list);
#line 1952 "rygel-media-object.c"
}

static void
rygel_media_object_apply_fragments_data_free (gpointer _data)
{
	RygelMediaObjectApplyFragmentsData* _data_;
	_data_ = _data;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->current_fragments);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->new_fragments);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->http_server);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_slice_free (RygelMediaObjectApplyFragmentsData, _data_);
#line 1970 "rygel-media-object.c"
}

void
rygel_media_object_apply_fragments (RygelMediaObject* self,
                                    GeeLinkedList* current_fragments,
                                    GeeLinkedList* new_fragments,
                                    RygelHTTPServer* http_server,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	RygelMediaObjectApplyFragmentsData* _data_;
	RygelMediaObject* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	RygelHTTPServer* _tmp3_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (current_fragments != NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (new_fragments != NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (http_server != NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_ = g_slice_new0 (RygelMediaObjectApplyFragmentsData);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_media_object_apply_fragments_data_free);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->self = _tmp0_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _g_object_ref0 (current_fragments);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->current_fragments);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->current_fragments = _tmp1_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp2_ = _g_object_ref0 (new_fragments);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->new_fragments);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->new_fragments = _tmp2_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp3_ = _g_object_ref0 (http_server);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->http_server);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->http_server = _tmp3_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_apply_fragments_co (_data_);
#line 2024 "rygel-media-object.c"
}

GUPnPDIDLLiteFragmentResult
rygel_media_object_apply_fragments_finish (RygelMediaObject* self,
                                           GAsyncResult* _res_)
{
	GUPnPDIDLLiteFragmentResult result;
	RygelMediaObjectApplyFragmentsData* _data_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	result = _data_->result;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 2039 "rygel-media-object.c"
}

static void
rygel_media_object_apply_fragments_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	RygelMediaObjectApplyFragmentsData* _data_;
#line 377 "../src/librygel-server/rygel-media-object.vala"
	_data_ = _user_data_;
#line 377 "../src/librygel-server/rygel-media-object.vala"
	_data_->_source_object_ = source_object;
#line 377 "../src/librygel-server/rygel-media-object.vala"
	_data_->_res_ = _res_;
#line 377 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_apply_fragments_co (_data_);
#line 2056 "rygel-media-object.c"
}

static gboolean
rygel_media_object_apply_fragments_co (RygelMediaObjectApplyFragmentsData* _data_)
{
#line 355 "../src/librygel-server/rygel-media-object.vala"
	switch (_data_->_state_) {
#line 355 "../src/librygel-server/rygel-media-object.vala"
		case 0:
#line 2066 "rygel-media-object.c"
		goto _state_0;
#line 355 "../src/librygel-server/rygel-media-object.vala"
		case 1:
#line 2070 "rygel-media-object.c"
		goto _state_1;
		default:
#line 355 "../src/librygel-server/rygel-media-object.vala"
		g_assert_not_reached ();
#line 2075 "rygel-media-object.c"
	}
	_state_0:
#line 359 "../src/librygel-server/rygel-media-object.vala"
	_data_->_result_ = GUPNP_DIDL_LITE_FRAGMENT_RESULT_UNKNOWN_ERROR;
#line 2080 "rygel-media-object.c"
	{
#line 362 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp0_ = rygel_serializer_new (RYGEL_SERIALIZER_TYPE_GENERIC_DIDL);
#line 362 "../src/librygel-server/rygel-media-object.vala"
		_data_->writer = _data_->_tmp0_;
#line 363 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp1_ = _data_->writer;
#line 363 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp2_ = rygel_media_object_serialize (_data_->self, _data_->_tmp1_, _data_->http_server, &_data_->_inner_error0_);
#line 363 "../src/librygel-server/rygel-media-object.vala"
		_data_->didl_object = _data_->_tmp2_;
#line 363 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 363 "../src/librygel-server/rygel-media-object.vala"
			_g_object_unref0 (_data_->writer);
#line 2096 "rygel-media-object.c"
			goto __catch0_g_error;
		}
#line 367 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp3_ = _data_->didl_object;
#line 367 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp4_ = gupnp_didl_lite_object_get_xml_node (_data_->_tmp3_);
#line 367 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 367 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp6_ = _data_->didl_object;
#line 367 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp7_ = gupnp_didl_lite_object_get_dlna_namespace (_data_->_tmp6_);
#line 367 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 367 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_clean_node (_data_->self, _data_->_tmp5_, _data_->_tmp8_);
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp9_ = _data_->didl_object;
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp10_ = 0;
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp11_ = gee_collection_to_array ((GeeCollection*) _data_->current_fragments, &_data_->_tmp10_);
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp12__length1 = _data_->_tmp10_;
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp13_ = 0;
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp14_ = gee_collection_to_array ((GeeCollection*) _data_->new_fragments, &_data_->_tmp13_);
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp15__length1 = _data_->_tmp13_;
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_result_ = gupnp_didl_lite_object_apply_fragments (_data_->_tmp9_, _data_->_tmp12_, (gint) _data_->_tmp10_, _data_->_tmp15_, (gint) _data_->_tmp13_);
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp15_ = (_vala_array_free (_data_->_tmp15_, _data_->_tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 370 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp12_ = (_vala_array_free (_data_->_tmp12_, _data_->_tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 374 "../src/librygel-server/rygel-media-object.vala"
		if (_data_->_result_ == GUPNP_DIDL_LITE_FRAGMENT_RESULT_OK) {
#line 375 "../src/librygel-server/rygel-media-object.vala"
			_data_->_tmp16_ = _data_->didl_object;
#line 375 "../src/librygel-server/rygel-media-object.vala"
			rygel_media_object_apply_didl_lite (_data_->self, _data_->_tmp16_);
#line 376 "../src/librygel-server/rygel-media-object.vala"
			if (RYGEL_IS_UPDATABLE_OBJECT (_data_->self)) {
#line 377 "../src/librygel-server/rygel-media-object.vala"
				_data_->_state_ = 1;
#line 377 "../src/librygel-server/rygel-media-object.vala"
				rygel_updatable_object_commit (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, RYGEL_TYPE_UPDATABLE_OBJECT, RygelUpdatableObject), rygel_media_object_apply_fragments_ready, _data_);
#line 377 "../src/librygel-server/rygel-media-object.vala"
				return FALSE;
#line 2151 "rygel-media-object.c"
				_state_1:
#line 377 "../src/librygel-server/rygel-media-object.vala"
				rygel_updatable_object_commit_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, RYGEL_TYPE_UPDATABLE_OBJECT, RygelUpdatableObject), _data_->_res_, &_data_->_inner_error0_);
#line 377 "../src/librygel-server/rygel-media-object.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 377 "../src/librygel-server/rygel-media-object.vala"
					_g_object_unref0 (_data_->didl_object);
#line 377 "../src/librygel-server/rygel-media-object.vala"
					_g_object_unref0 (_data_->writer);
#line 2161 "rygel-media-object.c"
					goto __catch0_g_error;
				}
			}
		}
#line 361 "../src/librygel-server/rygel-media-object.vala"
		_g_object_unref0 (_data_->didl_object);
#line 361 "../src/librygel-server/rygel-media-object.vala"
		_g_object_unref0 (_data_->writer);
#line 2170 "rygel-media-object.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 361 "../src/librygel-server/rygel-media-object.vala"
		_data_->e = _data_->_inner_error0_;
#line 361 "../src/librygel-server/rygel-media-object.vala"
		_data_->_inner_error0_ = NULL;
#line 382 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp17_ = _data_->e;
#line 382 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp18_ = _data_->_tmp17_->message;
#line 382 "../src/librygel-server/rygel-media-object.vala"
		g_debug ("rygel-media-object.vala:382: Failed to apply fragments: %s. Ignoring.", _data_->_tmp18_);
#line 361 "../src/librygel-server/rygel-media-object.vala"
		_g_error_free0 (_data_->e);
#line 2187 "rygel-media-object.c"
	}
	__finally0:
#line 361 "../src/librygel-server/rygel-media-object.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 361 "../src/librygel-server/rygel-media-object.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 361 "../src/librygel-server/rygel-media-object.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 361 "../src/librygel-server/rygel-media-object.vala"
		g_object_unref (_data_->_async_result);
#line 361 "../src/librygel-server/rygel-media-object.vala"
		return FALSE;
#line 2200 "rygel-media-object.c"
	}
#line 386 "../src/librygel-server/rygel-media-object.vala"
	_data_->result = _data_->_result_;
#line 386 "../src/librygel-server/rygel-media-object.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 386 "../src/librygel-server/rygel-media-object.vala"
	if (_data_->_state_ != 0) {
#line 386 "../src/librygel-server/rygel-media-object.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 386 "../src/librygel-server/rygel-media-object.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2212 "rygel-media-object.c"
		}
	}
#line 386 "../src/librygel-server/rygel-media-object.vala"
	g_object_unref (_data_->_async_result);
#line 386 "../src/librygel-server/rygel-media-object.vala"
	return FALSE;
#line 2219 "rygel-media-object.c"
}

static gint
rygel_media_object_real_compare_by_property (RygelMediaObject* self,
                                             RygelMediaObject* media_object,
                                             const gchar* property)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	static GQuark _tmp1_label0 = 0;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	static GQuark _tmp1_label1 = 0;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	static GQuark _tmp1_label2 = 0;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	static GQuark _tmp1_label3 = 0;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	static GQuark _tmp1_label4 = 0;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	static GQuark _tmp1_label5 = 0;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	static GQuark _tmp1_label6 = 0;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	static GQuark _tmp1_label7 = 0;
#line 2245 "rygel-media-object.c"
	gint result;
#line 389 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (media_object != NULL, 0);
#line 389 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (property != NULL, 0);
#line 391 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = property;
#line 391 "../src/librygel-server/rygel-media-object.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 391 "../src/librygel-server/rygel-media-object.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("@id")))) {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2259 "rygel-media-object.c"
			default:
			{
				const gchar* _tmp3_;
				const gchar* _tmp4_;
#line 393 "../src/librygel-server/rygel-media-object.vala"
				_tmp3_ = self->priv->_id;
#line 393 "../src/librygel-server/rygel-media-object.vala"
				_tmp4_ = media_object->priv->_id;
#line 393 "../src/librygel-server/rygel-media-object.vala"
				result = rygel_media_object_compare_string_props (self, _tmp3_, _tmp4_);
#line 393 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2272 "rygel-media-object.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("@parentID")))) {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2278 "rygel-media-object.c"
			default:
			{
				RygelMediaContainer* _tmp5_;
				RygelMediaContainer* _tmp6_;
				const gchar* _tmp7_;
				RygelMediaContainer* _tmp8_;
				RygelMediaContainer* _tmp9_;
				const gchar* _tmp10_;
#line 395 "../src/librygel-server/rygel-media-object.vala"
				_tmp5_ = rygel_media_object_get_parent (self);
#line 395 "../src/librygel-server/rygel-media-object.vala"
				_tmp6_ = _tmp5_;
#line 395 "../src/librygel-server/rygel-media-object.vala"
				_tmp7_ = ((RygelMediaObject*) _tmp6_)->priv->_id;
#line 395 "../src/librygel-server/rygel-media-object.vala"
				_tmp8_ = rygel_media_object_get_parent (media_object);
#line 395 "../src/librygel-server/rygel-media-object.vala"
				_tmp9_ = _tmp8_;
#line 395 "../src/librygel-server/rygel-media-object.vala"
				_tmp10_ = ((RygelMediaObject*) _tmp9_)->priv->_id;
#line 395 "../src/librygel-server/rygel-media-object.vala"
				result = rygel_media_object_compare_string_props (self, _tmp7_, _tmp10_);
#line 395 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2303 "rygel-media-object.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("dc:title")))) {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2309 "rygel-media-object.c"
			default:
			{
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
#line 398 "../src/librygel-server/rygel-media-object.vala"
				_tmp11_ = rygel_media_object_get_title (self);
#line 398 "../src/librygel-server/rygel-media-object.vala"
				_tmp12_ = _tmp11_;
#line 398 "../src/librygel-server/rygel-media-object.vala"
				_tmp13_ = rygel_media_object_get_title (media_object);
#line 398 "../src/librygel-server/rygel-media-object.vala"
				_tmp14_ = _tmp13_;
#line 398 "../src/librygel-server/rygel-media-object.vala"
				result = rygel_media_object_compare_string_props (self, _tmp12_, _tmp14_);
#line 398 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2328 "rygel-media-object.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("upnp:class")))) {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2334 "rygel-media-object.c"
			default:
			{
				const gchar* _tmp15_;
				const gchar* _tmp16_;
#line 400 "../src/librygel-server/rygel-media-object.vala"
				_tmp15_ = self->priv->_upnp_class;
#line 400 "../src/librygel-server/rygel-media-object.vala"
				_tmp16_ = media_object->priv->_upnp_class;
#line 400 "../src/librygel-server/rygel-media-object.vala"
				result = rygel_media_object_compare_string_props (self, _tmp15_, _tmp16_);
#line 400 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2347 "rygel-media-object.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("dc:artist")))) {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2353 "rygel-media-object.c"
			default:
			{
				const gchar* _tmp17_;
				const gchar* _tmp18_;
#line 403 "../src/librygel-server/rygel-media-object.vala"
				_tmp17_ = self->priv->_artist;
#line 403 "../src/librygel-server/rygel-media-object.vala"
				_tmp18_ = media_object->priv->_artist;
#line 403 "../src/librygel-server/rygel-media-object.vala"
				result = rygel_media_object_compare_string_props (self, _tmp17_, _tmp18_);
#line 403 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2366 "rygel-media-object.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("upnp:genre")))) {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2372 "rygel-media-object.c"
			default:
			{
				const gchar* _tmp19_;
				const gchar* _tmp20_;
#line 405 "../src/librygel-server/rygel-media-object.vala"
				_tmp19_ = self->priv->_genre;
#line 405 "../src/librygel-server/rygel-media-object.vala"
				_tmp20_ = media_object->priv->_genre;
#line 405 "../src/librygel-server/rygel-media-object.vala"
				result = rygel_media_object_compare_string_props (self, _tmp19_, _tmp20_);
#line 405 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2385 "rygel-media-object.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("dc:creator")))) {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2391 "rygel-media-object.c"
			default:
			{
				const gchar* _tmp21_;
				const gchar* _tmp22_;
#line 407 "../src/librygel-server/rygel-media-object.vala"
				_tmp21_ = self->priv->_creator;
#line 407 "../src/librygel-server/rygel-media-object.vala"
				_tmp22_ = media_object->priv->_creator;
#line 407 "../src/librygel-server/rygel-media-object.vala"
				result = rygel_media_object_compare_string_props (self, _tmp21_, _tmp22_);
#line 407 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2404 "rygel-media-object.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("dc:date")))) {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2410 "rygel-media-object.c"
			default:
			{
#line 410 "../src/librygel-server/rygel-media-object.vala"
				result = rygel_media_object_compare_by_date (self, media_object);
#line 410 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2417 "rygel-media-object.c"
			}
		}
	} else {
#line 391 "../src/librygel-server/rygel-media-object.vala"
		switch (0) {
#line 2423 "rygel-media-object.c"
			default:
			{
#line 412 "../src/librygel-server/rygel-media-object.vala"
				result = 0;
#line 412 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 2430 "rygel-media-object.c"
			}
		}
	}
}

gint
rygel_media_object_compare_by_property (RygelMediaObject* self,
                                        RygelMediaObject* media_object,
                                        const gchar* property)
{
	RygelMediaObjectClass* _klass_;
#line 389 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 389 "../src/librygel-server/rygel-media-object.vala"
	_klass_ = RYGEL_MEDIA_OBJECT_GET_CLASS (self);
#line 389 "../src/librygel-server/rygel-media-object.vala"
	if (_klass_->compare_by_property) {
#line 389 "../src/librygel-server/rygel-media-object.vala"
		return _klass_->compare_by_property (self, media_object, property);
#line 2450 "rygel-media-object.c"
	}
#line 389 "../src/librygel-server/rygel-media-object.vala"
	return -1;
#line 2454 "rygel-media-object.c"
}

gint
rygel_media_object_compare_string_props (RygelMediaObject* self,
                                         const gchar* prop1,
                                         const gchar* prop2)
{
	gint result;
#line 416 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 416 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (prop1 != NULL, 0);
#line 416 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (prop2 != NULL, 0);
#line 417 "../src/librygel-server/rygel-media-object.vala"
	if (prop1 == NULL) {
#line 418 "../src/librygel-server/rygel-media-object.vala"
		result = -1;
#line 418 "../src/librygel-server/rygel-media-object.vala"
		return result;
#line 2475 "rygel-media-object.c"
	} else {
#line 419 "../src/librygel-server/rygel-media-object.vala"
		if (prop2 == NULL) {
#line 420 "../src/librygel-server/rygel-media-object.vala"
			result = 1;
#line 420 "../src/librygel-server/rygel-media-object.vala"
			return result;
#line 2483 "rygel-media-object.c"
		} else {
#line 422 "../src/librygel-server/rygel-media-object.vala"
			result = g_utf8_collate (prop1, prop2);
#line 422 "../src/librygel-server/rygel-media-object.vala"
			return result;
#line 2489 "rygel-media-object.c"
		}
	}
}

gint
rygel_media_object_compare_int_props (RygelMediaObject* self,
                                      gint prop1,
                                      gint prop2)
{
	gint result;
#line 426 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 427 "../src/librygel-server/rygel-media-object.vala"
	result = CLAMP (prop1 - prop2, -1, 1);
#line 427 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 2506 "rygel-media-object.c"
}

static void
rygel_media_object_check_writable_data_free (gpointer _data)
{
	RygelMediaObjectCheckWritableData* _data_;
	_data_ = _data;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->file);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_slice_free (RygelMediaObjectCheckWritableData, _data_);
#line 2522 "rygel-media-object.c"
}

static void
rygel_media_object_check_writable (RygelMediaObject* self,
                                   GFile* file,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	RygelMediaObjectCheckWritableData* _data_;
	RygelMediaObject* _tmp0_;
	GFile* _tmp1_;
	GCancellable* _tmp2_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (file != NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_ = g_slice_new0 (RygelMediaObjectCheckWritableData);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_task_set_task_data (_data_->_async_result, _data_, rygel_media_object_check_writable_data_free);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->self = _tmp0_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->file);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->file = _tmp1_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (_data_->cancellable);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_->cancellable = _tmp2_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_check_writable_co (_data_);
#line 2564 "rygel-media-object.c"
}

static gboolean
rygel_media_object_check_writable_finish (RygelMediaObject* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	gboolean result;
	RygelMediaObjectCheckWritableData* _data_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	if (NULL == _data_) {
#line 2578 "rygel-media-object.c"
		gboolean _tmp0_ = FALSE;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		return _tmp0_;
#line 2582 "rygel-media-object.c"
	}
#line 36 "../src/librygel-server/rygel-media-object.vala"
	result = _data_->result;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 2588 "rygel-media-object.c"
}

static void
rygel_media_object_check_writable_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	RygelMediaObjectCheckWritableData* _data_;
#line 444 "../src/librygel-server/rygel-media-object.vala"
	_data_ = _user_data_;
#line 444 "../src/librygel-server/rygel-media-object.vala"
	_data_->_source_object_ = source_object;
#line 444 "../src/librygel-server/rygel-media-object.vala"
	_data_->_res_ = _res_;
#line 444 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_check_writable_co (_data_);
#line 2605 "rygel-media-object.c"
}

static gboolean
rygel_media_object_check_writable_co (RygelMediaObjectCheckWritableData* _data_)
{
#line 430 "../src/librygel-server/rygel-media-object.vala"
	switch (_data_->_state_) {
#line 430 "../src/librygel-server/rygel-media-object.vala"
		case 0:
#line 2615 "rygel-media-object.c"
		goto _state_0;
#line 430 "../src/librygel-server/rygel-media-object.vala"
		case 1:
#line 2619 "rygel-media-object.c"
		goto _state_1;
		default:
#line 430 "../src/librygel-server/rygel-media-object.vala"
		g_assert_not_reached ();
#line 2624 "rygel-media-object.c"
	}
	_state_0:
#line 434 "../src/librygel-server/rygel-media-object.vala"
	_data_->_tmp0_ = g_file_get_uri_scheme (_data_->file);
#line 434 "../src/librygel-server/rygel-media-object.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 434 "../src/librygel-server/rygel-media-object.vala"
	_data_->_tmp2_ = g_str_has_prefix (RYGEL_WRITABLE_CONTAINER_WRITABLE_SCHEME, _data_->_tmp1_);
#line 434 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (_data_->_tmp1_);
#line 434 "../src/librygel-server/rygel-media-object.vala"
	if (_data_->_tmp2_) {
#line 436 "../src/librygel-server/rygel-media-object.vala"
		_data_->result = TRUE;
#line 436 "../src/librygel-server/rygel-media-object.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 436 "../src/librygel-server/rygel-media-object.vala"
		if (_data_->_state_ != 0) {
#line 436 "../src/librygel-server/rygel-media-object.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 436 "../src/librygel-server/rygel-media-object.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2647 "rygel-media-object.c"
			}
		}
#line 436 "../src/librygel-server/rygel-media-object.vala"
		g_object_unref (_data_->_async_result);
#line 436 "../src/librygel-server/rygel-media-object.vala"
		return FALSE;
#line 2654 "rygel-media-object.c"
	}
#line 439 "../src/librygel-server/rygel-media-object.vala"
	if (!g_file_is_native (_data_->file)) {
#line 440 "../src/librygel-server/rygel-media-object.vala"
		_data_->result = FALSE;
#line 440 "../src/librygel-server/rygel-media-object.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 440 "../src/librygel-server/rygel-media-object.vala"
		if (_data_->_state_ != 0) {
#line 440 "../src/librygel-server/rygel-media-object.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 440 "../src/librygel-server/rygel-media-object.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2668 "rygel-media-object.c"
			}
		}
#line 440 "../src/librygel-server/rygel-media-object.vala"
		g_object_unref (_data_->_async_result);
#line 440 "../src/librygel-server/rygel-media-object.vala"
		return FALSE;
#line 2675 "rygel-media-object.c"
	}
	{
#line 444 "../src/librygel-server/rygel-media-object.vala"
		_data_->_state_ = 1;
#line 444 "../src/librygel-server/rygel-media-object.vala"
		g_file_query_info_async (_data_->file, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, _data_->cancellable, rygel_media_object_check_writable_ready, _data_);
#line 444 "../src/librygel-server/rygel-media-object.vala"
		return FALSE;
#line 2684 "rygel-media-object.c"
		_state_1:
#line 444 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp3_ = g_file_query_info_finish (_data_->file, _data_->_res_, &_data_->_inner_error0_);
#line 444 "../src/librygel-server/rygel-media-object.vala"
		_data_->info = _data_->_tmp3_;
#line 444 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 444 "../src/librygel-server/rygel-media-object.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 2694 "rygel-media-object.c"
				goto __catch0_g_io_error_not_found;
			}
			goto __finally0;
		}
#line 450 "../src/librygel-server/rygel-media-object.vala"
		_data_->_tmp4_ = _data_->info;
#line 450 "../src/librygel-server/rygel-media-object.vala"
		_data_->result = g_file_info_get_attribute_boolean (_data_->_tmp4_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
#line 450 "../src/librygel-server/rygel-media-object.vala"
		_g_object_unref0 (_data_->info);
#line 450 "../src/librygel-server/rygel-media-object.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 450 "../src/librygel-server/rygel-media-object.vala"
		if (_data_->_state_ != 0) {
#line 450 "../src/librygel-server/rygel-media-object.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 450 "../src/librygel-server/rygel-media-object.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2713 "rygel-media-object.c"
			}
		}
#line 450 "../src/librygel-server/rygel-media-object.vala"
		g_object_unref (_data_->_async_result);
#line 450 "../src/librygel-server/rygel-media-object.vala"
		return FALSE;
#line 2720 "rygel-media-object.c"
	}
	goto __finally0;
	__catch0_g_io_error_not_found:
	{
#line 443 "../src/librygel-server/rygel-media-object.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 452 "../src/librygel-server/rygel-media-object.vala"
		_data_->result = TRUE;
#line 452 "../src/librygel-server/rygel-media-object.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 452 "../src/librygel-server/rygel-media-object.vala"
		if (_data_->_state_ != 0) {
#line 452 "../src/librygel-server/rygel-media-object.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 452 "../src/librygel-server/rygel-media-object.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2737 "rygel-media-object.c"
			}
		}
#line 452 "../src/librygel-server/rygel-media-object.vala"
		g_object_unref (_data_->_async_result);
#line 452 "../src/librygel-server/rygel-media-object.vala"
		return FALSE;
#line 2744 "rygel-media-object.c"
	}
	__finally0:
#line 443 "../src/librygel-server/rygel-media-object.vala"
	g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 443 "../src/librygel-server/rygel-media-object.vala"
	g_object_unref (_data_->_async_result);
#line 443 "../src/librygel-server/rygel-media-object.vala"
	return FALSE;
#line 2753 "rygel-media-object.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 2772 "rygel-media-object.c"
}

static gint
rygel_media_object_compare_by_date (RygelMediaObject* self,
                                    RygelMediaObject* object)
{
	const gchar* _tmp0_;
	gint result;
#line 456 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 456 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (object != NULL, 0);
#line 457 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_date;
#line 457 "../src/librygel-server/rygel-media-object.vala"
	if (_tmp0_ == NULL) {
#line 458 "../src/librygel-server/rygel-media-object.vala"
		result = -1;
#line 458 "../src/librygel-server/rygel-media-object.vala"
		return result;
#line 2793 "rygel-media-object.c"
	} else {
		const gchar* _tmp1_;
#line 459 "../src/librygel-server/rygel-media-object.vala"
		_tmp1_ = object->priv->_date;
#line 459 "../src/librygel-server/rygel-media-object.vala"
		if (_tmp1_ == NULL) {
#line 460 "../src/librygel-server/rygel-media-object.vala"
			result = 1;
#line 460 "../src/librygel-server/rygel-media-object.vala"
			return result;
#line 2804 "rygel-media-object.c"
		} else {
			gchar* our_date = NULL;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* other_date = NULL;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp9_;
			GDateTime* our_date_time = NULL;
			const gchar* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* other_date_time = NULL;
			const gchar* _tmp14_;
			GDateTime* _tmp15_;
			GDateTime* _tmp16_;
			GDateTime* _tmp17_;
#line 462 "../src/librygel-server/rygel-media-object.vala"
			_tmp2_ = self->priv->_date;
#line 462 "../src/librygel-server/rygel-media-object.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 462 "../src/librygel-server/rygel-media-object.vala"
			our_date = _tmp3_;
#line 463 "../src/librygel-server/rygel-media-object.vala"
			_tmp4_ = object->priv->_date;
#line 463 "../src/librygel-server/rygel-media-object.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 463 "../src/librygel-server/rygel-media-object.vala"
			other_date = _tmp5_;
#line 465 "../src/librygel-server/rygel-media-object.vala"
			_tmp6_ = our_date;
#line 465 "../src/librygel-server/rygel-media-object.vala"
			if (!string_contains (_tmp6_, "T")) {
#line 2838 "rygel-media-object.c"
				const gchar* _tmp7_;
				gchar* _tmp8_;
#line 466 "../src/librygel-server/rygel-media-object.vala"
				_tmp7_ = our_date;
#line 466 "../src/librygel-server/rygel-media-object.vala"
				_tmp8_ = g_strconcat (_tmp7_, "T00:00:00Z", NULL);
#line 466 "../src/librygel-server/rygel-media-object.vala"
				_g_free0 (our_date);
#line 466 "../src/librygel-server/rygel-media-object.vala"
				our_date = _tmp8_;
#line 2849 "rygel-media-object.c"
			}
#line 469 "../src/librygel-server/rygel-media-object.vala"
			_tmp9_ = other_date;
#line 469 "../src/librygel-server/rygel-media-object.vala"
			if (!string_contains (_tmp9_, "T")) {
#line 2855 "rygel-media-object.c"
				const gchar* _tmp10_;
				gchar* _tmp11_;
#line 470 "../src/librygel-server/rygel-media-object.vala"
				_tmp10_ = other_date;
#line 470 "../src/librygel-server/rygel-media-object.vala"
				_tmp11_ = g_strconcat (_tmp10_, "T00:00:00Z", NULL);
#line 470 "../src/librygel-server/rygel-media-object.vala"
				_g_free0 (other_date);
#line 470 "../src/librygel-server/rygel-media-object.vala"
				other_date = _tmp11_;
#line 2866 "rygel-media-object.c"
			}
#line 473 "../src/librygel-server/rygel-media-object.vala"
			_tmp12_ = our_date;
#line 473 "../src/librygel-server/rygel-media-object.vala"
			_tmp13_ = g_date_time_new_from_iso8601 (_tmp12_, NULL);
#line 473 "../src/librygel-server/rygel-media-object.vala"
			our_date_time = _tmp13_;
#line 474 "../src/librygel-server/rygel-media-object.vala"
			_tmp14_ = other_date;
#line 474 "../src/librygel-server/rygel-media-object.vala"
			_tmp15_ = g_date_time_new_from_iso8601 (_tmp14_, NULL);
#line 474 "../src/librygel-server/rygel-media-object.vala"
			other_date_time = _tmp15_;
#line 476 "../src/librygel-server/rygel-media-object.vala"
			_tmp16_ = our_date_time;
#line 476 "../src/librygel-server/rygel-media-object.vala"
			_tmp17_ = other_date_time;
#line 476 "../src/librygel-server/rygel-media-object.vala"
			result = g_date_time_compare (_tmp16_, _tmp17_);
#line 476 "../src/librygel-server/rygel-media-object.vala"
			_g_date_time_unref0 (other_date_time);
#line 476 "../src/librygel-server/rygel-media-object.vala"
			_g_date_time_unref0 (our_date_time);
#line 476 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (other_date);
#line 476 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (our_date);
#line 476 "../src/librygel-server/rygel-media-object.vala"
			return result;
#line 2896 "rygel-media-object.c"
		}
	}
}

static gchar*
rygel_media_object_get_first (RygelMediaObject* self,
                              GList* contributors)
{
	gchar* _tmp4_;
	gchar* result;
#line 480 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 481 "../src/librygel-server/rygel-media-object.vala"
	if (contributors != NULL) {
#line 2911 "rygel-media-object.c"
		gconstpointer _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 482 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = contributors->data;
#line 482 "../src/librygel-server/rygel-media-object.vala"
		_tmp1_ = gupnp_didl_lite_contributor_get_name ((GUPnPDIDLLiteContributor*) _tmp0_);
#line 482 "../src/librygel-server/rygel-media-object.vala"
		_tmp2_ = _tmp1_;
#line 482 "../src/librygel-server/rygel-media-object.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 482 "../src/librygel-server/rygel-media-object.vala"
		result = _tmp3_;
#line 482 "../src/librygel-server/rygel-media-object.vala"
		return result;
#line 2928 "rygel-media-object.c"
	}
#line 485 "../src/librygel-server/rygel-media-object.vala"
	_tmp4_ = g_strdup ("");
#line 485 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp4_;
#line 485 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 2936 "rygel-media-object.c"
}

static void
_g_free0_ (gpointer var)
{
#line 497 "../src/librygel-server/rygel-media-object.vala"
	var = (g_free (var), NULL);
#line 2944 "rygel-media-object.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 497 "../src/librygel-server/rygel-media-object.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 2952 "rygel-media-object.c"
}

gchar*
rygel_media_object_get_protocol_for_uri (RygelMediaObject* self,
                                         const gchar* uri,
                                         GError** error)
{
	gchar* scheme = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	RygelMediaEngine* engine = NULL;
	RygelMediaEngine* _tmp3_;
	GList* schemes = NULL;
	RygelMediaEngine* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	const gchar* _tmp7_;
	GCompareFunc _tmp8_;
	GList* _tmp9_;
	const gchar* _tmp10_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 488 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 488 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 489 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = g_uri_parse_scheme (uri);
#line 489 "../src/librygel-server/rygel-media-object.vala"
	scheme = _tmp0_;
#line 490 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = scheme;
#line 490 "../src/librygel-server/rygel-media-object.vala"
	if (_tmp1_ == NULL) {
#line 2987 "rygel-media-object.c"
		GError* _tmp2_;
#line 491 "../src/librygel-server/rygel-media-object.vala"
		_tmp2_ = g_error_new (RYGEL_MEDIA_ITEM_ERROR, RYGEL_MEDIA_ITEM_ERROR_BAD_URI, _ ("Bad URI: %s"), uri);
#line 491 "../src/librygel-server/rygel-media-object.vala"
		_inner_error0_ = _tmp2_;
#line 491 "../src/librygel-server/rygel-media-object.vala"
		g_propagate_error (error, _inner_error0_);
#line 491 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (scheme);
#line 491 "../src/librygel-server/rygel-media-object.vala"
		return NULL;
#line 2999 "rygel-media-object.c"
	}
#line 494 "../src/librygel-server/rygel-media-object.vala"
	_tmp3_ = rygel_media_engine_get_default ();
#line 494 "../src/librygel-server/rygel-media-object.vala"
	engine = _tmp3_;
#line 495 "../src/librygel-server/rygel-media-object.vala"
	_tmp4_ = engine;
#line 495 "../src/librygel-server/rygel-media-object.vala"
	_tmp5_ = rygel_media_engine_get_internal_protocol_schemes (_tmp4_);
#line 495 "../src/librygel-server/rygel-media-object.vala"
	schemes = _tmp5_;
#line 496 "../src/librygel-server/rygel-media-object.vala"
	_tmp6_ = schemes;
#line 496 "../src/librygel-server/rygel-media-object.vala"
	_tmp7_ = scheme;
#line 496 "../src/librygel-server/rygel-media-object.vala"
	_tmp8_ = ((GCompareFunc) g_strcmp0);
#line 496 "../src/librygel-server/rygel-media-object.vala"
	_tmp9_ = g_list_find_custom (_tmp6_, _tmp7_, _tmp8_);
#line 496 "../src/librygel-server/rygel-media-object.vala"
	if (_tmp9_ != NULL) {
#line 497 "../src/librygel-server/rygel-media-object.vala"
		result = NULL;
#line 497 "../src/librygel-server/rygel-media-object.vala"
		(schemes == NULL) ? NULL : (schemes = (_g_list_free__g_free0_ (schemes), NULL));
#line 497 "../src/librygel-server/rygel-media-object.vala"
		_g_object_unref0 (engine);
#line 497 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (scheme);
#line 497 "../src/librygel-server/rygel-media-object.vala"
		return result;
#line 3031 "rygel-media-object.c"
	}
#line 500 "../src/librygel-server/rygel-media-object.vala"
	_tmp10_ = scheme;
#line 500 "../src/librygel-server/rygel-media-object.vala"
	if (g_strcmp0 (_tmp10_, "http") == 0) {
#line 3037 "rygel-media-object.c"
		gchar* _tmp11_;
#line 501 "../src/librygel-server/rygel-media-object.vala"
		_tmp11_ = g_strdup ("http-get");
#line 501 "../src/librygel-server/rygel-media-object.vala"
		result = _tmp11_;
#line 501 "../src/librygel-server/rygel-media-object.vala"
		(schemes == NULL) ? NULL : (schemes = (_g_list_free__g_free0_ (schemes), NULL));
#line 501 "../src/librygel-server/rygel-media-object.vala"
		_g_object_unref0 (engine);
#line 501 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (scheme);
#line 501 "../src/librygel-server/rygel-media-object.vala"
		return result;
#line 3051 "rygel-media-object.c"
	} else {
		const gchar* _tmp12_;
#line 502 "../src/librygel-server/rygel-media-object.vala"
		_tmp12_ = scheme;
#line 502 "../src/librygel-server/rygel-media-object.vala"
		if (g_strcmp0 (_tmp12_, "file") == 0) {
#line 3058 "rygel-media-object.c"
			gchar* _tmp13_;
#line 503 "../src/librygel-server/rygel-media-object.vala"
			_tmp13_ = g_strdup ("internal");
#line 503 "../src/librygel-server/rygel-media-object.vala"
			result = _tmp13_;
#line 503 "../src/librygel-server/rygel-media-object.vala"
			(schemes == NULL) ? NULL : (schemes = (_g_list_free__g_free0_ (schemes), NULL));
#line 503 "../src/librygel-server/rygel-media-object.vala"
			_g_object_unref0 (engine);
#line 503 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (scheme);
#line 503 "../src/librygel-server/rygel-media-object.vala"
			return result;
#line 3072 "rygel-media-object.c"
		} else {
			const gchar* _tmp14_;
#line 504 "../src/librygel-server/rygel-media-object.vala"
			_tmp14_ = scheme;
#line 504 "../src/librygel-server/rygel-media-object.vala"
			if (g_strcmp0 (_tmp14_, "rtsp") == 0) {
#line 3079 "rygel-media-object.c"
				gchar* _tmp15_;
#line 506 "../src/librygel-server/rygel-media-object.vala"
				_tmp15_ = g_strdup ("rtsp-rtp-udp");
#line 506 "../src/librygel-server/rygel-media-object.vala"
				result = _tmp15_;
#line 506 "../src/librygel-server/rygel-media-object.vala"
				(schemes == NULL) ? NULL : (schemes = (_g_list_free__g_free0_ (schemes), NULL));
#line 506 "../src/librygel-server/rygel-media-object.vala"
				_g_object_unref0 (engine);
#line 506 "../src/librygel-server/rygel-media-object.vala"
				_g_free0 (scheme);
#line 506 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 3093 "rygel-media-object.c"
			} else {
				const gchar* _tmp16_;
#line 509 "../src/librygel-server/rygel-media-object.vala"
				_tmp16_ = scheme;
#line 509 "../src/librygel-server/rygel-media-object.vala"
				g_debug ("Could not translate protocol scheme for  %s. " " Using '%s' as-is", uri, _tmp16_);
#line 514 "../src/librygel-server/rygel-media-object.vala"
				result = scheme;
#line 514 "../src/librygel-server/rygel-media-object.vala"
				(schemes == NULL) ? NULL : (schemes = (_g_list_free__g_free0_ (schemes), NULL));
#line 514 "../src/librygel-server/rygel-media-object.vala"
				_g_object_unref0 (engine);
#line 514 "../src/librygel-server/rygel-media-object.vala"
				return result;
#line 3108 "rygel-media-object.c"
			}
		}
	}
}

RygelMediaObject*
rygel_media_object_construct (GType object_type)
{
	RygelMediaObject * self = NULL;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	self = (RygelMediaObject*) g_object_new (object_type, NULL);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	return self;
#line 3122 "rygel-media-object.c"
}

const gchar*
rygel_media_object_get_id (RygelMediaObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_id;
#line 42 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 42 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3138 "rygel-media-object.c"
}

void
rygel_media_object_set_id (RygelMediaObject* self,
                           const gchar* value)
{
	gchar* old_value;
#line 42 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_id (self);
#line 42 "../src/librygel-server/rygel-media-object.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3152 "rygel-media-object.c"
		gchar* _tmp0_;
#line 42 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = g_strdup (value);
#line 42 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_id);
#line 42 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_id = _tmp0_;
#line 42 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_ID_PROPERTY]);
#line 3162 "rygel-media-object.c"
	}
}

const gchar*
rygel_media_object_get_ref_id (RygelMediaObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_ref_id;
#line 43 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 43 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3179 "rygel-media-object.c"
}

void
rygel_media_object_set_ref_id (RygelMediaObject* self,
                               const gchar* value)
{
	gchar* old_value;
#line 43 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_ref_id (self);
#line 43 "../src/librygel-server/rygel-media-object.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3193 "rygel-media-object.c"
		gchar* _tmp0_;
#line 43 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = g_strdup (value);
#line 43 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_ref_id);
#line 43 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_ref_id = _tmp0_;
#line 43 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_REF_ID_PROPERTY]);
#line 3203 "rygel-media-object.c"
	}
}

const gchar*
rygel_media_object_get_upnp_class (RygelMediaObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_upnp_class;
#line 44 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 44 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3220 "rygel-media-object.c"
}

void
rygel_media_object_set_upnp_class (RygelMediaObject* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 44 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_upnp_class (self);
#line 44 "../src/librygel-server/rygel-media-object.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3234 "rygel-media-object.c"
		gchar* _tmp0_;
#line 44 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = g_strdup (value);
#line 44 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_upnp_class);
#line 44 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_upnp_class = _tmp0_;
#line 44 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_UPNP_CLASS_PROPERTY]);
#line 3244 "rygel-media-object.c"
	}
}

const gchar*
rygel_media_object_get_date (RygelMediaObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 45 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_date;
#line 45 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 45 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3261 "rygel-media-object.c"
}

void
rygel_media_object_set_date (RygelMediaObject* self,
                             const gchar* value)
{
	gchar* old_value;
#line 45 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_date (self);
#line 45 "../src/librygel-server/rygel-media-object.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3275 "rygel-media-object.c"
		gchar* _tmp0_;
#line 45 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = g_strdup (value);
#line 45 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_date);
#line 45 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_date = _tmp0_;
#line 45 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_DATE_PROPERTY]);
#line 3285 "rygel-media-object.c"
	}
}

const gchar*
rygel_media_object_get_creator (RygelMediaObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 46 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_creator;
#line 46 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 46 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3302 "rygel-media-object.c"
}

void
rygel_media_object_set_creator (RygelMediaObject* self,
                                const gchar* value)
{
	gchar* old_value;
#line 46 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_creator (self);
#line 46 "../src/librygel-server/rygel-media-object.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3316 "rygel-media-object.c"
		gchar* _tmp0_;
#line 46 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = g_strdup (value);
#line 46 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_creator);
#line 46 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_creator = _tmp0_;
#line 46 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_CREATOR_PROPERTY]);
#line 3326 "rygel-media-object.c"
	}
}

guint64
rygel_media_object_get_modified (RygelMediaObject* self)
{
	guint64 result;
#line 47 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 47 "../src/librygel-server/rygel-media-object.vala"
	result = self->priv->_modified;
#line 47 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3340 "rygel-media-object.c"
}

void
rygel_media_object_set_modified (RygelMediaObject* self,
                                 guint64 value)
{
	guint64 old_value;
#line 47 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_modified (self);
#line 47 "../src/librygel-server/rygel-media-object.vala"
	if (old_value != value) {
#line 47 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_modified = value;
#line 47 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_MODIFIED_PROPERTY]);
#line 3358 "rygel-media-object.c"
	}
}

guint
rygel_media_object_get_object_update_id (RygelMediaObject* self)
{
	guint result;
#line 48 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 48 "../src/librygel-server/rygel-media-object.vala"
	result = self->priv->_object_update_id;
#line 48 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3372 "rygel-media-object.c"
}

void
rygel_media_object_set_object_update_id (RygelMediaObject* self,
                                         guint value)
{
	guint old_value;
#line 48 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_object_update_id (self);
#line 48 "../src/librygel-server/rygel-media-object.vala"
	if (old_value != value) {
#line 48 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_object_update_id = value;
#line 48 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_OBJECT_UPDATE_ID_PROPERTY]);
#line 3390 "rygel-media-object.c"
	}
}

const gchar*
rygel_media_object_get_artist (RygelMediaObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_artist;
#line 50 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 50 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3407 "rygel-media-object.c"
}

void
rygel_media_object_set_artist (RygelMediaObject* self,
                               const gchar* value)
{
	gchar* old_value;
#line 50 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_artist (self);
#line 50 "../src/librygel-server/rygel-media-object.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3421 "rygel-media-object.c"
		gchar* _tmp0_;
#line 50 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_artist);
#line 50 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_artist = _tmp0_;
#line 50 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_ARTIST_PROPERTY]);
#line 3431 "rygel-media-object.c"
	}
}

const gchar*
rygel_media_object_get_genre (RygelMediaObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_genre;
#line 51 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 51 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3448 "rygel-media-object.c"
}

void
rygel_media_object_set_genre (RygelMediaObject* self,
                              const gchar* value)
{
	gchar* old_value;
#line 51 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/librygel-server/rygel-media-object.vala"
	old_value = rygel_media_object_get_genre (self);
#line 51 "../src/librygel-server/rygel-media-object.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3462 "rygel-media-object.c"
		gchar* _tmp0_;
#line 51 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = g_strdup (value);
#line 51 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_genre);
#line 51 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_genre = _tmp0_;
#line 51 "../src/librygel-server/rygel-media-object.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_GENRE_PROPERTY]);
#line 3472 "rygel-media-object.c"
	}
}

RygelMediaContainer*
rygel_media_object_get_parent (RygelMediaObject* self)
{
	RygelMediaContainer* result;
	RygelMediaContainer* _tmp0_;
#line 84 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->parent_ptr;
#line 85 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 85 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3489 "rygel-media-object.c"
}

void
rygel_media_object_set_parent (RygelMediaObject* self,
                               RygelMediaContainer* value)
{
#line 88 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/librygel-server/rygel-media-object.vala"
	self->parent_ptr = value;
#line 88 "../src/librygel-server/rygel-media-object.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_PARENT_PROPERTY]);
#line 3502 "rygel-media-object.c"
}

RygelMediaContainer*
rygel_media_object_get_parent_ref (RygelMediaObject* self)
{
	RygelMediaContainer* result;
	RygelMediaContainer* _tmp0_;
#line 97 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_parent_ref;
#line 98 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 98 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3518 "rygel-media-object.c"
}

void
rygel_media_object_set_parent_ref (RygelMediaObject* self,
                                   RygelMediaContainer* value)
{
	RygelMediaContainer* _tmp0_;
#line 101 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_set_parent (self, value);
#line 103 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 103 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (self->priv->_parent_ref);
#line 103 "../src/librygel-server/rygel-media-object.vala"
	self->priv->_parent_ref = _tmp0_;
#line 101 "../src/librygel-server/rygel-media-object.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_PARENT_REF_PROPERTY]);
#line 3538 "rygel-media-object.c"
}

const gchar*
rygel_media_object_get_title (RygelMediaObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 127 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = self->priv->_title;
#line 128 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp0_;
#line 128 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3554 "rygel-media-object.c"
}

void
rygel_media_object_set_title (RygelMediaObject* self,
                              const gchar* value)
{
	GError* _inner_error0_ = NULL;
#line 131 "../src/librygel-server/rygel-media-object.vala"
	g_return_if_fail (self != NULL);
#line 3564 "rygel-media-object.c"
	{
		gchar* _tmp0_ = NULL;
		GRegex* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_ = NULL;
		GRegex* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 133 "../src/librygel-server/rygel-media-object.vala"
		_tmp1_ = rygel_media_object_real_name_regex;
#line 133 "../src/librygel-server/rygel-media-object.vala"
		_tmp2_ = g_get_real_name ();
#line 133 "../src/librygel-server/rygel-media-object.vala"
		_tmp3_ = g_regex_replace_literal (_tmp1_, value, (gssize) -1, 0, _tmp2_, 0, &_inner_error0_);
#line 133 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = _tmp3_;
#line 133 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 133 "../src/librygel-server/rygel-media-object.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3603 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 133 "../src/librygel-server/rygel-media-object.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 133 "../src/librygel-server/rygel-media-object.vala"
			g_clear_error (&_inner_error0_);
#line 133 "../src/librygel-server/rygel-media-object.vala"
			return;
#line 3612 "rygel-media-object.c"
		}
#line 133 "../src/librygel-server/rygel-media-object.vala"
		_tmp4_ = _tmp0_;
#line 133 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = NULL;
#line 133 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_title);
#line 133 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_title = _tmp4_;
#line 138 "../src/librygel-server/rygel-media-object.vala"
		_tmp6_ = rygel_media_object_user_name_regex;
#line 138 "../src/librygel-server/rygel-media-object.vala"
		_tmp7_ = self->priv->_title;
#line 138 "../src/librygel-server/rygel-media-object.vala"
		_tmp8_ = g_get_user_name ();
#line 138 "../src/librygel-server/rygel-media-object.vala"
		_tmp9_ = g_regex_replace_literal (_tmp6_, _tmp7_, (gssize) -1, 0, _tmp8_, 0, &_inner_error0_);
#line 138 "../src/librygel-server/rygel-media-object.vala"
		_tmp5_ = _tmp9_;
#line 138 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_tmp0_);
#line 138 "../src/librygel-server/rygel-media-object.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3638 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 138 "../src/librygel-server/rygel-media-object.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 138 "../src/librygel-server/rygel-media-object.vala"
			g_clear_error (&_inner_error0_);
#line 138 "../src/librygel-server/rygel-media-object.vala"
			return;
#line 3647 "rygel-media-object.c"
		}
#line 138 "../src/librygel-server/rygel-media-object.vala"
		_tmp10_ = _tmp5_;
#line 138 "../src/librygel-server/rygel-media-object.vala"
		_tmp5_ = NULL;
#line 138 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_title);
#line 138 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_title = _tmp10_;
#line 143 "../src/librygel-server/rygel-media-object.vala"
		_tmp12_ = rygel_media_object_host_name_regex;
#line 143 "../src/librygel-server/rygel-media-object.vala"
		_tmp13_ = self->priv->_title;
#line 143 "../src/librygel-server/rygel-media-object.vala"
		_tmp14_ = g_get_host_name ();
#line 143 "../src/librygel-server/rygel-media-object.vala"
		_tmp15_ = g_regex_replace_literal (_tmp12_, _tmp13_, (gssize) -1, 0, _tmp14_, 0, &_inner_error0_);
#line 143 "../src/librygel-server/rygel-media-object.vala"
		_tmp11_ = _tmp15_;
#line 143 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_tmp5_);
#line 143 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_tmp0_);
#line 143 "../src/librygel-server/rygel-media-object.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3675 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 143 "../src/librygel-server/rygel-media-object.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../src/librygel-server/rygel-media-object.vala"
			g_clear_error (&_inner_error0_);
#line 143 "../src/librygel-server/rygel-media-object.vala"
			return;
#line 3684 "rygel-media-object.c"
		}
#line 143 "../src/librygel-server/rygel-media-object.vala"
		_tmp16_ = _tmp11_;
#line 143 "../src/librygel-server/rygel-media-object.vala"
		_tmp11_ = NULL;
#line 143 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_title);
#line 143 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_title = _tmp16_;
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp18_ = rygel_media_object_pretty_name_regex;
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp19_ = self->priv->_title;
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp20_ = rygel_get_pretty_host_name ();
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp21_ = _tmp20_;
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp22_ = g_regex_replace_literal (_tmp18_, _tmp19_, (gssize) -1, 0, _tmp21_, 0, &_inner_error0_);
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp23_ = _tmp22_;
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp21_);
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp17_ = _tmp23_;
#line 148 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_tmp11_);
#line 148 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_tmp5_);
#line 148 "../src/librygel-server/rygel-media-object.vala"
			_g_free0 (_tmp0_);
#line 148 "../src/librygel-server/rygel-media-object.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3720 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 148 "../src/librygel-server/rygel-media-object.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../src/librygel-server/rygel-media-object.vala"
			g_clear_error (&_inner_error0_);
#line 148 "../src/librygel-server/rygel-media-object.vala"
			return;
#line 3729 "rygel-media-object.c"
		}
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp24_ = _tmp17_;
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_tmp17_ = NULL;
#line 148 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (self->priv->_title);
#line 148 "../src/librygel-server/rygel-media-object.vala"
		self->priv->_title = _tmp24_;
#line 132 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp17_);
#line 132 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp11_);
#line 132 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp5_);
#line 132 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp0_);
#line 3747 "rygel-media-object.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 132 "../src/librygel-server/rygel-media-object.vala"
		g_clear_error (&_inner_error0_);
#line 154 "../src/librygel-server/rygel-media-object.vala"
		g_assert_not_reached ();
#line 3756 "rygel-media-object.c"
	}
	__finally0:
#line 132 "../src/librygel-server/rygel-media-object.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 132 "../src/librygel-server/rygel-media-object.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 132 "../src/librygel-server/rygel-media-object.vala"
		g_clear_error (&_inner_error0_);
#line 132 "../src/librygel-server/rygel-media-object.vala"
		return;
#line 3767 "rygel-media-object.c"
	}
#line 131 "../src/librygel-server/rygel-media-object.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_TITLE_PROPERTY]);
#line 3771 "rygel-media-object.c"
}

GUPnPOCMFlags
rygel_media_object_get_ocm_flags (RygelMediaObject* self)
{
	RygelMediaObjectClass* _klass_;
#line 159 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 159 "../src/librygel-server/rygel-media-object.vala"
	_klass_ = RYGEL_MEDIA_OBJECT_GET_CLASS (self);
#line 159 "../src/librygel-server/rygel-media-object.vala"
	if (_klass_->get_ocm_flags) {
#line 159 "../src/librygel-server/rygel-media-object.vala"
		return _klass_->get_ocm_flags (self);
#line 3786 "rygel-media-object.c"
	}
#line 159 "../src/librygel-server/rygel-media-object.vala"
	return 0U;
#line 3790 "rygel-media-object.c"
}

static GUPnPOCMFlags
rygel_media_object_real_get_ocm_flags (RygelMediaObject* base)
{
	GUPnPOCMFlags result;
	RygelMediaObject* self;
#line 159 "../src/librygel-server/rygel-media-object.vala"
	self = base;
#line 159 "../src/librygel-server/rygel-media-object.vala"
	result = GUPNP_OCM_FLAGS_NONE;
#line 159 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3804 "rygel-media-object.c"
}

gboolean
rygel_media_object_get_restricted (RygelMediaObject* self)
{
	gboolean result;
	GUPnPOCMFlags _tmp0_;
	GUPnPOCMFlags _tmp1_;
#line 162 "../src/librygel-server/rygel-media-object.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = rygel_media_object_get_ocm_flags (self);
#line 163 "../src/librygel-server/rygel-media-object.vala"
	_tmp1_ = _tmp0_;
#line 163 "../src/librygel-server/rygel-media-object.vala"
	result = _tmp1_ == GUPNP_OCM_FLAGS_NONE;
#line 163 "../src/librygel-server/rygel-media-object.vala"
	return result;
#line 3823 "rygel-media-object.c"
}

static void
rygel_media_object_class_init (RygelMediaObjectClass * klass,
                               gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	rygel_media_object_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_type_class_adjust_private_offset (klass, &RygelMediaObject_private_offset);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	((RygelMediaObjectClass *) klass)->add_uri = (void (*) (RygelMediaObject*, const gchar*)) rygel_media_object_real_add_uri;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_media_object_real_constructed;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	((RygelMediaObjectClass *) klass)->serialize = (GUPnPDIDLLiteObject* (*) (RygelMediaObject*, RygelSerializer*, RygelHTTPServer*, GError**)) rygel_media_object_real_serialize;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	((RygelMediaObjectClass *) klass)->create_stream_source_for_resource = (RygelDataSource* (*) (RygelMediaObject*, RygelHTTPRequest*, RygelMediaResource*, GError**)) rygel_media_object_real_create_stream_source_for_resource;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	((RygelMediaObjectClass *) klass)->apply_didl_lite = (void (*) (RygelMediaObject*, GUPnPDIDLLiteObject*)) rygel_media_object_real_apply_didl_lite;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	((RygelMediaObjectClass *) klass)->compare_by_property = (gint (*) (RygelMediaObject*, RygelMediaObject*, const gchar*)) rygel_media_object_real_compare_by_property;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	RYGEL_MEDIA_OBJECT_CLASS (klass)->get_ocm_flags = (GUPnPOCMFlags (*) (RygelMediaObject*)) rygel_media_object_real_get_ocm_flags;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_media_object_get_property;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_media_object_set_property;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_media_object_finalize;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_ID_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_REF_ID_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_REF_ID_PROPERTY] = g_param_spec_string ("ref-id", "ref-id", "ref-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_UPNP_CLASS_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_UPNP_CLASS_PROPERTY] = g_param_spec_string ("upnp-class", "upnp-class", "upnp-class", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_DATE_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_DATE_PROPERTY] = g_param_spec_string ("date", "date", "date", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_CREATOR_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_CREATOR_PROPERTY] = g_param_spec_string ("creator", "creator", "creator", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_MODIFIED_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_MODIFIED_PROPERTY] = g_param_spec_uint64 ("modified", "modified", "modified", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_OBJECT_UPDATE_ID_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_OBJECT_UPDATE_ID_PROPERTY] = g_param_spec_uint ("object-update-id", "object-update-id", "object-update-id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_ARTIST_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_GENRE_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_PARENT_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", RYGEL_TYPE_MEDIA_CONTAINER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_PARENT_REF_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_PARENT_REF_PROPERTY] = g_param_spec_object ("parent-ref", "parent-ref", "parent-ref", RYGEL_TYPE_MEDIA_CONTAINER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3877 "rygel-media-object.c"
	/**
	     * The human-readable title of this container or item.
	     * These variables will be substituted:
	     *
	     *  - @@REALNAME@ will be substituted by the user's real name.
	     *  - @@USERNAME@ will be substituted by the users's login ID.
	     *  - @@HOSTNAME@ will be substituted by the name of the machine.
	     *  - @@ADDRESS@ will be substituted by the IP address of network interface
	     *    used for the UPnP communication.
	     *  - @@PRETTY_HOSTNAME@ will be substituted by the human readable name of the machine
	     *    (PRETTY_HOSTNAME field of /etc/machine-info)
	     */
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_TITLE_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_OCM_FLAGS_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_OCM_FLAGS_PROPERTY] = g_param_spec_flags ("ocm-flags", "ocm-flags", "ocm-flags", gupnp_ocm_flags_get_type (), 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../src/librygel-server/rygel-media-object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MEDIA_OBJECT_RESTRICTED_PROPERTY, rygel_media_object_properties[RYGEL_MEDIA_OBJECT_RESTRICTED_PROPERTY] = g_param_spec_boolean ("restricted", "restricted", "restricted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3896 "rygel-media-object.c"
	{
		GRegex* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_ = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		GRegex* _tmp11_;
		GRegex* _tmp12_ = NULL;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GRegex* _tmp15_;
		GRegex* _tmp16_;
		GRegex* _tmp17_;
		GRegex* _tmp18_ = NULL;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GRegex* _tmp21_;
		GRegex* _tmp22_;
		GRegex* _tmp23_;
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_tmp1_ = g_regex_escape_string ("@REALNAME@", -1);
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_tmp2_ = _tmp1_;
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error0_);
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_tmp4_ = _tmp3_;
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp2_);
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = _tmp4_;
#line 169 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../src/librygel-server/rygel-media-object.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3938 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 169 "../src/librygel-server/rygel-media-object.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 169 "../src/librygel-server/rygel-media-object.vala"
			g_clear_error (&_inner_error0_);
#line 3945 "rygel-media-object.c"
		}
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_tmp5_ = _tmp0_;
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_tmp0_ = NULL;
#line 169 "../src/librygel-server/rygel-media-object.vala"
		_g_regex_unref0 (rygel_media_object_real_name_regex);
#line 169 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_real_name_regex = _tmp5_;
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_tmp7_ = g_regex_escape_string ("@USERNAME@", -1);
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_tmp8_ = _tmp7_;
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error0_);
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_tmp10_ = _tmp9_;
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp8_);
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_tmp6_ = _tmp10_;
#line 170 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/librygel-server/rygel-media-object.vala"
			_g_regex_unref0 (_tmp0_);
#line 170 "../src/librygel-server/rygel-media-object.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3973 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 170 "../src/librygel-server/rygel-media-object.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/librygel-server/rygel-media-object.vala"
			g_clear_error (&_inner_error0_);
#line 3980 "rygel-media-object.c"
		}
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_tmp11_ = _tmp6_;
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_tmp6_ = NULL;
#line 170 "../src/librygel-server/rygel-media-object.vala"
		_g_regex_unref0 (rygel_media_object_user_name_regex);
#line 170 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_user_name_regex = _tmp11_;
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_tmp13_ = g_regex_escape_string ("@HOSTNAME@", -1);
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_tmp14_ = _tmp13_;
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_tmp15_ = g_regex_new (_tmp14_, 0, 0, &_inner_error0_);
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_tmp16_ = _tmp15_;
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp14_);
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_tmp12_ = _tmp16_;
#line 171 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/librygel-server/rygel-media-object.vala"
			_g_regex_unref0 (_tmp6_);
#line 171 "../src/librygel-server/rygel-media-object.vala"
			_g_regex_unref0 (_tmp0_);
#line 171 "../src/librygel-server/rygel-media-object.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4010 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 171 "../src/librygel-server/rygel-media-object.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/librygel-server/rygel-media-object.vala"
			g_clear_error (&_inner_error0_);
#line 4017 "rygel-media-object.c"
		}
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_tmp17_ = _tmp12_;
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_tmp12_ = NULL;
#line 171 "../src/librygel-server/rygel-media-object.vala"
		_g_regex_unref0 (rygel_media_object_host_name_regex);
#line 171 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_host_name_regex = _tmp17_;
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_tmp19_ = g_regex_escape_string ("@PRETTY_HOSTNAME@", -1);
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_tmp20_ = _tmp19_;
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_tmp21_ = g_regex_new (_tmp20_, 0, 0, &_inner_error0_);
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_tmp22_ = _tmp21_;
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_g_free0 (_tmp20_);
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_tmp18_ = _tmp22_;
#line 172 "../src/librygel-server/rygel-media-object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/librygel-server/rygel-media-object.vala"
			_g_regex_unref0 (_tmp12_);
#line 172 "../src/librygel-server/rygel-media-object.vala"
			_g_regex_unref0 (_tmp6_);
#line 172 "../src/librygel-server/rygel-media-object.vala"
			_g_regex_unref0 (_tmp0_);
#line 172 "../src/librygel-server/rygel-media-object.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4049 "rygel-media-object.c"
				goto __catch0_g_regex_error;
			}
#line 172 "../src/librygel-server/rygel-media-object.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/librygel-server/rygel-media-object.vala"
			g_clear_error (&_inner_error0_);
#line 4056 "rygel-media-object.c"
		}
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_tmp23_ = _tmp18_;
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_tmp18_ = NULL;
#line 172 "../src/librygel-server/rygel-media-object.vala"
		_g_regex_unref0 (rygel_media_object_pretty_name_regex);
#line 172 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_pretty_name_regex = _tmp23_;
#line 168 "../src/librygel-server/rygel-media-object.vala"
		_g_regex_unref0 (_tmp18_);
#line 168 "../src/librygel-server/rygel-media-object.vala"
		_g_regex_unref0 (_tmp12_);
#line 168 "../src/librygel-server/rygel-media-object.vala"
		_g_regex_unref0 (_tmp6_);
#line 168 "../src/librygel-server/rygel-media-object.vala"
		_g_regex_unref0 (_tmp0_);
#line 4074 "rygel-media-object.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 168 "../src/librygel-server/rygel-media-object.vala"
		g_clear_error (&_inner_error0_);
#line 174 "../src/librygel-server/rygel-media-object.vala"
		g_assert_not_reached ();
#line 4083 "rygel-media-object.c"
	}
	__finally0:
#line 168 "../src/librygel-server/rygel-media-object.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 168 "../src/librygel-server/rygel-media-object.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "../src/librygel-server/rygel-media-object.vala"
		g_clear_error (&_inner_error0_);
#line 4092 "rygel-media-object.c"
	}
}

static void
rygel_media_object_instance_init (RygelMediaObject * self,
                                  gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	self->priv = rygel_media_object_get_instance_private (self);
#line 72 "../src/librygel-server/rygel-media-object.vala"
	_tmp0_ = gee_linked_list_new (RYGEL_TYPE_MEDIA_RESOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 72 "../src/librygel-server/rygel-media-object.vala"
	self->priv->media_resources = (GeeList*) _tmp0_;
#line 4107 "rygel-media-object.c"
}

static void
rygel_media_object_finalize (GObject * obj)
{
	RygelMediaObject * self;
#line 36 "../src/librygel-server/rygel-media-object.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_MEDIA_OBJECT, RygelMediaObject);
#line 42 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (self->priv->_id);
#line 43 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (self->priv->_ref_id);
#line 44 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (self->priv->_upnp_class);
#line 45 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (self->priv->_date);
#line 46 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (self->priv->_creator);
#line 50 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (self->priv->_artist);
#line 51 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (self->priv->_genre);
#line 56 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (self->priv->uris);
#line 72 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (self->priv->media_resources);
#line 95 "../src/librygel-server/rygel-media-object.vala"
	_g_object_unref0 (self->priv->_parent_ref);
#line 107 "../src/librygel-server/rygel-media-object.vala"
	_g_free0 (self->priv->_title);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	G_OBJECT_CLASS (rygel_media_object_parent_class)->finalize (obj);
#line 4140 "rygel-media-object.c"
}

/**
 * Represents a media object (container or item).
 *
 * The derived RygelMediaContainer class represents a container
 * and the derived MediaItem classes represent media items.
 */
 G_GNUC_NO_INLINE static GType
rygel_media_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelMediaObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaObject), 0, (GInstanceInitFunc) rygel_media_object_instance_init, NULL };
	GType rygel_media_object_type_id;
	rygel_media_object_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelMediaObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	RygelMediaObject_private_offset = g_type_add_instance_private (rygel_media_object_type_id, sizeof (RygelMediaObjectPrivate));
	return rygel_media_object_type_id;
}

GType
rygel_media_object_get_type (void)
{
	static volatile gsize rygel_media_object_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_object_type_id__once)) {
		GType rygel_media_object_type_id;
		rygel_media_object_type_id = rygel_media_object_get_type_once ();
		g_once_init_leave (&rygel_media_object_type_id__once, rygel_media_object_type_id);
	}
	return rygel_media_object_type_id__once;
}

static void
_vala_rygel_media_object_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	RygelMediaObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MEDIA_OBJECT, RygelMediaObject);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	switch (property_id) {
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_ID_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_string (value, rygel_media_object_get_id (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_REF_ID_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_string (value, rygel_media_object_get_ref_id (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_UPNP_CLASS_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_string (value, rygel_media_object_get_upnp_class (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_DATE_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_string (value, rygel_media_object_get_date (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_CREATOR_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_string (value, rygel_media_object_get_creator (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_MODIFIED_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_uint64 (value, rygel_media_object_get_modified (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_OBJECT_UPDATE_ID_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_uint (value, rygel_media_object_get_object_update_id (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_ARTIST_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_string (value, rygel_media_object_get_artist (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_GENRE_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_string (value, rygel_media_object_get_genre (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_PARENT_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_object (value, rygel_media_object_get_parent (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_PARENT_REF_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_object (value, rygel_media_object_get_parent_ref (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_TITLE_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_string (value, rygel_media_object_get_title (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_OCM_FLAGS_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_flags (value, rygel_media_object_get_ocm_flags (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_RESTRICTED_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		g_value_set_boolean (value, rygel_media_object_get_restricted (self));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 4265 "rygel-media-object.c"
		default:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 4271 "rygel-media-object.c"
	}
}

static void
_vala_rygel_media_object_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	RygelMediaObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MEDIA_OBJECT, RygelMediaObject);
#line 36 "../src/librygel-server/rygel-media-object.vala"
	switch (property_id) {
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_ID_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_id (self, g_value_get_string (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_REF_ID_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_ref_id (self, g_value_get_string (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_UPNP_CLASS_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_upnp_class (self, g_value_get_string (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_DATE_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_date (self, g_value_get_string (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_CREATOR_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_creator (self, g_value_get_string (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_MODIFIED_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_modified (self, g_value_get_uint64 (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_OBJECT_UPDATE_ID_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_object_update_id (self, g_value_get_uint (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_ARTIST_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_artist (self, g_value_get_string (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_GENRE_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_genre (self, g_value_get_string (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_PARENT_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_parent (self, g_value_get_object (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_PARENT_REF_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_parent_ref (self, g_value_get_object (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 36 "../src/librygel-server/rygel-media-object.vala"
		case RYGEL_MEDIA_OBJECT_TITLE_PROPERTY:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		rygel_media_object_set_title (self, g_value_get_string (value));
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 4357 "rygel-media-object.c"
		default:
#line 36 "../src/librygel-server/rygel-media-object.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../src/librygel-server/rygel-media-object.vala"
		break;
#line 4363 "rygel-media-object.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

