/* rygel-media-export-media-cache.c generated by valac 0.56.18, the Vala compiler
 * generated from rygel-media-export-media-cache.vala, do not modify */

/*
 * Copyright (C) 2009,2010 Jens Georg <mail@jensge.org>.
 * Copyright (C) 2013 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Jens Georg <mail@jensge.org>
 *         Doug Galligan <doug@sentosatech.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-media-export.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "rygel-db.h"
#include <gee.h>
#include "rygel-core.h"
#include <gio/gio.h>
#include "rygel-server.h"
#include <glib/gi18n-lib.h>
#include <sqlite3.h>
#include <libgupnp-av/gupnp-av.h>

#define RYGEL_MEDIA_EXPORT_SQL_FACTORY_SCHEMA_VERSION "18"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	RYGEL_MEDIA_EXPORT_OBJECT_TYPE_CONTAINER,
	RYGEL_MEDIA_EXPORT_OBJECT_TYPE_ITEM
} RygelMediaExportObjectType;

#define RYGEL_MEDIA_EXPORT_TYPE_OBJECT_TYPE (rygel_media_export_object_type_get_type ())

#define RYGEL_MEDIA_EXPORT_TYPE_EXISTS_CACHE_ENTRY (rygel_media_export_exists_cache_entry_get_type ())
typedef struct _RygelMediaExportExistsCacheEntry RygelMediaExportExistsCacheEntry;
#define _g_free0(var) (var = (g_free (var), NULL))

#define RYGEL_MEDIA_EXPORT_TYPE_OBJECT_FACTORY (rygel_media_export_object_factory_get_type ())
#define RYGEL_MEDIA_EXPORT_OBJECT_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_OBJECT_FACTORY, RygelMediaExportObjectFactory))
#define RYGEL_MEDIA_EXPORT_OBJECT_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_OBJECT_FACTORY, RygelMediaExportObjectFactoryClass))
#define RYGEL_MEDIA_EXPORT_IS_OBJECT_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_OBJECT_FACTORY))
#define RYGEL_MEDIA_EXPORT_IS_OBJECT_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_OBJECT_FACTORY))
#define RYGEL_MEDIA_EXPORT_OBJECT_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_OBJECT_FACTORY, RygelMediaExportObjectFactoryClass))

typedef struct _RygelMediaExportObjectFactory RygelMediaExportObjectFactory;
typedef struct _RygelMediaExportObjectFactoryClass RygelMediaExportObjectFactoryClass;

#define RYGEL_MEDIA_EXPORT_TYPE_SQL_FACTORY (rygel_media_export_sql_factory_get_type ())
#define RYGEL_MEDIA_EXPORT_SQL_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_SQL_FACTORY, RygelMediaExportSQLFactory))
#define RYGEL_MEDIA_EXPORT_SQL_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_SQL_FACTORY, RygelMediaExportSQLFactoryClass))
#define RYGEL_MEDIA_EXPORT_IS_SQL_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_SQL_FACTORY))
#define RYGEL_MEDIA_EXPORT_IS_SQL_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_SQL_FACTORY))
#define RYGEL_MEDIA_EXPORT_SQL_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_SQL_FACTORY, RygelMediaExportSQLFactoryClass))

typedef struct _RygelMediaExportSQLFactory RygelMediaExportSQLFactory;
typedef struct _RygelMediaExportSQLFactoryClass RygelMediaExportSQLFactoryClass;
enum  {
	RYGEL_MEDIA_EXPORT_MEDIA_CACHE_0_PROPERTY,
	RYGEL_MEDIA_EXPORT_MEDIA_CACHE_NUM_PROPERTIES
};
static GParamSpec* rygel_media_export_media_cache_properties[RYGEL_MEDIA_EXPORT_MEDIA_CACHE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	RYGEL_MEDIA_EXPORT_SQL_STRING_SAVE_METADATA,
	RYGEL_MEDIA_EXPORT_SQL_STRING_INSERT,
	RYGEL_MEDIA_EXPORT_SQL_STRING_DELETE,
	RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECT,
	RYGEL_MEDIA_EXPORT_SQL_STRING_GET_CHILDREN,
	RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECTS_BY_FILTER,
	RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECTS_BY_FILTER_WITH_ANCESTOR,
	RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECT_COUNT_BY_FILTER,
	RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECT_COUNT_BY_FILTER_WITH_ANCESTOR,
	RYGEL_MEDIA_EXPORT_SQL_STRING_GET_META_DATA_COLUMN,
	RYGEL_MEDIA_EXPORT_SQL_STRING_CHILD_COUNT,
	RYGEL_MEDIA_EXPORT_SQL_STRING_EXISTS,
	RYGEL_MEDIA_EXPORT_SQL_STRING_CHILD_IDS,
	RYGEL_MEDIA_EXPORT_SQL_STRING_TABLE_METADATA,
	RYGEL_MEDIA_EXPORT_SQL_STRING_TABLE_CLOSURE,
	RYGEL_MEDIA_EXPORT_SQL_STRING_TRIGGER_CLOSURE,
	RYGEL_MEDIA_EXPORT_SQL_STRING_TRIGGER_COMMON,
	RYGEL_MEDIA_EXPORT_SQL_STRING_INDEX_COMMON,
	RYGEL_MEDIA_EXPORT_SQL_STRING_SCHEMA,
	RYGEL_MEDIA_EXPORT_SQL_STRING_EXISTS_CACHE,
	RYGEL_MEDIA_EXPORT_SQL_STRING_STATISTICS,
	RYGEL_MEDIA_EXPORT_SQL_STRING_RESET_TOKEN,
	RYGEL_MEDIA_EXPORT_SQL_STRING_MAX_UPDATE_ID,
	RYGEL_MEDIA_EXPORT_SQL_STRING_MAKE_GUARDED,
	RYGEL_MEDIA_EXPORT_SQL_STRING_IS_GUARDED,
	RYGEL_MEDIA_EXPORT_SQL_STRING_UPDATE_GUARDED_OBJECT,
	RYGEL_MEDIA_EXPORT_SQL_STRING_TRIGGER_REFERENCE,
	RYGEL_MEDIA_EXPORT_SQL_STRING_CREATE_IGNORELIST_TABLE,
	RYGEL_MEDIA_EXPORT_SQL_STRING_CREATE_IGNORELIST_INDEX,
	RYGEL_MEDIA_EXPORT_SQL_STRING_ADD_TO_IGNORELIST,
	RYGEL_MEDIA_EXPORT_SQL_STRING_CHECK_IGNORELIST
} RygelMediaExportSQLString;

#define RYGEL_MEDIA_EXPORT_TYPE_SQL_STRING (rygel_media_export_sql_string_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _rygel_database_cursor_iterator_unref0(var) ((var == NULL) ? NULL : (var = (rygel_database_cursor_iterator_unref (var), NULL)))
#define _rygel_media_export_exists_cache_entry_free0(var) ((var == NULL) ? NULL : (var = (rygel_media_export_exists_cache_entry_free (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef enum  {
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_TYPE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_TITLE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_SIZE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_MIME_TYPE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_WIDTH,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_HEIGHT,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_CLASS,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_CREATOR,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_AUTHOR,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_ALBUM,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DATE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_BITRATE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_SAMPLE_FREQ,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_BITS_PER_SAMPLE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_CHANNELS,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_TRACK,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_COLOR_DEPTH,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DURATION,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_ID,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_PARENT,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_TIMESTAMP,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_URI,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DLNA_PROFILE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_GENRE,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DISC,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_OBJECT_UPDATE_ID,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DELETED_CHILD_COUNT,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_CONTAINER_UPDATE_ID,
	RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_REFERENCE_ID
} RygelMediaExportDetailColumn;

#define RYGEL_MEDIA_EXPORT_TYPE_DETAIL_COLUMN (rygel_media_export_detail_column_get_type ())

#define RYGEL_TYPE_NULL_CONTAINER (rygel_null_container_get_type ())
#define RYGEL_NULL_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_NULL_CONTAINER, RygelNullContainer))
#define RYGEL_NULL_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_NULL_CONTAINER, RygelNullContainerClass))
#define RYGEL_IS_NULL_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_NULL_CONTAINER))
#define RYGEL_IS_NULL_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_NULL_CONTAINER))
#define RYGEL_NULL_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_NULL_CONTAINER, RygelNullContainerClass))

typedef struct _RygelNullContainer RygelNullContainer;
typedef struct _RygelNullContainerClass RygelNullContainerClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define RYGEL_MEDIA_EXPORT_TYPE_MEDIA_CACHE_UPGRADER (rygel_media_export_media_cache_upgrader_get_type ())
#define RYGEL_MEDIA_EXPORT_MEDIA_CACHE_UPGRADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_MEDIA_CACHE_UPGRADER, RygelMediaExportMediaCacheUpgrader))
#define RYGEL_MEDIA_EXPORT_MEDIA_CACHE_UPGRADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_MEDIA_CACHE_UPGRADER, RygelMediaExportMediaCacheUpgraderClass))
#define RYGEL_MEDIA_EXPORT_IS_MEDIA_CACHE_UPGRADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_MEDIA_CACHE_UPGRADER))
#define RYGEL_MEDIA_EXPORT_IS_MEDIA_CACHE_UPGRADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_MEDIA_CACHE_UPGRADER))
#define RYGEL_MEDIA_EXPORT_MEDIA_CACHE_UPGRADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_MEDIA_CACHE_UPGRADER, RygelMediaExportMediaCacheUpgraderClass))

typedef struct _RygelMediaExportMediaCacheUpgrader RygelMediaExportMediaCacheUpgrader;
typedef struct _RygelMediaExportMediaCacheUpgraderClass RygelMediaExportMediaCacheUpgraderClass;
#define _rygel_media_export_media_cache_upgrader_unref0(var) ((var == NULL) ? NULL : (var = (rygel_media_export_media_cache_upgrader_unref (var), NULL)))

#define RYGEL_MEDIA_EXPORT_TYPE_MUSIC_ITEM (rygel_media_export_music_item_get_type ())
#define RYGEL_MEDIA_EXPORT_MUSIC_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_MUSIC_ITEM, RygelMediaExportMusicItem))
#define RYGEL_MEDIA_EXPORT_MUSIC_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_MUSIC_ITEM, RygelMediaExportMusicItemClass))
#define RYGEL_MEDIA_EXPORT_IS_MUSIC_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_MUSIC_ITEM))
#define RYGEL_MEDIA_EXPORT_IS_MUSIC_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_MUSIC_ITEM))
#define RYGEL_MEDIA_EXPORT_MUSIC_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_MUSIC_ITEM, RygelMediaExportMusicItemClass))

typedef struct _RygelMediaExportMusicItem RygelMediaExportMusicItem;
typedef struct _RygelMediaExportMusicItemClass RygelMediaExportMusicItemClass;
typedef struct _RygelMediaExportMusicItemPrivate RygelMediaExportMusicItemPrivate;

#define RYGEL_MEDIA_EXPORT_TYPE_VIDEO_ITEM (rygel_media_export_video_item_get_type ())
#define RYGEL_MEDIA_EXPORT_VIDEO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_VIDEO_ITEM, RygelMediaExportVideoItem))
#define RYGEL_MEDIA_EXPORT_VIDEO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_VIDEO_ITEM, RygelMediaExportVideoItemClass))
#define RYGEL_MEDIA_EXPORT_IS_VIDEO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_VIDEO_ITEM))
#define RYGEL_MEDIA_EXPORT_IS_VIDEO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_VIDEO_ITEM))
#define RYGEL_MEDIA_EXPORT_VIDEO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_VIDEO_ITEM, RygelMediaExportVideoItemClass))

typedef struct _RygelMediaExportVideoItem RygelMediaExportVideoItem;
typedef struct _RygelMediaExportVideoItemClass RygelMediaExportVideoItemClass;

#define RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_ITEM (rygel_media_export_playlist_item_get_type ())
#define RYGEL_MEDIA_EXPORT_PLAYLIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_ITEM, RygelMediaExportPlaylistItem))
#define RYGEL_MEDIA_EXPORT_PLAYLIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_ITEM, RygelMediaExportPlaylistItemClass))
#define RYGEL_MEDIA_EXPORT_IS_PLAYLIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_ITEM))
#define RYGEL_MEDIA_EXPORT_IS_PLAYLIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_ITEM))
#define RYGEL_MEDIA_EXPORT_PLAYLIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLAYLIST_ITEM, RygelMediaExportPlaylistItemClass))

typedef struct _RygelMediaExportPlaylistItem RygelMediaExportPlaylistItem;
typedef struct _RygelMediaExportPlaylistItemClass RygelMediaExportPlaylistItemClass;
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

struct _RygelMediaExportExistsCacheEntry {
	gint64 mtime;
	gint64 size;
	gchar* content_type;
};

struct _RygelMediaExportMediaCachePrivate {
	RygelDatabaseDatabase* db;
	RygelMediaExportObjectFactory* factory;
	RygelMediaExportSQLFactory* sql;
	GeeHashMap* exists_cache;
};

struct _RygelMediaExportMusicItem {
	RygelMusicItem parent_instance;
	RygelMediaExportMusicItemPrivate * priv;
	gint disc;
};

struct _RygelMediaExportMusicItemClass {
	RygelMusicItemClass parent_class;
};

static gint RygelMediaExportMediaCache_private_offset;
static gpointer rygel_media_export_media_cache_parent_class = NULL;
static RygelMediaExportMediaCache* rygel_media_export_media_cache_instance;
static RygelMediaExportMediaCache* rygel_media_export_media_cache_instance = NULL;

VALA_EXTERN GType rygel_media_export_object_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_media_export_exists_cache_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelMediaExportExistsCacheEntry* rygel_media_export_exists_cache_entry_dup (const RygelMediaExportExistsCacheEntry* self);
VALA_EXTERN void rygel_media_export_exists_cache_entry_free (RygelMediaExportExistsCacheEntry* self);
VALA_EXTERN void rygel_media_export_exists_cache_entry_copy (const RygelMediaExportExistsCacheEntry* self,
                                                 RygelMediaExportExistsCacheEntry* dest);
VALA_EXTERN void rygel_media_export_exists_cache_entry_destroy (RygelMediaExportExistsCacheEntry* self);
VALA_EXTERN GType rygel_media_export_object_factory_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_media_export_sql_factory_get_type (void) G_GNUC_CONST ;
static RygelMediaExportMediaCache* rygel_media_export_media_cache_new (GError** error);
static RygelMediaExportMediaCache* rygel_media_export_media_cache_construct (GType object_type,
                                                                      GError** error);
VALA_EXTERN RygelMediaExportSQLFactory* rygel_media_export_sql_factory_new (void);
VALA_EXTERN RygelMediaExportSQLFactory* rygel_media_export_sql_factory_construct (GType object_type);
static void rygel_media_export_media_cache_open_db (RygelMediaExportMediaCache* self,
                                             const gchar* name,
                                             GError** error);
VALA_EXTERN RygelMediaExportObjectFactory* rygel_media_export_object_factory_new (void);
VALA_EXTERN RygelMediaExportObjectFactory* rygel_media_export_object_factory_construct (GType object_type);
VALA_EXTERN GType rygel_media_export_sql_string_get_type (void) G_GNUC_CONST ;
VALA_EXTERN const gchar* rygel_media_export_sql_factory_make (RygelMediaExportSQLFactory* self,
                                                  RygelMediaExportSQLString query);
static void _vala_GValue_array_free (GValue * array,
                              gssize array_length);
static void rygel_media_export_media_cache_save_container_metadata (RygelMediaExportMediaCache* self,
                                                             RygelMediaContainer* container,
                                                             GError** error);
static void rygel_media_export_media_cache_create_object (RygelMediaExportMediaCache* self,
                                                   RygelMediaObject* object,
                                                   gboolean override_guarded,
                                                   GError** error);
static void rygel_media_export_media_cache_save_item_metadata (RygelMediaExportMediaCache* self,
                                                        RygelMediaFileItem* item,
                                                        GError** error);
static RygelDatabaseCursor* rygel_media_export_media_cache_exec_cursor (RygelMediaExportMediaCache* self,
                                                                 RygelMediaExportSQLString id,
                                                                 GValue* values,
                                                                 gint values_length1,
                                                                 GError** error);
static RygelMediaObject* rygel_media_export_media_cache_get_object_from_statement (RygelMediaExportMediaCache* self,
                                                                            RygelMediaContainer* parent,
                                                                            sqlite3_stmt* statement);
static gint rygel_media_export_media_cache_query_value (RygelMediaExportMediaCache* self,
                                                 RygelMediaExportSQLString id,
                                                 GValue* values,
                                                 gint values_length1,
                                                 GError** error);
static gchar* rygel_media_export_media_cache_translate_sort_criteria (const gchar* sort_criteria,
                                                               gchar** extra_columns,
                                                               gint* column_count);
static gchar* rygel_media_export_media_cache_translate_search_expression (RygelSearchExpression* expression,
                                                                   GArray* args,
                                                                   const gchar* prefix,
                                                                   GError** error);
static guint rygel_media_export_media_cache_modify_limit (RygelMediaExportMediaCache* self,
                                                   guint max_count);
VALA_EXTERN GType rygel_media_export_detail_column_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelNullContainer* rygel_null_container_new_root (void);
VALA_EXTERN RygelNullContainer* rygel_null_container_construct_root (GType object_type);
VALA_EXTERN GType rygel_null_container_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelNullContainer* rygel_null_container_new (const gchar* id,
                                              RygelMediaContainer* parent,
                                              const gchar* title);
VALA_EXTERN RygelNullContainer* rygel_null_container_construct (GType object_type,
                                                    const gchar* id,
                                                    RygelMediaContainer* parent,
                                                    const gchar* title);
static gchar* rygel_media_export_media_cache_map_operand_to_column (const gchar* operand,
                                                             gchar** collate,
                                                             gboolean for_sort,
                                                             GError** error);
static gboolean rygel_media_export_media_cache_is_object_guarded (RygelMediaExportMediaCache* self,
                                                           const gchar* id);
VALA_EXTERN gpointer rygel_media_export_media_cache_upgrader_ref (gpointer instance);
VALA_EXTERN void rygel_media_export_media_cache_upgrader_unref (gpointer instance);
VALA_EXTERN GParamSpec* rygel_media_export_param_spec_media_cache_upgrader (const gchar* name,
                                                                const gchar* nick,
                                                                const gchar* blurb,
                                                                GType object_type,
                                                                GParamFlags flags);
VALA_EXTERN void rygel_media_export_value_set_media_cache_upgrader (GValue* value,
                                                        gpointer v_object);
VALA_EXTERN void rygel_media_export_value_take_media_cache_upgrader (GValue* value,
                                                         gpointer v_object);
VALA_EXTERN gpointer rygel_media_export_value_get_media_cache_upgrader (const GValue* value);
VALA_EXTERN GType rygel_media_export_media_cache_upgrader_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RygelMediaExportMediaCacheUpgrader* rygel_media_export_media_cache_upgrader_new (RygelDatabaseDatabase* database,
                                                                                 RygelMediaExportSQLFactory* sql);
VALA_EXTERN RygelMediaExportMediaCacheUpgrader* rygel_media_export_media_cache_upgrader_construct (GType object_type,
                                                                                       RygelDatabaseDatabase* database,
                                                                                       RygelMediaExportSQLFactory* sql);
VALA_EXTERN gboolean rygel_media_export_media_cache_upgrader_needs_upgrade (RygelMediaExportMediaCacheUpgrader* self,
                                                                gint* current_version,
                                                                GError** error);
VALA_EXTERN void rygel_media_export_media_cache_upgrader_upgrade (RygelMediaExportMediaCacheUpgrader* self,
                                                      gint old_version,
                                                      GError** error);
VALA_EXTERN void rygel_media_export_media_cache_upgrader_fix_schema (RygelMediaExportMediaCacheUpgrader* self,
                                                         GError** error);
VALA_EXTERN void rygel_media_export_media_cache_upgrader_ensure_indices (RygelMediaExportMediaCacheUpgrader* self);
static gboolean rygel_media_export_media_cache_create_schema (RygelMediaExportMediaCache* self);
VALA_EXTERN GType rygel_media_export_music_item_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_media_export_video_item_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rygel_media_export_playlist_item_get_type (void) G_GNUC_CONST ;
static void rygel_media_export_media_cache_update_guarded_object (RygelMediaExportMediaCache* self,
                                                           RygelMediaObject* object,
                                                           GError** error);
static void rygel_media_export_media_cache_create_normal_object (RygelMediaExportMediaCache* self,
                                                          RygelMediaObject* object,
                                                          gboolean is_guarded,
                                                          GError** error);
VALA_EXTERN RygelMediaContainer* rygel_media_export_object_factory_get_container (RygelMediaExportObjectFactory* self,
                                                                      const gchar* id,
                                                                      const gchar* title,
                                                                      guint child_count,
                                                                      const gchar* uri);
VALA_EXTERN RygelMediaFileItem* rygel_media_export_object_factory_get_item (RygelMediaExportObjectFactory* self,
                                                                RygelMediaContainer* parent,
                                                                const gchar* id,
                                                                const gchar* title,
                                                                const gchar* upnp_class);
static void rygel_media_export_media_cache_fill_item (RygelMediaExportMediaCache* self,
                                               sqlite3_stmt* statement,
                                               RygelMediaFileItem* item);
static gchar* rygel_media_export_media_cache_search_expression_to_sql (RygelSearchExpression* expression,
                                                                GArray* args,
                                                                GError** error);
static gchar* rygel_media_export_media_cache_logical_expression_to_sql (RygelLogicalExpression* expression,
                                                                 GArray* args,
                                                                 GError** error);
static gchar* rygel_media_export_media_cache_relational_expression_to_sql (RygelRelationalExpression* exp,
                                                                    GArray* args,
                                                                    GError** error);
static void _vala_GValue_free (GValue* self);
static void rygel_media_export_media_cache_finalize (GObject * obj);
static GType rygel_media_export_media_cache_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

GQuark
rygel_media_export_media_cache_error_quark (void)
{
	return g_quark_from_static_string ("rygel-media-export-media-cache-error-quark");
}

 G_GNUC_NO_INLINE static GType
rygel_media_export_media_cache_error_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_SQLITE_ERROR, "RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_SQLITE_ERROR", "sqlite-error"}, {RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_GENERAL_ERROR, "RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_GENERAL_ERROR", "general-error"}, {RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_INVALID_TYPE, "RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_INVALID_TYPE", "invalid-type"}, {RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_UNSUPPORTED_SEARCH, "RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_UNSUPPORTED_SEARCH", "unsupported-search"}, {RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_UPGRADE_FAILED, "RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_UPGRADE_FAILED", "upgrade-failed"}, {0, NULL, NULL}};
	GType rygel_media_export_media_cache_error_type_id;
	rygel_media_export_media_cache_error_type_id = g_enum_register_static ("RygelMediaExportMediaCacheError", values);
	return rygel_media_export_media_cache_error_type_id;
}

GType
rygel_media_export_media_cache_error_get_type (void)
{
	static volatile gsize rygel_media_export_media_cache_error_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_export_media_cache_error_type_id__once)) {
		GType rygel_media_export_media_cache_error_type_id;
		rygel_media_export_media_cache_error_type_id = rygel_media_export_media_cache_error_get_type_once ();
		g_once_init_leave (&rygel_media_export_media_cache_error_type_id__once, rygel_media_export_media_cache_error_type_id);
	}
	return rygel_media_export_media_cache_error_type_id__once;
}

 G_GNUC_NO_INLINE static GType
rygel_media_export_object_type_get_type_once (void)
{
	static const GEnumValue values[] = {{RYGEL_MEDIA_EXPORT_OBJECT_TYPE_CONTAINER, "RYGEL_MEDIA_EXPORT_OBJECT_TYPE_CONTAINER", "container"}, {RYGEL_MEDIA_EXPORT_OBJECT_TYPE_ITEM, "RYGEL_MEDIA_EXPORT_OBJECT_TYPE_ITEM", "item"}, {0, NULL, NULL}};
	GType rygel_media_export_object_type_type_id;
	rygel_media_export_object_type_type_id = g_enum_register_static ("RygelMediaExportObjectType", values);
	return rygel_media_export_object_type_type_id;
}

GType
rygel_media_export_object_type_get_type (void)
{
	static volatile gsize rygel_media_export_object_type_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_export_object_type_type_id__once)) {
		GType rygel_media_export_object_type_type_id;
		rygel_media_export_object_type_type_id = rygel_media_export_object_type_get_type_once ();
		g_once_init_leave (&rygel_media_export_object_type_type_id__once, rygel_media_export_object_type_type_id);
	}
	return rygel_media_export_object_type_type_id__once;
}

void
rygel_media_export_exists_cache_entry_copy (const RygelMediaExportExistsCacheEntry* self,
                                            RygelMediaExportExistsCacheEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	(*dest).mtime = (*self).mtime;
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	(*dest).size = (*self).size;
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = (*self).content_type;
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 ((*dest).content_type);
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	(*dest).content_type = _tmp1_;
#line 458 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_exists_cache_entry_destroy (RygelMediaExportExistsCacheEntry* self)
{
#line 48 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 ((*self).content_type);
#line 466 "rygel-media-export-media-cache.c"
}

RygelMediaExportExistsCacheEntry*
rygel_media_export_exists_cache_entry_dup (const RygelMediaExportExistsCacheEntry* self)
{
	RygelMediaExportExistsCacheEntry* dup;
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	dup = g_new0 (RygelMediaExportExistsCacheEntry, 1);
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_export_exists_cache_entry_copy (self, dup);
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return dup;
#line 479 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_exists_cache_entry_free (RygelMediaExportExistsCacheEntry* self)
{
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_export_exists_cache_entry_destroy (self);
#line 45 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_free (self);
#line 489 "rygel-media-export-media-cache.c"
}

 G_GNUC_NO_INLINE static GType
rygel_media_export_exists_cache_entry_get_type_once (void)
{
	GType rygel_media_export_exists_cache_entry_type_id;
	rygel_media_export_exists_cache_entry_type_id = g_boxed_type_register_static ("RygelMediaExportExistsCacheEntry", (GBoxedCopyFunc) rygel_media_export_exists_cache_entry_dup, (GBoxedFreeFunc) rygel_media_export_exists_cache_entry_free);
	return rygel_media_export_exists_cache_entry_type_id;
}

GType
rygel_media_export_exists_cache_entry_get_type (void)
{
	static volatile gsize rygel_media_export_exists_cache_entry_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_export_exists_cache_entry_type_id__once)) {
		GType rygel_media_export_exists_cache_entry_type_id;
		rygel_media_export_exists_cache_entry_type_id = rygel_media_export_exists_cache_entry_get_type_once ();
		g_once_init_leave (&rygel_media_export_exists_cache_entry_type_id__once, rygel_media_export_exists_cache_entry_type_id);
	}
	return rygel_media_export_exists_cache_entry_type_id__once;
}

static inline gpointer
rygel_media_export_media_cache_get_instance_private (RygelMediaExportMediaCache* self)
{
	return G_STRUCT_MEMBER_P (self, RygelMediaExportMediaCache_private_offset);
}

static RygelMediaExportMediaCache*
rygel_media_export_media_cache_construct (GType object_type,
                                          GError** error)
{
	RygelMediaExportMediaCache * self = NULL;
	gchar* db_name = NULL;
	gchar* _tmp0_;
	RygelMediaExportSQLFactory* _tmp4_;
	const gchar* _tmp5_;
	RygelMediaExportObjectFactory* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 67 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	self = (RygelMediaExportMediaCache*) g_object_new (object_type, NULL);
#line 68 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = g_strdup ("media-export");
#line 68 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	db_name = _tmp0_;
#line 535 "rygel-media-export-media-cache.c"
	{
		RygelMetaConfig* config = NULL;
		RygelMetaConfig* _tmp1_;
		gboolean _tmp2_ = FALSE;
#line 70 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = rygel_meta_config_get_default ();
#line 70 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		config = _tmp1_;
#line 71 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = rygel_configuration_get_bool ((RygelConfiguration*) config, "MediaExport", "use-temp-db", &_inner_error0_);
#line 71 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (config);
#line 550 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 71 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_tmp2_) {
#line 555 "rygel-media-export-media-cache.c"
			gchar* _tmp3_;
#line 72 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp3_ = g_strdup (":memory:");
#line 72 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (db_name);
#line 72 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			db_name = _tmp3_;
#line 563 "rygel-media-export-media-cache.c"
		}
#line 69 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (config);
#line 567 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 69 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 574 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 69 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 69 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (db_name);
#line 69 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (self);
#line 69 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 587 "rygel-media-export-media-cache.c"
	}
#line 75 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = rygel_media_export_sql_factory_new ();
#line 75 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (self->priv->sql);
#line 75 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	self->priv->sql = _tmp4_;
#line 76 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = db_name;
#line 76 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_export_media_cache_open_db (self, _tmp5_, &_inner_error0_);
#line 76 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 76 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 76 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (db_name);
#line 76 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (self);
#line 76 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 609 "rygel-media-export-media-cache.c"
	}
#line 77 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = rygel_media_export_object_factory_new ();
#line 77 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (self->priv->factory);
#line 77 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	self->priv->factory = _tmp6_;
#line 67 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (db_name);
#line 67 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return self;
#line 621 "rygel-media-export-media-cache.c"
}

static RygelMediaExportMediaCache*
rygel_media_export_media_cache_new (GError** error)
{
#line 67 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return rygel_media_export_media_cache_construct (RYGEL_MEDIA_EXPORT_TYPE_MEDIA_CACHE, error);
#line 629 "rygel-media-export-media-cache.c"
}

gchar*
rygel_media_export_media_cache_get_id (GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 81 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 82 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = g_file_get_uri (file);
#line 82 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = _tmp0_;
#line 82 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, _tmp1_, (gsize) -1);
#line 82 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = _tmp2_;
#line 82 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (_tmp1_);
#line 82 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp3_;
#line 82 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 656 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_ensure_exists (GError** error)
{
	RygelMediaExportMediaCache* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 87 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_export_media_cache_instance;
#line 87 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp0_ == NULL) {
#line 668 "rygel-media-export-media-cache.c"
		RygelMediaExportMediaCache* _tmp1_ = NULL;
		RygelMediaExportMediaCache* _tmp2_;
		RygelMediaExportMediaCache* _tmp3_;
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = rygel_media_export_media_cache_new (&_inner_error0_);
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = _tmp2_;
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 682 "rygel-media-export-media-cache.c"
		}
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = _tmp1_;
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = NULL;
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (rygel_media_export_media_cache_instance);
#line 88 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_instance = _tmp3_;
#line 87 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (_tmp1_);
#line 694 "rygel-media-export-media-cache.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 93 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return self ? g_object_ref (self) : NULL;
#line 703 "rygel-media-export-media-cache.c"
}

RygelMediaExportMediaCache*
rygel_media_export_media_cache_get_default (void)
{
	RygelMediaExportMediaCache* _tmp0_;
	RygelMediaExportMediaCache* _tmp1_;
	RygelMediaExportMediaCache* result;
#line 93 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_export_media_cache_instance;
#line 93 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 93 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp1_;
#line 93 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 720 "rygel-media-export-media-cache.c"
}

static void
_vala_GValue_array_free (GValue * array,
                         gssize array_length)
{
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (array != NULL) {
#line 729 "rygel-media-export-media-cache.c"
		gssize i;
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_unset (&array[i]);
#line 735 "rygel-media-export-media-cache.c"
		}
	}
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_free (array);
#line 740 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_remove_by_id (RygelMediaExportMediaCache* self,
                                             const gchar* id,
                                             GError** error)
{
	GValue* values = NULL;
	GValue _tmp0_ = {0};
	GValue* _tmp1_;
	gint values_length1;
	gint _values_size_;
	RygelDatabaseDatabase* _tmp2_;
	RygelMediaExportSQLFactory* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 97 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (id != NULL);
#line 98 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp0_, G_TYPE_STRING);
#line 98 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp0_, id);
#line 98 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = g_new0 (GValue, 1);
#line 98 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_[0] = _tmp0_;
#line 98 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp1_;
#line 98 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 1;
#line 98 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = self->priv->db;
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = self->priv->sql;
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = rygel_media_export_sql_factory_make (_tmp3_, RYGEL_MEDIA_EXPORT_SQL_STRING_DELETE);
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_database_exec (_tmp2_, _tmp4_, values, (gint) values_length1, &_inner_error0_);
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 793 "rygel-media-export-media-cache.c"
		} else {
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 803 "rygel-media-export-media-cache.c"
		}
	}
#line 97 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 808 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_remove_object (RygelMediaExportMediaCache* self,
                                              RygelMediaObject* object,
                                              GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 102 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (object != NULL);
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_object_get_id (object);
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = _tmp0_;
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_export_media_cache_remove_by_id (self, _tmp1_, &_inner_error0_);
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if ((_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) || (_inner_error0_->domain == RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR)) {
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 837 "rygel-media-export-media-cache.c"
		} else {
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 104 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 845 "rygel-media-export-media-cache.c"
		}
	}
}

/**
     * Add the container to the cache, in a database transcation,
     * rolling back the transaction if necessary.
     */
static gpointer
_g_error_copy0 (gpointer self)
{
#line 120 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return self ? g_error_copy (self) : NULL;
#line 859 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_save_container (RygelMediaExportMediaCache* self,
                                               RygelMediaContainer* container,
                                               GError** error)
{
	GError* _inner_error0_ = NULL;
#line 111 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (container != NULL);
#line 872 "rygel-media-export-media-cache.c"
	{
		RygelDatabaseDatabase* _tmp0_;
		RygelDatabaseDatabase* _tmp1_;
#line 113 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = self->priv->db;
#line 113 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_begin (_tmp0_, &_inner_error0_);
#line 113 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 884 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 113 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 113 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 893 "rygel-media-export-media-cache.c"
		}
#line 114 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_save_container_metadata (self, container, &_inner_error0_);
#line 114 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 901 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
			goto __finally0;
		}
#line 115 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_create_object (self, (RygelMediaObject*) container, FALSE, &_inner_error0_);
#line 115 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 912 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
			goto __finally0;
		}
#line 116 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = self->priv->db;
#line 116 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_commit (_tmp1_, &_inner_error0_);
#line 116 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 925 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 116 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 116 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 934 "rygel-media-export-media-cache.c"
		}
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		RygelDatabaseDatabase* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 112 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 112 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 118 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = self->priv->db;
#line 118 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_rollback (_tmp2_);
#line 120 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = _error_;
#line 120 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _g_error_copy0 (_tmp3_);
#line 120 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = _tmp4_;
#line 120 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 960 "rygel-media-export-media-cache.c"
		goto __finally0;
	}
	__finally0:
#line 112 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 112 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 970 "rygel-media-export-media-cache.c"
	}
}

/**
     * Add the item to the cache.
     */
void
rygel_media_export_media_cache_save_item (RygelMediaExportMediaCache* self,
                                          RygelMediaFileItem* item,
                                          gboolean override_guarded,
                                          GError** error)
{
	GError* _inner_error0_ = NULL;
#line 127 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (item != NULL);
#line 988 "rygel-media-export-media-cache.c"
	{
		RygelDatabaseDatabase* _tmp0_;
		RygelDatabaseDatabase* _tmp1_;
#line 130 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = self->priv->db;
#line 130 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_begin (_tmp0_, &_inner_error0_);
#line 130 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1000 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 130 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 130 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 1009 "rygel-media-export-media-cache.c"
		}
#line 131 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_save_item_metadata (self, item, &_inner_error0_);
#line 131 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1017 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
			goto __finally0;
		}
#line 132 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_create_object (self, (RygelMediaObject*) item, override_guarded, &_inner_error0_);
#line 132 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 132 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1028 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
			goto __finally0;
		}
#line 133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = self->priv->db;
#line 133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_commit (_tmp1_, &_inner_error0_);
#line 133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1041 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 1050 "rygel-media-export-media-cache.c"
		}
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		RygelDatabaseDatabase* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
#line 129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 135 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = rygel_media_object_get_id ((RygelMediaObject*) item);
#line 135 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = _tmp2_;
#line 135 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _error_;
#line 135 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = _tmp4_->message;
#line 135 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to add item with ID %s: %s"), _tmp3_, _tmp5_);
#line 138 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = self->priv->db;
#line 138 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_rollback (_tmp6_);
#line 140 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = _error_;
#line 140 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = _g_error_copy0 (_tmp7_);
#line 140 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = _tmp8_;
#line 140 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 1090 "rygel-media-export-media-cache.c"
		goto __finally0;
	}
	__finally0:
#line 129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 1100 "rygel-media-export-media-cache.c"
	}
}

/**
     * Create a new container or item instance based on the ID.
     *
     * The Rygel server discards the object when the browse request is finished,
     * after serializing the result.
     */
RygelMediaObject*
rygel_media_export_media_cache_get_object (RygelMediaExportMediaCache* self,
                                           const gchar* object_id,
                                           GError** error)
{
	GValue* values = NULL;
	GValue _tmp0_ = {0};
	GValue* _tmp1_;
	gint values_length1;
	gint _values_size_;
	RygelMediaObject* parent = NULL;
	RygelDatabaseCursor* cursor = NULL;
	GValue* _tmp2_;
	gint _tmp2__length1;
	RygelDatabaseCursor* _tmp3_;
	GError* _inner_error0_ = NULL;
	RygelMediaObject* result;
#line 150 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (object_id != NULL, NULL);
#line 151 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp0_, G_TYPE_STRING);
#line 151 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp0_, object_id);
#line 151 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = g_new0 (GValue, 1);
#line 151 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_[0] = _tmp0_;
#line 151 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp1_;
#line 151 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 1;
#line 151 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	parent = NULL;
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = values;
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2__length1 = values_length1;
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = rygel_media_export_media_cache_exec_cursor (self, RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECT, _tmp2_, (gint) _tmp2__length1, &_inner_error0_);
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	cursor = _tmp3_;
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (parent);
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 1167 "rygel-media-export-media-cache.c"
		} else {
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (parent);
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 154 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 1179 "rygel-media-export-media-cache.c"
		}
	}
	{
		RygelDatabaseCursorIterator* _statement_it = NULL;
		RygelDatabaseCursor* _tmp4_;
		RygelDatabaseCursorIterator* _tmp5_;
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = cursor;
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = rygel_database_cursor_iterator (_tmp4_);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_statement_it = _tmp5_;
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		while (TRUE) {
#line 1194 "rygel-media-export-media-cache.c"
			gboolean _tmp6_ = FALSE;
			RygelDatabaseCursorIterator* _tmp7_;
			sqlite3_stmt* statement = NULL;
			RygelDatabaseCursorIterator* _tmp8_;
			sqlite3_stmt* _tmp9_;
			RygelMediaContainer* parent_container = NULL;
			RygelMediaObject* _tmp10_;
			RygelMediaContainer* _tmp11_;
			RygelMediaObject* object = NULL;
			RygelMediaContainer* _tmp12_;
			sqlite3_stmt* _tmp13_;
			RygelMediaObject* _tmp14_;
			RygelMediaObject* _tmp15_;
			RygelMediaContainer* _tmp16_;
			RygelMediaObject* _tmp17_;
			RygelMediaObject* _tmp18_;
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp7_ = _statement_it;
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp6_ = rygel_database_cursor_iterator_next (_tmp7_, &_inner_error0_);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_propagate_error (error, _inner_error0_);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (parent);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 1231 "rygel-media-export-media-cache.c"
				} else {
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (parent);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_clear_error (&_inner_error0_);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 1247 "rygel-media-export-media-cache.c"
				}
			}
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (!_tmp6_) {
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 1254 "rygel-media-export-media-cache.c"
			}
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp8_ = _statement_it;
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp9_ = rygel_database_cursor_iterator_get (_tmp8_, &_inner_error0_);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			statement = _tmp9_;
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_propagate_error (error, _inner_error0_);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (parent);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 1278 "rygel-media-export-media-cache.c"
				} else {
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (parent);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_clear_error (&_inner_error0_);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 1294 "rygel-media-export-media-cache.c"
				}
			}
#line 157 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp10_ = parent;
#line 157 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, RYGEL_TYPE_MEDIA_CONTAINER) ? ((RygelMediaContainer*) _tmp10_) : NULL);
#line 157 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			parent_container = _tmp11_;
#line 158 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp12_ = parent_container;
#line 158 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp13_ = statement;
#line 158 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp14_ = rygel_media_export_media_cache_get_object_from_statement (self, _tmp12_, _tmp13_);
#line 158 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			object = _tmp14_;
#line 160 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp15_ = object;
#line 160 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp16_ = parent_container;
#line 160 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_object_set_parent_ref (_tmp15_, _tmp16_);
#line 161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp17_ = object;
#line 161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp18_ = _g_object_ref0 (_tmp17_);
#line 161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (parent);
#line 161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			parent = _tmp18_;
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (object);
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (parent_container);
#line 1329 "rygel-media-export-media-cache.c"
		}
#line 156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 1333 "rygel-media-export-media-cache.c"
	}
#line 164 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = parent;
#line 164 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (cursor);
#line 164 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 164 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 1343 "rygel-media-export-media-cache.c"
}

RygelMediaContainer*
rygel_media_export_media_cache_get_container (RygelMediaExportMediaCache* self,
                                              const gchar* container_id,
                                              GError** error)
{
	RygelMediaObject* object = NULL;
	RygelMediaObject* _tmp0_;
	gboolean _tmp1_ = FALSE;
	RygelMediaObject* _tmp2_;
	RygelMediaObject* _tmp5_;
	RygelMediaContainer* _tmp6_;
	GError* _inner_error0_ = NULL;
	RygelMediaContainer* result;
#line 167 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (container_id != NULL, NULL);
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_export_media_cache_get_object (self, container_id, &_inner_error0_);
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	object = _tmp0_;
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if ((_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) || (_inner_error0_->domain == RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR)) {
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 1375 "rygel-media-export-media-cache.c"
		} else {
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 170 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 1383 "rygel-media-export-media-cache.c"
		}
	}
#line 171 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = object;
#line 171 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp2_ != NULL) {
#line 1390 "rygel-media-export-media-cache.c"
		RygelMediaObject* _tmp3_;
#line 171 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = object;
#line 171 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, RYGEL_TYPE_MEDIA_CONTAINER);
#line 1396 "rygel-media-export-media-cache.c"
	} else {
#line 171 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = FALSE;
#line 1400 "rygel-media-export-media-cache.c"
	}
#line 171 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp1_) {
#line 1404 "rygel-media-export-media-cache.c"
		GError* _tmp4_;
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = g_error_new (RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR, RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_INVALID_TYPE, "Object with id %s is " "not a MediaContainer", container_id);
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = _tmp4_;
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if ((_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) || (_inner_error0_->domain == RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR)) {
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (object);
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 1418 "rygel-media-export-media-cache.c"
		} else {
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (object);
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 172 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 1428 "rygel-media-export-media-cache.c"
		}
	}
#line 177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = object;
#line 177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, RYGEL_TYPE_MEDIA_CONTAINER) ? ((RygelMediaContainer*) _tmp5_) : NULL);
#line 177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp6_;
#line 177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (object);
#line 177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 1441 "rygel-media-export-media-cache.c"
}

gint
rygel_media_export_media_cache_get_child_count (RygelMediaExportMediaCache* self,
                                                const gchar* container_id,
                                                GError** error)
{
	GValue* values = NULL;
	GValue _tmp0_ = {0};
	GValue* _tmp1_;
	gint values_length1;
	gint _values_size_;
	gint _tmp2_ = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 180 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 180 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (container_id != NULL, 0);
#line 181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp0_, G_TYPE_STRING);
#line 181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp0_, container_id);
#line 181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = g_new0 (GValue, 1);
#line 181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_[0] = _tmp0_;
#line 181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp1_;
#line 181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 1;
#line 181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = rygel_media_export_media_cache_query_value (self, RYGEL_MEDIA_EXPORT_SQL_STRING_CHILD_COUNT, values, (gint) values_length1, &_inner_error0_);
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1481 "rygel-media-export-media-cache.c"
			gint _tmp3_ = -1;
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp3_;
#line 1489 "rygel-media-export-media-cache.c"
		} else {
			gint _tmp4_ = -1;
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp4_;
#line 1500 "rygel-media-export-media-cache.c"
		}
	}
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp2_;
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 1509 "rygel-media-export-media-cache.c"
}

guint32
rygel_media_export_media_cache_get_update_id (RygelMediaExportMediaCache* self)
{
	GError* _inner_error0_ = NULL;
	guint32 result;
#line 186 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1519 "rygel-media-export-media-cache.c"
	{
		gint _tmp0_ = 0;
#line 189 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = rygel_media_export_media_cache_query_value (self, RYGEL_MEDIA_EXPORT_SQL_STRING_MAX_UPDATE_ID, NULL, (gint) 0, &_inner_error0_);
#line 189 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1526 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 189 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = (guint32) _tmp0_;
#line 189 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 1533 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 188 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 188 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = _error_;
#line 191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = _tmp1_->message;
#line 191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_debug ("rygel-media-export-media-cache.vala:191: Failed to query max update id" \
": %s", _tmp2_);
#line 188 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 1553 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 188 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1558 "rygel-media-export-media-cache.c"
		guint32 _tmp3_ = 0U;
#line 188 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 188 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return _tmp3_;
#line 1566 "rygel-media-export-media-cache.c"
	}
#line 194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = (guint32) 0;
#line 194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 1572 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_get_track_properties (RygelMediaExportMediaCache* self,
                                                     const gchar* id,
                                                     guint32* object_update_id,
                                                     guint32* container_update_id,
                                                     guint32* total_deleted_child_count)
{
	guint32 _vala_object_update_id = 0U;
	guint32 _vala_container_update_id = 0U;
	guint32 _vala_total_deleted_child_count = 0U;
	GValue* values = NULL;
	GValue _tmp0_ = {0};
	GValue* _tmp1_;
	gint values_length1;
	gint _values_size_;
	GError* _inner_error0_ = NULL;
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (id != NULL);
#line 201 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp0_, G_TYPE_STRING);
#line 201 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp0_, id);
#line 201 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = g_new0 (GValue, 1);
#line 201 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_[0] = _tmp0_;
#line 201 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp1_;
#line 201 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 1;
#line 201 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 203 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_object_update_id = (guint32) 0;
#line 204 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_container_update_id = (guint32) 0;
#line 205 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_total_deleted_child_count = (guint32) 0;
#line 1615 "rygel-media-export-media-cache.c"
	{
		RygelDatabaseCursor* cursor = NULL;
		RygelDatabaseDatabase* _tmp2_;
		GValue* _tmp3_;
		gint _tmp3__length1;
		RygelDatabaseCursor* _tmp4_;
		sqlite3_stmt* statement = NULL;
		RygelDatabaseCursor* _tmp5_;
		sqlite3_stmt* _tmp6_;
		sqlite3_stmt* _tmp7_;
		sqlite3_stmt* _tmp8_;
		sqlite3_stmt* _tmp9_;
#line 208 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = self->priv->db;
#line 208 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = values;
#line 208 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3__length1 = values_length1;
#line 208 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = rygel_database_database_exec_cursor (_tmp2_, "SELECT object_update_id, " "container_update_id, " "deleted_child_count " "FROM Object WHERE upnp_id = ?", _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 208 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		cursor = _tmp4_;
#line 208 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1640 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 213 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = cursor;
#line 213 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = rygel_database_cursor_next (_tmp5_, &_inner_error0_);
#line 213 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		statement = _tmp6_;
#line 213 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 213 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (cursor);
#line 1653 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 214 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = statement;
#line 214 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_object_update_id = (guint32) sqlite3_column_int64 (_tmp7_, 0);
#line 215 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = statement;
#line 215 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_container_update_id = (guint32) sqlite3_column_int64 (_tmp8_, 1);
#line 216 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp9_ = statement;
#line 216 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_total_deleted_child_count = (guint32) sqlite3_column_int64 (_tmp9_, 2);
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (cursor);
#line 1670 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp10_ = _error_;
#line 218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp11_ = _tmp10_->message;
#line 218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to get update IDs: %s"), _tmp11_);
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 1690 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 207 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 1703 "rygel-media-export-media-cache.c"
	}
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (object_update_id) {
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*object_update_id = _vala_object_update_id;
#line 1711 "rygel-media-export-media-cache.c"
	}
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (container_update_id) {
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*container_update_id = _vala_container_update_id;
#line 1717 "rygel-media-export-media-cache.c"
	}
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (total_deleted_child_count) {
#line 197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*total_deleted_child_count = _vala_total_deleted_child_count;
#line 1723 "rygel-media-export-media-cache.c"
	}
}

gboolean
rygel_media_export_media_cache_exists (RygelMediaExportMediaCache* self,
                                       GFile* file,
                                       gint64* timestamp,
                                       gint64* size,
                                       gchar** mime_type,
                                       GError** error)
{
	gint64 _vala_timestamp = 0LL;
	gint64 _vala_size = 0LL;
	gchar* _vala_mime_type = NULL;
	gchar* uri = NULL;
	gchar* _tmp0_;
	GValue* values = NULL;
	const gchar* _tmp1_;
	GValue _tmp2_ = {0};
	GValue* _tmp3_;
	gint values_length1;
	gint _values_size_;
	GeeHashMap* _tmp4_;
	const gchar* _tmp5_;
	RygelDatabaseCursor* cursor = NULL;
	GValue* _tmp16_;
	gint _tmp16__length1;
	RygelDatabaseCursor* _tmp17_;
	sqlite3_stmt* statement = NULL;
	RygelDatabaseCursor* _tmp20_;
	sqlite3_stmt* _tmp21_;
	sqlite3_stmt* _tmp24_;
	sqlite3_stmt* _tmp25_;
	sqlite3_stmt* _tmp26_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 222 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 222 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 226 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = g_file_get_uri (file);
#line 226 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	uri = _tmp0_;
#line 227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = uri;
#line 227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp2_, G_TYPE_STRING);
#line 227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp2_, _tmp1_);
#line 227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = g_new0 (GValue, 1);
#line 227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_[0] = _tmp2_;
#line 227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp3_;
#line 227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 1;
#line 227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 228 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (_vala_mime_type);
#line 228 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_mime_type = NULL;
#line 230 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = self->priv->exists_cache;
#line 230 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = uri;
#line 230 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, _tmp5_)) {
#line 1794 "rygel-media-export-media-cache.c"
		RygelMediaExportExistsCacheEntry* entry = NULL;
		GeeHashMap* _tmp6_;
		const gchar* _tmp7_;
		gpointer _tmp8_;
		GeeHashMap* _tmp9_;
		const gchar* _tmp10_;
		RygelMediaExportExistsCacheEntry* _tmp11_;
		RygelMediaExportExistsCacheEntry* _tmp12_;
		RygelMediaExportExistsCacheEntry* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 231 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = self->priv->exists_cache;
#line 231 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = uri;
#line 231 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
#line 231 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		entry = (RygelMediaExportExistsCacheEntry*) _tmp8_;
#line 232 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp9_ = self->priv->exists_cache;
#line 232 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp10_ = uri;
#line 232 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp9_, _tmp10_, NULL);
#line 233 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp11_ = entry;
#line 233 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_timestamp = (*_tmp11_).mtime;
#line 234 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp12_ = entry;
#line 234 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_size = (*_tmp12_).size;
#line 235 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp13_ = entry;
#line 235 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp14_ = (*_tmp13_).content_type;
#line 235 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 235 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_vala_mime_type);
#line 235 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_mime_type = _tmp15_;
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = TRUE;
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_rygel_media_export_exists_cache_entry_free0 (entry);
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (uri);
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (timestamp) {
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			*timestamp = _vala_timestamp;
#line 1850 "rygel-media-export-media-cache.c"
		}
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (size) {
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			*size = _vala_size;
#line 1856 "rygel-media-export-media-cache.c"
		}
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (mime_type) {
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			*mime_type = _vala_mime_type;
#line 1862 "rygel-media-export-media-cache.c"
		} else {
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (_vala_mime_type);
#line 1866 "rygel-media-export-media-cache.c"
		}
#line 237 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 1870 "rygel-media-export-media-cache.c"
	}
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp16_ = values;
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp16__length1 = values_length1;
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp17_ = rygel_media_export_media_cache_exec_cursor (self, RYGEL_MEDIA_EXPORT_SQL_STRING_EXISTS, _tmp16_, (gint) _tmp16__length1, &_inner_error0_);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	cursor = _tmp17_;
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1884 "rygel-media-export-media-cache.c"
			gboolean _tmp18_ = FALSE;
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (uri);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (_vala_mime_type);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp18_;
#line 1896 "rygel-media-export-media-cache.c"
		} else {
			gboolean _tmp19_ = FALSE;
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (uri);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (_vala_mime_type);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp19_;
#line 1911 "rygel-media-export-media-cache.c"
		}
	}
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp20_ = cursor;
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp21_ = rygel_database_cursor_next (_tmp20_, &_inner_error0_);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	statement = _tmp21_;
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1924 "rygel-media-export-media-cache.c"
			gboolean _tmp22_ = FALSE;
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (cursor);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (uri);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (_vala_mime_type);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp22_;
#line 1938 "rygel-media-export-media-cache.c"
		} else {
			gboolean _tmp23_ = FALSE;
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (cursor);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (uri);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (_vala_mime_type);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 241 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp23_;
#line 1955 "rygel-media-export-media-cache.c"
		}
	}
#line 242 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_ = statement;
#line 242 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_timestamp = sqlite3_column_int64 (_tmp24_, 1);
#line 245 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_vala_timestamp == G_MAXINT64) {
#line 246 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_timestamp = (gint64) 0;
#line 1966 "rygel-media-export-media-cache.c"
	}
#line 248 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_ = statement;
#line 248 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_size = sqlite3_column_int64 (_tmp25_, 2);
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp26_ = statement;
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = sqlite3_column_int (_tmp26_, 0) == 1;
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (cursor);
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (uri);
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (timestamp) {
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*timestamp = _vala_timestamp;
#line 1986 "rygel-media-export-media-cache.c"
	}
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (size) {
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*size = _vala_size;
#line 1992 "rygel-media-export-media-cache.c"
	}
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (mime_type) {
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*mime_type = _vala_mime_type;
#line 1998 "rygel-media-export-media-cache.c"
	} else {
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_vala_mime_type);
#line 2002 "rygel-media-export-media-cache.c"
	}
#line 250 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 2006 "rygel-media-export-media-cache.c"
}

RygelMediaObjects*
rygel_media_export_media_cache_get_children (RygelMediaExportMediaCache* self,
                                             RygelMediaContainer* container,
                                             const gchar* sort_criteria,
                                             glong offset,
                                             glong max_count,
                                             GError** error)
{
	RygelMediaObjects* children = NULL;
	RygelMediaObjects* _tmp0_;
	GValue* values = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GValue _tmp3_ = {0};
	GValue _tmp4_ = {0};
	GValue _tmp5_ = {0};
	GValue* _tmp6_;
	gint values_length1;
	gint _values_size_;
	gchar* sql = NULL;
	RygelMediaExportSQLFactory* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* sort_order = NULL;
	gchar* _tmp10_;
	RygelDatabaseCursor* cursor = NULL;
	RygelDatabaseDatabase* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GValue* _tmp16_;
	gint _tmp16__length1;
	RygelDatabaseCursor* _tmp17_;
	RygelDatabaseCursor* _tmp18_;
	GError* _inner_error0_ = NULL;
	RygelMediaObjects* result;
#line 253 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (container != NULL, NULL);
#line 253 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (sort_criteria != NULL, NULL);
#line 258 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_objects_new ();
#line 258 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	children = _tmp0_;
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = rygel_media_object_get_id ((RygelMediaObject*) container);
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = _tmp1_;
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp3_, G_TYPE_STRING);
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp3_, _tmp2_);
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp4_, G_TYPE_LONG);
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_long (&_tmp4_, offset);
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp5_, G_TYPE_LONG);
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_long (&_tmp5_, max_count);
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = g_new0 (GValue, 3);
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_[0] = _tmp3_;
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_[1] = _tmp4_;
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_[2] = _tmp5_;
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp6_;
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 3;
#line 260 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 264 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp7_ = self->priv->sql;
#line 264 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp8_ = rygel_media_export_sql_factory_make (_tmp7_, RYGEL_MEDIA_EXPORT_SQL_STRING_GET_CHILDREN);
#line 264 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 264 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	sql = _tmp9_;
#line 265 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp10_ = rygel_media_export_media_cache_translate_sort_criteria (sort_criteria, NULL, NULL);
#line 265 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	sort_order = _tmp10_;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp11_ = self->priv->db;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp12_ = sql;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp13_ = sort_order;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp14_ = g_strdup_printf (_tmp12_, _tmp13_);
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp15_ = _tmp14_;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp16_ = values;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp16__length1 = values_length1;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp17_ = rygel_database_database_exec_cursor (_tmp11_, _tmp15_, _tmp16_, (gint) _tmp16__length1, &_inner_error0_);
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp18_ = _tmp17_;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (_tmp15_);
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	cursor = _tmp18_;
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (sort_order);
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (sql);
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (children);
#line 266 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 2134 "rygel-media-export-media-cache.c"
	}
	{
		RygelDatabaseCursorIterator* _statement_it = NULL;
		RygelDatabaseCursor* _tmp19_;
		RygelDatabaseCursorIterator* _tmp20_;
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp19_ = cursor;
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp20_ = rygel_database_cursor_iterator (_tmp19_);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_statement_it = _tmp20_;
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		while (TRUE) {
#line 2148 "rygel-media-export-media-cache.c"
			gboolean _tmp21_ = FALSE;
			RygelDatabaseCursorIterator* _tmp22_;
			sqlite3_stmt* statement = NULL;
			RygelDatabaseCursorIterator* _tmp23_;
			sqlite3_stmt* _tmp24_;
			RygelMediaObjects* _tmp25_;
			sqlite3_stmt* _tmp26_;
			RygelMediaObject* _tmp27_;
			RygelMediaObject* _tmp28_;
			RygelMediaObjects* _tmp29_;
			gpointer _tmp30_;
			RygelMediaObject* _tmp31_;
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp22_ = _statement_it;
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp21_ = rygel_database_cursor_iterator_next (_tmp22_, &_inner_error0_);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_propagate_error (error, _inner_error0_);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (cursor);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sort_order);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sql);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (children);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return NULL;
#line 2183 "rygel-media-export-media-cache.c"
			}
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (!_tmp21_) {
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 2189 "rygel-media-export-media-cache.c"
			}
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp23_ = _statement_it;
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp24_ = rygel_database_cursor_iterator_get (_tmp23_, &_inner_error0_);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			statement = _tmp24_;
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_propagate_error (error, _inner_error0_);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (cursor);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sort_order);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sql);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (children);
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return NULL;
#line 2215 "rygel-media-export-media-cache.c"
			}
#line 269 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp25_ = children;
#line 269 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp26_ = statement;
#line 269 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp27_ = rygel_media_export_media_cache_get_object_from_statement (self, container, _tmp26_);
#line 269 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp28_ = _tmp27_;
#line 269 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp28_);
#line 269 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (_tmp28_);
#line 271 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp29_ = children;
#line 271 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp30_ = gee_list_last ((GeeList*) _tmp29_);
#line 271 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp31_ = (RygelMediaObject*) _tmp30_;
#line 271 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_object_set_parent_ref (_tmp31_, container);
#line 271 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (_tmp31_);
#line 2239 "rygel-media-export-media-cache.c"
		}
#line 268 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 2243 "rygel-media-export-media-cache.c"
	}
#line 274 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = children;
#line 274 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (cursor);
#line 274 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (sort_order);
#line 274 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (sql);
#line 274 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 274 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 2257 "rygel-media-export-media-cache.c"
}

RygelMediaObjects*
rygel_media_export_media_cache_get_objects_by_search_expression (RygelMediaExportMediaCache* self,
                                                                 RygelSearchExpression* expression,
                                                                 const gchar* container_id,
                                                                 const gchar* sort_criteria,
                                                                 guint offset,
                                                                 guint max_count,
                                                                 guint* total_matches,
                                                                 GError** error)
{
	guint _vala_total_matches = 0U;
	GArray* args = NULL;
	GArray* _tmp0_;
	gchar* filter = NULL;
	GArray* _tmp1_;
	gchar* _tmp2_;
	guint max_objects = 0U;
	glong _tmp6_ = 0L;
	const gchar* _tmp7_;
	GArray* _tmp8_;
	RygelMediaObjects* _tmp9_ = NULL;
	const gchar* _tmp10_;
	GArray* _tmp11_;
	RygelMediaObjects* _tmp12_;
	RygelMediaObjects* _tmp13_;
	GError* _inner_error0_ = NULL;
	RygelMediaObjects* result;
#line 277 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 277 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (sort_criteria != NULL, NULL);
#line 285 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (GValue));
#line 285 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) g_value_unset);
#line 285 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	args = _tmp0_;
#line 286 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = args;
#line 286 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = rygel_media_export_media_cache_translate_search_expression (expression, _tmp1_, "WHERE", &_inner_error0_);
#line 286 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	filter = _tmp2_;
#line 286 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 286 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 286 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_array_unref0 (args);
#line 286 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 2311 "rygel-media-export-media-cache.c"
	}
#line 288 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (expression != NULL) {
#line 2315 "rygel-media-export-media-cache.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 289 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = rygel_search_expression_to_string (expression);
#line 289 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _tmp3_;
#line 289 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_debug ("rygel-media-export-media-cache.vala:289: Original search: %s", _tmp4_);
#line 289 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_tmp4_);
#line 290 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = filter;
#line 290 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_debug ("rygel-media-export-media-cache.vala:290: Parsed search expression: %s", _tmp5_);
#line 2331 "rygel-media-export-media-cache.c"
	}
#line 293 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	max_objects = rygel_media_export_media_cache_modify_limit (self, max_count);
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp7_ = filter;
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp8_ = args;
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = rygel_media_export_media_cache_get_object_count_by_filter (self, _tmp7_, _tmp8_, container_id, &_inner_error0_);
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (filter);
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_array_unref0 (args);
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 2351 "rygel-media-export-media-cache.c"
	}
#line 294 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_total_matches = (guint) _tmp6_;
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp10_ = filter;
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp11_ = args;
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp12_ = rygel_media_export_media_cache_get_objects_by_filter (self, _tmp10_, _tmp11_, container_id, sort_criteria, (glong) offset, (glong) max_objects, &_inner_error0_);
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = _tmp12_;
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (filter);
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_array_unref0 (args);
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 2373 "rygel-media-export-media-cache.c"
	}
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp13_ = _tmp9_;
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = NULL;
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp13_;
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (_tmp9_);
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (filter);
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_array_unref0 (args);
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (total_matches) {
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*total_matches = _vala_total_matches;
#line 2391 "rygel-media-export-media-cache.c"
	}
#line 298 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 2395 "rygel-media-export-media-cache.c"
}

glong
rygel_media_export_media_cache_get_object_count_by_search_expression (RygelMediaExportMediaCache* self,
                                                                      RygelSearchExpression* expression,
                                                                      const gchar* container_id,
                                                                      GError** error)
{
	GArray* args = NULL;
	GArray* _tmp0_;
	gchar* filter = NULL;
	GArray* _tmp1_;
	gchar* _tmp2_;
	glong _tmp17_ = 0L;
	const gchar* _tmp18_;
	GArray* _tmp19_;
	GError* _inner_error0_ = NULL;
	glong result;
#line 306 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, 0L);
#line 310 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (GValue));
#line 310 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) g_value_unset);
#line 310 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	args = _tmp0_;
#line 311 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = args;
#line 311 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = rygel_media_export_media_cache_translate_search_expression (expression, _tmp1_, "WHERE", &_inner_error0_);
#line 311 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	filter = _tmp2_;
#line 311 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2430 "rygel-media-export-media-cache.c"
		glong _tmp3_ = -1L;
#line 311 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 311 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_array_unref0 (args);
#line 311 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return _tmp3_;
#line 2438 "rygel-media-export-media-cache.c"
	}
#line 313 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (expression != NULL) {
#line 2442 "rygel-media-export-media-cache.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 314 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = rygel_search_expression_to_string (expression);
#line 314 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = _tmp4_;
#line 314 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_debug ("rygel-media-export-media-cache.vala:314: Original search: %s", _tmp5_);
#line 314 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_tmp5_);
#line 315 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = filter;
#line 315 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_debug ("rygel-media-export-media-cache.vala:315: Parsed search expression: %s", _tmp6_);
#line 2458 "rygel-media-export-media-cache.c"
	}
	{
		gint i = 0;
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		i = 0;
#line 2464 "rygel-media-export-media-cache.c"
		{
			gboolean _tmp7_ = FALSE;
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp7_ = TRUE;
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			while (TRUE) {
#line 2471 "rygel-media-export-media-cache.c"
				GArray* _tmp9_;
				GValue arg = {0};
				GArray* _tmp10_;
				GValue _tmp11_;
				GValue _tmp12_ = {0};
				gchar* _tmp13_ = NULL;
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (!_tmp7_) {
#line 2480 "rygel-media-export-media-cache.c"
					gint _tmp8_;
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp8_ = i;
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					i = _tmp8_ + 1;
#line 2486 "rygel-media-export-media-cache.c"
				}
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp7_ = FALSE;
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp9_ = args;
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (!(((guint) i) < _tmp9_->len)) {
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					break;
#line 2496 "rygel-media-export-media-cache.c"
				}
#line 319 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp10_ = args;
#line 319 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp11_ = g_array_index (_tmp10_, GValue, (guint) i);
#line 319 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (G_IS_VALUE (&_tmp11_)) {
#line 319 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_value_init (&_tmp12_, G_VALUE_TYPE (&_tmp11_));
#line 319 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_value_copy (&_tmp11_, &_tmp12_);
#line 2508 "rygel-media-export-media-cache.c"
				} else {
#line 319 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp12_ = _tmp11_;
#line 2512 "rygel-media-export-media-cache.c"
				}
#line 319 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				arg = _tmp12_;
#line 320 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (G_VALUE_HOLDS (&arg, G_TYPE_STRING)) {
#line 2518 "rygel-media-export-media-cache.c"
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 321 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp14_ = g_value_get_string (&arg);
#line 321 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp15_ = g_strdup (_tmp14_);
#line 321 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (_tmp13_);
#line 321 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp13_ = _tmp15_;
#line 2529 "rygel-media-export-media-cache.c"
				} else {
					gchar* _tmp16_;
#line 322 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp16_ = g_strdup_value_contents (&arg);
#line 322 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (_tmp13_);
#line 322 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp13_ = _tmp16_;
#line 2538 "rygel-media-export-media-cache.c"
				}
#line 320 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_debug ("rygel-media-export-media-cache.vala:320: Arg %d: %s", i, _tmp13_);
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (_tmp13_);
#line 318 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				G_IS_VALUE (&arg) ? (g_value_unset (&arg), NULL) : NULL;
#line 2546 "rygel-media-export-media-cache.c"
			}
		}
	}
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp18_ = filter;
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp19_ = args;
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp17_ = rygel_media_export_media_cache_get_object_count_by_filter (self, _tmp18_, _tmp19_, container_id, &_inner_error0_);
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2558 "rygel-media-export-media-cache.c"
		glong _tmp20_ = -1L;
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (filter);
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_array_unref0 (args);
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return _tmp20_;
#line 2568 "rygel-media-export-media-cache.c"
	}
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp17_;
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (filter);
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_array_unref0 (args);
#line 325 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 2578 "rygel-media-export-media-cache.c"
}

glong
rygel_media_export_media_cache_get_object_count_by_filter (RygelMediaExportMediaCache* self,
                                                           const gchar* filter,
                                                           GArray* args,
                                                           const gchar* container_id,
                                                           GError** error)
{
	const gchar* pattern = NULL;
	RygelMediaExportSQLString string_id = 0;
	RygelMediaExportSQLFactory* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_ = 0;
	RygelDatabaseDatabase* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gpointer* _tmp10_;
	gint _tmp10__length1;
	gint _tmp11_;
	GError* _inner_error0_ = NULL;
	glong result;
#line 330 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, 0L);
#line 330 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (filter != NULL, 0L);
#line 330 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (args != NULL, 0L);
#line 335 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (container_id != NULL) {
#line 2609 "rygel-media-export-media-cache.c"
		GValue v = {0};
		GValue _tmp0_ = {0};
		GValue _tmp1_;
		GValue _tmp2_;
		GValue _tmp3_ = {0};
#line 336 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp0_, G_TYPE_STRING);
#line 336 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_string (&_tmp0_, container_id);
#line 336 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		v = _tmp0_;
#line 337 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = v;
#line 337 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = _tmp1_;
#line 337 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_IS_VALUE (&_tmp2_)) {
#line 337 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (&_tmp3_, G_VALUE_TYPE (&_tmp2_));
#line 337 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_copy (&_tmp2_, &_tmp3_);
#line 2631 "rygel-media-export-media-cache.c"
		} else {
#line 337 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp3_ = _tmp2_;
#line 2635 "rygel-media-export-media-cache.c"
		}
#line 337 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_array_prepend_val (args, _tmp3_);
#line 335 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 2641 "rygel-media-export-media-cache.c"
	}
#line 340 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_debug ("rygel-media-export-media-cache.vala:340: Parameters to bind: %u", args->len);
#line 343 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (container_id != NULL) {
#line 344 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		string_id = RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECT_COUNT_BY_FILTER_WITH_ANCESTOR;
#line 2649 "rygel-media-export-media-cache.c"
	} else {
#line 346 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		string_id = RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECT_COUNT_BY_FILTER;
#line 2653 "rygel-media-export-media-cache.c"
	}
#line 348 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = self->priv->sql;
#line 348 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = rygel_media_export_sql_factory_make (_tmp4_, string_id);
#line 348 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	pattern = _tmp5_;
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp7_ = self->priv->db;
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp8_ = g_strdup_printf (pattern, filter);
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = _tmp8_;
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp10_ = args->data;
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp10__length1 = args->len;
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp11_ = rygel_database_database_query_value (_tmp7_, _tmp9_, _tmp10_, (gint) _tmp10__length1, &_inner_error0_);
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (_tmp9_);
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = _tmp11_;
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2679 "rygel-media-export-media-cache.c"
		glong _tmp12_ = -1L;
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return _tmp12_;
#line 2685 "rygel-media-export-media-cache.c"
	}
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = (glong) _tmp6_;
#line 350 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 2691 "rygel-media-export-media-cache.c"
}

RygelMediaObjects*
rygel_media_export_media_cache_get_objects_by_filter (RygelMediaExportMediaCache* self,
                                                      const gchar* filter,
                                                      GArray* args,
                                                      const gchar* container_id,
                                                      const gchar* sort_criteria,
                                                      glong offset,
                                                      glong max_count,
                                                      GError** error)
{
	RygelMediaObjects* children = NULL;
	RygelMediaObjects* _tmp0_;
	GValue v = {0};
	GValue _tmp1_ = {0};
	GValue _tmp2_;
	GValue _tmp3_;
	GValue _tmp4_ = {0};
	GValue _tmp5_ = {0};
	GValue _tmp6_;
	GValue _tmp7_;
	GValue _tmp8_ = {0};
	RygelMediaContainer* parent = NULL;
	const gchar* sql = NULL;
	gchar* sort_order = NULL;
	gchar* _tmp21_;
	RygelDatabaseCursor* cursor = NULL;
	RygelDatabaseDatabase* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gpointer* _tmp27_;
	gint _tmp27__length1;
	RygelDatabaseCursor* _tmp28_;
	RygelDatabaseCursor* _tmp29_;
	GError* _inner_error0_ = NULL;
	RygelMediaObjects* result;
#line 353 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 353 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (filter != NULL, NULL);
#line 353 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 353 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (sort_criteria != NULL, NULL);
#line 360 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_objects_new ();
#line 360 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	children = _tmp0_;
#line 361 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp1_, G_TYPE_LONG);
#line 361 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_long (&_tmp1_, offset);
#line 361 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	v = _tmp1_;
#line 362 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = v;
#line 362 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = _tmp2_;
#line 362 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_IS_VALUE (&_tmp3_)) {
#line 362 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp4_, G_VALUE_TYPE (&_tmp3_));
#line 362 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_copy (&_tmp3_, &_tmp4_);
#line 2759 "rygel-media-export-media-cache.c"
	} else {
#line 362 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _tmp3_;
#line 2763 "rygel-media-export-media-cache.c"
	}
#line 362 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_array_append_val (args, _tmp4_);
#line 363 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp5_, G_TYPE_LONG);
#line 363 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_long (&_tmp5_, max_count);
#line 363 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 363 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	v = _tmp5_;
#line 364 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = v;
#line 364 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp7_ = _tmp6_;
#line 364 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_IS_VALUE (&_tmp7_)) {
#line 364 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp8_, G_VALUE_TYPE (&_tmp7_));
#line 364 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_copy (&_tmp7_, &_tmp8_);
#line 2785 "rygel-media-export-media-cache.c"
	} else {
#line 364 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = _tmp7_;
#line 2789 "rygel-media-export-media-cache.c"
	}
#line 364 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_array_append_val (args, _tmp8_);
#line 365 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	parent = NULL;
#line 367 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_debug ("rygel-media-export-media-cache.vala:367: Parameters to bind: %u", args->len);
#line 2797 "rygel-media-export-media-cache.c"
	{
		gint i = 0;
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		i = 0;
#line 2802 "rygel-media-export-media-cache.c"
		{
			gboolean _tmp9_ = FALSE;
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp9_ = TRUE;
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			while (TRUE) {
#line 2809 "rygel-media-export-media-cache.c"
				GValue arg = {0};
				GValue _tmp11_;
				GValue _tmp12_ = {0};
				gchar* _tmp13_ = NULL;
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (!_tmp9_) {
#line 2816 "rygel-media-export-media-cache.c"
					gint _tmp10_;
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp10_ = i;
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					i = _tmp10_ + 1;
#line 2822 "rygel-media-export-media-cache.c"
				}
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp9_ = FALSE;
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (!(((guint) i) < args->len)) {
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					break;
#line 2830 "rygel-media-export-media-cache.c"
				}
#line 369 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp11_ = g_array_index (args, GValue, (guint) i);
#line 369 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (G_IS_VALUE (&_tmp11_)) {
#line 369 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_value_init (&_tmp12_, G_VALUE_TYPE (&_tmp11_));
#line 369 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_value_copy (&_tmp11_, &_tmp12_);
#line 2840 "rygel-media-export-media-cache.c"
				} else {
#line 369 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp12_ = _tmp11_;
#line 2844 "rygel-media-export-media-cache.c"
				}
#line 369 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				arg = _tmp12_;
#line 370 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (G_VALUE_HOLDS (&arg, G_TYPE_STRING)) {
#line 2850 "rygel-media-export-media-cache.c"
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 371 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp14_ = g_value_get_string (&arg);
#line 371 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp15_ = g_strdup (_tmp14_);
#line 371 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (_tmp13_);
#line 371 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp13_ = _tmp15_;
#line 2861 "rygel-media-export-media-cache.c"
				} else {
					gchar* _tmp16_;
#line 372 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp16_ = g_strdup_value_contents (&arg);
#line 372 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (_tmp13_);
#line 372 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp13_ = _tmp16_;
#line 2870 "rygel-media-export-media-cache.c"
				}
#line 370 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_debug ("rygel-media-export-media-cache.vala:370: Arg %d: %s", i, _tmp13_);
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (_tmp13_);
#line 368 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				G_IS_VALUE (&arg) ? (g_value_unset (&arg), NULL) : NULL;
#line 2878 "rygel-media-export-media-cache.c"
			}
		}
	}
#line 376 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (container_id != NULL) {
#line 2884 "rygel-media-export-media-cache.c"
		RygelMediaExportSQLFactory* _tmp17_;
		const gchar* _tmp18_;
#line 377 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp17_ = self->priv->sql;
#line 377 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp18_ = rygel_media_export_sql_factory_make (_tmp17_, RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECTS_BY_FILTER_WITH_ANCESTOR);
#line 377 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		sql = _tmp18_;
#line 2893 "rygel-media-export-media-cache.c"
	} else {
		RygelMediaExportSQLFactory* _tmp19_;
		const gchar* _tmp20_;
#line 379 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp19_ = self->priv->sql;
#line 379 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp20_ = rygel_media_export_sql_factory_make (_tmp19_, RYGEL_MEDIA_EXPORT_SQL_STRING_GET_OBJECTS_BY_FILTER);
#line 379 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		sql = _tmp20_;
#line 2903 "rygel-media-export-media-cache.c"
	}
#line 382 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp21_ = rygel_media_export_media_cache_translate_sort_criteria (sort_criteria, NULL, NULL);
#line 382 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	sort_order = _tmp21_;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp22_ = self->priv->db;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp23_ = sql;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_ = sort_order;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_ = g_strdup_printf (_tmp23_, filter, _tmp24_);
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp26_ = _tmp25_;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp27_ = args->data;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp27__length1 = args->len;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp28_ = rygel_database_database_exec_cursor (_tmp22_, _tmp26_, _tmp27_, (gint) _tmp27__length1, &_inner_error0_);
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp29_ = _tmp28_;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (_tmp26_);
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	cursor = _tmp29_;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (sort_order);
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (parent);
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (children);
#line 383 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 2945 "rygel-media-export-media-cache.c"
	}
	{
		RygelDatabaseCursorIterator* _statement_it = NULL;
		RygelDatabaseCursor* _tmp30_;
		RygelDatabaseCursorIterator* _tmp31_;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp30_ = cursor;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp31_ = rygel_database_cursor_iterator (_tmp30_);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_statement_it = _tmp31_;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		while (TRUE) {
#line 2959 "rygel-media-export-media-cache.c"
			gboolean _tmp32_ = FALSE;
			RygelDatabaseCursorIterator* _tmp33_;
			sqlite3_stmt* statement = NULL;
			RygelDatabaseCursorIterator* _tmp34_;
			sqlite3_stmt* _tmp35_;
			const gchar* parent_id = NULL;
			sqlite3_stmt* _tmp36_;
			const gchar* _tmp37_;
			gboolean _tmp38_ = FALSE;
			RygelMediaContainer* _tmp39_;
			RygelMediaContainer* _tmp48_;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp33_ = _statement_it;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp32_ = rygel_database_cursor_iterator_next (_tmp33_, &_inner_error0_);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_propagate_error (error, _inner_error0_);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (cursor);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sort_order);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (parent);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (children);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return NULL;
#line 2993 "rygel-media-export-media-cache.c"
			}
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (!_tmp32_) {
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 2999 "rygel-media-export-media-cache.c"
			}
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp34_ = _statement_it;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp35_ = rygel_database_cursor_iterator_get (_tmp34_, &_inner_error0_);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			statement = _tmp35_;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_propagate_error (error, _inner_error0_);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (cursor);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sort_order);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (parent);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (children);
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return NULL;
#line 3025 "rygel-media-export-media-cache.c"
			}
#line 386 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp36_ = statement;
#line 386 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp37_ = (const gchar*) sqlite3_column_text (_tmp36_, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_PARENT);
#line 386 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			parent_id = _tmp37_;
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp39_ = parent;
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_tmp39_ == NULL) {
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp38_ = TRUE;
#line 3039 "rygel-media-export-media-cache.c"
			} else {
				const gchar* _tmp40_;
				RygelMediaContainer* _tmp41_;
				const gchar* _tmp42_;
				const gchar* _tmp43_;
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp40_ = parent_id;
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp41_ = parent;
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp42_ = rygel_media_object_get_id ((RygelMediaObject*) _tmp41_);
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp43_ = _tmp42_;
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp38_ = g_strcmp0 (_tmp40_, _tmp43_) != 0;
#line 3055 "rygel-media-export-media-cache.c"
			}
#line 388 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_tmp38_) {
#line 3059 "rygel-media-export-media-cache.c"
				const gchar* _tmp44_;
#line 389 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp44_ = parent_id;
#line 389 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_tmp44_ == NULL) {
#line 3065 "rygel-media-export-media-cache.c"
					RygelNullContainer* _tmp45_;
#line 390 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp45_ = rygel_null_container_new_root ();
#line 390 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (parent);
#line 390 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					parent = (RygelMediaContainer*) _tmp45_;
#line 3073 "rygel-media-export-media-cache.c"
				} else {
					const gchar* _tmp46_;
					RygelNullContainer* _tmp47_;
#line 392 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp46_ = parent_id;
#line 392 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp47_ = rygel_null_container_new (_tmp46_, NULL, "MediaExport");
#line 392 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (parent);
#line 392 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					parent = (RygelMediaContainer*) _tmp47_;
#line 3085 "rygel-media-export-media-cache.c"
				}
			}
#line 396 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp48_ = parent;
#line 396 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_tmp48_ != NULL) {
#line 3092 "rygel-media-export-media-cache.c"
				RygelMediaObjects* _tmp49_;
				RygelMediaContainer* _tmp50_;
				sqlite3_stmt* _tmp51_;
				RygelMediaObject* _tmp52_;
				RygelMediaObject* _tmp53_;
				RygelMediaObjects* _tmp54_;
				gpointer _tmp55_;
				RygelMediaObject* _tmp56_;
				RygelMediaContainer* _tmp57_;
#line 397 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp49_ = children;
#line 397 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp50_ = parent;
#line 397 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp51_ = statement;
#line 397 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp52_ = rygel_media_export_media_cache_get_object_from_statement (self, _tmp50_, _tmp51_);
#line 397 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp53_ = _tmp52_;
#line 397 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp53_);
#line 397 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (_tmp53_);
#line 399 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp54_ = children;
#line 399 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp55_ = gee_list_last ((GeeList*) _tmp54_);
#line 399 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp56_ = (RygelMediaObject*) _tmp55_;
#line 399 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp57_ = parent;
#line 399 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				rygel_media_object_set_parent_ref (_tmp56_, _tmp57_);
#line 399 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (_tmp56_);
#line 3128 "rygel-media-export-media-cache.c"
			} else {
				sqlite3_stmt* _tmp58_;
				const gchar* _tmp59_;
				const gchar* _tmp60_;
#line 401 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp58_ = statement;
#line 401 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp59_ = (const gchar*) sqlite3_column_text (_tmp58_, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_ID);
#line 401 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp60_ = parent_id;
#line 401 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_warning (_ ("Inconsistent database: item %s does not have parent %s"), _tmp59_, _tmp60_);
#line 3141 "rygel-media-export-media-cache.c"
			}
		}
#line 385 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 3146 "rygel-media-export-media-cache.c"
	}
#line 407 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = children;
#line 407 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (cursor);
#line 407 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (sort_order);
#line 407 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (parent);
#line 407 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 407 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 3160 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_debug_statistics (RygelMediaExportMediaCache* self)
{
	GError* _inner_error0_ = NULL;
#line 410 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 3169 "rygel-media-export-media-cache.c"
	{
		RygelDatabaseCursor* cursor = NULL;
		RygelDatabaseCursor* _tmp0_;
#line 412 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_debug ("rygel-media-export-media-cache.vala:412: Database statistics:");
#line 413 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = rygel_media_export_media_cache_exec_cursor (self, RYGEL_MEDIA_EXPORT_SQL_STRING_STATISTICS, NULL, (gint) 0, &_inner_error0_);
#line 413 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		cursor = _tmp0_;
#line 413 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3181 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
		{
			RygelDatabaseCursorIterator* _statement_it = NULL;
			RygelDatabaseCursor* _tmp1_;
			RygelDatabaseCursorIterator* _tmp2_;
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp1_ = cursor;
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp2_ = rygel_database_cursor_iterator (_tmp1_);
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_statement_it = _tmp2_;
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			while (TRUE) {
#line 3196 "rygel-media-export-media-cache.c"
				gboolean _tmp3_ = FALSE;
				RygelDatabaseCursorIterator* _tmp4_;
				sqlite3_stmt* statement = NULL;
				RygelDatabaseCursorIterator* _tmp5_;
				sqlite3_stmt* _tmp6_;
				sqlite3_stmt* _tmp7_;
				const gchar* _tmp8_;
				sqlite3_stmt* _tmp9_;
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp4_ = _statement_it;
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp3_ = rygel_database_cursor_iterator_next (_tmp4_, &_inner_error0_);
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 3215 "rygel-media-export-media-cache.c"
					goto __catch0_g_error;
				}
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (!_tmp3_) {
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					break;
#line 3222 "rygel-media-export-media-cache.c"
				}
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp5_ = _statement_it;
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp6_ = rygel_database_cursor_iterator_get (_tmp5_, &_inner_error0_);
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				statement = _tmp6_;
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 3236 "rygel-media-export-media-cache.c"
					goto __catch0_g_error;
				}
#line 415 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp7_ = statement;
#line 415 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp8_ = (const gchar*) sqlite3_column_text (_tmp7_, 0);
#line 415 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp9_ = statement;
#line 415 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_debug ("rygel-media-export-media-cache.vala:415: %s: %d", _tmp8_, sqlite3_column_int (_tmp9_, 1));
#line 3247 "rygel-media-export-media-cache.c"
			}
#line 414 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 3251 "rygel-media-export-media-cache.c"
		}
#line 411 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (cursor);
#line 3255 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 411 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 411 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 420 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp10_ = _error_;
#line 420 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp11_ = _tmp10_->message;
#line 420 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_debug ("rygel-media-export-media-cache.vala:420: Failed to get database statis" \
"tics: %s", _tmp11_);
#line 411 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 3275 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 411 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 411 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 411 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 3286 "rygel-media-export-media-cache.c"
	}
}

GeeArrayList*
rygel_media_export_media_cache_get_child_ids (RygelMediaExportMediaCache* self,
                                              const gchar* container_id,
                                              GError** error)
{
	GeeArrayList* children = NULL;
	GeeArrayList* _tmp0_;
	GValue* values = NULL;
	GValue _tmp1_ = {0};
	GValue* _tmp2_;
	gint values_length1;
	gint _values_size_;
	RygelDatabaseCursor* cursor = NULL;
	GValue* _tmp3_;
	gint _tmp3__length1;
	RygelDatabaseCursor* _tmp4_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 424 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 424 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (container_id != NULL, NULL);
#line 426 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 426 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	children = _tmp0_;
#line 427 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp1_, G_TYPE_STRING);
#line 427 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp1_, container_id);
#line 427 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = g_new0 (GValue, 1);
#line 427 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_[0] = _tmp1_;
#line 427 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp2_;
#line 427 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 1;
#line 427 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = values;
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3__length1 = values_length1;
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = rygel_media_export_media_cache_exec_cursor (self, RYGEL_MEDIA_EXPORT_SQL_STRING_CHILD_IDS, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	cursor = _tmp4_;
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (children);
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 3350 "rygel-media-export-media-cache.c"
		} else {
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (children);
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 429 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 3362 "rygel-media-export-media-cache.c"
		}
	}
	{
		RygelDatabaseCursorIterator* _statement_it = NULL;
		RygelDatabaseCursor* _tmp5_;
		RygelDatabaseCursorIterator* _tmp6_;
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = cursor;
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = rygel_database_cursor_iterator (_tmp5_);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_statement_it = _tmp6_;
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		while (TRUE) {
#line 3377 "rygel-media-export-media-cache.c"
			gboolean _tmp7_ = FALSE;
			RygelDatabaseCursorIterator* _tmp8_;
			sqlite3_stmt* statement = NULL;
			RygelDatabaseCursorIterator* _tmp9_;
			sqlite3_stmt* _tmp10_;
			GeeArrayList* _tmp11_;
			sqlite3_stmt* _tmp12_;
			const gchar* _tmp13_;
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp8_ = _statement_it;
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp7_ = rygel_database_cursor_iterator_next (_tmp8_, &_inner_error0_);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_propagate_error (error, _inner_error0_);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (children);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 3406 "rygel-media-export-media-cache.c"
				} else {
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (children);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_clear_error (&_inner_error0_);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 3422 "rygel-media-export-media-cache.c"
				}
			}
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (!_tmp7_) {
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 3429 "rygel-media-export-media-cache.c"
			}
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp9_ = _statement_it;
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp10_ = rygel_database_cursor_iterator_get (_tmp9_, &_inner_error0_);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			statement = _tmp10_;
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_propagate_error (error, _inner_error0_);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (children);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 3453 "rygel-media-export-media-cache.c"
				} else {
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (children);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_clear_error (&_inner_error0_);
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 3469 "rygel-media-export-media-cache.c"
				}
			}
#line 431 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp11_ = children;
#line 431 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp12_ = statement;
#line 431 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp13_ = (const gchar*) sqlite3_column_text (_tmp12_, 0);
#line 431 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp13_);
#line 3480 "rygel-media-export-media-cache.c"
		}
#line 430 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 3484 "rygel-media-export-media-cache.c"
	}
#line 434 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = children;
#line 434 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (cursor);
#line 434 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 434 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 3494 "rygel-media-export-media-cache.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 3516 "rygel-media-export-media-cache.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 3520 "rygel-media-export-media-cache.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 3526 "rygel-media-export-media-cache.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 3530 "rygel-media-export-media-cache.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3534 "rygel-media-export-media-cache.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 3542 "rygel-media-export-media-cache.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3570 "rygel-media-export-media-cache.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 3579 "rygel-media-export-media-cache.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3593 "rygel-media-export-media-cache.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 3602 "rygel-media-export-media-cache.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 3616 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 3625 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 3634 "rygel-media-export-media-cache.c"
}

GeeList*
rygel_media_export_media_cache_get_meta_data_column_by_filter (RygelMediaExportMediaCache* self,
                                                               const gchar* column,
                                                               const gchar* filter,
                                                               GArray* args,
                                                               glong offset,
                                                               const gchar* sort_criteria,
                                                               glong max_count,
                                                               gboolean add_all_container,
                                                               GError** error)
{
	GValue v = {0};
	GValue _tmp0_ = {0};
	GValue _tmp1_;
	GValue _tmp2_;
	GValue _tmp3_ = {0};
	GValue _tmp4_ = {0};
	GValue _tmp5_;
	GValue _tmp6_;
	GValue _tmp7_ = {0};
	gchar* extra_columns = NULL;
	gint column_count = 0;
	GString* builder = NULL;
	GString* _tmp8_;
	GeeArrayList* data = NULL;
	GeeArrayList* _tmp9_;
	gchar* sql_sort_order = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GString* _tmp22_;
	RygelMediaExportSQLFactory* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	RygelDatabaseCursor* cursor = NULL;
	RygelDatabaseDatabase* _tmp27_;
	GString* _tmp28_;
	const gchar* _tmp29_;
	gpointer* _tmp30_;
	gint _tmp30__length1;
	RygelDatabaseCursor* _tmp31_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 437 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 437 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (column != NULL, NULL);
#line 437 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (filter != NULL, NULL);
#line 437 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 437 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (sort_criteria != NULL, NULL);
#line 446 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp0_, G_TYPE_LONG);
#line 446 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_long (&_tmp0_, offset);
#line 446 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	v = _tmp0_;
#line 447 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = v;
#line 447 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = _tmp1_;
#line 447 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_IS_VALUE (&_tmp2_)) {
#line 447 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp3_, G_VALUE_TYPE (&_tmp2_));
#line 447 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_copy (&_tmp2_, &_tmp3_);
#line 3711 "rygel-media-export-media-cache.c"
	} else {
#line 447 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = _tmp2_;
#line 3715 "rygel-media-export-media-cache.c"
	}
#line 447 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_array_append_val (args, _tmp3_);
#line 448 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp4_, G_TYPE_LONG);
#line 448 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_long (&_tmp4_, max_count);
#line 448 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 448 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	v = _tmp4_;
#line 449 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = v;
#line 449 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = _tmp5_;
#line 449 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_IS_VALUE (&_tmp6_)) {
#line 449 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp7_, G_VALUE_TYPE (&_tmp6_));
#line 449 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_copy (&_tmp6_, &_tmp7_);
#line 3737 "rygel-media-export-media-cache.c"
	} else {
#line 449 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = _tmp6_;
#line 3741 "rygel-media-export-media-cache.c"
	}
#line 449 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_array_append_val (args, _tmp7_);
#line 453 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp8_ = g_string_new ("");
#line 453 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	builder = _tmp8_;
#line 454 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 454 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	data = _tmp9_;
#line 456 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp12_ = rygel_media_export_media_cache_translate_sort_criteria (sort_criteria, &_tmp10_, &_tmp11_);
#line 456 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (extra_columns);
#line 456 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	extra_columns = _tmp10_;
#line 456 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	column_count = _tmp11_;
#line 456 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	sql_sort_order = _tmp12_;
#line 463 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp13_ = sql_sort_order;
#line 463 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp14_ = string_replace (_tmp13_, "o.title", "_column");
#line 463 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (sql_sort_order);
#line 463 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	sql_sort_order = _tmp14_;
#line 464 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp15_ = extra_columns;
#line 464 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp16_ = string_replace (_tmp15_, "o.title", "1");
#line 464 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (extra_columns);
#line 464 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	extra_columns = _tmp16_;
#line 466 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (add_all_container) {
#line 3781 "rygel-media-export-media-cache.c"
		GString* _tmp17_;
		GString* _tmp21_;
#line 467 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp17_ = builder;
#line 467 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_string_append (_tmp17_, "SELECT 'all_place_holder' AS _column ");
#line 3788 "rygel-media-export-media-cache.c"
		{
			gint i = 0;
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			i = 0;
#line 3793 "rygel-media-export-media-cache.c"
			{
				gboolean _tmp18_ = FALSE;
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp18_ = TRUE;
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				while (TRUE) {
#line 3800 "rygel-media-export-media-cache.c"
					GString* _tmp20_;
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					if (!_tmp18_) {
#line 3804 "rygel-media-export-media-cache.c"
						gint _tmp19_;
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
						_tmp19_ = i;
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
						i = _tmp19_ + 1;
#line 3810 "rygel-media-export-media-cache.c"
					}
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp18_ = FALSE;
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					if (!(i < column_count)) {
#line 468 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
						break;
#line 3818 "rygel-media-export-media-cache.c"
					}
#line 469 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp20_ = builder;
#line 469 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_string_append (_tmp20_, ", 1 ");
#line 3824 "rygel-media-export-media-cache.c"
				}
			}
		}
#line 471 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp21_ = builder;
#line 471 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_string_append (_tmp21_, "UNION ");
#line 3832 "rygel-media-export-media-cache.c"
	}
#line 475 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp22_ = builder;
#line 475 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp23_ = self->priv->sql;
#line 475 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_ = rygel_media_export_sql_factory_make (_tmp23_, RYGEL_MEDIA_EXPORT_SQL_STRING_GET_META_DATA_COLUMN);
#line 475 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_ = extra_columns;
#line 475 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp26_ = sql_sort_order;
#line 475 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_string_append_printf (_tmp22_, _tmp24_, column, _tmp25_, filter, _tmp26_);
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp27_ = self->priv->db;
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp28_ = builder;
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp29_ = _tmp28_->str;
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp30_ = args->data;
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp30__length1 = args->len;
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp31_ = rygel_database_database_exec_cursor (_tmp27_, _tmp29_, _tmp30_, (gint) _tmp30__length1, &_inner_error0_);
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	cursor = _tmp31_;
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (sql_sort_order);
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (data);
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_string_free0 (builder);
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (extra_columns);
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 481 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 3876 "rygel-media-export-media-cache.c"
	}
	{
		RygelDatabaseCursorIterator* _statement_it = NULL;
		RygelDatabaseCursor* _tmp32_;
		RygelDatabaseCursorIterator* _tmp33_;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp32_ = cursor;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp33_ = rygel_database_cursor_iterator (_tmp32_);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_statement_it = _tmp33_;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		while (TRUE) {
#line 3890 "rygel-media-export-media-cache.c"
			gboolean _tmp34_ = FALSE;
			RygelDatabaseCursorIterator* _tmp35_;
			sqlite3_stmt* statement = NULL;
			RygelDatabaseCursorIterator* _tmp36_;
			sqlite3_stmt* _tmp37_;
			GeeArrayList* _tmp38_;
			sqlite3_stmt* _tmp39_;
			const gchar* _tmp40_;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp35_ = _statement_it;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp34_ = rygel_database_cursor_iterator_next (_tmp35_, &_inner_error0_);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_propagate_error (error, _inner_error0_);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (cursor);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sql_sort_order);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (data);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_string_free0 (builder);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (extra_columns);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return NULL;
#line 3923 "rygel-media-export-media-cache.c"
			}
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (!_tmp34_) {
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 3929 "rygel-media-export-media-cache.c"
			}
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp36_ = _statement_it;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp37_ = rygel_database_cursor_iterator_get (_tmp36_, &_inner_error0_);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			statement = _tmp37_;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_propagate_error (error, _inner_error0_);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (cursor);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sql_sort_order);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (data);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_string_free0 (builder);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (extra_columns);
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return NULL;
#line 3957 "rygel-media-export-media-cache.c"
			}
#line 483 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp38_ = data;
#line 483 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp39_ = statement;
#line 483 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp40_ = (const gchar*) sqlite3_column_text (_tmp39_, 0);
#line 483 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp40_);
#line 3967 "rygel-media-export-media-cache.c"
		}
#line 482 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 3971 "rygel-media-export-media-cache.c"
	}
#line 486 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = (GeeList*) data;
#line 486 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (cursor);
#line 486 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (sql_sort_order);
#line 486 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_string_free0 (builder);
#line 486 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (extra_columns);
#line 486 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 486 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 3987 "rygel-media-export-media-cache.c"
}

/**
     * TODO
     */
GeeList*
rygel_media_export_media_cache_get_object_attribute_by_search_expression (RygelMediaExportMediaCache* self,
                                                                          const gchar* attribute,
                                                                          RygelSearchExpression* expression,
                                                                          const gchar* sort_criteria,
                                                                          glong offset,
                                                                          guint max_count,
                                                                          gboolean add_all_container,
                                                                          GError** error)
{
	GArray* args = NULL;
	GArray* _tmp0_;
	gchar* filter = NULL;
	GArray* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* column = NULL;
	gchar* _tmp4_;
	guint max_objects = 0U;
	GeeList* _tmp5_ = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GArray* _tmp8_;
	GeeList* _tmp9_;
	GeeList* _tmp10_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 492 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 492 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (attribute != NULL, NULL);
#line 492 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (sort_criteria != NULL, NULL);
#line 500 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (GValue));
#line 500 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) g_value_unset);
#line 500 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	args = _tmp0_;
#line 501 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = args;
#line 501 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = rygel_media_export_media_cache_translate_search_expression (expression, _tmp1_, "AND", &_inner_error0_);
#line 501 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	filter = _tmp2_;
#line 501 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 501 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 501 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_array_unref0 (args);
#line 501 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 4046 "rygel-media-export-media-cache.c"
	}
#line 505 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = filter;
#line 505 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_debug ("rygel-media-export-media-cache.vala:505: Parsed filter: %s", _tmp3_);
#line 507 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = rygel_media_export_media_cache_map_operand_to_column (attribute, NULL, FALSE, &_inner_error0_);
#line 507 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	column = _tmp4_;
#line 507 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 507 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 507 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (filter);
#line 507 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_array_unref0 (args);
#line 507 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 4066 "rygel-media-export-media-cache.c"
	}
#line 508 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	max_objects = rygel_media_export_media_cache_modify_limit (self, max_count);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = column;
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp7_ = filter;
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp8_ = args;
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = rygel_media_export_media_cache_get_meta_data_column_by_filter (self, _tmp6_, _tmp7_, _tmp8_, offset, sort_criteria, (glong) max_objects, add_all_container, &_inner_error0_);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = _tmp9_;
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (column);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (filter);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_array_unref0 (args);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 4092 "rygel-media-export-media-cache.c"
	}
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp10_ = _tmp5_;
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = NULL;
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp10_;
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (_tmp5_);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (column);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (filter);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_array_unref0 (args);
#line 510 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 4110 "rygel-media-export-media-cache.c"
}

gchar*
rygel_media_export_media_cache_get_reset_token (RygelMediaExportMediaCache* self)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 519 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4120 "rygel-media-export-media-cache.c"
	{
		RygelDatabaseCursor* cursor = NULL;
		RygelDatabaseCursor* _tmp0_;
		sqlite3_stmt* statement = NULL;
		RygelDatabaseCursor* _tmp1_;
		sqlite3_stmt* _tmp2_;
		sqlite3_stmt* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 521 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = rygel_media_export_media_cache_exec_cursor (self, RYGEL_MEDIA_EXPORT_SQL_STRING_RESET_TOKEN, NULL, (gint) 0, &_inner_error0_);
#line 521 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		cursor = _tmp0_;
#line 521 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 521 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 4138 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 521 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 521 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 521 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 4147 "rygel-media-export-media-cache.c"
		}
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = cursor;
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = rygel_database_cursor_next (_tmp1_, &_inner_error0_);
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		statement = _tmp2_;
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (cursor);
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 4161 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 522 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 4170 "rygel-media-export-media-cache.c"
		}
#line 524 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = statement;
#line 524 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 524 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 524 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = _tmp5_;
#line 524 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (cursor);
#line 524 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 4184 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		gchar* _tmp6_;
#line 520 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 526 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning ("rygel-media-export-media-cache.vala:526: %s", _ ("Failed to get reset token"));
#line 528 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = g_uuid_string_random ();
#line 528 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = _tmp6_;
#line 528 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 4200 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 520 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 520 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_clear_error (&_inner_error0_);
#line 520 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return NULL;
#line 4209 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_save_reset_token (RygelMediaExportMediaCache* self,
                                                 const gchar* token)
{
	GError* _inner_error0_ = NULL;
#line 532 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (token != NULL);
#line 4221 "rygel-media-export-media-cache.c"
	{
		GValue* args = NULL;
		GValue _tmp0_ = {0};
		GValue* _tmp1_;
		gint args_length1;
		gint _args_size_;
		RygelDatabaseDatabase* _tmp2_;
#line 534 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp0_, G_TYPE_STRING);
#line 534 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_string (&_tmp0_, token);
#line 534 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = g_new0 (GValue, 1);
#line 534 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_[0] = _tmp0_;
#line 534 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		args = _tmp1_;
#line 534 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		args_length1 = 1;
#line 534 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_args_size_ = args_length1;
#line 536 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = self->priv->db;
#line 536 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp2_, "UPDATE schema_info SET reset_token = ?", args, (gint) args_length1, &_inner_error0_);
#line 536 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 536 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			args = (_vala_GValue_array_free (args, args_length1), NULL);
#line 536 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 4253 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 536 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 536 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 536 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 4262 "rygel-media-export-media-cache.c"
		}
#line 533 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		args = (_vala_GValue_array_free (args, args_length1), NULL);
#line 4266 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 533 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 533 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 538 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = _error_;
#line 538 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _tmp3_->message;
#line 538 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to persist ServiceResetToken: %s"), _tmp4_);
#line 533 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 4286 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 533 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 533 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 533 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 533 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 4297 "rygel-media-export-media-cache.c"
	}
}

void
rygel_media_export_media_cache_drop_virtual_folders (RygelMediaExportMediaCache* self)
{
	GError* _inner_error0_ = NULL;
#line 543 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 4307 "rygel-media-export-media-cache.c"
	{
		RygelDatabaseDatabase* _tmp0_;
#line 545 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = self->priv->db;
#line 545 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp0_, "DELETE FROM object WHERE " "upnp_id LIKE 'virtual-parent:%'", NULL, (gint) 0, &_inner_error0_);
#line 545 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 545 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 4318 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 545 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 545 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 545 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 4327 "rygel-media-export-media-cache.c"
		}
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 544 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 544 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 548 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = _error_;
#line 548 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = _tmp1_->message;
#line 548 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to remove virtual folders: %s"), _tmp2_);
#line 544 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 4348 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 544 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 544 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 544 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 544 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 4359 "rygel-media-export-media-cache.c"
	}
}

void
rygel_media_export_media_cache_make_object_guarded (RygelMediaExportMediaCache* self,
                                                    RygelMediaObject* object,
                                                    gboolean guarded)
{
	gint _tmp0_ = 0;
	gint guarded_val = 0;
	GError* _inner_error0_ = NULL;
#line 552 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 552 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (object != NULL);
#line 554 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (guarded) {
#line 554 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = 1;
#line 4379 "rygel-media-export-media-cache.c"
	} else {
#line 554 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = 0;
#line 4383 "rygel-media-export-media-cache.c"
	}
#line 554 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	guarded_val = _tmp0_;
#line 4387 "rygel-media-export-media-cache.c"
	{
		GValue* values = NULL;
		GValue _tmp1_ = {0};
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		GValue _tmp4_ = {0};
		GValue* _tmp5_;
		gint values_length1;
		gint _values_size_;
		RygelDatabaseDatabase* _tmp6_;
		RygelMediaExportSQLFactory* _tmp7_;
		const gchar* _tmp8_;
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp1_, G_TYPE_INT);
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int (&_tmp1_, guarded_val);
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = rygel_media_object_get_id (object);
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = _tmp2_;
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp4_, G_TYPE_STRING);
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_string (&_tmp4_, _tmp3_);
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = g_new0 (GValue, 2);
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_[0] = _tmp1_;
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_[1] = _tmp4_;
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = _tmp5_;
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values_length1 = 2;
#line 557 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_values_size_ = values_length1;
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = self->priv->db;
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = self->priv->sql;
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = rygel_media_export_sql_factory_make (_tmp7_, RYGEL_MEDIA_EXPORT_SQL_STRING_MAKE_GUARDED);
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp6_, _tmp8_, values, (gint) values_length1, &_inner_error0_);
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 4438 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 560 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 4447 "rygel-media-export-media-cache.c"
		}
#line 556 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 4451 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 556 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 556 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 562 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp9_ = rygel_media_object_get_id (object);
#line 562 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp10_ = _tmp9_;
#line 562 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp11_ = _error_;
#line 562 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp12_ = _tmp11_->message;
#line 562 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to mark item %s as guarded (%d): %s"), _tmp10_, guarded_val, _tmp12_);
#line 556 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 4477 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 556 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 556 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 556 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 556 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 4488 "rygel-media-export-media-cache.c"
	}
}

gchar*
rygel_media_export_media_cache_create_reference (RygelMediaExportMediaCache* self,
                                                 RygelMediaObject* object,
                                                 RygelMediaContainer* parent,
                                                 GError** error)
{
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 569 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 569 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 569 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 571 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (object, RYGEL_TYPE_MEDIA_CONTAINER)) {
#line 4515 "rygel-media-export-media-cache.c"
		gchar* msg = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		GError* _tmp2_;
#line 572 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = g_strdup (_ ("Cannot create references to containers"));
#line 572 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		msg = _tmp0_;
#line 574 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = msg;
#line 574 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = g_error_new_literal (RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR, RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_GENERAL_ERROR, _tmp1_);
#line 574 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = _tmp2_;
#line 574 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 574 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (msg);
#line 574 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 4536 "rygel-media-export-media-cache.c"
	}
#line 577 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_object_set_parent (object, parent);
#line 581 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = rygel_media_object_get_ref_id (object);
#line 581 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = _tmp3_;
#line 581 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp4_ == NULL) {
#line 4546 "rygel-media-export-media-cache.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 582 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = rygel_media_object_get_id (object);
#line 582 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = _tmp5_;
#line 582 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_object_set_ref_id (object, _tmp6_);
#line 4555 "rygel-media-export-media-cache.c"
	}
#line 584 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp7_ = g_uuid_string_random ();
#line 584 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp8_ = _tmp7_;
#line 584 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_object_set_id (object, _tmp8_);
#line 584 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (_tmp8_);
#line 586 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_export_media_cache_save_item (self, G_TYPE_CHECK_INSTANCE_TYPE (object, RYGEL_TYPE_MEDIA_FILE_ITEM) ? ((RygelMediaFileItem*) object) : NULL, FALSE, &_inner_error0_);
#line 586 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 586 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 586 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 4573 "rygel-media-export-media-cache.c"
	}
#line 588 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = rygel_media_object_get_id (object);
#line 588 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp10_ = _tmp9_;
#line 588 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 588 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp11_;
#line 588 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 4585 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_ignore (RygelMediaExportMediaCache* self,
                                       GFile* file)
{
	GError* _inner_error0_ = NULL;
#line 591 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 591 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (file != NULL);
#line 4597 "rygel-media-export-media-cache.c"
	{
		GValue* values = NULL;
		gchar* _tmp0_;
		GValue _tmp1_ = {0};
		GDateTime* _tmp2_;
		GDateTime* _tmp3_;
		GValue _tmp4_ = {0};
		GValue* _tmp5_;
		GValue* _tmp6_;
		gint _tmp6__length1;
		gint values_length1;
		gint _values_size_;
		RygelDatabaseDatabase* _tmp7_;
		RygelMediaExportSQLFactory* _tmp8_;
		const gchar* _tmp9_;
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = g_file_get_uri (file);
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp1_, G_TYPE_STRING);
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_take_string (&_tmp1_, _tmp0_);
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = g_date_time_new_now_utc ();
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = _tmp2_;
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp4_, G_TYPE_INT64);
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int64 (&_tmp4_, g_date_time_to_unix (_tmp3_));
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = g_new0 (GValue, 2);
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_[0] = _tmp1_;
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_[1] = _tmp4_;
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = _tmp5_;
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6__length1 = 2;
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_date_time_unref0 (_tmp3_);
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = _tmp6_;
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values_length1 = _tmp6__length1;
#line 593 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_values_size_ = values_length1;
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = self->priv->db;
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = self->priv->sql;
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp9_ = rygel_media_export_sql_factory_make (_tmp8_, RYGEL_MEDIA_EXPORT_SQL_STRING_ADD_TO_IGNORELIST);
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp7_, _tmp9_, values, (gint) values_length1, &_inner_error0_);
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 4659 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 595 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 4668 "rygel-media-export-media-cache.c"
		}
#line 592 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 4672 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 592 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 592 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 598 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp10_ = g_file_get_uri (file);
#line 598 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp11_ = _tmp10_;
#line 598 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp12_ = _error_;
#line 598 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp13_ = _tmp12_->message;
#line 598 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to add %s to ignored files: %s"), _tmp11_, _tmp13_);
#line 598 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_tmp11_);
#line 592 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 4700 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 592 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 592 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 592 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 592 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 4711 "rygel-media-export-media-cache.c"
	}
}

gboolean
rygel_media_export_media_cache_is_ignored (RygelMediaExportMediaCache* self,
                                           GFile* file)
{
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 604 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 604 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 4726 "rygel-media-export-media-cache.c"
	{
		GValue* values = NULL;
		gchar* _tmp0_;
		GValue _tmp1_ = {0};
		GValue* _tmp2_;
		gint values_length1;
		gint _values_size_;
		gint _tmp3_ = 0;
#line 606 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = g_file_get_uri (file);
#line 606 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp1_, G_TYPE_STRING);
#line 606 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_take_string (&_tmp1_, _tmp0_);
#line 606 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = g_new0 (GValue, 1);
#line 606 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_[0] = _tmp1_;
#line 606 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = _tmp2_;
#line 606 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values_length1 = 1;
#line 606 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_values_size_ = values_length1;
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = rygel_media_export_media_cache_query_value (self, RYGEL_MEDIA_EXPORT_SQL_STRING_CHECK_IGNORELIST, values, (gint) values_length1, &_inner_error0_);
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4755 "rygel-media-export-media-cache.c"
			gboolean _tmp4_ = FALSE;
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 4761 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp4_;
#line 4770 "rygel-media-export-media-cache.c"
		}
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = _tmp3_ == 1;
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 608 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 4778 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 605 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 605 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 611 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = g_file_get_uri (file);
#line 611 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = _tmp5_;
#line 611 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = _error_;
#line 611 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = _tmp7_->message;
#line 611 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to get whether URI %s is ignored: %s"), _tmp6_, _tmp8_);
#line 611 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_tmp6_);
#line 615 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = FALSE;
#line 615 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 615 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 4810 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 605 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 605 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_clear_error (&_inner_error0_);
#line 605 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return _tmp9_;
#line 4819 "rygel-media-export-media-cache.c"
}

static gboolean
rygel_media_export_media_cache_is_object_guarded (RygelMediaExportMediaCache* self,
                                                  const gchar* id)
{
	gboolean _tmp6_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 620 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 620 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 4833 "rygel-media-export-media-cache.c"
	{
		GValue* id_value = NULL;
		GValue _tmp0_ = {0};
		GValue* _tmp1_;
		gint id_value_length1;
		gint _id_value_size_;
		gint _tmp2_ = 0;
#line 622 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp0_, G_TYPE_STRING);
#line 622 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_string (&_tmp0_, id);
#line 622 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = g_new0 (GValue, 1);
#line 622 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_[0] = _tmp0_;
#line 622 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		id_value = _tmp1_;
#line 622 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		id_value_length1 = 1;
#line 622 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_id_value_size_ = id_value_length1;
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = rygel_media_export_media_cache_query_value (self, RYGEL_MEDIA_EXPORT_SQL_STRING_IS_GUARDED, id_value, (gint) id_value_length1, &_inner_error0_);
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4859 "rygel-media-export-media-cache.c"
			gboolean _tmp3_ = FALSE;
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			id_value = (_vala_GValue_array_free (id_value, id_value_length1), NULL);
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 4865 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp3_;
#line 4874 "rygel-media-export-media-cache.c"
		}
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = _tmp2_ == 1;
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		id_value = (_vala_GValue_array_free (id_value, id_value_length1), NULL);
#line 624 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 4882 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
		GError* _error_ = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 621 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_error_ = _inner_error0_;
#line 621 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 627 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _error_;
#line 627 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = _tmp4_->message;
#line 627 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to get whether item %s is guarded: %s"), id, _tmp5_);
#line 631 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = FALSE;
#line 631 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (_error_);
#line 631 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 4906 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 621 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 621 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_clear_error (&_inner_error0_);
#line 621 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return _tmp6_;
#line 4915 "rygel-media-export-media-cache.c"
}

void
rygel_media_export_media_cache_rebuild_exists_cache (RygelMediaExportMediaCache* self,
                                                     GError** error)
{
	GeeHashMap* _tmp0_;
	RygelDatabaseCursor* cursor = NULL;
	RygelDatabaseCursor* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 635 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 636 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, RYGEL_MEDIA_EXPORT_TYPE_EXISTS_CACHE_ENTRY, (GBoxedCopyFunc) rygel_media_export_exists_cache_entry_dup, (GDestroyNotify) rygel_media_export_exists_cache_entry_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 636 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (self->priv->exists_cache);
#line 636 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	self->priv->exists_cache = _tmp0_;
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = rygel_media_export_media_cache_exec_cursor (self, RYGEL_MEDIA_EXPORT_SQL_STRING_EXISTS_CACHE, NULL, (gint) 0, &_inner_error0_);
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	cursor = _tmp1_;
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 4946 "rygel-media-export-media-cache.c"
		} else {
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 637 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 4954 "rygel-media-export-media-cache.c"
		}
	}
	{
		RygelDatabaseCursorIterator* _statement_it = NULL;
		RygelDatabaseCursor* _tmp2_;
		RygelDatabaseCursorIterator* _tmp3_;
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = cursor;
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = rygel_database_cursor_iterator (_tmp2_);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_statement_it = _tmp3_;
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		while (TRUE) {
#line 4969 "rygel-media-export-media-cache.c"
			gboolean _tmp4_ = FALSE;
			RygelDatabaseCursorIterator* _tmp5_;
			sqlite3_stmt* statement = NULL;
			RygelDatabaseCursorIterator* _tmp6_;
			sqlite3_stmt* _tmp7_;
			RygelMediaExportExistsCacheEntry entry = {0};
			sqlite3_stmt* _tmp8_;
			sqlite3_stmt* _tmp9_;
			sqlite3_stmt* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			GeeHashMap* _tmp13_;
			sqlite3_stmt* _tmp14_;
			const gchar* _tmp15_;
			RygelMediaExportExistsCacheEntry _tmp16_;
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp5_ = _statement_it;
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp4_ = rygel_database_cursor_iterator_next (_tmp5_, &_inner_error0_);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_propagate_error (error, _inner_error0_);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return;
#line 5001 "rygel-media-export-media-cache.c"
				} else {
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_clear_error (&_inner_error0_);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return;
#line 5013 "rygel-media-export-media-cache.c"
				}
			}
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (!_tmp4_) {
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 5020 "rygel-media-export-media-cache.c"
			}
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp6_ = _statement_it;
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp7_ = rygel_database_cursor_iterator_get (_tmp6_, &_inner_error0_);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			statement = _tmp7_;
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_propagate_error (error, _inner_error0_);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return;
#line 5040 "rygel-media-export-media-cache.c"
				} else {
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (cursor);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_clear_error (&_inner_error0_);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return;
#line 5052 "rygel-media-export-media-cache.c"
				}
			}
#line 639 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			memset (&entry, 0, sizeof (RygelMediaExportExistsCacheEntry));
#line 640 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp8_ = statement;
#line 640 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			entry.mtime = sqlite3_column_int64 (_tmp8_, 1);
#line 641 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp9_ = statement;
#line 641 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			entry.size = sqlite3_column_int64 (_tmp9_, 0);
#line 642 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp10_ = statement;
#line 642 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 2);
#line 642 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 642 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (entry.content_type);
#line 642 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			entry.content_type = _tmp12_;
#line 643 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp13_ = self->priv->exists_cache;
#line 643 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp14_ = statement;
#line 643 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp15_ = (const gchar*) sqlite3_column_text (_tmp14_, 3);
#line 643 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp16_ = entry;
#line 643 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp15_, &_tmp16_);
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_export_exists_cache_entry_destroy (&entry);
#line 5087 "rygel-media-export-media-cache.c"
		}
#line 638 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_rygel_database_cursor_iterator_unref0 (_statement_it);
#line 5091 "rygel-media-export-media-cache.c"
	}
#line 635 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (cursor);
#line 5095 "rygel-media-export-media-cache.c"
}

static guint
rygel_media_export_media_cache_modify_limit (RygelMediaExportMediaCache* self,
                                             guint max_count)
{
	guint result;
#line 647 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 648 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (max_count == ((guint) 0)) {
#line 649 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = (guint) -1;
#line 649 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 5111 "rygel-media-export-media-cache.c"
	} else {
#line 651 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = max_count;
#line 651 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 5117 "rygel-media-export-media-cache.c"
	}
}

static void
rygel_media_export_media_cache_open_db (RygelMediaExportMediaCache* self,
                                        const gchar* name,
                                        GError** error)
{
	RygelDatabaseDatabase* _tmp0_ = NULL;
	RygelDatabaseDatabase* _tmp1_;
	RygelDatabaseDatabase* _tmp2_;
	gint old_version = 0;
	gint current_version = 0;
	GError* _inner_error0_ = NULL;
#line 655 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 655 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (name != NULL);
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = rygel_database_database_new (name, RYGEL_DATABASE_FLAVOR_CACHE, RYGEL_DATABASE_FLAGS_READ_WRITE, &_inner_error0_);
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = _tmp1_;
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 5146 "rygel-media-export-media-cache.c"
	}
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = _tmp0_;
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = NULL;
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (self->priv->db);
#line 656 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	self->priv->db = _tmp2_;
#line 657 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	old_version = -1;
#line 658 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	current_version = atoi (RYGEL_MEDIA_EXPORT_SQL_FACTORY_SCHEMA_VERSION);
#line 5160 "rygel-media-export-media-cache.c"
	{
		RygelMediaExportMediaCacheUpgrader* upgrader = NULL;
		RygelDatabaseDatabase* _tmp3_;
		RygelMediaExportSQLFactory* _tmp4_;
		RygelMediaExportMediaCacheUpgrader* _tmp5_;
		gboolean _tmp6_ = FALSE;
		RygelMediaExportMediaCacheUpgrader* _tmp7_;
		gint _tmp8_ = 0;
		gboolean _tmp9_;
		RygelMediaExportMediaCacheUpgrader* _tmp13_;
#line 661 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = self->priv->db;
#line 661 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = self->priv->sql;
#line 661 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = rygel_media_export_media_cache_upgrader_new (_tmp3_, _tmp4_);
#line 661 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		upgrader = _tmp5_;
#line 662 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = upgrader;
#line 662 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp9_ = rygel_media_export_media_cache_upgrader_needs_upgrade (_tmp7_, &_tmp8_, &_inner_error0_);
#line 662 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		old_version = _tmp8_;
#line 662 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = _tmp9_;
#line 662 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 662 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_rygel_media_export_media_cache_upgrader_unref0 (upgrader);
#line 662 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 5193 "rygel-media-export-media-cache.c"
				goto __catch0_rygel_database_database_error;
			}
			goto __finally0;
		}
#line 662 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_tmp6_) {
#line 5200 "rygel-media-export-media-cache.c"
			RygelMediaExportMediaCacheUpgrader* _tmp10_;
#line 663 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp10_ = upgrader;
#line 663 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_export_media_cache_upgrader_upgrade (_tmp10_, old_version, &_inner_error0_);
#line 663 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_rygel_media_export_media_cache_upgrader_unref0 (upgrader);
#line 663 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 5212 "rygel-media-export-media-cache.c"
					goto __catch0_rygel_database_database_error;
				}
				goto __finally0;
			}
		} else {
#line 664 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (old_version == current_version) {
#line 5220 "rygel-media-export-media-cache.c"
				RygelMediaExportMediaCacheUpgrader* _tmp11_;
#line 665 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp11_ = upgrader;
#line 665 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				rygel_media_export_media_cache_upgrader_fix_schema (_tmp11_, &_inner_error0_);
#line 665 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 665 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_rygel_media_export_media_cache_upgrader_unref0 (upgrader);
#line 665 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 5232 "rygel-media-export-media-cache.c"
						goto __catch0_rygel_database_database_error;
					}
					goto __finally0;
				}
			} else {
				GError* _tmp12_;
#line 667 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_warning (_ ("The version “%d” of the detected database is newer than our supported " \
"version “%d”"), old_version, current_version);
#line 670 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (self->priv->db);
#line 670 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				self->priv->db = NULL;
#line 672 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp12_ = g_error_new_literal (RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR, RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_GENERAL_ERROR, "Database format" " not supported");
#line 672 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_inner_error0_ = _tmp12_;
#line 672 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_rygel_media_export_media_cache_upgrader_unref0 (upgrader);
#line 672 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 5253 "rygel-media-export-media-cache.c"
					goto __catch0_rygel_database_database_error;
				}
				goto __finally0;
			}
		}
#line 675 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp13_ = upgrader;
#line 675 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_upgrader_ensure_indices (_tmp13_);
#line 660 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_rygel_media_export_media_cache_upgrader_unref0 (upgrader);
#line 5265 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_rygel_database_database_error:
	{
#line 660 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 677 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_debug ("rygel-media-export-media-cache.vala:677: %s", "Could not find schema version;" " checking for empty database...");
#line 5274 "rygel-media-export-media-cache.c"
		{
			gboolean _tmp14_ = FALSE;
			RygelDatabaseDatabase* _tmp15_;
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp15_ = self->priv->db;
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp14_ = rygel_database_database_is_empty (_tmp15_, &_inner_error0_);
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 5286 "rygel-media-export-media-cache.c"
					goto __catch1_rygel_database_database_error;
				}
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (_tmp0_);
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_clear_error (&_inner_error0_);
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return;
#line 5297 "rygel-media-export-media-cache.c"
			}
#line 680 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_tmp14_) {
#line 681 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_debug ("rygel-media-export-media-cache.vala:681: Empty database, creating new " \
"schema version %s", RYGEL_MEDIA_EXPORT_SQL_FACTORY_SCHEMA_VERSION);
#line 683 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (!rygel_media_export_media_cache_create_schema (self)) {
#line 684 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (self->priv->db);
#line 684 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					self->priv->db = NULL;
#line 686 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_object_unref0 (_tmp0_);
#line 686 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return;
#line 5313 "rygel-media-export-media-cache.c"
				}
			} else {
#line 689 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_warning ("rygel-media-export-media-cache.vala:689: %s", _ ("Incompatible schema… cannot proceed"));
#line 690 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (self->priv->db);
#line 690 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				self->priv->db = NULL;
#line 692 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_object_unref0 (_tmp0_);
#line 692 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return;
#line 5326 "rygel-media-export-media-cache.c"
			}
		}
		goto __finally1;
		__catch1_rygel_database_database_error:
		{
			GError* _error_ = NULL;
			GError* _tmp16_;
			const gchar* _tmp17_;
			GError* _tmp18_;
#line 679 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_error_ = _inner_error0_;
#line 679 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_inner_error0_ = NULL;
#line 695 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp16_ = _error_;
#line 695 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp17_ = _tmp16_->message;
#line 695 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_warning (_ ("Invalid database, cannot query sqlite_master table: %s"), _tmp17_);
#line 697 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (self->priv->db);
#line 697 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			self->priv->db = NULL;
#line 699 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp18_ = g_error_new_literal (RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR, RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_GENERAL_ERROR, "Invalid database");
#line 699 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_inner_error0_ = _tmp18_;
#line 699 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_error_free0 (_error_);
#line 5356 "rygel-media-export-media-cache.c"
			goto __finally1;
		}
		__finally1:
#line 679 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5362 "rygel-media-export-media-cache.c"
			goto __finally0;
		}
	}
	__finally0:
#line 660 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 660 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 660 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (_tmp0_);
#line 660 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 5375 "rygel-media-export-media-cache.c"
	}
#line 655 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (_tmp0_);
#line 5379 "rygel-media-export-media-cache.c"
}

static void
rygel_media_export_media_cache_save_container_metadata (RygelMediaExportMediaCache* self,
                                                        RygelMediaContainer* container,
                                                        GError** error)
{
	GValue* values = NULL;
	GValue _tmp0_ = {0};
	GValue _tmp1_ = {0};
	GValue _tmp2_ = {0};
	GValue _tmp3_ = {0};
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GValue _tmp6_ = {0};
	GValue _tmp7_ = {0};
	GValue _tmp8_ = {0};
	GValue _tmp9_ = {0};
	GValue _tmp10_ = {0};
	GValue _tmp11_ = {0};
	GValue _tmp12_ = {0};
	GValue _tmp13_ = {0};
	GValue _tmp14_ = {0};
	GValue _tmp15_ = {0};
	GValue _tmp16_ = {0};
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GValue _tmp19_ = {0};
	GValue _tmp20_ = {0};
	GValue _tmp21_ = {0};
	GValue _tmp22_ = {0};
	GValue _tmp23_ = {0};
	GValue* _tmp24_;
	gint values_length1;
	gint _values_size_;
	RygelDatabaseDatabase* _tmp25_;
	RygelMediaExportSQLFactory* _tmp26_;
	const gchar* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 704 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 704 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (container != NULL);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp0_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp0_, 0);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp1_, G_TYPE_STRING);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp1_, "inode/directory");
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp2_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp2_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp3_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp3_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = rygel_media_object_get_upnp_class ((RygelMediaObject*) container);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = _tmp4_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp6_, G_TYPE_STRING);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp6_, _tmp5_);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp7_);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp8_);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp9_);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp10_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp10_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp11_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp11_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp12_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp12_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp13_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp13_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp14_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp14_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp15_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp15_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp16_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp16_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp17_ = rygel_media_object_get_id ((RygelMediaObject*) container);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp18_ = _tmp17_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp19_, G_TYPE_STRING);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp19_, _tmp18_);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp20_);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp21_);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp22_, G_TYPE_INT);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp22_, -1);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp23_);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_ = g_new0 (GValue, 20);
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[0] = _tmp0_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[1] = _tmp1_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[2] = _tmp2_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[3] = _tmp3_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[4] = _tmp6_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[5] = _tmp7_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[6] = _tmp8_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[7] = _tmp9_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[8] = _tmp10_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[9] = _tmp11_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[10] = _tmp12_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[11] = _tmp13_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[12] = _tmp14_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[13] = _tmp15_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[14] = _tmp16_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[15] = _tmp19_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[16] = _tmp20_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[17] = _tmp21_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[18] = _tmp22_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_[19] = _tmp23_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp24_;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 20;
#line 706 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 727 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_ = self->priv->db;
#line 727 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp26_ = self->priv->sql;
#line 727 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp27_ = rygel_media_export_sql_factory_make (_tmp26_, RYGEL_MEDIA_EXPORT_SQL_STRING_SAVE_METADATA);
#line 727 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_database_exec (_tmp25_, _tmp27_, values, (gint) values_length1, &_inner_error0_);
#line 727 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 727 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 727 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 727 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 5563 "rygel-media-export-media-cache.c"
	}
#line 704 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 5567 "rygel-media-export-media-cache.c"
}

static void
rygel_media_export_media_cache_save_item_metadata (RygelMediaExportMediaCache* self,
                                                   RygelMediaFileItem* item,
                                                   GError** error)
{
	GValue* values = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GValue _tmp2_ = {0};
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GValue _tmp5_ = {0};
	GValue _tmp6_ = {0};
	GValue _tmp7_ = {0};
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GValue _tmp10_ = {0};
	GValue _tmp11_ = {0};
	GValue _tmp12_ = {0};
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GValue _tmp15_ = {0};
	GValue _tmp16_ = {0};
	GValue _tmp17_ = {0};
	GValue _tmp18_ = {0};
	GValue _tmp19_ = {0};
	GValue _tmp20_ = {0};
	GValue _tmp21_ = {0};
	GValue _tmp22_ = {0};
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	GValue _tmp25_ = {0};
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	GValue _tmp28_ = {0};
	GValue _tmp29_ = {0};
	GValue _tmp30_ = {0};
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	GValue _tmp33_ = {0};
	GValue* _tmp34_;
	gint values_length1;
	gint _values_size_;
	RygelDatabaseDatabase* _tmp113_;
	RygelMediaExportSQLFactory* _tmp114_;
	const gchar* _tmp115_;
	GValue* _tmp116_;
	gint _tmp116__length1;
	GError* _inner_error0_ = NULL;
#line 731 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 731 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (item != NULL);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_file_item_get_size (item);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = _tmp0_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp2_, G_TYPE_INT64);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int64 (&_tmp2_, _tmp1_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = rygel_media_file_item_get_mime_type (item);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = _tmp3_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp5_, G_TYPE_STRING);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp5_, _tmp4_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp6_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp6_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp7_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp7_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp8_ = rygel_media_object_get_upnp_class ((RygelMediaObject*) item);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = _tmp8_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp10_, G_TYPE_STRING);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp10_, _tmp9_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp11_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp12_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp13_ = rygel_media_object_get_date ((RygelMediaObject*) item);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp14_ = _tmp13_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp15_, G_TYPE_STRING);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp15_, _tmp14_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp16_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp16_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp17_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp17_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp18_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp18_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp19_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp19_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp20_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp20_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp21_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp21_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp22_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp22_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp23_ = rygel_media_object_get_id ((RygelMediaObject*) item);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp24_ = _tmp23_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp25_, G_TYPE_STRING);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp25_, _tmp24_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp26_ = rygel_media_file_item_get_dlna_profile (item);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp27_ = _tmp26_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp28_, G_TYPE_STRING);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp28_, _tmp27_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_null (&_tmp29_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp30_, G_TYPE_INT);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp30_, -1);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp31_ = rygel_media_object_get_creator ((RygelMediaObject*) item);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp32_ = _tmp31_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp33_, G_TYPE_STRING);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp33_, _tmp32_);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_ = g_new0 (GValue, 20);
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[0] = _tmp2_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[1] = _tmp5_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[2] = _tmp6_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[3] = _tmp7_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[4] = _tmp10_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[5] = _tmp11_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[6] = _tmp12_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[7] = _tmp15_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[8] = _tmp16_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[9] = _tmp17_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[10] = _tmp18_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[11] = _tmp19_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[12] = _tmp20_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[13] = _tmp21_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[14] = _tmp22_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[15] = _tmp25_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[16] = _tmp28_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[17] = _tmp29_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[18] = _tmp30_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[19] = _tmp33_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp34_;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 20;
#line 733 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 754 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_AUDIO_ITEM)) {
#line 5775 "rygel-media-export-media-cache.c"
		RygelAudioItem* audio_item = NULL;
		RygelAudioItem* _tmp35_;
		GValue* _tmp36_;
		gint _tmp36__length1;
		RygelAudioItem* _tmp37_;
		glong _tmp38_;
		glong _tmp39_;
		GValue _tmp40_ = {0};
		GValue* _tmp41_;
		gint _tmp41__length1;
		RygelAudioItem* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		GValue _tmp45_ = {0};
		GValue* _tmp46_;
		gint _tmp46__length1;
		RygelAudioItem* _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		GValue _tmp50_ = {0};
		GValue* _tmp51_;
		gint _tmp51__length1;
		RygelAudioItem* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		GValue _tmp55_ = {0};
		GValue* _tmp56_;
		gint _tmp56__length1;
		RygelAudioItem* _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		GValue _tmp60_ = {0};
#line 755 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_AUDIO_ITEM) ? ((RygelAudioItem*) item) : NULL);
#line 755 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		audio_item = _tmp35_;
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp36_ = values;
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp36__length1 = values_length1;
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp37_ = audio_item;
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp38_ = rygel_audio_item_get_duration (_tmp37_);
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp39_ = _tmp38_;
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp40_, G_TYPE_LONG);
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_long (&_tmp40_, _tmp39_);
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp36_[14]) ? (g_value_unset (&_tmp36_[14]), NULL) : NULL;
#line 756 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp36_[14] = _tmp40_;
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp41_ = values;
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp41__length1 = values_length1;
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp42_ = audio_item;
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp43_ = rygel_audio_item_get_bitrate (_tmp42_);
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp44_ = _tmp43_;
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp45_, G_TYPE_INT);
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int (&_tmp45_, _tmp44_);
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp41_[8]) ? (g_value_unset (&_tmp41_[8]), NULL) : NULL;
#line 757 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp41_[8] = _tmp45_;
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp46_ = values;
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp46__length1 = values_length1;
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp47_ = audio_item;
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp48_ = rygel_audio_item_get_sample_freq (_tmp47_);
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp49_ = _tmp48_;
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp50_, G_TYPE_INT);
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int (&_tmp50_, _tmp49_);
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp46_[9]) ? (g_value_unset (&_tmp46_[9]), NULL) : NULL;
#line 758 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp46_[9] = _tmp50_;
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp51_ = values;
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp51__length1 = values_length1;
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp52_ = audio_item;
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp53_ = rygel_audio_item_get_bits_per_sample (_tmp52_);
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp54_ = _tmp53_;
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp55_, G_TYPE_INT);
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int (&_tmp55_, _tmp54_);
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp51_[10]) ? (g_value_unset (&_tmp51_[10]), NULL) : NULL;
#line 759 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp51_[10] = _tmp55_;
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp56_ = values;
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp56__length1 = values_length1;
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp57_ = audio_item;
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp58_ = rygel_audio_item_get_channels (_tmp57_);
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp59_ = _tmp58_;
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp60_, G_TYPE_INT);
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int (&_tmp60_, _tmp59_);
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp56_[11]) ? (g_value_unset (&_tmp56_[11]), NULL) : NULL;
#line 760 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp56_[11] = _tmp60_;
#line 761 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (RYGEL_MEDIA_EXPORT_IS_MUSIC_ITEM (item)) {
#line 5904 "rygel-media-export-media-cache.c"
			RygelMediaExportMusicItem* music_item = NULL;
			RygelMediaExportMusicItem* _tmp61_;
			GValue* _tmp62_;
			gint _tmp62__length1;
			RygelMediaExportMusicItem* _tmp63_;
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			GValue _tmp66_ = {0};
			GValue* _tmp67_;
			gint _tmp67__length1;
			RygelMediaExportMusicItem* _tmp68_;
			const gchar* _tmp69_;
			const gchar* _tmp70_;
			GValue _tmp71_ = {0};
			GValue* _tmp72_;
			gint _tmp72__length1;
			RygelMediaExportMusicItem* _tmp73_;
			const gchar* _tmp74_;
			const gchar* _tmp75_;
			GValue _tmp76_ = {0};
			GValue* _tmp77_;
			gint _tmp77__length1;
			RygelMediaExportMusicItem* _tmp78_;
			gint _tmp79_;
			gint _tmp80_;
			GValue _tmp81_ = {0};
			GValue* _tmp82_;
			gint _tmp82__length1;
			RygelMediaExportMusicItem* _tmp83_;
			GValue _tmp84_ = {0};
#line 762 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp61_ = _g_object_ref0 (RYGEL_MEDIA_EXPORT_IS_MUSIC_ITEM (item) ? ((RygelMediaExportMusicItem*) item) : NULL);
#line 762 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			music_item = _tmp61_;
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp62_ = values;
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp62__length1 = values_length1;
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp63_ = music_item;
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp64_ = rygel_media_object_get_artist ((RygelMediaObject*) _tmp63_);
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp65_ = _tmp64_;
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (&_tmp66_, G_TYPE_STRING);
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_string (&_tmp66_, _tmp65_);
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			G_IS_VALUE (&_tmp62_[5]) ? (g_value_unset (&_tmp62_[5]), NULL) : NULL;
#line 763 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp62_[5] = _tmp66_;
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp67_ = values;
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp67__length1 = values_length1;
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp68_ = music_item;
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp69_ = rygel_audio_item_get_album ((RygelAudioItem*) _tmp68_);
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp70_ = _tmp69_;
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (&_tmp71_, G_TYPE_STRING);
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_string (&_tmp71_, _tmp70_);
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			G_IS_VALUE (&_tmp67_[6]) ? (g_value_unset (&_tmp67_[6]), NULL) : NULL;
#line 764 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp67_[6] = _tmp71_;
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp72_ = values;
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp72__length1 = values_length1;
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp73_ = music_item;
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp74_ = rygel_media_object_get_genre ((RygelMediaObject*) _tmp73_);
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp75_ = _tmp74_;
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (&_tmp76_, G_TYPE_STRING);
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_string (&_tmp76_, _tmp75_);
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			G_IS_VALUE (&_tmp72_[17]) ? (g_value_unset (&_tmp72_[17]), NULL) : NULL;
#line 765 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp72_[17] = _tmp76_;
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp77_ = values;
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp77__length1 = values_length1;
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp78_ = music_item;
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp79_ = rygel_music_item_get_track_number ((RygelMusicItem*) _tmp78_);
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp80_ = _tmp79_;
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (&_tmp81_, G_TYPE_INT);
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_int (&_tmp81_, _tmp80_);
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			G_IS_VALUE (&_tmp77_[12]) ? (g_value_unset (&_tmp77_[12]), NULL) : NULL;
#line 766 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp77_[12] = _tmp81_;
#line 767 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp82_ = values;
#line 767 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp82__length1 = values_length1;
#line 767 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp83_ = music_item;
#line 767 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (&_tmp84_, G_TYPE_INT);
#line 767 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_int (&_tmp84_, _tmp83_->disc);
#line 767 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			G_IS_VALUE (&_tmp82_[18]) ? (g_value_unset (&_tmp82_[18]), NULL) : NULL;
#line 767 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp82_[18] = _tmp84_;
#line 761 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (music_item);
#line 6027 "rygel-media-export-media-cache.c"
		}
#line 754 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (audio_item);
#line 6031 "rygel-media-export-media-cache.c"
	}
#line 771 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_VISUAL_ITEM)) {
#line 6035 "rygel-media-export-media-cache.c"
		RygelVisualItem* visual_item = NULL;
		RygelVisualItem* _tmp85_;
		GValue* _tmp86_;
		gint _tmp86__length1;
		RygelVisualItem* _tmp87_;
		gint _tmp88_;
		gint _tmp89_;
		GValue _tmp90_ = {0};
		GValue* _tmp91_;
		gint _tmp91__length1;
		RygelVisualItem* _tmp92_;
		gint _tmp93_;
		gint _tmp94_;
		GValue _tmp95_ = {0};
		GValue* _tmp96_;
		gint _tmp96__length1;
		RygelVisualItem* _tmp97_;
		gint _tmp98_;
		gint _tmp99_;
		GValue _tmp100_ = {0};
#line 772 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp85_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_VISUAL_ITEM) ? ((RygelVisualItem*) item) : NULL);
#line 772 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		visual_item = _tmp85_;
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp86_ = values;
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp86__length1 = values_length1;
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp87_ = visual_item;
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp88_ = rygel_visual_item_get_width (_tmp87_);
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp89_ = _tmp88_;
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp90_, G_TYPE_INT);
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int (&_tmp90_, _tmp89_);
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp86_[2]) ? (g_value_unset (&_tmp86_[2]), NULL) : NULL;
#line 773 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp86_[2] = _tmp90_;
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp91_ = values;
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp91__length1 = values_length1;
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp92_ = visual_item;
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp93_ = rygel_visual_item_get_height (_tmp92_);
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp94_ = _tmp93_;
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp95_, G_TYPE_INT);
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int (&_tmp95_, _tmp94_);
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp91_[3]) ? (g_value_unset (&_tmp91_[3]), NULL) : NULL;
#line 774 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp91_[3] = _tmp95_;
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp96_ = values;
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp96__length1 = values_length1;
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp97_ = visual_item;
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp98_ = rygel_visual_item_get_color_depth (_tmp97_);
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp99_ = _tmp98_;
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp100_, G_TYPE_INT);
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int (&_tmp100_, _tmp99_);
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp96_[13]) ? (g_value_unset (&_tmp96_[13]), NULL) : NULL;
#line 775 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp96_[13] = _tmp100_;
#line 776 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (RYGEL_MEDIA_EXPORT_IS_VIDEO_ITEM (item)) {
#line 6116 "rygel-media-export-media-cache.c"
			RygelMediaExportVideoItem* video_item = NULL;
			RygelMediaExportVideoItem* _tmp101_;
			GValue* _tmp102_;
			gint _tmp102__length1;
			RygelMediaExportVideoItem* _tmp103_;
			const gchar* _tmp104_;
			const gchar* _tmp105_;
			GValue _tmp106_ = {0};
#line 777 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp101_ = _g_object_ref0 (RYGEL_MEDIA_EXPORT_IS_VIDEO_ITEM (item) ? ((RygelMediaExportVideoItem*) item) : NULL);
#line 777 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			video_item = _tmp101_;
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp102_ = values;
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp102__length1 = values_length1;
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp103_ = video_item;
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp104_ = rygel_video_item_get_author ((RygelVideoItem*) _tmp103_);
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp105_ = _tmp104_;
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (&_tmp106_, G_TYPE_STRING);
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_string (&_tmp106_, _tmp105_);
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			G_IS_VALUE (&_tmp102_[5]) ? (g_value_unset (&_tmp102_[5]), NULL) : NULL;
#line 778 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp102_[5] = _tmp106_;
#line 776 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (video_item);
#line 6149 "rygel-media-export-media-cache.c"
		}
#line 771 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (visual_item);
#line 6153 "rygel-media-export-media-cache.c"
	}
#line 782 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (RYGEL_MEDIA_EXPORT_IS_PLAYLIST_ITEM (item)) {
#line 6157 "rygel-media-export-media-cache.c"
		RygelMediaExportPlaylistItem* playlist_item = NULL;
		RygelMediaExportPlaylistItem* _tmp107_;
		GValue* _tmp108_;
		gint _tmp108__length1;
		RygelMediaExportPlaylistItem* _tmp109_;
		const gchar* _tmp110_;
		const gchar* _tmp111_;
		GValue _tmp112_ = {0};
#line 783 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp107_ = _g_object_ref0 (RYGEL_MEDIA_EXPORT_IS_PLAYLIST_ITEM (item) ? ((RygelMediaExportPlaylistItem*) item) : NULL);
#line 783 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		playlist_item = _tmp107_;
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp108_ = values;
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp108__length1 = values_length1;
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp109_ = playlist_item;
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp110_ = rygel_media_object_get_creator ((RygelMediaObject*) _tmp109_);
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp111_ = _tmp110_;
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp112_, G_TYPE_STRING);
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_string (&_tmp112_, _tmp111_);
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp108_[5]) ? (g_value_unset (&_tmp108_[5]), NULL) : NULL;
#line 785 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp108_[5] = _tmp112_;
#line 782 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (playlist_item);
#line 6190 "rygel-media-export-media-cache.c"
	}
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp113_ = self->priv->db;
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp114_ = self->priv->sql;
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp115_ = rygel_media_export_sql_factory_make (_tmp114_, RYGEL_MEDIA_EXPORT_SQL_STRING_SAVE_METADATA);
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp116_ = values;
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp116__length1 = values_length1;
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_database_exec (_tmp113_, _tmp115_, _tmp116_, (gint) _tmp116__length1, &_inner_error0_);
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 788 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 6212 "rygel-media-export-media-cache.c"
	}
#line 731 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 6216 "rygel-media-export-media-cache.c"
}

static void
rygel_media_export_media_cache_update_guarded_object (RygelMediaExportMediaCache* self,
                                                      RygelMediaObject* object,
                                                      GError** error)
{
	gint type = 0;
	GValue parent = {0};
	RygelMediaContainer* _tmp0_;
	RygelMediaContainer* _tmp1_;
	GValue* values = NULL;
	GValue _tmp8_ = {0};
	GValue _tmp9_;
	GValue _tmp10_;
	GValue _tmp11_ = {0};
	guint64 _tmp12_;
	guint64 _tmp13_;
	GValue _tmp14_ = {0};
	gchar* _tmp15_;
	GValue _tmp16_ = {0};
	guint _tmp17_;
	guint _tmp18_;
	GValue _tmp19_ = {0};
	GValue _tmp20_ = {0};
	GValue _tmp21_ = {0};
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	GValue _tmp24_ = {0};
	GValue* _tmp25_;
	gint values_length1;
	gint _values_size_;
	RygelDatabaseDatabase* _tmp33_;
	RygelMediaExportSQLFactory* _tmp34_;
	const gchar* _tmp35_;
	GValue* _tmp36_;
	gint _tmp36__length1;
	GError* _inner_error0_ = NULL;
#line 791 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 791 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (object != NULL);
#line 792 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	type = (gint) RYGEL_MEDIA_EXPORT_OBJECT_TYPE_CONTAINER;
#line 795 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (object, RYGEL_TYPE_MEDIA_FILE_ITEM)) {
#line 796 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		type = (gint) RYGEL_MEDIA_EXPORT_OBJECT_TYPE_ITEM;
#line 6265 "rygel-media-export-media-cache.c"
	}
#line 799 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_object_get_parent (object);
#line 799 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = _tmp0_;
#line 799 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp1_ == NULL) {
#line 6273 "rygel-media-export-media-cache.c"
		GValue _tmp2_ = {0};
#line 800 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_null (&_tmp2_);
#line 800 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&parent) ? (g_value_unset (&parent), NULL) : NULL;
#line 800 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		parent = _tmp2_;
#line 6281 "rygel-media-export-media-cache.c"
	} else {
		RygelMediaContainer* _tmp3_;
		RygelMediaContainer* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GValue _tmp7_ = {0};
#line 802 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = rygel_media_object_get_parent (object);
#line 802 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _tmp3_;
#line 802 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = rygel_media_object_get_id ((RygelMediaObject*) _tmp4_);
#line 802 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = _tmp5_;
#line 802 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp7_, G_TYPE_STRING);
#line 802 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_string (&_tmp7_, _tmp6_);
#line 802 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&parent) ? (g_value_unset (&parent), NULL) : NULL;
#line 802 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		parent = _tmp7_;
#line 6304 "rygel-media-export-media-cache.c"
	}
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp8_, G_TYPE_INT);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp8_, type);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = parent;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp10_ = _tmp9_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_IS_VALUE (&_tmp10_)) {
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp11_, G_VALUE_TYPE (&_tmp10_));
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_copy (&_tmp10_, &_tmp11_);
#line 6320 "rygel-media-export-media-cache.c"
	} else {
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp11_ = _tmp10_;
#line 6324 "rygel-media-export-media-cache.c"
	}
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp12_ = rygel_media_object_get_modified (object);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp13_ = _tmp12_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp14_, G_TYPE_UINT64);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_uint64 (&_tmp14_, _tmp13_);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp15_ = rygel_media_object_get_primary_uri (object);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp16_, G_TYPE_STRING);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_take_string (&_tmp16_, _tmp15_);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp17_ = rygel_media_object_get_object_update_id (object);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp18_ = _tmp17_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp19_, G_TYPE_UINT);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_uint (&_tmp19_, _tmp18_);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp20_, G_TYPE_INT);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp20_, -1);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp21_, G_TYPE_INT);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp21_, -1);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp22_ = rygel_media_object_get_id (object);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp23_ = _tmp22_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp24_, G_TYPE_STRING);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp24_, _tmp23_);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_ = g_new0 (GValue, 8);
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_[0] = _tmp8_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_[1] = _tmp11_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_[2] = _tmp14_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_[3] = _tmp16_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_[4] = _tmp19_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_[5] = _tmp20_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_[6] = _tmp21_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_[7] = _tmp24_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp25_;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 8;
#line 805 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 814 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (object, RYGEL_TYPE_MEDIA_CONTAINER)) {
#line 6390 "rygel-media-export-media-cache.c"
		RygelMediaContainer* container = NULL;
		RygelMediaContainer* _tmp26_;
		GValue* _tmp27_;
		gint _tmp27__length1;
		RygelMediaContainer* _tmp28_;
		GValue _tmp29_ = {0};
		GValue* _tmp30_;
		gint _tmp30__length1;
		RygelMediaContainer* _tmp31_;
		GValue _tmp32_ = {0};
#line 815 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp26_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, RYGEL_TYPE_MEDIA_CONTAINER) ? ((RygelMediaContainer*) object) : NULL);
#line 815 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		container = _tmp26_;
#line 816 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp27_ = values;
#line 816 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp27__length1 = values_length1;
#line 816 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp28_ = container;
#line 816 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp29_, G_TYPE_INT64);
#line 816 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int64 (&_tmp29_, _tmp28_->total_deleted_child_count);
#line 816 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp27_[6]) ? (g_value_unset (&_tmp27_[6]), NULL) : NULL;
#line 816 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp27_[6] = _tmp29_;
#line 817 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp30_ = values;
#line 817 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp30__length1 = values_length1;
#line 817 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp31_ = container;
#line 817 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp32_, G_TYPE_UINT);
#line 817 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_uint (&_tmp32_, _tmp31_->update_id);
#line 817 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp30_[7]) ? (g_value_unset (&_tmp30_[7]), NULL) : NULL;
#line 817 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp30_[7] = _tmp32_;
#line 814 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (container);
#line 6435 "rygel-media-export-media-cache.c"
	}
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp33_ = self->priv->db;
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_ = self->priv->sql;
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp35_ = rygel_media_export_sql_factory_make (_tmp34_, RYGEL_MEDIA_EXPORT_SQL_STRING_UPDATE_GUARDED_OBJECT);
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp36_ = values;
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp36__length1 = values_length1;
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_database_exec (_tmp33_, _tmp35_, _tmp36_, (gint) _tmp36__length1, &_inner_error0_);
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&parent) ? (g_value_unset (&parent), NULL) : NULL;
#line 820 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 6459 "rygel-media-export-media-cache.c"
	}
#line 791 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 791 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	G_IS_VALUE (&parent) ? (g_value_unset (&parent), NULL) : NULL;
#line 6465 "rygel-media-export-media-cache.c"
}

static void
rygel_media_export_media_cache_create_normal_object (RygelMediaExportMediaCache* self,
                                                     RygelMediaObject* object,
                                                     gboolean is_guarded,
                                                     GError** error)
{
	gint type = 0;
	GValue parent = {0};
	RygelMediaContainer* _tmp0_;
	RygelMediaContainer* _tmp1_;
	gint _tmp8_ = 0;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GValue* values = NULL;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GValue _tmp14_ = {0};
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GValue _tmp17_ = {0};
	GValue _tmp18_ = {0};
	GValue _tmp19_;
	GValue _tmp20_;
	GValue _tmp21_ = {0};
	guint64 _tmp22_;
	guint64 _tmp23_;
	GValue _tmp24_ = {0};
	gchar* _tmp25_;
	GValue _tmp26_ = {0};
	guint _tmp27_;
	guint _tmp28_;
	GValue _tmp29_ = {0};
	GValue _tmp30_ = {0};
	GValue _tmp31_ = {0};
	GValue _tmp32_ = {0};
	GValue _tmp33_ = {0};
	GValue* _tmp34_;
	gint values_length1;
	gint _values_size_;
	RygelDatabaseDatabase* _tmp42_;
	RygelMediaExportSQLFactory* _tmp43_;
	const gchar* _tmp44_;
	GValue* _tmp45_;
	gint _tmp45__length1;
	GError* _inner_error0_ = NULL;
#line 823 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 823 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (object != NULL);
#line 825 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	type = (gint) RYGEL_MEDIA_EXPORT_OBJECT_TYPE_CONTAINER;
#line 828 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (object, RYGEL_TYPE_MEDIA_FILE_ITEM)) {
#line 829 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		type = (gint) RYGEL_MEDIA_EXPORT_OBJECT_TYPE_ITEM;
#line 6524 "rygel-media-export-media-cache.c"
	}
#line 832 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_object_get_parent (object);
#line 832 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = _tmp0_;
#line 832 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp1_ == NULL) {
#line 6532 "rygel-media-export-media-cache.c"
		GValue _tmp2_ = {0};
#line 833 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_null (&_tmp2_);
#line 833 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&parent) ? (g_value_unset (&parent), NULL) : NULL;
#line 833 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		parent = _tmp2_;
#line 6540 "rygel-media-export-media-cache.c"
	} else {
		RygelMediaContainer* _tmp3_;
		RygelMediaContainer* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GValue _tmp7_ = {0};
#line 835 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = rygel_media_object_get_parent (object);
#line 835 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _tmp3_;
#line 835 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = rygel_media_object_get_id ((RygelMediaObject*) _tmp4_);
#line 835 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = _tmp5_;
#line 835 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp7_, G_TYPE_STRING);
#line 835 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_string (&_tmp7_, _tmp6_);
#line 835 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&parent) ? (g_value_unset (&parent), NULL) : NULL;
#line 835 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		parent = _tmp7_;
#line 6563 "rygel-media-export-media-cache.c"
	}
#line 847 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (is_guarded) {
#line 847 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = 1;
#line 6569 "rygel-media-export-media-cache.c"
	} else {
#line 847 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = 0;
#line 6573 "rygel-media-export-media-cache.c"
	}
#line 848 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp10_ = rygel_media_object_get_ref_id (object);
#line 848 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp11_ = _tmp10_;
#line 848 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp9_ = _tmp11_;
#line 848 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp9_ == NULL) {
#line 848 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp9_ = NULL;
#line 6585 "rygel-media-export-media-cache.c"
	}
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp12_ = rygel_media_object_get_id (object);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp13_ = _tmp12_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp14_, G_TYPE_STRING);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp14_, _tmp13_);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp15_ = rygel_media_object_get_title (object);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp16_ = _tmp15_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp17_, G_TYPE_STRING);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp17_, _tmp16_);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp18_, G_TYPE_INT);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp18_, type);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp19_ = parent;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp20_ = _tmp19_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_IS_VALUE (&_tmp20_)) {
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp21_, G_VALUE_TYPE (&_tmp20_));
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_copy (&_tmp20_, &_tmp21_);
#line 6617 "rygel-media-export-media-cache.c"
	} else {
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp21_ = _tmp20_;
#line 6621 "rygel-media-export-media-cache.c"
	}
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp22_ = rygel_media_object_get_modified (object);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp23_ = _tmp22_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp24_, G_TYPE_UINT64);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_uint64 (&_tmp24_, _tmp23_);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp25_ = rygel_media_object_get_primary_uri (object);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp26_, G_TYPE_STRING);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_take_string (&_tmp26_, _tmp25_);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp27_ = rygel_media_object_get_object_update_id (object);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp28_ = _tmp27_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp29_, G_TYPE_UINT);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_uint (&_tmp29_, _tmp28_);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp30_, G_TYPE_INT);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp30_, -1);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp31_, G_TYPE_INT);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp31_, -1);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp32_, G_TYPE_INT);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_int (&_tmp32_, _tmp8_);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_init (&_tmp33_, G_TYPE_STRING);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_value_set_string (&_tmp33_, _tmp9_);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_ = g_new0 (GValue, 11);
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[0] = _tmp14_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[1] = _tmp17_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[2] = _tmp18_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[3] = _tmp21_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[4] = _tmp24_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[5] = _tmp26_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[6] = _tmp29_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[7] = _tmp30_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[8] = _tmp31_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[9] = _tmp32_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp34_[10] = _tmp33_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = _tmp34_;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values_length1 = 11;
#line 838 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_values_size_ = values_length1;
#line 850 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (object, RYGEL_TYPE_MEDIA_CONTAINER)) {
#line 6693 "rygel-media-export-media-cache.c"
		RygelMediaContainer* container = NULL;
		RygelMediaContainer* _tmp35_;
		GValue* _tmp36_;
		gint _tmp36__length1;
		RygelMediaContainer* _tmp37_;
		GValue _tmp38_ = {0};
		GValue* _tmp39_;
		gint _tmp39__length1;
		RygelMediaContainer* _tmp40_;
		GValue _tmp41_ = {0};
#line 851 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, RYGEL_TYPE_MEDIA_CONTAINER) ? ((RygelMediaContainer*) object) : NULL);
#line 851 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		container = _tmp35_;
#line 852 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp36_ = values;
#line 852 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp36__length1 = values_length1;
#line 852 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp37_ = container;
#line 852 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp38_, G_TYPE_INT64);
#line 852 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_int64 (&_tmp38_, _tmp37_->total_deleted_child_count);
#line 852 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp36_[7]) ? (g_value_unset (&_tmp36_[7]), NULL) : NULL;
#line 852 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp36_[7] = _tmp38_;
#line 853 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp39_ = values;
#line 853 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp39__length1 = values_length1;
#line 853 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp40_ = container;
#line 853 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_init (&_tmp41_, G_TYPE_UINT);
#line 853 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_value_set_uint (&_tmp41_, _tmp40_->update_id);
#line 853 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&_tmp39_[8]) ? (g_value_unset (&_tmp39_[8]), NULL) : NULL;
#line 853 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp39_[8] = _tmp41_;
#line 850 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (container);
#line 6738 "rygel-media-export-media-cache.c"
	}
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp42_ = self->priv->db;
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp43_ = self->priv->sql;
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp44_ = rygel_media_export_sql_factory_make (_tmp43_, RYGEL_MEDIA_EXPORT_SQL_STRING_INSERT);
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp45_ = values;
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp45__length1 = values_length1;
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_database_database_exec (_tmp42_, _tmp44_, _tmp45_, (gint) _tmp45__length1, &_inner_error0_);
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		G_IS_VALUE (&parent) ? (g_value_unset (&parent), NULL) : NULL;
#line 856 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return;
#line 6762 "rygel-media-export-media-cache.c"
	}
#line 823 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	values = (_vala_GValue_array_free (values, values_length1), NULL);
#line 823 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	G_IS_VALUE (&parent) ? (g_value_unset (&parent), NULL) : NULL;
#line 6768 "rygel-media-export-media-cache.c"
}

/**
     * Add the container or item to the cache.
     */
static void
rygel_media_export_media_cache_create_object (RygelMediaExportMediaCache* self,
                                              RygelMediaObject* object,
                                              gboolean override_guarded,
                                              GError** error)
{
	gboolean is_guarded = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 862 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 862 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (object != NULL);
#line 864 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_media_object_get_id (object);
#line 864 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = _tmp0_;
#line 864 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	is_guarded = rygel_media_export_media_cache_is_object_guarded (self, _tmp1_);
#line 866 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (!override_guarded) {
#line 866 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = is_guarded;
#line 6799 "rygel-media-export-media-cache.c"
	} else {
#line 866 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = FALSE;
#line 6803 "rygel-media-export-media-cache.c"
	}
#line 866 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp2_) {
#line 867 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_update_guarded_object (self, object, &_inner_error0_);
#line 867 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 867 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 867 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 6815 "rygel-media-export-media-cache.c"
		}
	} else {
		gboolean _tmp3_ = FALSE;
#line 869 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (is_guarded) {
#line 869 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp3_ = TRUE;
#line 6823 "rygel-media-export-media-cache.c"
		} else {
#line 869 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp3_ = override_guarded;
#line 6827 "rygel-media-export-media-cache.c"
		}
#line 869 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_create_normal_object (self, object, _tmp3_, &_inner_error0_);
#line 869 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 869 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 869 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return;
#line 6837 "rygel-media-export-media-cache.c"
		}
	}
}

/**
     * Create the current schema.
     *
     * If schema creation fails, schema will be rolled back
     * completely.
     *
     * @returns: true on success, false on failure
     */
static gboolean
rygel_media_export_media_cache_create_schema (RygelMediaExportMediaCache* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 881 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 6857 "rygel-media-export-media-cache.c"
	{
		RygelDatabaseDatabase* _tmp0_;
		RygelDatabaseDatabase* _tmp1_;
		RygelMediaExportSQLFactory* _tmp2_;
		const gchar* _tmp3_;
		RygelDatabaseDatabase* _tmp4_;
		RygelMediaExportSQLFactory* _tmp5_;
		const gchar* _tmp6_;
		RygelDatabaseDatabase* _tmp7_;
		RygelMediaExportSQLFactory* _tmp8_;
		const gchar* _tmp9_;
		RygelDatabaseDatabase* _tmp10_;
		RygelMediaExportSQLFactory* _tmp11_;
		const gchar* _tmp12_;
		RygelDatabaseDatabase* _tmp13_;
		RygelMediaExportSQLFactory* _tmp14_;
		const gchar* _tmp15_;
		RygelDatabaseDatabase* _tmp16_;
		RygelMediaExportSQLFactory* _tmp17_;
		const gchar* _tmp18_;
		RygelDatabaseDatabase* _tmp19_;
		RygelDatabaseDatabase* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 883 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = self->priv->db;
#line 883 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_begin (_tmp0_, &_inner_error0_);
#line 883 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6888 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 884 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = self->priv->db;
#line 884 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = self->priv->sql;
#line 884 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = rygel_media_export_sql_factory_make (_tmp2_, RYGEL_MEDIA_EXPORT_SQL_STRING_SCHEMA);
#line 884 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp1_, _tmp3_, NULL, (gint) 0, &_inner_error0_);
#line 884 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6901 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 885 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = self->priv->db;
#line 885 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = self->priv->sql;
#line 885 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = rygel_media_export_sql_factory_make (_tmp5_, RYGEL_MEDIA_EXPORT_SQL_STRING_TRIGGER_COMMON);
#line 885 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp4_, _tmp6_, NULL, (gint) 0, &_inner_error0_);
#line 885 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6914 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 886 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = self->priv->db;
#line 886 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = self->priv->sql;
#line 886 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp9_ = rygel_media_export_sql_factory_make (_tmp8_, RYGEL_MEDIA_EXPORT_SQL_STRING_TABLE_CLOSURE);
#line 886 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp7_, _tmp9_, NULL, (gint) 0, &_inner_error0_);
#line 886 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6927 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 887 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp10_ = self->priv->db;
#line 887 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp11_ = self->priv->sql;
#line 887 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp12_ = rygel_media_export_sql_factory_make (_tmp11_, RYGEL_MEDIA_EXPORT_SQL_STRING_INDEX_COMMON);
#line 887 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp10_, _tmp12_, NULL, (gint) 0, &_inner_error0_);
#line 887 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6940 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 888 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp13_ = self->priv->db;
#line 888 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp14_ = self->priv->sql;
#line 888 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp15_ = rygel_media_export_sql_factory_make (_tmp14_, RYGEL_MEDIA_EXPORT_SQL_STRING_TRIGGER_CLOSURE);
#line 888 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp13_, _tmp15_, NULL, (gint) 0, &_inner_error0_);
#line 888 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6953 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 889 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp16_ = self->priv->db;
#line 889 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp17_ = self->priv->sql;
#line 889 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp18_ = rygel_media_export_sql_factory_make (_tmp17_, RYGEL_MEDIA_EXPORT_SQL_STRING_TRIGGER_REFERENCE);
#line 889 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_exec (_tmp16_, _tmp18_, NULL, (gint) 0, &_inner_error0_);
#line 889 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6966 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 890 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp19_ = self->priv->db;
#line 890 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_commit (_tmp19_, &_inner_error0_);
#line 890 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6975 "rygel-media-export-media-cache.c"
			goto __catch0_g_error;
		}
#line 891 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp20_ = self->priv->db;
#line 891 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_analyze (_tmp20_);
#line 892 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp21_ = g_uuid_string_random ();
#line 892 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp22_ = _tmp21_;
#line 892 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_export_media_cache_save_reset_token (self, _tmp22_);
#line 892 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_tmp22_);
#line 894 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = TRUE;
#line 894 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 6994 "rygel-media-export-media-cache.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
		RygelDatabaseDatabase* _tmp25_;
#line 882 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		err = _inner_error0_;
#line 882 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_inner_error0_ = NULL;
#line 896 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp23_ = err;
#line 896 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp24_ = _tmp23_->message;
#line 896 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_warning (_ ("Failed to create database schema: %s"), _tmp24_);
#line 897 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp25_ = self->priv->db;
#line 897 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_database_database_rollback (_tmp25_);
#line 882 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_error_free0 (err);
#line 7019 "rygel-media-export-media-cache.c"
	}
	__finally0:
#line 882 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7024 "rygel-media-export-media-cache.c"
		gboolean _tmp26_ = FALSE;
#line 882 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 882 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_clear_error (&_inner_error0_);
#line 882 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return _tmp26_;
#line 7032 "rygel-media-export-media-cache.c"
	}
#line 900 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = FALSE;
#line 900 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 7038 "rygel-media-export-media-cache.c"
}

/**
     * Create a new container or item based on a SQL result.
     *
     * The Rygel server discards the object when the browse request is finished,
     * after serializing the result.
     *
     * @param parent The object's parent container.
     * @param statement a SQLite result indicating the container's details.
     */
static RygelMediaObject*
rygel_media_export_media_cache_get_object_from_statement (RygelMediaExportMediaCache* self,
                                                          RygelMediaContainer* parent,
                                                          sqlite3_stmt* statement)
{
	RygelMediaObject* object = NULL;
	const gchar* title = NULL;
	const gchar* _tmp0_;
	const gchar* object_id = NULL;
	const gchar* _tmp1_;
	const gchar* uri = NULL;
	const gchar* _tmp2_;
	RygelMediaObject* _tmp28_;
	RygelMediaObject* result;
#line 912 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 912 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (statement != NULL, NULL);
#line 914 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	object = NULL;
#line 915 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_TITLE);
#line 915 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	title = _tmp0_;
#line 916 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_ID);
#line 916 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	object_id = _tmp1_;
#line 917 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_URI);
#line 917 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	uri = _tmp2_;
#line 919 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	switch (sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_TYPE)) {
#line 919 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case 0:
#line 7086 "rygel-media-export-media-cache.c"
		{
			RygelMediaExportObjectFactory* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			RygelMediaContainer* _tmp7_;
			RygelMediaContainer* container = NULL;
			RygelMediaObject* _tmp8_;
			RygelMediaContainer* _tmp9_;
			const gchar* _tmp10_;
			RygelMediaContainer* _tmp13_;
			RygelMediaContainer* _tmp14_;
#line 922 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp3_ = self->priv->factory;
#line 922 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp4_ = object_id;
#line 922 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp5_ = title;
#line 922 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp6_ = uri;
#line 922 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp7_ = rygel_media_export_object_factory_get_container (_tmp3_, _tmp4_, _tmp5_, (guint) 0, _tmp6_);
#line 922 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (object);
#line 922 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			object = (RygelMediaObject*) _tmp7_;
#line 924 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp8_ = object;
#line 924 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, RYGEL_TYPE_MEDIA_CONTAINER) ? ((RygelMediaContainer*) _tmp8_) : NULL);
#line 924 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			container = _tmp9_;
#line 925 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp10_ = uri;
#line 925 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_tmp10_ != NULL) {
#line 7123 "rygel-media-export-media-cache.c"
				RygelMediaContainer* _tmp11_;
				const gchar* _tmp12_;
#line 926 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp11_ = container;
#line 926 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp12_ = uri;
#line 926 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				rygel_media_object_add_uri ((RygelMediaObject*) _tmp11_, _tmp12_);
#line 7132 "rygel-media-export-media-cache.c"
			}
#line 928 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp13_ = container;
#line 928 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp13_->total_deleted_child_count = (gint64) ((guint32) sqlite3_column_int64 (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DELETED_CHILD_COUNT));
#line 930 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp14_ = container;
#line 930 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp14_->update_id = (guint32) ((guint) sqlite3_column_int64 (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_CONTAINER_UPDATE_ID));
#line 932 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (container);
#line 932 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			break;
#line 7146 "rygel-media-export-media-cache.c"
		}
#line 919 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case 1:
#line 7150 "rygel-media-export-media-cache.c"
		{
			const gchar* upnp_class = NULL;
			const gchar* _tmp15_;
			RygelMediaExportObjectFactory* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			RygelMediaFileItem* _tmp20_;
			RygelMediaFileItem* item = NULL;
			RygelMediaObject* _tmp21_;
			RygelMediaFileItem* _tmp22_;
			RygelMediaFileItem* _tmp23_;
			const gchar* _tmp24_;
			RygelMediaFileItem* _tmp27_;
#line 935 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp15_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_CLASS);
#line 935 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			upnp_class = _tmp15_;
#line 937 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp16_ = self->priv->factory;
#line 937 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp17_ = object_id;
#line 937 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp18_ = title;
#line 937 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp19_ = upnp_class;
#line 937 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp20_ = rygel_media_export_object_factory_get_item (_tmp16_, parent, _tmp17_, _tmp18_, _tmp19_);
#line 937 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (object);
#line 937 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			object = (RygelMediaObject*) _tmp20_;
#line 941 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp21_ = object;
#line 941 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, RYGEL_TYPE_MEDIA_FILE_ITEM) ? ((RygelMediaFileItem*) _tmp21_) : NULL);
#line 941 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			item = _tmp22_;
#line 942 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp23_ = item;
#line 942 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_export_media_cache_fill_item (self, statement, _tmp23_);
#line 944 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp24_ = uri;
#line 944 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (_tmp24_ != NULL) {
#line 7197 "rygel-media-export-media-cache.c"
				RygelMediaFileItem* _tmp25_;
				const gchar* _tmp26_;
#line 945 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp25_ = item;
#line 945 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp26_ = uri;
#line 945 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				rygel_media_object_add_uri ((RygelMediaObject*) _tmp25_, _tmp26_);
#line 7206 "rygel-media-export-media-cache.c"
			}
#line 948 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp27_ = item;
#line 948 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_file_item_add_engine_resources (_tmp27_, NULL, NULL);
#line 949 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (item);
#line 949 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			break;
#line 7216 "rygel-media-export-media-cache.c"
		}
		default:
		{
#line 951 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_assert_not_reached ();
#line 7222 "rygel-media-export-media-cache.c"
		}
	}
#line 954 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp28_ = object;
#line 954 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp28_ != NULL) {
#line 7229 "rygel-media-export-media-cache.c"
		RygelMediaObject* _tmp29_;
		RygelMediaFileItem* item = NULL;
		RygelMediaObject* _tmp30_;
		RygelMediaFileItem* _tmp31_;
		gboolean _tmp32_ = FALSE;
		RygelMediaObject* _tmp33_;
		guint64 _tmp34_;
		guint64 _tmp35_;
		RygelMediaObject* _tmp39_;
		RygelMediaObject* _tmp40_;
		const gchar* _tmp41_;
#line 955 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp29_ = object;
#line 955 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_object_set_modified (_tmp29_, (guint64) sqlite3_column_int64 (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_TIMESTAMP));
#line 956 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp30_ = object;
#line 956 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp31_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp30_, RYGEL_TYPE_MEDIA_FILE_ITEM) ? ((RygelMediaFileItem*) _tmp30_) : NULL);
#line 956 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		item = _tmp31_;
#line 957 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp33_ = object;
#line 957 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp34_ = rygel_media_object_get_modified (_tmp33_);
#line 957 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp35_ = _tmp34_;
#line 957 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_tmp35_ == ((guint64) G_MAXINT64)) {
#line 7259 "rygel-media-export-media-cache.c"
			RygelMediaFileItem* _tmp36_;
#line 957 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp36_ = item;
#line 957 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp32_ = _tmp36_ != NULL;
#line 7265 "rygel-media-export-media-cache.c"
		} else {
#line 957 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp32_ = FALSE;
#line 7269 "rygel-media-export-media-cache.c"
		}
#line 957 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_tmp32_) {
#line 7273 "rygel-media-export-media-cache.c"
			RygelMediaObject* _tmp37_;
			RygelMediaFileItem* _tmp38_;
#line 958 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp37_ = object;
#line 958 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_object_set_modified (_tmp37_, (guint64) 0);
#line 959 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp38_ = item;
#line 959 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_file_item_set_place_holder (_tmp38_, TRUE);
#line 7284 "rygel-media-export-media-cache.c"
		}
#line 961 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp39_ = object;
#line 961 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_object_set_object_update_id (_tmp39_, (guint) sqlite3_column_int64 (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_OBJECT_UPDATE_ID));
#line 963 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp40_ = object;
#line 963 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp41_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_REFERENCE_ID);
#line 963 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_media_object_set_ref_id (_tmp40_, _tmp41_);
#line 954 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (item);
#line 7298 "rygel-media-export-media-cache.c"
	}
#line 966 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = object;
#line 966 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 7304 "rygel-media-export-media-cache.c"
}

static void
rygel_media_export_media_cache_fill_item (RygelMediaExportMediaCache* self,
                                          sqlite3_stmt* statement,
                                          RygelMediaFileItem* item)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 969 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (self != NULL);
#line 969 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (statement != NULL);
#line 969 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_if_fail (item != NULL);
#line 971 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DATE);
#line 971 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_object_set_date ((RygelMediaObject*) item, _tmp0_);
#line 972 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_MIME_TYPE);
#line 972 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_file_item_set_mime_type (item, _tmp1_);
#line 973 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DLNA_PROFILE);
#line 973 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_file_item_set_dlna_profile (item, _tmp2_);
#line 974 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_file_item_set_size (item, sqlite3_column_int64 (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_SIZE));
#line 975 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_CREATOR);
#line 975 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_object_set_creator ((RygelMediaObject*) item, _tmp3_);
#line 977 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_AUDIO_ITEM)) {
#line 7342 "rygel-media-export-media-cache.c"
		RygelAudioItem* audio_item = NULL;
		RygelAudioItem* _tmp4_;
		RygelAudioItem* _tmp5_;
		RygelAudioItem* _tmp6_;
		RygelAudioItem* _tmp7_;
		RygelAudioItem* _tmp8_;
		RygelAudioItem* _tmp9_;
#line 978 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_AUDIO_ITEM) ? ((RygelAudioItem*) item) : NULL);
#line 978 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		audio_item = _tmp4_;
#line 979 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = audio_item;
#line 979 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_audio_item_set_duration (_tmp5_, (glong) sqlite3_column_int64 (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DURATION));
#line 981 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = audio_item;
#line 981 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_audio_item_set_bitrate (_tmp6_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_BITRATE));
#line 982 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp7_ = audio_item;
#line 982 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_audio_item_set_sample_freq (_tmp7_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_SAMPLE_FREQ));
#line 984 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp8_ = audio_item;
#line 984 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_audio_item_set_bits_per_sample (_tmp8_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_BITS_PER_SAMPLE));
#line 986 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp9_ = audio_item;
#line 986 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_audio_item_set_channels (_tmp9_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_CHANNELS));
#line 987 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (RYGEL_MEDIA_EXPORT_IS_MUSIC_ITEM (item)) {
#line 7376 "rygel-media-export-media-cache.c"
			RygelMediaExportMusicItem* music_item = NULL;
			RygelMediaExportMusicItem* _tmp10_;
			RygelMediaExportMusicItem* _tmp11_;
			const gchar* _tmp12_;
			RygelMediaExportMusicItem* _tmp13_;
			const gchar* _tmp14_;
			RygelMediaExportMusicItem* _tmp15_;
			const gchar* _tmp16_;
			RygelMediaExportMusicItem* _tmp17_;
			RygelMediaExportMusicItem* _tmp18_;
			RygelMediaExportMusicItem* _tmp19_;
#line 988 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp10_ = _g_object_ref0 (RYGEL_MEDIA_EXPORT_IS_MUSIC_ITEM (item) ? ((RygelMediaExportMusicItem*) item) : NULL);
#line 988 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			music_item = _tmp10_;
#line 989 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp11_ = music_item;
#line 989 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp12_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_AUTHOR);
#line 989 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_object_set_artist ((RygelMediaObject*) _tmp11_, _tmp12_);
#line 990 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp13_ = music_item;
#line 990 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp14_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_ALBUM);
#line 990 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_audio_item_set_album ((RygelAudioItem*) _tmp13_, _tmp14_);
#line 991 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp15_ = music_item;
#line 991 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp16_ = (const gchar*) sqlite3_column_text (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_GENRE);
#line 991 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_media_object_set_genre ((RygelMediaObject*) _tmp15_, _tmp16_);
#line 992 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp17_ = music_item;
#line 992 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_music_item_set_track_number ((RygelMusicItem*) _tmp17_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_TRACK));
#line 994 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp18_ = music_item;
#line 994 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_music_item_set_disc_number ((RygelMusicItem*) _tmp18_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_DISC));
#line 995 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp19_ = music_item;
#line 995 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			rygel_music_item_lookup_album_art ((RygelMusicItem*) _tmp19_);
#line 987 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (music_item);
#line 7424 "rygel-media-export-media-cache.c"
		}
#line 977 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (audio_item);
#line 7428 "rygel-media-export-media-cache.c"
	}
#line 999 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_VISUAL_ITEM)) {
#line 7432 "rygel-media-export-media-cache.c"
		RygelVisualItem* visual_item = NULL;
		RygelVisualItem* _tmp20_;
		RygelVisualItem* _tmp21_;
		RygelVisualItem* _tmp22_;
		RygelVisualItem* _tmp23_;
#line 1000 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, RYGEL_TYPE_VISUAL_ITEM) ? ((RygelVisualItem*) item) : NULL);
#line 1000 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		visual_item = _tmp20_;
#line 1001 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp21_ = visual_item;
#line 1001 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_visual_item_set_width (_tmp21_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_WIDTH));
#line 1002 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp22_ = visual_item;
#line 1002 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_visual_item_set_height (_tmp22_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_HEIGHT));
#line 1003 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp23_ = visual_item;
#line 1003 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		rygel_visual_item_set_color_depth (_tmp23_, sqlite3_column_int (statement, (gint) RYGEL_MEDIA_EXPORT_DETAIL_COLUMN_COLOR_DEPTH));
#line 999 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_object_unref0 (visual_item);
#line 7456 "rygel-media-export-media-cache.c"
	}
}

static gchar*
rygel_media_export_media_cache_translate_search_expression (RygelSearchExpression* expression,
                                                            GArray* args,
                                                            const gchar* prefix,
                                                            GError** error)
{
	gchar* filter = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1008 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 1008 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (prefix != NULL, NULL);
#line 1013 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (expression == NULL) {
#line 7478 "rygel-media-export-media-cache.c"
		gchar* _tmp0_;
#line 1014 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = g_strdup ("");
#line 1014 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = _tmp0_;
#line 1014 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 7486 "rygel-media-export-media-cache.c"
	}
#line 1017 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = rygel_media_export_media_cache_search_expression_to_sql (expression, args, &_inner_error0_);
#line 1017 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	filter = _tmp1_;
#line 1017 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1017 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 1017 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 7498 "rygel-media-export-media-cache.c"
	}
#line 1019 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = filter;
#line 1019 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = g_strdup_printf (" %s %s", prefix, _tmp2_);
#line 1019 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp3_;
#line 1019 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (filter);
#line 1019 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 7510 "rygel-media-export-media-cache.c"
}

static gchar*
rygel_media_export_media_cache_search_expression_to_sql (RygelSearchExpression* expression,
                                                         GArray* args,
                                                         GError** error)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1022 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 1026 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (expression == NULL) {
#line 7524 "rygel-media-export-media-cache.c"
		gchar* _tmp0_;
#line 1027 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp0_ = g_strdup ("");
#line 1027 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = _tmp0_;
#line 1027 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 7532 "rygel-media-export-media-cache.c"
	}
#line 1030 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (expression, RYGEL_TYPE_LOGICAL_EXPRESSION)) {
#line 7536 "rygel-media-export-media-cache.c"
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp2_ = rygel_media_export_media_cache_logical_expression_to_sql (G_TYPE_CHECK_INSTANCE_TYPE (expression, RYGEL_TYPE_LOGICAL_EXPRESSION) ? ((RygelLogicalExpression*) expression) : NULL, args, &_inner_error0_);
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = _tmp2_;
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 7550 "rygel-media-export-media-cache.c"
		}
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp3_ = _tmp1_;
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp1_ = NULL;
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = _tmp3_;
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_tmp1_);
#line 1031 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 7562 "rygel-media-export-media-cache.c"
	} else {
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp5_ = rygel_media_export_media_cache_relational_expression_to_sql (G_TYPE_CHECK_INSTANCE_TYPE (expression, RYGEL_TYPE_RELATIONAL_EXPRESSION) ? ((RygelRelationalExpression*) expression) : NULL, args, &_inner_error0_);
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = _tmp5_;
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 7577 "rygel-media-export-media-cache.c"
		}
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp6_ = _tmp4_;
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp4_ = NULL;
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		result = _tmp6_;
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_tmp4_);
#line 1034 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return result;
#line 7589 "rygel-media-export-media-cache.c"
	}
}

static gchar*
rygel_media_export_media_cache_logical_expression_to_sql (RygelLogicalExpression* expression,
                                                          GArray* args,
                                                          GError** error)
{
	gchar* left_sql_string = NULL;
	gconstpointer _tmp0_;
	gchar* _tmp1_;
	gchar* right_sql_string = NULL;
	gconstpointer _tmp2_;
	gchar* _tmp3_;
	const gchar* operator_sql_string = NULL;
	gconstpointer _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1040 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (expression != NULL, NULL);
#line 1040 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 1044 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = ((RygelSearchExpression*) expression)->operand1;
#line 1044 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = rygel_media_export_media_cache_search_expression_to_sql ((RygelSearchExpression*) _tmp0_, args, &_inner_error0_);
#line 1044 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	left_sql_string = _tmp1_;
#line 1044 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1044 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 1044 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 7628 "rygel-media-export-media-cache.c"
	}
#line 1047 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = ((RygelSearchExpression*) expression)->operand2;
#line 1047 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = rygel_media_export_media_cache_search_expression_to_sql ((RygelSearchExpression*) _tmp2_, args, &_inner_error0_);
#line 1047 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	right_sql_string = _tmp3_;
#line 1047 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1047 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 1047 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (left_sql_string);
#line 1047 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 7644 "rygel-media-export-media-cache.c"
	}
#line 1050 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	operator_sql_string = "OR";
#line 1052 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = ((RygelSearchExpression*) expression)->op;
#line 1052 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (((RygelLogicalOperator) ((gintptr) _tmp4_)) == RYGEL_LOGICAL_OPERATOR_AND) {
#line 1053 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		operator_sql_string = "AND";
#line 7654 "rygel-media-export-media-cache.c"
	}
#line 1056 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = left_sql_string;
#line 1056 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp6_ = operator_sql_string;
#line 1056 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp7_ = right_sql_string;
#line 1056 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp8_ = g_strdup_printf ("(%s %s %s)", _tmp5_, _tmp6_, _tmp7_);
#line 1056 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp8_;
#line 1056 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (right_sql_string);
#line 1056 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (left_sql_string);
#line 1056 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 7672 "rygel-media-export-media-cache.c"
}

static gchar*
rygel_media_export_media_cache_map_operand_to_column (const gchar* operand,
                                                      gchar** collate,
                                                      gboolean for_sort,
                                                      GError** error)
{
	gchar* _vala_collate = NULL;
	gchar* column = NULL;
	gboolean use_collation = FALSE;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label0 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label1 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label2 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label3 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label4 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label5 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label6 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label7 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label8 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label9 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label10 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label11 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label12 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label13 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label14 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label15 = 0;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	static GQuark _tmp1_label16 = 0;
#line 7720 "rygel-media-export-media-cache.c"
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1061 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (operand != NULL, NULL);
#line 1065 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	column = NULL;
#line 1066 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	use_collation = FALSE;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = operand;
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("res")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7737 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp3_;
#line 1070 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp3_ = g_strdup ("o.uri");
#line 1070 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1070 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp3_;
#line 1071 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7749 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("res@duration")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7755 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp4_;
#line 1073 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp4_ = g_strdup ("m.duration");
#line 1073 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1073 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp4_;
#line 1074 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7767 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("@id")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7773 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp5_;
#line 1076 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp5_ = g_strdup ("o.upnp_id");
#line 1076 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1076 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp5_;
#line 1077 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7785 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("@parentID")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7791 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp6_;
#line 1079 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp6_ = g_strdup ("o.parent");
#line 1079 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1079 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp6_;
#line 1080 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7803 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("upnp:class")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7809 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp7_;
#line 1082 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp7_ = g_strdup ("m.class");
#line 1082 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1082 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp7_;
#line 1083 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7821 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("dc:title")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7827 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp8_;
#line 1085 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp8_ = g_strdup ("o.title");
#line 1085 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1085 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp8_;
#line 1086 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				use_collation = TRUE;
#line 1087 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7841 "rygel-media-export-media-cache.c"
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("upnp:artist")))) || (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("upnp:author"))))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7847 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp9_;
#line 1090 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp9_ = g_strdup ("m.author");
#line 1090 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1090 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp9_;
#line 1091 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				use_collation = TRUE;
#line 1092 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7861 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("dc:creator")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7867 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp10_;
#line 1094 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp10_ = g_strdup ("m.creator");
#line 1094 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1094 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp10_;
#line 1095 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				use_collation = TRUE;
#line 1096 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7881 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("dc:date")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7887 "rygel-media-export-media-cache.c"
			default:
			{
#line 1098 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (for_sort) {
#line 7892 "rygel-media-export-media-cache.c"
					gchar* _tmp11_;
#line 1099 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp11_ = g_strdup ("m.date");
#line 1099 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (column);
#line 1099 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					column = _tmp11_;
#line 7900 "rygel-media-export-media-cache.c"
				} else {
					gchar* _tmp12_;
#line 1101 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp12_ = g_strdup ("strftime(\"%Y\", m.date)");
#line 1101 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (column);
#line 1101 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					column = _tmp12_;
#line 7909 "rygel-media-export-media-cache.c"
				}
#line 1103 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7913 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("upnp:album")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7919 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp13_;
#line 1105 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp13_ = g_strdup ("m.album");
#line 1105 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1105 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp13_;
#line 1106 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				use_collation = TRUE;
#line 1107 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7933 "rygel-media-export-media-cache.c"
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("upnp:genre")))) || (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("dc:genre"))))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7939 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp14_;
#line 1111 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp14_ = g_strdup ("m.genre");
#line 1111 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1111 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp14_;
#line 1112 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				use_collation = TRUE;
#line 1113 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7953 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("upnp:originalTrackNumber")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7959 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp15_;
#line 1115 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp15_ = g_strdup ("m.track");
#line 1115 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1115 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp15_;
#line 1116 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7971 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("rygel:originalVolumeNumber")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7977 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp16_;
#line 1118 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp16_ = g_strdup ("m.disc");
#line 1118 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1118 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp16_;
#line 1119 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 7989 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("upnp:objectUpdateID")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 7995 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp17_;
#line 1121 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp17_ = g_strdup ("o.object_update_id");
#line 1121 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1121 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp17_;
#line 1122 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 8007 "rygel-media-export-media-cache.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("upnp:containerUpdateID")))) {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 8013 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* _tmp18_;
#line 1124 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp18_ = g_strdup ("o.container_update_id");
#line 1124 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1124 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				column = _tmp18_;
#line 1125 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				break;
#line 8025 "rygel-media-export-media-cache.c"
			}
		}
	} else {
#line 1068 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		switch (0) {
#line 8031 "rygel-media-export-media-cache.c"
			default:
			{
				gchar* message = NULL;
				gchar* _tmp19_;
				const gchar* _tmp20_;
				GError* _tmp21_;
#line 1127 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp19_ = g_strdup_printf ("Unsupported column %s", operand);
#line 1127 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				message = _tmp19_;
#line 1129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp20_ = message;
#line 1129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp21_ = g_error_new_literal (RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR, RYGEL_MEDIA_EXPORT_MEDIA_CACHE_ERROR_UNSUPPORTED_SEARCH, _tmp20_);
#line 1129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_inner_error0_ = _tmp21_;
#line 1129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				g_propagate_error (error, _inner_error0_);
#line 1129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (message);
#line 1129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (column);
#line 1129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (_vala_collate);
#line 1129 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				return NULL;
#line 8058 "rygel-media-export-media-cache.c"
			}
		}
	}
#line 1132 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (use_collation) {
#line 8064 "rygel-media-export-media-cache.c"
		gchar* _tmp22_;
#line 1133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp22_ = g_strdup ("COLLATE CASEFOLD");
#line 1133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_vala_collate);
#line 1133 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_collate = _tmp22_;
#line 8072 "rygel-media-export-media-cache.c"
	} else {
		gchar* _tmp23_;
#line 1135 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp23_ = g_strdup ("");
#line 1135 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_vala_collate);
#line 1135 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_vala_collate = _tmp23_;
#line 8081 "rygel-media-export-media-cache.c"
	}
#line 1138 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = column;
#line 1138 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (collate) {
#line 1138 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*collate = _vala_collate;
#line 8089 "rygel-media-export-media-cache.c"
	} else {
#line 1138 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_vala_collate);
#line 8093 "rygel-media-export-media-cache.c"
	}
#line 1138 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 8097 "rygel-media-export-media-cache.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 8105 "rygel-media-export-media-cache.c"
}

static gchar*
rygel_media_export_media_cache_relational_expression_to_sql (RygelRelationalExpression* exp,
                                                             GArray* args,
                                                             GError** error)
{
	GValue* v = NULL;
	gchar* collate = NULL;
	gchar* column = NULL;
	gconstpointer _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	RygelDatabaseSqlOperator* operator = NULL;
	gconstpointer _tmp3_;
	GValue* _tmp31_;
	RygelDatabaseSqlOperator* _tmp35_;
	gchar* _tmp36_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1141 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (exp != NULL, NULL);
#line 1141 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 1145 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	v = NULL;
#line 1146 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	collate = NULL;
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = ((RygelSearchExpression*) exp)->operand1;
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = rygel_media_export_media_cache_map_operand_to_column ((const gchar*) _tmp0_, &_tmp1_, FALSE, &_inner_error0_);
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (collate);
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	collate = _tmp1_;
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	column = _tmp2_;
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_propagate_error (error, _inner_error0_);
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (collate);
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		__vala_GValue_free0 (v);
#line 1148 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		return NULL;
#line 8154 "rygel-media-export-media-cache.c"
	}
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = ((RygelSearchExpression*) exp)->op;
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	switch ((GUPnPSearchCriteriaOp) ((gintptr) _tmp3_)) {
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_EXISTS:
#line 8162 "rygel-media-export-media-cache.c"
		{
			gchar* sql_function = NULL;
			gconstpointer _tmp4_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 1155 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp4_ = ((RygelSearchExpression*) exp)->operand2;
#line 1155 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			if (g_strcmp0 ((const gchar*) _tmp4_, "true") == 0) {
#line 8174 "rygel-media-export-media-cache.c"
				gchar* _tmp5_;
#line 1156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp5_ = g_strdup ("%s IS NOT NULL AND %s != ''");
#line 1156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sql_function);
#line 1156 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				sql_function = _tmp5_;
#line 8182 "rygel-media-export-media-cache.c"
			} else {
				gchar* _tmp6_;
#line 1158 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_tmp6_ = g_strdup ("%s IS NULL OR %s = ''");
#line 1158 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				_g_free0 (sql_function);
#line 1158 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				sql_function = _tmp6_;
#line 8191 "rygel-media-export-media-cache.c"
			}
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp7_ = sql_function;
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp8_ = column;
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp9_ = column;
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp10_ = g_strdup_printf (_tmp7_, _tmp8_, _tmp9_);
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			result = _tmp10_;
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (sql_function);
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (operator);
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (column);
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (collate);
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			__vala_GValue_free0 (v);
#line 1161 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return result;
#line 8215 "rygel-media-export-media-cache.c"
		}
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_EQ:
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_NEQ:
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_LESS:
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_LEQ:
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_GREATER:
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_GEQ:
#line 8229 "rygel-media-export-media-cache.c"
		{
			gconstpointer _tmp11_;
			GValue* _tmp12_ = NULL;
			gconstpointer _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			RygelDatabaseSqlOperator* _tmp16_;
#line 1168 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp11_ = ((RygelSearchExpression*) exp)->operand2;
#line 1168 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp12_ = g_new0 (GValue, 1);
#line 1168 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (_tmp12_, G_TYPE_STRING);
#line 1168 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_string (_tmp12_, (const gchar*) _tmp11_);
#line 1168 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			__vala_GValue_free0 (v);
#line 1168 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			v = _tmp12_;
#line 1169 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp13_ = ((RygelSearchExpression*) exp)->op;
#line 1169 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp14_ = column;
#line 1169 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp15_ = collate;
#line 1169 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp16_ = rygel_database_sql_operator_new_from_search_criteria_op ((GUPnPSearchCriteriaOp) ((gintptr) _tmp13_), _tmp14_, _tmp15_);
#line 1169 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (operator);
#line 1169 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			operator = _tmp16_;
#line 1171 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			break;
#line 8263 "rygel-media-export-media-cache.c"
		}
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_CONTAINS:
#line 8267 "rygel-media-export-media-cache.c"
		{
			const gchar* _tmp17_;
			RygelDatabaseSqlFunction* _tmp18_;
			gconstpointer _tmp19_;
			GValue* _tmp20_ = NULL;
#line 1173 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp17_ = column;
#line 1173 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp18_ = rygel_database_sql_function_new ("contains", _tmp17_);
#line 1173 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (operator);
#line 1173 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			operator = (RygelDatabaseSqlOperator*) _tmp18_;
#line 1174 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp19_ = ((RygelSearchExpression*) exp)->operand2;
#line 1174 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp20_ = g_new0 (GValue, 1);
#line 1174 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (_tmp20_, G_TYPE_STRING);
#line 1174 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_string (_tmp20_, (const gchar*) _tmp19_);
#line 1174 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			__vala_GValue_free0 (v);
#line 1174 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			v = _tmp20_;
#line 1175 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			break;
#line 8295 "rygel-media-export-media-cache.c"
		}
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_DOES_NOT_CONTAIN:
#line 8299 "rygel-media-export-media-cache.c"
		{
			const gchar* _tmp21_;
			RygelDatabaseSqlFunction* _tmp22_;
			gconstpointer _tmp23_;
			GValue* _tmp24_ = NULL;
#line 1177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp21_ = column;
#line 1177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp22_ = rygel_database_sql_function_new ("NOT contains", _tmp21_);
#line 1177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (operator);
#line 1177 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			operator = (RygelDatabaseSqlOperator*) _tmp22_;
#line 1178 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp23_ = ((RygelSearchExpression*) exp)->operand2;
#line 1178 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp24_ = g_new0 (GValue, 1);
#line 1178 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (_tmp24_, G_TYPE_STRING);
#line 1178 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_set_string (_tmp24_, (const gchar*) _tmp23_);
#line 1178 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			__vala_GValue_free0 (v);
#line 1178 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			v = _tmp24_;
#line 1179 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			break;
#line 8327 "rygel-media-export-media-cache.c"
		}
#line 1152 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		case GUPNP_SEARCH_CRITERIA_OP_DERIVED_FROM:
#line 8331 "rygel-media-export-media-cache.c"
		{
			const gchar* _tmp25_;
			RygelDatabaseSqlOperator* _tmp26_;
			gconstpointer _tmp27_;
			gchar* _tmp28_;
			GValue* _tmp29_ = NULL;
#line 1181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp25_ = column;
#line 1181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp26_ = rygel_database_sql_operator_new ("LIKE", _tmp25_, "");
#line 1181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (operator);
#line 1181 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			operator = _tmp26_;
#line 1182 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp27_ = ((RygelSearchExpression*) exp)->operand2;
#line 1182 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp28_ = g_strdup_printf ("%s%%", (const gchar*) _tmp27_);
#line 1182 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp29_ = g_new0 (GValue, 1);
#line 1182 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (_tmp29_, G_TYPE_STRING);
#line 1182 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_take_string (_tmp29_, _tmp28_);
#line 1182 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			__vala_GValue_free0 (v);
#line 1182 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			v = _tmp29_;
#line 1183 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			break;
#line 8362 "rygel-media-export-media-cache.c"
		}
		default:
		{
			gconstpointer _tmp30_;
#line 1185 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp30_ = ((RygelSearchExpression*) exp)->op;
#line 1185 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_debug ("rygel-media-export-media-cache.vala:1185: Unsupported search criteria " \
"op %d", (gint) ((GUPnPSearchCriteriaOp) ((gintptr) _tmp30_)));
#line 1187 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			result = NULL;
#line 1187 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_object_unref0 (operator);
#line 1187 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (column);
#line 1187 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_g_free0 (collate);
#line 1187 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			__vala_GValue_free0 (v);
#line 1187 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return result;
#line 8383 "rygel-media-export-media-cache.c"
		}
	}
#line 1190 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp31_ = v;
#line 1190 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (((gpointer) _tmp31_) != NULL) {
#line 8390 "rygel-media-export-media-cache.c"
		GValue* _tmp32_;
		GValue _tmp33_;
		GValue _tmp34_ = {0};
#line 1191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp32_ = v;
#line 1191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_tmp33_ = *_tmp32_;
#line 1191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (G_IS_VALUE (&_tmp33_)) {
#line 1191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_init (&_tmp34_, G_VALUE_TYPE (&_tmp33_));
#line 1191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_value_copy (&_tmp33_, &_tmp34_);
#line 8404 "rygel-media-export-media-cache.c"
		} else {
#line 1191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			_tmp34_ = _tmp33_;
#line 8408 "rygel-media-export-media-cache.c"
		}
#line 1191 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		g_array_append_val (args, _tmp34_);
#line 8412 "rygel-media-export-media-cache.c"
	}
#line 1194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp35_ = operator;
#line 1194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp36_ = rygel_database_sql_operator_to_string (_tmp35_);
#line 1194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp36_;
#line 1194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (operator);
#line 1194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (column);
#line 1194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (collate);
#line 1194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	__vala_GValue_free0 (v);
#line 1194 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 8430 "rygel-media-export-media-cache.c"
}

static RygelDatabaseCursor*
rygel_media_export_media_cache_exec_cursor (RygelMediaExportMediaCache* self,
                                            RygelMediaExportSQLString id,
                                            GValue* values,
                                            gint values_length1,
                                            GError** error)
{
	RygelDatabaseCursor* _tmp0_ = NULL;
	RygelDatabaseDatabase* _tmp1_;
	RygelMediaExportSQLFactory* _tmp2_;
	const gchar* _tmp3_;
	RygelDatabaseCursor* _tmp4_;
	RygelDatabaseCursor* _tmp5_;
	GError* _inner_error0_ = NULL;
	RygelDatabaseCursor* result;
#line 1197 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = self->priv->db;
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = self->priv->sql;
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = rygel_media_export_sql_factory_make (_tmp2_, id);
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = rygel_database_database_exec_cursor (_tmp1_, _tmp3_, values, (gint) values_length1, &_inner_error0_);
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = _tmp4_;
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 8468 "rygel-media-export-media-cache.c"
		} else {
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return NULL;
#line 8476 "rygel-media-export-media-cache.c"
		}
	}
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = _tmp0_;
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = NULL;
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp5_;
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (_tmp0_);
#line 1200 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 8489 "rygel-media-export-media-cache.c"
}

static gint
rygel_media_export_media_cache_query_value (RygelMediaExportMediaCache* self,
                                            RygelMediaExportSQLString id,
                                            GValue* values,
                                            gint values_length1,
                                            GError** error)
{
	gint _tmp0_ = 0;
	RygelDatabaseDatabase* _tmp1_;
	RygelMediaExportSQLFactory* _tmp2_;
	const gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 1203 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = self->priv->db;
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp2_ = self->priv->sql;
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = rygel_media_export_sql_factory_make (_tmp2_, id);
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = rygel_database_database_query_value (_tmp1_, _tmp3_, values, (gint) values_length1, &_inner_error0_);
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		if (_inner_error0_->domain == RYGEL_DATABASE_DATABASE_ERROR) {
#line 8519 "rygel-media-export-media-cache.c"
			gint _tmp4_ = -1;
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_propagate_error (error, _inner_error0_);
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp4_;
#line 8525 "rygel-media-export-media-cache.c"
		} else {
			gint _tmp5_ = -1;
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			g_clear_error (&_inner_error0_);
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			return _tmp5_;
#line 8534 "rygel-media-export-media-cache.c"
		}
	}
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp0_;
#line 1206 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 8541 "rygel-media-export-media-cache.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 8568 "rygel-media-export-media-cache.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 8574 "rygel-media-export-media-cache.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 8580 "rygel-media-export-media-cache.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 8584 "rygel-media-export-media-cache.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 8592 "rygel-media-export-media-cache.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 8596 "rygel-media-export-media-cache.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 8608 "rygel-media-export-media-cache.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 8625 "rygel-media-export-media-cache.c"
}

static gchar*
rygel_media_export_media_cache_translate_sort_criteria (const gchar* sort_criteria,
                                                        gchar** extra_columns,
                                                        gint* column_count)
{
	gchar* _vala_extra_columns = NULL;
	gint _vala_column_count = 0;
	gchar* collate = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	GString* column_builder = NULL;
	GString* _tmp1_;
	gchar** fields = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GString* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	GString* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1209 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_return_val_if_fail (sort_criteria != NULL, NULL);
#line 1214 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp0_ = g_string_new ("ORDER BY ");
#line 1214 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	builder = _tmp0_;
#line 1215 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp1_ = g_string_new ("");
#line 1215 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	column_builder = _tmp1_;
#line 1216 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp3_ = _tmp2_ = g_strsplit (sort_criteria, ",", 0);
#line 1216 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	fields = _tmp3_;
#line 1216 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	fields_length1 = _vala_array_length (_tmp2_);
#line 1216 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_fields_size_ = fields_length1;
#line 1217 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4_ = fields;
#line 1217 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp4__length1 = fields_length1;
#line 1217 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_column_count = _tmp4__length1;
#line 1218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5_ = fields;
#line 1218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp5__length1 = fields_length1;
#line 8685 "rygel-media-export-media-cache.c"
	{
		gchar** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 1218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		field_collection = _tmp5_;
#line 1218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		field_collection_length1 = _tmp5__length1;
#line 1218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 8697 "rygel-media-export-media-cache.c"
			const gchar* field = NULL;
#line 1218 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
			field = field_collection[field_it];
#line 8701 "rygel-media-export-media-cache.c"
			{
				{
					gchar* column = NULL;
					const gchar* _tmp6_;
					const gchar* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_ = NULL;
					gchar* _tmp13_;
					gchar* _tmp14_;
					const gchar* _tmp15_;
					gchar** _tmp16_;
					gint _tmp16__length1;
					const gchar* _tmp17_;
					GString* _tmp19_;
					const gchar* _tmp20_ = NULL;
					const gchar* _tmp21_;
					GString* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					GString* _tmp25_;
					const gchar* _tmp26_;
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp6_ = field;
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp7_ = field;
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp8_ = strlen (_tmp7_);
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp9_ = _tmp8_;
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp10_ = string_slice (_tmp6_, (glong) 1, (glong) _tmp9_);
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp11_ = _tmp10_;
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp13_ = rygel_media_export_media_cache_map_operand_to_column (_tmp11_, &_tmp12_, TRUE, &_inner_error0_);
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (collate);
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					collate = _tmp12_;
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp14_ = _tmp13_;
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (_tmp11_);
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					column = _tmp14_;
#line 1220 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8752 "rygel-media-export-media-cache.c"
						goto __catch0_g_error;
					}
#line 1224 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp15_ = field;
#line 1224 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp16_ = fields;
#line 1224 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp16__length1 = fields_length1;
#line 1224 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp17_ = _tmp16_[0];
#line 1224 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					if (g_strcmp0 (_tmp15_, _tmp17_) != 0) {
#line 8765 "rygel-media-export-media-cache.c"
						GString* _tmp18_;
#line 1225 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
						_tmp18_ = builder;
#line 1225 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
						g_string_append (_tmp18_, ",");
#line 8771 "rygel-media-export-media-cache.c"
					}
#line 1227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp19_ = column_builder;
#line 1227 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_string_append (_tmp19_, ",");
#line 1231 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp21_ = field;
#line 1231 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					if (string_get (_tmp21_, (glong) 0) == '-') {
#line 1231 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
						_tmp20_ = "DESC";
#line 8783 "rygel-media-export-media-cache.c"
					} else {
#line 1231 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
						_tmp20_ = "ASC";
#line 8787 "rygel-media-export-media-cache.c"
					}
#line 1228 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp22_ = builder;
#line 1228 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp23_ = column;
#line 1228 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp24_ = collate;
#line 1228 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_string_append_printf (_tmp22_, "%s %s %s ", _tmp23_, _tmp24_, _tmp20_);
#line 1232 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp25_ = column_builder;
#line 1232 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp26_ = column;
#line 1232 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_string_append (_tmp25_, _tmp26_);
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (column);
#line 8805 "rygel-media-export-media-cache.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					const gchar* _tmp27_;
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_clear_error (&_inner_error0_);
#line 1234 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_tmp27_ = field;
#line 1234 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_warning (_ ("Skipping unsupported sort field: %s"), _tmp27_);
#line 8817 "rygel-media-export-media-cache.c"
				}
				__finally0:
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_string_free0 (column_builder);
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_string_free0 (builder);
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (collate);
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					_g_free0 (_vala_extra_columns);
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					g_clear_error (&_inner_error0_);
#line 1219 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
					return NULL;
#line 8838 "rygel-media-export-media-cache.c"
				}
			}
		}
	}
#line 1238 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp28_ = column_builder;
#line 1238 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp29_ = _tmp28_->str;
#line 1238 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp30_ = g_strdup (_tmp29_);
#line 1238 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (_vala_extra_columns);
#line 1238 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_vala_extra_columns = _tmp30_;
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp31_ = builder;
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp32_ = _tmp31_->str;
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	result = _tmp33_;
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_string_free0 (column_builder);
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_string_free0 (builder);
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_free0 (collate);
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (extra_columns) {
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*extra_columns = _vala_extra_columns;
#line 8873 "rygel-media-export-media-cache.c"
	} else {
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		_g_free0 (_vala_extra_columns);
#line 8877 "rygel-media-export-media-cache.c"
	}
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	if (column_count) {
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
		*column_count = _vala_column_count;
#line 8883 "rygel-media-export-media-cache.c"
	}
#line 1240 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	return result;
#line 8887 "rygel-media-export-media-cache.c"
}

static void
rygel_media_export_media_cache_class_init (RygelMediaExportMediaCacheClass * klass,
                                           gpointer klass_data)
{
#line 56 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	rygel_media_export_media_cache_parent_class = g_type_class_peek_parent (klass);
#line 56 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	g_type_class_adjust_private_offset (klass, &RygelMediaExportMediaCache_private_offset);
#line 56 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_media_export_media_cache_finalize;
#line 8900 "rygel-media-export-media-cache.c"
}

static void
rygel_media_export_media_cache_instance_init (RygelMediaExportMediaCache * self,
                                              gpointer klass)
{
#line 56 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	self->priv = rygel_media_export_media_cache_get_instance_private (self);
#line 8909 "rygel-media-export-media-cache.c"
}

static void
rygel_media_export_media_cache_finalize (GObject * obj)
{
	RygelMediaExportMediaCache * self;
#line 56 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_MEDIA_EXPORT_TYPE_MEDIA_CACHE, RygelMediaExportMediaCache);
#line 58 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (self->priv->db);
#line 59 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (self->priv->factory);
#line 60 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (self->priv->sql);
#line 61 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	_g_object_unref0 (self->priv->exists_cache);
#line 56 "../src/plugins/media-export/rygel-media-export-media-cache.vala"
	G_OBJECT_CLASS (rygel_media_export_media_cache_parent_class)->finalize (obj);
#line 8928 "rygel-media-export-media-cache.c"
}

/**
 * Persistent storage of media objects.
 *
 * MediaExportDB is a sqlite3 backed persistent storage of media objects.
 */
 G_GNUC_NO_INLINE static GType
rygel_media_export_media_cache_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelMediaExportMediaCacheClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_export_media_cache_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaExportMediaCache), 0, (GInstanceInitFunc) rygel_media_export_media_cache_instance_init, NULL };
	GType rygel_media_export_media_cache_type_id;
	rygel_media_export_media_cache_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelMediaExportMediaCache", &g_define_type_info, 0);
	RygelMediaExportMediaCache_private_offset = g_type_add_instance_private (rygel_media_export_media_cache_type_id, sizeof (RygelMediaExportMediaCachePrivate));
	return rygel_media_export_media_cache_type_id;
}

GType
rygel_media_export_media_cache_get_type (void)
{
	static volatile gsize rygel_media_export_media_cache_type_id__once = 0;
	if (g_once_init_enter (&rygel_media_export_media_cache_type_id__once)) {
		GType rygel_media_export_media_cache_type_id;
		rygel_media_export_media_cache_type_id = rygel_media_export_media_cache_get_type_once ();
		g_once_init_leave (&rygel_media_export_media_cache_type_id__once, rygel_media_export_media_cache_type_id);
	}
	return rygel_media_export_media_cache_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

